// @ts-nocheck - Prevent tsc stepping into any required bundles.
/*!
 * Lighthouse v8.5.0 7435bf9aa961999c22926415d1e9e3edab379f6c (September 21st 2021)
 * 
 * Automated auditing, performance metrics, and best practices for the web.
 * 
 * @homepage https://github.com/GoogleChrome/lighthouse#readme
 * @author   The Lighthouse Authors
 * @license  Apache-2.0
 */
globalThis.require=function r(e,t,n){function o(a,s){if(!t[a]){if(!e[a]){var c="function"==typeof require&&require;if(!s&&c)return c(a,!0);if(i)return i(a,!0);var l=new Error("Cannot find module '"+a+"'");throw l.code="MODULE_NOT_FOUND",l}var u=t[a]={exports:{}};e[a][0].call(u.exports,(function(t){return o(e[a][1][t]||t)}),u,u.exports,r,e,t,n)}return t[a].exports}for(var i="function"==typeof require&&require,a=0;a<n.length;a++)o(n[a]);return o}({"../audits/accessibility/accesskeys":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[accesskey]` values are unique",failureTitle:"`[accesskey]` values are not unique",description:"Access keys let users quickly focus a part of the page. For proper navigation, each access key must be unique. [Learn more](https://web.dev/accesskeys/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class Accesskeys extends i{static get meta(){return{id:"accesskeys",title:c(s.title),
failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/accesskeys.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-allowed-attr":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[aria-*]` attributes match their roles",failureTitle:"`[aria-*]` attributes do not match their roles",description:"Each ARIA `role` supports a specific subset of `aria-*` attributes. Mismatching these invalidates the `aria-*` attributes. [Learn more](https://web.dev/aria-allowed-attr/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ARIAAllowedAttr extends i{static get meta(){return{id:"aria-allowed-attr",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)
}).call(this,"/lighthouse-core/audits/accessibility/aria-allowed-attr.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-command-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`button`, `link`, and `menuitem` elements have accessible names",failureTitle:"`button`, `link`, and `menuitem` elements do not have accessible names.",description:"When an element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more](https://web.dev/aria-name/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaCommandName extends i{static get meta(){return{id:"aria-command-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)
}).call(this,"/lighthouse-core/audits/accessibility/aria-command-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-hidden-body":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:'`[aria-hidden="true"]` is not present on the document `<body>`',failureTitle:'`[aria-hidden="true"]` is present on the document `<body>`',description:'Assistive technologies, like screen readers, work inconsistently when `aria-hidden="true"` is set on the document `<body>`. [Learn more](https://web.dev/aria-hidden-body/).'},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaHiddenBody extends i{static get meta(){return{id:"aria-hidden-body",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-hidden-body.js")},{"../../lib/i18n/i18n.js":98,
"./axe-audit.js":2}],"../audits/accessibility/aria-hidden-focus":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:'`[aria-hidden="true"]` elements do not contain focusable descendents',failureTitle:'`[aria-hidden="true"]` elements contain focusable descendents',description:'Focusable descendents within an `[aria-hidden="true"]` element prevent those interactive elements from being available to users of assistive technologies like screen readers. [Learn more](https://web.dev/aria-hidden-focus/).'},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaHiddenFocus extends i{static get meta(){return{id:"aria-hidden-focus",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-hidden-focus.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],
"../audits/accessibility/aria-input-field-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"ARIA input fields have accessible names",failureTitle:"ARIA input fields do not have accessible names",description:"When an input field doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more](https://web.dev/aria-name/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaInputFieldName extends i{static get meta(){return{id:"aria-input-field-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-input-field-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-meter-name":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"ARIA `meter` elements have accessible names",failureTitle:"ARIA `meter` elements do not have accessible names.",description:"When an element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more](https://web.dev/aria-name/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaMeterName extends i{static get meta(){return{id:"aria-meter-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-meter-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-progressbar-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={
title:"ARIA `progressbar` elements have accessible names",failureTitle:"ARIA `progressbar` elements do not have accessible names.",description:"When a `progressbar` element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more](https://web.dev/aria-name/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaProgressbarName extends i{static get meta(){return{id:"aria-progressbar-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-progressbar-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-required-attr":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[role]`s have all required `[aria-*]` attributes",
failureTitle:"`[role]`s do not have all required `[aria-*]` attributes",description:"Some ARIA roles have required attributes that describe the state of the element to screen readers. [Learn more](https://web.dev/aria-required-attr/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ARIARequiredAttr extends i{static get meta(){return{id:"aria-required-attr",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-required-attr.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-required-children":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Elements with an ARIA `[role]` that require children to contain a specific `[role]` have all required children.",
failureTitle:"Elements with an ARIA `[role]` that require children to contain a specific `[role]` are missing some or all of those required children.",description:"Some ARIA parent roles must contain specific child roles to perform their intended accessibility functions. [Learn more](https://web.dev/aria-required-children/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaRequiredChildren extends i{static get meta(){return{id:"aria-required-children",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-required-children.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-required-parent":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[role]`s are contained by their required parent element",
failureTitle:"`[role]`s are not contained by their required parent element",description:"Some ARIA child roles must be contained by specific parent roles to properly perform their intended accessibility functions. [Learn more](https://web.dev/aria-required-parent/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaRequiredParent extends i{static get meta(){return{id:"aria-required-parent",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-required-parent.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-roles":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[role]` values are valid",failureTitle:"`[role]` values are not valid",
description:"ARIA roles must have valid values in order to perform their intended accessibility functions. [Learn more](https://web.dev/aria-roles/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaRoles extends i{static get meta(){return{id:"aria-roles",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-roles.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-toggle-field-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"ARIA toggle fields have accessible names",failureTitle:"ARIA toggle fields do not have accessible names",
description:"When a toggle field doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more](https://web.dev/aria-name/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaToggleFieldName extends i{static get meta(){return{id:"aria-toggle-field-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-toggle-field-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-tooltip-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"ARIA `tooltip` elements have accessible names",failureTitle:"ARIA `tooltip` elements do not have accessible names.",
description:"When an element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more](https://web.dev/aria-name/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaTooltipName extends i{static get meta(){return{id:"aria-tooltip-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-tooltip-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-treeitem-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"ARIA `treeitem` elements have accessible names",failureTitle:"ARIA `treeitem` elements do not have accessible names.",
description:"When an element doesn't have an accessible name, screen readers announce it with a generic name, making it unusable for users who rely on screen readers. [Learn more](https://web.dev/aria-name/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AriaTreeitemName extends i{static get meta(){return{id:"aria-treeitem-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-treeitem-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-valid-attr-value":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[aria-*]` attributes have valid values",failureTitle:"`[aria-*]` attributes do not have valid values",
description:"Assistive technologies, like screen readers, can't interpret ARIA attributes with invalid values. [Learn more](https://web.dev/aria-valid-attr-value/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ARIAValidAttr extends i{static get meta(){return{id:"aria-valid-attr-value",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-valid-attr-value.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/aria-valid-attr":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[aria-*]` attributes are valid and not misspelled",failureTitle:"`[aria-*]` attributes are not valid or misspelled",
description:"Assistive technologies, like screen readers, can't interpret ARIA attributes with invalid names. [Learn more](https://web.dev/aria-valid-attr/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ARIAValidAttr extends i{static get meta(){return{id:"aria-valid-attr",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/aria-valid-attr.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/button-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Buttons have an accessible name",failureTitle:"Buttons do not have an accessible name",
description:'When a button doesn\'t have an accessible name, screen readers announce it as "button", making it unusable for users who rely on screen readers. [Learn more](https://web.dev/button-name/).'},c=a.createMessageInstanceIdFn(n,s);t.exports=class ButtonName extends i{static get meta(){return{id:"button-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/button-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/bypass":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"The page contains a heading, skip link, or landmark region",failureTitle:"The page does not contain a heading, skip link, or landmark region",
description:"Adding ways to bypass repetitive content lets keyboard users navigate the page more efficiently. [Learn more](https://web.dev/bypass/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class Bypass extends i{static get meta(){return{id:"bypass",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/bypass.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/color-contrast":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Background and foreground colors have a sufficient contrast ratio",failureTitle:"Background and foreground colors do not have a sufficient contrast ratio.",description:"Low-contrast text is difficult or impossible for many users to read. [Learn more](https://web.dev/color-contrast/)."
},c=a.createMessageInstanceIdFn(n,s);t.exports=class ColorContrast extends i{static get meta(){return{id:"color-contrast",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/color-contrast.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/definition-list":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`<dl>`'s contain only properly-ordered `<dt>` and `<dd>` groups, `<script>`, `<template>` or `<div>` elements.",failureTitle:"`<dl>`'s do not contain only properly-ordered `<dt>` and `<dd>` groups, `<script>`, `<template>` or `<div>` elements.",description:"When definition lists are not properly marked up, screen readers may produce confusing or inaccurate output. [Learn more](https://web.dev/definition-list/)."
},c=a.createMessageInstanceIdFn(n,s);t.exports=class DefinitionList extends i{static get meta(){return{id:"definition-list",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/definition-list.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/dlitem":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Definition list items are wrapped in `<dl>` elements",failureTitle:"Definition list items are not wrapped in `<dl>` elements",description:"Definition list items (`<dt>` and `<dd>`) must be wrapped in a parent `<dl>` element to ensure that screen readers can properly announce them. [Learn more](https://web.dev/dlitem/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class DLItem extends i{static get meta(){return{id:"dlitem",title:c(s.title),
failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/dlitem.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/document-title":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Document has a `<title>` element",failureTitle:"Document doesn't have a `<title>` element",description:"The title gives screen reader users an overview of the page, and search engine users rely on it heavily to determine if a page is relevant to their search. [Learn more](https://web.dev/document-title/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class DocumentTitle extends i{static get meta(){return{id:"document-title",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)
}).call(this,"/lighthouse-core/audits/accessibility/document-title.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/duplicate-id-active":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[id]` attributes on active, focusable elements are unique",failureTitle:"`[id]` attributes on active, focusable elements are not unique",description:"All focusable elements must have a unique `id` to ensure that they're visible to assistive technologies. [Learn more](https://web.dev/duplicate-id-active/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class DuplicateIdActive extends i{static get meta(){return{id:"duplicate-id-active",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/duplicate-id-active.js")},{"../../lib/i18n/i18n.js":98,
"./axe-audit.js":2}],"../audits/accessibility/duplicate-id-aria":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"ARIA IDs are unique",failureTitle:"ARIA IDs are not unique",description:"The value of an ARIA ID must be unique to prevent other instances from being overlooked by assistive technologies. [Learn more](https://web.dev/duplicate-id-aria/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class DuplicateIdAria extends i{static get meta(){return{id:"duplicate-id-aria",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/duplicate-id-aria.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/form-field-multiple-labels":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={
title:"No form fields have multiple labels",failureTitle:"Form fields have multiple labels",description:"Form fields with multiple labels can be confusingly announced by assistive technologies like screen readers which use either the first, the last, or all of the labels. [Learn more](https://web.dev/form-field-multiple-labels/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class FormFieldMultipleLabels extends i{static get meta(){return{id:"form-field-multiple-labels",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/form-field-multiple-labels.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/frame-title":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={
title:"`<frame>` or `<iframe>` elements have a title",failureTitle:"`<frame>` or `<iframe>` elements do not have a title",description:"Screen reader users rely on frame titles to describe the contents of frames. [Learn more](https://web.dev/frame-title/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class FrameTitle extends i{static get meta(){return{id:"frame-title",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/frame-title.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/heading-order":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Heading elements appear in a sequentially-descending order",failureTitle:"Heading elements are not in a sequentially-descending order",
description:"Properly ordered headings that do not skip levels convey the semantic structure of the page, making it easier to navigate and understand when using assistive technologies. [Learn more](https://web.dev/heading-order/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class HeadingOrder extends i{static get meta(){return{id:"heading-order",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/heading-order.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/html-has-lang":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`<html>` element has a `[lang]` attribute",failureTitle:"`<html>` element does not have a `[lang]` attribute",
description:"If a page doesn't specify a lang attribute, a screen reader assumes that the page is in the default language that the user chose when setting up the screen reader. If the page isn't actually in the default language, then the screen reader might not announce the page's text correctly. [Learn more](https://web.dev/html-has-lang/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class HTMLHasLang extends i{static get meta(){return{id:"html-has-lang",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/html-has-lang.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/html-lang-valid":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`<html>` element has a valid value for its `[lang]` attribute",
failureTitle:"`<html>` element does not have a valid value for its `[lang]` attribute.",description:"Specifying a valid [BCP 47 language](https://www.w3.org/International/questions/qa-choosing-language-tags#question) helps screen readers announce text properly. [Learn more](https://web.dev/html-lang-valid/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class HTMLLangValid extends i{static get meta(){return{id:"html-lang-valid",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/html-lang-valid.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/image-alt":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Image elements have `[alt]` attributes",failureTitle:"Image elements do not have `[alt]` attributes",
description:"Informative elements should aim for short, descriptive alternate text. Decorative elements can be ignored with an empty alt attribute. [Learn more](https://web.dev/image-alt/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ImageAlt extends i{static get meta(){return{id:"image-alt",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/image-alt.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/input-image-alt":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:'`<input type="image">` elements have `[alt]` text',failureTitle:'`<input type="image">` elements do not have `[alt]` text',
description:"When an image is being used as an `<input>` button, providing alternative text can help screen reader users understand the purpose of the button. [Learn more](https://web.dev/input-image-alt/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class InputImageAlt extends i{static get meta(){return{id:"input-image-alt",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/input-image-alt.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/label":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Form elements have associated labels",failureTitle:"Form elements do not have associated labels",
description:"Labels ensure that form controls are announced properly by assistive technologies, like screen readers. [Learn more](https://web.dev/label/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class Label extends i{static get meta(){return{id:"label",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/label.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/link-name":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Links have a discernible name",failureTitle:"Links do not have a discernible name",description:"Link text (and alternate text for images, when used as links) that is discernible, unique, and focusable improves the navigation experience for screen reader users. [Learn more](https://web.dev/link-name/)."
},c=a.createMessageInstanceIdFn(n,s);t.exports=class LinkName extends i{static get meta(){return{id:"link-name",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/link-name.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/listitem":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"List items (`<li>`) are contained within `<ul>` or `<ol>` parent elements",failureTitle:"List items (`<li>`) are not contained within `<ul>` or `<ol>` parent elements.",description:"Screen readers require list items (`<li>`) to be contained within a parent `<ul>` or `<ol>` to be announced properly. [Learn more](https://web.dev/listitem/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ListItem extends i{static get meta(){return{id:"listitem",
title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/listitem.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/list":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Lists contain only `<li>` elements and script supporting elements (`<script>` and `<template>`).",failureTitle:"Lists do not contain only `<li>` elements and script supporting elements (`<script>` and `<template>`).",description:"Screen readers have a specific way of announcing lists. Ensuring proper list structure aids screen reader output. [Learn more](https://web.dev/list/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class List extends i{static get meta(){return{id:"list",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),
requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/list.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/manual/custom-controls-labels":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js");t.exports=class CustomControlsLabels extends i{static get meta(){return Object.assign({id:"custom-controls-labels",description:"Custom interactive controls have associated labels, provided by aria-label or aria-labelledby. [Learn more](https://web.dev/custom-controls-labels/).",title:"Custom controls have associated labels"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/custom-controls-roles":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js");t.exports=class CustomControlsRoles extends i{static get meta(){return Object.assign({id:"custom-controls-roles",
description:"Custom interactive controls have appropriate ARIA roles. [Learn more](https://web.dev/custom-control-roles/).",title:"Custom controls have ARIA roles"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/focus-traps":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js");t.exports=class FocusTraps extends i{static get meta(){return Object.assign({id:"focus-traps",description:"A user can tab into and out of any control or region without accidentally trapping their focus. [Learn more](https://web.dev/focus-traps/).",title:"User focus is not accidentally trapped in a region"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/focusable-controls":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js");t.exports=class FocusableControls extends i{static get meta(){return Object.assign({id:"focusable-controls",
description:"Custom interactive controls are keyboard focusable and display a focus indicator. [Learn more](https://web.dev/focusable-controls/).",title:"Interactive controls are keyboard focusable"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/interactive-element-affordance":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js");t.exports=class InteractiveElementAffordance extends i{static get meta(){return Object.assign({id:"interactive-element-affordance",description:"Interactive elements, such as links and buttons, should indicate their state and be distinguishable from non-interactive elements. [Learn more](https://web.dev/interactive-element-affordance/).",title:"Interactive elements indicate their purpose and state"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/logical-tab-order":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js")
;t.exports=class LogicalTabOrder extends i{static get meta(){return Object.assign({id:"logical-tab-order",description:"Tabbing through the page follows the visual layout. Users cannot focus elements that are offscreen. [Learn more](https://web.dev/logical-tab-order/).",title:"The page has a logical tab order"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/managed-focus":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js");t.exports=class ManagedFocus extends i{static get meta(){return Object.assign({id:"managed-focus",description:"If new content, such as a dialog, is added to the page, the user's focus is directed to it. [Learn more](https://web.dev/managed-focus/).",title:"The user's focus is directed to new content added to the page"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/offscreen-content-hidden":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js")
;t.exports=class OffscreenContentHidden extends i{static get meta(){return Object.assign({id:"offscreen-content-hidden",description:"Offscreen content is hidden with display: none or aria-hidden=true. [Learn more](https://web.dev/offscreen-content-hidden/).",title:"Offscreen content is hidden from assistive technology"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/use-landmarks":[function(e,t,n){"use strict";const i=e("../../manual/manual-audit.js");t.exports=class UseLandmarks extends i{static get meta(){return Object.assign({id:"use-landmarks",description:"Landmark elements (<main>, <nav>, etc.) are used to improve the keyboard navigation of the page for assistive technology. [Learn more](https://web.dev/use-landmarks/).",title:"HTML5 landmark elements are used to improve navigation"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/manual/visual-order-follows-dom":[function(e,t,n){"use strict"
;const i=e("../../manual/manual-audit.js");t.exports=class VisualOrderFollowsDOM extends i{static get meta(){return Object.assign({id:"visual-order-follows-dom",description:"DOM order matches the visual order, improving navigation for assistive technology. [Learn more](https://web.dev/visual-order-follows-dom/).",title:"Visual order on the page follows DOM order"},super.partialMeta)}}},{"../../manual/manual-audit.js":6}],"../audits/accessibility/meta-refresh":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:'The document does not use `<meta http-equiv="refresh">`',failureTitle:'The document uses `<meta http-equiv="refresh">`',description:"Users do not expect a page to refresh automatically, and doing so will move focus back to the top of the page. This may create a frustrating or confusing experience. [Learn more](https://web.dev/meta-refresh/)."},c=a.createMessageInstanceIdFn(n,s)
;t.exports=class MetaRefresh extends i{static get meta(){return{id:"meta-refresh",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/meta-refresh.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/meta-viewport":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:'`[user-scalable="no"]` is not used in the `<meta name="viewport">` element and the `[maximum-scale]` attribute is not less than 5.',failureTitle:'`[user-scalable="no"]` is used in the `<meta name="viewport">` element or the `[maximum-scale]` attribute is less than 5.',description:"Disabling zooming is problematic for users with low vision who rely on screen magnification to properly see the contents of a web page. [Learn more](https://web.dev/meta-viewport/)."
},c=a.createMessageInstanceIdFn(n,s);t.exports=class MetaViewport extends i{static get meta(){return{id:"meta-viewport",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/meta-viewport.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/object-alt":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`<object>` elements have `[alt]` text",failureTitle:"`<object>` elements do not have `[alt]` text",description:"Screen readers cannot translate non-text content. Adding alt text to `<object>` elements helps screen readers convey meaning to users. [Learn more](https://web.dev/object-alt/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ObjectAlt extends i{static get meta(){return{id:"object-alt",title:c(s.title),
failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/object-alt.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/tabindex":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"No element has a `[tabindex]` value greater than 0",failureTitle:"Some elements have a `[tabindex]` value greater than 0",description:"A value greater than 0 implies an explicit navigation ordering. Although technically valid, this often creates frustrating experiences for users who rely on assistive technologies. [Learn more](https://web.dev/tabindex/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class TabIndex extends i{static get meta(){return{id:"tabindex",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},
t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/tabindex.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/td-headers-attr":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Cells in a `<table>` element that use the `[headers]` attribute refer to table cells within the same table.",failureTitle:"Cells in a `<table>` element that use the `[headers]` attribute refer to an element `id` not found within the same table.",description:"Screen readers have features to make navigating tables easier. Ensuring `<td>` cells using the `[headers]` attribute only refer to other cells in the same table may improve the experience for screen reader users. [Learn more](https://web.dev/td-headers-attr/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class TDHeadersAttr extends i{static get meta(){return{id:"td-headers-attr",title:c(s.title),
failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/td-headers-attr.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/th-has-data-cells":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:'`<th>` elements and elements with `[role="columnheader"/"rowheader"]` have data cells they describe.',failureTitle:'`<th>` elements and elements with `[role="columnheader"/"rowheader"]` do not have data cells they describe.',description:"Screen readers have features to make navigating tables easier. Ensuring table headers always refer to some set of cells may improve the experience for screen reader users. [Learn more](https://web.dev/th-has-data-cells/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class THHasDataCells extends i{static get meta(){return{
id:"th-has-data-cells",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/th-has-data-cells.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/valid-lang":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"`[lang]` attributes have a valid value",failureTitle:"`[lang]` attributes do not have a valid value",description:"Specifying a valid [BCP 47 language](https://www.w3.org/International/questions/qa-choosing-language-tags#question) on elements helps ensure that text is pronounced correctly by a screen reader. [Learn more](https://web.dev/valid-lang/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class ValidLang extends i{static get meta(){return{id:"valid-lang",title:c(s.title),failureTitle:c(s.failureTitle),
description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/valid-lang.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/accessibility/video-caption":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./axe-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:'`<video>` elements contain a `<track>` element with `[kind="captions"]`',failureTitle:'`<video>` elements do not contain a `<track>` element with `[kind="captions"]`.',description:"When a video provides a caption it is easier for deaf and hearing impaired users to access its information. [Learn more](https://web.dev/video-caption/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class VideoCaption extends i{static get meta(){return{id:"video-caption",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Accessibility"]}}},t.exports.UIStrings=s}).call(this)
}).call(this,"/lighthouse-core/audits/accessibility/video-caption.js")},{"../../lib/i18n/i18n.js":98,"./axe-audit.js":2}],"../audits/apple-touch-icon":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s={title:"Provides a valid `apple-touch-icon`",failureTitle:"Does not provide a valid `apple-touch-icon`",description:"For ideal appearance on iOS when users add a progressive web app to the home screen, define an `apple-touch-icon`. It must point to a non-transparent 192px (or 180px) square PNG. [Learn More](https://web.dev/apple-touch-icon/).",precomposedWarning:"`apple-touch-icon-precomposed` is out of date; `apple-touch-icon` is preferred."},c=a.createMessageInstanceIdFn(n,s);t.exports=class AppleTouchIcon extends i{static get meta(){return{id:"apple-touch-icon",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),supportedModes:["navigation"],requiredArtifacts:["LinkElements"]}}static audit(e){
const t=e.LinkElements.filter((e=>"apple-touch-icon"===e.rel||"apple-touch-icon-precomposed"===e.rel)).filter((e=>!!e.href)),n=0!==t.length,i=[];return 0!==t.filter((e=>"apple-touch-icon-precomposed"===e.rel)).length&&0===t.filter((e=>"apple-touch-icon"===e.rel)).length&&i.push(c(s.precomposedWarning)),{score:n?1:0,warnings:i}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/apple-touch-icon.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/autocomplete":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("lighthouse-logger"),c={title:"`<input>` elements correctly use `autocomplete`",failureTitle:"`<input>` elements do not have correct `autocomplete` attributes",
description:"`autocomplete` helps users submit forms quicker. To reduce user effort, consider enabling by setting the `autocomplete` attribute to a valid value. [Learn more](https://developers.google.com/web/fundamentals/design-and-ux/input/forms#use_metadata_to_enable_auto-complete)",columnSuggestions:"Suggested Token",columnCurrent:"Current Value",warningInvalid:'`autocomplete` token(s): "{token}" is invalid in {snippet}',warningOrder:'Review order of tokens: "{tokens}" in {snippet}',reviewOrder:"Review order of tokens",manualReview:"Requires manual review"
},l=a.createMessageInstanceIdFn(n,c),u=["name","honorific-prefix","given-name","additional-name","family-name","honorific-suffix","nickname","username","new-password","current-password","one-time-code","organization-title","organization","street-address","address-line1","address-line2","address-line3","address-level4","address-level3","address-level2","address-level1","country","country-name","postal-code","cc-name","cc-given-name","cc-additional-name","cc-family-name","cc-number","cc-exp","cc-exp-month","cc-exp-year","cc-csc","cc-type","transaction-currency","transaction-amount","language","bday","bday-day","bday-month","bday-year","sex","url","photo","tel","tel-country-code","tel-national","tel-area-code","on","tel-local","tel-local-prefix","tel-local-suffix","tel-extension","email","impp","off","additional-name-initial","home","work","mobile","fax","pager","shipping","billing"],d=["NO_SERVER_DATA","UNKNOWN_TYPE","EMPTY_TYPE","HTML_TYPE_UNSPECIFIED","HTML_TYPE_UNRECOGNIZED"],m={
NO_SERVER_DATA:l(c.manualReview),UNKNOWN_TYPE:l(c.manualReview),EMPTY_TYPE:l(c.manualReview),NAME_FIRST:"given-name",NAME_MIDDLE:"additional-name",NAME_LAST:"family-name",NAME_FULL:"name",NAME_MIDDLE_INITIAL:"additional-name-initial",NAME_SUFFIX:"honorific-suffix",NAME_BILLING_FIRST:"billing given-name",NAME_BILLING_MIDDLE:"billing additional-name",NAME_BILLING_LAST:"billing family-name",NAME_BILLING_MIDDLE_INITIAL:"billing additional-name-initial",NAME_BILLING_FULL:"billing name",NAME_BILLING_SUFFIX:"billing honorific-suffix",EMAIL_ADDRESS:"email",MERCHANT_EMAIL_SIGNUP:"email",PHONE_HOME_NUMBER:"tel-local",PHONE_HOME_CITY_CODE:"tel-area-code",PHONE_HOME_COUNTRY_CODE:"tel-country-code",PHONE_HOME_CITY_AND_NUMBER:"tel-national",PHONE_HOME_WHOLE_NUMBER:"tel",PHONE_HOME_EXTENSION:"tel-extension",PHONE_BILLING_NUMBER:"billing tel-local",PHONE_BILLING_CITY_CODE:"billing tel-area-code",PHONE_BILLING_COUNTRY_CODE:"tel-country-code",PHONE_BILLING_CITY_AND_NUMBER:"tel-national",
PHONE_BILLING_WHOLE_NUMBER:"tel",ADDRESS_HOME_STREET_ADDRESS:"street-address",ADDRESS_HOME_LINE1:"address-line1",ADDRESS_HOME_LINE2:"address-line2",ADDRESS_HOME_LINE3:"address-line3",ADDRESS_HOME_STATE:"address-level1",ADDRESS_HOME_CITY:"address-level2",ADDRESS_HOME_DEPENDENT_LOCALITY:"address-level3",ADDRESS_HOME_ZIP:"postal-code",ADDRESS_HOME_COUNTRY:"country-name",ADDRESS_BILLING_DEPENDENT_LOCALITY:"billing address-level3",ADDRESS_BILLING_STREET_ADDRESS:"billing street-address",ADDRESS_BILLING_LINE1:"billing address-line1",ADDRESS_BILLING_LINE2:"billing address-line2",ADDRESS_BILLING_LINE3:"billing address-line3",ADDRESS_BILLING_APT_NUM:"billing address-level3",ADDRESS_BILLING_CITY:"billing address-level2",ADDRESS_BILLING_STATE:"billing address-level1",ADDRESS_BILLING_ZIP:"billing postal-code",ADDRESS_BILLING_COUNTRY:"billing country-name",CREDIT_CARD_NAME_FULL:"cc-name",CREDIT_CARD_NAME_FIRST:"cc-given-name",CREDIT_CARD_NAME_LAST:"cc-family-name",CREDIT_CARD_NUMBER:"cc-number",
CREDIT_CARD_EXP_MONTH:"cc-exp-month",CREDIT_CARD_EXP_2_DIGIT_YEAR:"cc-exp-year",CREDIT_CARD_EXP_4_DIGIT_YEAR:"cc-exp-year",CREDIT_CARD_EXP_DATE_2_DIGIT_YEAR:"cc-exp",CREDIT_CARD_EXP_DATE_4_DIGIT_YEAR:"cc-exp",CREDIT_CARD_TYPE:"cc-type",CREDIT_CARD_VERIFICATION_CODE:"cc-csc",COMPANY_NAME:"organization",PASSWORD:"current-password",ACCOUNT_CREATION_PASSWORD:"new-password",HTML_TYPE_UNSPECIFIED:l(c.manualReview),HTML_TYPE_NAME:"name",HTML_TYPE_HONORIFIC_PREFIX:"honorific-prefix",HTML_TYPE_GIVEN_NAME:"given-name",HTML_TYPE_ADDITIONAL_NAME:"additional-name",HTML_TYPE_FAMILY_NAME:"family-name",HTML_TYPE_ORGANIZATION:"organization",HTML_TYPE_STREET_ADDRESS:"street-address",HTML_TYPE_ADDRESS_LINE1:"address-line1",HTML_TYPE_ADDRESS_LINE2:"address-line2",HTML_TYPE_ADDRESS_LINE3:"address-line3",HTML_TYPE_ADDRESS_LEVEL1:"address-level1",HTML_TYPE_ADDRESS_LEVEL2:"address-level2",HTML_TYPE_ADDRESS_LEVEL3:"address-level3",HTML_TYPE_COUNTRY_CODE:"tel-country-code",HTML_TYPE_COUNTRY_NAME:"country-name",
HTML_TYPE_POSTAL_CODE:"postal-code",HTML_TYPE_FULL_ADDRESS:"street-address",HTML_TYPE_CREDIT_CARD_NAME_FULL:"cc-name",HTML_TYPE_CREDIT_CARD_NAME_FIRST:"cc-given-name",HTML_TYPE_CREDIT_CARD_NAME_LAST:"cc-family-name",HTML_TYPE_CREDIT_CARD_NUMBER:"cc-number",HTML_TYPE_CREDIT_CARD_EXP:"cc-exp",HTML_TYPE_CREDIT_CARD_EXP_MONTH:"cc-exp-month",HTML_TYPE_CREDIT_CARD_EXP_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_VERIFICATION_CODE:"cc-csc",HTML_TYPE_CREDIT_CARD_TYPE:"cc-csc",HTML_TYPE_TEL:"tel",HTML_TYPE_TEL_COUNTRY_CODE:"tel-country-code",HTML_TYPE_TEL_NATIONAL:"tel-national",HTML_TYPE_TEL_AREA_CODE:"tel-area-code",HTML_TYPE_TEL_LOCAL:"tel-local",HTML_TYPE_TEL_LOCAL_PREFIX:"tel-local-prefix",HTML_TYPE_TEL_LOCAL_SUFFIX:"tel-local-suffix",HTML_TYPE_TEL_EXTENSION:"tel-extension",HTML_TYPE_EMAIL:"email",HTML_TYPE_ADDITIONAL_NAME_INITIAL:"additional-name-initial",HTML_TYPE_CREDIT_CARD_EXP_DATE_2_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_DATE_4_DIGIT_YEAR:"cc-exp-year",
HTML_TYPE_CREDIT_CARD_EXP_2_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_CREDIT_CARD_EXP_4_DIGIT_YEAR:"cc-exp-year",HTML_TYPE_UPI_VPA:l(c.manualReview),HTML_TYPE_ONE_TIME_CODE:"one-time-code",HTML_TYPE_UNRECOGNIZED:l(c.manualReview),HTML_TYPE_TRANSACTION_AMOUNT:"transaction-amount",HTML_TYPE_TRANSACTION_CURRENCY:"transaction-currency"};t.exports=class AutocompleteAudit extends i{static get meta(){return{id:"autocomplete",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["FormElements"]}}static checkAttributeValidity(e){if(!e.autocomplete.attribute)return{hasValidTokens:!1};const t=e.autocomplete.attribute.split(" ");for(const e of t)if("section-"!==e.slice(0,8)&&!u.includes(e))return{hasValidTokens:!1};return e.autocomplete.property?{hasValidTokens:!0,isValidOrder:!0}:{hasValidTokens:!0,isValidOrder:!1}}static audit(e){const t=e.FormElements,n=[],u=[];let p=!1;for(const e of t)for(const t of e.inputs){const e=this.checkAttributeValidity(t)
;if(e.hasValidTokens&&e.isValidOrder)continue;if(!t.autocomplete.prediction)continue;if(d.includes(t.autocomplete.prediction)&&!t.autocomplete.attribute)continue;p=!0;let a=m[t.autocomplete.prediction];t.autocomplete.attribute||(t.autocomplete.attribute=""),t.autocomplete.attribute&&u.push(l(c.warningInvalid,{token:t.autocomplete.attribute,snippet:t.node.snippet})),!1===e.isValidOrder&&(u.push(l(c.warningOrder,{tokens:t.autocomplete.attribute,snippet:t.node.snippet})),a=c.reviewOrder),t.autocomplete.prediction in m||!e.isValidOrder?n.push({node:i.makeNodeItem(t.node),suggestion:a,current:t.autocomplete.attribute}):s.warn(`Autocomplete prediction (${t.autocomplete.prediction})\n             not found in our mapping`)}const h=[{key:"node",itemType:"node",text:l(a.UIStrings.columnFailingElem)},{key:"current",itemType:"text",text:l(c.columnCurrent)},{key:"suggestion",itemType:"text",text:l(c.columnSuggestions)}],f=i.makeTableDetails(h,n);let g
;return n.length>0&&(g=l(a.UIStrings.displayValueElementsFound,{nodeCount:n.length})),{score:n.length>0?0:1,notApplicable:!p,displayValue:g,details:f,warnings:u}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/autocomplete.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3,"lighthouse-logger":188}],"../audits/bootup-time":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/network-request.js"),{taskGroups:s}=e("../lib/tracehouse/task-groups.js"),c=e("../lib/i18n/i18n.js"),l=e("../computed/network-records.js"),u=e("../computed/main-thread-tasks.js"),d={title:"JavaScript execution time",failureTitle:"Reduce JavaScript execution time",description:"Consider reducing the time spent parsing, compiling, and executing JS. You may find delivering smaller JS payloads helps with this. [Learn more](https://web.dev/bootup-time/).",columnTotal:"Total CPU Time",columnScriptEval:"Script Evaluation",columnScriptParse:"Script Parse",
chromeExtensionsWarning:"Chrome extensions negatively affected this page's load performance. Try auditing the page in incognito mode or from a Chrome profile without extensions."},m=c.createMessageInstanceIdFn(n,d),p=new Set(["CpuProfiler::StartProfiling"]),h=new Set(["V8.GCCompactor","MajorGC","MinorGC"]);class BootupTime extends i{static get meta(){return{id:"bootup-time",title:m(d.title),failureTitle:m(d.failureTitle),description:m(d.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","devtoolsLogs"]}}static get defaultOptions(){return{p10:1282,median:3500,thresholdInMs:50}}static getJavaScriptURLs(e){const t=new Set;for(const n of e)n.resourceType===a.TYPES.Script&&t.add(n.url);return t}static getAttributableURLForTask(e,t){const n=e.attributableURLs.find((e=>t.has(e))),i=e.attributableURLs[0];let a=n||i;return a&&"about:blank"!==a||(a=p.has(e.event.name)?"Browser":h.has(e.event.name)?"Browser GC":"Unattributable"),a}
static getExecutionTimingsByURL(e,t){const n=new Map;for(const i of e){const e=BootupTime.getAttributableURLForTask(i,t),a=n.get(e)||{},s=a[i.group.id]||0;a[i.group.id]=s+i.selfTime,n.set(e,a)}return n}static async audit(e,t){const n=t.settings||{},a=e.traces[BootupTime.DEFAULT_PASS],p=e.devtoolsLogs[BootupTime.DEFAULT_PASS],h=await l.request(p,t),f=await u.request(a,t),g="simulate"===n.throttlingMethod?n.throttling.cpuSlowdownMultiplier:1,y=BootupTime.getJavaScriptURLs(h),b=BootupTime.getExecutionTimingsByURL(f,y);let v=!1,w=0;const S=Array.from(b).map((([e,n])=>{let i=0;for(const[e,t]of Object.entries(n))n[e]=t*g,i+=t*g;const a=n[s.scriptEvaluation.id]||0,c=n[s.scriptParseCompile.id]||0;return i>=t.options.thresholdInMs&&(w+=a+c),v=v||e.startsWith("chrome-extension:")&&a>100,{url:e,total:i,scripting:a,scriptParseCompile:c}})).filter((e=>e.total>=t.options.thresholdInMs)).sort(((e,t)=>t.total-e.total));let T;v&&(T=[m(d.chromeExtensionsWarning)]);const E={wastedMs:w},_=[{key:"url",
itemType:"url",text:m(c.UIStrings.columnURL)},{key:"total",granularity:1,itemType:"ms",text:m(d.columnTotal)},{key:"scripting",granularity:1,itemType:"ms",text:m(d.columnScriptEval)},{key:"scriptParseCompile",granularity:1,itemType:"ms",text:m(d.columnScriptParse)}],x=BootupTime.makeTableDetails(_,S,E);return{score:i.computeLogNormalScore({p10:t.options.p10,median:t.options.median},w),numericValue:w,numericUnit:"millisecond",displayValue:w>0?m(c.UIStrings.seconds,{timeInMs:w}):"",details:x,runWarnings:T}}}t.exports=BootupTime,t.exports.UIStrings=d}).call(this)}).call(this,"/lighthouse-core/audits/bootup-time.js")},{"../computed/main-thread-tasks.js":15,"../computed/network-records.js":40,"../lib/i18n/i18n.js":98,"../lib/network-request.js":109,"../lib/tracehouse/task-groups.js":118,"./audit.js":3}],"../audits/byte-efficiency/duplicated-javascript":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./byte-efficiency-audit.js"),a=e("../../computed/module-duplication.js"),s=e("../../lib/dependency-graph/simulator/network-analyzer.js"),c=e("../../lib/i18n/i18n.js"),l={title:"Remove duplicate modules in JavaScript bundles",description:"Remove large, duplicate JavaScript modules from bundles to reduce unnecessary bytes consumed by network activity. "},u=c.createMessageInstanceIdFn(n,l);function indexOfOrEnd(e,t,n=0){const i=e.indexOf(t,n);return-1===i?e.length:i}class DuplicatedJavascript extends i{static get meta(){return{id:"duplicated-javascript",title:u(l.title),description:u(l.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces","SourceMaps","ScriptElements","GatherContext","URL"]}}static _getNodeModuleName(e){const t=e.split("node_modules/"),n=indexOfOrEnd(e=t[t.length-1],"/");return"@"===e[0]?e.slice(0,indexOfOrEnd(e,"/",n+1)):e.slice(0,n)}static async _getDuplicationGroupedByNodeModules(e,t){
const n=await a.request(e,t),i=new Map;for(const[e,t]of n.entries()){if(!e.includes("node_modules")){i.set(e,t);continue}const n="node_modules/"+DuplicatedJavascript._getNodeModuleName(e),a=i.get(n)||[];for(const{scriptUrl:e,resourceSize:n}of t){let t=a.find((t=>t.scriptUrl===e));t||(t={scriptUrl:e,resourceSize:0},a.push(t)),t.resourceSize+=n}i.set(n,a)}for(const e of n.values())e.sort(((e,t)=>t.resourceSize-e.resourceSize));return i}static _estimateTransferRatio(e,t){return i.estimateTransferSize(e,t,"Script")/t}static async audit_(e,t,n){const i=n.options&&n.options.ignoreThresholdInBytes||1024,a=await DuplicatedJavascript._getDuplicationGroupedByNodeModules(e,n),l=s.findOptionalMainDocument(t),d=new Map,m=[];let p=0;const h=new Set,f=new Map;for(const[n,s]of a.entries()){const a=[];let c=0;for(let n=0;n<s.length;n++){const i=s[n],u=i.scriptUrl;let m=d.get(u);if(void 0===m){const n=u===e.URL.finalUrl?l:t.find((e=>e.url===u)),i=e.ScriptElements.find((e=>e.src===u))
;if(!i||null===i.content)continue;const a=i.content.length;m=DuplicatedJavascript._estimateTransferRatio(n,a),d.set(u,m)}if(void 0===m)continue;const p=Math.round(i.resourceSize*m);a.push({url:u,sourceTransferBytes:p}),0!==n&&(c+=p,f.set(u,(f.get(u)||0)+p))}if(c<=i){p+=c;for(const e of a)h.add(e.url)}else m.push({source:n,wastedBytes:c,url:"",totalBytes:0,subItems:{type:"subitems",items:a}})}p>i&&m.push({source:"Other",wastedBytes:p,url:"",totalBytes:0,subItems:{type:"subitems",items:Array.from(h).map((e=>({url:e})))}});return{items:m,headings:[{key:"source",valueType:"code",subItemsHeading:{key:"url",valueType:"url"},label:u(c.UIStrings.columnSource)},{key:null,valueType:"bytes",subItemsHeading:{key:"sourceTransferBytes"},granularity:.05,label:u(c.UIStrings.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",granularity:.05,label:u(c.UIStrings.columnWastedBytes)}],wastedBytesByUrl:f}}}t.exports=DuplicatedJavascript,t.exports.UIStrings=l}).call(this)
}).call(this,"/lighthouse-core/audits/byte-efficiency/duplicated-javascript.js")},{"../../computed/module-duplication.js":38,"../../lib/dependency-graph/simulator/network-analyzer.js":93,"../../lib/i18n/i18n.js":98,"./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/efficient-animated-content":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../../lib/network-request.js"),a=e("./byte-efficiency-audit.js"),s=e("../../lib/i18n/i18n.js"),c={title:"Use video formats for animated content",description:"Large GIFs are inefficient for delivering animated content. Consider using MPEG4/WebM videos for animations and PNG/WebP for static images instead of GIF to save network bytes. [Learn more](https://web.dev/efficient-animated-content/)"},l=s.createMessageInstanceIdFn(n,c);class EfficientAnimatedContent extends a{static get meta(){return{id:"efficient-animated-content",title:l(c.title),description:l(c.description),scoreDisplayMode:a.SCORING_MODES.NUMERIC,
requiredArtifacts:["devtoolsLogs","traces","GatherContext"]}}static getPercentSavings(e){return Math.round(29.1*Math.log10(e)-100.7)/100}static audit_(e,t){return{items:t.filter((e=>"image/gif"===e.mimeType&&e.resourceType===i.TYPES.Image&&(e.resourceSize||0)>102400)).map((e=>{const t=e.resourceSize||0;return{url:e.url,totalBytes:t,wastedBytes:Math.round(t*EfficientAnimatedContent.getPercentSavings(t))}})),headings:[{key:"url",valueType:"url",label:l(s.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:l(s.UIStrings.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:l(s.UIStrings.columnWastedBytes)}]}}}t.exports=EfficientAnimatedContent,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/efficient-animated-content.js")},{"../../lib/i18n/i18n.js":98,"../../lib/network-request.js":109,"./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/legacy-javascript":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./byte-efficiency-audit.js"),a=e("../../computed/js-bundles.js"),s=e("../../lib/i18n/i18n.js"),c=e("../../lib/third-party-web.js"),l=e("../../lib/dependency-graph/simulator/network-analyzer.js"),u={title:"Avoid serving legacy JavaScript to modern browsers",description:"Polyfills and transforms enable legacy browsers to use new JavaScript features. However, many aren't necessary for modern browsers. For your bundled JavaScript, adopt a modern script deployment strategy using module/nomodule feature detection to reduce the amount of code shipped to modern browsers, while retaining support for legacy browsers. [Learn More](https://philipwalton.com/articles/deploying-es2015-code-in-production-today/)"},d=s.createMessageInstanceIdFn(n,u);class CodePatternMatcher{constructor(e){const t=e.map((e=>`(${e.expression})`)).join("|");this.re=new RegExp("(^\r\n|\r|\n)|"+t,"g"),this.patterns=e}match(e){this.re.lastIndex=0;const t=new Set,n=[];let i,a=0,s=0
;for(;null!==(i=this.re.exec(e));){const e=i.slice(1),[c,...l]=e;if(c){a++,s=i.index+1;continue}const u=this.patterns[l.findIndex(Boolean)];if(t.has(u)){const e=n.find((e=>e.name===u.name));e&&(e.count+=1)}else t.add(u),n.push({name:u.name,line:a,column:i.index-s,count:1})}return n}}t.exports=class LegacyJavascript extends i{static get meta(){return{id:"legacy-javascript",scoreDisplayMode:i.SCORING_MODES.NUMERIC,description:d(u.description),title:d(u.title),requiredArtifacts:["devtoolsLogs","traces","ScriptElements","SourceMaps","GatherContext","URL"]}}static buildPolyfillExpression(e,t){const qt=e=>`['"]${e}['"]`;let n="";if(n+=e?`${e}\\.${t}\\s?=[^=]`:`(?:window\\.|[\\s;]+)${t}\\s?=[^=]`,e&&(n+=`|${e}\\[${qt(t)}\\]\\s?=[^=]`),n+=`|defineProperty\\(${e||"window"},\\s?${qt(t)}`,e){const i=e.replace(".prototype","");n+=`|\\$export\\([^,]+,${qt(i)},{${t}:`,n+=`|{target:${qt(i)}\\S*},{${t}:`}else n+=`|function ${t}\\(`;return n}static getPolyfillData(){
return[["Array.prototype.fill","es6.array.fill"],["Array.prototype.filter","es6.array.filter"],["Array.prototype.find","es6.array.find"],["Array.prototype.findIndex","es6.array.find-index"],["Array.prototype.forEach","es6.array.for-each"],["Array.from","es6.array.from"],["Array.isArray","es6.array.is-array"],["Array.prototype.map","es6.array.map"],["Array.of","es6.array.of"],["Array.prototype.reduce","es6.array.reduce"],["Array.prototype.reduceRight","es6.array.reduce-right"],["Array.prototype.some","es6.array.some"],["Date.now","es6.date.now"],["Date.prototype.toISOString","es6.date.to-iso-string"],["Date.prototype.toJSON","es6.date.to-json"],["Date.prototype.toString","es6.date.to-string"],["Function.prototype.name","es6.function.name"],["Number.isInteger","es6.number.is-integer"],["Number.isSafeInteger","es6.number.is-safe-integer"],["Number.parseInt","es6.number.parse-int"],["Object.defineProperties","es6.object.define-properties"],["Object.defineProperty","es6.object.define-property"],["Object.freeze","es6.object.freeze"],["Object.getOwnPropertyNames","es6.object.get-own-property-names"],["Object.getPrototypeOf","es6.object.get-prototype-of"],["Object.isExtensible","es6.object.is-extensible"],["Object.isFrozen","es6.object.is-frozen"],["Object.isSealed","es6.object.is-sealed"],["Object.keys","es6.object.keys"],["Object.preventExtensions","es6.object.prevent-extensions"],["Object.seal","es6.object.seal"],["Object.setPrototypeOf","es6.object.set-prototype-of"],["Reflect.apply","es6.reflect.apply"],["Reflect.construct","es6.reflect.construct"],["Reflect.defineProperty","es6.reflect.define-property"],["Reflect.deleteProperty","es6.reflect.delete-property"],["Reflect.get","es6.reflect.get"],["Reflect.getOwnPropertyDescriptor","es6.reflect.get-own-property-descriptor"],["Reflect.getPrototypeOf","es6.reflect.get-prototype-of"],["Reflect.has","es6.reflect.has"],["Reflect.isExtensible","es6.reflect.is-extensible"],["Reflect.ownKeys","es6.reflect.own-keys"],["Reflect.preventExtensions","es6.reflect.prevent-extensions"],["Reflect.setPrototypeOf","es6.reflect.set-prototype-of"],["String.prototype.codePointAt","es6.string.code-point-at"],["String.fromCodePoint","es6.string.from-code-point"],["String.raw","es6.string.raw"],["String.prototype.repeat","es6.string.repeat"],["Array.prototype.includes","es7.array.includes"],["Object.entries","es7.object.entries"],["Object.getOwnPropertyDescriptors","es7.object.get-own-property-descriptors"],["Object.values","es7.object.values"]].map((e=>{
const[t,n]=e;return{name:t,coreJs2Module:n,coreJs3Module:n.replace("es6.","es.").replace("es7.","es.").replace("typed.","typed-array.")}}))}static getPolyfillPatterns(){return this.getPolyfillData().map((({name:e})=>{const t=e.split("."),n=t.length>1?t.slice(0,t.length-1).join("."):null,i=t[t.length-1];return{name:e,expression:this.buildPolyfillExpression(n,i)}}))}static getTransformPatterns(){return[{name:"@babel/plugin-transform-classes",expression:"Cannot call a class as a function",estimateBytes:e=>150+e.count*"_classCallCheck()".length},{name:"@babel/plugin-transform-regenerator",expression:/regeneratorRuntime\.a?wrap/.source,estimateBytes:e=>80*e.count},{name:"@babel/plugin-transform-spread",expression:/\.apply\(void 0,\s?_toConsumableArray/.source,estimateBytes:e=>1169+e.count*"_toConsumableArray()".length}]}static detectAcrossScripts(e,t,n,i){const a=new Map,s=this.getPolyfillData();for(const{requestId:c,content:l}of Object.values(t)){if(!l)continue
;const t=n.find((e=>e.requestId===c));if(!t)continue;const u=e.match(l),d=i.find((e=>e.script.src===t.url));if(d)for(const{coreJs2Module:e,coreJs3Module:t,name:n}of s){if(u.some((e=>e.name===n)))continue;const i=d.rawMap.sources.find((n=>n.endsWith(e+".js")||n.endsWith(t+".js")));if(!i)continue;const a=d.map.mappings().find((e=>e.sourceURL===i));a?u.push({name:n,line:a.lineNumber,column:a.columnNumber,count:1}):u.push({name:n,line:0,column:0,count:1})}u.length&&a.set(t.url,u)}return a}static estimateWastedBytes(t){const n=t.filter((e=>!e.name.startsWith("@"))),i=t.filter((e=>e.name.startsWith("@")));let a=0;const s=e("./polyfill-graph-data.json"),c=new Set;for(const e of n){const t=s.dependencies[e.name];if(t)for(const e of t)c.add(e)}n.length>0&&(a+=s.baseSize),a+=[...c].reduce(((e,t)=>e+s.moduleSizes[t]),0),a=Math.min(a,s.maxSize);let l=0;for(const e of i){const t=this.getTransformPatterns().find((t=>t.name===e.name));t&&t.estimateBytes&&(l+=t.estimateBytes(e))}return a+l}
static async estimateTransferRatioForScript(e,t,n,a){let s=e.get(t);if(void 0!==s)return s;const c=l.findOptionalMainDocument(a),u=t===n.URL.finalUrl?c:a.find((e=>e.url===t)),d=n.ScriptElements.find((e=>e.src===t));if(d&&null!==d.content){const e=d.content.length;s=i.estimateTransferSize(u,e,"Script")/e}else s=1;return e.set(t,s),s}static _findOriginalLocation(e,t,n){const i=e&&e.map.findEntry(t,n);if(i)return{file:i.sourceURL||"",line:i.sourceLineNumber||0,column:i.sourceColumnNumber||0}}static async audit_(e,t,n){const i=c.getEntity(e.URL.finalUrl),l=await a.request(e,n),u=[],m=new CodePatternMatcher([...this.getPolyfillPatterns(),...this.getTransformPatterns()]),p=new Map,h=this.detectAcrossScripts(m,e.ScriptElements,t,l);for(const[n,i]of h.entries()){const a=await this.estimateTransferRatioForScript(p,n,e,t),s=Math.round(this.estimateWastedBytes(i)*a),c={url:n,wastedBytes:s,subItems:{type:"subitems",items:[]},totalBytes:0},d=l.find((e=>e.script.src===n));for(const e of i){
const{name:t,line:i,column:a}=e,s={signal:t,location:{type:"source-location",url:n,line:i,column:a,original:d&&this._findOriginalLocation(d,i,a),urlProvider:"network"}};c.subItems.items.push(s)}u.push(c)}const f=new Map;for(const e of u)c.isFirstParty(e.url,i)&&f.set(e.url,e.wastedBytes);return{items:u,headings:[{key:"url",valueType:"url",subItemsHeading:{key:"location",valueType:"source-location"},label:d(s.UIStrings.columnURL)},{key:null,valueType:"code",subItemsHeading:{key:"signal"},label:""},{key:"wastedBytes",valueType:"bytes",label:d(s.UIStrings.columnWastedBytes)}],wastedBytesByUrl:f}}},t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/legacy-javascript.js")},{"../../computed/js-bundles.js":12,"../../lib/dependency-graph/simulator/network-analyzer.js":93,"../../lib/i18n/i18n.js":98,"../../lib/third-party-web.js":116,"./byte-efficiency-audit.js":4,"./polyfill-graph-data.json":5}],
"../audits/byte-efficiency/modern-image-formats":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../lib/url-shim.js"),s=e("../../lib/i18n/i18n.js"),c={title:"Serve images in next-gen formats",description:"Image formats like WebP and AVIF often provide better compression than PNG or JPEG, which means faster downloads and less data consumption. [Learn more](https://web.dev/uses-webp-images/)."},l=s.createMessageInstanceIdFn(n,c);class ModernImageFormats extends i{static get meta(){return{id:"modern-image-formats",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["OptimizedImages","devtoolsLogs","traces","URL","GatherContext","ImageElements"]}}static estimateWebPSizeFromDimensions(e){const t=e.naturalWidth*e.naturalHeight;return Math.round(.2*t)}static estimateAvifSizeFromDimensions(e){const t=e.naturalWidth*e.naturalHeight;return Math.round(t*(2/12))}
static estimateAvifSizeFromWebPAndJpegEstimates(e){if(!e.jpegSize||!e.webpSize)return;return 5*e.jpegSize/10/2+8*e.webpSize/10/2}static audit_(e){const t=e.URL.finalUrl,n=e.OptimizedImages,i=e.ImageElements,c=new Map;i.forEach((e=>c.set(e.src,e)));const u=[],d=[];for(const e of n){if(e.failed){d.push("Unable to decode "+a.getURLDisplayName(e.url));continue}if("image/webp"===e.mimeType||"image/avif"===e.mimeType)continue;const n=e.jpegSize;let i=e.webpSize,s=ModernImageFormats.estimateAvifSizeFromWebPAndJpegEstimates({jpegSize:n,webpSize:i}),l=!0;if(void 0===i){const t=c.get(e.url);if(!t){d.push("Unable to locate resource "+a.getURLDisplayName(e.url));continue}if(!t.naturalDimensions)continue;const n=t.naturalDimensions.height,u=t.naturalDimensions.width;if(!u||!n)continue;i=ModernImageFormats.estimateWebPSizeFromDimensions({naturalHeight:n,naturalWidth:u}),s=ModernImageFormats.estimateAvifSizeFromDimensions({naturalHeight:n,naturalWidth:u}),l=!1}if(void 0===i||void 0===s)continue
;const m=e.originalSize-i,p=e.originalSize-s;if(p<8192)continue;const h=a.elideDataURI(e.url),f=!a.originsMatch(t,e.url);u.push({url:h,fromProtocol:l,isCrossOrigin:f,totalBytes:e.originalSize,wastedBytes:p,wastedWebpBytes:m})}return{warnings:d,items:u,headings:[{key:"url",valueType:"thumbnail",label:""},{key:"url",valueType:"url",label:l(s.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:l(s.UIStrings.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:l(s.UIStrings.columnWastedBytes)}]}}}t.exports=ModernImageFormats,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/modern-image-formats.js")},{"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/offscreen-images":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./byte-efficiency-audit.js"),a=e("../../lib/network-request.js"),s=e("../../lib/sentry.js"),c=e("../../lib/url-shim.js"),l=e("../../lib/i18n/i18n.js"),u=e("../../computed/metrics/interactive.js"),d=e("../../computed/processed-trace.js"),m={title:"Defer offscreen images",description:"Consider lazy-loading offscreen and hidden images after all critical resources have finished loading to lower time to interactive. [Learn more](https://web.dev/offscreen-images/)."},p=l.createMessageInstanceIdFn(n,m);class OffscreenImages extends i{static get meta(){return{id:"offscreen-images",title:p(m.title),description:p(m.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["ImageElements","ViewportDimensions","GatherContext","devtoolsLogs","traces"]}}static computeVisiblePixels(e,t){const n=t.innerWidth,i=t.innerHeight,a=3*t.innerHeight,s=Math.max(e.top,-100),c=Math.min(e.right,n+100),l=Math.min(e.bottom,i+a),u=Math.max(e.left,-100)
;return Math.max(c-u,0)*Math.max(l-s,0)}static computeWaste(e,t,n){const i=n.find((t=>t.url===e.src));if(!i)return null;if("lazy"===e.loading||"eager"===e.loading)return null;const s=c.elideDataURI(e.src),l=e.displayedWidth*e.displayedHeight,u=this.computeVisiblePixels(e.clientRect,t),d=0===l?1:1-u/l,m=a.getResourceSizeOnNetwork(i),p=Math.round(m*d);return Number.isFinite(d)?{url:s,requestStartTime:i.startTime,totalBytes:m,wastedBytes:p,wastedPercent:100*d}:new Error("Invalid image sizing information "+s)}static filterLanternResults(e,t){const n=t.pessimisticEstimate.nodeTimings;let i=0;const a=new Map;for(const[e,t]of n)"cpu"===e.type&&t.duration>=50?i=Math.max(i,t.startTime):"network"===e.type&&a.set(e.record.url,t.startTime);return e.filter((e=>{if(e.wastedBytes<2048)return!1;if(e.wastedPercent<75)return!1;return(a.get(e.url)||0)<i-50}))}static filterObservedResults(e,t){return e.filter((e=>!(e.wastedBytes<2048)&&(!(e.wastedPercent<75)&&e.requestStartTime<t/1e6-.05)))}
static computeWasteWithTTIGraph(e,t,n){return super.computeWasteWithTTIGraph(e,t,n,{includeLoad:!1})}static async audit_(e,t,n){const a=e.ImageElements,c=e.ViewportDimensions,m=e.GatherContext,h=e.traces[i.DEFAULT_PASS],f=e.devtoolsLogs[i.DEFAULT_PASS],g=[],y=a.reduce(((e,n)=>{const i=OffscreenImages.computeWaste(n,c,t);if(null===i)return e;if(i instanceof Error)return g.push(i.message),s.captureException(i,{tags:{audit:this.meta.id},level:"warning"}),e;const a=e.get(i.url);return(!a||a.wastedBytes>i.wastedBytes)&&e.set(i.url,i),e}),new Map),b=n.settings;let v;const w=Array.from(y.values());try{const e={trace:h,devtoolsLog:f,gatherContext:m,settings:b},t=await u.request(e,n),i=t;v="simulate"===n.settings.throttlingMethod?OffscreenImages.filterLanternResults(w,i):OffscreenImages.filterObservedResults(w,t.timestamp)}catch(e){if("simulate"===n.settings.throttlingMethod)throw e;v=OffscreenImages.filterObservedResults(w,await d.request(h,n).then((e=>e.timestamps.traceEnd)))}const S=[{
key:"url",valueType:"thumbnail",label:""},{key:"url",valueType:"url",label:p(l.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:p(l.UIStrings.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:p(l.UIStrings.columnWastedBytes)}];return{warnings:g,items:v,headings:S}}}t.exports=OffscreenImages,t.exports.UIStrings=m}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/offscreen-images.js")},{"../../computed/metrics/interactive.js":21,"../../computed/processed-trace.js":43,"../../lib/i18n/i18n.js":98,"../../lib/network-request.js":109,"../../lib/sentry.js":112,"../../lib/url-shim.js":"url","./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/render-blocking-resources":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../lib/dependency-graph/base-node.js"),c=e("./byte-efficiency-audit.js"),l=e("../../computed/unused-css.js"),u=e("../../lib/network-request.js"),d=e("../../computed/processed-trace.js"),m=e("../../computed/processed-navigation.js"),p=e("../../computed/load-simulator.js"),h=e("../../computed/metrics/first-contentful-paint.js"),f={title:"Eliminate render-blocking resources",description:"Resources are blocking the first paint of your page. Consider delivering critical JS/CSS inline and deferring all non-critical JS/styles. [Learn more](https://web.dev/render-blocking-resources/)."},g=a.createMessageInstanceIdFn(n,f);function computeStackSpecificTiming(e,t,n){const i={...t};return n.some((e=>"amp"===e.id))&&e.type===s.TYPES.NETWORK&&e.record.resourceType===u.TYPES.Stylesheet&&t.endTime>2100&&(i.endTime=Math.max(t.startTime,2100),i.duration=i.endTime-i.startTime),i}class RenderBlockingResources extends i{static get meta(){
return{id:"render-blocking-resources",title:g(f.title),supportedModes:["navigation"],scoreDisplayMode:i.SCORING_MODES.NUMERIC,description:g(f.description),requiredArtifacts:["URL","TagsBlockingFirstPaint","traces","devtoolsLogs","CSSUsage","GatherContext","Stacks"]}}static async computeResults(e,t){const n=e.GatherContext,a=e.traces[i.DEFAULT_PASS],s=e.devtoolsLogs[i.DEFAULT_PASS],c={devtoolsLog:s,settings:t.settings},l=await d.request(a,t),u=await m.request(l,t),f=await p.request(c,t),g=await RenderBlockingResources.computeWastedCSSBytes(e,t),y={trace:a,devtoolsLog:s,gatherContext:n,simulator:f,settings:{...t.settings,throttlingMethod:"simulate"}},b=await h.request(y,t),v=u.timestamps.firstContentfulPaint/1e3,w=function getNodesAndTimingByUrl(e){const t={};return Array.from(e.keys()).forEach((n=>{if("network"!==n.type)return;const i=e.get(n);i&&(t[n.record.url]={node:n,nodeTiming:i})})),t}(b.optimisticEstimate.nodeTimings),S=[],T=new Set;for(const t of e.TagsBlockingFirstPaint){
if(1e3*t.endTime>v)continue;if(!w[t.tag.url])continue;const{node:n,nodeTiming:i}=w[t.tag.url],a=computeStackSpecificTiming(n,i,e.Stacks);n.traverse((e=>T.add(e.id)));const s=Math.round(a.duration);s<50||S.push({url:t.tag.url,totalBytes:t.transferSize,wastedMs:s})}if(!S.length)return{results:S,wastedMs:0};return{results:S,wastedMs:RenderBlockingResources.estimateSavingsWithGraphs(f,b.optimisticGraph,T,g,e.Stacks)}}static estimateSavingsWithGraphs(e,t,n,i,a){const{nodeTimings:c}=e.simulate(t),l=new Map(c);let d=0;const m=t.cloneWithRelationships((e=>{!function adjustNodeTimings(e,t,n){const i=e.get(t);if(!i)return;const a=computeStackSpecificTiming(t,i,n);i.duration-a.duration&&(t.traverse((t=>{e.delete(t)})),e.set(t,a))}(l,e,a);const t=n.has(e.id);if(e.type!==s.TYPES.NETWORK)return!t;const c=e.record.resourceType===u.TYPES.Stylesheet;if(t&&c){const t=i.get(e.record.url)||0;d+=(e.record.transferSize||0)-t}return!t}))
;if("network"!==m.type)throw new Error("minimalFCPGraph not a NetworkNode");const p=Math.max(...Array.from(Array.from(l).map((e=>e[1].endTime)))),h=m.record.transferSize,f=h||0;m.record.transferSize=f+d;const g=e.simulate(m).timeInMs;return m.record.transferSize=h,Math.round(Math.max(p-g,0))}static async computeWastedCSSBytes(e,t){const n=new Map;try{const a=await l.request({CSSUsage:e.CSSUsage,URL:e.URL,devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS]},t);for(const e of a)n.set(e.url,e.wastedBytes)}catch(e){}return n}static async audit(e,t){const{results:n,wastedMs:s}=await RenderBlockingResources.computeResults(e,t);let l;n.length>0&&(l=g(a.UIStrings.displayValueMsSavings,{wastedMs:s}));const u=[{key:"url",valueType:"url",label:g(a.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:g(a.UIStrings.columnTransferSize)},{key:"wastedMs",valueType:"timespanMs",label:g(a.UIStrings.columnWastedMs)}],d=i.makeOpportunityDetails(u,n,s);return{displayValue:l,score:c.scoreForWastedMs(s),
numericValue:s,numericUnit:"millisecond",details:d}}}t.exports=RenderBlockingResources,t.exports.UIStrings=f}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/render-blocking-resources.js")},{"../../computed/load-simulator.js":13,"../../computed/metrics/first-contentful-paint.js":19,"../../computed/processed-navigation.js":42,"../../computed/processed-trace.js":43,"../../computed/unused-css.js":48,"../../lib/dependency-graph/base-node.js":88,"../../lib/i18n/i18n.js":98,"../../lib/network-request.js":109,"../audit.js":3,"./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/total-byte-weight":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../lib/network-request.js"),c=e("../../computed/network-records.js"),l={title:"Avoids enormous network payloads",failureTitle:"Avoid enormous network payloads",
description:"Large network payloads cost users real money and are highly correlated with long load times. [Learn more](https://web.dev/total-byte-weight/).",displayValue:"Total size was {totalBytes, number, bytes} KiB"},u=a.createMessageInstanceIdFn(n,l);t.exports=class TotalByteWeight extends i{static get meta(){return{id:"total-byte-weight",title:u(l.title),failureTitle:u(l.failureTitle),description:u(l.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs"]}}static get defaultOptions(){return{p10:2731008,median:4096e3}}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],d=await c.request(n,t);let m=0,p=[];d.forEach((e=>{if(s.isNonNetworkRequest(e)||!e.transferSize)return;const t={url:e.url,totalBytes:e.transferSize};m+=t.totalBytes,p.push(t)})),p=p.sort(((e,t)=>t.totalBytes-e.totalBytes||e.url.localeCompare(t.url))).slice(0,10);const h=i.computeLogNormalScore({p10:t.options.p10,median:t.options.median},m),f=[{key:"url",itemType:"url",
text:u(a.UIStrings.columnURL)},{key:"totalBytes",itemType:"bytes",text:u(a.UIStrings.columnTransferSize)}],g=i.makeTableDetails(f,p);return{score:h,numericValue:m,numericUnit:"byte",displayValue:u(l.displayValue,{totalBytes:m}),details:g}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/total-byte-weight.js")},{"../../computed/network-records.js":40,"../../lib/i18n/i18n.js":98,"../../lib/network-request.js":109,"../audit.js":3}],"../audits/byte-efficiency/unminified-css":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../computed/unused-css.js"),s=e("../../lib/i18n/i18n.js"),c=e("../../lib/minification-estimator.js").computeCSSTokenLength,l={title:"Minify CSS",description:"Minifying CSS files can reduce network payload sizes. [Learn more](https://web.dev/unminified-css/)."},u=s.createMessageInstanceIdFn(n,l);class UnminifiedCSS extends i{static get meta(){return{id:"unminified-css",
title:u(l.title),description:u(l.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["CSSUsage","devtoolsLogs","traces","URL","GatherContext"]}}static computeTokenLength(e){return c(e)}static computeWaste(e,t,n){const s=e.content,c=UnminifiedCSS.computeTokenLength(s);let l=e.header.sourceURL;if(!l||l===n){l=a.determineContentPreview(e.content)}const u=i.estimateTransferSize(t,s.length,"Stylesheet"),d=1-c/s.length;return{url:l,totalBytes:u,wastedBytes:Math.round(u*d),wastedPercent:100*d}}static audit_(e,t){const n=e.URL.finalUrl,i=[];for(const a of e.CSSUsage.stylesheets){const e=t.find((e=>e.url===a.header.sourceURL));if(!a.content)continue;const s=UnminifiedCSS.computeWaste(a,e,n);s.wastedPercent<5||s.wastedBytes<2048||!Number.isFinite(s.wastedBytes)||i.push(s)}return{items:i,headings:[{key:"url",valueType:"url",label:u(s.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:u(s.UIStrings.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",
label:u(s.UIStrings.columnWastedBytes)}]}}}t.exports=UnminifiedCSS,t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/unminified-css.js")},{"../../computed/unused-css.js":48,"../../lib/i18n/i18n.js":98,"../../lib/minification-estimator.js":106,"./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/unminified-javascript":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../lib/minification-estimator.js").computeJSTokenLength,c={title:"Minify JavaScript",description:"Minifying JavaScript files can reduce payload sizes and script parse time. [Learn more](https://web.dev/unminified-javascript/)."},l=a.createMessageInstanceIdFn(n,c);class UnminifiedJavaScript extends i{static get meta(){return{id:"unminified-javascript",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,
requiredArtifacts:["ScriptElements","devtoolsLogs","traces","GatherContext"]}}static computeWaste(e,t,n){const a=e.length,c=s(e),l=i.estimateTransferSize(n,a,"Script"),u=1-c/a;return{url:t,totalBytes:l,wastedBytes:Math.round(l*u),wastedPercent:100*u}}static audit_(e,t){const n=[],i=[];for(const{requestId:a,src:s,content:c}of e.ScriptElements){if(!c)continue;const e=t.find((e=>e.requestId===a)),l=s&&e?e.url:`inline: ${c.substr(0,40)}...`;try{const t=UnminifiedJavaScript.computeWaste(c,l,e);if(t.wastedPercent<10||t.wastedBytes<2048||!Number.isFinite(t.wastedBytes))continue;n.push(t)}catch(t){const n=e?e.url:"?";i.push(`Unable to process script ${n}: ${t.message}`)}}return{items:n,warnings:i,headings:[{key:"url",valueType:"url",label:l(a.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:l(a.UIStrings.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:l(a.UIStrings.columnWastedBytes)}]}}}t.exports=UnminifiedJavaScript,t.exports.UIStrings=c}).call(this)
}).call(this,"/lighthouse-core/audits/byte-efficiency/unminified-javascript.js")},{"../../lib/i18n/i18n.js":98,"../../lib/minification-estimator.js":106,"./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/unused-css-rules":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../computed/unused-css.js"),s=e("../../lib/i18n/i18n.js"),c={title:"Reduce unused CSS",description:"Reduce unused rules from stylesheets and defer CSS not used for above-the-fold content to decrease bytes consumed by network activity. [Learn more](https://web.dev/unused-css-rules/)."},l=s.createMessageInstanceIdFn(n,c);t.exports=class UnusedCSSRules extends i{static get meta(){return{id:"unused-css-rules",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["CSSUsage","URL","devtoolsLogs","traces","GatherContext"]}}static async audit_(e,t,n){return{items:(await a.request({CSSUsage:e.CSSUsage,URL:e.URL,
devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS]},n)).filter((e=>e&&e.wastedBytes>10240)),headings:[{key:"url",valueType:"url",label:l(s.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:l(s.UIStrings.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:l(s.UIStrings.columnWastedBytes)}]}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/unused-css-rules.js")},{"../../computed/unused-css.js":48,"../../lib/i18n/i18n.js":98,"./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/unused-javascript":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../computed/unused-javascript-summary.js"),s=e("../../computed/js-bundles.js"),c=e("../../lib/i18n/i18n.js"),l={title:"Reduce unused JavaScript",description:"Reduce unused JavaScript and defer loading scripts until they are required to decrease bytes consumed by network activity. [Learn more](https://web.dev/unused-javascript/)."
},u=c.createMessageInstanceIdFn(n,l),d=20480,m=512;function commonPrefix(e){if(!e.length)return"";const t=e.reduce(((e,t)=>e>t?e:t));let n=e.reduce(((e,t)=>e>t?t:e));for(;!t.startsWith(n);)n=n.slice(0,-1);return n}function trimCommonPrefix(e,t){return t&&e.startsWith(t)?"…"+e.slice(t.length):e}t.exports=class UnusedJavaScript extends i{static get meta(){return{id:"unused-javascript",title:u(l.title),description:u(l.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["JsUsage","ScriptElements","SourceMaps","GatherContext","devtoolsLogs","traces"]}}static async audit_(e,t,n){const l=await s.request(e,n),{unusedThreshold:p=d,bundleSourceUnusedThreshold:h=m}=n.options||{},f=[];for(const[s,c]of Object.entries(e.JsUsage)){const e=t.find((e=>e.url===s));if(!e)continue;const u=l.find((e=>e.script.src===s)),d=await a.request({url:s,scriptCoverages:c,bundle:u},n);if(0===d.wastedBytes||0===d.totalBytes)continue
;const m=i.estimateTransferSize(e,d.totalBytes,"Script")/d.totalBytes,g={url:d.url,totalBytes:Math.round(m*d.totalBytes),wastedBytes:Math.round(m*d.wastedBytes),wastedPercent:d.wastedPercent};if(g.wastedBytes<=p)continue;if(f.push(g),!u||"errorMessage"in u.sizes)continue;const y=u.sizes;if(d.sourcesWastedBytes){const e=Object.entries(d.sourcesWastedBytes).sort(((e,t)=>t[1]-e[1])).slice(0,5).map((([e,t])=>{const n="(unmapped)"===e?y.unmappedBytes:y.files[e];return{source:e,unused:Math.round(t*m),total:Math.round(n*m)}})).filter((e=>e.unused>=h)),t=commonPrefix([...u.map._sourceInfos.keys()]);g.subItems={type:"subitems",items:e.map((({source:e,unused:n,total:i})=>({source:trimCommonPrefix(e,t),sourceBytes:i,sourceWastedBytes:n})))}}}return{items:f,headings:[{key:"url",valueType:"url",subItemsHeading:{key:"source",valueType:"code"},label:u(c.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",subItemsHeading:{key:"sourceBytes"},label:u(c.UIStrings.columnTransferSize)},{
key:"wastedBytes",valueType:"bytes",subItemsHeading:{key:"sourceWastedBytes"},label:u(c.UIStrings.columnWastedBytes)}]}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/unused-javascript.js")},{"../../computed/js-bundles.js":12,"../../computed/unused-javascript-summary.js":49,"../../lib/i18n/i18n.js":98,"./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/uses-long-cache-ttl":[function(e,t,n){(function(n){(function(){"use strict";const i=e("parse-cache-control"),a=e("../audit.js"),s=e("../../lib/network-request.js"),c=e("../../lib/url-shim.js"),l=e("../../lib/statistics.js").linearInterpolation,u=e("../../lib/i18n/i18n.js"),d=e("../../computed/network-records.js"),m={title:"Uses efficient cache policy on static assets",failureTitle:"Serve static assets with an efficient cache policy",description:"A long cache lifetime can speed up repeat visits to your page. [Learn more](https://web.dev/uses-long-cache-ttl/).",
displayValue:"{itemCount, plural,\n    =1 {1 resource found}\n    other {# resources found}\n    }"},p=u.createMessageInstanceIdFn(n,m);class CacheHeaders extends a{static get meta(){return{id:"uses-long-cache-ttl",title:p(m.title),failureTitle:p(m.failureTitle),description:p(m.description),scoreDisplayMode:a.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs"]}}static get defaultOptions(){return{p10:28672,median:131072}}static getCacheHitProbability(e){const t=[0,.2,1,3,8,12,24,48,72,168,8760,1/0];if(12!==t.length)throw new Error("deciles 0-10 and 1 for overflow");const n=e/3600,i=t.findIndex((e=>e>=n));if(i===t.length-1)return 1;if(0===i)return 0;const a=t[i],s=t[i-1];return l(s,(i-1)/10,a,i/10,n)}static computeCacheLifetimeInSeconds(e,t){if(t&&void 0!==t["max-age"])return t["max-age"];const n=e.get("expires");if(n){const e=new Date(n).getTime();return e?Math.ceil((e-Date.now())/1e3):0}return null}static isCacheableAsset(e){
const t=new Set([200,203,206]),n=new Set([s.TYPES.Font,s.TYPES.Image,s.TYPES.Media,s.TYPES.Script,s.TYPES.Stylesheet]);return!s.isNonNetworkRequest(e)&&(t.has(e.statusCode)&&n.has(e.resourceType||"Other"))}static shouldSkipRecord(e,t){return!(t||!(e.get("pragma")||"").includes("no-cache"))||!(!t||!(t["must-revalidate"]||t["no-cache"]||t["no-store"]||t.private))}static audit(e,t){const n=e.devtoolsLogs[a.DEFAULT_PASS];return d.request(n,t).then((e=>{const n=[];let s=0;for(const t of e){if(!CacheHeaders.isCacheableAsset(t))continue;const e=new Map;for(const n of t.responseHeaders||[])if(e.has(n.name.toLowerCase())){const t=e.get(n.name.toLowerCase());e.set(n.name.toLowerCase(),`${t}, ${n.value}`)}else e.set(n.name.toLowerCase(),n.value);const a=i(e.get("cache-control"));if(this.shouldSkipRecord(e,a))continue;let l=CacheHeaders.computeCacheLifetimeInSeconds(e,a);if(null!==l&&(!Number.isFinite(l)||l<=0))continue;l=l||0;const u=CacheHeaders.getCacheHitProbability(l);if(u>.925)continue
;const d=c.elideDataURI(t.url),m=t.transferSize||0,p=(1-u)*m;let h;s+=p,a&&(h={type:"debugdata",...a}),n.push({url:d,debugData:h,cacheLifetimeMs:1e3*l,cacheHitProbability:u,totalBytes:m,wastedBytes:p})}n.sort(((e,t)=>e.cacheLifetimeMs-t.cacheLifetimeMs||t.totalBytes-e.totalBytes||e.url.localeCompare(t.url)));const l=a.computeLogNormalScore({p10:t.options.p10,median:t.options.median},s),d=[{key:"url",itemType:"url",text:p(u.UIStrings.columnURL)},{key:"cacheLifetimeMs",itemType:"ms",text:p(u.UIStrings.columnCacheTTL),displayUnit:"duration"},{key:"totalBytes",itemType:"bytes",text:p(u.UIStrings.columnTransferSize),displayUnit:"kb",granularity:1}],h={wastedBytes:s},f=a.makeTableDetails(d,n,h);return{score:l,numericValue:s,numericUnit:"byte",displayValue:p(m.displayValue,{itemCount:n.length}),details:f}}))}}t.exports=CacheHeaders,t.exports.UIStrings=m}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/uses-long-cache-ttl.js")},{"../../computed/network-records.js":40,
"../../lib/i18n/i18n.js":98,"../../lib/network-request.js":109,"../../lib/statistics.js":114,"../../lib/url-shim.js":"url","../audit.js":3,"parse-cache-control":221}],"../audits/byte-efficiency/uses-optimized-images":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../lib/url-shim.js"),s=e("../../lib/i18n/i18n.js"),c={title:"Efficiently encode images",description:"Optimized images load faster and consume less cellular data. [Learn more](https://web.dev/uses-optimized-images/)."},l=s.createMessageInstanceIdFn(n,c);class UsesOptimizedImages extends i{static get meta(){return{id:"uses-optimized-images",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["OptimizedImages","ImageElements","GatherContext","devtoolsLogs","traces","URL"]}}static computeSavings(e){const t=e.originalSize-e.jpegSize;return{bytes:t,percent:100*t/e.originalSize}}static estimateJPEGSizeFromDimensions(e){
const t=e.naturalWidth*e.naturalHeight;return Math.round(t*(2/8))}static audit_(e){const t=e.URL.finalUrl,n=e.OptimizedImages,i=e.ImageElements,c=new Map;i.forEach((e=>c.set(e.src,e)));const u=[],d=[];for(const e of n){if(e.failed){d.push("Unable to decode "+a.getURLDisplayName(e.url));continue}if(!1===/(jpeg|bmp)/.test(e.mimeType))continue;let n=e.jpegSize,i=!0;if(void 0===n){const t=c.get(e.url);if(!t){d.push("Unable to locate resource "+a.getURLDisplayName(e.url));continue}if(!t.naturalDimensions)continue;const s=t.naturalDimensions.height,l=t.naturalDimensions.width;if(!s||!l)continue;n=UsesOptimizedImages.estimateJPEGSizeFromDimensions({naturalHeight:s,naturalWidth:l}),i=!1}if(e.originalSize<n+4096)continue;const s=a.elideDataURI(e.url),l=!a.originsMatch(t,e.url),m=UsesOptimizedImages.computeSavings({...e,jpegSize:n});u.push({url:s,fromProtocol:i,isCrossOrigin:l,totalBytes:e.originalSize,wastedBytes:m.bytes})}return{warnings:d,items:u,headings:[{key:"url",valueType:"thumbnail",
label:""},{key:"url",valueType:"url",label:l(s.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:l(s.UIStrings.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:l(s.UIStrings.columnWastedBytes)}]}}}t.exports=UsesOptimizedImages,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/uses-optimized-images.js")},{"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/uses-responsive-images-snapshot":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("./uses-responsive-images.js"),s=e("../../lib/url-shim.js"),c=e("../../lib/i18n/i18n.js"),l={title:"Images were appropriate for their displayed size",failureTitle:"Images were larger than their displayed size",columnDisplayedDimensions:"Displayed dimensions",columnActualDimensions:"Actual dimensions"},u=c.createMessageInstanceIdFn(n,l)
;t.exports=class UsesResponsiveImagesSnapshot extends i{static get meta(){return{id:"uses-responsive-images-snapshot",title:u(l.title),failureTitle:u(l.failureTitle),description:a.str_(a.UIStrings.description),supportedModes:["snapshot"],requiredArtifacts:["ImageElements","ViewportDimensions"]}}static async audit(e){let t=1;const n=[];for(const i of e.ImageElements){if(!i.naturalDimensions)continue;const c=i.naturalDimensions,l=a.getDisplayedDimensions({...i,naturalWidth:c.width,naturalHeight:c.height},e.ViewportDimensions),u=c.width*c.height,d=l.width*l.height;u<=d||(u-d>1365&&(t=0),n.push({url:s.elideDataURI(i.src),displayedDimensions:`${l.width}x${l.height}`,actualDimensions:`${c.width}x${c.height}`}))}const d=[{key:"url",itemType:"thumbnail",text:""},{key:"url",itemType:"url",text:u(c.UIStrings.columnURL)},{key:"displayedDimensions",itemType:"text",text:u(l.columnDisplayedDimensions)},{key:"actualDimensions",itemType:"text",text:u(l.columnActualDimensions)}];return{score:t,
details:i.makeTableDetails(d,n)}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/uses-responsive-images-snapshot.js")},{"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","../audit.js":3,"./uses-responsive-images.js":"../audits/byte-efficiency/uses-responsive-images"}],"../audits/byte-efficiency/uses-responsive-images":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../lib/network-request.js"),s=e("../../computed/image-records.js"),c=e("../../lib/url-shim.js"),l=e("../../lib/i18n/i18n.js"),u={title:"Properly size images",description:"Serve images that are appropriately-sized to save cellular data and improve load time. [Learn more](https://web.dev/uses-responsive-images/)."},d=l.createMessageInstanceIdFn(n,u);class UsesResponsiveImages extends i{static get meta(){return{id:"uses-responsive-images",title:d(u.title),description:d(u.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,
requiredArtifacts:["ImageElements","ViewportDimensions","GatherContext","devtoolsLogs","traces"]}}static getDisplayedDimensions(e,t){if(e.displayedWidth&&e.displayedHeight)return{width:e.displayedWidth*t.devicePixelRatio,height:e.displayedHeight*t.devicePixelRatio};const n=t.innerWidth,i=2*t.innerHeight,a=e.naturalWidth/e.naturalHeight;let s=n,c=i;return a>n/i?c=n/a:s=i*a,{width:s*t.devicePixelRatio,height:c*t.devicePixelRatio}}static computeWaste(e,t,n){const i=n.find((t=>t.url===e.src));if(!i)return null;const s=this.getDisplayedDimensions(e,t),l=s.width*s.height,u=c.elideDataURI(e.src),d=1-l/(e.naturalWidth*e.naturalHeight),m=a.getResourceSizeOnNetwork(i);return{url:u,totalBytes:m,wastedBytes:Math.round(m*d),wastedPercent:100*d}}static async audit_(e,t,n){const i=await s.request({ImageElements:e.ImageElements,networkRecords:t},n),a=e.ViewportDimensions,c=new Map;for(const e of i){if("image/svg+xml"===e.mimeType||e.isCss)continue;if(!e.naturalDimensions)continue
;const n=e.naturalDimensions.height,i=e.naturalDimensions.width;if(!i||!n)continue;const s=UsesResponsiveImages.computeWaste({...e,naturalHeight:n,naturalWidth:i},a,t);if(!s)continue;const l=c.get(s.url);(!l||l.wastedBytes>s.wastedBytes)&&c.set(s.url,s)}return{items:Array.from(c.values()).filter((e=>e.wastedBytes>4096)),headings:[{key:"url",valueType:"thumbnail",label:""},{key:"url",valueType:"url",label:d(l.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:d(l.UIStrings.columnResourceSize)},{key:"wastedBytes",valueType:"bytes",label:d(l.UIStrings.columnWastedBytes)}]}}}t.exports=UsesResponsiveImages,t.exports.UIStrings=u,t.exports.str_=d}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/uses-responsive-images.js")},{"../../computed/image-records.js":11,"../../lib/i18n/i18n.js":98,"../../lib/network-request.js":109,"../../lib/url-shim.js":"url","./byte-efficiency-audit.js":4}],"../audits/byte-efficiency/uses-text-compression":[function(e,t,n){(function(n){
(function(){"use strict";const i=e("./byte-efficiency-audit.js"),a=e("../../lib/url-shim.js"),s=e("../../lib/i18n/i18n.js"),c={title:"Enable text compression",description:"Text-based resources should be served with compression (gzip, deflate or brotli) to minimize total network bytes. [Learn more](https://web.dev/uses-text-compression/)."},l=s.createMessageInstanceIdFn(n,c);t.exports=class ResponsesAreCompressed extends i{static get meta(){return{id:"uses-text-compression",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["ResponseCompression","GatherContext","devtoolsLogs","traces"]}}static audit_(e){const t=e.ResponseCompression,n=[];t.forEach((e=>{if(!e.gzipSize||e.gzipSize<0)return;const t=e.resourceSize,i=e.gzipSize,s=t-i;if(1-i/t<.1||s<1400||e.transferSize<i)return;const c=a.elideDataURI(e.url);n.find((t=>t.url===c&&t.totalBytes===e.resourceSize))||n.push({url:c,totalBytes:t,wastedBytes:s})}));const i=[{key:"url",
valueType:"url",label:l(s.UIStrings.columnURL)},{key:"totalBytes",valueType:"bytes",label:l(s.UIStrings.columnTransferSize)},{key:"wastedBytes",valueType:"bytes",label:l(s.UIStrings.columnWastedBytes)}];return{items:n,headings:i}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/uses-text-compression.js")},{"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","./byte-efficiency-audit.js":4}],"../audits/content-width":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s={title:"Content is sized correctly for the viewport",failureTitle:"Content is not sized correctly for the viewport",description:"If the width of your app's content doesn't match the width of the viewport, your app might not be optimized for mobile screens. [Learn more](https://web.dev/content-width/).",explanation:"The viewport size of {innerWidth}px does not match the window size of {outerWidth}px."
},c=a.createMessageInstanceIdFn(n,s);t.exports=class ContentWidth extends i{static get meta(){return{id:"content-width",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["ViewportDimensions"]}}static audit(e,t){const n=e.ViewportDimensions.innerWidth===e.ViewportDimensions.outerWidth;if("desktop"===t.settings.formFactor)return{score:1,notApplicable:!0};let i;return n||(i=c(s.explanation,{innerWidth:e.ViewportDimensions.innerWidth,outerWidth:e.ViewportDimensions.outerWidth})),{score:Number(n),explanation:i}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/content-width.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/critical-request-chains":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../computed/critical-request-chains.js"),c={title:"Avoid chaining critical requests",
description:"The Critical Request Chains below show you what resources are loaded with a high priority. Consider reducing the length of chains, reducing the download size of resources, or deferring the download of unnecessary resources to improve page load. [Learn more](https://web.dev/critical-request-chains/).",displayValue:"{itemCount, plural,\n    =1 {1 chain found}\n    other {# chains found}\n    }"},l=a.createMessageInstanceIdFn(n,c);class CriticalRequestChains extends i{static get meta(){return{id:"critical-request-chains",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","URL"]}}static _traverse(e,t){!function walk(e,n,i,a=0){const s=Object.keys(e);0!==s.length&&s.forEach((s=>{const c=e[s];i||(i=c.request.startTime),t({depth:n,id:s,node:c,chainDuration:1e3*(c.request.endTime-i),chainTransferSize:a+c.request.transferSize}),c.children&&walk(c.children,n+1,i)}),"")
}(e,0)}static _getLongestChain(e){const t={duration:0,length:0,transferSize:0};return CriticalRequestChains._traverse(e,(e=>{const n=e.chainDuration;n>t.duration&&(t.duration=n,t.transferSize=e.chainTransferSize,t.length=e.depth)})),t.length++,t}static flattenRequests(e){const t={},n=new Map;return CriticalRequestChains._traverse(e,(function flatten(e){const i=e.node.request,a={url:i.url,startTime:i.startTime,endTime:i.endTime,responseReceivedTime:i.responseReceivedTime,transferSize:i.transferSize};let s=n.get(e.id);if(s?s.request=a:(s={request:a},t[e.id]=s),e.node.children)for(const t of Object.keys(e.node.children)){const e={request:{}};n.set(t,e),s.children||(s.children={}),s.children[t]=e}n.set(e.id,s)})),t}static audit(e,t){const n=e.traces[i.DEFAULT_PASS],a=e.devtoolsLogs[i.DEFAULT_PASS],u=e.URL;return s.request({devtoolsLog:a,trace:n,URL:u},t).then((e=>{let t=0;const n=CriticalRequestChains.flattenRequests(e),i=Object.keys(n)[0],a=i&&n[i].children
;a&&Object.keys(a).length>0&&function walk(e,n){Object.keys(e).forEach((i=>{const a=e[i];a.children?walk(a.children,n+1):t++}),"")}(a,0);const s=CriticalRequestChains._getLongestChain(n);return{score:Number(0===t),notApplicable:0===t,displayValue:t?l(c.displayValue,{itemCount:t}):"",details:{type:"criticalrequestchain",chains:n,longestChain:s}}}))}}t.exports=CriticalRequestChains,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/critical-request-chains.js")},{"../computed/critical-request-chains.js":10,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/csp-xss":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../computed/main-resource.js"),s=e("../lib/i18n/i18n.js"),{evaluateRawCspsForXss:c,getTranslatedDescription:l}=e("../lib/csp-evaluator.js"),u={title:"Ensure CSP is effective against XSS attacks",
description:"A strong Content Security Policy (CSP) significantly reduces the risk of cross-site scripting (XSS) attacks. [Learn more](https://web.dev/csp-xss/)",noCsp:"No CSP found in enforcement mode",metaTagMessage:"The page contains a CSP defined in a <meta> tag. Consider defining the CSP in an HTTP header if you can.",columnDirective:"Directive",columnSeverity:"Severity",itemSeveritySyntax:"Syntax"},d=s.createMessageInstanceIdFn(n,u);t.exports=class CspXss extends i{static get meta(){return{id:"csp-xss",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:d(u.title),description:d(u.description),requiredArtifacts:["devtoolsLogs","MetaElements","URL"]}}static async getRawCsps(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],s=await a.request({devtoolsLog:n,URL:e.URL},t),c=e.MetaElements.filter((e=>e.httpEquiv&&"content-security-policy"===e.httpEquiv.toLowerCase())).flatMap((e=>(e.content||"").split(","))).filter((e=>e.replace(/\s/g,"")));return{
cspHeaders:s.responseHeaders.filter((e=>"content-security-policy"===e.name.toLowerCase())).flatMap((e=>e.value.split(","))).filter((e=>e.replace(/\s/g,""))),cspMetaTags:c}}static findingToTableItem(e,t){return{directive:e.directive,description:l(e),severity:t}}static constructSyntaxResults(e,t){const n=[];for(let i=0;i<e.length;++i){const a=e[i].map((e=>this.findingToTableItem(e)));a.length&&n.push({severity:d(u.itemSeveritySyntax),description:{type:"code",value:t[i]},subItems:{type:"subitems",items:a}})}return n}static constructResults(e,t){const n=[...e,...t];if(!n.length)return{score:0,results:[{severity:d(s.UIStrings.itemSeverityHigh),description:d(u.noCsp),directive:void 0}]};const{bypasses:i,warnings:a,syntax:l}=c(n),m=[...this.constructSyntaxResults(l,n),...i.map((e=>this.findingToTableItem(e,d(s.UIStrings.itemSeverityHigh)))),...a.map((e=>this.findingToTableItem(e,d(s.UIStrings.itemSeverityMedium))))];return t.length&&m.push({severity:d(s.UIStrings.itemSeverityMedium),
description:d(u.metaTagMessage),directive:void 0}),{score:i.length?0:1,results:m}}static async audit(e,t){const{cspHeaders:n,cspMetaTags:a}=await this.getRawCsps(e,t),{score:c,results:l}=this.constructResults(n,a),m=[{key:"description",itemType:"text",subItemsHeading:{key:"description"},text:d(s.UIStrings.columnDescription)},{key:"directive",itemType:"code",subItemsHeading:{key:"directive"},text:d(u.columnDirective)},{key:"severity",itemType:"text",subItemsHeading:{key:"severity"},text:d(u.columnSeverity)}],p=i.makeTableDetails(m,l);return{score:c,notApplicable:!l.length,details:p}}},t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/csp-xss.js")},{"../computed/main-resource.js":14,"../lib/csp-evaluator.js":87,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/deprecations":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s={title:"Avoids deprecated APIs",failureTitle:"Uses deprecated APIs",
description:"Deprecated APIs will eventually be removed from the browser. [Learn more](https://web.dev/deprecations/).",displayValue:"{itemCount, plural,\n    =1 {1 warning found}\n    other {# warnings found}\n    }",columnDeprecate:"Deprecation / Warning",columnLine:"Line"},c=a.createMessageInstanceIdFn(n,s);t.exports=class Deprecations extends i{static get meta(){return{id:"deprecations",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["ConsoleMessages"]}}static audit(e){const t=e.ConsoleMessages.filter((e=>"deprecation"===e.source)).filter((e=>!e.text.includes("::-webkit-details-marker"))).map((e=>({value:e.text,source:i.makeSourceLocationFromConsoleMessage(e)}))),n=[{key:"value",itemType:"text",text:c(s.columnDeprecate)},{key:"source",itemType:"source-location",text:c(a.UIStrings.columnSource)}],l=i.makeTableDetails(n,t);let u;return t.length>0&&(u=c(s.displayValue,{itemCount:t.length})),{score:Number(0===t.length),displayValue:u,
details:l}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/deprecations.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/diagnostics":[function(e,t,n){"use strict";const i=e("./audit.js"),a=e("../computed/main-thread-tasks.js"),s=e("../computed/network-records.js"),c=e("../computed/network-analysis.js"),l=e("../lib/dependency-graph/simulator/network-analyzer.js");t.exports=class Diagnostics extends i{static get meta(){return{id:"diagnostics",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Diagnostics",description:"Collection of useful page vitals.",supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs"]}}static async audit(e,t){
const n=e.traces[i.DEFAULT_PASS],u=e.devtoolsLogs[i.DEFAULT_PASS],d=await a.request(n,t),m=await s.request(u,t),p=await c.request(u,t),h=d.filter((e=>!e.parent)),f=l.findMainDocument(m).transferSize,g=m.reduce(((e,t)=>e+(t.transferSize||0)),0),y=h.reduce(((e,t)=>e+(t.duration||0)),0),b=Math.max(...p.additionalRttByOrigin.values())+p.rtt,v=Math.max(...p.serverResponseTimeByOrigin.values());return{score:1,details:{type:"debugdata",items:[{numRequests:m.length,numScripts:m.filter((e=>"Script"===e.resourceType)).length,numStylesheets:m.filter((e=>"Stylesheet"===e.resourceType)).length,numFonts:m.filter((e=>"Font"===e.resourceType)).length,numTasks:h.length,numTasksOver10ms:h.filter((e=>e.duration>10)).length,numTasksOver25ms:h.filter((e=>e.duration>25)).length,numTasksOver50ms:h.filter((e=>e.duration>50)).length,numTasksOver100ms:h.filter((e=>e.duration>100)).length,numTasksOver500ms:h.filter((e=>e.duration>500)).length,rtt:p.rtt,throughput:p.throughput,maxRtt:b,maxServerLatency:v,
totalByteWeight:g,totalTaskTime:y,mainDocumentTransferSize:f}]}}}}},{"../computed/main-thread-tasks.js":15,"../computed/network-analysis.js":39,"../computed/network-records.js":40,"../lib/dependency-graph/simulator/network-analyzer.js":93,"./audit.js":3}],"../audits/dobetterweb/appcache-manifest":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Avoids Application Cache",failureTitle:"Uses Application Cache",description:"Application Cache is deprecated. [Learn more](https://web.dev/appcache-manifest/).",displayValue:'Found "{AppCacheManifest}"'},c=a.createMessageInstanceIdFn(n,s);t.exports=class AppCacheManifestAttr extends i{static get meta(){return{id:"appcache-manifest",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["AppCacheManifest"]}}static audit(e){return null!==e.AppCacheManifest?{score:0,displayValue:c(s.displayValue,{AppCacheManifest:e.AppCacheManifest})}:{
score:1}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/appcache-manifest.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/dobetterweb/charset":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../computed/main-resource.js"),c={title:"Properly defines charset",failureTitle:"Charset declaration is missing or occurs too late in the HTML",description:"A character encoding declaration is required. It can be done with a `<meta>` tag in the first 1024 bytes of the HTML or in the Content-Type HTTP response header. [Learn more](https://web.dev/charset/)."},l=a.createMessageInstanceIdFn(n,c),u=/^[a-zA-Z0-9-_:.()]{2,}$/,d=/<meta[^>]+charset[^<]+>/i,m=/charset\s*=\s*[a-zA-Z0-9-_:.()]{2,}/i;t.exports=class CharsetDefined extends i{static get meta(){return{id:"charset",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),
requiredArtifacts:["MainDocumentContent","URL","devtoolsLogs","MetaElements"]}}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],a=await s.request({devtoolsLog:n,URL:e.URL},t);let c=!1;if(a.responseHeaders){const e=a.responseHeaders.find((e=>"content-type"===e.name.toLowerCase()));e&&(c=m.test(e.value))}return c=c||65279===e.MainDocumentContent.charCodeAt(0),d.test(e.MainDocumentContent.slice(0,1024))&&(c=c||e.MetaElements.some((e=>e.charset&&u.test(e.charset)||"content-type"===e.httpEquiv&&e.content&&m.test(e.content)))),{score:Number(c)}}},t.exports.UIStrings=c,t.exports.CHARSET_HTML_REGEX=d,t.exports.CHARSET_HTTP_REGEX=m,t.exports.IANA_REGEX=u}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/charset.js")},{"../../computed/main-resource.js":14,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/dobetterweb/doctype":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={
title:"Page has the HTML doctype",failureTitle:"Page lacks the HTML doctype, thus triggering quirks-mode",description:"Specifying a doctype prevents the browser from switching to quirks-mode. [Learn more](https://web.dev/doctype/).",explanationNoDoctype:"Document must contain a doctype",explanationPublicId:"Expected publicId to be an empty string",explanationSystemId:"Expected systemId to be an empty string",explanationBadDoctype:"Doctype name must be the lowercase string `html`"},c=a.createMessageInstanceIdFn(n,s);t.exports=class Doctype extends i{static get meta(){return{id:"doctype",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["Doctype"]}}static audit(e){if(!e.Doctype)return{score:0,explanation:c(s.explanationNoDoctype)};const t=e.Doctype.name.trim(),n=e.Doctype.publicId,i=e.Doctype.systemId;return""!==n?{score:0,explanation:c(s.explanationPublicId)}:""!==i?{score:0,explanation:c(s.explanationSystemId)}:"html"===t?{score:1}:{
score:0,explanation:c(s.explanationBadDoctype)}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/doctype.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/dobetterweb/dom-size":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Avoids an excessive DOM size",failureTitle:"Avoid an excessive DOM size",description:"A large DOM will increase memory usage, cause longer [style calculations](https://developers.google.com/web/fundamentals/performance/rendering/reduce-the-scope-and-complexity-of-style-calculations), and produce costly [layout reflows](https://developers.google.com/speed/articles/reflow). [Learn more](https://web.dev/dom-size/).",columnStatistic:"Statistic",columnValue:"Value",displayValue:"{itemCount, plural,\n    =1 {1 element}\n    other {# elements}\n    }",statisticDOMElements:"Total DOM Elements",statisticDOMDepth:"Maximum DOM Depth",
statisticDOMWidth:"Maximum Child Elements"},c=a.createMessageInstanceIdFn(n,s);t.exports=class DOMSize extends i{static get meta(){return{id:"dom-size",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["DOMStats"]}}static get defaultOptions(){return{p10:818,median:1400}}static audit(e,t){const n=e.DOMStats,l=i.computeLogNormalScore({p10:t.options.p10,median:t.options.median},n.totalBodyElements),u=[{key:"statistic",itemType:"text",text:c(s.columnStatistic)},{key:"node",itemType:"node",text:c(a.UIStrings.columnElement)},{key:"value",itemType:"numeric",text:c(s.columnValue)}],d=[{statistic:c(s.statisticDOMElements),value:n.totalBodyElements},{node:i.makeNodeItem(n.depth),statistic:c(s.statisticDOMDepth),value:n.depth.max},{node:i.makeNodeItem(n.width),statistic:c(s.statisticDOMWidth),value:n.width.max}];return{score:l,numericValue:n.totalBodyElements,numericUnit:"element",
displayValue:c(s.displayValue,{itemCount:n.totalBodyElements}),details:i.makeTableDetails(u,d)}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/dom-size.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/dobetterweb/external-anchors-use-rel-noopener":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../../lib/url-shim.js"),a=e("../audit.js"),s=e("../../lib/i18n/i18n.js"),c={title:"Links to cross-origin destinations are safe",failureTitle:"Links to cross-origin destinations are unsafe",description:'Add `rel="noopener"` or `rel="noreferrer"` to any external links to improve performance and prevent security vulnerabilities. [Learn more](https://web.dev/external-anchors-use-rel-noopener/).',warning:"Unable to determine the destination for anchor ({anchorHTML}). If not used as a hyperlink, consider removing target=_blank.",columnFailingAnchors:"Failing Anchors"},l=s.createMessageInstanceIdFn(n,c)
;t.exports=class ExternalAnchorsUseRelNoopenerAudit extends a{static get meta(){return{id:"external-anchors-use-rel-noopener",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["URL","AnchorElements"]}}static audit(e){const t=[],n=new i(e.URL.finalUrl).host,s=e.AnchorElements.filter((e=>"_blank"===e.target&&!e.rel.includes("noopener")&&!e.rel.includes("noreferrer"))).filter((e=>{try{return new i(e.href).host!==n}catch(n){return t.push(l(c.warning,{anchorHTML:e.node.snippet})),!0}})).filter((e=>!e.href||e.href.toLowerCase().startsWith("http"))).map((e=>({node:a.makeNodeItem(e.node),href:e.href||"Unknown",target:e.target||"",rel:e.rel||"",outerHTML:e.node.snippet||""}))),u=[{key:"node",itemType:"node",text:l(c.columnFailingAnchors)}],d=a.makeTableDetails(u,s);return{score:Number(0===s.length),details:d,warnings:t}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/external-anchors-use-rel-noopener.js")},{
"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","../audit.js":3}],"../audits/dobetterweb/geolocation-on-start":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../violation-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Avoids requesting the geolocation permission on page load",failureTitle:"Requests the geolocation permission on page load",description:"Users are mistrustful of or confused by sites that request their location without context. Consider tying the request to a user action instead. [Learn more](https://web.dev/geolocation-on-start/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class GeolocationOnStart extends i{static get meta(){return{id:"geolocation-on-start",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),supportedModes:["navigation"],requiredArtifacts:["ConsoleMessages"]}}static audit(e){const t=i.getViolationResults(e,/geolocation/),n=[{key:"source",itemType:"source-location",
text:c(a.UIStrings.columnSource)}],s=i.makeTableDetails(n,t);return{score:Number(0===t.length),details:s}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/geolocation-on-start.js")},{"../../lib/i18n/i18n.js":98,"../violation-audit.js":8}],"../audits/dobetterweb/inspector-issues":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"No issues in the `Issues` panel in Chrome Devtools",failureTitle:"Issues were logged in the `Issues` panel in Chrome Devtools",description:"Issues logged to the `Issues` panel in Chrome Devtools indicate unresolved problems. They can come from network request failures, insufficient security controls, and other browser concerns. Open up the Issues panel in Chrome DevTools for more details on each issue.",columnIssueType:"Issue type",issueTypeBlockedByResponse:"Blocked by cross-origin policy",issueTypeHeavyAds:"Heavy resource usage by ads"
},c=a.createMessageInstanceIdFn(n,s);t.exports=class IssuesPanelEntries extends i{static get meta(){return{id:"inspector-issues",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["InspectorIssues"]}}static getMixedContentRow(e){const t=new Set;for(const n of e){const e=n.request&&n.request.url||n.mainResourceURL;t.add(e)}return{issueType:"Mixed content",subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static getSameSiteCookieRow(e){const t=new Set;for(const n of e){const e=n.request&&n.request.url||n.cookieUrl;e&&t.add(e)}return{issueType:"SameSite cookie",subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static getBlockedByResponseRow(e){const t=new Set;for(const n of e){const e=n.request&&n.request.url;e&&t.add(e)}return{issueType:c(s.issueTypeBlockedByResponse),subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static getContentSecurityPolicyRow(e){const t=new Set;for(const n of e){
const e=n.blockedURL;e&&t.add(e)}return{issueType:"Content security policy",subItems:{type:"subitems",items:Array.from(t).map((e=>({url:e})))}}}static audit(e){const t=[{key:"issueType",itemType:"text",subItemsHeading:{key:"url",itemType:"url"},text:c(s.columnIssueType)}],n=e.InspectorIssues,a=[];n.mixedContent.length&&a.push(this.getMixedContentRow(n.mixedContent)),n.sameSiteCookies.length&&a.push(this.getSameSiteCookieRow(n.sameSiteCookies)),n.blockedByResponse.length&&a.push(this.getBlockedByResponseRow(n.blockedByResponse)),n.heavyAds.length&&a.push({issueType:c(s.issueTypeHeavyAds)});const l=n.contentSecurityPolicy.filter((e=>"kTrustedTypesSinkViolation"!==e.contentSecurityPolicyViolationType&&"kTrustedTypesPolicyViolation"!==e.contentSecurityPolicyViolationType));return l.length&&a.push(this.getContentSecurityPolicyRow(l)),{score:a.length>0?0:1,details:i.makeTableDetails(t,a)}}},t.exports.UIStrings=s}).call(this)
}).call(this,"/lighthouse-core/audits/dobetterweb/inspector-issues.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/dobetterweb/js-libraries":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Detected JavaScript libraries",description:"All front-end JavaScript libraries detected on the page. [Learn more](https://web.dev/js-libraries/).",columnVersion:"Version"},c=a.createMessageInstanceIdFn(n,s);t.exports=class JsLibrariesAudit extends i{static get meta(){return{id:"js-libraries",title:c(s.title),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,description:c(s.description),requiredArtifacts:["Stacks"]}}static audit(e){const t=e.Stacks.filter((e=>"js"===e.detector)).filter((e=>!e.id.endsWith("-fast"))).map((e=>({name:e.name,version:e.version,npm:e.npm}))),n=[{key:"name",itemType:"text",text:c(a.UIStrings.columnName)},{key:"version",itemType:"text",text:c(s.columnVersion)}],l=i.makeTableDetails(n,t,{}),u={
type:"debugdata",stacks:e.Stacks.map((e=>({id:e.id,version:e.version})))};return t.length?{score:1,details:{...l,debugData:u}}:{score:null,notApplicable:!0}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/js-libraries.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/dobetterweb/no-document-write":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../violation-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Avoids `document.write()`",failureTitle:"Avoid `document.write()`",description:"For users on slow connections, external scripts dynamically injected via `document.write()` can delay page load by tens of seconds. [Learn more](https://web.dev/no-document-write/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class NoDocWriteAudit extends i{static get meta(){return{id:"no-document-write",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["ConsoleMessages"]}}
static audit(e){const t=i.getViolationResults(e,/document\.write/),n=[{key:"source",itemType:"source-location",text:c(a.UIStrings.columnSource)}],s=i.makeTableDetails(n,t);return{score:Number(0===t.length),details:s}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/no-document-write.js")},{"../../lib/i18n/i18n.js":98,"../violation-audit.js":8}],"../audits/dobetterweb/no-vulnerable-libraries":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/sentry.js"),s=e("semver"),c=e("../../../third-party/snyk/snapshot.json"),l=e("../../lib/i18n/i18n.js"),u={title:"Avoids front-end JavaScript libraries with known security vulnerabilities",failureTitle:"Includes front-end JavaScript libraries with known security vulnerabilities",description:"Some third-party scripts may contain known security vulnerabilities that are easily identified and exploited by attackers. [Learn more](https://web.dev/no-vulnerable-libraries/).",
displayValue:"{itemCount, plural,\n    =1 {1 vulnerability detected}\n    other {# vulnerabilities detected}\n    }",columnVersion:"Library Version",columnVuln:"Vulnerability Count",columnSeverity:"Highest Severity"},d=l.createMessageInstanceIdFn(n,u),m=/^(\d+\.\d+\.\d+)[^-0-9]+/,p={low:d(l.UIStrings.itemSeverityLow),medium:d(l.UIStrings.itemSeverityMedium),high:d(l.UIStrings.itemSeverityHigh)};class NoVulnerableLibrariesAudit extends i{static get meta(){return{id:"no-vulnerable-libraries",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),requiredArtifacts:["Stacks"]}}static get snykDB(){return c}static get severityMap(){return{high:3,medium:2,low:1}}static normalizeVersion(e){if(!e)return e;if(s.valid(e))return e;if(/^\d+\.\d+$/.test(e))return e+".0";const t=e.match(m);return t?t[1]:e}static getVulnerabilities(e,t,n){if(!t.npm||!n.npm[t.npm])return[];try{s.satisfies(e,"*")}catch(e){return e.pkgName=t.npm,a.captureException(e,{level:"warning"}),[]}
return n.npm[t.npm].filter((t=>t.semver.vulnerable.some((t=>s.satisfies(e,t))))).map((n=>({severity:p[n.severity],numericSeverity:this.severityMap[n.severity],library:`${t.name}@${e}`,url:"https://snyk.io/vuln/"+n.id})))}static highestSeverity(e){return e.sort(((e,t)=>t.numericSeverity-e.numericSeverity))[0].severity}static audit(e){const t=e.Stacks.filter((e=>"js"===e.detector)),n=NoVulnerableLibrariesAudit.snykDB;if(!t.length)return{score:1};let a=0;const s=[];for(const e of t){const t=this.normalizeVersion(e.version)||"",i=this.getVulnerabilities(t,e,n),c=i.length;let l;a+=c,i.length>0&&(l=this.highestSeverity(i),s.push({highestSeverity:l,vulnCount:c,detectedLib:{text:e.name+"@"+t,url:`https://snyk.io/vuln/npm:${e.npm}?lh=${t}&utm_source=lighthouse&utm_medium=ref&utm_campaign=audit`,type:"link"}}))}let c;a>0&&(c=d(u.displayValue,{itemCount:a}));const l=[{key:"detectedLib",itemType:"link",text:d(u.columnVersion)},{key:"vulnCount",itemType:"text",text:d(u.columnVuln)},{
key:"highestSeverity",itemType:"text",text:d(u.columnSeverity)}],m=i.makeTableDetails(l,s,{});return{score:Number(0===a),displayValue:c,details:m}}}t.exports=NoVulnerableLibrariesAudit,t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/no-vulnerable-libraries.js")},{"../../../third-party/snyk/snapshot.json":262,"../../lib/i18n/i18n.js":98,"../../lib/sentry.js":112,"../audit.js":3,semver:230}],"../audits/dobetterweb/notification-on-start":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../violation-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Avoids requesting the notification permission on page load",failureTitle:"Requests the notification permission on page load",description:"Users are mistrustful of or confused by sites that request to send notifications without context. Consider tying the request to user gestures instead. [Learn more](https://web.dev/notification-on-start/)."},c=a.createMessageInstanceIdFn(n,s)
;t.exports=class NotificationOnStart extends i{static get meta(){return{id:"notification-on-start",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),supportedModes:["navigation"],requiredArtifacts:["ConsoleMessages"]}}static audit(e){const t=i.getViolationResults(e,/notification permission/),n=[{key:"source",itemType:"source-location",text:c(a.UIStrings.columnSource)}],s=i.makeTableDetails(n,t);return{score:Number(0===t.length),details:s}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/notification-on-start.js")},{"../../lib/i18n/i18n.js":98,"../violation-audit.js":8}],"../audits/dobetterweb/password-inputs-can-be-pasted-into":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Allows users to paste into password fields",failureTitle:"Prevents users to paste into password fields",
description:"Preventing password pasting undermines good security policy. [Learn more](https://web.dev/password-inputs-can-be-pasted-into/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class PasswordInputsCanBePastedIntoAudit extends i{static get meta(){return{id:"password-inputs-can-be-pasted-into",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["PasswordInputsWithPreventedPaste"]}}static audit(e){const t=e.PasswordInputsWithPreventedPaste,n=[];t.forEach((e=>{n.push({node:i.makeNodeItem(e.node)})}));const s=[{key:"node",itemType:"node",text:c(a.UIStrings.columnFailingElem)}];return{score:Number(0===t.length),details:i.makeTableDetails(s,n)}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/password-inputs-can-be-pasted-into.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/dobetterweb/uses-http2":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("../audit.js"),a=e("../../lib/third-party-web.js"),s=e("../../lib/url-shim.js"),c=e("../byte-efficiency/byte-efficiency-audit.js"),l=e("../../computed/metrics/lantern-interactive.js"),u=e("../../lib/network-request.js"),d=e("../../computed/network-records.js"),m=e("../../computed/load-simulator.js"),p=e("../../computed/page-dependency-graph.js"),h=e("../../lib/i18n/i18n.js"),f={title:"Use HTTP/2",description:"HTTP/2 offers many benefits over HTTP/1.1, including binary headers and multiplexing. [Learn more](https://web.dev/uses-http2/).",displayValue:"{itemCount, plural,\n    =1 {1 request not served via HTTP/2}\n    other {# requests not served via HTTP/2}\n    }",columnProtocol:"Protocol"},g=h.createMessageInstanceIdFn(n,f),y=new Set([u.TYPES.Document,u.TYPES.Font,u.TYPES.Image,u.TYPES.Stylesheet,u.TYPES.Script,u.TYPES.Media]);class UsesHTTP2Audit extends i{static get meta(){return{id:"uses-http2",title:g(f.title),description:g(f.description),
scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["URL","devtoolsLogs","traces"]}}static computeWasteWithTTIGraph(e,t,n){const i=new Set(e.map((e=>e.url))),a=n.simulate(t,{label:"uses-http2-before",flexibleOrdering:true}),s=new Map;t.traverse((e=>{"network"===e.type&&i.has(e.record.url)&&(s.set(e.record.requestId,e.record.protocol),e.record.protocol="h2")}));const c=n.simulate(t,{label:"uses-http2-after",flexibleOrdering:true});t.traverse((e=>{if("network"!==e.type)return;const t=s.get(e.record.requestId);void 0!==t&&(e.record.protocol=t)}));const u=a.timeInMs-c.timeInMs,d=l.getLastLongTaskEndTime(a.nodeTimings)-l.getLastLongTaskEndTime(c.nodeTimings),m=Math.max(d,u);return 10*Math.round(Math.max(m,0)/10)}static isStaticAsset(e){if(!y.has(e.resourceType))return!1;if(e.resourceSize<100){if(a.getEntity(e.url))return!1}return!0}static determineNonHttp2Resources(e){const t=[],n=new Set,i=new Map;for(const t of e){
if(!UsesHTTP2Audit.isStaticAsset(t))continue;if(s.isLikeLocalhost(t.parsedURL.host))continue;const e=i.get(t.parsedURL.securityOrigin)||[];e.push(t),i.set(t.parsedURL.securityOrigin,e)}for(const a of e){if(n.has(a.url))continue;if(a.fetchedViaServiceWorker)continue;if(!/HTTP\/[01][.\d]?/i.test(a.protocol))continue;(i.get(a.parsedURL.securityOrigin)||[]).length<6||(n.add(a.url),t.push({protocol:a.protocol,url:a.url}))}return t}static async audit(e,t){const n=e.traces[i.DEFAULT_PASS],a=e.devtoolsLogs[i.DEFAULT_PASS],s={devtoolsLog:a,settings:t&&t.settings||{}},l=await d.request(a,t),u=await p.request({trace:n,devtoolsLog:a},t),y=await m.request(s,t),b=UsesHTTP2Audit.determineNonHttp2Resources(l),v=UsesHTTP2Audit.computeWasteWithTTIGraph(b,u,y);let w;b.length>0&&(w=g(f.displayValue,{itemCount:b.length}));const S=[{key:"url",valueType:"url",label:g(h.UIStrings.columnURL)},{key:"protocol",valueType:"text",label:g(f.columnProtocol)}],T=i.makeOpportunityDetails(S,b,v);return{displayValue:w,
numericValue:v,numericUnit:"millisecond",score:c.scoreForWastedMs(v),details:T}}}t.exports=UsesHTTP2Audit,t.exports.UIStrings=f}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/uses-http2.js")},{"../../computed/load-simulator.js":13,"../../computed/metrics/lantern-interactive.js":24,"../../computed/network-records.js":40,"../../computed/page-dependency-graph.js":41,"../../lib/i18n/i18n.js":98,"../../lib/network-request.js":109,"../../lib/third-party-web.js":116,"../../lib/url-shim.js":"url","../audit.js":3,"../byte-efficiency/byte-efficiency-audit.js":4}],"../audits/dobetterweb/uses-passive-event-listeners":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../violation-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Uses passive listeners to improve scrolling performance",failureTitle:"Does not use passive listeners to improve scrolling performance",
description:"Consider marking your touch and wheel event listeners as `passive` to improve your page's scroll performance. [Learn more](https://web.dev/uses-passive-event-listeners/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class PassiveEventsAudit extends i{static get meta(){return{id:"uses-passive-event-listeners",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["ConsoleMessages"]}}static audit(e){const t=i.getViolationResults(e,/passive event listener/),n=[{key:"source",itemType:"source-location",text:c(a.UIStrings.columnSource)}],s=i.makeTableDetails(n,t);return{score:Number(0===t.length),details:s}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/dobetterweb/uses-passive-event-listeners.js")},{"../../lib/i18n/i18n.js":98,"../violation-audit.js":8}],"../audits/errors-in-console":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("lighthouse-logger"),a=e("./audit.js"),s=e("../lib/i18n/i18n.js"),c={title:"No browser errors logged to the console",failureTitle:"Browser errors were logged to the console",description:"Errors logged to the console indicate unresolved problems. They can come from network request failures and other browser concerns. [Learn more](https://web.dev/errors-in-console/)"},l=s.createMessageInstanceIdFn(n,c);class ErrorLogs extends a{static get meta(){return{id:"errors-in-console",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["ConsoleMessages"]}}static get defaultOptions(){return{ignoredPatterns:["ERR_BLOCKED_BY_CLIENT.Inspector"]}}static filterAccordingToOptions(e,t){const{ignoredPatterns:n,...a}=t,s=Object.keys(a);return s.length&&i.warn(this.meta.id,"Unrecognized options",s),n?e.filter((({description:e})=>{if(!e)return!0;for(const t of n){if(t instanceof RegExp&&t.test(e))return!1;if("string"==typeof t&&e.includes(t))return!1}
return!0})):e}static audit(e,t){const n=t.options,i=e.ConsoleMessages.filter((e=>"error"===e.level)).map((e=>({source:e.source,description:e.text,url:e.url,sourceLocation:a.makeSourceLocationFromConsoleMessage(e)}))),c=ErrorLogs.filterAccordingToOptions(i,n).sort(((e,t)=>(e.description||"").localeCompare(t.description||""))),u=[{key:"sourceLocation",itemType:"source-location",text:l(s.UIStrings.columnSource)},{key:"description",itemType:"code",text:l(s.UIStrings.columnDescription)}],d=a.makeTableDetails(u,c),m=c.length;return{score:Number(0===m),details:d}}}t.exports=ErrorLogs,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/errors-in-console.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3,"lighthouse-logger":188}],"../audits/final-screenshot":[function(e,t,n){"use strict";const i=e("./audit.js"),a=e("../lib/lh-error.js"),s=e("../computed/processed-trace.js"),c=e("../computed/screenshots.js");t.exports=class FinalScreenshot extends i{static get meta(){return{
id:"final-screenshot",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Final Screenshot",description:"The last screenshot captured of the pageload.",requiredArtifacts:["traces","GatherContext"]}}static async audit(e,t){const n=e.traces[i.DEFAULT_PASS],l=await s.request(n,t),u=await c.request(n,t),{timeOrigin:d}=l.timestamps,m=u[u.length-1];if(!m){if("timespan"===e.GatherContext.gatherMode)return{notApplicable:!0,score:1};throw new a(a.errors.NO_SCREENSHOTS)}return{score:1,details:{type:"screenshot",timing:Math.round((m.timestamp-d)/1e3),timestamp:m.timestamp,data:m.datauri}}}}},{"../computed/processed-trace.js":43,"../computed/screenshots.js":45,"../lib/lh-error.js":103,"./audit.js":3}],"../audits/font-display":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/url-shim.js"),s=/^(block|fallback|optional|swap)$/,c=/url\((.*?)\)/,l=new RegExp(c,"g"),u=e("../lib/i18n/i18n.js"),d=e("../lib/sentry.js"),m=e("../computed/network-records.js"),p={
title:"All text remains visible during webfont loads",failureTitle:"Ensure text remains visible during webfont load",description:"Leverage the font-display CSS feature to ensure text is user-visible while webfonts are loading. [Learn more](https://web.dev/font-display/).",undeclaredFontOriginWarning:"{fontCountForOrigin, plural, =1 {Lighthouse was unable to automatically check the `font-display` value for the origin {fontOrigin}.} other {Lighthouse was unable to automatically check the `font-display` values for the origin {fontOrigin}.}}"},h=u.createMessageInstanceIdFn(n,p);class FontDisplay extends i{static get meta(){return{id:"font-display",title:h(p.title),failureTitle:h(p.failureTitle),description:h(p.description),supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","CSSUsage","URL"]}}static findFontDisplayDeclarations(e,t){const n=new Set,i=new Set;for(const s of e.CSSUsage.stylesheets){const u=s.content.replace(/(\r|\n)+/g," ").match(/@font-face\s*{(.*?)}/g)||[]
;for(const m of u){const u=m.match(l);if(!u)continue;const p=m.match(/font-display\s*:\s*(\w+)\s*(;|\})/),h=p&&p[1]||"",f=t.test(h)?n:i,g=u.map((e=>e.match(c)[1].trim())).map((e=>/^('|").*\1$/.test(e)?e.substr(1,e.length-2):e));for(const t of g)try{const n=a.isValid(s.header.sourceURL)?s.header.sourceURL:e.URL.finalUrl,i=new a(t,n);f.add(i.href)}catch(e){d.captureException(e,{tags:{audit:this.meta.id}})}}}return{passingURLs:n,failingURLs:i}}static getWarningsForFontUrls(e){const t=new Map;for(const n of e){const e=a.getOrigin(n);if(!e)continue;const i=t.get(e)||0;t.set(e,i+1)}return[...t].map((([e,t])=>h(p.undeclaredFontOriginWarning,{fontCountForOrigin:t,fontOrigin:e})))}static async audit(e,t){
const n=e.devtoolsLogs[this.DEFAULT_PASS],a=await m.request(n,t),{passingURLs:c,failingURLs:l}=FontDisplay.findFontDisplayDeclarations(e,s),d=[],p=a.filter((e=>"Font"===e.resourceType)).filter((e=>!/^data:/.test(e.url))).filter((e=>!/^blob:/.test(e.url))).filter((e=>!!l.has(e.url)||(c.has(e.url)||d.push(e.url),!1))).map((e=>{const t=Math.min(1e3*(e.endTime-e.startTime),3e3);return{url:e.url,wastedMs:t}})),f=[{key:"url",itemType:"url",text:h(u.UIStrings.columnURL)},{key:"wastedMs",itemType:"ms",text:h(u.UIStrings.columnWastedMs)}],g=i.makeTableDetails(f,p);return{score:Number(0===p.length),details:g,warnings:FontDisplay.getWarningsForFontUrls(d)}}}t.exports=FontDisplay,t.exports.UIStrings=p}).call(this)}).call(this,"/lighthouse-core/audits/font-display.js")},{"../computed/network-records.js":40,"../lib/i18n/i18n.js":98,"../lib/sentry.js":112,"../lib/url-shim.js":"url","./audit.js":3}],"../audits/full-page-screenshot":[function(e,t,n){"use strict";const i=e("./audit.js")
;t.exports=class FullPageScreenshot extends i{static get meta(){return{id:"full-page-screenshot",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Full-page screenshot",description:"A full-height screenshot of the final rendered page",requiredArtifacts:["FullPageScreenshot"]}}static async audit(e){return e.FullPageScreenshot?{score:1,details:{type:"full-page-screenshot",...e.FullPageScreenshot}}:{score:0,notApplicable:!0}}}},{"./audit.js":3}],"../audits/image-aspect-ratio":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/url-shim.js"),s=e("../lib/i18n/i18n.js"),c={title:"Displays images with correct aspect ratio",failureTitle:"Displays images with incorrect aspect ratio",description:"Image display dimensions should match natural aspect ratio. [Learn more](https://web.dev/image-aspect-ratio/).",columnDisplayed:"Aspect Ratio (Displayed)",columnActual:"Aspect Ratio (Actual)"},l=s.createMessageInstanceIdFn(n,c);class ImageAspectRatio extends i{
static get meta(){return{id:"image-aspect-ratio",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["ImageElements"]}}static computeAspectRatios(e){const t=a.elideDataURI(e.src),n=e.naturalDimensions.width/e.naturalDimensions.height,i=e.displayedWidth/e.displayedHeight,s=e.displayedWidth/n,c=Math.abs(s-e.displayedHeight)<2;return{url:t,displayedAspectRatio:`${e.displayedWidth} x ${e.displayedHeight}\n        (${i.toFixed(2)})`,actualAspectRatio:`${e.naturalDimensions.width} x ${e.naturalDimensions.height}\n        (${n.toFixed(2)})`,doRatiosMatch:c}}static audit(e){const t=e.ImageElements,n=[];t.filter((e=>!e.isCss&&e.mimeType&&"image/svg+xml"!==e.mimeType&&e.naturalDimensions&&e.naturalDimensions.height>5&&e.naturalDimensions.width>5&&e.displayedWidth&&e.displayedHeight&&"fill"===e.computedStyles.objectFit)).forEach((e=>{const t=e,i=ImageAspectRatio.computeAspectRatios(t);i.doRatiosMatch||n.push(i)}));const a=[{key:"url",
itemType:"thumbnail",text:""},{key:"url",itemType:"url",text:l(s.UIStrings.columnURL)},{key:"displayedAspectRatio",itemType:"text",text:l(c.columnDisplayed)},{key:"actualAspectRatio",itemType:"text",text:l(c.columnActual)}];return{score:Number(0===n.length),details:i.makeTableDetails(a,n)}}}t.exports=ImageAspectRatio,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/image-aspect-ratio.js")},{"../lib/i18n/i18n.js":98,"../lib/url-shim.js":"url","./audit.js":3}],"../audits/image-size-responsive":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/url-shim.js"),s=e("../lib/i18n/i18n.js"),c={title:"Serves images with appropriate resolution",failureTitle:"Serves images with low resolution",description:"Image natural dimensions should be proportional to the display size and the pixel ratio to maximize image clarity. [Learn more](https://web.dev/serve-responsive-images/).",columnDisplayed:"Displayed size",columnActual:"Actual size",
columnExpected:"Expected size"},l=s.createMessageInstanceIdFn(n,c);function isCandidate(e){return!(e.displayedWidth<=1||e.displayedHeight<=1)&&(!!(e.naturalDimensions&&e.naturalDimensions.width&&e.naturalDimensions.height)&&("image/svg+xml"!==e.mimeType&&(!e.isCss&&("fill"===e.computedStyles.objectFit&&(!["pixelated","crisp-edges"].includes(e.computedStyles.imageRendering)&&!/ \d+(\.\d+)?x/.test(e.srcset))))))}function imageHasNaturalDimensions(e){return!!e.naturalDimensions}function imageHasRightSize(e,t){const[n,i]=function allowedImageSize(e,t,n){let i=1;(e>64||t>64)&&(i=.75);const a=quantizeDpr(n),s=Math.ceil(i*a*e),c=Math.ceil(i*a*t);return[s,c]}(e.displayedWidth,e.displayedHeight,t);return e.naturalDimensions.width>=n&&e.naturalDimensions.height>=i}function getResult(e,t){const[n,i]=function expectedImageSize(e,t,n){const i=Math.ceil(quantizeDpr(n)*e),a=Math.ceil(quantizeDpr(n)*t);return[i,a]}(e.displayedWidth,e.displayedHeight,t);return{url:e.src,elidedUrl:a.elideDataURI(e.src),
displayedSize:`${e.displayedWidth} x ${e.displayedHeight}`,actualSize:`${e.naturalDimensions.width} x ${e.naturalDimensions.height}`,actualPixels:e.naturalDimensions.width*e.naturalDimensions.height,expectedSize:`${n} x ${i}`,expectedPixels:n*i}}function quantizeDpr(e){return e>=2?2:e>=1.5?1.5:1}t.exports=class ImageSizeResponsive extends i{static get meta(){return{id:"image-size-responsive",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["ImageElements","ViewportDimensions"]}}static audit(e){const t=e.ViewportDimensions.devicePixelRatio,n=Array.from(e.ImageElements).filter(isCandidate).filter(imageHasNaturalDimensions).filter((e=>!imageHasRightSize(e,t))).filter((t=>function isVisible(e,t){return(e.bottom-e.top)*(e.right-e.left)>0&&e.top<=t.innerHeight&&e.bottom>=0&&e.left<=t.innerWidth&&e.right>=0}(t.clientRect,e.ViewportDimensions))).filter((t=>function isSmallerThanViewport(e,t){
return e.bottom-e.top<=t.innerHeight&&e.right-e.left<=t.innerWidth}(t.clientRect,e.ViewportDimensions))).map((e=>getResult(e,t))),a=[{key:"url",itemType:"thumbnail",text:""},{key:"elidedUrl",itemType:"url",text:l(s.UIStrings.columnURL)},{key:"displayedSize",itemType:"text",text:l(c.columnDisplayed)},{key:"actualSize",itemType:"text",text:l(c.columnActual)},{key:"expectedSize",itemType:"text",text:l(c.columnExpected)}],u=function sortResultsBySizeDelta(e){return e.sort(((e,t)=>t.expectedPixels-t.actualPixels-(e.expectedPixels-e.actualPixels)))}(function deduplicateResultsByUrl(e){e.sort(((e,t)=>e.url===t.url?0:e.url<t.url?-1:1));const t=[];for(const n of e){const e=t[t.length-1];e&&e.url===n.url?e.expectedPixels<n.expectedPixels&&(t[t.length-1]=n):t.push(n)}return t}(n));return{score:Number(0===n.length),details:i.makeTableDetails(a,u)}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/image-size-responsive.js")},{"../lib/i18n/i18n.js":98,
"../lib/url-shim.js":"url","./audit.js":3}],"../audits/installable-manifest":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../computed/manifest-values.js"),c={title:"Web app manifest and service worker meet the installability requirements",failureTitle:"Web app manifest or service worker do not meet the installability requirements",description:"Service worker is the technology that enables your app to use many Progressive Web App features, such as offline, add to homescreen, and push notifications. With proper service worker and manifest implementations, browsers can proactively prompt users to add your app to their homescreen, which can lead to higher engagement. [Learn more](https://web.dev/installable-manifest/).",columnValue:"Failure reason",displayValue:"{itemCount, plural,\n    =1 {1 reason}\n    other {# reasons}\n    }",noErrorId:"Installability error id '{errorId}' is not recognized",
"not-in-main-frame":"Page is not loaded in the main frame","not-from-secure-origin":"Page is not served from a secure origin","no-manifest":"Page has no manifest <link> URL","start-url-not-valid":"Manifest start URL is not valid","manifest-missing-name-or-short-name":"Manifest does not contain a 'name' or 'short_name' field","manifest-display-not-supported":"Manifest 'display' property must be one of 'standalone', 'fullscreen', or 'minimal-ui'","manifest-empty":"Manifest could not be fetched, is empty, or could not be parsed","no-matching-service-worker":"No matching service worker detected. You may need to reload the page, or check that the scope of the service worker for the current page encloses the scope and start URL from the manifest.","manifest-missing-suitable-icon":'Manifest does not contain a suitable icon - PNG, SVG or WebP format of at least {value0} px is required, the sizes attribute must be set, and the purpose attribute, if set, must include "any".',
"no-acceptable-icon":'No supplied icon is at least {value0} px square in PNG, SVG or WebP format, with the purpose attribute unset or set to "any"',"cannot-download-icon":"Could not download a required icon from the manifest","no-icon-available":"Downloaded icon was empty or corrupted","platform-not-supported-on-android":"The specified application platform is not supported on Android","no-id-specified":"No Play store ID provided","ids-do-not-match":"The Play Store app URL and Play Store ID do not match","already-installed":"The app is already installed","url-not-supported-for-webapk":"A URL in the manifest contains a username, password, or port","in-incognito":"Page is loaded in an incognito window","not-offline-capable":"Page does not work offline","no-url-for-service-worker":"Could not check service worker without a 'start_url' field in the manifest","prefer-related-applications":"Manifest specifies prefer_related_applications: true",
"prefer-related-applications-only-beta-stable":"prefer_related_applications is only supported on Chrome Beta and Stable channels on Android.","manifest-display-override-not-supported":"Manifest contains 'display_override' field, and the first supported display mode must be one of 'standalone', 'fullscreen', or 'minimal-ui'","manifest-location-changed":"Manifest URL changed while the manifest was being fetched.","warn-not-offline-capable":"Page does not work offline. The page will not be regarded as installable after Chrome 93, stable release August 2021."},l=a.createMessageInstanceIdFn(n,c);class InstallableManifest extends i{static get meta(){return{id:"installable-manifest",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),supportedModes:["navigation"],requiredArtifacts:["URL","WebAppManifest","InstallabilityErrors"]}}static getInstallabilityErrors(e){const t=e.InstallabilityErrors.errors,n=[],i=[],a=/{([^}]+)}/g;for(const e of t){
if("in-incognito"===e.errorId)continue;if("warn-not-offline-capable"===e.errorId){i.push(l(c[e.errorId]));continue}const t=c[e.errorId];if(void 0===t){n.push(l(c.noErrorId,{errorId:e.errorId}));continue}const s=t.match(a)||[],u=e.errorArguments&&e.errorArguments.length&&e.errorArguments[0].value;if(t&&e.errorArguments.length!==s.length){const t=JSON.stringify(e.errorArguments),i=e.errorArguments.length>s.length?`${e.errorId} has unexpected arguments ${t}`:e.errorId+" does not have the expected number of arguments.";n.push(i)}else t&&u?n.push(l(t,{value0:u})):t&&n.push(l(t))}return{i18nErrors:n,warnings:i}}static async audit(e,t){const n=await s.request(e,t),{i18nErrors:a,warnings:u}=InstallableManifest.getInstallabilityErrors(e),d=e.WebAppManifest?e.WebAppManifest.url:null,m=[{key:"reason",itemType:"text",text:l(c.columnValue)}],p=a.map((e=>({reason:e})));n.isParseFailure&&p.push({reason:n.parseFailureReason});const h={type:"debugdata",manifestUrl:d};return p.length>0?{score:0,
warnings:u,numericValue:p.length,numericUnit:"element",displayValue:l(c.displayValue,{itemCount:p.length}),details:{...i.makeTableDetails(m,p),debugData:h}}:{score:1,warnings:u,details:{...i.makeTableDetails(m,p),debugData:h}}}}t.exports=InstallableManifest,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/installable-manifest.js")},{"../computed/manifest-values.js":16,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/is-on-https":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/url-shim.js"),s=e("../lib/network-request.js"),c=e("../computed/network-records.js"),l=e("../lib/i18n/i18n.js"),u={title:"Uses HTTPS",failureTitle:"Does not use HTTPS",
description:"All sites should be protected with HTTPS, even ones that don't handle sensitive data. This includes avoiding [mixed content](https://developers.google.com/web/fundamentals/security/prevent-mixed-content/what-is-mixed-content), where some resources are loaded over HTTP despite the initial request being served over HTTPS. HTTPS prevents intruders from tampering with or passively listening in on the communications between your app and your users, and is a prerequisite for HTTP/2 and many new web platform APIs. [Learn more](https://web.dev/is-on-https/).",displayValue:"{itemCount, plural,\n    =1 {1 insecure request found}\n    other {# insecure requests found}\n    }",columnInsecureURL:"Insecure URL",columnResolution:"Request Resolution",allowed:"Allowed",blocked:"Blocked",warning:"Allowed with warning",upgraded:"Automatically upgraded to HTTPS"},d={MixedContentAutomaticallyUpgraded:u.upgraded,MixedContentBlocked:u.blocked,MixedContentWarning:u.warning
},m=l.createMessageInstanceIdFn(n,u);t.exports=class HTTPS extends i{static get meta(){return{id:"is-on-https",title:m(u.title),failureTitle:m(u.failureTitle),description:m(u.description),requiredArtifacts:["devtoolsLogs","InspectorIssues"]}}static audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS];return c.request(n,t).then((t=>{const n=t.filter((e=>!s.isSecureRequest(e))).map((e=>a.elideDataURI(e.url))),c=Array.from(new Set(n)).map((e=>({url:e,resolution:void 0}))),l=[{key:"url",itemType:"url",text:m(u.columnInsecureURL)},{key:"resolution",itemType:"text",text:m(u.columnResolution)}];for(const t of e.InspectorIssues.mixedContent){let e=c.find((e=>e.url===t.insecureURL));e||(e={url:t.insecureURL},c.push(e)),e.resolution=d[t.resolutionStatus]?m(d[t.resolutionStatus]):t.resolutionStatus}for(const e of c)e.resolution||(e.resolution=m(u.allowed));let p;return c.length>0&&(p=m(u.displayValue,{itemCount:c.length})),{score:Number(0===c.length),displayValue:p,details:i.makeTableDetails(l,c)}
}))}},t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/is-on-https.js")},{"../computed/network-records.js":40,"../lib/i18n/i18n.js":98,"../lib/network-request.js":109,"../lib/url-shim.js":"url","./audit.js":3}],"../audits/largest-contentful-paint-element":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s={title:"Largest Contentful Paint element",description:"This is the largest contentful element painted within the viewport. [Learn More](https://web.dev/lighthouse-largest-contentful-paint/)"},c=a.createMessageInstanceIdFn(n,s);t.exports=class LargestContentfulPaintElement extends i{static get meta(){return{id:"largest-contentful-paint-element",title:c(s.title),description:c(s.description),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["traces","TraceElements"]}}static audit(e){
const t=e.TraceElements.find((e=>"largest-contentful-paint"===e.traceEventType)),n=[];t&&n.push({node:i.makeNodeItem(t.node)});const s=[{key:"node",itemType:"node",text:c(a.UIStrings.columnElement)}],l=i.makeTableDetails(s,n),u=c(a.UIStrings.displayValueElementsFound,{nodeCount:n.length});return{score:1,notApplicable:0===n.length,displayValue:u,details:l}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/largest-contentful-paint-element.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/layout-shift-elements":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s={title:"Avoid large layout shifts",description:"These DOM elements contribute most to the CLS of the page.",columnContribution:"CLS Contribution"},c=a.createMessageInstanceIdFn(n,s);t.exports=class LayoutShiftElements extends i{static get meta(){return{id:"layout-shift-elements",title:c(s.title),description:c(s.description),
scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,requiredArtifacts:["traces","TraceElements"]}}static audit(e){const t=e.TraceElements.filter((e=>"layout-shift"===e.traceEventType)).map((e=>({node:i.makeNodeItem(e.node),score:e.score}))),n=[{key:"node",itemType:"node",text:c(a.UIStrings.columnElement)},{key:"score",itemType:"numeric",granularity:.001,text:c(s.columnContribution)}],l=i.makeTableDetails(n,t);let u;return t.length>0&&(u=c(a.UIStrings.displayValueElementsFound,{nodeCount:t.length})),{score:1,notApplicable:0===l.items.length,displayValue:u,details:l}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/layout-shift-elements.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/lcp-lazy-loaded":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s={title:"Largest Contentful Paint image was not lazily loaded",failureTitle:"Largest Contentful Paint image was lazily loaded",
description:"Above-the-fold images that are lazily loaded render later in the page lifecycle, which can delay the largest contentful paint. [Learn more](https://web.dev/lcp-lazy-loading/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class LargestContentfulPaintLazyLoaded extends i{static get meta(){return{id:"lcp-lazy-loaded",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),supportedModes:["navigation"],requiredArtifacts:["TraceElements","ViewportDimensions","ImageElements"]}}static isImageInViewport(e,t){return e.clientRect.top<t.innerHeight}static audit(e){const t=e.TraceElements.find((e=>"largest-contentful-paint"===e.traceEventType)),n=t?e.ImageElements.find((e=>e.node.devtoolsNodePath===t.node.devtoolsNodePath)):void 0;if(!n||!this.isImageInViewport(n,e.ViewportDimensions))return{score:1,notApplicable:!0};const s=[{key:"node",itemType:"node",text:c(a.UIStrings.columnElement)}],l=i.makeTableDetails(s,[{node:i.makeNodeItem(n.node)}]);return{
score:"lazy"===n.loading?0:1,details:l}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/lcp-lazy-loaded.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/long-tasks":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../computed/network-records.js"),s=e("../lib/i18n/i18n.js"),c=e("../computed/main-thread-tasks.js"),l=e("./bootup-time.js"),u=e("../computed/page-dependency-graph.js"),d=e("../computed/load-simulator.js"),m={startTime:0,endTime:0,duration:0},p={title:"Avoid long main-thread tasks",description:"Lists the longest tasks on the main thread, useful for identifying worst contributors to input delay. [Learn more](https://web.dev/long-tasks-devtools/)",displayValue:"{itemCount, plural,\n  =1 {# long task found}\n  other {# long tasks found}\n  }"},h=s.createMessageInstanceIdFn(n,p);class LongTasks extends i{static get meta(){return{id:"long-tasks",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:h(p.title),
description:h(p.description),requiredArtifacts:["traces","devtoolsLogs"]}}static async audit(e,t){const n=t.settings||{},f=e.traces[i.DEFAULT_PASS],g=await c.request(f,t),y=e.devtoolsLogs[LongTasks.DEFAULT_PASS],b=await a.request(y,t),v=new Map;if("simulate"===n.throttlingMethod){const e={devtoolsLog:y,settings:t.settings},n=await u.request({trace:f,devtoolsLog:y},t),i=await d.request(e,t),a=await i.simulate(n,{label:"long-tasks-diagnostic"});for(const[e,t]of a.nodeTimings.entries())"cpu"===e.type&&v.set(e.event,t)}else for(const e of g)e.unbounded||e.parent||v.set(e.event,e);const w=l.getJavaScriptURLs(b),S=g.map((e=>{const t=v.get(e.event)||m;return{...e,duration:t.duration,startTime:t.startTime}})).filter((e=>e.duration>=50&&!e.unbounded&&!e.parent)).sort(((e,t)=>t.duration-e.duration)).slice(0,20).map((e=>({url:l.getAttributableURLForTask(e,w),duration:e.duration,startTime:e.startTime}))),T=[{key:"url",itemType:"url",text:h(s.UIStrings.columnURL)},{key:"startTime",itemType:"ms",
granularity:1,text:h(s.UIStrings.columnStartTime)},{key:"duration",itemType:"ms",granularity:1,text:h(s.UIStrings.columnDuration)}],E=i.makeTableDetails(T,S);let _;return S.length>0&&(_=h(p.displayValue,{itemCount:S.length})),{score:0===S.length?1:0,notApplicable:0===S.length,details:E,displayValue:_}}}t.exports=LongTasks,t.exports.UIStrings=p}).call(this)}).call(this,"/lighthouse-core/audits/long-tasks.js")},{"../computed/load-simulator.js":13,"../computed/main-thread-tasks.js":15,"../computed/network-records.js":40,"../computed/page-dependency-graph.js":41,"../lib/i18n/i18n.js":98,"./audit.js":3,"./bootup-time.js":"../audits/bootup-time"}],"../audits/main-thread-tasks":[function(e,t,n){"use strict";const i=e("./audit.js"),a=e("../computed/main-thread-tasks.js");t.exports=class MainThreadTasks extends i{static get meta(){return{id:"main-thread-tasks",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Tasks",
description:"Lists the toplevel main thread tasks that executed during page load.",requiredArtifacts:["traces"]}}static async audit(e,t){const n=e.traces[i.DEFAULT_PASS],s=(await a.request(n,t)).filter((e=>e.duration>5&&!e.parent)).map((e=>({duration:e.duration,startTime:e.startTime})));return{score:1,details:i.makeTableDetails([{key:"startTime",itemType:"ms",granularity:1,text:"Start Time"},{key:"duration",itemType:"ms",granularity:1,text:"End Time"}],s)}}}},{"../computed/main-thread-tasks.js":15,"./audit.js":3}],"../audits/mainthread-work-breakdown":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),{taskGroups:a}=e("../lib/tracehouse/task-groups.js"),s=e("../lib/i18n/i18n.js"),c=e("../computed/main-thread-tasks.js"),l={title:"Minimizes main-thread work",failureTitle:"Minimize main-thread work",
description:"Consider reducing the time spent parsing, compiling and executing JS. You may find delivering smaller JS payloads helps with this. [Learn more](https://web.dev/mainthread-work-breakdown/)",columnCategory:"Category"},u=s.createMessageInstanceIdFn(n,l);class MainThreadWorkBreakdown extends i{static get meta(){return{id:"mainthread-work-breakdown",title:u(l.title),failureTitle:u(l.failureTitle),description:u(l.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["traces"]}}static get defaultOptions(){return{p10:2017,median:4e3}}static getExecutionTimingsByGroup(e){const t=new Map;for(const n of e){const e=t.get(n.group.id)||0;t.set(n.group.id,e+n.selfTime)}return t}static async audit(e,t){const n=t.settings||{},d=e.traces[MainThreadWorkBreakdown.DEFAULT_PASS],m=await c.request(d,t),p="simulate"===n.throttlingMethod?n.throttling.cpuSlowdownMultiplier:1,h=MainThreadWorkBreakdown.getExecutionTimingsByGroup(m);let f=0;const g={},y=Array.from(h).map((([e,t])=>{
const n=t*p;f+=n;const i=g[e]||0;return g[e]=i+n,{group:e,groupLabel:a[e].label,duration:n}})),b=[{key:"groupLabel",itemType:"text",text:u(l.columnCategory)},{key:"duration",itemType:"ms",granularity:1,text:u(s.UIStrings.columnTimeSpent)}];y.sort(((e,t)=>g[t.group]-g[e.group]));const v=MainThreadWorkBreakdown.makeTableDetails(b,y);return{score:i.computeLogNormalScore({p10:t.options.p10,median:t.options.median},f),numericValue:f,numericUnit:"millisecond",displayValue:u(s.UIStrings.seconds,{timeInMs:f}),details:v}}}t.exports=MainThreadWorkBreakdown,t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/mainthread-work-breakdown.js")},{"../computed/main-thread-tasks.js":15,"../lib/i18n/i18n.js":98,"../lib/tracehouse/task-groups.js":118,"./audit.js":3}],"../audits/manual/pwa-cross-browser":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./manual-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Site works cross-browser",
description:"To reach the most number of users, sites should work across every major browser. [Learn more](https://web.dev/pwa-cross-browser/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class PWACrossBrowser extends i{static get meta(){return Object.assign({id:"pwa-cross-browser",title:c(s.title),description:c(s.description)},super.partialMeta)}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/manual/pwa-cross-browser.js")},{"../../lib/i18n/i18n.js":98,"./manual-audit.js":6}],"../audits/manual/pwa-each-page-has-url":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./manual-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Each page has a URL",description:"Ensure individual pages are deep linkable via URL and that URLs are unique for the purpose of shareability on social media. [Learn more](https://web.dev/pwa-each-page-has-url/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class PWAEachPageHasURL extends i{static get meta(){
return Object.assign({id:"pwa-each-page-has-url",title:c(s.title),description:c(s.description)},super.partialMeta)}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/manual/pwa-each-page-has-url.js")},{"../../lib/i18n/i18n.js":98,"./manual-audit.js":6}],"../audits/manual/pwa-page-transitions":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./manual-audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Page transitions don't feel like they block on the network",description:"Transitions should feel snappy as you tap around, even on a slow network. This experience is key to a user's perception of performance. [Learn more](https://web.dev/pwa-page-transitions/)."},c=a.createMessageInstanceIdFn(n,s);t.exports=class PWAPageTransitions extends i{static get meta(){return Object.assign({id:"pwa-page-transitions",title:c(s.title),description:c(s.description)},super.partialMeta)}},t.exports.UIStrings=s}).call(this)
}).call(this,"/lighthouse-core/audits/manual/pwa-page-transitions.js")},{"../../lib/i18n/i18n.js":98,"./manual-audit.js":6}],"../audits/maskable-icon":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../computed/manifest-values.js"),s=e("../lib/i18n/i18n.js"),c={title:"Manifest has a maskable icon",failureTitle:"Manifest doesn't have a maskable icon",description:"A maskable icon ensures that the image fills the entire shape without being letterboxed when installing the app on a device. [Learn more](https://web.dev/maskable-icon-audit/)."},l=s.createMessageInstanceIdFn(n,c);t.exports=class MaskableIcon extends i{static get meta(){return{id:"maskable-icon",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static async audit(e,t){const n=await a.request(e,t);if(n.isParseFailure)return{score:0,explanation:n.parseFailureReason}
;const i=n.allChecks.find((e=>"hasMaskableIcon"===e.id));return{score:i&&i.passing?1:0}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/maskable-icon.js")},{"../computed/manifest-values.js":16,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/metrics/cumulative-layout-shift":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../computed/metrics/cumulative-layout-shift.js"),s=e("../../lib/i18n/i18n.js"),c={description:"Cumulative Layout Shift measures the movement of visible elements within the viewport. [Learn more](https://web.dev/cls/)."},l=s.createMessageInstanceIdFn(n,c);t.exports=class CumulativeLayoutShift extends i{static get meta(){return{id:"cumulative-layout-shift",title:l(s.UIStrings.cumulativeLayoutShiftMetric),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["traces"]}}static get defaultOptions(){return{p10:.1,median:.25}}static async audit(e,t){
const n=e.traces[i.DEFAULT_PASS],{cumulativeLayoutShift:s,...c}=await a.request(n,t),l={type:"debugdata",items:[c]};return{score:i.computeLogNormalScore({p10:t.options.p10,median:t.options.median},s),numericValue:s,numericUnit:"unitless",displayValue:s.toLocaleString(t.settings.locale),details:l}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/metrics/cumulative-layout-shift.js")},{"../../computed/metrics/cumulative-layout-shift.js":17,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/metrics/first-contentful-paint-3g":[function(e,t,n){"use strict";const i=e("../audit.js"),a=e("../../config/constants.js").throttling.mobileRegular3G,s=e("../../computed/metrics/first-contentful-paint.js");t.exports=class FirstContentfulPaint3G extends i{static get meta(){return{id:"first-contentful-paint-3g",title:"First Contentful Paint (3G)",
description:"First Contentful Paint 3G marks the time at which the first text or image is painted while on a 3G network. [Learn more](https://developers.google.com/web/tools/lighthouse/audits/first-contentful-paint).",scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{p10:2700,median:4500}}static async audit(e,t){const n=e.GatherContext,c={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:n,settings:{...t.settings,throttlingMethod:"simulate",throttling:a}},l=await s.request(c,t);return{score:i.computeLogNormalScore({p10:t.options.p10,median:t.options.median},l.timing),numericValue:l.timing,numericUnit:"millisecond",displayValue:l.timing+" ms"}}}},{"../../computed/metrics/first-contentful-paint.js":19,"../../config/constants.js":56,"../audit.js":3}],"../audits/metrics/first-contentful-paint":[function(e,t,n){(function(n){(function(){
"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../computed/metrics/first-contentful-paint.js"),c={description:"First Contentful Paint marks the time at which the first text or image is painted. [Learn more](https://web.dev/first-contentful-paint/)."},l=a.createMessageInstanceIdFn(n,c);t.exports=class FirstContentfulPaint extends i{static get meta(){return{id:"first-contentful-paint",title:l(a.UIStrings.firstContentfulPaintMetric),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{mobile:{scoring:{p10:1800,median:3e3}},desktop:{scoring:{p10:934,median:1600}}}}static async audit(e,t){const n={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings},c=await s.request(n,t),u=t.options[t.settings.formFactor];return{
score:i.computeLogNormalScore(u.scoring,c.timing),numericValue:c.timing,numericUnit:"millisecond",displayValue:l(a.UIStrings.seconds,{timeInMs:c.timing})}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/metrics/first-contentful-paint.js")},{"../../computed/metrics/first-contentful-paint.js":19,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/metrics/first-meaningful-paint":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../computed/metrics/first-meaningful-paint.js"),c={description:"First Meaningful Paint measures when the primary content of a page is visible. [Learn more](https://web.dev/first-meaningful-paint/)."},l=a.createMessageInstanceIdFn(n,c);t.exports=class FirstMeaningfulPaint extends i{static get meta(){return{id:"first-meaningful-paint",title:l(a.UIStrings.firstMeaningfulPaintMetric),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,
supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{mobile:{scoring:{p10:2336,median:4e3}},desktop:{scoring:{p10:934,median:1600}}}}static async audit(e,t){const n={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings},c=await s.request(n,t),u=t.options[t.settings.formFactor];return{score:i.computeLogNormalScore(u.scoring,c.timing),numericValue:c.timing,numericUnit:"millisecond",displayValue:l(a.UIStrings.seconds,{timeInMs:c.timing})}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/metrics/first-meaningful-paint.js")},{"../../computed/metrics/first-meaningful-paint.js":20,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/metrics/interactive":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../computed/metrics/interactive.js"),c={
description:"Time to interactive is the amount of time it takes for the page to become fully interactive. [Learn more](https://web.dev/interactive/)."},l=a.createMessageInstanceIdFn(n,c);t.exports=class InteractiveMetric extends i{static get meta(){return{id:"interactive",title:l(a.UIStrings.interactiveMetric),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{mobile:{scoring:{p10:3785,median:7300}},desktop:{scoring:{p10:2468,median:4500}}}}static async audit(e,t){const n={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings},c=(await s.request(n,t)).timing,u=t.options[t.settings.formFactor];return{score:i.computeLogNormalScore(u.scoring,c),numericValue:c,numericUnit:"millisecond",displayValue:l(a.UIStrings.seconds,{timeInMs:c})}}},t.exports.UIStrings=c}).call(this)
}).call(this,"/lighthouse-core/audits/metrics/interactive.js")},{"../../computed/metrics/interactive.js":21,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/metrics/largest-contentful-paint":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../computed/metrics/largest-contentful-paint.js"),c=e("../../lib/lh-error.js"),l={description:"Largest Contentful Paint marks the time at which the largest text or image is painted. [Learn more](https://web.dev/lighthouse-largest-contentful-paint/)"},u=a.createMessageInstanceIdFn(n,l);t.exports=class LargestContentfulPaint extends i{static get meta(){return{id:"largest-contentful-paint",title:u(a.UIStrings.largestContentfulPaintMetric),description:u(l.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["HostUserAgent","traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{mobile:{scoring:{p10:2500,
median:4e3}},desktop:{scoring:{p10:1200,median:2400}}}}static async audit(e,t){const n={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings};let l;try{l=await s.request(n,t)}catch(t){const n=e.HostUserAgent.match(/Chrome\/(\d+)/);if(!n)throw t;if(Number(n[1])<79&&"NO_LCP"===t.code)throw new c(c.errors.UNSUPPORTED_OLD_CHROME,{featureName:"Largest Contentful Paint"});throw t}const d=t.options[t.settings.formFactor];return{score:i.computeLogNormalScore(d.scoring,l.timing),numericValue:l.timing,numericUnit:"millisecond",displayValue:u(a.UIStrings.seconds,{timeInMs:l.timing})}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/metrics/largest-contentful-paint.js")},{"../../computed/metrics/largest-contentful-paint.js":31,"../../lib/i18n/i18n.js":98,"../../lib/lh-error.js":103,"../audit.js":3}],"../audits/metrics/max-potential-fid":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("../audit.js"),a=e("../../computed/metrics/max-potential-fid.js"),s=e("../../lib/i18n/i18n.js"),c={description:"The maximum potential First Input Delay that your users could experience is the duration of the longest task. [Learn more](https://web.dev/lighthouse-max-potential-fid/)."},l=s.createMessageInstanceIdFn(n,c);t.exports=class MaxPotentialFID extends i{static get meta(){return{id:"max-potential-fid",title:l(s.UIStrings.maxPotentialFIDMetric),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{p10:130,median:250}}static async audit(e,t){const n={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings},c=await a.request(n,t);return{score:i.computeLogNormalScore({p10:t.options.p10,median:t.options.median},c.timing),numericValue:c.timing,numericUnit:"millisecond",
displayValue:l(s.UIStrings.ms,{timeInMs:c.timing})}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/metrics/max-potential-fid.js")},{"../../computed/metrics/max-potential-fid.js":32,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/metrics/speed-index":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s=e("../../computed/metrics/speed-index.js"),c={description:"Speed Index shows how quickly the contents of a page are visibly populated. [Learn more](https://web.dev/speed-index/)."},l=a.createMessageInstanceIdFn(n,c);t.exports=class SpeedIndex extends i{static get meta(){return{id:"speed-index",title:l(a.UIStrings.speedIndexMetric),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{mobile:{scoring:{p10:3387,median:5800}},desktop:{scoring:{p10:1311,
median:2300}}}}static async audit(e,t){const n={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:e.GatherContext,settings:t.settings},c=await s.request(n,t),u=t.options[t.settings.formFactor];return{score:i.computeLogNormalScore(u.scoring,c.timing),numericValue:c.timing,numericUnit:"millisecond",displayValue:l(a.UIStrings.seconds,{timeInMs:c.timing})}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/metrics/speed-index.js")},{"../../computed/metrics/speed-index.js":35,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/metrics/total-blocking-time":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../computed/metrics/total-blocking-time.js"),s=e("../../lib/i18n/i18n.js"),c={description:"Sum of all time periods between FCP and Time to Interactive, when task length exceeded 50ms, expressed in milliseconds. [Learn more](https://web.dev/lighthouse-total-blocking-time/)."
},l=s.createMessageInstanceIdFn(n,c);t.exports=class TotalBlockingTime extends i{static get meta(){return{id:"total-blocking-time",title:l(s.UIStrings.totalBlockingTimeMetric),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static get defaultOptions(){return{mobile:{scoring:{p10:200,median:600}},desktop:{scoring:{p10:150,median:350}}}}static async audit(e,t){const n=e.traces[i.DEFAULT_PASS],c=e.devtoolsLogs[i.DEFAULT_PASS],u=e.GatherContext,d={trace:n,devtoolsLog:c,gatherContext:u,settings:t.settings};if("timespan"===u.gatherMode&&"simulate"===t.settings.throttlingMethod)return{score:1,notApplicable:!0};const m=await a.request(d,t),p=t.options[t.settings.formFactor];return{score:i.computeLogNormalScore(p.scoring,m.timing),numericValue:m.timing,numericUnit:"millisecond",displayValue:l(s.UIStrings.ms,{timeInMs:m.timing})}}},t.exports.UIStrings=c}).call(this)
}).call(this,"/lighthouse-core/audits/metrics/total-blocking-time.js")},{"../../computed/metrics/total-blocking-time.js":37,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/metrics":[function(e,t,n){"use strict";const i=e("./audit.js"),a=e("../computed/metrics/timing-summary.js"),s=new Set(["cumulativeLayoutShift","cumulativeLayoutShiftMainFrame","totalCumulativeLayoutShift","observedCumulativeLayoutShift","observedCumulativeLayoutShiftMainFrame","observedTotalCumulativeLayoutShift"]);t.exports=class Metrics extends i{static get meta(){return{id:"metrics",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Metrics",description:"Collects all available metrics.",supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static async audit(e,t){const n=e.GatherContext,c=e.traces[i.DEFAULT_PASS],l=e.devtoolsLogs[i.DEFAULT_PASS],u=await a.request({trace:c,devtoolsLog:l,gatherContext:n,settings:t.settings},t),d=u.metrics,m=u.debugInfo
;for(const[e,t]of Object.entries(d)){const n=e;"number"!=typeof t||s.has(n)||(d[n]=Math.round(t))}const p={type:"debugdata",items:[d,m]};return{score:1,numericValue:d.interactive||0,numericUnit:"millisecond",details:p}}}},{"../computed/metrics/timing-summary.js":36,"./audit.js":3}],"../audits/network-requests":[function(e,t,n){"use strict";const i=e("./audit.js"),a=e("../lib/url-shim.js"),s=e("../computed/network-records.js");t.exports=class NetworkRequests extends i{static get meta(){return{id:"network-requests",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Network Requests",description:"Lists the network requests that were made during page load.",requiredArtifacts:["devtoolsLogs"]}}static audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS];return s.request(n,t).then((e=>{const t=e.reduce(((e,t)=>Math.min(e,t.startTime)),1/0),timeToMs=e=>e<t||!Number.isFinite(e)?void 0:1e3*(e-t),n=e.map((e=>{
const t=e.lrStatistics&&e.lrStatistics.endTimeDeltaMs,n=e.lrStatistics&&e.lrStatistics.TCPMs,i=e.lrStatistics&&e.lrStatistics.requestMs,s=e.lrStatistics&&e.lrStatistics.responseMs;return{url:a.elideDataURI(e.url),protocol:e.protocol,startTime:timeToMs(e.startTime),endTime:timeToMs(e.endTime),finished:e.finished,transferSize:e.transferSize,resourceSize:e.resourceSize,statusCode:e.statusCode,mimeType:e.mimeType,resourceType:e.resourceType,lrEndTimeDeltaMs:t,lrTCPMs:n,lrRequestMs:i,lrResponseMs:s}}));return{score:1,details:i.makeTableDetails([{key:"url",itemType:"url",text:"URL"},{key:"protocol",itemType:"text",text:"Protocol"},{key:"startTime",itemType:"ms",granularity:1,text:"Start Time"},{key:"endTime",itemType:"ms",granularity:1,text:"End Time"},{key:"transferSize",itemType:"bytes",displayUnit:"kb",granularity:1,text:"Transfer Size"},{key:"resourceSize",itemType:"bytes",displayUnit:"kb",granularity:1,text:"Resource Size"},{key:"statusCode",itemType:"text",text:"Status Code"},{
key:"mimeType",itemType:"text",text:"MIME Type"},{key:"resourceType",itemType:"text",text:"Resource Type"}],n)}}))}}},{"../computed/network-records.js":40,"../lib/url-shim.js":"url","./audit.js":3}],"../audits/network-rtt":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../computed/network-records.js"),c=e("../computed/network-analysis.js"),l={title:"Network Round Trip Times",description:"Network round trip times (RTT) have a large impact on performance. If the RTT to an origin is high, it's an indication that servers closer to the user could improve performance. [Learn more](https://hpbn.co/primer-on-latency-and-bandwidth/)."},u=a.createMessageInstanceIdFn(n,l);t.exports=class NetworkRTT extends i{static get meta(){return{id:"network-rtt",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:u(l.title),description:u(l.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){
const n=e.devtoolsLogs[i.DEFAULT_PASS];if(!(await s.request(n,t)).length)return{score:1,notApplicable:!0};const l=await c.request(n,t);let d=0;const m=l.rtt,p=[];for(const[e,t]of l.additionalRttByOrigin.entries()){if(!e.startsWith("http"))continue;const n=t+m;p.push({origin:e,rtt:n}),d=Number.isFinite(n)?Math.max(n,d):d}p.sort(((e,t)=>t.rtt-e.rtt));const h=[{key:"origin",itemType:"text",text:u(a.UIStrings.columnURL)},{key:"rtt",itemType:"ms",granularity:1,text:u(a.UIStrings.columnTimeSpent)}],f=i.makeTableDetails(h,p);return{score:1,numericValue:d,numericUnit:"millisecond",displayValue:u(a.UIStrings.ms,{timeInMs:d}),details:f}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/network-rtt.js")},{"../computed/network-analysis.js":39,"../computed/network-records.js":40,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/network-server-latency":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../computed/network-records.js"),c=e("../computed/network-analysis.js"),l={title:"Server Backend Latencies",description:"Server latencies can impact web performance. If the server latency of an origin is high, it's an indication the server is overloaded or has poor backend performance. [Learn more](https://hpbn.co/primer-on-web-performance/#analyzing-the-resource-waterfall)."},u=a.createMessageInstanceIdFn(n,l);t.exports=class NetworkServerLatency extends i{static get meta(){return{id:"network-server-latency",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:u(l.title),description:u(l.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS];if(!(await s.request(n,t)).length)return{score:1,notApplicable:!0};const l=await c.request(n,t);let d=0;const m=[];for(const[e,t]of l.serverResponseTimeByOrigin.entries())e.startsWith("http")&&(d=Math.max(t,d),m.push({origin:e,
serverResponseTime:t}));m.sort(((e,t)=>t.serverResponseTime-e.serverResponseTime));const p=[{key:"origin",itemType:"text",text:u(a.UIStrings.columnURL)},{key:"serverResponseTime",itemType:"ms",granularity:1,text:u(a.UIStrings.columnTimeSpent)}],h=i.makeTableDetails(p,m);return{score:Math.max(1-d/500,0),numericValue:d,numericUnit:"millisecond",displayValue:u(a.UIStrings.ms,{timeInMs:d}),details:h}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/network-server-latency.js")},{"../computed/network-analysis.js":39,"../computed/network-records.js":40,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/no-unload-listeners":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("./../lib/i18n/i18n.js"),s={title:"Avoids `unload` event listeners",failureTitle:"Registers an `unload` listener",
description:"The `unload` event does not fire reliably and listening for it can prevent browser optimizations like the Back-Forward Cache. Consider using the `pagehide` or `visibilitychange` events instead. [Learn more](https://developers.google.com/web/updates/2018/07/page-lifecycle-api#the-unload-event)"},c=a.createMessageInstanceIdFn(n,s);t.exports=class NoUnloadListeners extends i{static get meta(){return{id:"no-unload-listeners",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["GlobalListeners","JsUsage"]}}static audit(e){const t=e.GlobalListeners.filter((e=>"unload"===e.type));if(!t.length)return{score:1};const n=[{key:"source",itemType:"source-location",text:c(a.UIStrings.columnSource)}],s=new Map;for(const[t,n]of Object.entries(e.JsUsage))for(const e of n)s.set(e.scriptId,t);const l=t.map((e=>{const t=s.get(e.scriptId);return t?{source:{type:"source-location",url:t,urlProvider:"network",line:e.lineNumber,column:e.columnNumber}}:{
source:{type:"url",value:"(unknown)"}}}));return{score:0,details:i.makeTableDetails(n,l)}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/no-unload-listeners.js")},{"./../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/non-composited-animations":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s={title:"Avoid non-composited animations",description:"Animations which are not composited can be janky and increase CLS. [Learn more](https://web.dev/non-composited-animations)",displayValue:"{itemCount, plural,\n  =1 {# animated element found}\n  other {# animated elements found}\n  }",unsupportedCSSProperty:"{propertyCount, plural,\n    =1 {Unsupported CSS Property: {properties}}\n    other {Unsupported CSS Properties: {properties}}\n  }",transformDependsBoxSize:"Transform-related property depends on box size",filterMayMovePixels:"Filter-related property may move pixels",
nonReplaceCompositeMode:'Effect has composite mode other than "replace"',incompatibleAnimations:"Target has another animation which is incompatible",unsupportedTimingParameters:"Effect has unsupported timing parameters"},c=a.createMessageInstanceIdFn(n,s),l=[{flag:8192,text:s.unsupportedCSSProperty},{flag:2048,text:s.transformDependsBoxSize},{flag:4096,text:s.filterMayMovePixels},{flag:16,text:s.nonReplaceCompositeMode},{flag:64,text:s.incompatibleAnimations},{flag:8,text:s.unsupportedTimingParameters}];function getActionableFailureReasons(e,t){return l.filter((t=>e&t.flag)).map((e=>e.text===s.unsupportedCSSProperty?c(e.text,{propertyCount:t.length,properties:t.join(", ")}):c(e.text)))}t.exports=class NonCompositedAnimations extends i{static get meta(){return{id:"non-composited-animations",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:c(s.title),description:c(s.description),requiredArtifacts:["TraceElements","HostUserAgent"]}}static async audit(e){
const t=e.HostUserAgent.match(/Chrome\/(\d+)/);if(!t||Number(t[1])<86)return{score:1,notApplicable:!0};const n=[];let l=!1;e.TraceElements.forEach((e=>{if("animation"!==e.traceEventType)return;const t=e.animations||[],a=new Map;for(const{name:e,failureReasonsMask:n,unsupportedProperties:i}of t){if(!n)continue;const t=getActionableFailureReasons(n,i||[]);for(const n of t){e&&(l=!0);const t=a.get(e)||new Set;t.add(n),a.set(e,t)}}if(!a.size)return;const s=[];for(const[e,t]of a)for(const n of t)s.push({failureReason:n,animation:e});n.push({node:i.makeNodeItem(e.node),subItems:{type:"subitems",items:s}})}));const u=[{key:"node",itemType:"node",subItemsHeading:{key:"failureReason",itemType:"text"},text:c(a.UIStrings.columnElement)}];l&&u.push({key:null,itemType:"text",subItemsHeading:{key:"animation",itemType:"text"},text:c(a.UIStrings.columnName)});const d=i.makeTableDetails(u,n);let m;return n.length>0&&(m=c(s.displayValue,{itemCount:n.length})),{score:0===n.length?1:0,
notApplicable:0===n.length,details:d,displayValue:m}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/non-composited-animations.js")},{"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/oopif-iframe-test-audit":[function(e,t,n){"use strict";t.exports={meta:{id:"oopif-iframe-test-audit",title:"IFrame Elements",failureTitle:"IFrame Elements",description:"Audit to force the inclusion of IFrameElements artifact",requiredArtifacts:["IFrameElements"]},audit:()=>({score:1})}},{}],"../audits/performance-budget":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../computed/resource-summary.js"),s=e("../computed/main-resource.js"),c=e("../config/budget.js"),l=e("../lib/i18n/i18n.js"),u={title:"Performance budget",description:"Keep the quantity and size of network requests under the targets set by the provided performance budget. [Learn more](https://developers.google.com/web/tools/lighthouse/audits/budgets).",
requestCountOverBudget:"{count, plural,\n    =1 {1 request}\n    other {# requests}\n   }"},d=l.createMessageInstanceIdFn(n,u);t.exports=class ResourceBudget extends i{static get meta(){return{id:"performance-budget",title:d(u.title),description:d(u.description),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","URL"]}}static getRowLabel(e){return{total:l.UIStrings.totalResourceType,document:l.UIStrings.documentResourceType,script:l.UIStrings.scriptResourceType,stylesheet:l.UIStrings.stylesheetResourceType,image:l.UIStrings.imageResourceType,media:l.UIStrings.mediaResourceType,font:l.UIStrings.fontResourceType,other:l.UIStrings.otherResourceType,"third-party":l.UIStrings.thirdPartyResourceType}[e]}static tableItems(e,t){return Object.keys(t).map((n=>{const i=d(this.getRowLabel(n)),a=t[n].count,s=t[n].transferSize;let c,l;if(e.resourceSizes){const t=e.resourceSizes.find((e=>e.resourceType===n))
;t&&s>1024*t.budget&&(c=s-1024*t.budget)}if(e.resourceCounts){const t=e.resourceCounts.find((e=>e.resourceType===n));if(t&&a>t.budget){const e=a-t.budget;l=d(u.requestCountOverBudget,{count:e})}}return{resourceType:n,label:i,requestCount:a,transferSize:s,countOverBudget:l,sizeOverBudget:c}})).filter((t=>!(!e.resourceSizes||!e.resourceSizes.some((e=>e.resourceType===t.resourceType)))||!(!e.resourceCounts||!e.resourceCounts.some((e=>e.resourceType===t.resourceType))))).sort(((e,t)=>(t.sizeOverBudget||0)-(e.sizeOverBudget||0)))}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],u={devtoolsLog:n,URL:e.URL,budgets:t.settings.budgets},m=await a.request(u,t),p=await s.request({URL:e.URL,devtoolsLog:n},t),h=c.getMatchingBudget(t.settings.budgets,p.url);if(!h)return{score:0,notApplicable:!0};const f=[{key:"label",itemType:"text",text:d(l.UIStrings.columnResourceType)},{key:"requestCount",itemType:"numeric",text:d(l.UIStrings.columnRequests)},{key:"transferSize",itemType:"bytes",
text:d(l.UIStrings.columnTransferSize)},{key:"countOverBudget",itemType:"text",text:""},{key:"sizeOverBudget",itemType:"bytes",text:d(l.UIStrings.columnOverBudget)}];return{details:i.makeTableDetails(f,this.tableItems(h,m)),score:1}}},t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/performance-budget.js")},{"../computed/main-resource.js":14,"../computed/resource-summary.js":44,"../config/budget.js":52,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/predictive-perf":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../computed/metrics/lantern-first-contentful-paint.js"),c=e("../computed/metrics/lantern-first-meaningful-paint.js"),l=e("../computed/metrics/lantern-interactive.js"),u=e("../computed/metrics/lantern-speed-index.js"),d=e("../computed/metrics/lantern-largest-contentful-paint.js"),m=a.createMessageInstanceIdFn(n,{});t.exports=class PredictivePerf extends i{static get meta(){return{
id:"predictive-perf",title:"Predicted Performance (beta)",description:"Predicted performance evaluates how your site will perform under a cellular connection on a mobile device.",scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext"]}}static async audit(e,t){const n=e.GatherContext,p={trace:e.traces[i.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[i.DEFAULT_PASS],gatherContext:n,settings:{}},h=await s.request(p,t),f=await c.request(p,t),g=await l.request(p,t),y=await u.request(p,t),b=await d.request(p,t),v={roughEstimateOfFCP:h.timing,optimisticFCP:h.optimisticEstimate.timeInMs,pessimisticFCP:h.pessimisticEstimate.timeInMs,roughEstimateOfFMP:f.timing,optimisticFMP:f.optimisticEstimate.timeInMs,pessimisticFMP:f.pessimisticEstimate.timeInMs,roughEstimateOfTTI:g.timing,optimisticTTI:g.optimisticEstimate.timeInMs,pessimisticTTI:g.pessimisticEstimate.timeInMs,roughEstimateOfSI:y.timing,
optimisticSI:y.optimisticEstimate.timeInMs,pessimisticSI:y.pessimisticEstimate.timeInMs,roughEstimateOfLCP:b.timing,optimisticLCP:b.optimisticEstimate.timeInMs,pessimisticLCP:b.pessimisticEstimate.timeInMs};return{score:i.computeLogNormalScore({p10:3651,median:1e4},v.roughEstimateOfTTI),numericValue:v.roughEstimateOfTTI,numericUnit:"millisecond",displayValue:m(a.UIStrings.ms,{timeInMs:v.roughEstimateOfTTI}),details:{type:"debugdata",items:[v]}}}}}).call(this)}).call(this,"/lighthouse-core/audits/predictive-perf.js")},{"../computed/metrics/lantern-first-contentful-paint.js":22,"../computed/metrics/lantern-first-meaningful-paint.js":23,"../computed/metrics/lantern-interactive.js":24,"../computed/metrics/lantern-largest-contentful-paint.js":25,"../computed/metrics/lantern-speed-index.js":28,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/preload-fonts":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./audit.js"),a=e("./../lib/i18n/i18n.js"),s=e("./../audits/font-display.js"),c=/^(optional)$/,l=e("../computed/network-records.js"),u={title:"Fonts with `font-display: optional` are preloaded",failureTitle:"Fonts with `font-display: optional` are not preloaded",description:"Preload `optional` fonts so first-time visitors may use them. [Learn more](https://web.dev/preload-optional-fonts/)"},d=a.createMessageInstanceIdFn(n,u);class PreloadFontsAudit extends i{static get meta(){return{id:"preload-fonts",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),requiredArtifacts:["devtoolsLogs","URL","CSSUsage"]}}static getURLsAttemptedToPreload(e){const t=e.filter((e=>"Font"===e.resourceType)).filter((e=>e.isLinkPreload)).map((e=>e.url));return new Set(t)}static async audit_(e,t){
const n=e.devtoolsLogs[this.DEFAULT_PASS],u=await l.request(n,t),m=s.findFontDisplayDeclarations(e,c).passingURLs,p=PreloadFontsAudit.getURLsAttemptedToPreload(u),h=Array.from(m).filter((e=>!p.has(e))).map((e=>({url:e}))),f=[{key:"url",itemType:"url",text:d(a.UIStrings.columnURL)}];return{score:h.length>0?0:1,details:i.makeTableDetails(f,h),notApplicable:0===m.size}}static async audit(){return{score:1,notApplicable:!0}}}t.exports=PreloadFontsAudit,t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/preload-fonts.js")},{"../computed/network-records.js":40,"./../audits/font-display.js":"../audits/font-display","./../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/preload-lcp-image":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../lib/network-request.js"),c=e("../computed/main-resource.js"),l=e("../computed/metrics/lantern-largest-contentful-paint.js"),u=e("../computed/load-simulator.js"),d=e("./byte-efficiency/byte-efficiency-audit.js"),m={title:"Preload Largest Contentful Paint image",description:"Preload the image used by the LCP element in order to improve your LCP time. [Learn more](https://web.dev/optimize-lcp/#preload-important-resources)."},p=a.createMessageInstanceIdFn(n,m);class PreloadLCPImageAudit extends i{static get meta(){return{id:"preload-lcp-image",title:p(m.title),description:p(m.description),supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","GatherContext","URL","TraceElements","ImageElements"],scoreDisplayMode:i.SCORING_MODES.NUMERIC}}static shouldPreloadRequest(e,t,n){const i=t.redirects?t.redirects.length:0;return!e.isLinkPreload&&(!s.isNonNetworkRequest(e)&&(!(n.length<=i)&&e.frameId===t.frameId))}
static findLCPNode(e,t){let n,i;return e.traverse(((e,a)=>{"network"===e.type&&e.record.url===t&&(n=e,i=a.slice(1).filter((e=>"network"===e.type)))})),{lcpNode:n,path:i}}static getLCPNodeToPreload(e,t,n,i){if(!n)return;const a=i.find((e=>e.node.devtoolsNodePath===n.node.devtoolsNodePath));if(!a)return;const s=a.src,{lcpNode:c,path:l}=PreloadLCPImageAudit.findLCPNode(t,s);if(!c||!l)return;return PreloadLCPImageAudit.shouldPreloadRequest(c.record,e,l)?c:void 0}static computeWasteWithGraph(e,t,n){if(!e)return{wastedMs:0,results:[]};const i=t.cloneWithRelationships(),a=new Set;for(const t of e.getDependencies())a.add(t.id);let s=null,c=null;for(const{node:t}of i.traverseGenerator())"network"===t.type&&(t.isMainDocument()?c=t:t.id===e.id&&(s=t));if(!c)throw new Error("Could not find main document node");if(!s)throw new Error("Could not find the LCP node");s.removeAllDependencies(),s.addDependency(c);const l=n.simulate(t,{flexibleOrdering:!0}),u=n.simulate(i,{flexibleOrdering:!0
}),d=l.nodeTimings.get(e);if(!d)throw new Error("Impossible - node timings should never be undefined");const m=u.nodeTimings.get(s);if(!m)throw new Error("Impossible - node timings should never be undefined");const p=Array.from(u.nodeTimings.keys()).reduce(((e,t)=>e.set(t.id,t)),new Map);let h=0;for(const e of Array.from(a)){const t=p.get(e);if(!t)throw new Error("Impossible - node should never be undefined");const n=u.nodeTimings.get(t),i=n&&n.endTime||0;h=Math.max(h,i)}const f=d.endTime-Math.max(m.endTime,h);return{wastedMs:f,results:[{url:e.record.url,wastedMs:f}]}}static async audit_(e,t){const n=e.GatherContext,s=e.traces[PreloadLCPImageAudit.DEFAULT_PASS],m=e.devtoolsLogs[PreloadLCPImageAudit.DEFAULT_PASS],h=e.URL,f={trace:s,devtoolsLog:m,gatherContext:n,settings:t.settings},g=e.TraceElements.find((e=>"largest-contentful-paint"===e.traceEventType)),[y,b,v]=await Promise.all([c.request({devtoolsLog:m,URL:h},t),l.request(f,t),u.request({devtoolsLog:m,settings:t.settings
},t)]),w=b.pessimisticGraph,S=PreloadLCPImageAudit.getLCPNodeToPreload(y,w,g,e.ImageElements),{results:T,wastedMs:E}=PreloadLCPImageAudit.computeWasteWithGraph(S,w,v),_=[{key:"url",valueType:"thumbnail",label:""},{key:"url",valueType:"url",label:p(a.UIStrings.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:p(a.UIStrings.columnWastedMs)}],x=i.makeOpportunityDetails(_,T,E);return{score:d.scoreForWastedMs(E),numericValue:E,numericUnit:"millisecond",displayValue:E?p(a.UIStrings.displayValueMsSavings,{wastedMs:E}):"",details:x}}static async audit(){return{score:1,notApplicable:!0,details:i.makeOpportunityDetails([],[],0)}}}t.exports=PreloadLCPImageAudit,t.exports.UIStrings=m}).call(this)}).call(this,"/lighthouse-core/audits/preload-lcp-image.js")},{"../computed/load-simulator.js":13,"../computed/main-resource.js":14,"../computed/metrics/lantern-largest-contentful-paint.js":25,"../lib/i18n/i18n.js":98,"../lib/network-request.js":109,"./audit.js":3,
"./byte-efficiency/byte-efficiency-audit.js":4}],"../audits/redirects-http":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../lib/url-shim.js"),c={title:"Redirects HTTP traffic to HTTPS",failureTitle:"Does not redirect HTTP traffic to HTTPS",description:"If you've already set up HTTPS, make sure that you redirect all HTTP traffic to HTTPS in order to enable secure web features for all your users. [Learn more](https://web.dev/redirects-http/)."},l=a.createMessageInstanceIdFn(n,c);t.exports=class RedirectsHTTP extends i{static get meta(){return{id:"redirects-http",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["HTTPRedirect","URL"]}}static audit(e){const t=new s(e.URL.finalUrl);return s.isLikeLocalhost(t.hostname)?{score:1,notApplicable:!0}:{score:Number(e.HTTPRedirect.value)}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/redirects-http.js")},{
"../lib/i18n/i18n.js":98,"../lib/url-shim.js":"url","./audit.js":3}],"../audits/redirects":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("./byte-efficiency/byte-efficiency-audit.js"),s=e("../lib/i18n/i18n.js"),c=e("../computed/processed-trace.js"),l=e("../computed/network-records.js"),u=e("../computed/main-resource.js"),d=e("../computed/metrics/lantern-interactive.js"),m={title:"Avoid multiple page redirects",description:"Redirects introduce additional delays before the page can be loaded. [Learn more](https://web.dev/redirects/)."},p=s.createMessageInstanceIdFn(n,m);class Redirects extends i{static get meta(){return{id:"redirects",title:p(m.title),description:p(m.description),scoreDisplayMode:i.SCORING_MODES.NUMERIC,supportedModes:["navigation"],requiredArtifacts:["URL","GatherContext","devtoolsLogs","traces"]}}static getDocumentRequestChain(e,t,n){const i=[];for(const e of n.processEvents){if("navigationStart"!==e.name)continue
;const n=e.args.data||{};if(!n.documentLoaderURL||!n.isLoadingMainFrame)continue;let a=t.find((e=>e.url===n.documentLoaderURL));for(;a;)i.push(a),a=a.redirectDestination}return i.length?i:(e.redirects||[]).concat(e)}static async audit(e,t){const n=t.settings,m=e.traces[i.DEFAULT_PASS],h=e.devtoolsLogs[i.DEFAULT_PASS],f=e.GatherContext,g=await c.request(m,t),y=await l.request(h,t),b=await u.request({URL:e.URL,devtoolsLog:h},t),v={trace:m,devtoolsLog:h,gatherContext:f,settings:n},w=await d.request(v,t),S=new Map;for(const[e,t]of w.pessimisticEstimate.nodeTimings.entries())"network"===e.type&&S.set(e.record.url,t);const T=Redirects.getDocumentRequestChain(b,y,g);let E=0;const _=[];for(let e=0;e<T.length&&!(T.length<2);e++){const t=T[e],i=T[e+1]||t,a=S.get(t.url),s=S.get(i.url);if(!a||!s)throw new Error("Could not find redirects in graph");const c=s.startTime-a.startTime,l=i.startTime-t.startTime,u="simulate"===n.throttlingMethod?c:1e3*l;E+=u,_.push({url:t.url,wastedMs:u})}const x=[{
key:"url",valueType:"url",label:p(s.UIStrings.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:p(s.UIStrings.columnTimeSpent)}],A=i.makeOpportunityDetails(x,_,E);return{score:T.length<=2?1:a.scoreForWastedMs(E),numericValue:E,numericUnit:"millisecond",displayValue:E?p(s.UIStrings.displayValueMsSavings,{wastedMs:E}):"",details:A}}}t.exports=Redirects,t.exports.UIStrings=m}).call(this)}).call(this,"/lighthouse-core/audits/redirects.js")},{"../computed/main-resource.js":14,"../computed/metrics/lantern-interactive.js":24,"../computed/network-records.js":40,"../computed/processed-trace.js":43,"../lib/i18n/i18n.js":98,"./audit.js":3,"./byte-efficiency/byte-efficiency-audit.js":4}],"../audits/resource-summary":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../computed/resource-summary.js"),s=e("../lib/i18n/i18n.js"),c={title:"Keep request counts low and transfer sizes small",
description:"To set budgets for the quantity and size of page resources, add a budget.json file. [Learn more](https://web.dev/use-lighthouse-for-performance-budgets/).",displayValue:"{requestCount, plural, =1 {1 request • {byteCount, number, bytes} KiB} other {# requests • {byteCount, number, bytes} KiB}}"},l=s.createMessageInstanceIdFn(n,c);t.exports=class ResourceSummary extends i{static get meta(){return{id:"resource-summary",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],u=await a.request({devtoolsLog:n,URL:e.URL,budgets:t.settings.budgets},t),d=[{key:"label",itemType:"text",text:l(s.UIStrings.columnResourceType)},{key:"requestCount",itemType:"numeric",text:l(s.UIStrings.columnRequests)},{key:"transferSize",itemType:"bytes",text:l(s.UIStrings.columnTransferSize)}],m={total:l(s.UIStrings.totalResourceType),
document:l(s.UIStrings.documentResourceType),script:l(s.UIStrings.scriptResourceType),stylesheet:l(s.UIStrings.stylesheetResourceType),image:l(s.UIStrings.imageResourceType),media:l(s.UIStrings.mediaResourceType),font:l(s.UIStrings.fontResourceType),other:l(s.UIStrings.otherResourceType),"third-party":l(s.UIStrings.thirdPartyResourceType)},p=Object.keys(u).map((e=>({resourceType:e,label:m[e],requestCount:u[e].count,transferSize:u[e].transferSize}))),h=p.find((e=>"third-party"===e.resourceType))||[],f=p.filter((e=>"third-party"!==e.resourceType)).sort(((e,t)=>t.transferSize-e.transferSize)).concat(h);return{details:i.makeTableDetails(d,f),score:1,displayValue:l(c.displayValue,{requestCount:u.total.count,byteCount:u.total.transferSize})}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/resource-summary.js")},{"../computed/resource-summary.js":44,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/screenshot-thumbnails":[function(e,t,n){"use strict"
;const i=e("./audit.js"),a=e("../lib/lh-error.js"),s=e("jpeg-js"),c=e("../computed/speedline.js");class ScreenshotThumbnails extends i{static get meta(){return{id:"screenshot-thumbnails",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Screenshot Thumbnails",description:"This is what the load of your site looked like.",requiredArtifacts:["traces","GatherContext"]}}static scaleImageToThumbnail(e){const t=120,n=e.width/t,i=Math.floor(e.height/n),a=new Uint8Array(t*i*4);for(let s=0;s<t;s++)for(let c=0;c<i;c++){const i=Math.floor(s*n),l=4*(Math.floor(c*n)*e.width+i),u=4*(c*t+s);a[u]=e.data[l],a[u+1]=e.data[l+1],a[u+2]=e.data[l+2],a[u+3]=e.data[l+3]}return{width:t,height:i,data:a}}static async _audit(e,t){const n=e.traces[i.DEFAULT_PASS],l=new Map,u=await c.request(n,t),d=t.options.minimumTimelineDuration||3e3,m=[],p=u.frames.filter((e=>!e.isProgressInterpolated())),h=u.complete||Math.max(...u.frames.map((e=>e.getTimeStamp()-u.beginning))),f=Math.max(h,d)
;if(!p.length||!Number.isFinite(f))throw new a(a.errors.INVALID_SPEEDLINE);for(let e=1;e<=10;e++){const t=u.beginning+f*e/10;let n,i=null;10===e?i=p[p.length-1]:p.forEach((e=>{e.getTimeStamp()<=t&&(i=e)}));const a=l.get(i);if(a)n=a;else{const e=i.getParsedImage(),t=ScreenshotThumbnails.scaleImageToThumbnail(e);n=s.encode(t,90).data.toString("base64"),l.set(i,n)}m.push({timing:Math.round(t-u.beginning),timestamp:1e3*t,data:"data:image/jpeg;base64,"+n})}return{score:1,details:{type:"filmstrip",scale:f,items:m}}}static async audit(e,t){try{return await this._audit(e,t)}catch(t){if(new Set([a.errors.NO_SCREENSHOTS.code,a.errors.SPEEDINDEX_OF_ZERO.code,a.errors.NO_SPEEDLINE_FRAMES.code,a.errors.INVALID_SPEEDLINE.code]).has(t.code)&&"timespan"===e.GatherContext.gatherMode)return{notApplicable:!0,score:1};throw t}}}t.exports=ScreenshotThumbnails},{"../computed/speedline.js":46,"../lib/lh-error.js":103,"./audit.js":3,"jpeg-js":185}],"../audits/script-treemap-data":[function(e,t,n){"use strict"
;const i=e("./audit.js"),a=e("../computed/js-bundles.js"),s=e("../computed/unused-javascript-summary.js"),c=e("../computed/module-duplication.js");class ScriptTreemapDataAudit extends i{static get meta(){return{id:"script-treemap-data",scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,title:"Script Treemap Data",description:"Used for treemap app",requiredArtifacts:["traces","devtoolsLogs","SourceMaps","ScriptElements","JsUsage","URL"]}}static makeScriptNode(e,t,n){function newNode(e){return{name:e,resourceBytes:0}}const i=newNode(t);function addAllNodesInSourcePath(e,n){let a=i;i.resourceBytes+=n.resourceBytes,n.unusedBytes&&(i.unusedBytes=(i.unusedBytes||0)+n.unusedBytes);const s=e.replace(t,"").split(/\/+/);s.forEach(((e,t)=>{if(0===e.length)return;const i=t===s.length-1;let c=a.children&&a.children.find((t=>t.name===e));c||(c=newNode(e),a.children=a.children||[],a.children.push(c)),a=c,a.resourceBytes+=n.resourceBytes,n.unusedBytes&&(a.unusedBytes=(a.unusedBytes||0)+n.unusedBytes),
i&&void 0!==n.duplicatedNormalizedModuleName&&(a.duplicatedNormalizedModuleName=n.duplicatedNormalizedModuleName)}))}for(const[e,t]of Object.entries(n))addAllNodesInSourcePath(e,t);if(function collapseAll(e){for(;e.children&&1===e.children.length;)e.name+="/"+e.children[0].name,e.children=e.children[0].children;if(e.children)for(const t of e.children)collapseAll(t)}(i),!i.name)return{...i,name:e,children:i.children};const a={...i};return a.name=e,a.children=[i],a}static async makeNodes(e,t){const n=[];let i=0;for(const t of e.ScriptElements)t.src||(i+=(t.content||"").length);if(i){const t=e.URL.finalUrl;n.push({name:t,resourceBytes:i})}const l=await a.request(e,t),u=await c.request(e,t);for(const i of e.ScriptElements){if(!i.src)continue;const a=i.src,d=l.find((e=>i.src===e.script.src)),m=e.JsUsage[i.src]||[];if(!d&&0===m.length){n.push({name:a,resourceBytes:i.src.length});continue}const p=await s.request({url:i.src,scriptCoverages:m,bundle:d},t);let h
;if(d&&!("errorMessage"in d.sizes)){const e={};for(const t of Object.keys(d.sizes.files)){const n={resourceBytes:d.sizes.files[t]};p.sourcesWastedBytes&&(n.unusedBytes=p.sourcesWastedBytes[t]);let i=t;d.rawMap.sourceRoot&&t.startsWith(d.rawMap.sourceRoot)&&(i=t.replace(d.rawMap.sourceRoot,""));const a=c.normalizeSource(i);u.has(a)&&(n.duplicatedNormalizedModuleName=a),e[t]=n}if(d.sizes.unmappedBytes){const t={resourceBytes:d.sizes.unmappedBytes};p.sourcesWastedBytes&&(t.unusedBytes=p.sourcesWastedBytes["(unmapped)"]),e["(unmapped)"]=t}h=this.makeScriptNode(i.src,d.rawMap.sourceRoot||"",e)}else h={name:a,resourceBytes:p.totalBytes,unusedBytes:p.wastedBytes};n.push(h)}return n}static async audit(e,t){return{score:1,details:{type:"treemap-data",nodes:await ScriptTreemapDataAudit.makeNodes(e,t)}}}}t.exports=ScriptTreemapDataAudit},{"../computed/js-bundles.js":12,"../computed/module-duplication.js":38,"../computed/unused-javascript-summary.js":49,"./audit.js":3}],
"../audits/seo/canonical":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/url-shim.js"),s=e("../../computed/main-resource.js"),c=e("../../lib/i18n/i18n.js"),l={title:"Document has a valid `rel=canonical`",failureTitle:"Document does not have a valid `rel=canonical`",description:"Canonical links suggest which URL to show in search results. [Learn more](https://web.dev/canonical/).",explanationConflict:"Multiple conflicting URLs ({urlList})",explanationInvalid:"Invalid URL ({url})",explanationRelative:"Is not an absolute URL ({url})",explanationPointsElsewhere:"Points to another `hreflang` location ({url})",explanationDifferentDomain:"Points to a different domain ({url})",explanationRoot:"Points to the domain's root URL (the homepage), instead of an equivalent page of content"},u=c.createMessageInstanceIdFn(n,l);class Canonical extends i{static get meta(){return{id:"canonical",title:u(l.title),failureTitle:u(l.failureTitle),
description:u(l.description),supportedModes:["navigation"],requiredArtifacts:["LinkElements","URL","devtoolsLogs"]}}static collectCanonicalURLs(e){const t=new Set,n=new Set;let i,s;for(const c of e)if("body"!==c.source)if("canonical"===c.rel){if(!c.hrefRaw)continue;c.href?a.isValid(c.hrefRaw)?t.add(c.href):s=c:i=c}else"alternate"===c.rel&&c.href&&c.hreflang&&n.add(c.href);return{uniqueCanonicalURLs:t,hreflangURLs:n,invalidCanonicalLink:i,relativeCanonicallink:s}}static findInvalidCanonicalURLReason(e){const{uniqueCanonicalURLs:t,invalidCanonicalLink:n,relativeCanonicallink:i}=e;if(n)return{score:0,explanation:u(l.explanationInvalid,{url:n.hrefRaw})};if(i)return{score:0,explanation:u(l.explanationRelative,{url:i.hrefRaw})};const a=Array.from(t);return 0===a.length?{score:1,notApplicable:!0}:a.length>1?{score:0,explanation:u(l.explanationConflict,{urlList:a.join(", ")})}:void 0}static findCommonCanonicalURLMistakes(e,t,n){const{hreflangURLs:i}=e
;return i.has(n.href)&&i.has(t.href)&&n.href!==t.href?{score:0,explanation:u(l.explanationPointsElsewhere,{url:n.href})}:a.rootDomainsMatch(t,n)?t.origin===n.origin&&"/"===t.pathname&&"/"!==n.pathname?{score:0,explanation:u(l.explanationRoot)}:void 0:{score:0,explanation:u(l.explanationDifferentDomain,{url:t.href})}}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],c=await s.request({devtoolsLog:n,URL:e.URL},t),l=new a(c.url),u=Canonical.collectCanonicalURLs(e.LinkElements),d=Canonical.findInvalidCanonicalURLReason(u);if(d)return d;const m=new a([...u.uniqueCanonicalURLs][0]),p=Canonical.findCommonCanonicalURLMistakes(u,m,l);return p||{score:1}}}t.exports=Canonical,t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/seo/canonical.js")},{"../../computed/main-resource.js":14,"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","../audit.js":3}],"../audits/seo/crawlable-anchors":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Links are crawlable",failureTitle:"Links are not crawlable",description:"Search engines may use `href` attributes on links to crawl websites. Ensure that the `href` attribute of anchor elements links to an appropriate destination, so more pages of the site can be discovered. [Learn More](https://support.google.com/webmasters/answer/9112205)",columnFailingLink:"Uncrawlable Link"},c=a.createMessageInstanceIdFn(n,s);t.exports=class CrawlableAnchors extends i{static get meta(){return{id:"crawlable-anchors",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["AnchorElements"]}}static audit({AnchorElements:e}){const t=e.filter((({rawHref:e,listeners:t=[],onclick:n="",name:i="",role:a=""})=>{if(n=n.replace(/\s/g,""),e=e.replace(/\s/g,""),i=i.trim(),(a=a.trim()).length>0)return;if(e.startsWith("mailto:"))return;if(e.startsWith("file:"))return!0;if(/window\.location=/.test(n))return!0
;if(/window\.open\(/.test(n))return!0;return t.some((({type:e})=>"click"===e))||i.length>0?void 0:""===e||(!!/javascript:void(\(|)0(\)|)/.test(e)||void 0)})),n=[{key:"node",itemType:"node",text:c(s.columnFailingLink)}],a=t.map((e=>({node:i.makeNodeItem(e.node)})));return{score:Number(0===t.length),details:i.makeTableDetails(n,a)}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/seo/crawlable-anchors.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/seo/font-size":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../../lib/i18n/i18n.js"),a=e("../audit.js"),s=e("../../computed/viewport-meta.js"),c={title:"Document uses legible font sizes",failureTitle:"Document doesn't use legible font sizes",description:"Font sizes less than 12px are too small to be legible and require mobile visitors to “pinch to zoom” in order to read. Strive to have >60% of page text ≥12px. [Learn more](https://web.dev/font-size/).",
displayValue:"{decimalProportion, number, extendedPercent} legible text",explanationViewport:"Text is illegible because there's no viewport meta tag optimized for mobile screens.",additionalIllegibleText:"Add'l illegible text",legibleText:"Legible text",columnSelector:"Selector",columnPercentPageText:"% of Page Text",columnFontSize:"Font Size"},l=i.createMessageInstanceIdFn(n,c);function getSelector(e){const t=function getAttributeMap(e=[]){const t=new Map;for(let n=0;n<e.length;n+=2){const i=e[n],a=e[n+1];if(!i||!a)continue;const s=a.trim();s&&t.set(i.toLowerCase(),s)}return t}(e.attributes);if(t.has("id"))return"#"+t.get("id");{const e=t.get("class");if(e)return"."+e.split(/\s+/).join(".")}return e.nodeName.toLowerCase()}function nodeToTableNode(e){const t=(e.attributes||[]).map(((e,t)=>t%2==0?" "+e:`="${e}"`)).join("");return{type:"node",selector:e.parentNode?getSelector(e.parentNode):"",snippet:`<${e.nodeName.toLowerCase()}${t}>`}}t.exports=class FontSize extends a{
static get meta(){return{id:"font-size",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["FontSize","URL","MetaElements"]}}static async audit(e,t){if("desktop"===t.settings.formFactor)return{score:1,notApplicable:!0};if(!(await s.request(e.MetaElements,t)).isMobileOptimized)return{score:0,explanation:l(c.explanationViewport)};const{analyzedFailingNodesData:n,analyzedFailingTextLength:u,failingTextLength:d,totalTextLength:m}=e.FontSize;if(0===m)return{score:1};const p=function getUniqueFailingRules(e){const t=new Map;return e.forEach((e=>{const{nodeId:n,cssRule:i,fontSize:a,textLength:s,parentNode:c}=e,l=function getFontArtifactId(e,t){if(e&&"Regular"===e.type){const t=e.range?e.range.startLine:0,n=e.range?e.range.startColumn:0;return`${e.styleSheetId}@${t}:${n}`}return"node_"+t}(i,n),u=t.get(l);u?u.textLength+=s:t.set(l,{nodeId:n,parentNode:c,cssRule:i,fontSize:a,textLength:s})})),[...t.values()]}(n),h=(m-d)/m*100,f=e.URL.finalUrl,g=[{
key:"source",itemType:"source-location",text:l(i.UIStrings.columnSource)},{key:"selector",itemType:"code",text:l(c.columnSelector)},{key:"coverage",itemType:"text",text:l(c.columnPercentPageText)},{key:"fontSize",itemType:"text",text:l(c.columnFontSize)}],y=p.sort(((e,t)=>t.textLength-e.textLength)).map((({cssRule:e,textLength:t,fontSize:n,parentNode:i})=>{const a=t/m*100,s=function findStyleRuleSource(e,t,n){if(!t||"Attributes"===t.type||"Inline"===t.type)return{source:{type:"url",value:e},selector:nodeToTableNode(n)};if(t.parentRule&&"user-agent"===t.parentRule.origin)return{source:{type:"code",value:"User Agent Stylesheet"},selector:t.parentRule.selectors.map((e=>e.text)).join(", ")};let i="";t.parentRule&&(i=t.parentRule.selectors.map((e=>e.text)).join(", "));if(t.stylesheet&&!t.stylesheet.sourceURL)return{source:{type:"code",value:"dynamic"},selector:i};if(t.stylesheet&&t.range){const{range:e,stylesheet:n}=t,a=n.hasSourceURL?"comment":"network";let s=e.startLine,c=e.startColumn
;return n.isInline&&"comment"!==a&&(s+=n.startLine,0===e.startLine&&(c+=n.startColumn)),{source:{type:"source-location",url:n.sourceURL,urlProvider:a,line:s,column:c},selector:i}}return{selector:i,source:{type:"code",value:"Unknown"}}}(f,e,i);return{source:s.source,selector:s.selector,coverage:a.toFixed(2)+"%",fontSize:n+"px"}}));if(u<d){const e=(d-u)/m*100;y.push({source:{type:"code",value:l(c.additionalIllegibleText)},selector:"",coverage:e.toFixed(2)+"%",fontSize:"< 12px"})}h>0&&y.push({source:{type:"code",value:l(c.legibleText)},selector:"",coverage:h.toFixed(2)+"%",fontSize:"≥ 12px"});const b=l(c.displayValue,{decimalProportion:h/100}),v=a.makeTableDetails(g,y);return{score:Number(h>=60),details:v,displayValue:b}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/seo/font-size.js")},{"../../computed/viewport-meta.js":51,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/seo/hreflang":[function(require,module,exports){(function(__filename){(function(){
"use strict";const Audit=require("../audit.js"),i18n=require("../../lib/i18n/i18n.js"),axeLibSource=require("../../lib/axe.js").source,VALID_LANGS=importValidLangs(),NO_LANGUAGE="x-default",UIStrings={title:"Document has a valid `hreflang`",failureTitle:"Document doesn't have a valid `hreflang`",description:"hreflang links tell search engines what version of a page they should list in search results for a given language or region. [Learn more](https://web.dev/hreflang/).",unexpectedLanguage:"Unexpected language code",notFullyQualified:"Relative href value"},str_=i18n.createMessageInstanceIdFn(__filename,UIStrings);function importValidLangs(){const window={getComputedStyle:()=>{}};return eval(axeLibSource),window.axe.utils.validLangs()}function isFullyQualified(e){return e.startsWith("http:")||e.startsWith("https:")}function isExpectedLanguageCode(e){if(e.toLowerCase()===NO_LANGUAGE)return!0;const[t]=e.split("-");return VALID_LANGS.includes(t.toLowerCase())}class Hreflang extends Audit{
static get meta(){return{id:"hreflang",title:str_(UIStrings.title),failureTitle:str_(UIStrings.failureTitle),description:str_(UIStrings.description),supportedModes:["navigation"],requiredArtifacts:["LinkElements","URL"]}}static audit({LinkElements:e}){const t=[],n=e.filter((e=>{const t="alternate"===e.rel,n=e.hreflang,i="body"===e.source;return t&&n&&!i}));for(const e of n){const n=[];let i;isExpectedLanguageCode(e.hreflang)||n.push(str_(UIStrings.unexpectedLanguage)),isFullyQualified(e.hrefRaw.toLowerCase())||n.push(str_(UIStrings.notFullyQualified)),"head"===e.source?i=e.node?{...Audit.makeNodeItem(e.node),snippet:`<link rel="alternate" hreflang="${e.hreflang}" href="${e.hrefRaw}" />`}:{type:"node",snippet:`<link rel="alternate" hreflang="${e.hreflang}" href="${e.hrefRaw}" />`}:"headers"===e.source&&(i=`Link: <${e.hrefRaw}>; rel="alternate"; hreflang="${e.hreflang}"`),i&&n.length&&t.push({source:i,subItems:{type:"subitems",items:n.map((e=>({reason:e})))}})}
const i=Audit.makeTableDetails([{key:"source",itemType:"code",subItemsHeading:{key:"reason",itemType:"text"},text:""}],t);return{score:Number(0===t.length),details:i}}}module.exports=Hreflang,module.exports.UIStrings=UIStrings}).call(this)}).call(this,"/lighthouse-core/audits/seo/hreflang.js")},{"../../lib/axe.js":83,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/seo/http-status-code":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../computed/network-records.js"),s=e("../../lib/i18n/i18n.js"),c=e("../../lib/dependency-graph/simulator/network-analyzer.js"),l={title:"Page has successful HTTP status code",failureTitle:"Page has unsuccessful HTTP status code",description:"Pages with unsuccessful HTTP status codes may not be indexed properly. [Learn more](https://web.dev/http-status-code/)."},u=s.createMessageInstanceIdFn(n,l);t.exports=class HTTPStatusCode extends i{static get meta(){return{id:"http-status-code",title:u(l.title),
failureTitle:u(l.failureTitle),description:u(l.description),requiredArtifacts:["devtoolsLogs","URL","GatherContext"],supportedModes:["navigation"]}}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],s=e.URL,l=await a.request(n,t),u=c.findMainDocument(l,s.finalUrl).statusCode;return u>=400&&u<=599?{score:0,displayValue:""+u}:{score:1}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/seo/http-status-code.js")},{"../../computed/network-records.js":40,"../../lib/dependency-graph/simulator/network-analyzer.js":93,"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/seo/is-crawlable":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("robots-parser"),s=e("../../lib/url-shim.js"),c=e("../../computed/main-resource.js"),l=new Set(["noindex","none"]),u="unavailable_after",d=e("../../lib/i18n/i18n.js"),m={title:"Page isn’t blocked from indexing",failureTitle:"Page is blocked from indexing",
description:"Search engines are unable to include your pages in search results if they don't have permission to crawl them. [Learn more](https://web.dev/is-crawable/)."},p=d.createMessageInstanceIdFn(n,m);function hasBlockingDirective(e){return e.split(",").map((e=>e.toLowerCase().trim())).some((e=>l.has(e)||function isUnavailable(e){const t=e.split(":");if(t.length<=1||t[0]!==u)return!1;const n=Date.parse(t.slice(1).join(":"));return!isNaN(n)&&n<Date.now()}(e)))}t.exports=class IsCrawlable extends i{static get meta(){return{id:"is-crawlable",title:p(m.title),failureTitle:p(m.failureTitle),description:p(m.description),supportedModes:["navigation"],requiredArtifacts:["MetaElements","RobotsTxt","URL","devtoolsLogs"]}}static audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS],l=e.MetaElements.find((e=>"robots"===e.name));return c.request({devtoolsLog:n,URL:e.URL},t).then((t=>{const n=[];if(l){const e=l.content||"";hasBlockingDirective(e)&&n.push({source:{...i.makeNodeItem(l.node),
snippet:`<meta name="robots" content="${e}" />`}})}if(t.responseHeaders&&t.responseHeaders.filter((e=>"x-robots-tag"===e.name.toLowerCase()&&!function hasUserAgent(e){const t=e.match(/^([^,:]+):/);return!!t&&t[1].toLowerCase()!==u}(e.value)&&hasBlockingDirective(e.value))).forEach((e=>n.push({source:`${e.name}: ${e.value}`}))),e.RobotsTxt.content){const i=new s("/robots.txt",t.url),c=a(i.href,e.RobotsTxt.content);if(!c.isAllowed(t.url)){const e=c.getMatchingLineNumber(t.url)||1;n.push({source:{type:"source-location",url:i.href,urlProvider:"network",line:e-1,column:0}})}}const c=i.makeTableDetails([{key:"source",itemType:"code",text:"Blocking Directive Source"}],n);return{score:Number(0===n.length),details:c}}))}},t.exports.UIStrings=m}).call(this)}).call(this,"/lighthouse-core/audits/seo/is-crawlable.js")},{"../../computed/main-resource.js":14,"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","../audit.js":3,"robots-parser":228}],"../audits/seo/link-text":[function(e,t,n){
(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/url-shim.js"),s=new Set(["click here","click this","go","here","information","learn more","more","more info","more information","right here","read more","see more","start","this","ここをクリック","こちらをクリック","リンク","続きを読む","続く","全文表示","click aquí","click aqui","clicka aquí","clicka aqui","pincha aquí","pincha aqui","aquí","aqui","más","mas","más información","más informacion","mas información","mas informacion","este","enlace","este enlace","empezar","clique aqui","ir","mais informação","mais informações","mais","veja mais","여기","여기를 클릭","클릭","링크","자세히","자세히 보기","계속","이동","전체 보기","här","klicka här","läs mer","mer","mer info","mer information"]),c=e("../../lib/i18n/i18n.js"),l={title:"Links have descriptive text",failureTitle:"Links do not have descriptive text",description:"Descriptive link text helps search engines understand your content. [Learn more](https://web.dev/link-text/).",
displayValue:"{itemCount, plural,\n    =1 {1 link found}\n    other {# links found}\n    }"},u=c.createMessageInstanceIdFn(n,l);t.exports=class LinkText extends i{static get meta(){return{id:"link-text",title:u(l.title),failureTitle:u(l.failureTitle),description:u(l.description),requiredArtifacts:["URL","AnchorElements"]}}static audit(e){const t=e.AnchorElements.filter((e=>e.href&&!e.rel.includes("nofollow"))).filter((t=>{const n=t.href.toLowerCase();return!(n.startsWith("javascript:")||n.startsWith("mailto:")||a.equalWithExcludedFragments(t.href,e.URL.finalUrl))&&s.has(t.text.trim().toLowerCase())})).map((e=>({href:e.href,text:e.text.trim()}))),n=i.makeTableDetails([{key:"href",itemType:"url",text:"Link destination"},{key:"text",itemType:"text",text:"Link Text"}],t,{});let c;return t.length&&(c=u(l.displayValue,{itemCount:t.length})),{score:Number(0===t.length),details:n,displayValue:c}}},t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/seo/link-text.js")},{
"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","../audit.js":3}],"../audits/seo/manual/structured-data":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../../manual/manual-audit.js"),a=e("../../../lib/i18n/i18n.js"),s={description:"Run the [Structured Data Testing Tool](https://search.google.com/structured-data/testing-tool/) and the [Structured Data Linter](http://linter.structured-data.org/) to validate structured data. [Learn more](https://web.dev/structured-data/).",title:"Structured data is valid"},c=a.createMessageInstanceIdFn(n,s);t.exports=class StructuredData extends i{static get meta(){return Object.assign({id:"structured-data",description:c(s.description),title:c(s.title)},super.partialMeta)}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/seo/manual/structured-data.js")},{"../../../lib/i18n/i18n.js":98,"../../manual/manual-audit.js":6}],"../audits/seo/meta-description":[function(e,t,n){(function(n){(function(){
"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={title:"Document has a meta description",failureTitle:"Document does not have a meta description",description:"Meta descriptions may be included in search results to concisely summarize page content. [Learn more](https://web.dev/meta-description/).",explanation:"Description text is empty."},c=a.createMessageInstanceIdFn(n,s);t.exports=class Description extends i{static get meta(){return{id:"meta-description",title:c(s.title),failureTitle:c(s.failureTitle),description:c(s.description),requiredArtifacts:["MetaElements"]}}static audit(e){const t=e.MetaElements.find((e=>"description"===e.name));if(!t)return{score:0};return 0===(t.content||"").trim().length?{score:0,explanation:c(s.explanation)}:{score:1}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/seo/meta-description.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],"../audits/seo/plugins":[function(e,t,n){(function(n){(function(){
"use strict";const i=e("../audit.js"),a=e("../../lib/url-shim.js"),s="application/x-java-applet",c="application/x-java-bean",l=new Set(["application/x-shockwave-flash",s,c,"application/x-silverlight","application/x-silverlight-2"]),u=new Set(["swf","flv","class","xap"]),d=new Set(["code","movie","source","src"]),m=e("../../lib/i18n/i18n.js"),p={title:"Document avoids plugins",failureTitle:"Document uses plugins",description:"Search engines can't index plugin content, and many devices restrict plugins or don't support them. [Learn more](https://web.dev/plugins/)."},h=m.createMessageInstanceIdFn(n,p);function isPluginURL(e){try{const t=new a(e,"http://example.com").pathname.split(".");if(t.length<2)return!1;const n=t[t.length-1];return u.has(n.trim().toLowerCase())}catch(e){return!1}}t.exports=class Plugins extends i{static get meta(){return{id:"plugins",title:h(p.title),failureTitle:h(p.failureTitle),description:h(p.description),requiredArtifacts:["EmbeddedContent"]}}static audit(e){
const t=e.EmbeddedContent.filter((e=>{if("APPLET"===e.tagName)return!0;if(("EMBED"===e.tagName||"OBJECT"===e.tagName)&&e.type&&function isPluginType(e){return e=e.trim().toLowerCase(),l.has(e)||e.startsWith(s)||e.startsWith(c)}(e.type))return!0;const t=e.src||e.code;if("EMBED"===e.tagName&&t&&isPluginURL(t))return!0;if("OBJECT"===e.tagName&&e.data&&isPluginURL(e.data))return!0;return e.params.filter((e=>d.has(e.name.trim().toLowerCase())&&isPluginURL(e.value))).length>0})).map((e=>({source:i.makeNodeItem(e.node)}))),n=i.makeTableDetails([{key:"source",itemType:"code",text:"Element source"}],t);return{score:Number(0===t.length),details:n}}},t.exports.UIStrings=p}).call(this)}).call(this,"/lighthouse-core/audits/seo/plugins.js")},{"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","../audit.js":3}],"../audits/seo/robots-txt":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("../audit.js"),a=e("../../lib/url-shim.js"),s="sitemap",c="user-agent",l="allow",u="disallow",d=new Set([l,u]),m=new Set([c,u,l,s,"crawl-delay","clean-param","host","request-rate","visit-time","noindex"]),p=new Set(["https:","http:","ftp:"]),h=e("../../lib/i18n/i18n.js"),f={title:"robots.txt is valid",failureTitle:"robots.txt is not valid",description:"If your robots.txt file is malformed, crawlers may not be able to understand how you want your website to be crawled or indexed. [Learn more](https://web.dev/robots-txt/).",displayValueHttpBadCode:"Request for robots.txt returned HTTP status: {statusCode}",displayValueValidationError:"{itemCount, plural,\n    =1 {1 error found}\n    other {# errors found}\n    }",explanation:"Lighthouse was unable to download a robots.txt file"},g=h.createMessageInstanceIdFn(n,f);function parseLine(e){const t=e.indexOf("#");if(-1!==t&&(e=e.substr(0,t)),0===(e=e.trim()).length)return null;const n=e.indexOf(":")
;if(-1===n)throw new Error("Syntax not understood");const i=e.slice(0,n).trim().toLowerCase(),d=e.slice(n+1).trim();return function verifyDirective(e,t){if(!m.has(e))throw new Error("Unknown directive");if(e===s){let e;try{e=new a(t)}catch(e){throw new Error("Invalid sitemap URL")}if(!p.has(e.protocol))throw new Error("Invalid sitemap URL protocol")}if(e===c&&!t)throw new Error("No user-agent specified");if(e===l||e===u){if(""!==t&&"/"!==t[0]&&"*"!==t[0])throw new Error('Pattern should either be empty, start with "/" or "*"');const e=t.indexOf("$");if(-1!==e&&e!==t.length-1)throw new Error('"$" should only be used at the end of the pattern')}}(i,d),{directive:i,value:d}}t.exports=class RobotsTxt extends i{static get meta(){return{id:"robots-txt",title:g(f.title),failureTitle:g(f.failureTitle),description:g(f.description),requiredArtifacts:["RobotsTxt"]}}static audit(e){const{status:t,content:n}=e.RobotsTxt;if(!t)return{score:0,explanation:g(f.explanation)};if(t>=500)return{score:0,
displayValue:g(f.displayValueHttpBadCode,{statusCode:t})};if(t>=400||""===n)return{score:1,notApplicable:!0};if(null===n)throw new Error(`Status ${t} was valid, but content was null`);const a=function validateRobots(e){const t=[];let n=!1;return e.split(/\r\n|\r|\n/).forEach(((e,i)=>{let a;try{a=parseLine(e)}catch(n){t.push({index:(i+1).toString(),line:e,message:n.message.toString()})}a&&(a.directive===c?n=!0:!n&&d.has(a.directive)&&t.push({index:(i+1).toString(),line:e,message:"No user-agent specified"}))})),t}(n),s=i.makeTableDetails([{key:"index",itemType:"text",text:"Line #"},{key:"line",itemType:"code",text:"Content"},{key:"message",itemType:"code",text:"Error"}],a,{});let l;return a.length&&(l=g(f.displayValueValidationError,{itemCount:a.length})),{score:Number(0===a.length),details:s,displayValue:l}}},t.exports.UIStrings=f}).call(this)}).call(this,"/lighthouse-core/audits/seo/robots-txt.js")},{"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","../audit.js":3}],
"../audits/seo/tap-targets":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../computed/viewport-meta.js"),{rectsTouchOrOverlap:s,getRectOverlapArea:c,getRectAtCenter:l,allRectsContainedWithinEachOther:u,getLargestRect:d,getBoundingRectWithPadding:m}=e("../../lib/rect-helpers.js"),{getTappableRectsFromClientRects:p}=e("../../lib/tappable-rects.js"),h=e("../../lib/i18n/i18n.js"),f={title:"Tap targets are sized appropriately",failureTitle:"Tap targets are not sized appropriately",description:"Interactive elements like buttons and links should be large enough (48x48px), and have enough space around them, to be easy enough to tap without overlapping onto other elements. [Learn more](https://web.dev/tap-targets/).",tapTargetHeader:"Tap Target",overlappingTargetHeader:"Overlapping Target",explanationViewportMetaNotOptimized:"Tap targets are too small because there's no viewport meta tag optimized for mobile screens",
displayValue:"{decimalProportion, number, percent} appropriately sized tap targets"},g=h.createMessageInstanceIdFn(n,f);function clientRectBelowMinimumSize(e){return e.width<48||e.height<48}function getOverlapFailureForTargetPair(e,t){let n=null;for(const i of e){const e=l(i,48),a=c(e,i);for(const i of t){const t=c(e,i),s=t/a;s<.25||(!n||s>n.overlapScoreRatio)&&(n={overlapScoreRatio:s,tapTargetScore:a,overlappingTargetScore:t})}}return n}class TapTargets extends i{static get meta(){return{id:"tap-targets",title:g(f.title),failureTitle:g(f.failureTitle),description:g(f.description),requiredArtifacts:["MetaElements","TapTargets"]}}static async audit(e,t){if("desktop"===t.settings.formFactor)return{score:1,notApplicable:!0};if(!(await a.request(e.MetaElements,t)).isMobileOptimized)return{score:0,explanation:g(f.explanationViewportMetaNotOptimized)};const n=function getBoundedTapTargets(e){return e.map((e=>({tapTarget:e,paddedBoundsRect:m(e.clientRects,48)})))
}(e.TapTargets),c=function getAllOverlapFailures(e,t){const n=[];return e.forEach((e=>{const i=p(e.tapTarget.clientRects);for(const a of t){if(a===e)continue;if(!s(e.paddedBoundsRect,a.paddedBoundsRect))continue;if(e.tapTarget.href===a.tapTarget.href&&/https?:\/\//.test(e.tapTarget.href))continue;const t=a.tapTarget.clientRects;if(u(i,t))continue;const c=getOverlapFailureForTargetPair(i,t);c&&n.push({...c,tapTarget:e.tapTarget,overlappingTarget:a.tapTarget})}})),n}(function getTooSmallTargets(e){return e.filter((e=>e.tapTarget.clientRects.every(clientRectBelowMinimumSize)))}(n),n),l=function getTableItems(e){const t=e.map((e=>{const t=d(e.tapTarget.clientRects),n=Math.floor(t.width),a=Math.floor(t.height),s=n+"x"+a;return{tapTarget:i.makeNodeItem(e.tapTarget.node),overlappingTarget:i.makeNodeItem(e.overlappingTarget.node),tapTargetScore:e.tapTargetScore,overlappingTargetScore:e.overlappingTargetScore,overlapScoreRatio:e.overlapScoreRatio,size:s,width:n,height:a}}))
;return t.sort(((e,t)=>t.overlapScoreRatio-e.overlapScoreRatio)),t}(function mergeSymmetricFailures(e){const t=[];return e.forEach(((n,i)=>{const a=e.find((e=>e.tapTarget===n.overlappingTarget&&e.overlappingTarget===n.tapTarget));if(!a)return void t.push(n);const{overlapScoreRatio:s}=n,{overlapScoreRatio:c}=a;(s>c||s===c&&i<e.indexOf(a))&&t.push(n)})),t}(c)),y=[{key:"tapTarget",itemType:"node",text:g(f.tapTargetHeader)},{key:"size",itemType:"text",text:g(h.UIStrings.columnSize)},{key:"overlappingTarget",itemType:"node",text:g(f.overlappingTargetHeader)}],b=i.makeTableDetails(y,l),v=e.TapTargets.length,w=new Set(c.map((e=>e.tapTarget))).size;let S=1,T=1;w>0&&(T=(v-w)/v,S=.89*T);return{score:S,details:b,displayValue:g(f.displayValue,{decimalProportion:T})}}}TapTargets.FINGER_SIZE_PX=48,t.exports=TapTargets,t.exports.UIStrings=f}).call(this)}).call(this,"/lighthouse-core/audits/seo/tap-targets.js")},{"../../computed/viewport-meta.js":51,"../../lib/i18n/i18n.js":98,
"../../lib/rect-helpers.js":111,"../../lib/tappable-rects.js":115,"../audit.js":3}],"../audits/server-response-time":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../computed/main-resource.js"),c=e("../computed/network-records.js"),l=e("../lib/dependency-graph/simulator/network-analyzer.js"),u={title:"Initial server response time was short",failureTitle:"Reduce initial server response time",description:"Keep the server response time for the main document short because all other requests depend on it. [Learn more](https://web.dev/time-to-first-byte/).",displayValue:"Root document took {timeInMs, number, milliseconds} ms"},d=a.createMessageInstanceIdFn(n,u);class ServerResponseTime extends i{static get meta(){return{id:"server-response-time",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),supportedModes:["timespan","navigation"],requiredArtifacts:["devtoolsLogs","URL","GatherContext"]}}
static calculateResponseTime(e){const t=e.timing;return t?t.receiveHeadersEnd-t.sendEnd:0}static async audit(e,t){const n=e.devtoolsLogs[i.DEFAULT_PASS];let m;if("timespan"===e.GatherContext.gatherMode){const i=await c.request(n,t),a=l.findOptionalMainDocument(i,e.URL.finalUrl);if(!a)return{score:null,notApplicable:!0};m=a}else m=await s.request({devtoolsLog:n,URL:e.URL},t);const p=ServerResponseTime.calculateResponseTime(m),h=p<600,f=d(u.displayValue,{timeInMs:p}),g=[{key:"url",valueType:"url",label:d(a.UIStrings.columnURL)},{key:"responseTime",valueType:"timespanMs",label:d(a.UIStrings.columnTimeSpent)}],y=i.makeOpportunityDetails(g,[{url:m.url,responseTime:p}],p-100);return{numericValue:p,numericUnit:"millisecond",score:Number(h),displayValue:f,details:y}}}t.exports=ServerResponseTime,t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/server-response-time.js")},{"../computed/main-resource.js":14,"../computed/network-records.js":40,
"../lib/dependency-graph/simulator/network-analyzer.js":93,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/service-worker":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../lib/url-shim.js"),a=e("./audit.js"),s=e("../lib/i18n/i18n.js"),c={title:"Registers a service worker that controls page and `start_url`",failureTitle:"Does not register a service worker that controls page and `start_url`",description:"The service worker is the technology that enables your app to use many Progressive Web App features, such as offline, add to homescreen, and push notifications. [Learn more](https://web.dev/service-worker/).",explanationOutOfScope:"This origin has one or more service workers, however the page ({pageUrl}) is not in scope.",explanationNoManifest:"This page is controlled by a service worker, however no `start_url` was found because no manifest was fetched.",
explanationBadManifest:"This page is controlled by a service worker, however no `start_url` was found because manifest failed to parse as valid JSON",explanationBadStartUrl:"This page is controlled by a service worker, however the `start_url` ({startUrl}) is not in the service worker's scope ({scopeUrl})"},l=s.createMessageInstanceIdFn(n,c);class ServiceWorker extends a{static get meta(){return{id:"service-worker",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["URL","ServiceWorker","WebAppManifest"]}}static getVersionsForOrigin(e,t){return e.filter((e=>"activated"===e.status)).filter((e=>new i(e.scriptURL).origin===t.origin))}static getControllingServiceWorker(e,t,n){const a=[];for(const n of e){const e=t.find((e=>e.registrationId===n.registrationId));if(e){const t=new i(e.scopeURL).href,s=new i(n.scriptURL).href;a.push({scopeUrl:t,scriptUrl:s})}}
return a.filter((e=>n.href.startsWith(e.scopeUrl))).sort(((e,t)=>e.scopeUrl.length-t.scopeUrl.length)).pop()}static checkStartUrl(e,t){if(!e)return l(c.explanationNoManifest);if(!e.value)return l(c.explanationBadManifest);const n=e.value.start_url.value;return n.startsWith(t)?void 0:l(c.explanationBadStartUrl,{startUrl:n,scopeUrl:t})}static audit(e){const t=new i(e.URL.finalUrl),{versions:n,registrations:a}=e.ServiceWorker,s=ServiceWorker.getVersionsForOrigin(n,t);if(0===s.length)return{score:0};const u=ServiceWorker.getControllingServiceWorker(s,a,t);if(!u)return{score:0,explanation:l(c.explanationOutOfScope,{pageUrl:t.href})};const{scriptUrl:d,scopeUrl:m}=u,p={type:"debugdata",scriptUrl:d,scopeUrl:m},h=ServiceWorker.checkStartUrl(e.WebAppManifest,u.scopeUrl);return h?{score:0,details:p,explanation:h}:{score:1,details:p}}}t.exports=ServiceWorker,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/service-worker.js")},{"../lib/i18n/i18n.js":98,
"../lib/url-shim.js":"url","./audit.js":3}],"../audits/splash-screen":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./multi-check-audit.js"),a=e("../computed/manifest-values.js"),s=e("../lib/i18n/i18n.js"),c={title:"Configured for a custom splash screen",failureTitle:"Is not configured for a custom splash screen",description:"A themed splash screen ensures a high-quality experience when users launch your app from their homescreens. [Learn more](https://web.dev/splash-screen/)."},l=s.createMessageInstanceIdFn(n,c);class SplashScreen extends i{static get meta(){return{id:"splash-screen",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors"]}}static assessManifest(e,t){if(e.isParseFailure&&e.parseFailureReason)return void t.push(e.parseFailureReason);const n=["hasName","hasBackgroundColor","hasThemeColor","hasIconsAtLeast512px"]
;e.allChecks.filter((e=>n.includes(e.id))).forEach((e=>{e.passing||t.push(e.failureText)}))}static async audit_(e,t){const n=[],i=await a.request(e,t);return SplashScreen.assessManifest(i,n),{failures:n,manifestValues:i}}}t.exports=SplashScreen,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/splash-screen.js")},{"../computed/manifest-values.js":16,"../lib/i18n/i18n.js":98,"./multi-check-audit.js":7}],"../audits/themed-omnibox":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./multi-check-audit.js"),a=e("../computed/manifest-values.js"),s=e("cssstyle/lib/parsers"),c=e("../lib/i18n/i18n.js"),l={title:"Sets a theme color for the address bar.",failureTitle:"Does not set a theme color for the address bar.",description:"The browser address bar can be themed to match your site. [Learn more](https://web.dev/themed-omnibox/)."},u=c.createMessageInstanceIdFn(n,l);class ThemedOmnibox extends i{static get meta(){return{id:"themed-omnibox",title:u(l.title),
failureTitle:u(l.failureTitle),description:u(l.description),supportedModes:["navigation"],requiredArtifacts:["WebAppManifest","InstallabilityErrors","MetaElements"]}}static isValidColor(e){return s.valueType(e)===s.TYPES.COLOR}static assessMetaThemecolor(e,t){e?ThemedOmnibox.isValidColor(e.content||"")||t.push("The theme-color meta tag did not contain a valid CSS color"):t.push('No `<meta name="theme-color">` tag found')}static assessManifest(e,t){if(e.isParseFailure&&e.parseFailureReason)return void t.push(e.parseFailureReason);const n=e.allChecks.find((e=>"hasThemeColor"===e.id));n&&!n.passing&&t.push(n.failureText)}static async audit_(e,t){const n=[],i=e.MetaElements.find((e=>"theme-color"===e.name)),s=await a.request(e,t);return ThemedOmnibox.assessManifest(s,n),ThemedOmnibox.assessMetaThemecolor(i,n),{failures:n,manifestValues:s,themeColor:i&&i.content||null}}}t.exports=ThemedOmnibox,t.exports.UIStrings=l}).call(this)}).call(this,"/lighthouse-core/audits/themed-omnibox.js")},{
"../computed/manifest-values.js":16,"../lib/i18n/i18n.js":98,"./multi-check-audit.js":7,"cssstyle/lib/parsers":160}],"../audits/third-party-facades":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../lib/third-party-web.js"),c=e("../computed/network-records.js"),l=e("../computed/main-resource.js"),u=e("../computed/main-thread-tasks.js"),d=e("./third-party-summary.js"),m={title:"Lazy load third-party resources with facades",failureTitle:"Some third-party resources can be lazy loaded with a facade",description:"Some third-party embeds can be lazy loaded. Consider replacing them with a facade until they are required. [Learn more](https://web.dev/third-party-facades/).",displayValue:"{itemCount, plural,\n  =1 {# facade alternative available}\n  other {# facade alternatives available}\n  }",columnProduct:"Product",categoryVideo:"{productName} (Video)",categoryCustomerSuccess:"{productName} (Customer Success)",
categoryMarketing:"{productName} (Marketing)",categorySocial:"{productName} (Social)"},p=a.createMessageInstanceIdFn(n,m),h={video:m.categoryVideo,"customer-success":m.categoryCustomerSuccess,marketing:m.categoryMarketing,social:m.categorySocial};class ThirdPartyFacades extends i{static get meta(){return{id:"third-party-facades",title:p(m.title),failureTitle:p(m.failureTitle),description:p(m.description),supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","URL"]}}static condenseItems(e){e.sort(((e,t)=>t.transferSize-e.transferSize));let t=e.findIndex((e=>e.transferSize<1e3))||1;if((-1===t||t>5)&&(t=5),t>=e.length-1)return;const n=e.splice(t).reduce(((e,t)=>(e.transferSize+=t.transferSize,e.blockingTime+=t.blockingTime,e)));n.transferSize<1e3||(n.url=p(a.UIStrings.otherResourcesLabel),e.push(n))}static getProductsWithFacade(e,t){const n=new Map;for(const i of e.keys()){const e=s.getEntity(i);if(!e||s.isFirstParty(i,t))continue;const a=s.getProduct(i)
;a&&a.facades&&a.facades.length&&(n.has(a.name)||n.set(a.name,{product:a,entity:e}))}return Array.from(n.values())}static async audit(e,t){const n=t.settings,f=e.traces[i.DEFAULT_PASS],g=e.devtoolsLogs[i.DEFAULT_PASS],y=await c.request(g,t),b=await l.request({devtoolsLog:g,URL:e.URL},t),v=s.getEntity(b.url),w=await u.request(f,t),S="simulate"===n.throttlingMethod?n.throttling.cpuSlowdownMultiplier:1,T=d.getSummaries(y,w,S),E=ThirdPartyFacades.getProductsWithFacade(T.byURL,v),_=[];for(const{product:e,entity:t}of E){const n=h[e.categories[0]];let i;i=n?p(n,{productName:e.name}):e.name;const a=T.urls.get(t),s=T.byEntity.get(t);if(!a||!s)continue;const c=Array.from(a).map((e=>({url:e,...T.byURL.get(e)})));this.condenseItems(c),_.push({product:i,transferSize:s.transferSize,blockingTime:s.blockingTime,subItems:{type:"subitems",items:c}})}if(!_.length)return{score:1,notApplicable:!0};const x=[{key:"product",itemType:"text",subItemsHeading:{key:"url",itemType:"url"},text:p(m.columnProduct)},{
key:"transferSize",itemType:"bytes",subItemsHeading:{key:"transferSize"},granularity:1,text:p(a.UIStrings.columnTransferSize)},{key:"blockingTime",itemType:"ms",subItemsHeading:{key:"blockingTime"},granularity:1,text:p(a.UIStrings.columnBlockingTime)}];return{score:0,displayValue:p(m.displayValue,{itemCount:_.length}),details:i.makeTableDetails(x,_)}}}t.exports=ThirdPartyFacades,t.exports.UIStrings=m}).call(this)}).call(this,"/lighthouse-core/audits/third-party-facades.js")},{"../computed/main-resource.js":14,"../computed/main-thread-tasks.js":15,"../computed/network-records.js":40,"../lib/i18n/i18n.js":98,"../lib/third-party-web.js":116,"./audit.js":3,"./third-party-summary.js":"../audits/third-party-summary"}],"../audits/third-party-summary":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("./bootup-time.js"),s=e("../lib/i18n/i18n.js"),c=e("../lib/third-party-web.js"),l=e("../computed/network-records.js"),u=e("../computed/main-thread-tasks.js"),d={
title:"Minimize third-party usage",failureTitle:"Reduce the impact of third-party code",description:"Third-party code can significantly impact load performance. Limit the number of redundant third-party providers and try to load third-party code after your page has primarily finished loading. [Learn more](https://developers.google.com/web/fundamentals/performance/optimizing-content-efficiency/loading-third-party-javascript/).",columnThirdParty:"Third-Party",displayValue:"Third-party code blocked the main thread for {timeInMs, number, milliseconds} ms"},m=s.createMessageInstanceIdFn(n,d);class ThirdPartySummary extends i{static get meta(){return{id:"third-party-summary",title:m(d.title),failureTitle:m(d.failureTitle),description:m(d.description),requiredArtifacts:["traces","devtoolsLogs","URL"]}}static getSummaries(e,t,n){const i=new Map,s=new Map,l={mainThreadTime:0,blockingTime:0,transferSize:0};for(const t of e){const e=i.get(t.url)||{...l};e.transferSize+=t.transferSize,
i.set(t.url,e)}const u=a.getJavaScriptURLs(e);for(const e of t){const t=a.getAttributableURLForTask(e,u),s=i.get(t)||{...l},c=e.selfTime*n;s.mainThreadTime+=c,s.blockingTime+=Math.max(c-50,0),i.set(t,s)}const d=new Map;for(const[e,t]of i.entries()){const n=c.getEntity(e);if(!n){i.delete(e);continue}const a=s.get(n)||{...l};a.transferSize+=t.transferSize,a.mainThreadTime+=t.mainThreadTime,a.blockingTime+=t.blockingTime,s.set(n,a);const u=d.get(n)||[];u.push(e),d.set(n,u)}return{byURL:i,byEntity:s,urls:d}}static makeSubItems(e,t,n){let i=(t.urls.get(e)||[]).map((e=>({url:e,...t.byURL.get(e)}))).filter((e=>e.transferSize>0)).sort(((e,t)=>t.blockingTime-e.blockingTime||t.transferSize-e.transferSize));const a={transferSize:0,blockingTime:0},c=Math.max(4096,n.transferSize/20),l=Math.min(5,i.length);let u=0;for(;u<l;){const e=i[u];if(0===e.blockingTime&&e.transferSize<c)break;u++,a.transferSize+=e.transferSize,a.blockingTime+=e.blockingTime}if(!a.blockingTime&&!a.transferSize)return[]
;i=i.slice(0,u);const d={url:m(s.UIStrings.otherResourcesLabel),transferSize:n.transferSize-a.transferSize,blockingTime:n.blockingTime-a.blockingTime};return d.transferSize>c&&i.push(d),i}static async audit(e,t){const n=t.settings||{},a=e.traces[i.DEFAULT_PASS],p=e.devtoolsLogs[i.DEFAULT_PASS],h=await l.request(p,t),f=c.getEntity(e.URL.finalUrl),g=await u.request(a,t),y="simulate"===n.throttlingMethod?n.throttling.cpuSlowdownMultiplier:1,b=ThirdPartySummary.getSummaries(h,g,y),v={wastedBytes:0,wastedMs:0},w=Array.from(b.byEntity.entries()).filter((([e])=>!(f&&f.name===e.name))).map((([e,t])=>(v.wastedBytes+=t.transferSize,v.wastedMs+=t.blockingTime,{...t,entity:{type:"link",text:e.name,url:e.homepage||""},subItems:{type:"subitems",items:ThirdPartySummary.makeSubItems(e,b,t)}}))).sort(((e,t)=>t.blockingTime-e.blockingTime||t.transferSize-e.transferSize)),S=[{key:"entity",itemType:"link",text:m(d.columnThirdParty),subItemsHeading:{key:"url",itemType:"url"}},{key:"transferSize",
granularity:1,itemType:"bytes",text:m(s.UIStrings.columnTransferSize),subItemsHeading:{key:"transferSize"}},{key:"blockingTime",granularity:1,itemType:"ms",text:m(s.UIStrings.columnBlockingTime),subItemsHeading:{key:"blockingTime"}}];return w.length?{score:Number(v.wastedMs<=250),displayValue:m(d.displayValue,{timeInMs:v.wastedMs}),details:i.makeTableDetails(S,w,v)}:{score:1,notApplicable:!0}}}t.exports=ThirdPartySummary,t.exports.UIStrings=d}).call(this)}).call(this,"/lighthouse-core/audits/third-party-summary.js")},{"../computed/main-thread-tasks.js":15,"../computed/network-records.js":40,"../lib/i18n/i18n.js":98,"../lib/third-party-web.js":116,"./audit.js":3,"./bootup-time.js":"../audits/bootup-time"}],"../audits/timing-budget":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../computed/metrics/timing-summary.js"),s=e("../computed/main-resource.js"),c=e("../config/budget.js"),l=e("../lib/i18n/i18n.js"),u={title:"Timing budget",
description:"Set a timing budget to help you keep an eye on the performance of your site. Performant sites load fast and respond to user input events quickly. [Learn more](https://developers.google.com/web/tools/lighthouse/audits/budgets).",columnTimingMetric:"Metric",columnMeasurement:"Measurement"},d=l.createMessageInstanceIdFn(n,u);t.exports=class TimingBudget extends i{static get meta(){return{id:"timing-budget",title:d(u.title),description:d(u.description),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","traces","URL","GatherContext"]}}static getRowLabel(e){const t={"first-contentful-paint":l.UIStrings.firstContentfulPaintMetric,interactive:l.UIStrings.interactiveMetric,"first-meaningful-paint":l.UIStrings.firstMeaningfulPaintMetric,"max-potential-fid":l.UIStrings.maxPotentialFIDMetric,"total-blocking-time":l.UIStrings.totalBlockingTimeMetric,"speed-index":l.UIStrings.speedIndexMetric,
"largest-contentful-paint":l.UIStrings.largestContentfulPaintMetric,"cumulative-layout-shift":l.UIStrings.cumulativeLayoutShiftMetric};return d(t[e])}static getMeasurement(e,t){return{"first-contentful-paint":t.firstContentfulPaint,interactive:t.interactive,"first-meaningful-paint":t.firstMeaningfulPaint,"max-potential-fid":t.maxPotentialFID,"total-blocking-time":t.totalBlockingTime,"speed-index":t.speedIndex,"largest-contentful-paint":t.largestContentfulPaint,"cumulative-layout-shift":t.cumulativeLayoutShift}[e]}static tableItems(e,t){let n=[];if(!e.timings)return n;n=e.timings.map((e=>{const n=e.metric,i=this.getRowLabel(n),a=this.getMeasurement(n,t);return{metric:n,label:i,measurement:a,overBudget:a&&a>e.budget?a-e.budget:void 0}})).sort(((e,t)=>(t.overBudget||0)-(e.overBudget||0)));const i=n.find((e=>"cumulative-layout-shift"===e.metric));return i&&("number"==typeof i.measurement&&(i.measurement={type:"numeric",value:Number(i.measurement),granularity:.01}),
"number"==typeof i.overBudget&&(i.overBudget={type:"numeric",value:Number(i.overBudget),granularity:.01})),n}static async audit(e,t){const n=e.GatherContext,m=e.devtoolsLogs[i.DEFAULT_PASS],p=e.traces[i.DEFAULT_PASS],h=await s.request({URL:e.URL,devtoolsLog:m},t),f={trace:p,devtoolsLog:m,gatherContext:n,settings:t.settings},g=(await a.request(f,t)).metrics,y=c.getMatchingBudget(t.settings.budgets,h.url);if(!y)return{score:0,notApplicable:!0};const b=[{key:"label",itemType:"text",text:d(u.columnTimingMetric)},{key:"measurement",itemType:"ms",text:d(u.columnMeasurement)},{key:"overBudget",itemType:"ms",text:d(l.UIStrings.columnOverBudget)}];return{details:i.makeTableDetails(b,this.tableItems(y,g)),score:1}}},t.exports.UIStrings=u}).call(this)}).call(this,"/lighthouse-core/audits/timing-budget.js")},{"../computed/main-resource.js":14,"../computed/metrics/timing-summary.js":36,"../config/budget.js":52,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/unsized-images":[function(e,t,n){
(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("./../lib/i18n/i18n.js"),s=e("./../lib/url-shim.js"),c={title:"Image elements have explicit `width` and `height`",failureTitle:"Image elements do not have explicit `width` and `height`",description:"Set an explicit width and height on image elements to reduce layout shifts and improve CLS. [Learn more](https://web.dev/optimize-cls/#images-without-dimensions)"},l=a.createMessageInstanceIdFn(n,c);class UnsizedImages extends i{static get meta(){return{id:"unsized-images",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["ImageElements"]}}static doesHtmlAttrProvideExplicitSize(e){if(!e)return!1;if(e.startsWith("+"))return!1;return parseInt(e,10)>=0}static isCssPropExplicitlySet(e){return!!e&&!["auto","initial","unset","inherit"].includes(e)}static isSizedImage(e){if(void 0===e.cssEffectiveRules)return!0
;const t=e.attributeWidth,n=e.attributeHeight,i=e.cssEffectiveRules.width,a=e.cssEffectiveRules.height,s=e.cssEffectiveRules.aspectRatio,c=UnsizedImages.doesHtmlAttrProvideExplicitSize(t),l=UnsizedImages.isCssPropExplicitlySet(i),u=UnsizedImages.doesHtmlAttrProvideExplicitSize(n),d=UnsizedImages.isCssPropExplicitlySet(a),m=UnsizedImages.isCssPropExplicitlySet(s),p=c||l,h=u||d;return p&&h||p&&m||h&&m}static isNonNetworkSvg(e){const t="image/svg+xml"===e.mimeType,n=e.src.slice(0,e.src.indexOf(":")),i=s.isNonNetworkProtocol(n);return t&&i}static async audit(e){const t=e.ImageElements.filter((e=>!e.isCss&&!e.isInShadowDOM)),n=[];for(const e of t){if("fixed"===e.computedStyles.position||"absolute"===e.computedStyles.position)continue;if(UnsizedImages.isNonNetworkSvg(e))continue;if(UnsizedImages.isSizedImage(e))continue;const t=e.node.boundingRect;0===t.width&&0===t.height||n.push({url:s.elideDataURI(e.src),node:i.makeNodeItem(e.node)})}const c=[{key:"url",itemType:"thumbnail",text:""},{
key:"url",itemType:"url",text:l(a.UIStrings.columnURL)},{key:"node",itemType:"node",text:l(a.UIStrings.columnFailingElem)}];return{score:n.length>0?0:1,notApplicable:0===t.length,details:i.makeTableDetails(c,n)}}}t.exports=UnsizedImages,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/unsized-images.js")},{"./../lib/i18n/i18n.js":98,"./../lib/url-shim.js":"url","./audit.js":3}],"../audits/user-timings":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../lib/i18n/i18n.js"),s=e("../computed/user-timings.js"),c={title:"User Timing marks and measures",description:"Consider instrumenting your app with the User Timing API to measure your app's real-world performance during key user experiences. [Learn more](https://web.dev/user-timings/).",displayValue:"{itemCount, plural,\n    =1 {1 user timing}\n    other {# user timings}\n    }",columnType:"Type"},l=a.createMessageInstanceIdFn(n,c);class UserTimings extends i{static get meta(){
return{id:"user-timings",title:l(c.title),description:l(c.description),scoreDisplayMode:i.SCORING_MODES.INFORMATIVE,requiredArtifacts:["traces"]}}static get excludedPrefixes(){return["goog_"]}static excludeEvent(e){return UserTimings.excludedPrefixes.every((t=>!e.name.startsWith(t)))}static audit(e,t){const n=e.traces[i.DEFAULT_PASS];return s.request(n,t).then((e=>{const t=e.filter(UserTimings.excludeEvent),n=t.map((e=>({name:e.name,startTime:e.startTime,duration:e.isMark?void 0:e.duration,timingType:e.isMark?"Mark":"Measure"}))).sort(((e,t)=>e.timingType===t.timingType?e.startTime-t.startTime:"Measure"===e.timingType?-1:1)),s=[{key:"name",itemType:"text",text:l(a.UIStrings.columnName)},{key:"timingType",itemType:"text",text:l(c.columnType)},{key:"startTime",itemType:"ms",granularity:.01,text:l(a.UIStrings.columnStartTime)},{key:"duration",itemType:"ms",granularity:.01,text:l(a.UIStrings.columnDuration)}],u=i.makeTableDetails(s,n);let d;return t.length&&(d=l(c.displayValue,{
itemCount:t.length})),{score:Number(0===t.length),notApplicable:0===t.length,displayValue:d,details:u}}))}}t.exports=UserTimings,t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/user-timings.js")},{"../computed/user-timings.js":50,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../audits/uses-rel-preconnect":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("./byte-efficiency/byte-efficiency-audit.js"),s=e("../lib/url-shim.js"),c=e("../lib/i18n/i18n.js"),l=e("../computed/network-records.js"),u=e("../computed/main-resource.js"),d=e("../computed/load-simulator.js"),m=e("../computed/processed-trace.js"),p=e("../computed/processed-navigation.js"),h=e("../computed/page-dependency-graph.js"),f=e("../computed/metrics/lantern-largest-contentful-paint.js"),g={title:"Preconnect to required origins",
description:"Consider adding `preconnect` or `dns-prefetch` resource hints to establish early connections to important third-party origins. [Learn more](https://web.dev/uses-rel-preconnect/).",unusedWarning:'A `<link rel=preconnect>` was found for "{securityOrigin}" but was not used by the browser. Only use `preconnect` for important origins that the page will certainly request.',crossoriginWarning:'A `<link rel=preconnect>` was found for "{securityOrigin}" but was not used by the browser. Check that you are using the `crossorigin` attribute properly.',tooManyPreconnectLinksWarning:"More than 2 `<link rel=preconnect>` connections were found. These should be used sparingly and only to the most important origins."},y=c.createMessageInstanceIdFn(n,g);class UsesRelPreconnectAudit extends i{static get meta(){return{id:"uses-rel-preconnect",title:y(g.title),description:y(g.description),supportedModes:["navigation"],requiredArtifacts:["traces","devtoolsLogs","URL","LinkElements"],
scoreDisplayMode:i.SCORING_MODES.NUMERIC}}static hasValidTiming(e){return!!e.timing&&e.timing.connectEnd>0&&e.timing.connectStart>0}static hasAlreadyConnectedToOrigin(e){return!!e.timing&&e.timing.dnsEnd-e.timing.dnsStart==0&&e.timing.connectEnd-e.timing.connectStart==0}static socketStartTimeIsBelowThreshold(e,t){return Math.max(0,e.startTime-t.endTime)<15}static async audit(e,t){const n=e.traces[UsesRelPreconnectAudit.DEFAULT_PASS],b=e.devtoolsLogs[UsesRelPreconnectAudit.DEFAULT_PASS],v=t.settings;let w=0;const S=[],T=await m.request(n,t),[E,_,x,A,k]=await Promise.all([l.request(b,t),u.request({devtoolsLog:b,URL:e.URL},t),d.request({devtoolsLog:b,settings:v},t),p.request(T,t),h.request({trace:n,devtoolsLog:b},t)]),{rtt:R,additionalRttByOrigin:D}=x.getOptions(),I=await f.getPessimisticGraph(k,A),C=new Set;I.traverse((e=>{"network"===e.type&&C.add(e.record.url)}));const j=new Map;E.forEach((e=>{
if(!UsesRelPreconnectAudit.hasValidTiming(e)||e.initiator.url===_.url||!e.parsedURL||!e.parsedURL.securityOrigin||_.parsedURL.securityOrigin===e.parsedURL.securityOrigin||!C.has(e.url)||UsesRelPreconnectAudit.hasAlreadyConnectedToOrigin(e)||!UsesRelPreconnectAudit.socketStartTimeIsBelowThreshold(e,_))return;const t=e.parsedURL.securityOrigin,n=j.get(t)||[];n.push(e),j.set(t,n)}));const N=e.LinkElements.filter((e=>"preconnect"===e.rel)),L=new Set(N.map((e=>s.getOrigin(e.href||""))));let M=[];j.forEach((e=>{const t=e.reduce(((e,t)=>t.startTime<e.startTime?t:e));if(!t.timing)return;const n=t.parsedURL.securityOrigin,i=D.get(n)||0;let a=R+i;"https"===t.parsedURL.scheme&&(a*=2);const s=1e3*t.startTime-1e3*_.endTime+t.timing.dnsStart,c=Math.min(a,s);c<50||(L.has(n)?S.push(y(g.crossoriginWarning,{securityOrigin:n})):(w=Math.max(c,w),M.push({url:n,wastedMs:c})))})),M=M.sort(((e,t)=>t.wastedMs-e.wastedMs))
;for(const e of L)e&&(E.some((t=>e===t.parsedURL.securityOrigin))||S.push(y(g.unusedWarning,{securityOrigin:e})));if(N.length>=2)return{score:1,warnings:N.length>=3?[...S,y(g.tooManyPreconnectLinksWarning)]:S};const P=[{key:"url",valueType:"url",label:y(c.UIStrings.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:y(c.UIStrings.columnWastedMs)}],O=i.makeOpportunityDetails(P,M,w);return{score:a.scoreForWastedMs(w),numericValue:w,numericUnit:"millisecond",displayValue:w?y(c.UIStrings.displayValueMsSavings,{wastedMs:w}):"",warnings:S,details:O}}}t.exports=UsesRelPreconnectAudit,t.exports.UIStrings=g}).call(this)}).call(this,"/lighthouse-core/audits/uses-rel-preconnect.js")},{"../computed/load-simulator.js":13,"../computed/main-resource.js":14,"../computed/metrics/lantern-largest-contentful-paint.js":25,"../computed/network-records.js":40,"../computed/page-dependency-graph.js":41,"../computed/processed-navigation.js":42,"../computed/processed-trace.js":43,"../lib/i18n/i18n.js":98,
"../lib/url-shim.js":"url","./audit.js":3,"./byte-efficiency/byte-efficiency-audit.js":4}],"../audits/uses-rel-preload":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../lib/url-shim.js"),a=e("../lib/network-request.js"),s=e("./audit.js"),c=e("./byte-efficiency/byte-efficiency-audit.js"),l=e("../computed/critical-request-chains.js"),u=e("../lib/i18n/i18n.js"),d=e("../computed/main-resource.js"),m=e("../computed/page-dependency-graph.js"),p=e("../computed/load-simulator.js"),h={title:"Preload key requests",description:"Consider using `<link rel=preload>` to prioritize fetching resources that are currently requested later in page load. [Learn more](https://web.dev/uses-rel-preload/).",crossoriginWarning:'A preload `<link>` was found for "{preloadURL}" but was not used by the browser. Check that you are using the `crossorigin` attribute properly.'},f=u.createMessageInstanceIdFn(n,h);class UsesRelPreloadAudit extends s{static get meta(){return{id:"uses-rel-preload",
title:f(h.title),description:f(h.description),supportedModes:["navigation"],requiredArtifacts:["devtoolsLogs","traces","URL"],scoreDisplayMode:s.SCORING_MODES.NUMERIC}}static getURLsToPreload(e,t){const n=new Set;return t.traverse(((t,i)=>{if("network"!==t.type)return;const a=i.slice(1).filter((e=>"network"===e.type));UsesRelPreloadAudit.shouldPreloadRequest(t.record,e,a)&&n.add(t.record.url)})),n}static getURLsFailedToPreload(e){const t=[];e.traverse((e=>"network"===e.type&&t.push(e.record)));const n=t.filter((e=>e.isLinkPreload)),i=new Map;for(const e of n){const t=i.get(e.frameId)||new Set;t.add(e.url),i.set(e.frameId,t)}const a=t.filter((e=>{const t=i.get(e.frameId);if(!t)return!1;if(!t.has(e.url))return!1;return!(e.fromDiskCache||e.fromMemoryCache||e.fromPrefetchCache)&&!e.isLinkPreload}));return new Set(a.map((e=>e.url)))}static shouldPreloadRequest(e,t,n){const s=t.redirects?t.redirects.length:0
;return!e.isLinkPreload&&(!!l.isCritical(e,t)&&(!a.isNonNetworkRequest(e)&&(n.length===s+2&&(e.frameId===t.frameId&&i.rootDomainsMatch(e.url,t.url)))))}static computeWasteWithGraph(e,t,n){if(!e.size)return{wastedMs:0,results:[]};const i=n.simulate(t,{flexibleOrdering:!0}),a=t.cloneWithRelationships(),s=[];let c=null;if(a.traverse((t=>{"network"===t.type&&(t.isMainDocument()?c=t:t.record&&e.has(t.record.url)&&s.push(t))})),!c)throw new Error("Could not find main document node");for(const e of s)e.removeAllDependencies(),e.addDependency(c);const l=n.simulate(a,{flexibleOrdering:!0}),u=Array.from(i.nodeTimings.keys()).reduce(((e,t)=>e.set(t.record,t)),new Map),d=[];for(const e of s){const t=u.get(e.record),n=l.nodeTimings.get(e),a=i.nodeTimings.get(t);if(!a||!n)throw new Error("Missing preload node");const s=Math.round(a.endTime-n.endTime);s<100||d.push({url:e.record.url,wastedMs:s})}return d.length?{wastedMs:Math.max(...d.map((e=>e.wastedMs))),results:d}:{wastedMs:0,results:d}}
static async audit_(e,t){const n=e.traces[UsesRelPreloadAudit.DEFAULT_PASS],i=e.devtoolsLogs[UsesRelPreloadAudit.DEFAULT_PASS],a=e.URL,l={devtoolsLog:i,settings:t.settings},[g,y,b]=await Promise.all([d.request({devtoolsLog:i,URL:a},t),m.request({trace:n,devtoolsLog:i},t),p.request(l,t)]),v=UsesRelPreloadAudit.getURLsToPreload(g,y),{results:w,wastedMs:S}=UsesRelPreloadAudit.computeWasteWithGraph(v,y,b);let T;w.sort(((e,t)=>t.wastedMs-e.wastedMs));const E=UsesRelPreloadAudit.getURLsFailedToPreload(y);E.size&&(T=Array.from(E).map((e=>f(h.crossoriginWarning,{preloadURL:e}))));const _=[{key:"url",valueType:"url",label:f(u.UIStrings.columnURL)},{key:"wastedMs",valueType:"timespanMs",label:f(u.UIStrings.columnWastedMs)}],x=s.makeOpportunityDetails(_,w,S);return{score:c.scoreForWastedMs(S),numericValue:S,numericUnit:"millisecond",displayValue:S?f(u.UIStrings.displayValueMsSavings,{wastedMs:S}):"",details:x,warnings:T}}static async audit(){return{score:1,notApplicable:!0,
details:s.makeOpportunityDetails([],[],0)}}}t.exports=UsesRelPreloadAudit,t.exports.UIStrings=h}).call(this)}).call(this,"/lighthouse-core/audits/uses-rel-preload.js")},{"../computed/critical-request-chains.js":10,"../computed/load-simulator.js":13,"../computed/main-resource.js":14,"../computed/page-dependency-graph.js":41,"../lib/i18n/i18n.js":98,"../lib/network-request.js":109,"../lib/url-shim.js":"url","./audit.js":3,"./byte-efficiency/byte-efficiency-audit.js":4}],"../audits/valid-source-maps":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../lib/third-party-web.js"),a=e("./audit.js"),s=e("../lib/i18n/i18n.js"),c={title:"Page has valid source maps",failureTitle:"Missing source maps for large first-party JavaScript",
description:"Source maps translate minified code to the original source code. This helps developers debug in production. In addition, Lighthouse is able to provide further insights. Consider deploying source maps to take advantage of these benefits. [Learn more](https://developers.google.com/web/tools/chrome-devtools/javascript/source-maps).",columnMapURL:"Map URL",missingSourceMapErrorMessage:"Large JavaScript file is missing a source map",missingSourceMapItemsWarningMesssage:"{missingItems, plural,\n    =1 {Warning: missing 1 item in `.sourcesContent`}\n    other {Warning: missing # items in `.sourcesContent`}\n    }"},l=s.createMessageInstanceIdFn(n,c);t.exports=class ValidSourceMaps extends a{static get meta(){return{id:"valid-source-maps",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["ScriptElements","SourceMaps","URL"]}}static isLargeFirstPartyJS(e,t){if(null===e.content)return!1
;const n=e.content.length>=512e3,a=!!e.src&&i.isFirstParty(e.src,i.getEntity(t));return n&&a}static async audit(e){const{SourceMaps:t}=e,n=new Set;let i=!1;const u=[];for(const a of e.ScriptElements){if(!a.src)continue;const s=t.find((e=>e.scriptUrl===a.src)),d=[];if(!this.isLargeFirstPartyJS(a,e.URL.finalUrl)||s&&s.map||(i=!0,n.add(a.src),d.push({error:l(c.missingSourceMapErrorMessage)})),s&&!s.map&&d.push({error:s.errorMessage}),s&&s.map){const e=s.map.sourcesContent||[];let t=0;for(let n=0;n<s.map.sources.length;n++)(e.length<n||!e[n])&&(t+=1);t>0&&d.push({error:l(c.missingSourceMapItemsWarningMesssage,{missingItems:t})})}(s||d.length)&&u.push({scriptUrl:a.src,sourceMapUrl:s&&s.sourceMapUrl,subItems:{type:"subitems",items:d}})}const d=[{key:"scriptUrl",itemType:"url",subItemsHeading:{key:"error"},text:l(s.UIStrings.columnURL)},{key:"sourceMapUrl",itemType:"url",text:l(c.columnMapURL)}];return u.sort(((e,t)=>{const i=n.has(e.scriptUrl),a=n.has(t.scriptUrl)
;return i&&!a?-1:!i&&a?1:e.subItems.items.length&&!t.subItems.items.length?-1:!e.subItems.items.length&&t.subItems.items.length?1:t.scriptUrl.localeCompare(e.scriptUrl)})),{score:i?0:1,details:a.makeTableDetails(d,u)}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/valid-source-maps.js")},{"../lib/i18n/i18n.js":98,"../lib/third-party-web.js":116,"./audit.js":3}],"../audits/viewport":[function(e,t,n){(function(n){(function(){"use strict";const i=e("./audit.js"),a=e("../computed/viewport-meta.js"),s=e("../lib/i18n/i18n.js"),c={title:'Has a `<meta name="viewport">` tag with `width` or `initial-scale`',failureTitle:'Does not have a `<meta name="viewport">` tag with `width` or `initial-scale`',description:'A `<meta name="viewport">` not only optimizes your app for mobile screen sizes, but also prevents [a 300 millisecond delay to user input](https://developers.google.com/web/updates/2013/12/300ms-tap-delay-gone-away). [Learn more](https://web.dev/viewport/).',
explanationNoTag:'No `<meta name="viewport">` tag found'},l=s.createMessageInstanceIdFn(n,c);t.exports=class Viewport extends i{static get meta(){return{id:"viewport",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),requiredArtifacts:["MetaElements"]}}static async audit(e,t){const n=await a.request(e.MetaElements,t);return n.hasViewportTag?{score:Number(n.isMobileOptimized),warnings:n.parserWarnings}:{score:0,explanation:l(c.explanationNoTag)}}},t.exports.UIStrings=c}).call(this)}).call(this,"/lighthouse-core/audits/viewport.js")},{"../computed/viewport-meta.js":51,"../lib/i18n/i18n.js":98,"./audit.js":3}],"../gather/gatherers/accessibility":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/axe.js").source,s=e("../../lib/page-functions.js");async function runA11yChecks(){const e=window.axe,t="lighthouse-"+Math.random();e.configure({branding:{application:t},noHtml:!0});const n=await e.run(document,{
elementRef:!0,runOnly:{type:"tag",values:["wcag2a","wcag2aa"]},resultTypes:["violations","inapplicable"],rules:{tabindex:{enabled:!0},accesskeys:{enabled:!0},"heading-order":{enabled:!0},"meta-viewport":{enabled:!0},"duplicate-id":{enabled:!1},"table-fake-caption":{enabled:!1},"td-has-header":{enabled:!1},marquee:{enabled:!1},"area-alt":{enabled:!1},"html-xml-lang-mismatch":{enabled:!1},blink:{enabled:!1},"server-side-image-map":{enabled:!1},"identical-links-same-purpose":{enabled:!1},"no-autoplay-audio":{enabled:!1},"svg-img-alt":{enabled:!1},"audio-caption":{enabled:!1},"aria-treeitem-name":{enabled:!0},"nested-interactive":{enabled:!1},"frame-focusable-content":{enabled:!1}}});return document.documentElement.scrollTop=0,{violations:n.violations.map(createAxeRuleResultArtifact),incomplete:n.incomplete.map(createAxeRuleResultArtifact),notApplicable:n.inapplicable.map((e=>({id:e.id}))),version:n.testEngine.version}}function createAxeRuleResultArtifact(e){const t=e.nodes.map((e=>{
const{target:t,failureSummary:n,element:i}=e;return{target:t,failureSummary:n,node:getNodeDetails(i)}})),n=e.error;let i;return n instanceof Error&&(i={name:n.name,message:n.message}),{id:e.id,impact:e.impact||void 0,tags:e.tags,nodes:t,error:i}}t.exports=class Accessibility extends i{meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(runA11yChecks,{args:[],useIsolation:!0,deps:[a,s.getNodeDetailsString,createAxeRuleResultArtifact]})}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/axe.js":83,"../../lib/page-functions.js":110}],"../gather/gatherers/anchor-elements":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../driver/dom.js"),s=e("../../lib/page-functions.js");function collectAnchorElements(){const resolveURLOrEmpty=e=>{try{return new URL(e,window.location.href).href}catch(e){return""}};function getTruncatedOnclick(e){return(e.getAttribute("onclick")||"").slice(0,1024)}
return getElementsInDocument("a").map((e=>e instanceof HTMLAnchorElement?{href:e.href,rawHref:e.getAttribute("href")||"",onclick:getTruncatedOnclick(e),role:e.getAttribute("role")||"",name:e.name,text:e.innerText,rel:e.rel,target:e.target,node:getNodeDetails(e)}:{href:resolveURLOrEmpty(e.href.baseVal),rawHref:e.getAttribute("href")||"",onclick:getTruncatedOnclick(e),role:e.getAttribute("role")||"",text:e.textContent||"",rel:"",target:e.target.baseVal||"",node:getNodeDetails(e)}))}t.exports=class AnchorElements extends i{meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){const t=e.driver.defaultSession,n=await e.driver.executionContext.evaluate(collectAnchorElements,{args:[],useIsolation:!0,deps:[s.getElementsInDocumentString,s.getNodeDetailsString]});await t.sendCommand("DOM.enable"),await t.sendCommand("DOM.getDocument",{depth:-1,pierce:!0});const i=n.map((async e=>{const n=await async function getEventListeners(e,t){
const n=await a.resolveDevtoolsNodePathToObjectId(e,t);return n?(await e.sendCommand("DOMDebugger.getEventListeners",{objectId:n})).listeners.map((({type:e})=>({type:e}))):[]}(t,e.node.devtoolsNodePath);return{...e,listeners:n}})),c=await Promise.all(i);return await t.sendCommand("DOM.disable"),c}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/page-functions.js":110,"../driver/dom.js":66}],"../gather/gatherers/cache-contents":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js");function getCacheContents(){return caches.keys().then((e=>Promise.all(e.map((e=>caches.open(e)))))).then((e=>{const t=[];return Promise.all(e.map((e=>e.keys().then((e=>{t.push(...e.map((e=>e.url)))}))))).then((e=>t))}))}t.exports=class CacheContents extends i{meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){const t=e.driver;return await t.executionContext.evaluate(getCacheContents,{args:[]})}}},{"../../fraggle-rock/gather/base-gatherer.js":61}],
"../gather/gatherers/console-messages":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js");function remoteObjectToString(e){if(void 0!==e.value||"undefined"===e.type)return String(e.value);if("string"==typeof e.description&&e.description!==e.className)return e.description;return`[${e.subtype||e.type} ${e.className||"Object"}]`}t.exports=class ConsoleMessages extends i{meta={supportedModes:["timespan","navigation"]};constructor(){super(),this._logEntries=[],this._onConsoleAPICalled=this.onConsoleAPICalled.bind(this),this._onExceptionThrown=this.onExceptionThrown.bind(this),this._onLogEntryAdded=this.onLogEntry.bind(this)}onConsoleAPICalled(e){const{type:t}=e;if("warning"!==t&&"error"!==t)return;const n=(e.args||[]).map(remoteObjectToString).join(" ");if(!n&&!e.stackTrace)return;const{url:i,lineNumber:a,columnNumber:s}=e.stackTrace&&e.stackTrace.callFrames[0]||{},c={eventType:"consoleAPI",source:"warning"===t?"console.warn":"console.error",level:t,
text:n,stackTrace:e.stackTrace,timestamp:e.timestamp,url:i,lineNumber:a,columnNumber:s};this._logEntries.push(c)}onExceptionThrown(e){const t=e.exceptionDetails.exception?e.exceptionDetails.exception.description:e.exceptionDetails.text;if(!t)return;const n={eventType:"exception",source:"exception",level:"error",text:t,stackTrace:e.exceptionDetails.stackTrace,timestamp:e.timestamp,url:e.exceptionDetails.url,lineNumber:e.exceptionDetails.lineNumber,columnNumber:e.exceptionDetails.columnNumber};this._logEntries.push(n)}onLogEntry(e){const{source:t,level:n,text:i,stackTrace:a,timestamp:s,url:c,lineNumber:l}=e.entry,{columnNumber:u}=e.entry.stackTrace&&e.entry.stackTrace.callFrames[0]||{};this._logEntries.push({eventType:"protocolLog",source:t,level:n,text:i,stackTrace:a,timestamp:s,url:c,lineNumber:l,columnNumber:u})}async startInstrumentation(e){const t=e.driver.defaultSession;t.on("Log.entryAdded",this._onLogEntryAdded),await t.sendCommand("Log.enable"),
await t.sendCommand("Log.startViolationsReport",{config:[{name:"discouragedAPIUse",threshold:-1}]}),t.on("Runtime.consoleAPICalled",this._onConsoleAPICalled),t.on("Runtime.exceptionThrown",this._onExceptionThrown),await t.sendCommand("Runtime.enable")}async stopInstrumentation({driver:e}){await e.defaultSession.sendCommand("Log.stopViolationsReport"),await e.defaultSession.off("Log.entryAdded",this._onLogEntryAdded),await e.defaultSession.sendCommand("Log.disable"),await e.defaultSession.off("Runtime.consoleAPICalled",this._onConsoleAPICalled),await e.defaultSession.off("Runtime.exceptionThrown",this._onExceptionThrown),await e.defaultSession.sendCommand("Runtime.disable")}async getArtifact(){return this._logEntries}}},{"../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/css-usage":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js");t.exports=class CSSUsage extends i{constructor(){super(),this._stylesheets=[],
this._onStylesheetAdded=e=>this._stylesheets.push(e),this._onStylesheetRemoved=e=>{const t=e.styleSheetId;this._stylesheets=this._stylesheets.filter((e=>e.header.styleSheetId!==t))},this._ruleUsage=void 0}meta={supportedModes:["snapshot","timespan","navigation"]};async startCSSUsageTracking(e){const t=e.driver.defaultSession;t.on("CSS.styleSheetAdded",this._onStylesheetAdded),t.on("CSS.styleSheetRemoved",this._onStylesheetRemoved),await t.sendCommand("DOM.enable"),await t.sendCommand("CSS.enable"),await t.sendCommand("CSS.startRuleUsageTracking")}async startInstrumentation(e){"timespan"===e.gatherMode&&await this.startCSSUsageTracking(e)}async stopCSSUsageTracking(e){const t=e.driver.defaultSession,n=await t.sendCommand("CSS.stopRuleUsageTracking");this._ruleUsage=n.ruleUsage,t.off("CSS.styleSheetAdded",this._onStylesheetAdded),t.off("CSS.styleSheetRemoved",this._onStylesheetRemoved)}async stopInstrumentation(e){"timespan"===e.gatherMode&&await this.stopCSSUsageTracking(e)}
async getArtifact(e){const t=e.driver.defaultSession,n=e.driver.executionContext;"timespan"!==e.gatherMode&&(await this.startCSSUsageTracking(e),await n.evaluateAsync("getComputedStyle(document.body)"),await this.stopCSSUsageTracking(e));const i=this._stylesheets.map((e=>{const n=e.header.styleSheetId;return t.sendCommand("CSS.getStyleSheetText",{styleSheetId:n}).then((t=>({header:e.header,content:t.text})))})),a=await Promise.all(i);await t.sendCommand("CSS.disable"),await t.sendCommand("DOM.disable");const s=new Map(a.map((e=>[e.content,e])));if(!this._ruleUsage)throw new Error("Issue collecting rule usages");return{rules:this._ruleUsage,stylesheets:Array.from(s.values())}}}},{"../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/devtools-log-compat":[function(e,t,n){"use strict";const i=e("./devtools-log.js"),a=e("../../fraggle-rock/gather/base-gatherer.js");t.exports=class DevtoolsLogCompat extends a{meta={supportedModes:["timespan","navigation"],dependencies:{
DevtoolsLog:i.symbol}};async getArtifact(e){return{defaultPass:e.dependencies.DevtoolsLog}}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"./devtools-log.js":"../gather/gatherers/devtools-log"}],"../gather/gatherers/devtools-log":[function(e,t,n){"use strict";const i=e("../driver/network-monitor.js"),a=e("../devtools-log.js"),s=e("../../fraggle-rock/gather/base-gatherer.js");class DevtoolsLog extends s{static symbol=Symbol("DevtoolsLog");meta={symbol:DevtoolsLog.symbol,supportedModes:["timespan","navigation"]};constructor(){super(),this._networkMonitor=void 0,this._messageLog=new a(/^(Page|Network)\./),this._onProtocolMessage=e=>this._messageLog.record(e)}async startSensitiveInstrumentation({driver:e}){this._messageLog.reset(),this._messageLog.beginRecording(),this._networkMonitor=new i(e.defaultSession),this._networkMonitor.on("protocolmessage",this._onProtocolMessage),this._networkMonitor.enable()}async stopSensitiveInstrumentation(){
this._networkMonitor&&(this._messageLog.endRecording(),this._networkMonitor.disable(),this._networkMonitor.off("protocolmessage",this._onProtocolMessage))}async getArtifact(){return this._messageLog.messages}}t.exports=DevtoolsLog},{"../../fraggle-rock/gather/base-gatherer.js":61,"../devtools-log.js":64,"../driver/network-monitor.js":70}],"../gather/gatherers/dobetterweb/appcache":[function(e,t,n){"use strict";const i=e("../../../fraggle-rock/gather/base-gatherer.js");t.exports=class AppCacheManifest extends i{meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate((()=>document.documentElement&&document.documentElement.getAttribute("manifest")),{args:[],useIsolation:!0})}}},{"../../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/dobetterweb/doctype":[function(e,t,n){"use strict";const i=e("../../../fraggle-rock/gather/base-gatherer.js");function getDoctype(){if(!document.doctype)return null
;const{name:e,publicId:t,systemId:n}=document.doctype;return{name:e,publicId:t,systemId:n}}t.exports=class Doctype extends i{meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(getDoctype,{args:[],useIsolation:!0})}}},{"../../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/dobetterweb/domstats":[function(e,t,n){"use strict";const i=e("../../../fraggle-rock/gather/base-gatherer.js"),a=e("../../../lib/page-functions.js");function getDOMStats(e=document.body,t=!0){let n=null,i=-1,a=-1,s=0,c=null;const _calcDOMWidthAndHeight=function(e,l=1){l>i&&(n=e,i=l),e.children.length>a&&(c=e,a=e.children.length);let u=e.firstElementChild;for(;u;)_calcDOMWidthAndHeight(u,l+1),t&&u.shadowRoot&&_calcDOMWidthAndHeight(u.shadowRoot,l+1),u=u.nextElementSibling,s++;return{maxDepth:i,maxWidth:a,numElements:s}},l=_calcDOMWidthAndHeight(e);return{depth:{max:l.maxDepth,...getNodeDetails(n)},width:{max:l.maxWidth,...getNodeDetails(c)},
totalBodyElements:l.numElements}}t.exports=class DOMStats extends i{meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){const t=e.driver;await t.defaultSession.sendCommand("DOM.enable");const n=await t.executionContext.evaluate(getDOMStats,{args:[],useIsolation:!0,deps:[a.getNodeDetailsString]});return await t.defaultSession.sendCommand("DOM.disable"),n}}},{"../../../fraggle-rock/gather/base-gatherer.js":61,"../../../lib/page-functions.js":110}],"../gather/gatherers/dobetterweb/optimized-images":[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("../../../fraggle-rock/gather/base-gatherer.js"),s=e("../../../lib/url-shim.js"),c=e("../../../lib/network-request.js"),l=e("../../../lib/sentry.js"),u=e("../../../computed/network-records.js"),d=e("../devtools-log.js"),m=/^image\/((x|ms|x-ms)-)?(png|bmp|jpeg)$/;class OptimizedImages extends a{meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:d.symbol}};constructor(){super(),
this._encodingStartAt=0}static filterImageRequests(e){const t=new Set;return e.reduce(((e,n)=>{if(t.has(n.url)||!n.finished||n.sessionId)return e;t.add(n.url);const i=n.resourceType===c.TYPES.Image&&m.test(n.mimeType),a=c.getResourceSizeOnNetwork(n);return i&&a>4096&&e.push({requestId:n.requestId,url:n.url,mimeType:n.mimeType,resourceSize:a}),e}),[])}_getEncodedResponse(e,t,n){const i={requestId:t=c.getRequestIdForBackend(t),encoding:n,quality:"jpeg"===n?.92:.85,sizeOnly:!0};return e.sendCommand("Audits.getEncodedResponse",i)}async calculateImageStats(e,t){const n=t.resourceSize;if(Date.now()-this._encodingStartAt>5e3||n>2048e3)return{originalSize:n,jpegSize:void 0,webpSize:void 0};const i=await this._getEncodedResponse(e,t.requestId,"jpeg"),a=await this._getEncodedResponse(e,t.requestId,"webp");return{originalSize:n,jpegSize:i.encodedSize,webpSize:a.encodedSize}}async computeOptimizedImages(e,t){this._encodingStartAt=Date.now();const n=[];for(const a of t)try{const t={failed:!1,
...await this.calculateImageStats(e,a),...a};n.push(t)}catch(e){i.warn("optimized-images",e.message),l.captureException(e,{tags:{gatherer:"OptimizedImages"},extra:{imageUrl:s.elideDataURI(a.url)},level:"warning"});const t={failed:!0,errMsg:e.message,...a};n.push(t)}return n}async _getArtifact(e,t){const n=OptimizedImages.filterImageRequests(t).sort(((e,t)=>t.resourceSize-e.resourceSize)),i=await this.computeOptimizedImages(e.driver.defaultSession,n),a=i.filter((e=>!e.failed));if(i.length&&!a.length)throw new Error("All image optimizations failed");return i}async getArtifact(e){const t=e.dependencies.DevtoolsLog,n=await u.request(t,e);return this._getArtifact(e,n)}async afterPass(e,t){return this._getArtifact({...e,dependencies:{}},t.networkRecords)}}t.exports=OptimizedImages},{"../../../computed/network-records.js":40,"../../../fraggle-rock/gather/base-gatherer.js":61,"../../../lib/network-request.js":109,"../../../lib/sentry.js":112,"../../../lib/url-shim.js":"url",
"../devtools-log.js":"../gather/gatherers/devtools-log","lighthouse-logger":188}],"../gather/gatherers/dobetterweb/password-inputs-with-prevented-paste":[function(e,t,n){"use strict";const i=e("../../../fraggle-rock/gather/base-gatherer.js"),a=e("../../../lib/page-functions.js");function findPasswordInputsWithPreventedPaste(){return Array.from(document.querySelectorAll('input[type="password"]')).filter((e=>!e.dispatchEvent(new ClipboardEvent("paste",{cancelable:!0})))).map((e=>({node:getNodeDetails(e)})))}t.exports=class PasswordInputsWithPreventedPaste extends i{meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(findPasswordInputsWithPreventedPaste,{args:[],deps:[a.getNodeDetailsString]})}}},{"../../../fraggle-rock/gather/base-gatherer.js":61,"../../../lib/page-functions.js":110}],"../gather/gatherers/dobetterweb/response-compression":[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("../../../fraggle-rock/gather/base-gatherer.js"),a=e("../../../lib/url-shim.js"),s=e("../../../lib/sentry.js"),c=e("../../../lib/network-request.js"),l=e("zlib").gzip,u=e("../devtools-log.js"),{fetchResponseBodyFromCache:d}=e("../../driver/network.js"),m=e("../../../computed/network-records.js"),p=["content-encoding","x-original-content-encoding"],h=["gzip","br","deflate"],f=["image","audio","video"],g=[c.TYPES.Document,c.TYPES.Script,c.TYPES.Stylesheet,c.TYPES.XHR,c.TYPES.Fetch,c.TYPES.EventSource];class ResponseCompression extends i{meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:u.symbol}};static filterUnoptimizedResponses(e){const t=[];return e.forEach((e=>{if(e.sessionId)return;const n=e.mimeType,i=e.resourceType||c.TYPES.Other,a=e.resourceSize,s=!(n&&f.some((e=>n.startsWith(e))))&&g.includes(i),l=e.url.startsWith("chrome-extension:");if(!s||!a||!e.finished||l||!e.transferSize||304===e.statusCode)return
;(e.responseHeaders||[]).find((e=>p.includes(e.name.toLowerCase())&&h.includes(e.value)))||t.push({requestId:e.requestId,url:e.url,mimeType:n,transferSize:e.transferSize,resourceSize:a,gzipSize:0})})),t}async _getArtifact(e,t){const i=e.driver.defaultSession,c=ResponseCompression.filterUnoptimizedResponses(t);return Promise.all(c.map((e=>d(i,e.requestId).then((t=>t?new Promise(((i,a)=>l(t,((t,s)=>{if(t)return a(t);e.gzipSize=n.byteLength(s,"utf8"),i(e)})))):e)).catch((t=>(s.captureException(t,{tags:{gatherer:"ResponseCompression"},extra:{url:a.elideDataURI(e.url)},level:"warning"}),e.gzipSize=void 0,e))))))}async getArtifact(e){const t=e.dependencies.DevtoolsLog,n=await m.request(t,e);return this._getArtifact(e,n)}async afterPass(e,t){return this._getArtifact({...e,dependencies:{}},t.networkRecords)}}t.exports=ResponseCompression}).call(this)}).call(this,e("buffer").Buffer)},{"../../../computed/network-records.js":40,"../../../fraggle-rock/gather/base-gatherer.js":61,
"../../../lib/network-request.js":109,"../../../lib/sentry.js":112,"../../../lib/url-shim.js":"url","../../driver/network.js":71,"../devtools-log.js":"../gather/gatherers/devtools-log",buffer:145,zlib:135}],"../gather/gatherers/dobetterweb/tags-blocking-first-paint":[function(e,t,n){"use strict";const i=e("../../../computed/network-records.js"),a=e("../devtools-log.js"),s=e("../../../fraggle-rock/gather/base-gatherer.js");function installMediaListener(){window.___linkMediaChanges=[],Object.defineProperty(HTMLLinkElement.prototype,"media",{set:function(e){const t={href:this.href,media:e,msSinceHTMLEnd:Date.now()-performance.timing.responseEnd,matches:window.matchMedia(e).matches};window.___linkMediaChanges.push(t),this.setAttribute("media",e)}})}async function collectTagsThatBlockFirstPaint(){const e=window.___linkMediaChanges;try{const t=[...document.querySelectorAll("link")].filter((e=>{
const t="stylesheet"===e.rel&&window.matchMedia(e.media).matches&&!e.disabled,n="import"===e.rel&&!e.hasAttribute("async");return t||n})).map((t=>({tagName:"LINK",url:t.href,href:t.href,rel:t.rel,media:t.media,disabled:t.disabled,mediaChanges:e.filter((e=>e.href===t.href))}))),n=[...document.querySelectorAll("head script[src]")].filter((e=>!(e instanceof SVGScriptElement)&&!(e.hasAttribute("async")||e.hasAttribute("defer")||/^data:/.test(e.src)||/^blob:/.test(e.src)||"module"===e.getAttribute("type")))).map((e=>({tagName:"SCRIPT",url:e.src,src:e.src})));return[...t,...n]}catch(e){throw new Error(`${"Unable to gather Scripts/Stylesheets/HTML Imports on the page"}: ${e.message}`)}}class TagsBlockingFirstPaint extends s{meta={supportedModes:["navigation"],dependencies:{DevtoolsLog:a.symbol}};static _filteredAndIndexedByUrl(e){const t=new Map;for(const n of e){if(!n.finished)continue;const e="parser"===n.initiator.type,i=/(css|script)/.test(n.mimeType)&&e,a=n.failed
;(n.mimeType&&n.mimeType.includes("html")||i||a&&e)&&t.set(n.url,n)}return t}static async findBlockingTags(e,t){const n=t.reduce(((e,t)=>Math.min(e,t.endTime)),1/0),i=await e.executionContext.evaluate(collectTagsThatBlockFirstPaint,{args:[]}),a=TagsBlockingFirstPaint._filteredAndIndexedByUrl(t),s=[];for(const e of i){const t=a.get(e.url);if(!t||t.isLinkPreload)continue;let i,c=t.endTime;if("LINK"===e.tagName){const a=e.mediaChanges.filter((e=>!e.matches)).map((e=>e.msSinceHTMLEnd));if(a.length>0){const e=Math.min(...a),i=Math.max(t.startTime,n+e/1e3);c=Math.min(c,i)}i=e.mediaChanges}const{tagName:l,url:u}=e;s.push({tag:{tagName:l,url:u,mediaChanges:i},transferSize:t.transferSize,startTime:t.startTime,endTime:c}),a.delete(e.url)}return s}async startSensitiveInstrumentation(e){const{executionContext:t}=e.driver;await t.evaluateOnNewDocument(installMediaListener,{args:[]})}async getArtifact(e){const t=e.dependencies.DevtoolsLog,n=await i.request(t,e)
;return TagsBlockingFirstPaint.findBlockingTags(e.driver,n)}afterPass(e,t){return TagsBlockingFirstPaint.findBlockingTags(e.driver,t.networkRecords)}}t.exports=TagsBlockingFirstPaint},{"../../../computed/network-records.js":40,"../../../fraggle-rock/gather/base-gatherer.js":61,"../devtools-log.js":"../gather/gatherers/devtools-log"}],"../gather/gatherers/form-elements":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/page-functions.js");function collectFormElements(){const e=getElementsInDocument("textarea, input, label, select"),t=new Map,n={node:null,inputs:[],labels:[]};for(const i of e){if(i instanceof HTMLInputElement&&("submit"===i.type||"button"===i.type))continue;const e=i.form;if(!!e&&!t.has(e)){const n={attributes:{id:e.id,name:e.name,autocomplete:e.autocomplete},node:getNodeDetails(e),inputs:[],labels:[]};t.set(e,n)}const a=t.get(e)||n
;(i instanceof HTMLInputElement||i instanceof HTMLTextAreaElement||i instanceof HTMLSelectElement)&&a.inputs.push({id:i.id,name:i.name,placeholder:i instanceof HTMLSelectElement?void 0:i.placeholder,autocomplete:{property:i.autocomplete,attribute:i.getAttribute("autocomplete"),prediction:i.getAttribute("autofill-prediction")},node:getNodeDetails(i)}),i instanceof HTMLLabelElement&&a.labels.push({for:i.htmlFor,node:getNodeDetails(i)})}return(n.inputs.length>0||n.labels.length>0)&&t.set("formless",{node:n.node,inputs:n.inputs,labels:n.labels}),[...t.values()]}t.exports=class FormElements extends i{meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){const t=e.driver;return await t.executionContext.evaluate(collectFormElements,{args:[],useIsolation:!0,deps:[a.getElementsInDocumentString,a.getNodeDetailsString]})}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/page-functions.js":110}],"../gather/gatherers/full-page-screenshot":[function(e,t,n){"use strict"
;const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/emulation.js"),s=e("../../lib/page-functions.js");function snakeCaseToCamelCase(e){return e.replace(/(-\w)/g,(e=>e[1].toUpperCase()))}t.exports=class FullPageScreenshot extends i{meta={supportedModes:["snapshot","timespan","navigation"]};async getMaxScreenshotHeight(e){return await e.driver.executionContext.evaluate(s.getMaxTextureSize,{args:[],useIsolation:!0,deps:[]})}async _takeScreenshot(e){const t=e.driver.defaultSession,n=await this.getMaxScreenshotHeight(e),i=await t.sendCommand("Page.getLayoutMetrics"),a=Math.min(i.layoutViewport.clientWidth,n),s=Math.min(i.contentSize.height,n);await t.sendCommand("Emulation.setDeviceMetricsOverride",{mobile:e.settings.screenEmulation.mobile,height:s,width:a,deviceScaleFactor:1,scale:1,screenOrientation:{angle:0,type:"portraitPrimary"}});return{data:"data:image/jpeg;base64,"+(await t.sendCommand("Page.captureScreenshot",{format:"jpeg",quality:30})).data,width:a,height:s}}
async _resolveNodes(e){function resolveNodes(){const e={};if(!window.__lighthouseNodesDontTouchOrAllVarianceGoesAway)return e;const t=window.__lighthouseNodesDontTouchOrAllVarianceGoesAway;for(const[n,i]of t.entries()){const t=getBoundingClientRect(n);e[i]=t}return e}function resolveNodesInPage({useIsolation:t}){return e.driver.executionContext.evaluate(resolveNodes,{args:[],useIsolation:t,deps:[s.getBoundingClientRectString]})}return{...await resolveNodesInPage({useIsolation:!1}),...await resolveNodesInPage({useIsolation:!0})}}async getArtifact(e){const t=e.driver.defaultSession,n=e.driver.executionContext,i=e.settings,s=!i.screenEmulation.disabled;try{return{screenshot:await this._takeScreenshot(e),nodes:await this._resolveNodes(e)}}finally{if(s)await a.emulate(t,i);else{const e=await n.evaluate((function getObservedDeviceMetrics(){const e=snakeCaseToCamelCase(window.screen.orientation.type);return{width:document.documentElement.clientWidth,
height:document.documentElement.clientHeight,screenOrientation:{type:e,angle:window.screen.orientation.angle},deviceScaleFactor:window.devicePixelRatio}}),{args:[],useIsolation:!0,deps:[snakeCaseToCamelCase]});await t.sendCommand("Emulation.setDeviceMetricsOverride",{mobile:"mobile"===i.formFactor,...e})}}}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/emulation.js":97,"../../lib/page-functions.js":110}],"../gather/gatherers/global-listeners":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js");class GlobalListeners extends i{meta={supportedModes:["snapshot","timespan","navigation"]};static _filterForAllowlistedTypes(e){return"pagehide"===e.type||"unload"===e.type||"visibilitychange"===e.type}getListenerIndentifier(e){return`${e.type}:${e.scriptId}:${e.columnNumber}:${e.lineNumber}`}dedupeListeners(e){const t=new Set;return e.filter((e=>{const n=this.getListenerIndentifier(e);return!t.has(n)&&(t.add(n),!0)}))}async getArtifact(e){
const t=e.driver.defaultSession,{result:{objectId:n}}=await t.sendCommand("Runtime.evaluate",{expression:"window",returnByValue:!1});if(!n)throw new Error("Error fetching information about the global object");const{listeners:i}=await t.sendCommand("DOMDebugger.getEventListeners",{objectId:n}),a=i.filter(GlobalListeners._filterForAllowlistedTypes).map((e=>{const{type:t,scriptId:n,lineNumber:i,columnNumber:a}=e;return{type:t,scriptId:n,lineNumber:i,columnNumber:a}}));return this.dedupeListeners(a)}}t.exports=GlobalListeners},{"../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/http-redirect":[function(e,t,n){"use strict";const i=e("./gatherer.js");t.exports=class HTTPRedirect extends i{constructor(){super(),this._preRedirectURL=""}beforePass(e){this._preRedirectURL=e.url,e.url=this._preRedirectURL.replace(/^https/,"http")}async afterPass(e){e.url=this._preRedirectURL;const t=e.driver.executionContext;return{
value:await t.evaluateAsync("new URL(window.location).protocol === 'https:'",{useIsolation:!0})}}}},{"./gatherer.js":79}],"../gather/gatherers/iframe-elements":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/page-functions.js");function collectIFrameElements(){return getElementsInDocument("iframe").map((e=>{const t=e.getBoundingClientRect(),{top:n,bottom:i,left:a,right:s,width:c,height:l}=t;return{id:e.id,src:e.src,clientRect:{top:n,bottom:i,left:a,right:s,width:c,height:l},isPositionFixed:isPositionFixed(e),node:getNodeDetails(e)}}))}t.exports=class IFrameElements extends i{meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){const t=e.driver;return await t.executionContext.evaluate(collectIFrameElements,{args:[],useIsolation:!0,deps:[a.getElementsInDocumentString,a.isPositionFixedString,a.getNodeDetailsString]})}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/page-functions.js":110}],
"../gather/gatherers/image-elements":[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("../../fraggle-rock/gather/base-gatherer.js"),s=e("../../lib/page-functions.js"),c=e("../../lib/url-shim.js"),l=e("./seo/font-size.js");function getClientRect(e){const t=e.getBoundingClientRect();return{top:t.top,bottom:t.bottom,left:t.left,right:t.right}}function getPosition(e,t){if(e.parentElement&&"PICTURE"===e.parentElement.tagName){return window.getComputedStyle(e.parentElement).getPropertyValue("position")}return t.getPropertyValue("position")}function getHTMLImages(e){return e.filter((e=>"img"===e.localName)).map((e=>{const t=window.getComputedStyle(e),n=!!e.parentElement&&"PICTURE"===e.parentElement.tagName,i=!n&&!e.srcset;return{src:e.currentSrc,srcset:e.srcset,displayedWidth:e.width,displayedHeight:e.height,clientRect:getClientRect(e),attributeWidth:e.getAttribute("width"),attributeHeight:e.getAttribute("height"),naturalDimensions:i?{width:e.naturalWidth,
height:e.naturalHeight}:void 0,cssRules:void 0,computedStyles:{position:getPosition(e,t),objectFit:t.getPropertyValue("object-fit"),imageRendering:t.getPropertyValue("image-rendering")},isCss:!1,isPicture:n,loading:e.loading,isInShadowDOM:e.getRootNode()instanceof ShadowRoot,node:getNodeDetails(e)}}))}function getCSSImages(e){const t=/^url\("([^"]+)"\)$/,n=[];for(const i of e){const e=window.getComputedStyle(i);if(!e.backgroundImage||!t.test(e.backgroundImage))continue;const a=e.backgroundImage.match(t)[1];n.push({src:a,srcset:"",displayedWidth:i.clientWidth,displayedHeight:i.clientHeight,clientRect:getClientRect(i),attributeWidth:null,attributeHeight:null,naturalDimensions:void 0,cssEffectiveRules:void 0,computedStyles:{position:getPosition(i,e),objectFit:"",imageRendering:e.getPropertyValue("image-rendering")},isCss:!0,isPicture:!1,isInShadowDOM:i.getRootNode()instanceof ShadowRoot,node:getNodeDetails(i)})}return n}function collectImageElementInfo(){const e=getElementsInDocument()
;return getHTMLImages(e).concat(getCSSImages(e))}function determineNaturalSize(e){return new Promise(((t,n)=>{const i=new Image;i.addEventListener("error",(e=>n(new Error("determineNaturalSize failed img load")))),i.addEventListener("load",(()=>{t({naturalWidth:i.naturalWidth,naturalHeight:i.naturalHeight})})),i.src=e}))}function findSizeDeclaration(e,t){if(!e||!e.cssProperties)return;const n=e.cssProperties.find((({name:e})=>e===t));return n?n.value:void 0}function getEffectiveSizingRule({attributesStyle:e,inlineStyle:t,matchedCSSRules:n},i){const a=findSizeDeclaration(t,i);if(a)return a;const s=findSizeDeclaration(e,i);if(s)return s;const c=function findMostSpecificCSSRule(e,t){const n=l.findMostSpecificMatchedCSSRule(e,(e=>findSizeDeclaration(e,t)));if(n)return findSizeDeclaration(n,t)}(n,i);return c||null}function getPixelArea(e){return e.naturalDimensions?e.naturalDimensions.height*e.naturalDimensions.width:e.displayedHeight*e.displayedWidth}
t.exports=class ImageElements extends a{meta={supportedModes:["snapshot","timespan","navigation"]};constructor(){super(),this._naturalSizeCache=new Map}async fetchElementWithSizeInformation(e,t){const n=t.src;let i=this._naturalSizeCache.get(n);if(!i)try{e.defaultSession.setNextProtocolTimeout(250),i=await e.executionContext.evaluate(determineNaturalSize,{args:[n]}),this._naturalSizeCache.set(n,i)}catch(e){}i&&(t.naturalDimensions={width:i.naturalWidth,height:i.naturalHeight})}async fetchSourceRules(e,t,n){try{const{nodeId:i}=await e.sendCommand("DOM.pushNodeByPathToFrontend",{path:t});if(!i)return;const a=await e.sendCommand("CSS.getMatchedStylesForNode",{nodeId:i}),s=getEffectiveSizingRule(a,"width"),c=getEffectiveSizingRule(a,"height"),l=getEffectiveSizingRule(a,"aspect-ratio");n.cssEffectiveRules={width:s,height:c,aspectRatio:l}}catch(e){if(/No node.*found/.test(e.message))return;throw e}}async collectExtraDetails(e,t){let n=!1;setTimeout((e=>n=!0),5e3);let a=0
;for(const i of t)i.mimeType=c.guessMimeType(i.src),n?a++:(i.isInShadowDOM||i.isCss||await this.fetchSourceRules(e.defaultSession,i.node.devtoolsNodePath,i),(i.isPicture||i.isCss||i.srcset)&&await this.fetchElementWithSizeInformation(e,i));n&&i.warn("ImageElements",`Reached gathering budget of 5s. Skipped extra details for ${a}/${t.length}`)}async getArtifact(e){const t=e.driver.defaultSession,n=e.driver.executionContext,i=await n.evaluate(collectImageElementInfo,{args:[],deps:[s.getElementsInDocumentString,s.getBoundingClientRectString,s.getNodeDetailsString,getClientRect,getPosition,getHTMLImages,getCSSImages]});return await Promise.all([t.sendCommand("DOM.enable"),t.sendCommand("CSS.enable"),t.sendCommand("DOM.getDocument",{depth:-1,pierce:!0})]),i.sort(((e,t)=>getPixelArea(t)-getPixelArea(e))),await this.collectExtraDetails(e.driver,i),await Promise.all([t.sendCommand("DOM.disable"),t.sendCommand("CSS.disable")]),i}}},{"../../fraggle-rock/gather/base-gatherer.js":61,
"../../lib/page-functions.js":110,"../../lib/url-shim.js":"url","./seo/font-size.js":"../gather/gatherers/seo/font-size","lighthouse-logger":188}],"../gather/gatherers/inspector-issues":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../computed/network-records.js"),s=e("./devtools-log.js");t.exports=class InspectorIssues extends i{meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:s.symbol}};constructor(){super(),this._issues=[],this._onIssueAdded=this.onIssueAdded.bind(this)}onIssueAdded(e){this._issues.push(e.issue)}async startInstrumentation(e){const t=e.driver.defaultSession;t.on("Audits.issueAdded",this._onIssueAdded),await t.sendCommand("Audits.enable")}async stopInstrumentation(e){const t=e.driver.defaultSession;t.off("Audits.issueAdded",this._onIssueAdded),await t.sendCommand("Audits.disable")}async _getArtifact(e){const t={mixedContent:[],sameSiteCookies:[],blockedByResponse:[],heavyAds:[],
contentSecurityPolicy:[]};for(const n of this._issues){if(n.details.mixedContentIssueDetails){const i=n.details.mixedContentIssueDetails,a=i.request&&i.request.requestId;a&&e.find((e=>e.requestId===a))&&t.mixedContent.push(i)}if(n.details.sameSiteCookieIssueDetails){const i=n.details.sameSiteCookieIssueDetails,a=i.request&&i.request.requestId;a&&e.find((e=>e.requestId===a))&&t.sameSiteCookies.push(i)}if(n.details.blockedByResponseIssueDetails){const i=n.details.blockedByResponseIssueDetails,a=i.request&&i.request.requestId;a&&e.find((e=>e.requestId===a))&&t.blockedByResponse.push(i)}n.details.heavyAdIssueDetails&&t.heavyAds.push(n.details.heavyAdIssueDetails),n.details.contentSecurityPolicyIssueDetails&&t.contentSecurityPolicy.push(n.details.contentSecurityPolicyIssueDetails)}return t}async getArtifact(e){const t=e.dependencies.DevtoolsLog,n=await a.request(t,e);return this._getArtifact(n)}async afterPass(e,t){return await this.stopInstrumentation({...e,dependencies:{}}),
this._getArtifact(t.networkRecords)}}},{"../../computed/network-records.js":40,"../../fraggle-rock/gather/base-gatherer.js":61,"./devtools-log.js":"../gather/gatherers/devtools-log"}],"../gather/gatherers/installability-errors":[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("../../fraggle-rock/gather/base-gatherer.js");class InstallabilityErrors extends a{meta={supportedModes:["snapshot","navigation"]};static async getInstallabilityErrors(e){const t={msg:"Get webapp installability errors",id:"lh:gather:getInstallabilityErrors"};i.time(t);const n=(await e.sendCommand("Page.getInstallabilityErrors")).installabilityErrors;return i.timeEnd(t),{errors:n}}getArtifact(e){const t=e.driver;return InstallabilityErrors.getInstallabilityErrors(t.defaultSession)}}t.exports=InstallabilityErrors},{"../../fraggle-rock/gather/base-gatherer.js":61,"lighthouse-logger":188}],"../gather/gatherers/js-usage":[function(e,t,n){"use strict"
;const i=e("../../fraggle-rock/gather/base-gatherer.js");t.exports=class JsUsage extends i{meta={supportedModes:["snapshot","timespan","navigation"]};constructor(){super(),this._scriptParsedEvents=[],this._scriptUsages=[],this.onScriptParsed=this.onScriptParsed.bind(this)}onScriptParsed(e){e.embedderName&&this._scriptParsedEvents.push(e)}async startInstrumentation(e){const t=e.driver.defaultSession;await t.sendCommand("Profiler.enable"),await t.sendCommand("Profiler.startPreciseCoverage",{detailed:!1})}async stopInstrumentation(e){const t=e.driver.defaultSession,n=await t.sendCommand("Profiler.takePreciseCoverage");this._scriptUsages=n.result,await t.sendCommand("Profiler.stopPreciseCoverage"),await t.sendCommand("Profiler.disable")}async startSensitiveInstrumentation(e){const t=e.driver.defaultSession;t.on("Debugger.scriptParsed",this.onScriptParsed),await t.sendCommand("Debugger.enable")}async stopSensitiveInstrumentation(e){const t=e.driver.defaultSession
;await t.sendCommand("Debugger.disable"),t.off("Debugger.scriptParsed",this.onScriptParsed)}_addMissingScriptIds(e){for(const t of this._scriptParsedEvents){const n=t.embedderName;if(!n)continue;const i=e[n]||[];i.find((e=>e.scriptId===t.scriptId))||i.push({url:n,scriptId:t.scriptId,functions:[]}),e[n]=i}}async getArtifact(e){const t={};"snapshot"===e.gatherMode&&(await this.startSensitiveInstrumentation(e),await this.stopSensitiveInstrumentation(e));for(const e of this._scriptUsages){let n=e.url;const i=this._scriptParsedEvents.find((t=>t.scriptId===e.scriptId));if(i&&i.embedderName&&(n=i.embedderName),""===e.url||i&&""===i.embedderName)continue;const a=t[n]||[];a.push(e),t[n]=a}return"navigation"!==e.gatherMode&&this._addMissingScriptIds(t),t}}},{"../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/link-elements":[function(e,t,n){"use strict"
;const i=e("http-link-header"),a=e("../../fraggle-rock/gather/base-gatherer.js"),{URL:s}=e("../../lib/url-shim.js"),c=e("../../computed/network-records.js"),l=e("../../lib/dependency-graph/simulator/network-analyzer.js"),u=e("../../lib/page-functions.js"),d=e("./devtools-log.js");function normalizeUrlOrNull(e,t){try{return new s(e,t).href}catch(e){return null}}function getLinkElementsInDOM(){const e=getElementsInDocument("link"),t=[];for(const n of e){if(!(n instanceof HTMLLinkElement))continue;const e=n.getAttribute("href")||"",i=n.closest("head")?"head":"body";t.push({rel:n.rel,href:n.href,hreflang:n.hreflang,as:n.as,crossOrigin:n.crossOrigin,hrefRaw:e,source:i,node:getNodeDetails(n)})}return t}class LinkElements extends a{constructor(){super(),this.meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:d.symbol}}}static getLinkElementsInDOM(e){return e.driver.executionContext.evaluate(getLinkElementsInDOM,{args:[],useIsolation:!0,
deps:[u.getNodeDetailsString,u.getElementsInDocument]})}static getLinkElementsInHeaders(e,t){const n=e.url,a=l.findMainDocument(t,n),s=[];for(const e of a.responseHeaders)if("link"===e.name.toLowerCase())for(const t of i.parse(e.value).refs)s.push({rel:t.rel||"",href:normalizeUrlOrNull(t.uri,n),hrefRaw:t.uri||"",hreflang:t.hreflang||"",as:t.as||"",crossOrigin:(c=t.crossorigin,"anonymous"===c?"anonymous":"use-credentials"===c?"use-credentials":null),source:"headers",node:null});var c;return s}async _getArtifact(e,t){const n=await LinkElements.getLinkElementsInDOM(e),i=LinkElements.getLinkElementsInHeaders(e,t),a=n.concat(i);for(const e of a)e.rel=e.rel.toLowerCase();return a}async afterPass(e,t){return this._getArtifact({...e,dependencies:{}},t.networkRecords)}async getArtifact(e){const t=await c.request(e.dependencies.DevtoolsLog,e);return this._getArtifact(e,t)}}t.exports=LinkElements},{"../../computed/network-records.js":40,"../../fraggle-rock/gather/base-gatherer.js":61,
"../../lib/dependency-graph/simulator/network-analyzer.js":93,"../../lib/page-functions.js":110,"../../lib/url-shim.js":"url","./devtools-log.js":"../gather/gatherers/devtools-log","http-link-header":170}],"../gather/gatherers/main-document-content":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/dependency-graph/simulator/network-analyzer.js"),s=e("../../computed/network-records.js"),c=e("./devtools-log.js"),{fetchResponseBodyFromCache:l}=e("../driver/network.js");t.exports=class MainDocumentContent extends i{meta={supportedModes:["navigation"],dependencies:{DevtoolsLog:c.symbol}};async _getArtifact(e,t){const n=a.findMainDocument(t,e.url),i=e.driver.defaultSession;return l(i,n.requestId)}async getArtifact(e){const t=e.dependencies.DevtoolsLog,n=await s.request(t,e);return this._getArtifact(e,n)}async afterPass(e,t){return this._getArtifact({...e,dependencies:{}},t.networkRecords)}}},{"../../computed/network-records.js":40,
"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/dependency-graph/simulator/network-analyzer.js":93,"../driver/network.js":71,"./devtools-log.js":"../gather/gatherers/devtools-log"}],"../gather/gatherers/meta-elements":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/page-functions.js");function collectMetaElements(){const e={getElementsInDocument,getNodeDetails};return e.getElementsInDocument("head meta").map((t=>{const getAttribute=e=>{const n=t.attributes.getNamedItem(e);if(n)return n.value};return{name:t.name.toLowerCase(),content:t.content,property:getAttribute("property"),httpEquiv:t.httpEquiv?t.httpEquiv.toLowerCase():void 0,charset:getAttribute("charset"),node:e.getNodeDetails(t)}}))}t.exports=class MetaElements extends i{meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(collectMetaElements,{args:[],useIsolation:!0,
deps:[a.getElementsInDocument,a.getNodeDetailsString]})}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/page-functions.js":110}],"../gather/gatherers/network-user-agent":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("./devtools-log.js");class NetworkUserAgent extends i{meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:a.symbol}};static getNetworkUserAgent(e){for(const t of e){if("Network.requestWillBeSent"!==t.method)continue;const e=t.params.request.headers["User-Agent"];if(e)return e}return""}async getArtifact(e){return NetworkUserAgent.getNetworkUserAgent(e.dependencies.DevtoolsLog)}}t.exports=NetworkUserAgent},{"../../fraggle-rock/gather/base-gatherer.js":61,"./devtools-log.js":"../gather/gatherers/devtools-log"}],"../gather/gatherers/script-elements":[function(e,t,n){"use strict"
;const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../computed/network-records.js"),s=e("../../lib/dependency-graph/simulator/network-analyzer.js"),c=e("../../lib/network-request.js"),l=e("../../lib/page-functions.js"),{fetchResponseBodyFromCache:u}=e("../driver/network.js"),d=e("./devtools-log.js");function collectAllScriptElements(){return getElementsInDocument("script").map((e=>({type:e.type||null,src:e.src||null,id:e.id||null,async:e.async,defer:e.defer,source:e.closest("head")?"head":"body",content:e.src?null:e.text,requestId:null,node:getNodeDetails(e)})))}t.exports=class ScriptElements extends i{meta={supportedModes:["timespan","navigation"],dependencies:{DevtoolsLog:d.symbol}};async _getArtifact(e,t,n){const i=e.driver.defaultSession,a=e.driver.executionContext,d=s.findOptionalMainDocument(t,e.url),m=await a.evaluate(collectAllScriptElements,{args:[],useIsolation:!0,deps:[l.getNodeDetailsString,l.getElementsInDocument]})
;for(const e of m)d&&e.content&&(e.requestId=d.requestId);const p=t.filter((e=>!e.sessionId)).filter((e=>e.resourceType===c.TYPES.Script)),h=await async function runInSeriesOrParallel(e,t,n){if(n){const n=[];for(const i of e){const e=await t(i);n.push(e)}return n}{const n=e.map(t);return await Promise.all(n)}}(p,(e=>u(i,e.requestId).catch((()=>""))),"mobile"===n);for(let e=0;e<p.length;e++){const t=p[e],n=h[e];if(!n)continue;const i=m.find((e=>e.src===t.url));i?(i.requestId=t.requestId,i.content=n):m.push({type:null,src:t.url,id:null,async:!1,defer:!1,source:"network",requestId:t.requestId,content:n,node:null})}return m}async getArtifact(e){const t=e.dependencies.DevtoolsLog,n=e.baseArtifacts.HostFormFactor,i=await a.request(t,e);return this._getArtifact(e,i,n)}async afterPass(e,t){const n=t.networkRecords,i=e.baseArtifacts.HostFormFactor;return this._getArtifact({...e,dependencies:{}},n,i)}}},{"../../computed/network-records.js":40,"../../fraggle-rock/gather/base-gatherer.js":61,
"../../lib/dependency-graph/simulator/network-analyzer.js":93,"../../lib/network-request.js":109,"../../lib/page-functions.js":110,"../driver/network.js":71,"./devtools-log.js":"../gather/gatherers/devtools-log"}],"../gather/gatherers/seo/embedded-content":[function(e,t,n){"use strict";const i=e("../../../fraggle-rock/gather/base-gatherer.js"),a=e("../../../lib/page-functions.js");function getEmbeddedContent(){const e={getElementsInDocument,getNodeDetails};return e.getElementsInDocument("object, embed, applet").map((t=>({tagName:t.tagName,type:t.getAttribute("type"),src:t.getAttribute("src"),data:t.getAttribute("data"),code:t.getAttribute("code"),params:Array.from(t.children).filter((e=>"PARAM"===e.tagName)).map((e=>({name:e.getAttribute("name")||"",value:e.getAttribute("value")||""}))),node:e.getNodeDetails(t)})))}t.exports=class EmbeddedContent extends i{meta={supportedModes:["snapshot","navigation"]};getArtifact(e){return e.driver.executionContext.evaluate(getEmbeddedContent,{
args:[],deps:[a.getElementsInDocument,a.getNodeDetailsString]})}}},{"../../../fraggle-rock/gather/base-gatherer.js":61,"../../../lib/page-functions.js":110}],"../gather/gatherers/seo/font-size":[function(e,t,n){"use strict";const i=e("../../../fraggle-rock/gather/base-gatherer.js");function hasFontSizeDeclaration(e){return!!e&&!!e.cssProperties.find((({name:e})=>"font-size"===e))}function computeSelectorSpecificity(e){const t=e.split(" ");let n=0,i=0,a=0;for(const e of t){const t=e.match(/\b#[a-z0-9]+/g)||[],s=e.match(/\b\.[a-z0-9]+/g)||[],c=e.match(/^[a-z]+/)?[1]:[];n+=t.length,i+=s.length,a+=c.length}return 100*Math.min(9,n)+10*Math.min(9,i)+Math.min(9,a)}function findMostSpecificMatchedCSSRule(e=[],t){let n,i=-1/0;for(const{rule:a,matchingSelectors:s}of e)if(t(a.style)){const e=s.map((e=>computeSelectorSpecificity(a.selectorList.selectors[e].text))),t=Math.max(...e);t>=i&&(i=t,n=a)}if(n)return{type:"Regular",...n.style,parentRule:{origin:n.origin,selectors:n.selectorList.selectors}}
}function getEffectiveFontRule({attributesStyle:e,inlineStyle:t,matchedCSSRules:n,inherited:i}){if(hasFontSizeDeclaration(t))return{type:"Inline",...t};const a=findMostSpecificMatchedCSSRule(n,hasFontSizeDeclaration);if(a)return a;if(hasFontSizeDeclaration(e))return{type:"Attributes",...e};const s=function findInheritedCSSRule(e=[]){for(const{inlineStyle:t,matchedCSSRules:n}of e){if(hasFontSizeDeclaration(t))return{type:"Inline",...t};const e=findMostSpecificMatchedCSSRule(n,hasFontSizeDeclaration);if(e)return e}}(i);return s||void 0}function getTextLength(e){return e?Array.from(e.trim()).length:0}class FontSize extends i{meta={supportedModes:["snapshot","navigation"]};static async fetchFailingNodeSourceRules(e,t){const n=t.sort(((e,t)=>t.textLength-e.textLength)).slice(0,50);await e.sendCommand("DOM.getDocument",{depth:-1,pierce:!0});const{nodeIds:i}=await e.sendCommand("DOM.pushNodesByBackendIdsToFrontend",{backendNodeIds:n.map((e=>e.parentNode.backendNodeId))
}),a=n.map((async(t,n)=>{t.nodeId=i[n];try{const a=await async function fetchSourceRule(e,t){const n=getEffectiveFontRule(await e.sendCommand("CSS.getMatchedStylesForNode",{nodeId:t}));if(n)return{type:n.type,range:n.range,styleSheetId:n.styleSheetId,parentRule:n.parentRule&&{origin:n.parentRule.origin,selectors:n.parentRule.selectors}}}(e,i[n]);t.cssRule=a}catch(e){t.cssRule=void 0}return t})),s=await Promise.all(a),c=s.reduce(((e,{textLength:t})=>e+t),0);return{analyzedFailingNodesData:s,analyzedFailingTextLength:c}}getTextNodesInLayoutFromSnapshot(e){const t=e.strings,getString=e=>t[e],n=[];for(let i=0;i<e.documents.length;i++){const a=e.documents[i];if(!(a.nodes.backendNodeId&&a.nodes.parentIndex&&a.nodes.attributes&&a.nodes.nodeName))throw new Error("Unexpected response from DOMSnapshot.captureSnapshot.");const s=a.nodes,getParentData=e=>({backendNodeId:s.backendNodeId[e],attributes:s.attributes[e].map(getString),nodeName:getString(s.nodeName[e])})
;for(const e of a.textBoxes.layoutIndex){const i=t[a.layout.text[e]];if(!i)continue;const c=a.layout.nodeIndex[e],l=a.layout.styles[e],[u]=l,d=parseFloat(t[u]),m=s.parentIndex[c],p=s.parentIndex[m],h=getParentData(m),f=void 0!==p?getParentData(p):void 0;n.push({nodeIndex:c,backendNodeId:s.backendNodeId[c],fontSize:d,textLength:getTextLength(i),parentNode:{...h,parentNode:f}})}}return n}findFailingNodes(e){const t=[];let n=0,i=0;for(const a of this.getTextNodesInLayoutFromSnapshot(e))n+=a.textLength,a.fontSize<12&&(i+=a.textLength,t.push({nodeId:0,parentNode:a.parentNode,textLength:a.textLength,fontSize:a.fontSize}));return{totalTextLength:n,failingTextLength:i,failingNodes:t}}async getArtifact(e){const t=e.driver.defaultSession,n=new Map,onStylesheetAdded=e=>n.set(e.header.styleSheetId,e.header);t.on("CSS.styleSheetAdded",onStylesheetAdded),await Promise.all([t.sendCommand("DOMSnapshot.enable"),t.sendCommand("DOM.enable"),t.sendCommand("CSS.enable")])
;const i=await t.sendCommand("DOMSnapshot.captureSnapshot",{computedStyles:["font-size"]}),{totalTextLength:a,failingTextLength:s,failingNodes:c}=this.findFailingNodes(i),{analyzedFailingNodesData:l,analyzedFailingTextLength:u}=await FontSize.fetchFailingNodeSourceRules(t,c);return t.off("CSS.styleSheetAdded",onStylesheetAdded),l.filter((e=>e.cssRule&&e.cssRule.styleSheetId)).forEach((e=>e.cssRule.stylesheet=n.get(e.cssRule.styleSheetId))),await Promise.all([t.sendCommand("DOMSnapshot.disable"),t.sendCommand("DOM.disable"),t.sendCommand("CSS.disable")]),{analyzedFailingNodesData:l,analyzedFailingTextLength:u,failingTextLength:s,totalTextLength:a}}}t.exports=FontSize,t.exports.computeSelectorSpecificity=computeSelectorSpecificity,t.exports.getEffectiveFontRule=getEffectiveFontRule,t.exports.findMostSpecificMatchedCSSRule=findMostSpecificMatchedCSSRule},{"../../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/seo/robots-txt":[function(e,t,n){"use strict"
;const i=e("../../../fraggle-rock/gather/base-gatherer.js");async function getRobotsTxtContent(){try{const e=await fetch(new URL("/robots.txt",location.href).href);if(!e.ok)return{status:e.status,content:null};const t=await e.text();return{status:e.status,content:t}}catch(e){return{status:null,content:null,errorMessage:e.message}}}t.exports=class RobotsTxt extends i{meta={supportedModes:["snapshot","navigation"]};async getArtifact(e){if(await e.driver.fetcher.shouldUseLegacyFetcher())return e.driver.executionContext.evaluate(getRobotsTxtContent,{args:[],useIsolation:!0});const t=new URL("/robots.txt",e.url).href;return await e.driver.fetcher.enable(),e.driver.fetcher.fetchResource(t).catch((e=>({status:null,content:null,errorMessage:e.message})))}}},{"../../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/seo/tap-targets":[function(e,t,n){"use strict"
;const i=e("../../../fraggle-rock/gather/base-gatherer.js"),a=e("../../../lib/page-functions.js"),s=e("../../../lib/rect-helpers.js"),c=["button","a","input","textarea","select","option","[role=button]","[role=checkbox]","[role=link]","[role=menuitem]","[role=menuitemcheckbox]","[role=menuitemradio]","[role=option]","[role=scrollbar]","[role=slider]","[role=spinbutton]"].join(",");function elementIsVisible(e){return!!(e.offsetWidth||e.offsetHeight||e.getClientRects().length)}function getClientRects(e){const t=Array.from(e.getClientRects()).map((e=>{const{width:t,height:n,left:i,top:a,right:s,bottom:c}=e;return{width:t,height:n,left:i,top:a,right:s,bottom:c}}));for(const n of e.children)t.push(...getClientRects(n));return t}function elementHasAncestorTapTarget(e,t){return!!e.parentElement&&(!!e.parentElement.matches(t)||elementHasAncestorTapTarget(e.parentElement,t))}function hasTextNodeSiblingsFormingTextBlock(e){if(!e.parentElement)return!1;const t=e.parentElement,n=e.textContent||""
;if((t.textContent||"").length-n.length<5)return!1;for(const t of e.parentElement.childNodes){if(t===e)continue;const n=(t.textContent||"").trim();if(t.nodeType===Node.TEXT_NODE&&n.length>0)return!0}return!1}function elementIsInTextBlock(e){const{display:t}=getComputedStyle(e);return("inline"===t||"inline-block"===t)&&(!!hasTextNodeSiblingsFormingTextBlock(e)||!!e.parentElement&&elementIsInTextBlock(e.parentElement))}function elementCenterIsAtZAxisTop(e,t){const n=window.innerHeight,i=Math.floor(t.y/n)*n;window.scrollY!==i&&window.scrollTo(0,i);const a=document.elementFromPoint(t.x,t.y-window.scrollY);return a===e||e.contains(a)}function disableFixedAndStickyElementPointerEvents(e){return document.querySelectorAll("*").forEach((t=>{const n=getComputedStyle(t).position;"fixed"!==n&&"sticky"!==n||t.classList.add(e)})),function undo(){Array.from(document.getElementsByClassName(e)).forEach((t=>{t.classList.remove(e)}))}}function gatherTapTargets(e,t){const n=[];window.scrollTo(0,0)
;const i=getElementsInDocument(e),a=[];i.forEach((t=>{elementHasAncestorTapTarget(t,e)||elementIsInTextBlock(t)||elementIsVisible(t)&&a.push({tapTargetElement:t,clientRects:getClientRects(t)})}));const s=disableFixedAndStickyElementPointerEvents(t),c=[];a.forEach((({tapTargetElement:e,clientRects:t})=>{let n=t.filter((e=>0!==e.width&&0!==e.height));n=n.filter((t=>{const n=getRectCenterPoint(t);return elementCenterIsAtZAxisTop(e,n)})),n.length>0&&c.push({tapTargetElement:e,visibleClientRects:n})}));for(const{tapTargetElement:e,visibleClientRects:t}of c)n.push({clientRects:t,href:e.href||"",node:getNodeDetails(e)});return s(),n}t.exports=class TapTargets extends i{constructor(){super(),this.meta={supportedModes:["snapshot","navigation"]}}async addStyleRule(e,t){const n=await e.sendCommand("Page.getFrameTree"),{styleSheetId:i}=await e.sendCommand("CSS.createStyleSheet",{frameId:n.frameTree.frame.id}),a=`.${t} { pointer-events: none !important }`
;return await e.sendCommand("CSS.setStyleSheetText",{styleSheetId:i,text:a}),i}async removeStyleRule(e,t){await e.sendCommand("CSS.setStyleSheetText",{styleSheetId:t,text:""})}async getArtifact(e){const t=e.driver.defaultSession;await t.sendCommand("DOM.enable"),await t.sendCommand("CSS.enable");const n="lighthouse-disable-pointer-events",i=await this.addStyleRule(t,n),l=await e.driver.executionContext.evaluate(gatherTapTargets,{args:[c,n],useIsolation:!0,deps:[a.getNodeDetailsString,a.getElementsInDocument,disableFixedAndStickyElementPointerEvents,elementIsVisible,elementHasAncestorTapTarget,elementCenterIsAtZAxisTop,getClientRects,hasTextNodeSiblingsFormingTextBlock,elementIsInTextBlock,s.getRectCenterPoint,a.getNodePath,a.getNodeSelector,a.getNodeLabel]});return await this.removeStyleRule(t,i),await t.sendCommand("CSS.disable"),await t.sendCommand("DOM.disable"),l}}},{"../../../fraggle-rock/gather/base-gatherer.js":61,"../../../lib/page-functions.js":110,
"../../../lib/rect-helpers.js":111}],"../gather/gatherers/service-worker":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../driver/service-workers.js");t.exports=class ServiceWorker extends i{meta={supportedModes:["navigation"]};async beforePass(e){return this.getArtifact({...e,dependencies:{}})}async afterPass(){}async getArtifact(e){const t=e.driver.defaultSession,{versions:n}=await a.getServiceWorkerVersions(t),{registrations:i}=await a.getServiceWorkerRegistrations(t);return{versions:n,registrations:i}}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"../driver/service-workers.js":73}],"../gather/gatherers/source-maps":[function(e,t,n){(function(n){(function(){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/url-shim.js");t.exports=class SourceMaps extends i{meta={supportedModes:["timespan","navigation"]};constructor(){super(),this._scriptParsedEvents=[],
this.onScriptParsed=this.onScriptParsed.bind(this)}async fetchSourceMap(e,t){const n=await e.fetcher.fetchResource(t,{timeout:1500});if(null===n.content)throw new Error(`Failed fetching source map (${n.status})`);return JSON.parse(n.content)}parseSourceMapFromDataUrl(e){const t=n.from(e.split(",")[1],"base64");return JSON.parse(t.toString())}onScriptParsed(e){e.sourceMapURL&&this._scriptParsedEvents.push(e)}_resolveUrl(e,t){try{return new a(e,t).href}catch(e){return}}async _retrieveMapFromScriptParsedEvent(e,t){if(!t.sourceMapURL)throw new Error("precondition failed: event.sourceMapURL should exist");const n=t.sourceMapURL.startsWith("data:"),i=t.url,a=n?t.sourceMapURL:this._resolveUrl(t.sourceMapURL,t.url);if(!a)return{scriptUrl:i,errorMessage:"Could not resolve map url: "+t.sourceMapURL};const s=n?void 0:a;try{const t=n?this.parseSourceMapFromDataUrl(a):await this.fetchSourceMap(e,a);return t.sections&&(t.sections=t.sections.filter((e=>e.map))),{scriptUrl:i,sourceMapUrl:s,map:t}
}catch(e){return{scriptUrl:i,sourceMapUrl:s,errorMessage:e.toString()}}}async startSensitiveInstrumentation(e){const t=e.driver.defaultSession;t.on("Debugger.scriptParsed",this.onScriptParsed),await t.sendCommand("Debugger.enable")}async stopSensitiveInstrumentation(e){const t=e.driver.defaultSession;await t.sendCommand("Debugger.disable"),t.off("Debugger.scriptParsed",this.onScriptParsed)}async getArtifact(e){await e.driver.fetcher.enable();const t=this._scriptParsedEvents.map((t=>this._retrieveMapFromScriptParsedEvent(e.driver,t)));return Promise.all(t)}}}).call(this)}).call(this,e("buffer").Buffer)},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/url-shim.js":"url",buffer:145}],"../gather/gatherers/stacks":[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("../../fraggle-rock/gather/base-gatherer.js");async function detectLibraries(){const e=[],t=d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests;for(const[n,i]of Object.entries(t))try{let t
;const a=new Promise((e=>t=setTimeout((()=>e(!1)),1e3))),s=await Promise.race([i.test(window),a]);t&&clearTimeout(t),s&&e.push({id:i.id,name:n,version:s.version,npm:i.npm})}catch(e){}return e}class Stacks extends a{constructor(){super(),this.meta={supportedModes:["snapshot","navigation"]}}static async collectStacks(e){const t={msg:"Collect stacks",id:"lh:gather:collectStacks"};i.time(t);const n=(await e.evaluate(detectLibraries,{args:[],
deps:['function _createTimeoutHelper(){let e;return{timeoutPromise:new Promise(((t,o)=>{e=setTimeout((()=>o(new Error("Timed out"))),5e3)})),clearTimeout:()=>clearTimeout(e)}}var UNKNOWN_VERSION=null,d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests={GWT:{id:"gwt",icon:"gwt",url:"http://www.gwtproject.org/",test:function(e){var t=e.document,o=t.getElementById("__gwt_historyFrame"),r=t.gwt_uid,n=t.body.__listener,i=t.body.__eventBits,s=e.__gwt_activeModules,c=e.__gwt_jsonp__,u=e.__gwt_scriptsLoaded||e.__gwt_stylesLoaded||e.__gwt_activeModules;if(o||r||n||i||s||c||u){for(var a=t.getElementsByTagName("iframe"),l=UNKNOWN_VERSION,N=0;N<a.length;N++)try{if(a[N].tabIndex<0&&a[N].contentWindow&&a[N].contentWindow.$gwt_version){l=a[N].contentWindow.$gwt_version;break}}catch(e){}return"0.0.999"==l&&(l="Google Internal"),{version:l}}return!1}},Ink:{id:"ink",icon:"ink",url:"http://ink.sapo.pt/",test:function(e){return!(!e.Ink||!e.Ink.createModule)&&{version:UNKNOWN_VERSION}}},Vaadin:{id:"vaadin",icon:"vaadin",url:"https://vaadin.com/",test:function(e){return!(!e.vaadin||!e.vaadin.registerWidgetset)&&{version:UNKNOWN_VERSION}}},Bootstrap:{id:"bootstrap",icon:"bootstrap",url:"http://getbootstrap.com/",npm:"bootstrap",test:function(e){var t,o=e.$&&e.$.fn;if(o&&(["affix","alert","button","carousel","collapse","dropdown","modal","popover","scrollspy","tab","tooltip"].some((function(o){if(e.$.fn[o]){if(e.$.fn[o].Constructor&&e.$.fn[o].Constructor.VERSION)return t=e.$.fn[o].Constructor.VERSION,!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:\'|\\")(?:bs\\\\.){1}"+o).test(e.$.fn[o].toString()))return t=">= 3.0.0 & <= 3.1.1",!0;if(new RegExp("\\\\$this\\\\.data\\\\((?:\'|\\")"+o).test(e.$.fn[o].toString()))return t=">= 2.0.0 & <= 2.3.2",!0}return!1})),t))return{version:t};return!1}},Zurb:{id:"zurb",icon:"zurb",url:"https://foundation.zurb.com/",npm:"foundation-sites",test:function(e){return!(!e.Foundation||!e.Foundation.Toggler)&&{version:e.Foundation.version||UNKNOWN_VERSION}}},Polymer:{id:"polymer",icon:"polymer",url:"https://www.polymer-project.org/",npm:"@polymer/polymer",test:function(e){return!(!e.Polymer||!e.Polymer.dom)&&{version:e.Polymer.version||UNKNOWN_VERSION}}},LitElement:{id:"litelement",icon:"polymer",url:"https://lit-element.polymer-project.org/",npm:"lit-element",test:function(e){if(e.litElementVersions&&e.litElementVersions.length){var t=[...e.litElementVersions].sort(((e,t)=>e.localeCompare(t,void 0,{numeric:!0})));return{version:t[t.length-1]}}return!1}},Highcharts:{id:"highcharts",icon:"highcharts",url:"http://www.highcharts.com",npm:"highcharts",test:function(e){return!(!e.Highcharts||!e.Highcharts.Point)&&{version:e.Highcharts.version||UNKNOWN_VERSION}}},InfoVis:{id:"jit",icon:"jit",url:"http://philogb.github.com/jit/",test:function(e){return!(!e.$jit||!e.$jit.PieChart)&&{version:e.$jit.version||UNKNOWN_VERSION}}},FlotCharts:{id:"flotcharts",icon:"flotcharts",url:"http://www.flotcharts.org/",npm:"flot",test:function(e){return!(!e.$||!e.$.plot)&&{version:e.$.plot.version||UNKNOWN_VERSION}}},CreateJS:{id:"createjs",icon:"createjs",url:"https://createjs.com/",npm:"createjs",test:function(e){return!(!e.createjs||!e.createjs.promote)&&{version:UNKNOWN_VERSION}}},"Google Maps":{id:"gmaps",icon:"gmaps",url:"https://developers.google.com/maps/",test:function(e){return!(!e.google||!e.google.maps)&&{version:e.google.maps.version||UNKNOWN_VERSION}}},jQuery:{id:"jquery",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!!(t&&t.fn&&t.fn.jquery)&&{version:t.fn.jquery.replace(/[^\\d+\\.+]/g,"")||UNKNOWN_VERSION}}},"jQuery (Fast path)":{id:"jquery-fast",icon:"jquery",url:"http://jquery.com",npm:"jquery",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.fn)&&{version:UNKNOWN_VERSION}}},"jQuery UI":{id:"jquery_ui",icon:"jquery_ui",url:"http://jqueryui.com",npm:"jquery-ui",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;if(t&&t.fn&&t.fn.jquery&&t.ui){for(var o="accordion,datepicker,dialog,draggable,droppable,progressbar,resizable,selectable,slider,menu,grid,tabs".split(","),r=[],n=0;n<o.length;n++)t.ui[o[n]]&&r.push(o[n].substr(0,1).toUpperCase()+o[n].substr(1));return{version:t.ui.version||UNKNOWN_VERSION,details:r.length?"Plugins used: "+r.join(","):""}}return!1}},Dojo:{id:"dojo",icon:"dojo",url:"http://dojotoolkit.org",npm:"dojo",test:function(e){return!(!e.dojo||!e.dojo.delegate)&&{version:e.dojo.version?e.dojo.version.toString():UNKNOWN_VERSION,details:"Details: "+(e.dijit?"Uses Dijit":"none")}}},Prototype:{id:"prototype",icon:"prototype",url:"http://prototypejs.org",test:function(e){return!(!e.Prototype||!e.Prototype.BrowserFeatures)&&{version:e.Prototype.Version||UNKNOWN_VERSION}}},Scriptaculous:{id:"scriptaculous",icon:"scriptaculous",url:"http://script.aculo.us",test:function(e){return!(!e.Scriptaculous||!e.Scriptaculous.load)&&{version:e.Scriptaculous.Version||UNKNOWN_VERSION}}},MooTools:{id:"mootools",icon:"mootools",url:"https://mootools.net/",test:function(e){return!(!e.MooTools||!e.MooTools.build)&&{version:e.MooTools.version||UNKNOWN_VERSION}}},Spry:{id:"spry",icon:"spry",url:"http://labs.adobe.com/technologies/spry",test:function(e){return!(!e.Spry||!e.Spry.Data)&&{version:UNKNOWN_VERSION}}},"YUI 2":{id:"yui",icon:"yui",url:"http://developer.yahoo.com/yui/2/",test:function(e){return!(!e.YAHOO||!e.YAHOO.util)&&{version:e.YAHOO.VERSION||UNKNOWN_VERSION}}},"YUI 3":{id:"yui3",icon:"yui3",url:"https://yuilibrary.com/",npm:"yui",test:function(e){return!(!e.YUI||!e.YUI.Env)&&{version:e.YUI.version||UNKNOWN_VERSION}}},Qooxdoo:{id:"qooxdoo",icon:"qooxdoo",url:"http://www.qooxdoo.org/",npm:"qooxdoo",test:function(e){return!(!e.qx||!e.qx.Bootstrap)&&{version:UNKNOWN_VERSION}}},"Ext JS":{id:"extjs",icon:"extjs",url:"https://www.sencha.com/products/extjs/",test:function(e){return e.Ext&&e.Ext.versions?{version:e.Ext.versions.core.version}:!!e.Ext&&{version:e.Ext.version||UNKNOWN_VERSION}}},base2:{id:"base2",icon:"base2",url:"http://code.google.com/p/base2",test:function(e){return!(!e.base2||!e.base2.dom)&&{version:e.base2.version||UNKNOWN_VERSION}}},"Closure Library":{id:"closure",icon:"closure",url:"https://developers.google.com/closure/library/",npm:"google-closure-library",test:function(e){return!(!e.goog||!e.goog.provide)&&{version:UNKNOWN_VERSION}}},"Rapha&euml;l":{id:"raphael",icon:"raphael",url:"http://dmitrybaranovskiy.github.io/raphael/",test:function(e){return!(!e.Raphael||!e.Raphael.circle)&&{version:e.Raphael.version||UNKNOWN_VERSION}}},React:{id:"react",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),r=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||null!=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return t(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()||o&&o.innerText.length>0||r||e.React&&e.React.Component)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"React (Fast path)":{id:"react-fast",icon:"react",url:"https://reactjs.org/",npm:"react",test:function(e){function t(e){return null!=e&&null!=e._reactRootContainer}var o=document.getElementById("react-root"),r=document.querySelector("*[data-reactroot]");return!!(t(document.body)||t(document.body.firstElementChild)||o||r||e.React)&&{version:e.React&&e.React.version||UNKNOWN_VERSION}}},"Next.js":{id:"next",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!(!e.__NEXT_DATA__||!e.__NEXT_DATA__.buildId)&&{version:window.next&&window.next.version||UNKNOWN_VERSION}}},"Next.js (Fast path)":{id:"next-fast",icon:"next",url:"https://nextjs.org/",npm:"next",test:function(e){return!!e.__NEXT_DATA__&&{version:UNKNOWN_VERSION}}},Preact:{id:"preact",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t="undefined"!=typeof Symbol&&Symbol.for&&Symbol.for("preactattr");function o(e){return"__k"in e&&"props"in e.__k&&"type"in e.__k||("_component"in e||"__preactattr_"in e||t&&null!=e[t])}function r(e){return null!=e&&o(e)&&e}var n=r(document.body)||r(document.body.firstElementChild);if(n||(n=document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return o(e)?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()),n||e.preact){var i=UNKNOWN_VERSION;return n&&("__k"in n&&(i="10"),"__preactattr_"in n&&(i="8"),t&&null!=n[t]&&(i="7")),{version:i}}return!1}},"Preact (Fast path)":{id:"preact-fast",icon:"preact",url:"https://preactjs.com/",npm:"preact",test:function(e){var t=UNKNOWN_VERSION;function o(e){return null!=e&&function(e){return null!=e.__k?(t="10",!0):null!=e._component||null!=e.__preactattr_}(e)}return!(!o(document.body)&&!o(document.body.firstElementChild)&&!e.preact)&&{version:t}}},Modernizr:{id:"modernizr",icon:"modernizr",url:"https://modernizr.com/",npm:"modernizr",test:function(e){return!(!e.Modernizr||!e.Modernizr.addTest)&&{version:e.Modernizr._version||UNKNOWN_VERSION}}},"Processing.js":{id:"processingjs",icon:"processingjs",url:"http://processingjs.org",npm:"processing-js",test:function(e){return!(!e.Processing||!e.Processing.box)&&{version:Processing.version||UNKNOWN_VERSION}}},Backbone:{id:"backbone",icon:"backbone",url:"http://backbonejs.org/",npm:"backbone",test:function(e){return!(!e.Backbone||!e.Backbone.Model.extend)&&{version:e.Backbone.VERSION||UNKNOWN_VERSION}}},Leaflet:{id:"leaflet",icon:"leaflet",url:"http://leafletjs.com",npm:"leaflet",test:function(e){return!(!e.L||!e.L.GeoJSON||!e.L.marker&&!e.L.Marker)&&{version:e.L.version||e.L.VERSION||UNKNOWN_VERSION}}},Mapbox:{id:"mapbox",icon:"mapbox",url:"https://www.mapbox.com/",npm:"mapbox-gl",test:function(e){return!!(e.L&&e.L.mapbox&&e.L.mapbox.geocoder)&&{version:e.L.mapbox.VERSION||UNKNOWN_VERSION}}},"Lo-Dash":{id:"lodash",icon:"lodash",url:"https://lodash.com/",npm:"lodash",test:function(e){var t="function"==typeof(t=e._)&&t,o="function"==typeof(o=t&&t.chain)&&o,r=(o||t||function(){return{}})(1);return!(!t||!r.__wrapped__)&&{version:t.VERSION||UNKNOWN_VERSION}}},Underscore:{id:"underscore",icon:"underscore",url:"http://underscorejs.org/",npm:"underscore",test:function(e){return!(!e._||"function"!=typeof e._.tap||d41d8cd98f00b204e9800998ecf8427e_LibraryDetectorTests["Lo-Dash"].test(e))&&{version:e._.VERSION||UNKNOWN_VERSION}}},Sammy:{id:"sammy",icon:"sammy",url:"http://sammyjs.org",test:function(e){return!(!e.Sammy||!e.Sammy.Application.curry)&&{version:e.Sammy.VERSION||UNKNOWN_VERSION}}},Rico:{id:"rico",icon:"rico",url:"http://openrico.sourceforge.net/examples/index.html",test:function(e){return!(!e.Rico||!window.Rico.checkIfComplete)&&{version:e.Rico.Version||UNKNOWN_VERSION}}},MochiKit:{id:"mochikit",icon:"mochikit",url:"https://mochi.github.io/mochikit/",test:function(e){return!(!e.MochiKit||!e.MochiKit.Base.module)&&{version:MochiKit.VERSION||UNKNOWN_VERSION}}},"gRapha&euml;l":{id:"graphael",icon:"graphael",url:"https://github.com/DmitryBaranovskiy/g.raphael",test:function(e){return!(!e.Raphael||!e.Raphael.fn.g)&&{version:UNKNOWN_VERSION}}},Glow:{id:"glow",icon:"glow",url:"http://www.bbc.co.uk/glow/",test:function(e){return e.gloader&&e.gloader.getRequests?{version:UNKNOWN_VERSION}:e.glow&&e.glow.dom?{version:e.glow.VERSION||UNKNOWN_VERSION}:!!e.Glow&&{version:e.Glow.version||UNKNOWN_VERSION}}},"Socket.IO":{id:"socketio",icon:"socketio",url:"https://socket.io/",npm:"socket.io",test:function(e){return!(!e.io||!e.io.sockets&&!e.io.Socket)&&{version:e.io.version||UNKNOWN_VERSION}}},Mustache:{id:"mustache",icon:"mustache",url:"http://mustache.github.io/",npm:"mustache",test:function(e){return!(!e.Mustache||!e.Mustache.to_html)&&{version:e.Mustache.version||UNKNOWN_VERSION}}},"Fabric.js":{id:"fabricjs",icon:"icon38",url:"http://fabricjs.com/",npm:"fabric",test:function(e){return!(!e.fabric||!e.fabric.util)&&{version:e.fabric.version||UNKNOWN_VERSION}}},FuseJS:{id:"fusejs",icon:"fusejs",url:"http://fusejs.io/",npm:"fuse.js",test:function(e){return!!e.Fuse&&{version:UNKNOWN_VERSION}}},"Tween.js":{id:"tweenjs",icon:"icon38",url:"https://github.com/tweenjs/tween.js",npm:"tween.js",test:function(e){return!(!e.TWEEN||!e.TWEEN.Easing)&&{version:UNKNOWN_VERSION}}},SproutCore:{id:"sproutcore",icon:"sproutcore",url:"http://sproutcore.com/",test:function(e){return!(!e.SC||!e.SC.Application)&&{version:UNKNOWN_VERSION}}},"Zepto.js":{id:"zepto",icon:"zepto",url:"http://zeptojs.com",npm:"zepto",test:function(e){return!(!e.Zepto||!e.Zepto.fn)&&{version:UNKNOWN_VERSION}}},"three.js":{id:"threejs",icon:"icon38",url:"https://threejs.org/",npm:"three",test:function(e){return e.THREE&&e.THREE.REVISION?{version:"r"+e.THREE.REVISION}:!!e.THREE&&{version:UNKNOWN_VERSION}}},PhiloGL:{id:"philogl",icon:"philogl",url:"http://www.senchalabs.org/philogl/",npm:"philogl",test:function(e){return!(!e.PhiloGL||!e.PhiloGL.Camera)&&{version:e.PhiloGL.version||UNKNOWN_VERSION}}},CamanJS:{id:"camanjs",icon:"camanjs",url:"http://camanjs.com/",npm:"caman",test:function(e){return e.Caman&&e.Caman.version?{version:e.Caman.version.release}:!!e.Caman&&{version:UNKNOWN_VERSION}}},yepnope:{id:"yepnope",icon:"yepnope",url:"http://yepnopejs.com/",test:function(e){return!(!e.yepnope||!e.yepnope.injectJs)&&{version:UNKNOWN_VERSION}}},LABjs:{id:"labjs",icon:"icon38",url:"https://github.com/getify/LABjs",test:function(e){return!(!e.$LAB||!e.$LAB.setOptions)&&{version:UNKNOWN_VERSION}}},"Head JS":{id:"headjs",icon:"headjs",url:"http://headjs.com/",npm:"headjs",test:function(e){return!(!e.head||!e.head.js)&&{version:UNKNOWN_VERSION}}},ControlJS:{id:"controljs",icon:"icon38",url:"http://stevesouders.com/controljs/",test:function(e){return!(!e.CJS||!e.CJS.start)&&{version:UNKNOWN_VERSION}}},RequireJS:{id:"requirejs",icon:"requirejs",url:"http://requirejs.org/",npm:"requirejs",test:function(e){var t=e.require||e.requirejs;return!(!t||!(t.load||t.s&&t.s.contexts&&t.s.contexts._&&(t.s.contexts._.loaded||t.s.contexts._.load)))&&{version:t.version||UNKNOWN_VERSION}}},RightJS:{id:"rightjs",icon:"rightjs",url:"http://rightjs.org/",test:function(e){return!(!e.RightJS||!e.RightJS.isNode)&&{version:e.RightJS.version||UNKNOWN_VERSION}}},"jQuery Tools":{id:"jquerytools",icon:"jquerytools",url:"http://jquerytools.github.io/",test:function(e){var t=e.jQuery||e.$;return!(!t||!t.tools)&&{version:t.tools.version||UNKNOWN_VERSION}}},Pusher:{id:"pusher",icon:"pusher",url:"https://pusher.com/docs/",npm:"pusher-js",test:function(e){return!(!e.Pusher||!e.Pusher.Channel)&&{version:e.Pusher.VERSION||UNKNOWN_VERSION}}},"Paper.js":{id:"paperjs",icon:"paperjs",url:"http://paperjs.org/",npm:"paper",test:function(e){return!(!e.paper||!e.paper.Point)&&{version:e.paper.version||UNKNOWN_VERSION}}},Swiffy:{id:"swiffy",icon:"icon38",url:"https://developers.google.com/swiffy/",test:function(e){return!(!e.swiffy||!e.swiffy.Stage)&&{version:UNKNOWN_VERSION}}},Move:{id:"move",icon:"move",url:"https://github.com/rsms/move",npm:"move",test:function(e){return!(!e.move||!e.move.compile)&&{version:e.move.version()||UNKNOWN_VERSION}}},AmplifyJS:{id:"amplifyjs",icon:"amplifyjs",url:"http://amplifyjs.com/",npm:"amplifyjs",test:function(e){return!(!e.amplify||!e.amplify.publish)&&{version:UNKNOWN_VERSION}}},"Popcorn.js":{id:"popcornjs",icon:"popcornjs",url:"https://github.com/mozilla/popcorn-js/",test:function(e){return!(!e.Popcorn||!e.Popcorn.Events)&&{version:e.Popcorn.version||UNKNOWN_VERSION}}},D3:{id:"d3",icon:"d3",url:"https://d3js.org/",npm:"d3",test:function(e){return!(!e.d3||!e.d3.select)&&{version:e.d3.version||UNKNOWN_VERSION}}},Handlebars:{id:"handlebars",icon:"handlebars",url:"http://handlebarsjs.com/",npm:"handlebars",test:function(e){return!(!e.Handlebars||!e.Handlebars.compile)&&{version:e.Handlebars.VERSION||UNKNOWN_VERSION}}},Knockout:{id:"knockout",icon:"knockout",url:"http://knockoutjs.com/",npm:"knockout",test:function(e){return!(!e.ko||!e.ko.applyBindings)&&{version:e.ko.version||UNKNOWN_VERSION}}},Spine:{id:"spine",icon:"icon38",url:"http://spine.github.io/",test:function(e){return!(!e.Spine||!e.Spine.Controller)&&{version:e.Spine.version||UNKNOWN_VERSION}}},"jQuery Mobile":{id:"jquery-mobile",icon:"jquery_mobile",url:"http://jquerymobile.com/",npm:"jquery-mobile",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.mobile)&&{version:t.mobile.version||UNKNOWN_VERSION}}},"WebFont Loader":{id:"webfontloader",icon:"icon38",url:"https://github.com/typekit/webfontloader",npm:"webfontloader",test:function(e){return!(!e.WebFont||!e.WebFont.load)&&{version:UNKNOWN_VERSION}}},Angular:{id:"angular",icon:"angular",url:"https://angular.io/",npm:"@angular/core",test:function(e){var t=e.document.querySelector("[ng-version]");return t?{version:t.getAttribute("ng-version")||UNKNOWN_VERSION}:!!(e.ng&&e.ng.probe instanceof Function)&&{version:UNKNOWN_VERSION}}},AngularJS:{id:"angularjs",icon:"angularjs",url:"https://angularjs.org/",npm:"angular",test:function(e){var t=e.angular;return t&&t.version&&t.version.full?{version:t.version.full}:!!t&&{version:UNKNOWN_VERSION}}},"Ember.js":{id:"emberjs",icon:"emberjs",url:"https://emberjs.com/",npm:"ember-source",test:function(e){var t=e.Ember||e.Em;return!(!t||!t.GUID_KEY)&&{version:t.VERSION||UNKNOWN_VERSION}}},"Hammer.js":{id:"hammerjs",icon:"hammerjs",url:"http://eightmedia.github.io/hammer.js/",npm:"hammerjs",test:function(e){return!(!e.Hammer||!e.Hammer.Pinch)&&{version:e.Hammer.VERSION||"&lt; 1.0.10"}}},"Visibility.js":{id:"visibilityjs",icon:"icon38",url:"https://github.com/ai/visibilityjs",npm:"visibilityjs",test:function(e){return!(!e.Visibility||!e.Visibility.every)&&{version:UNKNOWN_VERSION}}},"Velocity.js":{id:"velocityjs",icon:"icon38",url:"http://velocityjs.org/",npm:"velocity-animate",test:function(e){var t=e.jQuery||e.$,o=t?t.Velocity:e.Velocity;return o&&o.RegisterEffect&&o.version?{version:o.version.major+"."+o.version.minor+"."+o.version.patch}:!(!o||!o.RegisterEffect)&&{version:UNKNOWN_VERSION}}},"IfVisible.js":{id:"ifvisiblejs",icon:"icon38",url:"http://serkanyersen.github.io/ifvisible.js/",npm:"ifvisible.js",test:function(e){var t=e.ifvisible;return!(!t||"ifvisible.object.event.identifier"!==t.__ceGUID)&&{version:UNKNOWN_VERSION}}},"Pixi.js":{id:"pixi",icon:"pixi",url:"http://www.pixijs.com/",npm:"pixi.js",test:function(e){var t=e.PIXI;return!!(t&&t.WebGLRenderer&&t.VERSION)&&{version:t.VERSION.replace("v","")||UNKNOWN_VERSION}}},"DC.js":{id:"dcjs",icon:"dcjs",url:"http://dc-js.github.io/dc.js/",npm:"dc",test:function(e){var t=e.dc;return!(!t||!t.registerChart)&&{version:t.version||UNKNOWN_VERSION}}},"GreenSock JS":{id:"greensock",icon:"greensock",url:"https://greensock.com/gsap",npm:"gsap",test:function(e){return!(!e.TweenMax||!e.TweenMax.pauseAll)&&{version:e.TweenMax.version||UNKNOWN_VERSION}}},FastClick:{id:"fastclick",icon:"fastclick",url:"https://github.com/ftlabs/fastclick",npm:"fastclick",test:function(e){return!(!e.FastClick||!e.FastClick.notNeeded)&&{version:UNKNOWN_VERSION}}},Isotope:{id:"isotope",icon:"isotope",url:"https://isotope.metafizzy.co/",npm:"isotope-layout",test:function(e){return!!(e.Isotope||null!=e.$&&e.$.Isotope)&&{version:UNKNOWN_VERSION}}},Marionette:{id:"marionette",icon:"marionette",url:"https://marionettejs.com/",npm:"backbone.marionette",test:function(e){return!(!e.Marionette||!e.Marionette.Application)&&{version:e.Marionette.VERSION||UNKNOWN_VERSION}}},Can:{id:"canjs",icon:"canjs",url:"https://canjs.com/",npm:"can",test:function(e){return!(!e.can||!e.can.Construct)&&{version:e.can.VERSION||UNKNOWN_VERSION}}},Vue:{id:"vue",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!(null===document.createTreeWalker(document.body,NodeFilter.SHOW_ELEMENT,(function(e){return null!=e.__vue__?NodeFilter.FILTER_ACCEPT:NodeFilter.FILTER_SKIP})).nextNode()&&!e.Vue)&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Vue (Fast path)":{id:"vue-fast",icon:"vue",url:"https://vuejs.org/",npm:"vue",test:function(e){return!!e.Vue&&{version:e.Vue&&e.Vue.version||UNKNOWN_VERSION}}},"Nuxt.js":{id:"nuxt",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!!(e.__NUXT__&&null!=e.__NUXT__.data||e.$nuxt)&&{version:UNKNOWN_VERSION}}},"Nuxt.js (Fast path)":{id:"nuxt-fast",icon:"nuxt",url:"https://nuxtjs.org/",npm:"nuxt",test:function(e){return!(!e.__NUXT__&&!e.$nuxt)&&{version:UNKNOWN_VERSION}}},Two:{id:"two",icon:"two",url:"https://two.js.org/",npm:"two.js",test:function(e){return!(!e.Two||!e.Two.Utils)&&{version:e.Two.Version||UNKNOWN_VERSION}}},Brewser:{id:"brewser",icon:"brewser",url:"https://robertpataki.github.io/brewser/",npm:"brewser",test:function(e){return!(!e.BREWSER||!e.BREWSER.ua)&&{version:BREWSER.VERSION||UNKNOWN_VERSION}}},"Material Design Lite":{id:"materialdesignlite",icon:"mdl",url:"https://getmdl.io/",npm:"material-design-lite",test:function(e){return!(!e.componentHandler||!e.componentHandler.upgradeElement)&&{version:UNKNOWN_VERSION}}},"Kendo UI":{id:"kendoui",icon:"kendoui",url:"https://github.com/telerik/kendo-ui-core",npm:"kendo-ui-core",test:function(e){return!!(e.kendo&&e.kendo.View&&e.kendo.View.extend)&&{version:e.kendo.version||UNKNOWN_VERSION}}},"Matter.js":{id:"matterjs",icon:"matter-js",url:"http://brm.io/matter-js/",npm:"matter-js",test:function(e){return!(!e.Matter||!e.Matter.Engine)&&{version:UNKNOWN_VERSION}}},Riot:{id:"riot",icon:"riot",url:"http://riotjs.com/",npm:"riot",test:function(e){return!(!e.riot||!e.riot.mixin)&&{version:e.riot.version||UNKNOWN_VERSION}}},"Sea.js":{id:"seajs",icon:"icon38",url:"https://seajs.github.io/seajs/docs/",npm:"seajs",test:function(e){return!(!e.seajs||!e.seajs.use)&&{version:e.seajs.version||UNKNOWN_VERSION}}},"Moment.js":{id:"momentjs",icon:"momentjs",url:"http://momentjs.com/",npm:"moment",test:function(e){return!(!e.moment||!e.moment.isMoment&&!e.moment.lang)&&{version:e.moment.version||UNKNOWN_VERSION}}},"Moment Timezone":{id:"moment-timezone",icon:"momentjs",url:"http://momentjs.com/timezone/",npm:"moment-timezone",test:function(e){return!(!e.moment||!e.moment.tz)&&{version:e.moment.tz.version||UNKNOWN_VERSION}}},ScrollMagic:{id:"scrollmagic",icon:"scrollmagic",url:"http://scrollmagic.io/",npm:"scrollmagic",test:function(e){return!(!e.ScrollMagic||!e.ScrollMagic.Controller)&&{version:ScrollMagic.version||UNKNOWN_VERSION}}},SWFObject:{id:"swfobject",icon:"icon38",url:"https://github.com/swfobject/swfobject",test:function(e){return e.swfobject&&e.swfobject.embedSWF?{version:e.swfobject.version||UNKNOWN_VERSION}:!(!e.deconcept||!e.deconcept.SWFObject)&&{version:UNKNOWN_VERSION}}},FlexSlider:{id:"flexslider",icon:"icon38",url:"https://woocommerce.com/flexslider/",npm:"flexslider",test:function(e){var t=e.jQuery||e.$||e.$jq||e.$j;return!!(t&&t.fn&&t.fn.jquery&&t.flexslider)&&{version:UNKNOWN_VERSION}}},SPF:{id:"spf",icon:"icon38",url:"https://youtube.github.io/spfjs/",npm:"spf",test:function(e){return!(!e.spf||!e.spf.init)&&{version:UNKNOWN_VERSION}}},"Numeral.js":{id:"numeraljs",icon:"icon38",url:"http://numeraljs.com/",npm:"numeraljs",test:function(e){return!(!e.numeral||!e.isNumeral)&&{version:e.numeral.version||UNKNOWN_VERSION}}},"boomerang.js":{id:"boomerangjs",icon:"icon38",url:"https://soasta.github.io/boomerang/",npm:"boomerangjs",test:function(e){return!!(e.BOOMR&&e.BOOMR.utils&&e.BOOMR.init)&&{version:e.BOOMR.version||UNKNOWN_VERSION}}},Framer:{id:"framer",icon:"framer",url:"https://framer.com/",npm:"framerjs",test:function(e){return!(!e.Framer||!e.Framer.Layer)&&{version:e.Framer.Version.build||UNKNOWN_VERSION}}},Marko:{id:"marko",icon:"marko",url:"https://markojs.com/",npm:"marko",test:function(e){return!!document.querySelector("[data-marko-key], [data-marko]")&&{version:UNKNOWN_VERSION}}},AMP:{id:"amp",icon:"amp",url:"https://amp.dev/",npm:"https://www.npmjs.com/org/ampproject",test:function(e){var t=e.document.documentElement.getAttribute("amp-version");return!!t&&{version:t}}},Gatsby:{id:"gatsby",icon:"gatsby",url:"https://www.gatsbyjs.org/",npm:"gatsby",test:function(e){return!!document.getElementById("___gatsby")&&{version:UNKNOWN_VERSION}}},Shopify:{id:"shopify",icon:"shopify",url:"https://www.shopify.com/",npm:null,test:function(e){return!(!e.Shopify||!e.Shopify.shop)&&{version:UNKNOWN_VERSION}}},Magento:{id:"magento",icon:"magento",url:"https://magento.com/",npm:null,test:function(e){const t=/\\/static(?:\\/version\\d+)?\\/frontend\\/.+\\/.+\\/requirejs\\/require(?:\\.min)?\\.js/;return!!Array.from(document.querySelectorAll("script[src]")||[]).some((e=>t.test(e.src)))&&{version:2}}},WordPress:{id:"wordpress",icon:"wordpress",url:"https://wordpress.org/",npm:null,test:function(e){const t=!!document.querySelector(\'link[rel="https://api.w.org/"]\'),o=!!document.querySelectorAll(\'link[href*="wp-includes"], script[src*="wp-includes"]\').length;if(!t&&!o)return!1;const r=document.querySelector(\'meta[name=generator][content^="WordPress"]\');return{version:r?r.getAttribute("content").replace(/^\\w+\\s/,""):UNKNOWN_VERSION}}},Wix:{id:"wix",icon:"wix",url:"https://www.wix.com/",npm:null,test:function(e){return!!e.wixBiSession&&{version:UNKNOWN_VERSION}}},Workbox:{id:"workbox",icon:"workbox",url:"https://developers.google.com/web/tools/workbox/",npm:"workbox-sw",test:async function(e){var t=e.navigator;if(!("serviceWorker"in t))return!1;const{timeoutPromise:o,clearTimeout:r}=_createTimeoutHelper(),n=t.serviceWorker.getRegistration().then((function(e){var o=t.serviceWorker.controller?t.serviceWorker.controller.scriptURL:e.active.scriptURL;return fetch(o,{credentials:"include",headers:{"service-worker":"script"}}).then((function(e){return e.text()})).then((function(e){if(/new Workbox|new workbox|workbox\\.precaching\\.|workbox\\.strategies/gm.test(e)){var t=/workbox.*?\\b((0|[1-9]\\d*)\\.(0|[1-9]\\d*)\\.(0|[1-9]\\d*)(-(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*)(\\.(0|[1-9]\\d*|\\d*[a-zA-Z-][0-9a-zA-Z-]*))*)?(\\+[0-9a-zA-Z-]+(\\.[0-9a-zA-Z-]+)*)?)\\b/gim.exec(e),o=UNKNOWN_VERSION;return Array.isArray(t)&&t.length>1&&t[1]&&(o=t[1]),{version:o}}return!1}))}));return Promise.race([n,o]).catch((function(e){return!1})).finally((e=>(r(),e)))}},Boq:{id:"boq",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/143",npm:null,test:function(e){return!!e.WIZ_global_data&&{version:UNKNOWN_VERSION}}},Wiz:{id:"wiz",icon:"icon38",url:"https://github.com/johnmichel/Library-Detector-for-Chrome/pull/147",npm:null,test:function(e){return!!document.__wizdispatcher&&{version:UNKNOWN_VERSION}}},"core-js":{id:"corejs",icon:"icon38",url:"https://github.com/zloirock/core-js",npm:"core-js",test:function(e){const t=e["__core-js_shared__"],o=e.core;if(t){const e=t.versions;return{version:Array.isArray(e)?e.map((e=>`core-js-${e.mode}@${e.version}`)).join("; "):UNKNOWN_VERSION}}return!!o&&{version:o.version||UNKNOWN_VERSION}}},Drupal:{id:"drupal",icon:"drupal",url:"https://www.drupal.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="Drupal"]\'),o=t?t.getAttribute("content").replace(/\\D+/gi,""):UNKNOWN_VERSION,r=/\\/sites\\/(?:default|all)\\/(?:themes|modules|files)/,n=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(n.some((e=>r.test(e.src)))||n.some((e=>r.test(e.href)))||t||e.Drupal&&e.Drupal.behaviors)&&{version:o}}},TYPO3:{id:"typo3",icon:"typo3",url:"https://typo3.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="TYPO3"]\'),o=/\\/(typo3conf|typo3temp|fileadmin)/,r=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||r.some((e=>o.test(e.src)))||r.some((e=>o.test(e.href))))&&{version:UNKNOWN_VERSION}}},"Create React App":{id:"create-react-app",icon:"cra",url:"https://create-react-app.dev/",npm:"react-scripts",test:function(e){let t,o,r=e.document.body.firstElementChild;do{"noscript"===r.localName?t=r:"root"===r.id&&(o=r)}while(r=r.nextElementSibling);return!!(o&&t&&/You need to enable JavaScript to run this app/.test(t.textContent))&&{version:UNKNOWN_VERSION}}},"Guess.js":{id:"guessjs",icon:"guessjs",url:"https://guess-js.github.io/",test:function(e){return!(!e.__GUESS__||!e.__GUESS__.guess)&&{version:UNKNOWN_VERSION}}},"October CMS":{id:"octobercms",icon:"octobercms",url:"https://octobercms.com/",npm:null,test:function(e){const t=document.querySelector(\'meta[name="generator"][content^="OctoberCMS"]\'),o=document.querySelector(\'meta[name="generator"][content^="October CMS"]\'),r=/\\/modules\\/system\\/assets\\/(css|js)\\/framework(\\.extras|\\.combined)?(-min)?/,n=Array.from(document.querySelectorAll("link,style,script")||[]);return!!(t||o||n.some((e=>r.test(e.src||e.href))))&&{version:UNKNOWN_VERSION}}},Joomla:{id:"joomla",icon:"joomla",url:"https://www.joomla.org/",npm:null,test:function(e){const t=document.querySelector(\'meta[name=generator][content^="Joomla"]\'),o=!!document.querySelectorAll(\'script[src*="/media/jui/js/bootstrap.min.js"]\').length;return t?{version:t.getAttribute("content").replace(/^\\w+\\s/,"")}:!(!e.Joomla&&!o)&&{version:UNKNOWN_VERSION}}}};']
})).map((e=>({detector:"js",id:e.id,name:e.name,version:"number"==typeof e.version?String(e.version):e.version||void 0,npm:e.npm||void 0})));return i.timeEnd(t),n}async getArtifact(e){return Stacks.collectStacks(e.driver.executionContext)}}t.exports=Stacks},{"../../fraggle-rock/gather/base-gatherer.js":61,"lighthouse-logger":188}],"../gather/gatherers/trace-compat":[function(e,t,n){"use strict";const i=e("./trace.js"),a=e("../../fraggle-rock/gather/base-gatherer.js");t.exports=class TraceCompat extends a{meta={supportedModes:["timespan","navigation"],dependencies:{Trace:i.symbol}};async getArtifact(e){return{defaultPass:e.dependencies.Trace}}}},{"../../fraggle-rock/gather/base-gatherer.js":61,"./trace.js":"../gather/gatherers/trace"}],"../gather/gatherers/trace-elements":[function(e,t,n){"use strict"
;const i=e("../../fraggle-rock/gather/base-gatherer.js"),{resolveNodeIdToObjectId:a}=e("../driver/dom.js"),s=e("../../lib/page-functions.js"),c=e("../../lib/rect-helpers.js"),l=e("../../lib/sentry.js"),u=e("./trace.js"),d=e("../../computed/processed-trace.js"),m=e("../../computed/processed-navigation.js"),p=e("../../lib/lh-error.js");function getNodeDetailsData(){const e=this.nodeType===document.ELEMENT_NODE?this:this.parentElement;let t;return e&&(t={node:getNodeDetails(e)}),t}class TraceElements extends i{meta={supportedModes:["timespan","navigation"],dependencies:{Trace:u.symbol}};animationIdToName=new Map;constructor(){super(),this._onAnimationStarted=this._onAnimationStarted.bind(this)}_onAnimationStarted({animation:{id:e,name:t}}){t&&this.animationIdToName.set(e,t)}static getNodeIDFromTraceEvent(e){return e&&e.args&&e.args.data&&e.args.data.nodeId}static getAnimationIDFromTraceEvent(e){return e&&e.args&&e.args.data&&e.args.data.id}static getFailureReasonsFromTraceEvent(e){
return e&&e.args&&e.args.data&&e.args.data.compositeFailed}static getUnsupportedPropertiesFromTraceEvent(e){return e&&e.args&&e.args.data&&e.args.data.unsupportedProperties}static traceRectToLHRect(e){const t={x:e[0],y:e[1],width:e[2],height:e[3]};return c.addRectTopAndBottom(t)}static getTopLayoutShiftElements(e){const t=new Map,n=e.filter((e=>"LayoutShift"===e.name)).map((e=>e.args&&e.args.data)),i=n.findIndex((e=>e&&!e.had_recent_input));n.forEach(((e,n)=>{if(!e||!e.impacted_nodes||!e.score)return;if(-1!==i&&n>=i&&e.had_recent_input)return;let a=0;const s=new Map;e.impacted_nodes.forEach((e=>{if(!e.node_id||!e.old_rect||!e.new_rect)return;const t=TraceElements.traceRectToLHRect(e.old_rect),n=TraceElements.traceRectToLHRect(e.new_rect),i=c.getRectArea(t)+c.getRectArea(n)-c.getRectOverlapArea(t,n);s.set(e.node_id,i),a+=i}));for(const[n,i]of s.entries()){let s=t.get(n)||0;s+=i/a*e.score,t.set(n,s)}}));return[...t.entries()].sort(((e,t)=>t[1]-e[1])).slice(0,5).map((([e,t])=>({nodeId:e,
score:t})))}async getAnimatedElements(e){const t=new Map;for(const n of e){if("Animation"!==n.name)continue;if(!n.id2||!n.id2.local)continue;const e=n.id2.local,i=t.get(e)||{begin:void 0,status:void 0};"b"===n.ph?i.begin=n:"n"===n.ph&&n.args.data&&void 0!==n.args.data.compositeFailed&&(i.status=n),t.set(e,i)}const n=new Map;for(const{begin:e,status:i}of t.values()){const t=TraceElements.getNodeIDFromTraceEvent(e),a=TraceElements.getAnimationIDFromTraceEvent(e),s=TraceElements.getFailureReasonsFromTraceEvent(i),c=TraceElements.getUnsupportedPropertiesFromTraceEvent(i);if(!t||!a)continue;const l=n.get(t)||new Set;l.add({animationId:a,failureReasonsMask:s,unsupportedProperties:c}),n.set(t,l)}const i=[];for(const[e,t]of n){const n=[];for(const{animationId:e,failureReasonsMask:i,unsupportedProperties:a}of t){const t=this.animationIdToName.get(e);n.push({name:t,failureReasonsMask:i,unsupportedProperties:a})}i.push({nodeId:e,animations:n})}return i}async startInstrumentation(e){
await e.driver.defaultSession.sendCommand("Animation.enable"),e.driver.defaultSession.on("Animation.animationStarted",this._onAnimationStarted)}async stopInstrumentation(e){e.driver.defaultSession.off("Animation.animationStarted",this._onAnimationStarted),await e.driver.defaultSession.sendCommand("Animation.disable")}async _getArtifact(e,t){const n=e.driver.defaultSession;if(!t)throw new Error("Trace is missing!");const i=await d.request(t,e),{largestContentfulPaintEvt:c}=await m.request(i,e).catch((t=>{if("timespan"===e.gatherMode&&t.code===p.errors.NO_FCP.code)return{largestContentfulPaintEvt:void 0};throw t})),{mainThreadEvents:u}=i,h=TraceElements.getNodeIDFromTraceEvent(c),f=TraceElements.getTopLayoutShiftElements(u),g=await this.getAnimatedElements(u),y=new Map([["largest-contentful-paint",h?[{nodeId:h}]:[]],["layout-shift",f],["animation",g]]),b=[];for(const[e,t]of y)for(let i=0;i<t.length;i++){const c=t[i].nodeId;let u;try{const e=await a(n,c);if(!e)continue
;u=await n.sendCommand("Runtime.callFunctionOn",{objectId:e,functionDeclaration:`function () {\n              ${getNodeDetailsData.toString()};\n              ${s.getNodeDetailsString};\n              return getNodeDetailsData.call(this);\n            }`,returnByValue:!0,awaitPromise:!0})}catch(e){l.captureException(e,{tags:{gatherer:this.name},level:"error"});continue}u&&u.result&&u.result.value&&b.push({traceEventType:e,...u.result.value,score:t[i].score,animations:t[i].animations,nodeId:c})}return b}async getArtifact(e){return this._getArtifact(e,e.dependencies.Trace)}async afterPass(e,t){const n={...e,dependencies:{}};return await this.stopInstrumentation(n),this._getArtifact(n,t.trace)}}t.exports=TraceElements},{"../../computed/processed-navigation.js":42,"../../computed/processed-trace.js":43,"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/lh-error.js":103,"../../lib/page-functions.js":110,"../../lib/rect-helpers.js":111,"../../lib/sentry.js":112,"../driver/dom.js":66,
"./trace.js":"../gather/gatherers/trace"}],"../gather/gatherers/trace":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js"),a=e("../../lib/tracehouse/trace-processor.js");class Trace extends i{_trace={traceEvents:[]};static getDefaultTraceCategories(){return["-*","disabled-by-default-lighthouse","loading","v8","v8.execute","blink.user_timing","blink.console","devtools.timeline","disabled-by-default-devtools.timeline","disabled-by-default-devtools.screenshot","disabled-by-default-devtools.timeline.stack","disabled-by-default-devtools.timeline.frame","latencyInfo"]}static async endTraceAndCollectEvents(e){const t=[],dataListener=function(e){t.push(...e.value)};return e.on("Tracing.dataCollected",dataListener),new Promise(((n,i)=>{e.once("Tracing.tracingComplete",(i=>{e.off("Tracing.dataCollected",dataListener),n({traceEvents:t})})),e.sendCommand("Tracing.end").catch(i)}))}static symbol=Symbol("Trace");meta={symbol:Trace.symbol,
supportedModes:["timespan","navigation"]};async startSensitiveInstrumentation({driver:e,gatherMode:t,settings:n}){const i=Trace.getDefaultTraceCategories().concat(n.additionalTraceCategories||[]);await e.defaultSession.sendCommand("Page.enable"),await e.defaultSession.sendCommand("Tracing.start",{categories:i.join(","),options:"sampling-frequency=10000"}),"timespan"===t&&await e.defaultSession.sendCommand("Tracing.recordClockSyncMarker",{syncId:a.TIMESPAN_MARKER_ID})}async stopSensitiveInstrumentation({driver:e}){this._trace=await Trace.endTraceAndCollectEvents(e.defaultSession)}getArtifact(){return this._trace}}t.exports=Trace},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/tracehouse/trace-processor.js":119}],"../gather/gatherers/viewport-dimensions":[function(e,t,n){"use strict";const i=e("../../fraggle-rock/gather/base-gatherer.js");function getViewportDimensions(){return{innerWidth:window.innerWidth,innerHeight:window.innerHeight,outerWidth:window.outerWidth,
outerHeight:window.outerHeight,devicePixelRatio:window.devicePixelRatio}}t.exports=class ViewportDimensions extends i{meta={supportedModes:["snapshot","timespan","navigation"]};async getArtifact(e){const t=e.driver,n=await t.executionContext.evaluate(getViewportDimensions,{args:[],useIsolation:!0});if(!Object.values(n).every(Number.isFinite)){const e=JSON.stringify(n);throw new Error("ViewportDimensions results were not numeric: "+e)}return n}}},{"../../fraggle-rock/gather/base-gatherer.js":61}],"../gather/gatherers/web-app-manifest":[function(e,t,n){(function(n){(function(){"use strict";const i=e("lighthouse-logger"),a=e("../../lib/manifest-parser.js"),s=e("../../fraggle-rock/gather/base-gatherer.js");class WebAppManifest extends s{meta={supportedModes:["snapshot","navigation"]};static async fetchAppManifest(e){let t;e.setNextProtocolTimeout(1e4);try{t=await e.sendCommand("Page.getAppManifest")}catch(e){
if("PROTOCOL_TIMEOUT"===e.code)return i.error("WebAppManifest","Failed fetching manifest",e),null;throw e}let a=t.data;if(!a)return null;return 65279===a.charCodeAt(0)&&(a=n.from(a).slice(3).toString()),{...t,data:a}}static async getWebAppManifest(e,t){const n={msg:"Get webapp manifest",id:"lh:gather:getWebAppManifest"};i.time(n);const s=await WebAppManifest.fetchAppManifest(e);if(!s)return null;const c=a(s.data,s.url,t);return i.timeEnd(n),c}getArtifact(e){const t=e.driver;return WebAppManifest.getWebAppManifest(t.defaultSession,e.url)}}t.exports=WebAppManifest}).call(this)}).call(this,e("buffer").Buffer)},{"../../fraggle-rock/gather/base-gatherer.js":61,"../../lib/manifest-parser.js":105,buffer:145,"lighthouse-logger":188}],1:[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("../lighthouse-core/index.js"),a=e("../lighthouse-core/gather/connections/raw.js"),s=e("lighthouse-logger"),{registerLocaleData:c,lookupLocale:l}=e("../lighthouse-core/lib/i18n/i18n.js"),u=e("../lighthouse-core/config/constants.js");void 0!==t&&t.exports&&(n.runBundledLighthouse=i),"undefined"!=typeof self&&(n.isDevtools=!0,self.setUpWorkerConnection=function setUpWorkerConnection(e){return new a(e)},self.runLighthouse=i,self.createConfig=function createConfig(e,t){const n={onlyCategories:e,screenEmulation:{disabled:!0}};return"desktop"===t&&(n.throttling=u.throttling.desktopDense4G,n.emulatedUserAgent=u.userAgents.desktop,n.formFactor="desktop"),{extends:"lighthouse:default",plugins:["lighthouse-plugin-publisher-ads"],settings:n}},self.listenForStatus=function listenForStatus(e){s.events.addListener("status",e)},self.registerLocaleData=c,self.lookupLocale=l)}).call(this)
}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"../lighthouse-core/config/constants.js":56,"../lighthouse-core/gather/connections/raw.js":63,"../lighthouse-core/index.js":80,"../lighthouse-core/lib/i18n/i18n.js":98,"lighthouse-logger":188}],2:[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/i18n/i18n.js"),s={failingElementsHeader:"Failing Elements"},c=a.createMessageInstanceIdFn(n,s);t.exports=class AxeAudit extends i{static audit(e){if((e.Accessibility.notApplicable||[]).find((e=>e.id===this.meta.id)))return{score:null,notApplicable:!0};const t=e.Accessibility.incomplete||[],n=t.find((e=>e.id===this.meta.id));if(n&&n.error)return{score:null,errorMessage:"axe-core Error: "+(n.error.message||"Unknown error")}
;const a=this.meta.scoreDisplayMode===i.SCORING_MODES.INFORMATIVE,l=e.Accessibility.violations||[],u=(a?l.concat(t):l).find((e=>e.id===this.meta.id)),d=u&&u.impact,m=u&&u.tags;if(a&&!u)return{score:null,notApplicable:!0};let p=[];u&&u.nodes&&(p=u.nodes.map((e=>({node:{...i.makeNodeItem(e.node),explanation:e.failureSummary}}))));const h=[{key:"node",itemType:"node",text:c(s.failingElementsHeader)}];let f;return(d||m)&&(f={type:"debugdata",impact:d,tags:m}),{score:Number(void 0===u),details:{...i.makeTableDetails(h,p),debugData:f}}}},t.exports.UIStrings=s}).call(this)}).call(this,"/lighthouse-core/audits/accessibility/axe-audit.js")},{"../../lib/i18n/i18n.js":98,"../audit.js":3}],3:[function(e,t,n){"use strict";const{isUnderTest:i}=e("../lib/lh-env.js"),a=e("../lib/statistics.js"),s=e("../util-commonjs.js"),clampTo2Decimals=e=>Math.round(100*e)/100;class Audit{static get DEFAULT_PASS(){return"defaultPass"}static get SCORING_MODES(){return{NUMERIC:"numeric",BINARY:"binary",
MANUAL:"manual",INFORMATIVE:"informative",NOT_APPLICABLE:"notApplicable",ERROR:"error"}}static get meta(){throw new Error("Audit meta information must be overridden.")}static get defaultOptions(){return{}}static audit(e,t){throw new Error("audit() method must be overriden")}static computeLogNormalScore(e,t){const n=a.getLogNormalScore(e,t);return clampTo2Decimals(n)}static assertHeadingKeysExist(e,t){if(t.length&&i)for(const n of e){if(null===n.key)continue;const e=n.key;if(!t.some((t=>e in t)))throw new Error(`"${n.key}" is missing from items`)}}static makeTableDetails(e,t,n){return 0===t.length?{type:"table",headings:[],items:[],summary:n}:(Audit.assertHeadingKeysExist(e,t),{type:"table",headings:e,items:t,summary:n})}static makeListDetails(e){return{type:"list",items:e}}static makeSnippetDetails({content:e,title:t,lineMessages:n,generalMessages:i,node:a,maxLineLength:c=200,maxLinesAroundMessage:l=20}){const u=Audit._makeSnippetLinesArray(e,c);return{type:"snippet",
lines:s.filterRelevantLines(u,n,l),title:t,lineMessages:n,generalMessages:i,lineCount:u.length,node:a}}static _makeSnippetLinesArray(e,t){return e.split("\n").map(((e,n)=>{const i=n+1,a={content:e.slice(0,t),lineNumber:i};return e.length>t&&(a.truncated=!0),a}))}static makeOpportunityDetails(e,t,n,i){return Audit.assertHeadingKeysExist(e,t),{type:"opportunity",headings:0===t.length?[]:e,items:t,overallSavingsMs:n,overallSavingsBytes:i}}static makeNodeItem(e){return{type:"node",lhId:e.lhId,path:e.devtoolsNodePath,selector:e.selector,boundingRect:e.boundingRect,snippet:e.snippet,nodeLabel:e.nodeLabel}}static makeSourceLocationFromConsoleMessage(e){if(e.url)return{type:"source-location",url:e.url,urlProvider:"network",line:e.lineNumber||0,column:e.columnNumber||0}}static _normalizeAuditScore(e,t,n){if(t!==Audit.SCORING_MODES.BINARY&&t!==Audit.SCORING_MODES.NUMERIC)return null;if(null===e||!Number.isFinite(e))throw new Error(`Invalid score for ${n}: ${e}`)
;if(e>1)throw new Error(`Audit score for ${n} is > 1`);if(e<0)throw new Error(`Audit score for ${n} is < 0`);return e=clampTo2Decimals(e)}static generateErrorAuditResult(e,t){return Audit.generateAuditResult(e,{score:null,errorMessage:t})}static generateAuditResult(e,t){if(void 0===t.score)throw new Error("generateAuditResult requires a score");let n=e.meta.scoreDisplayMode||Audit.SCORING_MODES.BINARY;t.errorMessage?n=Audit.SCORING_MODES.ERROR:t.notApplicable&&(n=Audit.SCORING_MODES.NOT_APPLICABLE);const i=Audit._normalizeAuditScore(t.score,n,e.meta.id);let a=e.meta.title;e.meta.failureTitle&&null!==i&&i<s.PASS_THRESHOLD&&(a=e.meta.failureTitle);const c="numericUnit"in t?t:void 0;return{id:e.meta.id,title:a,description:e.meta.description,score:i,scoreDisplayMode:n,numericValue:c&&c.numericValue,numericUnit:c&&c.numericUnit,displayValue:t.displayValue,explanation:t.explanation,errorMessage:t.errorMessage,warnings:t.warnings,details:t.details}}}t.exports=Audit},{"../lib/lh-env.js":102,
"../lib/statistics.js":114,"../util-commonjs.js":124}],4:[function(e,t,n){(function(n){(function(){"use strict";const i=e("../audit.js"),a=e("../../lib/statistics.js").linearInterpolation,s=e("../../computed/metrics/lantern-interactive.js"),c=e("../../lib/i18n/i18n.js"),l=e("../../computed/network-records.js"),u=e("../../computed/load-simulator.js"),d=e("../../computed/page-dependency-graph.js"),m=c.createMessageInstanceIdFn(n,{});class UnusedBytes extends i{static scoreForWastedMs(e){return 0===e?1:e<300?a(0,1,300,.75,e):e<750?a(300,.75,750,.5,e):Math.max(0,a(750,.5,5e3,0,e))}static estimateTransferSize(e,t,n){if(e){if(e.resourceType===n)return e.transferSize||0;{const n=e.transferSize||0,i=e.resourceSize||0,a=Number.isFinite(i)&&i>0?n/i:1;return Math.round(t*a)}}switch(n){case"Stylesheet":return Math.round(.2*t);case"Script":case"Document":return Math.round(.33*t);default:return Math.round(.5*t)}}static async audit(e,t){
const n=e.GatherContext,a=e.traces[i.DEFAULT_PASS],s=e.devtoolsLogs[i.DEFAULT_PASS],c={devtoolsLog:s,settings:t&&t.settings||{}},m=await l.request(s,t);if(!m.length&&"timespan"===n.gatherMode)return{score:1,notApplicable:!0};const[p,h,f]=await Promise.all([this.audit_(e,m,t),"navigation"===n.gatherMode?d.request({trace:a,devtoolsLog:s},t):null,u.request(c,t)]);return this.createAuditProduct(p,h,f,n)}static computeWasteWithTTIGraph(e,t,n,i){const a=(i=Object.assign({includeLoad:!0,label:this.meta.id},i)).label+"-before",c=i.label+"-after",l=n.simulate(t,{label:a}),u=i.providedWastedBytesByUrl||new Map;if(!i.providedWastedBytesByUrl)for(const{url:t,wastedBytes:n}of e)u.set(t,(u.get(t)||0)+n);const d=new Map;t.traverse((e=>{if("network"!==e.type)return;const t=u.get(e.record.url);if(!t)return;const n=e.record.transferSize;d.set(e.record.requestId,n),e.record.transferSize=Math.max(n-t,0)}));const m=n.simulate(t,{label:c});t.traverse((e=>{if("network"!==e.type)return
;const t=d.get(e.record.requestId);void 0!==t&&(e.record.transferSize=t)}));const p=l.timeInMs-m.timeInMs;let h=s.getLastLongTaskEndTime(l.nodeTimings)-s.getLastLongTaskEndTime(m.nodeTimings);return i.includeLoad&&(h=Math.max(h,p)),10*Math.round(Math.max(h,0)/10)}static computeWastedMsWithThroughput(e,t){return 8*e/t.getOptions().throughput*1e3}static createAuditProduct(e,t,n,a){const s=e.items.sort(((e,t)=>t.wastedBytes-e.wastedBytes)),l=s.reduce(((e,t)=>e+t.wastedBytes),0);let u;if("navigation"===a.gatherMode){if(!t)throw Error("Page dependency graph should always be computed in navigation mode");u=this.computeWasteWithTTIGraph(s,t,n,{providedWastedBytesByUrl:e.wastedBytesByUrl})}else u=this.computeWastedMsWithThroughput(l,n);let d=e.displayValue||"";void 0===e.displayValue&&l&&(d=m(c.UIStrings.displayValueByteSavings,{wastedBytes:l}));const p=i.makeOpportunityDetails(e.headings,s,u,l);return{explanation:e.explanation,warnings:e.warnings,displayValue:d,numericValue:u,
numericUnit:"millisecond",score:UnusedBytes.scoreForWastedMs(u),details:p}}static audit_(e,t,n){throw new Error("audit_ unimplemented")}}t.exports=UnusedBytes}).call(this)}).call(this,"/lighthouse-core/audits/byte-efficiency/byte-efficiency-audit.js")},{"../../computed/load-simulator.js":13,"../../computed/metrics/lantern-interactive.js":24,"../../computed/network-records.js":40,"../../computed/page-dependency-graph.js":41,"../../lib/i18n/i18n.js":98,"../../lib/statistics.js":114,"../audit.js":3}],5:[function(e,t,n){t.exports={
moduleSizes:[498,155,242,615,220,657,651,1664,790,1534,558,279,868,974,618,356,720,133,826,732,235,552,170,585,1030,210,349,179,546,167,1634,118,199,478,849,470,452,417,147,60,180,433,360,303,1325,1518,397,201,550,226,132,156,198,312,544,2125,658,778,1084,701,401,81,716,632,321,428,648,804,718,130,1443,142,374,259,286,403,821,938,514,654,280,328,186,233,243,553,267,187,206,879,105,343,779,833,773,275,477,696,224,759,671,772,746,716,182,304,658,473,592,235,334,277,404,420,280,675,1034,508,725,526,498,498,499,752,661,276,275,843,1698,962,562,609,573,1048,205,374,226,625,632,308,772,641,233],dependencies:{"Array.prototype.fill":[3,5,8,17,19,21,22,29,30,35,38,39,40,42,43,45,48,51,52,53,55,56,58,60,61,63,64,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,88,89,91],"Array.prototype.filter":[1,8,9,10,12,14,17,19,21,22,27,28,29,30,33,35,38,39,42,43,45,47,48,51,52,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,88,89,92],
"Array.prototype.find":[1,3,8,9,12,14,17,19,21,22,29,30,33,35,38,39,40,42,43,45,47,48,51,52,53,55,56,58,60,61,63,64,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,88,89,94],"Array.prototype.findIndex":[1,3,8,9,12,14,17,19,21,22,29,30,33,35,38,39,40,42,43,45,47,48,51,52,53,55,56,58,60,61,63,64,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,88,89,93],"Array.prototype.forEach":[1,6,8,9,11,12,14,17,19,21,22,29,30,33,35,38,39,42,43,45,47,48,51,52,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,88,89,95],"Array.from":[1,7,8,15,16,17,18,19,21,22,23,29,30,33,35,36,38,39,42,43,45,46,48,51,52,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,86,87,88,89,96],"Array.isArray":[8,17,19,21,22,29,30,35,38,39,42,43,45,47,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,98],"Array.prototype.map":[1,8,9,10,12,14,17,19,21,22,27,28,29,30,33,35,38,39,42,43,45,47,48,51,52,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,88,89,99],
"Array.of":[8,17,19,21,22,23,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,100],"Array.prototype.reduce":[1,8,11,12,13,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,102],"Array.prototype.reduceRight":[1,8,11,12,13,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,101],"Array.prototype.some":[1,8,9,11,12,14,17,19,21,22,29,30,33,35,38,39,42,43,45,47,48,51,52,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,88,89,103],"Date.now":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,104],"Date.prototype.toISOString":[8,17,19,21,22,24,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,77,78,80,81,82,83,87,105],"Date.prototype.toJSON":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,106],
"Date.prototype.toString":[21,22,38,39,43,45,51,53,70,72,73,74,75,87,107],"Function.prototype.name":[108],"Number.isInteger":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,49,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,109],"Number.isSafeInteger":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,49,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,110],"Number.parseInt":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,54,58,60,61,63,65,68,69,70,71,72,73,74,75,79,80,81,82,83,87,90,111],"Object.defineProperties":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,56,58,60,61,63,64,65,68,69,70,71,72,73,74,75,80,81,82,83,87,112],"Object.defineProperty":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,113],"Object.freeze":[8,17,19,21,22,29,30,32,35,38,39,42,43,44,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,115],
"Object.getOwnPropertyNames":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,59,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,117],"Object.getPrototypeOf":[8,17,19,20,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,62,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,118],"Object.isExtensible":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,119],"Object.isFrozen":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,120],"Object.isSealed":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,121],"Object.keys":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,64,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,122],"Object.preventExtensions":[8,17,19,21,22,29,30,32,35,38,39,42,43,44,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,123],
"Object.seal":[8,17,19,21,22,29,30,32,35,38,39,42,43,44,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,124],"Object.setPrototypeOf":[2,8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,66,68,69,70,71,72,73,74,75,80,81,82,83,87,125],"Reflect.apply":[1,8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,127],"Reflect.construct":[1,8,17,19,21,22,29,30,34,35,38,39,40,42,43,45,48,51,53,55,56,58,60,61,63,64,65,68,69,70,71,72,73,74,75,80,81,82,83,87,128],"Reflect.defineProperty":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,129],"Reflect.deleteProperty":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,130],"Reflect.get":[8,17,19,20,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,62,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,133],
"Reflect.getOwnPropertyDescriptor":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,131],"Reflect.getPrototypeOf":[8,17,19,20,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,62,63,65,68,69,70,71,72,73,74,75,80,81,82,83,84,87,132],"Reflect.has":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,134],"Reflect.isExtensible":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,135],"Reflect.ownKeys":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,136],"Reflect.preventExtensions":[8,17,19,21,22,29,30,32,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,137],"Reflect.setPrototypeOf":[2,8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,66,68,69,70,71,72,73,74,75,80,81,82,83,87,138],
"String.prototype.codePointAt":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,76,80,81,82,83,87,139],"String.fromCodePoint":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,140],"String.raw":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,141],"String.prototype.repeat":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,78,80,81,82,83,87,142],"Array.prototype.includes":[3,8,12,17,19,21,22,29,30,35,38,39,40,42,43,45,48,51,52,53,55,56,58,60,61,63,64,65,68,69,70,71,72,73,74,75,80,81,82,83,87,88,89,97],"Object.entries":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,64,65,67,68,69,70,71,72,73,74,75,80,81,82,83,87,114],"Object.getOwnPropertyDescriptors":[8,17,19,21,22,23,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,65,68,69,70,71,72,73,74,75,80,81,82,83,87,116],
"Object.values":[8,17,19,21,22,29,30,35,38,39,42,43,45,48,51,53,58,60,61,63,64,65,67,68,69,70,71,72,73,74,75,80,81,82,83,87,126]},maxSize:77759,baseSize:3708}},{}],6:[function(e,t,n){"use strict";const i=e("../audit.js");t.exports=class ManualAudit extends i{static get partialMeta(){return{scoreDisplayMode:i.SCORING_MODES.MANUAL,requiredArtifacts:[]}}static audit(){return{score:0}}}},{"../audit.js":3}],7:[function(e,t,n){"use strict";const i=e("./audit.js");t.exports=class MultiCheckAudit extends i{static async audit(e,t){const n=await this.audit_(e,t);return this.createAuditProduct(n)}static createAuditProduct(e){const t={...e,...e.manifestValues,manifestValues:void 0,allChecks:void 0};e.manifestValues&&e.manifestValues.allChecks&&e.manifestValues.allChecks.forEach((e=>{t[e.id]=e.passing}));const n={type:"debugdata",items:[t]};return e.failures.length>0?{score:0,explanation:`Failures: ${e.failures.join(",\n")}.`,details:n}:{score:1,details:n}}static audit_(e,t){
throw new Error("audit_ unimplemented")}}},{"./audit.js":3}],8:[function(e,t,n){"use strict";const i=e("./audit.js");t.exports=class ViolationAudit extends i{static getViolationResults(e,t){const n=new Set;return e.ConsoleMessages.filter((e=>e.url&&"violation"===e.source&&t.test(e.text))).map(i.makeSourceLocationFromConsoleMessage).filter((function filterUndefined(e){return void 0!==e})).filter((e=>{const t=`${e.url}!${e.line}!${e.column}`;return!n.has(t)&&(n.add(t),!0)})).map((e=>({source:e})))}}},{"./audit.js":3}],9:[function(e,t,n){"use strict";const i=e("../lib/arbitrary-equality-map.js"),a=e("lighthouse-logger");t.exports=function makeComputedArtifact(e){return Object.assign(e,{request:(t,n)=>{const s=n.computedCache,c=e.name,l=s.get(c)||new i;s.set(c,l);const u=l.get(t);if(u)return u;const d={msg:"Computing artifact: "+c,id:"lh:computed:"+c};a.time(d,"verbose");const m=e.compute_(t,n);return l.set(t,m),m.then((()=>a.timeEnd(d))).catch((()=>a.timeEnd(d))),m}})}},{
"../lib/arbitrary-equality-map.js":81,"lighthouse-logger":188}],10:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../lib/network-request.js"),s=e("./main-resource.js"),c=e("./page-dependency-graph.js");class CriticalRequestChains{static isCritical(e,t){if(!t)throw new Error("mainResource not provided");if(e.requestId===t.requestId)return!0;if(e.isLinkPreload)return!1;for(;e.redirectDestination;)e=e.redirectDestination;const n=e.resourceType===a.TYPES.Document&&e.frameId!==t.frameId;return!([a.TYPES.Image,a.TYPES.XHR,a.TYPES.Fetch,a.TYPES.EventSource].includes(e.resourceType||"Other")||n||e.mimeType&&e.mimeType.startsWith("image/"))&&(!!e.initiatorRequest&&["VeryHigh","High","Medium"].includes(e.priority))}static extractChainsFromGraph(e,t){const n={};const i=new Set;return t.traverse(((t,a)=>{if(i.add(t),"network"!==t.type)return;if(!CriticalRequestChains.isCritical(t.record,e))return;const s=a.filter((e=>"network"===e.type)).reverse().map((e=>e.record))
;s.some((t=>!CriticalRequestChains.isCritical(t,e)))||function addChain(e){let t=n;for(const n of e)t[n.requestId]||(t[n.requestId]={request:n,children:{}}),t=t[n.requestId].children}(s)}),(function getNextNodes(e){return e.getDependents().filter((e=>e.getDependencies().every((e=>i.has(e)))))})),n}static async compute_(e,t){const n=await s.request({URL:e.URL,devtoolsLog:e.devtoolsLog},t),i=await c.request({trace:e.trace,devtoolsLog:e.devtoolsLog},t);return CriticalRequestChains.extractChainsFromGraph(n,i)}}t.exports=i(CriticalRequestChains)},{"../lib/network-request.js":109,"./computed-artifact.js":9,"./main-resource.js":14,"./page-dependency-graph.js":41}],11:[function(e,t,n){"use strict";const i=e("./computed-artifact.js");class ImageRecords{static indexNetworkRecords(e){return e.reduce(((e,t)=>((/^image/.test(t.mimeType)||/\.(avif|webp)$/i.test(t.url))&&t.finished&&200===t.statusCode&&(e[t.url]=t),e)),{})}static async compute_(e){
const t=ImageRecords.indexNetworkRecords(e.networkRecords),n=[];for(const i of e.ImageElements){const e=t[i.src],a=e&&e.mimeType;n.push({...i,mimeType:a||i.mimeType})}return n.sort(((e,n)=>{const i=t[e.src]||{};return(t[n.src]||{}).resourceSize-i.resourceSize})),n}}t.exports=i(ImageRecords)},{"./computed-artifact.js":9}],12:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("./computed-artifact.js"),s=e("../lib/cdt/SDK.js");function computeGeneratedFileSizes(e,t){const n=t.split("\n"),a={},s=t.length;let c=s;e.computeLastGeneratedColumns();for(const t of e.mappings()){const s=t.sourceURL,l=t.lineNumber,u=t.columnNumber,d=t.lastColumnNumber;if(!s)continue;const m=n[l];if(null==m){const t=`${e.url()} mapping for line out of bounds: ${l+1}`;return i.error("JSBundles",t),{errorMessage:t}}if(u>m.length){const t=`${e.url()} mapping for column out of bounds: ${l+1}:${u}`;return i.error("JSBundles",t),{errorMessage:t}}let p=0;if(void 0!==d){if(d>m.length){
const t=`${e.url()} mapping for last column out of bounds: ${l+1}:${d}`;return i.error("JSBundles",t),{errorMessage:t}}p=d-u}else p=m.length-u+1;a[s]=(a[s]||0)+p,c-=p}return{files:a,unmappedBytes:c,totalBytes:s}}t.exports=a(class JSBundles{static async compute_(e){const{SourceMaps:t,ScriptElements:n}=e,i=[];for(const e of t){if(!e.map)continue;const{scriptUrl:t,map:a}=e;if(!a.mappings)continue;const c=n.find((e=>e.src===t));if(!c)continue;const l=e.scriptUrl||"compiled.js",u=e.sourceMapUrl||"compiled.js.map",d=a,m=new s.TextSourceMap(l,u,d),p={rawMap:a,script:c,map:m,sizes:computeGeneratedFileSizes(m,c&&c.content?c.content:"")};i.push(p)}return i}})},{"../lib/cdt/SDK.js":85,"./computed-artifact.js":9,"lighthouse-logger":188}],13:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../config/constants.js"),s=e("../lib/dependency-graph/simulator/simulator.js"),c=e("./network-analysis.js");t.exports=i(class LoadSimulator{static async compute_(e,t){
const{throttlingMethod:n,throttling:i,precomputedLanternData:l}=e.settings,u=await c.request(e.devtoolsLog,t),d={additionalRttByOrigin:u.additionalRttByOrigin,serverResponseTimeByOrigin:u.serverResponseTimeByOrigin};switch(l&&(d.additionalRttByOrigin=new Map(Object.entries(l.additionalRttByOrigin)),d.serverResponseTimeByOrigin=new Map(Object.entries(l.serverResponseTimeByOrigin))),n){case"provided":d.rtt=u.rtt,d.throughput=u.throughput,d.cpuSlowdownMultiplier=1,d.layoutTaskMultiplier=1;break;case"devtools":i&&(d.rtt=i.requestLatencyMs/a.throttling.DEVTOOLS_RTT_ADJUSTMENT_FACTOR,d.throughput=1024*i.downloadThroughputKbps/a.throttling.DEVTOOLS_THROUGHPUT_ADJUSTMENT_FACTOR),d.cpuSlowdownMultiplier=1,d.layoutTaskMultiplier=1;break;case"simulate":i&&(d.rtt=i.rttMs,d.throughput=1024*i.throughputKbps,d.cpuSlowdownMultiplier=i.cpuSlowdownMultiplier)}return new s(d)}static convertAnalysisToSaveableLanternData(e){const t={additionalRttByOrigin:{},serverResponseTimeByOrigin:{}}
;for(const[n,i]of e.additionalRttByOrigin.entries())n.startsWith("http")&&(t.additionalRttByOrigin[n]=i);for(const[n,i]of e.serverResponseTimeByOrigin.entries())n.startsWith("http")&&(t.serverResponseTimeByOrigin[n]=i);return t}})},{"../config/constants.js":56,"../lib/dependency-graph/simulator/simulator.js":95,"./computed-artifact.js":9,"./network-analysis.js":39}],14:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../lib/dependency-graph/simulator/network-analyzer.js"),s=e("./network-records.js");t.exports=i(class MainResource{static async compute_(e,t){const n=e.URL.finalUrl,i=await s.request(e.devtoolsLog,t),c=a.findMainDocument(i,n);if(!c)throw new Error("Unable to identify the main resource");return c}})},{"../lib/dependency-graph/simulator/network-analyzer.js":93,"./computed-artifact.js":9,"./network-records.js":40}],15:[function(e,t,n){"use strict"
;const i=e("./computed-artifact.js"),a=e("../lib/tracehouse/main-thread-tasks.js"),s=e("./processed-trace.js");t.exports=i(class MainThreadTasks{static async compute_(e,t){const{mainThreadEvents:n,frames:i,timestamps:c}=await s.request(e,t);return a.getMainThreadTasks(n,i,c.traceEnd)}})},{"../lib/tracehouse/main-thread-tasks.js":117,"./computed-artifact.js":9,"./processed-trace.js":43}],16:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../lib/icons.js"),s=["minimal-ui","fullscreen","standalone"];class ManifestValues{static get manifestChecks(){return[{id:"hasStartUrl",failureText:"Manifest does not contain a `start_url`",validate:e=>!!e.start_url.value},{id:"hasIconsAtLeast144px",failureText:"Manifest does not have a PNG icon of at least 144px",validate:e=>a.doExist(e)&&a.pngSizedAtLeast(144,e).length>0},{id:"hasIconsAtLeast512px",failureText:"Manifest does not have a PNG icon of at least 512px",validate:e=>a.doExist(e)&&a.pngSizedAtLeast(512,e).length>0},{
id:"fetchesIcon",failureText:"Manifest icon failed to be fetched",validate:(e,t)=>{const n=["cannot-download-icon","no-icon-available"];return a.doExist(e)&&!t.some((e=>n.includes(e.errorId)))}},{id:"hasPWADisplayValue",failureText:"Manifest's `display` value is not one of: "+s.join(" | "),validate:e=>s.includes(e.display.value)},{id:"hasBackgroundColor",failureText:"Manifest does not have `background_color`",validate:e=>!!e.background_color.value},{id:"hasThemeColor",failureText:"Manifest does not have `theme_color`",validate:e=>!!e.theme_color.value},{id:"hasShortName",failureText:"Manifest does not have `short_name`",validate:e=>!!e.short_name.value},{id:"shortNameLength",failureText:"Manifest's `short_name` is too long (>12 characters) to be displayed on a homescreen without truncation",validate:e=>!!e.short_name.value&&e.short_name.value.length<=12},{id:"hasName",failureText:"Manifest does not have `name`",validate:e=>!!e.name.value},{id:"hasMaskableIcon",
failureText:"Manifest does not have at least one icon that is maskable",validate:e=>a.doExist(e)&&a.containsMaskableIcon(e)}]}static async compute_({WebAppManifest:e,InstallabilityErrors:t}){if(null===e)return{isParseFailure:!0,parseFailureReason:"No manifest was fetched",allChecks:[]};const n=e.value;if(void 0===n)return{isParseFailure:!0,parseFailureReason:"Manifest failed to parse as valid JSON",allChecks:[]};return{isParseFailure:!1,allChecks:ManifestValues.manifestChecks.map((e=>({id:e.id,failureText:e.failureText,passing:e.validate(n,t.errors)})))}}}t.exports=i(ManifestValues)},{"../lib/icons.js":100,"./computed-artifact.js":9}],17:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("../processed-trace.js"),s=e("../../lib/lh-error.js");class CumulativeLayoutShift{static getLayoutShiftEvents(e){const t=[];let n=!0;for(const i of e)if("LayoutShift"===i.name&&i.args.data&&void 0!==i.args.data.is_main_frame){
if(void 0===i.args.data.weighted_score_delta)throw new s(s.errors.UNSUPPORTED_OLD_CHROME,{featureName:"Cumulative Layout Shift"});if(i.args.data.had_recent_input){if(!n)continue}else n=!1;t.push({ts:i.ts,isMainFrame:i.args.data.is_main_frame,weightedScore:i.args.data.weighted_score_delta})}return t}static calculate(e){let t=0,n=0,i=Number.NEGATIVE_INFINITY,a=Number.NEGATIVE_INFINITY;for(const s of e)(s.ts-i>5e6||s.ts-a>1e6)&&(i=s.ts,n=0),a=s.ts,n+=s.weightedScore,t=Math.max(t,n);return t}static calculateTotalCumulativeLayoutShift(e){return e.reduce(((e,t)=>e+t.weightedScore),0)}static async compute_(e,t){const n=await a.request(e,t),i=CumulativeLayoutShift.getLayoutShiftEvents(n.frameTreeEvents),s=i.filter((e=>e.isMainFrame)),c=CumulativeLayoutShift.calculateTotalCumulativeLayoutShift(s);return{cumulativeLayoutShift:CumulativeLayoutShift.calculate(i),cumulativeLayoutShiftMainFrame:CumulativeLayoutShift.calculate(s),totalCumulativeLayoutShift:c}}}t.exports=i(CumulativeLayoutShift)},{
"../../lib/lh-error.js":103,"../computed-artifact.js":9,"../processed-trace.js":43}],18:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./navigation-metric.js");t.exports=i(class FirstContentfulPaintAllFrames extends a{static computeSimulatedMetric(){throw new Error("FCP All Frames not implemented in lantern")}static async computeObservedMetric(e){const{processedNavigation:t}=e;return{timing:t.timings.firstContentfulPaintAllFrames,timestamp:t.timestamps.firstContentfulPaintAllFrames}}})},{"../computed-artifact.js":9,"./navigation-metric.js":34}],19:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./navigation-metric.js"),s=e("./lantern-first-contentful-paint.js");t.exports=i(class FirstContentfulPaint extends a{static computeSimulatedMetric(e,t){const n=a.getMetricComputationInput(e);return s.request(n,t)}static async computeObservedMetric(e){const{processedNavigation:t}=e;return{timing:t.timings.firstContentfulPaint,
timestamp:t.timestamps.firstContentfulPaint}}})},{"../computed-artifact.js":9,"./lantern-first-contentful-paint.js":22,"./navigation-metric.js":34}],20:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./navigation-metric.js"),s=e("../../lib/lh-error.js"),c=e("./lantern-first-meaningful-paint.js");t.exports=i(class FirstMeaningfulPaint extends a{static computeSimulatedMetric(e,t){const n=a.getMetricComputationInput(e);return c.request(n,t)}static async computeObservedMetric(e){const{processedNavigation:t}=e;if(void 0===t.timings.firstMeaningfulPaint)throw new s(s.errors.NO_FMP);return{timing:t.timings.firstMeaningfulPaint,timestamp:t.timestamps.firstMeaningfulPaint}}})},{"../../lib/lh-error.js":103,"../computed-artifact.js":9,"./lantern-first-meaningful-paint.js":23,"./navigation-metric.js":34}],21:[function(e,t,n){"use strict"
;const i=e("../computed-artifact.js"),a=e("./navigation-metric.js"),s=e("./lantern-interactive.js"),c=e("../../gather/driver/network-monitor.js"),l=e("../../lib/tracehouse/trace-processor.js"),u=e("../../lib/lh-error.js"),d=5e3;class Interactive extends a{static _findNetworkQuietPeriods(e,t){const n=t.timestamps.traceEnd/1e3,i=e.filter((e=>e.finished&&"GET"===e.requestMethod&&!e.failed&&e.statusCode<400));return c.findNetworkQuietPeriods(i,2,n)}static _findCPUQuietPeriods(e,t){const n=t.timestamps.timeOrigin/1e3,i=t.timestamps.traceEnd/1e3;if(0===e.length)return[{start:0,end:i}];const a=[];return e.forEach(((t,s)=>{0===s&&a.push({start:0,end:t.start+n}),s===e.length-1?a.push({start:t.end+n,end:i}):a.push({start:t.end+n,end:e[s+1].start+n})})),a}static findOverlappingQuietPeriods(e,t,n){
const i=n.timestamps.firstContentfulPaint/1e3,isLongEnoughQuietPeriod=e=>e.end>i+d&&e.end-e.start>=d,a=this._findNetworkQuietPeriods(t,n).filter(isLongEnoughQuietPeriod),s=this._findCPUQuietPeriods(e,n).filter(isLongEnoughQuietPeriod),c=s.slice(),l=a.slice();let m=c.shift(),p=l.shift();for(;m&&p;)if(m.start>=p.start){if(p.end>=m.start+d)return{cpuQuietPeriod:m,networkQuietPeriod:p,cpuQuietPeriods:s,networkQuietPeriods:a};p=l.shift()}else{if(m.end>=p.start+d)return{cpuQuietPeriod:m,networkQuietPeriod:p,cpuQuietPeriods:s,networkQuietPeriods:a};m=c.shift()}throw new u(m?u.errors.NO_TTI_NETWORK_IDLE_PERIOD:u.errors.NO_TTI_CPU_IDLE_PERIOD)}static computeSimulatedMetric(e,t){const n=a.getMetricComputationInput(e);return s.request(n,t)}static computeObservedMetric(e){const{processedTrace:t,processedNavigation:n,networkRecords:i}=e;if(!n.timestamps.domContentLoaded)throw new u(u.errors.NO_DCL)
;const a=l.getMainThreadTopLevelEvents(t).filter((e=>e.duration>=50)),s=Interactive.findOverlappingQuietPeriods(a,i,n).cpuQuietPeriod,c=1e3*Math.max(s.start,n.timestamps.firstContentfulPaint/1e3,n.timestamps.domContentLoaded/1e3),d=(c-n.timestamps.timeOrigin)/1e3;return Promise.resolve({timing:d,timestamp:c})}}t.exports=i(Interactive)},{"../../gather/driver/network-monitor.js":70,"../../lib/lh-error.js":103,"../../lib/tracehouse/trace-processor.js":119,"../computed-artifact.js":9,"./lantern-interactive.js":24,"./navigation-metric.js":34}],22:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./lantern-metric.js"),s=e("../../lib/dependency-graph/base-node.js");t.exports=i(class LanternFirstContentfulPaint extends a{static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getBlockingNodeData(e,t,n,i){const c=new Map,l=[];e.traverse((e=>{if(e.type===s.TYPES.CPU){e.startTime<=t&&l.push(e);const n=e.getEvaluateScriptURLs();for(const t of n){
const n=c.get(t)||e;c.set(t,e.startTime<n.startTime?e:n)}}})),l.sort(((e,t)=>e.startTime-t.startTime));const u=a.getScriptUrls(e,(e=>e.endTime<=t&&n(e))),d=new Set,m=new Set;for(const e of u){const t=c.get(e);t&&(l.includes(t)?m.add(t.id):d.add(e))}const p=l.find((e=>e.didPerformLayout()));p&&m.add(p.id);const h=l.find((e=>e.childEvents.some((e=>"Paint"===e.name))));h&&m.add(h.id);const f=l.find((e=>e.childEvents.some((e=>"ParseHTML"===e.name))));return f&&m.add(f.id),i&&l.filter(i).forEach((e=>m.add(e.id))),{definitelyNotRenderBlockingScriptUrls:d,blockingCpuNodeIds:m}}static getFirstPaintBasedGraph(e,t,n,i){const{definitelyNotRenderBlockingScriptUrls:a,blockingCpuNodeIds:c}=this.getBlockingNodeData(e,t,n,i);return e.cloneWithRelationships((e=>{if(e.type===s.TYPES.NETWORK){if(e.endTime>t&&!e.isMainDocument())return!1;const i=e.record.url;return!a.has(i)&&n(e)}return c.has(e.id)}))}static getOptimisticGraph(e,t){
return this.getFirstPaintBasedGraph(e,t.timestamps.firstContentfulPaint,(e=>e.hasRenderBlockingPriority()&&"script"!==e.initiatorType))}static getPessimisticGraph(e,t){return this.getFirstPaintBasedGraph(e,t.timestamps.firstContentfulPaint,(e=>e.hasRenderBlockingPriority()))}})},{"../../lib/dependency-graph/base-node.js":88,"../computed-artifact.js":9,"./lantern-metric.js":27}],23:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./lantern-metric.js"),s=e("../../lib/lh-error.js"),c=e("./lantern-first-contentful-paint.js");t.exports=i(class LanternFirstMeaningfulPaint extends a{static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e,t){const n=t.timestamps.firstMeaningfulPaint;if(!n)throw new s(s.errors.NO_FMP);return c.getFirstPaintBasedGraph(e,n,(e=>e.hasRenderBlockingPriority()&&"script"!==e.initiatorType))}static getPessimisticGraph(e,t){const n=t.timestamps.firstMeaningfulPaint;if(!n)throw new s(s.errors.NO_FMP)
;return c.getFirstPaintBasedGraph(e,n,(e=>e.hasRenderBlockingPriority()),(e=>e.didPerformLayout()))}static async compute_(e,t){const n=await c.request(e,t),i=await this.computeMetricWithGraphs(e,t);return i.timing=Math.max(i.timing,n.timing),i}})},{"../../lib/lh-error.js":103,"../computed-artifact.js":9,"./lantern-first-contentful-paint.js":22,"./lantern-metric.js":27}],24:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./lantern-metric.js"),s=e("../../lib/dependency-graph/base-node.js"),c=e("../../lib/network-request.js"),l=e("./lantern-first-meaningful-paint.js");class LanternInteractive extends a{static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e){return e.cloneWithRelationships((e=>{if(e.type===s.TYPES.CPU)return e.event.dur>2e4;const t=e.record.resourceType===c.TYPES.Image,n=e.record.resourceType===c.TYPES.Script;return!t&&(n||"High"===e.record.priority||"VeryHigh"===e.record.priority)}))}
static getPessimisticGraph(e){return e}static getEstimateFromSimulation(e,t){if(!t.fmpResult)throw new Error("missing fmpResult");const n=LanternInteractive.getLastLongTaskEndTime(e.nodeTimings),i=t.optimistic?t.fmpResult.optimisticEstimate.timeInMs:t.fmpResult.pessimisticEstimate.timeInMs;return{timeInMs:Math.max(i,n),nodeTimings:e.nodeTimings}}static async compute_(e,t){const n=await l.request(e,t),i=await this.computeMetricWithGraphs(e,t,{fmpResult:n});return i.timing=Math.max(i.timing,n.timing),i}static getLastLongTaskEndTime(e,t=50){return Array.from(e.entries()).filter((([e,n])=>e.type===s.TYPES.CPU&&n.duration>t)).map((([e,t])=>t.endTime)).reduce(((e,t)=>Math.max(e||0,t||0)),0)}}t.exports=i(LanternInteractive)},{"../../lib/dependency-graph/base-node.js":88,"../../lib/network-request.js":109,"../computed-artifact.js":9,"./lantern-first-meaningful-paint.js":23,"./lantern-metric.js":27}],25:[function(e,t,n){"use strict"
;const i=e("../computed-artifact.js"),a=e("./lantern-metric.js"),s=e("../../lib/lh-error.js"),c=e("./lantern-first-contentful-paint.js");class LanternLargestContentfulPaint extends a{static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static isNotLowPriorityImageNode(e){if("network"!==e.type)return!0;const t="Image"===e.record.resourceType,n="Low"===e.record.priority||"VeryLow"===e.record.priority;return!t||!n}static getOptimisticGraph(e,t){const n=t.timestamps.largestContentfulPaint;if(!n)throw new s(s.errors.NO_LCP);return c.getFirstPaintBasedGraph(e,n,LanternLargestContentfulPaint.isNotLowPriorityImageNode)}static getPessimisticGraph(e,t){const n=t.timestamps.largestContentfulPaint;if(!n)throw new s(s.errors.NO_LCP);return c.getFirstPaintBasedGraph(e,n,(e=>!0),(e=>e.didPerformLayout()))}static getEstimateFromSimulation(e){
const t=Array.from(e.nodeTimings.entries()).filter((e=>LanternLargestContentfulPaint.isNotLowPriorityImageNode(e[0]))).map((e=>e[1].endTime));return{timeInMs:Math.max(...t),nodeTimings:e.nodeTimings}}static async compute_(e,t){const n=await c.request(e,t),i=await this.computeMetricWithGraphs(e,t);return i.timing=Math.max(i.timing,n.timing),i}}t.exports=i(LanternLargestContentfulPaint)},{"../../lib/lh-error.js":103,"../computed-artifact.js":9,"./lantern-first-contentful-paint.js":22,"./lantern-metric.js":27}],26:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./lantern-metric.js"),s=e("../../lib/dependency-graph/base-node.js"),c=e("./lantern-first-contentful-paint.js");class LanternMaxPotentialFID extends a{static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e){return e}static getPessimisticGraph(e){return e}static getEstimateFromSimulation(e,t){if(!t.fcpResult)throw new Error("missing fcpResult")
;const n=t.optimistic?t.fcpResult.pessimisticEstimate.timeInMs:t.fcpResult.optimisticEstimate.timeInMs,i=LanternMaxPotentialFID.getTimingsAfterFCP(e.nodeTimings,n);return{timeInMs:Math.max(...i.map((e=>e.duration)),16),nodeTimings:e.nodeTimings}}static async compute_(e,t){const n=await c.request(e,t);return super.computeMetricWithGraphs(e,t,{fcpResult:n})}static getTimingsAfterFCP(e,t){return Array.from(e.entries()).filter((([e,n])=>e.type===s.TYPES.CPU&&n.endTime>t)).map((([e,t])=>t))}}t.exports=i(LanternMaxPotentialFID)},{"../../lib/dependency-graph/base-node.js":88,"../computed-artifact.js":9,"./lantern-first-contentful-paint.js":22,"./lantern-metric.js":27}],27:[function(e,t,n){"use strict";const i=e("../../lib/dependency-graph/base-node.js"),a=e("../../lib/network-request.js"),s=e("../processed-trace.js"),c=e("../processed-navigation.js"),l=e("../page-dependency-graph.js"),u=e("../load-simulator.js");t.exports=class LanternMetricArtifact{static getScriptUrls(e,t){const n=new Set
;return e.traverse((e=>{e.type!==i.TYPES.CPU&&e.record.resourceType===a.TYPES.Script&&(t&&!t(e)||n.add(e.record.url))})),n}static get COEFFICIENTS(){throw new Error("COEFFICIENTS unimplemented!")}static getScaledCoefficients(e){return this.COEFFICIENTS}static getOptimisticGraph(e,t){throw new Error("Optimistic graph unimplemented!")}static getPessimisticGraph(e,t){throw new Error("Pessmistic graph unimplemented!")}static getEstimateFromSimulation(e,t){return e}static async computeMetricWithGraphs(e,t,n){const i=e.gatherContext||{gatherMode:"navigation"},{trace:a,devtoolsLog:d,settings:m}=e;if("navigation"!==i.gatherMode)throw new Error("Lantern metrics can only be computed on navigations");const p=this.name.replace("Lantern",""),h=await l.request({trace:a,devtoolsLog:d},t),f=await s.request(a,t),g=await c.request(f,t),y=e.simulator||await u.request({devtoolsLog:d,settings:m},t),b=this.getOptimisticGraph(h,g),v=this.getPessimisticGraph(h,g);let w={label:"optimistic"+p}
;const S=y.simulate(b,w);w={label:"optimisticFlex"+p,flexibleOrdering:!0};const T=y.simulate(b,w);w={label:"pessimistic"+p};const E=y.simulate(v,w),_=this.getEstimateFromSimulation(S.timeInMs<T.timeInMs?S:T,{...n,optimistic:!0}),x=this.getEstimateFromSimulation(E,{...n,optimistic:!1}),A=this.getScaledCoefficients(y.rtt),k=A.intercept>0?Math.min(1,_.timeInMs/1e3):1;return{timing:A.intercept*k+A.optimistic*_.timeInMs+A.pessimistic*x.timeInMs,optimisticEstimate:_,pessimisticEstimate:x,optimisticGraph:b,pessimisticGraph:v}}static async compute_(e,t){return this.computeMetricWithGraphs(e,t)}}},{"../../lib/dependency-graph/base-node.js":88,"../../lib/network-request.js":109,"../load-simulator.js":13,"../page-dependency-graph.js":41,"../processed-navigation.js":42,"../processed-trace.js":43}],28:[function(e,t,n){"use strict"
;const i=e("../computed-artifact.js"),a=e("./lantern-metric.js"),s=e("../../lib/dependency-graph/base-node.js"),c=e("../speedline.js"),l=e("./lantern-first-contentful-paint.js"),u=e("../../config/constants.js").throttling;class LanternSpeedIndex extends a{static get COEFFICIENTS(){return{intercept:-250,optimistic:1.4,pessimistic:.65}}static getScaledCoefficients(e){const t=this.COEFFICIENTS,n=u.mobileSlow4G.rttMs-30,i=Math.max((e-30)/n,0);return{intercept:t.intercept*i,optimistic:.5+(t.optimistic-.5)*i,pessimistic:.5+(t.pessimistic-.5)*i}}static getOptimisticGraph(e){return e}static getPessimisticGraph(e){return e}static getEstimateFromSimulation(e,t){if(!t.fcpResult)throw new Error("missing fcpResult");if(!t.speedline)throw new Error("missing speedline");const n=t.fcpResult.pessimisticEstimate.timeInMs;return{timeInMs:t.optimistic?t.speedline.speedIndex:LanternSpeedIndex.computeLayoutBasedSpeedIndex(e.nodeTimings,n),nodeTimings:e.nodeTimings}}static async compute_(e,t){
const n=await c.request(e.trace,t),i=await l.request(e,t),a=await this.computeMetricWithGraphs(e,t,{speedline:n,fcpResult:i});return a.timing=Math.max(a.timing,i.timing),a}static computeLayoutBasedSpeedIndex(e,t){const n=[];for(const[t,i]of e.entries())if(t.type===s.TYPES.CPU&&t.childEvents.some((e=>"Layout"===e.name))){const e=Math.max(Math.log2(i.endTime-i.startTime),0);n.push({time:i.endTime,weight:e})}const i=n.map((e=>e.weight*Math.max(e.time,t))).reduce(((e,t)=>e+t),0),a=n.map((e=>e.weight)).reduce(((e,t)=>e+t),0);return a?i/a:t}}t.exports=i(LanternSpeedIndex)},{"../../config/constants.js":56,"../../lib/dependency-graph/base-node.js":88,"../computed-artifact.js":9,"../speedline.js":46,"./lantern-first-contentful-paint.js":22,"./lantern-metric.js":27}],29:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./lantern-metric.js"),s=e("../../lib/dependency-graph/base-node.js"),c=e("./lantern-first-contentful-paint.js"),l=e("./lantern-interactive.js")
;class LanternTotalBlockingTime extends a{static get COEFFICIENTS(){return{intercept:0,optimistic:.5,pessimistic:.5}}static getOptimisticGraph(e){return e}static getPessimisticGraph(e){return e}static getEstimateFromSimulation(t,n){if(!n.fcpResult)throw new Error("missing fcpResult");if(!n.interactiveResult)throw new Error("missing interactiveResult");const i=n.optimistic?n.fcpResult.pessimisticEstimate.timeInMs:n.fcpResult.optimisticEstimate.timeInMs,a=n.optimistic?n.interactiveResult.optimisticEstimate.timeInMs:n.interactiveResult.pessimisticEstimate.timeInMs,s=e("./total-blocking-time.js"),c=s.BLOCKING_TIME_THRESHOLD,l=LanternTotalBlockingTime.getTopLevelEvents(t.nodeTimings,c);return{timeInMs:s.calculateSumOfBlockingTime(l,i,a),nodeTimings:t.nodeTimings}}static async compute_(e,t){const n=await c.request(e,t),i=await l.request(e,t);return this.computeMetricWithGraphs(e,t,{fcpResult:n,interactiveResult:i})}static getTopLevelEvents(e,t){const n=[]
;for(const[i,a]of e.entries())i.type===s.TYPES.CPU&&(a.duration<t||n.push({start:a.startTime,end:a.endTime,duration:a.duration}));return n}}t.exports=i(LanternTotalBlockingTime)},{"../../lib/dependency-graph/base-node.js":88,"../computed-artifact.js":9,"./lantern-first-contentful-paint.js":22,"./lantern-interactive.js":24,"./lantern-metric.js":27,"./total-blocking-time.js":37}],30:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./navigation-metric.js"),s=e("../../lib/lh-error.js");t.exports=i(class LargestContentfulPaintAllFrames extends a{static async computeSimulatedMetric(){throw new Error("LCP All Frames not implemented in lantern")}static async computeObservedMetric(e){const{processedNavigation:t}=e;if(void 0===t.timings.largestContentfulPaintAllFrames)throw new s(s.errors.NO_LCP_ALL_FRAMES);return{timing:t.timings.largestContentfulPaintAllFrames,timestamp:t.timestamps.largestContentfulPaintAllFrames}}})},{"../../lib/lh-error.js":103,
"../computed-artifact.js":9,"./navigation-metric.js":34}],31:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./navigation-metric.js"),s=e("../../lib/lh-error.js"),c=e("./lantern-largest-contentful-paint.js");t.exports=i(class LargestContentfulPaint extends a{static computeSimulatedMetric(e,t){const n=a.getMetricComputationInput(e);return c.request(n,t)}static async computeObservedMetric(e){const{processedNavigation:t}=e;if(void 0===t.timings.largestContentfulPaint)throw new s(s.errors.NO_LCP);return{timing:t.timings.largestContentfulPaint,timestamp:t.timestamps.largestContentfulPaint}}})},{"../../lib/lh-error.js":103,"../computed-artifact.js":9,"./lantern-largest-contentful-paint.js":25,"./navigation-metric.js":34}],32:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./navigation-metric.js"),s=e("./lantern-max-potential-fid.js"),c=e("../../lib/tracehouse/trace-processor.js");t.exports=i(class MaxPotentialFID extends a{
static computeSimulatedMetric(e,t){const n=a.getMetricComputationInput(e);return s.request(n,t)}static computeObservedMetric(e){const{firstContentfulPaint:t}=e.processedNavigation.timings,n=c.getMainThreadTopLevelEvents(e.processedTrace,t).filter((e=>e.duration>=1));return Promise.resolve({timing:Math.max(...n.map((e=>e.duration)),16)})}})},{"../../lib/tracehouse/trace-processor.js":119,"../computed-artifact.js":9,"./lantern-max-potential-fid.js":26,"./navigation-metric.js":34}],33:[function(e,t,n){"use strict";const i=e("../../lib/tracehouse/trace-processor.js"),a=e("../processed-trace.js"),s=e("../processed-navigation.js"),c=e("../network-records.js");t.exports=class Metric{constructor(){}static getMetricComputationInput(e){return{trace:e.trace,devtoolsLog:e.devtoolsLog,gatherContext:e.gatherContext,settings:e.settings}}static computeSimulatedMetric(e,t){throw new Error("Unimplemented")}static computeObservedMetric(e,t){throw new Error("Unimplemented")}static async compute_(e,t){
const n=e.gatherContext||{gatherMode:"navigation"},{trace:l,devtoolsLog:u,settings:d}=e;if(!l||!u||!d)throw new Error("Did not provide necessary metric computation data");const m=await a.request(l,t),p="timespan"===n.gatherMode?void 0:await s.request(m,t),h=Object.assign({networkRecords:await c.request(u,t),gatherContext:n,processedTrace:m,processedNavigation:p},e);switch(i.assertHasToplevelEvents(h.processedTrace.mainThreadEvents),d.throttlingMethod){case"simulate":if("navigation"!==n.gatherMode)throw new Error(n.gatherMode+" does not support throttlingMethod simulate");return this.computeSimulatedMetric(h,t);case"provided":case"devtools":return this.computeObservedMetric(h,t);default:throw new TypeError("Unrecognized throttling method: "+d.throttlingMethod)}}}},{"../../lib/tracehouse/trace-processor.js":119,"../network-records.js":40,"../processed-navigation.js":42,"../processed-trace.js":43}],34:[function(e,t,n){"use strict";const i=e("./metric.js")
;t.exports=class NavigationMetric extends i{static computeSimulatedMetric(e,t){throw new Error("Unimplemented")}static computeObservedMetric(e,t){throw new Error("Unimplemented")}static async compute_(e,t){if("navigation"!==e.gatherContext.gatherMode)throw new Error(this.name+" can only be computed on navigations");return super.compute_(e,t)}}},{"./metric.js":33}],35:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./navigation-metric.js"),s=e("./lantern-speed-index.js"),c=e("../speedline.js");t.exports=i(class SpeedIndex extends a{static computeSimulatedMetric(e,t){const n=a.getMetricComputationInput(e);return s.request(n,t)}static async computeObservedMetric(e,t){const n=await c.request(e.trace,t),i=Math.round(n.speedIndex),a=1e3*(i+n.beginning);return Promise.resolve({timing:i,timestamp:a})}})},{"../computed-artifact.js":9,"../speedline.js":46,"./lantern-speed-index.js":28,"./navigation-metric.js":34}],36:[function(e,t,n){"use strict"
;const i=e("../processed-trace.js"),a=e("../processed-navigation.js"),s=e("../speedline.js"),c=e("./first-contentful-paint.js"),l=e("./first-contentful-paint-all-frames.js"),u=e("./first-meaningful-paint.js"),d=e("./largest-contentful-paint.js"),m=e("./largest-contentful-paint-all-frames.js"),p=e("./interactive.js"),h=e("./cumulative-layout-shift.js"),f=e("./speed-index.js"),g=e("./max-potential-fid.js"),y=e("./total-blocking-time.js"),b=e("../computed-artifact.js");class TimingSummary{static async summarize(e,t,n,b,v){const w={trace:e,devtoolsLog:t,gatherContext:n,settings:b
},requestOrUndefined=(e,t)=>e.request(t,v).catch((e=>{})),S=await i.request(e,v),T=await requestOrUndefined(a,S),E=await s.request(e,v),_=await requestOrUndefined(c,w),x=await requestOrUndefined(l,w),A=await requestOrUndefined(u,w),k=await requestOrUndefined(d,w),R=await requestOrUndefined(m,w),D=await requestOrUndefined(p,w),I=await requestOrUndefined(h,e),C=await requestOrUndefined(g,w),j=await requestOrUndefined(f,w),N=await requestOrUndefined(y,w),{cumulativeLayoutShift:L,cumulativeLayoutShiftMainFrame:M,totalCumulativeLayoutShift:P}=I||{};return{metrics:{firstContentfulPaint:_&&_.timing,firstContentfulPaintTs:_&&_.timestamp,firstContentfulPaintAllFrames:x&&x.timing,firstContentfulPaintAllFramesTs:x&&x.timestamp,firstMeaningfulPaint:A&&A.timing,firstMeaningfulPaintTs:A&&A.timestamp,largestContentfulPaint:k&&k.timing,largestContentfulPaintTs:k&&k.timestamp,largestContentfulPaintAllFrames:R&&R.timing,largestContentfulPaintAllFramesTs:R&&R.timestamp,interactive:D&&D.timing,
interactiveTs:D&&D.timestamp,speedIndex:j&&j.timing,speedIndexTs:j&&j.timestamp,totalBlockingTime:N&&N.timing,maxPotentialFID:C&&C.timing,cumulativeLayoutShift:L,cumulativeLayoutShiftMainFrame:M,totalCumulativeLayoutShift:P,observedTimeOrigin:S.timings.timeOrigin,observedTimeOriginTs:S.timestamps.timeOrigin,observedNavigationStart:T&&T.timings.timeOrigin,observedNavigationStartTs:T&&T.timestamps.timeOrigin,observedFirstPaint:T&&T.timings.firstPaint,observedFirstPaintTs:T&&T.timestamps.firstPaint,observedFirstContentfulPaint:T&&T.timings.firstContentfulPaint,observedFirstContentfulPaintTs:T&&T.timestamps.firstContentfulPaint,observedFirstContentfulPaintAllFrames:T&&T.timings.firstContentfulPaintAllFrames,observedFirstContentfulPaintAllFramesTs:T&&T.timestamps.firstContentfulPaintAllFrames,observedFirstMeaningfulPaint:T&&T.timings.firstMeaningfulPaint,observedFirstMeaningfulPaintTs:T&&T.timestamps.firstMeaningfulPaint,observedLargestContentfulPaint:T&&T.timings.largestContentfulPaint,
observedLargestContentfulPaintTs:T&&T.timestamps.largestContentfulPaint,observedLargestContentfulPaintAllFrames:T&&T.timings.largestContentfulPaintAllFrames,observedLargestContentfulPaintAllFramesTs:T&&T.timestamps.largestContentfulPaintAllFrames,observedTraceEnd:S.timings.traceEnd,observedTraceEndTs:S.timestamps.traceEnd,observedLoad:T&&T.timings.load,observedLoadTs:T&&T.timestamps.load,observedDomContentLoaded:T&&T.timings.domContentLoaded,observedDomContentLoadedTs:T&&T.timestamps.domContentLoaded,observedCumulativeLayoutShift:L,observedCumulativeLayoutShiftMainFrame:M,observedTotalCumulativeLayoutShift:P,observedFirstVisualChange:E.first,observedFirstVisualChangeTs:1e3*(E.first+E.beginning),observedLastVisualChange:E.complete,observedLastVisualChangeTs:1e3*(E.complete+E.beginning),observedSpeedIndex:E.speedIndex,observedSpeedIndexTs:1e3*(E.speedIndex+E.beginning)},debugInfo:{lcpInvalidated:!(!T||!T.lcpInvalidated)}}}static async compute_(e,t){
return TimingSummary.summarize(e.trace,e.devtoolsLog,e.gatherContext,e.settings,t)}}t.exports=b(TimingSummary)},{"../computed-artifact.js":9,"../processed-navigation.js":42,"../processed-trace.js":43,"../speedline.js":46,"./cumulative-layout-shift.js":17,"./first-contentful-paint-all-frames.js":18,"./first-contentful-paint.js":19,"./first-meaningful-paint.js":20,"./interactive.js":21,"./largest-contentful-paint-all-frames.js":30,"./largest-contentful-paint.js":31,"./max-potential-fid.js":32,"./speed-index.js":35,"./total-blocking-time.js":37}],37:[function(e,t,n){"use strict";const i=e("../computed-artifact.js"),a=e("./metric.js"),s=e("../../lib/tracehouse/trace-processor.js"),c=e("./lantern-total-blocking-time.js"),l=e("./interactive.js");class TotalBlockingTime extends a{static get BLOCKING_TIME_THRESHOLD(){return 50}static calculateSumOfBlockingTime(e,t,n){if(n<=t)return 0;const i=TotalBlockingTime.BLOCKING_TIME_THRESHOLD;let a=0;for(const s of e){if(s.duration<i)continue
;if(s.end<t)continue;if(s.start>n)continue;const e=Math.max(s.start,t),c=Math.min(s.end,n)-e;c<i||(a+=c-i)}return a}static computeSimulatedMetric(e,t){const n=a.getMetricComputationInput(e);return c.request(n,t)}static async computeObservedMetric(e,t){const n=s.getMainThreadTopLevelEvents(e.processedTrace);if(e.processedNavigation){const{firstContentfulPaint:i}=e.processedNavigation.timings,s=a.getMetricComputationInput(e),c=(await l.request(s,t)).timing;return{timing:TotalBlockingTime.calculateSumOfBlockingTime(n,i,c)}}return{timing:TotalBlockingTime.calculateSumOfBlockingTime(n,0,e.processedTrace.timestamps.traceEnd)}}}t.exports=i(TotalBlockingTime)},{"../../lib/tracehouse/trace-processor.js":119,"../computed-artifact.js":9,"./interactive.js":21,"./lantern-total-blocking-time.js":29,"./metric.js":33}],38:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("./js-bundles.js");class ModuleDuplication{static normalizeSource(e){
const t=(e=e.replace(/\?$/,"")).lastIndexOf("node_modules");return-1!==t&&(e=e.substring(t)),e}static _shouldIgnoreSource(e){return!!e.includes("webpack/bootstrap")||(!!e.includes("(webpack)/buildin")||!!e.includes("external "))}static _normalizeAggregatedData(e){for(const[t,n]of e.entries()){let i=n;if(i.sort(((e,t)=>t.resourceSize-e.resourceSize)),i.length>1){const e=i[0].resourceSize;i=i.filter((t=>t.resourceSize/e>=.1))}i=i.filter((e=>e.resourceSize>=512)),i.length>1?e.set(t,i):e.delete(t)}}static async compute_(e,t){const n=await a.request(e,t),i=new Map;for(const{rawMap:e,sizes:t}of n){if("errorMessage"in t)continue;const n=[];i.set(e,n);for(let i=0;i<e.sources.length;i++){if(this._shouldIgnoreSource(e.sources[i]))continue;const a=(e.sourceRoot||"")+e.sources[i],s=t.files[a];n.push({source:ModuleDuplication.normalizeSource(e.sources[i]),resourceSize:s})}}const s=new Map;for(const{rawMap:e,script:t}of n){const n=i.get(e);if(n)for(const e of n){let n=s.get(e.source);n||(n=[],
s.set(e.source,n)),n.push({scriptUrl:t.src||"",resourceSize:e.resourceSize})}}return this._normalizeAggregatedData(s),s}}t.exports=i(ModuleDuplication)},{"./computed-artifact.js":9,"./js-bundles.js":12}],39:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../lib/dependency-graph/simulator/network-analyzer.js"),s=e("./network-records.js");class NetworkAnalysis{static computeRTTAndServerResponseTime(e){const t=new Map;for(const[n,i]of a.estimateRTTByOrigin(e).entries())t.set(n,i.min);const n=Math.min(...Array.from(t.values())),i=a.estimateServerResponseTimeByOrigin(e,{rttByOrigin:t}),s=new Map,c=new Map;for(const[e,a]of i.entries()){const i=t.get(e)||n;s.set(e,i-n),c.set(e,a.median)}return{rtt:n,additionalRttByOrigin:s,serverResponseTimeByOrigin:c}}static async compute_(e,t){const n=await s.request(e,t);return{throughput:a.estimateThroughput(n),...NetworkAnalysis.computeRTTAndServerResponseTime(n)}}}t.exports=i(NetworkAnalysis)},{
"../lib/dependency-graph/simulator/network-analyzer.js":93,"./computed-artifact.js":9,"./network-records.js":40}],40:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../lib/network-recorder.js");t.exports=i(class NetworkRecords{static async compute_(e){return a.recordsFromLogs(e)}})},{"../lib/network-recorder.js":108,"./computed-artifact.js":9}],41:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../lib/dependency-graph/network-node.js"),s=e("../lib/dependency-graph/cpu-node.js"),c=e("../lib/dependency-graph/simulator/network-analyzer.js"),l=e("../lib/tracehouse/trace-processor.js"),u=e("../lib/network-request.js"),d=e("./processed-trace.js"),m=e("./network-records.js"),p=/^video/;class PageDependencyGraph{static getNetworkInitiators(e){if(!e.initiator)return[];if(e.initiator.url)return[e.initiator.url];if("script"===e.initiator.type){const t=new Set;let n=e.initiator.stack;for(;n;){const e=n.callFrames||[]
;for(const n of e)n.url&&t.add(n.url);n=n.parent}return Array.from(t)}return[]}static getNetworkNodeOutput(e){const t=[],n=new Map,i=new Map,s=new Map;return e.forEach((e=>{if(p.test(e.mimeType))return;for(;n.has(e.requestId);)e.requestId+=":duplicate";const c=new a(e);t.push(c);const l=i.get(e.url)||[];if(l.push(c),n.set(e.requestId,c),i.set(e.url,l),e.frameId&&e.resourceType===u.TYPES.Document&&e.documentURL===e.url){const t=s.has(e.frameId)?null:c;s.set(e.frameId,t)}})),{nodes:t,idToNodeMap:n,urlToNodeMap:i,frameIdToNodeMap:s}}static getCPUNodes({mainThreadEvents:e}){const t=[];let n=0;for(l.assertHasToplevelEvents(e);n<e.length;){const i=e[n];if(n++,!l.isScheduleableTask(i)||!i.dur)continue;const a=[];for(const t=i.ts+i.dur;n<e.length&&e[n].ts<t;n++)a.push(e[n]);t.push(new s(i,a))}return t}static linkNetworkNodes(e,t){t.nodes.forEach((n=>{const i=n.record.initiatorRequest||e.record,a=t.idToNodeMap.get(i.requestId)||e,s=PageDependencyGraph.getNetworkInitiators(n.record)
;if(s.length?s.forEach((e=>{const i=t.urlToNodeMap.get(e)||[];1===i.length&&i[0].startTime<=n.startTime&&!i[0].isDependentOn(n)?n.addDependency(i[0]):a.isDependentOn(n)||a.addDependent(n)})):a.isDependentOn(n)||a.addDependent(n),n!==e&&0===n.getDependencies().length&&n.addDependency(e),!n.record.redirects)return;const c=[...n.record.redirects,n.record];for(let e=1;e<c.length;e++){const n=t.idToNodeMap.get(c[e-1].requestId),i=t.idToNodeMap.get(c[e].requestId);i&&n&&i.addDependency(n)}}))}static linkCPUNodes(e,t,n){const i=new Set([u.TYPES.XHR,u.TYPES.Fetch,u.TYPES.Script]);function addDependentNetworkRequest(e,n){const a=t.idToNodeMap.get(n);if(!a||a.startTime<=e.startTime)return;const{record:s}=a,c=s.resourceType||s.redirectDestination&&s.redirectDestination.resourceType;i.has(c)&&e.addDependent(a)}function addDependencyOnFrame(e,n){if(!n)return;const i=t.frameIdToNodeMap.get(n);i&&(i.startTime>=e.startTime||e.addDependency(i))}function addDependencyOnUrl(e,n){if(!n)return
;const i=t.urlToNodeMap.get(n)||[];let a=null,s=1/0;for(const t of i){if(e.startTime<=t.startTime)return;const n=e.startTime-t.endTime;n>=-1e5&&n<s&&(a=t,s=n)}a&&e.addDependency(a)}const a=new Map;for(const t of n){for(const e of t.childEvents){if(!e.args.data)continue;const n=e.args.data.url,i=(e.args.data.stackTrace||[]).map((e=>e.url)).filter(Boolean);switch(e.name){case"TimerInstall":a.set(e.args.data.timerId,t),i.forEach((e=>addDependencyOnUrl(t,e)));break;case"TimerFire":{const n=a.get(e.args.data.timerId);if(!n||n.endTime>t.startTime)break;n.addDependent(t);break}case"InvalidateLayout":case"ScheduleStyleRecalculation":addDependencyOnFrame(t,e.args.data.frame),i.forEach((e=>addDependencyOnUrl(t,e)));break;case"EvaluateScript":addDependencyOnFrame(t,e.args.data.frame),addDependencyOnUrl(t,n),i.forEach((e=>addDependencyOnUrl(t,e)));break;case"XHRReadyStateChange":if(4!==e.args.data.readyState)break;addDependencyOnUrl(t,n),i.forEach((e=>addDependencyOnUrl(t,e)));break
;case"FunctionCall":case"v8.compile":addDependencyOnFrame(t,e.args.data.frame),addDependencyOnUrl(t,n);break;case"ParseAuthorStyleSheet":addDependencyOnFrame(t,e.args.data.frame),addDependencyOnUrl(t,e.args.data.styleSheetUrl);break;case"ResourceSendRequest":addDependencyOnFrame(t,e.args.data.frame),addDependentNetworkRequest(t,e.args.data.requestId),i.forEach((e=>addDependencyOnUrl(t,e)))}}0===t.getNumberOfDependencies()&&t.addDependency(e)}let s=!1,c=!1,l=!1;for(const e of n){let t=!1;!s&&e.childEvents.some((e=>"Layout"===e.name))&&(t=s=!0),!c&&e.childEvents.some((e=>"Paint"===e.name))&&(t=c=!0),!l&&e.childEvents.some((e=>"ParseHTML"===e.name))&&(t=l=!0),t||e.event.dur>=1e4||(1===e.getNumberOfDependencies()||e.getNumberOfDependents()<=1)&&PageDependencyGraph._pruneNode(e)}}static _pruneNode(e){const t=e.getDependencies(),n=e.getDependents();for(const i of t){e.removeDependency(i);for(const e of n)i.addDependent(e)}for(const t of n)e.removeDependent(t)}static createGraph(e,t){
const n=PageDependencyGraph.getNetworkNodeOutput(t),i=PageDependencyGraph.getCPUNodes(e),s=t.reduce(((e,t)=>t.startTime<e.startTime?t:e)),l=n.idToNodeMap.get(s.requestId),u=c.findMainDocument(t),d=n.idToNodeMap.get(u.requestId);if(!l||!d)throw new Error((l?"mainDocument":"root")+"Node not found.");if(!(d===l||d.record.redirects&&d.record.redirects.includes(l.record)))throw new Error("Root node was not in redirect chain of mainDocument");if(PageDependencyGraph.linkNetworkNodes(l,n),PageDependencyGraph.linkCPUNodes(l,n,i),d.setIsMainDocument(!0),a.hasCycle(l))throw new Error("Invalid dependency graph created, cycle detected");return l}static printGraph(e,t=100){function padRight(e,t,n=" "){return e+n.repeat(Math.max(t-e.length,0))}const n=[];e.traverse((e=>n.push(e))),n.sort(((e,t)=>e.startTime-t.startTime));const i=n[0].startTime,a=(n.reduce(((e,t)=>Math.max(e,t.endTime)),0)-i)/t;n.forEach((e=>{
const n=Math.round((e.startTime-i)/a),s=Math.ceil((e.endTime-e.startTime)/a),c=padRight("",n)+padRight("",s,"="),l=e.record?e.record.url:e.type;console.log(padRight(c,t),"| "+l.slice(0,30))}))}static async compute_(e,t){const n=e.trace,i=e.devtoolsLog,[a,s]=await Promise.all([d.request(n,t),m.request(i,t)]);return PageDependencyGraph.createGraph(a,s)}}t.exports=i(PageDependencyGraph)},{"../lib/dependency-graph/cpu-node.js":89,"../lib/dependency-graph/network-node.js":90,"../lib/dependency-graph/simulator/network-analyzer.js":93,"../lib/network-request.js":109,"../lib/tracehouse/trace-processor.js":119,"./computed-artifact.js":9,"./network-records.js":40,"./processed-trace.js":43}],42:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../lib/lh-trace-processor.js");t.exports=i(class ProcessedNavigation{static async compute_(e){return a.processNavigation(e)}})},{"../lib/lh-trace-processor.js":104,"./computed-artifact.js":9}],43:[function(e,t,n){"use strict"
;const i=e("./computed-artifact.js"),a=e("../lib/lh-trace-processor.js");t.exports=i(class ProcessedTrace{static async compute_(e){return a.processTrace(e)}})},{"../lib/lh-trace-processor.js":104,"./computed-artifact.js":9}],44:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("./network-records.js"),s=e("../lib/url-shim.js"),c=e("../lib/network-request.js"),l=e("../config/budget.js"),u=e("../util-commonjs.js");class ResourceSummary{static determineResourceType(e){if(!e.resourceType)return"other";return{Stylesheet:"stylesheet",Image:"image",Media:"media",Font:"font",Script:"script",Document:"document"}[e.resourceType]||"other"}static summarize(e,t,n){const i={stylesheet:{count:0,resourceSize:0,transferSize:0},image:{count:0,resourceSize:0,transferSize:0},media:{count:0,resourceSize:0,transferSize:0},font:{count:0,resourceSize:0,transferSize:0},script:{count:0,resourceSize:0,transferSize:0},document:{count:0,resourceSize:0,transferSize:0},other:{count:0,
resourceSize:0,transferSize:0},total:{count:0,resourceSize:0,transferSize:0},"third-party":{count:0,resourceSize:0,transferSize:0}},a=l.getMatchingBudget(n,t);let d=[];if(a&&a.options&&a.options.firstPartyHostnames)d=a.options.firstPartyHostnames;else{const e=u.getRootDomain(t);d=["*."+e]}return e.filter((e=>("other"!==this.determineResourceType(e)||!e.url.endsWith("/favicon.ico"))&&!c.isNonNetworkRequest(e))).forEach((e=>{const t=this.determineResourceType(e);i[t].count++,i[t].resourceSize+=e.resourceSize,i[t].transferSize+=e.transferSize,i.total.count++,i.total.resourceSize+=e.resourceSize,i.total.transferSize+=e.transferSize;d.some((t=>{const n=new s(e.url);return t.startsWith("*.")?n.hostname.endsWith(t.slice(2)):n.hostname===t}))||(i["third-party"].count++,i["third-party"].resourceSize+=e.resourceSize,i["third-party"].transferSize+=e.transferSize)})),i}static async compute_(e,t){const n=await a.request(e.devtoolsLog,t);return ResourceSummary.summarize(n,e.URL.finalUrl,e.budgets)}}
t.exports=i(ResourceSummary)},{"../config/budget.js":52,"../lib/network-request.js":109,"../lib/url-shim.js":"url","../util-commonjs.js":124,"./computed-artifact.js":9,"./network-records.js":40}],45:[function(e,t,n){"use strict";const i=e("./computed-artifact.js");t.exports=i(class Screenshots{static async compute_(e){return e.traceEvents.filter((e=>"Screenshot"===e.name)).map((e=>({timestamp:e.ts,datauri:"data:image/jpeg;base64,"+e.args.snapshot})))}})},{"./computed-artifact.js":9}],46:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("speedline-core"),s=e("../lib/lh-error.js"),c=e("./processed-trace.js");t.exports=i(class Speedline{static async compute_(e,t){return c.request(e,t).then((t=>{const n=e.traceEvents.slice(),i=t.timestamps.timeOrigin;return a(n,{timeOrigin:i,fastMode:!0,include:"speedIndex"})})).catch((e=>{if(/No screenshots found in trace/.test(e.message))throw new s(s.errors.NO_SCREENSHOTS);throw e})).then((e=>{
if(0===e.frames.length)throw new s(s.errors.NO_SPEEDLINE_FRAMES);if(0===e.speedIndex)throw new s(s.errors.SPEEDINDEX_OF_ZERO);return e}))}})},{"../lib/lh-error.js":103,"./computed-artifact.js":9,"./processed-trace.js":43,"speedline-core":232}],47:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("./computed-artifact.js"),s=e("./processed-trace.js"),c=e("./processed-navigation.js");i.warn("trace-of-tab","trace-of-tab is deprecated, use processed-trace / processed-navigation instead"),t.exports=a(class TraceOfTab{static async compute_(e,t){const n=await s.request(e,t),i=await c.request(n,t);return{...n,...i}}})},{"./computed-artifact.js":9,"./processed-navigation.js":42,"./processed-trace.js":43,"lighthouse-logger":188}],48:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("../audits/byte-efficiency/byte-efficiency-audit.js"),s=e("./network-records.js"),c=100;class UnusedCSS{static indexStylesheetsById(e,t){
const n=t.filter((e=>e.resourceSize>0)).reduce(((e,t)=>(e[t.url]=t,e)),{});return e.reduce(((e,t)=>(e[t.header.styleSheetId]=Object.assign({usedRules:[],networkRecord:n[t.header.sourceURL]},t),e)),{})}static indexUsedRules(e,t){e.forEach((e=>{const n=t[e.styleSheetId];n&&e.used&&n.usedRules.push(e)}))}static computeUsage(e){let t=0;const n=e.content.length;for(const n of e.usedRules)t+=n.endOffset-n.startOffset;const i=a.estimateTransferSize(e.networkRecord,n,"Stylesheet"),s=(n-t)/n;return{wastedBytes:Math.round(s*i),wastedPercent:100*s,totalBytes:i}}static determineContentPreview(e){let t=(e||"").slice(0,500).replace(/( {2,}|\t)+/g,"  ").replace(/\n\s+}/g,"\n}").trim();if(t.length>c){const e=t.indexOf("{"),n=t.indexOf("}");if(-1===e||-1===n||e>n||e>c)t=t.slice(0,c)+"...";else if(n<c)t=t.slice(0,n+1)+" ...";else{const n=t.slice(0,c).lastIndexOf(";");t=n<e?t.slice(0,c)+"... } ...":t.slice(0,n+1)+" ... } ..."}}return t}static mapSheetToResult(e,t){let n=e.header.sourceURL;if(!n||n===t){
n=UnusedCSS.determineContentPreview(e.content)}return{url:n,...UnusedCSS.computeUsage(e)}}static async compute_(e,t){const{CSSUsage:n,URL:i,devtoolsLog:a}=e,c=await s.request(a,t),l=UnusedCSS.indexStylesheetsById(n.stylesheets,c);UnusedCSS.indexUsedRules(n.rules,l);return Object.keys(l).map((e=>UnusedCSS.mapSheetToResult(l[e],i.finalUrl)))}}t.exports=i(UnusedCSS)},{"../audits/byte-efficiency/byte-efficiency-audit.js":4,"./computed-artifact.js":9,"./network-records.js":40}],49:[function(e,t,n){"use strict";const i=e("./computed-artifact.js");class UnusedJavascriptSummary{static computeWaste(e){let t=0;for(const n of e.functions)t=Math.max(t,...n.ranges.map((e=>e.endOffset)));const n=new Uint8Array(t);for(const t of e.functions)for(const e of t.ranges)if(0===e.count)for(let t=e.startOffset;t<e.endOffset;t++)n[t]=1;let i=0;for(const e of n)i+=e;return{unusedByIndex:n,unusedLength:i,contentLength:t}}static createItem(e,t){const n=t.unused/t.content||0,i=Math.round(t.content*n);return{
url:e,totalBytes:t.content,wastedBytes:i,wastedPercent:100*n}}static determineLengths(e){let t=0,n=0;for(const i of e)t+=i.unusedLength,n+=i.contentLength;return{content:n,unused:t}}static createSourceWastedBytes(e,t){if(!t.script.content)return;const n={},i=t.script.content.split("\n").map((e=>e.length));let a=0;const s=i.map((e=>{const t=a;return a+=e+1,t}));t.map.computeLastGeneratedColumns();for(const a of t.map.mappings()){let t=s[a.lineNumber];t+=a.columnNumber;const c=a.lastColumnNumber-1||i[a.lineNumber];for(let i=a.columnNumber;i<=c;i++){if(e.every((e=>1===e.unusedByIndex[t]))){const e=a.sourceURL||"(unmapped)";n[e]=(n[e]||0)+1}t+=1}}const c=Object.entries(n).sort((([e,t],[n,i])=>i-t)),l={};for(const[e,t]of c)l[e]=t;return l}static async compute_(e){const{url:t,scriptCoverages:n,bundle:i}=e,a=n.map(UnusedJavascriptSummary.computeWaste),s=UnusedJavascriptSummary.determineLengths(a),c=UnusedJavascriptSummary.createItem(t,s);return i?{...c,
sourcesWastedBytes:UnusedJavascriptSummary.createSourceWastedBytes(a,i)}:c}}t.exports=i(UnusedJavascriptSummary)},{"./computed-artifact.js":9}],50:[function(e,t,n){"use strict";const i=e("./computed-artifact.js"),a=e("./processed-trace.js");t.exports=i(class UserTimings{static async compute_(e,t){const n=await a.request(e,t),i=[],s={};return n.processEvents.filter((e=>!!e.cat.includes("blink.user_timing")&&("requestStart"!==e.name&&"navigationStart"!==e.name&&"paintNonDefaultBackgroundColor"!==e.name&&void 0===e.args.frame))).forEach((e=>{"R"===e.ph||"I"===e.ph.toUpperCase()?i.push({name:e.name,isMark:!0,args:e.args,startTime:e.ts}):"b"===e.ph.toLowerCase()?s[e.name]=e.ts:"e"===e.ph.toLowerCase()&&i.push({name:e.name,isMark:!1,args:e.args,startTime:s[e.name],endTime:e.ts,duration:e.ts-s[e.name]})})),i.forEach((e=>{e.startTime=(e.startTime-n.timeOriginEvt.ts)/1e3,e.isMark||(e.endTime=(e.endTime-n.timeOriginEvt.ts)/1e3,e.duration=e.duration/1e3)})),i}})},{"./computed-artifact.js":9,
"./processed-trace.js":43}],51:[function(e,t,n){"use strict";const i=e("metaviewport-parser"),a=e("./computed-artifact.js");t.exports=a(class ViewportMeta{static async compute_(e){const t=e.find((e=>"viewport"===e.name));if(!t)return{hasViewportTag:!1,isMobileOptimized:!1,parserWarnings:[]};const n=[],a=i.parseMetaViewPortContent(t.content||"");Object.keys(a.unknownProperties).length&&n.push("Invalid properties found: "+JSON.stringify(a.unknownProperties)),Object.keys(a.invalidValues).length&&n.push("Invalid values found: "+JSON.stringify(a.invalidValues));const s=a.validProperties;return{hasViewportTag:!0,isMobileOptimized:Boolean(s.width||s["initial-scale"]),parserWarnings:n}}})},{"./computed-artifact.js":9,"metaviewport-parser":220}],52:[function(e,t,n){"use strict";function isArrayOfUnknownObjects(e){return Array.isArray(e)&&e.every(isObjectOfUnknownProperties)}function isObjectOfUnknownProperties(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)}function isNumber(e){
return"number"==typeof e&&!isNaN(e)}class Budget{static assertNoExcessProperties(e,t){const n=Object.keys(e);if(n.length>0){const e=n.join(", ");throw new Error(`${t} has unrecognized properties: [${e}]`)}}static assertNoDuplicateStrings(e,t){const n=new Set;for(const i of e){if(n.has(i))throw new Error(`${t} has duplicate entry of type '${i}'`);n.add(i)}}static validateResourceBudget(e){const{resourceType:t,budget:n,...i}=e;Budget.assertNoExcessProperties(i,"Resource Budget");const a=["total","document","script","stylesheet","image","media","font","other","third-party"];if(!a.includes(t))throw new Error(`Invalid resource type: ${t}. \nValid resource types are: `+a.join(", "));if(!isNumber(n))throw new Error("Invalid budget: "+n);return{resourceType:t,budget:n}}static throwInvalidPathError(e,t){
throw new Error(`Invalid path ${e}. ${t}\n'Path' should be specified using the 'robots.txt' format.\nLearn more about the 'robots.txt' format here:\nhttps://developers.google.com/search/reference/robots_txt#url-matching-based-on-path-values`)}static validatePath(e){if(void 0!==e){if("string"==typeof e)return e.startsWith("/")?(e.match(/\*/g)||[]).length>1?this.throwInvalidPathError(e,"Path should only contain one '*'."):(e.match(/\$/g)||[]).length>1?this.throwInvalidPathError(e,"Path should only contain one '$' character."):e.includes("$")&&!e.endsWith("$")&&this.throwInvalidPathError(e,"'$' character should only occur at end of path."):this.throwInvalidPathError(e,"Path should start with '/'."),e;this.throwInvalidPathError(e,"Path should be a string.")}}static getMatchingBudget(e,t){if(null!==e)for(let n=e.length-1;n>=0;n--){const i=e[n];if(this.urlMatchesPattern(t,i.path))return i}}static urlMatchesPattern(e,t="/"){
const n=new URL(e),i=n.pathname+n.search,a=t.includes("*"),s=t.includes("$");if(!a&&!s)return i.startsWith(t);if(!a&&s)return i===t.slice(0,-1);if(a&&!s){const[e,n]=t.split("*"),a=i.slice(e.length);return i.startsWith(e)&&a.includes(n)}if(a&&s){const[e,n]=t.split("*"),a=i.slice(e.length);return i.startsWith(e)&&a.endsWith(n.slice(0,-1))}return!1}static validateTimingBudget(e){const{metric:t,budget:n,...i}=e;Budget.assertNoExcessProperties(i,"Timing Budget");const a=["first-contentful-paint","interactive","first-meaningful-paint","max-potential-fid","total-blocking-time","speed-index","largest-contentful-paint","cumulative-layout-shift"];if(!a.includes(t))throw new Error(`Invalid timing metric: ${t}. \nValid timing metrics are: `+a.join(", "));if(!isNumber(n))throw new Error("Invalid budget: "+n);return{metric:t,budget:n}}static validateHostname(e){const t=e+" is not a valid hostname.";if(0===e.length)throw new Error(t);if(e.includes("/"))throw new Error(t)
;if(e.includes(":"))throw new Error(t);if(e.includes("*")&&(!e.startsWith("*.")||e.lastIndexOf("*")>0))throw new Error(t);return e}static validateHostnames(e){if(Array.isArray(e)&&e.every((e=>"string"==typeof e)))return e.map(Budget.validateHostname);if(void 0!==e)throw new Error("firstPartyHostnames should be defined as an array of strings.")}static initializeBudget(e){if(!isArrayOfUnknownObjects(e=JSON.parse(JSON.stringify(e))))throw new Error("Budget file is not defined as an array of budgets.");return e.map(((e,t)=>{const n={},{path:i,options:a,resourceSizes:s,resourceCounts:c,timings:l,...u}=e;if(Budget.assertNoExcessProperties(u,"Budget"),n.path=Budget.validatePath(i),isObjectOfUnknownProperties(a)){const{firstPartyHostnames:e,...t}=a;Budget.assertNoExcessProperties(t,"Options property"),n.options={},n.options.firstPartyHostnames=Budget.validateHostnames(e)}else if(void 0!==a)throw new Error("Invalid options property in budget at index "+t)
;if(isArrayOfUnknownObjects(s))n.resourceSizes=s.map(Budget.validateResourceBudget),Budget.assertNoDuplicateStrings(n.resourceSizes.map((e=>e.resourceType)),`budgets[${t}].resourceSizes`);else if(void 0!==s)throw new Error("Invalid resourceSizes entry in budget at index "+t);if(isArrayOfUnknownObjects(c))n.resourceCounts=c.map(Budget.validateResourceBudget),Budget.assertNoDuplicateStrings(n.resourceCounts.map((e=>e.resourceType)),`budgets[${t}].resourceCounts`);else if(void 0!==c)throw new Error("Invalid resourceCounts entry in budget at index "+t);if(isArrayOfUnknownObjects(l))n.timings=l.map(Budget.validateTimingBudget),Budget.assertNoDuplicateStrings(n.timings.map((e=>e.metric)),`budgets[${t}].timings`);else if(void 0!==l)throw new Error("Invalid timings entry in budget at index "+t);return n}))}}t.exports=Budget},{}],53:[function(e,t,n){(function(n,i,a){(function(){"use strict"
;const s=e("path"),c=e("lodash.isequal"),l=e("./constants.js"),u=e("./budget.js"),d=e("./config-plugin.js"),m=e("../runner.js"),p=e("../lib/i18n/i18n.js"),h=e("../fraggle-rock/config/validation.js");function isBundledEnvironment(){if(i.isDevtools||i.isLightrider)return!0;try{return e.resolve("lighthouse-logger"),!1}catch(e){return!0}}const mergeOptionsOfItems=function(e){const t=[];for(const n of e){const e=n.path&&t.find((e=>e.path===n.path));e?e.options=Object.assign({},e.options,n.options):t.push(n)}return t};const f=function _mergeConfigFragment(e,t,n=!1){if(null==e)return t;if(void 0===t)return e;if(Array.isArray(t)){if(n)return t;if(!Array.isArray(e))throw new TypeError("Expected array but got "+typeof e);const i=e.slice();return t.forEach((e=>{i.some((t=>c(t,e)))||i.push(e)})),i}if("object"==typeof t){if("object"!=typeof e)throw new TypeError("Expected object but got "+typeof e);if(Array.isArray(e))throw new TypeError("Expected object but got Array")
;return Object.keys(t).forEach((i=>{const a=n||"settings"===i&&"object"==typeof e[i];e[i]=_mergeConfigFragment(e[i],t[i],a)})),e}return t};function resolveModulePath(t,i,c){try{return e.resolve(t)}catch(e){}try{return e.resolve(t,{paths:[n.cwd()]})}catch(e){}const l=s.resolve(n.cwd(),t);try{return e.resolve(l)}catch(e){}const u="Unable to locate "+(c?c+": ":"")+`\`${t}\`.\n     Tried to require() from these locations:\n       ${a}\n       ${l}`;if(!i)throw new Error(u);const d=s.resolve(i,t);try{return e.resolve(d)}catch(e){}try{return e.resolve(t,{paths:[i]})}catch(e){}throw new Error(u+"\n       "+d)}function shallowClone(e){return"object"==typeof e?Object.assign(Object.create(Object.getPrototypeOf(e)),e):e}function deepClone(e){return JSON.parse(JSON.stringify(e))}t.exports={deepClone,deepCloneConfigJson:function deepCloneConfigJson(e){const t=deepClone(e);if(Array.isArray(t.passes)&&Array.isArray(e.passes))for(let n=0;n<t.passes.length;n++){
t.passes[n].gatherers=(e.passes[n].gatherers||[]).map((e=>shallowClone(e)))}return Array.isArray(e.audits)&&(t.audits=e.audits.map((e=>shallowClone(e)))),Array.isArray(e.artifacts)&&(t.artifacts=e.artifacts.map((e=>({...e,gatherer:shallowClone(e.gatherer)})))),t},mergeOptionsOfItems,mergeConfigFragment:f,mergeConfigFragmentArrayByKey:function mergeConfigFragmentArrayByKey(e,t,n){const i=new Map,a=e||[];for(let e=0;e<a.length;e++){const t=a[e];i.set(n(t),{index:e,item:t})}for(const e of t||[]){const t=i.get(n(e));if(t){const n=t.item,i="object"==typeof e&&"object"==typeof n?f(n,e,!0):e;a[t.index]=i}else a.push(e)}return a},mergePlugins:function mergePlugins(t,n,i){const a=t.plugins||[],s=i&&i.plugins||[],c=new Set([...a,...s]);for(const i of c){h.assertValidPluginName(t,i);const a=isBundledEnvironment()?i:resolveModulePath(i,n,"plugin"),s=e(a),c=d.parsePlugin(s,i);t=f(t,c)}return t},resolveSettings:function resolveSettings(e={},t){
const n=p.lookupLocale(t&&t.locale||e.locale),{defaultSettings:i}=l,a=f(deepClone(i),e,!0),s=f(a,function cleanFlagsForSettings(e={}){const t={};for(const n of Object.keys(e))n in l.defaultSettings&&(t[n]=e[n]);return t}(t),!0);return s.budgets&&(s.budgets=u.initializeBudget(s.budgets)),s.locale=n,!0===s.emulatedUserAgent&&(s.emulatedUserAgent=l.userAgents[s.formFactor]),h.assertValidSettings(s),s},resolveGathererToDefn:function resolveGathererToDefn(t,n,i){const a=function expandGathererShorthand(e){if("string"==typeof e)return{path:e};if("implementation"in e||"instance"in e)return e;if("path"in e){if("string"!=typeof e.path)throw new Error("Invalid Gatherer type "+JSON.stringify(e));return e}if("function"==typeof e)return{implementation:e};if(e&&"function"==typeof e.beforePass)return{instance:e};throw new Error("Invalid Gatherer type "+JSON.stringify(e))}(t);if(a.instance)return{instance:a.instance,implementation:a.implementation,path:a.path};if(a.implementation){return{
instance:new(0,a.implementation),implementation:a.implementation,path:a.path}}if(a.path){return function requireGatherer(t,n,i){const a=n.find((e=>e===t+".js"));let s="../gather/gatherers/"+t;a||(s=resolveModulePath(t,i,"gatherer"));const c=e(s);return{instance:new c,implementation:c,path:t}}(a.path,n,i)}throw new Error("Invalid expanded Gatherer: "+JSON.stringify(a))},resolveAuditsToDefns:function resolveAuditsToDefns(t,n){if(!t)return null;const i=m.getAuditList(),c=t.map((t=>{const c=function expandAuditShorthand(e){if("string"==typeof e)return{path:e,options:{}};if("implementation"in e&&"function"==typeof e.implementation.audit)return e;if("path"in e&&"string"==typeof e.path)return e;if("audit"in e&&"function"==typeof e.audit)return{implementation:e,options:{}};throw new Error("Invalid Audit type "+JSON.stringify(e))}(t);let l;return l="implementation"in c?c.implementation:function requireAudit(t,n,i){const c=t+".js";let l="../audits/"+t
;if(!n.find((e=>e===c)))if(isBundledEnvironment())l=t;else{const e=resolveModulePath(t,i,"audit");l=s.relative(a,e)}return e(l)}(c.path,i,n),{implementation:l,path:c.path,options:c.options||{}}})),l=mergeOptionsOfItems(c);return l.forEach((e=>h.assertValidAudit(e))),l},resolveModulePath}}).call(this)}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{},"/lighthouse-core/config")},{"../fraggle-rock/config/validation.js":59,"../lib/i18n/i18n.js":98,"../runner.js":122,"./budget.js":52,"./config-plugin.js":54,"./constants.js":56,_process:223,"lodash.isequal":217,path:222}],54:[function(e,t,n){"use strict";const i=e("../lib/i18n/i18n.js");function isArrayOfUnknownObjects(e){return Array.isArray(e)&&e.every(isObjectOfUnknownProperties)}function isObjectOfUnknownProperties(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)}function assertNoExcessProperties(e,t,n=""){n&&(n+=" ");const i=Object.keys(e)
;if(i.length>0){const e=i.join(", ");throw new Error(`${t} has unrecognized ${n}properties: [${e}]`)}}class ConfigPlugin{static _parseAuditsList(e,t){if(void 0!==e){if(!isArrayOfUnknownObjects(e))throw new Error(t+" has an invalid audits array.");return e.map((e=>{const{path:n,...i}=e;if(assertNoExcessProperties(i,t,"audit"),"string"!=typeof n)throw new Error(t+" has a missing audit path.");return{path:n}}))}}static _parseAuditRefsList(e,t){if(!isArrayOfUnknownObjects(e))throw new Error(t+" has no valid auditsRefs.");return e.map((e=>{const{id:n,weight:i,group:a,...s}=e;if(assertNoExcessProperties(s,t,"auditRef"),"string"!=typeof n)throw new Error(t+" has an invalid auditRef id.");if("number"!=typeof i)throw new Error(t+" has an invalid auditRef weight.");if("string"!=typeof a&&void 0!==a)throw new Error(t+" has an invalid auditRef group.");return{id:n,weight:i,group:a?`${t}-${a}`:a}}))}static _parseCategory(e,t){
if(!isObjectOfUnknownProperties(e))throw new Error(t+" has no valid category.");const{title:n,description:a,manualDescription:s,auditRefs:c,...l}=e;if(assertNoExcessProperties(l,t,"category"),!i.isStringOrIcuMessage(n))throw new Error(t+" has an invalid category tile.");if(!i.isStringOrIcuMessage(a)&&void 0!==a)throw new Error(t+" has an invalid category description.");if(!i.isStringOrIcuMessage(s)&&void 0!==s)throw new Error(t+" has an invalid category manualDescription.");return{title:n,auditRefs:ConfigPlugin._parseAuditRefsList(c,t),description:a,manualDescription:s}}static _parseGroups(e,t){if(void 0===e)return;if(!isObjectOfUnknownProperties(e))throw new Error(t+" groups json is not defined as an object.");const n=Object.entries(e),a={};return n.forEach((([e,n])=>{if(!isObjectOfUnknownProperties(n))throw new Error(t+" has a group not defined as an object.");const{title:s,description:c,...l}=n;if(assertNoExcessProperties(l,t,"group"),
!i.isStringOrIcuMessage(s))throw new Error(t+" has an invalid group title.");if(!i.isStringOrIcuMessage(c)&&void 0!==c)throw new Error(t+" has an invalid group description.");a[`${t}-${e}`]={title:s,description:c}})),a}static parsePlugin(e,t){if(!isObjectOfUnknownProperties(e=JSON.parse(JSON.stringify(e))))throw new Error(t+" is not defined as an object.");const{audits:n,category:i,groups:a,...s}=e;return assertNoExcessProperties(s,t),{audits:ConfigPlugin._parseAuditsList(n,t),categories:{[t]:ConfigPlugin._parseCategory(i,t)},groups:ConfigPlugin._parseGroups(a,t)}}}t.exports=ConfigPlugin},{"../lib/i18n/i18n.js":98}],55:[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("./default-config.js"),a=e("./constants.js"),s=e("./../lib/i18n/i18n.js"),c=e("./../fraggle-rock/config/validation.js"),l=e("lighthouse-logger"),u=e("path"),d=e("../runner.js"),{mergePlugins:m,mergeConfigFragment:p,resolveSettings:h,resolveAuditsToDefns:f,resolveGathererToDefn:g,deepClone:y,deepCloneConfigJson:b}=e("./config-helpers.js"),v=Object.keys({fetchTime:"",LighthouseRunWarnings:"",HostFormFactor:"",HostUserAgent:"",NetworkUserAgent:"",BenchmarkIndex:"",WebAppManifest:"",GatherContext:"",InstallabilityErrors:"",Stacks:"",traces:"",devtoolsLogs:"",settings:"",URL:"",Timing:"",PageLoadError:""});class Config{constructor(e,t){const a={msg:"Create config",id:"lh:init:config"};l.time(a,"verbose");let s=t&&t.configPath;if(e||(e=i,s=u.resolve(n,"./default-config.js")),s&&!u.isAbsolute(s))throw new Error("configPath must be an absolute path.");if((e=b(e)).extends){if("lighthouse:default"!==e.extends)throw new Error("`lighthouse:default` is the only valid extension method.")
;e=Config.extendConfigJSON(b(i),e)}const d=s?u.dirname(s):void 0;e=m(e,d,t),t&&function assertValidFlags(e){if("devtools"===e.channel&&e.internalDisableDeviceScreenEmulation&&(e.formFactor=e.emulatedFormFactor,e.emulatedFormFactor=e.internalDisableDeviceScreenEmulation=void 0),e.emulatedFormFactor||e.internalDisableDeviceScreenEmulation)throw new Error("Invalid emulation flag. Emulation configuration changed in LH 7.0. See https://github.com/GoogleChrome/lighthouse/blob/master/docs/emulation.md")}(t);const p=h(e.settings||{},t),f=Config.augmentPassesWithDefaults(e.passes);Config.adjustDefaultPassForThrottling(p,f);const g=Config.requireGatherers(f,d);this.settings=p,this.passes=g,this.audits=Config.requireAudits(e.audits,d),this.categories=e.categories||null,this.groups=e.groups||null,Config.filterConfigIfNeeded(this),function assertValidPasses(e,t){if(!Array.isArray(e))return;const n=Config.getGatherersRequestedByAudits(t),i=new Set(v);e.forEach(((e,t)=>{
0===t&&"fatal"!==e.loadFailureMode&&(l.warn(`"${e.passName}" is the first pass but was marked as non-fatal. The first pass will always be treated as loadFailureMode=fatal.`),e.loadFailureMode="fatal"),e.gatherers.forEach((e=>{const t=e.instance;if(i.add(t.name),!n.has(t.name)){const e=t.name+" gatherer requested, however no audit requires it.";l.warn("config",e)}}))}));for(const e of t||[]){const t=e.implementation.meta;for(const e of t.requiredArtifacts)if(!i.has(e))throw new Error(`${e} gatherer, required by audit ${t.id}, was not found in config.`)}const a=new Set;e.forEach((e=>{const t=e.passName;if(a.has(t))throw new Error(`Passes must have unique names (repeated passName: ${t}.`);a.add(t)}))}(this.passes,this.audits),c.assertValidCategories(this.categories,this.audits,this.groups),l.timeEnd(a)}getPrintString(){const e=y(this);if(e.passes)for(const t of e.passes)for(const e of t.gatherers)e.implementation=void 0,e.instance=void 0
;if(e.audits)for(const t of e.audits)t.implementation=void 0,0===Object.keys(t.options).length&&(t.options=void 0);return s.replaceIcuMessages(e,e.settings.locale),JSON.stringify(e,null,2)}static extendConfigJSON(e,t){if(t.passes&&e.passes){for(const n of t.passes){const t=n.passName||a.defaultPassConfig.passName,i=e.passes.find((e=>e.passName===t));i?p(i,n):e.passes.push(n)}delete t.passes}return p(e,t)}static augmentPassesWithDefaults(e){if(!e)return null;const{defaultPassConfig:t}=a;return e.map((e=>p(y(t),e)))}static adjustDefaultPassForThrottling(e,t){if(!t||"devtools"!==e.throttlingMethod&&"provided"!==e.throttlingMethod)return;const n=t.find((e=>"defaultPass"===e.passName));if(!n)return;const i=a.nonSimulatedPassConfigOverrides;n.pauseAfterFcpMs=Math.max(i.pauseAfterFcpMs,n.pauseAfterFcpMs),n.pauseAfterLoadMs=Math.max(i.pauseAfterLoadMs,n.pauseAfterLoadMs),n.cpuQuietThresholdMs=Math.max(i.cpuQuietThresholdMs,n.cpuQuietThresholdMs),
n.networkQuietThresholdMs=Math.max(i.networkQuietThresholdMs,n.networkQuietThresholdMs)}static filterConfigIfNeeded(e){const t=e.settings;if(!t.onlyCategories&&!t.onlyAudits&&!t.skipAudits)return;const{categories:n,requestedAuditNames:i}=Config.filterCategoriesAndAudits(e.categories,t),a=e.audits&&e.audits.filter((e=>i.has(e.implementation.meta.id))),s=Config.getGatherersRequestedByAudits(a),c=Config.generatePassesNeededByGatherers(e.passes,s);e.categories=n,e.audits=a,e.passes=c}static filterCategoriesAndAudits(e,t){if(!e)return{categories:null,requestedAuditNames:new Set};if(t.onlyAudits&&t.skipAudits)throw new Error("Cannot set both skipAudits and onlyAudits");const n={},i=!!t.onlyCategories,a=!!t.onlyAudits,s=t.onlyCategories||[],c=t.onlyAudits||[],u=t.skipAudits||[];s.forEach((t=>{e[t]||l.warn("config","unrecognized category in 'onlyCategories': "+t)}));const d=new Set(c.concat(u));for(const t of d){const n=Object.keys(e).find((n=>!!e[n].auditRefs.find((e=>e.id===t))))
;if(n)c.includes(t)&&s.includes(n)&&l.warn("config",t+" in 'onlyAudits' is already included by "+n+" in 'onlyCategories'");else{const e=u.includes(t)?"skipAudits":"onlyAudits";l.warn("config",`unrecognized audit in '${e}': ${t}`)}}const m=new Set(c);u.forEach((e=>m.delete(e))),Object.keys(e).forEach((t=>{const l=y(e[t]);if(i&&a)s.includes(t)||(l.auditRefs=l.auditRefs.filter((e=>c.includes(e.id))));else if(i){if(!s.includes(t))return}else a&&(l.auditRefs=l.auditRefs.filter((e=>c.includes(e.id))));l.auditRefs=l.auditRefs.filter((e=>!u.includes(e.id))),l.auditRefs.length&&(n[t]=l,l.auditRefs.forEach((e=>m.add(e.id))))}));return t.skipAudits&&t.skipAudits.includes("full-page-screenshot")||!t.onlyCategories&&!t.skipAudits||m.add("full-page-screenshot"),{categories:n,requestedAuditNames:m}}static getGatherersRequestedByAudits(e){if(!e)return new Set;const t=new Set;for(const n of e){const{requiredArtifacts:e,__internalOptionalArtifacts:i}=n.implementation.meta;e.forEach((e=>t.add(e))),
i&&i.forEach((e=>t.add(e)))}return t}static generatePassesNeededByGatherers(e,t){if(!e)return null;const n=t.has("traces");return e.map((e=>{if(e.gatherers=e.gatherers.filter((e=>{const n=e.instance;return t.has(n.name)})),e.recordTrace&&!n){const t=e.passName||"unknown pass";l.warn("config","Trace not requested by an audit, dropping trace in "+t),e.recordTrace=!1}return e})).filter((e=>!!e.recordTrace||("defaultPass"===e.passName||e.gatherers.length>0)))}static requireAudits(e,t){const n={msg:"Requiring audits",id:"lh:config:requireAudits"};l.time(n,"verbose");const i=f(e,t);return l.timeEnd(n),i}static requireGatherers(e,t){if(!e)return null;const n={msg:"Requiring gatherers",id:"lh:config:requireGatherers"};l.time(n,"verbose");const i=d.getGathererList(),a=e.map((e=>{const n=e.gatherers.map((e=>g(e,i,t))),a=Array.from(new Map(n.map((e=>[e.instance.name,e]))).values());return a.forEach((e=>function assertValidGatherer(e,t){if(t=t||e.name||"gatherer",
"function"!=typeof e.beforePass)throw new Error(t+" has no beforePass() method.");if("function"!=typeof e.pass)throw new Error(t+" has no pass() method.");if("function"!=typeof e.afterPass)throw new Error(t+" has no afterPass() method.")}(e.instance,e.path))),Object.assign(e,{gatherers:a})}));return l.timeEnd(n),a}}t.exports=Config}).call(this)}).call(this,"/lighthouse-core/config")},{"../runner.js":122,"./../fraggle-rock/config/validation.js":59,"./../lib/i18n/i18n.js":98,"./config-helpers.js":53,"./constants.js":56,"./default-config.js":57,"lighthouse-logger":188,path:222}],56:[function(e,t,n){"use strict";const i=3.75,a=.9,s={DEVTOOLS_RTT_ADJUSTMENT_FACTOR:i,DEVTOOLS_THROUGHPUT_ADJUSTMENT_FACTOR:a,mobileSlow4G:{rttMs:150,throughputKbps:1638.4,requestLatencyMs:562.5,downloadThroughputKbps:1474.5600000000002,uploadThroughputKbps:675,cpuSlowdownMultiplier:4},mobileRegular3G:{rttMs:300,throughputKbps:700,requestLatencyMs:1125,downloadThroughputKbps:630,uploadThroughputKbps:630,
cpuSlowdownMultiplier:4},desktopDense4G:{rttMs:40,throughputKbps:10240,cpuSlowdownMultiplier:1,requestLatencyMs:0,downloadThroughputKbps:0,uploadThroughputKbps:0}},c={mobile:{mobile:!0,width:360,height:640,deviceScaleFactor:2.625,disabled:!1},desktop:{mobile:!1,width:1350,height:940,deviceScaleFactor:1,disabled:!1}},l={mobile:"Mozilla/5.0 (Linux; Android 7.0; Moto G (4)) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/94.0.4590.2 Mobile Safari/537.36 Chrome-Lighthouse",desktop:"Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_7) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/94.0.4590.2 Safari/537.36 Chrome-Lighthouse"},u={output:"json",maxWaitForFcp:3e4,maxWaitForLoad:45e3,formFactor:"mobile",throttling:s.mobileSlow4G,throttlingMethod:"simulate",screenEmulation:c.mobile,emulatedUserAgent:l.mobile,auditMode:!1,gatherMode:!1,disableStorageReset:!1,debugNavigation:!1,channel:"node",budgets:null,locale:"en-US",blockedUrlPatterns:null,additionalTraceCategories:null,extraHeaders:null,
precomputedLanternData:null,onlyAudits:null,onlyCategories:null,skipAudits:null};t.exports={throttling:s,screenEmulationMetrics:c,userAgents:l,defaultSettings:u,defaultPassConfig:{passName:"defaultPass",loadFailureMode:"fatal",recordTrace:!1,useThrottling:!1,pauseAfterFcpMs:0,pauseAfterLoadMs:0,networkQuietThresholdMs:0,cpuQuietThresholdMs:0,blockedUrlPatterns:[],blankPage:"about:blank",gatherers:[]},defaultNavigationConfig:{id:"default",loadFailureMode:"fatal",disableThrottling:!1,disableStorageReset:!1,pauseAfterFcpMs:0,pauseAfterLoadMs:0,networkQuietThresholdMs:0,cpuQuietThresholdMs:0,blockedUrlPatterns:[],blankPage:"about:blank",artifacts:[]},nonSimulatedPassConfigOverrides:{pauseAfterFcpMs:5250,pauseAfterLoadMs:5250,networkQuietThresholdMs:5250,cpuQuietThresholdMs:5250}}},{}],57:[function(e,t,n){(function(n){(function(){"use strict";const i=e("./constants.js"),a=e("../lib/i18n/i18n.js"),s=e("./metrics-to-audits.js"),c={performanceCategoryTitle:"Performance",
budgetsGroupTitle:"Budgets",budgetsGroupDescription:"Performance budgets set standards for the performance of your site.",metricGroupTitle:"Metrics",loadOpportunitiesGroupTitle:"Opportunities",loadOpportunitiesGroupDescription:"These suggestions can help your page load faster. They don't [directly affect](https://web.dev/performance-scoring/) the Performance score.",firstPaintImprovementsGroupTitle:"First Paint Improvements",firstPaintImprovementsGroupDescription:"The most critical aspect of performance is how quickly pixels are rendered onscreen. Key metrics: First Contentful Paint, First Meaningful Paint",overallImprovementsGroupTitle:"Overall Improvements",overallImprovementsGroupDescription:"Enhance the overall loading experience, so the page is responsive and ready to use as soon as possible. Key metrics: Time to Interactive, Speed Index",diagnosticsGroupTitle:"Diagnostics",
diagnosticsGroupDescription:"More information about the performance of your application. These numbers don't [directly affect](https://web.dev/performance-scoring/) the Performance score.",a11yCategoryTitle:"Accessibility",a11yCategoryDescription:"These checks highlight opportunities to [improve the accessibility of your web app](https://developers.google.com/web/fundamentals/accessibility). Only a subset of accessibility issues can be automatically detected so manual testing is also encouraged.",a11yCategoryManualDescription:"These items address areas which an automated testing tool cannot cover. Learn more in our guide on [conducting an accessibility review](https://developers.google.com/web/fundamentals/accessibility/how-to-review).",a11yBestPracticesGroupTitle:"Best practices",a11yBestPracticesGroupDescription:"These items highlight common accessibility best practices.",a11yColorContrastGroupTitle:"Contrast",
a11yColorContrastGroupDescription:"These are opportunities to improve the legibility of your content.",a11yNamesLabelsGroupTitle:"Names and labels",a11yNamesLabelsGroupDescription:"These are opportunities to improve the semantics of the controls in your application. This may enhance the experience for users of assistive technology, like a screen reader.",a11yNavigationGroupTitle:"Navigation",a11yNavigationGroupDescription:"These are opportunities to improve keyboard navigation in your application.",a11yAriaGroupTitle:"ARIA",a11yAriaGroupDescription:"These are opportunities to improve the usage of ARIA in your application which may enhance the experience for users of assistive technology, like a screen reader.",a11yLanguageGroupTitle:"Internationalization and localization",a11yLanguageGroupDescription:"These are opportunities to improve the interpretation of your content by users in different locales.",a11yAudioVideoGroupTitle:"Audio and video",
a11yAudioVideoGroupDescription:"These are opportunities to provide alternative content for audio and video. This may improve the experience for users with hearing or vision impairments.",a11yTablesListsVideoGroupTitle:"Tables and lists",a11yTablesListsVideoGroupDescription:"These are opportunities to improve the experience of reading tabular or list data using assistive technology, like a screen reader.",seoCategoryTitle:"SEO",seoCategoryDescription:"These checks ensure that your page is following basic search engine optimization advice. There are many additional factors Lighthouse does not score here that may affect your search ranking, including performance on [Core Web Vitals](https://web.dev/learn-web-vitals/). [Learn more](https://support.google.com/webmasters/answer/35769).",seoCategoryManualDescription:"Run these additional validators on your site to check additional SEO best practices.",seoMobileGroupTitle:"Mobile Friendly",
seoMobileGroupDescription:"Make sure your pages are mobile friendly so users don’t have to pinch or zoom in order to read the content pages. [Learn more](https://developers.google.com/search/mobile-sites/).",seoContentGroupTitle:"Content Best Practices",seoContentGroupDescription:"Format your HTML in a way that enables crawlers to better understand your app’s content.",seoCrawlingGroupTitle:"Crawling and Indexing",seoCrawlingGroupDescription:"To appear in search results, crawlers need access to your app.",pwaCategoryTitle:"Progressive Web App",pwaCategoryDescription:"These checks validate the aspects of a Progressive Web App. [Learn more](https://developers.google.com/web/progressive-web-apps/checklist).",pwaCategoryManualDescription:"These checks are required by the baseline [PWA Checklist](https://developers.google.com/web/progressive-web-apps/checklist) but are not automatically checked by Lighthouse. They do not affect your score but it's important that you verify them manually.",
bestPracticesCategoryTitle:"Best Practices",bestPracticesTrustSafetyGroupTitle:"Trust and Safety",bestPracticesUXGroupTitle:"User Experience",bestPracticesBrowserCompatGroupTitle:"Browser Compatibility",bestPracticesGeneralGroupTitle:"General",pwaInstallableGroupTitle:"Installable",pwaOptimizedGroupTitle:"PWA Optimized"},l=a.createMessageInstanceIdFn(n,c),u={settings:i.defaultSettings,passes:[{passName:"defaultPass",recordTrace:!0,useThrottling:!0,pauseAfterFcpMs:1e3,pauseAfterLoadMs:1e3,networkQuietThresholdMs:1e3,cpuQuietThresholdMs:1e3,
gatherers:["css-usage","js-usage","viewport-dimensions","console-messages","anchor-elements","image-elements","link-elements","meta-elements","script-elements","iframe-elements","form-elements","main-document-content","global-listeners","dobetterweb/appcache","dobetterweb/doctype","dobetterweb/domstats","dobetterweb/optimized-images","dobetterweb/password-inputs-with-prevented-paste","dobetterweb/response-compression","dobetterweb/tags-blocking-first-paint","seo/font-size","seo/embedded-content","seo/robots-txt","seo/tap-targets","accessibility","trace-elements","inspector-issues","source-maps","full-page-screenshot"]},{passName:"offlinePass",loadFailureMode:"ignore",gatherers:["service-worker"]},{passName:"redirectPass",loadFailureMode:"warn",blockedUrlPatterns:["*.css","*.jpg","*.jpeg","*.png","*.gif","*.svg","*.ttf","*.woff","*.woff2"],gatherers:["http-redirect"]}],
audits:["is-on-https","redirects-http","service-worker","viewport","metrics/first-contentful-paint","metrics/largest-contentful-paint","metrics/first-meaningful-paint","metrics/speed-index","screenshot-thumbnails","final-screenshot","metrics/total-blocking-time","metrics/max-potential-fid","metrics/cumulative-layout-shift","errors-in-console","server-response-time","metrics/interactive","user-timings","critical-request-chains","redirects","installable-manifest","apple-touch-icon","splash-screen","themed-omnibox","maskable-icon","content-width","image-aspect-ratio","image-size-responsive","preload-fonts","deprecations","mainthread-work-breakdown","bootup-time","uses-rel-preload","uses-rel-preconnect","font-display","diagnostics","network-requests","network-rtt","network-server-latency","main-thread-tasks","metrics","performance-budget","timing-budget","resource-summary","third-party-summary","third-party-facades","largest-contentful-paint-element","lcp-lazy-loaded","layout-shift-elements","long-tasks","no-unload-listeners","non-composited-animations","unsized-images","valid-source-maps","preload-lcp-image","csp-xss","full-page-screenshot","script-treemap-data","manual/pwa-cross-browser","manual/pwa-page-transitions","manual/pwa-each-page-has-url","accessibility/accesskeys","accessibility/aria-allowed-attr","accessibility/aria-command-name","accessibility/aria-hidden-body","accessibility/aria-hidden-focus","accessibility/aria-input-field-name","accessibility/aria-meter-name","accessibility/aria-progressbar-name","accessibility/aria-required-attr","accessibility/aria-required-children","accessibility/aria-required-parent","accessibility/aria-roles","accessibility/aria-toggle-field-name","accessibility/aria-tooltip-name","accessibility/aria-treeitem-name","accessibility/aria-valid-attr-value","accessibility/aria-valid-attr","accessibility/button-name","accessibility/bypass","accessibility/color-contrast","accessibility/definition-list","accessibility/dlitem","accessibility/document-title","accessibility/duplicate-id-active","accessibility/duplicate-id-aria","accessibility/form-field-multiple-labels","accessibility/frame-title","accessibility/heading-order","accessibility/html-has-lang","accessibility/html-lang-valid","accessibility/image-alt","accessibility/input-image-alt","accessibility/label","accessibility/link-name","accessibility/list","accessibility/listitem","accessibility/meta-refresh","accessibility/meta-viewport","accessibility/object-alt","accessibility/tabindex","accessibility/td-headers-attr","accessibility/th-has-data-cells","accessibility/valid-lang","accessibility/video-caption","accessibility/manual/custom-controls-labels","accessibility/manual/custom-controls-roles","accessibility/manual/focus-traps","accessibility/manual/focusable-controls","accessibility/manual/interactive-element-affordance","accessibility/manual/logical-tab-order","accessibility/manual/managed-focus","accessibility/manual/offscreen-content-hidden","accessibility/manual/use-landmarks","accessibility/manual/visual-order-follows-dom","byte-efficiency/uses-long-cache-ttl","byte-efficiency/total-byte-weight","byte-efficiency/offscreen-images","byte-efficiency/render-blocking-resources","byte-efficiency/unminified-css","byte-efficiency/unminified-javascript","byte-efficiency/unused-css-rules","byte-efficiency/unused-javascript","byte-efficiency/modern-image-formats","byte-efficiency/uses-optimized-images","byte-efficiency/uses-text-compression","byte-efficiency/uses-responsive-images","byte-efficiency/efficient-animated-content","byte-efficiency/duplicated-javascript","byte-efficiency/legacy-javascript","dobetterweb/appcache-manifest","dobetterweb/doctype","dobetterweb/charset","dobetterweb/dom-size","dobetterweb/external-anchors-use-rel-noopener","dobetterweb/geolocation-on-start","dobetterweb/inspector-issues","dobetterweb/no-document-write","dobetterweb/no-vulnerable-libraries","dobetterweb/js-libraries","dobetterweb/notification-on-start","dobetterweb/password-inputs-can-be-pasted-into","dobetterweb/uses-http2","dobetterweb/uses-passive-event-listeners","seo/meta-description","seo/http-status-code","seo/font-size","seo/link-text","seo/crawlable-anchors","seo/is-crawlable","seo/robots-txt","seo/tap-targets","seo/hreflang","seo/plugins","seo/canonical","seo/manual/structured-data"],
groups:{metrics:{title:l(c.metricGroupTitle)},"load-opportunities":{title:l(c.loadOpportunitiesGroupTitle),description:l(c.loadOpportunitiesGroupDescription)},budgets:{title:l(c.budgetsGroupTitle),description:l(c.budgetsGroupDescription)},diagnostics:{title:l(c.diagnosticsGroupTitle),description:l(c.diagnosticsGroupDescription)},"pwa-installable":{title:l(c.pwaInstallableGroupTitle)},"pwa-optimized":{title:l(c.pwaOptimizedGroupTitle)},"a11y-best-practices":{title:l(c.a11yBestPracticesGroupTitle),description:l(c.a11yBestPracticesGroupDescription)},"a11y-color-contrast":{title:l(c.a11yColorContrastGroupTitle),description:l(c.a11yColorContrastGroupDescription)},"a11y-names-labels":{title:l(c.a11yNamesLabelsGroupTitle),description:l(c.a11yNamesLabelsGroupDescription)},"a11y-navigation":{title:l(c.a11yNavigationGroupTitle),description:l(c.a11yNavigationGroupDescription)},"a11y-aria":{title:l(c.a11yAriaGroupTitle),description:l(c.a11yAriaGroupDescription)},"a11y-language":{
title:l(c.a11yLanguageGroupTitle),description:l(c.a11yLanguageGroupDescription)},"a11y-audio-video":{title:l(c.a11yAudioVideoGroupTitle),description:l(c.a11yAudioVideoGroupDescription)},"a11y-tables-lists":{title:l(c.a11yTablesListsVideoGroupTitle),description:l(c.a11yTablesListsVideoGroupDescription)},"seo-mobile":{title:l(c.seoMobileGroupTitle),description:l(c.seoMobileGroupDescription)},"seo-content":{title:l(c.seoContentGroupTitle),description:l(c.seoContentGroupDescription)},"seo-crawl":{title:l(c.seoCrawlingGroupTitle),description:l(c.seoCrawlingGroupDescription)},"best-practices-trust-safety":{title:l(c.bestPracticesTrustSafetyGroupTitle)},"best-practices-ux":{title:l(c.bestPracticesUXGroupTitle)},"best-practices-browser-compat":{title:l(c.bestPracticesBrowserCompatGroupTitle)},"best-practices-general":{title:l(c.bestPracticesGeneralGroupTitle)}},categories:{performance:{title:l(c.performanceCategoryTitle),auditRefs:[{id:"first-contentful-paint",weight:10,group:"metrics",
acronym:"FCP",relevantAudits:s.fcpRelevantAudits},{id:"speed-index",weight:10,group:"metrics",acronym:"SI"},{id:"largest-contentful-paint",weight:25,group:"metrics",acronym:"LCP",relevantAudits:s.lcpRelevantAudits},{id:"interactive",weight:10,group:"metrics",acronym:"TTI"},{id:"total-blocking-time",weight:30,group:"metrics",acronym:"TBT",relevantAudits:s.tbtRelevantAudits},{id:"cumulative-layout-shift",weight:15,group:"metrics",acronym:"CLS",relevantAudits:s.clsRelevantAudits},{id:"max-potential-fid",weight:0},{id:"first-meaningful-paint",weight:0,acronym:"FMP"},{id:"render-blocking-resources",weight:0,group:"load-opportunities"},{id:"uses-responsive-images",weight:0,group:"load-opportunities"},{id:"offscreen-images",weight:0,group:"load-opportunities"},{id:"unminified-css",weight:0,group:"load-opportunities"},{id:"unminified-javascript",weight:0,group:"load-opportunities"},{id:"unused-css-rules",weight:0,group:"load-opportunities"},{id:"unused-javascript",weight:0,
group:"load-opportunities"},{id:"uses-optimized-images",weight:0,group:"load-opportunities"},{id:"modern-image-formats",weight:0,group:"load-opportunities"},{id:"uses-text-compression",weight:0,group:"load-opportunities"},{id:"uses-rel-preconnect",weight:0,group:"load-opportunities"},{id:"server-response-time",weight:0,group:"load-opportunities"},{id:"redirects",weight:0,group:"load-opportunities"},{id:"uses-rel-preload",weight:0,group:"load-opportunities"},{id:"uses-http2",weight:0,group:"load-opportunities"},{id:"efficient-animated-content",weight:0,group:"load-opportunities"},{id:"duplicated-javascript",weight:0,group:"load-opportunities"},{id:"legacy-javascript",weight:0,group:"load-opportunities"},{id:"preload-lcp-image",weight:0,group:"load-opportunities"},{id:"total-byte-weight",weight:0,group:"diagnostics"},{id:"uses-long-cache-ttl",weight:0,group:"diagnostics"},{id:"dom-size",weight:0,group:"diagnostics"},{id:"critical-request-chains",weight:0,group:"diagnostics"},{
id:"user-timings",weight:0,group:"diagnostics"},{id:"bootup-time",weight:0,group:"diagnostics"},{id:"mainthread-work-breakdown",weight:0,group:"diagnostics"},{id:"font-display",weight:0,group:"diagnostics"},{id:"performance-budget",weight:0,group:"budgets"},{id:"timing-budget",weight:0,group:"budgets"},{id:"resource-summary",weight:0,group:"diagnostics"},{id:"third-party-summary",weight:0,group:"diagnostics"},{id:"third-party-facades",weight:0,group:"diagnostics"},{id:"largest-contentful-paint-element",weight:0,group:"diagnostics"},{id:"lcp-lazy-loaded",weight:0,group:"diagnostics"},{id:"layout-shift-elements",weight:0,group:"diagnostics"},{id:"uses-passive-event-listeners",weight:0,group:"diagnostics"},{id:"no-document-write",weight:0,group:"diagnostics"},{id:"long-tasks",weight:0,group:"diagnostics"},{id:"non-composited-animations",weight:0,group:"diagnostics"},{id:"unsized-images",weight:0,group:"diagnostics"},{id:"viewport",weight:0,group:"diagnostics"},{id:"network-requests",
weight:0},{id:"network-rtt",weight:0},{id:"network-server-latency",weight:0},{id:"main-thread-tasks",weight:0},{id:"diagnostics",weight:0},{id:"metrics",weight:0},{id:"screenshot-thumbnails",weight:0},{id:"final-screenshot",weight:0},{id:"script-treemap-data",weight:0}]},accessibility:{title:l(c.a11yCategoryTitle),description:l(c.a11yCategoryDescription),manualDescription:l(c.a11yCategoryManualDescription),auditRefs:[{id:"accesskeys",weight:3,group:"a11y-navigation"},{id:"aria-allowed-attr",weight:10,group:"a11y-aria"},{id:"aria-command-name",weight:3,group:"a11y-aria"},{id:"aria-hidden-body",weight:10,group:"a11y-aria"},{id:"aria-hidden-focus",weight:3,group:"a11y-aria"},{id:"aria-input-field-name",weight:3,group:"a11y-aria"},{id:"aria-meter-name",weight:3,group:"a11y-aria"},{id:"aria-progressbar-name",weight:3,group:"a11y-aria"},{id:"aria-required-attr",weight:10,group:"a11y-aria"},{id:"aria-required-children",weight:10,group:"a11y-aria"},{id:"aria-required-parent",weight:10,
group:"a11y-aria"},{id:"aria-roles",weight:10,group:"a11y-aria"},{id:"aria-toggle-field-name",weight:3,group:"a11y-aria"},{id:"aria-tooltip-name",weight:3,group:"a11y-aria"},{id:"aria-treeitem-name",weight:3,group:"a11y-aria"},{id:"aria-valid-attr-value",weight:10,group:"a11y-aria"},{id:"aria-valid-attr",weight:10,group:"a11y-aria"},{id:"button-name",weight:10,group:"a11y-names-labels"},{id:"bypass",weight:3,group:"a11y-navigation"},{id:"color-contrast",weight:3,group:"a11y-color-contrast"},{id:"definition-list",weight:3,group:"a11y-tables-lists"},{id:"dlitem",weight:3,group:"a11y-tables-lists"},{id:"document-title",weight:3,group:"a11y-names-labels"},{id:"duplicate-id-active",weight:3,group:"a11y-navigation"},{id:"duplicate-id-aria",weight:10,group:"a11y-aria"},{id:"form-field-multiple-labels",weight:2,group:"a11y-names-labels"},{id:"frame-title",weight:3,group:"a11y-names-labels"},{id:"heading-order",weight:2,group:"a11y-navigation"},{id:"html-has-lang",weight:3,group:"a11y-language"
},{id:"html-lang-valid",weight:3,group:"a11y-language"},{id:"image-alt",weight:10,group:"a11y-names-labels"},{id:"input-image-alt",weight:10,group:"a11y-names-labels"},{id:"label",weight:10,group:"a11y-names-labels"},{id:"link-name",weight:3,group:"a11y-names-labels"},{id:"list",weight:3,group:"a11y-tables-lists"},{id:"listitem",weight:3,group:"a11y-tables-lists"},{id:"meta-refresh",weight:10,group:"a11y-best-practices"},{id:"meta-viewport",weight:10,group:"a11y-best-practices"},{id:"object-alt",weight:3,group:"a11y-names-labels"},{id:"tabindex",weight:3,group:"a11y-navigation"},{id:"td-headers-attr",weight:3,group:"a11y-tables-lists"},{id:"th-has-data-cells",weight:3,group:"a11y-tables-lists"},{id:"valid-lang",weight:3,group:"a11y-language"},{id:"video-caption",weight:10,group:"a11y-audio-video"},{id:"logical-tab-order",weight:0},{id:"focusable-controls",weight:0},{id:"interactive-element-affordance",weight:0},{id:"managed-focus",weight:0},{id:"focus-traps",weight:0},{
id:"custom-controls-labels",weight:0},{id:"custom-controls-roles",weight:0},{id:"visual-order-follows-dom",weight:0},{id:"offscreen-content-hidden",weight:0},{id:"use-landmarks",weight:0}]},"best-practices":{title:l(c.bestPracticesCategoryTitle),auditRefs:[{id:"is-on-https",weight:1,group:"best-practices-trust-safety"},{id:"external-anchors-use-rel-noopener",weight:1,group:"best-practices-trust-safety"},{id:"geolocation-on-start",weight:1,group:"best-practices-trust-safety"},{id:"notification-on-start",weight:1,group:"best-practices-trust-safety"},{id:"no-vulnerable-libraries",weight:1,group:"best-practices-trust-safety"},{id:"csp-xss",weight:0,group:"best-practices-trust-safety"},{id:"password-inputs-can-be-pasted-into",weight:1,group:"best-practices-ux"},{id:"image-aspect-ratio",weight:1,group:"best-practices-ux"},{id:"image-size-responsive",weight:1,group:"best-practices-ux"},{id:"preload-fonts",weight:1,group:"best-practices-ux"},{id:"doctype",weight:1,
group:"best-practices-browser-compat"},{id:"charset",weight:1,group:"best-practices-browser-compat"},{id:"no-unload-listeners",weight:1,group:"best-practices-general"},{id:"appcache-manifest",weight:1,group:"best-practices-general"},{id:"js-libraries",weight:0,group:"best-practices-general"},{id:"deprecations",weight:1,group:"best-practices-general"},{id:"errors-in-console",weight:1,group:"best-practices-general"},{id:"valid-source-maps",weight:0,group:"best-practices-general"},{id:"inspector-issues",weight:1,group:"best-practices-general"}]},seo:{title:l(c.seoCategoryTitle),description:l(c.seoCategoryDescription),manualDescription:l(c.seoCategoryManualDescription),auditRefs:[{id:"viewport",weight:1,group:"seo-mobile"},{id:"document-title",weight:1,group:"seo-content"},{id:"meta-description",weight:1,group:"seo-content"},{id:"http-status-code",weight:1,group:"seo-crawl"},{id:"link-text",weight:1,group:"seo-content"},{id:"crawlable-anchors",weight:1,group:"seo-crawl"},{
id:"is-crawlable",weight:1,group:"seo-crawl"},{id:"robots-txt",weight:1,group:"seo-crawl"},{id:"image-alt",weight:1,group:"seo-content"},{id:"hreflang",weight:1,group:"seo-content"},{id:"canonical",weight:1,group:"seo-content"},{id:"font-size",weight:1,group:"seo-mobile"},{id:"plugins",weight:1,group:"seo-content"},{id:"tap-targets",weight:1,group:"seo-mobile"},{id:"structured-data",weight:0}]},pwa:{title:l(c.pwaCategoryTitle),description:l(c.pwaCategoryDescription),manualDescription:l(c.pwaCategoryManualDescription),auditRefs:[{id:"installable-manifest",weight:2,group:"pwa-installable"},{id:"service-worker",weight:1,group:"pwa-optimized"},{id:"redirects-http",weight:2,group:"pwa-optimized"},{id:"splash-screen",weight:1,group:"pwa-optimized"},{id:"themed-omnibox",weight:1,group:"pwa-optimized"},{id:"content-width",weight:1,group:"pwa-optimized"},{id:"viewport",weight:2,group:"pwa-optimized"},{id:"apple-touch-icon",weight:1,group:"pwa-optimized"},{id:"maskable-icon",weight:1,
group:"pwa-optimized"},{id:"pwa-cross-browser",weight:0},{id:"pwa-page-transitions",weight:0},{id:"pwa-each-page-has-url",weight:0}]}}};t.exports=u,Object.defineProperty(t.exports,"UIStrings",{enumerable:!1,get:()=>c})}).call(this)}).call(this,"/lighthouse-core/config/default-config.js")},{"../lib/i18n/i18n.js":98,"./constants.js":56,"./metrics-to-audits.js":58}],58:[function(e,t,n){"use strict";const i=["server-response-time","render-blocking-resources","redirects","critical-request-chains","uses-text-compression","uses-rel-preconnect","uses-rel-preload","font-display","unminified-javascript","unminified-css","unused-css-rules"],a=[...i,"largest-contentful-paint-element","preload-lcp-image","unused-javascript","efficient-animated-content","total-byte-weight"];t.exports={fcpRelevantAudits:i,lcpRelevantAudits:a,
tbtRelevantAudits:["long-tasks","third-party-summary","third-party-facades","bootup-time","mainthread-work-breakdown","dom-size","duplicated-javascript","legacy-javascript","viewport"],clsRelevantAudits:["layout-shift-elements","non-composited-animations","unsized-images"]}},{}],59:[function(e,t,n){"use strict";const i=e("../../audits/audit.js"),a=e("../gather/base-gatherer.js"),s=e("../../lib/i18n/i18n.js");function assertValidFRGatherer(e){const t=e.instance,n=t.name;if("object"!=typeof t.meta)throw new Error(n+" gatherer did not provide a meta object.");if(0===t.meta.supportedModes.length)throw new Error(n+" gatherer did not support any gather modes.");if("function"!=typeof t.getArtifact||t.getArtifact===a.prototype.getArtifact)throw new Error(n+' gatherer did not define a "getArtifact" method.')}function assertValidFRNavigations(e){if(!e||!e.length)return{warnings:[]};const t=[],n=e[0];if("fatal"!==n.loadFailureMode){
const e=n.loadFailureMode,i=[`"${n.id}" is the first navigation but had a failure mode of ${e}.`,"The first navigation will always be treated as loadFailureMode=fatal."].join(" ");t.push(i),n.loadFailureMode="fatal"}const i=e.map((e=>e.id)),a=i.find(((e,t)=>i.slice(t+1).some((t=>e===t))));if(a)throw new Error(`Navigation must have unique identifiers, but "${a}" was repeated.`);return{warnings:t}}function assertValidAudit(e){const{implementation:t,path:n}=e,a=n||t&&t.meta&&t.meta.id||"Unknown audit";if("function"!=typeof t.audit||t.audit===i.audit)throw new Error(a+" has no audit() method.");if("string"!=typeof t.meta.id)throw new Error(a+" has no meta.id property, or the property is not a string.");if(!s.isStringOrIcuMessage(t.meta.title))throw new Error(a+" has no meta.title property, or the property is not a string.");const c=t.meta.scoreDisplayMode||i.SCORING_MODES.BINARY
;if(!s.isStringOrIcuMessage(t.meta.failureTitle)&&c===i.SCORING_MODES.BINARY)throw new Error(a+" has no meta.failureTitle and should.");if(!s.isStringOrIcuMessage(t.meta.description))throw new Error(a+" has no meta.description property, or the property is not a string.");if(""===t.meta.description)throw new Error(a+" has an empty meta.description string. Please add a description for the UI.");if(!Array.isArray(t.meta.requiredArtifacts))throw new Error(a+" has no meta.requiredArtifacts property, or the property is not an array.")}function assertValidCategories(e,t,n){if(!e)return;const i=new Map((t||[]).map((e=>[e.implementation.meta.id,e])));Object.keys(e).forEach((t=>{e[t].auditRefs.forEach(((e,a)=>{if(!e.id)throw new Error(`missing an audit id at ${t}[${a}]`);const s=i.get(e.id);if(!s)throw new Error(`could not find ${e.id} audit for category ${t}`);const c="manual"===s.implementation.meta.scoreDisplayMode
;if("accessibility"===t&&!e.group&&!c)throw new Error(e.id+" accessibility audit does not have a group");if(e.weight>0&&c)throw new Error(e.id+" is manual but has a positive weight");if(e.group&&(!n||!n[e.group]))throw new Error(`${e.id} references unknown group ${e.group}`)}))}))}function assertValidSettings(e){if(!e.formFactor)throw new Error("`settings.formFactor` must be defined as 'mobile' or 'desktop'. See https://github.com/GoogleChrome/lighthouse/blob/master/docs/emulation.md");if(!e.screenEmulation.disabled&&e.screenEmulation.mobile!==("mobile"===e.formFactor))throw new Error(`Screen emulation mobile setting (${e.screenEmulation.mobile}) does not match formFactor setting (${e.formFactor}). See https://github.com/GoogleChrome/lighthouse/blob/master/docs/emulation.md`)}function throwInvalidDependencyOrder(e,t){
throw new Error([`Failed to find dependency "${t}" for "${e}" artifact`,"Check that...",`  1. A gatherer exposes a matching Symbol that satisfies "${t}".`,`  2. "${t}" is configured to run before "${e}"`].join("\n"))}t.exports={isFRGathererDefn:function isFRGathererDefn(e){return"meta"in e.instance},isValidArtifactDependency:function isValidArtifactDependency(e,t){const n={timespan:0,snapshot:1,navigation:2},i=Math.min(...e.instance.meta.supportedModes.map((e=>n[e]))),a=Math.min(...t.instance.meta.supportedModes.map((e=>n[e])));return i===n.timespan?a===n.timespan:i!==n.snapshot||a===n.snapshot},assertValidPluginName:function assertValidPluginName(e,t){if(!t.startsWith("lighthouse-plugin-"))throw new Error(`plugin name '${t}' does not start with 'lighthouse-plugin-'`);if(e.categories&&e.categories[t])throw new Error(`plugin name '${t}' not allowed because it is the id of a category already found in config`)},assertValidFRGatherer,assertValidFRNavigations,assertValidAudit,
assertValidCategories,assertValidSettings,assertArtifactTopologicalOrder:function assertArtifactTopologicalOrder(e){const t=new Set;for(const n of e)for(const e of n.artifacts)if(t.add(e.id),e.dependencies)for(const[n,{id:i}]of Object.entries(e.dependencies))t.has(i)||throwInvalidDependencyOrder(e.id,n)},assertValidConfig:function assertValidConfig(e){const{warnings:t}=assertValidFRNavigations(e.navigations);for(const t of e.artifacts||[])assertValidFRGatherer(t.gatherer);for(const t of e.audits||[])assertValidAudit(t);return assertValidCategories(e.categories,e.audits,e.groups),assertValidSettings(e.settings),{warnings:t}},throwInvalidDependencyOrder,throwInvalidArtifactDependency:function throwInvalidArtifactDependency(e,t){throw new Error([`Dependency "${t}" for "${e}" artifact is invalid.`,"The dependency must be collected before the dependent."].join("\n"))}}},{"../../audits/audit.js":3,"../../lib/i18n/i18n.js":98,"../gather/base-gatherer.js":61}],60:[function(e,t,n){"use strict"
;const i=e("lighthouse-logger"),a=e("lodash.isequal"),{getBrowserVersion:s,getBenchmarkIndex:c,getEnvironmentWarnings:l}=e("../../gather/driver/environment.js");t.exports={getBaseArtifacts:async function getBaseArtifacts(e,t,n){const i=await c(t.executionContext),{userAgent:a}=await s(t.defaultSession);return{fetchTime:(new Date).toJSON(),Timing:[],LighthouseRunWarnings:[],settings:e.settings,BenchmarkIndex:i,HostUserAgent:a,HostFormFactor:a.includes("Android")||a.includes("Mobile")?"mobile":"desktop",URL:{requestedUrl:"",finalUrl:""},PageLoadError:null,GatherContext:n,Stacks:[],NetworkUserAgent:"",WebAppManifest:null,InstallabilityErrors:{errors:[]},traces:{},devtoolsLogs:{}}},finalizeArtifacts:function finalizeArtifacts(e,t){const n=e.LighthouseRunWarnings.concat(t.LighthouseRunWarnings||[]).concat(l({settings:e.settings,baseArtifacts:e})),s={...e,...t};if(s.Timing=i.getTimeEntries(),s.LighthouseRunWarnings=function deduplicateWarnings(e){const t=[]
;for(const n of e)t.some((e=>a(n,e)))||t.push(n);return t}(n),s.PageLoadError&&!s.URL.finalUrl&&(s.URL.finalUrl=s.URL.requestedUrl),!s.URL.requestedUrl)throw new Error("Runner did not set requestedUrl");if(!s.URL.finalUrl)throw new Error("Runner did not set finalUrl");return s}}},{"../../gather/driver/environment.js":67,"lighthouse-logger":188,"lodash.isequal":217}],61:[function(e,t,n){"use strict";t.exports=class FRGatherer{meta={supportedModes:[]};startInstrumentation(e){}startSensitiveInstrumentation(e){}stopSensitiveInstrumentation(e){}stopInstrumentation(e){}getArtifact(e){}get name(){return this.constructor.name}async beforePass(e){await this.startInstrumentation({...e,dependencies:{}}),await this.startSensitiveInstrumentation({...e,dependencies:{}})}pass(e){}async afterPass(e,t){if("dependencies"in this.meta)throw Error("Gatherer with dependencies should override afterPass");return await this.stopSensitiveInstrumentation({...e,dependencies:{}}),await this.stopInstrumentation({
...e,dependencies:{}}),this.getArtifact({...e,dependencies:{}})}}},{}],62:[function(e,t,n){"use strict";const i=e("events").EventEmitter,a=e("lighthouse-logger"),s=e("../../lib/lh-error.js");t.exports=class Connection{constructor(){this._lastCommandId=0,this._callbacks=new Map,this._eventEmitter=new i}connect(){return Promise.reject(new Error("Not implemented"))}disconnect(){return Promise.reject(new Error("Not implemented"))}wsEndpoint(){return Promise.reject(new Error("Not implemented"))}sendCommand(e,t,...n){const i=n.length?n[0]:void 0;a.formatProtocol("method => browser",{method:e,params:i},"verbose");const s=++this._lastCommandId,c=JSON.stringify({id:s,sessionId:t,method:e,params:i});return this.sendRawMessage(c),new Promise((t=>{this._callbacks.set(s,{method:e,resolve:t})}))}on(e,t){if("protocolevent"!==e)throw new Error('Only supports "protocolevent" events');if(!this._eventEmitter)throw new Error("Attempted to add event listener after connection disposed.")
;this._eventEmitter.on(e,t)}off(e,t){if("protocolevent"!==e)throw new Error('Only supports "protocolevent" events');if(!this._eventEmitter)throw new Error("Attempted to remove event listener after connection disposed.");this._eventEmitter.removeListener(e,t)}sendRawMessage(e){throw new Error("Not implemented")}handleRawMessage(e){const t=JSON.parse(e);if(!("id"in t))return a.formatProtocol("<= event",{method:t.method,params:t.params},"verbose"),void this.emitProtocolEvent(t);const n=this._callbacks.get(t.id);if(n)this._callbacks.delete(t.id),n.resolve(Promise.resolve().then((e=>{if(t.error)throw a.formatProtocol("method <= browser ERR",{method:n.method},"error"),s.fromProtocolMessage(n.method,t.error);return a.formatProtocol("method <= browser OK",{method:n.method,params:t.result},"verbose"),t.result})));else{const e=t.error&&t.error.message;a.formatProtocol("disowned method <= browser "+(e?"ERR":"OK"),{method:"UNKNOWN",params:e||t.result},"verbose")}}emitProtocolEvent(e){
if(!this._eventEmitter)throw new Error("Attempted to emit event after connection disposed.");this._eventEmitter.emit("protocolevent",e)}dispose(){this._eventEmitter&&(this._eventEmitter.removeAllListeners(),this._eventEmitter=null)}}},{"../../lib/lh-error.js":103,events:162,"lighthouse-logger":188}],63:[function(e,t,n){"use strict";const i=e("./connection.js");t.exports=class RawConnection extends i{constructor(e){super(),this._port=e,this._port.on("message",this.handleRawMessage.bind(this)),this._port.on("close",this.dispose.bind(this))}connect(){return Promise.resolve()}disconnect(){return this._port.close(),Promise.resolve()}sendRawMessage(e){this._port.send(e)}}},{"./connection.js":62}],64:[function(e,t,n){"use strict";t.exports=class DevtoolsLog{constructor(e){this._filter=e,this._messages=[],this._isRecording=!1}get messages(){return this._messages}reset(){this._messages=[]}beginRecording(){this._isRecording=!0}endRecording(){this._isRecording=!1}record(e){
this._isRecording&&"string"==typeof e.method&&(this._filter&&!this._filter.test(e.method)||this._messages.push(e))}}},{}],65:[function(e,t,n){"use strict";const i=e("./fetcher.js"),a=e("./driver/execution-context.js"),s=e("../lib/lh-error.js"),{fetchResponseBodyFromCache:c}=e("../gather/driver/network.js"),l=e("events").EventEmitter,u=e("lighthouse-logger"),d=e("./devtools-log.js"),m=e("./gatherers/trace.js"),{getBrowserVersion:p}=(e("./connections/connection.js"),e("./driver/environment.js")),h=3e4;t.exports=class Driver{_eventEmitter=new l;_devtoolsLog=new d(/^(Page|Network)\./);_domainEnabledCounts=new Map;_nextProtocolTimeout=h;online=!0;executionContext=new a(this);defaultSession=this;fetcher=new i(this.defaultSession,this.executionContext);constructor(e){this._connection=e,this.on("Target.attachedToTarget",(e=>{this._handleTargetAttached(e).catch(this._handleEventError)})),this.on("Page.frameNavigated",(e=>{e.frame.parentId||this.sendCommand("Target.setAutoAttach",{flatten:!0,
autoAttach:!0,waitForDebuggerOnStart:!0}).catch(this._handleEventError)})),e.on("protocolevent",this._handleProtocolEvent.bind(this)),this.evaluate=this.executionContext.evaluate.bind(this.executionContext),this.evaluateAsync=this.executionContext.evaluateAsync.bind(this.executionContext)}static get traceCategories(){return m.getDefaultTraceCategories()}async getBrowserVersion(){return p(this)}async connect(){const e={msg:"Connecting to browser",id:"lh:init:connect"};u.time(e),await this._connection.connect(),u.timeEnd(e)}disconnect(){return this._connection.disconnect()}dispose(){return this.disconnect()}wsEndpoint(){return this._connection.wsEndpoint()}on(e,t){if(null===this._eventEmitter)throw new Error("connect() must be called before attempting to listen to events.");u.formatProtocol("listen for event =>",{method:e},"verbose"),this._eventEmitter.on(e,t)}once(e,t){if(null===this._eventEmitter)throw new Error("connect() must be called before attempting to listen to events.")
;u.formatProtocol("listen once for event =>",{method:e},"verbose"),this._eventEmitter.once(e,t)}off(e,t){if(null===this._eventEmitter)throw new Error("connect() must be called before attempting to remove an event listener.");this._eventEmitter.removeListener(e,t)}addProtocolMessageListener(e){this._connection.on("protocolevent",e)}removeProtocolMessageListener(e){this._connection.off("protocolevent",e)}setTargetInfo(e){}addSessionAttachedListener(e){}removeSessionAttachedListener(e){}_shouldToggleDomain(e,t,n){const i=e+(t||""),a=(this._domainEnabledCounts.get(i)||0)+(n?1:-1);return this._domainEnabledCounts.set(i,Math.max(0,a)),n&&1===a||!n&&0===a?(u.verbose("Driver",`${e}.${n?"enable":"disable"}`),!0):(a<0&&u.error("Driver",`Attempted to disable domain '${e}' when already disabled.`),!1)}hasNextProtocolTimeout(){return this._nextProtocolTimeout!==h}getNextProtocolTimeout(){return this._nextProtocolTimeout}setNextProtocolTimeout(e){this._nextProtocolTimeout=e}_handleProtocolEvent(e){
this._devtoolsLog.record(e),this._eventEmitter.emit(e.method,e.params)}_handleEventError(e){u.error("Driver","Unhandled event error",e.message)}async _handleTargetAttached(e){"iframe"===e.targetInfo.type?(await this.sendCommandToSession("Network.enable",e.sessionId),await this.sendCommandToSession("Target.setAutoAttach",e.sessionId,{autoAttach:!0,flatten:!0,waitForDebuggerOnStart:!0}),await this.sendCommandToSession("Runtime.runIfWaitingForDebugger",e.sessionId)):await this.sendCommandToSession("Runtime.runIfWaitingForDebugger",e.sessionId)}sendCommandToSession(e,t,...n){const i=this._nextProtocolTimeout;let a;this._nextProtocolTimeout=h;const c=new Promise(((t,n)=>{i!==1/0&&(a=setTimeout((()=>{const t=new s(s.errors.PROTOCOL_TIMEOUT,{protocolMethod:e});n(t)}),i))}));return Promise.race([this._innerSendCommand(e,t,...n),c]).finally((()=>{a&&clearTimeout(a)}))}sendCommand(e,...t){return this.sendCommandToSession(e,void 0,...t)}_innerSendCommand(e,t,...n){
const i=/^(\w+)\.(enable|disable)$/.exec(e);if(i){const e="enable"===i[2];if(!this._shouldToggleDomain(i[1],t,e))return Promise.resolve()}return this._connection.sendCommand(e,t,...n)}isDomainEnabled(e){return!!this._domainEnabledCounts.get(e)}async getRequestContent(e,t=1e3){return c(this.defaultSession,e,t)}scrollTo(e){const t=`window.scrollTo(${e.x}, ${e.y})`;return this.executionContext.evaluateAsync(t,{useIsolation:!0})}getScrollPosition(){return this.executionContext.evaluateAsync("({x: window.scrollX, y: window.scrollY})",{useIsolation:!0})}async beginTrace(e){const t=e&&e.additionalTraceCategories&&e.additionalTraceCategories.split(",")||[],n=m.getDefaultTraceCategories().concat(t),i=Array.from(new Set(n));if(this.isDomainEnabled("CSS"))throw new Error("CSS domain enabled when starting trace");if(this.isDomainEnabled("DOM"))throw new Error("DOM domain enabled when starting trace");return this.sendCommand("Page.enable").then((e=>this.sendCommand("Tracing.start",{
categories:i.join(","),options:"sampling-frequency=10000"})))}endTrace(){return m.endTraceAndCollectEvents(this.defaultSession)}beginDevtoolsLog(){this._devtoolsLog.reset(),this._devtoolsLog.beginRecording()}endDevtoolsLog(){return this._devtoolsLog.endRecording(),this._devtoolsLog.messages}}},{"../gather/driver/network.js":71,"../lib/lh-error.js":103,"./connections/connection.js":62,"./devtools-log.js":64,"./driver/environment.js":67,"./driver/execution-context.js":68,"./fetcher.js":77,"./gatherers/trace.js":"../gather/gatherers/trace",events:162,"lighthouse-logger":188}],66:[function(e,t,n){"use strict";function handlePotentialMissingNodeError(e){if(!/No node.*found/.test(e.message)&&!/Node.*does not belong to the document/.test(e.message))throw e}t.exports={resolveNodeIdToObjectId:async function resolveNodeIdToObjectId(e,t){try{return(await e.sendCommand("DOM.resolveNode",{backendNodeId:t})).object.objectId}catch(e){return handlePotentialMissingNodeError(e)}},
resolveDevtoolsNodePathToObjectId:async function resolveDevtoolsNodePathToObjectId(e,t){try{const{nodeId:n}=await e.sendCommand("DOM.pushNodeByPathToFrontend",{path:t}),{object:{objectId:i}}=await e.sendCommand("DOM.resolveNode",{nodeId:n});return i}catch(e){return handlePotentialMissingNodeError(e)}}}},{}],67:[function(e,t,n){(function(n){(function(){"use strict";const i=e("lighthouse-logger"),a=e("../../config/constants.js"),s=e("../../lib/page-functions.js"),c=e("../../lib/i18n/i18n.js"),l={warningSlowHostCpu:"The tested device appears to have a slower CPU than  Lighthouse expects. This can negatively affect your performance score. Learn more about [calibrating an appropriate CPU slowdown multiplier](https://github.com/GoogleChrome/lighthouse/blob/master/docs/throttling.md#cpu-throttling)."},u=c.createMessageInstanceIdFn(n,l);function getSlowHostCpuWarning(e){const{settings:t,baseArtifacts:n}=e,{throttling:i,throttlingMethod:s}=t,c=a.defaultSettings.throttling
;if("cli"!==t.channel)return;const d="simulate"===s||"devtools"===s,m=i.cpuSlowdownMultiplier===c.cpuSlowdownMultiplier;return!d||!m||n.BenchmarkIndex>1e3?void 0:u(l.warningSlowHostCpu)}t.exports={UIStrings:l,getBrowserVersion:async function getBrowserVersion(e){const t={msg:"Getting browser version",id:"lh:gather:getVersion"};i.time(t,"verbose");const n=await e.sendCommand("Browser.getVersion"),a=n.product.match(/\/(\d+)/),s=a?parseInt(a[1]):0;return i.timeEnd(t),Object.assign(n,{milestone:s})},getBenchmarkIndex:async function getBenchmarkIndex(e){const t={msg:"Benchmarking machine",id:"lh:gather:getBenchmarkIndex"};i.time(t);const n=await e.evaluate(s.computeBenchmarkIndex,{args:[]});return i.timeEnd(t),n},getSlowHostCpuWarning,getEnvironmentWarnings:function getEnvironmentWarnings(e){return[getSlowHostCpuWarning(e)].filter((e=>!!e))}}}).call(this)}).call(this,"/lighthouse-core/gather/driver/environment.js")},{"../../config/constants.js":56,"../../lib/i18n/i18n.js":98,
"../../lib/page-functions.js":110,"lighthouse-logger":188}],68:[function(e,t,n){"use strict";const i=e("../../lib/page-functions.js");class ExecutionContext{constructor(e){this._session=e,this._executionContextId=void 0,e.on("Page.frameNavigated",(()=>this.clearContextId())),e.on("Runtime.executionContextDestroyed",(e=>{e.executionContextId===this._executionContextId&&this.clearContextId()}))}getContextId(){return this._executionContextId}clearContextId(){this._executionContextId=void 0}async _getOrCreateIsolatedContextId(){if("number"==typeof this._executionContextId)return this._executionContextId;await this._session.sendCommand("Page.enable"),await this._session.sendCommand("Runtime.enable");const e=(await this._session.sendCommand("Page.getResourceTree")).frameTree.frame.id,t=await this._session.sendCommand("Page.createIsolatedWorld",{frameId:e,worldName:"lighthouse_isolated_context"});return this._executionContextId=t.executionContextId,t.executionContextId}
async _evaluateInContext(e,t){const n=this._session.hasNextProtocolTimeout()?this._session.getNextProtocolTimeout():6e4,a={expression:`(function wrapInNativePromise() {\n        ${ExecutionContext._cachedNativesPreamble};\n        globalThis.__lighthouseExecutionContextId = ${t};\n        return new Promise(function (resolve) {\n          return Promise.resolve()\n            .then(_ => ${e})\n            .catch(${i.wrapRuntimeEvalErrorInBrowserString})\n            .then(resolve);\n        });\n      }())`,includeCommandLineAPI:!0,awaitPromise:!0,returnByValue:!0,timeout:n,contextId:t};this._session.setNextProtocolTimeout(n);const s=await this._session.sendCommand("Runtime.evaluate",a);if(s.exceptionDetails){const e=s.exceptionDetails.exception?s.exceptionDetails.exception.description:s.exceptionDetails.text;return Promise.reject(new Error("Evaluation exception: "+e))}if(void 0===s.result)return Promise.reject(new Error('Runtime.evaluate response did not contain a "result" object'))
;const c=s.result.value;return c&&c.__failedInBrowser?Promise.reject(Object.assign(new Error,c)):c}async evaluateAsync(e,t={}){const n=t.useIsolation?await this._getOrCreateIsolatedContextId():void 0;try{return await this._evaluateInContext(e,n)}catch(t){if(n&&t.message.includes("Cannot find context")){this.clearContextId();const t=await this._getOrCreateIsolatedContextId();return this._evaluateInContext(e,t)}throw t}}evaluate(e,t){const n=ExecutionContext.serializeArguments(t.args),i=`(() => {\n      ${t.deps?t.deps.join("\n"):""}\n      return (${e})(${n});\n    })()`;return this.evaluateAsync(i,t)}async evaluateOnNewDocument(e,t){const n=ExecutionContext.serializeArguments(t.args),i=t.deps?t.deps.join("\n"):"",a=`(() => {\n      ${ExecutionContext._cachedNativesPreamble};\n      ${i};\n      (${e})(${n});\n    })()`;await this._session.sendCommand("Page.addScriptToEvaluateOnNewDocument",{source:a})}async cacheNativesOnNewDocument(){await this.evaluateOnNewDocument((()=>{
window.__nativePromise=window.Promise,window.__nativeURL=window.URL,window.__nativePerformance=window.performance,window.__ElementMatches=window.Element.prototype.matches;const e=window.performance,t=window.performance.now;Object.defineProperty(e,"now",{value:()=>t.call(e),writable:!1})}),{args:[]})}static _cachedNativesPreamble=["const Promise = globalThis.__nativePromise || globalThis.Promise","const URL = globalThis.__nativeURL || globalThis.URL","const performance = globalThis.__nativePerformance || globalThis.performance"].join(";\n");static serializeArguments(e){return e.map((e=>void 0===e?"undefined":JSON.stringify(e))).join(",")}}t.exports=ExecutionContext},{"../../lib/page-functions.js":110}],69:[function(e,t,n){(function(n){(function(){"use strict";const i=e("./network-monitor.js"),{waitForFullyLoaded:a,waitForFrameNavigated:s,waitForUserToContinue:c}=e("./wait-for-condition.js"),l=e("../../config/constants.js"),u=e("../../lib/i18n/i18n.js"),d=e("../../lib/url-shim.js"),m={
warningRedirected:"The page may not be loading as expected because your test URL ({requested}) was redirected to {final}. Try testing the second URL directly.",warningTimeout:"The page loaded too slowly to finish within the time limit. Results may be incomplete."},p=u.createMessageInstanceIdFn(n,m);function getNavigationWarnings(e){const{requestedUrl:t,finalUrl:n}=e,i=[];return e.timedOut&&i.push(p(m.warningTimeout)),d.equalWithExcludedFragments(t,n)||i.push(p(m.warningRedirected,{requested:t,final:n})),i}t.exports={gotoURL:async function gotoURL(e,t,n){const u=e.defaultSession,d=new i(e.defaultSession);await d.enable(),await u.sendCommand("Page.enable"),await u.sendCommand("Page.setLifecycleEventsEnabled",{enabled:!0}),u.setNextProtocolTimeout(1/0);const m=u.sendCommand("Page.navigate",{url:t}),p=n.waitUntil.includes("navigated"),h=n.waitUntil.includes("load"),f=n.waitUntil.includes("fcp"),g=[];if(p){const e=s(u).promise;g.push(e.then((()=>({timedOut:!1}))))}if(h){
const e=function resolveWaitForFullyLoadedOptions(e){let{pauseAfterFcpMs:t,pauseAfterLoadMs:n,networkQuietThresholdMs:i,cpuQuietThresholdMs:a}=e,s=e.maxWaitForLoad,c=e.maxWaitForFcp;return"number"!=typeof t&&(t=0),"number"!=typeof n&&(n=0),"number"!=typeof i&&(i=5e3),"number"!=typeof a&&(a=0),"number"!=typeof s&&(s=l.defaultSettings.maxWaitForLoad),"number"!=typeof c&&(c=l.defaultSettings.maxWaitForFcp),e.waitUntil.includes("fcp")||(c=void 0),{pauseAfterFcpMs:t,pauseAfterLoadMs:n,networkQuietThresholdMs:i,cpuQuietThresholdMs:a,maxWaitForLoadedMs:s,maxWaitForFcpMs:c}}(n);g.push(a(u,d,e))}else if(f)throw new Error("Cannot wait for FCP without waiting for page load");const y=(await Promise.all(g)).some((e=>e.timedOut)),b=await d.getFinalNavigationUrl()||t;return await m,await d.disable(),n.debugNavigation&&await c(e),{finalUrl:b,warnings:getNavigationWarnings({timedOut:y,finalUrl:b,requestedUrl:t})}},getNavigationWarnings,UIStrings:m}}).call(this)
}).call(this,"/lighthouse-core/gather/driver/navigation.js")},{"../../config/constants.js":56,"../../lib/i18n/i18n.js":98,"../../lib/url-shim.js":"url","./network-monitor.js":70,"./wait-for-condition.js":76}],70:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),{EventEmitter:a}=e("events"),s=e("../../lib/network-recorder.js"),c=e("../../lib/network-request.js"),l=e("../../lib/url-shim.js"),u=e("./target-manager.js");t.exports=class NetworkMonitor{_networkRecorder=void 0;_targetManager=void 0;_frameNavigations=[];constructor(e){this._session=e,this._onTargetAttached=this._onTargetAttached.bind(this),this._sessions=new Map,this._onFrameNavigated=e=>this._frameNavigations.push(e.frame),this._onProtocolMessage=e=>{this.emit("protocolmessage",e),this._networkRecorder&&this._networkRecorder.dispatch(e)};const t=new a;this.emit=t.emit.bind(t),this.on=t.on.bind(t),this.once=t.once.bind(t),this.off=t.off.bind(t),this.addListener=t.addListener.bind(t),
this.removeListener=t.removeListener.bind(t),this.removeAllListeners=t.removeAllListeners.bind(t)}async _onTargetAttached({session:e,target:t}){const n=t.targetId;this._sessions.set(n,e),e.addProtocolMessageListener(this._onProtocolMessage),await e.sendCommand("Network.enable")}async enable(){if(this._targetManager)return;this._frameNavigations=[],this._sessions=new Map,this._networkRecorder=new s,this._targetManager=new u(this._session);const reEmit=e=>t=>{this.emit(e,t),this._emitNetworkStatus()};this._networkRecorder.on("requeststarted",reEmit("requeststarted")),this._networkRecorder.on("requestloaded",reEmit("requestloaded")),this._session.on("Page.frameNavigated",this._onFrameNavigated),this._targetManager.addTargetAttachedListener(this._onTargetAttached),await this._session.sendCommand("Page.enable"),await this._targetManager.enable()}async disable(){if(this._targetManager){this._session.off("Page.frameNavigated",this._onFrameNavigated),
this._targetManager.removeTargetAttachedListener(this._onTargetAttached);for(const e of this._sessions.values())e.removeProtocolMessageListener(this._onProtocolMessage);await this._targetManager.disable(),this._frameNavigations=[],this._networkRecorder=void 0,this._targetManager=void 0,this._sessions=new Map}}async getFinalNavigationUrl(){const e=this._frameNavigations;if(!e.length)return;const t=(await this._session.sendCommand("Page.getResourceTree")).frameTree.frame.id,n=e.filter((e=>e.id===t)),a=n[n.length-1];return a||i.warn("NetworkMonitor","No detected navigations"),a&&a.url}getInflightRequests(){return this._networkRecorder?this._networkRecorder.getRawRecords().filter((e=>!e.finished)):[]}isIdle(){return this._isActiveIdlePeriod(0)}isCriticalIdle(){if(!this._networkRecorder)return!1;const e=this._networkRecorder.getRawRecords().find((e=>"Document"===e.resourceType)),t=e&&e.frameId
;return this._isActiveIdlePeriod(0,(e=>e.frameId===t&&("VeryHigh"===e.priority||"High"===e.priority)))}is2Idle(){return this._isActiveIdlePeriod(2)}_isActiveIdlePeriod(e,t){if(!this._networkRecorder)return!1;const n=this._networkRecorder.getRawRecords();let i=0;for(let e=0;e<n.length;e++){const a=n[e];a.finished||(t&&!t(a)||c.isNonNetworkRequest(a)||i++)}return i<=e}_emitNetworkStatus(){const e=this.isIdle(),t=this.is2Idle(),n=this.isCriticalIdle();this.emit(e?"networkidle":"networkbusy"),this.emit(t?"network-2-idle":"network-2-busy"),this.emit(n?"network-critical-idle":"network-critical-busy"),t&&e?i.verbose("NetworkRecorder","network fully-quiet"):t&&!e?i.verbose("NetworkRecorder","network semi-quiet"):i.verbose("NetworkRecorder","network busy")}static findNetworkQuietPeriods(e,t,n=1/0){let i=[];e.forEach((e=>{l.isNonNetworkProtocol(e.protocol)||"ws"!==e.protocol&&"wss"!==e.protocol&&(i.push({time:1e3*e.startTime,isStart:!0}),e.finished&&i.push({time:1e3*e.endTime,isStart:!1}))})),
i=i.filter((e=>e.time<=n)).sort(((e,t)=>e.time-t.time));let a=0,s=0;const c=[];return i.forEach((e=>{e.isStart?(a===t&&c.push({start:s,end:e.time}),a++):(a--,a===t&&(s=e.time))})),a<=t&&c.push({start:s,end:n}),c.filter((e=>e.start!==e.end))}}},{"../../lib/network-recorder.js":108,"../../lib/network-request.js":109,"../../lib/url-shim.js":"url","./target-manager.js":75,events:162,"lighthouse-logger":188}],71:[function(e,t,n){"use strict";const i=e("../../lib/network-request.js");t.exports={fetchResponseBodyFromCache:async function fetchResponseBodyFromCache(e,t,n=1e3){return t=i.getRequestIdForBackend(t),e.setNextProtocolTimeout(n),(await e.sendCommand("Network.getResponseBody",{requestId:t})).body}}},{"../../lib/network-request.js":109}],72:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("./storage.js"),s=e("../../lib/emulation.js"),c=e("../../lib/page-functions.js");async function prepareThrottlingAndNetwork(e,t,n){const a={msg:"Preparing network conditions",
id:"lh:gather:prepareThrottlingAndNetwork"};i.time(a),n.disableThrottling?await s.clearThrottling(e):await s.throttle(e,t);const c=(n.blockedUrlPatterns||[]).concat(t.blockedUrlPatterns||[]);await e.sendCommand("Network.setBlockedURLs",{urls:c});const l=t.extraHeaders;l&&await e.sendCommand("Network.setExtraHTTPHeaders",{headers:l}),i.timeEnd(a)}async function prepareDeviceEmulationAndAsyncStacks(e,t){await e.defaultSession.sendCommand("Network.enable"),await s.emulate(e.defaultSession,t),await async function enableAsyncStacks(e){const enable=async()=>{await e.sendCommand("Debugger.enable"),await e.sendCommand("Debugger.setSkipAllPauses",{skip:!0}),await e.sendCommand("Debugger.setAsyncCallStackDepth",{maxDepth:8})};e.on("Debugger.paused",(()=>e.sendCommand("Debugger.resume"))),e.on("Page.frameNavigated",(e=>{e.frame.parentId||enable().catch((e=>i.error("Driver",e)))})),await enable()}(e.defaultSession)}t.exports={prepareThrottlingAndNetwork,
prepareTargetForTimespanMode:async function prepareTargetForTimespanMode(e,t){await prepareDeviceEmulationAndAsyncStacks(e,t),await prepareThrottlingAndNetwork(e.defaultSession,t,{disableThrottling:!1,blockedUrlPatterns:void 0})},prepareTargetForNavigationMode:async function prepareTargetForNavigationMode(e,t){await prepareDeviceEmulationAndAsyncStacks(e,t),await async function dismissJavaScriptDialogs(e){e.on("Page.javascriptDialogOpening",(t=>{i.warn("Driver",t.type+" dialog opened by the page automatically suppressed."),e.sendCommand("Page.handleJavaScriptDialog",{accept:!0,promptText:"Lighthouse prompt response"}).catch((e=>i.warn("Driver",e)))})),await e.sendCommand("Page.enable")}(e.defaultSession),await e.executionContext.cacheNativesOnNewDocument(),"simulate"===t.throttlingMethod&&await async function shimRequestIdleCallbackOnNewDocument(e,t){await e.executionContext.evaluateOnNewDocument(c.wrapRequestIdleCallback,{args:[t.throttling.cpuSlowdownMultiplier]})}(e,t)},
prepareTargetForIndividualNavigation:async function prepareTargetForIndividualNavigation(e,t,n){const i=[];if(!t.disableStorageReset&&!n.disableStorageReset){const{warnings:t}=await async function resetStorageForNavigation(e,t){const n=[],i=await a.getImportantStorageWarning(e,t.url);return i&&n.push(i),await a.clearDataForOrigin(e,t.url),await a.clearBrowserCaches(e),{warnings:n}}(e,n);i.push(...t)}return await prepareThrottlingAndNetwork(e,t,n),{warnings:i}}}},{"../../lib/emulation.js":97,"../../lib/page-functions.js":110,"./storage.js":74,"lighthouse-logger":188}],73:[function(e,t,n){"use strict";t.exports={getServiceWorkerVersions:function getServiceWorkerVersions(e){return new Promise(((t,n)=>{const versionUpdatedListener=i=>{const a=i.versions.filter((e=>"redundant"!==e.status)),s=a.find((e=>"activated"===e.status));a.length&&!s||(e.off("ServiceWorker.workerVersionUpdated",versionUpdatedListener),e.sendCommand("ServiceWorker.disable").then((e=>t(i)),n))}
;e.on("ServiceWorker.workerVersionUpdated",versionUpdatedListener),e.sendCommand("ServiceWorker.enable").catch(n)}))},getServiceWorkerRegistrations:function getServiceWorkerRegistrations(e){return new Promise(((t,n)=>{e.once("ServiceWorker.workerRegistrationUpdated",(i=>{e.sendCommand("ServiceWorker.disable").then((e=>t(i)),n)})),e.sendCommand("ServiceWorker.enable").catch(n)}))}}},{}],74:[function(e,t,n){(function(n){(function(){"use strict";const i=e("lighthouse-logger"),a=e("../../lib/i18n/i18n.js"),s={warningData:"{locationCount, plural,\n    =1 {There may be stored data affecting loading performance in this location: {locations}. Audit this page in an incognito window to prevent those resources from affecting your scores.}\n    other {There may be stored data affecting loading performance in these locations: {locations}. Audit this page in an incognito window to prevent those resources from affecting your scores.}\n  }"},c=a.createMessageInstanceIdFn(n,s);t.exports={
clearDataForOrigin:async function clearDataForOrigin(e,t){const n=new URL(t).origin,a=["appcache","file_systems","shader_cache","service_workers","cache_storage"].join(",");e.setNextProtocolTimeout(5e3);try{await e.sendCommand("Storage.clearDataForOrigin",{origin:n,storageTypes:a})}catch(e){if("PROTOCOL_TIMEOUT"!==e.code)throw e;i.warn("Driver","clearDataForOrigin timed out")}},clearBrowserCaches:async function clearBrowserCaches(e){const t={msg:"Cleaning browser cache",id:"lh:storage:clearBrowserCaches"};i.time(t),await e.sendCommand("Network.clearBrowserCache"),await e.sendCommand("Network.setCacheDisabled",{cacheDisabled:!0}),await e.sendCommand("Network.setCacheDisabled",{cacheDisabled:!1}),i.timeEnd(t)},getImportantStorageWarning:async function getImportantStorageWarning(e,t){const n=await e.sendCommand("Storage.getUsageAndQuota",{origin:t}),i={local_storage:"Local Storage",indexeddb:"IndexedDB",websql:"Web SQL"
},a=n.usageBreakdown.filter((e=>e.usage)).map((e=>i[e.storageType]||"")).filter(Boolean);if(a.length)return c(s.warningData,{locations:a.join(", "),locationCount:a.length})},UIStrings:s}}).call(this)}).call(this,"/lighthouse-core/gather/driver/storage.js")},{"../../lib/i18n/i18n.js":98,"lighthouse-logger":188}],75:[function(e,t,n){"use strict";const i=e("lighthouse-logger");t.exports=class TargetManager{constructor(e){this._enabled=!1,this._session=e,this._listeners=[],this._onSessionAttached=this._onSessionAttached.bind(this),this._targets=new Map,this._onFrameNavigated=async e=>{e.frame.parentId||await this._session.sendCommand("Target.setAutoAttach",{autoAttach:!0,flatten:!0,waitForDebuggerOnStart:!0})}}async _onSessionAttached(e){try{const t=await e.sendCommand("Target.getTargetInfo").catch((()=>null)),n=t&&t.targetInfo&&t.targetInfo.type,a="page"===n||"iframe"===n;if(!t||!a)return;const s=t.targetInfo.targetId;if(e.setTargetInfo(t.targetInfo),this._targets.has(s))return
;const c=t.targetInfo.url||t.targetInfo.targetId;i.verbose("target-manager",`target ${c} attached`);const l={target:t.targetInfo,session:e};this._targets.set(s,l);for(const e of this._listeners)await e(l);await e.sendCommand("Target.setAutoAttach",{autoAttach:!0,flatten:!0,waitForDebuggerOnStart:!0})}catch(e){if(/Target closed/.test(e.message))return;throw e}finally{await e.sendCommand("Runtime.runIfWaitingForDebugger").catch((()=>{}))}}async enable(){this._enabled||(this._enabled=!0,this._targets=new Map,this._session.on("Page.frameNavigated",this._onFrameNavigated),this._session.addSessionAttachedListener(this._onSessionAttached),await this._session.sendCommand("Page.enable"),await this._onSessionAttached(this._session))}async disable(){this._session.off("Page.frameNavigated",this._onFrameNavigated),this._session.removeSessionAttachedListener(this._onSessionAttached),this._enabled=!1,this._targets=new Map}addTargetAttachedListener(e){this._listeners.push(e)}
removeTargetAttachedListener(e){this._listeners=this._listeners.filter((t=>t!==e))}}},{"lighthouse-logger":188}],76:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("../../lib/lh-error.js"),s=e("./execution-context.js");function waitForNothing(){return{promise:Promise.resolve(),cancel(){}}}function waitForFcp(e,t,n){let cancel=()=>{throw new Error("waitForFcp.cancel() called before it was defined")};return{promise:new Promise(((i,s)=>{const c=setTimeout((()=>{s(new a(a.errors.NO_FCP))}),n);let l;const lifecycleListener=e=>{"firstContentfulPaint"===e.name&&(l=setTimeout((()=>{i(),cancel()}),t))};e.on("Page.lifecycleEvent",lifecycleListener);let u=!1;cancel=()=>{u||(u=!0,e.off("Page.lifecycleEvent",lifecycleListener),c&&clearTimeout(c),l&&clearTimeout(l),s(new Error("Wait for FCP canceled")))}})),cancel}}function waitForNetworkIdle(e,t,n){let a,s=!1,cancel=()=>{throw new Error("waitForNetworkIdle.cancel() called before it was defined")}
;const{networkQuietThresholdMs:c,busyEvent:l,idleEvent:u,isIdle:d}=n;return{promise:new Promise(((n,m)=>{const onIdle=()=>{t.once(l,onBusy),a=setTimeout((()=>{cancel(),n()}),c)},onBusy=()=>{t.once(u,onIdle),a&&clearTimeout(a)},domContentLoadedListener=()=>{s=!0,d(t)?onIdle():onBusy()},logStatus=()=>{if(!s)return void i.verbose("waitFor","Waiting on DomContentLoaded");const e=t.getInflightRequests();if(e.length<20)for(const t of e)i.verbose("waitFor",`Waiting on ${t.url.slice(0,120)} to finish`)};t.on("requeststarted",logStatus),t.on("requestloaded",logStatus),t.on(l,logStatus),e.once("Page.domContentEventFired",domContentLoadedListener);let p=!1;cancel=()=>{p||(p=!0,a&&clearTimeout(a),e.off("Page.domContentEventFired",domContentLoadedListener),t.removeListener(l,onBusy),t.removeListener(u,onIdle),t.removeListener("requeststarted",logStatus),t.removeListener("requestloaded",logStatus),t.removeListener(l,logStatus))}})),cancel}}function waitForCPUIdle(e,t){if(!t)return{
promise:Promise.resolve(),cancel:()=>{}};let n,a=!1;async function checkForQuiet(e,s){if(a)return;const c=await e.evaluate(checkTimeSinceLastLongTaskInPage,{args:[]});if(!a&&"number"==typeof c)if(c>=t)i.verbose("waitFor",`CPU has been idle for ${c} ms`),s();else{i.verbose("waitFor",`CPU has been idle for ${c} ms`);n=setTimeout((()=>checkForQuiet(e,s)),t-c)}}let cancel=()=>{throw new Error("waitForCPUIdle.cancel() called before it was defined")};const c=new s(e);return{promise:new Promise(((e,t)=>{c.evaluate(registerPerformanceObserverInPage,{args:[]}).then((()=>checkForQuiet(c,e))).catch(t),cancel=()=>{a||(a=!0,n&&clearTimeout(n),t(new Error("Wait for CPU idle canceled")))}})),cancel}}function registerPerformanceObserverInPage(){if(void 0!==window.____lastLongTask)return;window.____lastLongTask=performance.now();new window.PerformanceObserver((e=>{const t=e.getEntries();for(const e of t)if("longtask"===e.entryType){const t=e.startTime+e.duration
;window.____lastLongTask=Math.max(window.____lastLongTask||0,t)}})).observe({type:"longtask",buffered:!0})}function checkTimeSinceLastLongTaskInPage(){return new Promise((e=>{const t=performance.now(),n=window.____lastLongTask||0;setTimeout((()=>{const i=window.____lastLongTask||0;e(n===i?t-n:0)}),150)}))}function waitForLoadEvent(e,t){let cancel=()=>{throw new Error("waitForLoadEvent.cancel() called before it was defined")};return{promise:new Promise(((n,i)=>{let a;const loadListener=function(){a=setTimeout(n,t)};e.once("Page.loadEventFired",loadListener);let s=!1;cancel=()=>{s||(s=!0,e.off("Page.loadEventFired",loadListener),a&&clearTimeout(a))}})),cancel}}const c={waitForFcp,waitForLoadEvent,waitForCPUIdle,waitForNetworkIdle};t.exports={waitForNothing,waitForFrameNavigated:function waitForFrameNavigated(e){let cancel=()=>{throw new Error("waitForFrameNavigated.cancel() called before it was defined")};return{promise:new Promise(((t,n)=>{e.once("Page.frameNavigated",t),cancel=()=>{
e.off("Page.frameNavigated",t),n(new Error("Wait for navigated cancelled"))}})),cancel}},waitForFcp,waitForLoadEvent,waitForNetworkIdle,waitForCPUIdle,waitForFullyLoaded:async function waitForFullyLoaded(e,t,n){const{pauseAfterFcpMs:s,pauseAfterLoadMs:l,networkQuietThresholdMs:u,cpuQuietThresholdMs:d,maxWaitForLoadedMs:m,maxWaitForFcpMs:p}=n,{waitForFcp:h,waitForLoadEvent:f,waitForNetworkIdle:g,waitForCPUIdle:y}=n._waitForTestOverrides||c;let b;const v=p?h(e,s,p):waitForNothing(),w=f(e,l),S=g(e,t,{networkQuietThresholdMs:u,busyEvent:"network-2-busy",idleEvent:"network-2-idle",isIdle:e=>e.is2Idle()}),T=g(e,t,{networkQuietThresholdMs:u,busyEvent:"network-critical-busy",idleEvent:"network-critical-idle",isIdle:e=>e.isCriticalIdle()});let E=waitForNothing();const _=Promise.all([v.promise,w.promise,S.promise,T.promise]).then((()=>(E=y(e,d),E.promise))).then((()=>async function(){return i.verbose("waitFor","loadEventFired and network considered idle"),{timedOut:!1}})).catch((e=>function(){
throw e})),x=new Promise(((e,t)=>{b=setTimeout(e,m)})).then((t=>async()=>{if(i.warn("waitFor","Timed out waiting for page load. Checking if page is hung..."),await async function isPageHung(e){try{return e.setNextProtocolTimeout(1e3),await e.sendCommand("Runtime.evaluate",{expression:'"ping"',returnByValue:!0,timeout:1e3}),!1}catch(e){return!0}}(e))throw i.warn("waitFor","Page appears to be hung, killing JavaScript..."),await e.sendCommand("Emulation.setScriptExecutionDisabled",{value:!0}),await e.sendCommand("Runtime.terminateExecution"),new a(a.errors.PAGE_HUNG);return{timedOut:!0}})),A=await Promise.race([_,x]);return b&&clearTimeout(b),v.cancel(),w.cancel(),S.cancel(),E.cancel(),A()},waitForUserToContinue:function waitForUserToContinue(e){return e.defaultSession.setNextProtocolTimeout(2**31-1),e.executionContext.evaluate((function createInPagePromise(){let resolve=()=>{};const e=new Promise((e=>resolve=e))
;return console.log(["You have enabled Lighthouse navigation debug mode.",'When you have finished inspecting the page, evaluate "continueLighthouseRun()"',"in the console to continue with the Lighthouse run."].join(" ")),window.continueLighthouseRun=resolve,e}),{args:[]})}}},{"../../lib/lh-error.js":103,"./execution-context.js":68,"lighthouse-logger":188}],77:[function(e,t,n){(function(n,i){(function(){"use strict";const a=e("lighthouse-logger"),{getBrowserVersion:s}=e("./driver/environment.js");t.exports=class Fetcher{constructor(e,t){this.session=e,this.executionContext=t,this._onRequestPausedHandlers=new Map,this._onRequestPaused=this._onRequestPaused.bind(this),this._enabled=!1}async enable(){this._enabled||(this._enabled=!0,await this.session.sendCommand("Fetch.enable",{patterns:[{requestStage:"Request"},{requestStage:"Response"}]}),await this.session.on("Fetch.requestPaused",this._onRequestPaused))}async disable(){this._enabled&&(this._enabled=!1,
await this.session.off("Fetch.requestPaused",this._onRequestPaused),await this.session.sendCommand("Fetch.disable"),this._onRequestPausedHandlers.clear())}async _setOnRequestPausedHandler(e,t){this._onRequestPausedHandlers.set(e,t)}_onRequestPaused(e){const t=this._onRequestPausedHandlers.get(e.request.url);t?t(e):this.session.sendCommand("Fetch.continueRequest",{requestId:e.requestId}).catch((e=>{a.error("Fetcher","Failed to continueRequest: "+e.message)}))}async shouldUseLegacyFetcher(){const{milestone:e}=await s(this.session);return e<92||Boolean(n.isLightrider)}async fetchResource(e,t={timeout:2e3}){if(!this._enabled)throw new Error("Must call `enable` before using fetchResource");return await this.shouldUseLegacyFetcher()?this._fetchResourceIframe(e,t):this._fetchResourceOverProtocol(e,t)}async _readIOStream(e,t={timeout:2e3}){const n=Date.now();let a,s="";for(;!a||!a.eof;){
if(Date.now()-n>t.timeout)throw new Error("Waiting for the end of the IO stream exceeded the allotted time.");a=await this.session.sendCommand("IO.read",{handle:e});const c=a.base64Encoded?i.from(a.data,"base64").toString("utf-8"):a.data;s=s.concat(c)}return s}async _loadNetworkResource(e){const t=await this.session.sendCommand("Page.getFrameTree"),n=await this.session.sendCommand("Network.loadNetworkResource",{frameId:t.frameTree.frame.id,url:e,options:{disableCache:!0,includeCredentials:!0}});return{stream:n.resource.success&&n.resource.stream||null,status:n.resource.httpStatusCode||null}}async _resolveResponseBody(e){const t=await this.session.sendCommand("Fetch.getResponseBody",{requestId:e});return t.base64Encoded?i.from(t.body,"base64").toString():t.body}async _fetchResourceOverProtocol(e,t){const n=Date.now();let i;const a=new Promise(((e,n)=>{i=setTimeout((()=>{n(new Error("Timed out fetching resource"))}),t.timeout)
})),s=this._loadNetworkResource(e),c=await Promise.race([s,a]).finally((()=>clearTimeout(i))),l=c.status&&c.status>=200&&c.status<=299;if(!c.stream||!l)return{status:c.status,content:null};const u=t.timeout-(Date.now()-n),d=await this._readIOStream(c.stream,{timeout:u});return{status:c.status,content:d}}async _fetchResourceIframe(e,t){const n=new Promise(((t,n)=>{const handlerAsync=async e=>{const{requestId:n,responseStatusCode:i}=e;if(i)t(i>=200&&i<=299?{status:i,content:await this._resolveResponseBody(n)}:{status:i,content:null}),await this.session.sendCommand("Fetch.failRequest",{requestId:n,errorReason:"Aborted"});else{const t=Object.entries(e.request.headers).filter((([e])=>"Cookie"!==e)).map((([e,t])=>({name:e,value:t})));await this.session.sendCommand("Fetch.continueRequest",{requestId:n,headers:t})}};this._setOnRequestPausedHandler(e,(e=>handlerAsync(e).catch(n)))}));let i;const a=new Promise(((e,n)=>{i=setTimeout((()=>n(new Error("Timed out fetching resource."))),t.timeout)
})),s=Promise.race([a,n]).finally((()=>clearTimeout(i)));await this.session.sendCommand("Target.setAutoAttach",{autoAttach:!1,waitForDebuggerOnStart:!1});const c=this.executionContext.evaluate((function injectIframe(e){const t=document.createElement("iframe");t.style.display="none",t.style.visibility="hidden",t.style.position="absolute",t.style.top="-1000px",t.style.left="-1000px",t.style.width="1px",t.style.height="1px",t.src=e,t.onload=t.onerror=()=>{t.remove(),t.onload=null,t.onerror=null},document.body.appendChild(t)}),{args:[e],useIsolation:!0}),[l]=await Promise.all([s,c]);return await this.session.sendCommand("Target.setAutoAttach",{flatten:!0,autoAttach:!0,waitForDebuggerOnStart:!0}),l}}}).call(this)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{},e("buffer").Buffer)},{"./driver/environment.js":67,buffer:145,"lighthouse-logger":188}],78:[function(e,t,n){"use strict"
;const i=e("lighthouse-logger"),a=e("../computed/network-records.js"),{getPageLoadError:s}=e("../lib/navigation-error.js"),c=e("../lib/emulation.js"),l=e("../config/constants.js"),u=e("../lib/i18n/i18n.js"),{getBenchmarkIndex:d,getEnvironmentWarnings:m}=e("./driver/environment.js"),p=e("./driver/prepare.js"),h=e("./driver/storage.js"),f=e("./driver/navigation.js"),g=e("./driver/service-workers.js"),y=e("./gatherers/web-app-manifest.js"),b=e("./gatherers/installability-errors.js"),v=e("./gatherers/network-user-agent.js"),w=e("./gatherers/stacks.js"),{finalizeArtifacts:S}=e("../fraggle-rock/gather/base-artifacts.js");class GatherRunner{static async loadBlank(e,t=l.defaultPassConfig.blankPage){const n={msg:"Resetting state with about:blank",id:"lh:gather:loadBlank"};i.time(n),await f.gotoURL(e,t,{waitUntil:["navigated"]}),i.timeEnd(n)}static async loadPage(e,t){const n={msg:"Loading page & waiting for onload",id:"lh:gather:loadPage-"+t.passConfig.passName};i.time(n);try{
const a=t.url,{finalUrl:s,warnings:c}=await f.gotoURL(e,a,{waitUntil:t.passConfig.recordTrace?["load","fcp"]:["load"],debugNavigation:t.settings.debugNavigation,maxWaitForFcp:t.settings.maxWaitForFcp,maxWaitForLoad:t.settings.maxWaitForLoad,...t.passConfig});t.url=s,"fatal"===t.passConfig.loadFailureMode&&t.LighthouseRunWarnings.push(...c)}catch(e){if("NO_FCP"===e.code||"PAGE_HUNG"===e.code)return{navigationError:e};throw e}finally{i.timeEnd(n)}return{}}static assertNoSameOriginServiceWorkerClients(e,t){let n,i;return g.getServiceWorkerRegistrations(e).then((e=>{n=e.registrations})).then((t=>g.getServiceWorkerVersions(e))).then((e=>{i=e.versions})).then((e=>{const a=new URL(t).origin;n.filter((e=>{const t=new URL(e.scopeURL).origin;return a===t})).forEach((e=>{i.forEach((t=>{if(t.registrationId===e.registrationId&&t.controlledClients&&t.controlledClients.length>0)throw new Error("You probably have multiple tabs open to the same origin.")}))}))}))}static async setupDriver(e,t){const n={
msg:"Initializing…",id:"lh:gather:setupDriver"};i.time(n);const a=e.defaultSession;await GatherRunner.assertNoSameOriginServiceWorkerClients(a,t.requestedUrl),await p.prepareTargetForNavigationMode(e,t.settings),i.timeEnd(n)}static async disposeDriver(e,t){const n={msg:"Disconnecting from browser...",id:"lh:gather:disconnect"};i.time(n);try{const n=e.defaultSession;!t.settings.disableStorageReset&&await h.clearDataForOrigin(n,t.requestedUrl),await e.fetcher.disable(),await e.disconnect()}catch(e){/close\/.*status: (500|404)$/.test(e.message)||i.error("GatherRunner disconnect",e.message)}i.timeEnd(n)}static async beginRecording(e){const t={msg:"Beginning devtoolsLog and trace",id:"lh:gather:beginRecording"};i.time(t);const{driver:n,passConfig:a,settings:s}=e;await n.beginDevtoolsLog(),a.recordTrace&&await n.beginTrace(s),i.timeEnd(t)}static async endRecording(e){const{driver:t,passConfig:n}=e;let s;if(n.recordTrace){const e={msg:"Gathering trace",id:"lh:gather:getTrace"};i.time(e),
s=await t.endTrace(),i.timeEnd(e)}const c={msg:"Gathering devtoolsLog & network records",id:"lh:gather:getDevtoolsLog"};i.time(c);const l=t.endDevtoolsLog(),u=await a.request(l,e);return i.timeEnd(c),{networkRecords:u,devtoolsLog:l,trace:s}}static async beforePass(e,t){const n={msg:"Running beforePass methods",id:"lh:gather:beforePass"};i.time(n,"verbose");for(const n of e.passConfig.gatherers){const a=n.instance,s={msg:"Gathering setup: "+a.name,id:"lh:gather:beforePass:"+a.name};i.time(s,"verbose");const c=Promise.resolve().then((t=>a.beforePass(e)));t[a.name]=[c],await c.catch((()=>{})),i.timeEnd(s)}i.timeEnd(n)}static async pass(e,t){const n=e.passConfig.gatherers,a={msg:"Running pass methods",id:"lh:gather:pass"};i.time(a,"verbose");for(const a of n){const n=a.instance,s={msg:"Gathering in-page: "+n.name,id:"lh:gather:pass:"+n.name};i.time(s);const c=Promise.resolve().then((t=>n.pass(e))),l=t[n.name]||[];l.push(c),t[n.name]=l,await c.catch((()=>{}))}i.timeEnd(a)}
static async afterPass(e,t,n){const a=e.driver,s=e.passConfig.gatherers,c={msg:"Running afterPass methods",id:"lh:gather:afterPass"};i.time(c,"verbose");const l=await a.getScrollPosition();for(const c of s){const s=c.instance,u={msg:"Gathering: "+s.name,id:"lh:gather:afterPass:"+s.name};i.time(u);const d=Promise.resolve().then((n=>s.afterPass(e,t))),m=n[s.name]||[];m.push(d),n[s.name]=m,await d.catch((()=>{})),await a.scrollTo(l),i.timeEnd(u)}i.timeEnd(c)}static async collectArtifacts(e){const t={},n=Object.entries(e);for(const[e,i]of n){try{const n=(await Promise.all(i)).filter((e=>void 0!==e)),a=n[n.length-1];t[e]=a}catch(n){t[e]=n}if(void 0===t[e])throw new Error(e+" failed to provide an artifact.")}return{artifacts:t}}static async initializeBaseArtifacts(e){const t=(await e.driver.getBrowserVersion()).userAgent,n=t.includes("Android")||t.includes("Mobile")?"mobile":"desktop";return{fetchTime:(new Date).toJSON(),LighthouseRunWarnings:[],HostFormFactor:n,HostUserAgent:t,
NetworkUserAgent:"",BenchmarkIndex:0,WebAppManifest:null,InstallabilityErrors:{errors:[]},Stacks:[],traces:{},devtoolsLogs:{},settings:e.settings,GatherContext:{gatherMode:"navigation"},URL:{requestedUrl:e.requestedUrl,finalUrl:e.requestedUrl},Timing:[],PageLoadError:null}}static async populateBaseArtifacts(e){const t={msg:"Populate base artifacts",id:"lh:gather:populateBaseArtifacts"};i.time(t);const n=e.baseArtifacts;n.URL.finalUrl=e.url,n.WebAppManifest=await y.getWebAppManifest(e.driver.defaultSession,e.url),n.WebAppManifest&&(n.InstallabilityErrors=await b.getInstallabilityErrors(e.driver.defaultSession)),n.Stacks=await w.collectStacks(e.driver.executionContext);const a=n.devtoolsLogs[e.passConfig.passName];n.NetworkUserAgent=v.getNetworkUserAgent(a);const s=m(e);n.LighthouseRunWarnings.push(...s),i.timeEnd(t)}static async run(e,t){const n=t.driver,i={};try{await n.connect(),await GatherRunner.loadBlank(n);const a=await GatherRunner.initializeBaseArtifacts(t)
;a.BenchmarkIndex=await d(n.executionContext),await GatherRunner.setupDriver(n,t);let s=!0;for(const c of e){const e={gatherMode:"navigation",driver:n,url:t.requestedUrl,settings:t.settings,passConfig:c,baseArtifacts:a,computedCache:t.computedCache,LighthouseRunWarnings:a.LighthouseRunWarnings},l=await GatherRunner.runPass(e);if(Object.assign(i,l.artifacts),l.pageLoadError&&"fatal"===c.loadFailureMode){a.PageLoadError=l.pageLoadError;break}s&&(await GatherRunner.populateBaseArtifacts(e),s=!1),await n.fetcher.disable()}return await GatherRunner.disposeDriver(n,t),S(a,i)}catch(e){throw GatherRunner.disposeDriver(n,t),e}}static _addLoadDataToBaseArtifacts(e,t,n){const i=e.baseArtifacts;i.devtoolsLogs[n]=t.devtoolsLog,t.trace&&(i.traces[n]=t.trace)}static async runPass(e){const t={msg:`Running ${e.passConfig.passName} pass`,id:"lh:gather:runPass-"+e.passConfig.passName,args:[e.passConfig.gatherers.map((e=>e.instance.name)).join(", ")]};i.time(t);const n={},{driver:a,passConfig:l}=e
;await GatherRunner.loadBlank(a,l.blankPage);const{warnings:d}=await p.prepareTargetForIndividualNavigation(a.defaultSession,e.settings,{url:e.url,disableStorageReset:!l.useThrottling,disableThrottling:!l.useThrottling,blockedUrlPatterns:l.blockedUrlPatterns});e.LighthouseRunWarnings.push(...d),await GatherRunner.beforePass(e,n),await GatherRunner.beginRecording(e);const{navigationError:m}=await GatherRunner.loadPage(a,e);await GatherRunner.pass(e,n);const h=await GatherRunner.endRecording(e);await c.clearThrottling(a.defaultSession);const f=s(m,{url:e.url,loadFailureMode:l.loadFailureMode,networkRecords:h.networkRecords});if(f){const n=u.getFormatted(f.friendlyMessage,e.settings.locale);return i.error("GatherRunner",n,e.url),e.LighthouseRunWarnings.push(f.friendlyMessage),GatherRunner._addLoadDataToBaseArtifacts(e,h,"pageLoadError-"+l.passName),i.timeEnd(t),{artifacts:{},pageLoadError:f}}GatherRunner._addLoadDataToBaseArtifacts(e,h,l.passName),await GatherRunner.afterPass(e,h,n)
;const g=GatherRunner.collectArtifacts(n);return i.timeEnd(t),g}}t.exports=GatherRunner},{"../computed/network-records.js":40,"../config/constants.js":56,"../fraggle-rock/gather/base-artifacts.js":60,"../lib/emulation.js":97,"../lib/i18n/i18n.js":98,"../lib/navigation-error.js":107,"./driver/environment.js":67,"./driver/navigation.js":69,"./driver/prepare.js":72,"./driver/service-workers.js":73,"./driver/storage.js":74,"./gatherers/installability-errors.js":"../gather/gatherers/installability-errors","./gatherers/network-user-agent.js":"../gather/gatherers/network-user-agent","./gatherers/stacks.js":"../gather/gatherers/stacks","./gatherers/web-app-manifest.js":"../gather/gatherers/web-app-manifest","lighthouse-logger":188}],79:[function(e,t,n){"use strict";t.exports=class Gatherer{get name(){return this.constructor.name}beforePass(e){}pass(e){}afterPass(e,t){}}},{}],80:[function(e,t,n){"use strict"
;const i=e("./runner.js"),a=e("lighthouse-logger"),s=e("./gather/connections/cri.js"),c=e("./config/config.js");async function lighthouse(e,t={},n,c){t.logLevel=t.logLevel||"error",a.setLevel(t.logLevel);const l={url:e,config:generateConfig(n,t),computedCache:new Map},u=c||new s(t.port,t.hostname);return i.run((({requestedUrl:e})=>i._gatherArtifactsFromBrowser(e,l,u)),l)}function generateConfig(e,t){return new c(e,t)}lighthouse.generateConfig=generateConfig,lighthouse.getAuditList=i.getAuditList,lighthouse.traceCategories=e("./gather/driver.js").traceCategories,lighthouse.Audit=e("./audits/audit.js"),lighthouse.Gatherer=e("./gather/gatherers/gatherer.js"),lighthouse.NetworkRecords=e("./computed/network-records.js"),t.exports=lighthouse},{"./audits/audit.js":3,"./computed/network-records.js":40,"./config/config.js":55,"./gather/connections/cri.js":144,"./gather/driver.js":65,"./gather/gatherers/gatherer.js":79,"./runner.js":122,"lighthouse-logger":188}],81:[function(e,t,n){"use strict"
;const i=e("lodash.isequal");class ArbitraryEqualityMap{constructor(){this._equalsFn=ArbitraryEqualityMap.deepEquals,this._entries=[]}setEqualityFn(e){this._equalsFn=e}has(e){return-1!==this._findIndexOf(e)}get(e){const t=this._entries[this._findIndexOf(e)];return t&&t.value}set(e,t){let n=this._findIndexOf(e);-1===n&&(n=this._entries.length),this._entries[n]={key:e,value:t}}_findIndexOf(e){for(let t=0;t<this._entries.length;t++)if(this._equalsFn(e,this._entries[t].key))return t;return-1}static deepEquals(e,t){return i(e,t)}}t.exports=ArbitraryEqualityMap},{"lodash.isequal":217}],82:[function(e,t,n){(function(n){(function(){"use strict"
;const i=e("fs"),a=e("path"),s=e("lighthouse-logger"),c=e("stream"),{promisify:l}=e("util"),u=e("./dependency-graph/simulator/simulator.js"),d=e("./lantern-trace-saver.js"),m=e("./traces/pwmetrics-events.js"),p=e("../computed/network-analysis.js"),h=e("../computed/load-simulator.js"),f=e("../lib/lh-error.js"),g=l(c.pipeline),y="artifacts.json",b=".trace.json",v=".devtoolslog.json";function stringifyReplacer(e,t){return t instanceof Error?f.stringifyReplacer(t):t}async function prepareAssets(e,t){const n=Object.keys(e.traces),i=[];for(const a of n){const n=e.traces[a],s=e.devtoolsLogs[a],c=Object.assign({},n);if(t){const e=new m(c.traceEvents,t).generateFakeEvents();c.traceEvents=c.traceEvents.concat(e)}i.push({passName:a,traceData:c,devtoolsLog:s})}return i}function*arrayOfObjectsJsonGenerator(e){if(yield"[\n",e.length>0){const t=e[Symbol.iterator](),n=t.next().value;yield"  "+JSON.stringify(n);let i=500,a="";for(const e of t)a+=",\n  "+JSON.stringify(e),i--,0===i&&(yield a,i=500,a="")
;yield a}yield"\n]"}async function saveTrace(e,t){const n=function*traceJsonGenerator(e){const{traceEvents:t,...n}=e;yield"{\n",yield'"traceEvents": ',yield*arrayOfObjectsJsonGenerator(t);for(const[e,t]of Object.entries(n))yield`,\n"${e}": ${JSON.stringify(t,null,2)}`;yield"}\n"}(e),a=i.createWriteStream(t);return g(c.Readable.from(n),a)}function saveDevtoolsLog(e,t){const n=arrayOfObjectsJsonGenerator(e),a=i.createWriteStream(t);return g(c.Readable.from(n),a)}t.exports={saveArtifacts:async function saveArtifacts(e,t){const n={msg:"Saving artifacts",id:"lh:assetSaver:saveArtifacts"};s.time(n),i.mkdirSync(t,{recursive:!0});const a=i.readdirSync(t);for(const e of a)(e.endsWith(b)||e.endsWith(v)||e===y)&&i.unlinkSync(`${t}/${e}`);const{traces:c,devtoolsLogs:l,...u}=e;for(const[e,n]of Object.entries(c))await saveTrace(n,`${t}/${e}.trace.json`);for(const[e,n]of Object.entries(l))await saveDevtoolsLog(n,`${t}/${e}.devtoolslog.json`);const d=JSON.stringify(u,stringifyReplacer,2)+"\n"
;i.writeFileSync(t+"/artifacts.json",d,"utf8"),s.log("Artifacts saved to disk in folder:",t),s.timeEnd(n)},saveLhr:function saveLhr(e,t){i.writeFileSync(t+"/lhr.report.json",JSON.stringify(e,null,2))},loadArtifacts:function loadArtifacts(e){if(s.log("Reading artifacts from disk:",e),!i.existsSync(e))throw new Error("No saved artifacts found at "+e);const t=i.readFileSync(a.join(e,y),"utf8"),n=JSON.parse(t,f.parseReviver),c=i.readdirSync(e);return n.devtoolsLogs={},c.filter((e=>e.endsWith(v))).forEach((t=>{const s=t.replace(v,""),c=JSON.parse(i.readFileSync(a.join(e,t),"utf8"));n.devtoolsLogs[s]=c})),n.traces={},c.filter((e=>e.endsWith(b))).forEach((t=>{const s=i.readFileSync(a.join(e,t),{encoding:"utf-8"}),c=JSON.parse(s),l=t.replace(b,"");n.traces[l]=Array.isArray(c)?{traceEvents:c}:c})),Array.isArray(n.Timing)&&n.Timing.forEach((e=>e.gather=!0)),n},saveAssets:async function saveAssets(e,t,a){const c=(await prepareAssets(e,t)).map((async(e,t)=>{const n=`${a}-${t}.devtoolslog.json`
;i.writeFileSync(n,JSON.stringify(e.devtoolsLog,null,2)),s.log("saveAssets","devtools log saved to disk: "+n);const c=`${a}-${t}.trace.json`;s.log("saveAssets","streaming trace file to disk: "+c),await saveTrace(e.traceData,c),s.log("saveAssets","trace file streamed to disk: "+c)}));await Promise.all(c),await async function saveLanternDebugTraces(e){if(n.env.LANTERN_DEBUG)for(const[t,n]of u.ALL_NODE_TIMINGS){if(d.simulationNamesToIgnore.includes(t))continue;const i=`${e}-${t}.trace.json`;await saveTrace(d.convertNodeTimingsToTrace(n),i),s.log("saveAssets",`${t} lantern trace file streamed to disk: ${i}`)}}(a)},prepareAssets,saveTrace,saveDevtoolsLog,saveLanternNetworkData:async function saveLanternNetworkData(e,t){const n={computedCache:new Map},a=await p.request(e,n),s=h.convertAnalysisToSaveableLanternData(a);i.writeFileSync(t,JSON.stringify(s))},stringifyReplacer}}).call(this)}).call(this,e("_process"))},{"../computed/load-simulator.js":13,"../computed/network-analysis.js":39,
"../lib/lh-error.js":103,"./dependency-graph/simulator/simulator.js":95,"./lantern-trace-saver.js":101,"./traces/pwmetrics-events.js":120,_process:223,fs:144,"lighthouse-logger":188,path:222,stream:234,util:257}],83:[function(e,t,n){"use strict";t.exports={
source:'/*! axe v4.2.3\n * Copyright (c) 2021 Deque Systems, Inc.\n *\n * Your use of this Source Code Form is subject to the terms of the Mozilla Public\n * License, v. 2.0. If a copy of the MPL was not distributed with this\n * file, You can obtain one at http://mozilla.org/MPL/2.0/.\n *\n * This entire copyright notice must appear in every copy of this file you\n * distribute or in any file that contains substantial portions of this source\n * code.\n */\n!function e(t){var a=t,r=t.document;function n(e){return(n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}var o=o||{};function i(e){this.name="SupportError",this.cause=e.cause,this.message="`".concat(e.cause,"` - feature unsupported in your environment."),e.ruleId&&(this.ruleId=e.ruleId,this.message+=" Skipping ".concat(this.ruleId," rule.")),this.stack=(new Error).stack}o.version="4.2.3","function"==typeof define&&define.amd&&define("axe-core",[],(function(){return o})),"object"===("undefined"==typeof module?"undefined":n(module))&&module.exports&&"function"==typeof e.toString&&(o.source="("+e.toString()+\')(typeof window === "object" ? window : this);\',module.exports=o),"function"==typeof t.getComputedStyle&&(t.axe=o),(i.prototype=Object.create(Error.prototype)).constructor=i;var l=["variant"],s=["matches"],u=["chromium"],c=["noImplicit"],d=["noPresentational"];function p(e,t){if(null==e)return{};var a,r=function(e,t){if(null==e)return{};var a,r,n={},o=Object.keys(e);for(r=0;r<o.length;r++)a=o[r],0<=t.indexOf(a)||(n[a]=e[a]);return n}(e,t);if(Object.getOwnPropertySymbols)for(var n=Object.getOwnPropertySymbols(e),o=0;o<n.length;o++)a=n[o],0<=t.indexOf(a)||Object.prototype.propertyIsEnumerable.call(e,a)&&(r[a]=e[a]);return r}function f(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),t&&m(e,t)}function m(e,t){return(m=Object.setPrototypeOf||function(e,t){return e.__proto__=t,e})(e,t)}function h(e){var t=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var a,r=b(e);return a=t?(a=b(this).constructor,Reflect.construct(r,arguments,a)):r.apply(this,arguments),r=this,!(a=a)||"object"!==n(a)&&"function"!=typeof a?g(r):a}}function g(e){if(void 0===e)throw new ReferenceError("this hasn\'t been initialised - super() hasn\'t been called");return e}function b(e){return(b=Object.setPrototypeOf?Object.getPrototypeOf:function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function y(e){return function(e){if(Array.isArray(e))return F(e)}(e)||function(e){if("undefined"!=typeof Symbol&&null!=e[Symbol.iterator]||null!=e["@@iterator"])return Array.from(e)}(e)||C(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function v(e,t){return function(e){if(Array.isArray(e))return e}(e)||function(e,t){var a=null==e?null:"undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(null!=a){var r,n,o=[],i=!0,l=!1;try{for(a=a.call(e);!(i=(r=a.next()).done)&&(o.push(r.value),!t||o.length!==t);i=!0);}catch(e){l=!0,n=e}finally{try{i||null==a.return||a.return()}finally{if(l)throw n}}return o}}(e,t)||C(e,t)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function D(){return(D=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var a,r=arguments[t];for(a in r)Object.prototype.hasOwnProperty.call(r,a)&&(e[a]=r[a])}return e}).apply(this,arguments)}function w(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function x(e,t){for(var a=0;a<t.length;a++){var r=t[a];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function E(e,t,a){return t&&x(e.prototype,t),a&&x(e,a),e}function A(e,t){var a="undefined"!=typeof Symbol&&e[Symbol.iterator]||e["@@iterator"];if(!a){if(Array.isArray(e)||(a=C(e))||t&&e&&"number"==typeof e.length){a&&(e=a);var r=0;return{s:t=function(){},n:function(){return r>=e.length?{done:!0}:{done:!1,value:e[r++]}},e:function(e){throw e},f:t}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var n,o=!0,i=!1;return{s:function(){a=a.call(e)},n:function(){var e=a.next();return o=e.done,e},e:function(e){i=!0,n=e},f:function(){try{o||null==a.return||a.return()}finally{if(i)throw n}}}}function C(e,t){if(e){if("string"==typeof e)return F(e,t);var a=Object.prototype.toString.call(e).slice(8,-1);return"Map"===(a="Object"===a&&e.constructor?e.constructor.name:a)||"Set"===a?Array.from(e):"Arguments"===a||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a)?F(e,t):void 0}}function F(e,t){(null==t||t>e.length)&&(t=e.length);for(var a=0,r=new Array(t);a<t;a++)r[a]=e[a];return r}function n(e){return(n="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}!function(){function e(e){return x(e,"__esModule",{value:!0})}function m(t,a,r){if(e(t),"object"===n(a)||"function"==typeof a){var o,i=A(k(a));try{for(i.s();!(o=i.n()).done;)!function(){var e=o.value;F.call(t,e)||"default"===e||x(t,e,{get:function(){return a[e]},enumerable:!(r=R(a,e))||r.enumerable})}()}catch(e){i.e(e)}finally{i.f()}}return t}var b=Object.create,x=Object.defineProperty,C=Object.getPrototypeOf,F=Object.prototype.hasOwnProperty,k=Object.getOwnPropertyNames,R=Object.getOwnPropertyDescriptor,T=function(e,t){return function(){return t||e((t={exports:{}}).exports,t),t.exports}},N=function(t,a){for(var r in e(t),a)x(t,r,{get:a[r],enumerable:!0})},_=function(e){return e&&e.__esModule?e:m(x(b(C(e)),"default",{value:e,enumerable:!0}),e)},O=T((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isIdentStart=function(e){return"a"<=e&&e<="z"||"A"<=e&&e<="Z"||"-"===e||"_"===e},e.isIdent=function(e){return"a"<=e&&e<="z"||"A"<=e&&e<="Z"||"0"<=e&&e<="9"||"-"===e||"_"===e},e.isHex=function(e){return"a"<=e&&e<="f"||"A"<=e&&e<="F"||"0"<=e&&e<="9"},e.escapeIdentifier=function(t){for(var a=t.length,r="",n=0;n<a;){var o=t.charAt(n);if(e.identSpecialChars[o])r+="\\\\"+o;else if("_"===o||"-"===o||"A"<=o&&o<="Z"||"a"<=o&&o<="z"||0!==n&&"0"<=o&&o<="9")r+=o;else{var i=o.charCodeAt(0);if(55296==(63488&i)){if(o=t.charCodeAt(n++),55296!=(64512&i)||56320!=(64512&o))throw Error("UCS-2(decode): illegal sequence");i=((1023&i)<<10)+(1023&o)+65536}r+="\\\\"+i.toString(16)+" "}n++}return r},e.escapeStr=function(t){for(var a,r=t.length,n="",o=0;o<r;){var i=t.charAt(o);\'"\'===i?i=\'\\\\"\':"\\\\"===i?i="\\\\\\\\":void 0!==(a=e.strReplacementsRev[i])&&(i=a),n+=i,o++}return\'"\'+n+\'"\'},e.identSpecialChars={"!":!0,\'"\':!0,"#":!0,$:!0,"%":!0,"&":!0,"\'":!0,"(":!0,")":!0,"*":!0,"+":!0,",":!0,".":!0,"/":!0,";":!0,"<":!0,"=":!0,">":!0,"?":!0,"@":!0,"[":!0,"\\\\":!0,"]":!0,"^":!0,"`":!0,"{":!0,"|":!0,"}":!0,"~":!0},e.strReplacementsRev={"\\n":"\\\\n","\\r":"\\\\r","\\t":"\\\\t","\\f":"\\\\f","\\v":"\\\\v"},e.singleQuoteEscapeChars={n:"\\n",r:"\\r",t:"\\t",f:"\\f","\\\\":"\\\\","\'":"\'"},e.doubleQuotesEscapeChars={n:"\\n",r:"\\r",t:"\\t",f:"\\f","\\\\":"\\\\",\'"\':\'"\'}})),S=T((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=O();e.parseCssSelector=function(e,a,r,n,o,i){var l=e.length,s="";function u(r,n){var o="";for(a++,s=e.charAt(a);a<l;){if(s===r)return a++,o;var i;if("\\\\"===s)if(a++,(s=e.charAt(a))===r)o+=r;else if(void 0!==(i=n[s]))o+=i;else{if(t.isHex(s)){var u=s;for(a++,s=e.charAt(a);t.isHex(s);)u+=s,a++,s=e.charAt(a);" "===s&&(a++,s=e.charAt(a)),o+=String.fromCharCode(parseInt(u,16));continue}o+=s}else o+=s;a++,s=e.charAt(a)}return o}function c(){var r="";for(s=e.charAt(a);a<l;){if(t.isIdent(s))r+=s;else{if("\\\\"!==s)return r;if(l<=++a)throw Error("Expected symbol but end of file reached.");if(s=e.charAt(a),t.identSpecialChars[s])r+=s;else{if(t.isHex(s)){var n=s;for(a++,s=e.charAt(a);t.isHex(s);)n+=s,a++,s=e.charAt(a);" "===s&&(a++,s=e.charAt(a)),r+=String.fromCharCode(parseInt(n,16));continue}r+=s}}a++,s=e.charAt(a)}return r}function d(){s=e.charAt(a);for(var t=!1;" "===s||"\\t"===s||"\\n"===s||"\\r"===s||"\\f"===s;)t=!0,a++,s=e.charAt(a);return t}function p(){var t=f();if(!t)return null;var r=t;for(s=e.charAt(a);","===s;){if(a++,d(),"selectors"!==r.type&&(r={type:"selectors",selectors:[t]}),!(t=f()))throw Error(\'Rule expected after ",".\');r.selectors.push(t)}return r}function f(){d();var t={type:"ruleSet"},r=m();if(!r)return null;for(var n=t;r&&(r.type="rule",n.rule=r,n=r,d(),s=e.charAt(a),!(l<=a||","===s||")"===s));)if(o[s]){var i=s;if(a++,d(),!(r=m()))throw Error(\'Rule expected after "\'+i+\'".\');r.nestingOperator=i}else(r=m())&&(r.nestingOperator=null);return t}function m(){for(var o=null;a<l;)if("*"===(s=e.charAt(a)))a++,(o=o||{}).tagName="*";else if(t.isIdentStart(s)||"\\\\"===s)(o=o||{}).tagName=c();else if("."===s)a++,((o=o||{}).classNames=o.classNames||[]).push(c());else if("#"===s)a++,(o=o||{}).id=c();else if("["===s){a++,d();var f={name:c()};if(d(),"]"===s)a++;else{var m="";if(n[s]&&(m=s,a++,s=e.charAt(a)),l<=a)throw Error(\'Expected "=" but end of file reached.\');if("="!==s)throw Error(\'Expected "=" but "\'+s+\'" found.\');f.operator=m+"=",a++,d();var h="";if(f.valueType="string",\'"\'===s)h=u(\'"\',t.doubleQuotesEscapeChars);else if("\'"===s)h=u("\'",t.singleQuoteEscapeChars);else if(i&&"$"===s)a++,h=c(),f.valueType="substitute";else{for(;a<l&&"]"!==s;)h+=s,a++,s=e.charAt(a);h=h.trim()}if(d(),l<=a)throw Error(\'Expected "]" but end of file reached.\');if("]"!==s)throw Error(\'Expected "]" but "\'+s+\'" found.\');a++,f.value=h}((o=o||{}).attrs=o.attrs||[]).push(f)}else{if(":"!==s)break;if(a++,f={name:m=c()},"("===s){a++;var g="";if(d(),"selector"===r[m])f.valueType="selector",g=p();else{if(f.valueType=r[m]||"string",\'"\'===s)g=u(\'"\',t.doubleQuotesEscapeChars);else if("\'"===s)g=u("\'",t.singleQuoteEscapeChars);else if(i&&"$"===s)a++,g=c(),f.valueType="substitute";else{for(;a<l&&")"!==s;)g+=s,a++,s=e.charAt(a);g=g.trim()}d()}if(l<=a)throw Error(\'Expected ")" but end of file reached.\');if(")"!==s)throw Error(\'Expected ")" but "\'+s+\'" found.\');a++,f.value=g}((o=o||{}).pseudos=o.pseudos||[]).push(f)}return o}return function(){var t=p();if(a<l)throw Error(\'Rule expected but "\'+e.charAt(a)+\'" found.\');return t}()}})),P=T((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=O();e.renderEntity=function e(a){var r="";switch(a.type){case"ruleSet":for(var n=a.rule,o=[];n;)n.nestingOperator&&o.push(n.nestingOperator),o.push(e(n)),n=n.rule;r=o.join(" ");break;case"selectors":r=a.selectors.map(e).join(", ");break;case"rule":a.tagName&&(r="*"===a.tagName?"*":t.escapeIdentifier(a.tagName)),a.id&&(r+="#"+t.escapeIdentifier(a.id)),a.classNames&&(r+=a.classNames.map((function(e){return"."+t.escapeIdentifier(e)})).join("")),a.attrs&&(r+=a.attrs.map((function(e){return"operator"in e?"substitute"===e.valueType?"["+t.escapeIdentifier(e.name)+e.operator+"$"+e.value+"]":"["+t.escapeIdentifier(e.name)+e.operator+t.escapeStr(e.value)+"]":"["+t.escapeIdentifier(e.name)+"]"})).join("")),a.pseudos&&(r+=a.pseudos.map((function(a){return a.valueType?"selector"===a.valueType?":"+t.escapeIdentifier(a.name)+"("+e(a.value)+")":"substitute"===a.valueType?":"+t.escapeIdentifier(a.name)+"($"+a.value+")":"numeric"===a.valueType?":"+t.escapeIdentifier(a.name)+"("+a.value+")":":"+t.escapeIdentifier(a.name)+"("+t.escapeIdentifier(a.value)+")":":"+t.escapeIdentifier(a.name)})).join(""));break;default:throw Error(\'Unknown entity type: "\'+a.type+\'".\')}return r}})),I=T((function(e){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t=S(),a=P(),r=(n.prototype.registerSelectorPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];this.pseudos[n]="selector"}return this},n.prototype.unregisterSelectorPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];delete this.pseudos[n]}return this},n.prototype.registerNumericPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];this.pseudos[n]="numeric"}return this},n.prototype.unregisterNumericPseudos=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];delete this.pseudos[n]}return this},n.prototype.registerNestingOperators=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];this.ruleNestingOperators[n]=!0}return this},n.prototype.unregisterNestingOperators=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];delete this.ruleNestingOperators[n]}return this},n.prototype.registerAttrEqualityMods=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];this.attrEqualityMods[n]=!0}return this},n.prototype.unregisterAttrEqualityMods=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];for(var a=0,r=e;a<r.length;a++){var n=r[a];delete this.attrEqualityMods[n]}return this},n.prototype.enableSubstitutes=function(){return this.substitutesEnabled=!0,this},n.prototype.disableSubstitutes=function(){return this.substitutesEnabled=!1,this},n.prototype.parse=function(e){return t.parseCssSelector(e,0,this.pseudos,this.attrEqualityMods,this.ruleNestingOperators,this.substitutesEnabled)},n.prototype.render=function(e){return a.renderEntity(e).trim()},n);function n(){this.pseudos={},this.attrEqualityMods={},this.ruleNestingOperators={},this.substitutesEnabled=!1}e.CssSelectorParser=r})),B=T((function(e,t){"use strict";t.exports=function(){}})),L=T((function(e,t){"use strict";var a=B()();t.exports=function(e){return e!==a&&null!==e}})),q=T((function(e,t){"use strict";var a=L(),r=Array.prototype.forEach,n=Object.create;t.exports=function(e){var t=n(null);return r.call(arguments,(function(e){a(e)&&function(e,t){for(var a in e)t[a]=e[a]}(Object(e),t)})),t}})),M=T((function(e,t){"use strict";t.exports=function(){var e=Math.sign;return"function"==typeof e&&1===e(10)&&-1===e(-20)}})),j=T((function(e,t){"use strict";t.exports=function(e){return e=Number(e),isNaN(e)||0===e?e:0<e?1:-1}})),U=T((function(e,t){"use strict";t.exports=M()()?Math.sign:j()})),V=T((function(e,t){"use strict";var a=U(),r=Math.abs,n=Math.floor;t.exports=function(e){return isNaN(e)?0:0!==(e=Number(e))&&isFinite(e)?a(e)*n(r(e)):e}})),H=T((function(e,t){"use strict";var a=V(),r=Math.max;t.exports=function(e){return r(0,a(e))}})),z=T((function(e,t){"use strict";var a=H();t.exports=function(e,t,r){return isNaN(e)?0<=t?r&&t?t-1:t:1:!1!==e&&a(e)}})),$=T((function(e,t){"use strict";t.exports=function(e){if("function"!=typeof e)throw new TypeError(e+" is not a function");return e}})),W=T((function(e,t){"use strict";var a=L();t.exports=function(e){if(!a(e))throw new TypeError("Cannot use null or undefined");return e}})),G=T((function(e,t){"use strict";var a=$(),r=W(),n=Function.prototype.bind,o=Function.prototype.call,i=Object.keys,l=Object.prototype.propertyIsEnumerable;t.exports=function(e,t){return function(s,u){var c,d=arguments[2],p=arguments[3];return s=Object(r(s)),a(u),c=i(s),p&&c.sort("function"==typeof p?n.call(p,s):void 0),"function"!=typeof e&&(e=c[e]),o.call(e,c,(function(e,a){return l.call(s,e)?o.call(u,d,s[e],e,s,a):t}))}}})),Y=T((function(e,t){"use strict";t.exports=G()("forEach")})),K=T((function(){})),X=T((function(e,t){"use strict";t.exports=function(){var e=Object.assign;return"function"==typeof e&&(e(e={foo:"raz"},{bar:"dwa"},{trzy:"trzy"}),e.foo+e.bar+e.trzy==="razdwatrzy")}})),J=T((function(e,t){"use strict";t.exports=function(){try{return Object.keys("primitive"),!0}catch(e){return!1}}})),Q=T((function(e,t){"use strict";var a=L(),r=Object.keys;t.exports=function(e){return r(a(e)?Object(e):e)}})),Z=T((function(e,t){"use strict";t.exports=J()()?Object.keys:Q()})),ee=T((function(e,t){"use strict";var a=Z(),r=W(),n=Math.max;t.exports=function(e,t){var o,i,l,s=n(arguments.length,2);for(e=Object(r(e)),l=function(a){try{e[a]=t[a]}catch(a){o=o||a}},i=1;i<s;++i)a(t=arguments[i]).forEach(l);if(void 0!==o)throw o;return e}})),te=T((function(e,t){"use strict";t.exports=X()()?Object.assign:ee()})),ae=T((function(e,t){"use strict";var a=L(),r={function:!0,object:!0};t.exports=function(e){return a(e)&&r[n(e)]||!1}})),re=T((function(e,t){"use strict";var a=te(),r=ae(),n=L(),o=Error.captureStackTrace;t.exports=function(e){var i=new Error(e),l=arguments[1];return n(e=arguments[2])||r(l)&&(e=l,l=null),n(e)&&a(i,e),n(l)&&(i.code=l),o&&o(i,t.exports),i}})),ne=T((function(e,t){"use strict";var a=W(),r=Object.defineProperty,n=Object.getOwnPropertyDescriptor,o=Object.getOwnPropertyNames,i=Object.getOwnPropertySymbols;t.exports=function(e,t){var l,s=Object(a(t));if(e=Object(a(e)),o(s).forEach((function(a){try{r(e,a,n(t,a))}catch(a){l=a}})),"function"==typeof i&&i(s).forEach((function(a){try{r(e,a,n(t,a))}catch(a){l=a}})),void 0!==l)throw l;return e}})),oe=T((function(e,t){"use strict";function a(e,t){return t}var r,n,o,i,l,s=H();try{Object.defineProperty(a,"length",{configurable:!0,writable:!1,enumerable:!1,value:1})}catch(e){}1===a.length?(r={configurable:!0,writable:!1,enumerable:!1},n=Object.defineProperty,t.exports=function(e,t){return t=s(t),e.length===t?e:(r.value=t,n(e,"length",r))}):(i=ne(),l=[],o=function(e){var t,a=0;if(l[e])return l[e];for(t=[];e--;)t.push("a"+(++a).toString(36));return new Function("fn","return function ("+t.join(", ")+") { return fn.apply(this, arguments); };")},t.exports=function(e,t){if(t=s(t),e.length===t)return e;t=o(t)(e);try{i(t,e)}catch(e){}return t})})),ie=T((function(e,t){"use strict";t.exports=function(e){return null!=e}})),le=T((function(e,t){"use strict";var a=ie(),r={object:!0,function:!0,undefined:!0};t.exports=function(e){return!!a(e)&&hasOwnProperty.call(r,n(e))}})),se=T((function(e,t){"use strict";var a=le();t.exports=function(e){if(!a(e))return!1;try{return!!e.constructor&&e.constructor.prototype===e}catch(e){return!1}}})),ue=T((function(e,t){"use strict";var a=se();t.exports=function(e){if("function"!=typeof e)return!1;if(!hasOwnProperty.call(e,"length"))return!1;try{if("number"!=typeof e.length)return!1;if("function"!=typeof e.call)return!1;if("function"!=typeof e.apply)return!1}catch(e){return!1}return!a(e)}})),ce=T((function(e,t){"use strict";var a=ue(),r=/^\\s*class[\\s{/}]/,n=Function.prototype.toString;t.exports=function(e){return!!a(e)&&!r.test(n.call(e))}})),de=T((function(e,t){"use strict";var a="razdwatrzy";t.exports=function(){return"function"==typeof a.contains&&!0===a.contains("dwa")&&!1===a.contains("foo")}})),pe=T((function(e,t){"use strict";var a=String.prototype.indexOf;t.exports=function(e){return-1<a.call(this,e,arguments[1])}})),fe=T((function(e,t){"use strict";t.exports=de()()?String.prototype.contains:pe()})),me=T((function(e,t){"use strict";var a=ie(),r=ce(),n=te(),o=q(),i=fe();(t.exports=function(e,t){var r,l,s,u;return arguments.length<2||"string"!=typeof e?(s=t,t=e,e=null):s=arguments[2],a(e)?(r=i.call(e,"c"),l=i.call(e,"e"),u=i.call(e,"w")):l=!(r=u=!0),u={value:t,configurable:r,enumerable:l,writable:u},s?n(o(s),u):u}).gs=function(e,t,l){var s,u;return"string"!=typeof e?(u=l,l=t,t=e,e=null):u=arguments[3],a(t)?r(t)?a(l)?r(l)||(u=l,l=void 0):l=void 0:(u=t,t=l=void 0):t=void 0,e=a(e)?(s=i.call(e,"c"),i.call(e,"e")):!(s=!0),e={get:t,set:l,configurable:s,enumerable:e},u?n(o(u),e):e}})),he=T((function(e,t){"use strict";var a=me(),r=$(),o=Function.prototype.apply,i=Function.prototype.call,l=Object.create,s=Object.defineProperty,u=Object.defineProperties,c=Object.prototype.hasOwnProperty,d={configurable:!0,enumerable:!1,writable:!0},p=function(e,t){var a;return r(t),c.call(this,"__ee__")?a=this.__ee__:(a=d.value=l(null),s(this,"__ee__",d),d.value=null),a[e]?"object"===n(a[e])?a[e].push(t):a[e]=[a[e],t]:a[e]=t,this},f=function(e,t){var a,n;return r(t),p.call(n=this,e,a=function(){m.call(n,e,a),o.call(t,this,arguments)}),a.__eeOnceListener__=t,this},m=function(e,t){var a,o,i,l;if(r(t),!c.call(this,"__ee__"))return this;if(!(a=this.__ee__)[e])return this;if(o=a[e],"object"===n(o))for(l=0;i=o[l];++l)i!==t&&i.__eeOnceListener__!==t||(2===o.length?a[e]=o[l?0:1]:o.splice(l,1));else o!==t&&o.__eeOnceListener__!==t||delete a[e];return this},h=function(e){var t,a,r,l,s;if(c.call(this,"__ee__")&&(l=this.__ee__[e]))if("object"===n(l)){for(a=arguments.length,s=new Array(a-1),t=1;t<a;++t)s[t-1]=arguments[t];for(l=l.slice(),t=0;r=l[t];++t)o.call(r,this,s)}else switch(arguments.length){case 1:i.call(l,this);break;case 2:i.call(l,this,arguments[1]);break;case 3:i.call(l,this,arguments[1],arguments[2]);break;default:for(a=arguments.length,s=new Array(a-1),t=1;t<a;++t)s[t-1]=arguments[t];o.call(l,this,s)}},g={on:p,once:f,off:m,emit:h},b={on:a(p),once:a(f),off:a(m),emit:a(h)},y=u({},b);t.exports=e=function(e){return null==e?l(y):u(Object(e),b)},e.methods=g})),ge=T((function(e,t){"use strict";t.exports=function(){var e,t=Array.from;return"function"==typeof t&&(t=t(e=["raz","dwa"]),Boolean(t&&t!==e&&"dwa"===t[1]))}})),be=T((function(e,t){"use strict";t.exports=function(){return"object"===("undefined"==typeof globalThis?"undefined":n(globalThis))&&!!globalThis&&globalThis.Array===Array}})),ye=T((function(e,a){function r(){if("object"===("undefined"==typeof self?"undefined":n(self))&&self)return self;if("object"===(void 0===t?"undefined":n(t))&&t)return t;throw new Error("Unable to resolve global `this`")}a.exports=function(){if(this)return this;try{Object.defineProperty(Object.prototype,"__global__",{get:function(){return this},configurable:!0})}catch(e){return r()}try{return __global__||r()}finally{delete Object.prototype.__global__}}()})),ve=T((function(e,t){"use strict";t.exports=be()()?globalThis:ye()})),De=T((function(e,t){"use strict";var a=ve(),r={object:!0,symbol:!0};t.exports=function(){var e,t=a.Symbol;if("function"!=typeof t)return!1;e=t("test symbol");try{String(e)}catch(e){return!1}return!!r[n(t.iterator)]&&!!r[n(t.toPrimitive)]&&!!r[n(t.toStringTag)]}})),we=T((function(e,t){"use strict";t.exports=function(e){return!!e&&("symbol"===n(e)||!!e.constructor&&"Symbol"===e.constructor.name&&"Symbol"===e[e.constructor.toStringTag])}})),xe=T((function(e,t){"use strict";var a=we();t.exports=function(e){if(!a(e))throw new TypeError(e+" is not a symbol");return e}})),Ee=T((function(e,t){"use strict";var a=me(),r=Object.create,n=Object.defineProperty,o=Object.prototype,i=r(null);t.exports=function(e){for(var t,r,l=0;i[e+(l||"")];)++l;return i[e+=l||""]=!0,n(o,t="@@"+e,a.gs(null,(function(e){r||(r=!0,n(this,t,a(e)),r=!1)}))),t}})),Ae=T((function(e,t){"use strict";var a=me(),r=ve().Symbol;t.exports=function(e){return Object.defineProperties(e,{hasInstance:a("",r&&r.hasInstance||e("hasInstance")),isConcatSpreadable:a("",r&&r.isConcatSpreadable||e("isConcatSpreadable")),iterator:a("",r&&r.iterator||e("iterator")),match:a("",r&&r.match||e("match")),replace:a("",r&&r.replace||e("replace")),search:a("",r&&r.search||e("search")),species:a("",r&&r.species||e("species")),split:a("",r&&r.split||e("split")),toPrimitive:a("",r&&r.toPrimitive||e("toPrimitive")),toStringTag:a("",r&&r.toStringTag||e("toStringTag")),unscopables:a("",r&&r.unscopables||e("unscopables"))})}})),Ce=T((function(e,t){"use strict";var a=me(),r=xe(),n=Object.create(null);t.exports=function(e){return Object.defineProperties(e,{for:a((function(t){return n[t]||(n[t]=e(String(t)))})),keyFor:a((function(e){for(var t in r(e),n)if(n[t]===e)return t}))})}})),Fe=T((function(e,t){"use strict";var a,r,o,i=me(),l=xe(),s=ve().Symbol,u=Ee(),c=Ae(),d=Ce(),p=Object.create,f=Object.defineProperties,m=Object.defineProperty;if("function"==typeof s)try{String(s()),o=!0}catch(e){}else s=null;r=function(e){if(this instanceof r)throw new TypeError("Symbol is not a constructor");return a(e)},t.exports=a=function e(t){var a;if(this instanceof e)throw new TypeError("Symbol is not a constructor");return o?s(t):(a=p(r.prototype),t=void 0===t?"":String(t),f(a,{__description__:i("",t),__name__:i("",u(t))}))},c(a),d(a),f(r.prototype,{constructor:i(a),toString:i("",(function(){return this.__name__}))}),f(a.prototype,{toString:i((function(){return"Symbol ("+l(this).__description__+")"})),valueOf:i((function(){return l(this)}))}),m(a.prototype,a.toPrimitive,i("",(function(){var e=l(this);return"symbol"===n(e)?e:e.toString()}))),m(a.prototype,a.toStringTag,i("c","Symbol")),m(r.prototype,a.toStringTag,i("c",a.prototype[a.toStringTag])),m(r.prototype,a.toPrimitive,i("c",a.prototype[a.toPrimitive]))})),ke=T((function(e,t){"use strict";t.exports=De()()?ve().Symbol:Fe()})),Re=T((function(e,t){"use strict";var a=Object.prototype.toString,r=a.call(function(){return arguments}());t.exports=function(e){return a.call(e)===r}})),Te=T((function(e,t){"use strict";var a=Object.prototype.toString,r=RegExp.prototype.test.bind(/^[object [A-Za-z0-9]*Function]$/);t.exports=function(e){return"function"==typeof e&&r(a.call(e))}})),Ne=T((function(e,t){"use strict";var a=Object.prototype.toString,r=a.call("");t.exports=function(e){return"string"==typeof e||e&&"object"===n(e)&&(e instanceof String||a.call(e)===r)||!1}})),_e=T((function(e,t){"use strict";var a=ke().iterator,r=Re(),n=Te(),o=H(),i=$(),l=W(),s=L(),u=Ne(),c=Array.isArray,d=Function.prototype.call,p={configurable:!0,enumerable:!0,writable:!0,value:null},f=Object.defineProperty;t.exports=function(e){var t,m,h,g,b,y,v,D,w,x,E=arguments[1],A=arguments[2];if(e=Object(l(e)),s(E)&&i(E),this&&this!==Array&&n(this))t=this;else{if(!E){if(r(e))return 1!==(b=e.length)?Array.apply(null,e):((g=new Array(1))[0]=e[0],g);if(c(e)){for(g=new Array(b=e.length),m=0;m<b;++m)g[m]=e[m];return g}}g=[]}if(!c(e))if(void 0!==(w=e[a])){for(v=i(w).call(e),t&&(g=new t),D=v.next(),m=0;!D.done;)x=E?d.call(E,A,D.value,m):D.value,t?(p.value=x,f(g,m,p)):g[m]=x,D=v.next(),++m;b=m}else if(u(e)){for(b=e.length,t&&(g=new t),h=m=0;m<b;++m)x=e[m],m+1<b&&55296<=(y=x.charCodeAt(0))&&y<=56319&&(x+=e[++m]),x=E?d.call(E,A,x,h):x,t?(p.value=x,f(g,h,p)):g[h]=x,++h;b=h}if(void 0===b)for(b=o(e.length),t&&(g=new t(b)),m=0;m<b;++m)x=E?d.call(E,A,e[m],m):e[m],t?(p.value=x,f(g,m,p)):g[m]=x;return t&&(p.value=null,g.length=b),g}})),Oe=T((function(e,t){"use strict";t.exports=ge()()?Array.from:_e()})),Se=T((function(e,t){"use strict";var a=Oe(),r=Array.isArray;t.exports=function(e){return r(e)?e:a(e)}})),Pe=T((function(e,t){"use strict";var a=Se(),r=L(),n=$(),o=Array.prototype.slice,i=function(e){return this.map((function(t,a){return t?t(e[a]):e[a]})).concat(o.call(e,this.length))};t.exports=function(e){return(e=a(e)).forEach((function(e){r(e)&&n(e)})),i.bind(e)}})),Ie=T((function(e,t){"use strict";var a=$();t.exports=function(e){var t;return"function"==typeof e?{set:e,get:e}:(t={get:a(e.get)},void 0!==e.set?(t.set=a(e.set),e.delete&&(t.delete=a(e.delete)),e.clear&&(t.clear=a(e.clear))):t.set=t.get,t)}})),Be=T((function(e,t){"use strict";var a=re(),r=oe(),n=me(),o=he().methods,i=Pe(),l=Ie(),s=Function.prototype.apply,u=Function.prototype.call,c=Object.create,d=Object.defineProperties,p=o.on,f=o.emit;t.exports=function(e,t,o){var m,h,g,b,y,v,D,w,x,E,A,C=c(null),F=!1!==t?t:isNaN(e.length)?1:e.length;return o.normalizer&&(v=l(o.normalizer),h=v.get,g=v.set,b=v.delete,y=v.clear),null!=o.resolvers&&(A=i(o.resolvers)),E=h?r((function(t){var r,n,o=arguments;if(A&&(o=A(o)),null!==(r=h(o))&&hasOwnProperty.call(C,r))return D&&m.emit("get",r,o,this),C[r];if(n=1===o.length?u.call(e,this,o[0]):s.call(e,this,o),null===r){if(null!==(r=h(o)))throw a("Circular invocation","CIRCULAR_INVOCATION");r=g(o)}else if(hasOwnProperty.call(C,r))throw a("Circular invocation","CIRCULAR_INVOCATION");return C[r]=n,w&&m.emit("set",r,null,n),n}),F):0===t?function(){var t;if(hasOwnProperty.call(C,"data"))return D&&m.emit("get","data",arguments,this),C.data;if(t=arguments.length?s.call(e,this,arguments):u.call(e,this),hasOwnProperty.call(C,"data"))throw a("Circular invocation","CIRCULAR_INVOCATION");return C.data=t,w&&m.emit("set","data",null,t),t}:function(t){var r,n=arguments;if(A&&(n=A(arguments)),r=String(n[0]),hasOwnProperty.call(C,r))return D&&m.emit("get",r,n,this),C[r];if(n=1===n.length?u.call(e,this,n[0]):s.call(e,this,n),hasOwnProperty.call(C,r))throw a("Circular invocation","CIRCULAR_INVOCATION");return C[r]=n,w&&m.emit("set",r,null,n),n},m={original:e,memoized:E,profileName:o.profileName,get:function(e){return A&&(e=A(e)),h?h(e):String(e[0])},has:function(e){return hasOwnProperty.call(C,e)},delete:function(e){var t;hasOwnProperty.call(C,e)&&(b&&b(e),t=C[e],delete C[e],x&&m.emit("delete",e,t))},clear:function(){var e=C;y&&y(),C=c(null),m.emit("clear",e)},on:function(e,t){return"get"===e?D=!0:"set"===e?w=!0:"delete"===e&&(x=!0),p.call(this,e,t)},emit:f,updateEnv:function(){e=m.original}},v=h?r((function(e){var t=arguments;A&&(t=A(t)),null!==(t=h(t))&&m.delete(t)}),F):0===t?function(){return m.delete("data")}:function(e){return A&&(e=A(arguments)[0]),m.delete(e)},o=r((function(){var e=arguments;return 0===t?C.data:(A&&(e=A(e)),e=h?h(e):String(e[0]),C[e])})),F=r((function(){var e=arguments;return 0===t?m.has("data"):(A&&(e=A(e)),null!==(e=h?h(e):String(e[0]))&&m.has(e))})),d(E,{__memoized__:n(!0),delete:n(v),clear:n(m.clear),_get:n(o),_has:n(F)}),m}})),Le=T((function(e,t){"use strict";var a=$(),r=Y(),n=K(),o=Be(),i=z();t.exports=function e(t){var l,s,u;if(a(t),(l=Object(arguments[1])).async&&l.promise)throw new Error("Options \'async\' and \'promise\' cannot be used together");return hasOwnProperty.call(t,"__memoized__")&&!l.force?t:(s=i(l.length,t.length,l.async&&n.async),u=o(t,s,l),r(n,(function(e,t){l[t]&&e(l[t],u,l)})),e.__profiler__&&e.__profiler__(u),u.updateEnv(),u.memoized)}})),qe=T((function(e,t){"use strict";t.exports=function(e){var t,a,r=e.length;if(!r)return"";for(t=String(e[a=0]);--r;)t+=""+e[++a];return t}})),Me=T((function(e,t){"use strict";t.exports=function(e){return e?function(t){for(var a=String(t[0]),r=0,n=e;--n;)a+=""+t[++r];return a}:function(){return""}}})),je=T((function(e,t){"use strict";t.exports=function(){var e=Number.isNaN;return"function"==typeof e&&!e({})&&e(NaN)&&!e(34)}})),Ue=T((function(e,t){"use strict";t.exports=function(e){return e!=e}})),Ve=T((function(e,t){"use strict";t.exports=je()()?Number.isNaN:Ue()})),He=T((function(e,t){"use strict";var a=Ve(),r=H(),n=W(),o=Array.prototype.indexOf,i=Object.prototype.hasOwnProperty,l=Math.abs,s=Math.floor;t.exports=function(e){var t,u,c;if(!a(e))return o.apply(this,arguments);for(u=r(n(this).length),e=arguments[1],t=e=isNaN(e)?0:0<=e?s(e):r(this.length)-s(l(e));t<u;++t)if(i.call(this,t)&&(c=this[t],a(c)))return t;return-1}})),ze=T((function(e,t){"use strict";var a=He(),r=Object.create;t.exports=function(){var e=0,t=[],n=r(null);return{get:function(e){var r,n=0,o=t,i=e.length;if(0===i)return o[i]||null;if(o=o[i]){for(;n<i-1;){if(-1===(r=a.call(o[0],e[n])))return null;o=o[1][r],++n}return-1===(r=a.call(o[0],e[n]))?null:o[1][r]||null}return null},set:function(r){var o,i=0,l=t,s=r.length;if(0===s)l[s]=++e;else{for(l[s]||(l[s]=[[],[]]),l=l[s];i<s-1;)-1===(o=a.call(l[0],r[i]))&&(o=l[0].push(r[i])-1,l[1].push([[],[]])),l=l[1][o],++i;-1===(o=a.call(l[0],r[i]))&&(o=l[0].push(r[i])-1),l[1][o]=++e}return n[e]=r,e},delete:function(e){var r,o=0,i=t,l=n[e],s=l.length,u=[];if(0===s)delete i[s];else if(i=i[s]){for(;o<s-1;){if(-1===(r=a.call(i[0],l[o])))return;u.push(i,r),i=i[1][r],++o}if(-1===(r=a.call(i[0],l[o])))return;for(e=i[1][r],i[0].splice(r,1),i[1].splice(r,1);!i[0].length&&u.length;)r=u.pop(),(i=u.pop())[0].splice(r,1),i[1].splice(r,1)}delete n[e]},clear:function(){t=[],n=r(null)}}}})),$e=T((function(e,t){"use strict";var a=He();t.exports=function(){var e=0,t=[],r=[];return{get:function(e){return-1===(e=a.call(t,e[0]))?null:r[e]},set:function(a){return t.push(a[0]),r.push(++e),e},delete:function(e){-1!==(e=a.call(r,e))&&(t.splice(e,1),r.splice(e,1))},clear:function(){t=[],r=[]}}}})),We=T((function(e,t){"use strict";var a=He(),r=Object.create;t.exports=function(e){var t=0,n=[[],[]],o=r(null);return{get:function(t){for(var r,o=0,i=n;o<e-1;){if(-1===(r=a.call(i[0],t[o])))return null;i=i[1][r],++o}return-1!==(r=a.call(i[0],t[o]))&&i[1][r]||null},set:function(r){for(var i,l=0,s=n;l<e-1;)-1===(i=a.call(s[0],r[l]))&&(i=s[0].push(r[l])-1,s[1].push([[],[]])),s=s[1][i],++l;return-1===(i=a.call(s[0],r[l]))&&(i=s[0].push(r[l])-1),s[1][i]=++t,o[t]=r,t},delete:function(t){for(var r,i=0,l=n,s=[],u=o[t];i<e-1;){if(-1===(r=a.call(l[0],u[i])))return;s.push(l,r),l=l[1][r],++i}if(-1!==(r=a.call(l[0],u[i]))){for(t=l[1][r],l[0].splice(r,1),l[1].splice(r,1);!l[0].length&&s.length;)r=s.pop(),(l=s.pop())[0].splice(r,1),l[1].splice(r,1);delete o[t]}},clear:function(){n=[[],[]],o=r(null)}}}})),Ge=T((function(e,t){"use strict";var a=$(),r=Y(),n=Function.prototype.call;t.exports=function(e,t){var o={},i=arguments[2];return a(t),r(e,(function(e,a,r,l){o[a]=n.call(t,i,e,a,r,l)})),o}})),Ye=T((function(e,t){"use strict";function a(e){if("function"!=typeof e)throw new TypeError(e+" is not a function");return e}function o(e){var t,n,o=r.createTextNode(""),i=0;return new e((function(){var e;if(t)n&&(t=n.concat(t));else{if(!n)return;t=n}if(n=t,t=null,"function"==typeof n)return e=n,n=null,void e();for(o.data=i=++i%2;n;)e=n.shift(),n.length||(n=null),e()})).observe(o,{characterData:!0}),function(e){a(e),t?"function"==typeof t?t=[t,e]:t.push(e):(t=e,o.data=i=++i%2)}}t.exports=function(){if("object"===("undefined"==typeof process?"undefined":n(process))&&process&&"function"==typeof process.nextTick)return process.nextTick;if("function"==typeof queueMicrotask)return function(e){queueMicrotask(a(e))};if("object"===(void 0===r?"undefined":n(r))&&r){if("function"==typeof MutationObserver)return o(MutationObserver);if("function"==typeof WebKitMutationObserver)return o(WebKitMutationObserver)}return"function"==typeof setImmediate?function(e){setImmediate(a(e))}:"function"==typeof setTimeout||"object"===("undefined"==typeof setTimeout?"undefined":n(setTimeout))?function(e){setTimeout(a(e),0)}:null}()})),Ke=T((function(){"use strict";var e=Oe(),t=Ge(),a=ne(),r=oe(),n=Ye(),o=Array.prototype.slice,i=Function.prototype.apply,l=Object.create;K().async=function(s,u){var c,d,p,f=l(null),m=l(null),h=u.memoized,g=u.original;u.memoized=r((function(e){var t=arguments,a=t[t.length-1];return"function"==typeof a&&(c=a,t=o.call(t,0,-1)),h.apply(d=this,p=t)}),h);try{a(u.memoized,h)}catch(s){}u.on("get",(function(e){var t,a,r;if(c){if(f[e])return"function"==typeof f[e]?f[e]=[f[e],c]:f[e].push(c),void(c=null);t=c,a=d,r=p,c=d=p=null,n((function(){var n;hasOwnProperty.call(m,e)?(n=m[e],u.emit("getasync",e,r,a),i.call(t,n.context,n.args)):(c=t,d=a,p=r,h.apply(a,r))}))}})),u.original=function(){var t,a,r,o;return c?(t=e(arguments),a=function t(a){var r,l,s=t.id;if(null!=s){if(delete t.id,r=f[s],delete f[s],r)return l=e(arguments),u.has(s)&&(a?u.delete(s):(m[s]={context:this,args:l},u.emit("setasync",s,"function"==typeof r?1:r.length))),"function"==typeof r?o=i.call(r,this,l):r.forEach((function(e){o=i.call(e,this,l)}),this),o}else n(i.bind(t,this,arguments))},r=c,c=d=p=null,t.push(a),o=i.call(g,this,t),a.cb=r,c=a,o):i.call(g,this,arguments)},u.on("set",(function(e){c?(f[e]?"function"==typeof f[e]?f[e]=[f[e],c.cb]:f[e].push(c.cb):f[e]=c.cb,delete c.cb,c.id=e,c=null):u.delete(e)})),u.on("delete",(function(e){var t;hasOwnProperty.call(f,e)||m[e]&&(t=m[e],delete m[e],u.emit("deleteasync",e,o.call(t.args,1)))})),u.on("clear",(function(){var e=m;m=l(null),u.emit("clearasync",t(e,(function(e){return o.call(e.args,1)})))}))}})),Xe=T((function(e,t){"use strict";var a=Array.prototype.forEach,r=Object.create;t.exports=function(e){var t=r(null);return a.call(arguments,(function(e){t[e]=!0})),t}})),Je=T((function(e,t){"use strict";t.exports=function(e){return"function"==typeof e}})),Qe=T((function(e,t){"use strict";var a=Je();t.exports=function(e){try{return e&&a(e.toString)?e.toString():String(e)}catch(e){throw new TypeError("Passed argument cannot be stringifed")}}})),Ze=T((function(e,t){"use strict";var a=W(),r=Qe();t.exports=function(e){return r(a(e))}})),et=T((function(e,t){"use strict";var a=Je();t.exports=function(e){try{return e&&a(e.toString)?e.toString():String(e)}catch(e){return"<Non-coercible to string value>"}}})),tt=T((function(e,t){"use strict";var a=et(),r=/[\\n\\r\\u2028\\u2029]/g;t.exports=function(e){return(e=100<(e=a(e)).length?e.slice(0,99)+"…":e).replace(r,(function(e){return JSON.stringify(e).slice(1,-1)}))}})),at=T((function(e,t){function a(e){return!!e&&("object"===n(e)||"function"==typeof e)&&"function"==typeof e.then}t.exports=a,t.exports.default=a})),rt=T((function(){"use strict";var e=Ge(),t=Xe(),a=Ze(),r=tt(),n=at(),o=Ye(),i=Object.create,l=t("then","then:finally","done","done:finally");K().promise=function(t,s){var u=i(null),c=i(null),d=i(null);if(!0===t)t=null;else if(t=a(t),!l[t])throw new TypeError("\'"+r(t)+"\' is not valid promise mode");s.on("set",(function(e,a,r){var i=!1;if(!n(r))return c[e]=r,void s.emit("setasync",e,1);function l(t){var a=u[e];if(i)throw new Error("Memoizee error: Detected unordered then|done & finally resolution, which in turn makes proper detection of success/failure impossible (when in \'done:finally\' mode)\\nConsider to rely on \'then\' or \'done\' mode instead.");a&&(delete u[e],c[e]=t,s.emit("setasync",e,a))}function p(){i=!0,u[e]&&(delete u[e],delete d[e],s.delete(e))}u[e]=1,d[e]=r;var f=t;if("then"===(f=f||"then")){var m=function(){o(p)};"function"==typeof(r=r.then((function(e){o(l.bind(this,e))}),m)).finally&&r.finally(m)}else if("done"===f){if("function"!=typeof r.done)throw new Error("Memoizee error: Retrieved promise does not implement \'done\' in \'done\' mode");r.done(l,p)}else if("done:finally"===f){if("function"!=typeof r.done)throw new Error("Memoizee error: Retrieved promise does not implement \'done\' in \'done:finally\' mode");if("function"!=typeof r.finally)throw new Error("Memoizee error: Retrieved promise does not implement \'finally\' in \'done:finally\' mode");r.done(l),r.finally(p)}})),s.on("get",(function(e,t,a){var r,i;u[e]?++u[e]:(r=d[e],i=function(){s.emit("getasync",e,t,a)},n(r)?"function"==typeof r.done?r.done(i):r.then((function(){o(i)})):i())})),s.on("delete",(function(e){var t;delete d[e],u[e]?delete u[e]:hasOwnProperty.call(c,e)&&(t=c[e],delete c[e],s.emit("deleteasync",e,[t]))})),s.on("clear",(function(){var t=c;c=i(null),u=i(null),d=i(null),s.emit("clearasync",e(t,(function(e){return[e]})))}))}})),nt=T((function(){"use strict";var e=$(),t=Y(),a=K(),r=Function.prototype.apply;a.dispose=function(n,o,i){var l;if(e(n),i.async&&a.async||i.promise&&a.promise)return o.on("deleteasync",l=function(e,t){r.call(n,null,t)}),void o.on("clearasync",(function(e){t(e,(function(e,t){l(t,e)}))}));o.on("delete",l=function(e,t){n(t)}),o.on("clear",(function(e){t(e,(function(e,t){l(t,e)}))}))}})),ot=T((function(e,t){"use strict";t.exports=2147483647})),it=T((function(e,t){"use strict";var a=H(),r=ot();t.exports=function(e){if(e=a(e),r<e)throw new TypeError(e+" exceeds maximum possible timeout");return e}})),lt=T((function(){"use strict";var e=Oe(),t=Y(),a=Ye(),r=at(),n=it(),o=K(),i=Function.prototype,l=Math.max,s=Math.min,u=Object.create;o.maxAge=function(c,d,p){var f,m,h,g;(c=n(c))&&(f=u(null),m=p.async&&o.async||p.promise&&o.promise?"async":"",d.on("set"+m,(function(e){f[e]=setTimeout((function(){d.delete(e)}),c),"function"==typeof f[e].unref&&f[e].unref(),g&&(g[e]&&"nextTick"!==g[e]&&clearTimeout(g[e]),g[e]=setTimeout((function(){delete g[e]}),h),"function"==typeof g[e].unref&&g[e].unref())})),d.on("delete"+m,(function(e){clearTimeout(f[e]),delete f[e],g&&("nextTick"!==g[e]&&clearTimeout(g[e]),delete g[e])})),p.preFetch&&(h=!0===p.preFetch||isNaN(p.preFetch)?.333:l(s(Number(p.preFetch),1),0))&&(g={},h=(1-h)*c,d.on("get"+m,(function(t,n,o){g[t]||(g[t]="nextTick",a((function(){var a;"nextTick"===g[t]&&(delete g[t],d.delete(t),p.async&&(n=e(n)).push(i),a=d.memoized.apply(o,n),p.promise&&r(a)&&("function"==typeof a.done?a.done(i,i):a.then(i,i)))})))}))),d.on("clear"+m,(function(){t(f,(function(e){clearTimeout(e)})),f={},g&&(t(g,(function(e){"nextTick"!==e&&clearTimeout(e)})),g={})})))}})),st=T((function(e,t){"use strict";var a=H(),r=Object.create,n=Object.prototype.hasOwnProperty;t.exports=function(e){var t,o=0,i=1,l=r(null),s=r(null),u=0;return e=a(e),{hit:function(a){var r=s[a],c=++u;if(l[c]=a,s[a]=c,!r)return++o<=e?void 0:(a=l[i],t(a),a);if(delete l[r],i===r)for(;!n.call(l,++i););},delete:t=function(e){var t=s[e];if(t&&(delete l[t],delete s[e],--o,i===t)){if(!o)return u=0,void(i=1);for(;!n.call(l,++i););}},clear:function(){o=0,i=1,l=r(null),s=r(null),u=0}}}})),ut=T((function(){"use strict";var e=H(),t=st(),a=K();a.max=function(r,n,o){var i;(r=e(r))&&(i=t(r),r=o.async&&a.async||o.promise&&a.promise?"async":"",n.on("set"+r,o=function(e){void 0!==(e=i.hit(e))&&n.delete(e)}),n.on("get"+r,o),n.on("delete"+r,i.delete),n.on("clear"+r,i.clear))}})),ct=T((function(){"use strict";var e=me(),t=K(),a=Object.create,r=Object.defineProperties;t.refCounter=function(n,o,i){var l=a(null);i=i.async&&t.async||i.promise&&t.promise?"async":"";o.on("set"+i,(function(e,t){l[e]=t||1})),o.on("get"+i,(function(e){++l[e]})),o.on("delete"+i,(function(e){delete l[e]})),o.on("clear"+i,(function(){l={}})),r(o.memoized,{deleteRef:e((function(){var e=o.get(arguments);return null!==e&&l[e]?!--l[e]&&(o.delete(e),!0):null})),getRefCount:e((function(){var e=o.get(arguments);return null!==e&&l[e]||0}))})}})),dt=T((function(e,t){"use strict";var a=q(),r=z(),n=Le();t.exports=function(e){var t,o=a(arguments[1]);return o.normalizer||0!==(t=o.length=r(o.length,e.length,o.async))&&(o.primitive?!1===t?o.normalizer=qe():1<t&&(o.normalizer=Me()(t)):o.normalizer=!1===t?ze()():1===t?$e()():We()(t)),o.async&&Ke(),o.promise&&rt(),o.dispose&&nt(),o.maxAge&&lt(),o.max&&ut(),o.refCounter&&ct(),n(e,o)}})),pt=T((function(e,t){"use strict";t.exports=function(){return/\\uD83C\\uDFF4\\uDB40\\uDC67\\uDB40\\uDC62(?:\\uDB40\\uDC65\\uDB40\\uDC6E\\uDB40\\uDC67|\\uDB40\\uDC73\\uDB40\\uDC63\\uDB40\\uDC74|\\uDB40\\uDC77\\uDB40\\uDC6C\\uDB40\\uDC73)\\uDB40\\uDC7F|\\uD83D\\uDC68(?:\\uD83C\\uDFFC\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68\\uD83C\\uDFFB|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C\\uDFFF\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68(?:\\uD83C[\\uDFFB-\\uDFFE])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C\\uDFFE\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68(?:\\uD83C[\\uDFFB-\\uDFFD])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C\\uDFFD\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68(?:\\uD83C[\\uDFFB\\uDFFC])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\u200D(?:\\u2764\\uFE0F\\u200D(?:\\uD83D\\uDC8B\\u200D)?\\uD83D\\uDC68|(?:\\uD83D[\\uDC68\\uDC69])\\u200D(?:\\uD83D\\uDC66\\u200D\\uD83D\\uDC66|\\uD83D\\uDC67\\u200D(?:\\uD83D[\\uDC66\\uDC67]))|\\uD83D\\uDC66\\u200D\\uD83D\\uDC66|\\uD83D\\uDC67\\u200D(?:\\uD83D[\\uDC66\\uDC67])|(?:\\uD83D[\\uDC68\\uDC69])\\u200D(?:\\uD83D[\\uDC66\\uDC67])|[\\u2695\\u2696\\u2708]\\uFE0F|\\uD83D[\\uDC66\\uDC67]|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|(?:\\uD83C\\uDFFB\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFF\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFE\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFD\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFC\\u200D[\\u2695\\u2696\\u2708])\\uFE0F|\\uD83C\\uDFFB\\u200D(?:\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C[\\uDFFB-\\uDFFF])|(?:\\uD83E\\uDDD1\\uD83C\\uDFFB\\u200D\\uD83E\\uDD1D\\u200D\\uD83E\\uDDD1|\\uD83D\\uDC69\\uD83C\\uDFFC\\u200D\\uD83E\\uDD1D\\u200D\\uD83D\\uDC69)\\uD83C\\uDFFB|\\uD83E\\uDDD1(?:\\uD83C\\uDFFF\\u200D\\uD83E\\uDD1D\\u200D\\uD83E\\uDDD1(?:\\uD83C[\\uDFFB-\\uDFFF])|\\u200D\\uD83E\\uDD1D\\u200D\\uD83E\\uDDD1)|(?:\\uD83E\\uDDD1\\uD83C\\uDFFE\\u200D\\uD83E\\uDD1D\\u200D\\uD83E\\uDDD1|\\uD83D\\uDC69\\uD83C\\uDFFF\\u200D\\uD83E\\uDD1D\\u200D(?:\\uD83D[\\uDC68\\uDC69]))(?:\\uD83C[\\uDFFB-\\uDFFE])|(?:\\uD83E\\uDDD1\\uD83C\\uDFFC\\u200D\\uD83E\\uDD1D\\u200D\\uD83E\\uDDD1|\\uD83D\\uDC69\\uD83C\\uDFFD\\u200D\\uD83E\\uDD1D\\u200D\\uD83D\\uDC69)(?:\\uD83C[\\uDFFB\\uDFFC])|\\uD83D\\uDC69(?:\\uD83C\\uDFFE\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68(?:\\uD83C[\\uDFFB-\\uDFFD\\uDFFF])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C\\uDFFC\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68(?:\\uD83C[\\uDFFB\\uDFFD-\\uDFFF])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C\\uDFFB\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68(?:\\uD83C[\\uDFFC-\\uDFFF])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C\\uDFFD\\u200D(?:\\uD83E\\uDD1D\\u200D\\uD83D\\uDC68(?:\\uD83C[\\uDFFB\\uDFFC\\uDFFE\\uDFFF])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\u200D(?:\\u2764\\uFE0F\\u200D(?:\\uD83D\\uDC8B\\u200D(?:\\uD83D[\\uDC68\\uDC69])|\\uD83D[\\uDC68\\uDC69])|\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD])|\\uD83C\\uDFFF\\u200D(?:\\uD83C[\\uDF3E\\uDF73\\uDF93\\uDFA4\\uDFA8\\uDFEB\\uDFED]|\\uD83D[\\uDCBB\\uDCBC\\uDD27\\uDD2C\\uDE80\\uDE92]|\\uD83E[\\uDDAF-\\uDDB3\\uDDBC\\uDDBD]))|\\uD83D\\uDC69\\u200D\\uD83D\\uDC69\\u200D(?:\\uD83D\\uDC66\\u200D\\uD83D\\uDC66|\\uD83D\\uDC67\\u200D(?:\\uD83D[\\uDC66\\uDC67]))|(?:\\uD83E\\uDDD1\\uD83C\\uDFFD\\u200D\\uD83E\\uDD1D\\u200D\\uD83E\\uDDD1|\\uD83D\\uDC69\\uD83C\\uDFFE\\u200D\\uD83E\\uDD1D\\u200D\\uD83D\\uDC69)(?:\\uD83C[\\uDFFB-\\uDFFD])|\\uD83D\\uDC69\\u200D\\uD83D\\uDC66\\u200D\\uD83D\\uDC66|\\uD83D\\uDC69\\u200D\\uD83D\\uDC69\\u200D(?:\\uD83D[\\uDC66\\uDC67])|(?:\\uD83D\\uDC41\\uFE0F\\u200D\\uD83D\\uDDE8|\\uD83D\\uDC69(?:\\uD83C\\uDFFF\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFE\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFC\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFB\\u200D[\\u2695\\u2696\\u2708]|\\uD83C\\uDFFD\\u200D[\\u2695\\u2696\\u2708]|\\u200D[\\u2695\\u2696\\u2708])|(?:(?:\\u26F9|\\uD83C[\\uDFCB\\uDFCC]|\\uD83D\\uDD75)\\uFE0F|\\uD83D\\uDC6F|\\uD83E[\\uDD3C\\uDDDE\\uDDDF])\\u200D[\\u2640\\u2642]|(?:\\u26F9|\\uD83C[\\uDFCB\\uDFCC]|\\uD83D\\uDD75)(?:\\uD83C[\\uDFFB-\\uDFFF])\\u200D[\\u2640\\u2642]|(?:\\uD83C[\\uDFC3\\uDFC4\\uDFCA]|\\uD83D[\\uDC6E\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6]|\\uD83E[\\uDD26\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD6-\\uDDDD])(?:(?:\\uD83C[\\uDFFB-\\uDFFF])\\u200D[\\u2640\\u2642]|\\u200D[\\u2640\\u2642])|\\uD83C\\uDFF4\\u200D\\u2620)\\uFE0F|\\uD83D\\uDC69\\u200D\\uD83D\\uDC67\\u200D(?:\\uD83D[\\uDC66\\uDC67])|\\uD83C\\uDFF3\\uFE0F\\u200D\\uD83C\\uDF08|\\uD83D\\uDC15\\u200D\\uD83E\\uDDBA|\\uD83D\\uDC69\\u200D\\uD83D\\uDC66|\\uD83D\\uDC69\\u200D\\uD83D\\uDC67|\\uD83C\\uDDFD\\uD83C\\uDDF0|\\uD83C\\uDDF4\\uD83C\\uDDF2|\\uD83C\\uDDF6\\uD83C\\uDDE6|[#\\*0-9]\\uFE0F\\u20E3|\\uD83C\\uDDE7(?:\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEF\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9\\uDDFB\\uDDFC\\uDDFE\\uDDFF])|\\uD83C\\uDDF9(?:\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDED\\uDDEF-\\uDDF4\\uDDF7\\uDDF9\\uDDFB\\uDDFC\\uDDFF])|\\uD83C\\uDDEA(?:\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDED\\uDDF7-\\uDDFA])|\\uD83E\\uDDD1(?:\\uD83C[\\uDFFB-\\uDFFF])|\\uD83C\\uDDF7(?:\\uD83C[\\uDDEA\\uDDF4\\uDDF8\\uDDFA\\uDDFC])|\\uD83D\\uDC69(?:\\uD83C[\\uDFFB-\\uDFFF])|\\uD83C\\uDDF2(?:\\uD83C[\\uDDE6\\uDDE8-\\uDDED\\uDDF0-\\uDDFF])|\\uD83C\\uDDE6(?:\\uD83C[\\uDDE8-\\uDDEC\\uDDEE\\uDDF1\\uDDF2\\uDDF4\\uDDF6-\\uDDFA\\uDDFC\\uDDFD\\uDDFF])|\\uD83C\\uDDF0(?:\\uD83C[\\uDDEA\\uDDEC-\\uDDEE\\uDDF2\\uDDF3\\uDDF5\\uDDF7\\uDDFC\\uDDFE\\uDDFF])|\\uD83C\\uDDED(?:\\uD83C[\\uDDF0\\uDDF2\\uDDF3\\uDDF7\\uDDF9\\uDDFA])|\\uD83C\\uDDE9(?:\\uD83C[\\uDDEA\\uDDEC\\uDDEF\\uDDF0\\uDDF2\\uDDF4\\uDDFF])|\\uD83C\\uDDFE(?:\\uD83C[\\uDDEA\\uDDF9])|\\uD83C\\uDDEC(?:\\uD83C[\\uDDE6\\uDDE7\\uDDE9-\\uDDEE\\uDDF1-\\uDDF3\\uDDF5-\\uDDFA\\uDDFC\\uDDFE])|\\uD83C\\uDDF8(?:\\uD83C[\\uDDE6-\\uDDEA\\uDDEC-\\uDDF4\\uDDF7-\\uDDF9\\uDDFB\\uDDFD-\\uDDFF])|\\uD83C\\uDDEB(?:\\uD83C[\\uDDEE-\\uDDF0\\uDDF2\\uDDF4\\uDDF7])|\\uD83C\\uDDF5(?:\\uD83C[\\uDDE6\\uDDEA-\\uDDED\\uDDF0-\\uDDF3\\uDDF7-\\uDDF9\\uDDFC\\uDDFE])|\\uD83C\\uDDFB(?:\\uD83C[\\uDDE6\\uDDE8\\uDDEA\\uDDEC\\uDDEE\\uDDF3\\uDDFA])|\\uD83C\\uDDF3(?:\\uD83C[\\uDDE6\\uDDE8\\uDDEA-\\uDDEC\\uDDEE\\uDDF1\\uDDF4\\uDDF5\\uDDF7\\uDDFA\\uDDFF])|\\uD83C\\uDDE8(?:\\uD83C[\\uDDE6\\uDDE8\\uDDE9\\uDDEB-\\uDDEE\\uDDF0-\\uDDF5\\uDDF7\\uDDFA-\\uDDFF])|\\uD83C\\uDDF1(?:\\uD83C[\\uDDE6-\\uDDE8\\uDDEE\\uDDF0\\uDDF7-\\uDDFB\\uDDFE])|\\uD83C\\uDDFF(?:\\uD83C[\\uDDE6\\uDDF2\\uDDFC])|\\uD83C\\uDDFC(?:\\uD83C[\\uDDEB\\uDDF8])|\\uD83C\\uDDFA(?:\\uD83C[\\uDDE6\\uDDEC\\uDDF2\\uDDF3\\uDDF8\\uDDFE\\uDDFF])|\\uD83C\\uDDEE(?:\\uD83C[\\uDDE8-\\uDDEA\\uDDF1-\\uDDF4\\uDDF6-\\uDDF9])|\\uD83C\\uDDEF(?:\\uD83C[\\uDDEA\\uDDF2\\uDDF4\\uDDF5])|(?:\\uD83C[\\uDFC3\\uDFC4\\uDFCA]|\\uD83D[\\uDC6E\\uDC71\\uDC73\\uDC77\\uDC81\\uDC82\\uDC86\\uDC87\\uDE45-\\uDE47\\uDE4B\\uDE4D\\uDE4E\\uDEA3\\uDEB4-\\uDEB6]|\\uD83E[\\uDD26\\uDD37-\\uDD39\\uDD3D\\uDD3E\\uDDB8\\uDDB9\\uDDCD-\\uDDCF\\uDDD6-\\uDDDD])(?:\\uD83C[\\uDFFB-\\uDFFF])|(?:\\u26F9|\\uD83C[\\uDFCB\\uDFCC]|\\uD83D\\uDD75)(?:\\uD83C[\\uDFFB-\\uDFFF])|(?:[\\u261D\\u270A-\\u270D]|\\uD83C[\\uDF85\\uDFC2\\uDFC7]|\\uD83D[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66\\uDC67\\uDC6B-\\uDC6D\\uDC70\\uDC72\\uDC74-\\uDC76\\uDC78\\uDC7C\\uDC83\\uDC85\\uDCAA\\uDD74\\uDD7A\\uDD90\\uDD95\\uDD96\\uDE4C\\uDE4F\\uDEC0\\uDECC]|\\uD83E[\\uDD0F\\uDD18-\\uDD1C\\uDD1E\\uDD1F\\uDD30-\\uDD36\\uDDB5\\uDDB6\\uDDBB\\uDDD2-\\uDDD5])(?:\\uD83C[\\uDFFB-\\uDFFF])|(?:[\\u231A\\u231B\\u23E9-\\u23EC\\u23F0\\u23F3\\u25FD\\u25FE\\u2614\\u2615\\u2648-\\u2653\\u267F\\u2693\\u26A1\\u26AA\\u26AB\\u26BD\\u26BE\\u26C4\\u26C5\\u26CE\\u26D4\\u26EA\\u26F2\\u26F3\\u26F5\\u26FA\\u26FD\\u2705\\u270A\\u270B\\u2728\\u274C\\u274E\\u2753-\\u2755\\u2757\\u2795-\\u2797\\u27B0\\u27BF\\u2B1B\\u2B1C\\u2B50\\u2B55]|\\uD83C[\\uDC04\\uDCCF\\uDD8E\\uDD91-\\uDD9A\\uDDE6-\\uDDFF\\uDE01\\uDE1A\\uDE2F\\uDE32-\\uDE36\\uDE38-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF20\\uDF2D-\\uDF35\\uDF37-\\uDF7C\\uDF7E-\\uDF93\\uDFA0-\\uDFCA\\uDFCF-\\uDFD3\\uDFE0-\\uDFF0\\uDFF4\\uDFF8-\\uDFFF]|\\uD83D[\\uDC00-\\uDC3E\\uDC40\\uDC42-\\uDCFC\\uDCFF-\\uDD3D\\uDD4B-\\uDD4E\\uDD50-\\uDD67\\uDD7A\\uDD95\\uDD96\\uDDA4\\uDDFB-\\uDE4F\\uDE80-\\uDEC5\\uDECC\\uDED0-\\uDED2\\uDED5\\uDEEB\\uDEEC\\uDEF4-\\uDEFA\\uDFE0-\\uDFEB]|\\uD83E[\\uDD0D-\\uDD3A\\uDD3C-\\uDD45\\uDD47-\\uDD71\\uDD73-\\uDD76\\uDD7A-\\uDDA2\\uDDA5-\\uDDAA\\uDDAE-\\uDDCA\\uDDCD-\\uDDFF\\uDE70-\\uDE73\\uDE78-\\uDE7A\\uDE80-\\uDE82\\uDE90-\\uDE95])|(?:[#\\*0-9\\xA9\\xAE\\u203C\\u2049\\u2122\\u2139\\u2194-\\u2199\\u21A9\\u21AA\\u231A\\u231B\\u2328\\u23CF\\u23E9-\\u23F3\\u23F8-\\u23FA\\u24C2\\u25AA\\u25AB\\u25B6\\u25C0\\u25FB-\\u25FE\\u2600-\\u2604\\u260E\\u2611\\u2614\\u2615\\u2618\\u261D\\u2620\\u2622\\u2623\\u2626\\u262A\\u262E\\u262F\\u2638-\\u263A\\u2640\\u2642\\u2648-\\u2653\\u265F\\u2660\\u2663\\u2665\\u2666\\u2668\\u267B\\u267E\\u267F\\u2692-\\u2697\\u2699\\u269B\\u269C\\u26A0\\u26A1\\u26AA\\u26AB\\u26B0\\u26B1\\u26BD\\u26BE\\u26C4\\u26C5\\u26C8\\u26CE\\u26CF\\u26D1\\u26D3\\u26D4\\u26E9\\u26EA\\u26F0-\\u26F5\\u26F7-\\u26FA\\u26FD\\u2702\\u2705\\u2708-\\u270D\\u270F\\u2712\\u2714\\u2716\\u271D\\u2721\\u2728\\u2733\\u2734\\u2744\\u2747\\u274C\\u274E\\u2753-\\u2755\\u2757\\u2763\\u2764\\u2795-\\u2797\\u27A1\\u27B0\\u27BF\\u2934\\u2935\\u2B05-\\u2B07\\u2B1B\\u2B1C\\u2B50\\u2B55\\u3030\\u303D\\u3297\\u3299]|\\uD83C[\\uDC04\\uDCCF\\uDD70\\uDD71\\uDD7E\\uDD7F\\uDD8E\\uDD91-\\uDD9A\\uDDE6-\\uDDFF\\uDE01\\uDE02\\uDE1A\\uDE2F\\uDE32-\\uDE3A\\uDE50\\uDE51\\uDF00-\\uDF21\\uDF24-\\uDF93\\uDF96\\uDF97\\uDF99-\\uDF9B\\uDF9E-\\uDFF0\\uDFF3-\\uDFF5\\uDFF7-\\uDFFF]|\\uD83D[\\uDC00-\\uDCFD\\uDCFF-\\uDD3D\\uDD49-\\uDD4E\\uDD50-\\uDD67\\uDD6F\\uDD70\\uDD73-\\uDD7A\\uDD87\\uDD8A-\\uDD8D\\uDD90\\uDD95\\uDD96\\uDDA4\\uDDA5\\uDDA8\\uDDB1\\uDDB2\\uDDBC\\uDDC2-\\uDDC4\\uDDD1-\\uDDD3\\uDDDC-\\uDDDE\\uDDE1\\uDDE3\\uDDE8\\uDDEF\\uDDF3\\uDDFA-\\uDE4F\\uDE80-\\uDEC5\\uDECB-\\uDED2\\uDED5\\uDEE0-\\uDEE5\\uDEE9\\uDEEB\\uDEEC\\uDEF0\\uDEF3-\\uDEFA\\uDFE0-\\uDFEB]|\\uD83E[\\uDD0D-\\uDD3A\\uDD3C-\\uDD45\\uDD47-\\uDD71\\uDD73-\\uDD76\\uDD7A-\\uDDA2\\uDDA5-\\uDDAA\\uDDAE-\\uDDCA\\uDDCD-\\uDDFF\\uDE70-\\uDE73\\uDE78-\\uDE7A\\uDE80-\\uDE82\\uDE90-\\uDE95])\\uFE0F|(?:[\\u261D\\u26F9\\u270A-\\u270D]|\\uD83C[\\uDF85\\uDFC2-\\uDFC4\\uDFC7\\uDFCA-\\uDFCC]|\\uD83D[\\uDC42\\uDC43\\uDC46-\\uDC50\\uDC66-\\uDC78\\uDC7C\\uDC81-\\uDC83\\uDC85-\\uDC87\\uDC8F\\uDC91\\uDCAA\\uDD74\\uDD75\\uDD7A\\uDD90\\uDD95\\uDD96\\uDE45-\\uDE47\\uDE4B-\\uDE4F\\uDEA3\\uDEB4-\\uDEB6\\uDEC0\\uDECC]|\\uD83E[\\uDD0F\\uDD18-\\uDD1F\\uDD26\\uDD30-\\uDD39\\uDD3C-\\uDD3E\\uDDB5\\uDDB6\\uDDB8\\uDDB9\\uDDBB\\uDDCD-\\uDDCF\\uDDD1-\\uDDDD])/g}})),ft=T((function(e,r){!function(){"use strict";var e={name:"doT",version:"1.1.1",templateSettings:{evaluate:/\\{\\{([\\s\\S]+?(\\}?)+)\\}\\}/g,interpolate:/\\{\\{=([\\s\\S]+?)\\}\\}/g,encode:/\\{\\{!([\\s\\S]+?)\\}\\}/g,use:/\\{\\{#([\\s\\S]+?)\\}\\}/g,useParams:/(^|[^\\w$])def(?:\\.|\\[[\\\'\\"])([\\w$\\.]+)(?:[\\\'\\"]\\])?\\s*\\:\\s*([\\w$\\.]+|\\"[^\\"]+\\"|\\\'[^\\\']+\\\'|\\{[^\\}]+\\})/g,define:/\\{\\{##\\s*([\\w\\.$]+)\\s*(\\:|=)([\\s\\S]+?)#\\}\\}/g,defineParams:/^\\s*([\\w$]+):([\\s\\S]+)/,conditional:/\\{\\{\\?(\\?)?\\s*([\\s\\S]*?)\\s*\\}\\}/g,iterate:/\\{\\{~\\s*(?:\\}\\}|([\\s\\S]+?)\\s*\\:\\s*([\\w$]+)\\s*(?:\\:\\s*([\\w$]+))?\\s*\\}\\})/g,varname:"it",strip:!0,append:!0,selfcontained:!1,doNotSkipEncoded:!1},template:void 0,compile:void 0,log:!0};!function(){if("object"!==("undefined"==typeof globalThis?"undefined":n(globalThis)))try{Object.defineProperty(Object.prototype,"__magic__",{get:function(){return this},configurable:!0}),__magic__.globalThis=__magic__,delete Object.prototype.__magic__}catch(e){t.globalThis=function(){if("undefined"!=typeof self)return self;if(void 0!==t)return t;if(void 0!==a)return a;if(void 0!==this)return this;throw new Error("Unable to locate global `this`")}()}}(),e.encodeHTMLSource=function(e){var t={"&":"&#38;","<":"&#60;",">":"&#62;",\'"\':"&#34;","\'":"&#39;","/":"&#47;"},a=e?/[&<>"\'\\/]/g:/&(?!#?\\w+;)|<|>|"|\'|\\//g;return function(e){return e?e.toString().replace(a,(function(e){return t[e]||e})):""}},void 0!==r&&r.exports?r.exports=e:"function"==typeof define&&define.amd?define((function(){return e})):globalThis.doT=e;var o={append:{start:"\'+(",end:")+\'",startencode:"\'+encodeHTML("},split:{start:"\';out+=(",end:");out+=\'",startencode:"\';out+=encodeHTML("}},i=/$^/;function l(e){return e.replace(/\\\\(\'|\\\\)/g,"$1").replace(/[\\r\\t\\n]/g," ")}e.template=function(t,a,r){var n,s,u=(a=a||e.templateSettings).append?o.append:o.split,c=0;t=a.use||a.define?function e(t,a,r){return("string"==typeof a?a:a.toString()).replace(t.define||i,(function(e,a,n,o){return(a=0===a.indexOf("def.")?a.substring(4):a)in r||(":"===n?(t.defineParams&&o.replace(t.defineParams,(function(e,t,n){r[a]={arg:t,text:n}})),a in r||(r[a]=o)):new Function("def","def[\'"+a+"\']="+o)(r)),""})).replace(t.use||i,(function(a,n){return t.useParams&&(n=n.replace(t.useParams,(function(e,t,a,n){if(r[a]&&r[a].arg&&n){var o=(a+":"+n).replace(/\'|\\\\/g,"_");return r.__exp=r.__exp||{},r.__exp[o]=r[a].text.replace(new RegExp("(^|[^\\\\w$])"+r[a].arg+"([^\\\\w$])","g"),"$1"+n+"$2"),t+"def.__exp[\'"+o+"\']"}}))),(n=new Function("def","return "+n)(r))&&e(t,n,r)}))}(a,t,r||{}):t,t=("var out=\'"+(a.strip?t.replace(/(^|\\r|\\n)\\t* +| +\\t*(\\r|\\n|$)/g," ").replace(/\\r|\\n|\\t|\\/\\*[\\s\\S]*?\\*\\//g,""):t).replace(/\'|\\\\/g,"\\\\$&").replace(a.interpolate||i,(function(e,t){return u.start+l(t)+u.end})).replace(a.encode||i,(function(e,t){return n=!0,u.startencode+l(t)+u.end})).replace(a.conditional||i,(function(e,t,a){return t?a?"\';}else if("+l(a)+"){out+=\'":"\';}else{out+=\'":a?"\';if("+l(a)+"){out+=\'":"\';}out+=\'"})).replace(a.iterate||i,(function(e,t,a,r){return t?(c+=1,s=r||"i"+c,t=l(t),"\';var arr"+c+"="+t+";if(arr"+c+"){var "+a+","+s+"=-1,l"+c+"=arr"+c+".length-1;while("+s+"<l"+c+"){"+a+"=arr"+c+"["+s+"+=1];out+=\'"):"\';} } out+=\'"})).replace(a.evaluate||i,(function(e,t){return"\';"+l(t)+"out+=\'"}))+"\';return out;").replace(/\\n/g,"\\\\n").replace(/\\t/g,"\\\\t").replace(/\\r/g,"\\\\r").replace(/(\\s|;|\\}|^|\\{)out\\+=\'\';/g,"$1").replace(/\\+\'\'/g,"");n&&(a.selfcontained||!globalThis||globalThis._encodeHTML||(globalThis._encodeHTML=e.encodeHTMLSource(a.doNotSkipEncoded)),t="var encodeHTML = typeof _encodeHTML !== \'undefined\' ? _encodeHTML : ("+e.encodeHTMLSource.toString()+"("+(a.doNotSkipEncoded||"")+"));"+t);try{return new Function(a.varname,t)}catch(a){throw"undefined"!=typeof console&&console.log("Could not create a template function: "+t),a}},e.compile=function(t,a){return e.template(t,null,a)}}()})),mt=T((function(e,o){var i;i=function(){"use strict";function e(e){return"function"==typeof e}var o=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)},i=0,l=void 0,s=void 0,u=function(e,t){h[i]=e,h[i+1]=t,2===(i+=2)&&(s?s(g):w())},c=void 0!==t?t:void 0,d=(f=c||{}).MutationObserver||f.WebKitMutationObserver,p="undefined"==typeof self&&"undefined"!=typeof process&&"[object process]"==={}.toString.call(process),f="undefined"!=typeof Uint8ClampedArray&&"undefined"!=typeof importScripts&&"undefined"!=typeof MessageChannel;function m(){var e=setTimeout;return function(){return e(g,1)}}var h=new Array(1e3);function g(){for(var e=0;e<i;e+=2)(0,h[e])(h[e+1]),h[e]=void 0,h[e+1]=void 0;i=0}var b,y,v,D,w=void 0;function x(e,t){var a=this,r=new this.constructor(C);void 0===r[A]&&B(r);var n,o=a._state;return o?(n=arguments[o-1],u((function(){return P(o,r,n,a._result)}))):O(a,r,e,t),r}function E(e){if(e&&"object"===n(e)&&e.constructor===this)return e;var t=new this(C);return R(t,e),t}w=p?function(){return process.nextTick(g)}:d?(y=0,v=new d(g),D=r.createTextNode(""),v.observe(D,{characterData:!0}),function(){D.data=y=++y%2}):f?((b=new MessageChannel).port1.onmessage=g,function(){return b.port2.postMessage(0)}):(void 0===c?function(){try{var e=Function("return this")().require("vertx");return void 0!==(l=e.runOnLoop||e.runOnContext)?function(){l(g)}:m()}catch(e){return m()}}:m)();var A=Math.random().toString(36).substring(2);function C(){}var F=void 0;function k(t,a,r){var n,o;a.constructor===t.constructor&&r===x&&a.constructor.resolve===E?(n=t,1===(o=a)._state?N(n,o._result):2===o._state?_(n,o._result):O(o,void 0,(function(e){return R(n,e)}),(function(e){return _(n,e)}))):void 0!==r&&e(r)?function(e,t,a){u((function(e){var r=!1,n=function(e,t,a,r){try{e.call(t,a,r)}catch(e){return e}}(a,t,(function(a){r||(r=!0,(t!==a?R:N)(e,a))}),(function(t){r||(r=!0,_(e,t))}),e._label);!r&&n&&(r=!0,_(e,n))}),e)}(t,a,r):N(t,a)}function R(e,t){if(e===t)_(e,new TypeError("You cannot resolve a promise with itself"));else if(r=n(a=t),null===a||"object"!==r&&"function"!==r)N(e,t);else{r=void 0;try{r=t.then}catch(t){return void _(e,t)}k(e,t,r)}var a,r}function T(e){e._onerror&&e._onerror(e._result),S(e)}function N(e,t){e._state===F&&(e._result=t,e._state=1,0!==e._subscribers.length&&u(S,e))}function _(e,t){e._state===F&&(e._state=2,e._result=t,u(T,e))}function O(e,t,a,r){var n=e._subscribers,o=n.length;e._onerror=null,n[o]=t,n[o+1]=a,n[o+2]=r,0===o&&e._state&&u(S,e)}function S(e){var t=e._subscribers,a=e._state;if(0!==t.length){for(var r,n=void 0,o=e._result,i=0;i<t.length;i+=3)r=t[i],n=t[i+a],r?P(a,r,n,o):n(o);e._subscribers.length=0}}function P(t,a,r,n){var o=e(r),i=void 0,l=void 0,s=!0;if(o){try{i=r(n)}catch(t){s=!1,l=t}if(a===i)return void _(a,new TypeError("A promises callback cannot return that same promise."))}else i=n;a._state!==F||(o&&s?R(a,i):!1===s?_(a,l):1===t?N(a,i):2===t&&_(a,i))}var I=0;function B(e){e[A]=I++,e._state=void 0,e._result=void 0,e._subscribers=[]}var L=(q.prototype._enumerate=function(e){for(var t=0;this._state===F&&t<e.length;t++)this._eachEntry(e[t],t)},q.prototype._eachEntry=function(e,t){var a=this._instanceConstructor,r=a.resolve;if(r===E){var n,o=void 0,i=void 0,l=!1;try{o=e.then}catch(t){l=!0,i=t}o===x&&e._state!==F?this._settledAt(e._state,t,e._result):"function"!=typeof o?(this._remaining--,this._result[t]=e):a===M?(n=new a(C),l?_(n,i):k(n,e,o),this._willSettleAt(n,t)):this._willSettleAt(new a((function(t){return t(e)})),t)}else this._willSettleAt(r(e),t)},q.prototype._settledAt=function(e,t,a){var r=this.promise;r._state===F&&(this._remaining--,2===e?_(r,a):this._result[t]=a),0===this._remaining&&N(r,this._result)},q.prototype._willSettleAt=function(e,t){var a=this;O(e,void 0,(function(e){return a._settledAt(1,t,e)}),(function(e){return a._settledAt(2,t,e)}))},q);function q(e,t){this._instanceConstructor=e,this.promise=new e(C),this.promise[A]||B(this.promise),o(t)?(this.length=t.length,this._remaining=t.length,this._result=new Array(this.length),0===this.length?N(this.promise,this._result):(this.length=this.length||0,this._enumerate(t),0===this._remaining&&N(this.promise,this._result))):_(this.promise,new Error("Array Methods must be provided an Array"))}var M=(j.prototype.catch=function(e){return this.then(null,e)},j.prototype.finally=function(t){var a=this.constructor;return e(t)?this.then((function(e){return a.resolve(t()).then((function(){return e}))}),(function(e){return a.resolve(t()).then((function(){throw e}))})):this.then(t,t)},j);function j(e){this[A]=I++,this._result=this._state=void 0,this._subscribers=[],C!==e&&("function"!=typeof e&&function(){throw new TypeError("You must pass a resolver function as the first argument to the promise constructor")}(),this instanceof j?function(e,t){try{t((function(t){R(e,t)}),(function(t){_(e,t)}))}catch(t){_(e,t)}}(this,e):function(){throw new TypeError("Failed to construct \'Promise\': Please use the \'new\' operator, this object constructor cannot be called as a function.")}())}return M.prototype.then=x,M.all=function(e){return new L(this,e).promise},M.race=function(e){var t=this;return o(e)?new t((function(a,r){for(var n=e.length,o=0;o<n;o++)t.resolve(e[o]).then(a,r)})):new t((function(e,t){return t(new TypeError("You must pass an array to race."))}))},M.resolve=E,M.reject=function(e){var t=new this(C);return _(t,e),t},M._setScheduler=function(e){s=e},M._setAsap=function(e){u=e},M._asap=u,M.polyfill=function(){var e=void 0;if(void 0!==a)e=a;else if("undefined"!=typeof self)e=self;else try{e=Function("return this")()}catch(e){throw new Error("polyfill failed because global object is unavailable in this environment")}var t=e.Promise;if(t){var r=null;try{r=Object.prototype.toString.call(t.resolve())}catch(e){}if("[object Promise]"===r&&!t.cast)return}e.Promise=M},M.Promise=M},"object"===n(e=e)&&void 0!==o?o.exports=i():"function"==typeof define&&define.amd?define(i):e.ES6Promise=i()})),ht=T((function(e){var t,a,r=(t=Object.prototype.toString,a=Object.prototype.hasOwnProperty,{Class:function(e){return t.call(e).replace(/^\\[object *|\\]$/g,"")},HasProperty:function(e,t){return t in e},HasOwnProperty:function(e,t){return a.call(e,t)},IsCallable:function(e){return"function"==typeof e},ToInt32:function(e){return e>>0},ToUint32:function(e){return e>>>0}}),o=Math.LN2,i=Math.abs,l=Math.floor,s=Math.log,u=Math.min,c=Math.pow,d=Math.round;function p(e){if(g&&h)for(var t=g(e),a=0;a<t.length;a+=1)h(e,t[a],{value:e[t[a]],writable:!1,enumerable:!1,configurable:!1})}var f,m,h=Object.defineProperty&&function(){try{return Object.defineProperty({},"x",{}),1}catch(e){return}}()?Object.defineProperty:function(e,t,a){if(!e===Object(e))throw new TypeError("Object.defineProperty called on non-object");return r.HasProperty(a,"get")&&Object.prototype.__defineGetter__&&Object.prototype.__defineGetter__.call(e,t,a.get),r.HasProperty(a,"set")&&Object.prototype.__defineSetter__&&Object.prototype.__defineSetter__.call(e,t,a.set),r.HasProperty(a,"value")&&(e[t]=a.value),e},g=Object.getOwnPropertyNames||function(e){if(e!==Object(e))throw new TypeError("Object.getOwnPropertyNames called on non-object");var t,a=[];for(t in e)r.HasOwnProperty(e,t)&&a.push(t);return a};function b(e){if(h){if(e.length>1e5)throw new RangeError("Array too large for polyfill");for(var t=0;t<e.length;t+=1)!function(t){h(e,t,{get:function(){return e._getter(t)},set:function(a){e._setter(t,a)},enumerable:!0,configurable:!1})}(t)}}function y(e,t){return e<<(t=32-t)>>t}function v(e,t){return e<<(t=32-t)>>>t}function D(e){return[255&e]}function w(e){return y(e[0],8)}function x(e){return[255&e]}function E(e){return v(e[0],8)}function A(e){return[(e=d(Number(e)))<0?0:255<e?255:255&e]}function C(e){return[e>>8&255,255&e]}function F(e){return y(e[0]<<8|e[1],16)}function k(e){return[e>>8&255,255&e]}function R(e){return v(e[0]<<8|e[1],16)}function T(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}function N(e){return y(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)}function _(e){return[e>>24&255,e>>16&255,e>>8&255,255&e]}function O(e){return v(e[0]<<24|e[1]<<16|e[2]<<8|e[3],32)}function S(e,t,a){var r,n,d,p,f,m,h,g=(1<<t-1)-1;function b(e){var t=l(e);return(e=e-t)<.5||!(.5<e||t%2)?t:t+1}for(e!=e?(n=(1<<t)-1,d=c(2,a-1),r=0):e===1/0||e===-1/0?(n=(1<<t)-1,r=e<(d=0)?1:0):0===e?r=1/e==-1/(d=n=0)?1:0:(r=e<0,(e=i(e))>=c(2,1-g)?(n=u(l(s(e)/o),1023),2<=(d=b(e/c(2,n)*c(2,a)))/c(2,a)&&(n+=1,d=1),g<n?(n=(1<<t)-1,d=0):(n+=g,d-=c(2,a))):(n=0,d=b(e/c(2,1-g-a)))),f=[],p=a;p;--p)f.push(d%2?1:0),d=l(d/2);for(p=t;p;--p)f.push(n%2?1:0),n=l(n/2);for(f.push(r?1:0),f.reverse(),m=f.join(""),h=[];m.length;)h.push(parseInt(m.substring(0,8),2)),m=m.substring(8);return h}function P(e,t,a){for(var r,n,o,i,l,s,u=[],d=e.length;d;--d)for(n=e[d-1],r=8;r;--r)u.push(n%2?1:0),n>>=1;return u.reverse(),s=u.join(""),o=(1<<t-1)-1,i=parseInt(s.substring(0,1),2)?-1:1,l=parseInt(s.substring(1,1+t),2),s=parseInt(s.substring(1+t),2),l===(1<<t)-1?0!==s?NaN:1/0*i:0<l?i*c(2,l-o)*(1+s/c(2,a)):0!==s?i*c(2,-(o-1))*(s/c(2,a)):i<0?-0:0}function I(e){return P(e,11,52)}function B(e){return S(e,11,52)}function L(e){return P(e,8,23)}function q(e){return S(e,8,23)}function M(e,t){return r.IsCallable(e.get)?e.get(t):e[t]}function j(t){return function(a,n){if((a=r.ToUint32(a))+t.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");a+=this.byteOffset;for(var o=new e.Uint8Array(this.buffer,a,t.BYTES_PER_ELEMENT),i=[],l=0;l<t.BYTES_PER_ELEMENT;l+=1)i.push(M(o,l));return Boolean(n)===Boolean(f)&&i.reverse(),M(new t(new e.Uint8Array(i).buffer),0)}}function U(t){return function(a,n,o){if((a=r.ToUint32(a))+t.BYTES_PER_ELEMENT>this.byteLength)throw new RangeError("Array index out of range");n=new t([n]);for(var i=new e.Uint8Array(n.buffer),l=[],s=0;s<t.BYTES_PER_ELEMENT;s+=1)l.push(M(i,s));Boolean(o)===Boolean(f)&&l.reverse(),new e.Uint8Array(this.buffer,a,t.BYTES_PER_ELEMENT).set(l)}}!function(){function t(e){if((e=r.ToInt32(e))<0)throw new RangeError("ArrayBuffer size is not a small enough positive integer");var t;for(this.byteLength=e,this._bytes=[],this._bytes.length=e,t=0;t<this.byteLength;t+=1)this._bytes[t]=0;p(this)}function a(){}function o(e,o,i){var l=function(e,a,o){var i,s,u,c;if(arguments.length&&"number"!=typeof e)if("object"===n(e)&&e.constructor===l)for(this.length=(i=e).length,this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new t(this.byteLength),u=this.byteOffset=0;u<this.length;u+=1)this._setter(u,i._getter(u));else if("object"!==n(e)||e instanceof t||"ArrayBuffer"===r.Class(e)){if("object"!==n(e)||!(e instanceof t||"ArrayBuffer"===r.Class(e)))throw new TypeError("Unexpected argument type(s)");if(this.buffer=e,this.byteOffset=r.ToUint32(a),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteOffset%this.BYTES_PER_ELEMENT)throw new RangeError("ArrayBuffer length minus the byteOffset is not a multiple of the element size.");if(arguments.length<3){if(this.byteLength=this.buffer.byteLength-this.byteOffset,this.byteLength%this.BYTES_PER_ELEMENT)throw new RangeError("length of buffer minus byteOffset not a multiple of the element size");this.length=this.byteLength/this.BYTES_PER_ELEMENT}else this.length=r.ToUint32(o),this.byteLength=this.length*this.BYTES_PER_ELEMENT;if(this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer")}else for(this.length=r.ToUint32((s=e).length),this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new t(this.byteLength),u=this.byteOffset=0;u<this.length;u+=1)c=s[u],this._setter(u,Number(c));else{if(this.length=r.ToInt32(e),o<0)throw new RangeError("ArrayBufferView size is not a small enough positive integer");this.byteLength=this.length*this.BYTES_PER_ELEMENT,this.buffer=new t(this.byteLength),this.byteOffset=0}this.constructor=l,p(this),b(this)};return l.prototype=new a,l.prototype.BYTES_PER_ELEMENT=e,l.prototype._pack=o,l.prototype._unpack=i,l.BYTES_PER_ELEMENT=e,l.prototype._getter=function(e){if(arguments.length<1)throw new SyntaxError("Not enough arguments");if(!((e=r.ToUint32(e))>=this.length)){for(var t=[],a=0,n=this.byteOffset+e*this.BYTES_PER_ELEMENT;a<this.BYTES_PER_ELEMENT;a+=1,n+=1)t.push(this.buffer._bytes[n]);return this._unpack(t)}},l.prototype.get=l.prototype._getter,l.prototype._setter=function(e,t){if(arguments.length<2)throw new SyntaxError("Not enough arguments");if(!((e=r.ToUint32(e))>=this.length))for(var a=this._pack(t),n=0,o=this.byteOffset+e*this.BYTES_PER_ELEMENT;n<this.BYTES_PER_ELEMENT;n+=1,o+=1)this.buffer._bytes[o]=a[n]},l.prototype.set=function(e,t){if(arguments.length<1)throw new SyntaxError("Not enough arguments");var a,o,i,l,s,u,c,d,p,f;if("object"===n(e)&&e.constructor===this.constructor){if(a=e,(i=r.ToUint32(t))+a.length>this.length)throw new RangeError("Offset plus length of array is out of range");if(d=this.byteOffset+i*this.BYTES_PER_ELEMENT,p=a.length*this.BYTES_PER_ELEMENT,a.buffer===this.buffer){for(f=[],s=0,u=a.byteOffset;s<p;s+=1,u+=1)f[s]=a.buffer._bytes[u];for(s=0,c=d;s<p;s+=1,c+=1)this.buffer._bytes[c]=f[s]}else for(s=0,u=a.byteOffset,c=d;s<p;s+=1,u+=1,c+=1)this.buffer._bytes[c]=a.buffer._bytes[u]}else{if("object"!==n(e)||void 0===e.length)throw new TypeError("Unexpected argument type(s)");if(l=r.ToUint32((o=e).length),(i=r.ToUint32(t))+l>this.length)throw new RangeError("Offset plus length of array is out of range");for(s=0;s<l;s+=1)u=o[s],this._setter(i+s,Number(u))}},l.prototype.subarray=function(e,t){function a(e,t,a){return e<t?t:a<e?a:e}e=r.ToInt32(e),t=r.ToInt32(t),arguments.length<1&&(e=0),arguments.length<2&&(t=this.length),e<0&&(e=this.length+e),t<0&&(t=this.length+t),e=a(e,0,this.length);var n=(t=a(t,0,this.length))-e;return new this.constructor(this.buffer,this.byteOffset+e*this.BYTES_PER_ELEMENT,n=n<0?0:n)},l}e.ArrayBuffer=e.ArrayBuffer||t;var i=o(1,D,w),l=o(1,x,E),s=o(1,A,E),u=o(2,C,F),c=o(2,k,R),d=o(4,T,N),f=o(4,_,O),m=o(4,q,L),h=o(8,B,I);e.Int8Array=e.Int8Array||i,e.Uint8Array=e.Uint8Array||l,e.Uint8ClampedArray=e.Uint8ClampedArray||s,e.Int16Array=e.Int16Array||u,e.Uint16Array=e.Uint16Array||c,e.Int32Array=e.Int32Array||d,e.Uint32Array=e.Uint32Array||f,e.Float32Array=e.Float32Array||m,e.Float64Array=e.Float64Array||h}(),m=new e.Uint16Array([4660]),f=18===M(new e.Uint8Array(m.buffer),0),(m=function(t,a,n){if(0===arguments.length)t=new e.ArrayBuffer(0);else if(!(t instanceof e.ArrayBuffer||"ArrayBuffer"===r.Class(t)))throw new TypeError("TypeError");if(this.buffer=t||new e.ArrayBuffer(0),this.byteOffset=r.ToUint32(a),this.byteOffset>this.buffer.byteLength)throw new RangeError("byteOffset out of range");if(this.byteLength=arguments.length<3?this.buffer.byteLength-this.byteOffset:r.ToUint32(n),this.byteOffset+this.byteLength>this.buffer.byteLength)throw new RangeError("byteOffset and length reference an area beyond the end of the buffer");p(this)}).prototype.getUint8=j(e.Uint8Array),m.prototype.getInt8=j(e.Int8Array),m.prototype.getUint16=j(e.Uint16Array),m.prototype.getInt16=j(e.Int16Array),m.prototype.getUint32=j(e.Uint32Array),m.prototype.getInt32=j(e.Int32Array),m.prototype.getFloat32=j(e.Float32Array),m.prototype.getFloat64=j(e.Float64Array),m.prototype.setUint8=U(e.Uint8Array),m.prototype.setInt8=U(e.Int8Array),m.prototype.setUint16=U(e.Uint16Array),m.prototype.setInt16=U(e.Int16Array),m.prototype.setUint32=U(e.Uint32Array),m.prototype.setInt32=U(e.Int32Array),m.prototype.setFloat32=U(e.Float32Array),m.prototype.setFloat64=U(e.Float64Array),e.DataView=e.DataView||m})),gt=T((function(e){!function(e){"use strict";var t,a,r;function o(){if(void 0===this)throw new TypeError("Constructor WeakMap requires \'new\'");if(r(this,"_id","_WeakMap_"+l()+"."+l()),0<arguments.length)throw new TypeError("WeakMap iterable is not supported")}function i(e,a){if(!s(e)||!t.call(e,"_id"))throw new TypeError(a+" method called on incompatible receiver "+n(e))}function l(){return Math.random().toString().substring(2)}function s(e){return Object(e)===e}e.WeakMap||(t=Object.prototype.hasOwnProperty,a=Object.defineProperty&&function(){try{return 1===Object.defineProperty({},"x",{value:1}).x}catch(e){}}(),e.WeakMap=((r=function(e,t,r){a?Object.defineProperty(e,t,{configurable:!0,writable:!0,value:r}):e[t]=r})(o.prototype,"delete",(function(e){if(i(this,"delete"),!s(e))return!1;var t=e[this._id];return!(!t||t[0]!==e||(delete e[this._id],0))})),r(o.prototype,"get",(function(e){if(i(this,"get"),s(e)){var t=e[this._id];return t&&t[0]===e?t[1]:void 0}})),r(o.prototype,"has",(function(e){if(i(this,"has"),!s(e))return!1;var t=e[this._id];return!(!t||t[0]!==e)})),r(o.prototype,"set",(function(e,t){if(i(this,"set"),!s(e))throw new TypeError("Invalid value used as weak map key");var a=e[this._id];return a&&a[0]===e?a[1]=t:r(e,this._id,[e,t]),this})),r(o,"_polyfill",!0),o))}("undefined"!=typeof globalThis?globalThis:"undefined"!=typeof self?self:void 0!==t?t:void 0!==a?a:e)})),bt={helpUrlBase:"https://dequeuniversity.com/rules/",results:[],resultGroups:[],resultGroupMap:{},impact:Object.freeze(["minor","moderate","serious","critical"]),preload:Object.freeze({assets:["cssom","media"],timeout:1e4}),allOrigins:"<unsafe_all_origins>",sameOrigin:"<same_origin>"};[{name:"NA",value:"inapplicable",priority:0,group:"inapplicable"},{name:"PASS",value:"passed",priority:1,group:"passes"},{name:"CANTTELL",value:"cantTell",priority:2,group:"incomplete"},{name:"FAIL",value:"failed",priority:3,group:"violations"}].forEach((function(e){var t=e.name,a=e.value,r=e.priority;e=e.group;bt[t]=a,bt[t+"_PRIO"]=r,bt[t+"_GROUP"]=e,bt.results[r]=a,bt.resultGroups[r]=e,bt.resultGroupMap[a]=e})),Object.freeze(bt.results),Object.freeze(bt.resultGroups),Object.freeze(bt.resultGroupMap),Object.freeze(bt);var yt=bt,vt=function(){"object"===("undefined"==typeof console?"undefined":n(console))&&console.log&&Function.prototype.apply.call(console.log,console,arguments)},Dt=/[\\t\\r\\n\\f]/g;function wt(){w(this,wt),this.parent=void 0}var xt=(E(wt,[{key:"props",get:function(){throw new Error(\'VirtualNode class must have a "props" object consisting of "nodeType" and "nodeName" properties\')}},{key:"attrNames",get:function(){throw new Error(\'VirtualNode class must have an "attrNames" property\')}},{key:"attr",value:function(){throw new Error(\'VirtualNode class must have an "attr" function\')}},{key:"hasAttr",value:function(){throw new Error(\'VirtualNode class must have a "hasAttr" function\')}},{key:"hasClass",value:function(e){var t=this.attr("class");return!!t&&(e=" "+e+" ",0<=(" "+t+" ").replace(Dt," ").indexOf(e))}}]),wt),Et={};N(Et,{DqElement:function(){return Ua},aggregate:function(){return aa},aggregateChecks:function(){return sa},aggregateNodeResults:function(){return ca},aggregateResult:function(){return pa},areStylesSet:function(){return fa},assert:function(){return Ft},checkHelper:function(){return Va},clone:function(){return Ha},closest:function(){return er},collectResultsFromFrames:function(){return hr},contains:function(){return gr},convertSelector:function(){return Ja},cssParser:function(){return $a},deepMerge:function(){return br},escapeSelector:function(){return ha},extendMetaData:function(){return yr},filterHtmlAttrs:function(){return jo},finalizeRuleResult:function(){return ua},findBy:function(){return pr},getAllChecks:function(){return dr},getAncestry:function(){return Ia},getBaseLang:function(){return jn},getCheckMessage:function(){return Kn},getCheckOption:function(){return Xn},getFlattenedTree:function(){return Mn},getFriendlyUriEnd:function(){return Da},getNodeAttributes:function(){return wa},getNodeFromTree:function(){return Ma},getPreloadConfig:function(){return So},getRootNode:function(){return xr},getRule:function(){return Jn},getScroll:function(){return Qn},getScrollState:function(){return Zn},getSelector:function(){return Sa},getSelectorData:function(){return Ta},getShadowSelector:function(){return Aa},getStandards:function(){return eo},getStyleSheetFactory:function(){return ao},getXpath:function(){return Ba},injectStyle:function(){return ro},isHidden:function(){return no},isHtmlElement:function(){return io},isNodeInContext:function(){return so},isShadowRoot:function(){return Dr},isValidLang:function(){return Go},isXHTML:function(){return Ea},matches:function(){return Za},matchesExpression:function(){return Qa},matchesSelector:function(){return xa},memoize:function(){return fo},mergeResults:function(){return mr},nodeSorter:function(){return mo},parseCrossOriginStylesheet:function(){return bo},parseSameOriginStylesheet:function(){return ho},parseStylesheet:function(){return go},performanceTimer:function(){return wo},pollyfillElementsFromPoint:function(){return xo},preload:function(){return Po},preloadCssom:function(){return Ro},preloadMedia:function(){return _o},processMessage:function(){return Yn},publishMetaData:function(){return Bo},querySelectorAll:function(){return Lo},querySelectorAllFilter:function(){return ko},queue:function(){return or},respondable:function(){return lr},ruleShouldRun:function(){return Mo},select:function(){return Uo},sendCommandToFrame:function(){return cr},setScrollState:function(){return Vo},shouldPreload:function(){return Oo},toArray:function(){return ma},tokenList:function(){return Ho},uniqueArray:function(){return Co},uuid:function(){return Yt},validInputTypes:function(){return zo},validLangs:function(){return Wo}});var At=Object.freeze(["EvalError","RangeError","ReferenceError","SyntaxError","TypeError","URIError"]);function Ct(){var e="axeAPI",t="";return(e=void 0!==o&&o._audit&&o._audit.application?o._audit.application:e)+"."+(void 0!==o?o.version:t)}var Ft=function(e,t){if(!e)throw new Error(t)};function kt(e){Tt(e),Ft(t.parent===e,"Source of the response must be the parent window.")}function Rt(e){Tt(e),Ft(e.parent===t,"Respondable target must be a frame in the current window")}function Tt(e){Ft(t!==e,"Messages can not be sent to the same window.")}var Nt,_t,Ot,St,Pt={},It=t.crypto||t.msCrypto;!_t&&It&&It.getRandomValues&&(Nt=new Uint8Array(16),_t=function(){return It.getRandomValues(Nt),Nt});try{_t||(Ot=require("crypto"),_t=function(){return Ot.randomBytes(16)})}catch(k){}_t||(St=new Array(16),_t=function(){for(var e,t=0;t<16;t++)0==(3&t)&&(e=4294967296*Math.random()),St[t]=e>>>((3&t)<<3)&255;return St});for(var Bt="function"==typeof t.Buffer?t.Buffer:Array,Lt=[],qt={},Mt=0;Mt<256;Mt++)Lt[Mt]=(Mt+256).toString(16).substr(1),qt[Lt[Mt]]=Mt;function jt(e,t){return t=t||0,Lt[e[t++]]+Lt[e[t++]]+Lt[e[t++]]+Lt[e[t++]]+"-"+Lt[e[t++]]+Lt[e[t++]]+"-"+Lt[e[t++]]+Lt[e[t++]]+"-"+Lt[e[t++]]+Lt[e[t++]]+"-"+Lt[e[t++]]+Lt[e[t++]]+Lt[e[t++]]+Lt[e[t++]]+Lt[e[t++]]+Lt[e[t++]]}var Ut=_t(),Vt=[1|Ut[0],Ut[1],Ut[2],Ut[3],Ut[4],Ut[5]],Ht=16383&(Ut[6]<<8|Ut[7]),zt=0,$t=0;function Wt(e,t,a){var r=t&&a||0,n=t||[],o=null!=(e=e||{}).clockseq?e.clockseq:Ht,i=null!=e.msecs?e.msecs:(new Date).getTime(),l=null!=e.nsecs?e.nsecs:$t+1;if((a=i-zt+(l-$t)/1e4)<0&&null==e.clockseq&&(o=o+1&16383),1e4<=(l=(a<0||zt<i)&&null==e.nsecs?0:l))throw new Error("uuid.v1(): Can\'t create more than 10M uuids/sec");zt=i,Ht=o,l=(1e4*(268435455&(i+=122192928e5))+($t=l))%4294967296,n[r++]=l>>>24&255,n[r++]=l>>>16&255,n[r++]=l>>>8&255,n[r++]=255&l,i=i/4294967296*1e4&268435455,n[r++]=i>>>8&255,n[r++]=255&i,n[r++]=i>>>24&15|16,n[r++]=i>>>16&255,n[r++]=o>>>8|128,n[r++]=255&o;for(var s=e.node||Vt,u=0;u<6;u++)n[r+u]=s[u];return t||jt(n)}function Gt(e,t,a){var r=t&&a||0;"string"==typeof e&&(t="binary"==e?new Bt(16):null,e=null);var n=(e=e||{}).random||(e.rng||_t)();if(n[6]=15&n[6]|64,n[8]=63&n[8]|128,t)for(var o=0;o<16;o++)t[r+o]=n[o];return t||jt(n)}(hs=Gt).v1=Wt,hs.v4=Gt,hs.parse=function(e,t,a){var r=t&&a||0,n=0;for(t=t||[],e.toLowerCase().replace(/[0-9a-f]{2}/g,(function(e){n<16&&(t[r+n++]=qt[e])}));n<16;)t[r+n++]=0;return t},hs.unparse=jt,hs.BufferClass=Bt,o._uuid=Wt();var Yt=Gt,Kt=[];function Xt(){var e="".concat(Gt(),":").concat(Gt());return Kt.includes(e)?Xt():(Kt.push(e),e)}function Jt(e,t,a,r){if("function"==typeof r&&function(e,t,a){var r=!(2<arguments.length&&void 0!==a)||a;Ft(!Pt[e],"A replyHandler already exists for this message channel."),Pt[e]={replyHandler:t,sendToParent:r}}(t.channelId,r,a),(a?kt:Rt)(e),t.message instanceof Error&&!a)return o.log(t.message),!1;var n=(r=(i=D({messageId:Xt()},t)).topic,a=i.channelId,t=i.message,i={channelId:a,topic:r,messageId:i.messageId,keepalive:!!i.keepalive,source:Ct()},t instanceof Error?i.error={name:t.name,message:t.message,stack:t.stack}:i.payload=t,JSON.stringify(i)),i=o._audit.allowedOrigins;return!(!i||!i.length||(i.forEach((function(t){try{e.postMessage(n,t)}catch(a){if(a instanceof e.DOMException)throw new Error(\'allowedOrigins value "\'.concat(t,\'" is not a valid origin\'));throw a}})),0))}function Qt(e,t,a){var r=!(2<arguments.length&&void 0!==a)||a;return function(a,n,o){Jt(e,{channelId:t,message:a,keepalive:n},r,o)}}function Zt(e,a){var r,i=e.origin,l=e.data,s=e.source,u=function(e){var a;try{a=JSON.parse(e)}catch(e){return}if("object"===n(o=a)&&"string"==typeof o.channelId&&o.source===Ct()){var r=(i=a).topic,o=(e=i.channelId,i.messageId),i=i.keepalive;return{topic:r,message:"object"===n(a.error)?function(e){var a=e.message||"Unknown error occurred",r=At.includes(e.name)?e.name:"Error";return r=t[r]||Error,e.stack&&(a+="\\n"+e.stack.replace(e.message,"")),new r(a)}(a.error):a.payload,messageId:o,channelId:e,keepalive:!!i}}}(l)||{},c=u.channelId,d=u.message;e=u.messageId;if(l=i,((i=o._audit.allowedOrigins)&&i.includes("*")||i.includes(l))&&(e=e,!Kt.includes(e)&&(Kt.push(e),1)))if(d instanceof Error&&s.parent!==t)o.log(d);else try{u.topic?(r=Qt(s,c),kt(s),a(u,r)):function(e,t){var a=t.channelId,r=t.message,n=t.keepalive,i=(t=(i=function(e){return Pt[e]}(a)||{}).replyHandler,i.sendToParent);if(t){(i?kt:Rt)(e),i=Qt(e,a,i),!n&&a&&function(e){delete Pt[e]}(a);try{t(r,n,i)}catch(e){o.log(e),i(e,n)}}}(s,u)}catch(e){!function(e,a,r){if(!e.parent!==t)return o.log(a);try{Jt(e,{topic:null,channelId:r,message:a,messageId:Xt(),keepalive:!0},!0)}catch(e){return o.log(e)}}(s,e,c)}}var ea={open:function(e){if("function"==typeof t.addEventListener){function a(t){Zt(t,e)}return t.addEventListener("message",a,!1),function(){t.removeEventListener("message",a,!1)}}},post:function(e,a,r){return"function"==typeof t.addEventListener&&Jt(e,a,!1,r)}};function ta(e){e.updateMessenger(ea)}var aa=function(e,t,a){return t=t.slice(),a&&t.push(a),t=t.map((function(t){return e.indexOf(t)})).sort(),e[t.pop()]},ra=yt.CANTTELL_PRIO,na=yt.FAIL_PRIO,oa=[];oa[yt.PASS_PRIO]=!0,oa[yt.CANTTELL_PRIO]=null,oa[yt.FAIL_PRIO]=!1;var ia=["any","all","none"];function la(e,t){return ia.reduce((function(a,r){return a[r]=(e[r]||[]).map((function(e){return t(e,r)})),a}),{})}var sa=function(e){var t=Object.assign({},e);la(t,(function(e,t){var a=void 0===e.result?-1:oa.indexOf(e.result);e.priority=-1!==a?a:yt.CANTTELL_PRIO,"none"===t&&(e.priority===yt.PASS_PRIO?e.priority=yt.FAIL_PRIO:e.priority===yt.FAIL_PRIO&&(e.priority=yt.PASS_PRIO))}));var a={all:t.all.reduce((function(e,t){return Math.max(e,t.priority)}),0),none:t.none.reduce((function(e,t){return Math.max(e,t.priority)}),0),any:t.any.reduce((function(e,t){return Math.min(e,t.priority)}),4)%4};t.priority=Math.max(a.all,a.none,a.any);var r=[];return ia.forEach((function(e){t[e]=t[e].filter((function(r){return r.priority===t.priority&&r.priority===a[e]})),t[e].forEach((function(e){return r.push(e.impact)}))})),[ra,na].includes(t.priority)?t.impact=aa(yt.impact,r):t.impact=null,la(t,(function(e){delete e.result,delete e.priority})),t.result=yt.results[t.priority],delete t.priority,t},ua=function(e){var t=o._audit.rules.find((function(t){return t.id===e.id}));return t&&t.impact&&e.nodes.forEach((function(e){["any","all","none"].forEach((function(a){(e[a]||[]).forEach((function(e){e.impact=t.impact}))}))})),Object.assign(e,ca(e.nodes)),delete e.nodes,e},ca=function(e){var t,a={};return(e=e.map((function(e){if(e.any&&e.all&&e.none)return sa(e);if(Array.isArray(e.node))return ua(e);throw new TypeError("Invalid Result type")})))&&e.length?(t=e.map((function(e){return e.result})),a.result=aa(yt.results,t,a.result)):a.result="inapplicable",yt.resultGroups.forEach((function(e){return a[e]=[]})),e.forEach((function(e){var t=yt.resultGroupMap[e.result];a[t].push(e)})),e=yt.FAIL_GROUP,0===a[e].length&&(e=yt.CANTTELL_GROUP),0<a[e].length?(e=a[e].map((function(e){return e.impact})),a.impact=aa(yt.impact,e)||null):a.impact=null,a};function da(e,t,a){var r=Object.assign({},t);r.nodes=(r[a]||[]).concat(),yt.resultGroups.forEach((function(e){delete r[e]})),e[a].push(r)}var pa=function(e){var t={};return yt.resultGroups.forEach((function(e){return t[e]=[]})),e.forEach((function(e){e.error?da(t,e,yt.CANTTELL_GROUP):e.result===yt.NA?da(t,e,yt.NA_GROUP):yt.resultGroups.forEach((function(a){Array.isArray(e[a])&&0<e[a].length&&da(t,e,a)}))})),t},fa=function e(a,r,n){var o=t.getComputedStyle(a,null);if(!o)return!1;for(var i=0;i<r.length;++i){var l=r[i];if(o.getPropertyValue(l.property)===l.value)return!0}return!(!a.parentNode||a.nodeName.toUpperCase()===n.toUpperCase())&&e(a.parentNode,r,n)},ma=function(e){return Array.prototype.slice.call(e)},ha=function(e){for(var t,a=String(e),r=a.length,n=-1,o="",i=a.charCodeAt(0);++n<r;)0!=(t=a.charCodeAt(n))?o+=1<=t&&t<=31||127==t||0==n&&48<=t&&t<=57||1==n&&48<=t&&t<=57&&45==i?"\\\\"+t.toString(16)+" ":0==n&&1==r&&45==t||!(128<=t||45==t||95==t||48<=t&&t<=57||65<=t&&t<=90||97<=t&&t<=122)?"\\\\"+a.charAt(n):a.charAt(n):o+="�";return o};function ga(e,t){return[e.substring(0,t),e.substring(t)]}function ba(e){return e.replace(/\\s+$/,"")}var ya,va,Da=function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:"",t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};if(!(e.length<=1||"data:"===e.substr(0,5)||"javascript:"===e.substr(0,11)||e.includes("?"))){var a,r,n,o,i=t.currentDomain,l=t.maxLength,s=void 0===l?25:l,u=(t=(d=(c=u=d=o=n="",(l=t=e).includes("#")&&(t=(e=v(ga(t,t.indexOf("#")),2))[0],c=e[1]),t.includes("?")&&(t=(a=v(ga(t,t.indexOf("?")),2))[0],u=a[1]),t.includes("://")?(n=(a=v(t.split("://"),2))[0],o=(a=v(ga(t=a[1],t.indexOf("/")),2))[0],t=a[1]):"//"===t.substr(0,2)&&(o=(r=v(ga(t=t.substr(2),t.indexOf("/")),2))[0],t=r[1]),(o="www."===o.substr(0,4)?o.substr(4):o)&&o.includes(":")&&(o=(r=v(ga(o,o.indexOf(":")),2))[0],d=r[1]),{original:l,protocol:n,domain:o,port:d,path:t,query:u,hash:c})).path,d.domain),c=d.hash,d=t.substr(t.substr(0,t.length-2).lastIndexOf("/")+1);return c?d&&(d+c).length<=s?ba(d+c):d.length<2&&2<c.length&&c.length<=s?ba(c):void 0:u&&u.length<s&&t.length<=1||t==="/"+d&&u&&i&&u!==i&&(u+t).length<=s?ba(u+t):(-1===(t=d.lastIndexOf("."))||1<t)&&(-1!==t||2<d.length)&&d.length<=s&&!d.match(/index(\\.[a-zA-Z]{2-4})?/)&&!function(e){var t=0<arguments.length&&void 0!==e?e:"";return 0!==t.length&&(t.match(/[0-9]/g)||"").length>=t.length/2}(d)?ba(d):void 0}},wa=function(e){return(e.attributes instanceof t.NamedNodeMap?e:e.cloneNode(!1)).attributes},xa=function(e,t){return!!e[ya=ya&&e[ya]?ya:function(e){for(var t,a=["matches","matchesSelector","mozMatchesSelector","webkitMatchesSelector","msMatchesSelector"],r=a.length,n=0;n<r;n++)if(e[t=a[n]])return t}(e)]&&e[ya](t)},Ea=function(e){return!!e.createElement&&"A"===e.createElement("A").localName},Aa=function(e,t){var a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};if(!t)return"";var n=t.getRootNode&&t.getRootNode()||r;if(11!==n.nodeType)return e(t,a,n);for(var o=[];11===n.nodeType;){if(!n.host)return"";o.unshift({elm:t,doc:n}),n=(t=n.host).getRootNode()}return o.unshift({elm:t,doc:n}),o.map((function(t){var r=t.elm;t=t.doc;return e(r,a,t)}))},Ca=["class","style","id","selected","checked","disabled","tabindex","aria-checked","aria-selected","aria-invalid","aria-activedescendant","aria-busy","aria-disabled","aria-expanded","aria-grabbed","aria-pressed","aria-valuenow"];function Fa(e,t){var a=t.name;if(-1!==a.indexOf("href")||-1!==a.indexOf("src")){var r=Da(e.getAttribute(a));if(r){var n=encodeURI(r);if(!n)return;n=ha(t.name)+\'$="\'+ha(n)+\'"\'}else n=ha(t.name)+\'="\'+ha(e.getAttribute(a))+\'"\'}else n=ha(a)+\'="\'+ha(t.value)+\'"\';return n}function ka(e,t){return e.count<t.count?-1:e.count===t.count?0:1}function Ra(e){return!Ca.includes(e.name)&&-1===e.name.indexOf(":")&&(!e.value||e.value.length<31)}function Ta(e){for(var t={classes:{},tags:{},attributes:{}},a=(e=Array.isArray(e)?e:[e]).slice(),r=[];a.length;)!function(){var e,n=a.pop(),o=n.actualNode;for(o.querySelectorAll&&(e=o.nodeName,t.tags[e]?t.tags[e]++:t.tags[e]=1,o.classList&&Array.from(o.classList).forEach((function(e){e=ha(e),t.classes[e]?t.classes[e]++:t.classes[e]=1})),o.hasAttributes()&&Array.from(wa(o)).filter(Ra).forEach((function(e){(e=Fa(o,e))&&(t.attributes[e]?t.attributes[e]++:t.attributes[e]=1)}))),n.children.length&&(r.push(a),a=n.children.slice());!a.length&&r.length;)a=r.pop()}();return t}function Na(e){return void 0===va&&(va=Ea(r)),ha(va?e.localName:e.nodeName.toLowerCase())}function _a(e,t){var a,r,n,o,i,l,s,u,c,d="",p=(r=e,n=[],o=t.classes,i=t.tags,r.classList&&Array.from(r.classList).forEach((function(e){e=ha(e),o[e]<i[r.nodeName]&&n.push({name:e,count:o[e],species:"class"})})),n.sort(ka));l=e,s=[],u=t.attributes,c=t.tags,l.hasAttributes()&&Array.from(wa(l)).filter(Ra).forEach((function(e){(e=Fa(l,e))&&u[e]<c[l.nodeName]&&s.push({name:e,count:u[e],species:"attribute"})})),t=s.sort(ka);return p.length&&1===p[0].count?a=[p[0]]:t.length&&1===t[0].count?(a=[t[0]],d=Na(e)):((a=p.concat(t)).sort(ka),(a=a.slice(0,3)).some((function(e){return"class"===e.species}))?a.sort((function(e,t){return e.species!==t.species&&"class"===e.species?-1:e.species===t.species?0:1})):d=Na(e)),d+a.reduce((function(e,t){switch(t.species){case"class":return e+"."+t.name;case"attribute":return e+"["+t.name+"]"}return e}),"")}function Oa(e,t,a){if(!o._selectorData)throw new Error("Expect axe._selectorData to be set up");var n,i,l=void 0!==(t=t.toRoot)&&t;do{var s=function(e){if(e.getAttribute("id")){var t=e.getRootNode&&e.getRootNode()||r;return(e="#"+ha(e.getAttribute("id")||"")).match(/player_uid_/)||1!==t.querySelectorAll(e).length?void 0:e}}(e);s||(s=_a(e,o._selectorData),s+=function(e,t){var a=e.parentNode&&Array.from(e.parentNode.children||"")||[];return a.find((function(a){return a!==e&&xa(a,t)}))?":nth-child("+(1+a.indexOf(e))+")":""}(e,s)),n=n?s+" > "+n:s,i=i?i.filter((function(e){return xa(e,n)})):Array.from(a.querySelectorAll(n)),e=e.parentElement}while((1<i.length||l)&&e&&11!==e.nodeType);return 1===i.length?n:-1!==n.indexOf(" > ")?":root"+n.substring(n.indexOf(" > ")):":root"}function Sa(e,t){return Aa(Oa,e,t)}function Pa(e){var t=e.nodeName.toLowerCase(),a=e.parentElement;if(!a)return t;var r="";return"head"!==t&&"body"!==t&&1<a.children.length&&(e=Array.prototype.indexOf.call(a.children,e)+1,r=":nth-child(".concat(e,")")),Pa(a)+" > "+t+r}function Ia(e,t){return Aa(Pa,e,t)}var Ba=function(e){return function e(t,a){var r,n,o,i;if(!t)return[];if(!a&&9===t.nodeType)return[{str:"html"}];if(a=a||[],t.parentNode&&t.parentNode!==t&&(a=e(t.parentNode,a)),t.previousSibling){for(n=1,r=t.previousSibling;1===r.nodeType&&r.nodeName===t.nodeName&&n++,r=r.previousSibling;);1===n&&(n=null)}else if(t.nextSibling)for(r=t.nextSibling;r=1===r.nodeType&&r.nodeName===t.nodeName?(n=1,null):(n=null,r.previousSibling););return 1===t.nodeType&&((o={}).str=t.nodeName.toLowerCase(),(i=t.getAttribute&&ha(t.getAttribute("id")))&&1===t.ownerDocument.querySelectorAll("#"+i).length&&(o.id=t.getAttribute("id")),1<n&&(o.count=n),a.push(o)),a}(e).reduce((function(e,t){return t.id?"/".concat(t.str,"[@id=\'").concat(t.id,"\']"):e+"/".concat(t.str)+(0<t.count?"[".concat(t.count,"]"):"")}),"")},La={},qa={set:function(e,t){La[e]=t},get:function(e){return La[e]},clear:function(){La={}}},Ma=function(e,t){return e=t||e,qa.get("nodeMap")?qa.get("nodeMap").get(e):null};function ja(e){var t,a,r,n=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};this.spec=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{},e instanceof xt?(this._virtualNode=e,this._element=e.actualNode):(this._element=e,this._virtualNode=Ma(e)),this.fromFrame=1<(null===(t=this.spec.selector)||void 0===t?void 0:t.length),n.absolutePaths&&(this._options={toRoot:!0}),this.nodeIndexes=[],Array.isArray(this.spec.nodeIndexes)?this.nodeIndexes=this.spec.nodeIndexes:"number"==typeof(null===(a=this._virtualNode)||void 0===a?void 0:a.nodeIndex)&&(this.nodeIndexes=[this._virtualNode.nodeIndex]),this.source=null,o._audit.noHtml||(this.source=null!==(n=this.spec.source)&&void 0!==n?n:null!=(a=this._element)&&a.outerHTML?((n=(n=(n=a.outerHTML)||"function"!=typeof XMLSerializer?n:(new XMLSerializer).serializeToString(a))||"").length>(r=r||300)&&(r=n.indexOf(">"),n=n.substring(0,r+1)),n):"")}ja.prototype={get selector(){return this.spec.selector||[Sa(this.element,this._options)]},get ancestry(){return this.spec.ancestry||[Ia(this.element)]},get xpath(){return this.spec.xpath||[Ba(this.element)]},get element(){return this._element},toJSON:function(){return{selector:this.selector,source:this.source,xpath:this.xpath,ancestry:this.ancestry,nodeIndexes:this.nodeIndexes}}},ja.fromFrame=function(e,t,a){return e=D({},e,{selector:[].concat(y(a.selector),y(e.selector)),ancestry:[].concat(y(a.ancestry),y(e.ancestry)),xpath:[].concat(y(a.xpath),y(e.xpath)),nodeIndexes:[].concat(y(a.nodeIndexes),y(e.nodeIndexes))}),new ja(a.element,t,e)};var Ua=ja,Va=function(e,a,r,n){return{isAsync:!1,async:function(){return this.isAsync=!0,function(t){t instanceof Error==0?(e.result=t,r(e)):n(t)}},data:function(t){e.data=t},relatedNodes:function(r){r=r instanceof t.Node?[r]:ma(r),e.relatedNodes=r.map((function(e){return new Ua(e,a)}))}}},Ha=function e(t){var a,r,o=t;if(null!==t&&"object"===n(t))if(Array.isArray(t))for(o=[],a=0,r=t.length;a<r;a++)o[a]=e(t[a]);else for(a in o={},t)o[a]=e(t[a]);return o},za=new(_(I()).CssSelectorParser);za.registerSelectorPseudos("not"),za.registerSelectorPseudos("is"),za.registerNestingOperators(">"),za.registerAttrEqualityMods("^","$","*","~");var $a=za;function Wa(e,t){return s=t,1===(l=e).props.nodeType&&("*"===s.tag||l.props.nodeName===s.tag)&&(o=e,!(i=t).classes||i.classes.every((function(e){return o.hasClass(e.value)})))&&(r=e,!(n=t).attributes||n.attributes.every((function(e){var t=r.attr(e.key);return null!==t&&(!e.value||e.test(t))})))&&(i=e,!(n=t).id||i.props.id===n.id)&&(a=e,!((t=t).pseudos&&!t.pseudos.every((function(e){if("not"===e.name)return!e.expressions.some((function(e){return Qa(a,e)}));if("is"===e.name)return e.expressions.some((function(e){return Qa(a,e)}));throw new Error("the pseudo selector "+e.name+" has not yet been implemented")}))));var a,r,n,o,i,l,s}var Ga,Ya=(Ga=/(?=[\\-\\[\\]{}()*+?.\\\\\\^$|,#\\s])/g,function(e){return e.replace(Ga,"\\\\")}),Ka=/\\\\/g;function Xa(e){return e.map((function(e){for(var t=[],a=e.rule;a;)t.push({tag:a.tagName?a.tagName.toLowerCase():"*",combinator:a.nestingOperator||" ",id:a.id,attributes:function(e){if(e)return e.map((function(e){var t,a,r=e.name.replace(Ka,""),n=(e.value||"").replace(Ka,"");switch(e.operator){case"^=":a=new RegExp("^"+Ya(n));break;case"$=":a=new RegExp(Ya(n)+"$");break;case"~=":a=new RegExp("(^|\\\\s)"+Ya(n)+"(\\\\s|$)");break;case"|=":a=new RegExp("^"+Ya(n)+"(-|$)");break;case"=":t=function(e){return n===e};break;case"*=":t=function(e){return e&&e.includes(n)};break;case"!=":t=function(e){return n!==e};break;default:t=function(e){return!!e}}return""===n&&/^[*$^]=$/.test(e.operator)&&(t=function(){return!1}),{key:r,value:n,test:t=t||function(e){return e&&a.test(e)}}}))}(a.attrs),classes:function(e){if(e)return e.map((function(e){return{value:e=e.replace(Ka,""),regexp:new RegExp("(^|\\\\s)"+Ya(e)+"(\\\\s|$)")}}))}(a.classNames),pseudos:function(e){if(e)return e.map((function(e){var t;return["is","not"].includes(e.name)&&(t=Xa(t=(t=e.value).selectors||[t])),{name:e.name,expressions:t,value:e.value}}))}(a.pseudos)}),a=a.rule;return t}))}function Ja(e){return Xa(e=(e=$a.parse(e)).selectors||[e])}function Qa(e,t,a){for(var r=(t=[].concat(t)).pop(),n=Wa(e,r);!n&&a&&e.parent;)n=Wa(e=e.parent,r);if(t.length){if(!1===[" ",">"].includes(r.combinator))throw new Error("axe.utils.matchesExpression does not support the combinator: "+r.combinator);n=n&&Qa(e.parent,t," "===r.combinator)}return n}var Za=function(e,t){return Ja(t).some((function(t){return Qa(e,t)}))},er=function(e,t){for(;e;){if(Za(e,t))return e;if(void 0===e.parent)throw new TypeError("Cannot resolve parent for non-DOM nodes");e=e.parent}return null};function tr(){}function ar(e){if("function"!=typeof e)throw new TypeError("Queue methods require functions as arguments")}var rr,nr,or=function(){function e(e){t=e,setTimeout((function(){null!=t&&vt("Uncaught error (of queue)",t)}),1)}var t,a=[],r=0,o=0,i=tr,l=!1,s=e;function u(e){return i=tr,s(e),a}function c(){for(var e=a.length;r<e;r++){var t=a[r];try{t.call(null,function(e){return function(t){a[e]=t,--o||i===tr||(l=!0,i(a))}}(r),u)}catch(e){u(e)}}}var d={defer:function(e){var r;if("object"===n(e)&&e.then&&e.catch&&(r=e,e=function(e,t){r.then(e).catch(t)}),ar(e),void 0===t){if(l)throw new Error("Queue already completed");return a.push(e),++o,c(),d}},then:function(e){if(ar(e),i!==tr)throw new Error("queue `then` already set");return t||(i=e,o||(l=!0,i(a))),d},catch:function(a){if(ar(a),s!==e)throw new Error("queue `catch` already set");return t?(a(t),t=null):s=a,d},abort:u};return d},ir={};function lr(e,t,a,r,n){return r={topic:t,message:a,channelId:"".concat(Gt(),":").concat(Gt()),keepalive:r},nr(e,r,n)}function sr(e,t){var a=e.topic,r=e.message;e=e.keepalive;if(a=ir[a])try{a(r,e,t)}catch(a){o.log(a),t(a,e)}}function ur(e,t){var a;return o._tree&&(a=Sa(t)),new Error(e+": "+(a||t))}lr.updateMessenger=function(e){var t=e.open;e=e.post;Ft("function"==typeof t,"open callback must be a function"),Ft("function"==typeof e,"post callback must be a function"),rr&&rr(),t=t(sr),rr=t?(Ft("function"==typeof t,"open callback must return a cleanup function"),t):null,nr=e},lr.subscribe=function(e,t){Ft("function"==typeof t,"Subscriber callback must be a function"),Ft(!ir[e],"Topic ".concat(e," is already registered to.")),ir[e]=t},lr.isInFrame=function(){return!!(0<arguments.length&&void 0!==arguments[0]?arguments[0]:t).frameElement},ta(lr);var cr=function(e,t,a,r){var n=e.contentWindow;if(!n)return vt("Frame does not have a content window",e),void a(null);var o=setTimeout((function(){o=setTimeout((function(){t.debug?r(ur("No response from frame",e)):a(null)}),0)}),500);lr(n,"axe.ping",null,void 0,(function(){clearTimeout(o);var i=t.options&&t.options.frameWaitTime||6e4;o=setTimeout((function(){r(ur("Axe in frame timed out",e))}),i),lr(n,"axe.start",t,void 0,(function(e){clearTimeout(o),(e instanceof Error==0?a:r)(e)}))}))},dr=function(e){return[].concat(e.any||[]).concat(e.all||[]).concat(e.none||[])},pr=function(e,t,a){if(Array.isArray(e))return e.find((function(e){return"object"===n(e)&&e[t]===a}))};function fr(e,t){for(var a=0<arguments.length&&void 0!==e?e:[],r=1<arguments.length&&void 0!==t?t:[],n=Math.max(null==a?void 0:a.length,null==r?void 0:r.length),o=0;o<n;o++){var i=null==a?void 0:a[o],l=null==r?void 0:r[o];if("number"!=typeof i||isNaN(i))return 0===o?1:-1;if("number"!=typeof l||isNaN(l))return 0===o?-1:1;if(i!==l)return i-l}return 0}var mr=function(e,t){var a=[];return e.forEach((function(e){var r,n,o=(r=e)&&r.results?Array.isArray(r.results)?r.results.length?r.results:null:[r.results]:null;o&&o.length&&(e.frameElement&&(r={selector:[e.frame]},n=new Ua(e.frameElement,t,r)),o.forEach((function(e){var r,o;e.nodes&&n&&(i=e.nodes,r=n,o=t,i.forEach((function(e){e.node=Ua.fromFrame(e.node,o,r),dr(e).forEach((function(e){e.relatedNodes=e.relatedNodes.map((function(e){return Ua.fromFrame(e,o,r)}))}))})));var i=pr(a,"id",e.id);i?e.nodes.length&&function(e,t){for(var a=t[0].node,r=0;r<e.length;r++){var n=e[r].node,o=fr(n.nodeIndexes,a.nodeIndexes);if(0<o||0===o&&a.selector.length<n.selector.length)return e.splice.apply(e,[r,0].concat(y(t)))}e.push.apply(e,y(t))}(i.nodes,e.nodes):a.push(e)})))})),a.forEach((function(e){e.nodes&&e.nodes.sort((function(e,t){return fr(e.node.nodeIndexes,t.node.nodeIndexes)}))})),a},hr=function(e,t,a,r,n,o){var i=or();e.frames.forEach((function(n){var o=parseInt(n.node.getAttribute("tabindex"),10),l=isNaN(o)||0<=o,s=n.node.getBoundingClientRect(),u=parseInt(n.node.getAttribute("width"),10),c=(o=parseInt(n.node.getAttribute("height"),10),u=isNaN(u)?s.width:u,o=isNaN(o)?s.height:o,{options:t,command:a,parameter:r,context:{initiator:!1,focusable:!1!==e.focusable&&l,boundingClientRect:{width:u,height:o},page:e.page,include:n.include||[],exclude:n.exclude||[]}});i.defer((function(e,t){var a=n.node;cr(a,c,(function(t){return t?e({results:t,frameElement:a,frame:Sa(a)}):void e(null)}),t)}))})),i.then((function(e){n(mr(e,t))})).catch(o)},gr=function(e,t){if(e.shadowId||t.shadowId)return function e(t,a){return t.shadowId===a.shadowId||!!t.children.find((function(t){return e(t,a)}))}(e,t);if(e.actualNode)return"function"==typeof e.actualNode.contains?e.actualNode.contains(t.actualNode):!!(16&e.actualNode.compareDocumentPosition(t.actualNode));do{if(t===e)return!0}while(t=t&&t.parent);return!1},br=function e(){for(var t={},a=arguments.length,r=new Array(a),o=0;o<a;o++)r[o]=arguments[o];return r.forEach((function(a){if(a&&"object"===n(a)&&!Array.isArray(a))for(var r=0,o=Object.keys(a);r<o.length;r++){var i=o[r];!t.hasOwnProperty(i)||"object"!==n(a[i])||Array.isArray(t[i])?t[i]=a[i]:t[i]=e(t[i],a[i])}})),t},yr=function(e,t){Object.assign(e,t),Object.keys(t).filter((function(e){return"function"==typeof t[e]})).forEach((function(a){e[a]=null;try{e[a]=t[a](e)}catch(a){}}))},vr=["article","aside","blockquote","body","div","footer","h1","h2","h3","h4","h5","h6","header","main","nav","p","section","span"],Dr=function(e){return!!(e.shadowRoot&&(e=e.nodeName.toLowerCase(),vr.includes(e)||/^[a-z][a-z0-9_.-]*-[a-z0-9_.-]*$/.test(e)))},wr={};N(wr,{findElmsInContext:function(){return Ar},findUp:function(){return Fr},findUpVirtual:function(){return Cr},getComposedParent:function(){return kr},getElementByReference:function(){return Rr},getElementCoordinates:function(){return Nr},getElementStack:function(){return Hr},getRootNode:function(){return Er},getScrollOffset:function(){return Tr},getTabbableElements:function(){return zr},getTextElementStack:function(){return Wr},getViewportSize:function(){return _r},hasContent:function(){return en},hasContentVirtual:function(){return Zr},idrefs:function(){return Kr},insertedIntoFocusOrder:function(){return sn},isFocusable:function(){return ln},isHTML5:function(){return un},isHiddenWithCSS:function(){return rn},isInTextBlock:function(){return pn},isModalOpen:function(){return fn},isNativelyFocusable:function(){return on},isNode:function(){return mn},isOffscreen:function(){return Or},isOpaque:function(){return Fn},isSkipLink:function(){return Rn},isVisible:function(){return Ir},isVisualContent:function(){return Yr},reduceToElementsBelowFloating:function(){return Tn},shadowElementsFromPoint:function(){return Sn},urlPropsFromAttribute:function(){return Pn},visuallyContains:function(){return On},visuallyOverlaps:function(){return In}});var xr=function(e){var t=e.getRootNode&&e.getRootNode()||r;return t===e?r:t},Er=xr,Ar=function(e){var t=e.context,a=e.value,r=e.attr;e=void 0===(e=e.elm)?"":e,a=ha(a),t=9===t.nodeType||11===t.nodeType?t:Er(t);return Array.from(t.querySelectorAll(e+"["+r+"="+a+"]"))},Cr=function(e,t){var a=e.actualNode;if(!e.shadowId&&"function"==typeof e.actualNode.closest)return(e=e.actualNode.closest(t))||null;for(;(a=(a=a.assignedSlot||a.parentNode)&&11===a.nodeType?a.host:a)&&!xa(a,t)&&a!==r.documentElement;);return a&&xa(a,t)?a:null},Fr=function(e,t){return Cr(Ma(e),t)},kr=function e(t){if(t.assignedSlot)return e(t.assignedSlot);if(t.parentNode){if(1===(t=t.parentNode).nodeType)return t;if(t.host)return t.host}return null},Rr=function(e,t){return(e=e.getAttribute(t))?("#"===e.charAt(0)?e=decodeURIComponent(e.substring(1)):"/#"===e.substr(0,2)&&(e=decodeURIComponent(e.substring(2))),(t=r.getElementById(e))||((t=r.getElementsByName(e)).length?t[0]:null)):null},Tr=function(e){if(9!==(e=!e.nodeType&&e.document?e.document:e).nodeType)return{left:e.scrollLeft,top:e.scrollTop};var t=e.documentElement;e=e.body;return{left:t&&t.scrollLeft||e&&e.scrollLeft||0,top:t&&t.scrollTop||e&&e.scrollTop||0}},Nr=function(e){var t=(a=Tr(r)).left,a=a.top;return{top:(e=e.getBoundingClientRect()).top+a,right:e.right+t,bottom:e.bottom+a,left:e.left+t,width:e.right-e.left,height:e.bottom-e.top}},_r=function(e){var t=e.document,a=t.documentElement;return e.innerWidth?{width:e.innerWidth,height:e.innerHeight}:a?{width:a.clientWidth,height:a.clientHeight}:{width:(t=t.body).clientWidth,height:t.clientHeight}},Or=function(e){var a=r.documentElement,n=t.getComputedStyle(e),o=t.getComputedStyle(r.body||a).getPropertyValue("direction"),i=Nr(e);if(i.bottom<0&&(function(e,t){for(e=kr(e);e&&"html"!==e.nodeName.toLowerCase();){if(e.scrollTop&&0<=(t+=e.scrollTop))return;e=kr(e)}return 1}(e,i.bottom)||"absolute"===n.position))return!0;if(0===i.left&&0===i.right)return!1;if("ltr"===o){if(i.right<=0)return!0}else if(a=Math.max(a.scrollWidth,_r(t).width),i.left>=a)return!0;return!1},Sr=/rect\\s*\\(([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px,?\\s*([0-9]+)px\\s*\\)/,Pr=/(\\w+)\\((\\d+)/;var Ir=function e(a,r,n){if(!a)throw new TypeError("Cannot determine if element is visible for non-DOM nodes");var i=Ma(a),l="_isVisible"+(r?"ScreenReader":"");if(9===a.nodeType)return!0;if(11===a.nodeType&&(a=a.host),i&&void 0!==i[l])return i[l];var s,u,c,d=t.getComputedStyle(a,null);if(null===d)return!1;if("AREA"===(f=a.nodeName.toUpperCase()))return u=r,c=n,!!(p=Fr(s=a,"map"))&&!!(p=p.getAttribute("name"))&&!(!(s=Er(s))||9!==s.nodeType)&&!(!(p=Lo(o._tree,\'img[usemap="#\'.concat(ha(p),\'"]\')))||!p.length)&&p.some((function(t){return e(t.actualNode,u,c)}));if("none"===d.getPropertyValue("display")||["STYLE","SCRIPT","NOSCRIPT","TEMPLATE"].includes(f))return!1;if(r&&"true"===a.getAttribute("aria-hidden"))return!1;var p=parseInt(d.getPropertyValue("height")),f=Qn(a)&&0===p;return p="absolute"===d.getPropertyValue("position")&&p<2&&"hidden"===d.getPropertyValue("overflow"),!(!r&&(function(e){var t=e.getPropertyValue("clip").match(Sr);e=e.getPropertyValue("clip-path").match(Pr);if(t&&5===t.length)return t[3]-t[1]<=0&&t[2]-t[4]<=0;if(e){t=e[1];var a=parseInt(e[2],10);switch(t){case"inset":return 50<=a;case"circle":return 0===a}}}(d)||"0"===d.getPropertyValue("opacity")||f||p))&&(!(!n&&("hidden"===d.getPropertyValue("visibility")||!r&&Or(a)))&&(d=a.assignedSlot||a.parentNode,a=!1,d&&(a=e(d,r,!0)),i&&(i[l]=a),a))},Br=200;function Lr(e){return"static"===e.getComputedStylePropertyValue("position")?-1!==e.getComputedStylePropertyValue("display").indexOf("inline")?2:function e(t){if(!t)return!1;if(void 0!==t._isFloated)return t._isFloated;if("none"!==t.getComputedStylePropertyValue("float"))return t._isFloated=!0;var a=e(t.parent);return t._isFloated=a}(e)?1:0:3}function qr(e,a){for(var r=0;r<e._stackingOrder.length;r++){if(void 0===a._stackingOrder[r])return-1;if(a._stackingOrder[r]>e._stackingOrder[r])return 1;if(a._stackingOrder[r]<e._stackingOrder[r])return-1}var n=e.actualNode,o=a.actualNode;if(n.getRootNode&&n.getRootNode()!==o.getRootNode()){for(var i=[];n;)i.push({root:n.getRootNode(),node:n}),n=n.getRootNode().host;for(;o&&!i.find((function(e){return e.root===o.getRootNode()}));)o=o.getRootNode().host;if((n=i.find((function(e){return e.root===o.getRootNode()})).node)===o)return e.actualNode.getRootNode()!==n.getRootNode()?-1:1}var l,s=(l=t.Node).DOCUMENT_POSITION_FOLLOWING,u=l.DOCUMENT_POSITION_CONTAINS,c=l.DOCUMENT_POSITION_CONTAINED_BY;s=(l=n.compareDocumentPosition(o))&s?1:-1,u=l&u||l&c;return(l=Lr(e))===(c=Lr(a))||u?s:c-l}function Mr(e,t){var a=t._stackingOrder.slice(),r=e.getComputedStylePropertyValue("z-index");return"auto"!==r&&(a[a.length-1]=parseInt(r)),function(e,t){var a=e.getComputedStylePropertyValue("position"),r=e.getComputedStylePropertyValue("z-index");return"fixed"===a||"sticky"===a||"auto"!==r&&"static"!==a||"1"!==e.getComputedStylePropertyValue("opacity")||"none"!==(e.getComputedStylePropertyValue("-webkit-transform")||e.getComputedStylePropertyValue("-ms-transform")||e.getComputedStylePropertyValue("transform")||"none")||(a=e.getComputedStylePropertyValue("mix-blend-mode"))&&"normal"!==a||(a=e.getComputedStylePropertyValue("filter"))&&"none"!==a||(a=e.getComputedStylePropertyValue("perspective"))&&"none"!==a||(a=e.getComputedStylePropertyValue("clip-path"))&&"none"!==a||"none"!==(e.getComputedStylePropertyValue("-webkit-mask")||e.getComputedStylePropertyValue("mask")||"none")||"none"!==(e.getComputedStylePropertyValue("-webkit-mask-image")||e.getComputedStylePropertyValue("mask-image")||"none")||"none"!==(e.getComputedStylePropertyValue("-webkit-mask-border")||e.getComputedStylePropertyValue("mask-border")||"none")||"isolate"===e.getComputedStylePropertyValue("isolation")||"transform"===(a=e.getComputedStylePropertyValue("will-change"))||"opacity"===a||"touch"===e.getComputedStylePropertyValue("-webkit-overflow-scrolling")?1:(e=e.getComputedStylePropertyValue("contain"),["layout","paint","strict","content"].includes(e)||"auto"!==r&&t&&(t=t.getComputedStylePropertyValue("display"),["flex","inline-flex","inline flex","grid","inline-grid","inline grid"].includes(t))?1:void 0)}(e,t)&&a.push(0),a}function jr(e,t){t._grid=e,t.clientRects.forEach((function(a){for(var r=a.left,n=a.top,o=r/Br|0,i=(n+a.height)/Br|0,l=(r+a.width)/Br|0,s=n/Br|0;s<=i;s++){e.cells[s]=e.cells[s]||[];for(var u=o;u<=l;u++)e.cells[s][u]=e.cells[s][u]||[],e.cells[s][u].includes(t)||e.cells[s][u].push(t)}}))}function Ur(e,a,n){var i,l=0<arguments.length&&void 0!==e?e:r.body,s=1<arguments.length&&void 0!==a?a:{container:null,cells:[]},u=2<arguments.length&&void 0!==n?n:null;u||((i=(i=Ma(r.documentElement))||new Ln(r.documentElement))._stackingOrder=[0],jr(s,i),Qn(i.actualNode)&&(i._subGrid={container:i,cells:[]}));for(var c=r.createTreeWalker(l,t.NodeFilter.SHOW_ELEMENT,null,!1),d=u?c.nextNode():c.currentNode;d;){var p=Ma(d);d.parentElement?u=Ma(d.parentElement):d.parentNode&&Ma(d.parentNode)&&(u=Ma(d.parentNode)),(p=p||new o.VirtualNode(d,u))._stackingOrder=Mr(p,u);var f=function(e,t){for(var a=null,r=[e];t;){if(t._scrollRegionParent){a=t._scrollRegionParent;break}if(Qn(t.actualNode)){a=t;break}r.push(t),t=Ma(t.actualNode.parentElement||t.actualNode.parentNode)}return r.forEach((function(e){return e._scrollRegionParent=a})),a}(p,u),m=f?f._subGrid:s;Qn(p.actualNode)&&(p._subGrid={container:p,cells:[]}),0!==(f=p.boundingClientRect).width&&0!==f.height&&Ir(d)&&jr(m,p),Dr(d)&&Ur(d.shadowRoot,m,p),d=c.nextNode()}}function Vr(e,t,a){var n=2<arguments.length&&void 0!==a&&a,o=t.left+t.width/2,i=t.top+t.height/2,l=e.cells[i/Br|0][o/Br|0].filter((function(e){return e.clientRects.find((function(e){var t=e.left,a=e.top;return o<=t+e.width&&t<=o&&i<=a+e.height&&a<=i}))})),s=e.container;return s&&(l=Vr(s._grid,s.boundingClientRect,!0).concat(l)),n?l:l.sort(qr).map((function(e){return e.actualNode})).concat(r.documentElement).filter((function(e,t,a){return a.indexOf(e)===t}))}var Hr=function(e){qa.get("gridCreated")||(Ur(),qa.set("gridCreated",!0));var t=Ma(e);return(e=t._grid)?Vr(e,t.boundingClientRect):[]},zr=function(e){return Lo(e,"*").filter((function(e){var t=e.isFocusable;return(e=(e=e.actualNode.getAttribute("tabindex"))&&!isNaN(parseInt(e,10))?parseInt(e):null)?t&&0<=e:t}))},$r=function(e){return e?e.replace(/\\r\\n/g,"\\n").replace(/\\u00A0/g," ").replace(/[\\s]{2,}/g," ").trim():""},Wr=function(e){qa.get("gridCreated")||(Ur(),qa.set("gridCreated",!0));var t=Ma(e),a=t._grid;if(!a)return[];var n=t.boundingClientRect,o=[];return Array.from(e.childNodes).forEach((function(e){if(3===e.nodeType&&""!==$r(e.textContent)){var t=r.createRange();t.selectNodeContents(e);var a=t.getClientRects();if(!Array.from(a).some((function(e){var t=e.left+e.width/2;e=e.top+e.height/2;return t<n.left||t>n.right||e<n.top||e>n.bottom})))for(var i=0;i<a.length;i++){var l=a[i];1<=l.width&&1<=l.height&&o.push(l)}}})),o.length?o.map((function(e){return Vr(a,e)})):[Hr(e)]},Gr=["checkbox","img","radio","range","slider","spinbutton","textbox"],Yr=function(e){var t=e.getAttribute("role");if(t)return-1!==Gr.indexOf(t);switch(e.nodeName.toUpperCase()){case"IMG":case"IFRAME":case"OBJECT":case"VIDEO":case"AUDIO":case"CANVAS":case"SVG":case"MATH":case"BUTTON":case"SELECT":case"TEXTAREA":case"KEYGEN":case"PROGRESS":case"METER":return!0;case"INPUT":return"hidden"!==e.type;default:return!1}},Kr=function(e,t){e=e.actualNode||e;try{var a=Er(e),r=[];if(n=e.getAttribute(t))for(var n=Ho(n),o=0;o<n.length;o++)r.push(a.getElementById(n[o]));return r}catch(e){throw new TypeError("Cannot resolve id references for non-DOM nodes")}},Xr=function e(t,a,r){var n=t instanceof xt?t:Ma(t),o=!t.actualNode||t.actualNode&&Ir(t.actualNode,a);n=n.children.map((function(t){var n=(i=t.props).nodeType,i=i.nodeValue;if(3===n){if(i&&o)return i}else if(!r)return e(t,a)})).join("");return $r(n)},Jr=function(e){var t;return e.attr("aria-labelledby")&&(t=Kr(e.actualNode,"aria-labelledby").map((function(e){return(e=Ma(e))?Xr(e,!0):""})).join(" ").trim())||(t=(t=e.attr("aria-label"))&&$r(t))?t:null},Qr=["HEAD","TITLE","TEMPLATE","SCRIPT","STYLE","IFRAME","OBJECT","VIDEO","AUDIO","NOSCRIPT"],Zr=function e(t,a,r){return function(e){if(!Qr.includes(e.actualNode.nodeName.toUpperCase()))return e.children.some((function(e){return 3===(e=e.actualNode).nodeType&&e.nodeValue.trim()}))}(t)||Yr(t.actualNode)||!r&&!!Jr(t)||!a&&t.children.some((function(t){return 1===t.actualNode.nodeType&&e(t)}))},en=function(e,t,a){return e=Ma(e),Zr(e,t,a)};function tn(e,t){var a=Ma(e);return a?(void 0===a._isHiddenWithCSS&&(a._isHiddenWithCSS=an(e,t)),a._isHiddenWithCSS):an(e,t)}function an(e,a){if(9===e.nodeType)return!1;if(11===e.nodeType&&(e=e.host),["STYLE","SCRIPT"].includes(e.nodeName.toUpperCase()))return!1;if(!(n=t.getComputedStyle(e,null)))throw new Error("Style does not exist for the given element.");if("none"===n.getPropertyValue("display"))return!0;var r=["hidden","collapse"],n=n.getPropertyValue("visibility");return!(!r.includes(n)||a)||(!!(r.includes(n)&&a&&r.includes(a))||!(!(e=kr(e))||r.includes(n))&&tn(e,n))}var rn=tn,nn=function(e){return!!(e=e instanceof xt?e:Ma(e)).hasAttr("disabled")||"area"!==e.props.nodeName&&!!e.actualNode&&rn(e.actualNode)},on=function(e){var t=e instanceof xt?e:Ma(e);if(!t||nn(t))return!1;switch(t.props.nodeName){case"a":case"area":if(t.hasAttr("href"))return!0;break;case"input":return"hidden"!==t.props.type;case"textarea":case"select":case"summary":case"button":return!0;case"details":return!Lo(t,"summary").length}return!1},ln=function(e){return!(1!==(e=e instanceof xt?e:Ma(e)).props.nodeType||nn(e)||!on(e)&&(!(e=e.attr("tabindex"))||isNaN(parseInt(e,10))))},sn=function(e){return-1<parseInt(e.getAttribute("tabindex"),10)&&ln(e)&&!on(e)},un=function(e){return null!==(e=e.doctype)&&"html"===e.name&&!e.publicId&&!e.systemId},cn=["block","list-item","table","flex","grid","inline-block"];function dn(e){return e=t.getComputedStyle(e).getPropertyValue("display"),cn.includes(e)||"table-"===e.substr(0,6)}var pn=function(e){if(dn(e))return!1;var t=function(e){for(var t=kr(e);t&&!dn(t);)t=kr(t);return Ma(t)}(e),a="",r="",n=0;return function e(t,a){!1!==a(t.actualNode)&&t.children.forEach((function(t){return e(t,a)}))}(t,(function(t){if(2===n)return!1;if(3===t.nodeType&&(a+=t.nodeValue),1===t.nodeType){var o=(t.nodeName||"").toUpperCase();if(!["BR","HR"].includes(o))return!("none"===t.style.display||"hidden"===t.style.overflow||!["",null,"none"].includes(t.style.float)||!["",null,"relative"].includes(t.style.position))&&("A"===o&&t.href||"link"===(t.getAttribute("role")||"").toLowerCase()?(t===e&&(n=1),r+=t.textContent,!1):void 0);0===n?r=a="":n=2}})),a=$r(a),r=$r(r),a.length>r.length},fn=function(e){var a=(e=e||{}).modalPercent||.75;if(qa.get("isModalOpen"))return qa.get("isModalOpen");if(ko(o._tree[0],"dialog, [role=dialog], [aria-modal=true]",(function(e){return Ir(e.actualNode)})).length)return qa.set("isModalOpen",!0),!0;for(var i=_r(t),l=i.width*a,s=i.height*a,u=[{x:e=(i.width-l)/2,y:a=(i.height-s)/2},{x:i.width-e,y:a},{x:i.width/2,y:i.height/2},{x:e,y:i.height-a},{x:i.width-e,y:i.height-a}].map((function(e){return Array.from(r.elementsFromPoint(e.x,e.y))})),c=0;c<u.length;c++){var d=function(e){var a=u[e].find((function(e){return e=t.getComputedStyle(e),parseInt(e.width,10)>=l&&parseInt(e.height,10)>=s&&"none"!==e.getPropertyValue("pointer-events")&&("absolute"===e.position||"fixed"===e.position)}));if(a&&u.every((function(e){return e.includes(a)})))return qa.set("isModalOpen",!0),{v:!0}}(c);if("object"===n(d))return d.v}qa.set("isModalOpen",void 0)},mn=function(e){return e instanceof t.Node},hn={},gn={set:function(e,t){if("string"!=typeof e)throw new Error("Incomplete data: key must be a string");return t&&(hn[e]=t),hn[e]},get:function(e){return hn[e]},clear:function(){hn={}}},bn=function(e,a){var r=e.nodeName.toUpperCase();return["IMG","CANVAS","OBJECT","IFRAME","VIDEO","SVG"].includes(r)?(gn.set("bgColor","imgNode"),!0):((a="none"!==(e=(a=a||t.getComputedStyle(e)).getPropertyValue("background-image")))&&(e=/gradient/.test(e),gn.set("bgColor",e?"bgGradient":"bgImage")),a)},yn={alert:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},alertdialog:{type:"widget",allowedAttrs:["aria-expanded","aria-modal"],superclassRole:["alert","dialog"],accessibleNameRequired:!0},application:{type:"landmark",allowedAttrs:["aria-activedescendant","aria-expanded"],superclassRole:["structure"],accessibleNameRequired:!0},article:{type:"structure",allowedAttrs:["aria-posinset","aria-setsize","aria-expanded"],superclassRole:["document"]},banner:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},blockquote:{type:"structure",superclassRole:["section"]},button:{type:"widget",allowedAttrs:["aria-expanded","aria-pressed"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},caption:{type:"structure",requiredContext:["figure","table","grid","treegrid"],superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},cell:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-colindex","aria-colspan","aria-rowindex","aria-rowspan","aria-expanded"],superclassRole:["section"],nameFromContent:!0},checkbox:{type:"widget",allowedAttrs:["aria-checked","aria-readonly","aria-required"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},code:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},columnheader:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-sort","aria-colindex","aria-colspan","aria-expanded","aria-readonly","aria-required","aria-rowindex","aria-rowspan","aria-selected"],superclassRole:["cell","gridcell","sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},combobox:{type:"composite",requiredOwned:["listbox","tree","grid","dialog","textbox"],requiredAttrs:["aria-expanded"],allowedAttrs:["aria-controls","aria-autocomplete","aria-readonly","aria-required","aria-activedescendant","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!0},command:{type:"abstract",superclassRole:["widget"]},complementary:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},composite:{type:"abstract",superclassRole:["widget"]},contentinfo:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},definition:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"]},deletion:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},dialog:{type:"widget",allowedAttrs:["aria-expanded","aria-modal"],superclassRole:["window"],accessibleNameRequired:!0},directory:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["list"],nameFromContent:!0},document:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["structure"]},emphasis:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},feed:{type:"structure",requiredOwned:["article"],allowedAttrs:["aria-expanded"],superclassRole:["list"]},figure:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},form:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},grid:{type:"composite",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-level","aria-multiselectable","aria-readonly","aria-activedescendant","aria-colcount","aria-expanded","aria-rowcount"],superclassRole:["composite","table"],accessibleNameRequired:!1},gridcell:{type:"widget",requiredContext:["row"],allowedAttrs:["aria-readonly","aria-required","aria-selected","aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan"],superclassRole:["cell","widget"],nameFromContent:!0},group:{type:"structure",allowedAttrs:["aria-activedescendant","aria-expanded"],superclassRole:["section"]},heading:{type:"structure",requiredAttrs:["aria-level"],allowedAttrs:["aria-expanded"],superclassRole:["sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},img:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],accessibleNameRequired:!0,childrenPresentational:!0},input:{type:"abstract",superclassRole:["widget"]},insertion:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},landmark:{type:"abstract",superclassRole:["section"]},link:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0},list:{type:"structure",requiredOwned:["group","listitem"],allowedAttrs:["aria-expanded"],superclassRole:["section"]},listbox:{type:"composite",requiredOwned:["option"],allowedAttrs:["aria-multiselectable","aria-readonly","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!0},listitem:{type:"structure",requiredContext:["list","group"],allowedAttrs:["aria-level","aria-posinset","aria-setsize","aria-expanded"],superclassRole:["section"],nameFromContent:!0},log:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},main:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},marquee:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},math:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],childrenPresentational:!0},menu:{type:"composite",requiredOwned:["group","menuitemradio","menuitem","menuitemcheckbox"],allowedAttrs:["aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"]},menubar:{type:"composite",requiredOwned:["group","menuitemradio","menuitem","menuitemcheckbox"],allowedAttrs:["aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["menu"]},menuitem:{type:"widget",requiredContext:["menu","menubar","group"],allowedAttrs:["aria-posinset","aria-setsize","aria-expanded"],superclassRole:["command"],accessibleNameRequired:!0,nameFromContent:!0},menuitemcheckbox:{type:"widget",requiredContext:["menu","menubar","group"],allowedAttrs:["aria-checked","aria-posinset","aria-readonly","aria-setsize"],superclassRole:["checkbox","menuitem"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},menuitemradio:{type:"widget",requiredContext:["menu","menubar","group"],allowedAttrs:["aria-checked","aria-posinset","aria-readonly","aria-setsize"],superclassRole:["menuitemcheckbox","radio"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},meter:{type:"structure",allowedAttrs:["aria-valuetext"],requiredAttrs:["aria-valuemax","aria-valuemin","aria-valuenow"],superclassRole:["range"],accessibleNameRequired:!0,childrenPresentational:!0},navigation:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},none:{type:"structure",superclassRole:["structure"],prohibitedAttrs:["aria-label","aria-labelledby"]},note:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"]},option:{type:"widget",requiredContext:["listbox"],allowedAttrs:["aria-selected","aria-checked","aria-posinset","aria-setsize"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},paragraph:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},presentation:{type:"structure",superclassRole:["structure"],prohibitedAttrs:["aria-label","aria-labelledby"]},progressbar:{type:"widget",allowedAttrs:["aria-expanded","aria-valuemax","aria-valuemin","aria-valuenow","aria-valuetext"],superclassRole:["range"],accessibleNameRequired:!0,childrenPresentational:!0},radio:{type:"widget",allowedAttrs:["aria-checked","aria-posinset","aria-setsize","aria-required"],superclassRole:["input"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},radiogroup:{type:"composite",requiredOwned:["radio"],allowedAttrs:["aria-readonly","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!1},range:{type:"abstract",superclassRole:["widget"]},region:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"],accessibleNameRequired:!1},roletype:{type:"abstract",superclassRole:[]},row:{type:"structure",requiredContext:["grid","rowgroup","table","treegrid"],requiredOwned:["cell","columnheader","gridcell","rowheader"],allowedAttrs:["aria-colindex","aria-level","aria-rowindex","aria-selected","aria-activedescendant","aria-expanded","aria-posinset","aria-setsize"],superclassRole:["group","widget"],nameFromContent:!0},rowgroup:{type:"structure",requiredContext:["grid","table","treegrid"],requiredOwned:["row"],superclassRole:["structure"],nameFromContent:!0},rowheader:{type:"structure",requiredContext:["row"],allowedAttrs:["aria-sort","aria-colindex","aria-colspan","aria-expanded","aria-readonly","aria-required","aria-rowindex","aria-rowspan","aria-selected"],superclassRole:["cell","gridcell","sectionhead"],accessibleNameRequired:!1,nameFromContent:!0},scrollbar:{type:"widget",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-controls","aria-orientation","aria-valuemax","aria-valuemin","aria-valuetext"],superclassRole:["range"],childrenPresentational:!0},search:{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},searchbox:{type:"widget",allowedAttrs:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-placeholder","aria-readonly","aria-required"],superclassRole:["textbox"],accessibleNameRequired:!0},section:{type:"abstract",superclassRole:["structure"],nameFromContent:!0},sectionhead:{type:"abstract",superclassRole:["structure"],nameFromContent:!0},select:{type:"abstract",superclassRole:["composite","group"]},separator:{type:"structure",allowedAttrs:["aria-valuemax","aria-valuemin","aria-valuenow","aria-orientation","aria-valuetext"],superclassRole:["structure","widget"],childrenPresentational:!0},slider:{type:"widget",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-orientation","aria-readonly","aria-valuetext"],superclassRole:["input","range"],accessibleNameRequired:!0,childrenPresentational:!0},spinbutton:{type:"widget",requiredAttrs:["aria-valuenow"],allowedAttrs:["aria-valuemax","aria-valuemin","aria-readonly","aria-required","aria-activedescendant","aria-valuetext"],superclassRole:["composite","input","range"],accessibleNameRequired:!0},status:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"]},strong:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},structure:{type:"abstract",superclassRole:["roletype"]},subscript:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},superscript:{type:"structure",superclassRole:["section"],prohibitedAttrs:["aria-label","aria-labelledby"]},switch:{type:"widget",requiredAttrs:["aria-checked"],allowedAttrs:["aria-readonly"],superclassRole:["checkbox"],accessibleNameRequired:!0,nameFromContent:!0,childrenPresentational:!0},tab:{type:"widget",requiredContext:["tablist"],allowedAttrs:["aria-posinset","aria-selected","aria-setsize","aria-expanded"],superclassRole:["sectionhead","widget"],nameFromContent:!0,childrenPresentational:!0},table:{type:"structure",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-colcount","aria-rowcount","aria-expanded"],superclassRole:["section"],accessibleNameRequired:!1,nameFromContent:!0},tablist:{type:"composite",requiredOwned:["tab"],allowedAttrs:["aria-level","aria-multiselectable","aria-orientation","aria-activedescendant","aria-expanded"],superclassRole:["composite"]},tabpanel:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["section"],accessibleNameRequired:!1},term:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},text:{type:"structure",superclassRole:["section"],nameFromContent:!0},textbox:{type:"widget",allowedAttrs:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-placeholder","aria-readonly","aria-required"],superclassRole:["input"],accessibleNameRequired:!0},time:{type:"structure",superclassRole:["section"]},timer:{type:"widget",allowedAttrs:["aria-expanded"],superclassRole:["status"]},toolbar:{type:"structure",allowedAttrs:["aria-orientation","aria-activedescendant","aria-expanded"],superclassRole:["group"],accessibleNameRequired:!0},tooltip:{type:"structure",allowedAttrs:["aria-expanded"],superclassRole:["section"],nameFromContent:!0},tree:{type:"composite",requiredOwned:["group","treeitem"],allowedAttrs:["aria-multiselectable","aria-required","aria-activedescendant","aria-expanded","aria-orientation"],superclassRole:["select"],accessibleNameRequired:!1},treegrid:{type:"composite",requiredOwned:["rowgroup","row"],allowedAttrs:["aria-activedescendant","aria-colcount","aria-expanded","aria-level","aria-multiselectable","aria-orientation","aria-readonly","aria-required","aria-rowcount"],superclassRole:["grid","tree"],accessibleNameRequired:!1},treeitem:{type:"widget",requiredContext:["group","tree"],allowedAttrs:["aria-checked","aria-expanded","aria-level","aria-posinset","aria-selected","aria-setsize"],superclassRole:["listitem","option"],accessibleNameRequired:!0,nameFromContent:!0},widget:{type:"abstract",superclassRole:["roletype"]},window:{type:"abstract",superclassRole:["roletype"]}},vn={a:{variant:{href:{matches:"[href]",contentTypes:["interactive","phrasing","flow"],allowedRoles:["button","checkbox","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab","treeitem","doc-backlink","doc-biblioref","doc-glossref","doc-noteref"],namingMethods:["subtreeText"]},default:{contentTypes:["phrasing","flow"],allowedRoles:!0}}},abbr:{contentTypes:["phrasing","flow"],allowedRoles:!0},addres:{contentTypes:["flow"],allowedRoles:!0},area:{contentTypes:["phrasing","flow"],allowedRoles:!1,namingMethods:["altText"]},article:{contentTypes:["sectioning","flow"],allowedRoles:["feed","presentation","none","document","application","main","region"],shadowRoot:!0},aside:{contentTypes:["sectioning","flow"],allowedRoles:["feed","note","presentation","none","region","search","doc-dedication","doc-example","doc-footnote","doc-pullquote","doc-tip"]},audio:{variant:{controls:{matches:"[controls]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application"],chromiumRole:"Audio"},b:{contentTypes:["phrasing","flow"],allowedRoles:!1},base:{allowedRoles:!1,noAriaAttrs:!0},bdi:{contentTypes:["phrasing","flow"],allowedRoles:!0},bdo:{contentTypes:["phrasing","flow"],allowedRoles:!0},blockquote:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},body:{allowedRoles:!1,shadowRoot:!0},br:{contentTypes:["phrasing","flow"],allowedRoles:["presentation","none"],namingMethods:["titleText","singleSpace"]},button:{contentTypes:["interactive","phrasing","flow"],allowedRoles:["checkbox","link","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab"],namingMethods:["subtreeText"]},canvas:{allowedRoles:!0,contentTypes:["embedded","phrasing","flow"],chromiumRole:"Canvas"},caption:{allowedRoles:!1},cite:{contentTypes:["phrasing","flow"],allowedRoles:!0},code:{contentTypes:["phrasing","flow"],allowedRoles:!0},col:{allowedRoles:!1,noAriaAttrs:!0},colgroup:{allowedRoles:!1,noAriaAttrs:!0},data:{contentTypes:["phrasing","flow"],allowedRoles:!0},datalist:{contentTypes:["phrasing","flow"],allowedRoles:!1,implicitAttrs:{"aria-multiselectable":"false"}},dd:{allowedRoles:!1},del:{contentTypes:["phrasing","flow"],allowedRoles:!0},dfn:{contentTypes:["phrasing","flow"],allowedRoles:!0},details:{contentTypes:["interactive","flow"],allowedRoles:!1},dialog:{contentTypes:["flow"],allowedRoles:["alertdialog"]},div:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},dl:{contentTypes:["flow"],allowedRoles:["group","list","presentation","none"],chromiumRole:"DescriptionList"},dt:{allowedRoles:["listitem"]},em:{contentTypes:["phrasing","flow"],allowedRoles:!0},embed:{contentTypes:["interactive","embedded","phrasing","flow"],allowedRoles:["application","document","img","presentation","none"],chromiumRole:"EmbeddedObject"},fieldset:{contentTypes:["flow"],allowedRoles:["none","presentation","radiogroup"],namingMethods:["fieldsetLegendText"]},figcaption:{allowedRoles:["group","none","presentation"]},figure:{contentTypes:["flow"],allowedRoles:!0,namingMethods:["figureText","titleText"]},footer:{contentTypes:["flow"],allowedRoles:["group","none","presentation","doc-footnote"],shadowRoot:!0},form:{contentTypes:["flow"],allowedRoles:["search","none","presentation"]},h1:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"1"}},h2:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"2"}},h3:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"3"}},h4:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"4"}},h5:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"5"}},h6:{contentTypes:["heading","flow"],allowedRoles:["none","presentation","tab","doc-subtitle"],shadowRoot:!0,implicitAttrs:{"aria-level":"6"}},head:{allowedRoles:!1,noAriaAttrs:!0},header:{contentTypes:["flow"],allowedRoles:["group","none","presentation","doc-footnote"],shadowRoot:!0},hgroup:{contentTypes:["heading","flow"],allowedRoles:!0},hr:{contentTypes:["flow"],allowedRoles:["none","presentation","doc-pagebreak"],namingMethods:["titleText","singleSpace"]},html:{allowedRoles:!1,noAriaAttrs:!0},i:{contentTypes:["phrasing","flow"],allowedRoles:!0},iframe:{contentTypes:["interactive","embedded","phrasing","flow"],allowedRoles:["application","document","img","none","presentation"],chromiumRole:"Iframe"},img:{variant:{nonEmptyAlt:{matches:{attributes:{alt:"/.+/"}},allowedRoles:["button","checkbox","link","menuitem","menuitemcheckbox","menuitemradio","option","progressbar","scrollbar","separator","slider","switch","tab","treeitem","doc-cover"]},usemap:{matches:"[usemap]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{allowedRoles:["presentation","none"],contentTypes:["embedded","phrasing","flow"]}},namingMethods:["altText"]},input:{variant:{button:{matches:{properties:{type:"button"}},allowedRoles:["link","menuitem","menuitemcheckbox","menuitemradio","option","radio","switch","tab"]},buttonType:{matches:{properties:{type:["button","submit","reset"]}},namingMethods:["valueText","titleText","buttonDefaultText"]},checkboxPressed:{matches:{properties:{type:"checkbox"},attributes:{"aria-pressed":"/.*/"}},allowedRoles:["button","menuitemcheckbox","option","switch"],implicitAttrs:{"aria-checked":"false"}},checkbox:{matches:{properties:{type:"checkbox"},attributes:{"aria-pressed":null}},allowedRoles:["menuitemcheckbox","option","switch"],implicitAttrs:{"aria-checked":"false"}},noRoles:{matches:{properties:{type:["color","date","datetime-local","file","month","number","password","range","reset","submit","time","week"]}},allowedRoles:!1},hidden:{matches:{properties:{type:"hidden"}},contentTypes:["flow"],allowedRoles:!1,noAriaAttrs:!0},image:{matches:{properties:{type:"image"}},allowedRoles:["link","menuitem","menuitemcheckbox","menuitemradio","radio","switch"],namingMethods:["altText","valueText","labelText","titleText","buttonDefaultText"]},radio:{matches:{properties:{type:"radio"}},allowedRoles:["menuitemradio"],implicitAttrs:{"aria-checked":"false"}},textWithList:{matches:{properties:{type:"text"},attributes:{list:"/.*/"}},allowedRoles:!1},default:{contentTypes:["interactive","flow"],allowedRoles:["combobox","searchbox","spinbutton"],implicitAttrs:{"aria-valuenow":""},namingMethods:["labelText","placeholderText"]}}},ins:{contentTypes:["phrasing","flow"],allowedRoles:!0},kbd:{contentTypes:["phrasing","flow"],allowedRoles:!0},label:{contentTypes:["interactive","phrasing","flow"],allowedRoles:!1,chromiumRole:"Label"},legend:{allowedRoles:!1},li:{allowedRoles:["menuitem","menuitemcheckbox","menuitemradio","option","none","presentation","radio","separator","tab","treeitem","doc-biblioentry","doc-endnote"],implicitAttrs:{"aria-setsize":"1","aria-posinset":"1"}},link:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},main:{contentTypes:["flow"],allowedRoles:!1,shadowRoot:!0},map:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},math:{contentTypes:["embedded","phrasing","flow"],allowedRoles:!1},mark:{contentTypes:["phrasing","flow"],allowedRoles:!0},menu:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},meta:{variant:{itemprop:{matches:"[itemprop]",contentTypes:["phrasing","flow"]}},allowedRoles:!1,noAriaAttrs:!0},meter:{contentTypes:["phrasing","flow"],allowedRoles:!1,chromiumRole:"progressbar"},nav:{contentTypes:["sectioning","flow"],allowedRoles:["doc-index","doc-pagelist","doc-toc"],shadowRoot:!0},noscript:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},object:{variant:{usemap:{matches:"[usemap]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application","document","img"],chromiumRole:"PluginObject"},ol:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},optgroup:{allowedRoles:!1},option:{allowedRoles:!1,implicitAttrs:{"aria-selected":"false"}},output:{contentTypes:["phrasing","flow"],allowedRoles:!0,namingMethods:["subtreeText"]},p:{contentTypes:["flow"],allowedRoles:!0,shadowRoot:!0},param:{allowedRoles:!1,noAriaAttrs:!0},picture:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},pre:{contentTypes:["flow"],allowedRoles:!0},progress:{contentTypes:["phrasing","flow"],allowedRoles:!0,implicitAttrs:{"aria-valuemax":"100","aria-valuemin":"0","aria-valuenow":"0"}},q:{contentTypes:["phrasing","flow"],allowedRoles:!0},rp:{allowedRoles:!0},rt:{allowedRoles:!0},ruby:{contentTypes:["phrasing","flow"],allowedRoles:!0},s:{contentTypes:["phrasing","flow"],allowedRoles:!0},samp:{contentTypes:["phrasing","flow"],allowedRoles:!0},script:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},section:{contentTypes:["sectioning","flow"],allowedRoles:["alert","alertdialog","application","banner","complementary","contentinfo","dialog","document","feed","log","main","marquee","navigation","none","note","presentation","search","status","tabpanel","doc-abstract","doc-acknowledgments","doc-afterword","doc-appendix","doc-bibliography","doc-chapter","doc-colophon","doc-conclusion","doc-credit","doc-credits","doc-dedication","doc-endnotes","doc-epigraph","doc-epilogue","doc-errata","doc-example","doc-foreword","doc-glossary","doc-index","doc-introduction","doc-notice","doc-pagelist","doc-part","doc-preface","doc-prologue","doc-pullquote","doc-qna","doc-toc"],shadowRoot:!0},select:{variant:{combobox:{matches:{attributes:{multiple:null,size:[null,"1"]}},allowedRoles:["menu"]},default:{allowedRoles:!1}},contentTypes:["interactive","phrasing","flow"],implicitAttrs:{"aria-valuenow":""},namingMethods:["labelText"]},slot:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},small:{contentTypes:["phrasing","flow"],allowedRoles:!0},source:{allowedRoles:!1,noAriaAttrs:!0},span:{contentTypes:["phrasing","flow"],allowedRoles:!0,shadowRoot:!0},strong:{contentTypes:["phrasing","flow"],allowedRoles:!0},style:{allowedRoles:!1,noAriaAttrs:!0},svg:{contentTypes:["embedded","phrasing","flow"],allowedRoles:["application","document","img"],chromiumRole:"SVGRoot",namingMethods:["svgTitleText"]},sub:{contentTypes:["phrasing","flow"],allowedRoles:!0},summary:{allowedRoles:!1,namingMethods:["subtreeText"]},sup:{contentTypes:["phrasing","flow"],allowedRoles:!0},table:{contentTypes:["flow"],allowedRoles:!0,namingMethods:["tableCaptionText","tableSummaryText"]},tbody:{allowedRoles:!0},template:{contentTypes:["phrasing","flow"],allowedRoles:!1,noAriaAttrs:!0},textarea:{contentTypes:["interactive","phrasing","flow"],allowedRoles:!1,implicitAttrs:{"aria-valuenow":"","aria-multiline":"true"},namingMethods:["labelText","placeholderText"]},tfoot:{allowedRoles:!0},thead:{allowedRoles:!0},time:{contentTypes:["phrasing","flow"],allowedRoles:!0},title:{allowedRoles:!1,noAriaAttrs:!0},td:{allowedRoles:!0},th:{allowedRoles:!0},tr:{allowedRoles:!0},track:{allowedRoles:!1,noAriaAttrs:!0},u:{contentTypes:["phrasing","flow"],allowedRoles:!0},ul:{contentTypes:["flow"],allowedRoles:["directory","group","listbox","menu","menubar","none","presentation","radiogroup","tablist","toolbar","tree"]},var:{contentTypes:["phrasing","flow"],allowedRoles:!0},video:{variant:{controls:{matches:"[controls]",contentTypes:["interactive","embedded","phrasing","flow"]},default:{contentTypes:["embedded","phrasing","flow"]}},allowedRoles:["application"],chromiumRole:"video"},wbr:{contentTypes:["phrasing","flow"],allowedRoles:!0}},Dn={aliceblue:[240,248,255],antiquewhite:[250,235,215],aqua:[0,255,255],aquamarine:[127,255,212],azure:[240,255,255],beige:[245,245,220],bisque:[255,228,196],black:[0,0,0],blanchedalmond:[255,235,205],blue:[0,0,255],blueviolet:[138,43,226],brown:[165,42,42],burlywood:[222,184,135],cadetblue:[95,158,160],chartreuse:[127,255,0],chocolate:[210,105,30],coral:[255,127,80],cornflowerblue:[100,149,237],cornsilk:[255,248,220],crimson:[220,20,60],cyan:[0,255,255],darkblue:[0,0,139],darkcyan:[0,139,139],darkgoldenrod:[184,134,11],darkgray:[169,169,169],darkgreen:[0,100,0],darkgrey:[169,169,169],darkkhaki:[189,183,107],darkmagenta:[139,0,139],darkolivegreen:[85,107,47],darkorange:[255,140,0],darkorchid:[153,50,204],darkred:[139,0,0],darksalmon:[233,150,122],darkseagreen:[143,188,143],darkslateblue:[72,61,139],darkslategray:[47,79,79],darkslategrey:[47,79,79],darkturquoise:[0,206,209],darkviolet:[148,0,211],deeppink:[255,20,147],deepskyblue:[0,191,255],dimgray:[105,105,105],dimgrey:[105,105,105],dodgerblue:[30,144,255],firebrick:[178,34,34],floralwhite:[255,250,240],forestgreen:[34,139,34],fuchsia:[255,0,255],gainsboro:[220,220,220],ghostwhite:[248,248,255],gold:[255,215,0],goldenrod:[218,165,32],gray:[128,128,128],green:[0,128,0],greenyellow:[173,255,47],grey:[128,128,128],honeydew:[240,255,240],hotpink:[255,105,180],indianred:[205,92,92],indigo:[75,0,130],ivory:[255,255,240],khaki:[240,230,140],lavender:[230,230,250],lavenderblush:[255,240,245],lawngreen:[124,252,0],lemonchiffon:[255,250,205],lightblue:[173,216,230],lightcoral:[240,128,128],lightcyan:[224,255,255],lightgoldenrodyellow:[250,250,210],lightgray:[211,211,211],lightgreen:[144,238,144],lightgrey:[211,211,211],lightpink:[255,182,193],lightsalmon:[255,160,122],lightseagreen:[32,178,170],lightskyblue:[135,206,250],lightslategray:[119,136,153],lightslategrey:[119,136,153],lightsteelblue:[176,196,222],lightyellow:[255,255,224],lime:[0,255,0],limegreen:[50,205,50],linen:[250,240,230],magenta:[255,0,255],maroon:[128,0,0],mediumaquamarine:[102,205,170],mediumblue:[0,0,205],mediumorchid:[186,85,211],mediumpurple:[147,112,219],mediumseagreen:[60,179,113],mediumslateblue:[123,104,238],mediumspringgreen:[0,250,154],mediumturquoise:[72,209,204],mediumvioletred:[199,21,133],midnightblue:[25,25,112],mintcream:[245,255,250],mistyrose:[255,228,225],moccasin:[255,228,181],navajowhite:[255,222,173],navy:[0,0,128],oldlace:[253,245,230],olive:[128,128,0],olivedrab:[107,142,35],orange:[255,165,0],orangered:[255,69,0],orchid:[218,112,214],palegoldenrod:[238,232,170],palegreen:[152,251,152],paleturquoise:[175,238,238],palevioletred:[219,112,147],papayawhip:[255,239,213],peachpuff:[255,218,185],peru:[205,133,63],pink:[255,192,203],plum:[221,160,221],powderblue:[176,224,230],purple:[128,0,128],rebeccapurple:[102,51,153],red:[255,0,0],rosybrown:[188,143,143],royalblue:[65,105,225],saddlebrown:[139,69,19],salmon:[250,128,114],sandybrown:[244,164,96],seagreen:[46,139,87],seashell:[255,245,238],sienna:[160,82,45],silver:[192,192,192],skyblue:[135,206,235],slateblue:[106,90,205],slategray:[112,128,144],slategrey:[112,128,144],snow:[255,250,250],springgreen:[0,255,127],steelblue:[70,130,180],tan:[210,180,140],teal:[0,128,128],thistle:[216,191,216],tomato:[255,99,71],turquoise:[64,224,208],violet:[238,130,238],wheat:[245,222,179],white:[255,255,255],whitesmoke:[245,245,245],yellow:[255,255,0],yellowgreen:[154,205,50]},wn={ariaAttrs:{"aria-activedescendant":{type:"idref",allowEmpty:!0},"aria-atomic":{type:"boolean",global:!0},"aria-autocomplete":{type:"nmtoken",values:["inline","list","both","none"]},"aria-busy":{type:"boolean",global:!0},"aria-checked":{type:"nmtoken",values:["false","mixed","true","undefined"]},"aria-colcount":{type:"int",minValue:-1},"aria-colindex":{type:"int",minValue:1},"aria-colspan":{type:"int",minValue:1},"aria-controls":{type:"idrefs",allowEmpty:!0,global:!0},"aria-current":{type:"nmtoken",allowEmpty:!0,values:["page","step","location","date","time","true","false"],global:!0},"aria-describedby":{type:"idrefs",allowEmpty:!0,global:!0},"aria-details":{type:"idref",allowEmpty:!0,global:!0},"aria-disabled":{type:"boolean",global:!0},"aria-dropeffect":{type:"nmtokens",values:["copy","execute","link","move","none","popup"],global:!0},"aria-errormessage":{type:"idref",allowEmpty:!0,global:!0},"aria-expanded":{type:"nmtoken",values:["true","false","undefined"]},"aria-flowto":{type:"idrefs",allowEmpty:!0,global:!0},"aria-grabbed":{type:"nmtoken",values:["true","false","undefined"],global:!0},"aria-haspopup":{type:"nmtoken",allowEmpty:!0,values:["true","false","menu","listbox","tree","grid","dialog"],global:!0},"aria-hidden":{type:"nmtoken",values:["true","false","undefined"],global:!0},"aria-invalid":{type:"nmtoken",allowEmpty:!0,values:["grammar","false","spelling","true"],global:!0},"aria-keyshortcuts":{type:"string",allowEmpty:!0,global:!0},"aria-label":{type:"string",allowEmpty:!0,global:!0},"aria-labelledby":{type:"idrefs",allowEmpty:!0,global:!0},"aria-level":{type:"int",minValue:1},"aria-live":{type:"nmtoken",values:["assertive","off","polite"],global:!0},"aria-modal":{type:"boolean"},"aria-multiline":{type:"boolean"},"aria-multiselectable":{type:"boolean"},"aria-orientation":{type:"nmtoken",values:["horizontal","undefined","vertical"]},"aria-owns":{type:"idrefs",allowEmpty:!0,global:!0},"aria-placeholder":{type:"string",allowEmpty:!0},"aria-posinset":{type:"int",minValue:1},"aria-pressed":{type:"nmtoken",values:["false","mixed","true","undefined"]},"aria-readonly":{type:"boolean"},"aria-relevant":{type:"nmtokens",values:["additions","all","removals","text"],global:!0},"aria-required":{type:"boolean"},"aria-roledescription":{type:"string",allowEmpty:!0,global:!0},"aria-rowcount":{type:"int",minValue:-1},"aria-rowindex":{type:"int",minValue:1},"aria-rowspan":{type:"int",minValue:0},"aria-selected":{type:"nmtoken",values:["false","true","undefined"]},"aria-setsize":{type:"int",minValue:-1},"aria-sort":{type:"nmtoken",values:["ascending","descending","none","other"]},"aria-valuemax":{type:"decimal"},"aria-valuemin":{type:"decimal"},"aria-valuenow":{type:"decimal"},"aria-valuetext":{type:"string"}},ariaRoles:D({},yn,{"doc-abstract":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-acknowledgments":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-afterword":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-appendix":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-backlink":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-biblioentry":{type:"listitem",requiredContext:["doc-bibliography"],allowedAttrs:["aria-expanded","aria-level","aria-posinset","aria-setsize"],superclassRole:["listitem"]},"doc-bibliography":{type:"landmark",requiredOwned:["doc-biblioentry"],allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-biblioref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-chapter":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-colophon":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-conclusion":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-cover":{type:"img",allowedAttrs:["aria-expanded"],superclassRole:["img"]},"doc-credit":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-credits":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-dedication":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-endnote":{type:"listitem",requiredContext:["doc-endnotes"],allowedAttrs:["aria-expanded","aria-level","aria-posinset","aria-setsize"],superclassRole:["listitem"]},"doc-endnotes":{type:"landmark",requiredOwned:["doc-endnote"],allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-epigraph":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-epilogue":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-errata":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-example":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-footnote":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-foreword":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-glossary":{type:"landmark",requiredOwned:["definition","term"],allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-glossref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-index":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]},"doc-introduction":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-noteref":{type:"link",allowedAttrs:["aria-expanded"],nameFromContent:!0,superclassRole:["link"]},"doc-notice":{type:"note",allowedAttrs:["aria-expanded"],superclassRole:["note"]},"doc-pagebreak":{type:"separator",allowedAttrs:["aria-expanded","aria-orientation"],superclassRole:["separator"],childrenPresentational:!0},"doc-pagelist":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]},"doc-part":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-preface":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-prologue":{type:"landmark",allowedAttrs:["aria-expanded"],superclassRole:["landmark"]},"doc-pullquote":{type:"none",superclassRole:["none"]},"doc-qna":{type:"section",allowedAttrs:["aria-expanded"],superclassRole:["section"]},"doc-subtitle":{type:"sectionhead",allowedAttrs:["aria-expanded"],superclassRole:["sectionhead"]},"doc-tip":{type:"note",allowedAttrs:["aria-expanded"],superclassRole:["note"]},"doc-toc":{type:"navigation",allowedAttrs:["aria-expanded"],superclassRole:["navigation"]}},{"graphics-document":{type:"structure",superclassRole:["document"],accessibleNameRequired:!0},"graphics-object":{type:"structure",superclassRole:["group"],nameFromContent:!0},"graphics-symbol":{type:"structure",superclassRole:["img"],accessibleNameRequired:!0,childrenPresentational:!0}}),htmlElms:vn,cssColors:Dn},xn=D({},wn),En=xn,An=function(e,t,a,r){this.red=e,this.green=t,this.blue=a,this.alpha=r,this.toHexString=function(){var e=Math.round(this.red).toString(16),t=Math.round(this.green).toString(16),a=Math.round(this.blue).toString(16);return"#"+(15.5<this.red?e:"0"+e)+(15.5<this.green?t:"0"+t)+(15.5<this.blue?a:"0"+a)};var n=/^#[0-9a-f]{3,8}$/i,o=/^((?:rgb|hsl)a?)\\s*\\(([^\\)]*)\\)/i;this.parseString=function(e){if(En.cssColors[e]||"transparent"===e){var t=(r=v(En.cssColors[e]||[0,0,0],3))[0],a=r[1],r=r[2];return this.red=t,this.green=a,this.blue=r,void(this.alpha="transparent"===e?0:1)}if(e.match(o))this.parseColorFnString(e);else{if(!e.match(n))throw new Error(\'Unable to parse color "\'.concat(e,\'"\'));this.parseHexString(e)}},this.parseRgbString=function(e){if("transparent"===e)return this.red=0,this.green=0,this.blue=0,void(this.alpha=0);this.parseColorFnString(e)},this.parseHexString=function(e){var t,a;e.match(n)&&![6,8].includes(e.length)&&((e=e.replace("#","")).length<6&&(e=(t=(a=v(e,4))[0])+t+(t=a[1])+t+(t=a[2])+t,(a=a[3])&&(e+=a+a)),e=e.match(/.{1,2}/g),this.red=parseInt(e[0],16),this.green=parseInt(e[1],16),this.blue=parseInt(e[2],16),e[3]?this.alpha=parseInt(e[3],16)/255:this.alpha=1)},this.parseColorFnString=function(e){var t=(e=v(e.match(o)||[],3))[1];e=e[2];t&&e&&(e=e.split(/\\s*[,\\/\\s]\\s*/).map((function(e){return e.replace(",","").trim()})).filter((function(e){return""!==e})).map((function(e,a){return function(e,t,a){if(/%$/.test(t))return 3===a?parseFloat(t)/100:255*parseFloat(t)/100;if("h"===e[a]){if(/turn$/.test(t))return 360*parseFloat(t);if(/rad$/.test(t))return 57.3*parseFloat(t)}return parseFloat(t)}(t,e,a)})),"hsl"===t.substr(0,3)&&(e=function(e){var t=v(e,4),a=t[0],r=t[1],n=t[2];e=t[3];r/=255,n/=255;r=(t=(1-Math.abs(2*n-1))*r)*(1-Math.abs(a/60%2-1));var o=n-t/2;return(r=a<60?[t,r,0]:a<120?[r,t,0]:a<180?[0,t,r]:a<240?[0,r,t]:a<300?[r,0,t]:[t,0,r]).map((function(e){return Math.round(255*(e+o))})).concat(e)}(e)),this.red=e[0],this.green=e[1],this.blue=e[2],this.alpha="number"==typeof e[3]?e[3]:1)},this.getRelativeLuminance=function(){var e=this.red/255,t=this.green/255,a=this.blue/255;return.2126*(e<=.03928?e/12.92:Math.pow((.055+e)/1.055,2.4))+.7152*(t<=.03928?t/12.92:Math.pow((.055+t)/1.055,2.4))+.0722*(a<=.03928?a/12.92:Math.pow((.055+a)/1.055,2.4))}},Cn=function(e){var t=new An;return t.parseString(e.getPropertyValue("background-color")),0!==t.alpha&&(e=e.getPropertyValue("opacity"),t.alpha=t.alpha*e),t},Fn=function(e){var a=t.getComputedStyle(e);return bn(e,a)||1===Cn(a).alpha},kn=/^\\/?#[^/!]/,Rn=function(e){return!!kn.test(e.getAttribute("href"))&&(void 0!==qa.get("firstPageLink")?t=qa.get("firstPageLink"):(t=Lo(o._tree,\'a:not([href^="#"]):not([href^="/#"]):not([href^="javascript"])\')[0],qa.set("firstPageLink",t||null)),!t||e.compareDocumentPosition(t.actualNode)===e.DOCUMENT_POSITION_FOLLOWING);var t},Tn=function(e,a){for(var r=["fixed","sticky"],n=[],o=!1,i=0;i<e.length;++i){var l=e[i];l===a&&(o=!0);var s=t.getComputedStyle(l);o||-1===r.indexOf(s.position)?n.push(l):n=[]}return n};function Nn(e){for(var t=Ma(e).parent;t;){if(Qn(t.actualNode))return t.actualNode;t=t.parent}}var _n,On=function(e,a){var r,n,o,i,l,s,u,c,d,p,f,m=Nn(a);do{var h=Nn(e);if(h===m||h===a)return n=a,c=f=d=c=void 0,o=(f=(r=e).getBoundingClientRect()).top+.01,i=f.bottom-.01,l=f.left+.01,s=f.right-.01,c=(u=n.getBoundingClientRect()).top,d=u.left,p=c-n.scrollTop,r=c-n.scrollTop+n.scrollHeight,f=d-n.scrollLeft,c=d-n.scrollLeft+n.scrollWidth,"inline"===(d=t.getComputedStyle(n)).getPropertyValue("display")||!(l<f&&l<u.left||o<p&&o<u.top||c<s&&s>u.right||r<i&&i>u.bottom)&&(!(s>u.right||i>u.bottom)||"scroll"===d.overflow||"auto"===d.overflow||"hidden"===d.overflow||n instanceof t.HTMLBodyElement||n instanceof t.HTMLHtmlElement)}while(e=h);return!1},Sn=function e(t,a){var n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:r,o=3<arguments.length&&void 0!==arguments[3]?arguments[3]:0;if(999<o)throw new Error("Infinite loop detected");return Array.from(n.elementsFromPoint(t,a)||[]).filter((function(e){return Er(e)===n})).reduce((function(r,n){var i;return Dr(n)?(i=e(t,a,n.shadowRoot,o+1),(r=r.concat(i)).length&&On(r[0],n)&&r.push(n)):r.push(n),r}),[])},Pn=function(e,t){if(e.hasAttribute(t)){var a=e.nodeName.toUpperCase(),n=e;return["A","AREA"].includes(a)&&!e.ownerSVGElement||((n=r.createElement("a")).href=e.getAttribute(t)),a=["https:","ftps:"].includes(n.protocol)?n.protocol.replace(/s:$/,":"):n.protocol,e=(e=(t=e=/^\\//.test(n.pathname)?n.pathname:"/".concat(n.pathname)).split("/").pop())&&-1!==e.indexOf(".")?{pathname:t.replace(e,""),filename:/index./.test(e)?"":e}:{pathname:t,filename:""},t=e.pathname,e=e.filename,{protocol:a,hostname:n.hostname,port:(a=n.port,["443","80"].includes(a)?"":a),pathname:/\\/$/.test(t)?t:"".concat(t,"/"),search:function(e){var t={};if(!e||!e.length)return t;var a=e.substring(1).split("&");if(!a||!a.length)return t;for(var r=0;r<a.length;r++){var n=(o=v(a[r].split("="),2))[0],o=void 0===(o=o[1])?"":o;t[decodeURIComponent(n)]=decodeURIComponent(o)}return t}(n.search),hash:function(e){if(!e)return"";var t=e.match(/#!?\\/?/g);return t&&"#"!==v(t,1)[0]?e:""}(n.hash),filename:e}}},In=function(e,a){var r=a.getBoundingClientRect(),n=r.top,o=r.left,i=n-a.scrollTop,l=n-a.scrollTop+a.scrollHeight;n=o-a.scrollLeft,o=o-a.scrollLeft+a.scrollWidth;return!(e.left>o&&e.left>r.right||e.top>l&&e.top>r.bottom||e.right<n&&e.right<r.left||e.bottom<i&&e.bottom<r.top)&&(i=t.getComputedStyle(a),!(e.left>r.right||e.top>r.bottom)||"scroll"===i.overflow||"auto"===i.overflow||a instanceof t.HTMLBodyElement||a instanceof t.HTMLHtmlElement)},Bn=0,Ln=function(){f(a,xt);var e=h(a);function a(t,r,n){var o;return w(this,a),(o=e.call(this)).shadowId=n,o.children=[],o.actualNode=t,(o.parent=r)||(Bn=0),o.nodeIndex=Bn++,o._isHidden=null,o._cache={},void 0===_n&&(_n=Ea(t.ownerDocument)),o._isXHTML=_n,"input"===t.nodeName.toLowerCase()&&(r=t.getAttribute("type"),r=o._isXHTML?r:(r||"").toLowerCase(),zo().includes(r)||(r="text"),o._type=r),qa.get("nodeMap")&&qa.get("nodeMap").set(t,g(o)),o}return E(a,[{key:"props",get:function(){var e=(o=this.actualNode).nodeType,t=o.nodeName,a=o.id,r=o.multiple,n=o.nodeValue,o=o.value;return{nodeType:e,nodeName:this._isXHTML?t:t.toLowerCase(),id:a,type:this._type,multiple:r,nodeValue:n,value:o}}},{key:"attr",value:function(e){return"function"!=typeof this.actualNode.getAttribute?null:this.actualNode.getAttribute(e)}},{key:"hasAttr",value:function(e){return"function"==typeof this.actualNode.hasAttribute&&this.actualNode.hasAttribute(e)}},{key:"attrNames",get:function(){var e;return this._cache.hasOwnProperty("attrNames")||(e=(this.actualNode.attributes instanceof t.NamedNodeMap?this.actualNode:this.actualNode.cloneNode(!1)).attributes,this._cache.attrNames=Array.from(e).map((function(e){return e.name}))),this._cache.attrNames}},{key:"getComputedStylePropertyValue",value:function(e){var a="computedStyle_"+e;return this._cache.hasOwnProperty(a)||(this._cache.hasOwnProperty("computedStyle")||(this._cache.computedStyle=t.getComputedStyle(this.actualNode)),this._cache[a]=this._cache.computedStyle.getPropertyValue(e)),this._cache[a]}},{key:"isFocusable",get:function(){return this._cache.hasOwnProperty("isFocusable")||(this._cache.isFocusable=ln(this.actualNode)),this._cache.isFocusable}},{key:"tabbableElements",get:function(){return this._cache.hasOwnProperty("tabbableElements")||(this._cache.tabbableElements=zr(this)),this._cache.tabbableElements}},{key:"clientRects",get:function(){return this._cache.hasOwnProperty("clientRects")||(this._cache.clientRects=Array.from(this.actualNode.getClientRects()).filter((function(e){return 0<e.width}))),this._cache.clientRects}},{key:"boundingClientRect",get:function(){return this._cache.hasOwnProperty("boundingClientRect")||(this._cache.boundingClientRect=this.actualNode.getBoundingClientRect()),this._cache.boundingClientRect}}]),a}();function qn(e,a,r){var n,o,i;function l(e,t,r){return(r=qn(t,a,r))?e.concat(r):e}return i=(e=e.documentElement?e.documentElement:e).nodeName.toLowerCase(),Dr(e)?(n=new Ln(e,r,a),a="a"+Math.random().toString().substring(2),o=Array.from(e.shadowRoot.childNodes),n.children=o.reduce((function(e,t){return l(e,t,n)}),[]),[n]):"content"===i&&"function"==typeof e.getDistributedNodes?(o=Array.from(e.getDistributedNodes())).reduce((function(e,t){return l(e,t,r)}),[]):"slot"!==i||"function"!=typeof e.assignedNodes?1===e.nodeType?(n=new Ln(e,r,a),o=Array.from(e.childNodes),n.children=o.reduce((function(e,t){return l(e,t,n)}),[]),[n]):3===e.nodeType?[new Ln(e,r)]:void 0:((o=Array.from(e.assignedNodes())).length||(o=function(e){var t=[];for(e=e.firstChild;e;)t.push(e),e=e.nextSibling;return t}(e)),t.getComputedStyle(e),o.reduce((function(e,t){return l(e,t,r)}),[]))}var Mn=function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:r.documentElement,t=1<arguments.length?arguments[1]:void 0;return qa.set("nodeMap",new WeakMap),qn(e,t,null)},jn=function(e){return e?e.trim().split("-")[0].toLowerCase():""},Un=function(e){var t={};return t.none=e.none.concat(e.all),t.any=e.any,Object.keys(t).map((function(e){if(t[e].length){var a=o._audit.data.failureSummaries[e];return a&&"function"==typeof a.failureMessage?a.failureMessage(t[e].map((function(e){return e.message||""}))):void 0}})).filter((function(e){return void 0!==e})).join("\\n\\n")},Vn=function(){var e=void 0===(r=(i=0<arguments.length&&void 0!==arguments[0]?arguments[0]:t).screen)?{}:r,a=i.navigator,r=void 0===(n=i.location)?{}:n,n=i.innerHeight,i=i.innerWidth;e=e.msOrientation||e.orientation||e.mozOrientation||{};return{testEngine:{name:"axe-core",version:o.version},testRunner:{name:o._audit.brand},testEnvironment:{userAgent:(void 0===a?{}:a).userAgent,windowWidth:i,windowHeight:n,orientationAngle:e.angle,orientationType:e.type},timestamp:(new Date).toISOString(),url:r.href}},Hn=function(){return"function"==typeof o._audit.data.incompleteFallbackMessage?o._audit.data.incompleteFallbackMessage():o._audit.data.incompleteFallbackMessage},zn=yt.resultGroups,$n=function(e,t){var a=o.utils.aggregateResult(e);return zn.forEach((function(e){t.resultTypes&&!t.resultTypes.includes(e)&&(a[e]||[]).forEach((function(e){Array.isArray(e.nodes)&&0<e.nodes.length&&(e.nodes=[e.nodes[0]])})),a[e]=(a[e]||[]).map((function(e){return e=Object.assign({},e),Array.isArray(e.nodes)&&0<e.nodes.length&&(e.nodes=e.nodes.map((function(e){var a,r;return"object"===n(e.node)&&(e.html=e.node.source,t.elementRef&&!e.node.fromFrame&&(e.element=e.node.element),!1===t.selectors&&!e.node.fromFrame||(e.target=e.node.selector),t.ancestry&&(e.ancestry=e.node.ancestry),t.xpath&&(e.xpath=e.node.xpath)),delete e.result,delete e.node,a=e,r=t,["any","all","none"].forEach((function(e){Array.isArray(a[e])&&a[e].filter((function(e){return Array.isArray(e.relatedNodes)})).forEach((function(e){e.relatedNodes=e.relatedNodes.map((function(e){var t={html:e.source};return r.elementRef&&!e.fromFrame&&(t.element=e.element),!1===r.selectors&&!e.fromFrame||(t.target=e.selector),r.ancestry&&(t.ancestry=e.ancestry),r.xpath&&(t.xpath=e.xpath),t}))}))})),e}))),zn.forEach((function(t){return delete e[t]})),delete e.pageLevel,delete e.result,e}))})),a};o._thisWillBeDeletedDoNotUse=o._thisWillBeDeletedDoNotUse||{},o._thisWillBeDeletedDoNotUse.helpers={failureSummary:Un,getEnvironmentData:Vn,incompleteFallbackMessage:Hn,processAggregate:$n};var Wn=/\\$\\{\\s?data\\s?\\}/g;function Gn(e,t){if("string"==typeof t)return e.replace(Wn,t);for(var a in t){var r;t.hasOwnProperty(a)&&(r=new RegExp("\\\\${\\\\s?data\\\\."+a+"\\\\s?}","g"),a=void 0===t[a]?"":String(t[a]),e=e.replace(r,a))}return e}var Yn=function e(t,a){if(t){if(Array.isArray(a))return a.values=a.join(", "),"string"!=typeof t.singular||"string"!=typeof t.plural?Gn(t,a):Gn(1===a.length?t.singular:t.plural,a);if("string"==typeof t)return Gn(t,a);if("string"==typeof a)return Gn(t[a],a);var r=t.default||Hn();return e(r=a&&a.messageKey&&t[a.messageKey]?t[a.messageKey]:r,a)}},Kn=function(e,t,a){var r=o._audit.data.checks[e];if(!r)throw new Error("Cannot get message for unknown check: ".concat(e,"."));if(!r.messages[t])throw new Error(\'Check "\'.concat(e,\'"" does not have a "\').concat(t,\'" message.\'));return Yn(r.messages[t],a)},Xn=function(e,t,a){var r=((a.rules&&a.rules[t]||{}).checks||{})[e.id],n=(a.checks||{})[e.id];t=e.enabled,e=e.options;return n&&(n.hasOwnProperty("enabled")&&(t=n.enabled),n.hasOwnProperty("options")&&(e=n.options)),r&&(r.hasOwnProperty("enabled")&&(t=r.enabled),r.hasOwnProperty("options")&&(e=r.options)),{enabled:t,options:e,absolutePaths:a.absolutePaths}},Jn=function(e){var t=o._audit.rules.find((function(t){return t.id===e}));if(!t)throw new Error("Cannot find rule by id: ".concat(e));return t},Qn=function(e){var a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:0,r=e.scrollWidth>e.clientWidth+a,n=e.scrollHeight>e.clientHeight+a;if(r||n){a=(o=t.getComputedStyle(e)).getPropertyValue("overflow-x");var o=o.getPropertyValue("overflow-y");return r&&"visible"!==a&&"hidden"!==a||n&&"visible"!==o&&"hidden"!==o?{elm:e,top:e.scrollTop,left:e.scrollLeft}:void 0}},Zn=function(){var e=0<arguments.length&&void 0!==arguments[0]?arguments[0]:t,a=e.document.documentElement;return[void 0!==e.pageXOffset?{elm:e,top:e.pageYOffset,left:e.pageXOffset}:{elm:a,top:a.scrollTop,left:a.scrollLeft}].concat(function e(t){return Array.from(t.children||t.childNodes||[]).reduce((function(t,a){var r=Qn(a);return r&&t.push(r),t.concat(e(a))}),[])}(r.body))};function eo(){return Ha(En)}var to,ao=function(e){if(!e)throw new Error("axe.utils.getStyleSheetFactory should be invoked with an argument");return function(t){var a=t.data,r=void 0!==(l=t.isCrossOrigin)&&l,n=t.shadowId,o=t.root,i=t.priority,l=(t=void 0!==(l=t.isLink)&&l,e.createElement("style"));return t?(t=e.createTextNode(\'@import "\'.concat(a.href,\'"\')),l.appendChild(t)):l.appendChild(e.createTextNode(a)),e.head.appendChild(l),{sheet:l.sheet,isCrossOrigin:r,shadowId:n,root:o,priority:i}}},ro=function(e){if(to&&to.parentNode)return void 0===to.styleSheet?to.appendChild(r.createTextNode(e)):to.styleSheet.cssText+=e,to;if(e){var t=r.head||r.getElementsByTagName("head")[0];return(to=r.createElement("style")).type="text/css",void 0===to.styleSheet?to.appendChild(r.createTextNode(e)):to.styleSheet.cssText=e,t.appendChild(to),to}},no=function e(a,r){var n=Ma(a);if(9===a.nodeType)return!1;if(11===a.nodeType&&(a=a.host),n&&null!==n._isHidden)return n._isHidden;var o=t.getComputedStyle(a,null);return!o||!a.parentNode||"none"===o.getPropertyValue("display")||!r&&"hidden"===o.getPropertyValue("visibility")||"true"===a.getAttribute("aria-hidden")||(a=e(a.assignedSlot||a.parentNode,!0),n&&(n._isHidden=a),a)},oo=["a","abbr","address","area","article","aside","audio","b","base","bdi","bdo","blockquote","body","br","button","canvas","caption","cite","code","col","colgroup","data","datalist","dd","del","details","dfn","dialog","div","dl","dt","em","embed","fieldset","figcaption","figure","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","iframe","img","input","ins","kbd","keygen","label","legend","li","link","main","map","mark","math","menu","menuitem","meta","meter","nav","noscript","object","ol","optgroup","option","output","p","param","picture","pre","progress","q","rb","rp","rt","rtc","ruby","s","samp","script","section","select","slot","small","source","span","strong","style","sub","summary","sup","svg","table","tbody","td","template","textarea","tfoot","th","thead","time","title","tr","track","u","ul","var","video","wbr"],io=function(e){return"http://www.w3.org/2000/svg"!==e.namespaceURI&&oo.includes(e.nodeName.toLowerCase())};function lo(e){return e.sort((function(e,t){return gr(e,t)?1:-1}))[0]}var so=function(e,t){var a=t.include&&lo(t.include.filter((function(t){return gr(t,e)})));return!!(!(t=t.exclude&&lo(t.exclude.filter((function(t){return gr(t,e)}))))&&a||t&&gr(t,a))},uo=_(dt());o._memoizedFns=[];var co,po,fo=function(e){return e=uo.default(e),o._memoizedFns.push(e),e},mo=function(e,t){return(e=e.actualNode||e)===(t=t.actualNode||t)?0:4&e.compareDocumentPosition(t)?-1:1},ho=function(e,t,a,r){var n=4<arguments.length&&void 0!==arguments[4]&&arguments[4],o=Array.from(e.cssRules);if(!o)return Promise.resolve();var i=o.filter((function(e){return 3===e.type}));return i.length?(i=i.filter((function(e){return e.href})).map((function(e){return e.href})).filter((function(e){return!r.includes(e)})).map((function(e,n){var o=[].concat(y(a),[n]);n=/^https?:\\/\\/|^\\/\\//i.test(e);return bo(e,t,o,r,n)})),(o=o.filter((function(e){return 3!==e.type}))).length&&i.push(Promise.resolve(t.convertDataToStylesheet({data:o.map((function(e){return e.cssText})).join(),isCrossOrigin:n,priority:a,root:t.rootNode,shadowId:t.shadowId}))),Promise.all(i)):Promise.resolve({isCrossOrigin:n,priority:a,root:t.rootNode,shadowId:t.shadowId,sheet:e})},go=function(e,t,a,r){var n=4<arguments.length&&void 0!==arguments[4]&&arguments[4];return function(e){try{return!(!e.cssRules&&e.href)}catch(e){return!1}}(e)?ho(e,t,a,r,n):bo(e.href,t,a,r,!0)},bo=function(e,t,a,r,n){return r.push(e),new Promise((function(t,a){var r=new XMLHttpRequest;r.open("GET",e),r.timeout=yt.preload.timeout,r.addEventListener("error",a),r.addEventListener("timeout",a),r.addEventListener("loadend",(function(e){return e.loaded&&r.responseText?t(r.responseText):void a(r.responseText)})),r.send()})).then((function(e){return e=t.convertDataToStylesheet({data:e,isCrossOrigin:n,priority:a,root:t.rootNode,shadowId:t.shadowId}),go(e.sheet,t,a,r,e.isCrossOrigin)}))};function yo(){if(t.performance&&t.performance)return t.performance.now()}var vo,Do,wo=(co=null,po=yo(),{start:function(){this.mark("mark_axe_start")},end:function(){this.mark("mark_axe_end"),this.measure("axe","mark_axe_start","mark_axe_end"),this.logMeasures("axe")},auditStart:function(){this.mark("mark_audit_start")},auditEnd:function(){this.mark("mark_audit_end"),this.measure("audit_start_to_end","mark_audit_start","mark_audit_end"),this.logMeasures()},mark:function(e){t.performance&&void 0!==t.performance.mark&&t.performance.mark(e)},measure:function(e,a,r){t.performance&&void 0!==t.performance.measure&&t.performance.measure(e,a,r)},logMeasures:function(e){function a(e){vt("Measure "+e.name+" took "+e.duration+"ms")}if(t.performance&&void 0!==t.performance.getEntriesByType)for(var r=t.performance.getEntriesByName("mark_axe_start")[0],n=t.performance.getEntriesByType("measure").filter((function(e){return e.startTime>=r.startTime})),o=0;o<n.length;++o){var i=n[o];if(i.name===e)return void a(i);a(i)}},timeElapsed:function(){return yo()-po},reset:function(){co=co||yo(),po=yo()}});function xo(){if(r.elementsFromPoint)return r.elementsFromPoint;if(r.msElementsFromPoint)return r.msElementsFromPoint;var e,t=(e=((e=r.createElement("x")).style.cssText="pointer-events:auto","auto"===e.style.pointerEvents))?"pointer-events":"visibility",a=e?"none":"hidden",n=r.createElement("style");return n.innerHTML=e?"* { pointer-events: all }":"* { visibility: visible }",function(e,o){var i,l,s,u=[],c=[];for(r.head.appendChild(n);(i=r.elementFromPoint(e,o))&&-1===u.indexOf(i);)u.push(i),c.push({value:i.style.getPropertyValue(t),priority:i.style.getPropertyPriority(t)}),i.style.setProperty(t,a,"important");for(u.indexOf(r.documentElement)<u.length-1&&(u.splice(u.indexOf(r.documentElement),1),u.push(r.documentElement)),l=c.length;s=c[--l];)u[l].style.setProperty(t,s.value||"",s.priority);return r.head.removeChild(n),u}}function Eo(e){return"function"==typeof e||"[object Function]"===vo.call(e)}function Ao(e){return e=function(e){return e=Number(e),isNaN(e)?0:0!==e&&isFinite(e)?(0<e?1:-1)*Math.floor(Math.abs(e)):e}(e),Math.min(Math.max(e,0),Do)}"function"!=typeof Object.assign&&(Object.assign=function(e){if(null==e)throw new TypeError("Cannot convert undefined or null to object");for(var t=Object(e),a=1;a<arguments.length;a++){var r=arguments[a];if(null!=r)for(var n in r)r.hasOwnProperty(n)&&(t[n]=r[n])}return t}),Array.prototype.find||Object.defineProperty(Array.prototype,"find",{value:function(e){if(null===this)throw new TypeError("Array.prototype.find called on null or undefined");if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var t,a=Object(this),r=a.length>>>0,n=arguments[1],o=0;o<r;o++)if(t=a[o],e.call(n,t,o,a))return t}}),Array.prototype.findIndex||Object.defineProperty(Array.prototype,"findIndex",{value:function(e,t){if(null===this)throw new TypeError("Array.prototype.find called on null or undefined");if("function"!=typeof e)throw new TypeError("predicate must be a function");for(var a,r=Object(this),n=r.length>>>0,o=0;o<n;o++)if(a=r[o],e.call(t,a,o,r))return o;return-1}}),"function"==typeof t.addEventListener&&(r.elementsFromPoint=xo()),Array.prototype.includes||Object.defineProperty(Array.prototype,"includes",{value:function(e){var t=Object(this),a=parseInt(t.length,10)||0;if(0===a)return!1;var r,n,o=parseInt(arguments[1],10)||0;for(0<=o?r=o:(r=a+o)<0&&(r=0);r<a;){if(e===(n=t[r])||e!=e&&n!=n)return!0;r++}return!1}}),Array.prototype.some||Object.defineProperty(Array.prototype,"some",{value:function(e){if(null==this)throw new TypeError("Array.prototype.some called on null or undefined");if("function"!=typeof e)throw new TypeError;for(var t=Object(this),a=t.length>>>0,r=2<=arguments.length?arguments[1]:void 0,n=0;n<a;n++)if(n in t&&e.call(r,t[n],n,t))return!0;return!1}}),Array.from||Object.defineProperty(Array,"from",{value:(vo=Object.prototype.toString,Do=Math.pow(2,53)-1,function(e){var t=Object(e);if(null==e)throw new TypeError("Array.from requires an array-like object - not null or undefined");var a,r=1<arguments.length?arguments[1]:void 0;if(void 0!==r){if(!Eo(r))throw new TypeError("Array.from: when provided, the second argument must be a function");2<arguments.length&&(a=arguments[2])}for(var n,o=Ao(t.length),i=Eo(this)?Object(new this(o)):new Array(o),l=0;l<o;)n=t[l],i[l]=r?void 0===a?r(n,l):r.call(a,n,l):n,l+=1;return i.length=o,i})}),String.prototype.includes||(String.prototype.includes=function(e,t){return!((t="number"!=typeof t?0:t)+e.length>this.length)&&-1!==this.indexOf(e,t)}),Array.prototype.flat||Object.defineProperty(Array.prototype,"flat",{configurable:!0,value:function e(){var t=isNaN(arguments[0])?1:Number(arguments[0]);return t?Array.prototype.reduce.call(this,(function(a,r){return Array.isArray(r)?a.push.apply(a,e.call(r,t-1)):a.push(r),a}),[]):Array.prototype.slice.call(this)},writable:!0});var Co=function(e,t){return e.concat(t).filter((function(e,t,a){return a.indexOf(e)===t}))};function Fo(e,t,a,r){return(r={vNodes:e.slice(),anyLevel:t,thisLevel:a,parentShadowId:r}).vNodes.reverse(),r}var ko=function(e,t,a){return function(e,t,a){for(var r=[],n=Fo(Array.isArray(e)?e:[e],t,[],e[0].shadowId),o=[];n.vNodes.length;){for(var i=n.vNodes.pop(),l=[],s=[],u=n.anyLevel.slice().concat(n.thisLevel),c=!1,d=0;d<u.length;d++){var p=u[d];if((!p[0].id||i.shadowId===n.parentShadowId)&&Qa(i,p[0]))if(1===p.length)c||a&&!a(i)||(o.push(i),c=!0);else{var f=p.slice(1);if(!1===[" ",">"].includes(f[0].combinator))throw new Error("axe.utils.querySelectorAll does not support the combinator: "+p[1].combinator);(">"===f[0].combinator?l:s).push(f)}p[0].id&&i.shadowId!==n.parentShadowId||!n.anyLevel.includes(p)||s.push(p)}for(i.children&&i.children.length&&(r.push(n),n=Fo(i.children,s,l,i.shadowId));!n.vNodes.length&&r.length;)n=r.pop()}return o}(e=Array.isArray(e)?e:[e],Ja(t),a)},Ro=function(e){var t;e=void 0===(i=e.treeRoot)?o._tree[0]:i;if(!(t=[],i=ko(i=e,"*",(function(e){return!t.includes(e.shadowId)&&(t.push(e.shadowId),!0)})).map((function(e){return{shadowId:e.shadowId,rootNode:xr(e.actualNode)}})),e=Co(i,[])).length)return Promise.resolve();var a,n,i=r.implementation.createHTMLDocument("Dynamic document for loading cssom");i=ao(i);return a=i,n=[],e.forEach((function(e,t){var r=e.rootNode,o=e.shadowId;if(!(e=function(e,t,a){return function(e){var t=[];return e.filter((function(e){return!e.href||!t.includes(e.href)&&(t.push(e.href),!0)}))}(e=11===e.nodeType&&t?function(e,t){return Array.from(e.children).filter(To).reduce((function(a,r){r="STYLE"===(n=r.nodeName.toUpperCase())?r.textContent:r;var n=t({data:r,isLink:"LINK"===n,root:e});return a.push(n.sheet),a}),[])}(e,a):function(e){return Array.from(e.styleSheets).filter((function(e){return No(e.media.mediaText)}))}(e))}(r,o,a)))return Promise.all(n);var i=t+1,l={rootNode:r,shadowId:o,convertDataToStylesheet:a,rootIndex:i},s=[];e=Promise.all(e.map((function(e,t){return go(e,l,[i,t],s)})));n.push(e)})),Promise.all(n).then((function e(t){return t.reduce((function(t,a){return Array.isArray(a)?t.concat(e(a)):t.concat(a)}),[])}))};function To(e){var t=e.nodeName.toUpperCase(),a=e.getAttribute("href"),r=e.getAttribute("rel");r="LINK"===t&&a&&r&&e.rel.toUpperCase().includes("STYLESHEET");return"STYLE"===t||r&&No(e.media)}function No(e){return!e||!e.toUpperCase().includes("PRINT")}var _o=function(e){return e=void 0===(e=e.treeRoot)?o._tree[0]:e,e=ko(e,"video, audio",(function(e){return(e=e.actualNode).hasAttribute("src")?!!e.getAttribute("src"):!(Array.from(e.getElementsByTagName("source")).filter((function(e){return!!e.getAttribute("src")})).length<=0)})),Promise.all(e.map((function(e){var t;e=e.actualNode;return t=e,new Promise((function(e){0<t.readyState&&e(t),t.addEventListener("loadedmetadata",(function a(){t.removeEventListener("loadedmetadata",a),e(t)}))}))})))};function Oo(e){return!e||void 0===e.preload||null===e.preload||("boolean"==typeof e.preload?e.preload:(e=e.preload,"object"===n(e)&&Array.isArray(e.assets)))}function So(e){var t=(a=yt.preload).assets,a=a.timeout;a={assets:t,timeout:a};if(!e.preload)return a;if("boolean"==typeof e.preload)return a;if(!e.preload.assets.every((function(e){return t.includes(e.toLowerCase())})))throw new Error("Requested assets, not supported. Supported assets are: ".concat(t.join(", "),"."));return a.assets=Co(e.preload.assets.map((function(e){return e.toLowerCase()})),[]),e.preload.timeout&&"number"==typeof e.preload.timeout&&!isNaN(e.preload.timeout)&&(a.timeout=e.preload.timeout),a}var Po=function(e){var t={cssom:Ro,media:_o};return Oo(e)?new Promise((function(a,r){var n=(o=So(e)).assets,o=o.timeout,i=setTimeout((function(){return r(new Error("Preload assets timed out."))}),o);Promise.all(n.map((function(a){return t[a](e).then((function(e){return r=e,(t=a)in(e={})?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e;var t,r}))}))).then((function(e){e=e.reduce((function(e,t){return D({},e,t)}),{}),clearTimeout(i),a(e)})).catch((function(e){clearTimeout(i),r(e)}))})):Promise.resolve()};function Io(e,t,a){return function(r){var o,i=(o=e[r.id]||{}).messages||{};delete(o=Object.assign({},o)).messages,a.reviewOnFail||void 0!==r.result?o.message=r.result===t?i.pass:i.fail:("object"!==n(i.incomplete)||Array.isArray(r.data)||(o.message=function(e,t){function a(e){return e.incomplete&&e.incomplete.default?e.incomplete.default:Hn()}if(!e||!e.missingData)return e&&e.messageKey?t.incomplete[e.messageKey]:a(t);try{var r=t.incomplete[e.missingData[0].reason];if(!r)throw new Error;return r}catch(r){return"string"==typeof e.missingData?t.incomplete[e.missingData]:a(t)}}(r.data,i)),o.message||(o.message=i.incomplete)),"function"!=typeof o.message&&(o.message=Yn(o.message,r.data)),yr(r,o)}}var Bo=function(e){var t=o._audit.data.checks||{},a=o._audit.data.rules||{},r=pr(o._audit.rules,"id",e.id)||{};e.tags=Ha(r.tags||[]);var n=Io(t,!0,r),i=Io(t,!1,r);e.nodes.forEach((function(e){e.any.forEach(n),e.all.forEach(n),e.none.forEach(i)})),yr(e,Ha(a[e.id]||{}))},Lo=function(e,t){return ko(e,t)};function qo(e,t){var a,r=o._audit&&o._audit.tagExclude?o._audit.tagExclude:[],n=t.hasOwnProperty("include")||t.hasOwnProperty("exclude")?(a=t.include||[],a=Array.isArray(a)?a:[a],n=t.exclude||[],(n=Array.isArray(n)?n:[n]).concat(r.filter((function(e){return-1===a.indexOf(e)})))):(a=Array.isArray(t)?t:[t],r.filter((function(e){return-1===a.indexOf(e)})));return!!(a.some((function(t){return-1!==e.tags.indexOf(t)}))||0===a.length&&!1!==e.enabled)&&n.every((function(t){return-1===e.tags.indexOf(t)}))}var Mo=function(e,t,a){var r=a.runOnly||{};a=(a.rules||{})[e.id];return!(e.pageLevel&&!t.page)&&("rule"===r.type?-1!==r.values.indexOf(e.id):a&&"boolean"==typeof a.enabled?a.enabled:"tag"===r.type&&r.values?qo(e,r.values):qo(e,[]))},jo=function e(t,a){if(!a)return t;var n=t.cloneNode(!1),o=n.outerHTML,i=wa(n);return qa.get(o)?n=qa.get(o):i&&(n=r.createElement(n.nodeName),Array.from(i).forEach((function(e){var r,o,i;r=t,o=e.name,void 0!==(i=a)[o]&&(!0===i[o]||xa(r,i[o]))||n.setAttribute(e.name,e.value)})),qa.set(o,n)),Array.from(t.childNodes).forEach((function(t){n.appendChild(e(t,a))})),n},Uo=function(e,t){var a,r=[];if(o._selectCache)for(var n=0,i=o._selectCache.length;n<i;n++){var l=o._selectCache[n];if(l.selector===e)return l.result}function s(e){return so(e,u)}for(var u,c=(u=t).include.reduce((function(e,t){return e.length&&gr(e[e.length-1],t)||e.push(t),e}),[]),d=0;d<c.length;d++)a=c[d],r=function(e,t){var a;if(0===e.length)return t;e.length<t.length&&(a=e,e=t,t=a);for(var r=0,n=t.length;r<n;r++)e.includes(t[r])||e.push(t[r]);return e}(r,ko(a,e,s));return o._selectCache&&o._selectCache.push({selector:e,result:r}),r},Vo=function(e){e.forEach((function(e){return function(e,a,r){if(e===t)return e.scroll(r,a);e.scrollTop=a,e.scrollLeft=r}(e.elm,e.top,e.left)}))},Ho=function(e){return(e||"").trim().replace(/\\s{2,}/g," ").split(" ")},zo=function(){return["hidden","text","search","tel","url","email","password","date","month","week","time","datetime-local","number","range","color","checkbox","radio","file","submit","image","reset","button"]},$o=[,[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,,,,,1,1,1,1,,,1,1,1,,1,,1,,1,1],[1,1,1,,1,1,,1,1,1,,1,,,1,1,1,,,1,1,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,,,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1],[,1,,,,,,1,,1,,,,,1,,1,,,,1,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,,,1,,,,,1,1,1,,1,,1,,1,,,,,,1],[1,,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,,1,,1,,,,,1,,1,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,,1,1,1,,1,,1,1,1,,,1,1,1,1,1,1,1,1],[,,1,,,1,,1,,,,1,1,1,,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1,1,1,1,1,,,1,1,1],[1,1,1,1,1,,,1,,,1,,,1,1,1,,,,,1,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1],[,1,,1,1,1,,1,1,,1,,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,,,1,1,1,,,1,1,,,,,,1,1],[1,1,1,,,,,1,,,,1,1,,1,,,,,,1,,,,,1],[,1,,,1,,,1,,,,,,1],[,1,,1,,,,1,,,,1],[1,,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,,1,,,1,1,1,1],[,1,1,1,1,1,,,1,,,1,,1,1,,1,,1,,,,,1,,1],[,1,,,,1,,,1,1,,1,,1,1,1,1,,1,1,,,1,,,1],[,1,1,,,,,,1,,,,1,1,1,1,,1,1,1,1,1,1,,1,1,1],[,1,,1,1,1,,,1,1,1,1,1,1,,1,,,,,1,1,,1,,1],[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,1,1],[,1,1,1,,,,1,1,1,,1,1,,,1,1,,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,,1,,,,,1,1,1,,,1,,1,,,1,1],[,,,,1,,,,,,,,,,,,,,,,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,,1,1,1,,1,1,,,,1,1,1,1,1,,,1,1,1,,,,,1],[1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,1,,,,,,,1],[,1,1,,1,1,,1,,,,,,,,,,,,,1],,[1,1,1,,,,,,,,,,,,,1],[,,,,,,,,1,,,1,,,1,1,,,,,1]],[,[1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,,1,1,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,,1],[,,,1,,,,,,,,,,,,,,,1],[,1,,,1,1,,1,,1,1,,,,1,1,,,1,1,,,,1],[1,,,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,,,,1],,[,1,1,1,1,1,,1,1,1,,1,1,,1,1,,,1,1,1,1,,1,1,,1],[,1,,,1,,,1,,1,,,1,1,1,1,,,1,1,,1,1,1,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,,,1,1,1,1,1,1,1,,,1,,,1,,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,,,,1],[,,,,,,,1,,,,1,,1,1],[,1,1,1,1,1,1,1,,,,1,1,1,1,1,,,1,1,,1,1,1,1,1],[,1,,,1,1,,1,,1,1,1,,,1,1,,,1,,1,1,1,1,,1],[,1,1,1,,1,1,,1,1,,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1],[,,,,,,,,,,,,,,,,1],,[,1,1,1,1,1,,1,1,1,,,1,,1,1,,1,1,1,1,1,,1,,1],[,,1,,,1,,,1,1,,,1,,1,1,,1],[,1,1,,1,,,,1,1,,1,,1,1,1,1,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1],[,1,,,,,,,,,,1,1,,,,,,1,1,,1,,1,,1,1],,[,1,1,,1,,,1,,1,,,,1,1,1,,,,,,1,,,,1],[1,1,,,1,1,,1,,,,,1,,1]],[,[,1],[,,,1,,,,1,,,,1,,,,1,,,1,,,1],[,,,,,,,,,,,,,,,,,,1,1,,,,,,1],,[1,,,,,1],[,1,,,,1,,,,1],[,1,,,,,,,,,,,1,,,1,,,,,,,,,1,1],[,,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,1,,1],[,1],[,1,,1,,1,,1,,1,,1,1,1,,1,1,,1,,,,,,,1],[1,,,,,1,,,1,1,,1,,1,,1,1,,,,,1,,,1],[,1,1,,,1,,1,,1,,1,,1,1,1,1,,,1,,1,,1,1,1],[1,1,1,1,1,,1,,1,,,,1,1,1,1,,1,1,,,1,1,1,1],[1,,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],,[,1,,,,,,1,1,1,,1,,,,1,,,1,1,1,,,1],[1,,,,,1,,1,1,1,,1,1,1,1,1,,1,,1,,1,,,1,1],[1,,1,1,,,,,1,,,,,,1,1,,,1,1,1,1,,,1,,1],[1,,,,,,,,,,,,,,,,,1],[,,,,,1,,,1,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,,,1],[,1,,,,1]],[,[1,1,1,,1,,1,1,1,1,1,1,1,1,1,,1,,1,,1,1,,,1,1,1],[,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],,[,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1],,[1,1,,,,1,1,,,,,,1,,,,1,,1,,1,1,,1],[1],[,,,,,,,,,,,1,,,,,,,,,,,1],[,1,,,,,,,1,1,,,1,,1,,,,1,,,,,,,1],[,,,,,,,,,,,,,,,,1,,,,,1],[,,1,,,,,1,,1],[1,,,,1,,,,,1,,,,1,1,,,,1,1,,,,,1],[,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[1,,,1,1,,,,,,,1,,1,,1,1,1,1,1,1],[,,,,,1,,,,,,,1,,,,,,,1],,[,,1,1,1,1,1,,1,1,1,,,1,1,,,1,1,,1,1,1,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,,,,1],,[1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[,,,1,1,1,1,,,,,,1,,1,,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,,1],[,1,1,1,1,,1,1,1,1,1,1,1,1,,,,1,,1,,,1,1,1,1,1],[,,,,,,,,,,,1,,,,,,,,,1,,,,1],[,1,1,,1,1,,1,,,,1,1,,1,1,,,1,,1,1,,1],[,1,,1,,1,,,1,,,1,1,,1,1,,,1,1,1],[,1,1,1,1,1,,1,1,,,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,,,,,,,,,1,,1,,1,1,,,,1,,,1],[,1,,,1,1,,,,,,,,,1,1,1,,,,,1],[1,,,1,1,,,,1,1,1,1,1,,,1,,,1,,,1,,1,,1],[,1,1,,1,1,,1,1,,,,1,1,1,,,1,1,,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,,,,1,,,,,,,,,1],[,1,,,,,,,,1,,,,,1,,,,1,,,1],[,1,1,1,1,,,1,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1],[,,,,,1,,1,,,,,1,1,1,1,1,,,1,,,,1],[,1,,,,,,,,1,,,,,,,,,,,,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,1,,,,1,,1,1,1,1,1,,1,1,,,,,,1],[,1,1,1,1,1,1,1,,1,1,,,1,1,,,,1,,1,1,,1,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,1,1,,1,,,1,1,1,1,,,1,,,,,,,1],[,1,,,,,,,,1,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1],[,1,1,,,,,,,,,,,,1,1,,,,,,1],[,1,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,,,,,1],[1,1,,,1,,,1,1,1,,,,1],,[,,,,,,,,,,,,,1,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,1,,,,,,,1],[1,1,1,,1,,1,1,1,1,1,1,1,1,,1,,,1,,1,,,1,1],[,,,,,,,,,1],[,1,,,,1,,,,,,1,,,1,,,,,1],[,1,1,,1,1,,,,,,,,,,,,,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,1,1,1,,,,1,1,,,,1,,1],[1,1,1,1,1,1,,,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,,1,1],[,,,,,,,,,,,,,,,1,,,,1],,[1,1,,1,,1,,,,,,1,,1,,1,1,,1,,1,1,,1,1,,1],[,,1,,,,,,1,,,,1,,1,,,,,1],[1,,,,,,,,,1,,,,,,1,,,,1,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,,1,,,,,,1,,,1,,,,,,,,1],[,1,,1,,,,,,,,,,,,1],,[1,1,,,,,,,,,,,,,,,,,,,,,,1,1],[1]],[,[1,,,,,,,,,1,,,,,1,,1,,1],[,1,1,,1,1,,1,1,1,,,1,1,1,,,,1,,,1,,,,1],[,1,,,,,,,1,,,,1,,,,,,1],[1,1,1,1,1,1,,,,1,,,,,,,,,1,1,1,1],[1],[,1,1,,,1,1,,,,,1,,1,,,,,,,,1,,,,1],[1,,1,,,1,,1,,,,,1,1,1,1,,,,1,,,,1],[,,1,,,,,,,1,,,,,,,1,,,,,,,1],[1,,,,,,,,,,,,,,1,,,,1],[,,,1,,1,,,,,1,,,,1,1,,,,1],[1,,,,,1,,,,1,,1,1,,,1,1,,1,1,1,,1,1,1,,1],[,1,1,,,,,1,,1,,1,1,1,,1,1,,,1,,1,1,1],[,1,,,,1,,,,1,,,1,,1,1,,,1,1,,,,,,1],[1,,1,1,,1,,1,1,,1,,1,1,1,1,1,,,1,1,,,,,,1],[1,,,,,,,,,,,,,,,,,,1,,,1,,1],[,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,,1,,1],[,1,,,,1,,,1,1,,1,,,1,1,,,1,,,1,,,1,1],[1,1,,1,1,1,,1,1,1,,1,,1,1,1,,,1,,1,1],[1,,1,1,1,1,,,,1,,1,1,1,,1,,,1,1,1,,1,1,1,1,1],[1,,,,,,,,,,,,,1],[,,1,,,,,,,,,,,,,,,,,,,,1],[1,,,,,,,,,,,1,,1,,1,,,,1],[,,,1,,,,,,,,,1],[,1,,,,,,,,,,,,,,1,,,,,,,,,1],[,,,,,,,,1,1,,,,,,,,,1,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,,,1,1,1],[,,,,,1,,,,1,1,1,,,1,1,,,1,,1,1,,1],[,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,1,,,,,,,,,,,,,1],[,,1,,,1,,1,1,1,,1,1,,1,,,,1,,1,1],,[,,1,,,1,,,,,,1,,,,1],[,,,,,,,,,1,,,,,,,,,,1],[1,1,1,1,1,1,,1,1,1,,,1,1,,1,,1,,,1,1,1,,,1],[,,,,,1,,,,,,,,,,,,,1],[,1,,,,,,,,,,,,1,,1,1,,1,,,1],[,,,,,1,,,,,,,,,,,,,,1],[,1,1,1,1,,,,,1,,,1,,1,,,,1,1,,,,1,1],[,1,,,1,,,1,,1,1,,1,,,,,,,1],[,,1,,1,,,1,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,,,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,,,,,,,,,,1,,1,1],[,,,,,,,,,,,,1],,[,1,1,1,1,,,,1,1,,1,1,1,1,1,1,,1,1,1,1,,1,,1],[1,,,,1,,,,,,,,,,1],[1,,,,,,,,,1],,[,1,,,,1,,,,,,,,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,,,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,,1,1,1,1],[1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,,1,,,,1,1,,,1,1,,1],[,1,1,,1,,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,1],[1,1,1,,,,,1,1,1,,1,1,1,1,,,1,1,,1,1,,,,,1],[,1,,,,,,,1,1,,,1,1,1,,1,,,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,,,1,,,,1,,,1,,,,1,,,,,,,1,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1],[1,1,1,,1,,,1,1,1,1,,1,1,1,1,,,,1,,1,,1,,,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,,1,1,,,,,,,,,1],,[,1,,1,,1,,1,,1,,1,1,1,1,1,,,1,,1,,1,,,,1],[,1,,,1,1,,1,1,1,,,1,1,1,1,1,,1,1,1,,1,,,1],[1,,,1,,,,1,1,1,,,,,1,1,,,,1,,1],[1,1,,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,,1,,1,,,,,,,,1,,1],[,1,,,,1,,1,1,,,,1,1,,1,,,,1,1,1,,1],,[,1,,,,,,1,,,,,,,1],[,,,,,,,,1,,,,1,,1,,,,,,,,,,,,1]],[,[,1,1,,1,1,1,1,,1,1,1,,1,1,,1,1,,1,1,1,1,1,1,,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,,,1,,,,,,,,1,,,,,,1,,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,1,1,1,,1,1,1,1,,,1,1,1,1,,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,,1,,1,,1,,1,1,1,1,1,1,1,,1,1,,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1],[,1,1,,,,,1,1,1,,,1,,1,1,,,,1,,1,,,1,1],[,,,,,,,1,,,,1,1,1,1,1,,1,,,,,,,,1],[1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,,1,,1,1,,,1,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,1,1,,1,,1,1,1,,1,,1,1,,1,1,,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,,,,,,1,,,,,1,,1],[,1,1,1,,1,,1,,1,,,,1,,1,,,1,,,,,,1,1],[,1,,,1,1,,1,,1,,1,1,1,1,1,,1,1,,,1,,,1],[1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,,,1,,1,,1,,,,,,1,,1,,,,1,1]],[,[,1,,1,,,,,,,,,,,,,,,1,,,,1],[,,,,,,,,,1,,1,1,1,,1,,,1,,1,1],[1,1,,,,,,,1,,,,,,,1,,,,,,1],[,1,,,,,,,,,,1,,,,,,,,,1,1],,[,,,,,,,,,,,,,,,1,,,,1,,1],[,,1,1,,1,,1,,,,,,,,1,,,,,,1],[,,,,,,,,,,,,,,,,,,,,1,1],[,1,,,,,,,,,,,,,1],[1,,1,1,,,,1,,,,,,,,,1,,,1,,,1,1],[,1,1,,1,1,,1,1,1,1,1,1,1,1,1,,,1,1,,1,1,,1],[,1,,,1,1,,,,,,1,,1,,1,,,1,,1,1],[1,1,1,1,,1,,1,,1,,1,1,,1,1,1,1,1,,1,1,1,1,1],[,1,1,,,1,,1,,1,1,1,,,1,1,1,,1,1,1,1,,1,1],[,,,,1,,,1,,,,,,,1,,,,1,1],[,1,,,,,,,,,,1,,1,,1,,,,,1,,,,,1],,[1,1,,1,,1,,1,1,,,,,,1,1,,,1,1,1,1,1,1,1,1,1],[1,1,,1,,,,,,1,,,,,,1,1,,,,1,1,,,1],[,1,1,,1,1,,,,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,,,1,,,,1,,,,1,1],[,,,,1],[,,,,,,,,,1,,,1],,[,,1,,1,,,,,,,,,1,,,,,,,,,,,,1],[,,,,,,,,,,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,1,1,1,1,,,1,1,1,1,1,,1,1,1,1,1,,,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,,,,,1],[,1,,1,,,,,,1,,,,,1,1,,,,,1,1],[,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,,1,,,1,,1,1,1],[,1,,,,1,,,,,,,1],[,1,,,1,,,1,,1,,1,1,,1,,,,,1,,1,,,,1,1],[,1,,,1,,,1,1,1,,1,1,1,1,1,,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1],[,,,,,,,,,,,,,,,,,,,,1],[,1,1,1,,,,1,1,,,,,,1,1,1,,1,1,1,1],[1,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1],[,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,1,1,1,1,1,1,1,,1,,1,1,1,1,1,,1,1,,1,1,1,1,1],[,1,,,,1,,,,1,,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,1,,,,,,,,1,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1],[1,1,,1,1,1,,1,1,1,,,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,,,,,,,1,1,,,,,1,1,1,1,1,,1,1,1,1,,1],[,1,1,1,1,1,1,1,,1,1,1,,1,,1,1,1,1,,1,1,,1,1,1,1],,[,1,1,,,,,1,,1,,,,1,1,1,,,1,,,,,1],[,,,,,,,,,,,,,1],[,,,,,1,,,,,,,,1,1,,,,,1,,1,,,1,1],[,,,,,,,,,,,,,,1]],[,[,1],,,,,,,,,,,,,,,,,,,,[1,1,1,1,1,,1,1,1,1,,1,1,1,1,,1,1,1,1,,,1,1,1,1,1],[,1,,1,,1,,,1,1,1,,1,1,1,1,1,,,1,,,,1,,1,1],[,1,,1,,1,,,1,,,,,1,,,,,,1,1],[,1,,1,,,,,1,,,,1,,1,1,1,1,1,1,1,1,,1],[,1,,,,,,,,,,,,,,,1]],[,[,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,,,,,,,,,1,1,,,,1],[,,,,,,1],[,,1],[,1,1,,,1,,1,,1,1,,1,1,1,,,,1,1,1,,,,,1],,[,1,,,,1,,,,,,1,,,1,,,,1,1,,1],[,,,,,,,1,,,,,,,,,1],[,1,,,,1,1,,,,,,1,1,1,,,,1,,1,1],[,,,,,,,1,,1,,,,,,,,,,1],[,1,1,,,,,,1,1,,,,1,,,,,,,1,,,1],,[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,,1,,,1,,,,,1,,1,,1,,1,,,,,1],[1,1,1,1,1,1,1,1,,,,,1,1,,1,1,,1,,,1,,1],[,,,,,,,,,,,,,,1,,,,,,1],,[,,,,,,,,,1,,,,,,1,,,,,1],[,,1,,,,,,,1,,,1,1],[,,,1,,,,,1,,,,,1,,,,,,1,,,,1],[1,,1,1,,1,1,1,1,1,,1,,,,1,1,1,,,1,1,,,,1,1],,[1,1,,,,,,,,,,1,,1,,1,,,1],[,,,,1,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,1,,,,,1,,1],[,,,,,,,,1]],[,[1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,,1,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,,1,,,1,,,,,,,,1,,,,,,1,,,,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,1,,,,1,1,1,1,1,1,,1,1,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,,1,1,1,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1],[1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,,1,1,1,1,,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,,,,,,,1,,1,1,,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1],[1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,,1,,1,,1,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1],[1,1,1,1,,1,,,,,,1,,1,,,,,1,1,,,,,1],[1,,1,1,,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,1,1,,1,,1,,,,1,1,1,1,1,,,1,1,,1,,1],[,1,1,1,1,,,,,1,,1,1,1,1,1,,,1,1,,,,1,1,1],[,1,1,1,1,1,,1,,,,,1,,1,,1,,,1,,,1,1,,1]],[,[1,1,1,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1,,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,,,,,1,,,,,1,1,,,1,,1],[1,1,1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,,1,1,1,1,,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1],[1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,,,,1,,1,1,,1,1,1,1,1,,,1,,1,,1],[1,1,1,,1,1,1,1,,,,1,1,1,1,,1,1,1,1,1,1,1,1,1,,1],[1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,,1,1,1,1,1,1,1,1,1,,1,1,,1,1,1,1,1,,1,1,1,1,1,1],[,1,,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1],[,,1,,,,,,,,,,1,1,1,1,1,1,1,,1,1,,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,1,1,1,1,1,1,1],[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,1,1,1,1,1],[,1,,,1,1,,,,,,1,1,1,1,1,,,,1,1,1,,1,1,1],[1,1,1,1,1,1,1,1,1,,,,1,1,1,1,1,1,1,,1,1,,1,1,1],[,1,1,1,,1,,1,1,1,1,,,1,1,1,,1,1,1,1,1,,,1,1],[1,1,,,,1,,,1,1,1,,1,,1,,1,,1,1,1,1,1,,1,,1],[,1,,,,,,,1,,1,,1,1,1,1,,,,,,,,,1]],[,[,,,,,,,,,,,,,1,1,,,,1],[,1,,,,,,,,1,,,1,,,,,,1,,,1,,,,1],,[,1,,,,1,,1,,1,1,,1,1,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1],[,,,,,,,,,1],[1,1,1,,,1,,,,,,,,,1,1,,,,,,,,,,1],[,1,,,,,,,,,,,,,1],[,,,,,,,,,,,,,,,,,,,1,,,1],[,,,,,,,,,1],[1,1,,,,,,1,1,1,,1,1,,,,1,1,,1,,1,1,1,,1],[,1,1,1,,1,1,,,1,,1,1,1,1,,,,,,,1,,1],[,1,1,1,1,,,1,,1,,,,1,1,1,1,,1,1,,1],[,1,,,1,1,,1,,,,1,,1,1,,1,,1,,,1,,,1,,1],[,,,,,,,,,,,1],[,,,,,,,,,1,,,,,,,,,,,,,1],,[1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,,1,1,1,1,1,1,1],[,1,,,,,,,1,1,,1,,,,,1,,,1,,1],[,1,,,,1,,,1,,,,,,,,1,,1,,,1],[,,,,,,,,,,,,,1,1,,,,1,,,1],[,,,,,1,,,1,,,,1],[,1],,[,1],[1,,,,,,,,,,,,,,1,,,,,1]],[,[,1,,,,1,1,1,1,1,1,,1,1,1,1,1,,1,1,,1,1,,,1],[,,1,,,,,,,,,1],,,[1,,,1,1,,,,,,,,1,1,,1,1,,1],,[,,,,,,,,,,,,,,,,,,1,,1],,[1,,,1,1,,1,1,,,,,1,,1,,,,,1,1,,1],,[,1,,,,,,,,1,1,1,1,1,,1,1,,,,1,1],[,,,,,,,,,,,,,,,,1,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,,,1,1,1,1,,1,1,1,1,1,1],[,,,,,,,,,,,1,,1,,,1],[1,,,,,,,,,,,,,,,,,,1,,1],,,[,1,,,,,,,,,,,,,,1,,,,1,1],[,,,,,,,,,1,,,1,,,,,,,,,,1],[,,,,,,,,,,,,,,,1],[,,,,,,,,,,,,,1,1,,,,,,1],,[,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,,1,1,,1,1,1,1,1,1,,,1,1,1,1,1,,1,1],[,1,,,,,,,,1],[,,,,1,,,1,,,1,1,,,,,,,,,,1,,,,1],[,1,,1,1,,,1,1,1,,,,1,1,1,1,,1,1,1,1,,1],[,,,,,,,1],[,1,1,,,,,1,,1,,,,,,1,,,,,,1,,1,,1],[,1,,,,,,1,,,,1,,,,,,,,,,1],[,,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1,1,1,1,,1],[,1,,,,,,,,1],[,1,1,,1,,,,,,,,1,,,,,,1,,,1,,1,,1],[,1,,1,,1,,1,1,1,,1,1,1,,1,,,1,1,,1,1,1,1,1],[,1,1,1,1,1,,,1,1,,,,1,1,1,,,,1,1,,,1,1],[,,1,1,1,1,,1,,1,,1,,1,1,1,1,,,,,1,,1,,1],[1,1,1,1,1,1,1,1,,1,,1,,1,1,1,,,1,1,,,,1,,1],[,,,1],,[,1,1,,1,,,1,1,1,,1,1,1,1,1,1,,1,1,,1,1,1,1,1,1],[,1,,,,,,1,,1,,1,,,,,,,1,1,,1,1],[,,,,,,1,,1,1,,1,,1,,,,,,,,,,1],[,1,1,,1,,,,1,,,,1,1,1,,,,1,,1,1,1,,1,1],,[,1,1,,,,,,,,,,,,,1,,,1,,,,,1],[,1,,,,,,,,,,,,,,,,,,,,,,1],[,1,1,,,,,,,1,,,,1,,,,,1,,,,,,,1]],[,[,1,1,1,1,1,,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1],[,1,1,1,1,1,,1,,1,1,,,1,1,1,1,,1,,,,,1,1,1],[,,1,1,,1,,1,1,,,,1,1,1,1,,,1,,1,1,1,1,,1],[,1,,1,,,,,,,,1,,1,,1,,,,,,,,,,1],[,,1,,1,,,1,,,,,1,1,,,1,,1,1,1,1],[,1],[,1,1,,1,,1,1,,1,,,1,1,1,,,,1,,,1,,1],[1,1,,1,1,1,,,,,,,,,,,,,1,,1,1,1],[,1,1,,,,,,,1,,,1,,1,,1,,1,1,,,1,,,1],[,,1,,,,,,,,,,,,,,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,1,1,1,,1,,1,,,,,1,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,,,1,1,1,,1,,1,1,1,,,1,1,1,1,,,,1,1],[,,,1,1,,,1,,1,,1,,1,1,1,1,,1,,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,1,,1,1,,1,,1,,,,1,1,,,1,1,,1,1,,1],[,1,1,1,1,1,,,1,1,1,,1,1,1,1,1,1,1,1,,1,1,,,1],[,1,1,1,1,1,,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1,,1,1],[,1,1,,1,,,1,,,1,,1,1,1,1,1,,1,,1,1],[,,,,,1,,,,1,,,,,1,1,,,,1],[,1,,1,1,1,,1,,,1,1,1,,,1,,,1,,1,,,1],[,,1,,,,,,,,,1,,1,,,,,1,,1],[,1,1,,,,,,,,1,1,1,,,,,,,,1,,,,,1],[,,,,,,,,1,,,,,1,,,1]],[,[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,1,,1,1,,,1,1,1,1,1,1,1,1,,,,,,,,,1,1],[,,,,,,,,1,,,,1,,1,,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,1,,1,,1,,,,1,1,,1,,1,,,,1,1,1,1,1,,,1],,[,1,,,,,,,,1,,,1,1,,,1,,1,1,,1,,1],[,1,,,1,,,,,,,,1,,,,,,,1],[1,1,,,,,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,,1,1,1],,[,1,,,,,,1,,1,,1,1,1,1,1,,,1,,1,1,,,,1],[,1,1,,,1,,1,,1,,,1,1,1,1,,,1,,,1,,,,1],[,1,1,1,1,1,,1,1,1,,1,1,1,1,1,1,1,1,1,1,,,,1,,1],[,1,,,1,1,,1,1,,,1,1,,1,1,,1,,1,,1],[1,,1,,,,,1,,1,,1,1,1,1,,,,,1,1,,,,1,1],[,1,1,,,,,1,1,,,1,,1,1,1,1,,,,,,,,,,1],,[,1,1,,,1,,,,1,,1,1,1,1,1,,,,1,,,,1,,1],[,,,1,1,,,1,,,,,1,,1,1,1,,1,1,,,,,,1],[,1,,,,,,,,,,,1,,,,1,,,,,,,1,,1],[,1,1,1,1,1,1,1,,1,1,1,1,1,1,,1,1,1,,1,1,,1,1,1,1],[,1,,,,,,,,,,,,,,,,,,,1],[,1,,,,,,1,,,,,1,,1,,,1,1,,1,1,,1],[,1,,,,,,1,,,,,1,1,,,,,,,,1,,,,1],[,,,,,,,,,,,,,,,,,,1,,,1,,,,,1],[,,,,,,,1,,,,1]],[,[1,1,1,1,1,1,1,1,1,1,1,1,1,1,,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,1,,1,,,,,,,1,,,,,,,,1,,,1],[,1,,,,,,,1],[,,,,,,,,,,1],[,1,,,,,,1,1,,,,,,1],,[,1,1,,,,,,1,,,,,1,1,,,,1],[1,,1,,1,,,,,1,,,,,1,,,,,,,,,1,1],[,1,1,,,,,,,,,1,1,1,1,,,,1,,,,,1,,,1],,[,1,1,,1,,,1,1,,,1,,,1,1,1,,1,,1,1,1,,,,1],[,,,,,1,,,,,1,,,1,1,,,1,,1,,,,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,1,,,1,1,,1,,,,1,,,,,,,,1],[,,,1,,,,,1,,,,,1,,1,,1,1,1],[,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],[,,,,,1],[,1,,,,,,1,,,,,,,1,1,1,,,1],[,1,,,,,,,,,,1,1,1,,,,,1,,,1],[,,,,,1,,1,,,,,1,1,1,,1,1,,1,1,1,,,1,1],[1,1,,,,,,,1,,,,,1,1,,,,,,,,,,,1],,[,1],[,,,,,,,,,,,,,,,,,,,,,,,,1],[,,1,,,,,1,,,1,,,,1,,1],[,1,,,,,,,,,1]]];function Wo(e){e=Array.isArray(e)?e:$o;var t=[];return e.forEach((function(e,a){var r=String.fromCharCode(a+96).replace("`","");Array.isArray(e)?t=t.concat(Wo(e).map((function(e){return r+e}))):t.push(r)})),t}var Go=function(e){for(var t=$o;e.length<3;)e+="`";for(var a=0;a<=e.length-1;a++)if(!(t=t[e.charCodeAt(a)-96]))return!1;return!0};o._thisWillBeDeletedDoNotUse=o._thisWillBeDeletedDoNotUse||{},o._thisWillBeDeletedDoNotUse.utils={setDefaultFrameMessenger:ta};var Yo=function(){f(t,xt);var e=h(t);function t(a){var r,o,i;return w(this,t),(r=e.call(this))._props=function(e){var t=e.nodeName,a=e.nodeType,r=void 0===a?1:a;return Ft("number"==typeof r,"nodeType has to be a number, got \'".concat(r,"\'")),Ft("string"==typeof t,"nodeName has to be a string, got \'".concat(t,"\'")),a=null,"input"===(t=t.toLowerCase())&&(a=(e.type||e.attributes&&e.attributes.type||"").toLowerCase(),zo().includes(a)||(a="text")),t=D({},e,{nodeType:r,nodeName:t}),a&&(t.type=a),delete t.attributes,Object.freeze(t)}(a),r._attrs=(a=(a=a).attributes,o=void 0===a?{}:a,i={htmlFor:"for",className:"class"},Object.keys(o).reduce((function(e,t){var a=o[t];return Ft("object"!==n(a)||null===a,"expects attributes not to be an object, \'".concat(t,"\' was")),void 0!==a&&(e[i[t]||t]=null!==a?String(a):null),e}),{})),r}return E(t,[{key:"props",get:function(){return this._props}},{key:"attr",value:function(e){return this._attrs[e]||null}},{key:"hasAttr",value:function(e){return void 0!==this._attrs[e]}},{key:"attrNames",get:function(){return Object.keys(this._attrs)}}]),t}(),Ko={};N(Ko,{allowedAttr:function(){return Jo},arialabelText:function(){return Qo},arialabelledbyText:function(){return rl},getAccessibleRefs:function(){return vl},getElementUnallowedRoles:function(){return El},getExplicitRole:function(){return ti},getImplicitRole:function(){return Ei},getOwnedVirtual:function(){return _i},getRole:function(){return ki},getRoleType:function(){return Dl},getRolesByType:function(){return Cl},getRolesWithNameFromContents:function(){return kl},implicitNodes:function(){return Ol},implicitRole:function(){return Ei},isAccessibleRef:function(){return Sl},isAriaRoleAllowedOnElement:function(){return wl},isUnsupportedRole:function(){return Zo},isValidRole:function(){return ei},label:function(){return Pl},labelVirtual:function(){return Jr},lookupTable:function(){return _l},namedFromContents:function(){return Ni},requiredAttr:function(){return Il},requiredContext:function(){return Bl},requiredOwned:function(){return Ll},validateAttr:function(){return Ml},validateAttrValue:function(){return ql}});var Xo=function(){if(qa.get("globalAriaAttrs"))return qa.get("globalAriaAttrs");var e=Object.keys(En.ariaAttrs).filter((function(e){return En.ariaAttrs[e].global}));return qa.set("globalAriaAttrs",e),e},Jo=function(e){var t=En.ariaRoles[e];e=y(Xo());return t&&(t.allowedAttrs&&e.push.apply(e,y(t.allowedAttrs)),t.requiredAttrs&&e.push.apply(e,y(t.requiredAttrs))),e},Qo=function(e){if(!(e instanceof xt)){if(1!==e.nodeType)return"";e=Ma(e)}return e.attr("aria-label")||""},Zo=function(e){return!!(e=En.ariaRoles[e])&&!!e.unsupported},ei=function(e){var t=(r=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).allowAbstract,a=void 0!==(n=r.flagUnsupported)&&n,r=En.ariaRoles[e],n=Zo(e);return!(!r||a&&n||!t&&"abstract"===r.type)},ti=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=t.fallback,r=t.abstracts,n=t.dpub;return 1!==(e=e instanceof xt?e:Ma(e)).props.nodeType?null:(t=(e.attr("role")||"").trim().toLowerCase(),(a?Ho(t):[t]).find((function(e){return!(!n&&"doc-"===e.substr(0,4))&&ei(e,{allowAbstract:r})}))||null)},ai=function(e){return Object.keys(En.htmlElms).filter((function(t){return(t=En.htmlElms[t]).contentTypes?t.contentTypes.includes(e):!!t.variant&&!(!t.variant.default||!t.variant.default.contentTypes)&&t.variant.default.contentTypes.includes(e)}))},ri=fo((function(e){for(var t=[],a=e.rows,r=0,n=a.length;r<n;r++){var o=a[r].cells;t[r]=t[r]||[];for(var i=0,l=0,s=o.length;l<s;l++)for(var u=0;u<o[l].colSpan;u++){for(var c=o[l].getAttribute("rowspan"),d=0===parseInt(c)||0===o[l].rowspan?a.length:o[l].rowSpan,p=0;p<d;p++){for(t[r+p]=t[r+p]||[];t[r+p][i];)i++;t[r+p][i]=o[l]}i++}}return t})),ni=fo((function(e,t){var a,r;for(t=t||ri(Fr(e,"table")),a=0;a<t.length;a++)if(t[a]&&-1!==(r=t[a].indexOf(e)))return{x:r,y:a}})),oi=function(e){var a=e.getAttribute("scope"),r=e.getAttribute("role");if(e instanceof t.Element==0||-1===["TD","TH"].indexOf(e.nodeName.toUpperCase()))throw new TypeError("Expected TD or TH element");if("columnheader"===r)return"col";if("rowheader"===r)return"row";if("col"===a||"row"===a)return a;if("TH"!==e.nodeName.toUpperCase())return!1;a=ri(Fr(e,"table"));var n=ni(e,a);return a[n.y].reduce((function(e,t){return e&&"TH"===t.nodeName.toUpperCase()}),!0)?"col":a.map((function(e){return e[n.x]})).reduce((function(e,t){return e&&t&&"TH"===t.nodeName.toUpperCase()}),!0)?"row":"auto"},ii=function(e){return-1!==["col","auto"].indexOf(oi(e))},li=function(e){return["row","auto"].includes(oi(e))},si=ai("sectioning").map((function(e){return"".concat(e,":not([role])")})).join(", ")+" , main:not([role]), [role=article], [role=complementary], [role=main], [role=navigation], [role=region]";function ui(e){var t=$r(rl(e));e=$r(Qo(e));return t||e}var ci={a:function(e){return e.hasAttr("href")?"link":null},area:function(e){return e.hasAttr("href")?"link":null},article:"article",aside:"complementary",body:"document",button:"button",datalist:"listbox",dd:"definition",dfn:"term",details:"group",dialog:"dialog",dt:"term",fieldset:"group",figure:"figure",footer:function(e){return er(e,si)?null:"contentinfo"},form:function(e){return ui(e)?"form":null},h1:"heading",h2:"heading",h3:"heading",h4:"heading",h5:"heading",h6:"heading",header:function(e){return er(e,si)?null:"banner"},hr:"separator",img:function(e){var t=e.hasAttr("alt")&&!e.attr("alt"),a=Xo().find((function(t){return e.hasAttr(t)}));return!t||a||ln(e)?"img":"presentation"},input:function(e){var t,a;switch(e.hasAttr("list")&&(a=(t=Kr(e.actualNode,"list").filter((function(e){return!!e}))[0])&&"datalist"===t.nodeName.toLowerCase()),e.props.type){case"checkbox":return"checkbox";case"number":return"spinbutton";case"radio":return"radio";case"range":return"slider";case"search":return a?"combobox":"searchbox";case"button":case"image":case"reset":case"submit":return"button";case"text":case"tel":case"url":case"email":case"":return a?"combobox":"textbox";default:return"textbox"}},li:"listitem",main:"main",math:"math",menu:"list",nav:"navigation",ol:"list",optgroup:"group",option:"option",output:"status",progress:"progressbar",section:function(e){return ui(e)?"region":null},select:function(e){return e.hasAttr("multiple")||1<parseInt(e.attr("size"))?"listbox":"combobox"},summary:"button",table:"table",tbody:"rowgroup",td:function(e){return e=er(e,"table"),e=ti(e),["grid","treegrid"].includes(e)?"gridcell":"cell"},textarea:"textbox",tfoot:"rowgroup",th:function(e){return ii(e.actualNode)?"columnheader":li(e.actualNode)?"rowheader":void 0},thead:"rowgroup",tr:"row",ul:"list"},di=function(e,t){var a=n(t);if(Array.isArray(t)&&void 0!==e)return t.includes(e);if("function"===a)return!!t(e);if(null!=e){if(t instanceof RegExp)return t.test(e);if(/^\\/.*\\/$/.test(t))return a=t.substring(1,t.length-1),new RegExp(a).test(e)}return t===e},pi=function(e,t){if("object"!==n(t)||Array.isArray(t)||t instanceof RegExp)throw new Error("Expect matcher to be an object");return Object.keys(t).every((function(a){return di(e(a),t[a])}))},fi=function(e,t){return e instanceof xt||(e=Ma(e)),pi((function(t){return e.attr(t)}),t)},mi=function(e,t){return!!t(e)},hi=function(e,t){return di(ti(e),t)},gi=function(e,t){return di(Ei(e),t)},bi=function(e,t){return e instanceof xt||(e=Ma(e)),di(e.props.nodeName,t)},yi={attributes:fi,condition:mi,explicitRole:hi,implicitRole:gi,nodeName:bi,properties:Js=function(e,t){return e instanceof xt||(e=Ma(e)),pi((function(t){return e.props[t]}),t)},semanticRole:ru=function(e,t){return di(ki(e),t)}},vi=function e(t,a){return t instanceof xt||(t=Ma(t)),Array.isArray(a)?a.some((function(a){return e(t,a)})):"string"==typeof a?Za(t,a):Object.keys(a).every((function(e){if(!yi[e])throw new Error(\'Unknown matcher type "\'.concat(e,\'"\'));var r=yi[e];e=a[e];return r(t,e)}))},Di=function(e,t){return vi(e,t)};Di.attributes=fi,Di.condition=mi,Di.explicitRole=hi,Di.fromDefinition=vi,Di.fromFunction=pi,Di.fromPrimative=di,Di.implicitRole=gi,Di.nodeName=bi,Di.properties=Js,Di.semanticRole=ru;var wi=Di,xi=function(e){var t=En.htmlElms[e.props.nodeName];if(!t)return{};if(!t.variant)return t;var a,r,n=t.variant,o=p(t,l);for(a in n)if(n.hasOwnProperty(a)&&"default"!==a){var i=n[a],u=i.matches,c=p(i,s);if(wi(e,u))for(var d in c)c.hasOwnProperty(d)&&(o[d]=c[d])}for(r in n.default)n.default.hasOwnProperty(r)&&void 0===o[r]&&(o[r]=n.default[r]);return o},Ei=function(e){var t=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).chromium,a=e instanceof xt?e:Ma(e);if(e=a.actualNode,!a)throw new ReferenceError("Cannot get implicit role of a node outside the current scope.");var r=a.props.nodeName;return(r=ci[r])||!t?"function"==typeof r?r(a):r||null:xi(a).chromiumRole||null},Ai={td:["tr"],th:["tr"],tr:["thead","tbody","tfoot","table"],thead:["table"],tbody:["table"],tfoot:["table"],li:["ol","ul"],dt:["dl","div"],dd:["dl","div"],div:["dl"]};function Ci(e,t){var a=t.chromium;t=p(t,u);return(a=Ei(e,{chromium:a}))?(t=function e(t,a){var r=Ai[t.props.nodeName];if(!r)return null;if(!t.parent)throw new ReferenceError("Cannot determine role presentational inheritance of a required parent outside the current scope.");return r.includes(t.parent.props.nodeName)?(r=ti(t.parent,a),["none","presentation"].includes(r)&&!Fi(t.parent)?r:r?null:e(t.parent,a)):null}(e,t))||a:null}function Fi(e){return Xo().some((function(t){return e.hasAttr(t)}))||ln(e)}var ki=function(e){var t=(a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).noPresentational,a=function(e,t){var a=1<arguments.length&&void 0!==t?t:{},r=a.noImplicit,n=p(a,c),o=e instanceof xt?e:Ma(e);return 1!==o.props.nodeType?null:!(a=ti(o,n))||["presentation","none"].includes(a)&&Fi(o)?r?null:Ci(o,n):a}(e,p(a,d));return t&&["presentation","none"].includes(a)?null:a},Ri=["iframe"],Ti=function(e){var t=e instanceof xt?e:Ma(e);return 1!==t.props.nodeType||!e.hasAttr("title")||!Di(t,Ri)&&["none","presentation"].includes(ki(t))?"":t.attr("title")},Ni=function(e){var t=(1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).strict;if(1!==(e=e instanceof xt?e:Ma(e)).props.nodeType)return!1;var a=ki(e),r=En.ariaRoles[a];return!(!r||!r.nameFromContent)||!t&&(!r||["presentation","none"].includes(a))},_i=function(e){var t=e.actualNode,a=e.children;if(!a)throw new Error("getOwnedVirtual requires a virtual node");return e.hasAttr("aria-owns")?(t=Kr(t,"aria-owns").filter((function(e){return!!e})).map((function(e){return o.utils.getNodeFromTree(e)})),[].concat(y(a),y(t))):y(a)},Oi=ai("phrasing").concat(["#text"]),Si=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=tl.alreadyProcessed;t.startNode=t.startNode||e;var r=(i=t).strict,n=i.inControlContext,o=i.inLabelledByContext,i=xi(e).contentTypes;return a(e,t)||1!==e.props.nodeType||null!=i&&i.includes("embedded")||!Ni(e,{strict:r})&&!t.subtreeDescendant?"":(r||(t=D({subtreeDescendant:!n&&!o},t)),_i(e).reduce((function(e,a){return function(e,t,a){var r=t.props.nodeName;return(a=tl(t,a))?(Oi.includes(r)||(" "!==a[0]&&(a+=" "),e&&" "!==e[e.length-1]&&(a=" "+a)),e+a):e}(e,a,t)}),""))},Pi=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=tl.alreadyProcessed;if(t.inControlContext||t.inLabelledByContext||a(e,t))return"";t.startNode||(t.startNode=e);var r,n=D({inControlContext:!0},t);a=function(e){if(!e.attr("id"))return[];if(e.actualNode)return Ar({elm:"label",attr:"for",value:e.attr("id"),context:e.actualNode});throw new TypeError("Cannot resolve explicit label reference for non-DOM nodes")}(e);return(t=er(e,"label"))?(r=[].concat(y(a),[t.actualNode])).sort(mo):r=a,r.map((function(e){return al(e,n)})).filter((function(e){return""!==e})).join(" ")},Ii={submit:"Submit",image:"Submit",reset:"Reset",button:""};function Bi(e,t){return t.attr(e)||""}function Li(e,t,a){var r=t.actualNode;t=[e=e.toLowerCase(),r.nodeName.toLowerCase()].join(",");return(t=r.querySelector(t))&&t.nodeName.toLowerCase()===e?al(t,a):""}var qi={valueText:function(e){return e.actualNode.value||""},buttonDefaultText:function(e){return e=e.actualNode,Ii[e.type]||""},tableCaptionText:Li.bind(null,"caption"),figureText:Li.bind(null,"figcaption"),svgTitleText:Li.bind(null,"title"),fieldsetLegendText:Li.bind(null,"legend"),altText:Bi.bind(null,"alt"),tableSummaryText:Bi.bind(null,"summary"),titleText:Ti,subtreeText:Si,labelText:Pi,singleSpace:function(){return" "},placeholderText:Bi.bind(null,"placeholder")};function Mi(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=e.actualNode;if(1!==e.props.nodeType||["presentation","none"].includes(ki(e)))return"";var r=(xi(e).namingMethods||[]).map((function(e){return qi[e]})).reduce((function(a,r){return a||r(e,t)}),"");return t.debug&&o.log(r||"{empty-value}",a,t),r}var ji={accessibleNameFromFieldValue:["combobox","listbox","progressbar"]},Ui=["button","checkbox","color","file","hidden","image","password","radio","reset","submit"],Vi=function(e){var t=(e=e instanceof xt?e:Ma(e)).props.nodeName;return"textarea"===t||"input"===t&&!Ui.includes((e.attr("type")||"").toLowerCase())},Hi=function(e){return"select"===(e=e instanceof xt?e:Ma(e)).props.nodeName},zi=function(e){return"textbox"===ti(e)},$i=function(e){return"listbox"===ti(e)},Wi=function(e){return"combobox"===ti(e)},Gi=["progressbar","scrollbar","slider","spinbutton"],Yi=function(e){return e=ti(e),Gi.includes(e)},Ki=["textbox","progressbar","scrollbar","slider","spinbutton","combobox","listbox"],Xi={nativeTextboxValue:function(e){return e=e instanceof xt?e:Ma(e),Vi(e)&&e.props.value||""},nativeSelectValue:function(e){var t=e instanceof xt?e:Ma(e);return Hi(t)?((t=(e=Lo(t,"option")).filter((function(e){return e.hasAttr("selected")}))).length||t.push(e[0]),t.map((function(e){return Xr(e)})).join(" ")||""):""},ariaTextboxValue:function(e){var t=e instanceof xt?e:Ma(e);e=t.actualNode;return zi(t)?!e||e&&!rn(e)?Xr(t,!0):e.textContent:""},ariaListboxValue:Ji,ariaComboboxValue:function(e,t){return e=e instanceof xt?e:Ma(e),Wi(e)&&(e=_i(e).filter((function(e){return"listbox"===ki(e)}))[0])?Ji(e,t):""},ariaRangeValue:function(e){return e=e instanceof xt?e:Ma(e),Yi(e)&&e.hasAttr("aria-valuenow")?(e=+e.attr("aria-valuenow"),isNaN(e)?"0":String(e)):""}};function Ji(e,t){return e=e instanceof xt?e:Ma(e),$i(e)?0===(e=_i(e).filter((function(e){return"option"===ki(e)&&"true"===e.attr("aria-selected")}))).length?"":tl(e[0],t):""}function Qi(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=e.actualNode,r=ji.accessibleNameFromFieldValue||[],n=ki(e);return t.startNode===e||!Ki.includes(n)||r.includes(n)?"":(n=Object.keys(Xi).map((function(e){return Xi[e]})).reduce((function(a,r){return a||r(e,t)}),""),t.debug&&vt(n||"{empty-value}",a,t),n)}function Zi(e){var t=e.actualNode,a=function(e,t){var a=e.actualNode;return t.startNode||(t=D({startNode:e},t)),a?(1===a.nodeType&&t.inLabelledByContext&&void 0===t.includeHidden&&(t=D({includeHidden:!Ir(a,!0)},t)),t):t}(e,a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{});if(function(e,t){return!!(e=e.actualNode)&&(1===e.nodeType&&!t.includeHidden&&!Ir(e,!0))}(e,a))return"";var r=[rl,Qo,Mi,Qi,Si,el,Ti].reduce((function(t,r){return""!==(t=a.startNode===e?$r(t):t)?t:r(e,a)}),"");return a.debug&&o.log(r||"{empty-value}",t,a),r}function el(e){return 3!==e.props.nodeType?"":e.props.nodeValue}Zi.alreadyProcessed=function(e,t){return t.processed=t.processed||[],!!t.processed.includes(e)||(t.processed.push(e),!1)};var tl=Zi,al=function(e,t){return e=Ma(e),tl(e,t)},rl=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};if(!(e instanceof xt)){if(1!==e.nodeType)return"";e=Ma(e)}return 1!==e.props.nodeType||t.inLabelledByContext||t.inControlContext||!e.attr("aria-labelledby")?"":Kr(e,"aria-labelledby").filter((function(e){return e})).reduce((function(a,r){return r=al(r,D({inLabelledByContext:!0,startNode:t.startNode||e},t)),a?"".concat(a," ").concat(r):r}),"")},nl={};N(nl,{accessibleText:function(){return al},accessibleTextVirtual:function(){return tl},autocomplete:function(){return dl},formControlValue:function(){return Qi},formControlValueMethods:function(){return Xi},hasUnicode:function(){return il},isHumanInterpretable:function(){return ul},isIconLigature:function(){return cl},isValidAutocomplete:function(){return pl},label:function(){return hl},labelText:function(){return Pi},labelVirtual:function(){return ml},nativeElementType:function(){return gl},nativeTextAlternative:function(){return Mi},nativeTextMethods:function(){return qi},removeUnicode:function(){return sl},sanitize:function(){return $r},subtreeText:function(){return Si},titleText:function(){return Ti},unsupported:function(){return ji},visible:function(){return fl},visibleTextNodes:function(){return bl},visibleVirtual:function(){return Xr}});var ol=_(pt()),il=function(e,t){var a=t.emoji,r=t.nonBmp;t=t.punctuations;return a?ol.default().test(e):r?/[\\u1D00-\\u1D7F\\u1D80-\\u1DBF\\u1DC0-\\u1DFF\\u20A0-\\u20CF\\u20D0-\\u20FF\\u2100-\\u214F\\u2150-\\u218F\\u2190-\\u21FF\\u2200-\\u22FF\\u2300-\\u23FF\\u2400-\\u243F\\u2440-\\u245F\\u2460-\\u24FF\\u2500-\\u257F\\u2580-\\u259F\\u25A0-\\u25FF\\u2600-\\u26FF\\u2700-\\u27BF\\uE000-\\uF8FF]/g.test(e)||/[\\uDB80-\\uDBBF][\\uDC00-\\uDFFF]/g.test(e):!!t&&/[\\u2000-\\u206F\\u2E00-\\u2E7F\\\\\'!"#$%&\\xa3\\xa2\\xa5\\xa7\\u20ac()*+,\\-.\\/:;<=>?@\\[\\]^_`{|}~\\xb1]/g.test(e)},ll=_(pt()),sl=function(e,t){var a=t.emoji,r=t.nonBmp;t=t.punctuations;return a&&(e=e.replace(ll.default(),"")),r&&(e=(e=e.replace(/[\\u1D00-\\u1D7F\\u1D80-\\u1DBF\\u1DC0-\\u1DFF\\u20A0-\\u20CF\\u20D0-\\u20FF\\u2100-\\u214F\\u2150-\\u218F\\u2190-\\u21FF\\u2200-\\u22FF\\u2300-\\u23FF\\u2400-\\u243F\\u2440-\\u245F\\u2460-\\u24FF\\u2500-\\u257F\\u2580-\\u259F\\u25A0-\\u25FF\\u2600-\\u26FF\\u2700-\\u27BF\\uE000-\\uF8FF]/g,"")).replace(/[\\uDB80-\\uDBBF][\\uDC00-\\uDFFF]/g,"")),t?e.replace(/[\\u2000-\\u206F\\u2E00-\\u2E7F\\\\\'!"#$%&\\xa3\\xa2\\xa5\\xa7\\u20ac()*+,\\-.\\/:;<=>?@\\[\\]^_`{|}~\\xb1]/g,""):e},ul=function(e){return!e.length||["x","i"].includes(e)?0:(e=sl(e,{emoji:!0,nonBmp:!0,punctuations:!0}),$r(e)?1:0)},cl=function(e){var a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:.15,n=2<arguments.length&&void 0!==arguments[2]?arguments[2]:3,o=e.actualNode.nodeValue.trim();if(!$r(o)||il(o,{emoji:!0,nonBmp:!0}))return!1;qa.get("canvasContext")||qa.set("canvasContext",r.createElement("canvas").getContext("2d"));var i=qa.get("canvasContext"),l=i.canvas;qa.get("fonts")||qa.set("fonts",{});var s=qa.get("fonts"),u=t.getComputedStyle(e.parent.actualNode).getPropertyValue("font-family");s[u]||(s[u]={occurances:0,numLigatures:0});var c=s[u];if(c.occurances>=n){if(c.numLigatures/c.occurances==1)return!0;if(0===c.numLigatures)return!1}c.occurances++;var d="".concat(m=30,"px ").concat(u);i.font=d;var p=o.charAt(0);if((s=i.measureText(p).width)<30&&(s*=n=30/s,d="".concat(m*=n,"px ").concat(u)),l.width=s,l.height=m,i.font=d,i.textAlign="left",i.textBaseline="top",i.fillText(p,0,0),!(p=new Uint32Array(i.getImageData(0,0,s,m).data.buffer)).some((function(e){return e})))return c.numLigatures++,!0;i.clearRect(0,0,s,m),i.fillText(o,0,0);var f=new Uint32Array(i.getImageData(0,0,s,m).data.buffer),m=(s=p.reduce((function(e,t,a){return 0===t&&0===f[a]||0!==t&&0!==f[a]?e:++e}),0),o.split("").reduce((function(e,t){return e+i.measureText(t).width}),0));o=i.measureText(o).width;return a<=s/p.length&&a<=1-o/m&&(c.numLigatures++,!0)},dl={stateTerms:["on","off"],standaloneTerms:["name","honorific-prefix","given-name","additional-name","family-name","honorific-suffix","nickname","username","new-password","current-password","organization-title","organization","street-address","address-line1","address-line2","address-line3","address-level4","address-level3","address-level2","address-level1","country","country-name","postal-code","cc-name","cc-given-name","cc-additional-name","cc-family-name","cc-number","cc-exp","cc-exp-month","cc-exp-year","cc-csc","cc-type","transaction-currency","transaction-amount","language","bday","bday-day","bday-month","bday-year","sex","url","photo","one-time-code"],qualifiers:["home","work","mobile","fax","pager"],qualifiedTerms:["tel","tel-country-code","tel-national","tel-area-code","tel-local","tel-local-prefix","tel-local-suffix","tel-extension","email","impp"],locations:["billing","shipping"]},pl=function(e){var t=void 0!==(r=(i=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).looseTyped)&&r,a=void 0===(o=i.stateTerms)?[]:o,r=void 0===(n=i.locations)?[]:n,n=void 0===(o=i.qualifiers)?[]:o,o=void 0===(o=i.standaloneTerms)?[]:o,i=void 0===(i=i.qualifiedTerms)?[]:i;return e=e.toLowerCase().trim(),!(!(a=a.concat(dl.stateTerms)).includes(e)&&""!==e)||(n=n.concat(dl.qualifiers),r=r.concat(dl.locations),o=o.concat(dl.standaloneTerms),i=i.concat(dl.qualifiedTerms),a=e.split(/\\s+/g),!(!t&&(8<a[0].length&&"section-"===a[0].substr(0,8)&&a.shift(),r.includes(a[0])&&a.shift(),n.includes(a[0])&&(a.shift(),o=[]),1!==a.length))&&(a=a[a.length-1],o.includes(a)||i.includes(a)))},fl=function(e,t,a){return e=Ma(e),Xr(e,t,a)},ml=function(e){if(t=Jr(e))return t;if(e.attr("id")){if(!e.actualNode)throw new TypeError("Cannot resolve explicit label reference for non-DOM nodes");var t,a=ha(e.attr("id"));if(t=(a=Er(e.actualNode).querySelector(\'label[for="\'+a+\'"]\'))&&fl(a,!0))return t}return(t=(a=er(e,"label"))&&Xr(a,!0))?t:null},hl=function(e){return e=Ma(e),ml(e)},gl=[{matches:[{nodeName:"textarea"},{nodeName:"input",properties:{type:["text","password","search","tel","email","url"]}}],namingMethods:"labelText"},{matches:{nodeName:"input",properties:{type:["button","submit","reset"]}},namingMethods:["valueText","titleText","buttonDefaultText"]},{matches:{nodeName:"input",properties:{type:"image"}},namingMethods:["altText","valueText","labelText","titleText","buttonDefaultText"]},{matches:"button",namingMethods:"subtreeText"},{matches:"fieldset",namingMethods:"fieldsetLegendText"},{matches:"OUTPUT",namingMethods:"subtreeText"},{matches:[{nodeName:"select"},{nodeName:"input",properties:{type:/^(?!text|password|search|tel|email|url|button|submit|reset)/}}],namingMethods:"labelText"},{matches:"summary",namingMethods:"subtreeText"},{matches:"figure",namingMethods:["figureText","titleText"]},{matches:"img",namingMethods:"altText"},{matches:"table",namingMethods:["tableCaptionText","tableSummaryText"]},{matches:["hr","br"],namingMethods:["titleText","singleSpace"]}],bl=function e(t){var a=Ir(t.actualNode),r=[];return t.children.forEach((function(t){3===t.actualNode.nodeType?a&&r.push(t):r=r.concat(e(t))})),r},yl=/^idrefs?$/,vl=function(e){e=e.actualNode||e;var t=(t=Er(e)).documentElement||t,a=qa.get("idRefsByRoot");a||(a=new WeakMap,qa.set("idRefsByRoot",a));var r=a.get(t);return r||(a.set(t,r={}),function e(t,a,r){if(t.hasAttribute){var n;"LABEL"===t.nodeName.toUpperCase()&&t.hasAttribute("for")&&(a[n=t.getAttribute("for")]=a[n]||[],a[n].push(t));for(var o=0;o<r.length;++o){var i=r[o];if(i=$r(t.getAttribute(i)||""))for(var l=Ho(i),s=0;s<l.length;++s)a[l[s]]=a[l[s]]||[],a[l[s]].push(t)}}for(var u=0;u<t.children.length;u++)e(t.children[u],a,r)}(t,r,Object.keys(En.ariaAttrs).filter((function(e){return e=En.ariaAttrs[e].type,yl.test(e)})))),r[e.id]||[]},Dl=function(e){return(e=En.ariaRoles[e])?e.type:null},wl=function(e,t){return e=e instanceof xt?e:Ma(e),t===Ei(e)||(e=xi(e),Array.isArray(e.allowedRoles)?e.allowedRoles.includes(t):!!e.allowedRoles)},xl=["doc-backlink","doc-biblioentry","doc-biblioref","doc-cover","doc-endnote","doc-glossref","doc-noteref"],El=function(e){var t=!(1<arguments.length&&void 0!==arguments[1])||arguments[1],a=e.nodeName.toUpperCase();if(!io(e))return[];var r,n,o=(o=[],(r=e)?(r.hasAttribute("role")&&(n=Ho(r.getAttribute("role").toLowerCase()),o=o.concat(n)),r.hasAttributeNS("http://www.idpf.org/2007/ops","type")&&(r=Ho(r.getAttributeNS("http://www.idpf.org/2007/ops","type").toLowerCase()).map((function(e){return"doc-".concat(e)})),o=o.concat(r)),o=o.filter((function(e){return ei(e)}))):o),i=Ei(e);return o.filter((function(r){if(t&&r===i)return!1;if(t&&xl.includes(r)){var n=Dl(r);if(i!==n)return!0}return!(t||"row"===r&&"TR"===a&&xa(e,\'table[role="grid"] > tr\'))||!wl(e,r)}))},Al=function(e){return Object.keys(En.ariaRoles).filter((function(t){return En.ariaRoles[t].type===e}))},Cl=function(e){return Al(e)},Fl=function(){if(qa.get("ariaRolesNameFromContent"))return qa.get("ariaRolesNameFromContent");var e=Object.keys(En.ariaRoles).filter((function(e){return En.ariaRoles[e].nameFromContent}));return qa.set("ariaRolesNameFromContent",e),e},kl=function(){return Fl()},Rl=function(e){return null===e},Tl=function(e){return null!==e},Nl={attributes:{"aria-activedescendant":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-atomic":{type:"boolean",values:["true","false"],unsupported:!1},"aria-autocomplete":{type:"nmtoken",values:["inline","list","both","none"],unsupported:!1},"aria-busy":{type:"boolean",values:["true","false"],unsupported:!1},"aria-checked":{type:"nmtoken",values:["true","false","mixed","undefined"],unsupported:!1},"aria-colcount":{type:"int",unsupported:!1},"aria-colindex":{type:"int",unsupported:!1},"aria-colspan":{type:"int",unsupported:!1},"aria-controls":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-current":{type:"nmtoken",allowEmpty:!0,values:["page","step","location","date","time","true","false"],unsupported:!1},"aria-describedby":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-describedat":{unsupported:!0,unstandardized:!0},"aria-details":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-disabled":{type:"boolean",values:["true","false"],unsupported:!1},"aria-dropeffect":{type:"nmtokens",values:["copy","move","reference","execute","popup","none"],unsupported:!1},"aria-errormessage":{type:"idref",allowEmpty:!0,unsupported:!1},"aria-expanded":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-flowto":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-grabbed":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-haspopup":{type:"nmtoken",allowEmpty:!0,values:["true","false","menu","listbox","tree","grid","dialog"],unsupported:!1},"aria-hidden":{type:"boolean",values:["true","false"],unsupported:!1},"aria-invalid":{type:"nmtoken",allowEmpty:!0,values:["true","false","spelling","grammar"],unsupported:!1},"aria-keyshortcuts":{type:"string",allowEmpty:!0,unsupported:!1},"aria-label":{type:"string",allowEmpty:!0,unsupported:!1},"aria-labelledby":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-level":{type:"int",unsupported:!1},"aria-live":{type:"nmtoken",values:["off","polite","assertive"],unsupported:!1},"aria-modal":{type:"boolean",values:["true","false"],unsupported:!1},"aria-multiline":{type:"boolean",values:["true","false"],unsupported:!1},"aria-multiselectable":{type:"boolean",values:["true","false"],unsupported:!1},"aria-orientation":{type:"nmtoken",values:["horizontal","vertical"],unsupported:!1},"aria-owns":{type:"idrefs",allowEmpty:!0,unsupported:!1},"aria-placeholder":{type:"string",allowEmpty:!0,unsupported:!1},"aria-posinset":{type:"int",unsupported:!1},"aria-pressed":{type:"nmtoken",values:["true","false","mixed","undefined"],unsupported:!1},"aria-readonly":{type:"boolean",values:["true","false"],unsupported:!1},"aria-relevant":{type:"nmtokens",values:["additions","removals","text","all"],unsupported:!1},"aria-required":{type:"boolean",values:["true","false"],unsupported:!1},"aria-roledescription":{type:"string",allowEmpty:!0,unsupported:!1},"aria-rowcount":{type:"int",unsupported:!1},"aria-rowindex":{type:"int",unsupported:!1},"aria-rowspan":{type:"int",unsupported:!1},"aria-selected":{type:"nmtoken",values:["true","false","undefined"],unsupported:!1},"aria-setsize":{type:"int",unsupported:!1},"aria-sort":{type:"nmtoken",values:["ascending","descending","other","none"],unsupported:!1},"aria-valuemax":{type:"decimal",unsupported:!1},"aria-valuemin":{type:"decimal",unsupported:!1},"aria-valuenow":{type:"decimal",unsupported:!1},"aria-valuetext":{type:"string",unsupported:!1}},globalAttributes:["aria-atomic","aria-busy","aria-controls","aria-current","aria-describedby","aria-details","aria-disabled","aria-dropeffect","aria-flowto","aria-grabbed","aria-haspopup","aria-hidden","aria-invalid","aria-keyshortcuts","aria-label","aria-labelledby","aria-live","aria-owns","aria-relevant","aria-roledescription"]};Nl.role={alert:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},alertdialog:{type:"widget",attributes:{allowed:["aria-expanded","aria-modal","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["dialog","section"]},application:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage","aria-activedescendant"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["article","audio","embed","iframe","object","section","svg","video"]},article:{type:"structure",attributes:{allowed:["aria-expanded","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["article"],unsupported:!1},banner:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["header"],unsupported:!1,allowedElements:["section"]},button:{type:"widget",attributes:{allowed:["aria-expanded","aria-pressed","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["button",\'input[type="button"]\',\'input[type="image"]\',\'input[type="reset"]\',\'input[type="submit"]\',"summary"],unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Tl}}]},cell:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-rowindex","aria-rowspan","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["td","th"],unsupported:!1},checkbox:{type:"widget",attributes:{allowed:["aria-checked","aria-required","aria-readonly","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:[\'input[type="checkbox"]\'],unsupported:!1,allowedElements:["button"]},columnheader:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-required","aria-readonly","aria-selected","aria-sort","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["th"],unsupported:!1},combobox:{type:"composite",attributes:{allowed:["aria-autocomplete","aria-required","aria-activedescendant","aria-orientation","aria-errormessage"],required:["aria-expanded"]},owned:{all:["listbox","tree","grid","dialog","textbox"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:"input",properties:{type:["text","search","tel","url","email"]}}]},command:{nameFrom:["author"],type:"abstract",unsupported:!1},complementary:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["aside"],unsupported:!1,allowedElements:["section"]},composite:{nameFrom:["author"],type:"abstract",unsupported:!1},contentinfo:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["footer"],unsupported:!1,allowedElements:["section"]},definition:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["dd","dfn"],unsupported:!1},dialog:{type:"widget",attributes:{allowed:["aria-expanded","aria-modal","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["dialog"],unsupported:!1,allowedElements:["section"]},directory:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:["ol","ul"]},document:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["body"],unsupported:!1,allowedElements:["article","embed","iframe","object","section","svg"]},"doc-abstract":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-acknowledgments":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-afterword":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-appendix":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-backlink":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Tl}}]},"doc-biblioentry":{type:"listitem",attributes:{allowed:["aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author"],context:["doc-bibliography"],unsupported:!1,allowedElements:["li"]},"doc-bibliography":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["doc-biblioentry"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-biblioref":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Tl}}]},"doc-chapter":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-colophon":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-conclusion":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-cover":{type:"img",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1},"doc-credit":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-credits":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-dedication":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-endnote":{type:"listitem",attributes:{allowed:["aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,namefrom:["author"],context:["doc-endnotes"],unsupported:!1,allowedElements:["li"]},"doc-endnotes":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["doc-endnote"]},namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-epigraph":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1},"doc-epilogue":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-errata":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-example":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","section"]},"doc-footnote":{type:"section",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","footer","header"]},"doc-foreword":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-glossary":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:["term","definition"],namefrom:["author"],context:null,unsupported:!1,allowedElements:["dl"]},"doc-glossref":{type:"link",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Tl}}]},"doc-index":{type:"navigation",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},"doc-introduction":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-noteref":{type:"link",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author","contents"],context:null,unsupported:!1,allowedElements:[{nodeName:"a",attributes:{href:Tl}}]},"doc-notice":{type:"note",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-pagebreak":{type:"separator",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["hr"]},"doc-pagelist":{type:"navigation",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},"doc-part":{type:"landmark",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-preface":{type:"landmark",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-prologue":{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-pullquote":{type:"none",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside","section"]},"doc-qna":{type:"section",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},"doc-subtitle":{type:"sectionhead",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["h1","h2","h3","h4","h5","h6"]}},"doc-tip":{type:"note",attributes:{allowed:["aria-expanded"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["aside"]},"doc-toc":{type:"navigation",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,namefrom:["author"],context:null,unsupported:!1,allowedElements:["nav","section"]},feed:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{one:["article"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["article","aside","section"]},figure:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["figure"],unsupported:!1},form:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["form"],unsupported:!1},grid:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-colcount","aria-level","aria-multiselectable","aria-readonly","aria-rowcount","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author"],context:null,implicit:["table"],unsupported:!1},gridcell:{type:"widget",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-selected","aria-readonly","aria-required","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["td","th"],unsupported:!1},group:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["details","optgroup"],unsupported:!1,allowedElements:["dl","figcaption","fieldset","figure","footer","header","ol","ul"]},heading:{type:"structure",attributes:{required:["aria-level"],allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["h1","h2","h3","h4","h5","h6"],unsupported:!1},img:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["img"],unsupported:!1,allowedElements:["embed","iframe","object","svg"]},input:{nameFrom:["author"],type:"abstract",unsupported:!1},landmark:{nameFrom:["author"],type:"abstract",unsupported:!1},link:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["a[href]","area[href]"],unsupported:!1,allowedElements:["button",{nodeName:"input",properties:{type:["image","button"]}}]},list:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:{all:["listitem"]},nameFrom:["author"],context:null,implicit:["ol","ul","dl"],unsupported:!1},listbox:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-multiselectable","aria-readonly","aria-required","aria-expanded","aria-orientation","aria-errormessage"]},owned:{all:["option"]},nameFrom:["author"],context:null,implicit:["select"],unsupported:!1,allowedElements:["ol","ul"]},listitem:{type:"structure",attributes:{allowed:["aria-level","aria-posinset","aria-setsize","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["list"],implicit:["li","dt"],unsupported:!1},log:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},main:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["main"],unsupported:!1,allowedElements:["article","section"]},marquee:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},math:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["math"],unsupported:!1},menu:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:{one:["menuitem","menuitemradio","menuitemcheckbox"]},nameFrom:["author"],context:null,implicit:[\'menu[type="context"]\'],unsupported:!1,allowedElements:["ol","ul"]},menubar:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:{one:["menuitem","menuitemradio","menuitemcheckbox"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},menuitem:{type:"widget",attributes:{allowed:["aria-posinset","aria-setsize","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:[\'menuitem[type="command"]\'],unsupported:!1,allowedElements:["button","li",{nodeName:"iput",properties:{type:["image","button"]}},{nodeName:"a",attributes:{href:Tl}}]},menuitemcheckbox:{type:"widget",attributes:{allowed:["aria-checked","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:[\'menuitem[type="checkbox"]\'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["checkbox","image","button"]}},{nodeName:"a",attributes:{href:Tl}}]},menuitemradio:{type:"widget",attributes:{allowed:["aria-checked","aria-selected","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["menu","menubar"],implicit:[\'menuitem[type="radio"]\'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["image","button","radio"]}},{nodeName:"a",attributes:{href:Tl}}]},navigation:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["nav"],unsupported:!1,allowedElements:["section"]},none:{type:"structure",attributes:null,owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:["article","aside","dl","embed","figcaption","fieldset","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hr","iframe","li","ol","section","ul"]},{nodeName:"img",attributes:{alt:Tl}}]},note:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["aside"]},option:{type:"widget",attributes:{allowed:["aria-selected","aria-posinset","aria-setsize","aria-checked","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["listbox"],implicit:["option"],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["checkbox","button"]}},{nodeName:"a",attributes:{href:Tl}}]},presentation:{type:"structure",attributes:null,owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:[{nodeName:["article","aside","dl","embed","figcaption","fieldset","figure","footer","form","h1","h2","h3","h4","h5","h6","header","hr","iframe","li","ol","section","ul"]},{nodeName:"img",attributes:{alt:Tl}}]},progressbar:{type:"widget",attributes:{allowed:["aria-valuetext","aria-valuenow","aria-valuemax","aria-valuemin","aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["progress"],unsupported:!1},radio:{type:"widget",attributes:{allowed:["aria-selected","aria-posinset","aria-setsize","aria-required","aria-errormessage","aria-checked"]},owned:null,nameFrom:["author","contents"],context:null,implicit:[\'input[type="radio"]\'],unsupported:!1,allowedElements:[{nodeName:["button","li"]},{nodeName:"input",properties:{type:["image","button"]}}]},radiogroup:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-required","aria-expanded","aria-readonly","aria-errormessage","aria-orientation"]},owned:{all:["radio"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["ol","ul","fieldset"]}},range:{nameFrom:["author"],type:"abstract",unsupported:!1},region:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["section[aria-label]","section[aria-labelledby]","section[title]"],unsupported:!1,allowedElements:{nodeName:["article","aside"]}},roletype:{type:"abstract",unsupported:!1},row:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-colindex","aria-expanded","aria-level","aria-selected","aria-rowindex","aria-errormessage"]},owned:{one:["cell","columnheader","rowheader","gridcell"]},nameFrom:["author","contents"],context:["rowgroup","grid","treegrid","table"],implicit:["tr"],unsupported:!1},rowgroup:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-errormessage"]},owned:{all:["row"]},nameFrom:["author","contents"],context:["grid","table","treegrid"],implicit:["tbody","thead","tfoot"],unsupported:!1},rowheader:{type:"structure",attributes:{allowed:["aria-colindex","aria-colspan","aria-expanded","aria-rowindex","aria-rowspan","aria-required","aria-readonly","aria-selected","aria-sort","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["row"],implicit:["th"],unsupported:!1},scrollbar:{type:"widget",attributes:{required:["aria-controls","aria-valuenow"],allowed:["aria-valuetext","aria-orientation","aria-errormessage","aria-valuemax","aria-valuemin"]},owned:null,nameFrom:["author"],context:null,unsupported:!1},search:{type:"landmark",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:{nodeName:["aside","form","section"]}},searchbox:{type:"widget",attributes:{allowed:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-readonly","aria-required","aria-placeholder","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="search"]\'],unsupported:!1,allowedElements:{nodeName:"input",properties:{type:"text"}}},section:{nameFrom:["author","contents"],type:"abstract",unsupported:!1},sectionhead:{nameFrom:["author","contents"],type:"abstract",unsupported:!1},select:{nameFrom:["author"],type:"abstract",unsupported:!1},separator:{type:"structure",attributes:{allowed:["aria-expanded","aria-orientation","aria-valuenow","aria-valuemax","aria-valuemin","aria-valuetext","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["hr"],unsupported:!1,allowedElements:["li"]},slider:{type:"widget",attributes:{allowed:["aria-valuetext","aria-orientation","aria-readonly","aria-errormessage","aria-valuemax","aria-valuemin"],required:["aria-valuenow"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="range"]\'],unsupported:!1},spinbutton:{type:"widget",attributes:{allowed:["aria-valuetext","aria-required","aria-readonly","aria-errormessage","aria-valuemax","aria-valuemin"],required:["aria-valuenow"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="number"]\'],unsupported:!1,allowedElements:{nodeName:"input",properties:{type:["text","tel"]}}},status:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:["output"],unsupported:!1,allowedElements:["section"]},structure:{type:"abstract",unsupported:!1},switch:{type:"widget",attributes:{allowed:["aria-errormessage"],required:["aria-checked"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1,allowedElements:["button",{nodeName:"input",properties:{type:["checkbox","image","button"]}},{nodeName:"a",attributes:{href:Tl}}]},tab:{type:"widget",attributes:{allowed:["aria-selected","aria-expanded","aria-setsize","aria-posinset","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["tablist"],unsupported:!1,allowedElements:[{nodeName:["button","h1","h2","h3","h4","h5","h6","li"]},{nodeName:"input",properties:{type:"button"}},{nodeName:"a",attributes:{href:Tl}}]},table:{type:"structure",attributes:{allowed:["aria-colcount","aria-rowcount","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author","contents"],context:null,implicit:["table"],unsupported:!1},tablist:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-level","aria-multiselectable","aria-orientation","aria-errormessage"]},owned:{all:["tab"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},tabpanel:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1,allowedElements:["section"]},term:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,implicit:["dt"],unsupported:!1},textbox:{type:"widget",attributes:{allowed:["aria-activedescendant","aria-autocomplete","aria-multiline","aria-readonly","aria-required","aria-placeholder","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:[\'input[type="text"]\',\'input[type="email"]\',\'input[type="password"]\',\'input[type="tel"]\',\'input[type="url"]\',"input:not([type])","textarea"],unsupported:!1},timer:{type:"widget",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,unsupported:!1},toolbar:{type:"structure",attributes:{allowed:["aria-activedescendant","aria-expanded","aria-orientation","aria-errormessage"]},owned:null,nameFrom:["author"],context:null,implicit:[\'menu[type="toolbar"]\'],unsupported:!1,allowedElements:["ol","ul"]},tooltip:{type:"structure",attributes:{allowed:["aria-expanded","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:null,unsupported:!1},tree:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-multiselectable","aria-required","aria-expanded","aria-orientation","aria-errormessage"]},owned:{all:["treeitem"]},nameFrom:["author"],context:null,unsupported:!1,allowedElements:["ol","ul"]},treegrid:{type:"composite",attributes:{allowed:["aria-activedescendant","aria-colcount","aria-expanded","aria-level","aria-multiselectable","aria-readonly","aria-required","aria-rowcount","aria-orientation","aria-errormessage"]},owned:{one:["rowgroup","row"]},nameFrom:["author"],context:null,unsupported:!1},treeitem:{type:"widget",attributes:{allowed:["aria-checked","aria-selected","aria-expanded","aria-level","aria-posinset","aria-setsize","aria-errormessage"]},owned:null,nameFrom:["author","contents"],context:["group","tree"],unsupported:!1,allowedElements:["li",{nodeName:"a",attributes:{href:Tl}}]},widget:{type:"abstract",unsupported:!1},window:{nameFrom:["author"],type:"abstract",unsupported:!1}},Nl.implicitHtmlRole=ci,Nl.elementsAllowedNoRole=[{nodeName:["base","body","caption","col","colgroup","datalist","dd","details","dt","head","html","keygen","label","legend","main","map","math","meta","meter","noscript","optgroup","param","picture","progress","script","source","style","template","textarea","title","track"]},{nodeName:"area",attributes:{href:Tl}},{nodeName:"input",properties:{type:["color","data","datatime","file","hidden","month","number","password","range","reset","submit","time","week"]}},{nodeName:"link",attributes:{href:Tl}},{nodeName:"menu",attributes:{type:"context"}},{nodeName:"menuitem",attributes:{type:["command","checkbox","radio"]}},{nodeName:"select",condition:function(e){return e instanceof o.AbstractVirtualNode||(e=o.utils.getNodeFromTree(e)),1<Number(e.attr("size"))},properties:{multiple:!0}},{nodeName:["clippath","cursor","defs","desc","feblend","fecolormatrix","fecomponenttransfer","fecomposite","feconvolvematrix","fediffuselighting","fedisplacementmap","fedistantlight","fedropshadow","feflood","fefunca","fefuncb","fefuncg","fefuncr","fegaussianblur","feimage","femerge","femergenode","femorphology","feoffset","fepointlight","fespecularlighting","fespotlight","fetile","feturbulence","filter","hatch","hatchpath","lineargradient","marker","mask","meshgradient","meshpatch","meshrow","metadata","mpath","pattern","radialgradient","solidcolor","stop","switch","view"]}],Nl.elementsAllowedAnyRole=[{nodeName:"a",attributes:{href:Rl}},{nodeName:"img",attributes:{alt:Rl}},{nodeName:["abbr","address","canvas","div","p","pre","blockquote","ins","del","output","span","table","tbody","thead","tfoot","td","em","strong","small","s","cite","q","dfn","abbr","time","code","var","samp","kbd","sub","sup","i","b","u","mark","ruby","rt","rp","bdi","bdo","br","wbr","th","tr"]}],Nl.evaluateRoleForElement={A:function(e){var t=e.node;e=e.out;return"http://www.w3.org/2000/svg"===t.namespaceURI||!t.href.length||e},AREA:function(e){return!e.node.href},BUTTON:function(e){var t=e.node,a=e.role;e=e.out;return"menu"===t.getAttribute("type")?"menuitem"===a:e},IMG:function(e){var t=e.node,a=e.role,r=e.out;switch(t.alt){case null:return r;case"":return"presentation"===a||"none"===a;default:return"presentation"!==a&&"none"!==a}},INPUT:function(e){var t=e.node,a=e.role,r=e.out;switch(t.type){case"button":case"image":return r;case"checkbox":return!("button"!==a||!t.hasAttribute("aria-pressed"))||r;case"radio":return"menuitemradio"===a;case"text":return"combobox"===a||"searchbox"===a||"spinbutton"===a;case"tel":return"combobox"===a||"spinbutton"===a;case"url":case"search":case"email":return"combobox"===a;default:return!1}},LI:function(e){var t=e.node;e=e.out;return!o.utils.matchesSelector(t,"ol li, ul li")||e},MENU:function(e){return"context"!==e.node.getAttribute("type")},OPTION:function(e){return e=e.node,!o.utils.matchesSelector(e,"select > option, datalist > option, optgroup > option")},SELECT:function(e){var t=e.node;e=e.role;return!t.multiple&&t.size<=1&&"menu"===e},SVG:function(e){var t=e.node;e=e.out;return!(!t.parentNode||"http://www.w3.org/2000/svg"!==t.parentNode.namespaceURI)||e}},Nl.rolesOfType={widget:["button","checkbox","dialog","gridcell","link","log","marquee","menuitem","menuitemcheckbox","menuitemradio","option","progressbar","radio","scrollbar","searchbox","slider","spinbutton","status","switch","tab","tabpanel","textbox","timer","tooltip","tree","treeitem"]};var _l=Nl,Ol=function(e){var t=null;return(e=_l.role[e])&&e.implicit?Ha(e.implicit):t},Sl=function(e){return!!vl(e).length},Pl=function(e){return e=Ma(e),Jr(e)},Il=function(e){return(e=En.ariaRoles[e])&&Array.isArray(e.requiredAttrs)?y(e.requiredAttrs):[]},Bl=function(e){return(e=En.ariaRoles[e])&&Array.isArray(e.requiredContext)?y(e.requiredContext):null},Ll=function(e){return(e=En.ariaRoles[e])&&Array.isArray(e.requiredOwned)?y(e.requiredOwned):null},ql=function(e,t){var a,r=e.getAttribute(t),n=En.ariaAttrs[t],o=Er(e);if(!n)return!0;if(n.allowEmpty&&(!r||""===r.trim()))return!0;switch(n.type){case"boolean":return["true","false"].includes(r.toLowerCase());case"nmtoken":return"string"==typeof r&&n.values.includes(r.toLowerCase());case"nmtokens":return(a=Ho(r)).reduce((function(e,t){return e&&n.values.includes(t)}),0!==a.length);case"idref":return!(!r||!o.getElementById(r));case"idrefs":return(a=Ho(r)).some((function(e){return o.getElementById(e)}));case"string":return""!==r.trim();case"decimal":return!(!(i=r.match(/^[-+]?([0-9]*)\\.?([0-9]*)$/))||!i[1]&&!i[2]);case"int":var i=void 0!==n.minValue?n.minValue:-1/0;return/^[-+]?[0-9]+$/.test(r)&&parseInt(r)>=i}},Ml=function(e){return!!En.ariaAttrs[e]};var jl={};function Ul(e,t,a,r){var n=ti(e);if(!(a=a||Bl(n)))return null;for(var o=r?e:e.parent;o;){var i=ki(o);if(a.includes("group")&&"group"===i)t.includes(n)&&a.push(n),o=o.parent;else{if(a.includes(i))return null;if(i&&!["presentation","none"].includes(i))return a;o=o.parent}}return a}N(jl,{getAriaRolesByType:function(){return Al},getAriaRolesSupportingNameFromContent:function(){return Fl},getElementSpec:function(){return xi},getElementsByContentType:function(){return ai},getGlobalAriaAttrs:function(){return Xo},implicitHtmlRoles:function(){return ci}});var Vl={ARTICLE:!0,ASIDE:!0,NAV:!0,SECTION:!0},Hl={application:!0,banner:!1,complementary:!0,contentinfo:!0,form:!0,main:!0,navigation:!0,region:!0,search:!1};var zl={};N(zl,{getAllCells:function(){return $l},getCellPosition:function(){return ni},getHeaders:function(){return Gl},getScope:function(){return oi},isColumnHeader:function(){return ii},isDataCell:function(){return Yl},isDataTable:function(){return Kl},isHeader:function(){return Xl},isRowHeader:function(){return li},toArray:function(){return ri},toGrid:function(){return ri},traverse:function(){return Jl}});var $l=function(e){for(var t,a,r=[],n=0,o=e.rows.length;n<o;n++)for(t=0,a=e.rows[n].cells.length;t<a;t++)r.push(e.rows[n].cells[t]);return r};function Wl(e,t,a){for(var r,n="row"===e?"_rowHeaders":"_colHeaders",i="row"===e?li:ii,l=(u=a[t.y][t.x]).colSpan-1,s=u.getAttribute("rowspan"),u=0===parseInt(s)||0===u.rowspan?a.length:u.rowSpan,c=(u=t.y+(u-1),t.x+l),d="row"===e?t.y:0,p="row"===e?0:t.x,f=[],m=u;d<=m&&!r;m--)for(var h=c;p<=h;h--){var g=a[m]?a[m][h]:void 0;if(g){var b=o.utils.getNodeFromTree(g);if(b[n]){r=b[n];break}f.push(g)}}return r=(r||[]).concat(f.filter(i)),f.forEach((function(e){o.utils.getNodeFromTree(e)[n]=r})),r}var Gl=function(e,t){if(e.getAttribute("headers")){var a=Kr(e,"headers");if(a.filter((function(e){return e})).length)return a}return t=t||ri(Fr(e,"table")),e=Wl("row",a=ni(e,t),t),t=Wl("col",a,t),[].concat(e,t).reverse()},Yl=function(e){if(!e.children.length&&!e.textContent.trim())return!1;var t=e.getAttribute("role");return ei(t)?["cell","gridcell"].includes(t):"TD"===e.nodeName.toUpperCase()},Kl=function(e){var a=(e.getAttribute("role")||"").toLowerCase();if(("presentation"===a||"none"===a)&&!ln(e))return!1;if("true"===e.getAttribute("contenteditable")||Fr(e,\'[contenteditable="true"]\'))return!0;if("grid"===a||"treegrid"===a||"table"===a)return!0;if("landmark"===Dl(a))return!0;if("0"===e.getAttribute("datatable"))return!1;if(e.getAttribute("summary"))return!0;if(e.tHead||e.tFoot||e.caption)return!0;for(var r=0,n=e.children.length;r<n;r++)if("COLGROUP"===e.children[r].nodeName.toUpperCase())return!0;for(var o,i,l,s=0,u=e.rows.length,c=!1,d=0;d<u;d++)for(var p,f=0,m=(p=e.rows[d]).cells.length;f<m;f++){if("TH"===(o=p.cells[f]).nodeName.toUpperCase())return!0;if(c||o.offsetWidth===o.clientWidth&&o.offsetHeight===o.clientHeight||(c=!0),o.getAttribute("scope")||o.getAttribute("headers")||o.getAttribute("abbr"))return!0;if(["columnheader","rowheader"].includes((o.getAttribute("role")||"").toLowerCase()))return!0;if(1===o.children.length&&"ABBR"===o.children[0].nodeName.toUpperCase())return!0;s++}if(e.getElementsByTagName("table").length)return!1;if(u<2)return!1;if(1===(a=e.rows[Math.ceil(u/2)]).cells.length&&1===a.cells[0].colSpan)return!1;if(5<=a.cells.length)return!0;if(c)return!0;for(d=0;d<u;d++){if(p=e.rows[d],i&&i!==t.getComputedStyle(p).getPropertyValue("background-color"))return!0;if(i=t.getComputedStyle(p).getPropertyValue("background-color"),l&&l!==t.getComputedStyle(p).getPropertyValue("background-image"))return!0;l=t.getComputedStyle(p).getPropertyValue("background-image")}return 20<=u||!(Nr(e).width>.95*_r(t).width)&&!(s<10)&&!e.querySelector("object, embed, iframe, applet")},Xl=function(e){return!(!ii(e)&&!li(e))||!!e.getAttribute("id")&&(e=ha(e.getAttribute("id")),!!r.querySelector(\'[headers~="\'.concat(e,\'"]\')))},Jl=function(e,t,a,r){if(Array.isArray(t)&&(r=a,a=t,t={x:0,y:0}),"string"==typeof e)switch(e){case"left":e={x:-1,y:0};break;case"up":e={x:0,y:-1};break;case"right":e={x:1,y:0};break;case"down":e={x:0,y:1}}return function e(t,a,r,n){var o,i=r[a.y]?r[a.y][a.x]:void 0;return i?"function"==typeof n&&!0===(o=n(i,a,r))?[i]:((o=e(t,{x:a.x+t.x,y:a.y+t.y},r,n)).unshift(i),o):[]}(e,{x:t.x+e.x,y:t.y+e.y},a,r)};var Ql={};N(Ql,{Color:function(){return An},centerPointOfRect:function(){return Zl},elementHasImage:function(){return bn},elementIsDistinct:function(){return ts},filteredRectStack:function(){return rs},flattenColors:function(){return ns},getBackgroundColor:function(){return ls},getBackgroundStack:function(){return os},getContrast:function(){return ss},getForegroundColor:function(){return us},getOwnBackgroundColor:function(){return Cn},getRectStack:function(){return as},getTextShadowColors:function(){return is},hasValidContrastRatio:function(){return cs},incompleteData:function(){return gn}});var Zl=function(e){if(!(e.left>t.innerWidth||e.top>t.innerHeight))return{x:Math.min(Math.ceil(e.left+e.width/2),t.innerWidth-1),y:Math.min(Math.ceil(e.top+e.height/2),t.innerHeight-1)}};function es(e){return e.getPropertyValue("font-family").split(/[,;]/g).map((function(e){return e.trim().toLowerCase()}))}var ts=function(e,a){var r=t.getComputedStyle(e);if("none"!==r.getPropertyValue("background-image"))return!0;if(["border-bottom","border-top","outline"].reduce((function(e,t){var a=new An;return a.parseString(r.getPropertyValue(t+"-color")),e||"none"!==r.getPropertyValue(t+"-style")&&0<parseFloat(r.getPropertyValue(t+"-width"))&&0!==a.alpha}),!1))return!0;var n=t.getComputedStyle(a);return es(r)[0]!==es(n)[0]||(e=["text-decoration-line","text-decoration-style","font-weight","font-style","font-size"].reduce((function(e,t){return e||r.getPropertyValue(t)!==n.getPropertyValue(t)}),!1),(a=r.getPropertyValue("text-decoration")).split(" ").length<3?e||a!==n.getPropertyValue("text-decoration"):e)},as=function(e){var t=Hr(e);return!(e=Wr(e))||e.length<=1?[t]:e.some((function(e){return void 0===e}))?null:(e.splice(0,0,t),e)},rs=function(e){var t=as(e);if(t&&1===t.length)return t[0];if(t&&1<t.length){var a,r=t.shift();return t.forEach((function(n,o){var i,l;0!==o&&(i=t[o-1],l=t[o],a=i.every((function(e,t){return e===l[t]}))||r.includes(e))})),a?t[0]:(gn.set("bgColor","elmPartiallyObscuring"),null)}return gn.set("bgColor","outsideViewport"),null},ns=function(e,t){var a=(1-(n=e.alpha))*t.red+n*e.red,r=(1-n)*t.green+n*e.green,n=(1-n)*t.blue+n*e.blue;e=e.alpha+t.alpha*(1-e.alpha);return new An(a,r,n,e)};var os=function(e){var a,n,o=rs(e);if(null===o)return null;n=(a=o=Tn(o,e)).indexOf(r.body),i=a,(1<n||-1===n)&&!bn(r.documentElement)&&0===Cn(t.getComputedStyle(r.documentElement)).alpha&&(1<n&&i.splice(n,1),i.splice(a.indexOf(r.documentElement),1),i.push(r.body));var i=(o=i).indexOf(e);return function(e,t,a){if(0<e)for(var r=e-1;0<=r;r--){if(function(e,t){var a=e.getClientRects()[0],r=Sn(a.left,a.top);if(r)for(var n=0;n<r.length;n++)if(r[n]!==e&&r[n]===t)return 1}(a,t[r]))return 1;t.splice(r,1)}}(i,o,e)?(gn.set("bgColor","bgOverlap"),null):-1!==i?o:null},is=function(e){var a=(i=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).minRatio,r=i.maxRatio,n=t.getComputedStyle(e),o=n.getPropertyValue("text-shadow");if("none"===o)return[];var i=n.getPropertyValue("font-size"),l=parseInt(i);Ft(!1===isNaN(l),"Unable to determine font-size value ".concat(i));var s=[];return function(e){var t={pixels:[]},a=e.trim(),r=[t];if(!a)return[];for(;a;){var n=a.match(/^rgba?\\([0-9,.\\s]+\\)/i)||a.match(/^[a-z]+/i)||a.match(/^#[0-9a-f]+/i),o=a.match(/^([0-9.-]+)px/i)||a.match(/^(0)/);if(n)Ft(!t.colorStr,"Multiple colors identified in text-shadow: ".concat(e)),a=a.replace(n[0],"").trim(),t.colorStr=n[0];else if(o)Ft(t.pixels.length<3,"Too many pixel units in text-shadow: ".concat(e)),a=a.replace(o[0],"").trim(),o=parseFloat(("."===o[1][0]?"0":"")+o[1]),t.pixels.push(o);else{if(","!==a[0])throw new Error("Unable to process text-shadows: ".concat(e));Ft(2<=t.pixels.length,"Missing pixel value in text-shadow: ".concat(e)),t={pixels:[]},r.push(t),a=a.substr(1).trim()}}return r}(o).forEach((function(e){var t=e.colorStr,o=e.pixels,i=(t=t||n.getPropertyValue("color"),e=(i=v(o,3))[0],o=i[1],void 0===(i=i[2])?0:i);(!a||l*a<=i)&&(!r||i<l*r)&&(i=function(e){var t=e.colorStr,a=e.offsetX,r=e.offsetY,n=e.blurRadius;e=e.fontSize;return n<a||n<r?new An(0,0,0,0):((r=new An).parseString(t),r.alpha*=function(e,t){return.185/(e/t+.4)}(n,e),r)}({colorStr:t,offsetY:e,offsetX:o,blurRadius:i,fontSize:l}),s.push(i))})),s},ls=function(e){var a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:[],r=is(e,{minRatio:2<arguments.length&&void 0!==arguments[2]?arguments[2]:.1}),n=os(e);return(n||[]).some((function(n){var o,i,l,s=t.getComputedStyle(n),u=Cn(s);return l=u,(l=(o=e)!==(i=n)&&!On(o,i)&&0!==l.alpha)&&gn.set("bgColor","elmPartiallyObscured"),l||bn(n,s)?(r=null,a.push(n),!0):0!==u.alpha&&(a.push(n),r.push(u),1===u.alpha)})),null===r||null===n?null:(r.push(new An(255,255,255,1)),r.reduce(ns))},ss=function(e,t){return t&&e?(t.alpha<1&&(t=ns(t,e)),e=e.getRelativeLuminance(),t=t.getRelativeLuminance(),(Math.max(t,e)+.05)/(Math.min(t,e)+.05)):null},us=function(e,a,r){var n=t.getComputedStyle(e),o=new An;return o.parseString(n.getPropertyValue("color")),n=function e(a){if(!a)return 1;var r=Ma(a);return r&&void 0!==r._opacity&&null!==r._opacity?r._opacity:(a=t.getComputedStyle(a).getPropertyValue("opacity")*e(a.parentElement),r&&(r._opacity=a),a)}(e),o.alpha=o.alpha*n,1===o.alpha?o:null!==(r=r||ls(e,[]))?ns(o,r):(r=gn.get("bgColor"),gn.set("fgColor",r),null)},cs=function(e,t,a,r){return t=ss(e,t),{isValid:(a=r&&Math.ceil(72*a)/96<14||!r&&Math.ceil(72*a)/96<18?4.5:3)<t,contrastRatio:t,expectedContrastRatio:a}},ds=fo((function(e,a){return e=t.getComputedStyle(e,a),a=Cn(e),"none"!==e.getPropertyValue("content")&&"absolute"===e.getPropertyValue("position")&&0!==parseInt(e.getPropertyValue("width"))&&0!==parseInt(e.getPropertyValue("height"))&&(0!==a.alpha||"none"!==e.getPropertyValue("background-image"))}));function ps(e,t){return e=e.getRelativeLuminance(),t=t.getRelativeLuminance(),(Math.max(e,t)+.05)/(Math.min(e,t)+.05)}var fs=["block","list-item","table","flex","grid","inline-block"];function ms(e){return e=t.getComputedStyle(e).getPropertyValue("display"),-1!==fs.indexOf(e)||"table-"===e.substr(0,6)}T=function(e,t,a){return a=a.attr("autocomplete")||"",pl(a,t)},Ut=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=2<arguments.length?arguments[2]:void 0;if(!t.attribute||"string"!=typeof t.attribute)throw new TypeError("attr-non-space-content requires options.attribute to be a string");return a.hasAttr(t.attribute)?(t=a.attr(t.attribute),!!$r(t)||(this.data({messageKey:"emptyAttr"}),!1)):(this.data({messageKey:"noAttr"}),!1)};var hs=function(e){return e.some((function(e){return!0===e.result}))&&e.forEach((function(e){e.result=!0})),e};function gs(e,t){var a=null===(a=t.data)||void 0===a?void 0:a.headingOrder,r=ys(t.node.ancestry,1);return a?(t=a.map((function(e){return function(e,t){return D({},e,{ancestry:t=t.concat(e.ancestry)})}(e,r)})),-1===(a=function(e,t){for(;t.length;){var a=bs(e,t);if(-1!==a)return a;t=ys(t,1)}return-1}(e,r))?e.push.apply(e,y(t)):e.splice.apply(e,[a,0].concat(y(t))),e):e}function bs(e,t){return e.findIndex((function(e){return e=e.ancestry,a=t,e.length===a.length&&e.every((function(e,t){var r=a[t];return Array.isArray(e)?e.length===r.length&&e.every((function(e,t){return r[t]===e})):e===r}));var a}))}function ys(e,t){return e.slice(0,e.length-t)}za=function(e,t,a){if(!t||!t.selector||"string"!=typeof t.selector)throw new TypeError("has-descendant requires options.selector to be a string");return t=ko(a,t.selector,(function(e){return Ir(e.actualNode,!0)})),this.relatedNodes(t.map((function(e){return e.actualNode}))),0<t.length},vn=function(e,t,a){try{return""!==$r(Si(a))}catch(e){return}},Dn=function(e,t,a){return wi(a,t.matcher)},fi=function(e){return e.filter((function(e){return"ignored"!==e.data}))},mi=function(e,t,a){if(!t||!t.selector||"string"!=typeof t.selector)throw new TypeError("page-no-duplicate requires options.selector to be a string");var r="page-no-duplicate;"+t.selector;if(!qa.get(r))return qa.set(r,!0),r=ko(o._tree[0],t.selector,(function(e){return Ir(e.actualNode)})),"string"==typeof t.nativeScopeFilter&&(r=r.filter((function(e){return e.actualNode.hasAttribute("role")||!Cr(e,t.nativeScopeFilter)}))),this.relatedNodes(r.filter((function(e){return e!==a})).map((function(e){return e.actualNode}))),r.length<=1;this.data("ignored")},hi=function(){if(qa.get("headingOrder"))return!0;var e=ko(o._tree[0],"h1, h2, h3, h4, h5, h6, [role=heading], iframe, frame",(function(e){return Ir(e.actualNode,!0)})),t=e.map((function(e){return{ancestry:[Ia(e.actualNode)],level:function(e){var t=e.attr("role");return t&&t.includes("heading")?(t=e.attr("aria-level"),t=parseInt(t,10),isNaN(t)||t<1||6<t?2:t):(e=e.props.nodeName.match(/h(\\d)/))?parseInt(e[1],10):-1}(e)}}));return this.data({headingOrder:t}),qa.set("headingOrder",e),!0},gi=function(e){if(e.length<2)return e;function t(e){var t=a[e],i=(u=t.data).name,l=u.urlProps;if(o[i])return"continue";var s=a.filter((function(t,a){return t.data.name===i&&a!==e})),u=s.every((function(e){return function e(t,a){if(!t||!a)return!1;var r=Object.getOwnPropertyNames(t),o=Object.getOwnPropertyNames(a);return r.length===o.length&&r.every((function(r){var o=t[r];r=a[r];return n(o)===n(r)&&("object"==typeof o||"object"==typeof r?e(o,r):o===r)}))}(e.data.urlProps,l)}));s.length&&!u&&(t.result=void 0),t.relatedNodes=[],(u=t.relatedNodes).push.apply(u,y(s.map((function(e){return e.relatedNodes[0]})))),o[i]=s,r.push(t)}for(var a=e.filter((function(e){return void 0!==e.result})),r=[],o={},i=0;i<a.length;i++)t(i);return r},N(bi={},{aria:function(){return Ko},color:function(){return Ql},dom:function(){return wr},forms:function(){return vs},matches:function(){return wi},standards:function(){return jl},table:function(){return zl},text:function(){return nl},utils:function(){return Et}});var vs={};N(vs,{isAriaCombobox:function(){return Wi},isAriaListbox:function(){return $i},isAriaRange:function(){return Yi},isAriaTextbox:function(){return zi},isDisabled:function(){return ws},isNativeSelect:function(){return Hi},isNativeTextbox:function(){return Vi}});var Ds=["fieldset","button","select","input","textarea"],ws=function e(t){if("boolean"==typeof(n=t._isDisabled))return n;var a=t.props.nodeName,r=t.attr("aria-disabled"),n=!(!Ds.includes(a)||!t.hasAttr("disabled"))||(r?"true"===r.toLowerCase():!!t.parent&&e(t.parent));return t._isDisabled=n};function xs(e){return{fontWeight:function(e){switch(e){case"lighter":return 100;case"normal":return 400;case"bold":return 700;case"bolder":return 900}return e=parseInt(e),isNaN(e)?400:e}((e=t.getComputedStyle(function(e){for(var t=e,a=e.textContent.trim(),r=a;r===a&&void 0!==t;){var n=-1;if(0===(e=t).children.length)return e;for(;n++,""===(r=e.children[n].textContent.trim())&&n+1<e.children.length;);t=e.children[n]}return e}(e))).getPropertyValue("font-weight")),fontSize:parseInt(e.getPropertyValue("font-size")),isItalic:"italic"===e.getPropertyValue("font-style")}}function Es(e,t,a){return a.reduce((function(a,r){return a||(!r.size||e.fontSize/r.size>t.fontSize)&&(!r.weight||e.fontWeight-r.weight>t.fontWeight)&&(!r.italic||e.isItalic&&!t.isItalic)}),!1)}Js=function(e,t,a){if(a=nl.accessibleTextVirtual(a),a=nl.sanitize(nl.removeUnicode(a,{emoji:!0,nonBmp:!0,punctuations:!0})).toLowerCase())return a={name:a,urlProps:wr.urlPropsFromAttribute(e,"href")},this.data(a),this.relatedNodes([e]),!0},ru=function(e,t,a){return Lo(a,"a[href]").some((function(e){return/^#[^/!]/.test(e.actualNode.getAttribute("href"))}))},Tl=function(e,t,a){var r=a.attr("content")||"";a=r.split(/[;,]/);return""===r||"0"===a[0]};Rl=function(e,t,a){var r=Array.from(e.parentNode.children),n=r.indexOf(e),o=(t=t||{}).margins||[];t=r.slice(n+1).find((function(e){return"P"===e.nodeName.toUpperCase()})),n=r.slice(0,n).reverse().find((function(e){return"P"===e.nodeName.toUpperCase()})),e=xs(e),t=t?xs(t):null,n=n?xs(n):null;return!t||!Es(e,t,o)||!!((a=Cr(a,"blockquote"))&&"BLOCKQUOTE"===a.nodeName.toUpperCase()||n&&!Es(e,n,o))&&void 0};var As=Al("landmark"),Cs=["alert","log","status"];function Fs(e,t){var a,n,o,i,l=e.actualNode;if(n=t,o=(a=e).actualNode,i=ki(a),o=(o.getAttribute("aria-live")||"").toLowerCase().trim(),["assertive","polite"].includes(o)||Cs.includes(i)||As.includes(i)||n.regionMatcher&&wi(a,n.regionMatcher)||Rn(e.actualNode)&&Rr(e.actualNode,"href")||!Ir(l,!0)){for(var s=e;s;)s._hasRegionDescendant=!0,s=s.parent;return[]}return l!==r.body&&en(l,!0)?[e]:e.children.filter((function(e){return 1===e.actualNode.nodeType})).map((function(e){return Fs(e,t)})).reduce((function(e,t){return e.concat(t)}),[])}function ks(e,t){return t=Rs(t),e=Rs(e),!(!t||!e)&&t.includes(e)}function Rs(e){return e=sl(e,{emoji:!0,nonBmp:!0,punctuations:!0}),$r(e)}function Ts(e){return""!==(e||"").trim()}var Ns=function(e,t,a){return a.initiator},_s=function(e,t){try{return"svg"===t.props.nodeName||!!er(t,"svg")}catch(e){return!1}},Os={"abstractrole-evaluate":function(e,t,a){return 0<(a=Ho(a.attr("role")).filter((function(e){return"abstract"===Dl(e)}))).length&&(this.data(a),!0)},"aria-allowed-attr-evaluate":function(e,t,a){var r=[],n=ki(a),o=a.attrNames,i=Jo(n);if(Array.isArray(t[n])&&(i=Co(t[n].concat(i))),n&&i)for(var l=0;l<o.length;l++){var s=o[l];Ml(s)&&!i.includes(s)&&r.push(s+\'="\'+a.attr(s)+\'"\')}return!r.length||(this.data(r),!1)},"aria-allowed-role-evaluate":function(e){var t=void 0===(r=(a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).allowImplicit)||r,a=void 0===(r=a.ignoredTags)?[]:r,r=e.nodeName.toUpperCase();return!!a.map((function(e){return e.toUpperCase()})).includes(r)||!(t=El(e,t)).length||(this.data(t),!Ir(e,!0)&&void 0)},"aria-errormessage-evaluate":function(e,t){t=Array.isArray(t)?t:[];var a=e.getAttribute("aria-errormessage"),r=e.hasAttribute("aria-errormessage"),n=e.getAttribute("aria-invalid");if(!e.hasAttribute("aria-invalid")||"false"===n)return!0;var o=Er(e);return-1!==t.indexOf(a)||!r||(this.data(Ho(a)),function(t){if(""===t.trim())return En.ariaAttrs["aria-errormessage"].allowEmpty;var a=t&&o.getElementById(t);return a?"alert"===a.getAttribute("role")||"assertive"===a.getAttribute("aria-live")||"polite"===a.getAttribute("aria-live")||-1<Ho(e.getAttribute("aria-describedby")).indexOf(t):void 0}(a))},"aria-hidden-body-evaluate":function(e,t,a){return"true"!==a.attr("aria-hidden")},"aria-prohibited-attr-evaluate":function(e){var t=2<arguments.length?arguments[2]:void 0,a=(a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{}).elementsAllowedAriaLabel||[];return 0!==(a=function(e,t){var a=ki(e,{chromium:!0}),r=En.ariaRoles[a];return r?r.prohibitedAttrs||[]:(e=e.props.nodeName,a||t.includes(e)?[]:["aria-label","aria-labelledby"])}(t,a).filter((function(e){return!!t.attrNames.includes(e)&&""!==$r(t.attr(e))}))).length&&(this.data(a),!(""!==$r(Si(t)))||void 0)},"aria-required-attr-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=2<arguments.length?arguments[2]:void 0,r=[];if(a.attrNames.length){var n=ti(a),o=Il(n),i=xi(a);if(Array.isArray(t[n])&&(o=Co(t[n],o)),n&&o)for(var l=0,s=o.length;l<s;l++){var u=o[l];a.attr(u)||i.implicitAttrs&&void 0!==i.implicitAttrs[u]||r.push(u)}}return!r.length||(this.data(r),!1)},"aria-required-children-evaluate":function(e,t,a){var r=t&&Array.isArray(t.reviewEmpty)?t.reviewEmpty:[],n=ti(a,{dpub:!0}),o=Ll(n);return null===o||(t=function(e,t){for(var a=[],r=_i(e),n=0;n<r.length;n++)!function(e){e=r[e];var n=ki(e,{noPresentational:!0});!n||["group","rowgroup"].includes(n)&&t.some((function(e){return e===n}))?r.push.apply(r,y(e.children)):n&&a.push(n)}(n);return a}(a,o),!(o=function(e,t,a,r){var n,o,i,l="combobox"===t;l&&(("input"===e.props.nodeName&&["text","search","email","url","tel"].includes(e.props.type)||r.includes("searchbox"))&&(a=a.filter((function(e){return"textbox"!==e}))),n=["listbox","tree","grid","dialog"],t=e.attr("aria-expanded"),o=t&&"false"!==t.toLowerCase(),i=(e.attr("aria-haspopup")||"listbox").toLowerCase(),a=a.filter((function(e){return!n.includes(e)||o&&e===i})));for(var s=0;s<r.length;s++){var u=r[s];if(a.includes(u)&&(a=a.filter((function(e){return e!==u})),!l))return null}return a.length?a:null}(a,n,o,t))||(this.data(o),!(!r.includes(n)||Zr(a,!1,!0)||t.length||a.hasAttr("aria-owns")&&Kr(e,"aria-owns").length)&&void 0))},"aria-required-parent-evaluate":function(e,t,a){var r=t&&Array.isArray(t.ownGroupRoles)?t.ownGroupRoles:[],n=Ul(a,r);if(!n)return!0;var o=function(e){for(var t,a=[],r=null;e;)e.getAttribute("id")&&(t=ha(e.getAttribute("id")),(r=Er(e).querySelector("[aria-owns~=".concat(t,"]")))&&a.push(r)),e=e.parentElement;return a.length?a:null}(e);if(o)for(var i=0,l=o.length;i<l;i++)if(!(n=Ul(Ma(o[i]),r,n,!0)))return!0;return this.data(n),!1},"aria-roledescription-evaluate":function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a=ki(e);return!!(t.supportedRoles||[]).includes(a)||!(!a||"presentation"===a||"none"===a)&&void 0},"aria-unsupported-attr-evaluate":function(e,t,a){return!!(a=a.attrNames.filter((function(t){var a=En.ariaAttrs[t];return!!Ml(t)&&(a=a.unsupported,"object"!==n(a)?!!a:!wi(e,a.exceptions))}))).length&&(this.data(a),!0)},"aria-valid-attr-evaluate":function(e,t,a){t=Array.isArray(t.value)?t.value:[];var r=[],n=/^aria-/;return a.attrNames.forEach((function(e){-1===t.indexOf(e)&&n.test(e)&&!Ml(e)&&r.push(e)})),!r.length||(this.data(r),!1)},"aria-valid-attr-value-evaluate":function(e,t){t=Array.isArray(t.value)?t.value:[];for(var a="",r="",n=[],o=/^aria-/,i=wa(e),l=["aria-errormessage"],s={"aria-controls":function(){return"false"!==e.getAttribute("aria-expanded")&&"false"!==e.getAttribute("aria-selected")},"aria-current":function(){ql(e,"aria-current")||(a=\'aria-current="\'.concat(e.getAttribute("aria-current"),\'"\'),r="ariaCurrent")},"aria-owns":function(){return"false"!==e.getAttribute("aria-expanded")},"aria-describedby":function(){ql(e,"aria-describedby")||(a=\'aria-describedby="\'.concat(e.getAttribute("aria-describedby"),\'"\'),r="noId")},"aria-labelledby":function(){ql(e,"aria-labelledby")||(a=\'aria-labelledby="\'.concat(e.getAttribute("aria-labelledby"),\'"\'),r="noId")}},u=0,c=i.length;u<c;u++){var d=i[u],p=d.name;l.includes(p)||-1!==t.indexOf(p)||!o.test(p)||s[p]&&!s[p]()||ql(e,p)||n.push("".concat(p,\'="\').concat(d.nodeValue,\'"\'))}if(!a)return!n.length||(this.data(n),!1);this.data({messageKey:r,needsReview:a})},"fallbackrole-evaluate":function(e,t,a){return 1<Ho(a.attr("role")).length},"has-global-aria-attribute-evaluate":function(e,t,a){var r=Xo().filter((function(e){return a.hasAttr(e)}));return this.data(r),0<r.length},"has-implicit-chromium-role-matches":function(e,t){return null!==Ei(t,{chromium:!0})},"has-widget-role-evaluate":function(e){return null!==(e=e.getAttribute("role"))&&("widget"===(e=Dl(e))||"composite"===e)},"invalidrole-evaluate":function(e,t,a){return!!(a=Ho(a.attr("role"))).every((function(e){return!ei(e,{allowAbstract:!0})}))&&(this.data(a),!0)},"is-element-focusable-evaluate":function(e,t,a){return ln(a)},"no-implicit-explicit-label-evaluate":function(e,t,a){var r,n,o=ki(a,{noImplicit:!0});this.data(o);try{r=$r(Pi(a)).toLowerCase(),n=$r(tl(a)).toLowerCase()}catch(e){return}return!(!n&&!r)&&!((n||!r)&&n.includes(r))&&void 0},"unsupportedrole-evaluate":function(e,t,a){return Zo(ki(a))},"valid-scrollable-semantics-evaluate":function(e,t){return a=t,(t=ti(t=e))&&(Hl[t]||a.roles.includes(t))||(t=(t=e).nodeName.toUpperCase(),Vl[t]||!1);var a},"caption-faked-evaluate":function(e){var t=ri(e),a=t[0];return t.length<=1||a.length<=1||e.rows.length<=1||a.reduce((function(e,t,r){return e||t!==a[r+1]&&void 0!==a[r+1]}),!1)},"html5-scope-evaluate":function(e){return!un(r)||"TH"===e.nodeName.toUpperCase()},"same-caption-summary-evaluate":function(e){return!(!e.summary||!e.caption)&&e.summary.toLowerCase()===al(e.caption).toLowerCase()},"scope-value-evaluate":function(e,t){return e=e.getAttribute("scope").toLowerCase(),-1!==t.values.indexOf(e)},"td-has-header-evaluate":function(e){var t=[],a=$l(e),r=ri(e);return a.forEach((function(e){en(e)&&Yl(e)&&!Pl(e)&&(Gl(e,r).some((function(e){return null!==e&&!!en(e)}))||t.push(e))})),!t.length||(this.relatedNodes(t),!1)},"td-headers-attr-evaluate":function(e){for(var t=[],a=[],r=[],n=0;n<e.rows.length;n++)for(var o=e.rows[n],i=0;i<o.cells.length;i++)t.push(o.cells[i]);var l=t.reduce((function(e,t){return t.getAttribute("id")&&e.push(t.getAttribute("id")),e}),[]);return t.forEach((function(e){var t,n=!1;if(e.hasAttribute("headers")){var o=e.getAttribute("headers").trim();if(!o)return a.push(e);0!==(o=Ho(o)).length&&(e.getAttribute("id")&&(n=-1!==o.indexOf(e.getAttribute("id").trim())),t=o.some((function(e){return!l.includes(e)})),(n||t)&&r.push(e))}})),0<r.length?(this.relatedNodes(r),!1):!a.length||void this.relatedNodes(a)},"th-has-data-cells-evaluate":function(e){var t=$l(e),a=this,r=[];t.forEach((function(e){var t=e.getAttribute("headers");t&&(r=r.concat(t.split(/\\s+/))),(e=e.getAttribute("aria-labelledby"))&&(r=r.concat(e.split(/\\s+/)))})),t=t.filter((function(e){return""!==$r(e.textContent)&&("TH"===e.nodeName.toUpperCase()||-1!==["rowheader","columnheader"].indexOf(e.getAttribute("role")))}));var n=ri(e),o=!0;return t.forEach((function(e){var t,i;e.getAttribute("id")&&r.includes(e.getAttribute("id"))||(t=ni(e,n),i=!1,(i=!(i=ii(e)?Jl("down",t,n).find((function(t){return!ii(t)&&Gl(t,n).includes(e)})):i)&&li(e)?Jl("right",t,n).find((function(t){return!li(t)&&Gl(t,n).includes(e)})):i)||a.relatedNodes(e),o=o&&i)})),!!o||void 0},"hidden-content-evaluate":function(e,a,r){if(!["SCRIPT","HEAD","TITLE","NOSCRIPT","STYLE","TEMPLATE"].includes(e.nodeName.toUpperCase())&&Zr(r)){if("none"===(r=t.getComputedStyle(e)).getPropertyValue("display"))return;if("hidden"===r.getPropertyValue("visibility")&&(!(e=(e=kr(e))&&t.getComputedStyle(e))||"hidden"!==e.getPropertyValue("visibility")))return}return!0},"color-contrast-evaluate":function(e,a,r){if(!Ir(e,!1))return!0;var n=a.ignoreUnicode,o=a.ignoreLength,i=a.boldValue,l=a.boldTextPt,s=a.largeTextPt,u=a.contrastRatio,c=a.shadowOutlineEmMax,d=Xr(r,!1,!0);if(!il(d,{nonBmp:!0})||""!==$r(sl(d,{nonBmp:!0}))||!n){var p=[],f=ls(e,p,c);a=us(e,!1,f),r=is(e,{maxRatio:c}),n=t.getComputedStyle(e),c=parseFloat(n.getPropertyValue("font-size")),n=n.getPropertyValue("font-weight"),i=parseFloat(n)>=i||"bold"===n,n=null;0===r.length?n=ss(f,a):a&&f&&(m=[].concat(y(r),[f]).reduce(ns),r=ss(f,m),m=ss(m,a),n=Math.max(r,m));for(var m=Math.ceil(72*c)/96,h=(m=(l=i&&m<l||!i&&m<s?u.normal:u.large).expected,s=l.minThreshold,u=l.maxThreshold,l=m<n,e);h;){if(ds(h,":before")||ds(h,":after"))return this.data({messageKey:"pseudoContent"}),void this.relatedNodes(h);h=h.parentElement}if("number"==typeof s&&n<s||"number"==typeof u&&u<n)return!0;var g;u=Math.floor(100*n)/100;return null===f&&(g=gn.get("bgColor")),n=1==u,d=1===d.length,n?g=gn.set("bgColor","equalRatio"):d&&!o&&(g="shortTextContent"),m={fgColor:a?a.toHexString():void 0,bgColor:f?f.toHexString():void 0,contrastRatio:u,fontSize:"".concat((72*c/96).toFixed(1),"pt (").concat(c,"px)"),fontWeight:i?"bold":"normal",messageKey:g,expectedContrastRatio:m+":1"},this.data(m),null===a||null===f||n||d&&!o&&!l?(g=null,gn.clear(),void this.relatedNodes(p)):(l||this.relatedNodes(p),l)}this.data({messageKey:"nonBmp"})},"link-in-text-block-evaluate":function(e){if(ms(e))return!1;for(var t=kr(e);1===t.nodeType&&!ms(t);)t=kr(t);if(this.relatedNodes([t]),ts(e,t))return!0;var a=us(e),r=us(t);if(a&&r){var n=ps(a,r);return 1===n||(3<=n?(gn.set("fgColor","bgContrast"),this.data({messageKey:gn.get("fgColor")}),void gn.clear()):(a=ls(e),r=ls(t),(!a||!r||3<=ps(a,r))&&(r=a&&r?"bgContrast":gn.get("bgColor"),gn.set("fgColor",r),this.data({messageKey:gn.get("fgColor")}),void gn.clear())))}},"autocomplete-appropriate-evaluate":function(e,t,a){if("input"!==a.props.nodeName)return!0;var r=["text","search","number","tel"],o=["text","search","url"],i={bday:["text","search","date"],email:["text","search","email"],username:["text","search","email"],"street-address":["text"],tel:["text","search","tel"],"tel-country-code":["text","search","tel"],"tel-national":["text","search","tel"],"tel-area-code":["text","search","tel"],"tel-local":["text","search","tel"],"tel-local-prefix":["text","search","tel"],"tel-local-suffix":["text","search","tel"],"tel-extension":["text","search","tel"],"cc-number":r,"cc-exp":["text","search","month","tel"],"cc-exp-month":r,"cc-exp-year":r,"cc-csc":r,"transaction-amount":r,"bday-day":r,"bday-month":r,"bday-year":r,"new-password":["text","search","password"],"current-password":["text","search","password"],url:o,photo:o,impp:o};return"object"===n(t)&&Object.keys(t).forEach((function(e){i[e]||(i[e]=[]),i[e]=i[e].concat(t[e])})),o=(o=a.attr("autocomplete").split(/\\s+/g).map((function(e){return e.toLowerCase()})))[o.length-1],!!dl.stateTerms.includes(o)||(o=i[o],a=a.hasAttr("type")?$r(a.attr("type")).toLowerCase():"text",a=zo().includes(a)?a:"text",void 0===o?"text"===a:o.includes(a))},"autocomplete-valid-evaluate":T,"attr-non-space-content-evaluate":Ut,"has-descendant-after":hs,"has-descendant-evaluate":za,"has-text-content-evaluate":vn,"matches-definition-evaluate":Dn,"page-no-duplicate-after":fi,"page-no-duplicate-evaluate":mi,"heading-order-after":function(e){var t,a=((t=y(t=e)).sort((function(e,t){return e=e.node,t=t.node,e.ancestry.length-t.ancestry.length})),t.reduce(gs,[]).filter((function(e){return-1!==e.level})));return e.forEach((function(e){e.result=function(e,t){var a=bs(t,e.node.ancestry);e=null!==(e=null===(e=t[a])||void 0===e?void 0:e.level)&&void 0!==e?e:-1,t=null!==(t=null===(t=t[a-1])||void 0===t?void 0:t.level)&&void 0!==t?t:-1;return 0===a||(-1!==e?e-t<=1:void 0)}(e,a)})),e},"heading-order-evaluate":hi,"identical-links-same-purpose-after":gi,"identical-links-same-purpose-evaluate":Js,"internal-link-present-evaluate":ru,"meta-refresh-evaluate":Tl,"p-as-heading-evaluate":Rl,"region-evaluate":function(e,t,a){if(n=qa.get("regionlessNodes"))return!n.includes(a);var n=Fs(o._tree[0],t).map((function(e){for(;e.parent&&!e.parent._hasRegionDescendant&&e.parent.actualNode!==r.body;)e=e.parent;return e})).filter((function(e,t,a){return a.indexOf(e)===t}));return qa.set("regionlessNodes",n),!n.includes(a)},"skip-link-evaluate":function(e){return!!(e=Rr(e,"href"))&&(Ir(e,!0)||void 0)},"unique-frame-title-after":function(e){var t={};return e.forEach((function(e){t[e.data]=void 0!==t[e.data]?++t[e.data]:0})),e.forEach((function(e){e.result=!!t[e.data]})),e},"unique-frame-title-evaluate":function(e,t,a){return a=$r(a.attr("title")).toLowerCase(),this.data(a),!0},"aria-label-evaluate":function(e,t,a){return!!$r(Qo(a))},"aria-labelledby-evaluate":function(e,t,a){try{return!!$r(rl(a))}catch(e){return}},"avoid-inline-spacing-evaluate":function(e,t){return!(0<(t=t.cssProperties.filter((function(t){if("important"===e.style.getPropertyPriority(t))return t}))).length&&(this.data(t),1))},"doc-has-title-evaluate":function(){var e=r.title;return!!$r(e)},"exists-evaluate":function(){},"has-alt-evaluate":function(e,t,a){var r=a.props.nodeName;return!!["img","input","area"].includes(r)&&a.hasAttr("alt")},"is-on-screen-evaluate":function(e){return Ir(e,!1)&&!Or(e)},"non-empty-if-present-evaluate":function(e,t,a){var r=a.props.nodeName,n=(a.attr("type")||"").toLowerCase();return(a=a.attr("value"))&&this.data({messageKey:"has-label"}),!("input"!==r||!["submit","reset"].includes(n))&&null===a},"presentational-role-evaluate":function(e,t,a){var r=ki(a),n=ti(a);if(["presentation","none"].includes(r))return this.data({role:r}),!0;if(!["presentation","none"].includes(n))return!1;var o=Xo().some((function(e){return a.hasAttr(e)}));n=ln(a),n=o&&!n?"globalAria":!o&&n?"focusable":"both";return this.data({messageKey:n,role:r}),!1},"svg-non-empty-title-evaluate":function(e,t,a){if(a.children){if(!(a=a.children.find((function(e){return"title"===e.props.nodeName}))))return this.data({messageKey:"noTitle"}),!1;try{if(""===Xr(a))return this.data({messageKey:"emptyTitle"}),!1}catch(e){return}return!0}},"css-orientation-lock-evaluate":function(e,t,a,r){r=void 0===(r=(r||{}).cssom)?void 0:r;var n=void 0===(t=(t||{}).degreeThreshold)?0:t;if(r&&r.length){function o(){var e=c[u],t=(e=s[e]).root;if(!(e=e.rules.filter(d)).length)return"continue";e.forEach((function(e){e=e.cssRules,Array.from(e).forEach((function(e){var a=function(e){var t=e.selectorText;e=e.style;return!(!t||e.length<=0)&&(!!(t=e.transform||e.webkitTransform||e.msTransform||!1)&&(!!(e=t.match(/(rotate|rotateZ|rotate3d|matrix|matrix3d)\\(([^)]+)\\)(?!.*(rotate|rotateZ|rotate3d|matrix|matrix3d))/))&&(!!(t=function(e,t){switch(e){case"rotate":case"rotateZ":return p(t);case"rotate3d":var a=(r=v(t.split(",").map((function(e){return e.trim()})),4))[2],r=r[3];return 0===parseInt(a)?void 0:p(r);case"matrix":case"matrix3d":return function(e){var t=e.split(",");if(t.length<=6){var a=(e=v(t,2))[0];e=e[1];return f(Math.atan2(parseFloat(e),parseFloat(a)))}return a=parseFloat(t[8]),a=Math.asin(a),a=Math.cos(a),f(Math.acos(parseFloat(t[0])/a))}(t);default:return}}(e=(t=v(e,3))[1],t=t[2]))&&(t=Math.abs(t),!(Math.abs(t-180)%180<=n)&&Math.abs(t-90)%90<=n))))}(e);a&&"HTML"!==e.selectorText.toUpperCase()&&(e=Array.from(t.querySelectorAll(e.selectorText))||[],l=l.concat(e)),i=i||a}))}))}for(var i=!1,l=[],s=r.reduce((function(e,t){var a=t.sheet,r=t.root;return e[t=(t=t.shadowId)||"topDocument"]||(e[t]={root:r,rules:[]}),a&&a.cssRules?(a=Array.from(a.cssRules),e[t].rules=e[t].rules.concat(a),e):e}),{}),u=0,c=Object.keys(s);u<c.length;u++)o();return!i||(l.length&&this.relatedNodes(l),!1)}function d(e){var t=e.type;e=e.cssText;return 4===t&&(/orientation:\\s*landscape/i.test(e)||/orientation:\\s*portrait/i.test(e))}function p(e){var t=v(e.match(/(deg|grad|rad|turn)/)||[],1)[0];if(t){var a=parseFloat(e.replace(t,""));switch(t){case"rad":return f(a);case"grad":return function(e){return(e%=400)<0&&(e+=400),Math.round(e/400*360)}(a);case"turn":return Math.round(360/(1/a));case"deg":default:return parseInt(a)}}}function f(e){return Math.round(e*(180/Math.PI))}},"meta-viewport-scale-evaluate":function(e,t,a){var r=(n=t||{}).scaleMinimum,n=(t=void 0===r?2:r,void 0!==(r=n.lowerBound)&&r);return!((r=a.attr("content")||"")&&(a=r.split(/[;,]/).reduce((function(e,t){var a=t.trim();return a?(t=v(a.split("="),2),a=t[0],t=t[1],a&&t?(a=a.toLowerCase().trim(),t=t.toLowerCase().trim(),"maximum-scale"===a&&"yes"===t&&(t=1),"maximum-scale"===a&&parseFloat(t)<0||(e[a]=t),e):e):e}),{}),!(n&&a["maximum-scale"]&&parseFloat(a["maximum-scale"])<n)&&(n||"no"!==a["user-scalable"]?(r=parseFloat(a["user-scalable"]),!n&&a["user-scalable"]&&(r||0===r)&&-1<r&&r<1?(this.data("user-scalable"),1):a["maximum-scale"]&&parseFloat(a["maximum-scale"])<t&&(this.data("maximum-scale"),1)):(this.data("user-scalable=no"),1))))},"duplicate-id-after":function(e){var t=[];return e.filter((function(e){return-1===t.indexOf(e.data)&&(t.push(e.data),!0)}))},"duplicate-id-evaluate":function(e){var t=e.getAttribute("id").trim();if(!t)return!0;var a=Er(e);return(a=Array.from(a.querySelectorAll(\'[id="\'.concat(ha(t),\'"]\'))).filter((function(t){return t!==e}))).length&&this.relatedNodes(a),this.data(t),0===a.length},"accesskeys-after":function(e){var t={};return e.filter((function(e){if(!e.data)return!1;var a=e.data.toUpperCase();return t[a]?(t[a].relatedNodes.push(e.relatedNodes[0]),!1):((t[a]=e).relatedNodes=[],!0)})).map((function(e){return e.result=!!e.relatedNodes.length,e}))},"accesskeys-evaluate":function(e){return Ir(e,!1)&&(this.data(e.getAttribute("accesskey")),this.relatedNodes([e])),!0},"focusable-content-evaluate":function(e,t,a){var r=a.tabbableElements;return!!r&&0<r.filter((function(e){return e!==a})).length},"focusable-disabled-evaluate":function(e,t,a){var r=["BUTTON","FIELDSET","INPUT","SELECT","TEXTAREA"];return!(a=a.tabbableElements)||!a.length||(a=a.reduce((function(e,t){var a=t.actualNode;t=a.nodeName.toUpperCase();return r.includes(t)&&e.push(a),e}),[]),this.relatedNodes(a),!(!a.length||!fn())||0===a.length)},"focusable-element-evaluate":function(e,t,a){if(a.hasAttr("contenteditable")&&function e(t){return"true"===(t=t.attr("contenteditable"))||""===t||"false"!==t&&(!!(t=er(a.parent,"[contenteditable]"))&&e(t))}(a))return!0;var r=a.isFocusable,n=parseInt(a.attr("tabindex"),10);return(n=isNaN(n)?null:n)?r&&0<=n:r},"focusable-modal-open-evaluate":function(e,t,a){return!(a=a.tabbableElements.map((function(e){return e.actualNode})))||!a.length||!fn()||void this.relatedNodes(a)},"focusable-no-name-evaluate":function(e,t,a){var r=a.attr("tabindex");if(!(ln(a)&&-1<r))return!1;try{return!tl(a)}catch(e){return}},"focusable-not-tabbable-evaluate":function(e,t,a){var r=["BUTTON","FIELDSET","INPUT","SELECT","TEXTAREA"];return!(a=a.tabbableElements)||!a.length||(a=a.reduce((function(e,t){var a=t.actualNode;t=a.nodeName.toUpperCase();return r.includes(t)||e.push(a),e}),[]),this.relatedNodes(a),!!(0<a.length&&fn())||0===a.length)},"landmark-is-top-level-evaluate":function(e){var t=Al("landmark"),a=kr(e),r=ki(e);for(this.data({role:r});a;){var n=a.getAttribute("role");if((n=n||"FORM"===a.nodeName.toUpperCase()?n:Ei(a))&&t.includes(n)&&("main"!==n||"complementary"!==r))return!1;a=kr(a)}return!0},"no-focusable-content-evaluate":function(e,t,a){if(a.children)try{return!a.children.some((function e(t){if(ln(t))return!0;if(t.children)return t.children.some(e);if(1===t.props.nodeType)throw new Error("Cannot determine children");return!1}))}catch(e){return}},"tabindex-evaluate":function(e,t,a){return a=parseInt(a.attr("tabindex"),10),!!isNaN(a)||a<=0},"alt-space-value-evaluate":function(e,t,a){return"string"==typeof(a=a.attr("alt"))&&/^\\s+$/.test(a)},"duplicate-img-label-evaluate":function(e,t,a){return!["none","presentation"].includes(ki(a))&&!!(t=er(a,t.parentSelector))&&""!==(t=Xr(t,!0).toLowerCase())&&t===tl(a).toLowerCase()},"explicit-evaluate":function(e,t,a){if(a.attr("id")){if(!a.actualNode)return;var r=Er(a.actualNode);a=ha(a.attr("id"));if((a=Array.from(r.querySelectorAll(\'label[for="\'.concat(a,\'"]\')))).length)try{return a.some((function(e){return!Ir(e)||!!al(e)}))}catch(e){return}}return!1},"help-same-as-label-evaluate":function(e,t,a){var r=ml(a);a=e.getAttribute("title");return!!r&&(a||(a="",e.getAttribute("aria-describedby")&&(a=Kr(e,"aria-describedby").map((function(e){return e?al(e):""})).join(""))),$r(a)===$r(r))},"hidden-explicit-label-evaluate":function(e,t,a){if(a.hasAttr("id")){if(!a.actualNode)return;var r,n=Er(e);e=ha(e.getAttribute("id"));if((e=n.querySelector(\'label[for="\'.concat(e,\'"]\')))&&!Ir(e,!0)){try{r=tl(a).trim()}catch(e){return}return""===r}}return!1},"implicit-evaluate":function(e,t,a){try{var r=er(a,"label");return!!r&&!!tl(r,{inControlContext:!0})}catch(e){return}},"label-content-name-mismatch-evaluate":function(e,t,a){var r=(t=t||{}).pixelThreshold,n=t.occuranceThreshold;e=al(e).toLowerCase();if(!(ul(e)<1))return a=bl(a).filter((function(e){return!cl(e,r,n)})).map((function(e){return e.actualNode.nodeValue})).join(""),!(a=$r(a).toLowerCase())||(ul(a)<1?!!ks(a,e)||void 0:ks(a,e))},"multiple-label-evaluate":function(e){var t=ha(e.getAttribute("id")),a=e.parentNode,r=(r=Er(e)).documentElement||r,n=Array.from(r.querySelectorAll(\'label[for="\'.concat(t,\'"]\')));for(n.length&&(n=n.filter((function(e){return Ir(e)})));a;)"LABEL"===a.nodeName.toUpperCase()&&-1===n.indexOf(a)&&n.push(a),a=a.parentNode;return this.relatedNodes(n),1<n.length&&((1<(t=n.filter((function(e){return Ir(e,!0)}))).length||!Kr(e,"aria-labelledby").includes(t[0]))&&void 0)},"title-only-evaluate":function(e,t,a){var r=ml(a),n=Ti(a);a=a.attr("aria-describedby");return!(r||!n&&!a)},"landmark-is-unique-after":function(e){var t=[];return e.filter((function(e){var a=t.find((function(t){return e.data.role===t.data.role&&e.data.accessibleText===t.data.accessibleText}));return a?(a.result=!1,a.relatedNodes.push(e.relatedNodes[0]),!1):(t.push(e),e.relatedNodes=[],!0)}))},"landmark-is-unique-evaluate":function(e,t,a){var r=ki(e);a=(a=tl(a))?a.toLowerCase():null;return this.data({role:r,accessibleText:a}),this.relatedNodes([e]),!0},"has-lang-evaluate":function(e,t,a){var n=void 0!==r&&Ea(r);return t.attributes.includes("xml:lang")&&t.attributes.includes("lang")&&Ts(a.attr("xml:lang"))&&!Ts(a.attr("lang"))&&!n?(this.data({messageKey:"noXHTML"}),!1):!!t.attributes.some((function(e){return Ts(a.attr(e))}))||(this.data({messageKey:"noLang"}),!1)},"valid-lang-evaluate":function(e,t,a){var r=[];return t.attributes.forEach((function(e){var n,o,i=a.attr(e);"string"==typeof i&&(n=jn(i),o=t.value?!t.value.map(jn).includes(n):!Go(n),(""!==n&&o||""!==i&&!$r(i))&&r.push(e+\'="\'+a.attr(e)+\'"\'))})),!!r.length&&(this.data(r),!0)},"xml-lang-mismatch-evaluate":function(e,t,a){return jn(a.attr("lang"))===jn(a.attr("xml:lang"))},"dlitem-evaluate":function(e){var t=kr(e),a=t.nodeName.toUpperCase();e=ti(t);return"DIV"===a&&["presentation","none",null].includes(e)&&(a=(t=kr(t)).nodeName.toUpperCase(),e=ti(t)),"DL"===a&&!(e&&!["presentation","none","list"].includes(e))},"listitem-evaluate":function(e){var t=kr(e);if(t)return e=t.nodeName.toUpperCase(),t=(t.getAttribute("role")||"").toLowerCase(),!!["presentation","none","list"].includes(t)||(t&&ei(t)?(this.data({messageKey:"roleNotValid"}),!1):["UL","OL"].includes(e))},"only-dlitems-evaluate":function(e,t,a){var r=["definition","term","list"];return(a=a.children.reduce((function(e,t){var a=t.actualNode;return"DIV"===a.nodeName.toUpperCase()&&null===ki(a)?e.concat(t.children):e.concat(t)}),[]).reduce((function(e,t){var a=t.actualNode,n=a.nodeName.toUpperCase();return 1===a.nodeType&&Ir(a,!0,!1)?(t=ti(a),("DT"!==n&&"DD"!==n||t)&&(r.includes(t)||e.badNodes.push(a))):3===a.nodeType&&""!==a.nodeValue.trim()&&(e.hasNonEmptyTextNode=!0),e}),{badNodes:[],hasNonEmptyTextNode:!1})).badNodes.length&&this.relatedNodes(a.badNodes),!!a.badNodes.length||a.hasNonEmptyTextNode},"only-listitems-evaluate":function(e,t,a){var r=!1,n=!1,o=!0,i=[],l=[],s=[];return a.children.forEach((function(e){var t,a,u=e.actualNode;3!==u.nodeType||""===u.nodeValue.trim()?1===u.nodeType&&Ir(u,!0,!1)&&(o=!1,t="LI"===u.nodeName.toUpperCase(),e="listitem"===(a=ki(e)),t||e||i.push(u),t&&!e&&(l.push(u),s.includes(a)||s.push(a)),e&&(n=!0)):r=!0})),r||i.length?(this.relatedNodes(i),!0):!o&&!n&&(this.relatedNodes(l),this.data({messageKey:"roleNotValid",roles:s.join(", ")}),!0)},"structured-dlitems-evaluate":function(e,t,a){var r=a.children;if(!r||!r.length)return!1;for(var n,o=!1,i=!1,l=0;l<r.length;l++){if((o="DT"===(n=r[l].props.nodeName.toUpperCase())||o)&&"DD"===n)return!1;"DD"===n&&(i=!0)}return o||i},"caption-evaluate":function(e,t,a){return!Lo(a,"track").some((function(e){return"captions"===(e.attr("kind")||"").toLowerCase()}))&&void 0},"frame-tested-evaluate":function(e,t){return!t.isViolation&&void 0},"frame-tested-after":function(e){var t={};return e.filter((function(e){if("html"!==e.node.ancestry[e.node.ancestry.length-1]){var a=e.node.ancestry.flat(1/0).join(" > ");return t[a]=e,!0}return e=e.node.ancestry.slice(0,e.node.ancestry.length-1).flat(1/0).join(" > "),t[e]&&(t[e].result=!0),!1}))},"no-autoplay-audio-evaluate":function(e,t){if(e.duration)return t=void 0===(t=t.allowedDuration)?3:t,function(e){if(!e.currentSrc)return 0;var t=function(e){if(e=e.match(/#t=(.*)/))return v(e,2)[1].split(",").map((function(e){return(/:/.test(e)?function(e){for(var t=e.split(":"),a=0,r=1;0<t.length;)a+=r*parseInt(t.pop(),10),r*=60;return parseFloat(a)}:parseFloat)(e)}))}(e.currentSrc);return t?1!==t.length?Math.abs(t[1]-t[0]):Math.abs(e.duration-t[0]):Math.abs(e.duration-(e.currentTime||0))}(e)<=t&&!e.hasAttribute("loop")||!!e.hasAttribute("controls");console.warn("axe.utils.preloadMedia did not load metadata")},"aria-allowed-attr-matches":function(e,t){var a=/^aria-/,r=t.attrNames;if(r.length)for(var n=0,o=r.length;n<o;n++)if(a.test(r[n]))return!0;return!1},"aria-allowed-role-matches":function(e){return null!==ti(e,{dpub:!0,fallback:!0})},"aria-form-field-name-matches":Nl=function(e,t){var a=xi(t).namingMethods;return!(a&&0!==a.length||"combobox"===ti(t)&&Lo(t,\'input:not([type="hidden"])\').length)},"aria-has-attr-matches":function(e,t){var a=/^aria-/;return t.attrNames.some((function(e){return a.test(e)}))},"aria-hidden-focus-matches":function(e){return function e(t){return!t||"true"!==t.getAttribute("aria-hidden")&&e(kr(t))}(kr(e))},"aria-required-children-matches":function(e,t){return t=ti(t,{dpub:!0}),!!Ll(t)},"aria-required-parent-matches":function(e,t){return t=ti(t),!!Bl(t)},"autocomplete-matches":function(e,t){var a=t.attr("autocomplete");if(!a||""===$r(a))return!1;var r=t.props.nodeName;return!1!==["textarea","input","select"].includes(r)&&(("input"!==r||!["submit","reset","button","hidden"].includes(t.props.type))&&(a=t.attr("aria-disabled")||"false",!t.hasAttr("disabled")&&"true"!==a.toLowerCase()&&(r=t.attr("role"),("-1"!==(a=t.attr("tabindex"))||!r||void 0!==(r=En.ariaRoles[r])&&"widget"===r.type)&&!("-1"===a&&t.actualNode&&!Ir(t.actualNode,!1)&&!Ir(t.actualNode,!0)))))},"bypass-matches":function(e,t,a){return!Ns(0,0,a)||!!e.querySelector("a[href]")},"color-contrast-matches":function(e,a){var n=(o=a.props).nodeName,o=o.type;if("option"===n)return!1;if("select"===n&&!e.options.length)return!1;if("input"===n&&["hidden","range","color","checkbox","radio","image"].includes(o))return!1;if(ws(a))return!1;if(["input","select","textarea"].includes(n)){if(o=t.getComputedStyle(e),o=parseInt(o.getPropertyValue("text-indent"),10)){var i={top:(i=e.getBoundingClientRect()).top,bottom:i.bottom,left:i.left+o,right:i.right+o};if(!In(i,e))return!1}return!0}if(i=Cr(a,"label"),"label"===n||i){n=i||e;var l=i?Ma(i):a;if(n.htmlFor&&(n=(n=Er(n).getElementById(n.htmlFor))&&Ma(n))&&ws(n))return!1;if((l=Lo(l,\'input:not([type="hidden"],[type="image"],[type="button"],[type="submit"],[type="reset"]), select, textarea\')[0])&&ws(l))return!1}for(var s,u=[],c=a;c;)c.props.id&&(s=vl(c).filter((function(e){return Ho(e.getAttribute("aria-labelledby")||"").includes(c.props.id)})).map((function(e){return Ma(e)})),u.push.apply(u,y(s))),c=c.parent;if(0<u.length&&u.every(ws))return!1;if(!(l=Xr(a,!1,!0))||!sl(l,{emoji:!0,nonBmp:!1,punctuations:!0}))return!1;for(var d=r.createRange(),p=a.children,f=0;f<p.length;f++){var m=p[f];3===m.actualNode.nodeType&&""!==$r(m.actualNode.nodeValue)&&d.selectNodeContents(m.actualNode)}for(var h=d.getClientRects(),g=0;g<h.length;g++)if(In(h[g],e))return!0;return!1},"data-table-large-matches":function(e){return!!Kl(e)&&(3<=(e=ri(e)).length&&3<=e[0].length&&3<=e[1].length&&3<=e[2].length)},"data-table-matches":function(e){return Kl(e)},"duplicate-id-active-matches":function(e){var t=e.getAttribute("id").trim();t=\'*[id="\'.concat(ha(t),\'"]\'),t=Array.from(Er(e).querySelectorAll(t));return!Sl(e)&&t.some(ln)},"duplicate-id-aria-matches":function(e){return Sl(e)},"duplicate-id-misc-matches":function(e){var t=e.getAttribute("id").trim();t=\'*[id="\'.concat(ha(t),\'"]\'),t=Array.from(Er(e).querySelectorAll(t));return!Sl(e)&&t.every((function(e){return!ln(e)}))},"frame-focusable-content-matches":function(e,t,a){return!a.initiator&&!a.focusable&&1<a.boundingClientRect.width*a.boundingClientRect.height},"frame-title-has-text-matches":function(e){return e=e.getAttribute("title"),!!$r(e)},"heading-matches":function(e){var t;return(t=e.hasAttribute("role")?e.getAttribute("role").split(/\\s+/i).filter(o.commons.aria.isValidRole):t)&&0<t.length?t.includes("heading"):"heading"===o.commons.aria.implicitRole(e)},"html-namespace-matches":function(e,t){return!_s(0,t)},"identical-links-same-purpose-matches":function(e,t){return!(!tl(t)||(e=ki(e))&&"link"!==e)},"inserted-into-focus-order-matches":function(e){return sn(e)},"is-initiator-matches":Ns,"label-content-name-mismatch-matches":function(e,t){var a=ki(e);return!!(a&&Al("widget").includes(a)&&Fl().includes(a)&&($r(Qo(t))||$r(rl(e)))&&$r(Xr(t)))},"label-matches":function(e,t){return"input"!==t.props.nodeName||!1===t.hasAttr("type")||(t=t.attr("type").toLowerCase(),!1===["hidden","image","button","submit","reset"].includes(t))},"landmark-has-body-context-matches":function(e,t){return e.hasAttribute("role")||!Cr(t,"article, aside, main, nav, section")},"landmark-unique-matches":function(e,t){var a,r,n,o=["article","aside","main","nav","section"].join(",");return r=(a=t).actualNode,n=Al("landmark"),!!(t=ki(r))&&("HEADER"===(r=r.nodeName.toUpperCase())||"FOOTER"===r?!Cr(a,o):"SECTION"!==r&&"FORM"!==r?0<=n.indexOf(t)||"region"===t:!!tl(a))&&Ir(e,!0)},"layout-table-matches":function(e){return!Kl(e)&&!ln(e)},"link-in-text-block-matches":function(e){var t=$r(e.textContent),a=e.getAttribute("role");return(!a||"link"===a)&&!!t&&!!Ir(e,!1)&&pn(e)},"nested-interactive-matches":function(e,t){return!!(t=ki(t))&&!!En.ariaRoles[t].childrenPresentational},"no-autoplay-audio-matches":function(e){return!!e.currentSrc&&!e.hasAttribute("paused")&&!e.hasAttribute("muted")},"no-empty-role-matches":function(e,t){return!!t.hasAttr("role")&&!!t.attr("role").trim()},"no-explicit-name-required-matches":function(e,t){var a=ti(t);return!(a&&!["none","presentation"].includes(a)&&!(yn[a]||{}).accessibleNameRequired&&!ln(t))},"no-naming-method-matches":Nl,"no-role-matches":function(e){return!e.getAttribute("role")},"not-html-matches":function(e,t){return"html"!==t.props.nodeName},"p-as-heading-matches":function(e){var t=Array.from(e.parentNode.childNodes),a=e.textContent.trim();return!(0===a.length||2<=(a.match(/[.!?:;](?![.!?:;])/g)||[]).length)&&0!==t.slice(t.indexOf(e)+1).filter((function(e){return"P"===e.nodeName.toUpperCase()&&""!==e.textContent.trim()})).length},"scrollable-region-focusable-matches":function(e,t){if(0==!!Qn(e,13))return!1;var a=ti(t);if(En.ariaRoles.combobox.requiredOwned.includes(a)){if(er(t,\'[role~="combobox"]\'))return!1;if((a=t.attr("id"))&&(e=xr(e),Array.from(e.querySelectorAll(\'[aria-owns~="\'.concat(a,\'"], [aria-controls~="\').concat(a,\'"]\'))).some((function(e){return Ho(e.getAttribute("role")).includes("combobox")}))))return!1}return!!Lo(t,"*").some((function(e){return Zr(e,!0,!0)}))},"skip-link-matches":function(e){return Rn(e)&&Or(e)},"svg-namespace-matches":_s,"window-is-top-matches":function(e){return e.ownerDocument.defaultView.self===e.ownerDocument.defaultView.top},"xml-lang-mismatch-matches":function(e){var t=jn(e.getAttribute("lang"));e=jn(e.getAttribute("xml:lang"));return Go(t)&&Go(e)}},Ss=function(e){this.id=e.id,this.data=null,this.relatedNodes=[],this.result=null};function Ps(e){if("string"!=typeof e)return e;if(Os[e])return Os[e];if(/^\\s*function[\\s\\w]*\\(/.test(e))return new Function("return "+e+";")();throw new ReferenceError("Function ID does not exist in the metadata-function-map: ".concat(e))}function Is(e){var t=0<arguments.length&&void 0!==e?e:{};return Array.isArray(t)||"object"!==n(t)?{value:t}:t}function Bs(e){e&&(this.id=e.id,this.configure(e))}Bs.prototype.enabled=!0,Bs.prototype.run=function(e,t,a,r,n){var o=((t=t||{}).hasOwnProperty("enabled")?t:this).enabled,i=this.getOptions(t.options);if(o){var l;o=new Ss(this),t=Va(o,t,r,n);try{l=this.evaluate.call(t,e.actualNode,i,e,a)}catch(t){return e&&e.actualNode&&(t.errorNode=new Ua(e).toJSON()),void n(t)}t.isAsync||(o.result=l,r(o))}else r(null)},Bs.prototype.runSync=function(e,t,a){if(!(void 0===(o=(t=t||{}).enabled)?this.enabled:o))return null;var r,n=this.getOptions(t.options),o=new Ss(this);(t=Va(o,t)).async=function(){throw new Error("Cannot run async check while in a synchronous run")};try{r=this.evaluate.call(t,e.actualNode,n,e,a)}catch(t){throw e&&e.actualNode&&(t.errorNode=new Ua(e).toJSON()),t}return o.result=r,o},Bs.prototype.configure=function(e){var t=this;e.evaluate&&!Os[e.evaluate]||(this._internalCheck=!0),e.hasOwnProperty("enabled")&&(this.enabled=e.enabled),e.hasOwnProperty("options")&&(this._internalCheck?this.options=Is(e.options):this.options=e.options),["evaluate","after"].filter((function(t){return e.hasOwnProperty(t)})).forEach((function(a){return t[a]=Ps(e[a])}))},Bs.prototype.getOptions=function(e){return this._internalCheck?br(this.options,Is(e||{})):e||this.options};var Ls=Bs,qs=function(e){this.id=e.id,this.result=yt.NA,this.pageLevel=e.pageLevel,this.impact=null,this.nodes=[]};function Ms(e,t){this._audit=t,this.id=e.id,this.selector=e.selector||"*",e.impact&&(Ft(yt.impact.includes(e.impact),"Impact ".concat(e.impact," is not a valid impact")),this.impact=e.impact),this.excludeHidden="boolean"!=typeof e.excludeHidden||e.excludeHidden,this.enabled="boolean"!=typeof e.enabled||e.enabled,this.pageLevel="boolean"==typeof e.pageLevel&&e.pageLevel,this.reviewOnFail="boolean"==typeof e.reviewOnFail&&e.reviewOnFail,this.any=e.any||[],this.all=e.all||[],this.none=e.none||[],this.tags=e.tags||[],this.preload=!!e.preload,e.matches&&(this.matches=Ps(e.matches))}function js(e){if(e.length){var t=!1,a={};return e.forEach((function(e){var r=e.results.filter((function(e){return e}));(a[e.type]=r).length&&(t=!0)})),t?a:null}}Ms.prototype.matches=function(){return!0},Ms.prototype.gather=function(e){var t=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},a="mark_gather_start_"+this.id,r="mark_gather_end_"+this.id,n="mark_isHidden_start_"+this.id,o="mark_isHidden_end_"+this.id;t.performanceTimer&&wo.mark(a);var i=Uo(this.selector,e);return this.excludeHidden&&(t.performanceTimer&&wo.mark(n),i=i.filter((function(e){return!no(e.actualNode)})),t.performanceTimer&&(wo.mark(o),wo.measure("rule_"+this.id+"#gather_axe.utils.isHidden",n,o))),t.performanceTimer&&(wo.mark(r),wo.measure("rule_"+this.id+"#gather",a,r)),i},Ms.prototype.runChecks=function(e,t,a,r,n,o){var i=this,l=or();this[e].forEach((function(e){var n=i._audit.checks[e.id||e],o=Xn(n,i.id,a);l.defer((function(e,a){n.run(t,o,r,e,a)}))})),l.then((function(t){t=t.filter((function(e){return e})),n({type:e,results:t})})).catch(o)},Ms.prototype.runChecksSync=function(e,t,a,r){var n=this,o=[];return this[e].forEach((function(e){var i=n._audit.checks[e.id||e];e=Xn(i,n.id,a);o.push(i.runSync(t,e,r))})),{type:e,results:o=o.filter((function(e){return e}))}},Ms.prototype.run=function(e){var t=this,a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},r=2<arguments.length?arguments[2]:void 0,n=3<arguments.length?arguments[3]:void 0;a.performanceTimer&&this._trackPerformance();var o,l=or(),s=new qs(this);try{o=this.gatherAndMatchNodes(e,a)}catch(r){return void n(new i({cause:r,ruleId:this.id}))}a.performanceTimer&&this._logGatherPerformance(o),o.forEach((function(r){l.defer((function(n,o){var i=or();["any","all","none"].forEach((function(n){i.defer((function(o,i){t.runChecks(n,r,a,e,o,i)}))})),i.then((function(e){var o=js(e);o&&(o.node=new Ua(r,a),s.nodes.push(o),t.reviewOnFail&&(["any","all"].forEach((function(e){o[e].forEach((function(e){!1===e.result&&(e.result=void 0)}))})),o.none.forEach((function(e){!0===e.result&&(e.result=void 0)})))),n()})).catch((function(e){return o(e)}))}))})),l.defer((function(e){return setTimeout(e,0)})),a.performanceTimer&&this._logRulePerformance(),l.then((function(){return r(s)})).catch((function(e){return n(e)}))},Ms.prototype.runSync=function(e){var t=this,a=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{};a.performanceTimer&&this._trackPerformance();var r,n=new qs(this);try{r=this.gatherAndMatchNodes(e,a)}catch(r){throw new i({cause:r,ruleId:this.id})}return a.performanceTimer&&this._logGatherPerformance(r),r.forEach((function(r){var o=[];["any","all","none"].forEach((function(n){o.push(t.runChecksSync(n,r,a,e))}));var i=js(o);i&&(i.node=r.actualNode?new Ua(r,a):null,n.nodes.push(i),t.reviewOnFail&&(["any","all"].forEach((function(e){i[e].forEach((function(e){!1===e.result&&(e.result=void 0)}))})),i.none.forEach((function(e){!0===e.result&&(e.result=void 0)}))))})),a.performanceTimer&&this._logRulePerformance(),n},Ms.prototype._trackPerformance=function(){this._markStart="mark_rule_start_"+this.id,this._markEnd="mark_rule_end_"+this.id,this._markChecksStart="mark_runchecks_start_"+this.id,this._markChecksEnd="mark_runchecks_end_"+this.id},Ms.prototype._logGatherPerformance=function(e){vt("gather (",e.length,"):",wo.timeElapsed()+"ms"),wo.mark(this._markChecksStart)},Ms.prototype._logRulePerformance=function(){wo.mark(this._markChecksEnd),wo.mark(this._markEnd),wo.measure("runchecks_"+this.id,this._markChecksStart,this._markChecksEnd),wo.measure("rule_"+this.id,this._markStart,this._markEnd)},Ms.prototype.gatherAndMatchNodes=function(e,t){var a=this,r="mark_matches_start_"+this.id,n="mark_matches_end_"+this.id,o=this.gather(e,t);return t.performanceTimer&&wo.mark(r),o=o.filter((function(t){return a.matches(t.actualNode,t,e)})),t.performanceTimer&&(wo.mark(n),wo.measure("rule_"+this.id+"#matches",r,n)),o},Ms.prototype.after=function(e,t){var a,r,n,o=dr(a=this).map((function(e){return(e=a._audit.checks[e.id||e])&&"function"==typeof e.after?e:null})).filter(Boolean),i=this.id;return o.forEach((function(a){var r,n,o=(l=e.nodes,r=a.id,n=[],l.forEach((function(e){dr(e).forEach((function(t){t.id===r&&(t.node=e.node,n.push(t))}))})),n),l=Xn(a,i,t),s=a.after(o,l);o.forEach((function(e){delete e.node,-1===s.indexOf(e)&&(e.filtered=!0)}))})),e.nodes=(n=["any","all","none"],o=(r=e).nodes.filter((function(e){var t=0;return n.forEach((function(a){e[a]=e[a].filter((function(e){return!0!==e.filtered})),t+=e[a].length})),0<t})),o=r.pageLevel&&o.length?[o.reduce((function(e,t){if(e)return n.forEach((function(a){e[a].push.apply(e[a],t[a])})),e}))]:o),e},Ms.prototype.configure=function(e){e.hasOwnProperty("selector")&&(this.selector=e.selector),e.hasOwnProperty("excludeHidden")&&(this.excludeHidden="boolean"!=typeof e.excludeHidden||e.excludeHidden),e.hasOwnProperty("enabled")&&(this.enabled="boolean"!=typeof e.enabled||e.enabled),e.hasOwnProperty("pageLevel")&&(this.pageLevel="boolean"==typeof e.pageLevel&&e.pageLevel),e.hasOwnProperty("reviewOnFail")&&(this.reviewOnFail="boolean"==typeof e.reviewOnFail&&e.reviewOnFail),e.hasOwnProperty("any")&&(this.any=e.any),e.hasOwnProperty("all")&&(this.all=e.all),e.hasOwnProperty("none")&&(this.none=e.none),e.hasOwnProperty("tags")&&(this.tags=e.tags),e.hasOwnProperty("matches")&&(this.matches=Ps(e.matches)),e.impact&&(Ft(yt.impact.includes(e.impact),"Impact ".concat(e.impact," is not a valid impact")),this.impact=e.impact)};var Us=Ms,Vs=_(ft()),Hs=/\\{\\{.+?\\}\\}/g;function zs(){return t.origin||(t.location&&t.location.origin?t.location.origin:void 0)}function $s(e,t,a){for(var r=0,n=e.length;r<n;r++)t[a](e[r])}function Ws(e){w(this,Ws),this.lang="en",this.defaultConfig=e,this.standards=En,this._init(),this._defaultLocale=null}function Gs(e,t,a){return a.performanceTimer&&wo.mark("mark_rule_start_"+e.id),function(r,n){e.run(t,a,(function(e){r(e)}),(function(t){a.debug?n(t):(t=Object.assign(new qs(e),{result:yt.CANTTELL,description:"An error occured while running this rule",message:t.message,stack:t.stack,error:t,errorNode:t.errorNode}),r(t))}))}}function Ys(e,t,a){var r=e.brand,n=e.application;e=e.lang;return yt.helpUrlBase+r+"/"+(a||o.version.substring(0,o.version.lastIndexOf(".")))+"/"+t+"?application="+encodeURIComponent(n)+(e&&"en"!==e?"&lang="+encodeURIComponent(e):"")}var Ks=(E(Ws,[{key:"_setDefaultLocale",value:function(){if(!this._defaultLocale){for(var e={checks:{},rules:{},failureSummaries:{},incompleteFallbackMessage:"",lang:this.lang},t=Object.keys(this.data.checks),a=0;a<t.length;a++){var r=t[a],n=(i=this.data.checks[r].messages).pass,o=i.fail,i=i.incomplete;e.checks[r]={pass:n,fail:o,incomplete:i}}for(var l=Object.keys(this.data.rules),s=0;s<l.length;s++){var u=l[s],c=(d=this.data.rules[u]).description,d=d.help;e.rules[u]={description:c,help:d}}for(var p=Object.keys(this.data.failureSummaries),f=0;f<p.length;f++){var m=p[f],h=this.data.failureSummaries[m].failureMessage;e.failureSummaries[m]={failureMessage:h}}e.incompleteFallbackMessage=this.data.incompleteFallbackMessage,this._defaultLocale=e}}},{key:"_resetLocale",value:function(){var e=this._defaultLocale;e&&this.applyLocale(e)}},{key:"_applyCheckLocale",value:function(e){for(var t,a,r,o=Object.keys(e),i=0;i<o.length;i++){var l=o[i];if(!this.data.checks[l])throw new Error(\'Locale provided for unknown check: "\'.concat(l,\'"\'));this.data.checks[l]=(t=this.data.checks[l],a=e[l],l=r=void 0,r=a.pass,l=a.fail,"string"==typeof r&&Hs.test(r)&&(r=Vs.default.compile(r)),"string"==typeof l&&Hs.test(l)&&(l=Vs.default.compile(l)),D({},t,{messages:{pass:r||t.messages.pass,fail:l||t.messages.fail,incomplete:"object"===n(t.messages.incomplete)?D({},t.messages.incomplete,a.incomplete):a.incomplete}}))}}},{key:"_applyRuleLocale",value:function(e){for(var t,a,r=Object.keys(e),n=0;n<r.length;n++){var o=r[n];if(!this.data.rules[o])throw new Error(\'Locale provided for unknown rule: "\'.concat(o,\'"\'));this.data.rules[o]=(t=this.data.rules[o],a=e[o],o=void 0,o=a.help,a=a.description,"string"==typeof o&&Hs.test(o)&&(o=Vs.default.compile(o)),"string"==typeof a&&Hs.test(a)&&(a=Vs.default.compile(a)),D({},t,{help:o||t.help,description:a||t.description}))}}},{key:"_applyFailureSummaries",value:function(e){for(var t=Object.keys(e),a=0;a<t.length;a++){var r=t[a];if(!this.data.failureSummaries[r])throw new Error(\'Locale provided for unknown failureMessage: "\'.concat(r,\'"\'));this.data.failureSummaries[r]=function(e,t){return D({},e,{failureMessage:(t="string"==typeof(t=t.failureMessage)&&Hs.test(t)?Vs.default.compile(t):t)||e.failureMessage})}(this.data.failureSummaries[r],e[r])}}},{key:"applyLocale",value:function(e){var t,a;this._setDefaultLocale(),e.checks&&this._applyCheckLocale(e.checks),e.rules&&this._applyRuleLocale(e.rules),e.failureSummaries&&this._applyFailureSummaries(e.failureSummaries,"failureSummaries"),e.incompleteFallbackMessage&&(this.data.incompleteFallbackMessage=(t=this.data.incompleteFallbackMessage,(a="string"==typeof(a=e.incompleteFallbackMessage)&&Hs.test(a)?Vs.default.compile(a):a)||t)),e.lang&&(this.lang=e.lang)}},{key:"setAllowedOrigins",value:function(e){var t=zs();this.allowedOrigins=[];var a,r=A(e);try{for(r.s();!(a=r.n()).done;){var n=a.value;if(n===yt.allOrigins)return void(this.allowedOrigins=["*"]);n!==yt.sameOrigin?this.allowedOrigins.push(n):t&&this.allowedOrigins.push(t)}}catch(e){r.e(e)}finally{r.f()}}},{key:"_init",value:function(){var e,t=((e=this.defaultConfig)?(t=Ha(e)).commons=e.commons:t={},t.reporter=t.reporter||null,t.noHtml=t.noHtml||!1,t.allowedOrigins||(e=zs(),t.allowedOrigins=e?[e]:[]),t.rules=t.rules||[],t.checks=t.checks||[],t.data=D({checks:{},rules:{}},t.data),t);this.lang=t.lang||"en",this.reporter=t.reporter,this.commands={},this.rules=[],this.checks={},this.brand="axe",this.application="axeAPI",this.tagExclude=["experimental"],this.noHtml=t.noHtml,this.allowedOrigins=t.allowedOrigins,$s(t.rules,this,"addRule"),$s(t.checks,this,"addCheck"),this.data={},this.data.checks=t.data&&t.data.checks||{},this.data.rules=t.data&&t.data.rules||{},this.data.failureSummaries=t.data&&t.data.failureSummaries||{},this.data.incompleteFallbackMessage=t.data&&t.data.incompleteFallbackMessage||"",this._constructHelpUrls()}},{key:"registerCommand",value:function(e){this.commands[e.id]=e.callback}},{key:"addRule",value:function(e){e.metadata&&(this.data.rules[e.id]=e.metadata);var t=this.getRule(e.id);t?t.configure(e):this.rules.push(new Us(e,this))}},{key:"addCheck",value:function(e){var t=e.metadata;"object"===n(t)&&(this.data.checks[e.id]=t,"object"===n(t.messages)&&Object.keys(t.messages).filter((function(e){return t.messages.hasOwnProperty(e)&&"string"==typeof t.messages[e]})).forEach((function(e){0===t.messages[e].indexOf("function")&&(t.messages[e]=new Function("return "+t.messages[e]+";")())}))),this.checks[e.id]?this.checks[e.id].configure(e):this.checks[e.id]=new Ls(e)}},{key:"run",value:function(e,t,a,r){this.normalizeOptions(t),o._selectCache=[];var n,i,l=(s=this.rules,n=e,i=t,s.reduce((function(e,t){return Mo(t,n,i)&&(t.preload?e.later:e.now).push(t),e}),{now:[],later:[]})),s=l.now,u=l.later,c=or();s.forEach((function(a){c.defer(Gs(a,e,t))})),l=or(),u.length&&l.defer((function(e){Po(t).then((function(t){return e(t)})).catch((function(t){console.warn("Couldn\'t load preload assets: ",t),e(void 0)}))})),(s=or()).defer(c),s.defer(l),s.then((function(n){var i=n.pop();i&&i.length&&(i=i[0])&&(e=D({},e,i));var l=n[0];if(!u.length)return o._selectCache=void 0,void a(l.filter((function(e){return!!e})));var s=or();u.forEach((function(a){a=Gs(a,e,t),s.defer(a)})),s.then((function(e){o._selectCache=void 0,a(l.concat(e).filter((function(e){return!!e})))})).catch(r)})).catch(r)}},{key:"after",value:function(e,t){var a=this.rules;return e.map((function(e){var r=pr(a,"id",e.id);if(!r)throw new Error("Result for unknown rule. You may be running mismatch axe-core versions");return r.after(e,t)}))}},{key:"getRule",value:function(e){return this.rules.find((function(t){return t.id===e}))}},{key:"normalizeOptions",value:function(e){var t=[],a=[];if(this.rules.forEach((function(e){a.push(e.id),e.tags.forEach((function(e){t.includes(e)||t.push(e)}))})),"object"===n(e.runOnly)){if(Array.isArray(e.runOnly)){var r=e.runOnly.find((function(e){return t.includes(e)})),o=e.runOnly.find((function(e){return a.includes(e)}));if(r&&o)throw new Error("runOnly cannot be both rules and tags");e.runOnly=o?{type:"rule",values:e.runOnly}:{type:"tag",values:e.runOnly}}if((o=e.runOnly).value&&!o.values&&(o.values=o.value,delete o.value),!Array.isArray(o.values)||0===o.values.length)throw new Error("runOnly.values must be a non-empty array");if(["rule","rules"].includes(o.type))o.type="rule",o.values.forEach((function(e){if(!a.includes(e))throw new Error("unknown rule `"+e+"` in options.runOnly")}));else{if(!["tag","tags",void 0].includes(o.type))throw new Error("Unknown runOnly type \'".concat(o.type,"\'"));o.type="tag",0!==(o=o.values.filter((function(e){return!t.includes(e)}))).length&&vt("Could not find tags `"+o.join("`, `")+"`")}}return"object"===n(e.rules)&&Object.keys(e.rules).forEach((function(e){if(!a.includes(e))throw new Error("unknown rule `"+e+"` in options.rules")})),e}},{key:"setBranding",value:function(e){var t={brand:this.brand,application:this.application};e&&e.hasOwnProperty("brand")&&e.brand&&"string"==typeof e.brand&&(this.brand=e.brand),e&&e.hasOwnProperty("application")&&e.application&&"string"==typeof e.application&&(this.application=e.application),this._constructHelpUrls(t)}},{key:"_constructHelpUrls",value:function(){var e=this,t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:null,a=(o.version.match(/^[1-9][0-9]*\\.[0-9]+/)||["x.y"])[0];this.rules.forEach((function(r){e.data.rules[r.id]||(e.data.rules[r.id]={});var n=e.data.rules[r.id];("string"!=typeof n.helpUrl||t&&n.helpUrl===Ys(t,r.id,a))&&(n.helpUrl=Ys(e,r.id,a))}))}},{key:"resetRulesAndChecks",value:function(){this._init(),this._resetLocale()}}]),Ws);function Xs(e,a){for(var n,o,i=[],l=0,s=e[a].length;l<s;l++){if("string"==typeof(n=e[a][l])){o=Array.from(r.querySelectorAll(n)),i=i.concat(o.map((function(e){return Ma(e)})));break}!n||!n.length||n instanceof t.Node?n instanceof t.Node&&(n.documentElement instanceof t.Node?i.push(e.flatTree[0]):i.push(Ma(n))):1<n.length?function(e,t,a){var n;e.frames=e.frames||[];var o=r.querySelectorAll(a.shift());e:for(var i=0,l=o.length;i<l;i++){for(var s=o[i],u=0,c=e.frames.length;u<c;u++)if(e.frames[u].node===s){e.frames[u][t].push(a);break e}n={node:s,include:[],exclude:[]},a&&n[t].push(a),e.frames.push(n)}}(e,a,n):(o=Array.from(r.querySelectorAll(n[0])),i=i.concat(o.map((function(e){return Ma(e)}))))}return i.filter((function(e){return e}))}var Js,Qs=function(e){var a=this;if(this.frames=[],this.initiator=!e||"boolean"!=typeof e.initiator||e.initiator,this.focusable=!e||"boolean"!=typeof e.focusable||e.focusable,this.boundingClientRect=e&&"object"===n(e.boundingClientRect)?e.boundingClientRect:{},this.page=!1,e=function(e){if(e&&"object"===n(e)||e instanceof t.NodeList){if(e instanceof t.Node)return{include:[e],exclude:[]};if(e.hasOwnProperty("include")||e.hasOwnProperty("exclude"))return{include:e.include&&+e.include.length?e.include:[r],exclude:e.exclude||[]};if(e.length===+e.length)return{include:e,exclude:[]}}return"string"==typeof e?{include:[e],exclude:[]}:{include:[r],exclude:[]}}(e),this.flatTree=Mn(function(e){for(var a=e.include,n=(e=e.exclude,Array.from(a).concat(Array.from(e))),o=0;o<n.length;++o){var i=n[o];if(i instanceof t.Element)return i.ownerDocument.documentElement;if(i instanceof t.Document)return i.documentElement}return r.documentElement}(e)),this.exclude=e.exclude,this.include=e.include,this.include=Xs(this,"include"),this.exclude=Xs(this,"exclude"),Uo("frame, iframe",this).forEach((function(e){var t;so(e,a)&&(t=a.frames,e=e.actualNode,no(e)||pr(t,"node",e)||t.push({node:e,include:[],exclude:[]}))})),1===this.include.length&&this.include[0].actualNode===r.documentElement&&(this.page=!0),(e=function(e){if(0===e.include.length){if(0===e.frames.length){var t=lr.isInFrame()?"frame":"page";return new Error("No elements found for include in "+t+" Context")}e.frames.forEach((function(e,t){if(0===e.include.length)return new Error("No elements found for include in Context of frame "+t)}))}}(this))instanceof Error)throw e;Array.isArray(this.include)||(this.include=Array.from(this.include)),this.include.sort(mo)};N(Js={},{CssSelectorParser:function(){return Zs.CssSelectorParser},doT:function(){return eu.default},emojiRegexText:function(){return tu.default},memoize:function(){return au.default}});var Zs=_(I()),eu=_(ft()),tu=_(pt()),au=_(dt()),ru=_(mt());Tl=_(ht());_(gt()),"Promise"in t||ru.default.polyfill(),"Uint32Array"in t||(t.Uint32Array=Tl.Uint32Array),t.Uint32Array&&("some"in t.Uint32Array.prototype||Object.defineProperty(t.Uint32Array.prototype,"some",{value:Array.prototype.some}),"reduce"in t.Uint32Array.prototype||Object.defineProperty(t.Uint32Array.prototype,"reduce",{value:Array.prototype.reduce}));var nu,ou=function(e,t){if(e=e||function(){},t=t||o.log,!o._audit)throw new Error("No audit configured");var a=o.utils.queue(),n=[];Object.keys(o.plugins).forEach((function(e){a.defer((function(t){function a(e){n.push(e),t()}try{o.plugins[e].cleanup(t,a)}catch(e){a(e)}}))}));var i=o.utils.getFlattenedTree(r.body);o.utils.querySelectorAll(i,"iframe, frame").forEach((function(e){a.defer((function(t,a){return o.utils.sendCommandToFrame(e.actualNode,{command:"cleanup-plugin"},t,a)}))})),a.then((function(a){0===n.length?e(a):t(n)})).catch(t)},iu={};function lu(e){return iu.hasOwnProperty(e)}function su(e){return"string"==typeof e&&iu[e]?iu[e]:"function"==typeof e?e:nu}Rl=function(e){var t=o._audit;if(!t)throw new Error("No audit configured");if(e.axeVersion||e.ver){var a=e.axeVersion||e.ver;if(!/^\\d+\\.\\d+\\.\\d+(-canary)?/.test(a))throw new Error("Invalid configured version ".concat(a));var r=(u=v(a.split("-"),2))[0],n=u[1],i=(d=v(r.split(".").map(Number),3))[0],l=d[1],s=d[2],u=(c=v(o.version.split("-"),2))[0],c=(r=c[1],(d=v(u.split(".").map(Number),3))[0]),d=(u=d[1],d[2]);if(i!==c||u<l||u===l&&d<s||i===c&&l===u&&s===d&&n&&n!==r)throw new Error("Configured version ".concat(a," is not compatible with current axe version ").concat(o.version))}if(e.reporter&&("function"==typeof e.reporter||lu(e.reporter))&&(t.reporter=e.reporter),e.checks){if(!Array.isArray(e.checks))throw new TypeError("Checks property must be an array");e.checks.forEach((function(e){if(!e.id)throw new TypeError("Configured check ".concat(JSON.stringify(e)," is invalid. Checks must be an object with at least an id property"));t.addCheck(e)}))}var p,f=[];if(e.rules){if(!Array.isArray(e.rules))throw new TypeError("Rules property must be an array");e.rules.forEach((function(e){if(!e.id)throw new TypeError("Configured rule ".concat(JSON.stringify(e)," is invalid. Rules must be an object with at least an id property"));f.push(e.id),t.addRule(e)}))}if(e.disableOtherRules&&t.rules.forEach((function(e){!1===f.includes(e.id)&&(e.enabled=!1)})),void 0!==e.branding?t.setBranding(e.branding):t._constructHelpUrls(),e.tagExclude&&(t.tagExclude=e.tagExclude),e.locale&&t.applyLocale(e.locale),e.standards&&(p=e.standards,Object.keys(xn).forEach((function(e){p[e]&&(xn[e]=br(xn[e],p[e]))}))),e.noHtml&&(t.noHtml=!0),e.allowedOrigins){if(!Array.isArray(e.allowedOrigins))throw new TypeError("Allowed origins property must be an array");if(e.allowedOrigins.includes("*"))throw new Error(\'"*" is not allowed. Use "\'.concat(yt.allOrigins,\'" instead\'));t.setAllowedOrigins(e.allowedOrigins)}},Nl=function(e){var t=(e=e||[]).length?o._audit.rules.filter((function(t){return!!e.filter((function(e){return-1!==t.tags.indexOf(e)})).length})):o._audit.rules,a=o._audit.data.rules||{};return t.map((function(e){var t=a[e.id]||{};return{ruleId:e.id,description:t.description,help:t.help,helpUrl:t.helpUrl,tags:e.tags}}))};var uu=function(){qa.get("globalDocumentSet")&&(r=null),qa.get("globalWindowSet")&&(t=null),o._memoizedFns.forEach((function(e){return e.clear()})),qa.clear(),o._tree=void 0,o._selectorData=void 0,o._selectCache=void 0},cu=function(e,t,a,r){try{e=new Qs(e),o._tree=e.flatTree,o._selectorData=Ta(e.flatTree)}catch(n){return uu(),r(n)}var n=or(),i=o._audit;t.performanceTimer&&wo.auditStart(),e.frames.length&&!1!==t.iframes&&n.defer((function(a,r){hr(e,t,"rules",null,a,r)})),n.defer((function(a,r){i.run(e,t,a,r)})),n.then((function(n){try{t.performanceTimer&&wo.auditEnd();var o=mr(n.map((function(e){return{results:e}})));e.initiator&&((o=i.after(o,t)).forEach(Bo),o=o.map(ua));try{a(o,uu)}catch(n){uu(),vt(n)}}catch(n){uu(),r(n)}})).catch((function(e){uu(),r(e)}))};function du(e){this._run=e.run,this._collect=e.collect,this._registry={},e.commands.forEach((function(e){o._audit.registerCommand(e)}))}t.top!==t&&(lr.subscribe("axe.start",(function(e,t,a){function n(e){e instanceof Error==0&&(e=new Error(e)),a(e)}var i=a,l=e&&e.context||{};l.hasOwnProperty("include")&&!l.include.length&&(l.include=[r]);var s=e&&e.options||{};switch(e.command){case"rules":return cu(l,s,(function(e,t){i(e),t()}),n);case"cleanup-plugin":return ou(i,n);default:if(o._audit&&o._audit.commands&&o._audit.commands[e.command])return o._audit.commands[e.command](e,a)}})),lr.subscribe("axe.ping",(function(e,t,a){a({axe:!0})}))),N=function(e){o._audit=new Ks(e)},du.prototype.run=function(){return this._run.apply(this,arguments)},du.prototype.collect=function(){return this._collect.apply(this,arguments)},du.prototype.cleanup=function(e){var t=o.utils.queue(),a=this;Object.keys(this._registry).forEach((function(e){t.defer((function(t){a._registry[e].cleanup(t)}))})),t.then(e)},du.prototype.add=function(e){this._registry[e.id]=e},I=function(e){o.plugins[e.id]=new du(e)},ft=function(){var e=o._audit;if(!e)throw new Error("No audit configured");e.resetRulesAndChecks(),Object.keys(xn).forEach((function(e){xn[e]=wn[e]}))},pt=function(e,t){var a=2<arguments.length&&void 0!==arguments[2]?arguments[2]:{};a.reporter=a.reporter||o._audit.reporter||"v1",o._selectorData={},t instanceof xt||(t=new Yo(t));var r=Jn(e);if(!r)throw new Error("unknown rule `"+e+"`");return r=(r=Object.create(r,{excludeHidden:{value:!1}})).runSync({initiator:!0,include:[t]},a),Bo(r),ua(r),(r=pa([r])).violations.forEach((function(e){return e.nodes.forEach((function(e){e.failureSummary=Un(e)}))})),D({},Vn(),r,{toolOptions:a})};var pu=function(){};dt=function(e,a,i){if(!o._audit)throw new Error("No audit configured");var l=!!r;if(!(u=t&&"Node"in t&&"NodeList"in t)||!l){if(!e||!e.ownerDocument)throw new Error(\'Required "window" or "document" globals not defined and cannot be deduced from the context. Either set the globals before running or pass in a valid Element.\');l||(qa.set("globalDocumentSet",!0),r=e.ownerDocument),u||(qa.set("globalWindowSet",!0),t=r.defaultView)}var s,u=function(e,a,o){var i=new TypeError("axe.run arguments are invalid");if(!function(e){switch(!0){case"string"==typeof e:case Array.isArray(e):case t.Node&&e instanceof t.Node:case t.NodeList&&e instanceof t.NodeList:return 1;case"object"!==n(e):return;case void 0!==e.include:case void 0!==e.exclude:case"number"==typeof e.length:return 1;default:return}}(e)){if(void 0!==o)throw i;o=a,a=e,e=r}if("object"!==n(a)){if(void 0!==o)throw i;o=a,a={}}if("function"!=typeof o&&void 0!==o)throw i;return{context:e,options:a,callback:o||pu}}(e,a,i);e=u.context,a=u.options,i=u.callback,a.reporter=a.reporter||o._audit.reporter||"v1",a.performanceTimer&&o.utils.performanceTimer.start();var c=pu,d=pu;return"function"==typeof Promise&&i===pu&&(s=new Promise((function(e,t){c=t,d=e}))),o._running?(i(u="Axe is already running. Use `await axe.run()` to wait for the previous run to finish before starting a new run."),c(u),s):(o._running=!0,o._runRules(e,a,(function(e,t){function r(e){o._running=!1,t();try{i(null,e)}catch(e){o.log(e)}d(e)}a.performanceTimer&&o.utils.performanceTimer.end();try{var n=su(a.reporter)(e,a,r);void 0!==n&&r(n)}catch(e){o._running=!1,t(),i(e),c(e)}}),(function(e){o._running=!1,i(e),c(e)})),s)};mt=function(e){if(o._tree)throw new Error("Axe is already setup. Call `axe.teardown()` before calling `axe.setup` again.");return o._tree=Mn(e),o._selectorData=Ta(o._tree),o._tree[0]},ht=function(e,t,a){console.warn(\'"na" reporter will be deprecated in axe v4.0. Use the "v2" reporter instead.\'),"function"==typeof t&&(a=t,t={}),e=$n(e,t),a(D({},Vn(),{toolOptions:t,violations:e.violations,passes:e.passes,incomplete:e.incomplete,inapplicable:e.inapplicable}))},_=function(e,t,a){"function"==typeof t&&(a=t,t={}),t.resultTypes=["violations"],e=$n(e,t),a(D({},Vn(),{toolOptions:t,violations:e.violations}))};var fu=function(e,t,a){if("function"==typeof t&&(a=t,t={}),!e||!Array.isArray(e))return a(e);a(e.map((function(e){for(var t=D({},e),a=0,r=["passes","violations","incomplete","inapplicable"];a<r.length;a++){var n=r[a];t[n]&&Array.isArray(t[n])&&(t[n]=t[n].map((function(e){return D({},e,{node:e.node.toJSON()})})))}return t})))};gt=function(e,t,a){"function"==typeof t&&(a=t,t={}),fu(e,t,(function(e){var t=Vn();a({raw:e,env:t})}))},ru=function(e,t,a){"function"==typeof t&&(a=t,t={});var r=$n(e,t);e=function(e){e.nodes.forEach((function(e){e.failureSummary=Un(e)}))};r.incomplete.forEach(e),r.violations.forEach(e),a(D({},Vn(),{toolOptions:t,violations:r.violations,passes:r.passes,incomplete:r.incomplete,inapplicable:r.inapplicable}))},Tl=function(e,t,a){"function"==typeof t&&(a=t,t={}),e=$n(e,t),a(D({},Vn(),{toolOptions:t,violations:e.violations,passes:e.passes,incomplete:e.incomplete,inapplicable:e.inapplicable}))};o.constants=yt,o.log=vt,o.AbstractVirtualNode=xt,o.SerialVirtualNode=Yo,o.VirtualNode=Ln,o._cache=qa,o._thisWillBeDeletedDoNotUse=o._thisWillBeDeletedDoNotUse||{},o._thisWillBeDeletedDoNotUse.base={Audit:Ks,CheckResult:Ss,Check:Ls,Context:Qs,RuleResult:qs,Rule:Us,metadataFunctionMap:Os},o.imports=Js,o.cleanup=ou,o.configure=Rl,o.frameMessenger=function(e){lr.updateMessenger(e)},o.getRules=Nl,o._load=N,o.plugins={},o.registerPlugin=I,o.hasReporter=lu,o.getReporter=su,o.addReporter=function(e,t,a){iu[e]=t,a&&(nu=t)},o.reset=ft,o._runRules=cu,o.runVirtualRule=pt,o.run=dt,o.setup=mt,o.teardown=uu,o.commons=bi,o.utils=Et,o.addReporter("na",ht),o.addReporter("no-passes",_),o.addReporter("rawEnv",gt),o.addReporter("raw",fu),o.addReporter("v1",ru),o.addReporter("v2",Tl,!0)}(),o._load({lang:"en",data:{rules:{accesskeys:{description:"Ensures every accesskey attribute value is unique",help:"accesskey attribute value should be unique"},"area-alt":{description:"Ensures <area> elements of image maps have alternate text",help:"Active <area> elements must have alternate text"},"aria-allowed-attr":{description:"Ensures ARIA attributes are allowed for an element\'s role",help:"Elements must only use allowed ARIA attributes"},"aria-allowed-role":{description:"Ensures role attribute has an appropriate value for the element",help:"ARIA role should be appropriate for the element"},"aria-command-name":{description:"Ensures every ARIA button, link and menuitem has an accessible name",help:"ARIA commands must have an accessible name"},"aria-dialog-name":{description:"Ensures every ARIA dialog and alertdialog node has an accessible name",help:"ARIA dialog and alertdialog nodes should have an accessible name"},"aria-hidden-body":{description:"Ensures aria-hidden=\'true\' is not present on the document body.",help:"aria-hidden=\'true\' must not be present on the document body"},"aria-hidden-focus":{description:"Ensures aria-hidden elements do not contain focusable elements",help:"ARIA hidden element must not contain focusable elements"},"aria-input-field-name":{description:"Ensures every ARIA input field has an accessible name",help:"ARIA input fields must have an accessible name"},"aria-meter-name":{description:"Ensures every ARIA meter node has an accessible name",help:"ARIA meter nodes must have an accessible name"},"aria-progressbar-name":{description:"Ensures every ARIA progressbar node has an accessible name",help:"ARIA progressbar nodes must have an accessible name"},"aria-required-attr":{description:"Ensures elements with ARIA roles have all required ARIA attributes",help:"Required ARIA attributes must be provided"},"aria-required-children":{description:"Ensures elements with an ARIA role that require child roles contain them",help:"Certain ARIA roles must contain particular children"},"aria-required-parent":{description:"Ensures elements with an ARIA role that require parent roles are contained by them",help:"Certain ARIA roles must be contained by particular parents"},"aria-roledescription":{description:"Ensure aria-roledescription is only used on elements with an implicit or explicit role",help:"Use aria-roledescription on elements with a semantic role"},"aria-roles":{description:"Ensures all elements with a role attribute use a valid value",help:"ARIA roles used must conform to valid values"},"aria-text":{description:\'Ensures "role=text" is used on elements with no focusable descendants\',help:\'"role=text" should have no focusable descendants\'},"aria-toggle-field-name":{description:"Ensures every ARIA toggle field has an accessible name",help:"ARIA toggle fields have an accessible name"},"aria-tooltip-name":{description:"Ensures every ARIA tooltip node has an accessible name",help:"ARIA tooltip nodes must have an accessible name"},"aria-treeitem-name":{description:"Ensures every ARIA treeitem node has an accessible name",help:"ARIA treeitem nodes should have an accessible name"},"aria-valid-attr-value":{description:"Ensures all ARIA attributes have valid values",help:"ARIA attributes must conform to valid values"},"aria-valid-attr":{description:"Ensures attributes that begin with aria- are valid ARIA attributes",help:"ARIA attributes must conform to valid names"},"audio-caption":{description:"Ensures <audio> elements have captions",help:"<audio> elements must have a captions track"},"autocomplete-valid":{description:"Ensure the autocomplete attribute is correct and suitable for the form field",help:"autocomplete attribute must be used correctly"},"avoid-inline-spacing":{description:"Ensure that text spacing set through style attributes can be adjusted with custom stylesheets",help:"Inline text spacing must be adjustable with custom stylesheets"},blink:{description:"Ensures <blink> elements are not used",help:"<blink> elements are deprecated and must not be used"},"button-name":{description:"Ensures buttons have discernible text",help:"Buttons must have discernible text"},bypass:{description:"Ensures each page has at least one mechanism for a user to bypass navigation and jump straight to the content",help:"Page must have means to bypass repeated blocks"},"color-contrast":{description:"Ensures the contrast between foreground and background colors meets WCAG 2 AA contrast ratio thresholds",help:"Elements must have sufficient color contrast"},"css-orientation-lock":{description:"Ensures content is not locked to any specific display orientation, and the content is operable in all display orientations",help:"CSS Media queries are not used to lock display orientation"},"definition-list":{description:"Ensures <dl> elements are structured correctly",help:"<dl> elements must only directly contain properly-ordered <dt> and <dd> groups, <script>, <template> or <div> elements"},dlitem:{description:"Ensures <dt> and <dd> elements are contained by a <dl>",help:"<dt> and <dd> elements must be contained by a <dl>"},"document-title":{description:"Ensures each HTML document contains a non-empty <title> element",help:"Documents must have <title> element to aid in navigation"},"duplicate-id-active":{description:"Ensures every id attribute value of active elements is unique",help:"IDs of active elements must be unique"},"duplicate-id-aria":{description:"Ensures every id attribute value used in ARIA and in labels is unique",help:"IDs used in ARIA and labels must be unique"},"duplicate-id":{description:"Ensures every id attribute value is unique",help:"id attribute value must be unique"},"empty-heading":{description:"Ensures headings have discernible text",help:"Headings should not be empty"},"empty-table-header":{description:"Ensures table headers have discernible text",help:"Table header text must not be empty"},"focus-order-semantics":{description:"Ensures elements in the focus order have an appropriate role",help:"Elements in the focus order need a role appropriate for interactive content"},"form-field-multiple-labels":{description:"Ensures form field does not have multiple label elements",help:"Form field must not have multiple label elements"},"frame-focusable-content":{description:"Ensures <frame> and <iframe> elements with focusable content do not have tabindex=-1",help:"Frames with focusable content must not have tabindex=-1"},"frame-tested":{description:"Ensures <iframe> and <frame> elements contain the axe-core script",help:"Frames should be tested with axe-core"},"frame-title-unique":{description:"Ensures <iframe> and <frame> elements contain a unique title attribute",help:"Frames should have a unique title attribute"},"frame-title":{description:"Ensures <iframe> and <frame> elements have an accessible name",help:"Frames must have an accessible name"},"heading-order":{description:"Ensures the order of headings is semantically correct",help:"Heading levels should only increase by one"},"hidden-content":{description:"Informs users about hidden content.",help:"Hidden content on the page cannot be analyzed"},"html-has-lang":{description:"Ensures every HTML document has a lang attribute",help:"<html> element must have a lang attribute"},"html-lang-valid":{description:"Ensures the lang attribute of the <html> element has a valid value",help:"<html> element must have a valid value for the lang attribute"},"html-xml-lang-mismatch":{description:"Ensure that HTML elements with both valid lang and xml:lang attributes agree on the base language of the page",help:"HTML elements with lang and xml:lang must have the same base language"},"identical-links-same-purpose":{description:"Ensure that links with the same accessible name serve a similar purpose",help:"Links with the same name have a similar purpose"},"image-alt":{description:"Ensures <img> elements have alternate text or a role of none or presentation",help:"Images must have alternate text"},"image-redundant-alt":{description:"Ensure image alternative is not repeated as text",help:"Alternative text of images should not be repeated as text"},"input-button-name":{description:"Ensures input buttons have discernible text",help:"Input buttons must have discernible text"},"input-image-alt":{description:\'Ensures <input type="image"> elements have alternate text\',help:"Image buttons must have alternate text"},"label-content-name-mismatch":{description:"Ensures that elements labelled through their content must have their visible text as part of their accessible name",help:"Elements must have their visible text as part of their accessible name"},"label-title-only":{description:"Ensures that every form element is not solely labeled using the title or aria-describedby attributes",help:"Form elements should have a visible label"},label:{description:"Ensures every form element has a label",help:"Form elements must have labels"},"landmark-banner-is-top-level":{description:"Ensures the banner landmark is at top level",help:"Banner landmark should not be contained in another landmark"},"landmark-complementary-is-top-level":{description:"Ensures the complementary landmark or aside is at top level",help:"Aside should not be contained in another landmark"},"landmark-contentinfo-is-top-level":{description:"Ensures the contentinfo landmark is at top level",help:"Contentinfo landmark should not be contained in another landmark"},"landmark-main-is-top-level":{description:"Ensures the main landmark is at top level",help:"Main landmark should not be contained in another landmark"},"landmark-no-duplicate-banner":{description:"Ensures the document has at most one banner landmark",help:"Document should not have more than one banner landmark"},"landmark-no-duplicate-contentinfo":{description:"Ensures the document has at most one contentinfo landmark",help:"Document should not have more than one contentinfo landmark"},"landmark-no-duplicate-main":{description:"Ensures the document has at most one main landmark",help:"Document should not have more than one main landmark"},"landmark-one-main":{description:"Ensures the document has a main landmark",help:"Document should have one main landmark"},"landmark-unique":{help:"Ensures landmarks are unique",description:"Landmarks should have a unique role or role/label/title (i.e. accessible name) combination"},"link-in-text-block":{description:"Links can be distinguished without relying on color",help:"Links must be distinguished from surrounding text in a way that does not rely on color"},"link-name":{description:"Ensures links have discernible text",help:"Links must have discernible text"},list:{description:"Ensures that lists are structured correctly",help:"<ul> and <ol> must only directly contain <li>, <script> or <template> elements"},listitem:{description:"Ensures <li> elements are used semantically",help:"<li> elements must be contained in a <ul> or <ol>"},marquee:{description:"Ensures <marquee> elements are not used",help:"<marquee> elements are deprecated and must not be used"},"meta-refresh":{description:\'Ensures <meta http-equiv="refresh"> is not used\',help:"Timed refresh must not exist"},"meta-viewport-large":{description:\'Ensures <meta name="viewport"> can scale a significant amount\',help:"Users should be able to zoom and scale the text up to 500%"},"meta-viewport":{description:\'Ensures <meta name="viewport"> does not disable text scaling and zooming\',help:"Zooming and scaling should not be disabled"},"nested-interactive":{description:"Nested interactive controls are not announced by screen readers",help:"Ensure interactive controls are not nested"},"no-autoplay-audio":{description:"Ensures <video> or <audio> elements do not autoplay audio for more than 3 seconds without a control mechanism to stop or mute the audio",help:"<video> or <audio> elements do not autoplay audio"},"object-alt":{description:"Ensures <object> elements have alternate text",help:"<object> elements must have alternate text"},"p-as-heading":{description:"Ensure p elements are not used to style headings",help:"Bold, italic text and font-size are not used to style p elements as a heading"},"page-has-heading-one":{description:"Ensure that the page, or at least one of its frames contains a level-one heading",help:"Page should contain a level-one heading"},"presentation-role-conflict":{description:"Flags elements whose role is none or presentation and which cause the role conflict resolution to trigger.",help:"Elements of role none or presentation should be flagged"},region:{description:"Ensures all page content is contained by landmarks",help:"All page content should be contained by landmarks"},"role-img-alt":{description:"Ensures [role=\'img\'] elements have alternate text",help:"[role=\'img\'] elements have an alternative text"},"scope-attr-valid":{description:"Ensures the scope attribute is used correctly on tables",help:"scope attribute should be used correctly"},"scrollable-region-focusable":{description:"Elements that have scrollable content must be accessible by keyboard",help:"Ensure that scrollable region has keyboard access"},"select-name":{description:"Ensures select element has an accessible name",help:"Select element must have an accessible name"},"server-side-image-map":{description:"Ensures that server-side image maps are not used",help:"Server-side image maps must not be used"},"skip-link":{description:"Ensure all skip links have a focusable target",help:"The skip-link target should exist and be focusable"},"svg-img-alt":{description:"Ensures svg elements with an img, graphics-document or graphics-symbol role have an accessible text",help:"svg elements with an img role have an alternative text"},tabindex:{description:"Ensures tabindex attribute values are not greater than 0",help:"Elements should not have tabindex greater than zero"},"table-duplicate-name":{description:"Ensure that tables do not have the same summary and caption",help:"The <caption> element should not contain the same text as the summary attribute"},"table-fake-caption":{description:"Ensure that tables with a caption use the <caption> element.",help:"Data or header cells must not be used to give caption to a data table."},"td-has-header":{description:"Ensure that each non-empty data cell in a large table has one or more table headers",help:"All non-empty td element in table larger than 3 by 3 must have an associated table header"},"td-headers-attr":{description:"Ensure that each cell in a table using the headers refers to another cell in that table",help:"All cells in a table element that use the headers attribute must only refer to other cells of that same table"},"th-has-data-cells":{description:"Ensure that each table header in a data table refers to data cells",help:"All th elements and elements with role=columnheader/rowheader must have data cells they describe"},"valid-lang":{description:"Ensures lang attributes have valid values",help:"lang attribute must have a valid value"},"video-caption":{description:"Ensures <video> elements have captions",help:"<video> elements must have captions"}},checks:{abstractrole:{impact:"serious",messages:{pass:"Abstract roles are not used",fail:{singular:"Abstract role cannot be directly used: ${data.values}",plural:"Abstract roles cannot be directly used: ${data.values}"}}},"aria-allowed-attr":{impact:"critical",messages:{pass:"ARIA attributes are used correctly for the defined role",fail:{singular:"ARIA attribute is not allowed: ${data.values}",plural:"ARIA attributes are not allowed: ${data.values}"}}},"aria-allowed-role":{impact:"minor",messages:{pass:"ARIA role is allowed for given element",fail:{singular:"ARIA role ${data.values} is not allowed for given element",plural:"ARIA roles ${data.values} are not allowed for given element"},incomplete:{singular:"ARIA role ${data.values} must be removed when the element is made visible, as it is not allowed for the element",plural:"ARIA roles ${data.values} must be removed when the element is made visible, as they are not allowed for the element"}}},"aria-errormessage":{impact:"critical",messages:{pass:"aria-errormessage exists and references elements visible to screen readers that use a supported aria-errormessage technique",fail:{singular:"aria-errormessage value `${data.values}` must use a technique to announce the message (e.g., aria-live, aria-describedby, role=alert, etc.)",plural:"aria-errormessage values `${data.values}` must use a technique to announce the message (e.g., aria-live, aria-describedby, role=alert, etc.)"},incomplete:{singular:"ensure aria-errormessage value `${data.values}` references an existing element",plural:"ensure aria-errormessage values `${data.values}` reference existing elements"}}},"aria-hidden-body":{impact:"critical",messages:{pass:"No aria-hidden attribute is present on document body",fail:"aria-hidden=true should not be present on the document body"}},"aria-prohibited-attr":{impact:"serious",messages:{pass:"ARIA attribute is allowed",fail:"ARIA attribute cannot be used, add a role attribute or use a different element: ${data.values}",incomplete:"ARIA attribute is not well supported on the element and the text content will be used instead: ${data.values}"}},"aria-required-attr":{impact:"critical",messages:{pass:"All required ARIA attributes are present",fail:{singular:"Required ARIA attribute not present: ${data.values}",plural:"Required ARIA attributes not present: ${data.values}"}}},"aria-required-children":{impact:"critical",messages:{pass:"Required ARIA children are present",fail:{singular:"Required ARIA child role not present: ${data.values}",plural:"Required ARIA children role not present: ${data.values}"},incomplete:{singular:"Expecting ARIA child role to be added: ${data.values}",plural:"Expecting ARIA children role to be added: ${data.values}"}}},"aria-required-parent":{impact:"critical",messages:{pass:"Required ARIA parent role present",fail:{singular:"Required ARIA parent role not present: ${data.values}",plural:"Required ARIA parents role not present: ${data.values}"}}},"aria-roledescription":{impact:"serious",messages:{pass:"aria-roledescription used on a supported semantic role",incomplete:"Check that the aria-roledescription is announced by supported screen readers",fail:"Give the element a role that supports aria-roledescription"}},"aria-unsupported-attr":{impact:"critical",messages:{pass:"ARIA attribute is supported",fail:"ARIA attribute is not widely supported in screen readers and assistive technologies: ${data.values}"}},"aria-valid-attr-value":{impact:"critical",messages:{pass:"ARIA attribute values are valid",fail:{singular:"Invalid ARIA attribute value: ${data.values}",plural:"Invalid ARIA attribute values: ${data.values}"},incomplete:{noId:"ARIA attribute element ID does not exist on the page: ${data.needsReview}",ariaCurrent:\'ARIA attribute value is invalid and will be treated as "aria-current=true": ${data.needsReview}\'}}},"aria-valid-attr":{impact:"critical",messages:{pass:"ARIA attribute name is valid",fail:{singular:"Invalid ARIA attribute name: ${data.values}",plural:"Invalid ARIA attribute names: ${data.values}"}}},fallbackrole:{impact:"serious",messages:{pass:"Only one role value used",fail:"Use only one role value, since fallback roles are not supported in older browsers"}},"has-global-aria-attribute":{impact:"minor",messages:{pass:{singular:"Element has global ARIA attribute: ${data.values}",plural:"Element has global ARIA attributes: ${data.values}"},fail:"Element does not have global ARIA attribute"}},"has-widget-role":{impact:"minor",messages:{pass:"Element has a widget role.",fail:"Element does not have a widget role."}},invalidrole:{impact:"critical",messages:{pass:"ARIA role is valid",fail:{singular:"Role must be one of the valid ARIA roles: ${data.values}",plural:"Roles must be one of the valid ARIA roles: ${data.values}"}}},"is-element-focusable":{impact:"minor",messages:{pass:"Element is focusable.",fail:"Element is not focusable."}},"no-implicit-explicit-label":{impact:"moderate",messages:{pass:"There is no mismatch between a <label> and accessible name",incomplete:"Check that the <label> does not need be part of the ARIA ${data} field\'s name"}},unsupportedrole:{impact:"critical",messages:{pass:"ARIA role is supported",fail:"The role used is not widely supported in screen readers and assistive technologies: ${data.values}"}},"valid-scrollable-semantics":{impact:"minor",messages:{pass:"Element has valid semantics for an element in the focus order.",fail:"Element has invalid semantics for an element in the focus order."}},"color-contrast":{impact:"serious",messages:{pass:"Element has sufficient color contrast of ${data.contrastRatio}",fail:"Element has insufficient color contrast of ${data.contrastRatio} (foreground color: ${data.fgColor}, background color: ${data.bgColor}, font size: ${data.fontSize}, font weight: ${data.fontWeight}). Expected contrast ratio of ${data.expectedContrastRatio}",incomplete:{default:"Unable to determine contrast ratio",bgImage:"Element\'s background color could not be determined due to a background image",bgGradient:"Element\'s background color could not be determined due to a background gradient",imgNode:"Element\'s background color could not be determined because element contains an image node",bgOverlap:"Element\'s background color could not be determined because it is overlapped by another element",fgAlpha:"Element\'s foreground color could not be determined because of alpha transparency",elmPartiallyObscured:"Element\'s background color could not be determined because it\'s partially obscured by another element",elmPartiallyObscuring:"Element\'s background color could not be determined because it partially overlaps other elements",outsideViewport:"Element\'s background color could not be determined because it\'s outside the viewport",equalRatio:"Element has a 1:1 contrast ratio with the background",shortTextContent:"Element content is too short to determine if it is actual text content",nonBmp:"Element content contains only non-text characters",pseudoContent:"Element\'s background color could not be determined due to a pseudo element"}}},"link-in-text-block":{impact:"serious",messages:{pass:"Links can be distinguished from surrounding text in some way other than by color",fail:"Links need to be distinguished from surrounding text in some way other than by color",incomplete:{default:"Unable to determine contrast ratio",bgContrast:"Element\'s contrast ratio could not be determined. Check for a distinct hover/focus style",bgImage:"Element\'s contrast ratio could not be determined due to a background image",bgGradient:"Element\'s contrast ratio could not be determined due to a background gradient",imgNode:"Element\'s contrast ratio could not be determined because element contains an image node",bgOverlap:"Element\'s contrast ratio could not be determined because of element overlap"}}},"autocomplete-appropriate":{impact:"serious",messages:{pass:"the autocomplete value is on an appropriate element",fail:"the autocomplete value is inappropriate for this type of input"}},"autocomplete-valid":{impact:"serious",messages:{pass:"the autocomplete attribute is correctly formatted",fail:"the autocomplete attribute is incorrectly formatted"}},accesskeys:{impact:"serious",messages:{pass:"Accesskey attribute value is unique",fail:"Document has multiple elements with the same accesskey"}},"focusable-content":{impact:"moderate",messages:{pass:"Element contains focusable elements",fail:"Element should have focusable content"}},"focusable-disabled":{impact:"serious",messages:{pass:"No focusable elements contained within element",fail:"Focusable content should be disabled or be removed from the DOM"}},"focusable-element":{impact:"moderate",messages:{pass:"Element is focusable",fail:"Element should be focusable"}},"focusable-modal-open":{impact:"serious",messages:{pass:"No focusable elements while a modal is open",incomplete:"Check that focusable elements are not tabbable in the current state"}},"focusable-no-name":{impact:"serious",messages:{pass:"Element is not in tab order or has accessible text",fail:"Element is in tab order and does not have accessible text",incomplete:"Unable to determine if element has an accessible name"}},"focusable-not-tabbable":{impact:"serious",messages:{pass:"No focusable elements contained within element",fail:"Focusable content should have tabindex=\'-1\' or be removed from the DOM"}},"frame-focusable-content":{impact:"serious",messages:{pass:"Element does not have focusable descendants",fail:"Element has focusable descendants",incomplete:"Could not determine if element has descendants"}},"landmark-is-top-level":{impact:"moderate",messages:{pass:"The ${data.role} landmark is at the top level.",fail:"The ${data.role} landmark is contained in another landmark."}},"no-focusable-content":{impact:"serious",messages:{pass:"Element does not have focusable descendants",fail:"Element has focusable descendants",incomplete:"Could not determine if element has descendants"}},"page-has-heading-one":{impact:"moderate",messages:{pass:"Page has at least one level-one heading",fail:"Page must have a level-one heading"}},"page-has-main":{impact:"moderate",messages:{pass:"Document has at least one main landmark",fail:"Document does not have a main landmark"}},"page-no-duplicate-banner":{impact:"moderate",messages:{pass:"Document does not have more than one banner landmark",fail:"Document has more than one banner landmark"}},"page-no-duplicate-contentinfo":{impact:"moderate",messages:{pass:"Document does not have more than one contentinfo landmark",fail:"Document has more than one contentinfo landmark"}},"page-no-duplicate-main":{impact:"moderate",messages:{pass:"Document does not have more than one main landmark",fail:"Document has more than one main landmark"}},tabindex:{impact:"serious",messages:{pass:"Element does not have a tabindex greater than 0",fail:"Element has a tabindex greater than 0"}},"alt-space-value":{impact:"critical",messages:{pass:"Element has a valid alt attribute value",fail:"Element has an alt attribute containing only a space character, which is not ignored by all screen readers"}},"duplicate-img-label":{impact:"minor",messages:{pass:"Element does not duplicate existing text in <img> alt text",fail:"Element contains <img> element with alt text that duplicates existing text"}},"explicit-label":{impact:"critical",messages:{pass:"Form element has an explicit <label>",fail:"Form element does not have an explicit <label>",incomplete:"Unable to determine if form element has an explicit <label>"}},"help-same-as-label":{impact:"minor",messages:{pass:"Help text (title or aria-describedby) does not duplicate label text",fail:"Help text (title or aria-describedby) text is the same as the label text"}},"hidden-explicit-label":{impact:"critical",messages:{pass:"Form element has a visible explicit <label>",fail:"Form element has explicit <label> that is hidden",incomplete:"Unable to determine if form element has explicit <label> that is hidden"}},"implicit-label":{impact:"critical",messages:{pass:"Form element has an implicit (wrapped) <label>",fail:"Form element does not have an implicit (wrapped) <label>",incomplete:"Unable to determine if form element has an implicit (wrapped} <label>"}},"label-content-name-mismatch":{impact:"serious",messages:{pass:"Element contains visible text as part of it\'s accessible name",fail:"Text inside the element is not included in the accessible name"}},"multiple-label":{impact:"moderate",messages:{pass:"Form field does not have multiple label elements",incomplete:"Multiple label elements is not widely supported in assistive technologies. Ensure the first label contains all necessary information."}},"title-only":{impact:"serious",messages:{pass:"Form element does not solely use title attribute for its label",fail:"Only title used to generate label for form element"}},"landmark-is-unique":{impact:"moderate",messages:{pass:"Landmarks must have a unique role or role/label/title (i.e. accessible name) combination",fail:"The landmark must have a unique aria-label, aria-labelledby, or title to make landmarks distinguishable"}},"has-lang":{impact:"serious",messages:{pass:"The <html> element has a lang attribute",fail:{noXHTML:"The xml:lang attribute is not valid on HTML pages, use the lang attribute.",noLang:"The <html> element does not have a lang attribute"}}},"valid-lang":{impact:"serious",messages:{pass:"Value of lang attribute is included in the list of valid languages",fail:"Value of lang attribute not included in the list of valid languages"}},"xml-lang-mismatch":{impact:"moderate",messages:{pass:"Lang and xml:lang attributes have the same base language",fail:"Lang and xml:lang attributes do not have the same base language"}},dlitem:{impact:"serious",messages:{pass:"Description list item has a <dl> parent element",fail:"Description list item does not have a <dl> parent element"}},listitem:{impact:"serious",messages:{pass:\'List item has a <ul>, <ol> or role="list" parent element\',fail:{default:"List item does not have a <ul>, <ol> parent element",roleNotValid:\'List item does not have a <ul>, <ol> parent element without a role, or a role="list"\'}}},"only-dlitems":{impact:"serious",messages:{pass:"List element only has direct children that are allowed inside <dt> or <dd> elements",fail:"List element has direct children that are not allowed inside <dt> or <dd> elements"}},"only-listitems":{impact:"serious",messages:{pass:"List element only has direct children that are allowed inside <li> elements",fail:{default:"List element has direct children that are not allowed inside <li> elements",roleNotValid:"List element has direct children with a role that is not allowed: ${data.roles}"}}},"structured-dlitems":{impact:"serious",messages:{pass:"When not empty, element has both <dt> and <dd> elements",fail:"When not empty, element does not have at least one <dt> element followed by at least one <dd> element"}},caption:{impact:"critical",messages:{pass:"The multimedia element has a captions track",incomplete:"Check that captions is available for the element"}},"frame-tested":{impact:"critical",messages:{pass:"The iframe was tested with axe-core",fail:"The iframe could not be tested with axe-core",incomplete:"The iframe still has to be tested with axe-core"}},"no-autoplay-audio":{impact:"moderate",messages:{pass:"<video> or <audio> does not output audio for more than allowed duration or has controls mechanism",fail:"<video> or <audio> outputs audio for more than allowed duration and does not have a controls mechanism",incomplete:"Check that the <video> or <audio> does not output audio for more than allowed duration or provides a controls mechanism"}},"css-orientation-lock":{impact:"serious",messages:{pass:"Display is operable, and orientation lock does not exist",fail:"CSS Orientation lock is applied, and makes display inoperable",incomplete:"CSS Orientation lock cannot be determined"}},"meta-viewport-large":{impact:"minor",messages:{pass:"<meta> tag does not prevent significant zooming on mobile devices",fail:"<meta> tag limits zooming on mobile devices"}},"meta-viewport":{impact:"critical",messages:{pass:"<meta> tag does not disable zooming on mobile devices",fail:"${data} on <meta> tag disables zooming on mobile devices"}},"header-present":{impact:"serious",messages:{pass:"Page has a heading",fail:"Page does not have a heading"}},"heading-order":{impact:"moderate",messages:{pass:"Heading order valid",fail:"Heading order invalid",incomplete:"Unable to determine previous heading"}},"identical-links-same-purpose":{impact:"minor",messages:{pass:"There are no other links with the same name, that go to a different URL",incomplete:"Check that links have the same purpose, or are intentionally ambiguous."}},"internal-link-present":{impact:"serious",messages:{pass:"Valid skip link found",fail:"No valid skip link found"}},landmark:{impact:"serious",messages:{pass:"Page has a landmark region",fail:"Page does not have a landmark region"}},"meta-refresh":{impact:"critical",messages:{pass:"<meta> tag does not immediately refresh the page",fail:"<meta> tag forces timed refresh of page"}},"p-as-heading":{impact:"serious",messages:{pass:"<p> elements are not styled as headings",fail:"Heading elements should be used instead of styled p elements"}},region:{impact:"moderate",messages:{pass:"All page content is contained by landmarks",fail:"Some page content is not contained by landmarks"}},"skip-link":{impact:"moderate",messages:{pass:"Skip link target exists",incomplete:"Skip link target should become visible on activation",fail:"No skip link target"}},"unique-frame-title":{impact:"serious",messages:{pass:"Element\'s title attribute is unique",fail:"Element\'s title attribute is not unique"}},"duplicate-id-active":{impact:"serious",messages:{pass:"Document has no active elements that share the same id attribute",fail:"Document has active elements with the same id attribute: ${data}"}},"duplicate-id-aria":{impact:"critical",messages:{pass:"Document has no elements referenced with ARIA or labels that share the same id attribute",fail:"Document has multiple elements referenced with ARIA with the same id attribute: ${data}"}},"duplicate-id":{impact:"minor",messages:{pass:"Document has no static elements that share the same id attribute",fail:"Document has multiple static elements with the same id attribute: ${data}"}},"aria-label":{impact:"serious",messages:{pass:"aria-label attribute exists and is not empty",fail:"aria-label attribute does not exist or is empty"}},"aria-labelledby":{impact:"serious",messages:{pass:"aria-labelledby attribute exists and references elements that are visible to screen readers",fail:"aria-labelledby attribute does not exist, references elements that do not exist or references elements that are empty",incomplete:"ensure aria-labelledby references an existing element"}},"avoid-inline-spacing":{impact:"serious",messages:{pass:"No inline styles with \'!important\' that affect text spacing has been specified",fail:{singular:"Remove \'!important\' from inline style ${data.values}, as overriding this is not supported by most browsers",plural:"Remove \'!important\' from inline styles ${data.values}, as overriding this is not supported by most browsers"}}},"button-has-visible-text":{impact:"critical",messages:{pass:"Element has inner text that is visible to screen readers",fail:"Element does not have inner text that is visible to screen readers",incomplete:"Unable to determine if element has children"}},"doc-has-title":{impact:"serious",messages:{pass:"Document has a non-empty <title> element",fail:"Document does not have a non-empty <title> element"}},exists:{impact:"minor",messages:{pass:"Element does not exist",incomplete:"Element exists"}},"has-alt":{impact:"critical",messages:{pass:"Element has an alt attribute",fail:"Element does not have an alt attribute"}},"has-visible-text":{impact:"minor",messages:{pass:"Element has text that is visible to screen readers",fail:"Element does not have text that is visible to screen readers",incomplete:"Unable to determine if element has children"}},"is-on-screen":{impact:"serious",messages:{pass:"Element is not visible",fail:"Element is visible"}},"non-empty-alt":{impact:"critical",messages:{pass:"Element has a non-empty alt attribute",fail:{noAttr:"Element has no alt attribute",emptyAttr:"Element has an empty alt attribute"}}},"non-empty-if-present":{impact:"critical",messages:{pass:{default:"Element does not have a value attribute","has-label":"Element has a non-empty value attribute"},fail:"Element has a value attribute and the value attribute is empty"}},"non-empty-placeholder":{impact:"serious",messages:{pass:"Element has a placeholder attribute",fail:{noAttr:"Element has no placeholder attribute",emptyAttr:"Element has an empty placeholder attribute"}}},"non-empty-title":{impact:"serious",messages:{pass:"Element has a title attribute",fail:{noAttr:"Element has no title attribute",emptyAttr:"Element has an empty title attribute"}}},"non-empty-value":{impact:"critical",messages:{pass:"Element has a non-empty value attribute",fail:{noAttr:"Element has no value attribute",emptyAttr:"Element has an empty value attribute"}}},"presentational-role":{impact:"minor",messages:{pass:\'Element\\\'s default semantics were overriden with role="${data.role}"\',fail:{default:\'Element\\\'s default semantics were not overridden with role="none" or role="presentation"\',globalAria:"Element\'s role is not presentational because it has a global ARIA attribute",focusable:"Element\'s role is not presentational because it is focusable",both:"Element\'s role is not presentational because it has a global ARIA attribute and is focusable"}}},"role-none":{impact:"minor",messages:{pass:\'Element\\\'s default semantics were overriden with role="none"\',fail:\'Element\\\'s default semantics were not overridden with role="none"\'}},"role-presentation":{impact:"minor",messages:{pass:\'Element\\\'s default semantics were overriden with role="presentation"\',fail:\'Element\\\'s default semantics were not overridden with role="presentation"\'}},"svg-non-empty-title":{impact:"serious",messages:{pass:"Element has a child that is a title",fail:{noTitle:"Element has no child that is a title",emptyTitle:"Element child title is empty"},incomplete:"Unable to determine element has a child that is a title"}},"caption-faked":{impact:"serious",messages:{pass:"The first row of a table is not used as a caption",fail:"The first child of the table should be a caption instead of a table cell"}},"html5-scope":{impact:"moderate",messages:{pass:"Scope attribute is only used on table header elements (<th>)",fail:"In HTML 5, scope attributes may only be used on table header elements (<th>)"}},"same-caption-summary":{impact:"minor",messages:{pass:"Content of summary attribute and <caption> are not duplicated",fail:"Content of summary attribute and <caption> element are identical"}},"scope-value":{impact:"critical",messages:{pass:"Scope attribute is used correctly",fail:"The value of the scope attribute may only be \'row\' or \'col\'"}},"td-has-header":{impact:"critical",messages:{pass:"All non-empty data cells have table headers",fail:"Some non-empty data cells do not have table headers"}},"td-headers-attr":{impact:"serious",messages:{pass:"The headers attribute is exclusively used to refer to other cells in the table",incomplete:"The headers attribute is empty",fail:"The headers attribute is not exclusively used to refer to other cells in the table"}},"th-has-data-cells":{impact:"serious",messages:{pass:"All table header cells refer to data cells",fail:"Not all table header cells refer to data cells",incomplete:"Table data cells are missing or empty"}},"hidden-content":{impact:"minor",messages:{pass:"All content on the page has been analyzed.",fail:"There were problems analyzing the content on this page.",incomplete:"There is hidden content on the page that was not analyzed. You will need to trigger the display of this content in order to analyze it."}}},failureSummaries:{any:{failureMessage:function(e){var t="Fix any of the following:",a=e;if(a)for(var r=-1,n=a.length-1;r<n;)t+="\\n  "+a[r+=1].split("\\n").join("\\n  ");return t}},none:{failureMessage:function(e){var t="Fix all of the following:",a=e;if(a)for(var r=-1,n=a.length-1;r<n;)t+="\\n  "+a[r+=1].split("\\n").join("\\n  ");return t}}},incompleteFallbackMessage:{}},rules:[{id:"accesskeys",selector:"[accesskey]",excludeHidden:!1,tags:["cat.keyboard","best-practice"],all:[],any:[],none:["accesskeys"]},{id:"area-alt",selector:"map area[href]",excludeHidden:!1,tags:["cat.text-alternatives","wcag2a","wcag111","wcag244","wcag412","section508","section508.22.a","ACT"],all:[],any:[{options:{attribute:"alt"},id:"non-empty-alt"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-allowed-attr",matches:"aria-allowed-attr-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:["aria-allowed-attr"],none:["aria-unsupported-attr",{options:{elementsAllowedAriaLabel:["applet","input"]},id:"aria-prohibited-attr"}]},{id:"aria-allowed-role",excludeHidden:!1,selector:"[role]",matches:"aria-allowed-role-matches",tags:["cat.aria","best-practice"],all:[],any:[{options:{allowImplicit:!0,ignoredTags:[]},id:"aria-allowed-role"}],none:[]},{id:"aria-command-name",selector:\'[role="link"], [role="button"], [role="menuitem"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-dialog-name",selector:\'[role="dialog"], [role="alertdialog"]\',matches:"no-naming-method-matches",tags:["cat.aria","best-practice"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-hidden-body",selector:"body",excludeHidden:!1,matches:"is-initiator-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:["aria-hidden-body"],none:[]},{id:"aria-hidden-focus",selector:\'[aria-hidden="true"]\',matches:"aria-hidden-focus-matches",excludeHidden:!1,tags:["cat.name-role-value","wcag2a","wcag412","wcag131"],all:["focusable-modal-open","focusable-disabled","focusable-not-tabbable"],any:[],none:[]},{id:"aria-input-field-name",selector:\'[role="combobox"], [role="listbox"], [role="searchbox"], [role="slider"], [role="spinbutton"], [role="textbox"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","ACT"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["no-implicit-explicit-label"]},{id:"aria-meter-name",selector:\'[role="meter"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag111"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-progressbar-name",selector:\'[role="progressbar"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag111"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-required-attr",selector:"[role]",tags:["cat.aria","wcag2a","wcag412"],all:[],any:["aria-required-attr"],none:[]},{id:"aria-required-children",selector:"[role]",matches:"aria-required-children-matches",tags:["cat.aria","wcag2a","wcag131"],all:[],any:[{options:{reviewEmpty:["doc-bibliography","doc-endnotes","grid","list","listbox","table","tablist","tree","treegrid","rowgroup"]},id:"aria-required-children"}],none:[]},{id:"aria-required-parent",selector:"[role]",matches:"aria-required-parent-matches",tags:["cat.aria","wcag2a","wcag131"],all:[],any:[{options:{ownGroupRoles:["listitem","treeitem"]},id:"aria-required-parent"}],none:[]},{id:"aria-roledescription",selector:"[aria-roledescription]",tags:["cat.aria","wcag2a","wcag412"],all:[],any:[{options:{supportedRoles:["button","img","checkbox","radio","combobox","menuitemcheckbox","menuitemradio"]},id:"aria-roledescription"}],none:[]},{id:"aria-roles",selector:"[role]",matches:"no-empty-role-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:[],none:["fallbackrole","invalidrole","abstractrole","unsupportedrole"]},{id:"aria-text",selector:"[role=text]",tags:["cat.aria","best-practice"],all:[],any:["no-focusable-content"],none:[]},{id:"aria-toggle-field-name",selector:\'[role="checkbox"], [role="menuitemcheckbox"], [role="menuitemradio"], [role="radio"], [role="switch"], [role="option"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412","ACT"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["no-implicit-explicit-label"]},{id:"aria-tooltip-name",selector:\'[role="tooltip"]\',matches:"no-naming-method-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-treeitem-name",selector:\'[role="treeitem"]\',matches:"no-naming-method-matches",tags:["cat.aria","best-practice"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"aria-valid-attr-value",matches:"aria-has-attr-matches",tags:["cat.aria","wcag2a","wcag412"],all:[{options:[],id:"aria-valid-attr-value"},"aria-errormessage"],any:[],none:[]},{id:"aria-valid-attr",matches:"aria-has-attr-matches",tags:["cat.aria","wcag2a","wcag412"],all:[],any:[{options:[],id:"aria-valid-attr"}],none:[]},{id:"audio-caption",selector:"audio",enabled:!1,excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag121","section508","section508.22.a"],all:[],any:[],none:["caption"]},{id:"autocomplete-valid",matches:"autocomplete-matches",tags:["cat.forms","wcag21aa","wcag135"],all:["autocomplete-valid","autocomplete-appropriate"],any:[],none:[]},{id:"avoid-inline-spacing",selector:"[style]",tags:["cat.structure","wcag21aa","wcag1412"],all:[{options:{cssProperties:["line-height","letter-spacing","word-spacing"]},id:"avoid-inline-spacing"}],any:[],none:[]},{id:"blink",selector:"blink",excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag222","section508","section508.22.j"],all:[],any:[],none:["is-on-screen"]},{id:"button-name",selector:"button",matches:"no-explicit-name-required-matches",tags:["cat.name-role-value","wcag2a","wcag412","section508","section508.22.a","ACT"],all:[],any:["button-has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"bypass",selector:"html",pageLevel:!0,matches:"bypass-matches",reviewOnFail:!0,tags:["cat.keyboard","wcag2a","wcag241","section508","section508.22.o"],all:[],any:["internal-link-present",{options:{selector:":is(h1, h2, h3, h4, h5, h6):not([role]), [role=heading]"},id:"header-present"},{options:{selector:"main, [role=main]"},id:"landmark"}],none:[]},{id:"color-contrast",matches:"color-contrast-matches",excludeHidden:!1,tags:["cat.color","wcag2aa","wcag143"],all:[],any:[{options:{ignoreUnicode:!0,ignoreLength:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:4.5},large:{expected:3}},shadowOutlineEmMax:.1},id:"color-contrast"}],none:[]},{id:"css-orientation-lock",selector:"html",tags:["cat.structure","wcag134","wcag21aa","experimental"],all:[{options:{degreeThreshold:2},id:"css-orientation-lock"}],any:[],none:[],preload:!0},{id:"definition-list",selector:"dl",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:[],none:["structured-dlitems","only-dlitems"]},{id:"dlitem",selector:"dd, dt",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:["dlitem"],none:[]},{id:"document-title",selector:"html",matches:"is-initiator-matches",tags:["cat.text-alternatives","wcag2a","wcag242","ACT"],all:[],any:["doc-has-title"],none:[]},{id:"duplicate-id-active",selector:"[id]",matches:"duplicate-id-active-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag411"],all:[],any:["duplicate-id-active"],none:[]},{id:"duplicate-id-aria",selector:"[id]",matches:"duplicate-id-aria-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag411"],all:[],any:["duplicate-id-aria"],none:[]},{id:"duplicate-id",selector:"[id]",matches:"duplicate-id-misc-matches",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag411"],all:[],any:["duplicate-id"],none:[]},{id:"empty-heading",selector:\'h1, h2, h3, h4, h5, h6, [role="heading"]\',matches:"heading-matches",tags:["cat.name-role-value","best-practice"],impact:"minor",all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"empty-table-header",selector:\'th, [role="rowheader"], [role="columnheader"]\',tags:["wcag131","cat.aria"],reviewOnFail:!0,all:[],any:["has-visible-text"],none:[]},{id:"focus-order-semantics",selector:"div, h1, h2, h3, h4, h5, h6, [role=heading], p, span",matches:"inserted-into-focus-order-matches",tags:["cat.keyboard","best-practice","experimental"],all:[],any:[{options:[],id:"has-widget-role"},{options:{roles:["tooltip"]},id:"valid-scrollable-semantics"}],none:[]},{id:"form-field-multiple-labels",selector:"input, select, textarea",matches:"label-matches",tags:["cat.forms","wcag2a","wcag332"],all:[],any:[],none:["multiple-label"]},{id:"frame-focusable-content",selector:"html",matches:"frame-focusable-content-matches",tags:["cat.keyboard","wcag2a","wcag211"],all:[],any:["frame-focusable-content"],none:[]},{id:"frame-tested",selector:"html, frame, iframe",tags:["cat.structure","review-item","best-practice"],all:[{options:{isViolation:!1},id:"frame-tested"}],any:[],none:[]},{id:"frame-title-unique",selector:"frame[title], iframe[title]",matches:"frame-title-has-text-matches",tags:["cat.text-alternatives","best-practice"],all:[],any:[],none:["unique-frame-title"]},{id:"frame-title",selector:"frame, iframe",tags:["cat.text-alternatives","wcag2a","wcag241","wcag412","section508","section508.22.i"],all:[],any:[{options:{attribute:"title"},id:"non-empty-title"},"aria-label","aria-labelledby","presentational-role"],none:[]},{id:"heading-order",selector:"h1, h2, h3, h4, h5, h6, [role=heading]",matches:"heading-matches",tags:["cat.semantics","best-practice"],all:[],any:["heading-order"],none:[]},{id:"hidden-content",selector:"*",excludeHidden:!1,tags:["cat.structure","experimental","review-item","best-practice"],all:[],any:["hidden-content"],none:[]},{id:"html-has-lang",selector:"html",matches:"is-initiator-matches",tags:["cat.language","wcag2a","wcag311","ACT"],all:[],any:[{options:{attributes:["lang","xml:lang"]},id:"has-lang"}],none:[]},{id:"html-lang-valid",selector:"html[lang], html[xml\\\\:lang]",tags:["cat.language","wcag2a","wcag311","ACT"],all:[],any:[],none:[{options:{attributes:["lang","xml:lang"]},id:"valid-lang"}]},{id:"html-xml-lang-mismatch",selector:"html[lang][xml\\\\:lang]",matches:"xml-lang-mismatch-matches",tags:["cat.language","wcag2a","wcag311","ACT"],all:["xml-lang-mismatch"],any:[],none:[]},{id:"identical-links-same-purpose",selector:\'a[href], area[href], [role="link"]\',excludeHidden:!1,matches:"identical-links-same-purpose-matches",tags:["cat.semantics","wcag2aaa","wcag249","best-practice"],all:["identical-links-same-purpose"],any:[],none:[]},{id:"image-alt",selector:"img",matches:"no-explicit-name-required-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","ACT"],all:[],any:["has-alt","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:["alt-space-value"]},{id:"image-redundant-alt",selector:"img",tags:["cat.text-alternatives","best-practice"],all:[],any:[],none:[{options:{parentSelector:"button, [role=button], a[href], p, li, td, th"},id:"duplicate-img-label"}]},{id:"input-button-name",selector:\'input[type="button"], input[type="submit"], input[type="reset"]\',matches:"no-explicit-name-required-matches",tags:["cat.name-role-value","wcag2a","wcag412","section508","section508.22.a"],all:[],any:["non-empty-if-present",{options:{attribute:"value"},id:"non-empty-value"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"input-image-alt",selector:\'input[type="image"]\',matches:"no-explicit-name-required-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","ACT"],all:[],any:[{options:{attribute:"alt"},id:"non-empty-alt"},"aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"label-content-name-mismatch",matches:"label-content-name-mismatch-matches",tags:["cat.semantics","wcag21a","wcag253","experimental"],all:[],any:[{options:{pixelThreshold:.1,occuranceThreshold:3},id:"label-content-name-mismatch"}],none:[]},{id:"label-title-only",selector:"input, select, textarea",matches:"label-matches",tags:["cat.forms","best-practice"],all:[],any:[],none:["title-only"]},{id:"label",selector:"input, textarea",matches:"label-matches",tags:["cat.forms","wcag2a","wcag412","wcag131","section508","section508.22.n","ACT"],all:[],any:["implicit-label","explicit-label","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},{options:{attribute:"placeholder"},id:"non-empty-placeholder"},"presentational-role"],none:["help-same-as-label","hidden-explicit-label"]},{id:"landmark-banner-is-top-level",selector:"header:not([role]), [role=banner]",matches:"landmark-has-body-context-matches",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-complementary-is-top-level",selector:"aside:not([role]), [role=complementary]",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-contentinfo-is-top-level",selector:"footer:not([role]), [role=contentinfo]",matches:"landmark-has-body-context-matches",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-main-is-top-level",selector:"main:not([role]), [role=main]",tags:["cat.semantics","best-practice"],all:[],any:["landmark-is-top-level"],none:[]},{id:"landmark-no-duplicate-banner",selector:"header:not([role]), [role=banner]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"header:not([role]), [role=banner]",nativeScopeFilter:"article, aside, main, nav, section"},id:"page-no-duplicate-banner"}],none:[]},{id:"landmark-no-duplicate-contentinfo",selector:"footer:not([role]), [role=contentinfo]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"footer:not([role]), [role=contentinfo]",nativeScopeFilter:"article, aside, main, nav, section"},id:"page-no-duplicate-contentinfo"}],none:[]},{id:"landmark-no-duplicate-main",selector:"main:not([role]), [role=main]",tags:["cat.semantics","best-practice"],all:[],any:[{options:{selector:"main:not([role]), [role=\'main\']"},id:"page-no-duplicate-main"}],none:[]},{id:"landmark-one-main",selector:"html",tags:["cat.semantics","best-practice"],all:[{options:{selector:"main:not([role]), [role=\'main\']"},id:"page-has-main"}],any:[],none:[]},{id:"landmark-unique",selector:"[role=banner], [role=complementary], [role=contentinfo], [role=main], [role=navigation], [role=region], [role=search], [role=form], form, footer, header, aside, main, nav, section",tags:["cat.semantics","best-practice"],matches:"landmark-unique-matches",all:[],any:["landmark-is-unique"],none:[]},{id:"link-in-text-block",selector:"a[href], [role=link]",matches:"link-in-text-block-matches",excludeHidden:!1,tags:["cat.color","experimental","wcag2a","wcag141"],all:["link-in-text-block"],any:[],none:[]},{id:"link-name",selector:"a[href]",tags:["cat.name-role-value","wcag2a","wcag412","wcag244","section508","section508.22.a","ACT"],all:[],any:["has-visible-text","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:["focusable-no-name"]},{id:"list",selector:"ul, ol",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:[],none:["only-listitems"]},{id:"listitem",selector:"li",matches:"no-role-matches",tags:["cat.structure","wcag2a","wcag131"],all:[],any:["listitem"],none:[]},{id:"marquee",selector:"marquee",excludeHidden:!1,tags:["cat.parsing","wcag2a","wcag222"],all:[],any:[],none:["is-on-screen"]},{id:"meta-refresh",selector:\'meta[http-equiv="refresh"]\',excludeHidden:!1,tags:["cat.time-and-media","wcag2a","wcag2aaa","wcag221","wcag224","wcag325"],all:[],any:["meta-refresh"],none:[]},{id:"meta-viewport-large",selector:\'meta[name="viewport"]\',matches:"is-initiator-matches",excludeHidden:!1,tags:["cat.sensory-and-visual-cues","best-practice"],all:[],any:[{options:{scaleMinimum:5,lowerBound:2},id:"meta-viewport-large"}],none:[]},{id:"meta-viewport",selector:\'meta[name="viewport"]\',matches:"is-initiator-matches",excludeHidden:!1,tags:["cat.sensory-and-visual-cues","best-practice","ACT"],all:[],any:[{options:{scaleMinimum:2},id:"meta-viewport"}],none:[]},{id:"nested-interactive",matches:"nested-interactive-matches",tags:["cat.keyboard","wcag2a","wcag412"],all:[],any:["no-focusable-content"],none:[]},{id:"no-autoplay-audio",excludeHidden:!1,selector:"audio[autoplay], video[autoplay]",matches:"no-autoplay-audio-matches",tags:["cat.time-and-media","wcag2a","wcag142","experimental"],preload:!0,all:[{options:{allowedDuration:3},id:"no-autoplay-audio"}],any:[],none:[]},{id:"object-alt",selector:"object",matches:"no-explicit-name-required-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:[]},{id:"p-as-heading",selector:"p",matches:"p-as-heading-matches",tags:["cat.semantics","wcag2a","wcag131","experimental"],all:[{options:{margins:[{weight:150,italic:!0},{weight:150,size:1.15},{italic:!0,size:1.15},{size:1.4}]},id:"p-as-heading"}],any:[],none:[]},{id:"page-has-heading-one",selector:"html",tags:["cat.semantics","best-practice"],all:[{options:{selector:"h1:not([role], [aria-level]), :is(h1, h2, h3, h4, h5, h6):not([role])[aria-level=1], [role=heading][aria-level=1]"},id:"page-has-heading-one"}],any:[],none:[]},{id:"presentation-role-conflict",matches:"has-implicit-chromium-role-matches",selector:\'[role="none"], [role="presentation"]\',tags:["cat.aria","best-practice"],all:[],any:[],none:["is-element-focusable","has-global-aria-attribute"]},{id:"region",selector:"body *",tags:["cat.keyboard","best-practice"],all:[],any:[{options:{regionMatcher:"dialog, [role=dialog], [role=alertdialog], svg, iframe"},id:"region"}],none:[]},{id:"role-img-alt",selector:"[role=\'img\']:not(img, area, input, object)",matches:"html-namespace-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","ACT"],all:[],any:["aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"scope-attr-valid",selector:"td[scope], th[scope]",tags:["cat.tables","best-practice"],all:["html5-scope",{options:{values:["row","col","rowgroup","colgroup"]},id:"scope-value"}],any:[],none:[]},{id:"scrollable-region-focusable",matches:"scrollable-region-focusable-matches",tags:["cat.keyboard","wcag2a","wcag211"],all:[],any:["focusable-content","focusable-element"],none:[]},{id:"select-name",selector:"select",tags:["cat.forms","wcag2a","wcag412","wcag131","section508","section508.22.n","ACT"],all:[],any:["implicit-label","explicit-label","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"},"presentational-role"],none:["help-same-as-label","hidden-explicit-label"]},{id:"server-side-image-map",selector:"img[ismap]",tags:["cat.text-alternatives","wcag2a","wcag211","section508","section508.22.f"],all:[],any:[],none:["exists"]},{id:"skip-link",selector:\'a[href^="#"], a[href^="/#"]\',matches:"skip-link-matches",tags:["cat.keyboard","best-practice"],all:[],any:["skip-link"],none:[]},{id:"svg-img-alt",selector:\'[role="img"], [role="graphics-symbol"], svg[role="graphics-document"]\',matches:"svg-namespace-matches",tags:["cat.text-alternatives","wcag2a","wcag111","section508","section508.22.a","ACT"],all:[],any:["svg-non-empty-title","aria-label","aria-labelledby",{options:{attribute:"title"},id:"non-empty-title"}],none:[]},{id:"tabindex",selector:"[tabindex]",tags:["cat.keyboard","best-practice"],all:[],any:["tabindex"],none:[]},{id:"table-duplicate-name",selector:"table",tags:["cat.tables","best-practice"],all:[],any:[],none:["same-caption-summary"]},{id:"table-fake-caption",selector:"table",matches:"data-table-matches",tags:["cat.tables","experimental","wcag2a","wcag131","section508","section508.22.g"],all:["caption-faked"],any:[],none:[]},{id:"td-has-header",selector:"table",matches:"data-table-large-matches",tags:["cat.tables","experimental","wcag2a","wcag131","section508","section508.22.g"],all:["td-has-header"],any:[],none:[]},{id:"td-headers-attr",selector:"table",tags:["cat.tables","wcag2a","wcag131","section508","section508.22.g"],all:["td-headers-attr"],any:[],none:[]},{id:"th-has-data-cells",selector:"table",matches:"data-table-matches",tags:["cat.tables","wcag2a","wcag131","section508","section508.22.g"],all:["th-has-data-cells"],any:[],none:[]},{id:"valid-lang",selector:"[lang], [xml\\\\:lang]",matches:"not-html-matches",tags:["cat.language","wcag2aa","wcag312"],all:[],any:[],none:[{options:{attributes:["lang","xml:lang"]},id:"valid-lang"}]},{id:"video-caption",selector:"video",excludeHidden:!1,tags:["cat.text-alternatives","wcag2a","wcag122","section508","section508.22.a"],all:[],any:[],none:["caption"]}],checks:[{id:"abstractrole",evaluate:"abstractrole-evaluate"},{id:"aria-allowed-attr",evaluate:"aria-allowed-attr-evaluate"},{id:"aria-allowed-role",evaluate:"aria-allowed-role-evaluate",options:{allowImplicit:!0,ignoredTags:[]}},{id:"aria-errormessage",evaluate:"aria-errormessage-evaluate"},{id:"aria-hidden-body",evaluate:"aria-hidden-body-evaluate"},{id:"aria-prohibited-attr",evaluate:"aria-prohibited-attr-evaluate",options:{elementsAllowedAriaLabel:["applet","input"]}},{id:"aria-required-attr",evaluate:"aria-required-attr-evaluate"},{id:"aria-required-children",evaluate:"aria-required-children-evaluate",options:{reviewEmpty:["doc-bibliography","doc-endnotes","grid","list","listbox","table","tablist","tree","treegrid","rowgroup"]}},{id:"aria-required-parent",evaluate:"aria-required-parent-evaluate",options:{ownGroupRoles:["listitem","treeitem"]}},{id:"aria-roledescription",evaluate:"aria-roledescription-evaluate",options:{supportedRoles:["button","img","checkbox","radio","combobox","menuitemcheckbox","menuitemradio"]}},{id:"aria-unsupported-attr",evaluate:"aria-unsupported-attr-evaluate"},{id:"aria-valid-attr-value",evaluate:"aria-valid-attr-value-evaluate",options:[]},{id:"aria-valid-attr",evaluate:"aria-valid-attr-evaluate",options:[]},{id:"fallbackrole",evaluate:"fallbackrole-evaluate"},{id:"has-global-aria-attribute",evaluate:"has-global-aria-attribute-evaluate"},{id:"has-widget-role",evaluate:"has-widget-role-evaluate",options:[]},{id:"invalidrole",evaluate:"invalidrole-evaluate"},{id:"is-element-focusable",evaluate:"is-element-focusable-evaluate"},{id:"no-implicit-explicit-label",evaluate:"no-implicit-explicit-label-evaluate"},{id:"unsupportedrole",evaluate:"unsupportedrole-evaluate"},{id:"valid-scrollable-semantics",evaluate:"valid-scrollable-semantics-evaluate",options:{roles:["tooltip"]}},{id:"color-contrast",evaluate:"color-contrast-evaluate",options:{ignoreUnicode:!0,ignoreLength:!1,boldValue:700,boldTextPt:14,largeTextPt:18,contrastRatio:{normal:{expected:4.5},large:{expected:3}},shadowOutlineEmMax:.1}},{id:"link-in-text-block",evaluate:"link-in-text-block-evaluate"},{id:"autocomplete-appropriate",evaluate:"autocomplete-appropriate-evaluate"},{id:"autocomplete-valid",evaluate:"autocomplete-valid-evaluate"},{id:"accesskeys",evaluate:"accesskeys-evaluate",after:"accesskeys-after"},{id:"focusable-content",evaluate:"focusable-content-evaluate"},{id:"focusable-disabled",evaluate:"focusable-disabled-evaluate"},{id:"focusable-element",evaluate:"focusable-element-evaluate"},{id:"focusable-modal-open",evaluate:"focusable-modal-open-evaluate"},{id:"focusable-no-name",evaluate:"focusable-no-name-evaluate"},{id:"focusable-not-tabbable",evaluate:"focusable-not-tabbable-evaluate"},{id:"frame-focusable-content",evaluate:"no-focusable-content-evaluate"},{id:"landmark-is-top-level",evaluate:"landmark-is-top-level-evaluate"},{id:"no-focusable-content",evaluate:"no-focusable-content-evaluate"},{id:"page-has-heading-one",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:"h1:not([role], [aria-level]), :is(h1, h2, h3, h4, h5, h6):not([role])[aria-level=1], [role=heading][aria-level=1]"}},{id:"page-has-main",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:"main:not([role]), [role=\'main\']"}},{id:"page-no-duplicate-banner",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"header:not([role]), [role=banner]",nativeScopeFilter:"article, aside, main, nav, section"}},{id:"page-no-duplicate-contentinfo",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"footer:not([role]), [role=contentinfo]",nativeScopeFilter:"article, aside, main, nav, section"}},{id:"page-no-duplicate-main",evaluate:"page-no-duplicate-evaluate",after:"page-no-duplicate-after",options:{selector:"main:not([role]), [role=\'main\']"}},{id:"tabindex",evaluate:"tabindex-evaluate"},{id:"alt-space-value",evaluate:"alt-space-value-evaluate"},{id:"duplicate-img-label",evaluate:"duplicate-img-label-evaluate",options:{parentSelector:"button, [role=button], a[href], p, li, td, th"}},{id:"explicit-label",evaluate:"explicit-evaluate"},{id:"help-same-as-label",evaluate:"help-same-as-label-evaluate",enabled:!1},{id:"hidden-explicit-label",evaluate:"hidden-explicit-label-evaluate"},{id:"implicit-label",evaluate:"implicit-evaluate"},{id:"label-content-name-mismatch",evaluate:"label-content-name-mismatch-evaluate",options:{pixelThreshold:.1,occuranceThreshold:3}},{id:"multiple-label",evaluate:"multiple-label-evaluate"},{id:"title-only",evaluate:"title-only-evaluate"},{id:"landmark-is-unique",evaluate:"landmark-is-unique-evaluate",after:"landmark-is-unique-after"},{id:"has-lang",evaluate:"has-lang-evaluate",options:{attributes:["lang","xml:lang"]}},{id:"valid-lang",evaluate:"valid-lang-evaluate",options:{attributes:["lang","xml:lang"]}},{id:"xml-lang-mismatch",evaluate:"xml-lang-mismatch-evaluate"},{id:"dlitem",evaluate:"dlitem-evaluate"},{id:"listitem",evaluate:"listitem-evaluate"},{id:"only-dlitems",evaluate:"only-dlitems-evaluate"},{id:"only-listitems",evaluate:"only-listitems-evaluate"},{id:"structured-dlitems",evaluate:"structured-dlitems-evaluate"},{id:"caption",evaluate:"caption-evaluate"},{id:"frame-tested",evaluate:"frame-tested-evaluate",after:"frame-tested-after",options:{isViolation:!1}},{id:"no-autoplay-audio",evaluate:"no-autoplay-audio-evaluate",options:{allowedDuration:3}},{id:"css-orientation-lock",evaluate:"css-orientation-lock-evaluate",options:{degreeThreshold:2}},{id:"meta-viewport-large",evaluate:"meta-viewport-scale-evaluate",options:{scaleMinimum:5,lowerBound:2}},{id:"meta-viewport",evaluate:"meta-viewport-scale-evaluate",options:{scaleMinimum:2}},{id:"header-present",evaluate:"has-descendant-evaluate",after:"has-descendant-after",options:{selector:":is(h1, h2, h3, h4, h5, h6):not([role]), [role=heading]"}},{id:"heading-order",evaluate:"heading-order-evaluate",after:"heading-order-after"},{id:"identical-links-same-purpose",evaluate:"identical-links-same-purpose-evaluate",after:"identical-links-same-purpose-after"},{id:"internal-link-present",evaluate:"internal-link-present-evaluate"},{id:"landmark",evaluate:"has-descendant-evaluate",options:{selector:"main, [role=main]"}},{id:"meta-refresh",evaluate:"meta-refresh-evaluate"},{id:"p-as-heading",evaluate:"p-as-heading-evaluate",options:{margins:[{weight:150,italic:!0},{weight:150,size:1.15},{italic:!0,size:1.15},{size:1.4}]}},{id:"region",evaluate:"region-evaluate",options:{regionMatcher:"dialog, [role=dialog], [role=alertdialog], svg, iframe"}},{id:"skip-link",evaluate:"skip-link-evaluate"},{id:"unique-frame-title",evaluate:"unique-frame-title-evaluate",after:"unique-frame-title-after"},{id:"duplicate-id-active",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"duplicate-id-aria",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"duplicate-id",evaluate:"duplicate-id-evaluate",after:"duplicate-id-after"},{id:"aria-label",evaluate:"aria-label-evaluate"},{id:"aria-labelledby",evaluate:"aria-labelledby-evaluate"},{id:"avoid-inline-spacing",evaluate:"avoid-inline-spacing-evaluate",options:{cssProperties:["line-height","letter-spacing","word-spacing"]}},{id:"button-has-visible-text",evaluate:"has-text-content-evaluate"},{id:"doc-has-title",evaluate:"doc-has-title-evaluate"},{id:"exists",evaluate:"exists-evaluate"},{id:"has-alt",evaluate:"has-alt-evaluate"},{id:"has-visible-text",evaluate:"has-text-content-evaluate"},{id:"is-on-screen",evaluate:"is-on-screen-evaluate"},{id:"non-empty-alt",evaluate:"attr-non-space-content-evaluate",options:{attribute:"alt"}},{id:"non-empty-if-present",evaluate:"non-empty-if-present-evaluate"},{id:"non-empty-placeholder",evaluate:"attr-non-space-content-evaluate",options:{attribute:"placeholder"}},{id:"non-empty-title",evaluate:"attr-non-space-content-evaluate",options:{attribute:"title"}},{id:"non-empty-value",evaluate:"attr-non-space-content-evaluate",options:{attribute:"value"}},{id:"presentational-role",evaluate:"presentational-role-evaluate"},{id:"role-none",evaluate:"matches-definition-evaluate",deprecated:!0,options:{matcher:{attributes:{role:"none"}}}},{id:"role-presentation",evaluate:"matches-definition-evaluate",deprecated:!0,options:{matcher:{attributes:{role:"presentation"}}}},{id:"svg-non-empty-title",evaluate:"svg-non-empty-title-evaluate"},{id:"caption-faked",evaluate:"caption-faked-evaluate"},{id:"html5-scope",evaluate:"html5-scope-evaluate"},{id:"same-caption-summary",evaluate:"same-caption-summary-evaluate"},{id:"scope-value",evaluate:"scope-value-evaluate",options:{values:["row","col","rowgroup","colgroup"]}},{id:"td-has-header",evaluate:"td-has-header-evaluate"},{id:"td-headers-attr",evaluate:"td-headers-attr-evaluate"},{id:"th-has-data-cells",evaluate:"th-has-data-cells-evaluate"},{id:"hidden-content",evaluate:"hidden-content-evaluate"}]})}("object"==typeof window?window:this);'
}},{}],84:[function(e,t,n){"use strict";const i={console};t.exports=i},{}],85:[function(e,t,n){"use strict";const i={TextSourceMap:e("./generated/SourceMap.js")};function extendArray(e){e.lowerBound||(e.lowerBound=lowerBound.bind(e),e.upperBound=upperBound.bind(e),e.slice=function(t,n){const i=Array.prototype.slice.call(e,t,n);return extendArray(i),i},e.filter=function(t){const n=Array.prototype.filter.call(e,t);return extendArray(n),n})}const a=i.TextSourceMap.prototype.mappings;i.TextSourceMap.prototype.mappings=function(){const e=a.call(this);return extendArray(e),e};const s=i.TextSourceMap.prototype._reversedMappings;function upperBound(e,t,n,i){t=t||function defaultComparator(e,t){return e<t?-1:e>t?1:0};let a=n||0,s=void 0!==i?i:this.length;for(;a<s;){const n=a+s>>1;t(e,this[n])>=0?a=n+1:s=n}return s}function lowerBound(e,t,n,i){t=t||function defaultComparator(e,t){return e<t?-1:e>t?1:0};let a=n||0,s=void 0!==i?i:this.length;for(;a<s;){const n=a+s>>1;t(e,this[n])>0?a=n+1:s=n}
return s}i.TextSourceMap.prototype._reversedMappings=function(e){const t=s.call(this,e);return extendArray(t),t},i.TextSourceMap.prototype.computeLastGeneratedColumns=function(){const e=this.mappings();if(!e.length||void 0===e[0].lastColumnNumber)for(let t=0;t<e.length-1;t++){const n=e[t],i=e[t+1];n.lineNumber===i.lineNumber&&(n.lastColumnNumber=i.columnNumber)}},t.exports=i},{"./generated/SourceMap.js":86}],86:[function(e,t,n){const i=e("../Common.js");Object.defineProperty(n,"__esModule",{value:!0});class SourceMapV3{constructor(){this.version,this.file,this.sources,this.sections,this.mappings,this.sourceRoot,this.names}}SourceMapV3.Section=class{constructor(){this.map,this.offset}},SourceMapV3.Offset=class{constructor(){this.line,this.column}};class SourceMapEntry{constructor(e,t,n,i,a,s){this.lineNumber=e,this.columnNumber=t,this.sourceURL=n,this.sourceLineNumber=i,this.sourceColumnNumber=a,this.name=s}static compare(e,t){
return e.lineNumber!==t.lineNumber?e.lineNumber-t.lineNumber:e.columnNumber-t.columnNumber}}class TextSourceMap{constructor(e,t,n){if(!TextSourceMap._base64Map){const e="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";TextSourceMap._base64Map={};for(let t=0;t<e.length;++t)TextSourceMap._base64Map[e.charAt(t)]=t}if(this._json=n,this._compiledURL=e,this._sourceMappingURL=t,this._baseURL=t.startsWith("data:")?e:t,this._mappings=null,this._sourceInfos=new Map,this._json.sections){!!this._json.sections.find((e=>!!e.url))&&i.console.warn(`SourceMap "${t}" contains unsupported "URL" field in one of its sections.`)}this._eachSection(this._parseSources.bind(this))}compiledURL(){return this._compiledURL}url(){return this._sourceMappingURL}sourceURLs(){return this._sourceInfos.keysArray()}embeddedContentByURL(e){return this._sourceInfos.has(e)?this._sourceInfos.get(e).content:null}findEntry(e,t){
const n=this.mappings(),i=n.upperBound(void 0,((n,i)=>e-i.lineNumber||t-i.columnNumber));return i?n[i-1]:null}sourceLineMapping(e,t,n){const i=this._reversedMappings(e),a=i.lowerBound(t,lineComparator),s=i.upperBound(t,lineComparator);if(a>=i.length||i[a].sourceLineNumber!==t)return null;const c=i.slice(a,s);if(!c.length)return null;const l=c.lowerBound(n,((e,t)=>e-t.sourceColumnNumber));return l>=c.length?c[c.length-1]:c[l];function lineComparator(e,t){return e-t.sourceLineNumber}}findReverseEntries(e,t,n){const i=this._reversedMappings(e),a=i.upperBound(void 0,((e,i)=>t-i.sourceLineNumber||n-i.sourceColumnNumber));let s=a;for(;s>0&&i[s-1].sourceLineNumber===i[a-1].sourceLineNumber&&i[s-1].sourceColumnNumber===i[a-1].sourceColumnNumber;)--s;return i.slice(s,a)}mappings(){return null===this._mappings&&(this._mappings=[],this._eachSection(this._parseMap.bind(this)),this._json=null),this._mappings}_reversedMappings(e){if(!this._sourceInfos.has(e))return[]
;const t=this.mappings(),n=this._sourceInfos.get(e);return null===n.reverseMappings&&(n.reverseMappings=t.filter((t=>t.sourceURL===e)).sort((function sourceMappingComparator(e,t){if(e.sourceLineNumber!==t.sourceLineNumber)return e.sourceLineNumber-t.sourceLineNumber;if(e.sourceColumnNumber!==t.sourceColumnNumber)return e.sourceColumnNumber-t.sourceColumnNumber;if(e.lineNumber!==t.lineNumber)return e.lineNumber-t.lineNumber;return e.columnNumber-t.columnNumber}))),n.reverseMappings}_eachSection(e){if(this._json.sections)for(const t of this._json.sections)e(t.map,t.offset.line,t.offset.column);else e(this._json,0,0)}_parseSources(e){const t=[];let n=e.sourceRoot||"";n&&!n.endsWith("/")&&(n+="/");for(let i=0;i<e.sources.length;++i){let a=n+e.sources[i];const s=e.sourcesContent&&e.sourcesContent[i];this._compiledURL,this._sourceInfos.set(a,new TextSourceMap.SourceInfo(s,null)),t.push(a)}e[TextSourceMap._sourcesListSymbol]=t}_parseMap(e,t,n){let i=0,a=0,s=0,c=0
;const l=e[TextSourceMap._sourcesListSymbol],u=e.names||[],d=new TextSourceMap.StringCharIterator(e.mappings);let m=l[i];for(;;){if(","===d.peek())d.next();else{for(;";"===d.peek();)t+=1,n=0,d.next();if(!d.hasNext())break}if(n+=this._decodeVLQ(d),!d.hasNext()||this._isSeparator(d.peek())){this._mappings.push(new SourceMapEntry(t,n));continue}const e=this._decodeVLQ(d);e&&(i+=e,m=l[i]),a+=this._decodeVLQ(d),s+=this._decodeVLQ(d),d.hasNext()&&!this._isSeparator(d.peek())?(c+=this._decodeVLQ(d),this._mappings.push(new SourceMapEntry(t,n,m,a,s,u[c]))):this._mappings.push(new SourceMapEntry(t,n,m,a,s))}this._mappings.sort(SourceMapEntry.compare)}_isSeparator(e){return","===e||";"===e}_decodeVLQ(e){let t,n=0,i=0;do{t=TextSourceMap._base64Map[e.next()],n+=(t&TextSourceMap._VLQ_BASE_MASK)<<i,i+=TextSourceMap._VLQ_BASE_SHIFT}while(t&TextSourceMap._VLQ_CONTINUATION_MASK);const a=1&n;return n>>=1,a?-n:n}reverseMapTextRange(e,t){function comparator(e,t){
return e.lineNumber!==t.sourceLineNumber?e.lineNumber-t.sourceLineNumber:e.columnNumber-t.sourceColumnNumber}const n=this._reversedMappings(e),i=n.lowerBound({lineNumber:t.startLine,columnNumber:t.startColumn},comparator),a=n.upperBound({lineNumber:t.endLine,columnNumber:t.endColumn},comparator),s=n[i],c=n[a];return new TextUtils.TextRange(s.lineNumber,s.columnNumber,c.lineNumber,c.columnNumber)}dispose(){}}TextSourceMap._VLQ_BASE_SHIFT=5,TextSourceMap._VLQ_BASE_MASK=31,TextSourceMap._VLQ_CONTINUATION_MASK=32,TextSourceMap.StringCharIterator=class{constructor(e){this._string=e,this._position=0}next(){return this._string.charAt(this._position++)}peek(){return this._string.charAt(this._position)}hasNext(){return this._position<this._string.length}},TextSourceMap.SourceInfo=class{constructor(e,t){this.content=e,this.reverseMappings=t}},TextSourceMap._sourcesListSymbol=Symbol("sourcesList"),t.exports=TextSourceMap},{"../Common.js":84}],87:[function(e,t,n){(function(n){(function(){
"use strict";const{evaluateForFailure:i,evaluateForSyntaxErrors:a,evaluateForWarnings:s}=e("csp_evaluator/dist/lighthouse/lighthouse_checks.js"),{Type:c}=e("csp_evaluator/dist/finding.js"),{CspParser:l}=e("csp_evaluator/dist/parser.js"),{Directive:u}=e("csp_evaluator/dist/csp.js"),d=e("lighthouse-logger"),m=e("../lib/i18n/i18n.js"),p={missingBaseUri:"Missing base-uri allows injected <base> tags to set the base URL for all relative URLs (e.g. scripts) to an attacker controlled domain. Consider setting base-uri to 'none' or 'self'.",missingScriptSrc:"script-src directive is missing. This can allow the execution of unsafe scripts.",missingObjectSrc:"Missing object-src allows the injection of plugins that execute unsafe scripts. Consider setting object-src to 'none' if you can.",strictDynamic:"Host allowlists can frequently be bypassed. Consider using CSP nonces or hashes instead, along with 'strict-dynamic' if necessary.",
unsafeInline:"'unsafe-inline' allows the execution of unsafe in-page scripts and event handlers. Consider using CSP nonces or hashes to allow scripts individually.",unsafeInlineFallback:"Consider adding 'unsafe-inline' (ignored by browsers supporting nonces/hashes) to be backward compatible with older browsers.",allowlistFallback:"Consider adding https: and http: URL schemes (ignored by browsers supporting 'strict-dynamic') to be backward compatible with older browsers.",reportToOnly:"The reporting destination is only configured via the report-to directive. This directive is only supported in Chromium-based browsers so it is recommended to also use a report-uri directive.",reportingDestinationMissing:"No CSP configures a reporting destination. This makes it difficult to maintain the CSP over time and monitor for any breakages.",nonceLength:"Nonces should be at least 8 characters long.",nonceCharset:"Nonces should use the base64 charset.",
missingSemicolon:"Did you forget the semicolon? {keyword} seems to be a directive, not a keyword.",unknownDirective:"Unknown CSP directive.",unknownKeyword:"{keyword} seems to be an invalid keyword.",deprecatedReflectedXSS:"reflected-xss is deprecated since CSP2. Please, use the X-XSS-Protection header instead.",deprecatedReferrer:"referrer is deprecated since CSP2. Please, use the Referrer-Policy header instead.",deprecatedDisownOpener:"disown-opener is deprecated since CSP3. Please, use the Cross-Origin-Opener-Policy header instead.",plainWildcards:"Avoid using plain wildcards ({keyword}) in this directive. Plain wildcards allow scripts to be sourced from an unsafe domain.",plainUrlScheme:"Avoid using plain URL schemes ({keyword}) in this directive. Plain URL schemes allow scripts to be sourced from an unsafe domain."},h=m.createMessageInstanceIdFn(n,p),f={[c.MISSING_SEMICOLON]:p.missingSemicolon,[c.UNKNOWN_DIRECTIVE]:h(p.unknownDirective),[c.INVALID_KEYWORD]:p.unknownKeyword,
[c.MISSING_DIRECTIVES]:{[u.BASE_URI]:h(p.missingBaseUri),[u.SCRIPT_SRC]:h(p.missingScriptSrc),[u.OBJECT_SRC]:h(p.missingObjectSrc)},[c.SCRIPT_UNSAFE_INLINE]:h(p.unsafeInline),[c.PLAIN_WILDCARD]:p.plainWildcards,[c.PLAIN_URL_SCHEMES]:p.plainUrlScheme,[c.NONCE_LENGTH]:h(p.nonceLength),[c.NONCE_CHARSET]:h(p.nonceCharset),[c.DEPRECATED_DIRECTIVE]:{[u.REFLECTED_XSS]:h(p.deprecatedReflectedXSS),[u.REFERRER]:h(p.deprecatedReferrer),[u.DISOWN_OPENER]:h(p.deprecatedDisownOpener)},[c.STRICT_DYNAMIC]:h(p.strictDynamic),[c.UNSAFE_INLINE_FALLBACK]:h(p.unsafeInlineFallback),[c.ALLOWLIST_FALLBACK]:h(p.allowlistFallback),[c.REPORTING_DESTINATION_MISSING]:h(p.reportingDestinationMissing),[c.REPORT_TO_ONLY]:h(p.reportToOnly)};function parseCsp(e){return new l(e).csp}t.exports={getTranslatedDescription:function getTranslatedDescription(e){let t=f[e.type];return t?m.isIcuMessage(t)?t:"string"==typeof t?h(t,{keyword:e.value||""}):(t=t[e.directive],
t||(d.warn("CSP Evaluator","No translation found for description: "+e.description),e.description)):(d.warn("CSP Evaluator","No translation found for description: "+e.description),e.description)},evaluateRawCspsForXss:function evaluateRawCspsForXss(e){const t=e.map(parseCsp);return{bypasses:i(t),warnings:s(t),syntax:a(t)}},parseCsp,UIStrings:p}}).call(this)}).call(this,"/lighthouse-core/lib/csp-evaluator.js")},{"../lib/i18n/i18n.js":98,"csp_evaluator/dist/csp.js":154,"csp_evaluator/dist/finding.js":155,"csp_evaluator/dist/lighthouse/lighthouse_checks.js":156,"csp_evaluator/dist/parser.js":157,"lighthouse-logger":188}],88:[function(e,t,n){"use strict";class BaseNode{constructor(e){this._id=e,this._isMainDocument=!1,this._dependents=[],this._dependencies=[]}get id(){return this._id}get type(){throw new Error("Unimplemented")}get startTime(){throw new Error("Unimplemented")}get endTime(){throw new Error("Unimplemented")}setIsMainDocument(e){this._isMainDocument=e}isMainDocument(){
return this._isMainDocument}getDependents(){return this._dependents.slice()}getNumberOfDependents(){return this._dependents.length}getDependencies(){return this._dependencies.slice()}getNumberOfDependencies(){return this._dependencies.length}getRootNode(){let e=this;for(;e._dependencies.length;)e=e._dependencies[0];return e}addDependent(e){e.addDependency(this)}addDependency(e){if(e===this)throw new Error("Cannot add dependency on itself");this._dependencies.includes(e)||(e._dependents.push(this),this._dependencies.push(e))}removeDependent(e){e.removeDependency(this)}removeDependency(e){if(!this._dependencies.includes(e))return;const t=e._dependents.indexOf(this);e._dependents.splice(t,1),this._dependencies.splice(this._dependencies.indexOf(e),1)}removeAllDependencies(){for(const e of this._dependencies.slice())this.removeDependency(e)}isDependentOn(e){let t=!1;return this.traverse((n=>{t||(t=n===e)}),(e=>t?[]:e.getDependencies())),t}cloneWithoutRelationships(){
const e=new BaseNode(this.id);return e.setIsMainDocument(this._isMainDocument),e}cloneWithRelationships(e){const t=this.getRootNode(),n=new Map;t.traverse((t=>{n.has(t.id)||(void 0!==e?e(t)&&t.traverse((e=>n.set(e.id,e.cloneWithoutRelationships())),(e=>e._dependencies.filter((e=>!n.has(e.id))))):n.set(t.id,t.cloneWithoutRelationships()))})),t.traverse((e=>{const t=n.get(e.id);if(t)for(const i of e._dependencies){const e=n.get(i.id);if(!e)throw new Error("Dependency somehow not cloned");t.addDependency(e)}}));const i=n.get(this.id);if(!i)throw new Error("Cloned graph missing node");return i}traverse(e,t){for(const{node:n,traversalPath:i}of this.traverseGenerator(t))e(n,i)}*traverseGenerator(e){e||(e=e=>e.getDependents());const t=[[this]],n=new Set([this.id]);for(;t.length;){const i=t.shift(),a=i[0];yield{node:a,traversalPath:i};for(const s of e(a))n.has(s.id)||(n.add(s.id),t.push([s,...i]))}}static hasCycle(e,t="both"){
if("both"===t)return BaseNode.hasCycle(e,"dependents")||BaseNode.hasCycle(e,"dependencies");const n=new Set,i=[],a=[e],s=new Map([[e,0]]);for(;a.length;){const e=a.pop();if(i.includes(e))return!0;if(n.has(e))continue;for(;i.length>s.get(e);)i.pop();n.add(e),i.push(e);const c="dependents"===t?e._dependents:e._dependencies;for(const e of c)a.includes(e)||(a.push(e),s.set(e,i.length))}return!1}}BaseNode.TYPES={NETWORK:"network",CPU:"cpu"},t.exports=BaseNode},{}],89:[function(e,t,n){"use strict";const i=e("./base-node.js");class CPUNode extends i{constructor(e,t=[]){super(`${e.tid}.${e.ts}`),this._event=e,this._childEvents=t}get type(){return i.TYPES.CPU}get startTime(){return this._event.ts}get endTime(){return this._event.ts+this._event.dur}get event(){return this._event}get childEvents(){return this._childEvents}didPerformLayout(){return this._childEvents.some((e=>"Layout"===e.name))}getEvaluateScriptURLs(){const e=new Set
;for(const t of this._childEvents)"EvaluateScript"===t.name&&t.args.data&&t.args.data.url&&e.add(t.args.data.url);return e}cloneWithoutRelationships(){return new CPUNode(this._event,this._childEvents)}}t.exports=CPUNode},{"./base-node.js":88}],90:[function(e,t,n){"use strict";const i=e("./base-node.js"),a=e("../network-request.js");class NetworkNode extends i{constructor(e){super(e.requestId),this._record=e}get type(){return i.TYPES.NETWORK}get startTime(){return 1e3*this._record.startTime*1e3}get endTime(){return 1e3*this._record.endTime*1e3}get record(){return this._record}get initiatorType(){return this._record.initiator&&this._record.initiator.type}get fromDiskCache(){return!!this._record.fromDiskCache}get isNonNetworkProtocol(){return a.isNonNetworkRequest(this._record)}get isConnectionless(){return this.fromDiskCache||this.isNonNetworkProtocol}hasRenderBlockingPriority(){
const e=this._record.priority,t=this._record.resourceType===a.TYPES.Script,n=this._record.resourceType===a.TYPES.Document;return"VeryHigh"===e||"High"===e&&t||"High"===e&&n}cloneWithoutRelationships(){const e=new NetworkNode(this._record);return e.setIsMainDocument(this._isMainDocument),e}}t.exports=NetworkNode},{"../network-request.js":109,"./base-node.js":88}],91:[function(e,t,n){"use strict";const i=e("./network-analyzer.js"),a=e("./tcp-connection.js"),s=["https","wss"];t.exports=class ConnectionPool{constructor(e,t){this._options=t,this._records=e,this._connectionsByOrigin=new Map,this._connectionsByRecord=new Map,this._connectionsInUse=new Set,this._connectionReusedByRequestId=i.estimateIfConnectionWasReused(e,{forceCoarseEstimates:!0}),this._initializeConnections()}connectionsInUse(){return Array.from(this._connectionsInUse)}_initializeConnections(){
const e=this._connectionReusedByRequestId,t=this._options.additionalRttByOrigin,n=this._options.serverResponseTimeByOrigin,c=i.groupByOrigin(this._records);for(const[i,l]of c.entries()){const c=[],u=t.get(i)||0,d=n.get(i)||30;for(const t of l){if(e.get(t.requestId))continue;const n=s.includes(t.parsedURL.scheme),i="h2"===t.protocol,l=new a(this._options.rtt+u,this._options.throughput,d,n,i);c.push(l)}if(!c.length)throw new Error("Could not find a connection for origin: "+i);const m=c[0].isH2()?1:6;for(;c.length<m;)c.push(c[0].clone());this._connectionsByOrigin.set(i,c)}}_findAvailableConnectionWithLargestCongestionWindow(e,t){const{ignoreConnectionReused:n,observedConnectionWasReused:i}=t;let a=null;for(let t=0;t<e.length;t++){const s=e[t];if(!n&&s._warmed!==i)continue;if(this._connectionsInUse.has(s))continue;const c=a&&a.congestionWindow||-1/0;s.congestionWindow>c&&(a=s)}return a}acquire(e,t={}){if(this._connectionsByRecord.has(e))throw new Error("Record already has a connection")
;const n=e.parsedURL.securityOrigin,i=!!this._connectionReusedByRequestId.get(e.requestId),a=this._connectionsByOrigin.get(n)||[],s=this._findAvailableConnectionWithLargestCongestionWindow(a,{ignoreConnectionReused:t.ignoreConnectionReused,observedConnectionWasReused:i});return s?(this._connectionsInUse.add(s),this._connectionsByRecord.set(e,s),s):null}acquireActiveConnectionFromRecord(e){const t=this._connectionsByRecord.get(e);if(!t)throw new Error("Could not find an active connection for record");return t}release(e){const t=this._connectionsByRecord.get(e);this._connectionsByRecord.delete(e),this._connectionsInUse.delete(t)}}},{"./network-analyzer.js":93,"./tcp-connection.js":96}],92:[function(e,t,n){"use strict";class DNSCache{constructor({rtt:e}){this._rtt=e,this._resolvedDomainNames=new Map}getTimeUntilResolution(e,t){const{requestedAt:n=0,shouldUpdateCache:i=!1}=t||{},a=e.parsedURL.host,s=this._resolvedDomainNames.get(a);let c=this._rtt*DNSCache.RTT_MULTIPLIER;if(s){
const e=Math.max(s.resolvedAt-n,0);c=Math.min(e,c)}const l=n+c;return i&&this._updateCacheResolvedAtIfNeeded(e,l),c}_updateCacheResolvedAtIfNeeded(e,t){const n=e.parsedURL.host,i=this._resolvedDomainNames.get(n)||{resolvedAt:t};i.resolvedAt=Math.min(i.resolvedAt,t),this._resolvedDomainNames.set(n,i)}setResolvedAt(e,t){this._resolvedDomainNames.set(e,{resolvedAt:t})}}DNSCache.RTT_MULTIPLIER=2,t.exports=DNSCache},{}],93:[function(e,t,n){"use strict";const i=e("../../network-request.js"),a=e("../../url-shim.js"),s={Document:.9,XHR:.9,Fetch:.9};class NetworkAnalyzer{static get SUMMARY(){return"__SUMMARY__"}static groupByOrigin(e){const t=new Map;return e.forEach((e=>{const n=e.parsedURL.securityOrigin,i=t.get(n)||[];i.push(e),t.set(n,i)})),t}static getSummary(e){return e.sort(((e,t)=>e-t)),{min:e[0],max:e[e.length-1],avg:e.reduce(((e,t)=>e+t),0)/e.length,median:e[Math.floor((e.length-1)/2)]}}static summarize(e){const t=new Map,n=[];for(const[i,a]of e)t.set(i,NetworkAnalyzer.getSummary(a)),
n.push(...a);return t.set(NetworkAnalyzer.SUMMARY,NetworkAnalyzer.getSummary(n)),t}static _estimateValueByOrigin(e,t){const n=NetworkAnalyzer.estimateIfConnectionWasReused(e),i=NetworkAnalyzer.groupByOrigin(e),a=new Map;for(const[e,s]of i.entries()){let i=[];for(const e of s){const a=e.timing;if(!a)continue;const s=t({record:e,timing:a,connectionReused:n.get(e.requestId)});void 0!==s&&(i=i.concat(s))}i.length&&a.set(e,i)}return a}static _estimateRTTByOriginViaTCPTiming(e){return NetworkAnalyzer._estimateValueByOrigin(e,(({timing:e,connectionReused:t})=>{if(!t)return e.sslStart>0&&e.sslEnd>0?[e.connectEnd-e.sslStart,e.sslStart-e.connectStart]:e.connectStart>0&&e.connectEnd>0?e.connectEnd-e.connectStart:void 0}))}static _estimateRTTByOriginViaDownloadTiming(e){return NetworkAnalyzer._estimateValueByOrigin(e,(({record:e,timing:t,connectionReused:n})=>{if(n)return;if(e.transferSize<=14336)return;if(!Number.isFinite(t.receiveHeadersEnd)||t.receiveHeadersEnd<0)return
;const i=1e3*(e.endTime-e.startTime)-t.receiveHeadersEnd,a=Math.log2(e.transferSize/14336);return a>5?void 0:i/a}))}static _estimateRTTByOriginViaSendStartTiming(e){return NetworkAnalyzer._estimateValueByOrigin(e,(({record:e,timing:t,connectionReused:n})=>{if(n)return;if(!Number.isFinite(t.sendStart)||t.sendStart<0)return;let i=2;return"https"===e.parsedURL.scheme&&(i+=1),t.sendStart/i}))}static _estimateRTTByOriginViaHeadersEndTiming(e){return NetworkAnalyzer._estimateValueByOrigin(e,(({record:e,timing:t,connectionReused:n})=>{if(!Number.isFinite(t.receiveHeadersEnd)||t.receiveHeadersEnd<0)return;if(!e.resourceType)return;const i=s[e.resourceType]||.4,a=t.receiveHeadersEnd*i;let c=1;return n||(c+=1,"https"===e.parsedURL.scheme&&(c+=1),c+=1),Math.max((t.receiveHeadersEnd-a)/c,3)}))}static _estimateResponseTimeByOrigin(e,t){return NetworkAnalyzer._estimateValueByOrigin(e,(({record:e,timing:n})=>{if(!Number.isFinite(n.receiveHeadersEnd)||n.receiveHeadersEnd<0)return
;if(!Number.isFinite(n.sendEnd)||n.sendEnd<0)return;const i=n.receiveHeadersEnd-n.sendEnd,a=e.parsedURL.securityOrigin,s=t.get(a)||t.get(NetworkAnalyzer.SUMMARY)||0;return Math.max(i-s,0)}))}static canTrustConnectionInformation(e){const t=new Map;for(const n of e){const e=t.get(n.connectionId)||!n.connectionReused;t.set(n.connectionId,e)}return!(t.size<=1)&&Array.from(t.values()).every((e=>e))}static estimateIfConnectionWasReused(e,t){const{forceCoarseEstimates:n=!1}=t||{};if(!n&&NetworkAnalyzer.canTrustConnectionInformation(e))return new Map(e.map((e=>[e.requestId,!!e.connectionReused])));const i=new Map,a=NetworkAnalyzer.groupByOrigin(e);for(const[e,t]of a.entries()){const e=t.map((e=>e.endTime)).reduce(((e,t)=>Math.min(e,t)),1/0);for(const n of t)i.set(n.requestId,n.startTime>=e||"h2"===n.protocol);const n=t.reduce(((e,t)=>e.startTime>t.startTime?t:e));i.set(n.requestId,!1)}return i}static estimateRTTByOrigin(e,t){
const{forceCoarseEstimates:n=!1,coarseEstimateMultiplier:i=.3,useDownloadEstimates:a=!0,useSendStartEstimates:s=!0,useHeadersEndEstimates:c=!0}=t||{};let l=NetworkAnalyzer._estimateRTTByOriginViaTCPTiming(e);if(!l.size||n){l=new Map;const t=NetworkAnalyzer._estimateRTTByOriginViaDownloadTiming(e),n=NetworkAnalyzer._estimateRTTByOriginViaSendStartTiming(e),u=NetworkAnalyzer._estimateRTTByOriginViaHeadersEndTiming(e);for(const[e,n]of t.entries())a&&l.set(e,n);for(const[e,t]of n.entries()){if(!s)continue;const n=l.get(e)||[];l.set(e,n.concat(t))}for(const[e,t]of u.entries()){if(!c)continue;const n=l.get(e)||[];l.set(e,n.concat(t))}for(const e of l.values())e.forEach(((t,n)=>e[n]=t*i))}if(!l.size)throw new Error("No timing information available");return NetworkAnalyzer.summarize(l)}static estimateServerResponseTimeByOrigin(e,t){let n=(t||{}).rttByOrigin;if(!n){n=new Map;const i=NetworkAnalyzer.estimateRTTByOrigin(e,t);for(const[e,t]of i.entries())n.set(e,t.min)}
const i=NetworkAnalyzer._estimateResponseTimeByOrigin(e,n);return NetworkAnalyzer.summarize(i)}static estimateThroughput(e){let t=0;const n=e.reduce(((e,n)=>("data"===(n.parsedURL&&n.parsedURL.scheme)||n.failed||!n.finished||n.statusCode>300||!n.transferSize||(t+=n.transferSize,e.push({time:n.responseReceivedTime,isStart:!0}),e.push({time:n.endTime,isStart:!1})),e)),[]).sort(((e,t)=>e.time-t.time));if(!n.length)return 1/0;let i=0,a=0,s=0;return n.forEach((e=>{e.isStart?(0===i&&(a=e.time),i++):(i--,0===i&&(s+=e.time-a))})),8*t/s}static findMainDocument(e,t){const n=NetworkAnalyzer.findOptionalMainDocument(e,t);if(!n)throw new Error("Unable to identify the main resource");return n}static findOptionalMainDocument(e,t){if(t){const n=e.find((e=>t.startsWith(e.url)&&a.equalWithExcludedFragments(e.url,t)));if(n)return n}const n=e.filter((e=>e.resourceType===i.TYPES.Document));if(n.length)return n.reduce(((e,t)=>t.startTime<e.startTime?t:e))}static resolveRedirects(e){
for(;e.redirectDestination;)e=e.redirectDestination;return e}}t.exports=NetworkAnalyzer},{"../../network-request.js":109,"../../url-shim.js":"url"}],94:[function(e,t,n){"use strict";const i=e("../base-node.js");t.exports=class SimulatorTimingMap{constructor(){this._nodeTimings=new Map}getNodes(){return Array.from(this._nodeTimings.keys())}setReadyToStart(e,t){this._nodeTimings.set(e,t)}setInProgress(e,t){const n={...this.getQueued(e),startTime:t.startTime,timeElapsed:0};this._nodeTimings.set(e,e.type===i.TYPES.NETWORK?{...n,timeElapsedOvershoot:0,bytesDownloaded:0}:n)}setCompleted(e,t){const n={...this.getInProgress(e),endTime:t.endTime};this._nodeTimings.set(e,n)}setCpu(e,t){const n={...this.getCpuStarted(e),timeElapsed:t.timeElapsed};this._nodeTimings.set(e,n)}setCpuEstimated(e,t){const n={...this.getCpuStarted(e),estimatedTimeElapsed:t.estimatedTimeElapsed};this._nodeTimings.set(e,n)}setNetwork(e,t){const n={...this.getNetworkStarted(e),timeElapsed:t.timeElapsed,
timeElapsedOvershoot:t.timeElapsedOvershoot,bytesDownloaded:t.bytesDownloaded};this._nodeTimings.set(e,n)}setNetworkEstimated(e,t){const n={...this.getNetworkStarted(e),estimatedTimeElapsed:t.estimatedTimeElapsed};this._nodeTimings.set(e,n)}getQueued(e){const t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);return t}getCpuStarted(e){const t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if("bytesDownloaded"in t)throw new Error(`Node ${e.id} timing not valid`);return t}getNetworkStarted(e){const t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if(!("bytesDownloaded"in t))throw new Error(`Node ${e.id} timing not valid`);return t}getInProgress(e){const t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`)
;if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if(!("estimatedTimeElapsed"in t))throw new Error(`Node ${e.id} not yet in progress`);return t}getCompleted(e){const t=this._nodeTimings.get(e);if(!t)throw new Error(`Node ${e.id} not yet queued`);if(!("startTime"in t))throw new Error(`Node ${e.id} not yet started`);if(!("estimatedTimeElapsed"in t))throw new Error(`Node ${e.id} not yet in progress`);if(!("endTime"in t))throw new Error(`Node ${e.id} not yet completed`);return t}}},{"../base-node.js":88}],95:[function(e,t,n){"use strict";const i=e("../base-node.js"),a=e("./tcp-connection.js"),s=e("./connection-pool.js"),c=e("./dns-cache.js"),l=e("../../../config/constants.js").throttling.mobileSlow4G,u=e("./simulator-timing-map.js"),d={NotReadyToStart:0,ReadyToStart:1,InProgress:2,Complete:3},m={VeryHigh:0,High:.25,Medium:.5,Low:1,VeryLow:2},p=new Map;class Simulator{constructor(e){if(this._options=Object.assign({rtt:l.rttMs,throughput:1024*l.throughputKbps,
maximumConcurrentRequests:10,cpuSlowdownMultiplier:l.cpuSlowdownMultiplier,layoutTaskMultiplier:.5,additionalRttByOrigin:new Map,serverResponseTimeByOrigin:new Map},e),this._rtt=this._options.rtt,this._throughput=this._options.throughput,this._maximumConcurrentRequests=Math.max(Math.min(a.maximumSaturatedConnections(this._rtt,this._throughput),this._options.maximumConcurrentRequests),1),this._cpuSlowdownMultiplier=this._options.cpuSlowdownMultiplier,this._layoutTaskMultiplier=this._cpuSlowdownMultiplier*this._options.layoutTaskMultiplier,this._cachedNodeListByStartPosition=[],this._flexibleOrdering=!1,this._nodeTimings=new u,this._numberInProgressByType=new Map,this._nodes={},this._dns=new c({rtt:this._rtt}),this._connectionPool=null,!Number.isFinite(this._rtt))throw new Error("Invalid rtt "+this._rtt);if(!Number.isFinite(this._throughput))throw new Error("Invalid rtt "+this._throughput)}get rtt(){return this._rtt}_initializeConnectionPool(e){const t=[];e.getRootNode().traverse((e=>{
e.type===i.TYPES.NETWORK&&t.push(e.record)})),this._connectionPool=new s(t,this._options)}_initializeAuxiliaryData(){this._nodeTimings=new u,this._numberInProgressByType=new Map,this._nodes={},this._cachedNodeListByStartPosition=[];for(const e of Object.values(d))this._nodes[e]=new Set}_numberInProgress(e){return this._numberInProgressByType.get(e)||0}_markNodeAsReadyToStart(e,t){const n=Simulator._computeNodeStartPosition(e),i=this._cachedNodeListByStartPosition.findIndex((e=>Simulator._computeNodeStartPosition(e)>n)),a=-1===i?this._cachedNodeListByStartPosition.length:i;this._cachedNodeListByStartPosition.splice(a,0,e),this._nodes[d.ReadyToStart].add(e),this._nodes[d.NotReadyToStart].delete(e),this._nodeTimings.setReadyToStart(e,{queuedTime:t})}_markNodeAsInProgress(e,t){const n=this._cachedNodeListByStartPosition.indexOf(e);this._cachedNodeListByStartPosition.splice(n,1),this._nodes[d.InProgress].add(e),this._nodes[d.ReadyToStart].delete(e),
this._numberInProgressByType.set(e.type,this._numberInProgress(e.type)+1),this._nodeTimings.setInProgress(e,{startTime:t})}_markNodeAsComplete(e,t){this._nodes[d.Complete].add(e),this._nodes[d.InProgress].delete(e),this._numberInProgressByType.set(e.type,this._numberInProgress(e.type)-1),this._nodeTimings.setCompleted(e,{endTime:t});for(const n of e.getDependents()){n.getDependencies().some((e=>!this._nodes[d.Complete].has(e)))||this._markNodeAsReadyToStart(n,t)}}_acquireConnection(e){return this._connectionPool.acquire(e,{ignoreConnectionReused:this._flexibleOrdering})}_getNodesSortedByStartPosition(){return Array.from(this._cachedNodeListByStartPosition)}_startNodeIfPossible(e,t){if(e.type!==i.TYPES.CPU){if(e.type!==i.TYPES.NETWORK)throw new Error("Unsupported");if(!e.isConnectionless){if(this._numberInProgress(e.type)>=this._maximumConcurrentRequests)return;if(!this._acquireConnection(e.record))return}this._markNodeAsInProgress(e,t)
}else 0===this._numberInProgress(e.type)&&this._markNodeAsInProgress(e,t)}_updateNetworkCapacity(){for(const e of this._connectionPool.connectionsInUse())e.setThroughput(this._throughput/this._nodes[d.InProgress].size)}_estimateTimeRemaining(e){if(e.type===i.TYPES.CPU)return this._estimateCPUTimeRemaining(e);if(e.type===i.TYPES.NETWORK)return this._estimateNetworkTimeRemaining(e);throw new Error("Unsupported")}_estimateCPUTimeRemaining(e){const t=this._nodeTimings.getCpuStarted(e),n=e.didPerformLayout()?this._layoutTaskMultiplier:this._cpuSlowdownMultiplier,i=Math.min(Math.round(e.event.dur/1e3*n),1e4)-t.timeElapsed;return this._nodeTimings.setCpuEstimated(e,{estimatedTimeElapsed:i}),i}_estimateNetworkTimeRemaining(e){const t=e.record,n=this._nodeTimings.getNetworkStarted(e);let i=0;if(e.fromDiskCache){i=8+20*((t.resourceSize||0)/1024/1024)-n.timeElapsed}else if(e.isNonNetworkProtocol){i=2+10*((t.resourceSize||0)/1024/1024)-n.timeElapsed}else{
const e=this._connectionPool.acquireActiveConnectionFromRecord(t),a=this._dns.getTimeUntilResolution(t,{requestedAt:n.startTime,shouldUpdateCache:!0}),s=n.timeElapsed;i=e.simulateDownloadUntil(t.transferSize-n.bytesDownloaded,{timeAlreadyElapsed:s,dnsResolutionTime:a,maximumTimeToElapse:1/0}).timeElapsed}const a=i+n.timeElapsedOvershoot;return this._nodeTimings.setNetworkEstimated(e,{estimatedTimeElapsed:a}),a}_findNextNodeCompletionTime(){let e=1/0;for(const t of this._nodes[d.InProgress])e=Math.min(e,this._estimateTimeRemaining(t));return e}_updateProgressMadeInTimePeriod(e,t,n){const a=this._nodeTimings.getInProgress(e),s=a.estimatedTimeElapsed===t;if(e.type===i.TYPES.CPU||e.isConnectionless)return s?this._markNodeAsComplete(e,n):a.timeElapsed+=t;if(e.type!==i.TYPES.NETWORK)throw new Error("Unsupported");if(!("bytesDownloaded"in a))throw new Error("Invalid timing data")
;const c=e.record,l=this._connectionPool.acquireActiveConnectionFromRecord(c),u=this._dns.getTimeUntilResolution(c,{requestedAt:a.startTime,shouldUpdateCache:!0}),d=l.simulateDownloadUntil(c.transferSize-a.bytesDownloaded,{dnsResolutionTime:u,timeAlreadyElapsed:a.timeElapsed,maximumTimeToElapse:t-a.timeElapsedOvershoot});l.setCongestionWindow(d.congestionWindow),l.setH2OverflowBytesDownloaded(d.extraBytesDownloaded),s?(l.setWarmed(!0),this._connectionPool.release(c),this._markNodeAsComplete(e,n)):(a.timeElapsed+=d.timeElapsed,a.timeElapsedOvershoot+=d.timeElapsed-t,a.bytesDownloaded+=d.bytesDownloaded)}_computeFinalNodeTimings(){const e=[];for(const t of this._nodeTimings.getNodes()){const n=this._nodeTimings.getCompleted(t);e.push([t,{startTime:n.startTime,endTime:n.endTime,duration:n.endTime-n.startTime}])}return e.sort(((e,t)=>e[1].startTime-t[1].startTime)),new Map(e)}getOptions(){return this._options}simulate(e,t){
if(i.hasCycle(e))throw new Error("Cannot simulate graph with cycle");t=Object.assign({label:void 0,flexibleOrdering:!1},t),this._flexibleOrdering=!!t.flexibleOrdering,this._dns=new c({rtt:this._rtt}),this._initializeConnectionPool(e),this._initializeAuxiliaryData();const n=this._nodes[d.NotReadyToStart],a=this._nodes[d.ReadyToStart],s=this._nodes[d.InProgress],l=e.getRootNode();l.traverse((e=>n.add(e)));let u=0,m=0;for(this._markNodeAsReadyToStart(l,u);a.size||s.size;){for(const e of this._getNodesSortedByStartPosition())this._startNodeIfPossible(e,u);if(!s.size){if(this._flexibleOrdering)throw new Error("Failed to start a node");this._flexibleOrdering=!0;continue}this._updateNetworkCapacity();const e=this._findNextNodeCompletionTime();if(u+=e,!Number.isFinite(e)||m>1e5)throw new Error("Simulation failed, depth exceeded");m++;for(const t of s)this._updateProgressMadeInTimePeriod(t,e,u)}const h=this._computeFinalNodeTimings();return p.set(t.label||"unlabeled",h),{timeInMs:u,
nodeTimings:h}}static get ALL_NODE_TIMINGS(){return p}static _computeNodeStartPosition(e){return"cpu"===e.type?e.startTime:e.startTime+(1e3*m[e.record.priority]*1e3||0)}}t.exports=Simulator},{"../../../config/constants.js":56,"../base-node.js":88,"./connection-pool.js":91,"./dns-cache.js":92,"./simulator-timing-map.js":94,"./tcp-connection.js":96}],96:[function(e,t,n){"use strict";const i=1460;class TcpConnection{constructor(e,t,n=0,i=!0,a=!1){this._warmed=!1,this._ssl=i,this._h2=a,this._rtt=e,this._throughput=t,this._serverLatency=n,this._congestionWindow=10,this._h2OverflowBytesDownloaded=0}static maximumSaturatedConnections(e,t){const n=8*(1460*(1e3/e));return Math.floor(t/n)}_computeMaximumCongestionWindowInSegments(){const e=this._throughput/8*(this._rtt/1e3);return Math.floor(e/i)}setThroughput(e){this._throughput=e}setCongestionWindow(e){this._congestionWindow=e}setWarmed(e){this._warmed=e}isWarm(){return this._warmed}isH2(){return this._h2}get congestionWindow(){
return this._congestionWindow}setH2OverflowBytesDownloaded(e){this._h2&&(this._h2OverflowBytesDownloaded=e)}clone(){return Object.assign(new TcpConnection(this._rtt,this._throughput),this)}simulateDownloadUntil(e,t){const{timeAlreadyElapsed:n=0,maximumTimeToElapse:a=1/0,dnsResolutionTime:s=0}=t||{};this._warmed&&this._h2&&(e-=this._h2OverflowBytesDownloaded);const c=this._rtt,l=c/2,u=this._computeMaximumCongestionWindowInSegments();let d=l;this._warmed||(d=s+l+l+l+(this._ssl?c:0));let m=Math.ceil(d/c),p=d+this._serverLatency+l;this._warmed&&this._h2&&(p=0);const h=Math.max(p-n,0),f=a-h;let g=Math.min(this._congestionWindow,u),y=0;h>0?y=g*i:m=0;let b=0,v=e-y;for(;v>0&&b<=f;){m++,b+=c,g=Math.max(Math.min(u,2*g),1);const e=g*i;y+=e,v-=e}const w=h+b,S=this._h2?Math.max(y-e,0):0;return{roundTrips:m,timeElapsed:w,bytesDownloaded:Math.max(Math.min(y,e),0),extraBytesDownloaded:S,congestionWindow:g}}}t.exports=TcpConnection},{}],97:[function(e,t,n){"use strict";const i={latency:0,
downloadThroughput:0,uploadThroughput:0,offline:!1},a={rate:1};function enableNetworkThrottling(e,t){const n={offline:!1,latency:t.requestLatencyMs||0,downloadThroughput:t.downloadThroughputKbps||0,uploadThroughput:t.uploadThroughputKbps||0};return n.downloadThroughput=Math.floor(1024*n.downloadThroughput/8),n.uploadThroughput=Math.floor(1024*n.uploadThroughput/8),e.sendCommand("Network.emulateNetworkConditions",n)}function clearNetworkThrottling(e){return e.sendCommand("Network.emulateNetworkConditions",i)}function enableCPUThrottling(e,t){const n=t.cpuSlowdownMultiplier;return e.sendCommand("Emulation.setCPUThrottlingRate",{rate:n})}function clearCPUThrottling(e){return e.sendCommand("Emulation.setCPUThrottlingRate",a)}t.exports={emulate:async function emulate(e,t){if(!1!==t.emulatedUserAgent&&await e.sendCommand("Network.setUserAgentOverride",{userAgent:t.emulatedUserAgent}),!0!==t.screenEmulation.disabled){const{width:n,height:i,deviceScaleFactor:a,mobile:s}=t.screenEmulation,c={
width:n,height:i,deviceScaleFactor:a,mobile:s};await e.sendCommand("Emulation.setDeviceMetricsOverride",c),await e.sendCommand("Emulation.setTouchEmulationEnabled",{enabled:c.mobile})}},throttle:async function throttle(e,t){if("devtools"!==t.throttlingMethod)return clearNetworkThrottling(e);await Promise.all([enableNetworkThrottling(e,t.throttling),enableCPUThrottling(e,t.throttling)])},clearThrottling:async function clearThrottling(e){await Promise.all([clearNetworkThrottling(e),clearCPUThrottling(e)])},enableNetworkThrottling,clearNetworkThrottling,enableCPUThrottling,clearCPUThrottling}},{}],98:[function(e,t,n){(function(n){(function(){"use strict";const i=e("path"),a=e("intl-messageformat").default,s=e("lookup-closest-locale"),c=e("./locales.js"),{isObjectOfUnknownValues:l,isObjectOrArrayOfUnknownValues:u}=e("../type-verifiers.js"),d=e("lighthouse-logger"),{LH_ROOT:m}=e("../../../root.js"),p="en",h=/ | [^\s]+$/,f={ms:"{timeInMs, number, milliseconds} ms",
seconds:"{timeInMs, number, seconds} s",displayValueByteSavings:"Potential savings of {wastedBytes, number, bytes} KiB",displayValueMsSavings:"Potential savings of {wastedMs, number, milliseconds} ms",displayValueElementsFound:"{nodeCount, plural, =1 {1 element found} other {# elements found}}",columnURL:"URL",columnSize:"Size",columnResourceSize:"Resource Size",columnTransferSize:"Transfer Size",columnCacheTTL:"Cache TTL",columnWastedBytes:"Potential Savings",columnWastedMs:"Potential Savings",columnBlockingTime:"Main-Thread Blocking Time",columnTimeSpent:"Time Spent",columnLocation:"Location",columnResourceType:"Resource Type",columnRequests:"Requests",columnName:"Name",columnSource:"Source",columnOverBudget:"Over Budget",columnElement:"Element",columnStartTime:"Start Time",columnDuration:"Duration",columnFailingElem:"Failing Elements",columnDescription:"Description",totalResourceType:"Total",documentResourceType:"Document",scriptResourceType:"Script",
stylesheetResourceType:"Stylesheet",imageResourceType:"Image",mediaResourceType:"Media",fontResourceType:"Font",otherResourceType:"Other",thirdPartyResourceType:"Third-party",otherResourcesLabel:"Other resources",firstContentfulPaintMetric:"First Contentful Paint",interactiveMetric:"Time to Interactive",firstMeaningfulPaintMetric:"First Meaningful Paint",totalBlockingTimeMetric:"Total Blocking Time",maxPotentialFIDMetric:"Max Potential First Input Delay",speedIndexMetric:"Speed Index",largestContentfulPaintMetric:"Largest Contentful Paint",cumulativeLayoutShiftMetric:"Cumulative Layout Shift",itemSeverityLow:"Low",itemSeverityMedium:"Medium",itemSeverityHigh:"High"},g={number:{bytes:{maximumFractionDigits:0},milliseconds:{maximumFractionDigits:0},seconds:{minimumFractionDigits:1,maximumFractionDigits:1},extendedPercent:{maximumFractionDigits:2,style:"percent"}}};function collectAllCustomElementsFromICU(e,t=new Map){for(const n of e)if("argumentElement"===n.type&&(t.set(n.id,n),
n.format&&"pluralFormat"===n.format.type))for(const e of n.format.options)collectAllCustomElementsFromICU(e.value.elements,t);return t}function _formatMessage(e,t={},n){const i=new a(e,"en-XA"===n||"en-XL"===n?"de-DE":n,g),s=function _preformatValues(e,t,n){const i=[...collectAllCustomElementsFromICU(e.getAst().elements).values()],a={};for(const{id:e,format:s}of i){if(e&&e in t==0)throw new Error(`ICU Message "${n}" contains a value reference ("${e}") that wasn't provided`);const i=t[e];if(s&&"numberFormat"===s.type){if("number"!=typeof i)throw new Error(`ICU Message "${n}" contains a numeric reference ("${e}") but provided value was not a number`);"milliseconds"===s.style?a[e]=10*Math.round(i/10):"seconds"===s.style&&"timeInMs"===e?a[e]=Math.round(i/100)/10:"bytes"===s.style?a[e]=i/1024:a[e]=i}else a[e]=i}for(const e of Object.keys(t))if(!(e in a)){if("errorCode"!==e)throw new Error(`Provided value "${e}" does not match any placeholder in ICU message "${n}"`);a.errorCode=t.errorCode}
return a}(i,t,e);return i.format(s)}function _localizeIcuMessage(e,t){const n=c[t];if(!n)throw new Error(`Unsupported locale '${t}'`);const i=n[e.i18nId];return i?_formatMessage(i.message,e.values,t):e.formattedDefault}function _formatPathAsString(e){let t="";for(const n of e)if(/^[a-z]+$/i.test(n))t.length&&(t+="."),t+=n;else{if(/]|"|'|\s/.test(n))throw new Error(`Cannot handle "${n}" in i18n`);t+=`[${n}]`}return t}function createIcuMessageFn(e,t){const a={...f,...t};return(s,c)=>{const l=Object.keys(a).find((e=>a[e]===s));if(!l)throw new Error("Could not locate: "+s);const u=l in t?e:n;return{i18nId:`${i.relative(m,u).replace(/\\/g,"/")} | ${l}`,values:c,formattedDefault:_formatMessage(s,c,p)}}}function isIcuMessage(e){if(!l(e))return!1;const{i18nId:t,values:n,formattedDefault:i}=e;if("string"!=typeof t)return!1;if("string"!=typeof i)return!1;if(void 0!==n){if(!l(n))return!1;for(const e of Object.values(n))if("string"!=typeof e&&"number"!=typeof e)return!1}return h.test(t)}
t.exports={_formatPathAsString,UIStrings:f,lookupLocale:function lookupLocale(e){if("object"!=typeof Intl)throw new Error("Lighthouse must be run in Node with `Intl` support. See https://nodejs.org/api/intl.html for help");const t=Intl.getCanonicalLocales(e),n=Intl.NumberFormat.supportedLocalesOf(t),i=s(n,c);return i||(0===Intl.NumberFormat.supportedLocalesOf("es").length&&d.warn("i18n","Requested locale not available in this version of node. The `full-icu` npm module can provide additional locales. For help, see https://github.com/GoogleChrome/lighthouse/blob/master/readme.md#how-do-i-get-localized-lighthouse-results-via-the-cli"),d.warn("i18n",`locale(s) '${e}' not available. Falling back to default 'en'`)),i||p},getRendererFormattedStrings:function getRendererFormattedStrings(e){const t=c[e];if(!t)throw new Error(`Unsupported locale '${e}'`);const n=Object.keys(t).filter((e=>e.startsWith("report/"))),i={};for(const e of n){const[n,a]=e.split(" | ")
;if(!n.endsWith("util.js"))throw new Error("Unexpected message: "+e);i[a]=t[e].message}return i},createIcuMessageFn,getFormatted:function getFormatted(e,t){if(isIcuMessage(e))return _localizeIcuMessage(e,t);if("string"==typeof e)return e;throw new Error("Attempted to format invalid icuMessage type")},replaceIcuMessages:function replaceIcuMessages(e,t){const n={};return function replaceInObject(e,n,i=[]){if(u(e))for(const[a,s]of Object.entries(e)){const c=i.concat([a]);if(isIcuMessage(s)){const i=_localizeIcuMessage(s,t),l=n[s.i18nId]||[],u=_formatPathAsString(c);l.push(s.values?{values:s.values,path:u}:u),e[a]=i,n[s.i18nId]=l}else replaceInObject(s,n,c)}}(e,n),n},isIcuMessage,collectAllCustomElementsFromICU,registerLocaleData:function registerLocaleData(e,t){c[e]=t},isStringOrIcuMessage:function isStringOrIcuMessage(e){return"string"==typeof e||isIcuMessage(e)},createMessageInstanceIdFn:createIcuMessageFn}}).call(this)}).call(this,"/lighthouse-core/lib/i18n/i18n.js")},{
"../../../root.js":261,"../type-verifiers.js":121,"./locales.js":99,"intl-messageformat":180,"lighthouse-logger":188,"lookup-closest-locale":218,path:222}],99:[function(e,t,n){"use strict";const i={ar:JSON.parse("{}"),"ar-XB":JSON.parse("{}"),bg:JSON.parse("{}"),ca:JSON.parse("{}"),cs:JSON.parse("{}"),da:JSON.parse("{}"),de:JSON.parse("{}"),el:JSON.parse("{}"),"en-GB":JSON.parse("{}"),"en-US":JSON.parse("{}"),"en-XA":JSON.parse("{}"),"en-XL":JSON.parse("{}"),es:JSON.parse("{}"),"es-419":JSON.parse("{}"),fi:JSON.parse("{}"),fil:JSON.parse("{}"),fr:JSON.parse("{}"),he:JSON.parse("{}"),hi:JSON.parse("{}"),hr:JSON.parse("{}"),hu:JSON.parse("{}"),id:JSON.parse("{}"),it:JSON.parse("{}"),ja:JSON.parse("{}"),ko:JSON.parse("{}"),lt:JSON.parse("{}"),lv:JSON.parse("{}"),nl:JSON.parse("{}"),no:JSON.parse("{}"),pl:JSON.parse("{}"),pt:JSON.parse("{}"),"pt-PT":JSON.parse("{}"),ro:JSON.parse("{}"),ru:JSON.parse("{}"),sk:JSON.parse("{}"),sl:JSON.parse("{}"),sr:JSON.parse("{}"),
"sr-Latn":JSON.parse("{}"),sv:JSON.parse("{}"),ta:JSON.parse("{}"),te:JSON.parse("{}"),th:JSON.parse("{}"),tr:JSON.parse("{}"),uk:JSON.parse("{}"),vi:JSON.parse("{}"),zh:JSON.parse("{}"),"zh-HK":JSON.parse("{}"),"zh-TW":JSON.parse("{}")},a={"en-US":i["en-US"],en:i["en-US"],"en-AU":i["en-GB"],"en-GB":i["en-GB"],"en-IE":i["en-GB"],"en-SG":i["en-GB"],"en-ZA":i["en-GB"],"en-IN":i["en-GB"],"ar-XB":i["ar-XB"],ar:i.ar,bg:i.bg,ca:i.ca,cs:i.cs,da:i.da,de:i.de,el:i.el,"en-XA":i["en-XA"],"en-XL":i["en-XL"],es:i.es,"es-419":i["es-419"],"es-AR":i["es-419"],"es-BO":i["es-419"],"es-BR":i["es-419"],"es-BZ":i["es-419"],"es-CL":i["es-419"],"es-CO":i["es-419"],"es-CR":i["es-419"],"es-CU":i["es-419"],"es-DO":i["es-419"],"es-EC":i["es-419"],"es-GT":i["es-419"],"es-HN":i["es-419"],"es-MX":i["es-419"],"es-NI":i["es-419"],"es-PA":i["es-419"],"es-PE":i["es-419"],"es-PR":i["es-419"],"es-PY":i["es-419"],"es-SV":i["es-419"],"es-US":i["es-419"],"es-UY":i["es-419"],"es-VE":i["es-419"],fi:i.fi,fil:i.fil,fr:i.fr,
he:i.he,hi:i.hi,hr:i.hr,hu:i.hu,gsw:i.de,id:i.id,in:i.id,it:i.it,iw:i.he,ja:i.ja,ko:i.ko,lt:i.lt,lv:i.lv,mo:i.ro,nl:i.nl,nb:i.no,no:i.no,pl:i.pl,pt:i.pt,"pt-PT":i["pt-PT"],ro:i.ro,ru:i.ru,sk:i.sk,sl:i.sl,sr:i.sr,"sr-Latn":i["sr-Latn"],sv:i.sv,ta:i.ta,te:i.te,th:i.th,tl:i.fil,tr:i.tr,uk:i.uk,vi:i.vi,zh:i.zh,"zh-HK":i["zh-HK"],"zh-TW":i["zh-TW"]};t.exports=a},{}],100:[function(e,t,n){"use strict";const i=e("./url-shim.js");t.exports={doExist:function doExist(e){return!(!e||!e.icons)&&0!==e.icons.value.length},pngSizedAtLeast:function pngSizedAtLeast(e,t){const n=t.icons.value,a=[];return n.filter((e=>{const t=e.value.type.value;if(t)return"image/png"===t;const n=e.value.src.value;return n&&new i(n).pathname.endsWith(".png")})).forEach((e=>{e.value.sizes.value&&a.push(...e.value.sizes.value)})),a.filter((e=>/\d+x\d+/.test(e))).filter((t=>{const n=t.split(/x/i),i=[parseFloat(n[0]),parseFloat(n[1])];return i[0]>=e&&i[1]>=e&&i[0]===i[1]}))},
containsMaskableIcon:function containsMaskableIcon(e){return e.icons.value.some((e=>e.value.purpose&&e.value.purpose.value&&e.value.purpose.value.includes("maskable")))}}},{"./url-shim.js":"url"}],101:[function(e,t,n){"use strict";t.exports={simulationNamesToIgnore:["unlabeled","optimisticSpeedIndex","optimisticFlexSpeedIndex","pessimisticSpeedIndex"],convertNodeTimingsToTrace:function convertNodeTimingsToTrace(e){const t=[],n=1e9,i={pid:1,tid:1,cat:"devtools.timeline"},a="A00001",toMicroseconds=e=>n+1e3*e;t.push(createFakeTracingStartedEvent()),t.push({...createFakeTracingStartedEvent(),name:"TracingStartedInBrowser"});let s=1,c=0;for(const[n,i]of e.entries())if(c=Math.max(c,i.endTime),"cpu"===n.type)t.push(...createFakeTaskEvents(n,i));else{if(/^data/.test(n.record.url))continue;t.push(...createFakeNetworkEvents(n.record,i))}return t.push(...createFakeTaskEvents({childEvents:[],event:{}},{startTime:c+1e3,endTime:c+1001})),{traceEvents:t};function createFakeTracingStartedEvent(){
const e={frameTreeNodeId:1,sessionId:"1.1",page:a,persistentIds:!0,frames:[{frame:a,url:"about:blank",name:"",processId:1}]};return{...i,ts:9999e5,ph:"I",s:"t",cat:"disabled-by-default-devtools.timeline",name:"TracingStartedInPage",args:{data:e},dur:0}}function createFakeTaskEvents(e,t){const n={url:"",frame:a,lineNumber:0,columnNumber:0},s=toMicroseconds(t.startTime),c=[{...i,ph:"X",name:"Task",ts:s,dur:1e3*(t.endTime-t.startTime),args:{data:n}}],l=e.event.ts||0,u=1e3*(t.endTime-t.startTime)/e.event.dur,d=new Set(["ResourceSendRequest","ResourceFinish","ResourceReceiveResponse","ResourceReceivedData"]);for(const t of e.childEvents){if(d.has(t.name))continue;const e=s+(t.ts-l)*u,n={...t,pid:i.pid,tid:i.tid,ts:e};t.dur&&(n.dur=t.dur*u),c.push(n)}return c}function createFakeNetworkEvents(e,t){s++;let{startTime:n,endTime:c}=t;n===c&&(c+=.3);const l={requestId:s.toString(),frame:a},u={...i,ph:"I",s:"t",dur:0},d={...l,requestMethod:e.requestMethod,url:e.url,priority:e.priority},m={...l,
statusCode:e.statusCode,mimeType:e.mimeType,encodedDataLength:e.transferSize,fromCache:e.fromDiskCache,fromServiceWorker:e.fetchedViaServiceWorker},p={...l,decodedBodyLength:e.resourceSize,didFail:!!e.failed,finishTime:c},h=[{...u,name:"ResourceSendRequest",ts:toMicroseconds(n),args:{data:d}},{...u,name:"ResourceFinish",ts:toMicroseconds(c),args:{data:p}}];return e.failed||h.push({...u,name:"ResourceReceiveResponse",ts:toMicroseconds((n+c)/2),args:{data:m}}),h}}}},{}],102:[function(e,t,n){(function(e){(function(){"use strict";t.exports={isUnderTest:!!e.env.CI||"test"===e.env.NODE_ENV}}).call(this)}).call(this,e("_process"))},{_process:223}],103:[function(e,t,n){(function(n){(function(){"use strict";const i={didntCollectScreenshots:"Chrome didn't collect any screenshots during the page load. Please make sure there is content visible on the page, and then try re-running Lighthouse. ({errorCode})",
badTraceRecording:"Something went wrong with recording the trace over your page load. Please run Lighthouse again. ({errorCode})",noFcp:"The page did not paint any content. Please ensure you keep the browser window in the foreground during the load and try again. ({errorCode})",pageLoadTookTooLong:"Your page took too long to load. Please follow the opportunities in the report to reduce your page load time, and then try re-running Lighthouse. ({errorCode})",pageLoadFailed:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests.",pageLoadFailedWithStatusCode:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests. (Status code: {statusCode})",
pageLoadFailedWithDetails:"Lighthouse was unable to reliably load the page you requested. Make sure you are testing the correct URL and that the server is properly responding to all requests. (Details: {errorDetails})",pageLoadFailedInsecure:"The URL you have provided does not have a valid security certificate. {securityMessages}",pageLoadFailedInterstitial:"Chrome prevented page load with an interstitial. Make sure you are testing the correct URL and that the server is properly responding to all requests.",internalChromeError:"An internal Chrome error occurred. Please restart Chrome and try re-running Lighthouse.",requestContentTimeout:"Fetching resource content has exceeded the allotted time",notHtml:"The page provided is not HTML (served as MIME type {mimeType}).",urlInvalid:"The URL you have provided appears to be invalid.",protocolTimeout:"Waiting for DevTools protocol response has exceeded the allotted time. (Method: {protocolMethod})",
dnsFailure:"DNS servers could not resolve the provided domain.",pageLoadFailedHung:"Lighthouse was unable to reliably load the URL you requested because the page stopped responding.",criTimeout:"Timeout waiting for initial Debugger Protocol connection.",missingRequiredArtifact:"Required {artifactName} gatherer did not run.",erroredRequiredArtifact:"Required {artifactName} gatherer encountered an error: {errorMessage}",oldChromeDoesNotSupportFeature:"This version of Chrome is too old to support '{featureName}'. Use a newer version to see full results."},a=e("./i18n/i18n.js").createMessageInstanceIdFn(n,i),s="__LighthouseErrorSentinel",c="__ErrorSentinel";class LighthouseError extends Error{constructor(e,t){super(e.code),this.name="LHError",this.code=e.code,this.friendlyMessage=a(e.message,{errorCode:this.code,...t}),this.lhrRuntimeError=!!e.lhrRuntimeError,t&&Object.assign(this,t),Error.captureStackTrace(this,LighthouseError)}static fromProtocolMessage(e,t){
const n=Object.values(LighthouseError.errors).filter((e=>e.pattern)).find((e=>e.pattern&&e.pattern.test(t.message)));if(n)return new LighthouseError(n);let i=`(${e}): ${t.message}`;t.data&&(i+=` (${t.data})`);const a=new Error("Protocol error "+i);return Object.assign(a,{protocolMethod:e,protocolError:t.message})}static stringifyReplacer(e){if(e instanceof LighthouseError){const{name:t,code:n,message:i,friendlyMessage:a,lhrRuntimeError:c,stack:l,...u}=e;return{sentinel:s,code:n,stack:l,...u}}if(e instanceof Error){const{message:t,stack:n}=e,i=e.code;return{sentinel:c,message:t,code:i,stack:n}}throw new Error("Invalid value for LHError stringification")}static parseReviver(e,t){if("object"==typeof t&&null!==t){if(t.sentinel===s){const{sentinel:e,code:n,stack:i,...a}=t,s=LighthouseError.errors[n],c=new LighthouseError(s,a);return c.stack=i,c}if(t.sentinel===c){const{message:e,code:n,stack:i}=t,a=new Error(e);return Object.assign(a,{code:n,stack:i}),a}}return t}}const l={
NO_SPEEDLINE_FRAMES:{code:"NO_SPEEDLINE_FRAMES",message:i.didntCollectScreenshots,lhrRuntimeError:!0},SPEEDINDEX_OF_ZERO:{code:"SPEEDINDEX_OF_ZERO",message:i.didntCollectScreenshots,lhrRuntimeError:!0},NO_SCREENSHOTS:{code:"NO_SCREENSHOTS",message:i.didntCollectScreenshots,lhrRuntimeError:!0},INVALID_SPEEDLINE:{code:"INVALID_SPEEDLINE",message:i.didntCollectScreenshots,lhrRuntimeError:!0},NO_TRACING_STARTED:{code:"NO_TRACING_STARTED",message:i.badTraceRecording,lhrRuntimeError:!0},NO_RESOURCE_REQUEST:{code:"NO_RESOURCE_REQUEST",message:i.badTraceRecording,lhrRuntimeError:!0},NO_NAVSTART:{code:"NO_NAVSTART",message:i.badTraceRecording,lhrRuntimeError:!0},NO_FCP:{code:"NO_FCP",message:i.noFcp,lhrRuntimeError:!0},NO_DCL:{code:"NO_DCL",message:i.badTraceRecording,lhrRuntimeError:!0},NO_FMP:{code:"NO_FMP",message:i.badTraceRecording},NO_LCP:{code:"NO_LCP",message:i.badTraceRecording},NO_LCP_ALL_FRAMES:{code:"NO_LCP_ALL_FRAMES",message:i.badTraceRecording},UNSUPPORTED_OLD_CHROME:{
code:"UNSUPPORTED_OLD_CHROME",message:i.oldChromeDoesNotSupportFeature},NO_TTI_CPU_IDLE_PERIOD:{code:"NO_TTI_CPU_IDLE_PERIOD",message:i.pageLoadTookTooLong},NO_TTI_NETWORK_IDLE_PERIOD:{code:"NO_TTI_NETWORK_IDLE_PERIOD",message:i.pageLoadTookTooLong},NO_DOCUMENT_REQUEST:{code:"NO_DOCUMENT_REQUEST",message:i.pageLoadFailed,lhrRuntimeError:!0},FAILED_DOCUMENT_REQUEST:{code:"FAILED_DOCUMENT_REQUEST",message:i.pageLoadFailedWithDetails,lhrRuntimeError:!0},ERRORED_DOCUMENT_REQUEST:{code:"ERRORED_DOCUMENT_REQUEST",message:i.pageLoadFailedWithStatusCode,lhrRuntimeError:!0},INSECURE_DOCUMENT_REQUEST:{code:"INSECURE_DOCUMENT_REQUEST",message:i.pageLoadFailedInsecure,lhrRuntimeError:!0},CHROME_INTERSTITIAL_ERROR:{code:"CHROME_INTERSTITIAL_ERROR",message:i.pageLoadFailedInterstitial,lhrRuntimeError:!0},PAGE_HUNG:{code:"PAGE_HUNG",message:i.pageLoadFailedHung,lhrRuntimeError:!0},NOT_HTML:{code:"NOT_HTML",message:i.notHtml,lhrRuntimeError:!0},TRACING_ALREADY_STARTED:{code:"TRACING_ALREADY_STARTED",
message:i.internalChromeError,pattern:/Tracing.*started/,lhrRuntimeError:!0},PARSING_PROBLEM:{code:"PARSING_PROBLEM",message:i.internalChromeError,pattern:/Parsing problem/,lhrRuntimeError:!0},READ_FAILED:{code:"READ_FAILED",message:i.internalChromeError,pattern:/Read failed/,lhrRuntimeError:!0},INVALID_URL:{code:"INVALID_URL",message:i.urlInvalid},PROTOCOL_TIMEOUT:{code:"PROTOCOL_TIMEOUT",message:i.protocolTimeout,lhrRuntimeError:!0},DNS_FAILURE:{code:"DNS_FAILURE",message:i.dnsFailure,lhrRuntimeError:!0},CRI_TIMEOUT:{code:"CRI_TIMEOUT",message:i.criTimeout,lhrRuntimeError:!0},MISSING_REQUIRED_ARTIFACT:{code:"MISSING_REQUIRED_ARTIFACT",message:i.missingRequiredArtifact},ERRORED_REQUIRED_ARTIFACT:{code:"ERRORED_REQUIRED_ARTIFACT",message:i.erroredRequiredArtifact}};LighthouseError.errors=l,LighthouseError.NO_ERROR="NO_ERROR",LighthouseError.UNKNOWN_ERROR="UNKNOWN_ERROR",t.exports=LighthouseError,t.exports.UIStrings=i}).call(this)}).call(this,"/lighthouse-core/lib/lh-error.js")},{
"./i18n/i18n.js":98}],104:[function(e,t,n){"use strict";const i=e("../lib/lh-error.js"),a=e("../lib/tracehouse/trace-processor.js");t.exports=class LHTraceProcessor extends a{static createNoNavstartError(){return new i(i.errors.NO_NAVSTART)}static createNoResourceSendRequestError(){return new i(i.errors.NO_RESOURCE_REQUEST)}static createNoTracingStartedError(){return new i(i.errors.NO_TRACING_STARTED)}static createNoFirstContentfulPaintError(){return new i(i.errors.NO_FCP)}}},{"../lib/lh-error.js":103,"../lib/tracehouse/trace-processor.js":119}],105:[function(e,t,n){"use strict";const i=e("./url-shim.js"),a=e("cssstyle/lib/parsers"),s=["fullscreen","standalone","minimal-ui","browser"],c="browser",l=["any","natural","landscape","portrait","portrait-primary","portrait-secondary","landscape-primary","landscape-secondary"];function parseString(e,t){let n,i;return"string"==typeof e?n=t?e.trim():e:(void 0!==e&&(i="ERROR: expected a string."),n=void 0),{raw:e,value:n,warning:i}}
function parseColor(e){const t=parseString(e);return void 0===t.value||function isValidColor(e){return a.valueType(e)===a.TYPES.COLOR}(t.raw)||(t.value=void 0,t.warning="ERROR: color parsing failed."),t}function parseName(e){return parseString(e.name,!0)}function parseShortName(e){return parseString(e.short_name,!0)}function parseStartUrl(e,t,n){const a=e.start_url;if(""===a)return{raw:a,value:n,warning:"ERROR: start_url string empty"};if(void 0===a)return{raw:a,value:n};if("string"!=typeof a)return{raw:a,value:n,warning:"ERROR: expected a string."};let s;try{s=new i(a,t).href}catch(e){return{raw:a,value:n,warning:"ERROR: invalid start_url relative to "+t}}return function checkSameOrigin(e,t){const n=new i(e),a=new i(t);return n.origin===a.origin}(s,n)?{raw:a,value:s}:{raw:a,value:n,warning:"ERROR: start_url must be same-origin as document"}}function parseDisplay(e){const t=parseString(e.display,!0),n=t.value;if(!n)return{raw:e,value:c,warning:t.warning};const i=n.toLowerCase()
;return s.includes(i)?{raw:e,value:i,warning:void 0}:{raw:e,value:c,warning:"ERROR: 'display' has invalid value "+i+". will fall back to browser."}}function parseOrientation(e){const t=parseString(e.orientation,!0);return t.value&&!l.includes(t.value.toLowerCase())&&(t.value=void 0,t.warning="ERROR: 'orientation' has an invalid value, will be ignored."),t}function parseIcons(e,t){const n=e.icons;if(void 0===n)return{raw:n,value:[],warning:void 0};if(!Array.isArray(n))return{raw:n,value:[],warning:"ERROR: 'icons' expected to be an array but is not."};const a=n.filter((e=>void 0!==e.src)).map((e=>function parseIcon(e,t){const n=parseString(e.src,!0);if(""===n.value&&(n.value=void 0),n.value)try{n.value=new i(n.value,t).href}catch(t){n.warning=`ERROR: invalid icon url will be ignored: '${e.src}'`,n.value=void 0}const a=parseString(e.type,!0),s=parseString(e.purpose),c={raw:e.purpose,value:["any"],warning:void 0};void 0!==s.value&&(c.value=s.value.split(/\s+/).map((e=>e.toLowerCase())))
;const l={raw:e.density,value:1,warning:void 0};let u;void 0!==l.raw&&(l.value=parseFloat(l.raw),(isNaN(l.value)||!isFinite(l.value)||l.value<=0)&&(l.value=1,l.warning="ERROR: icon density cannot be NaN, +∞, or less than or equal to +0."));const d=parseString(e.sizes);if(void 0!==d.value){const t=new Set;d.value.trim().split(/\s+/).forEach((e=>t.add(e.toLowerCase()))),u={raw:e.sizes,value:t.size>0?Array.from(t):void 0,warning:void 0}}else u={...d,value:void 0};return{raw:e,value:{src:n,type:a,density:l,sizes:u,purpose:c},warning:void 0}}(e,t))),s=a.filter((e=>{const t=[e.warning,e.value.type.warning,e.value.src.warning,e.value.sizes.warning,e.value.density.warning].filter(Boolean),n=!!e.value.src.value;return!!t.length&&!n}));return{raw:n,value:a.filter((e=>void 0!==e.value.src.value)),warning:s.length?"WARNING: Some icons were ignored due to warnings.":void 0}}function parseApplication(e){const t=parseString(e.platform,!0),n=parseString(e.id,!0),a=parseString(e.url,!0);if(a.value)try{
a.value=new i(a.value).href}catch(t){a.value=void 0,a.warning="ERROR: invalid application URL "+e.url}return{raw:e,value:{platform:t,id:n,url:a},warning:void 0}}function parseRelatedApplications(e){const t=e.related_applications;if(void 0===t)return{raw:t,value:void 0,warning:void 0};if(!Array.isArray(t))return{raw:t,value:void 0,warning:"ERROR: 'related_applications' expected to be an array but is not."};const n=t.filter((e=>!!e.platform)).map(parseApplication).filter((e=>!!e.value.id.value||!!e.value.url.value));return{raw:t,value:n,warning:void 0}}function parsePreferRelatedApplications(e){const t=e.prefer_related_applications;let n,i;return"boolean"==typeof t?n=t:(void 0!==t&&(i="ERROR: 'prefer_related_applications' expected to be a boolean."),n=void 0),{raw:t,value:n,warning:i}}function parseThemeColor(e){return parseColor(e.theme_color)}function parseBackgroundColor(e){return parseColor(e.background_color)}t.exports=function parse(e,t,n){
if(void 0===t||void 0===n)throw new Error("Manifest and document URLs required for manifest parsing.");let a;try{a=JSON.parse(e)}catch(n){return{raw:e,value:void 0,warning:"ERROR: file isn't valid JSON: "+n,url:t}}const s={name:parseName(a),short_name:parseShortName(a),start_url:parseStartUrl(a,t,n),display:parseDisplay(a),orientation:parseOrientation(a),icons:parseIcons(a,t),related_applications:parseRelatedApplications(a),prefer_related_applications:parsePreferRelatedApplications(a),theme_color:parseThemeColor(a),background_color:parseBackgroundColor(a)};let c;try{new i(t).protocol.startsWith("http")||(c="WARNING: manifest URL not available over a valid network protocol")}catch(e){c=`ERROR: invalid manifest URL: '${t}'`}return{raw:e,value:s,warning:c,url:t}}},{"./url-shim.js":"url","cssstyle/lib/parsers":160}],106:[function(e,t,n){"use strict"
;const i=/(return|case|{|\(|\[|\.\.\.|;|,|<|>|<=|>=|==|!=|===|!==|\+|-|\*|%|\*\*|\+\+|--|<<|>>|>>>|&|\||\^|!|~|&&|\|\||\?|:|=|\+=|-=|\*=|%=|\*\*=|<<=|>>=|>>>=|&=|\|=|\^=|=>|\/|\/=|\})$/,a=/( |\n|\t)+$/;function hasPunctuatorBefore(e,t){for(let n=t;n>0;n--){const t=Math.max(0,n-6),s=e.slice(t,n);if(!a.test(s))return i.test(s)}return!0}function computeTokenLength(e,t){let n=0,i=!1,a=!1,s=!1,c=!1,l=!1,u=!1,d=null;const m=[];for(let p=0;p<e.length;p++){const h=e.substr(p,2),f=h.charAt(0),g=" "===f||"\n"===f||"\t"===f,y="'"===f||'"'===f||"`"===f;i?"\n"===f&&(i=!1):a?(s&&n++,"*/"===h&&(s&&n++,a=!1,p++)):c?(n++,"`"===d&&"${"===h?(m.push("templateBrace"),c=!1,n++,p++):"\\"===f?(n++,p++):f===d&&(c=!1)):l?(n++,"\\"===f?(n++,p++):"["===f?u=!0:"]"===f&&u?u=!1:"/"!==f||u||(l=!1)):"/*"===h?(a=!0,s="!"===e.charAt(p+2),s&&(n+=2),p++):"//"===h&&t.singlelineComments?(i=!0,a=!1,s=!1,p++):"/"===f&&t.regex&&hasPunctuatorBefore(e,p)?(l=!0,n++):"{"===f&&m.length?(m.push("normalBrace"),
n++):"}"===f&&m.length?("templateBrace"===m[m.length-1]&&(c=!0,d="`"),m.pop(),n++):y?(c=!0,d=f,n++):g||n++}return a||c?e.length:n}t.exports={computeJSTokenLength:function computeJSTokenLength(e){return computeTokenLength(e,{singlelineComments:!0,regex:!0})},computeCSSTokenLength:function computeCSSTokenLength(e){return computeTokenLength(e,{singlelineComments:!1,regex:!1})}}},{}],107:[function(e,t,n){"use strict";const i=e("./lh-error.js"),a=e("./dependency-graph/simulator/network-analyzer.js");function getNetworkError(e){if(!e)return new i(i.errors.NO_DOCUMENT_REQUEST);if(e.failed){const t=e.localizedFailDescription;return"net::ERR_NAME_NOT_RESOLVED"===t||"net::ERR_NAME_RESOLUTION_FAILED"===t||t.startsWith("net::ERR_DNS_")?new i(i.errors.DNS_FAILURE):new i(i.errors.FAILED_DOCUMENT_REQUEST,{errorDetails:t})}return e.hasErrorStatusCode()?new i(i.errors.ERRORED_DOCUMENT_REQUEST,{statusCode:""+e.statusCode}):void 0}function getInterstitialError(e,t){if(!e)return
;return t.find((e=>e.documentURL.startsWith("chrome-error://")))&&e.failed?e.localizedFailDescription.startsWith("net::ERR_CERT")?new i(i.errors.INSECURE_DOCUMENT_REQUEST,{securityMessages:e.localizedFailDescription}):new i(i.errors.CHROME_INTERSTITIAL_ERROR):void 0}function getNonHtmlError(e){if(e)return"text/html"!==e.mimeType?new i(i.errors.NOT_HTML,{mimeType:e.mimeType}):void 0}t.exports={getNetworkError,getInterstitialError,getPageLoadError:function getPageLoadError(e,t){const{url:n,loadFailureMode:i,networkRecords:s}=t;let c,l;try{c=a.findMainDocument(s,n)}catch(e){}c&&(l=a.resolveRedirects(c));const u=getNetworkError(c),d=getInterstitialError(c,s),m=getNonHtmlError(l);if("ignore"!==i)return d||(u||(m||e))},getNonHtmlError}},{"./dependency-graph/simulator/network-analyzer.js":93,"./lh-error.js":103}],108:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("./network-request.js"),s=e("events").EventEmitter;class NetworkRecorder extends s{constructor(){super(),
this._records=[],this._recordsById=new Map,this._mainSessionId=null}getRawRecords(){return Array.from(this._records)}on(e,t){return super.on(e,t)}once(e,t){return super.once(e,t)}onRequestStarted(e){this._records.push(e),this._recordsById.set(e.requestId,e),this.emit("requeststarted",e)}onRequestFinished(e){this.emit("requestloaded",e)}onRequestWillBeSent(e){const t=e.params,n=this._findRealRequestAndSetSession(t.requestId,e.sessionId);if(!n){const n=new a;return n.onRequestWillBeSent(t),n.sessionId=e.sessionId,this.onRequestStarted(n),void i.verbose("network","request will be sent to "+n.url)}if(!t.redirectResponse)return;const s={...t,initiator:n.initiator,requestId:n.requestId+":redirect"},c=new a;c.onRequestWillBeSent(s),n.onRedirectResponse(t),i.verbose("network",`${n.url} redirected to ${c.url}`),n.redirectDestination=c,c.redirectSource=n,this.onRequestStarted(c),this.onRequestFinished(n)}onRequestServedFromCache(e){
const t=e.params,n=this._findRealRequestAndSetSession(t.requestId,e.sessionId);n&&(i.verbose("network",n.url+" served from cache"),n.onRequestServedFromCache())}onResponseReceived(e){const t=e.params,n=this._findRealRequestAndSetSession(t.requestId,e.sessionId);n&&(i.verbose("network",n.url+" response received"),n.onResponseReceived(t))}onDataReceived(e){const t=e.params,n=this._findRealRequestAndSetSession(t.requestId,e.sessionId);n&&(i.verbose("network",n.url+" data received"),n.onDataReceived(t))}onLoadingFinished(e){const t=e.params,n=this._findRealRequestAndSetSession(t.requestId,e.sessionId);n&&(i.verbose("network",n.url+" loading finished"),n.onLoadingFinished(t),this.onRequestFinished(n))}onLoadingFailed(e){const t=e.params,n=this._findRealRequestAndSetSession(t.requestId,e.sessionId);n&&(i.verbose("network",n.url+" loading failed"),n.onLoadingFailed(t),this.onRequestFinished(n))}onResourceChangedPriority(e){
const t=e.params,n=this._findRealRequestAndSetSession(t.requestId,e.sessionId);n&&n.onResourceChangedPriority(t)}dispatch(e){switch(e.method){case"Network.requestWillBeSent":return this.onRequestWillBeSent(e);case"Network.requestServedFromCache":return this.onRequestServedFromCache(e);case"Network.responseReceived":return this.onResponseReceived(e);case"Network.dataReceived":return this.onDataReceived(e);case"Network.loadingFinished":return this.onLoadingFinished(e);case"Network.loadingFailed":return this.onLoadingFailed(e);case"Network.resourceChangedPriority":return this.onResourceChangedPriority(e);default:return}}_findRealRequestAndSetSession(e,t){null===this._mainSessionId&&(this._mainSessionId=t),this._mainSessionId===t&&(t=void 0);let n=this._recordsById.get(e);if(n&&n.isValid){for(;n.redirectDestination;)n=n.redirectDestination;return n.setSession(t),n}}static _chooseInitiatorRequest(e,t){if(e.redirectSource)return e.redirectSource
;const n=e.initiator.stack&&e.initiator.stack.callFrames||[],i=e.initiator.url||n[0]&&n[0].url;let s=t.get(i)||[];if(s=s.filter((t=>t.responseReceivedTime<=e.startTime)),s.length>1){const e=s.filter((e=>e.resourceType!==a.TYPES.Other));e.length&&(s=e)}if(s.length>1){const t=s.filter((t=>t.frameId===e.frameId));t.length&&(s=t)}if(s.length>1&&"parser"===e.initiator.type){const e=s.filter((e=>e.resourceType===a.TYPES.Document));e.length&&(s=e)}return 1===s.length?s[0]:null}static recordsFromLogs(e){const t=new NetworkRecorder;e.forEach((e=>t.dispatch(e)));const n=t.getRawRecords().filter((e=>e.isValid)),i=new Map;for(const e of n){const t=i.get(e.url)||[];t.push(e),i.set(e.url,t)}for(const e of n){const t=NetworkRecorder._chooseInitiatorRequest(e,i);t&&e.setInitiatorRequest(t);let n=e;for(;n.redirectDestination;)n=n.redirectDestination;if(n===e||n.redirects)continue;const a=[];for(let e=n.redirectSource;e;e=e.redirectSource)a.unshift(e);n.redirects=a}return n}}t.exports=NetworkRecorder},{
"./network-request.js":109,events:162,"lighthouse-logger":188}],109:[function(e,t,n){(function(n){(function(){"use strict";const i=e("./url-shim.js"),a="X-TCPMs",s="X-SSLMs",c="X-RequestMs",l="X-ResponseMs",u="X-TotalMs",d="X-TotalFetchedSize",m="X-ProtocolIsH2",p={XHR:"XHR",Fetch:"Fetch",EventSource:"EventSource",Script:"Script",Stylesheet:"Stylesheet",Image:"Image",Media:"Media",Font:"Font",Document:"Document",TextTrack:"TextTrack",WebSocket:"WebSocket",Other:"Other",Manifest:"Manifest",SignedExchange:"SignedExchange",Ping:"Ping",Preflight:"Preflight",CSPViolationReport:"CSPViolationReport"};class NetworkRequest{constructor(){this.requestId="",this.connectionId="0",this.connectionReused=!1,this.url="",this.protocol="",this.isSecure=!1,this.isValid=!1,this.parsedURL={scheme:""},this.documentURL="",this.startTime=-1,this.endTime=-1,this.responseReceivedTime=-1,this.transferSize=0,this.resourceSize=0,this.fromDiskCache=!1,this.fromMemoryCache=!1,this.fromPrefetchCache=!1,
this.lrStatistics=void 0,this.finished=!1,this.requestMethod="",this.statusCode=-1,this.redirectSource=void 0,this.redirectDestination=void 0,this.redirects=void 0,this.failed=!1,this.localizedFailDescription="",this.initiator={type:"other"},this.timing=void 0,this.resourceType=void 0,this.mimeType="",this.priority="Low",this.initiatorRequest=void 0,this.responseHeaders=[],this.responseHeadersText="",this.fetchedViaServiceWorker=!1,this.frameId="",this.sessionId=void 0,this.isLinkPreload=!1}hasErrorStatusCode(){return this.statusCode>=400}setInitiatorRequest(e){this.initiatorRequest=e}onRequestWillBeSent(e){let t;this.requestId=e.requestId;try{t=new i(e.request.url)}catch(e){return}this.url=e.request.url,this.documentURL=e.documentURL,this.parsedURL={scheme:t.protocol.split(":")[0],host:t.hostname,securityOrigin:t.origin},this.isSecure=i.isSecureScheme(this.parsedURL.scheme),this.startTime=e.timestamp,this.requestMethod=e.request.method,this.initiator=e.initiator,
this.resourceType=e.type&&p[e.type],this.priority=e.request.initialPriority,this.frameId=e.frameId,this.isLinkPreload="preload"===e.initiator.type||!!e.request.isLinkPreload,this.isValid=!0}onRequestServedFromCache(){this.fromMemoryCache=!0}onResponseReceived(e){this._onResponse(e.response,e.timestamp,e.type),this._updateProtocolForLightrider(),this.frameId=e.frameId}onDataReceived(e){this.resourceSize+=e.dataLength,-1!==e.encodedDataLength&&(this.transferSize+=e.encodedDataLength)}onLoadingFinished(e){this.finished||(this.finished=!0,this.endTime=e.timestamp,e.encodedDataLength>=0&&(this.transferSize=e.encodedDataLength),this._updateResponseReceivedTimeIfNecessary(),this._updateTransferSizeForLightrider(),this._updateTimingsForLightrider())}onLoadingFailed(e){this.finished||(this.finished=!0,this.endTime=e.timestamp,this.failed=!0,this.resourceType=e.type&&p[e.type],this.localizedFailDescription=e.errorText,this._updateResponseReceivedTimeIfNecessary(),
this._updateTransferSizeForLightrider(),this._updateTimingsForLightrider())}onResourceChangedPriority(e){this.priority=e.newPriority}onRedirectResponse(e){if(!e.redirectResponse)throw new Error("Missing redirectResponse data");this._onResponse(e.redirectResponse,e.timestamp,e.type),this.resourceType=void 0,this.finished=!0,this.endTime=e.timestamp,this._updateResponseReceivedTimeIfNecessary()}setSession(e){this.sessionId=e}_onResponse(e,t,n){this.url=e.url,this.connectionId=String(e.connectionId),this.connectionReused=e.connectionReused,e.protocol&&(this.protocol=e.protocol),this.responseReceivedTime=t,this.transferSize=e.encodedDataLength,"boolean"==typeof e.fromDiskCache&&(this.fromDiskCache=e.fromDiskCache),"boolean"==typeof e.fromPrefetchCache&&(this.fromPrefetchCache=e.fromPrefetchCache),this.statusCode=e.status,this.timing=e.timing,n&&(this.resourceType=p[n]),this.mimeType=e.mimeType,this.responseHeadersText=e.headersText||"",
this.responseHeaders=NetworkRequest._headersDictToHeadersArray(e.headers),this.fetchedViaServiceWorker=!!e.fromServiceWorker,this.fromMemoryCache&&(this.timing=void 0),this.timing&&this._recomputeTimesWithResourceTiming(this.timing)}_recomputeTimesWithResourceTiming(e){if(0===e.requestTime||-1===e.receiveHeadersEnd)return;this.startTime=e.requestTime;const t=e.requestTime+e.receiveHeadersEnd/1e3;(!this.responseReceivedTime||this.responseReceivedTime<0)&&(this.responseReceivedTime=t),this.responseReceivedTime=Math.min(this.responseReceivedTime,t),this.responseReceivedTime=Math.max(this.responseReceivedTime,this.startTime),this.endTime=Math.max(this.endTime,this.responseReceivedTime)}_updateResponseReceivedTimeIfNecessary(){this.responseReceivedTime=Math.min(this.endTime,this.responseReceivedTime)}_updateTransferSizeForLightrider(){if(!n.isLightrider)return;const e=this.responseHeaders.find((e=>e.name===d));if(!e)return;const t=parseFloat(e.value);isNaN(t)||(this.transferSize=t)}
_updateProtocolForLightrider(){n.isLightrider&&this.responseHeaders.some((e=>e.name===m))&&(this.protocol="h2")}_updateTimingsForLightrider(){if(!n.isLightrider)return;const e=this.responseHeaders.find((e=>e.name===u));if(!e)return;const t=parseInt(e.value),i=this.responseHeaders.find((e=>e.name===a)),d=this.responseHeaders.find((e=>e.name===s)),m=this.responseHeaders.find((e=>e.name===c)),p=this.responseHeaders.find((e=>e.name===l)),h=i?Math.max(0,parseInt(i.value)):0,f=d?Math.max(0,parseInt(d.value)):0,g=m?Math.max(0,parseInt(m.value)):0,y=p?Math.max(0,parseInt(p.value)):0;h+g+y===t&&(f>h||(this.lrStatistics={endTimeDeltaMs:1e3*(this.endTime-(this.startTime+t/1e3)),TCPMs:h,requestMs:g,responseMs:y}))}static getRequestIdForBackend(e){return e.replace(/(:redirect)+$/,"")}static _headersDictToHeadersArray(e){const t=[];for(const n of Object.keys(e)){const i=e[n].split("\n");for(let e=0;e<i.length;++e)t.push({name:n,value:i[e]})}return t}static get TYPES(){return p}
static isNonNetworkRequest(e){return i.isNonNetworkProtocol(e.protocol)||i.isNonNetworkProtocol(e.parsedURL.scheme)}static isSecureRequest(e){return i.isSecureScheme(e.parsedURL.scheme)||i.isSecureScheme(e.protocol)||i.isLikeLocalhost(e.parsedURL.host)||NetworkRequest.isHstsRequest(e)}static isHstsRequest(e){const t=e.redirectDestination;if(!t)return!1;const n=e.responseHeaders.find((e=>"Non-Authoritative-Reason"===e.name));return"HSTS"===(n&&n.value)&&NetworkRequest.isSecureRequest(t)}static getResourceSizeOnNetwork(e){return Math.min(e.resourceSize||0,e.transferSize||1/0)}}NetworkRequest.HEADER_TCP=a,NetworkRequest.HEADER_SSL=s,NetworkRequest.HEADER_REQ=c,NetworkRequest.HEADER_RES=l,NetworkRequest.HEADER_TOTAL=u,NetworkRequest.HEADER_FETCHED_SIZE=d,NetworkRequest.HEADER_PROTOCOL_IS_H2=m,t.exports=NetworkRequest}).call(this)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./url-shim.js":"url"}],110:[function(e,t,n){
"use strict";function wrapRuntimeEvalErrorInBrowser(e){return e&&"string"!=typeof e||(e=new Error(e)),{__failedInBrowser:!0,name:e.name||"Error",message:e.message||"unknown error",stack:e.stack}}function getElementsInDocument(e){const t=window.__ElementMatches||window.Element.prototype.matches,n=[],_findAllElements=i=>{for(let a,s=0;a=i[s];++s){if(!e||t.call(a,e)){const e=a;n.push(e)}a.shadowRoot&&_findAllElements(a.shadowRoot.querySelectorAll("*"))}};return _findAllElements(document.querySelectorAll("*")),n}function getOuterHTMLSnippet(e,t=[],n=500){const i=["autofill-information","autofill-prediction","title"];e instanceof ShadowRoot&&(e=e.host);try{const a=e.cloneNode();e.ownerDocument.createElement("template").content.append(a),t.concat(i).forEach((e=>{a.removeAttribute(e)}));let s=0;for(const t of a.getAttributeNames()){if(s>n){a.removeAttribute(t);continue}let i=a.getAttribute(t);if(null===i)continue;let c=!1;if("src"===t&&"currentSrc"in e){
const t=e,n=t.currentSrc,a=t.ownerDocument.location.href;new URL(i,a).toString()!==n&&(i=n,c=!0)}i.length>75&&(i=i.slice(0,74)+"…",c=!0),c&&a.setAttribute(t,i),s+=t.length+i.length}const c=/^[\s\S]*?>/,[l]=a.outerHTML.match(c)||[];return l&&s>n?l.slice(0,l.length-1)+" …>":l||""}catch(t){return`<${e.localName}>`}}function computeBenchmarkIndex(){return(function benchmarkIndexGC(){const e=Date.now();let t=0;for(;Date.now()-e<500;){let e="";for(let t=0;t<1e4;t++)e+="a";t++}const n=(Date.now()-e)/1e3;return Math.round(t/10/n)}()+function benchmarkIndexNoGC(){const e=[],t=[];for(let n=0;n<1e5;n++)e[n]=t[n]=n;const n=Date.now();let i=0;for(;i%10!=0||Date.now()-n<500;){const n=i%2==0?e:t,a=i%2==0?t:e;for(let e=0;e<n.length;e++)a[e]=n[e];i++}const a=(Date.now()-n)/1e3;return Math.round(i/10/a)}())/2}function getNodePath(e){const isShadowRoot=e=>e.nodeType===Node.DOCUMENT_FRAGMENT_NODE,getNodeParent=e=>isShadowRoot(e)?e.host:e.parentNode;function getNodeIndex(e){if(isShadowRoot(e))return"a"
;let t,n=0;for(;t=e.previousSibling;)(e=t).nodeType===Node.TEXT_NODE&&0===(e.nodeValue||"").trim().length||n++;return n}let t=e;const n=[];for(;t&&getNodeParent(t);){const e=getNodeIndex(t);n.push([e,t.nodeName]),t=getNodeParent(t)}return n.reverse(),n.join(",")}function getNodeSelector(e){function getSelectorPart(e){let t=e.tagName.toLowerCase();return e.id?t+="#"+e.id:e.classList.length>0&&(t+="."+e.classList[0]),t}const t=[];for(;t.length<4&&(t.unshift(getSelectorPart(e)),e.parentElement)&&"HTML"!==(e=e.parentElement).tagName;);return t.join(" > ")}function getNodeLabel(e){const t=e.tagName.toLowerCase();if("html"!==t&&"body"!==t){const t=e instanceof HTMLElement&&e.innerText||e.getAttribute("alt")||e.getAttribute("aria-label");if(t)return function truncate(e,t){return e.length<=t?e:Array.from(e).slice(0,t-1).join("")+"…"}(t,80);{const t=e.querySelector("[alt], [aria-label]");if(t)return getNodeLabel(t)}}return null}function getBoundingClientRect(e){const t=e.getBoundingClientRect()
;return{top:Math.round(t.top),bottom:Math.round(t.bottom),left:Math.round(t.left),right:Math.round(t.right),width:Math.round(t.width),height:Math.round(t.height)}}function getNodeDetails(e){window.__lighthouseNodesDontTouchOrAllVarianceGoesAway||(window.__lighthouseNodesDontTouchOrAllVarianceGoesAway=new Map);const t=getNodeSelector(e=e instanceof ShadowRoot?e.host:e);let n=window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.get(e);n||(n=[void 0!==window.__lighthouseExecutionContextId?window.__lighthouseExecutionContextId:"page",window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.size,e.tagName].join("-"),window.__lighthouseNodesDontTouchOrAllVarianceGoesAway.set(e,n));return{lhId:n,devtoolsNodePath:getNodePath(e),selector:t,boundingRect:getBoundingClientRect(e),snippet:getOuterHTMLSnippet(e),nodeLabel:getNodeLabel(e)||t}}
const i=`function getNodeDetails(element) {\n  ${getNodePath.toString()};\n  ${getNodeSelector.toString()};\n  ${getBoundingClientRect.toString()};\n  ${getOuterHTMLSnippet.toString()};\n  ${getNodeLabel.toString()};\n  return (${getNodeDetails.toString()})(element);\n}`;t.exports={wrapRuntimeEvalErrorInBrowserString:wrapRuntimeEvalErrorInBrowser.toString(),wrapRuntimeEvalErrorInBrowser,getElementsInDocument,getElementsInDocumentString:getElementsInDocument.toString(),getOuterHTMLSnippetString:getOuterHTMLSnippet.toString(),getOuterHTMLSnippet,computeBenchmarkIndex,computeBenchmarkIndexString:computeBenchmarkIndex.toString(),getMaxTextureSize:function getMaxTextureSize(){try{const e=document.createElement("canvas").getContext("webgl");if(!e)throw new Error("no webgl");return e.getParameter(e.MAX_TEXTURE_SIZE)}catch(e){return 4095}},getNodeDetailsString:i,getNodeDetails,getNodePathString:getNodePath.toString(),getNodeSelectorString:getNodeSelector.toString(),getNodePath,getNodeSelector,
getNodeLabel,getNodeLabelString:getNodeLabel.toString(),isPositionFixedString:function isPositionFixed(e){function getStyleAttrValue(e,t){return e.style[t]||window.getComputedStyle(e)[t]}const t=document.querySelector("html");if(!t)throw new Error("html element not found in document");if(t.scrollHeight<=t.clientHeight||!["scroll","auto","visible"].includes(getStyleAttrValue(t,"overflowY")))return!1;let n=e;for(;n;){const e=getStyleAttrValue(n,"position");if("fixed"===e||"sticky"===e)return!0;n=n.parentElement}return!1}.toString(),wrapRequestIdleCallback:function wrapRequestIdleCallback(e){const t=Math.floor(40/e),n=window.requestIdleCallback;window.requestIdleCallback=(e,i)=>n((n=>{const i=Date.now();n.__timeRemaining=n.timeRemaining,n.timeRemaining=()=>{const e=n.__timeRemaining();return Math.min(e,Math.max(0,t-(Date.now()-i)))},n.timeRemaining.toString=()=>"function timeRemaining() { [native code] }",e(n)}),i),
window.requestIdleCallback.toString=()=>"function requestIdleCallback() { [native code] }"},getBoundingClientRectString:getBoundingClientRect.toString()}},{}],111:[function(e,t,n){"use strict";function rectContains(e,t){return t.top>=e.top&&t.right<=e.right&&t.bottom<=e.bottom&&t.left>=e.left}function getBoundingRectWithPadding(e,t){if(0===e.length)throw new Error("No rects to take bounds of");let n=Number.MAX_VALUE,i=-Number.MAX_VALUE,a=Number.MAX_VALUE,s=-Number.MAX_VALUE;for(const t of e)n=Math.min(n,t.left),i=Math.max(i,t.right),a=Math.min(a,t.top),s=Math.max(s,t.bottom);const c=t/2;return n-=c,i+=c,a-=c,s+=c,{left:n,right:i,top:a,bottom:s,width:i-n,height:s-a}}function addRectWidthAndHeight({left:e,top:t,right:n,bottom:i}){return{left:e,top:t,right:n,bottom:i,width:n-e,height:i-t}}function getRectArea(e){return e.width*e.height}t.exports={rectContainsPoint:function rectContainsPoint(e,{x:t,y:n}){return e.left<=t&&e.right>=t&&e.top<=n&&e.bottom>=n},rectContains,
addRectWidthAndHeight,addRectTopAndBottom:function addRectTopAndBottom({x:e,y:t,width:n,height:i}){return{left:e,top:t,right:e+n,bottom:t+i,width:n,height:i}},getRectOverlapArea:function getRectOverlapArea(e,t){const n=Math.min(e.bottom,t.bottom)-Math.max(e.top,t.top);if(n<=0)return 0;const i=Math.min(e.right,t.right)-Math.max(e.left,t.left);return i<=0?0:i*n},getRectAtCenter:function getRectAtCenter(e,t){return addRectWidthAndHeight({left:e.left+e.width/2-t/2,top:e.top+e.height/2-t/2,right:e.right-e.width/2+t/2,bottom:e.bottom-e.height/2+t/2})},getLargestRect:function getLargestRect(e){let t=e[0];for(const n of e)getRectArea(n)>getRectArea(t)&&(t=n);return t},getRectArea,getRectCenterPoint:function getRectCenterPoint(e){return{x:e.left+e.width/2,y:e.top+e.height/2}},getBoundingRect:function getBoundingRect(e){return getBoundingRectWithPadding(e,0)},getBoundingRectWithPadding,rectsTouchOrOverlap:function rectsTouchOrOverlap(e,t){
return e.left<=t.right&&t.left<=e.right&&e.top<=t.bottom&&t.top<=e.bottom},allRectsContainedWithinEachOther:function allRectsContainedWithinEachOther(e,t){for(const n of e)for(const e of t)if(!rectContains(n,e)&&!rectContains(e,n))return!1;return!0},filterOutRectsContainedByOthers:function filterOutRectsContainedByOthers(e){const t=new Set(e);for(const n of e)for(const i of e)if(n!==i&&t.has(i)&&rectContains(i,n)){t.delete(n);break}return Array.from(t)},filterOutTinyRects:function filterOutTinyRects(e){return e.filter((e=>e.width>1&&e.height>1))}}},{}],112:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=[],noop=()=>{},s={init:function init(t){if(!t.flags.enableErrorReporting)return;if(!s._shouldSample())return;try{const n=e("raven"),i=Object.assign({},t.environmentData,{captureUnhandledRejections:!0});n.config("https://a6bb0da87ee048cc9ae2a345fc09ab2e:63a7029f46f74265981b7e005e0f69f8@sentry.io/174697",i).install(),s.captureMessage=(...e)=>n.captureMessage(...e),
s.captureBreadcrumb=(...e)=>n.captureBreadcrumb(...e),s.getContext=()=>n.getContext();const c=new Map;s.captureException=async(e,t={})=>{if(!e)return;if(e.expected)return;const i=t.tags||{};if(i.audit){const t=`audit-${i.audit}-${e.message}`;if(c.has(t))return;c.set(t,!0)}if(i.gatherer){const t=`gatherer-${i.gatherer}-${e.message}`;if(c.has(t))return;c.set(t,!0)}const s=a.find((t=>t.pattern.test(e.message)));return s&&s.rate<=Math.random()?void 0:(e.protocolMethod&&(t.fingerprint=["{{ default }}",e.protocolMethod,e.protocolError],t.tags=t.tags||{},t.tags.protocolMethod=e.protocolMethod),new Promise((i=>{n.captureException(e,t,(()=>i()))})))};const l=Object.assign({url:t.url,formFactor:t.flags.formFactor,throttlingMethod:t.flags.throttlingMethod},t.flags.throttling);n.mergeContext({extra:Object.assign({},t.environmentData.extra,l)})}catch(e){i.warn("sentry","Could not load raven library, errors will not be reported.")}},captureMessage:noop,captureBreadcrumb:noop,getContext:noop,
captureException:async()=>{},_shouldSample:()=>.01>=Math.random()};t.exports=s},{"lighthouse-logger":188,raven:144}],113:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("lighthouse-stack-packs"),s=e("./i18n/i18n.js");function resolve(t){return e.resolve?e.resolve(t):"node_modules/"+t}const c=[{packId:"wordpress",requiredStacks:["js:wordpress"]},{packId:"drupal",requiredStacks:["js:drupal"]},{packId:"react",requiredStacks:["js:react"]},{packId:"angular",requiredStacks:["js:@angular/core"]},{packId:"amp",requiredStacks:["js:amp"]},{packId:"magento",requiredStacks:["js:magento"]},{packId:"octobercms",requiredStacks:["js:octobercms"]},{packId:"joomla",requiredStacks:["js:joomla"]}];t.exports={getStackPacks:function getStackPacks(e){const t=[];for(const n of e){const e=c.find((e=>e.requiredStacks.includes(`${n.detector}:${n.id}`)));if(!e)continue;const l=a.find((t=>t.id===e.packId));if(!l){
i.warn("StackPacks",`'${e.packId}' stack pack was matched but is not found in stack-packs lib`);continue}const u=s.createMessageInstanceIdFn(resolve("lighthouse-stack-packs/packs/"+l.id),l.UIStrings),d={},m=l.UIStrings;for(const e in m)m[e]&&(d[e]=u(m[e]));t.push({id:l.id,title:l.title,iconDataURL:l.icon,descriptions:d})}return t},stackPacksToInclude:c}},{"./i18n/i18n.js":98,"lighthouse-logger":188,"lighthouse-stack-packs":208}],114:[function(e,t,n){"use strict";function erf(e){const t=Math.sign(e),n=1/(1+.3275911*(e=Math.abs(e)));return t*(1-n*(.254829592+n*(n*(1.421413741+n*(1.061405429*n-1.453152027))-.284496736))*Math.exp(-e*e))}t.exports={linearInterpolation:function linearInterpolation(e,t,n,i,a){return t+(a-e)*((i-t)/(n-e))},getLogNormalDistribution:function getLogNormalDistribution(e,t){const n=Math.log(e),i=Math.log(t/e),a=Math.sqrt(1-3*i-Math.sqrt((i-3)*(i-3)-8))/2;return{computeComplementaryPercentile:e=>(1-erf((Math.log(e)-n)/(Math.SQRT2*a)))/2}},
getLogNormalScore:function getLogNormalScore({median:e,p10:t},n){if(e<=0)throw new Error("median must be greater than zero");if(t<=0)throw new Error("p10 must be greater than zero");if(t>=e)throw new Error("p10 must be less than the median");if(n<=0)return 1;const i=(1-erf(.9061938024368232*Math.log(n/e)/-Math.log(t/e)))/2;return Math.min(1,Math.max(0,i))}}},{}],115:[function(e,t,n){"use strict";const{filterOutRectsContainedByOthers:i,filterOutTinyRects:a,rectsTouchOrOverlap:s,rectContainsPoint:c,getBoundingRect:l,getRectCenterPoint:u}=e("./rect-helpers.js");function almostEqual(e,t){return Math.abs(e-t)<=10}function mergeTouchingClientRects(e){for(let t=0;t<e.length;t++)for(let n=t+1;n<e.length;n++){const i=e[t],a=e[n],d=almostEqual(i.top,a.top)||almostEqual(i.bottom,a.bottom),m=almostEqual(i.left,a.left)||almostEqual(i.right,a.right);if(s(i,a)&&(d||m)){const t=l([i,a]),n=u(t);if(!c(i,n)&&!c(a,n))continue;return(e=e.filter((e=>e!==i&&e!==a))).push(t),mergeTouchingClientRects(e)}}
return e}t.exports={getTappableRectsFromClientRects:function getTappableRectsFromClientRects(e){return e=a(e),e=mergeTouchingClientRects(e=i(e))}}},{"./rect-helpers.js":111}],116:[function(e,t,n){"use strict";const i=e("third-party-web/httparchive-nostats-subset");function getEntity(e){return i.getEntity(e)}function isThirdParty(e,t){const n=getEntity(e);return!!n&&n!==t}t.exports={getEntity,getProduct:function getProduct(e){return i.getProduct(e)},isThirdParty,isFirstParty:function isFirstParty(e,t){return!isThirdParty(e,t)}}},{"third-party-web/httparchive-nostats-subset":251}],117:[function(e,t,n){"use strict";const{taskGroups:i,taskNameToGroup:a}=e("./task-groups.js");class MainThreadTasks{static _createNewTaskNode(e,t){const n="X"===e.ph&&!t,a="B"===e.ph&&t&&"E"===t.ph;if(!n&&!a)throw new Error("Invalid parameters for _createNewTaskNode");const s=e.ts,c=t?t.ts:e.ts+Number(e.dur||0);return{event:e,endEvent:t,startTime:s,endTime:c,duration:c-s,unbounded:!1,parent:void 0,children:[],
attributableURLs:[],group:i.other,selfTime:NaN}}static _assignAllTimersUntilTs(e,t,n,i){for(;i.length;){const a=i.pop();if(!a)break;if(a.ts>t){i.push(a);break}if(a.ts<e.startTime)continue;const s=a.args.data.timerId;n.timers.set(s,e)}}static _createTasksFromStartAndEndEvents(e,t,n){const i=[],a=t.slice().reverse();for(let t=0;t<e.length;t++){const s=e[t];if("X"===s.ph){i.push(MainThreadTasks._createNewTaskNode(s));continue}let c,l=-1,u=0,d=t+1;for(let t=a.length-1;t>=0;t--){const n=a[t];for(;d<e.length&&!(e[d].ts>=n.ts);d++)e[d].name===s.name&&u++;if(n.name===s.name&&!(n.ts<s.ts)){if(!(u>0)){l=t;break}u--}}let m=!1;-1===l?(c={...s,ph:"E",ts:n},m=!0):c=l===a.length-1?a.pop():a.splice(l,1)[0];const p=MainThreadTasks._createNewTaskNode(s,c);p.unbounded=m,i.push(p)}if(a.length)throw new Error(`Fatal trace logic error - ${a.length} unmatched end events`);return i}static _createTaskRelationships(e,t,n){let i;const a=t.slice().reverse();for(let t=0;t<e.length;t++){let s=e[t]
;if("XHRReadyStateChange"===s.event.name){const e=s.event.args.data,t=e&&e.url;e&&t&&1===e.readyState&&n.xhrs.set(t,s)}for(;i&&Number.isFinite(i.endTime)&&i.endTime<=s.startTime;)MainThreadTasks._assignAllTimersUntilTs(i,i.endTime,n,a),i=i.parent;if(i){if(s.endTime>i.endTime){const e=s.endTime-i.endTime;if(e<1e3)i.endTime=s.endTime,i.duration+=e;else if(s.unbounded)s.endTime=i.endTime,s.duration=s.endTime-s.startTime;else{if(!(s.startTime-i.startTime<1e3)||i.children.length){const t=new Error("Fatal trace logic error - child cannot end after parent");throw t.timeDelta=e,t.nextTaskEvent=s.event,t.nextTaskEndEvent=s.endEvent,t.nextTaskEndTime=s.endTime,t.currentTaskEvent=i.event,t.currentTaskEndEvent=i.endEvent,t.currentTaskEndTime=i.endTime,t}{const e=s,t=i,n=i.parent;if(n){const i=n.children.length-1;if(n.children[i]!==t)throw new Error("Fatal trace logic error - impossible children");n.children.pop(),n.children.push(e)}e.parent=n,e.startTime=t.startTime,
e.duration=e.endTime-e.startTime,i=e,s=t}}}s.parent=i,i.children.push(s),MainThreadTasks._assignAllTimersUntilTs(i,s.startTime,n,a)}i=s}i&&MainThreadTasks._assignAllTimersUntilTs(i,i.endTime,n,a)}static _createTasksFromEvents(e,t,n){const i=[],a=[],s=[];for(const t of e)"X"!==t.ph&&"B"!==t.ph||i.push(t),"E"===t.ph&&a.push(t),"TimerInstall"===t.name&&s.push(t);const c=MainThreadTasks._createTasksFromStartAndEndEvents(i,a,n).sort(((e,t)=>e.startTime-t.startTime||t.duration-e.duration));return MainThreadTasks._createTaskRelationships(c,s,t),c.sort(((e,t)=>e.startTime-t.startTime||t.duration-e.duration))}static _computeRecursiveSelfTime(e,t){if(t&&e.endTime>t.endTime)throw new Error("Fatal trace logic error - child cannot end after parent");const n=e.children.map((t=>MainThreadTasks._computeRecursiveSelfTime(t,e))).reduce(((e,t)=>e+t),0);return e.selfTime=e.duration-n,e.duration}static _computeRecursiveAttributableURLs(e,t,n,i){const a=e.event.args,s={...a.beginData||{},...a.data||{}
},c=s.frame||"";let l=i.frameURLsById.get(c);const u=(s.stackTrace||[]).map((e=>e.url)),d=u[0];c&&l&&l.startsWith("about:")&&d&&(i.frameURLsById.set(c,d),l=d);let m=[];switch(e.event.name){case"v8.compile":case"EvaluateScript":case"FunctionCall":m=[s.url,l];break;case"v8.compileModule":m=[e.event.args.fileName];break;case"TimerFire":{const t=e.event.args.data.timerId,n=i.timers.get(t);if(!n)break;m=n.attributableURLs;break}case"ParseHTML":m=[s.url,l];break;case"ParseAuthorStyleSheet":m=[s.styleSheetUrl,l];break;case"UpdateLayoutTree":case"Layout":case"Paint":if(l){m=[l];break}if(n.length)break;m=i.lastTaskURLs;break;case"XHRReadyStateChange":case"XHRLoad":{const e=s.url,t=s.readyState;if(!e||"number"==typeof t&&4!==t)break;const n=i.xhrs.get(e);if(!n)break;m=n.attributableURLs;break}default:m=[]}const p=Array.from(t);for(const e of[...m,...u])e&&(n.includes(e)||n.push(e),p[p.length-1]!==e&&p.push(e));e.attributableURLs=p,
e.children.forEach((e=>MainThreadTasks._computeRecursiveAttributableURLs(e,p,n,i))),p.length||e.parent||!n.length||MainThreadTasks._setRecursiveEmptyAttributableURLs(e,n)}static _setRecursiveEmptyAttributableURLs(e,t){e.attributableURLs.length||(e.attributableURLs=t.slice(),e.children.forEach((e=>MainThreadTasks._setRecursiveEmptyAttributableURLs(e,t))))}static _computeRecursiveTaskGroup(e,t){const n=a[e.event.name];e.group=n||t||i.other,e.children.forEach((t=>MainThreadTasks._computeRecursiveTaskGroup(t,e.group)))}static getMainThreadTasks(e,t,n){const i=new Map,a=new Map,s=new Map;t.forEach((({id:e,url:t})=>s.set(e,t)));const c={timers:i,xhrs:a,frameURLsById:s,lastTaskURLs:[]},l=MainThreadTasks._createTasksFromEvents(e,c,n);for(const e of l)e.parent||(MainThreadTasks._computeRecursiveSelfTime(e,void 0),MainThreadTasks._computeRecursiveAttributableURLs(e,[],[],c),MainThreadTasks._computeRecursiveTaskGroup(e),c.lastTaskURLs=e.attributableURLs);const u=(l[0]||{startTime:0}).startTime
;for(const e of l)if(e.startTime=(e.startTime-u)/1e3,e.endTime=(e.endTime-u)/1e3,e.duration/=1e3,e.selfTime/=1e3,!Number.isFinite(e.selfTime))throw new Error("Invalid task timing data");return l}static printTaskTreeToDebugString(e,t={}){const n=Math.max(...e.map((e=>e.endTime)),0),{printWidth:i=100,startTime:a=0,endTime:s=n,taskLabelFn:c=(e=>e.event.name)}=t;function computeTaskDepth(e){let t=0;for(;e.parent;e=e.parent)t++;return t}const l=(s-a)/i,u=new Map,d=new Map;for(const t of e){if(t.startTime>s||t.endTime<a)continue;const e=computeTaskDepth(t),n=d.get(e)||[];n.push(t),d.set(e,n);const i=String.fromCharCode(65+u.size%26);u.set(t,{id:i,task:t})}const m=[`Trace Duration: ${n.toFixed(0)}ms`,`Range: [${a}, ${s}]`,`█ = ${l.toFixed(2)}ms`,""],p=Array.from(d.entries()).sort(((e,t)=>e[0]-t[0]));for(const[,e]of p){const t=Array.from({length:i}).map((()=>" "));for(const n of e){const e=Math.max(n.startTime,a),i=Math.min(n.endTime,s),{id:c}=u.get(n)||{id:"?"
},d=Math.floor(e/l),m=Math.floor(i/l),p=Math.floor((d+m)/2);for(let e=d;e<=m;e++)t[e]="█";for(let e=0;e<c.length;e++)t[p]=c}m.push(t.join(""))}m.push("");for(const{id:e,task:t}of u.values())m.push(`${e} = ${c(t)}`);return m.join("\n")}}t.exports=MainThreadTasks},{"./task-groups.js":118}],118:[function(e,t,n){"use strict";const i={parseHTML:{id:"parseHTML",label:"Parse HTML & CSS",traceEventNames:["ParseHTML","ParseAuthorStyleSheet"]},styleLayout:{id:"styleLayout",label:"Style & Layout",traceEventNames:["ScheduleStyleRecalculation","UpdateLayoutTree","InvalidateLayout","Layout"]},paintCompositeRender:{id:"paintCompositeRender",label:"Rendering",traceEventNames:["Animation","HitTest","PaintSetup","Paint","PaintImage","RasterTask","ScrollLayer","UpdateLayer","UpdateLayerTree","CompositeLayers"]},scriptParseCompile:{id:"scriptParseCompile",label:"Script Parsing & Compilation",traceEventNames:["v8.compile","v8.compileModule","v8.parseOnBackground"]},scriptEvaluation:{id:"scriptEvaluation",
label:"Script Evaluation",traceEventNames:["EventDispatch","EvaluateScript","v8.evaluateModule","FunctionCall","TimerFire","FireIdleCallback","FireAnimationFrame","RunMicrotasks","V8.Execute"]},garbageCollection:{id:"garbageCollection",label:"Garbage Collection",traceEventNames:["MinorGC","MajorGC","BlinkGC.AtomicPhase","ThreadState::performIdleLazySweep","ThreadState::completeSweep","BlinkGCMarking"]},other:{id:"other",label:"Other",traceEventNames:["MessageLoop::RunTask","TaskQueueManager::ProcessTaskFromWorkQueue","ThreadControllerImpl::DoWork"]}},a={};for(const e of Object.values(i))for(const t of e.traceEventNames)a[t]=e;t.exports={taskGroups:i,taskNameToGroup:a}},{}],119:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=/^(chrome|https?):/;class TraceProcessor{static get TIMESPAN_MARKER_ID(){return"__lighthouseTimespanStart__"}static createNoNavstartError(){return new Error("No navigationStart event found")}static createNoResourceSendRequestError(){
return new Error("No ResourceSendRequest event found")}static createNoTracingStartedError(){return new Error("No tracingStartedInBrowser event found")}static createNoFirstContentfulPaintError(){return new Error("No FirstContentfulPaint event found")}static createNoLighthouseMarkerError(){return new Error("No Lighthouse timespan marker event found")}static _isNavigationStartOfInterest(e){return"navigationStart"===e.name&&(!e.args.data||!e.args.data.documentLoaderURL||a.test(e.args.data.documentLoaderURL))}static _sortTimestampEventGroup(e,t,n,i){const lookupArrayIndexByTsIndex=e=>t[e],lookupEventByTsIndex=e=>i[lookupArrayIndexByTsIndex(e)],a=[],s=[],c=[];for(const t of e){const e=lookupArrayIndexByTsIndex(t),n=lookupEventByTsIndex(t);"E"===n.ph?a.push(e):"X"===n.ph||"B"===n.ph?s.push(e):c.push(e)}const l=new Map;for(const a of s){const s=i[a];if("X"===s.ph)l.set(a,s.dur);else{let i=Number.MAX_SAFE_INTEGER,c=0;for(let a=n+e.length;a<t.length;a++){const e=lookupEventByTsIndex(a)
;if(e.name===s.name&&e.pid===s.pid&&e.tid===s.tid){if("E"===e.ph&&0===c){i=e.ts-s.ts;break}"E"===e.ph?c--:"B"===e.ph&&c++}}l.set(a,i)}}return s.sort(((e,t)=>(l.get(t)||0)-(l.get(e)||0)||e-t)),c.sort(((e,t)=>e-t)),[...a,...s,...c]}static filteredTraceSort(e,t){const n=[];for(let i=0;i<e.length;i++)t(e[i])&&n.push(i);n.sort(((t,n)=>e[t].ts-e[n].ts));for(let t=0;t<n.length-1;t++){const i=e[n[t]].ts,a=[t];for(let s=t+1;s<n.length&&e[n[s]].ts===i;s++)a.push(s);if(1===a.length)continue;const s=TraceProcessor._sortTimestampEventGroup(a,n,t,e);n.splice(t,s.length,...s),t+=a.length-1}const i=[];for(let t=0;t<n.length;t++)i.push(e[n[t]]);return i}static assertHasToplevelEvents(e){if(!e.some(this.isScheduleableTask))throw new Error("Could not find any top level events")}static _riskPercentiles(e,t,n,i=0){let a=0;for(let t=0;t<e.length;t++)a+=e[t];a-=i;let s=t-a,c=0,l=s;const u=[];let d=-1,m=e.length+1;i>0&&m--;for(const a of n){const n=a*t;for(;l<n&&d<e.length-1;)s+=c,m-=c<0?-1:1,
i>0&&i<e[d+1]?(c=-i,i=0):(d++,c=e[d]),l=s+Math.abs(c)*m;u.push({percentile:a,time:Math.max(0,(n-s)/m)+16})}return u}static getRiskToResponsiveness(e,t,n,i=[.5,.75,.9,.99,1]){const a=n-t;i.sort(((e,t)=>e-t));const s=this.getMainThreadTopLevelEventDurations(e,t,n);return this._riskPercentiles(s.durations,a,i,s.clippedLength)}static getMainThreadTopLevelEventDurations(e,t=0,n=1/0){const i=[];let a=0;for(const s of e){if(s.end<t||s.start>n)continue;let e=s.duration,c=s.start;c<t&&(c=t,e=s.end-t),s.end>n&&(a=e-(n-c)),i.push(e)}return i.sort(((e,t)=>e-t)),{durations:i,clippedLength:a}}static getMainThreadTopLevelEvents(e,t=0,n=1/0){const i=[];for(const a of e.mainThreadEvents){if(!this.isScheduleableTask(a)||!a.dur)continue;const s=(a.ts-e.timeOriginEvt.ts)/1e3,c=(a.ts+a.dur-e.timeOriginEvt.ts)/1e3;s>n||c<t||i.push({start:s,end:c,duration:a.dur/1e3})}return i}static findMainFrameIds(e){const t=e.find((e=>"TracingStartedInBrowser"===e.name));if(t&&t.args.data&&t.args.data.frames){
const n=t.args.data.frames.find((e=>!e.parent)),i=n&&n.frame,a=n&&n.processId,s=e.find((e=>e.pid===a&&"M"===e.ph&&"__metadata"===e.cat&&"thread_name"===e.name&&"CrRendererMain"===e.args.name)),c=s&&s.tid;if(a&&c&&i)return{pid:a,tid:c,frameId:i}}const n=e.find((e=>"TracingStartedInPage"===e.name));if(n&&n.args&&n.args.data){const e=n.args.data.page;if(e)return{pid:n.pid,tid:n.tid,frameId:e}}const i=e.find((e=>Boolean("navigationStart"===e.name&&e.args&&e.args.data&&e.args.data.isLoadingMainFrame&&e.args.data.documentLoaderURL))),a=e.find((e=>"ResourceSendRequest"===e.name));if(i&&i.args&&i.args.data&&a&&a.pid===i.pid&&a.tid===i.tid){const e=i.args.frame;if(e)return{pid:i.pid,tid:i.tid,frameId:e}}throw this.createNoTracingStartedError()}static isScheduleableTask(e){return"RunTask"===e.name||"ThreadControllerImpl::RunTask"===e.name||"ThreadControllerImpl::DoWork"===e.name||"TaskQueueManager::ProcessTaskFromWorkQueue"===e.name}static isLCPEvent(e){
return("largestContentfulPaint::Invalidate"===e.name||"largestContentfulPaint::Candidate"===e.name)&&Boolean(e.args&&e.args.frame)}static isLCPCandidateEvent(e){return Boolean("largestContentfulPaint::Candidate"===e.name&&e.args&&e.args.frame&&e.args.data&&void 0!==e.args.data.size)}static computeValidLCPAllFrames(e,t){const n=e.filter(this.isLCPEvent).reverse(),i=new Map;for(const e of n){if(e.ts<=t.ts)break;const n=e.args.frame;i.has(n)||i.set(n,e)}let a;for(const e of i.values())this.isLCPCandidateEvent(e)&&(!a||e.args.data.size>a.args.data.size)&&(a=e);return{lcp:a,invalidated:Boolean(!a&&i.size)}}static resolveRootFrames(e){const t=new Map;for(const n of e)n.parent&&t.set(n.id,n.parent);const n=new Map;for(const i of e){let e=i.id;for(;t.has(e);)e=t.get(e);n.set(i.id,e)}return n}static processTrace(e,t){
const{timeOriginDeterminationMethod:n="auto"}=t||{},a=this.filteredTraceSort(e.traceEvents,(e=>e.cat.includes("blink.user_timing")||e.cat.includes("loading")||e.cat.includes("devtools.timeline")||"__metadata"===e.cat)),s=this.findMainFrameIds(a),c=a.filter((e=>Boolean("FrameCommittedInBrowser"===e.name&&e.args.data&&e.args.data.frame&&e.args.data.url))).map((e=>({id:e.args.data.frame,url:e.args.data.url,parent:e.args.data.parent}))),l=this.resolveRootFrames(c),u=a.filter((e=>e.args.frame===s.frameId));let d=[];l.has(s.frameId)?d=a.filter((e=>e.args.frame&&l.get(e.args.frame)===s.frameId)):(i.warn("trace-of-tab","frameTreeEvents may be incomplete, make sure the trace has FrameCommittedInBrowser events"),l.set(s.frameId,s.frameId),d=u);const m=this.computeTimeOrigin({keyEvents:a,frameEvents:u,mainFrameIds:s},n),p=TraceProcessor.filteredTraceSort(e.traceEvents,(e=>e.pid===s.pid)),h=p.filter((e=>e.tid===s.tid)),f=this.computeTraceEnd(e.traceEvents,m);return{frames:c,mainThreadEvents:h,
frameEvents:u,frameTreeEvents:d,processEvents:p,mainFrameIds:s,timeOriginEvt:m,timings:{timeOrigin:0,traceEnd:f.timing},timestamps:{timeOrigin:m.ts,traceEnd:f.timestamp}}}static processNavigation(e){const{frameEvents:t,frameTreeEvents:n,timeOriginEvt:i,timings:a,timestamps:s}=e,c=this.computeNavigationTimingsForFrame(t,{timeOriginEvt:i}),l=n.find((e=>"firstContentfulPaint"===e.name&&e.ts>i.ts));if(!l)throw this.createNoFirstContentfulPaintError();const u=this.computeValidLCPAllFrames(n,i).lcp,getTiming=e=>(e-i.ts)/1e3;return{timings:{timeOrigin:a.timeOrigin,firstPaint:c.timings.firstPaint,firstContentfulPaint:c.timings.firstContentfulPaint,firstContentfulPaintAllFrames:getTiming(l.ts),firstMeaningfulPaint:c.timings.firstMeaningfulPaint,largestContentfulPaint:c.timings.largestContentfulPaint,largestContentfulPaintAllFrames:(d=u&&u.ts,void 0===d?void 0:getTiming(d)),load:c.timings.load,domContentLoaded:c.timings.domContentLoaded,traceEnd:a.traceEnd},timestamps:{timeOrigin:s.timeOrigin,
firstPaint:c.timestamps.firstPaint,firstContentfulPaint:c.timestamps.firstContentfulPaint,firstContentfulPaintAllFrames:l.ts,firstMeaningfulPaint:c.timestamps.firstMeaningfulPaint,largestContentfulPaint:c.timestamps.largestContentfulPaint,largestContentfulPaintAllFrames:u&&u.ts,load:c.timestamps.load,domContentLoaded:c.timestamps.domContentLoaded,traceEnd:s.traceEnd},firstPaintEvt:c.firstPaintEvt,firstContentfulPaintEvt:c.firstContentfulPaintEvt,firstContentfulPaintAllFramesEvt:l,firstMeaningfulPaintEvt:c.firstMeaningfulPaintEvt,largestContentfulPaintEvt:c.largestContentfulPaintEvt,largestContentfulPaintAllFramesEvt:u,loadEvt:c.loadEvt,domContentLoadedEvt:c.domContentLoadedEvt,fmpFellBack:c.fmpFellBack,lcpInvalidated:c.lcpInvalidated};var d}static computeTraceEnd(e,t){let n=-1/0;for(const t of e)n=Math.max(t.ts+(t.dur||0),n);return{timestamp:n,timing:(n-t.ts)/1e3}}static computeTimeOrigin(e,t){
const lastNavigationStart=()=>e.frameEvents.filter(this._isNavigationStartOfInterest).pop(),lighthouseMarker=()=>e.keyEvents.find((e=>"clock_sync"===e.name&&e.args.sync_id===TraceProcessor.TIMESPAN_MARKER_ID));switch(t){case"firstResourceSendRequest":{const t=e.keyEvents.find((t=>{if("ResourceSendRequest"!==t.name)return!1;return(t.args.data||{}).frame===e.mainFrameIds.frameId}));if(!t)throw this.createNoResourceSendRequestError();return t}case"lastNavigationStart":{const e=lastNavigationStart();if(!e)throw this.createNoNavstartError();return e}case"lighthouseMarker":{const e=lighthouseMarker();if(!e)throw this.createNoLighthouseMarkerError();return e}case"auto":{const e=lighthouseMarker()||lastNavigationStart();if(!e)throw this.createNoNavstartError();return e}}}static computeNavigationTimingsForFrame(e,t){const{timeOriginEvt:n}=t,a=e.find((e=>"firstPaint"===e.name&&e.ts>n.ts)),s=e.find((e=>"firstContentfulPaint"===e.name&&e.ts>n.ts))
;if(!s)throw this.createNoFirstContentfulPaintError();let c=e.find((e=>"firstMeaningfulPaint"===e.name&&e.ts>n.ts)),l=!1;if(!c){const t="firstMeaningfulPaintCandidate";l=!0,i.verbose("trace-of-tab","No firstMeaningfulPaint found, falling back to last "+t);const n=e.filter((e=>e.name===t)).pop();n||i.verbose("trace-of-tab","No `firstMeaningfulPaintCandidate` events found in trace"),c=n}const u=this.computeValidLCPAllFrames(e,n),d=e.find((e=>"loadEventEnd"===e.name&&e.ts>n.ts)),m=e.find((e=>"domContentLoadedEventEnd"===e.name&&e.ts>n.ts)),getTimestamp=e=>e&&e.ts,p={timeOrigin:n.ts,firstPaint:getTimestamp(a),firstContentfulPaint:s.ts,firstMeaningfulPaint:getTimestamp(c),largestContentfulPaint:getTimestamp(u.lcp),load:getTimestamp(d),domContentLoaded:getTimestamp(m)},getTiming=e=>(e-n.ts)/1e3,maybeGetTiming=e=>void 0===e?void 0:getTiming(e);return{timings:{timeOrigin:0,firstPaint:maybeGetTiming(p.firstPaint),firstContentfulPaint:getTiming(p.firstContentfulPaint),
firstMeaningfulPaint:maybeGetTiming(p.firstMeaningfulPaint),largestContentfulPaint:maybeGetTiming(p.largestContentfulPaint),load:maybeGetTiming(p.load),domContentLoaded:maybeGetTiming(p.domContentLoaded)},timestamps:p,timeOriginEvt:n,firstPaintEvt:a,firstContentfulPaintEvt:s,firstMeaningfulPaintEvt:c,largestContentfulPaintEvt:u.lcp,loadEvt:d,domContentLoadedEvt:m,fmpFellBack:l,lcpInvalidated:u.invalidated}}}t.exports=TraceProcessor},{"lighthouse-logger":188}],120:[function(e,t,n){"use strict";const i=e("lighthouse-logger"),a=e("../tracehouse/trace-processor.js");class Metrics{constructor(e,t){this._traceEvents=e,this._auditResults=t}static get metricsDefinitions(){return[{name:"Time Origin",id:"timeorigin",tsKey:"observedTimeOriginTs"},{name:"First Contentful Paint",id:"ttfcp",tsKey:"observedFirstContentfulPaintTs"},{name:"First Meaningful Paint",id:"ttfmp",tsKey:"observedFirstMeaningfulPaintTs"},{name:"Speed Index",id:"si",tsKey:"observedSpeedIndexTs"},{name:"First Visual Change",
id:"fv",tsKey:"observedFirstVisualChangeTs"},{name:"Visually Complete 100%",id:"vc100",tsKey:"observedLastVisualChangeTs"},{name:"Interactive",id:"tti",tsKey:"interactiveTs"},{name:"End of Trace",id:"eot",tsKey:"observedTraceEndTs"},{name:"On Load",id:"onload",tsKey:"observedLoadTs"},{name:"DOM Content Loaded",id:"dcl",tsKey:"observedDomContentLoadedTs"}]}gatherMetrics(){const e=function getUberMetrics(e){const t=e.metrics;if(t&&t.details&&"items"in t.details)return t.details.items[0]}(this._auditResults);if(!e)return[];const t=[];return Metrics.metricsDefinitions.forEach((n=>{const a=e[n.tsKey];void 0!==a?t.push({id:n.id,name:n.name,ts:a}):i.error("pwmetrics-events",n.name+" timestamp not found")})),t}getTimeOriginEvt(e){const t=e.find((e=>"timeorigin"===e.id));if(!t)return{errorMessage:"timeorigin Metric not found in definitions"};try{const e=a.findMainFrameIds(this._traceEvents);return{pid:e.pid,tid:e.tid,ts:t.ts}}catch(e){return{errorMessage:e.message}}}synthesizeEventPair(e,t){
const n={pid:t.pid,tid:t.tid,cat:"blink.user_timing",name:e.name,args:{},id:"0x"+(1e6*Math.random()|0).toString(16)};return[Object.assign({},n,{ts:t.ts,ph:"b"}),Object.assign({},n,{ts:e.ts,ph:"e"})]}generateFakeEvents(){const e=this.gatherMetrics();if(0===e.length)return i.error("metrics-events","Metrics collection had errors, not synthetizing trace events"),[];const t=this.getTimeOriginEvt(e);if("errorMessage"in t)return i.error("pwmetrics-events","Reference timeOrigin error: "+t.errorMessage),[];const n=[];return e.forEach((e=>{"timeorigin"!==e.id&&(e.ts?(i.verbose("pwmetrics-events","Sythesizing trace events for "+e.name),n.push(...this.synthesizeEventPair(e,t))):i.error("pwmetrics-events",`(${e.name}) missing timestamp. Skipping…`))})),n}}t.exports=Metrics},{"../tracehouse/trace-processor.js":119,"lighthouse-logger":188}],121:[function(e,t,n){"use strict";t.exports={isObjectOfUnknownValues:function isObjectOfUnknownValues(e){return"object"==typeof e&&null!==e&&!Array.isArray(e)},
isObjectOrArrayOfUnknownValues:function isObjectOrArrayOfUnknownValues(e){return"object"==typeof e&&null!==e}}},{}],122:[function(e,t,n){(function(n){(function(){"use strict";const i=e("lodash.isequal"),a=e("./gather/driver.js"),s=e("./gather/gather-runner.js"),c=e("./scoring.js"),l=e("./audits/audit.js"),u=e("lighthouse-logger"),d=e("./lib/i18n/i18n.js"),m=e("./lib/stack-packs.js"),p=e("./lib/asset-saver.js"),h=e("path"),f=e("./lib/url-shim.js"),g=e("./lib/sentry.js"),y=e("../report/generator/report-generator.js").generateReport,b=e("./lib/lh-error.js");class Runner{static async run(t,n){const i=n.config.settings;try{const a={msg:"Runner setup",id:"lh:runner:run"};u.time(a,"verbose");const s=[],l=g.getContext();let h,v;if(g.captureBreadcrumb({message:"Run started",category:"lifecycle",data:l&&l.extra}),i.auditMode&&!i.gatherMode){const e=Runner._getDataSavePath(i);if(h=p.loadArtifacts(e),v=h.URL.requestedUrl,!v)throw new Error("Cannot run audit mode on empty URL")
;if(n.url&&!f.equalWithExcludedFragments(n.url,v))throw new Error("Cannot run audit mode on different URL")}else{if(!(n.url&&f.isValid(n.url)&&f.isProtocolAllowed(n.url)))throw new b(b.errors.INVALID_URL);if(v=new f(n.url).href,h=await t({requestedUrl:v,config:n.config,driverMock:n.driverMock}),i.gatherMode){const e=Runner._getDataSavePath(i);await p.saveArtifacts(h,e)}}if(i.gatherMode&&!i.auditMode)return;if(!n.config.audits)throw new Error("No audits to evaluate.");const w=await Runner._runAudits(i,n.config.audits,h,s,n.computedCache),S={msg:"Generating results...",id:"lh:runner:generate"};u.time(S),h.LighthouseRunWarnings&&s.push(...h.LighthouseRunWarnings);const T=e("../package.json").version,E={"axe-core":h.Accessibility&&h.Accessibility.version};let _={};n.config.categories&&(_=c.scoreAllCategories(n.config.categories,w)),u.timeEnd(S),u.timeEnd(a);const x={gatherMode:h.GatherContext.gatherMode,userAgent:h.HostUserAgent,environment:{networkUserAgent:h.NetworkUserAgent,
hostUserAgent:h.HostUserAgent,benchmarkIndex:h.BenchmarkIndex,credits:E},lighthouseVersion:T,fetchTime:h.fetchTime,requestedUrl:v,finalUrl:h.URL.finalUrl,runWarnings:s,runtimeError:Runner.getArtifactRuntimeError(h),audits:w,configSettings:i,categories:_,categoryGroups:n.config.groups||void 0,timing:this._getTiming(h),i18n:{rendererFormattedStrings:d.getRendererFormattedStrings(i.locale),icuMessagePaths:{}},stackPacks:m.getStackPacks(h.Stacks)};x.i18n.icuMessagePaths=d.replaceIcuMessages(x,i.locale);const A=x;if(i.gatherMode&&i.auditMode){const e=Runner._getDataSavePath(i);p.saveLhr(A,e)}return{lhr:A,artifacts:h,report:y(A,i.output)}}catch(e){throw e.friendlyMessage&&(e.friendlyMessage=d.getFormatted(e.friendlyMessage,i.locale)),await g.captureException(e,{level:"fatal"}),e}}static _getTiming(e){const t=[...e.Timing||[],...u.takeTimeEntries()].map((e=>[e.startTime,e])),n=Array.from(new Map(t).values()).map((e=>({startTime:parseFloat(e.startTime.toFixed(2)),name:e.name,
duration:parseFloat(e.duration.toFixed(2)),entryType:e.entryType}))),i=n.find((e=>"lh:runner:run"===e.name));return{entries:n,total:i&&i.duration||0}}static async _gatherArtifactsFromBrowser(e,t,n){if(!t.config.passes)throw new Error("No browser artifacts are either provided or requested.");const i={driver:t.driverMock||new a(n),requestedUrl:e,settings:t.config.settings,computedCache:t.computedCache};return await s.run(t.config.passes,i)}static async _runAudits(e,t,n,a,s){const c={msg:"Analyzing and running audits...",id:"lh:runner:auditing"};if(u.time(c),n.settings){const t={locale:void 0,gatherMode:void 0,auditMode:void 0,output:void 0,channel:void 0,budgets:void 0},a=Object.assign({},n.settings,t),s=Object.assign({},e,t);if(!i(a,s))throw new Error("Cannot change settings between gathering and auditing")}const l={settings:e,computedCache:s},d={};for(const e of t){const t=e.implementation.meta.id,i=await Runner._runAudit(e,n,l,a);d[t]=i}return u.timeEnd(c),d}
static async _runAudit(e,t,n,i){const a=e.implementation,s={msg:"Auditing: "+d.getFormatted(a.meta.title,"en-US"),id:"lh:audit:"+a.meta.id};let c;u.time(s);try{for(const e of a.meta.requiredArtifacts){const n=void 0===t[e],i="traces"===e&&!t.traces[l.DEFAULT_PASS],s="devtoolsLogs"===e&&!t.devtoolsLogs[l.DEFAULT_PASS];if(n||i||s)throw u.warn("Runner",`${e} gatherer, required by audit ${a.meta.id}, did not run.`),new b(b.errors.MISSING_REQUIRED_ARTIFACT,{artifactName:e});if(t[e]instanceof Error){const n=t[e];g.captureException(n,{tags:{gatherer:e},level:"error"}),u.warn("Runner",`${e} gatherer, required by audit ${a.meta.id}, encountered an error: `+n.message);const i=new b(b.errors.ERRORED_REQUIRED_ARTIFACT,{artifactName:e,errorMessage:n.message});throw i.expected=!0,i}}const s={options:Object.assign({},a.defaultOptions,e.options),...n},d=a.meta.requiredArtifacts.concat(a.meta.__internalOptionalArtifacts||[]).reduce(((e,n)=>{const i=t[n];return e[n]=i,e}),{}),m=await a.audit(d,s)
;i.push(...m.runWarnings||[]),c=l.generateAuditResult(a,m)}catch(e){"MISSING_REQUIRED_ARTIFACT"!==e.code&&"ERRORED_REQUIRED_ARTIFACT"!==e.code&&u.warn(a.meta.id,"Caught exception: "+e.message),g.captureException(e,{tags:{audit:a.meta.id},level:"error"});const t=e.friendlyMessage?e.friendlyMessage:e.message;c=l.generateErrorAuditResult(a,t)}return u.timeEnd(s),c}static getArtifactRuntimeError(e){const t=[e.PageLoadError,...Object.values(e)];for(const e of t)if(e instanceof b&&e.lhrRuntimeError){const t=e.friendlyMessage||e.message;return{code:e.code,message:t}}}static getAuditList(){const e=["audit.js","violation-audit.js","accessibility/axe-audit.js","multi-check-audit.js","byte-efficiency/byte-efficiency-audit.js","manual/manual-audit.js"]
;return["accessibility","apple-touch-icon.js","audit.js","autocomplete.js","bootup-time.js","byte-efficiency","content-width.js","critical-request-chains.js","csp-xss.js","deprecations.js","diagnostics.js","dobetterweb","errors-in-console.js","final-screenshot.js","font-display.js","full-page-screenshot.js","image-aspect-ratio.js","image-size-responsive.js","installable-manifest.js","is-on-https.js","largest-contentful-paint-element.js","layout-shift-elements.js","lcp-lazy-loaded.js","long-tasks.js","main-thread-tasks.js","mainthread-work-breakdown.js","manual","maskable-icon.js","metrics","metrics.js","multi-check-audit.js","network-requests.js","network-rtt.js","network-server-latency.js","no-unload-listeners.js","non-composited-animations.js","oopif-iframe-test-audit.js","performance-budget.js","predictive-perf.js","preload-fonts.js","preload-lcp-image.js","redirects-http.js","redirects.js","resource-summary.js","screenshot-thumbnails.js","script-treemap-data.js","seo","server-response-time.js","service-worker.js","splash-screen.js","themed-omnibox.js","third-party-facades.js","third-party-summary.js","timing-budget.js","unsized-images.js","user-timings.js","uses-rel-preconnect.js","uses-rel-preload.js","valid-source-maps.js","viewport.js","violation-audit.js",...["appcache-manifest.js","charset.js","doctype.js","dom-size.js","external-anchors-use-rel-noopener.js","geolocation-on-start.js","inspector-issues.js","js-libraries.js","no-document-write.js","no-vulnerable-libraries.js","notification-on-start.js","password-inputs-can-be-pasted-into.js","uses-http2.js","uses-passive-event-listeners.js"].map((e=>"dobetterweb/"+e)),...["cumulative-layout-shift.js","first-contentful-paint-3g.js","first-contentful-paint.js","first-meaningful-paint.js","interactive.js","largest-contentful-paint.js","max-potential-fid.js","speed-index.js","total-blocking-time.js"].map((e=>"metrics/"+e)),...["canonical.js","crawlable-anchors.js","font-size.js","hreflang.js","http-status-code.js","is-crawlable.js","link-text.js","manual","meta-description.js","plugins.js","robots-txt.js","tap-targets.js"].map((e=>"seo/"+e)),...["structured-data.js"].map((e=>"seo/manual/"+e)),...["accesskeys.js","aria-allowed-attr.js","aria-command-name.js","aria-hidden-body.js","aria-hidden-focus.js","aria-input-field-name.js","aria-meter-name.js","aria-progressbar-name.js","aria-required-attr.js","aria-required-children.js","aria-required-parent.js","aria-roles.js","aria-toggle-field-name.js","aria-tooltip-name.js","aria-treeitem-name.js","aria-valid-attr-value.js","aria-valid-attr.js","axe-audit.js","button-name.js","bypass.js","color-contrast.js","definition-list.js","dlitem.js","document-title.js","duplicate-id-active.js","duplicate-id-aria.js","form-field-multiple-labels.js","frame-title.js","heading-order.js","html-has-lang.js","html-lang-valid.js","image-alt.js","input-image-alt.js","label.js","link-name.js","list.js","listitem.js","manual","meta-refresh.js","meta-viewport.js","object-alt.js","tabindex.js","td-headers-attr.js","th-has-data-cells.js","valid-lang.js","video-caption.js"].map((e=>"accessibility/"+e)),...["custom-controls-labels.js","custom-controls-roles.js","focus-traps.js","focusable-controls.js","interactive-element-affordance.js","logical-tab-order.js","managed-focus.js","offscreen-content-hidden.js","use-landmarks.js","visual-order-follows-dom.js"].map((e=>"accessibility/manual/"+e)),...["byte-efficiency-audit.js","duplicated-javascript.js","efficient-animated-content.js","legacy-javascript.js","modern-image-formats.js","offscreen-images.js","polyfill-graph-data.json","render-blocking-resources.js","total-byte-weight.js","unminified-css.js","unminified-javascript.js","unused-css-rules.js","unused-javascript.js","uses-long-cache-ttl.js","uses-optimized-images.js","uses-responsive-images-snapshot.js","uses-responsive-images.js","uses-text-compression.js"].map((e=>"byte-efficiency/"+e)),...["manual-audit.js","pwa-cross-browser.js","pwa-each-page-has-url.js","pwa-page-transitions.js"].map((e=>"manual/"+e))].filter((t=>/\.js$/.test(t)&&!e.includes(t))).sort()
}static getGathererList(){return["accessibility.js","anchor-elements.js","cache-contents.js","console-messages.js","css-usage.js","devtools-log-compat.js","devtools-log.js","dobetterweb","form-elements.js","full-page-screenshot.js","gatherer.js","global-listeners.js","http-redirect.js","iframe-elements.js","image-elements.js","inspector-issues.js","installability-errors.js","js-usage.js","link-elements.js","main-document-content.js","meta-elements.js","network-user-agent.js","script-elements.js","seo","service-worker.js","source-maps.js","stacks.js","trace-compat.js","trace-elements.js","trace.js","viewport-dimensions.js","web-app-manifest.js",...["embedded-content.js","font-size.js","robots-txt.js","tap-targets.js"].map((e=>"seo/"+e)),...["appcache.js","doctype.js","domstats.js","optimized-images.js","password-inputs-with-prevented-paste.js","response-compression.js","tags-blocking-first-paint.js"].map((e=>"dobetterweb/"+e))].filter((e=>/\.js$/.test(e)&&"gatherer.js"!==e)).sort()}
static _getDataSavePath(e){const{auditMode:t,gatherMode:i}=e;return"string"==typeof t?h.resolve(n.cwd(),t):"string"==typeof i?h.resolve(n.cwd(),i):h.join(n.cwd(),"latest-run")}}t.exports=Runner}).call(this)}).call(this,e("_process"))},{"../package.json":259,"../report/generator/report-generator.js":260,"./audits/audit.js":3,"./gather/driver.js":65,"./gather/gather-runner.js":78,"./lib/asset-saver.js":82,"./lib/i18n/i18n.js":98,"./lib/lh-error.js":103,"./lib/sentry.js":112,"./lib/stack-packs.js":113,"./lib/url-shim.js":"url","./scoring.js":123,_process:223,"lighthouse-logger":188,"lodash.isequal":217,path:222}],123:[function(e,t,n){"use strict";const i=e("./audits/audit.js");class ReportScoring{static arithmeticMean(e){if((e=e.filter((e=>e.weight>0))).some((e=>null===e.score)))return null;const t=e.reduce(((e,t)=>{const n=t.score,i=t.weight;return{weight:e.weight+i,sum:e.sum+n*i}}),{weight:0,sum:0});return n=t.sum/t.weight||0,Math.round(100*n)/100;var n}static scoreAllCategories(e,t){
const n={};for(const[a,s]of Object.entries(e)){const e=s.auditRefs.map((e=>{const n={...e},a=t[n.id];return a.scoreDisplayMode!==i.SCORING_MODES.NOT_APPLICABLE&&a.scoreDisplayMode!==i.SCORING_MODES.INFORMATIVE&&a.scoreDisplayMode!==i.SCORING_MODES.MANUAL||(n.weight=0),n})),c=e.map((e=>({score:t[e.id].score,weight:e.weight}))),l=ReportScoring.arithmeticMean(c);n[a]={...s,auditRefs:e,id:a,score:l}}return n}}t.exports=ReportScoring},{"./audits/audit.js":3}],124:[function(e,t,n){"use strict";const i="…",a="data:image/jpeg;base64,",s={label:"pass",minScore:.9},c={label:"average",minScore:.5},l={label:"fail"},u={label:"error"},d=["com","co","gov","edu","ac","org","go","gob","or","net","in","ne","nic","gouv","web","spb","blog","jus","kiev","mil","wi","qc","ca","bel","on"];class Util{static get PASS_THRESHOLD(){return.9}static get MS_DISPLAY_VALUE(){return"%10d ms"}static prepareReportResult(e){const t=JSON.parse(JSON.stringify(e));t.configSettings.locale||(t.configSettings.locale="en"),
t.configSettings.formFactor||(t.configSettings.formFactor=t.configSettings.emulatedFormFactor);for(const e of Object.values(t.audits))if("not_applicable"!==e.scoreDisplayMode&&"not-applicable"!==e.scoreDisplayMode||(e.scoreDisplayMode="notApplicable"),e.details&&(void 0!==e.details.type&&"diagnostic"!==e.details.type||(e.details.type="debugdata"),"filmstrip"===e.details.type))for(const t of e.details.items)t.data.startsWith(a)||(t.data=a+t.data);if("object"!=typeof t.categories)throw new Error("No categories provided.");const n=new Map;for(const e of Object.values(t.categories))e.auditRefs.forEach((e=>{e.relevantAudits&&e.relevantAudits.forEach((t=>{const i=n.get(t)||[];i.push(e),n.set(t,i)}))})),e.auditRefs.forEach((e=>{const i=t.audits[e.id];e.result=i,n.has(e.id)&&(e.relevantMetrics=n.get(e.id)),t.stackPacks&&t.stackPacks.forEach((t=>{t.descriptions[e.id]&&(e.stackPacks=e.stackPacks||[],e.stackPacks.push({title:t.title,iconDataURL:t.iconDataURL,description:t.descriptions[e.id]}))}))
}));return t}static showAsPassed(e){switch(e.scoreDisplayMode){case"manual":case"notApplicable":return!0;case"error":case"informative":return!1;case"numeric":case"binary":default:return Number(e.score)>=s.minScore}}static calculateRating(e,t){if("manual"===t||"notApplicable"===t)return s.label;if("error"===t)return u.label;if(null===e)return l.label;let n=l.label;return e>=s.minScore?n=s.label:e>=c.minScore&&(n=c.label),n}static splitMarkdownCodeSpans(e){const t=[],n=e.split(/`(.*?)`/g);for(let e=0;e<n.length;e++){const i=n[e];if(!i)continue;const a=e%2!=0;t.push({isCode:a,text:i})}return t}static splitMarkdownLink(e){const t=[],n=e.split(/\[([^\]]+?)\]\((https?:\/\/.*?)\)/g);for(;n.length;){const[e,i,a]=n.splice(0,3);e&&t.push({isLink:!1,text:e}),i&&a&&t.push({isLink:!0,text:i,linkHref:a})}return t}static getURLDisplayName(e,t){const n=void 0!==(t=t||{numPathParts:void 0,preserveQuery:void 0,preserveHost:void 0
}).numPathParts?t.numPathParts:2,a=void 0===t.preserveQuery||t.preserveQuery,s=t.preserveHost||!1;let c;if("about:"===e.protocol||"data:"===e.protocol)c=e.href;else{c=e.pathname;const t=c.split("/").filter((e=>e.length));n&&t.length>n&&(c=i+t.slice(-1*n).join("/")),s&&(c=`${e.host}/${c.replace(/^\//,"")}`),a&&(c=`${c}${e.search}`)}if(c=c.replace(/([a-f0-9]{7})[a-f0-9]{13}[a-f0-9]*/g,"$1…"),c=c.replace(/([a-zA-Z0-9-_]{9})(?=.*[a-z])(?=.*[A-Z])(?=.*[0-9])[a-zA-Z0-9-_]{10,}/g,"$1…"),c=c.replace(/(\d{3})\d{6,}/g,"$1…"),c=c.replace(/\u2026+/g,i),c.length>64&&c.includes("?")&&(c=c.replace(/\?([^=]*)(=)?.*/,"?$1$2…"),c.length>64&&(c=c.replace(/\?.*/,"?…"))),c.length>64){const e=c.lastIndexOf(".");c=e>=0?c.slice(0,63-(c.length-e))+"…"+c.slice(e):c.slice(0,63)+i}return c}static parseURL(e){const t=new URL(e);return{file:Util.getURLDisplayName(t),hostname:t.hostname,origin:t.origin}}static createOrReturnURL(e){return e instanceof URL?e:new URL(e)}static getTld(e){const t=e.split(".").slice(-2)
;return d.includes(t[0])?"."+t.join("."):"."+t[t.length-1]}static getRootDomain(e){const t=Util.createOrReturnURL(e).hostname,n=Util.getTld(t).split(".");return t.split(".").slice(-n.length).join(".")}static getEnvironmentDisplayValues(e){const t=Util.getEmulationDescriptions(e);return[{name:Util.i18n.strings.runtimeSettingsDevice,description:t.deviceEmulation},{name:Util.i18n.strings.runtimeSettingsNetworkThrottling,description:t.networkThrottling},{name:Util.i18n.strings.runtimeSettingsCPUThrottling,description:t.cpuThrottling}]}static getEmulationDescriptions(e){let t,n;const i=e.throttling;switch(e.throttlingMethod){case"provided":t=Util.i18n.strings.throttlingProvided,n=Util.i18n.strings.throttlingProvided;break;case"devtools":{const{cpuSlowdownMultiplier:e,requestLatencyMs:a}=i;t=Util.i18n.formatNumber(e)+"x slowdown (DevTools)",
n=Util.i18n.formatNumber(a)+" ms HTTP RTT, "+Util.i18n.formatNumber(i.downloadThroughputKbps)+" Kbps down, "+Util.i18n.formatNumber(i.uploadThroughputKbps)+" Kbps up (DevTools)";break}case"simulate":{const{cpuSlowdownMultiplier:e,rttMs:a,throughputKbps:s}=i;t=Util.i18n.formatNumber(e)+"x slowdown (Simulated)",n=Util.i18n.formatNumber(a)+" ms TCP RTT, "+Util.i18n.formatNumber(s)+" Kbps throughput (Simulated)";break}default:t=Util.i18n.strings.runtimeUnknown,n=Util.i18n.strings.runtimeUnknown}return{deviceEmulation:{mobile:Util.i18n.strings.runtimeMobileEmulation,desktop:Util.i18n.strings.runtimeDesktopEmulation}[e.formFactor]||Util.i18n.strings.runtimeNoEmulation,cpuThrottling:t,networkThrottling:n}}static filterRelevantLines(e,t,n){if(0===t.length)return e.slice(0,2*n+1);const i=new Set;return(t=t.sort(((e,t)=>(e.lineNumber||0)-(t.lineNumber||0)))).forEach((({lineNumber:e})=>{let t=e-n,a=e+n;for(;t<1;)t++,a++;i.has(t-3-1)&&(t-=3);for(let e=t;e<=a;e++){const t=e;i.add(t)}})),
e.filter((e=>i.has(e.lineNumber)))}static isPluginCategory(e){return e.startsWith("lighthouse-plugin-")}}Util.reportJson=null,Util.getUniqueSuffix=(()=>{let e=0;return function(){return e++}})(),Util.i18n=null,Util.UIStrings={varianceDisclaimer:"Values are estimated and may vary. The [performance score is calculated](https://web.dev/performance-scoring/) directly from these metrics.",calculatorLink:"See calculator.",showRelevantAudits:"Show audits relevant to:",opportunityResourceColumnLabel:"Opportunity",opportunitySavingsColumnLabel:"Estimated Savings",errorMissingAuditInfo:"Report error: no audit information",errorLabel:"Error!",warningHeader:"Warnings: ",warningAuditsGroupTitle:"Passed audits but with warnings",passedAuditsGroupTitle:"Passed audits",notApplicableAuditsGroupTitle:"Not applicable",manualAuditsGroupTitle:"Additional items to manually check",toplevelWarningsMessage:"There were issues affecting this run of Lighthouse:",crcInitialNavigation:"Initial Navigation",
crcLongestDurationLabel:"Maximum critical path latency:",snippetExpandButtonLabel:"Expand snippet",snippetCollapseButtonLabel:"Collapse snippet",lsPerformanceCategoryDescription:"[Lighthouse](https://developers.google.com/web/tools/lighthouse/) analysis of the current page on an emulated mobile network. Values are estimated and may vary.",labDataTitle:"Lab Data",thirdPartyResourcesLabel:"Show 3rd-party resources",viewTreemapLabel:"View Treemap",dropdownPrintSummary:"Print Summary",dropdownPrintExpanded:"Print Expanded",dropdownCopyJSON:"Copy JSON",dropdownSaveHTML:"Save as HTML",dropdownSaveJSON:"Save as JSON",dropdownViewer:"Open in Viewer",dropdownSaveGist:"Save as Gist",dropdownDarkTheme:"Toggle Dark Theme",runtimeSettingsTitle:"Runtime Settings",runtimeSettingsUrl:"URL",runtimeSettingsFetchTime:"Fetch Time",runtimeSettingsDevice:"Device",runtimeSettingsNetworkThrottling:"Network throttling",runtimeSettingsCPUThrottling:"CPU throttling",runtimeSettingsChannel:"Channel",
runtimeSettingsUA:"User agent (host)",runtimeSettingsUANetwork:"User agent (network)",runtimeSettingsBenchmark:"CPU/Memory Power",runtimeSettingsAxeVersion:"Axe version",footerIssue:"File an issue",runtimeNoEmulation:"No emulation",runtimeMobileEmulation:"Emulated Moto G4",runtimeDesktopEmulation:"Emulated Desktop",runtimeUnknown:"Unknown",throttlingProvided:"Provided by environment"},t.exports=Util},{}],125:[function(e,t,n){const i=/([a-zA-Z][a-zA-Z_-]*)\s*(?:=(?:"([^"]*)"|([^ \t",;]*)))?/g,a="max-age",s="s-maxage",c="max-stale",l="min-fresh",u="immutable",d="must-revalidate",m="no-cache",p="no-store",h="no-transform",f="only-if-cached",g="private",y="proxy-revalidate",b="public";function parseBooleanOnly(e){return null===e}function parseDuration(e){if(!e)return null;const t=parseInt(e,10);return!Number.isFinite(t)||t<0?null:t}class CacheControl{constructor(){this.maxAge=null,this.sharedMaxAge=null,this.maxStale=null,this.maxStaleDuration=null,this.minFresh=null,this.immutable=null,
this.mustRevalidate=null,this.noCache=null,this.noStore=null,this.noTransform=null,this.onlyIfCached=null,this.private=null,this.proxyRevalidate=null,this.public=null}parse(e){if(!e||0===e.length)return this;const t={},n=e.match(i)||[];return Array.prototype.forEach.call(n,(e=>{const n=e.split("=",2),[i]=n;let a=null;n.length>1&&(a=n[1].trim()),t[i.toLowerCase()]=a})),this.maxAge=parseDuration(t[a]),this.sharedMaxAge=parseDuration(t[s]),this.maxStale=parseBooleanOnly(t[c]),this.maxStaleDuration=parseDuration(t[c]),this.maxStaleDuration&&(this.maxStale=!0),this.minFresh=parseDuration(t[l]),this.immutable=parseBooleanOnly(t[u]),this.mustRevalidate=parseBooleanOnly(t[d]),this.noCache=parseBooleanOnly(t[m]),this.noStore=parseBooleanOnly(t[p]),this.noTransform=parseBooleanOnly(t[h]),this.onlyIfCached=parseBooleanOnly(t[f]),this.private=parseBooleanOnly(t[g]),this.proxyRevalidate=parseBooleanOnly(t[y]),this.public=parseBooleanOnly(t[b]),this}format(){const e=[]
;return this.maxAge&&e.push(`${a}=${this.maxAge}`),this.sharedMaxAge&&e.push(`${s}=${this.sharedMaxAge}`),this.maxStale&&(this.maxStaleDuration?e.push(`${c}=${this.maxStaleDuration}`):e.push(c)),this.minFresh&&e.push(`${l}=${this.minFresh}`),this.immutable&&e.push(u),this.mustRevalidate&&e.push(d),this.noCache&&e.push(m),this.noStore&&e.push(p),this.noTransform&&e.push(h),this.onlyIfCached&&e.push(f),this.private&&e.push(g),this.proxyRevalidate&&e.push(y),this.public&&e.push(b),e.join(", ")}}t.exports={CacheControl,parse:function parse(e){return(new CacheControl).parse(e)},format:function format(e){return e instanceof CacheControl?e.format():CacheControl.prototype.format.call(e)}}},{}],126:[function(e,t,n){t.exports=function(e,t,n){if(e.filter)return e.filter(t,n);if(null==e)throw new TypeError;if("function"!=typeof t)throw new TypeError;for(var a=[],s=0;s<e.length;s++)if(i.call(e,s)){var c=e[s];t.call(n,c,s,e)&&a.push(c)}return a};var i=Object.prototype.hasOwnProperty},{}],
127:[function(e,t,n){(function(n){(function(){"use strict";
/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <feross@feross.org> <http://feross.org>
 * @license  MIT
 */function compare(e,t){if(e===t)return 0;for(var n=e.length,i=t.length,a=0,s=Math.min(n,i);a<s;++a)if(e[a]!==t[a]){n=e[a],i=t[a];break}return n<i?-1:i<n?1:0}function isBuffer(e){return n.Buffer&&"function"==typeof n.Buffer.isBuffer?n.Buffer.isBuffer(e):!(null==e||!e._isBuffer)}var i=e("util/"),a=Object.prototype.hasOwnProperty,s=Array.prototype.slice,c="foo"===function foo(){}.name;function pToString(e){return Object.prototype.toString.call(e)}function isView(e){return!isBuffer(e)&&("function"==typeof n.ArrayBuffer&&("function"==typeof ArrayBuffer.isView?ArrayBuffer.isView(e):!!e&&(e instanceof DataView||!!(e.buffer&&e.buffer instanceof ArrayBuffer))))}var l=t.exports=ok,u=/\s*function\s+([^\(\s]*)\s*/;function getName(e){if(i.isFunction(e)){if(c)return e.name;var t=e.toString().match(u);return t&&t[1]}}function truncate(e,t){return"string"==typeof e?e.length<t?e:e.slice(0,t):e}function inspect(e){if(c||!i.isFunction(e))return i.inspect(e);var t=getName(e)
;return"[Function"+(t?": "+t:"")+"]"}function fail(e,t,n,i,a){throw new l.AssertionError({message:n,actual:e,expected:t,operator:i,stackStartFunction:a})}function ok(e,t){e||fail(e,!0,t,"==",l.ok)}function _deepEqual(e,t,n,a){if(e===t)return!0;if(isBuffer(e)&&isBuffer(t))return 0===compare(e,t);if(i.isDate(e)&&i.isDate(t))return e.getTime()===t.getTime();if(i.isRegExp(e)&&i.isRegExp(t))return e.source===t.source&&e.global===t.global&&e.multiline===t.multiline&&e.lastIndex===t.lastIndex&&e.ignoreCase===t.ignoreCase;if(null!==e&&"object"==typeof e||null!==t&&"object"==typeof t){if(isView(e)&&isView(t)&&pToString(e)===pToString(t)&&!(e instanceof Float32Array||e instanceof Float64Array))return 0===compare(new Uint8Array(e.buffer),new Uint8Array(t.buffer));if(isBuffer(e)!==isBuffer(t))return!1;var c=(a=a||{actual:[],expected:[]}).actual.indexOf(e);return-1!==c&&c===a.expected.indexOf(t)||(a.actual.push(e),a.expected.push(t),function objEquiv(e,t,n,a){if(null==e||null==t)return!1
;if(i.isPrimitive(e)||i.isPrimitive(t))return e===t;if(n&&Object.getPrototypeOf(e)!==Object.getPrototypeOf(t))return!1;var c=isArguments(e),l=isArguments(t);if(c&&!l||!c&&l)return!1;if(c)return _deepEqual(e=s.call(e),t=s.call(t),n);var u,m,p=d(e),h=d(t);if(p.length!==h.length)return!1;for(p.sort(),h.sort(),m=p.length-1;m>=0;m--)if(p[m]!==h[m])return!1;for(m=p.length-1;m>=0;m--)if(!_deepEqual(e[u=p[m]],t[u],n,a))return!1;return!0}(e,t,n,a))}return n?e===t:e==t}function isArguments(e){return"[object Arguments]"==Object.prototype.toString.call(e)}function expectedException(e,t){if(!e||!t)return!1;if("[object RegExp]"==Object.prototype.toString.call(t))return t.test(e);try{if(e instanceof t)return!0}catch(e){}return!Error.isPrototypeOf(t)&&!0===t.call({},e)}function _throws(e,t,n,a){var s;if("function"!=typeof t)throw new TypeError('"block" argument must be a function');"string"==typeof n&&(a=n,n=null),s=function _tryBlock(e){var t;try{e()}catch(e){t=e}return t}(t),
a=(n&&n.name?" ("+n.name+").":".")+(a?" "+a:"."),e&&!s&&fail(s,n,"Missing expected exception"+a);var c="string"==typeof a,l=!e&&s&&!n;if((!e&&i.isError(s)&&c&&expectedException(s,n)||l)&&fail(s,n,"Got unwanted exception"+a),e&&s&&n&&!expectedException(s,n)||!e&&s)throw s}l.AssertionError=function AssertionError(e){this.name="AssertionError",this.actual=e.actual,this.expected=e.expected,this.operator=e.operator,e.message?(this.message=e.message,this.generatedMessage=!1):(this.message=function getMessage(e){return truncate(inspect(e.actual),128)+" "+e.operator+" "+truncate(inspect(e.expected),128)}(this),this.generatedMessage=!0);var t=e.stackStartFunction||fail;if(Error.captureStackTrace)Error.captureStackTrace(this,t);else{var n=new Error;if(n.stack){var i=n.stack,a=getName(t),s=i.indexOf("\n"+a);if(s>=0){var c=i.indexOf("\n",s+1);i=i.substring(c+1)}this.stack=i}}},i.inherits(l.AssertionError,Error),l.fail=fail,l.ok=ok,l.equal=function equal(e,t,n){e!=t&&fail(e,t,n,"==",l.equal)},
l.notEqual=function notEqual(e,t,n){e==t&&fail(e,t,n,"!=",l.notEqual)},l.deepEqual=function deepEqual(e,t,n){_deepEqual(e,t,!1)||fail(e,t,n,"deepEqual",l.deepEqual)},l.deepStrictEqual=function deepStrictEqual(e,t,n){_deepEqual(e,t,!0)||fail(e,t,n,"deepStrictEqual",l.deepStrictEqual)},l.notDeepEqual=function notDeepEqual(e,t,n){_deepEqual(e,t,!1)&&fail(e,t,n,"notDeepEqual",l.notDeepEqual)},l.notDeepStrictEqual=function notDeepStrictEqual(e,t,n){_deepEqual(e,t,!0)&&fail(e,t,n,"notDeepStrictEqual",notDeepStrictEqual)},l.strictEqual=function strictEqual(e,t,n){e!==t&&fail(e,t,n,"===",l.strictEqual)},l.notStrictEqual=function notStrictEqual(e,t,n){e===t&&fail(e,t,n,"!==",l.notStrictEqual)},l.throws=function(e,t,n){_throws(!0,e,t,n)},l.doesNotThrow=function(e,t,n){_throws(!1,e,t,n)},l.ifError=function(e){if(e)throw e};var d=Object.keys||function(e){var t=[];for(var n in e)a.call(e,n)&&t.push(n);return t}}).call(this)
}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"util/":130}],128:[function(e,t,n){"function"==typeof Object.create?t.exports=function inherits(e,t){e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}})}:t.exports=function inherits(e,t){e.super_=t;var TempCtor=function(){};TempCtor.prototype=t.prototype,e.prototype=new TempCtor,e.prototype.constructor=e}},{}],129:[function(e,t,n){t.exports=function isBuffer(e){return e&&"object"==typeof e&&"function"==typeof e.copy&&"function"==typeof e.fill&&"function"==typeof e.readUInt8}},{}],130:[function(e,t,n){(function(t,i){(function(){var a=/%[sdj%]/g;n.format=function(e){if(!isString(e)){for(var t=[],n=0;n<arguments.length;n++)t.push(inspect(arguments[n]));return t.join(" ")}n=1;for(var i=arguments,s=i.length,c=String(e).replace(a,(function(e){if("%%"===e)return"%";if(n>=s)return e;switch(e){case"%s":
return String(i[n++]);case"%d":return Number(i[n++]);case"%j":try{return JSON.stringify(i[n++])}catch(e){return"[Circular]"}default:return e}})),l=i[n];n<s;l=i[++n])isNull(l)||!isObject(l)?c+=" "+l:c+=" "+inspect(l);return c},n.deprecate=function(e,a){if(isUndefined(i.process))return function(){return n.deprecate(e,a).apply(this,arguments)};if(!0===t.noDeprecation)return e;var s=!1;return function deprecated(){if(!s){if(t.throwDeprecation)throw new Error(a);t.traceDeprecation?console.trace(a):console.error(a),s=!0}return e.apply(this,arguments)}};var s,c={};function inspect(e,t){var i={seen:[],stylize:stylizeNoColor};return arguments.length>=3&&(i.depth=arguments[2]),arguments.length>=4&&(i.colors=arguments[3]),isBoolean(t)?i.showHidden=t:t&&n._extend(i,t),isUndefined(i.showHidden)&&(i.showHidden=!1),isUndefined(i.depth)&&(i.depth=2),isUndefined(i.colors)&&(i.colors=!1),isUndefined(i.customInspect)&&(i.customInspect=!0),i.colors&&(i.stylize=stylizeWithColor),formatValue(i,e,i.depth)}
function stylizeWithColor(e,t){var n=inspect.styles[t];return n?"["+inspect.colors[n][0]+"m"+e+"["+inspect.colors[n][1]+"m":e}function stylizeNoColor(e,t){return e}function formatValue(e,t,i){if(e.customInspect&&t&&isFunction(t.inspect)&&t.inspect!==n.inspect&&(!t.constructor||t.constructor.prototype!==t)){var a=t.inspect(i,e);return isString(a)||(a=formatValue(e,a,i)),a}var s=function formatPrimitive(e,t){if(isUndefined(t))return e.stylize("undefined","undefined");if(isString(t)){var n="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(n,"string")}if(isNumber(t))return e.stylize(""+t,"number");if(isBoolean(t))return e.stylize(""+t,"boolean");if(isNull(t))return e.stylize("null","null")}(e,t);if(s)return s;var c=Object.keys(t),l=function arrayToHash(e){var t={};return e.forEach((function(e,n){t[e]=!0})),t}(c);if(e.showHidden&&(c=Object.getOwnPropertyNames(t)),
isError(t)&&(c.indexOf("message")>=0||c.indexOf("description")>=0))return formatError(t);if(0===c.length){if(isFunction(t)){var u=t.name?": "+t.name:"";return e.stylize("[Function"+u+"]","special")}if(isRegExp(t))return e.stylize(RegExp.prototype.toString.call(t),"regexp");if(isDate(t))return e.stylize(Date.prototype.toString.call(t),"date");if(isError(t))return formatError(t)}var d,m="",p=!1,h=["{","}"];(isArray(t)&&(p=!0,h=["[","]"]),isFunction(t))&&(m=" [Function"+(t.name?": "+t.name:"")+"]");return isRegExp(t)&&(m=" "+RegExp.prototype.toString.call(t)),isDate(t)&&(m=" "+Date.prototype.toUTCString.call(t)),isError(t)&&(m=" "+formatError(t)),0!==c.length||p&&0!=t.length?i<0?isRegExp(t)?e.stylize(RegExp.prototype.toString.call(t),"regexp"):e.stylize("[Object]","special"):(e.seen.push(t),d=p?function formatArray(e,t,n,i,a){for(var s=[],c=0,l=t.length;c<l;++c)hasOwnProperty(t,String(c))?s.push(formatProperty(e,t,n,i,String(c),!0)):s.push("");return a.forEach((function(a){
a.match(/^\d+$/)||s.push(formatProperty(e,t,n,i,a,!0))})),s}(e,t,i,l,c):c.map((function(n){return formatProperty(e,t,i,l,n,p)})),e.seen.pop(),function reduceToSingleString(e,t,n){if(e.reduce((function(e,t){return t.indexOf("\n")>=0&&0,e+t.replace(/\u001b\[\d\d?m/g,"").length+1}),0)>60)return n[0]+(""===t?"":t+"\n ")+" "+e.join(",\n  ")+" "+n[1];return n[0]+t+" "+e.join(", ")+" "+n[1]}(d,m,h)):h[0]+m+h[1]}function formatError(e){return"["+Error.prototype.toString.call(e)+"]"}function formatProperty(e,t,n,i,a,s){var c,l,u;if((u=Object.getOwnPropertyDescriptor(t,a)||{value:t[a]}).get?l=u.set?e.stylize("[Getter/Setter]","special"):e.stylize("[Getter]","special"):u.set&&(l=e.stylize("[Setter]","special")),hasOwnProperty(i,a)||(c="["+a+"]"),l||(e.seen.indexOf(u.value)<0?(l=isNull(n)?formatValue(e,u.value,null):formatValue(e,u.value,n-1)).indexOf("\n")>-1&&(l=s?l.split("\n").map((function(e){return"  "+e})).join("\n").substr(2):"\n"+l.split("\n").map((function(e){return"   "+e
})).join("\n")):l=e.stylize("[Circular]","special")),isUndefined(c)){if(s&&a.match(/^\d+$/))return l;(c=JSON.stringify(""+a)).match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(c=c.substr(1,c.length-2),c=e.stylize(c,"name")):(c=c.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),c=e.stylize(c,"string"))}return c+": "+l}function isArray(e){return Array.isArray(e)}function isBoolean(e){return"boolean"==typeof e}function isNull(e){return null===e}function isNumber(e){return"number"==typeof e}function isString(e){return"string"==typeof e}function isUndefined(e){return void 0===e}function isRegExp(e){return isObject(e)&&"[object RegExp]"===objectToString(e)}function isObject(e){return"object"==typeof e&&null!==e}function isDate(e){return isObject(e)&&"[object Date]"===objectToString(e)}function isError(e){return isObject(e)&&("[object Error]"===objectToString(e)||e instanceof Error)}function isFunction(e){return"function"==typeof e}function objectToString(e){
return Object.prototype.toString.call(e)}function pad(e){return e<10?"0"+e.toString(10):e.toString(10)}n.debuglog=function(e){if(isUndefined(s)&&(s=t.env.NODE_DEBUG||""),e=e.toUpperCase(),!c[e])if(new RegExp("\\b"+e+"\\b","i").test(s)){var i=t.pid;c[e]=function(){var t=n.format.apply(n,arguments);console.error("%s %d: %s",e,i,t)}}else c[e]=function(){};return c[e]},n.inspect=inspect,inspect.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},inspect.styles={special:"cyan",number:"yellow",boolean:"yellow",undefined:"grey",null:"bold",string:"green",date:"magenta",regexp:"red"},n.isArray=isArray,n.isBoolean=isBoolean,n.isNull=isNull,n.isNullOrUndefined=function isNullOrUndefined(e){return null==e},n.isNumber=isNumber,n.isString=isString,n.isSymbol=function isSymbol(e){return"symbol"==typeof e},n.isUndefined=isUndefined,n.isRegExp=isRegExp,
n.isObject=isObject,n.isDate=isDate,n.isError=isError,n.isFunction=isFunction,n.isPrimitive=function isPrimitive(e){return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||void 0===e},n.isBuffer=e("./support/isBuffer");var l=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];function timestamp(){var e=new Date,t=[pad(e.getHours()),pad(e.getMinutes()),pad(e.getSeconds())].join(":");return[e.getDate(),l[e.getMonth()],t].join(" ")}function hasOwnProperty(e,t){return Object.prototype.hasOwnProperty.call(e,t)}n.log=function(){console.log("%s - %s",timestamp(),n.format.apply(n,arguments))},n.inherits=e("inherits"),n._extend=function(e,t){if(!t||!isObject(t))return e;for(var n=Object.keys(t),i=n.length;i--;)e[n[i]]=t[n[i]];return e}}).call(this)}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./support/isBuffer":129,_process:223,inherits:128}],
131:[function(e,t,n){(function(n){(function(){"use strict";var i=e("array-filter");t.exports=function availableTypedArrays(){return i(["BigInt64Array","BigUint64Array","Float32Array","Float64Array","Int16Array","Int32Array","Int8Array","Uint16Array","Uint32Array","Uint8Array","Uint8ClampedArray"],(function(e){return"function"==typeof n[e]}))}}).call(this)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"array-filter":126}],132:[function(e,t,n){"use strict";n.byteLength=function byteLength(e){var t=getLens(e),n=t[0],i=t[1];return 3*(n+i)/4-i},n.toByteArray=function toByteArray(e){for(var t,n=getLens(e),i=n[0],c=n[1],l=new s(function _byteLength(e,t,n){return 3*(t+n)/4-n}(0,i,c)),u=0,d=c>0?i-4:i,m=0;m<d;m+=4)t=a[e.charCodeAt(m)]<<18|a[e.charCodeAt(m+1)]<<12|a[e.charCodeAt(m+2)]<<6|a[e.charCodeAt(m+3)],l[u++]=t>>16&255,l[u++]=t>>8&255,l[u++]=255&t;2===c&&(t=a[e.charCodeAt(m)]<<2|a[e.charCodeAt(m+1)]>>4,l[u++]=255&t)
;1===c&&(t=a[e.charCodeAt(m)]<<10|a[e.charCodeAt(m+1)]<<4|a[e.charCodeAt(m+2)]>>2,l[u++]=t>>8&255,l[u++]=255&t);return l},n.fromByteArray=function fromByteArray(e){for(var t,n=e.length,a=n%3,s=[],c=16383,l=0,u=n-a;l<u;l+=c)s.push(encodeChunk(e,l,l+c>u?u:l+c));1===a?(t=e[n-1],s.push(i[t>>2]+i[t<<4&63]+"==")):2===a&&(t=(e[n-2]<<8)+e[n-1],s.push(i[t>>10]+i[t>>4&63]+i[t<<2&63]+"="));return s.join("")};for(var i=[],a=[],s="undefined"!=typeof Uint8Array?Uint8Array:Array,c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",l=0,u=c.length;l<u;++l)i[l]=c[l],a[c.charCodeAt(l)]=l;function getLens(e){var t=e.length;if(t%4>0)throw new Error("Invalid string. Length must be a multiple of 4");var n=e.indexOf("=");return-1===n&&(n=t),[n,n===t?0:4-n%4]}function encodeChunk(e,t,n){for(var a,s,c=[],l=t;l<n;l+=3)a=(e[l]<<16&16711680)+(e[l+1]<<8&65280)+(255&e[l+2]),c.push(i[(s=a)>>18&63]+i[s>>12&63]+i[s>>6&63]+i[63&s]);return c.join("")}a["-".charCodeAt(0)]=62,a["_".charCodeAt(0)]=63},{}],
133:[function(e,t,n){},{}],134:[function(e,t,n){(function(t,i){(function(){"use strict";var a=e("assert"),s=e("pako/lib/zlib/zstream"),c=e("pako/lib/zlib/deflate.js"),l=e("pako/lib/zlib/inflate.js"),u=e("pako/lib/zlib/constants");for(var d in u)n[d]=u[d];n.NONE=0,n.DEFLATE=1,n.INFLATE=2,n.GZIP=3,n.GUNZIP=4,n.DEFLATERAW=5,n.INFLATERAW=6,n.UNZIP=7;function Zlib(e){if("number"!=typeof e||e<n.DEFLATE||e>n.UNZIP)throw new TypeError("Bad argument");this.dictionary=null,this.err=0,this.flush=0,this.init_done=!1,this.level=0,this.memLevel=0,this.mode=e,this.strategy=0,this.windowBits=0,this.write_in_progress=!1,this.pending_close=!1,this.gzip_id_bytes_read=0}Zlib.prototype.close=function(){this.write_in_progress?this.pending_close=!0:(this.pending_close=!1,a(this.init_done,"close before init"),a(this.mode<=n.UNZIP),
this.mode===n.DEFLATE||this.mode===n.GZIP||this.mode===n.DEFLATERAW?c.deflateEnd(this.strm):this.mode!==n.INFLATE&&this.mode!==n.GUNZIP&&this.mode!==n.INFLATERAW&&this.mode!==n.UNZIP||l.inflateEnd(this.strm),this.mode=n.NONE,this.dictionary=null)},Zlib.prototype.write=function(e,t,n,i,a,s,c){return this._write(!0,e,t,n,i,a,s,c)},Zlib.prototype.writeSync=function(e,t,n,i,a,s,c){return this._write(!1,e,t,n,i,a,s,c)},Zlib.prototype._write=function(e,s,c,l,u,d,m,p){if(a.equal(arguments.length,8),a(this.init_done,"write before init"),a(this.mode!==n.NONE,"already finalized"),a.equal(!1,this.write_in_progress,"write already in progress"),a.equal(!1,this.pending_close,"close is pending"),this.write_in_progress=!0,a.equal(!1,void 0===s,"must provide flush value"),this.write_in_progress=!0,s!==n.Z_NO_FLUSH&&s!==n.Z_PARTIAL_FLUSH&&s!==n.Z_SYNC_FLUSH&&s!==n.Z_FULL_FLUSH&&s!==n.Z_FINISH&&s!==n.Z_BLOCK)throw new Error("Invalid flush value");if(null==c&&(c=i.alloc(0),u=0,l=0),this.strm.avail_in=u,
this.strm.input=c,this.strm.next_in=l,this.strm.avail_out=p,this.strm.output=d,this.strm.next_out=m,this.flush=s,!e)return this._process(),this._checkError()?this._afterSync():void 0;var h=this;return t.nextTick((function(){h._process(),h._after()})),this},Zlib.prototype._afterSync=function(){var e=this.strm.avail_out,t=this.strm.avail_in;return this.write_in_progress=!1,[t,e]},Zlib.prototype._process=function(){var e=null;switch(this.mode){case n.DEFLATE:case n.GZIP:case n.DEFLATERAW:this.err=c.deflate(this.strm,this.flush);break;case n.UNZIP:switch(this.strm.avail_in>0&&(e=this.strm.next_in),this.gzip_id_bytes_read){case 0:if(null===e)break;if(31!==this.strm.input[e]){this.mode=n.INFLATE;break}if(this.gzip_id_bytes_read=1,e++,1===this.strm.avail_in)break;case 1:if(null===e)break;139===this.strm.input[e]?(this.gzip_id_bytes_read=2,this.mode=n.GUNZIP):this.mode=n.INFLATE;break;default:throw new Error("invalid number of gzip magic number bytes read")}case n.INFLATE:case n.GUNZIP:
case n.INFLATERAW:for(this.err=l.inflate(this.strm,this.flush),this.err===n.Z_NEED_DICT&&this.dictionary&&(this.err=l.inflateSetDictionary(this.strm,this.dictionary),this.err===n.Z_OK?this.err=l.inflate(this.strm,this.flush):this.err===n.Z_DATA_ERROR&&(this.err=n.Z_NEED_DICT));this.strm.avail_in>0&&this.mode===n.GUNZIP&&this.err===n.Z_STREAM_END&&0!==this.strm.next_in[0];)this.reset(),this.err=l.inflate(this.strm,this.flush);break;default:throw new Error("Unknown mode "+this.mode)}},Zlib.prototype._checkError=function(){switch(this.err){case n.Z_OK:case n.Z_BUF_ERROR:if(0!==this.strm.avail_out&&this.flush===n.Z_FINISH)return this._error("unexpected end of file"),!1;break;case n.Z_STREAM_END:break;case n.Z_NEED_DICT:return null==this.dictionary?this._error("Missing dictionary"):this._error("Bad dictionary"),!1;default:return this._error("Zlib error"),!1}return!0},Zlib.prototype._after=function(){if(this._checkError()){var e=this.strm.avail_out,t=this.strm.avail_in
;this.write_in_progress=!1,this.callback(t,e),this.pending_close&&this.close()}},Zlib.prototype._error=function(e){this.strm.msg&&(e=this.strm.msg),this.onerror(e,this.err),this.write_in_progress=!1,this.pending_close&&this.close()},Zlib.prototype.init=function(e,t,i,s,c){a(4===arguments.length||5===arguments.length,"init(windowBits, level, memLevel, strategy, [dictionary])"),a(e>=8&&e<=15,"invalid windowBits"),a(t>=-1&&t<=9,"invalid compression level"),a(i>=1&&i<=9,"invalid memlevel"),a(s===n.Z_FILTERED||s===n.Z_HUFFMAN_ONLY||s===n.Z_RLE||s===n.Z_FIXED||s===n.Z_DEFAULT_STRATEGY,"invalid strategy"),this._init(t,e,i,s,c),this._setDictionary()},Zlib.prototype.params=function(){throw new Error("deflateParams Not supported")},Zlib.prototype.reset=function(){this._reset(),this._setDictionary()},Zlib.prototype._init=function(e,t,i,a,u){switch(this.level=e,this.windowBits=t,this.memLevel=i,this.strategy=a,this.flush=n.Z_NO_FLUSH,this.err=n.Z_OK,
this.mode!==n.GZIP&&this.mode!==n.GUNZIP||(this.windowBits+=16),this.mode===n.UNZIP&&(this.windowBits+=32),this.mode!==n.DEFLATERAW&&this.mode!==n.INFLATERAW||(this.windowBits=-1*this.windowBits),this.strm=new s,this.mode){case n.DEFLATE:case n.GZIP:case n.DEFLATERAW:this.err=c.deflateInit2(this.strm,this.level,n.Z_DEFLATED,this.windowBits,this.memLevel,this.strategy);break;case n.INFLATE:case n.GUNZIP:case n.INFLATERAW:case n.UNZIP:this.err=l.inflateInit2(this.strm,this.windowBits);break;default:throw new Error("Unknown mode "+this.mode)}this.err!==n.Z_OK&&this._error("Init error"),this.dictionary=u,this.write_in_progress=!1,this.init_done=!0},Zlib.prototype._setDictionary=function(){if(null!=this.dictionary){switch(this.err=n.Z_OK,this.mode){case n.DEFLATE:case n.DEFLATERAW:this.err=c.deflateSetDictionary(this.strm,this.dictionary)}this.err!==n.Z_OK&&this._error("Failed to set dictionary")}},Zlib.prototype._reset=function(){switch(this.err=n.Z_OK,this.mode){case n.DEFLATE:
case n.DEFLATERAW:case n.GZIP:this.err=c.deflateReset(this.strm);break;case n.INFLATE:case n.INFLATERAW:case n.GUNZIP:this.err=l.inflateReset(this.strm)}this.err!==n.Z_OK&&this._error("Failed to reset stream")},n.Zlib=Zlib}).call(this)}).call(this,e("_process"),e("buffer").Buffer)},{_process:223,assert:127,buffer:145,"pako/lib/zlib/constants":138,"pako/lib/zlib/deflate.js":140,"pako/lib/zlib/inflate.js":144,"pako/lib/zlib/zstream":143}],135:[function(e,t,n){(function(t){(function(){"use strict";var i=e("buffer").Buffer,a=e("stream").Transform,s=e("./binding"),c=e("util"),l=e("assert").ok,u=e("buffer").kMaxLength,d="Cannot create final Buffer. It would be larger than 0x"+u.toString(16)+" bytes";s.Z_MIN_WINDOWBITS=8,s.Z_MAX_WINDOWBITS=15,s.Z_DEFAULT_WINDOWBITS=15,s.Z_MIN_CHUNK=64,s.Z_MAX_CHUNK=1/0,s.Z_DEFAULT_CHUNK=16384,s.Z_MIN_MEMLEVEL=1,s.Z_MAX_MEMLEVEL=9,s.Z_DEFAULT_MEMLEVEL=8,s.Z_MIN_LEVEL=-1,s.Z_MAX_LEVEL=9,s.Z_DEFAULT_LEVEL=s.Z_DEFAULT_COMPRESSION
;for(var m=Object.keys(s),p=0;p<m.length;p++){var h=m[p];h.match(/^Z/)&&Object.defineProperty(n,h,{enumerable:!0,value:s[h],writable:!1})}for(var f={Z_OK:s.Z_OK,Z_STREAM_END:s.Z_STREAM_END,Z_NEED_DICT:s.Z_NEED_DICT,Z_ERRNO:s.Z_ERRNO,Z_STREAM_ERROR:s.Z_STREAM_ERROR,Z_DATA_ERROR:s.Z_DATA_ERROR,Z_MEM_ERROR:s.Z_MEM_ERROR,Z_BUF_ERROR:s.Z_BUF_ERROR,Z_VERSION_ERROR:s.Z_VERSION_ERROR},g=Object.keys(f),y=0;y<g.length;y++){var b=g[y];f[f[b]]=b}function zlibBuffer(e,t,n){var a=[],s=0;function flow(){for(var t;null!==(t=e.read());)a.push(t),s+=t.length;e.once("readable",flow)}function onEnd(){var t,c=null;s>=u?c=new RangeError(d):t=i.concat(a,s),a=[],e.close(),n(c,t)}e.on("error",(function onError(t){e.removeListener("end",onEnd),e.removeListener("readable",flow),n(t)})),e.on("end",onEnd),e.end(t),flow()}function zlibBufferSync(e,t){if("string"==typeof t&&(t=i.from(t)),!i.isBuffer(t))throw new TypeError("Not a string or buffer");var n=e._finishFlushFlag;return e._processChunk(t,n)}
function Deflate(e){if(!(this instanceof Deflate))return new Deflate(e);Zlib.call(this,e,s.DEFLATE)}function Inflate(e){if(!(this instanceof Inflate))return new Inflate(e);Zlib.call(this,e,s.INFLATE)}function Gzip(e){if(!(this instanceof Gzip))return new Gzip(e);Zlib.call(this,e,s.GZIP)}function Gunzip(e){if(!(this instanceof Gunzip))return new Gunzip(e);Zlib.call(this,e,s.GUNZIP)}function DeflateRaw(e){if(!(this instanceof DeflateRaw))return new DeflateRaw(e);Zlib.call(this,e,s.DEFLATERAW)}function InflateRaw(e){if(!(this instanceof InflateRaw))return new InflateRaw(e);Zlib.call(this,e,s.INFLATERAW)}function Unzip(e){if(!(this instanceof Unzip))return new Unzip(e);Zlib.call(this,e,s.UNZIP)}function isValidFlushFlag(e){return e===s.Z_NO_FLUSH||e===s.Z_PARTIAL_FLUSH||e===s.Z_SYNC_FLUSH||e===s.Z_FULL_FLUSH||e===s.Z_FINISH||e===s.Z_BLOCK}function Zlib(e,t){var c=this;if(this._opts=e=e||{},this._chunkSize=e.chunkSize||n.Z_DEFAULT_CHUNK,a.call(this,e),
e.flush&&!isValidFlushFlag(e.flush))throw new Error("Invalid flush flag: "+e.flush);if(e.finishFlush&&!isValidFlushFlag(e.finishFlush))throw new Error("Invalid flush flag: "+e.finishFlush);if(this._flushFlag=e.flush||s.Z_NO_FLUSH,this._finishFlushFlag=void 0!==e.finishFlush?e.finishFlush:s.Z_FINISH,e.chunkSize&&(e.chunkSize<n.Z_MIN_CHUNK||e.chunkSize>n.Z_MAX_CHUNK))throw new Error("Invalid chunk size: "+e.chunkSize);if(e.windowBits&&(e.windowBits<n.Z_MIN_WINDOWBITS||e.windowBits>n.Z_MAX_WINDOWBITS))throw new Error("Invalid windowBits: "+e.windowBits);if(e.level&&(e.level<n.Z_MIN_LEVEL||e.level>n.Z_MAX_LEVEL))throw new Error("Invalid compression level: "+e.level);if(e.memLevel&&(e.memLevel<n.Z_MIN_MEMLEVEL||e.memLevel>n.Z_MAX_MEMLEVEL))throw new Error("Invalid memLevel: "+e.memLevel);if(e.strategy&&e.strategy!=n.Z_FILTERED&&e.strategy!=n.Z_HUFFMAN_ONLY&&e.strategy!=n.Z_RLE&&e.strategy!=n.Z_FIXED&&e.strategy!=n.Z_DEFAULT_STRATEGY)throw new Error("Invalid strategy: "+e.strategy)
;if(e.dictionary&&!i.isBuffer(e.dictionary))throw new Error("Invalid dictionary: it should be a Buffer instance");this._handle=new s.Zlib(t);var l=this;this._hadError=!1,this._handle.onerror=function(e,t){_close(l),l._hadError=!0;var i=new Error(e);i.errno=t,i.code=n.codes[t],l.emit("error",i)};var u=n.Z_DEFAULT_COMPRESSION;"number"==typeof e.level&&(u=e.level);var d=n.Z_DEFAULT_STRATEGY;"number"==typeof e.strategy&&(d=e.strategy),this._handle.init(e.windowBits||n.Z_DEFAULT_WINDOWBITS,u,e.memLevel||n.Z_DEFAULT_MEMLEVEL,d,e.dictionary),this._buffer=i.allocUnsafe(this._chunkSize),this._offset=0,this._level=u,this._strategy=d,this.once("end",this.close),Object.defineProperty(this,"_closed",{get:function(){return!c._handle},configurable:!0,enumerable:!0})}function _close(e,n){n&&t.nextTick(n),e._handle&&(e._handle.close(),e._handle=null)}function emitCloseNT(e){e.emit("close")}Object.defineProperty(n,"codes",{enumerable:!0,value:Object.freeze(f),writable:!1}),n.Deflate=Deflate,
n.Inflate=Inflate,n.Gzip=Gzip,n.Gunzip=Gunzip,n.DeflateRaw=DeflateRaw,n.InflateRaw=InflateRaw,n.Unzip=Unzip,n.createDeflate=function(e){return new Deflate(e)},n.createInflate=function(e){return new Inflate(e)},n.createDeflateRaw=function(e){return new DeflateRaw(e)},n.createInflateRaw=function(e){return new InflateRaw(e)},n.createGzip=function(e){return new Gzip(e)},n.createGunzip=function(e){return new Gunzip(e)},n.createUnzip=function(e){return new Unzip(e)},n.deflate=function(e,t,n){return"function"==typeof t&&(n=t,t={}),zlibBuffer(new Deflate(t),e,n)},n.deflateSync=function(e,t){return zlibBufferSync(new Deflate(t),e)},n.gzip=function(e,t,n){return"function"==typeof t&&(n=t,t={}),zlibBuffer(new Gzip(t),e,n)},n.gzipSync=function(e,t){return zlibBufferSync(new Gzip(t),e)},n.deflateRaw=function(e,t,n){return"function"==typeof t&&(n=t,t={}),zlibBuffer(new DeflateRaw(t),e,n)},n.deflateRawSync=function(e,t){return zlibBufferSync(new DeflateRaw(t),e)},n.unzip=function(e,t,n){
return"function"==typeof t&&(n=t,t={}),zlibBuffer(new Unzip(t),e,n)},n.unzipSync=function(e,t){return zlibBufferSync(new Unzip(t),e)},n.inflate=function(e,t,n){return"function"==typeof t&&(n=t,t={}),zlibBuffer(new Inflate(t),e,n)},n.inflateSync=function(e,t){return zlibBufferSync(new Inflate(t),e)},n.gunzip=function(e,t,n){return"function"==typeof t&&(n=t,t={}),zlibBuffer(new Gunzip(t),e,n)},n.gunzipSync=function(e,t){return zlibBufferSync(new Gunzip(t),e)},n.inflateRaw=function(e,t,n){return"function"==typeof t&&(n=t,t={}),zlibBuffer(new InflateRaw(t),e,n)},n.inflateRawSync=function(e,t){return zlibBufferSync(new InflateRaw(t),e)},c.inherits(Zlib,a),Zlib.prototype.params=function(e,i,a){if(e<n.Z_MIN_LEVEL||e>n.Z_MAX_LEVEL)throw new RangeError("Invalid compression level: "+e);if(i!=n.Z_FILTERED&&i!=n.Z_HUFFMAN_ONLY&&i!=n.Z_RLE&&i!=n.Z_FIXED&&i!=n.Z_DEFAULT_STRATEGY)throw new TypeError("Invalid strategy: "+i);if(this._level!==e||this._strategy!==i){var c=this
;this.flush(s.Z_SYNC_FLUSH,(function(){l(c._handle,"zlib binding closed"),c._handle.params(e,i),c._hadError||(c._level=e,c._strategy=i,a&&a())}))}else t.nextTick(a)},Zlib.prototype.reset=function(){return l(this._handle,"zlib binding closed"),this._handle.reset()},Zlib.prototype._flush=function(e){this._transform(i.alloc(0),"",e)},Zlib.prototype.flush=function(e,n){var a=this,c=this._writableState;("function"==typeof e||void 0===e&&!n)&&(n=e,e=s.Z_FULL_FLUSH),c.ended?n&&t.nextTick(n):c.ending?n&&this.once("end",n):c.needDrain?n&&this.once("drain",(function(){return a.flush(e,n)})):(this._flushFlag=e,this.write(i.alloc(0),"",n))},Zlib.prototype.close=function(e){_close(this,e),t.nextTick(emitCloseNT,this)},Zlib.prototype._transform=function(e,t,n){var a,c=this._writableState,l=(c.ending||c.ended)&&(!e||c.length===e.length);return null===e||i.isBuffer(e)?this._handle?(l?a=this._finishFlushFlag:(a=this._flushFlag,e.length>=c.length&&(this._flushFlag=this._opts.flush||s.Z_NO_FLUSH)),
void this._processChunk(e,a,n)):n(new Error("zlib binding closed")):n(new Error("invalid input"))},Zlib.prototype._processChunk=function(e,t,n){var a=e&&e.length,s=this._chunkSize-this._offset,c=0,m=this,p="function"==typeof n;if(!p){var h,f=[],g=0;this.on("error",(function(e){h=e})),l(this._handle,"zlib binding closed");do{var y=this._handle.writeSync(t,e,c,a,this._buffer,this._offset,s)}while(!this._hadError&&callback(y[0],y[1]));if(this._hadError)throw h;if(g>=u)throw _close(this),new RangeError(d);var b=i.concat(f,g);return _close(this),b}l(this._handle,"zlib binding closed");var v=this._handle.write(t,e,c,a,this._buffer,this._offset,s);function callback(u,d){if(this&&(this.buffer=null,this.callback=null),!m._hadError){var h=s-d;if(l(h>=0,"have should not go down"),h>0){var y=m._buffer.slice(m._offset,m._offset+h);m._offset+=h,p?m.push(y):(f.push(y),g+=y.length)}if((0===d||m._offset>=m._chunkSize)&&(s=m._chunkSize,m._offset=0,m._buffer=i.allocUnsafe(m._chunkSize)),0===d){if(c+=a-u,
a=u,!p)return!0;var b=m._handle.write(t,e,c,a,m._buffer,m._offset,m._chunkSize);return b.callback=callback,void(b.buffer=e)}if(!p)return!1;n()}}v.buffer=e,v.callback=callback},c.inherits(Deflate,Zlib),c.inherits(Inflate,Zlib),c.inherits(Gzip,Zlib),c.inherits(Gunzip,Zlib),c.inherits(DeflateRaw,Zlib),c.inherits(InflateRaw,Zlib),c.inherits(Unzip,Zlib)}).call(this)}).call(this,e("_process"))},{"./binding":134,_process:223,assert:127,buffer:145,stream:234,util:257}],136:[function(e,t,n){"use strict";var i="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Int32Array;function _has(e,t){return Object.prototype.hasOwnProperty.call(e,t)}n.assign=function(e){for(var t=Array.prototype.slice.call(arguments,1);t.length;){var n=t.shift();if(n){if("object"!=typeof n)throw new TypeError(n+"must be non-object");for(var i in n)_has(n,i)&&(e[i]=n[i])}}return e},n.shrinkBuf=function(e,t){return e.length===t?e:e.subarray?e.subarray(0,t):(e.length=t,e)};var a={
arraySet:function(e,t,n,i,a){if(t.subarray&&e.subarray)e.set(t.subarray(n,n+i),a);else for(var s=0;s<i;s++)e[a+s]=t[n+s]},flattenChunks:function(e){var t,n,i,a,s,c;for(i=0,t=0,n=e.length;t<n;t++)i+=e[t].length;for(c=new Uint8Array(i),a=0,t=0,n=e.length;t<n;t++)s=e[t],c.set(s,a),a+=s.length;return c}},s={arraySet:function(e,t,n,i,a){for(var s=0;s<i;s++)e[a+s]=t[n+s]},flattenChunks:function(e){return[].concat.apply([],e)}};n.setTyped=function(e){e?(n.Buf8=Uint8Array,n.Buf16=Uint16Array,n.Buf32=Int32Array,n.assign(n,a)):(n.Buf8=Array,n.Buf16=Array,n.Buf32=Array,n.assign(n,s))},n.setTyped(i)},{}],137:[function(e,t,n){"use strict";t.exports=function adler32(e,t,n,i){for(var a=65535&e|0,s=e>>>16&65535|0,c=0;0!==n;){n-=c=n>2e3?2e3:n;do{s=s+(a=a+t[i++]|0)|0}while(--c);a%=65521,s%=65521}return a|s<<16|0}},{}],138:[function(e,t,n){"use strict";t.exports={Z_NO_FLUSH:0,Z_PARTIAL_FLUSH:1,Z_SYNC_FLUSH:2,Z_FULL_FLUSH:3,Z_FINISH:4,Z_BLOCK:5,Z_TREES:6,Z_OK:0,Z_STREAM_END:1,Z_NEED_DICT:2,Z_ERRNO:-1,
Z_STREAM_ERROR:-2,Z_DATA_ERROR:-3,Z_BUF_ERROR:-5,Z_NO_COMPRESSION:0,Z_BEST_SPEED:1,Z_BEST_COMPRESSION:9,Z_DEFAULT_COMPRESSION:-1,Z_FILTERED:1,Z_HUFFMAN_ONLY:2,Z_RLE:3,Z_FIXED:4,Z_DEFAULT_STRATEGY:0,Z_BINARY:0,Z_TEXT:1,Z_UNKNOWN:2,Z_DEFLATED:8}},{}],139:[function(e,t,n){"use strict";var i=function makeTable(){for(var e,t=[],n=0;n<256;n++){e=n;for(var i=0;i<8;i++)e=1&e?3988292384^e>>>1:e>>>1;t[n]=e}return t}();t.exports=function crc32(e,t,n,a){var s=i,c=a+n;e^=-1;for(var l=a;l<c;l++)e=e>>>8^s[255&(e^t[l])];return-1^e}},{}],140:[function(e,t,n){"use strict";var i,a=e("../utils/common"),s=e("./trees"),c=e("./adler32"),l=e("./crc32"),u=e("./messages"),d=-2,m=258,p=262,h=103,f=113,g=666;function err(e,t){return e.msg=u[t],t}function rank(e){return(e<<1)-(e>4?9:0)}function zero(e){for(var t=e.length;--t>=0;)e[t]=0}function flush_pending(e){var t=e.state,n=t.pending;n>e.avail_out&&(n=e.avail_out),0!==n&&(a.arraySet(e.output,t.pending_buf,t.pending_out,n,e.next_out),e.next_out+=n,
t.pending_out+=n,e.total_out+=n,e.avail_out-=n,t.pending-=n,0===t.pending&&(t.pending_out=0))}function flush_block_only(e,t){s._tr_flush_block(e,e.block_start>=0?e.block_start:-1,e.strstart-e.block_start,t),e.block_start=e.strstart,flush_pending(e.strm)}function put_byte(e,t){e.pending_buf[e.pending++]=t}function putShortMSB(e,t){e.pending_buf[e.pending++]=t>>>8&255,e.pending_buf[e.pending++]=255&t}function longest_match(e,t){var n,i,a=e.max_chain_length,s=e.strstart,c=e.prev_length,l=e.nice_match,u=e.strstart>e.w_size-p?e.strstart-(e.w_size-p):0,d=e.window,h=e.w_mask,f=e.prev,g=e.strstart+m,y=d[s+c-1],b=d[s+c];e.prev_length>=e.good_match&&(a>>=2),l>e.lookahead&&(l=e.lookahead);do{if(d[(n=t)+c]===b&&d[n+c-1]===y&&d[n]===d[s]&&d[++n]===d[s+1]){s+=2,n++;do{}while(d[++s]===d[++n]&&d[++s]===d[++n]&&d[++s]===d[++n]&&d[++s]===d[++n]&&d[++s]===d[++n]&&d[++s]===d[++n]&&d[++s]===d[++n]&&d[++s]===d[++n]&&s<g);if(i=m-(g-s),s=g-m,i>c){if(e.match_start=t,c=i,i>=l)break;y=d[s+c-1],b=d[s+c]}}
}while((t=f[t&h])>u&&0!=--a);return c<=e.lookahead?c:e.lookahead}function fill_window(e){var t,n,i,s,u,d,m,h,f,g,y=e.w_size;do{if(s=e.window_size-e.lookahead-e.strstart,e.strstart>=y+(y-p)){a.arraySet(e.window,e.window,y,y,0),e.match_start-=y,e.strstart-=y,e.block_start-=y,t=n=e.hash_size;do{i=e.head[--t],e.head[t]=i>=y?i-y:0}while(--n);t=n=y;do{i=e.prev[--t],e.prev[t]=i>=y?i-y:0}while(--n);s+=y}if(0===e.strm.avail_in)break;if(d=e.strm,m=e.window,h=e.strstart+e.lookahead,f=s,g=void 0,(g=d.avail_in)>f&&(g=f),n=0===g?0:(d.avail_in-=g,a.arraySet(m,d.input,d.next_in,g,h),1===d.state.wrap?d.adler=c(d.adler,m,g,h):2===d.state.wrap&&(d.adler=l(d.adler,m,g,h)),d.next_in+=g,d.total_in+=g,g),e.lookahead+=n,e.lookahead+e.insert>=3)for(u=e.strstart-e.insert,e.ins_h=e.window[u],e.ins_h=(e.ins_h<<e.hash_shift^e.window[u+1])&e.hash_mask;e.insert&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[u+3-1])&e.hash_mask,e.prev[u&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=u,u++,e.insert--,
!(e.lookahead+e.insert<3)););}while(e.lookahead<p&&0!==e.strm.avail_in)}function deflate_fast(e,t){for(var n,i;;){if(e.lookahead<p){if(fill_window(e),e.lookahead<p&&0===t)return 1;if(0===e.lookahead)break}if(n=0,e.lookahead>=3&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),0!==n&&e.strstart-n<=e.w_size-p&&(e.match_length=longest_match(e,n)),e.match_length>=3)if(i=s._tr_tally(e,e.strstart-e.match_start,e.match_length-3),e.lookahead-=e.match_length,e.match_length<=e.max_lazy_match&&e.lookahead>=3){e.match_length--;do{e.strstart++,e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart}while(0!=--e.match_length);e.strstart++}else e.strstart+=e.match_length,e.match_length=0,e.ins_h=e.window[e.strstart],
e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+1])&e.hash_mask;else i=s._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++;if(i&&(flush_block_only(e,!1),0===e.strm.avail_out))return 1}return e.insert=e.strstart<2?e.strstart:2,4===t?(flush_block_only(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(flush_block_only(e,!1),0===e.strm.avail_out)?1:2}function deflate_slow(e,t){for(var n,i,a;;){if(e.lookahead<p){if(fill_window(e),e.lookahead<p&&0===t)return 1;if(0===e.lookahead)break}if(n=0,e.lookahead>=3&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart),e.prev_length=e.match_length,e.prev_match=e.match_start,e.match_length=2,0!==n&&e.prev_length<e.max_lazy_match&&e.strstart-n<=e.w_size-p&&(e.match_length=longest_match(e,n),e.match_length<=5&&(1===e.strategy||3===e.match_length&&e.strstart-e.match_start>4096)&&(e.match_length=2)),e.prev_length>=3&&e.match_length<=e.prev_length){
a=e.strstart+e.lookahead-3,i=s._tr_tally(e,e.strstart-1-e.prev_match,e.prev_length-3),e.lookahead-=e.prev_length-1,e.prev_length-=2;do{++e.strstart<=a&&(e.ins_h=(e.ins_h<<e.hash_shift^e.window[e.strstart+3-1])&e.hash_mask,n=e.prev[e.strstart&e.w_mask]=e.head[e.ins_h],e.head[e.ins_h]=e.strstart)}while(0!=--e.prev_length);if(e.match_available=0,e.match_length=2,e.strstart++,i&&(flush_block_only(e,!1),0===e.strm.avail_out))return 1}else if(e.match_available){if((i=s._tr_tally(e,0,e.window[e.strstart-1]))&&flush_block_only(e,!1),e.strstart++,e.lookahead--,0===e.strm.avail_out)return 1}else e.match_available=1,e.strstart++,e.lookahead--}return e.match_available&&(i=s._tr_tally(e,0,e.window[e.strstart-1]),e.match_available=0),e.insert=e.strstart<2?e.strstart:2,4===t?(flush_block_only(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(flush_block_only(e,!1),0===e.strm.avail_out)?1:2}function Config(e,t,n,i,a){this.good_length=e,this.max_lazy=t,this.nice_length=n,this.max_chain=i,this.func=a}
function DeflateState(){this.strm=null,this.status=0,this.pending_buf=null,this.pending_buf_size=0,this.pending_out=0,this.pending=0,this.wrap=0,this.gzhead=null,this.gzindex=0,this.method=8,this.last_flush=-1,this.w_size=0,this.w_bits=0,this.w_mask=0,this.window=null,this.window_size=0,this.prev=null,this.head=null,this.ins_h=0,this.hash_size=0,this.hash_bits=0,this.hash_mask=0,this.hash_shift=0,this.block_start=0,this.match_length=0,this.prev_match=0,this.match_available=0,this.strstart=0,this.match_start=0,this.lookahead=0,this.prev_length=0,this.max_chain_length=0,this.max_lazy_match=0,this.level=0,this.strategy=0,this.good_match=0,this.nice_match=0,this.dyn_ltree=new a.Buf16(1146),this.dyn_dtree=new a.Buf16(122),this.bl_tree=new a.Buf16(78),zero(this.dyn_ltree),zero(this.dyn_dtree),zero(this.bl_tree),this.l_desc=null,this.d_desc=null,this.bl_desc=null,this.bl_count=new a.Buf16(16),this.heap=new a.Buf16(573),zero(this.heap),this.heap_len=0,this.heap_max=0,
this.depth=new a.Buf16(573),zero(this.depth),this.l_buf=0,this.lit_bufsize=0,this.last_lit=0,this.d_buf=0,this.opt_len=0,this.static_len=0,this.matches=0,this.insert=0,this.bi_buf=0,this.bi_valid=0}function deflateResetKeep(e){var t;return e&&e.state?(e.total_in=e.total_out=0,e.data_type=2,(t=e.state).pending=0,t.pending_out=0,t.wrap<0&&(t.wrap=-t.wrap),t.status=t.wrap?42:f,e.adler=2===t.wrap?0:1,t.last_flush=0,s._tr_init(t),0):err(e,d)}function deflateReset(e){var t=deflateResetKeep(e);return 0===t&&function lm_init(e){e.window_size=2*e.w_size,zero(e.head),e.max_lazy_match=i[e.level].max_lazy,e.good_match=i[e.level].good_length,e.nice_match=i[e.level].nice_length,e.max_chain_length=i[e.level].max_chain,e.strstart=0,e.block_start=0,e.lookahead=0,e.insert=0,e.match_length=e.prev_length=2,e.match_available=0,e.ins_h=0}(e.state),t}function deflateInit2(e,t,n,i,s,c){if(!e)return d;var l=1;if(-1===t&&(t=6),i<0?(l=0,i=-i):i>15&&(l=2,i-=16),
s<1||s>9||8!==n||i<8||i>15||t<0||t>9||c<0||c>4)return err(e,d);8===i&&(i=9);var u=new DeflateState;return e.state=u,u.strm=e,u.wrap=l,u.gzhead=null,u.w_bits=i,u.w_size=1<<u.w_bits,u.w_mask=u.w_size-1,u.hash_bits=s+7,u.hash_size=1<<u.hash_bits,u.hash_mask=u.hash_size-1,u.hash_shift=~~((u.hash_bits+3-1)/3),u.window=new a.Buf8(2*u.w_size),u.head=new a.Buf16(u.hash_size),u.prev=new a.Buf16(u.w_size),u.lit_bufsize=1<<s+6,u.pending_buf_size=4*u.lit_bufsize,u.pending_buf=new a.Buf8(u.pending_buf_size),u.d_buf=1*u.lit_bufsize,u.l_buf=3*u.lit_bufsize,u.level=t,u.strategy=c,u.method=n,deflateReset(e)}i=[new Config(0,0,0,0,(function deflate_stored(e,t){var n=65535;for(n>e.pending_buf_size-5&&(n=e.pending_buf_size-5);;){if(e.lookahead<=1){if(fill_window(e),0===e.lookahead&&0===t)return 1;if(0===e.lookahead)break}e.strstart+=e.lookahead,e.lookahead=0;var i=e.block_start+n;if((0===e.strstart||e.strstart>=i)&&(e.lookahead=e.strstart-i,e.strstart=i,flush_block_only(e,!1),0===e.strm.avail_out))return 1
;if(e.strstart-e.block_start>=e.w_size-p&&(flush_block_only(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,4===t?(flush_block_only(e,!0),0===e.strm.avail_out?3:4):(e.strstart>e.block_start&&(flush_block_only(e,!1),e.strm.avail_out),1)})),new Config(4,4,8,4,deflate_fast),new Config(4,5,16,8,deflate_fast),new Config(4,6,32,32,deflate_fast),new Config(4,4,16,16,deflate_slow),new Config(8,16,32,32,deflate_slow),new Config(8,16,128,128,deflate_slow),new Config(8,32,128,256,deflate_slow),new Config(32,128,258,1024,deflate_slow),new Config(32,258,258,4096,deflate_slow)],n.deflateInit=function deflateInit(e,t){return deflateInit2(e,t,8,15,8,0)},n.deflateInit2=deflateInit2,n.deflateReset=deflateReset,n.deflateResetKeep=deflateResetKeep,n.deflateSetHeader=function deflateSetHeader(e,t){return e&&e.state?2!==e.state.wrap?d:(e.state.gzhead=t,0):d},n.deflate=function deflate(e,t){var n,a,c,u;if(!e||!e.state||t>5||t<0)return e?err(e,d):d;if(a=e.state,
!e.output||!e.input&&0!==e.avail_in||a.status===g&&4!==t)return err(e,0===e.avail_out?-5:d);if(a.strm=e,n=a.last_flush,a.last_flush=t,42===a.status)if(2===a.wrap)e.adler=0,put_byte(a,31),put_byte(a,139),put_byte(a,8),a.gzhead?(put_byte(a,(a.gzhead.text?1:0)+(a.gzhead.hcrc?2:0)+(a.gzhead.extra?4:0)+(a.gzhead.name?8:0)+(a.gzhead.comment?16:0)),put_byte(a,255&a.gzhead.time),put_byte(a,a.gzhead.time>>8&255),put_byte(a,a.gzhead.time>>16&255),put_byte(a,a.gzhead.time>>24&255),put_byte(a,9===a.level?2:a.strategy>=2||a.level<2?4:0),put_byte(a,255&a.gzhead.os),a.gzhead.extra&&a.gzhead.extra.length&&(put_byte(a,255&a.gzhead.extra.length),put_byte(a,a.gzhead.extra.length>>8&255)),a.gzhead.hcrc&&(e.adler=l(e.adler,a.pending_buf,a.pending,0)),a.gzindex=0,a.status=69):(put_byte(a,0),put_byte(a,0),put_byte(a,0),put_byte(a,0),put_byte(a,0),put_byte(a,9===a.level?2:a.strategy>=2||a.level<2?4:0),put_byte(a,3),a.status=f);else{var p=8+(a.w_bits-8<<4)<<8
;p|=(a.strategy>=2||a.level<2?0:a.level<6?1:6===a.level?2:3)<<6,0!==a.strstart&&(p|=32),p+=31-p%31,a.status=f,putShortMSB(a,p),0!==a.strstart&&(putShortMSB(a,e.adler>>>16),putShortMSB(a,65535&e.adler)),e.adler=1}if(69===a.status)if(a.gzhead.extra){for(c=a.pending;a.gzindex<(65535&a.gzhead.extra.length)&&(a.pending!==a.pending_buf_size||(a.gzhead.hcrc&&a.pending>c&&(e.adler=l(e.adler,a.pending_buf,a.pending-c,c)),flush_pending(e),c=a.pending,a.pending!==a.pending_buf_size));)put_byte(a,255&a.gzhead.extra[a.gzindex]),a.gzindex++;a.gzhead.hcrc&&a.pending>c&&(e.adler=l(e.adler,a.pending_buf,a.pending-c,c)),a.gzindex===a.gzhead.extra.length&&(a.gzindex=0,a.status=73)}else a.status=73;if(73===a.status)if(a.gzhead.name){c=a.pending;do{if(a.pending===a.pending_buf_size&&(a.gzhead.hcrc&&a.pending>c&&(e.adler=l(e.adler,a.pending_buf,a.pending-c,c)),flush_pending(e),c=a.pending,a.pending===a.pending_buf_size)){u=1;break}u=a.gzindex<a.gzhead.name.length?255&a.gzhead.name.charCodeAt(a.gzindex++):0,
put_byte(a,u)}while(0!==u);a.gzhead.hcrc&&a.pending>c&&(e.adler=l(e.adler,a.pending_buf,a.pending-c,c)),0===u&&(a.gzindex=0,a.status=91)}else a.status=91;if(91===a.status)if(a.gzhead.comment){c=a.pending;do{if(a.pending===a.pending_buf_size&&(a.gzhead.hcrc&&a.pending>c&&(e.adler=l(e.adler,a.pending_buf,a.pending-c,c)),flush_pending(e),c=a.pending,a.pending===a.pending_buf_size)){u=1;break}u=a.gzindex<a.gzhead.comment.length?255&a.gzhead.comment.charCodeAt(a.gzindex++):0,put_byte(a,u)}while(0!==u);a.gzhead.hcrc&&a.pending>c&&(e.adler=l(e.adler,a.pending_buf,a.pending-c,c)),0===u&&(a.status=h)}else a.status=h;if(a.status===h&&(a.gzhead.hcrc?(a.pending+2>a.pending_buf_size&&flush_pending(e),a.pending+2<=a.pending_buf_size&&(put_byte(a,255&e.adler),put_byte(a,e.adler>>8&255),e.adler=0,a.status=f)):a.status=f),0!==a.pending){if(flush_pending(e),0===e.avail_out)return a.last_flush=-1,0}else if(0===e.avail_in&&rank(t)<=rank(n)&&4!==t)return err(e,-5)
;if(a.status===g&&0!==e.avail_in)return err(e,-5);if(0!==e.avail_in||0!==a.lookahead||0!==t&&a.status!==g){var y=2===a.strategy?function deflate_huff(e,t){for(var n;;){if(0===e.lookahead&&(fill_window(e),0===e.lookahead)){if(0===t)return 1;break}if(e.match_length=0,n=s._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++,n&&(flush_block_only(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,4===t?(flush_block_only(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(flush_block_only(e,!1),0===e.strm.avail_out)?1:2}(a,t):3===a.strategy?function deflate_rle(e,t){for(var n,i,a,c,l=e.window;;){if(e.lookahead<=m){if(fill_window(e),e.lookahead<=m&&0===t)return 1;if(0===e.lookahead)break}if(e.match_length=0,e.lookahead>=3&&e.strstart>0&&(i=l[a=e.strstart-1])===l[++a]&&i===l[++a]&&i===l[++a]){c=e.strstart+m;do{}while(i===l[++a]&&i===l[++a]&&i===l[++a]&&i===l[++a]&&i===l[++a]&&i===l[++a]&&i===l[++a]&&i===l[++a]&&a<c);e.match_length=m-(c-a),
e.match_length>e.lookahead&&(e.match_length=e.lookahead)}if(e.match_length>=3?(n=s._tr_tally(e,1,e.match_length-3),e.lookahead-=e.match_length,e.strstart+=e.match_length,e.match_length=0):(n=s._tr_tally(e,0,e.window[e.strstart]),e.lookahead--,e.strstart++),n&&(flush_block_only(e,!1),0===e.strm.avail_out))return 1}return e.insert=0,4===t?(flush_block_only(e,!0),0===e.strm.avail_out?3:4):e.last_lit&&(flush_block_only(e,!1),0===e.strm.avail_out)?1:2}(a,t):i[a.level].func(a,t);if(3!==y&&4!==y||(a.status=g),1===y||3===y)return 0===e.avail_out&&(a.last_flush=-1),0;if(2===y&&(1===t?s._tr_align(a):5!==t&&(s._tr_stored_block(a,0,0,!1),3===t&&(zero(a.head),0===a.lookahead&&(a.strstart=0,a.block_start=0,a.insert=0))),flush_pending(e),0===e.avail_out))return a.last_flush=-1,0}return 4!==t?0:a.wrap<=0?1:(2===a.wrap?(put_byte(a,255&e.adler),put_byte(a,e.adler>>8&255),put_byte(a,e.adler>>16&255),put_byte(a,e.adler>>24&255),put_byte(a,255&e.total_in),put_byte(a,e.total_in>>8&255),
put_byte(a,e.total_in>>16&255),put_byte(a,e.total_in>>24&255)):(putShortMSB(a,e.adler>>>16),putShortMSB(a,65535&e.adler)),flush_pending(e),a.wrap>0&&(a.wrap=-a.wrap),0!==a.pending?0:1)},n.deflateEnd=function deflateEnd(e){var t;return e&&e.state?42!==(t=e.state.status)&&69!==t&&73!==t&&91!==t&&t!==h&&t!==f&&t!==g?err(e,d):(e.state=null,t===f?err(e,-3):0):d},n.deflateSetDictionary=function deflateSetDictionary(e,t){var n,i,s,l,u,m,p,h,f=t.length;if(!e||!e.state)return d;if(2===(l=(n=e.state).wrap)||1===l&&42!==n.status||n.lookahead)return d;for(1===l&&(e.adler=c(e.adler,t,f,0)),n.wrap=0,f>=n.w_size&&(0===l&&(zero(n.head),n.strstart=0,n.block_start=0,n.insert=0),h=new a.Buf8(n.w_size),a.arraySet(h,t,f-n.w_size,n.w_size,0),t=h,f=n.w_size),u=e.avail_in,m=e.next_in,p=e.input,e.avail_in=f,e.next_in=0,e.input=t,fill_window(n);n.lookahead>=3;){i=n.strstart,s=n.lookahead-2;do{n.ins_h=(n.ins_h<<n.hash_shift^n.window[i+3-1])&n.hash_mask,n.prev[i&n.w_mask]=n.head[n.ins_h],n.head[n.ins_h]=i,i++
}while(--s);n.strstart=i,n.lookahead=2,fill_window(n)}return n.strstart+=n.lookahead,n.block_start=n.strstart,n.insert=n.lookahead,n.lookahead=0,n.match_length=n.prev_length=2,n.match_available=0,e.next_in=m,e.input=p,e.avail_in=u,n.wrap=l,0},n.deflateInfo="pako deflate (from Nodeca project)"},{"../utils/common":136,"./adler32":137,"./crc32":139,"./messages":141,"./trees":142}],141:[function(e,t,n){"use strict";t.exports={2:"need dictionary",1:"stream end",0:"","-1":"file error","-2":"stream error","-3":"data error","-4":"insufficient memory","-5":"buffer error","-6":"incompatible version"}},{}],142:[function(e,t,n){"use strict";var i=e("../utils/common");function zero(e){for(var t=e.length;--t>=0;)e[t]=0}var a=256,s=286,c=30,l=15,u=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0],d=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],m=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,3,7],p=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],h=new Array(576);zero(h)
;var f=new Array(60);zero(f);var g=new Array(512);zero(g);var y=new Array(256);zero(y);var b=new Array(29);zero(b);var v,w,S,T=new Array(c);function StaticTreeDesc(e,t,n,i,a){this.static_tree=e,this.extra_bits=t,this.extra_base=n,this.elems=i,this.max_length=a,this.has_stree=e&&e.length}function TreeDesc(e,t){this.dyn_tree=e,this.max_code=0,this.stat_desc=t}function d_code(e){return e<256?g[e]:g[256+(e>>>7)]}function put_short(e,t){e.pending_buf[e.pending++]=255&t,e.pending_buf[e.pending++]=t>>>8&255}function send_bits(e,t,n){e.bi_valid>16-n?(e.bi_buf|=t<<e.bi_valid&65535,put_short(e,e.bi_buf),e.bi_buf=t>>16-e.bi_valid,e.bi_valid+=n-16):(e.bi_buf|=t<<e.bi_valid&65535,e.bi_valid+=n)}function send_code(e,t,n){send_bits(e,n[2*t],n[2*t+1])}function bi_reverse(e,t){var n=0;do{n|=1&e,e>>>=1,n<<=1}while(--t>0);return n>>>1}function gen_codes(e,t,n){var i,a,s=new Array(16),c=0;for(i=1;i<=l;i++)s[i]=c=c+n[i-1]<<1;for(a=0;a<=t;a++){var u=e[2*a+1];0!==u&&(e[2*a]=bi_reverse(s[u]++,u))}}
function init_block(e){var t;for(t=0;t<s;t++)e.dyn_ltree[2*t]=0;for(t=0;t<c;t++)e.dyn_dtree[2*t]=0;for(t=0;t<19;t++)e.bl_tree[2*t]=0;e.dyn_ltree[512]=1,e.opt_len=e.static_len=0,e.last_lit=e.matches=0}function bi_windup(e){e.bi_valid>8?put_short(e,e.bi_buf):e.bi_valid>0&&(e.pending_buf[e.pending++]=e.bi_buf),e.bi_buf=0,e.bi_valid=0}function smaller(e,t,n,i){var a=2*t,s=2*n;return e[a]<e[s]||e[a]===e[s]&&i[t]<=i[n]}function pqdownheap(e,t,n){for(var i=e.heap[n],a=n<<1;a<=e.heap_len&&(a<e.heap_len&&smaller(t,e.heap[a+1],e.heap[a],e.depth)&&a++,!smaller(t,i,e.heap[a],e.depth));)e.heap[n]=e.heap[a],n=a,a<<=1;e.heap[n]=i}function compress_block(e,t,n){var i,s,c,l,m=0;if(0!==e.last_lit)do{i=e.pending_buf[e.d_buf+2*m]<<8|e.pending_buf[e.d_buf+2*m+1],s=e.pending_buf[e.l_buf+m],m++,0===i?send_code(e,s,t):(send_code(e,(c=y[s])+a+1,t),0!==(l=u[c])&&send_bits(e,s-=b[c],l),send_code(e,c=d_code(--i),n),0!==(l=d[c])&&send_bits(e,i-=T[c],l))}while(m<e.last_lit);send_code(e,256,t)}
function build_tree(e,t){var n,i,a,s=t.dyn_tree,c=t.stat_desc.static_tree,u=t.stat_desc.has_stree,d=t.stat_desc.elems,m=-1;for(e.heap_len=0,e.heap_max=573,n=0;n<d;n++)0!==s[2*n]?(e.heap[++e.heap_len]=m=n,e.depth[n]=0):s[2*n+1]=0;for(;e.heap_len<2;)s[2*(a=e.heap[++e.heap_len]=m<2?++m:0)]=1,e.depth[a]=0,e.opt_len--,u&&(e.static_len-=c[2*a+1]);for(t.max_code=m,n=e.heap_len>>1;n>=1;n--)pqdownheap(e,s,n);a=d;do{n=e.heap[1],e.heap[1]=e.heap[e.heap_len--],pqdownheap(e,s,1),i=e.heap[1],e.heap[--e.heap_max]=n,e.heap[--e.heap_max]=i,s[2*a]=s[2*n]+s[2*i],e.depth[a]=(e.depth[n]>=e.depth[i]?e.depth[n]:e.depth[i])+1,s[2*n+1]=s[2*i+1]=a,e.heap[1]=a++,pqdownheap(e,s,1)}while(e.heap_len>=2);e.heap[--e.heap_max]=e.heap[1],function gen_bitlen(e,t){var n,i,a,s,c,u,d=t.dyn_tree,m=t.max_code,p=t.stat_desc.static_tree,h=t.stat_desc.has_stree,f=t.stat_desc.extra_bits,g=t.stat_desc.extra_base,y=t.stat_desc.max_length,b=0;for(s=0;s<=l;s++)e.bl_count[s]=0;for(d[2*e.heap[e.heap_max]+1]=0,
n=e.heap_max+1;n<573;n++)(s=d[2*d[2*(i=e.heap[n])+1]+1]+1)>y&&(s=y,b++),d[2*i+1]=s,i>m||(e.bl_count[s]++,c=0,i>=g&&(c=f[i-g]),u=d[2*i],e.opt_len+=u*(s+c),h&&(e.static_len+=u*(p[2*i+1]+c)));if(0!==b){do{for(s=y-1;0===e.bl_count[s];)s--;e.bl_count[s]--,e.bl_count[s+1]+=2,e.bl_count[y]--,b-=2}while(b>0);for(s=y;0!==s;s--)for(i=e.bl_count[s];0!==i;)(a=e.heap[--n])>m||(d[2*a+1]!==s&&(e.opt_len+=(s-d[2*a+1])*d[2*a],d[2*a+1]=s),i--)}}(e,t),gen_codes(s,m,e.bl_count)}function scan_tree(e,t,n){var i,a,s=-1,c=t[1],l=0,u=7,d=4;for(0===c&&(u=138,d=3),t[2*(n+1)+1]=65535,i=0;i<=n;i++)a=c,c=t[2*(i+1)+1],++l<u&&a===c||(l<d?e.bl_tree[2*a]+=l:0!==a?(a!==s&&e.bl_tree[2*a]++,e.bl_tree[32]++):l<=10?e.bl_tree[34]++:e.bl_tree[36]++,l=0,s=a,0===c?(u=138,d=3):a===c?(u=6,d=3):(u=7,d=4))}function send_tree(e,t,n){var i,a,s=-1,c=t[1],l=0,u=7,d=4;for(0===c&&(u=138,d=3),i=0;i<=n;i++)if(a=c,c=t[2*(i+1)+1],!(++l<u&&a===c)){if(l<d)do{send_code(e,a,e.bl_tree)}while(0!=--l);else 0!==a?(a!==s&&(send_code(e,a,e.bl_tree),
l--),send_code(e,16,e.bl_tree),send_bits(e,l-3,2)):l<=10?(send_code(e,17,e.bl_tree),send_bits(e,l-3,3)):(send_code(e,18,e.bl_tree),send_bits(e,l-11,7));l=0,s=a,0===c?(u=138,d=3):a===c?(u=6,d=3):(u=7,d=4)}}zero(T);var E=!1;function _tr_stored_block(e,t,n,a){send_bits(e,0+(a?1:0),3),function copy_block(e,t,n,a){bi_windup(e),a&&(put_short(e,n),put_short(e,~n)),i.arraySet(e.pending_buf,e.window,t,n,e.pending),e.pending+=n}(e,t,n,!0)}n._tr_init=function _tr_init(e){E||(!function tr_static_init(){var e,t,n,i,a,p=new Array(16);for(n=0,i=0;i<28;i++)for(b[i]=n,e=0;e<1<<u[i];e++)y[n++]=i;for(y[n-1]=i,a=0,i=0;i<16;i++)for(T[i]=a,e=0;e<1<<d[i];e++)g[a++]=i;for(a>>=7;i<c;i++)for(T[i]=a<<7,e=0;e<1<<d[i]-7;e++)g[256+a++]=i;for(t=0;t<=l;t++)p[t]=0;for(e=0;e<=143;)h[2*e+1]=8,e++,p[8]++;for(;e<=255;)h[2*e+1]=9,e++,p[9]++;for(;e<=279;)h[2*e+1]=7,e++,p[7]++;for(;e<=287;)h[2*e+1]=8,e++,p[8]++;for(gen_codes(h,287,p),e=0;e<c;e++)f[2*e+1]=5,f[2*e]=bi_reverse(e,5);v=new StaticTreeDesc(h,u,257,s,l),
w=new StaticTreeDesc(f,d,0,c,l),S=new StaticTreeDesc(new Array(0),m,0,19,7)}(),E=!0),e.l_desc=new TreeDesc(e.dyn_ltree,v),e.d_desc=new TreeDesc(e.dyn_dtree,w),e.bl_desc=new TreeDesc(e.bl_tree,S),e.bi_buf=0,e.bi_valid=0,init_block(e)},n._tr_stored_block=_tr_stored_block,n._tr_flush_block=function _tr_flush_block(e,t,n,i){var s,c,l=0;e.level>0?(2===e.strm.data_type&&(e.strm.data_type=function detect_data_type(e){var t,n=4093624447;for(t=0;t<=31;t++,n>>>=1)if(1&n&&0!==e.dyn_ltree[2*t])return 0;if(0!==e.dyn_ltree[18]||0!==e.dyn_ltree[20]||0!==e.dyn_ltree[26])return 1;for(t=32;t<a;t++)if(0!==e.dyn_ltree[2*t])return 1;return 0}(e)),build_tree(e,e.l_desc),build_tree(e,e.d_desc),l=function build_bl_tree(e){var t;for(scan_tree(e,e.dyn_ltree,e.l_desc.max_code),scan_tree(e,e.dyn_dtree,e.d_desc.max_code),build_tree(e,e.bl_desc),t=18;t>=3&&0===e.bl_tree[2*p[t]+1];t--);return e.opt_len+=3*(t+1)+5+5+4,t}(e),s=e.opt_len+3+7>>>3,(c=e.static_len+3+7>>>3)<=s&&(s=c)):s=c=n+5,
n+4<=s&&-1!==t?_tr_stored_block(e,t,n,i):4===e.strategy||c===s?(send_bits(e,2+(i?1:0),3),compress_block(e,h,f)):(send_bits(e,4+(i?1:0),3),function send_all_trees(e,t,n,i){var a;for(send_bits(e,t-257,5),send_bits(e,n-1,5),send_bits(e,i-4,4),a=0;a<i;a++)send_bits(e,e.bl_tree[2*p[a]+1],3);send_tree(e,e.dyn_ltree,t-1),send_tree(e,e.dyn_dtree,n-1)}(e,e.l_desc.max_code+1,e.d_desc.max_code+1,l+1),compress_block(e,e.dyn_ltree,e.dyn_dtree)),init_block(e),i&&bi_windup(e)},n._tr_tally=function _tr_tally(e,t,n){return e.pending_buf[e.d_buf+2*e.last_lit]=t>>>8&255,e.pending_buf[e.d_buf+2*e.last_lit+1]=255&t,e.pending_buf[e.l_buf+e.last_lit]=255&n,e.last_lit++,0===t?e.dyn_ltree[2*n]++:(e.matches++,t--,e.dyn_ltree[2*(y[n]+a+1)]++,e.dyn_dtree[2*d_code(t)]++),e.last_lit===e.lit_bufsize-1},n._tr_align=function _tr_align(e){send_bits(e,2,3),send_code(e,256,h),function bi_flush(e){16===e.bi_valid?(put_short(e,e.bi_buf),e.bi_buf=0,e.bi_valid=0):e.bi_valid>=8&&(e.pending_buf[e.pending++]=255&e.bi_buf,
e.bi_buf>>=8,e.bi_valid-=8)}(e)}},{"../utils/common":136}],143:[function(e,t,n){"use strict";t.exports=function ZStream(){this.input=null,this.next_in=0,this.avail_in=0,this.total_in=0,this.output=null,this.next_out=0,this.avail_out=0,this.total_out=0,this.msg="",this.state=null,this.data_type=2,this.adler=0}},{}],144:[function(e,t,n){arguments[4][133][0].apply(n,arguments)},{dup:133}],145:[function(e,t,n){(function(t){(function(){
/*!
 * The buffer module from node.js, for the browser.
 *
 * @author   Feross Aboukhadijeh <https://feross.org>
 * @license  MIT
 */
"use strict";var t=e("base64-js"),i=e("ieee754");n.Buffer=Buffer,n.SlowBuffer=function SlowBuffer(e){+e!=e&&(e=0);return Buffer.alloc(+e)},n.INSPECT_MAX_BYTES=50;var a=2147483647;function createBuffer(e){if(e>a)throw new RangeError('The value "'+e+'" is invalid for option "size"');var t=new Uint8Array(e);return t.__proto__=Buffer.prototype,t}function Buffer(e,t,n){if("number"==typeof e){if("string"==typeof t)throw new TypeError('The "string" argument must be of type string. Received type number');return allocUnsafe(e)}return from(e,t,n)}function from(e,t,n){if("string"==typeof e)return function fromString(e,t){"string"==typeof t&&""!==t||(t="utf8");if(!Buffer.isEncoding(t))throw new TypeError("Unknown encoding: "+t);var n=0|byteLength(e,t),i=createBuffer(n),a=i.write(e,t);a!==n&&(i=i.slice(0,a));return i}(e,t);if(ArrayBuffer.isView(e))return fromArrayLike(e)
;if(null==e)throw TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof e);if(isInstance(e,ArrayBuffer)||e&&isInstance(e.buffer,ArrayBuffer))return function fromArrayBuffer(e,t,n){if(t<0||e.byteLength<t)throw new RangeError('"offset" is outside of buffer bounds');if(e.byteLength<t+(n||0))throw new RangeError('"length" is outside of buffer bounds');var i;i=void 0===t&&void 0===n?new Uint8Array(e):void 0===n?new Uint8Array(e,t):new Uint8Array(e,t,n);return i.__proto__=Buffer.prototype,i}(e,t,n);if("number"==typeof e)throw new TypeError('The "value" argument must not be of type number. Received type number');var i=e.valueOf&&e.valueOf();if(null!=i&&i!==e)return Buffer.from(i,t,n);var a=function fromObject(e){if(Buffer.isBuffer(e)){var t=0|checked(e.length),n=createBuffer(t);return 0===n.length||e.copy(n,0,0,t),n}
if(void 0!==e.length)return"number"!=typeof e.length||numberIsNaN(e.length)?createBuffer(0):fromArrayLike(e);if("Buffer"===e.type&&Array.isArray(e.data))return fromArrayLike(e.data)}(e);if(a)return a;if("undefined"!=typeof Symbol&&null!=Symbol.toPrimitive&&"function"==typeof e[Symbol.toPrimitive])return Buffer.from(e[Symbol.toPrimitive]("string"),t,n);throw new TypeError("The first argument must be one of type string, Buffer, ArrayBuffer, Array, or Array-like Object. Received type "+typeof e)}function assertSize(e){if("number"!=typeof e)throw new TypeError('"size" argument must be of type number');if(e<0)throw new RangeError('The value "'+e+'" is invalid for option "size"')}function allocUnsafe(e){return assertSize(e),createBuffer(e<0?0:0|checked(e))}function fromArrayLike(e){for(var t=e.length<0?0:0|checked(e.length),n=createBuffer(t),i=0;i<t;i+=1)n[i]=255&e[i];return n}function checked(e){
if(e>=a)throw new RangeError("Attempt to allocate Buffer larger than maximum size: 0x"+a.toString(16)+" bytes");return 0|e}function byteLength(e,t){if(Buffer.isBuffer(e))return e.length;if(ArrayBuffer.isView(e)||isInstance(e,ArrayBuffer))return e.byteLength;if("string"!=typeof e)throw new TypeError('The "string" argument must be one of type string, Buffer, or ArrayBuffer. Received type '+typeof e);var n=e.length,i=arguments.length>2&&!0===arguments[2];if(!i&&0===n)return 0;for(var a=!1;;)switch(t){case"ascii":case"latin1":case"binary":return n;case"utf8":case"utf-8":return utf8ToBytes(e).length;case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return 2*n;case"hex":return n>>>1;case"base64":return base64ToBytes(e).length;default:if(a)return i?-1:utf8ToBytes(e).length;t=(""+t).toLowerCase(),a=!0}}function slowToString(e,t,n){var i=!1;if((void 0===t||t<0)&&(t=0),t>this.length)return"";if((void 0===n||n>this.length)&&(n=this.length),n<=0)return"";if((n>>>=0)<=(t>>>=0))return""
;for(e||(e="utf8");;)switch(e){case"hex":return hexSlice(this,t,n);case"utf8":case"utf-8":return utf8Slice(this,t,n);case"ascii":return asciiSlice(this,t,n);case"latin1":case"binary":return latin1Slice(this,t,n);case"base64":return base64Slice(this,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return utf16leSlice(this,t,n);default:if(i)throw new TypeError("Unknown encoding: "+e);e=(e+"").toLowerCase(),i=!0}}function swap(e,t,n){var i=e[t];e[t]=e[n],e[n]=i}function bidirectionalIndexOf(e,t,n,i,a){if(0===e.length)return-1;if("string"==typeof n?(i=n,n=0):n>2147483647?n=2147483647:n<-2147483648&&(n=-2147483648),numberIsNaN(n=+n)&&(n=a?0:e.length-1),n<0&&(n=e.length+n),n>=e.length){if(a)return-1;n=e.length-1}else if(n<0){if(!a)return-1;n=0}if("string"==typeof t&&(t=Buffer.from(t,i)),Buffer.isBuffer(t))return 0===t.length?-1:arrayIndexOf(e,t,n,i,a);if("number"==typeof t)return t&=255,
"function"==typeof Uint8Array.prototype.indexOf?a?Uint8Array.prototype.indexOf.call(e,t,n):Uint8Array.prototype.lastIndexOf.call(e,t,n):arrayIndexOf(e,[t],n,i,a);throw new TypeError("val must be string, number or Buffer")}function arrayIndexOf(e,t,n,i,a){var s,c=1,l=e.length,u=t.length;if(void 0!==i&&("ucs2"===(i=String(i).toLowerCase())||"ucs-2"===i||"utf16le"===i||"utf-16le"===i)){if(e.length<2||t.length<2)return-1;c=2,l/=2,u/=2,n/=2}function read(e,t){return 1===c?e[t]:e.readUInt16BE(t*c)}if(a){var d=-1;for(s=n;s<l;s++)if(read(e,s)===read(t,-1===d?0:s-d)){if(-1===d&&(d=s),s-d+1===u)return d*c}else-1!==d&&(s-=s-d),d=-1}else for(n+u>l&&(n=l-u),s=n;s>=0;s--){for(var m=!0,p=0;p<u;p++)if(read(e,s+p)!==read(t,p)){m=!1;break}if(m)return s}return-1}function hexWrite(e,t,n,i){n=Number(n)||0;var a=e.length-n;i?(i=Number(i))>a&&(i=a):i=a;var s=t.length;i>s/2&&(i=s/2);for(var c=0;c<i;++c){var l=parseInt(t.substr(2*c,2),16);if(numberIsNaN(l))return c;e[n+c]=l}return c}
function utf8Write(e,t,n,i){return blitBuffer(utf8ToBytes(t,e.length-n),e,n,i)}function asciiWrite(e,t,n,i){return blitBuffer(function asciiToBytes(e){for(var t=[],n=0;n<e.length;++n)t.push(255&e.charCodeAt(n));return t}(t),e,n,i)}function latin1Write(e,t,n,i){return asciiWrite(e,t,n,i)}function base64Write(e,t,n,i){return blitBuffer(base64ToBytes(t),e,n,i)}function ucs2Write(e,t,n,i){return blitBuffer(function utf16leToBytes(e,t){for(var n,i,a,s=[],c=0;c<e.length&&!((t-=2)<0);++c)i=(n=e.charCodeAt(c))>>8,a=n%256,s.push(a),s.push(i);return s}(t,e.length-n),e,n,i)}function base64Slice(e,n,i){return 0===n&&i===e.length?t.fromByteArray(e):t.fromByteArray(e.slice(n,i))}function utf8Slice(e,t,n){n=Math.min(e.length,n);for(var i=[],a=t;a<n;){var c,l,u,d,m=e[a],p=null,h=m>239?4:m>223?3:m>191?2:1;if(a+h<=n)switch(h){case 1:m<128&&(p=m);break;case 2:128==(192&(c=e[a+1]))&&(d=(31&m)<<6|63&c)>127&&(p=d);break;case 3:c=e[a+1],l=e[a+2],
128==(192&c)&&128==(192&l)&&(d=(15&m)<<12|(63&c)<<6|63&l)>2047&&(d<55296||d>57343)&&(p=d);break;case 4:c=e[a+1],l=e[a+2],u=e[a+3],128==(192&c)&&128==(192&l)&&128==(192&u)&&(d=(15&m)<<18|(63&c)<<12|(63&l)<<6|63&u)>65535&&d<1114112&&(p=d)}null===p?(p=65533,h=1):p>65535&&(p-=65536,i.push(p>>>10&1023|55296),p=56320|1023&p),i.push(p),a+=h}return function decodeCodePointsArray(e){var t=e.length;if(t<=s)return String.fromCharCode.apply(String,e);var n="",i=0;for(;i<t;)n+=String.fromCharCode.apply(String,e.slice(i,i+=s));return n}(i)}n.kMaxLength=a,Buffer.TYPED_ARRAY_SUPPORT=function typedArraySupport(){try{var e=new Uint8Array(1);return e.__proto__={__proto__:Uint8Array.prototype,foo:function(){return 42}},42===e.foo()}catch(e){return!1}}(),Buffer.TYPED_ARRAY_SUPPORT||"undefined"==typeof console||"function"!=typeof console.error||console.error("This browser lacks typed array (Uint8Array) support which is required by `buffer` v5.x. Use `buffer` v4.x if you require old browser support."),
Object.defineProperty(Buffer.prototype,"parent",{enumerable:!0,get:function(){if(Buffer.isBuffer(this))return this.buffer}}),Object.defineProperty(Buffer.prototype,"offset",{enumerable:!0,get:function(){if(Buffer.isBuffer(this))return this.byteOffset}}),"undefined"!=typeof Symbol&&null!=Symbol.species&&Buffer[Symbol.species]===Buffer&&Object.defineProperty(Buffer,Symbol.species,{value:null,configurable:!0,enumerable:!1,writable:!1}),Buffer.poolSize=8192,Buffer.from=function(e,t,n){return from(e,t,n)},Buffer.prototype.__proto__=Uint8Array.prototype,Buffer.__proto__=Uint8Array,Buffer.alloc=function(e,t,n){return function alloc(e,t,n){return assertSize(e),e<=0?createBuffer(e):void 0!==t?"string"==typeof n?createBuffer(e).fill(t,n):createBuffer(e).fill(t):createBuffer(e)}(e,t,n)},Buffer.allocUnsafe=function(e){return allocUnsafe(e)},Buffer.allocUnsafeSlow=function(e){return allocUnsafe(e)},Buffer.isBuffer=function isBuffer(e){return null!=e&&!0===e._isBuffer&&e!==Buffer.prototype},
Buffer.compare=function compare(e,t){if(isInstance(e,Uint8Array)&&(e=Buffer.from(e,e.offset,e.byteLength)),isInstance(t,Uint8Array)&&(t=Buffer.from(t,t.offset,t.byteLength)),!Buffer.isBuffer(e)||!Buffer.isBuffer(t))throw new TypeError('The "buf1", "buf2" arguments must be one of type Buffer or Uint8Array');if(e===t)return 0;for(var n=e.length,i=t.length,a=0,s=Math.min(n,i);a<s;++a)if(e[a]!==t[a]){n=e[a],i=t[a];break}return n<i?-1:i<n?1:0},Buffer.isEncoding=function isEncoding(e){switch(String(e).toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"latin1":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return!0;default:return!1}},Buffer.concat=function concat(e,t){if(!Array.isArray(e))throw new TypeError('"list" argument must be an Array of Buffers');if(0===e.length)return Buffer.alloc(0);var n;if(void 0===t)for(t=0,n=0;n<e.length;++n)t+=e[n].length;var i=Buffer.allocUnsafe(t),a=0;for(n=0;n<e.length;++n){var s=e[n]
;if(isInstance(s,Uint8Array)&&(s=Buffer.from(s)),!Buffer.isBuffer(s))throw new TypeError('"list" argument must be an Array of Buffers');s.copy(i,a),a+=s.length}return i},Buffer.byteLength=byteLength,Buffer.prototype._isBuffer=!0,Buffer.prototype.swap16=function swap16(){var e=this.length;if(e%2!=0)throw new RangeError("Buffer size must be a multiple of 16-bits");for(var t=0;t<e;t+=2)swap(this,t,t+1);return this},Buffer.prototype.swap32=function swap32(){var e=this.length;if(e%4!=0)throw new RangeError("Buffer size must be a multiple of 32-bits");for(var t=0;t<e;t+=4)swap(this,t,t+3),swap(this,t+1,t+2);return this},Buffer.prototype.swap64=function swap64(){var e=this.length;if(e%8!=0)throw new RangeError("Buffer size must be a multiple of 64-bits");for(var t=0;t<e;t+=8)swap(this,t,t+7),swap(this,t+1,t+6),swap(this,t+2,t+5),swap(this,t+3,t+4);return this},Buffer.prototype.toString=function toString(){var e=this.length
;return 0===e?"":0===arguments.length?utf8Slice(this,0,e):slowToString.apply(this,arguments)},Buffer.prototype.toLocaleString=Buffer.prototype.toString,Buffer.prototype.equals=function equals(e){if(!Buffer.isBuffer(e))throw new TypeError("Argument must be a Buffer");return this===e||0===Buffer.compare(this,e)},Buffer.prototype.inspect=function inspect(){var e="",t=n.INSPECT_MAX_BYTES;return e=this.toString("hex",0,t).replace(/(.{2})/g,"$1 ").trim(),this.length>t&&(e+=" ... "),"<Buffer "+e+">"},Buffer.prototype.compare=function compare(e,t,n,i,a){if(isInstance(e,Uint8Array)&&(e=Buffer.from(e,e.offset,e.byteLength)),!Buffer.isBuffer(e))throw new TypeError('The "target" argument must be one of type Buffer or Uint8Array. Received type '+typeof e);if(void 0===t&&(t=0),void 0===n&&(n=e?e.length:0),void 0===i&&(i=0),void 0===a&&(a=this.length),t<0||n>e.length||i<0||a>this.length)throw new RangeError("out of range index");if(i>=a&&t>=n)return 0;if(i>=a)return-1;if(t>=n)return 1
;if(this===e)return 0;for(var s=(a>>>=0)-(i>>>=0),c=(n>>>=0)-(t>>>=0),l=Math.min(s,c),u=this.slice(i,a),d=e.slice(t,n),m=0;m<l;++m)if(u[m]!==d[m]){s=u[m],c=d[m];break}return s<c?-1:c<s?1:0},Buffer.prototype.includes=function includes(e,t,n){return-1!==this.indexOf(e,t,n)},Buffer.prototype.indexOf=function indexOf(e,t,n){return bidirectionalIndexOf(this,e,t,n,!0)},Buffer.prototype.lastIndexOf=function lastIndexOf(e,t,n){return bidirectionalIndexOf(this,e,t,n,!1)},Buffer.prototype.write=function write(e,t,n,i){if(void 0===t)i="utf8",n=this.length,t=0;else if(void 0===n&&"string"==typeof t)i=t,n=this.length,t=0;else{if(!isFinite(t))throw new Error("Buffer.write(string, encoding, offset[, length]) is no longer supported");t>>>=0,isFinite(n)?(n>>>=0,void 0===i&&(i="utf8")):(i=n,n=void 0)}var a=this.length-t;if((void 0===n||n>a)&&(n=a),e.length>0&&(n<0||t<0)||t>this.length)throw new RangeError("Attempt to write outside buffer bounds");i||(i="utf8");for(var s=!1;;)switch(i){case"hex":
return hexWrite(this,e,t,n);case"utf8":case"utf-8":return utf8Write(this,e,t,n);case"ascii":return asciiWrite(this,e,t,n);case"latin1":case"binary":return latin1Write(this,e,t,n);case"base64":return base64Write(this,e,t,n);case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return ucs2Write(this,e,t,n);default:if(s)throw new TypeError("Unknown encoding: "+i);i=(""+i).toLowerCase(),s=!0}},Buffer.prototype.toJSON=function toJSON(){return{type:"Buffer",data:Array.prototype.slice.call(this._arr||this,0)}};var s=4096;function asciiSlice(e,t,n){var i="";n=Math.min(e.length,n);for(var a=t;a<n;++a)i+=String.fromCharCode(127&e[a]);return i}function latin1Slice(e,t,n){var i="";n=Math.min(e.length,n);for(var a=t;a<n;++a)i+=String.fromCharCode(e[a]);return i}function hexSlice(e,t,n){var i=e.length;(!t||t<0)&&(t=0),(!n||n<0||n>i)&&(n=i);for(var a="",s=t;s<n;++s)a+=toHex(e[s]);return a}function utf16leSlice(e,t,n){
for(var i=e.slice(t,n),a="",s=0;s<i.length;s+=2)a+=String.fromCharCode(i[s]+256*i[s+1]);return a}function checkOffset(e,t,n){if(e%1!=0||e<0)throw new RangeError("offset is not uint");if(e+t>n)throw new RangeError("Trying to access beyond buffer length")}function checkInt(e,t,n,i,a,s){if(!Buffer.isBuffer(e))throw new TypeError('"buffer" argument must be a Buffer instance');if(t>a||t<s)throw new RangeError('"value" argument is out of bounds');if(n+i>e.length)throw new RangeError("Index out of range")}function checkIEEE754(e,t,n,i,a,s){if(n+i>e.length)throw new RangeError("Index out of range");if(n<0)throw new RangeError("Index out of range")}function writeFloat(e,t,n,a,s){return t=+t,n>>>=0,s||checkIEEE754(e,0,n,4),i.write(e,t,n,a,23,4),n+4}function writeDouble(e,t,n,a,s){return t=+t,n>>>=0,s||checkIEEE754(e,0,n,8),i.write(e,t,n,a,52,8),n+8}Buffer.prototype.slice=function slice(e,t){var n=this.length;(e=~~e)<0?(e+=n)<0&&(e=0):e>n&&(e=n),(t=void 0===t?n:~~t)<0?(t+=n)<0&&(t=0):t>n&&(t=n),
t<e&&(t=e);var i=this.subarray(e,t);return i.__proto__=Buffer.prototype,i},Buffer.prototype.readUIntLE=function readUIntLE(e,t,n){e>>>=0,t>>>=0,n||checkOffset(e,t,this.length);for(var i=this[e],a=1,s=0;++s<t&&(a*=256);)i+=this[e+s]*a;return i},Buffer.prototype.readUIntBE=function readUIntBE(e,t,n){e>>>=0,t>>>=0,n||checkOffset(e,t,this.length);for(var i=this[e+--t],a=1;t>0&&(a*=256);)i+=this[e+--t]*a;return i},Buffer.prototype.readUInt8=function readUInt8(e,t){return e>>>=0,t||checkOffset(e,1,this.length),this[e]},Buffer.prototype.readUInt16LE=function readUInt16LE(e,t){return e>>>=0,t||checkOffset(e,2,this.length),this[e]|this[e+1]<<8},Buffer.prototype.readUInt16BE=function readUInt16BE(e,t){return e>>>=0,t||checkOffset(e,2,this.length),this[e]<<8|this[e+1]},Buffer.prototype.readUInt32LE=function readUInt32LE(e,t){return e>>>=0,t||checkOffset(e,4,this.length),(this[e]|this[e+1]<<8|this[e+2]<<16)+16777216*this[e+3]},Buffer.prototype.readUInt32BE=function readUInt32BE(e,t){return e>>>=0,
t||checkOffset(e,4,this.length),16777216*this[e]+(this[e+1]<<16|this[e+2]<<8|this[e+3])},Buffer.prototype.readIntLE=function readIntLE(e,t,n){e>>>=0,t>>>=0,n||checkOffset(e,t,this.length);for(var i=this[e],a=1,s=0;++s<t&&(a*=256);)i+=this[e+s]*a;return i>=(a*=128)&&(i-=Math.pow(2,8*t)),i},Buffer.prototype.readIntBE=function readIntBE(e,t,n){e>>>=0,t>>>=0,n||checkOffset(e,t,this.length);for(var i=t,a=1,s=this[e+--i];i>0&&(a*=256);)s+=this[e+--i]*a;return s>=(a*=128)&&(s-=Math.pow(2,8*t)),s},Buffer.prototype.readInt8=function readInt8(e,t){return e>>>=0,t||checkOffset(e,1,this.length),128&this[e]?-1*(255-this[e]+1):this[e]},Buffer.prototype.readInt16LE=function readInt16LE(e,t){e>>>=0,t||checkOffset(e,2,this.length);var n=this[e]|this[e+1]<<8;return 32768&n?4294901760|n:n},Buffer.prototype.readInt16BE=function readInt16BE(e,t){e>>>=0,t||checkOffset(e,2,this.length);var n=this[e+1]|this[e]<<8;return 32768&n?4294901760|n:n},Buffer.prototype.readInt32LE=function readInt32LE(e,t){
return e>>>=0,t||checkOffset(e,4,this.length),this[e]|this[e+1]<<8|this[e+2]<<16|this[e+3]<<24},Buffer.prototype.readInt32BE=function readInt32BE(e,t){return e>>>=0,t||checkOffset(e,4,this.length),this[e]<<24|this[e+1]<<16|this[e+2]<<8|this[e+3]},Buffer.prototype.readFloatLE=function readFloatLE(e,t){return e>>>=0,t||checkOffset(e,4,this.length),i.read(this,e,!0,23,4)},Buffer.prototype.readFloatBE=function readFloatBE(e,t){return e>>>=0,t||checkOffset(e,4,this.length),i.read(this,e,!1,23,4)},Buffer.prototype.readDoubleLE=function readDoubleLE(e,t){return e>>>=0,t||checkOffset(e,8,this.length),i.read(this,e,!0,52,8)},Buffer.prototype.readDoubleBE=function readDoubleBE(e,t){return e>>>=0,t||checkOffset(e,8,this.length),i.read(this,e,!1,52,8)},Buffer.prototype.writeUIntLE=function writeUIntLE(e,t,n,i){(e=+e,t>>>=0,n>>>=0,i)||checkInt(this,e,t,n,Math.pow(2,8*n)-1,0);var a=1,s=0;for(this[t]=255&e;++s<n&&(a*=256);)this[t+s]=e/a&255;return t+n},
Buffer.prototype.writeUIntBE=function writeUIntBE(e,t,n,i){(e=+e,t>>>=0,n>>>=0,i)||checkInt(this,e,t,n,Math.pow(2,8*n)-1,0);var a=n-1,s=1;for(this[t+a]=255&e;--a>=0&&(s*=256);)this[t+a]=e/s&255;return t+n},Buffer.prototype.writeUInt8=function writeUInt8(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,1,255,0),this[t]=255&e,t+1},Buffer.prototype.writeUInt16LE=function writeUInt16LE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,2,65535,0),this[t]=255&e,this[t+1]=e>>>8,t+2},Buffer.prototype.writeUInt16BE=function writeUInt16BE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,2,65535,0),this[t]=e>>>8,this[t+1]=255&e,t+2},Buffer.prototype.writeUInt32LE=function writeUInt32LE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,4,4294967295,0),this[t+3]=e>>>24,this[t+2]=e>>>16,this[t+1]=e>>>8,this[t]=255&e,t+4},Buffer.prototype.writeUInt32BE=function writeUInt32BE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,4,4294967295,0),this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e,t+4},
Buffer.prototype.writeIntLE=function writeIntLE(e,t,n,i){if(e=+e,t>>>=0,!i){var a=Math.pow(2,8*n-1);checkInt(this,e,t,n,a-1,-a)}var s=0,c=1,l=0;for(this[t]=255&e;++s<n&&(c*=256);)e<0&&0===l&&0!==this[t+s-1]&&(l=1),this[t+s]=(e/c>>0)-l&255;return t+n},Buffer.prototype.writeIntBE=function writeIntBE(e,t,n,i){if(e=+e,t>>>=0,!i){var a=Math.pow(2,8*n-1);checkInt(this,e,t,n,a-1,-a)}var s=n-1,c=1,l=0;for(this[t+s]=255&e;--s>=0&&(c*=256);)e<0&&0===l&&0!==this[t+s+1]&&(l=1),this[t+s]=(e/c>>0)-l&255;return t+n},Buffer.prototype.writeInt8=function writeInt8(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,1,127,-128),e<0&&(e=255+e+1),this[t]=255&e,t+1},Buffer.prototype.writeInt16LE=function writeInt16LE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,2,32767,-32768),this[t]=255&e,this[t+1]=e>>>8,t+2},Buffer.prototype.writeInt16BE=function writeInt16BE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,2,32767,-32768),this[t]=e>>>8,this[t+1]=255&e,t+2},
Buffer.prototype.writeInt32LE=function writeInt32LE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,4,2147483647,-2147483648),this[t]=255&e,this[t+1]=e>>>8,this[t+2]=e>>>16,this[t+3]=e>>>24,t+4},Buffer.prototype.writeInt32BE=function writeInt32BE(e,t,n){return e=+e,t>>>=0,n||checkInt(this,e,t,4,2147483647,-2147483648),e<0&&(e=4294967295+e+1),this[t]=e>>>24,this[t+1]=e>>>16,this[t+2]=e>>>8,this[t+3]=255&e,t+4},Buffer.prototype.writeFloatLE=function writeFloatLE(e,t,n){return writeFloat(this,e,t,!0,n)},Buffer.prototype.writeFloatBE=function writeFloatBE(e,t,n){return writeFloat(this,e,t,!1,n)},Buffer.prototype.writeDoubleLE=function writeDoubleLE(e,t,n){return writeDouble(this,e,t,!0,n)},Buffer.prototype.writeDoubleBE=function writeDoubleBE(e,t,n){return writeDouble(this,e,t,!1,n)},Buffer.prototype.copy=function copy(e,t,n,i){if(!Buffer.isBuffer(e))throw new TypeError("argument should be a Buffer");if(n||(n=0),i||0===i||(i=this.length),t>=e.length&&(t=e.length),t||(t=0),i>0&&i<n&&(i=n),
i===n)return 0;if(0===e.length||0===this.length)return 0;if(t<0)throw new RangeError("targetStart out of bounds");if(n<0||n>=this.length)throw new RangeError("Index out of range");if(i<0)throw new RangeError("sourceEnd out of bounds");i>this.length&&(i=this.length),e.length-t<i-n&&(i=e.length-t+n);var a=i-n;if(this===e&&"function"==typeof Uint8Array.prototype.copyWithin)this.copyWithin(t,n,i);else if(this===e&&n<t&&t<i)for(var s=a-1;s>=0;--s)e[s+t]=this[s+n];else Uint8Array.prototype.set.call(e,this.subarray(n,i),t);return a},Buffer.prototype.fill=function fill(e,t,n,i){if("string"==typeof e){if("string"==typeof t?(i=t,t=0,n=this.length):"string"==typeof n&&(i=n,n=this.length),void 0!==i&&"string"!=typeof i)throw new TypeError("encoding must be a string");if("string"==typeof i&&!Buffer.isEncoding(i))throw new TypeError("Unknown encoding: "+i);if(1===e.length){var a=e.charCodeAt(0);("utf8"===i&&a<128||"latin1"===i)&&(e=a)}}else"number"==typeof e&&(e&=255)
;if(t<0||this.length<t||this.length<n)throw new RangeError("Out of range index");if(n<=t)return this;var s;if(t>>>=0,n=void 0===n?this.length:n>>>0,e||(e=0),"number"==typeof e)for(s=t;s<n;++s)this[s]=e;else{var c=Buffer.isBuffer(e)?e:Buffer.from(e,i),l=c.length;if(0===l)throw new TypeError('The value "'+e+'" is invalid for argument "value"');for(s=0;s<n-t;++s)this[s+t]=c[s%l]}return this};var c=/[^+/0-9A-Za-z-_]/g;function toHex(e){return e<16?"0"+e.toString(16):e.toString(16)}function utf8ToBytes(e,t){var n;t=t||1/0;for(var i=e.length,a=null,s=[],c=0;c<i;++c){if((n=e.charCodeAt(c))>55295&&n<57344){if(!a){if(n>56319){(t-=3)>-1&&s.push(239,191,189);continue}if(c+1===i){(t-=3)>-1&&s.push(239,191,189);continue}a=n;continue}if(n<56320){(t-=3)>-1&&s.push(239,191,189),a=n;continue}n=65536+(a-55296<<10|n-56320)}else a&&(t-=3)>-1&&s.push(239,191,189);if(a=null,n<128){if((t-=1)<0)break;s.push(n)}else if(n<2048){if((t-=2)<0)break;s.push(n>>6|192,63&n|128)}else if(n<65536){if((t-=3)<0)break
;s.push(n>>12|224,n>>6&63|128,63&n|128)}else{if(!(n<1114112))throw new Error("Invalid code point");if((t-=4)<0)break;s.push(n>>18|240,n>>12&63|128,n>>6&63|128,63&n|128)}}return s}function base64ToBytes(e){return t.toByteArray(function base64clean(e){if((e=(e=e.split("=")[0]).trim().replace(c,"")).length<2)return"";for(;e.length%4!=0;)e+="=";return e}(e))}function blitBuffer(e,t,n,i){for(var a=0;a<i&&!(a+n>=t.length||a>=e.length);++a)t[a+n]=e[a];return a}function isInstance(e,t){return e instanceof t||null!=e&&null!=e.constructor&&null!=e.constructor.name&&e.constructor.name===t.name}function numberIsNaN(e){return e!=e}}).call(this)}).call(this,e("buffer").Buffer)},{"base64-js":132,buffer:145,ieee754:172}],146:[function(e,t,n){"use strict";var i=e("get-intrinsic"),a=e("./"),s=a(i("String.prototype.indexOf"));t.exports=function callBoundIntrinsic(e,t){var n=i(e,!!t);return"function"==typeof n&&s(e,".prototype.")>-1?a(n):n}},{"./":147,"get-intrinsic":166}],147:[function(e,t,n){
"use strict";var i=e("function-bind"),a=e("get-intrinsic"),s=a("%Function.prototype.apply%"),c=a("%Function.prototype.call%"),l=a("%Reflect.apply%",!0)||i.call(c,s),u=a("%Object.getOwnPropertyDescriptor%",!0),d=a("%Object.defineProperty%",!0),m=a("%Math.max%");if(d)try{d({},"a",{value:1})}catch(e){d=null}t.exports=function callBind(e){var t=l(i,c,arguments);if(u&&d){var n=u(t,"length");n.configurable&&d(t,"length",{value:1+m(0,e.length-(arguments.length-1))})}return t};var p=function applyBind(){return l(i,s,arguments)};d?d(t.exports,"apply",{value:p}):t.exports.apply=p},{"function-bind":165,"get-intrinsic":166}],148:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URLS=void 0,
n.URLS=["//gstatic.com/fsn/angular_js-bundle1.js","//www.gstatic.com/fsn/angular_js-bundle1.js","//www.googleadservices.com/pageadimg/imgad","//yandex.st/angularjs/1.2.16/angular-cookies.min.js","//yastatic.net/angularjs/1.2.23/angular.min.js","//yuedust.yuedu.126.net/js/components/angular/angular.js","//art.jobs.netease.com/script/angular.js","//csu-c45.kxcdn.com/angular/angular.js","//elysiumwebsite.s3.amazonaws.com/uploads/blog-media/rockstar/angular.min.js","//inno.blob.core.windows.net/new/libs/AngularJS/1.2.1/angular.min.js","//gift-talk.kakao.com/public/javascripts/angular.min.js","//ajax.googleapis.com/ajax/libs/angularjs/1.2.0rc1/angular-route.min.js","//master-sumok.ru/vendors/angular/angular-cookies.js","//ayicommon-a.akamaihd.net/static/vendor/angular-1.4.2.min.js","//pangxiehaitao.com/framework/angular-1.3.9/angular-animate.min.js","//cdnjs.cloudflare.com/ajax/libs/angular.js/1.2.16/angular.min.js","//96fe3ee995e96e922b6b-d10c35bd0a0de2c718b252bc575fdb73.ssl.cf1.rackcdn.com/angular.js","//oss.maxcdn.com/angularjs/1.2.20/angular.min.js","//reports.zemanta.com/smedia/common/angularjs/1.2.11/angular.js","//cdn.shopify.com/s/files/1/0225/6463/t/1/assets/angular-animate.min.js","//parademanagement.com.s3-website-ap-southeast-1.amazonaws.com/js/angular.min.js","//cdn.jsdelivr.net/angularjs/1.1.2/angular.min.js","//eb2883ede55c53e09fd5-9c145fb03d93709ea57875d307e2d82e.ssl.cf3.rackcdn.com/components/angular-resource.min.js","//andors-trail.googlecode.com/git/AndorsTrailEdit/lib/angular.min.js","//cdn.walkme.com/General/EnvironmentTests/angular/angular.min.js","//laundrymail.com/angular/angular.js","//s3-eu-west-1.amazonaws.com/staticancpa/js/angular-cookies.min.js","//collade.demo.stswp.com/js/vendor/angular.min.js","//mrfishie.github.io/sailor/bower_components/angular/angular.min.js","//askgithub.com/static/js/angular.min.js","//services.amazon.com/solution-providers/assets/vendor/angular-cookies.min.js","//raw.githubusercontent.com/angular/code.angularjs.org/master/1.0.7/angular-resource.js","//prb-resume.appspot.com/bower_components/angular-animate/angular-animate.js","//dl.dropboxusercontent.com/u/30877786/angular.min.js","//static.tumblr.com/x5qdx0r/nPOnngtff/angular-resource.min_1_.js","//storage.googleapis.com/assets-prod.urbansitter.net/us-sym/assets/vendor/angular-sanitize/angular-sanitize.min.js","//twitter.github.io/labella.js/bower_components/angular/angular.min.js","//cdn2-casinoroom.global.ssl.fastly.net/js/lib/angular-animate.min.js","//www.adobe.com/devnet-apps/flashshowcase/lib/angular/angular.1.1.5.min.js","//eternal-sunset.herokuapp.com/bower_components/angular/angular.js","//cdn.bootcss.com/angular.js/1.2.0/angular.min.js"]
},{}],149:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URLS=void 0,n.URLS=["//vk.com/swf/video.swf","//ajax.googleapis.com/ajax/libs/yui/2.8.0r4/build/charts/assets/charts.swf"]},{}],150:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.URLS=n.NEEDS_EVAL=void 0,n.NEEDS_EVAL=["googletagmanager.com","www.googletagmanager.com","www.googleadservices.com","google-analytics.com","ssl.google-analytics.com","www.google-analytics.com"],
n.URLS=["//bebezoo.1688.com/fragment/index.htm","//www.google-analytics.com/gtm/js","//googleads.g.doubleclick.net/pagead/conversion/1036918760/wcm","//www.googleadservices.com/pagead/conversion/1070110417/wcm","//www.google.com/tools/feedback/escalation-options","//pin.aliyun.com/check_audio","//offer.alibaba.com/market/CID100002954/5/fetchKeyword.do","//ccrprod.alipay.com/ccr/arriveTime.json","//group.aliexpress.com/ajaxAcquireGroupbuyProduct.do","//detector.alicdn.com/2.7.3/index.php","//suggest.taobao.com/sug","//translate.google.com/translate_a/l","//count.tbcdn.cn//counter3","//wb.amap.com/channel.php","//translate.googleapis.com/translate_a/l","//afpeng.alimama.com/ex","//accounts.google.com/o/oauth2/revoke","//pagead2.googlesyndication.com/relatedsearch","//yandex.ru/soft/browsers/check","//api.facebook.com/restserver.php","//mts0.googleapis.com/maps/vt","//syndication.twitter.com/widgets/timelines/765840589183213568","//www.youtube.com/profile_style","//googletagmanager.com/gtm/js","//mc.yandex.ru/watch/24306916/1","//share.yandex.net/counter/gpp/","//ok.go.mail.ru/lady_on_lady_recipes_r.json","//d1f69o4buvlrj5.cloudfront.net/__efa_15_1_ornpba.xekq.arg/optout_check","//www.googletagmanager.com/gtm/js","//api.vk.com/method/wall.get","//www.sharethis.com/get-publisher-info.php","//google.ru/maps/vt","//pro.netrox.sc/oapi/h_checksite.ashx","//vimeo.com/api/oembed.json/","//de.blog.newrelic.com/wp-admin/admin-ajax.php","//ajax.googleapis.com/ajax/services/search/news","//ssl.google-analytics.com/gtm/js","//pubsub.pubnub.com/subscribe/demo/hello_world/","//pass.yandex.ua/services","//id.rambler.ru/script/topline_info.js","//m.addthis.com/live/red_lojson/100eng.json","//passport.ngs.ru/ajax/check","//catalog.api.2gis.ru/ads/search","//gum.criteo.com/sync","//maps.google.com/maps/vt","//ynuf.alipay.com/service/um.json","//securepubads.g.doubleclick.net/gampad/ads","//c.tiles.mapbox.com/v3/texastribune.tx-congress-cvap/6/15/26.grid.json","//rexchange.begun.ru/banners","//an.yandex.ru/page/147484","//links.services.disqus.com/api/ping","//api.map.baidu.com/","//tj.gongchang.com/api/keywordrecomm/","//data.gongchang.com/livegrail/","//ulogin.ru/token.php","//beta.gismeteo.ru/api/informer/layout.js/120x240-3/ru/","//maps.googleapis.com/maps/api/js/GeoPhotoService.GetMetadata","//a.config.skype.com/config/v1/Skype/908_1.33.0.111/SkypePersonalization","//maps.beeline.ru/w","//target.ukr.net/","//www.meteoprog.ua/data/weather/informer/Poltava.js","//cdn.syndication.twimg.com/widgets/timelines/599200054310604802","//wslocker.ru/client/user.chk.php","//community.adobe.com/CommunityPod/getJSON","//maps.google.lv/maps/vt","//dev.virtualearth.net/REST/V1/Imagery/Metadata/AerialWithLabels/26.318581","//awaps.yandex.ru/10/8938/02400400.","//a248.e.akamai.net/h5.hulu.com/h5.mp4","//nominatim.openstreetmap.org/","//plugins.mozilla.org/en-us/plugins_list.json","//h.cackle.me/widget/32153/bootstrap","//graph.facebook.com/1/","//fellowes.ugc.bazaarvoice.com/data/reviews.json","//widgets.pinterest.com/v3/pidgets/boards/ciciwin/hedgehog-squirrel-crafts/pins/","//appcenter.intuit.com/Account/LogoutJSONP","//www.linkedin.com/countserv/count/share","//se.wikipedia.org/w/api.php","//cse.google.com/api/007627024705277327428/cse/r3vs7b0fcli/queries/js","//relap.io/api/v2/similar_pages_jsonp.js","//c1n3.hypercomments.com/stream/subscribe","//maps.google.de/maps/vt","//books.google.com/books","//connect.mail.ru/share_count","//tr.indeed.com/m/newjobs","//www-onepick-opensocial.googleusercontent.com/gadgets/proxy","//www.panoramio.com/map/get_panoramas.php","//client.siteheart.com/streamcli/client","//www.facebook.com/restserver.php","//autocomplete.travelpayouts.com/avia","//www.googleapis.com/freebase/v1/topic/m/0344_","//mts1.googleapis.com/mapslt/ft","//api.twitter.com/1/statuses/oembed.json","//fast.wistia.com/embed/medias/o75jtw7654.json","//partner.googleadservices.com/gampad/ads","//pass.yandex.ru/services","//gupiao.baidu.com/stocks/stockbets","//widget.admitad.com/widget/init","//api.instagram.com/v1/tags/partykungen23328/media/recent","//video.media.yql.yahoo.com/v1/video/sapi/streams/063fb76c-6c70-38c5-9bbc-04b7c384de2b","//ib.adnxs.com/jpt","//pass.yandex.com/services","//www.google.de/maps/vt","//clients1.google.com/complete/search","//api.userlike.com/api/chat/slot/proactive/","//www.youku.com/index_cookielist/s/jsonp","//mt1.googleapis.com/mapslt/ft","//api.mixpanel.com/track/","//wpd.b.qq.com/cgi/get_sign.php","//pipes.yahooapis.com/pipes/pipe.run","//gdata.youtube.com/feeds/api/videos/WsJIHN1kNWc","//9.chart.apis.google.com/chart","//cdn.syndication.twitter.com/moments/709229296800440320","//api.flickr.com/services/feeds/photos_friends.gne","//cbks0.googleapis.com/cbk","//www.blogger.com/feeds/5578653387562324002/posts/summary/4427562025302749269","//query.yahooapis.com/v1/public/yql","//kecngantang.blogspot.com/feeds/posts/default/-/Komik","//www.travelpayouts.com/widgets/50f53ce9ada1b54bcc000031.json","//i.cackle.me/widget/32586/bootstrap","//translate.yandex.net/api/v1.5/tr.json/detect","//a.tiles.mapbox.com/v3/zentralmedia.map-n2raeauc.jsonp","//maps.google.ru/maps/vt","//c1n2.hypercomments.com/stream/subscribe","//rec.ydf.yandex.ru/cookie","//cdn.jsdelivr.net"]
},{}],151:[function(e,t,n){"use strict";var i=this&&this.__createBinding||(Object.create?function(e,t,n,i){void 0===i&&(i=n),Object.defineProperty(e,i,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,i){void 0===i&&(i=n),e[i]=t[n]}),a=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),s=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)"default"!==n&&Object.prototype.hasOwnProperty.call(e,n)&&i(t,e,n);return a(t,e),t};Object.defineProperty(n,"__esModule",{value:!0}),n.checkInvalidKeyword=n.checkMissingSemicolon=n.checkUnknownDirective=void 0;const c=s(e("../csp")),l=e("../csp"),u=e("../finding");n.checkUnknownDirective=function checkUnknownDirective(e){const t=[]
;for(const n of Object.keys(e.directives))c.isDirective(n)||(n.endsWith(":")?t.push(new u.Finding(u.Type.UNKNOWN_DIRECTIVE,"CSP directives don't end with a colon.",u.Severity.SYNTAX,n)):t.push(new u.Finding(u.Type.UNKNOWN_DIRECTIVE,'Directive "'+n+'" is not a known CSP directive.',u.Severity.SYNTAX,n)));return t},n.checkMissingSemicolon=function checkMissingSemicolon(e){const t=[];for(const[n,i]of Object.entries(e.directives))if(void 0!==i)for(const e of i)c.isDirective(e)&&t.push(new u.Finding(u.Type.MISSING_SEMICOLON,'Did you forget the semicolon? "'+e+'" seems to be a directive, not a value.',u.Severity.SYNTAX,n,e));return t},n.checkInvalidKeyword=function checkInvalidKeyword(e){const t=[],n=Object.values(l.Keyword).map((e=>e.replace(/'/g,"")))
;for(const[i,a]of Object.entries(e.directives))if(void 0!==a)for(const e of a)if(n.some((t=>t===e))||e.startsWith("nonce-")||e.match(/^(sha256|sha384|sha512)-/))t.push(new u.Finding(u.Type.INVALID_KEYWORD,'Did you forget to surround "'+e+'" with single-ticks?',u.Severity.SYNTAX,i,e));else if(e.startsWith("'")){if(i===c.Directive.REQUIRE_TRUSTED_TYPES_FOR){if(e===c.TrustedTypesSink.SCRIPT)continue}else if(i===c.Directive.TRUSTED_TYPES){if("'allow-duplicates'"===e||"'none'"===e)continue}else if(c.isKeyword(e)||c.isHash(e)||c.isNonce(e))continue;t.push(new u.Finding(u.Type.INVALID_KEYWORD,e+" seems to be an invalid CSP keyword.",u.Severity.SYNTAX,i,e))}return t}},{"../csp":154,"../finding":155}],152:[function(e,t,n){"use strict";var i=this&&this.__createBinding||(Object.create?function(e,t,n,i){void 0===i&&(i=n),Object.defineProperty(e,i,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,i){void 0===i&&(i=n),e[i]=t[n]
}),a=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),s=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)"default"!==n&&Object.prototype.hasOwnProperty.call(e,n)&&i(t,e,n);return a(t,e),t};Object.defineProperty(n,"__esModule",{value:!0}),n.checkHasConfiguredReporting=n.checkSrcHttp=n.checkNonceLength=n.checkDeprecatedDirective=n.checkIpSource=n.looksLikeIpAddress=n.checkFlashObjectAllowlistBypass=n.checkScriptAllowlistBypass=n.checkMissingDirectives=n.checkMultipleMissingBaseUriDirective=n.checkMissingBaseUriDirective=n.checkMissingScriptSrcDirective=n.checkMissingObjectSrcDirective=n.checkWildcards=n.checkPlainUrlSchemes=n.checkScriptUnsafeEval=n.checkScriptUnsafeInline=n.URL_SCHEMES_CAUSING_XSS=n.DIRECTIVES_CAUSING_XSS=void 0
;const c=s(e("../allowlist_bypasses/angular")),l=s(e("../allowlist_bypasses/flash")),u=s(e("../allowlist_bypasses/jsonp")),d=s(e("../csp")),m=e("../csp"),p=e("../finding"),h=s(e("../utils"));function checkMissingObjectSrcDirective(e){let t=[];return m.Directive.OBJECT_SRC in e.directives?t=e.directives[m.Directive.OBJECT_SRC]:m.Directive.DEFAULT_SRC in e.directives&&(t=e.directives[m.Directive.DEFAULT_SRC]),void 0!==t&&t.length>=1?[]:[new p.Finding(p.Type.MISSING_DIRECTIVES,"Missing object-src allows the injection of plugins which can execute JavaScript. Can you set it to 'none'?",p.Severity.HIGH,m.Directive.OBJECT_SRC)]}function checkMissingScriptSrcDirective(e){return m.Directive.SCRIPT_SRC in e.directives||m.Directive.DEFAULT_SRC in e.directives?[]:[new p.Finding(p.Type.MISSING_DIRECTIVES,"script-src directive is missing.",p.Severity.HIGH,m.Directive.SCRIPT_SRC)]}function checkMissingBaseUriDirective(e){return checkMultipleMissingBaseUriDirective([e])}
function checkMultipleMissingBaseUriDirective(e){if(e.some((e=>e.policyHasScriptNonces()||e.policyHasScriptHashes()&&e.policyHasStrictDynamic()))&&!e.some((e=>m.Directive.BASE_URI in e.directives))){const e="Missing base-uri allows the injection of base tags. They can be used to set the base URL for all relative (script) URLs to an attacker controlled domain. Can you set it to 'none' or 'self'?";return[new p.Finding(p.Type.MISSING_DIRECTIVES,e,p.Severity.HIGH,m.Directive.BASE_URI)]}return[]}function looksLikeIpAddress(e){return!(!e.startsWith("[")||!e.endsWith("]"))||!!/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/.test(e)}n.DIRECTIVES_CAUSING_XSS=[m.Directive.SCRIPT_SRC,m.Directive.OBJECT_SRC,m.Directive.BASE_URI],n.URL_SCHEMES_CAUSING_XSS=["data:","http:","https:"],n.checkScriptUnsafeInline=function checkScriptUnsafeInline(e){const t=e.getEffectiveDirective(m.Directive.SCRIPT_SRC)
;return(e.directives[t]||[]).includes(m.Keyword.UNSAFE_INLINE)?[new p.Finding(p.Type.SCRIPT_UNSAFE_INLINE,"'unsafe-inline' allows the execution of unsafe in-page scripts and event handlers.",p.Severity.HIGH,t,m.Keyword.UNSAFE_INLINE)]:[]},n.checkScriptUnsafeEval=function checkScriptUnsafeEval(e){const t=e.getEffectiveDirective(m.Directive.SCRIPT_SRC);return(e.directives[t]||[]).includes(m.Keyword.UNSAFE_EVAL)?[new p.Finding(p.Type.SCRIPT_UNSAFE_EVAL,"'unsafe-eval' allows the execution of code injected into DOM APIs such as eval().",p.Severity.MEDIUM_MAYBE,t,m.Keyword.UNSAFE_EVAL)]:[]},n.checkPlainUrlSchemes=function checkPlainUrlSchemes(e){const t=[],i=e.getEffectiveDirectives(n.DIRECTIVES_CAUSING_XSS);for(const a of i){const i=e.directives[a]||[];for(const e of i)n.URL_SCHEMES_CAUSING_XSS.includes(e)&&t.push(new p.Finding(p.Type.PLAIN_URL_SCHEMES,e+" URI in "+a+" allows the execution of unsafe scripts.",p.Severity.HIGH,a,e))}return t},n.checkWildcards=function checkWildcards(e){
const t=[],i=e.getEffectiveDirectives(n.DIRECTIVES_CAUSING_XSS);for(const n of i){const i=e.directives[n]||[];for(const e of i){"*"!==h.getSchemeFreeUrl(e)||t.push(new p.Finding(p.Type.PLAIN_WILDCARD,n+" should not allow '*' as source",p.Severity.HIGH,n,e))}}return t},n.checkMissingObjectSrcDirective=checkMissingObjectSrcDirective,n.checkMissingScriptSrcDirective=checkMissingScriptSrcDirective,n.checkMissingBaseUriDirective=checkMissingBaseUriDirective,n.checkMultipleMissingBaseUriDirective=checkMultipleMissingBaseUriDirective,n.checkMissingDirectives=function checkMissingDirectives(e){return[...checkMissingObjectSrcDirective(e),...checkMissingScriptSrcDirective(e),...checkMissingBaseUriDirective(e)]},n.checkScriptAllowlistBypass=function checkScriptAllowlistBypass(e){const t=[],n=e.getEffectiveDirective(m.Directive.SCRIPT_SRC),i=e.directives[n]||[];if(i.includes(m.Keyword.NONE))return t;for(const e of i){if(e===m.Keyword.SELF){
t.push(new p.Finding(p.Type.SCRIPT_ALLOWLIST_BYPASS,"'self' can be problematic if you host JSONP, Angular or user uploaded files.",p.Severity.MEDIUM_MAYBE,n,e));continue}if(e.startsWith("'"))continue;if(d.isUrlScheme(e)||-1===e.indexOf("."))continue;const a="//"+h.getSchemeFreeUrl(e),s=h.matchWildcardUrls(a,c.URLS);let l=h.matchWildcardUrls(a,u.URLS);if(l){const e=u.NEEDS_EVAL.includes(l.hostname),t=i.includes(m.Keyword.UNSAFE_EVAL);e&&!t&&(l=null)}if(l||s){let i="",a="";l&&(i=l.hostname,a=" JSONP endpoints"),s&&(i=s.hostname,a+=""===a.trim()?"":" and",a+=" Angular libraries"),t.push(new p.Finding(p.Type.SCRIPT_ALLOWLIST_BYPASS,i+" is known to host"+a+" which allow to bypass this CSP.",p.Severity.HIGH,n,e))}else t.push(new p.Finding(p.Type.SCRIPT_ALLOWLIST_BYPASS,"No bypass found; make sure that this URL doesn't serve JSONP replies or Angular libraries.",p.Severity.MEDIUM_MAYBE,n,e))}return t},n.checkFlashObjectAllowlistBypass=function checkFlashObjectAllowlistBypass(e){
const t=[],n=e.getEffectiveDirective(m.Directive.OBJECT_SRC),i=e.directives[n]||[],a=e.directives[m.Directive.PLUGIN_TYPES];if(a&&!a.includes("application/x-shockwave-flash"))return[];for(const e of i){if(e===m.Keyword.NONE)return[];const i="//"+h.getSchemeFreeUrl(e),a=h.matchWildcardUrls(i,l.URLS);a?t.push(new p.Finding(p.Type.OBJECT_ALLOWLIST_BYPASS,a.hostname+" is known to host Flash files which allow to bypass this CSP.",p.Severity.HIGH,n,e)):n===m.Directive.OBJECT_SRC&&t.push(new p.Finding(p.Type.OBJECT_ALLOWLIST_BYPASS,"Can you restrict object-src to 'none' only?",p.Severity.MEDIUM_MAYBE,n,e))}return t},n.looksLikeIpAddress=looksLikeIpAddress,n.checkIpSource=function checkIpSource(e){const t=[];return h.applyCheckFunktionToDirectives(e,((e,n)=>{for(const i of n){const n=h.getHostname(i)
;looksLikeIpAddress(n)&&("127.0.0.1"===n?t.push(new p.Finding(p.Type.IP_SOURCE,e+" directive allows localhost as source. Please make sure to remove this in production environments.",p.Severity.INFO,e,i)):t.push(new p.Finding(p.Type.IP_SOURCE,e+" directive has an IP-Address as source: "+n+" (will be ignored by browsers!). ",p.Severity.INFO,e,i)))}})),t},n.checkDeprecatedDirective=function checkDeprecatedDirective(e){const t=[];return m.Directive.REFLECTED_XSS in e.directives&&t.push(new p.Finding(p.Type.DEPRECATED_DIRECTIVE,"reflected-xss is deprecated since CSP2. Please, use the X-XSS-Protection header instead.",p.Severity.INFO,m.Directive.REFLECTED_XSS)),m.Directive.REFERRER in e.directives&&t.push(new p.Finding(p.Type.DEPRECATED_DIRECTIVE,"referrer is deprecated since CSP2. Please, use the Referrer-Policy header instead.",p.Severity.INFO,m.Directive.REFERRER)),
m.Directive.DISOWN_OPENER in e.directives&&t.push(new p.Finding(p.Type.DEPRECATED_DIRECTIVE,"disown-opener is deprecated since CSP3. Please, use the Cross Origin Opener Policy header instead.",p.Severity.INFO,m.Directive.DISOWN_OPENER)),t},n.checkNonceLength=function checkNonceLength(e){const t=new RegExp("^'nonce-(.+)'$"),n=[];return h.applyCheckFunktionToDirectives(e,((e,i)=>{for(const a of i){const i=a.match(t);if(!i)continue;i[1].length<8&&n.push(new p.Finding(p.Type.NONCE_LENGTH,"Nonces should be at least 8 characters long.",p.Severity.MEDIUM,e,a)),d.isNonce(a,!0)||n.push(new p.Finding(p.Type.NONCE_CHARSET,"Nonces should only use the base64 charset.",p.Severity.INFO,e,a))}})),n},n.checkSrcHttp=function checkSrcHttp(e){const t=[];return h.applyCheckFunktionToDirectives(e,((e,n)=>{for(const i of n){const n=e===m.Directive.REPORT_URI?"Use HTTPS to send violation reports securely.":"Allow only resources downloaded over HTTPS."
;i.startsWith("http://")&&t.push(new p.Finding(p.Type.SRC_HTTP,n,p.Severity.MEDIUM,e,i))}})),t},n.checkHasConfiguredReporting=function checkHasConfiguredReporting(e){return(e.directives[m.Directive.REPORT_URI]||[]).length>0?[]:(e.directives[m.Directive.REPORT_TO]||[]).length>0?[new p.Finding(p.Type.REPORT_TO_ONLY,"This CSP policy only provides a reporting destination via the 'report-to' directive. This directive is only supported in Chromium-based browsers so it is recommended to also use a 'report-uri' directive.",p.Severity.INFO,m.Directive.REPORT_TO)]:[new p.Finding(p.Type.REPORTING_DESTINATION_MISSING,"This CSP policy does not configure a reporting destination. This makes it difficult to maintain the CSP policy over time and monitor for any breakages.",p.Severity.INFO,m.Directive.REPORT_URI)]}},{"../allowlist_bypasses/angular":148,"../allowlist_bypasses/flash":149,"../allowlist_bypasses/jsonp":150,"../csp":154,"../finding":155,"../utils":158}],153:[function(e,t,n){"use strict"
;var i=this&&this.__createBinding||(Object.create?function(e,t,n,i){void 0===i&&(i=n),Object.defineProperty(e,i,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,i){void 0===i&&(i=n),e[i]=t[n]}),a=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),s=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)"default"!==n&&Object.prototype.hasOwnProperty.call(e,n)&&i(t,e,n);return a(t,e),t};Object.defineProperty(n,"__esModule",{value:!0}),n.checkRequiresTrustedTypesForScripts=n.checkAllowlistFallback=n.checkUnsafeInlineFallback=n.checkStrictDynamicNotStandalone=n.checkStrictDynamic=void 0;const c=s(e("../csp")),l=e("../csp"),u=e("../finding");n.checkStrictDynamic=function checkStrictDynamic(e){const t=e.getEffectiveDirective(c.Directive.SCRIPT_SRC),n=e.directives[t]||[]
;return n.some((e=>!e.startsWith("'")))&&!n.includes(l.Keyword.STRICT_DYNAMIC)?[new u.Finding(u.Type.STRICT_DYNAMIC,"Host allowlists can frequently be bypassed. Consider using 'strict-dynamic' in combination with CSP nonces or hashes.",u.Severity.STRICT_CSP,t)]:[]},n.checkStrictDynamicNotStandalone=function checkStrictDynamicNotStandalone(e){const t=e.getEffectiveDirective(c.Directive.SCRIPT_SRC);return!(e.directives[t]||[]).includes(l.Keyword.STRICT_DYNAMIC)||e.policyHasScriptNonces()||e.policyHasScriptHashes()?[]:[new u.Finding(u.Type.STRICT_DYNAMIC_NOT_STANDALONE,"'strict-dynamic' without a CSP nonce/hash will block all scripts.",u.Severity.INFO,t)]},n.checkUnsafeInlineFallback=function checkUnsafeInlineFallback(e){if(!e.policyHasScriptNonces()&&!e.policyHasScriptHashes())return[];const t=e.getEffectiveDirective(c.Directive.SCRIPT_SRC)
;return(e.directives[t]||[]).includes(l.Keyword.UNSAFE_INLINE)?[]:[new u.Finding(u.Type.UNSAFE_INLINE_FALLBACK,"Consider adding 'unsafe-inline' (ignored by browsers supporting nonces/hashes) to be backward compatible with older browsers.",u.Severity.STRICT_CSP,t)]},n.checkAllowlistFallback=function checkAllowlistFallback(e){const t=e.getEffectiveDirective(c.Directive.SCRIPT_SRC),n=e.directives[t]||[];return n.includes(l.Keyword.STRICT_DYNAMIC)?n.some((e=>["http:","https:","*"].includes(e)||e.includes(".")))?[]:[new u.Finding(u.Type.ALLOWLIST_FALLBACK,"Consider adding https: and http: url schemes (ignored by browsers supporting 'strict-dynamic') to be backward compatible with older browsers.",u.Severity.STRICT_CSP,t)]:[]},n.checkRequiresTrustedTypesForScripts=function checkRequiresTrustedTypesForScripts(e){const t=e.getEffectiveDirective(c.Directive.REQUIRE_TRUSTED_TYPES_FOR)
;return(e.directives[t]||[]).includes(c.TrustedTypesSink.SCRIPT)?[]:[new u.Finding(u.Type.REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS,"Consider requiring Trusted Types for scripts to lock down DOM XSS injection sinks. You can do this by adding \"require-trusted-types-for 'script'\" to your policy.",u.Severity.INFO,c.Directive.REQUIRE_TRUSTED_TYPES_FOR)]}},{"../csp":154,"../finding":155}],154:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CspError=n.isHash=n.HASH_PATTERN=n.STRICT_HASH_PATTERN=n.isNonce=n.NONCE_PATTERN=n.STRICT_NONCE_PATTERN=n.isUrlScheme=n.isKeyword=n.isDirective=n.Version=n.FETCH_DIRECTIVES=n.Directive=n.TrustedTypesSink=n.Keyword=n.Csp=void 0;const i=e("./finding");class Csp{constructor(){this.directives={}}clone(){const e=new Csp;for(const[t,n]of Object.entries(this.directives))n&&(e.directives[t]=[...n]);return e}convertToString(){let e="";for(const[t,n]of Object.entries(this.directives)){if(e+=t,void 0!==n)for(let t,i=0;t=n[i];i++)e+=" ",
e+=t;e+="; "}return e}getEffectiveCsp(e,t){const n=t||[],l=this.clone(),u=l.getEffectiveDirective(s.SCRIPT_SRC),d=this.directives[u]||[],m=l.directives[u];if(m&&(l.policyHasScriptNonces()||l.policyHasScriptHashes()))if(e>=c.CSP2)d.includes(a.UNSAFE_INLINE)&&(arrayRemove(m,a.UNSAFE_INLINE),n.push(new i.Finding(i.Type.IGNORED,"unsafe-inline is ignored if a nonce or a hash is present. (CSP2 and above)",i.Severity.NONE,u,a.UNSAFE_INLINE)));else for(const e of d)(e.startsWith("'nonce-")||e.startsWith("'sha"))&&arrayRemove(m,e);if(m&&this.policyHasStrictDynamic())if(e>=c.CSP3)for(const e of d)e.startsWith("'")&&e!==a.SELF&&e!==a.UNSAFE_INLINE||(arrayRemove(m,e),n.push(new i.Finding(i.Type.IGNORED,"Because of strict-dynamic this entry is ignored in CSP3 and above",i.Severity.NONE,u,e)));else arrayRemove(m,a.STRICT_DYNAMIC);return e<c.CSP3&&(delete l.directives[s.REPORT_TO],delete l.directives[s.WORKER_SRC],delete l.directives[s.MANIFEST_SRC],delete l.directives[s.TRUSTED_TYPES],
delete l.directives[s.REQUIRE_TRUSTED_TYPES_FOR]),l}getEffectiveDirective(e){return!(e in this.directives)&&n.FETCH_DIRECTIVES.includes(e)?s.DEFAULT_SRC:e}getEffectiveDirectives(e){return[...new Set(e.map((e=>this.getEffectiveDirective(e))))]}policyHasScriptNonces(){const e=this.getEffectiveDirective(s.SCRIPT_SRC);return(this.directives[e]||[]).some((e=>isNonce(e)))}policyHasScriptHashes(){const e=this.getEffectiveDirective(s.SCRIPT_SRC);return(this.directives[e]||[]).some((e=>isHash(e)))}policyHasStrictDynamic(){const e=this.getEffectiveDirective(s.SCRIPT_SRC);return(this.directives[e]||[]).includes(a.STRICT_DYNAMIC)}}var a,s,c;function isNonce(e,t){return(t?n.STRICT_NONCE_PATTERN:n.NONCE_PATTERN).test(e)}function isHash(e,t){return(t?n.STRICT_HASH_PATTERN:n.HASH_PATTERN).test(e)}n.Csp=Csp,function(e){e.SELF="'self'",e.NONE="'none'",e.UNSAFE_INLINE="'unsafe-inline'",e.UNSAFE_EVAL="'unsafe-eval'",e.WASM_EVAL="'wasm-eval'",e.WASM_UNSAFE_EVAL="'wasm-unsafe-eval'",
e.STRICT_DYNAMIC="'strict-dynamic'",e.UNSAFE_HASHED_ATTRIBUTES="'unsafe-hashed-attributes'",e.UNSAFE_HASHES="'unsafe-hashes'",e.REPORT_SAMPLE="'report-sample'"}(a=n.Keyword||(n.Keyword={})),function(e){e.SCRIPT="'script'"}(n.TrustedTypesSink||(n.TrustedTypesSink={})),function(e){e.CHILD_SRC="child-src",e.CONNECT_SRC="connect-src",e.DEFAULT_SRC="default-src",e.FONT_SRC="font-src",e.FRAME_SRC="frame-src",e.IMG_SRC="img-src",e.MEDIA_SRC="media-src",e.OBJECT_SRC="object-src",e.SCRIPT_SRC="script-src",e.SCRIPT_SRC_ATTR="script-src-attr",e.SCRIPT_SRC_ELEM="script-src-elem",e.STYLE_SRC="style-src",e.STYLE_SRC_ATTR="style-src-attr",e.STYLE_SRC_ELEM="style-src-elem",e.PREFETCH_SRC="prefetch-src",e.MANIFEST_SRC="manifest-src",e.WORKER_SRC="worker-src",e.BASE_URI="base-uri",e.PLUGIN_TYPES="plugin-types",e.SANDBOX="sandbox",e.DISOWN_OPENER="disown-opener",e.FORM_ACTION="form-action",e.FRAME_ANCESTORS="frame-ancestors",e.REPORT_TO="report-to",e.REPORT_URI="report-uri",
e.BLOCK_ALL_MIXED_CONTENT="block-all-mixed-content",e.UPGRADE_INSECURE_REQUESTS="upgrade-insecure-requests",e.REFLECTED_XSS="reflected-xss",e.REFERRER="referrer",e.REQUIRE_SRI_FOR="require-sri-for",e.TRUSTED_TYPES="trusted-types",e.REQUIRE_TRUSTED_TYPES_FOR="require-trusted-types-for"}(s=n.Directive||(n.Directive={})),n.FETCH_DIRECTIVES=[s.CHILD_SRC,s.CONNECT_SRC,s.DEFAULT_SRC,s.FONT_SRC,s.FRAME_SRC,s.IMG_SRC,s.MANIFEST_SRC,s.MEDIA_SRC,s.OBJECT_SRC,s.SCRIPT_SRC,s.SCRIPT_SRC_ATTR,s.SCRIPT_SRC_ELEM,s.STYLE_SRC,s.STYLE_SRC_ATTR,s.STYLE_SRC_ELEM,s.WORKER_SRC],function(e){e[e.CSP1=1]="CSP1",e[e.CSP2=2]="CSP2",e[e.CSP3=3]="CSP3"}(c=n.Version||(n.Version={})),n.isDirective=function isDirective(e){return Object.values(s).includes(e)},n.isKeyword=function isKeyword(e){return Object.values(a).includes(e)},n.isUrlScheme=function isUrlScheme(e){return new RegExp("^[a-zA-Z][+a-zA-Z0-9.-]*:$").test(e)},n.STRICT_NONCE_PATTERN=new RegExp("^'nonce-[a-zA-Z0-9+/_-]+[=]{0,2}'$"),
n.NONCE_PATTERN=new RegExp("^'nonce-(.+)'$"),n.isNonce=isNonce,n.STRICT_HASH_PATTERN=new RegExp("^'(sha256|sha384|sha512)-[a-zA-Z0-9+/]+[=]{0,2}'$"),n.HASH_PATTERN=new RegExp("^'(sha256|sha384|sha512)-(.+)'$"),n.isHash=isHash;class CspError extends Error{constructor(e){super(e)}}function arrayRemove(e,t){if(e.includes(t)){const n=e.findIndex((e=>t===e));e.splice(n,1)}}n.CspError=CspError},{"./finding":155}],155:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Type=n.Severity=n.Finding=void 0;class Finding{constructor(e,t,n,i,a){this.type=e,this.description=t,this.severity=n,this.directive=i,this.value=a}static getHighestSeverity(e){if(0===e.length)return i.NONE;return e.map((e=>e.severity)).reduce(((e,t)=>e<t?e:t),i.NONE)}equals(e){return e instanceof Finding&&(e.type===this.type&&e.description===this.description&&e.severity===this.severity&&e.directive===this.directive&&e.value===this.value)}}var i;n.Finding=Finding,function(e){e[e.HIGH=10]="HIGH",
e[e.SYNTAX=20]="SYNTAX",e[e.MEDIUM=30]="MEDIUM",e[e.HIGH_MAYBE=40]="HIGH_MAYBE",e[e.STRICT_CSP=45]="STRICT_CSP",e[e.MEDIUM_MAYBE=50]="MEDIUM_MAYBE",e[e.INFO=60]="INFO",e[e.NONE=100]="NONE"}(i=n.Severity||(n.Severity={})),function(e){e[e.MISSING_SEMICOLON=100]="MISSING_SEMICOLON",e[e.UNKNOWN_DIRECTIVE=101]="UNKNOWN_DIRECTIVE",e[e.INVALID_KEYWORD=102]="INVALID_KEYWORD",e[e.NONCE_CHARSET=106]="NONCE_CHARSET",e[e.MISSING_DIRECTIVES=300]="MISSING_DIRECTIVES",e[e.SCRIPT_UNSAFE_INLINE=301]="SCRIPT_UNSAFE_INLINE",e[e.SCRIPT_UNSAFE_EVAL=302]="SCRIPT_UNSAFE_EVAL",e[e.PLAIN_URL_SCHEMES=303]="PLAIN_URL_SCHEMES",e[e.PLAIN_WILDCARD=304]="PLAIN_WILDCARD",e[e.SCRIPT_ALLOWLIST_BYPASS=305]="SCRIPT_ALLOWLIST_BYPASS",e[e.OBJECT_ALLOWLIST_BYPASS=306]="OBJECT_ALLOWLIST_BYPASS",e[e.NONCE_LENGTH=307]="NONCE_LENGTH",e[e.IP_SOURCE=308]="IP_SOURCE",e[e.DEPRECATED_DIRECTIVE=309]="DEPRECATED_DIRECTIVE",e[e.SRC_HTTP=310]="SRC_HTTP",e[e.STRICT_DYNAMIC=400]="STRICT_DYNAMIC",
e[e.STRICT_DYNAMIC_NOT_STANDALONE=401]="STRICT_DYNAMIC_NOT_STANDALONE",e[e.NONCE_HASH=402]="NONCE_HASH",e[e.UNSAFE_INLINE_FALLBACK=403]="UNSAFE_INLINE_FALLBACK",e[e.ALLOWLIST_FALLBACK=404]="ALLOWLIST_FALLBACK",e[e.IGNORED=405]="IGNORED",e[e.REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS=500]="REQUIRE_TRUSTED_TYPES_FOR_SCRIPTS",e[e.REPORTING_DESTINATION_MISSING=600]="REPORTING_DESTINATION_MISSING",e[e.REPORT_TO_ONLY=601]="REPORT_TO_ONLY"}(n.Type||(n.Type={}))},{}],156:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.evaluateForSyntaxErrors=n.evaluateForWarnings=n.evaluateForFailure=void 0;const i=e("../checks/parser_checks"),a=e("../checks/security_checks"),s=e("../checks/strictcsp_checks"),c=e("../csp");function arrayContains(e,t){return e.some((e=>e.equals(t)))}function atLeastOnePasses(e,t){const n=[];for(const i of e)n.push(t(i));return function setIntersection(e){const t=[];if(0===e.length)return t;const n=e[0]
;for(const i of n)e.every((e=>arrayContains(e,i)))&&t.push(i);return t}(n)}function atLeastOneFails(e,t){const n=[];for(const i of e)n.push(t(i));return function setUnion(e){const t=[];for(const n of e)for(const e of n)arrayContains(t,e)||t.push(e);return t}(n)}n.evaluateForFailure=function evaluateForFailure(e){const t=[...atLeastOnePasses(e,a.checkMissingScriptSrcDirective),...atLeastOnePasses(e,a.checkMissingObjectSrcDirective),...a.checkMultipleMissingBaseUriDirective(e)],n=e.map((e=>e.getEffectiveCsp(c.Version.CSP3))),i=n.filter((e=>{const t=e.getEffectiveDirective(c.Directive.SCRIPT_SRC);return e.directives[t]}));return[...t,...[...atLeastOnePasses(i,s.checkStrictDynamic),...atLeastOnePasses(i,a.checkScriptUnsafeInline),...atLeastOnePasses(n,a.checkWildcards),...atLeastOnePasses(n,a.checkPlainUrlSchemes)]]},n.evaluateForWarnings=function evaluateForWarnings(e){return[...atLeastOneFails(e,s.checkUnsafeInlineFallback),...atLeastOneFails(e,s.checkAllowlistFallback)]},
n.evaluateForSyntaxErrors=function evaluateForSyntaxErrors(e){const t=[];for(const n of e){const e=[...a.checkNonceLength(n),...i.checkUnknownDirective(n),...a.checkDeprecatedDirective(n),...i.checkMissingSemicolon(n),...i.checkInvalidKeyword(n)];t.push(e)}return t}},{"../checks/parser_checks":151,"../checks/security_checks":152,"../checks/strictcsp_checks":153,"../csp":154}],157:[function(e,t,n){"use strict";var i=this&&this.__createBinding||(Object.create?function(e,t,n,i){void 0===i&&(i=n),Object.defineProperty(e,i,{enumerable:!0,get:function(){return t[n]}})}:function(e,t,n,i){void 0===i&&(i=n),e[i]=t[n]}),a=this&&this.__setModuleDefault||(Object.create?function(e,t){Object.defineProperty(e,"default",{enumerable:!0,value:t})}:function(e,t){e.default=t}),s=this&&this.__importStar||function(e){if(e&&e.__esModule)return e;var t={};if(null!=e)for(var n in e)"default"!==n&&Object.prototype.hasOwnProperty.call(e,n)&&i(t,e,n);return a(t,e),t};Object.defineProperty(n,"__esModule",{value:!0
}),n.TEST_ONLY=n.CspParser=void 0;const c=s(e("./csp"));function normalizeDirectiveValue(e){const t=(e=e.trim()).toLowerCase();return c.isKeyword(t)||c.isUrlScheme(e)?t:e}n.CspParser=class CspParser{constructor(e){this.csp=new c.Csp,this.parse(e)}parse(e){this.csp=new c.Csp;const t=e.split(";");for(let e=0;e<t.length;e++){const n=t[e].trim().match(/\S+/g);if(Array.isArray(n)){const e=n[0].toLowerCase();if(e in this.csp.directives)continue;c.isDirective(e);const t=[];for(let e,i=1;e=n[i];i++)e=normalizeDirectiveValue(e),t.includes(e)||t.push(e);this.csp.directives[e]=t}}return this.csp}},n.TEST_ONLY={normalizeDirectiveValue}},{"./csp":154}],158:[function(e,t,n){"use strict";function getSchemeFreeUrl(e){return e=(e=e.replace(/^\w[+\w.-]*:\/\//i,"")).replace(/^\/\//,"")}function setScheme(e){return e.startsWith("//")?e.replace("//","https://"):e}Object.defineProperty(n,"__esModule",{value:!0}),n.applyCheckFunktionToDirectives=n.matchWildcardUrls=n.getHostname=n.getSchemeFreeUrl=void 0,
n.getSchemeFreeUrl=getSchemeFreeUrl,n.getHostname=function getHostname(e){const t=new URL("https://"+getSchemeFreeUrl(e).replace("*","wildcard_placeholder")).hostname.replace("wildcard_placeholder","*"),n=/^\[[\d:]+\]/;return getSchemeFreeUrl(e).match(n)&&!t.match(n)?"["+t+"]":t},n.matchWildcardUrls=function matchWildcardUrls(e,t){const n=new URL(setScheme(e.replace("*","wildcard_placeholder"))),i=t.map((e=>new URL(setScheme(e)))),a=n.hostname.toLowerCase(),s=a.startsWith("wildcard_placeholder."),c=a.replace(/^\wildcard_placeholder/i,""),l=n.pathname,u="/"!==l;for(const e of i){const t=e.hostname;if(t.endsWith(c)&&(s||a===t)){if(u)if(l.endsWith("/")){if(!e.pathname.startsWith(l))continue}else if(e.pathname!==l)continue;return e}}return null},n.applyCheckFunktionToDirectives=function applyCheckFunktionToDirectives(e,t){const n=Object.keys(e.directives);for(const i of n){const n=e.directives[i];n&&t(i,n)}}},{}],159:[function(e,t,n){
t.exports=["aliceblue","antiquewhite","aqua","aquamarine","azure","beige","bisque","black","blanchedalmond","blue","blueviolet","brown","burlywood","cadetblue","chartreuse","chocolate","coral","cornflowerblue","cornsilk","crimson","cyan","darkblue","darkcyan","darkgoldenrod","darkgray","darkgreen","darkgrey","darkkhaki","darkmagenta","darkolivegreen","darkorange","darkorchid","darkred","darksalmon","darkseagreen","darkslateblue","darkslategray","darkslategrey","darkturquoise","darkviolet","deeppink","deepskyblue","dimgray","dimgrey","dodgerblue","firebrick","floralwhite","forestgreen","fuchsia","gainsboro","ghostwhite","gold","goldenrod","gray","green","greenyellow","grey","honeydew","hotpink","indianred","indigo","ivory","khaki","lavender","lavenderblush","lawngreen","lemonchiffon","lightblue","lightcoral","lightcyan","lightgoldenrodyellow","lightgray","lightgreen","lightgrey","lightpink","lightsalmon","lightseagreen","lightskyblue","lightslategray","lightslategrey","lightsteelblue","lightyellow","lime","limegreen","linen","magenta","maroon","mediumaquamarine","mediumblue","mediumorchid","mediumpurple","mediumseagreen","mediumslateblue","mediumspringgreen","mediumturquoise","mediumvioletred","midnightblue","mintcream","mistyrose","moccasin","navajowhite","navy","oldlace","olive","olivedrab","orange","orangered","orchid","palegoldenrod","palegreen","paleturquoise","palevioletred","papayawhip","peachpuff","peru","pink","plum","powderblue","purple","rebeccapurple","red","rosybrown","royalblue","saddlebrown","salmon","sandybrown","seagreen","seashell","sienna","silver","skyblue","slateblue","slategray","slategrey","snow","springgreen","steelblue","tan","teal","thistle","tomato","turquoise","violet","wheat","white","whitesmoke","yellow","yellowgreen"]
},{}],160:[function(e,t,n){"use strict";const i=e("./named_colors.json");n.TYPES={INTEGER:1,NUMBER:2,LENGTH:3,PERCENT:4,URL:5,COLOR:6,STRING:7,ANGLE:8,KEYWORD:9,NULL_OR_EMPTY_STR:10};var a=/^[-+]?[0-9]+$/,s=/^[-+]?[0-9]*\.[0-9]+$/,c=/^(0|[-+]?[0-9]*\.?[0-9]+(in|cm|em|mm|pt|pc|px|ex|rem|vh|vw))$/,l=/^[-+]?[0-9]*\.?[0-9]+%$/,u=/^url\(\s*([^)]*)\s*\)$/,d=/^("[^"]*"|'[^']*')$/,m=/^#[0-9a-fA-F][0-9a-fA-F][0-9a-fA-F]([0-9a-fA-F][0-9a-fA-F][0-9a-fA-F])?$/,p=/^rgb\(([^)]*)\)$/,h=/^rgba\(([^)]*)\)$/,f=/^hsla?\(\s*(-?\d+|-?\d*.\d+)\s*,\s*(-?\d+|-?\d*.\d+)%\s*,\s*(-?\d+|-?\d*.\d+)%\s*(,\s*(-?\d+|-?\d*.\d+)\s*)?\)/,g=/^([-+]?[0-9]*\.?[0-9]+)(deg|grad|rad)$/;n.valueType=function valueType(e){if(""===e||null===e)return n.TYPES.NULL_OR_EMPTY_STR;if("number"==typeof e&&(e=e.toString()),"string"==typeof e){if(a.test(e))return n.TYPES.INTEGER;if(s.test(e))return n.TYPES.NUMBER;if(c.test(e))return n.TYPES.LENGTH;if(l.test(e))return n.TYPES.PERCENT;if(u.test(e))return n.TYPES.URL
;if(d.test(e))return n.TYPES.STRING;if(g.test(e))return n.TYPES.ANGLE;if(m.test(e))return n.TYPES.COLOR;var t,y=p.exec(e);if(null!==y){if(3!==(t=y[1].split(/\s*,\s*/)).length)return;return t.every(l.test.bind(l))||t.every(a.test.bind(a))?n.TYPES.COLOR:void 0}if(null!==(y=h.exec(e))){if(4!==(t=y[1].split(/\s*,\s*/)).length)return;return(t.slice(0,3).every(l.test.bind(l))||t.every(a.test.bind(a)))&&s.test(t[3])?n.TYPES.COLOR:void 0}if(f.test(e))return n.TYPES.COLOR;if(e=e.toLowerCase(),i.includes(e))return n.TYPES.COLOR;switch(e){case"activeborder":case"activecaption":case"appworkspace":case"background":case"buttonface":case"buttonhighlight":case"buttonshadow":case"buttontext":case"captiontext":case"graytext":case"highlight":case"highlighttext":case"inactiveborder":case"inactivecaption":case"inactivecaptiontext":case"infobackground":case"infotext":case"menu":case"menutext":case"scrollbar":case"threeddarkshadow":case"threedface":case"threedhighlight":case"threedlightshadow":
case"threedshadow":case"window":case"windowframe":case"windowtext":return n.TYPES.COLOR;default:return n.TYPES.KEYWORD}}},n.parseInteger=function parseInteger(e){var t=n.valueType(e);return t===n.TYPES.NULL_OR_EMPTY_STR?e:t===n.TYPES.INTEGER?String(parseInt(e,10)):void 0},n.parseNumber=function parseNumber(e){var t=n.valueType(e);return t===n.TYPES.NULL_OR_EMPTY_STR?e:t===n.TYPES.NUMBER||t===n.TYPES.INTEGER?String(parseFloat(e)):void 0},n.parseLength=function parseLength(e){if(0===e||"0"===e)return"0px";var t=n.valueType(e);return t===n.TYPES.NULL_OR_EMPTY_STR||t===n.TYPES.LENGTH?e:void 0},n.parsePercent=function parsePercent(e){if(0===e||"0"===e)return"0%";var t=n.valueType(e);return t===n.TYPES.NULL_OR_EMPTY_STR||t===n.TYPES.PERCENT?e:void 0},n.parseMeasurement=function parseMeasurement(e){var t=n.parseLength(e);return void 0!==t?t:n.parsePercent(e)},n.parseUrl=function parseUrl(e){if(n.valueType(e)===n.TYPES.NULL_OR_EMPTY_STR)return e;var t=u.exec(e);if(t){var i=t[1]
;if('"'!==i[0]&&"'"!==i[0]||i[0]===i[i.length-1]){var a;for('"'!==i[0]&&"'"!==i[0]||(i=i.substr(1,i.length-2)),a=0;a<i.length;a++)switch(i[a]){case"(":case")":case" ":case"\t":case"\n":case"'":case'"':return;case"\\":a++}return"url("+i+")"}}},n.parseString=function parseString(e){var t=n.valueType(e);if(t===n.TYPES.NULL_OR_EMPTY_STR)return e;if(t===n.TYPES.STRING){var i;for(i=1;i<e.length-1;i++)switch(e[i]){case e[0]:return;case"\\":for(i++;i<e.length-1&&/[0-9A-Fa-f]/.test(e[i]);)i++}if(!(i>=e.length))return e}},n.parseColor=function parseColor(e){var t=n.valueType(e);if(t===n.TYPES.NULL_OR_EMPTY_STR)return e;var i,c,u,d,g,y,b,v=1,w=m.exec(e);if(w){var S=e.substr(1);return 3===S.length&&(S=S[0]+S[0]+S[1]+S[1]+S[2]+S[2]),"rgb("+(i=parseInt(S.substr(0,2),16))+", "+(c=parseInt(S.substr(2,2),16))+", "+(u=parseInt(S.substr(4,2),16))+")"}if(w=p.exec(e)){if(3!==(b=w[1].split(/\s*,\s*/)).length)return;if(b.every(l.test.bind(l)))i=Math.floor(255*parseFloat(b[0].slice(0,-1))/100),
c=Math.floor(255*parseFloat(b[1].slice(0,-1))/100),u=Math.floor(255*parseFloat(b[2].slice(0,-1))/100);else{if(!b.every(a.test.bind(a)))return;i=parseInt(b[0],10),c=parseInt(b[1],10),u=parseInt(b[2],10)}return"rgb("+(i=Math.min(255,Math.max(0,i)))+", "+(c=Math.min(255,Math.max(0,c)))+", "+(u=Math.min(255,Math.max(0,u)))+")"}if(w=h.exec(e)){if(4!==(b=w[1].split(/\s*,\s*/)).length)return;if(b.slice(0,3).every(l.test.bind(l)))i=Math.floor(255*parseFloat(b[0].slice(0,-1))/100),c=Math.floor(255*parseFloat(b[1].slice(0,-1))/100),u=Math.floor(255*parseFloat(b[2].slice(0,-1))/100),v=parseFloat(b[3]);else{if(!b.slice(0,3).every(a.test.bind(a)))return;i=parseInt(b[0],10),c=parseInt(b[1],10),u=parseInt(b[2],10),v=parseFloat(b[3])}return isNaN(v)&&(v=1),i=Math.min(255,Math.max(0,i)),c=Math.min(255,Math.max(0,c)),u=Math.min(255,Math.max(0,u)),1===(v=Math.min(1,Math.max(0,v)))?"rgb("+i+", "+c+", "+u+")":"rgba("+i+", "+c+", "+u+", "+v+")"}if(w=f.exec(e)){
const[,e,t,n,i=""]=w,a=parseFloat(i.replace(",","").trim());if(!e||!t||!n)return;return d=parseFloat(e),g=parseInt(t,10),y=parseInt(n,10),a&&s.test(a)&&(v=parseFloat(a)),i&&1!==v?"hsla("+d+", "+g+"%, "+y+"%, "+v+")":"hsl("+d+", "+g+"%, "+y+"%)"}return t===n.TYPES.COLOR?e:void 0},n.parseAngle=function parseAngle(e){var t=n.valueType(e);if(t===n.TYPES.NULL_OR_EMPTY_STR)return e;if(t===n.TYPES.ANGLE){var i=g.exec(e),a=parseFloat(i[1]);for("rad"===i[2]?a*=180/Math.PI:"grad"===i[2]&&(a*=.9);a<0;)a+=360;for(;a>360;)a-=360;return a+"deg"}},n.parseKeyword=function parseKeyword(e,t){var i,a=n.valueType(e);if(a===n.TYPES.NULL_OR_EMPTY_STR)return e;if(a===n.TYPES.KEYWORD)for(e=e.toString().toLowerCase(),i=0;i<t.length;i++)if(t[i].toLowerCase()===e)return t[i]};var dashedToCamelCase=function(e){var t,n="",i=!1;for(t=0;t<e.length;t++)"-"!==e[t]?(n+=i?e[t].toUpperCase():e[t],i=!1):i=!0;return n};n.dashedToCamelCase=dashedToCamelCase;var y=/\s/,b=['"',"'","("],v=['"',"'",")"],getParts=function(e){
var t,n,i,a=[],s=e.length,c=[],l="";for(t=0;t<s;t++)n=b.indexOf(e[t]),i=v.indexOf(e[t]),y.test(e[t])?0===a.length?(""!==l&&c.push(l),l=""):l+=e[t]:"\\"===e[t]?l+=e[++t]:(l+=e[t],-1!==i&&i===a[a.length-1]?a.pop():-1!==n&&a.push(n));return""!==l&&c.push(l),c};n.shorthandParser=function parse(e,t){var i={};if(n.valueType(e)===n.TYPES.NULL_OR_EMPTY_STR)return Object.keys(t).forEach((function(e){i[e]=""})),i;if("number"==typeof e&&(e=e.toString()),"string"==typeof e){if("inherit"===e.toLowerCase())return{};var a=getParts(e),s=!0;if(a.forEach((function(e,n){var a=!1;Object.keys(t).forEach((function(s){t[s].isValid(e,n)&&(a=!0,i[s]=e)})),s=s&&a})),s)return i}},n.shorthandSetter=function(e,t){return function(i){var a=n.shorthandParser(i,t);if(void 0!==a){Object.keys(a).forEach((function(e){var t=dashedToCamelCase(e);this[t]=a[e],a[e]=this[t],this.removeProperty(e),""!==a[e]&&(this._values[e]=a[e])}),this),Object.keys(t).forEach((function(e){a.hasOwnProperty(e)||(this.removeProperty(e),
delete this._values[e])}),this),this.removeProperty(e);var s=n.shorthandGetter(e,t).call(this);""!==s&&this._setProperty(e,s)}}},n.shorthandGetter=function(e,t){return function(){return void 0!==this._values[e]?this.getPropertyValue(e):Object.keys(t).map((function(e){return this.getPropertyValue(e)}),this).filter((function(e){return""!==e})).join(" ")}},n.implicitSetter=function(e,t,n,i){""!==(t=t||"")&&(t="-"+t);var a=["top","right","bottom","left"];return function(s){var c;if(("number"==typeof s&&(s=s.toString()),"string"==typeof s)&&(!((c="inherit"===s.toLowerCase()||""===s?[s]:getParts(s)).length<1||c.length>4)&&c.every(n))){c=c.map((function(e){return i(e)})),this._setProperty(e+t,c.join(" ")),1===c.length&&(c[1]=c[0]),2===c.length&&(c[2]=c[0]),3===c.length&&(c[3]=c[1]);for(var l=0;l<4;l++){var u=e+"-"+a[l]+t;this.removeProperty(u),""!==c[l]&&(this._values[u]=c[l])}return s}}},n.subImplicitSetter=function(e,t,n,i){var a=e+"-"+t,s=[e+"-top",e+"-right",e+"-bottom",e+"-left"]
;return function(t){if("number"==typeof t&&(t=t.toString()),"string"==typeof t&&n(t)){t=i(t),this._setProperty(a,t);for(var c=[],l=0;l<4&&(null!=this._values[s[l]]&&""!==this._values[s[l]]);l++)c.push(this._values[s[l]]);if(4===c.length){for(l=0;l<4;l++)this.removeProperty(s[l]),this._values[s[l]]=c[l];this._setProperty(e,c.join(" "))}return t}}};var w=/[A-Z]/g,S=/^\([^-]\)-/,T=["o","moz","ms","webkit"];n.camelToDashed=function(e){var t,n=e.replace(w,"-$&").toLowerCase();return(t=n.match(S))&&-1!==T.indexOf(t[1])&&(n="-"+n),n}},{"./named_colors.json":159}],161:[function(e,t,n){"use strict";var i=e("get-intrinsic")("%Object.getOwnPropertyDescriptor%");if(i)try{i([],"length")}catch(e){i=null}t.exports=i},{"get-intrinsic":166}],162:[function(e,t,n){"use strict";var i,a="object"==typeof Reflect?Reflect:null,s=a&&"function"==typeof a.apply?a.apply:function ReflectApply(e,t,n){return Function.prototype.apply.call(e,t,n)}
;i=a&&"function"==typeof a.ownKeys?a.ownKeys:Object.getOwnPropertySymbols?function ReflectOwnKeys(e){return Object.getOwnPropertyNames(e).concat(Object.getOwnPropertySymbols(e))}:function ReflectOwnKeys(e){return Object.getOwnPropertyNames(e)};var c=Number.isNaN||function NumberIsNaN(e){return e!=e};function EventEmitter(){EventEmitter.init.call(this)}t.exports=EventEmitter,t.exports.once=function once(e,t){return new Promise((function(n,i){function errorListener(n){e.removeListener(t,resolver),i(n)}function resolver(){"function"==typeof e.removeListener&&e.removeListener("error",errorListener),n([].slice.call(arguments))}eventTargetAgnosticAddListener(e,t,resolver,{once:!0}),"error"!==t&&function addErrorHandlerIfEventEmitter(e,t,n){"function"==typeof e.on&&eventTargetAgnosticAddListener(e,"error",t,n)}(e,errorListener,{once:!0})}))},EventEmitter.EventEmitter=EventEmitter,EventEmitter.prototype._events=void 0,EventEmitter.prototype._eventsCount=0,
EventEmitter.prototype._maxListeners=void 0;var l=10;function checkListener(e){if("function"!=typeof e)throw new TypeError('The "listener" argument must be of type Function. Received type '+typeof e)}function _getMaxListeners(e){return void 0===e._maxListeners?EventEmitter.defaultMaxListeners:e._maxListeners}function _addListener(e,t,n,i){var a,s,c;if(checkListener(n),void 0===(s=e._events)?(s=e._events=Object.create(null),e._eventsCount=0):(void 0!==s.newListener&&(e.emit("newListener",t,n.listener?n.listener:n),s=e._events),c=s[t]),void 0===c)c=s[t]=n,++e._eventsCount;else if("function"==typeof c?c=s[t]=i?[n,c]:[c,n]:i?c.unshift(n):c.push(n),(a=_getMaxListeners(e))>0&&c.length>a&&!c.warned){c.warned=!0;var l=new Error("Possible EventEmitter memory leak detected. "+c.length+" "+String(t)+" listeners added. Use emitter.setMaxListeners() to increase limit");l.name="MaxListenersExceededWarning",l.emitter=e,l.type=t,l.count=c.length,function ProcessEmitWarning(e){
console&&console.warn&&console.warn(e)}(l)}return e}function onceWrapper(){if(!this.fired)return this.target.removeListener(this.type,this.wrapFn),this.fired=!0,0===arguments.length?this.listener.call(this.target):this.listener.apply(this.target,arguments)}function _onceWrap(e,t,n){var i={fired:!1,wrapFn:void 0,target:e,type:t,listener:n},a=onceWrapper.bind(i);return a.listener=n,i.wrapFn=a,a}function _listeners(e,t,n){var i=e._events;if(void 0===i)return[];var a=i[t];return void 0===a?[]:"function"==typeof a?n?[a.listener||a]:[a]:n?function unwrapListeners(e){for(var t=new Array(e.length),n=0;n<t.length;++n)t[n]=e[n].listener||e[n];return t}(a):arrayClone(a,a.length)}function listenerCount(e){var t=this._events;if(void 0!==t){var n=t[e];if("function"==typeof n)return 1;if(void 0!==n)return n.length}return 0}function arrayClone(e,t){for(var n=new Array(t),i=0;i<t;++i)n[i]=e[i];return n}function eventTargetAgnosticAddListener(e,t,n,i){
if("function"==typeof e.on)i.once?e.once(t,n):e.on(t,n);else{if("function"!=typeof e.addEventListener)throw new TypeError('The "emitter" argument must be of type EventEmitter. Received type '+typeof e);e.addEventListener(t,(function wrapListener(a){i.once&&e.removeEventListener(t,wrapListener),n(a)}))}}Object.defineProperty(EventEmitter,"defaultMaxListeners",{enumerable:!0,get:function(){return l},set:function(e){if("number"!=typeof e||e<0||c(e))throw new RangeError('The value of "defaultMaxListeners" is out of range. It must be a non-negative number. Received '+e+".");l=e}}),EventEmitter.init=function(){void 0!==this._events&&this._events!==Object.getPrototypeOf(this)._events||(this._events=Object.create(null),this._eventsCount=0),this._maxListeners=this._maxListeners||void 0},EventEmitter.prototype.setMaxListeners=function setMaxListeners(e){if("number"!=typeof e||e<0||c(e))throw new RangeError('The value of "n" is out of range. It must be a non-negative number. Received '+e+".")
;return this._maxListeners=e,this},EventEmitter.prototype.getMaxListeners=function getMaxListeners(){return _getMaxListeners(this)},EventEmitter.prototype.emit=function emit(e){for(var t=[],n=1;n<arguments.length;n++)t.push(arguments[n]);var i="error"===e,a=this._events;if(void 0!==a)i=i&&void 0===a.error;else if(!i)return!1;if(i){var c;if(t.length>0&&(c=t[0]),c instanceof Error)throw c;var l=new Error("Unhandled error."+(c?" ("+c.message+")":""));throw l.context=c,l}var u=a[e];if(void 0===u)return!1;if("function"==typeof u)s(u,this,t);else{var d=u.length,m=arrayClone(u,d);for(n=0;n<d;++n)s(m[n],this,t)}return!0},EventEmitter.prototype.addListener=function addListener(e,t){return _addListener(this,e,t,!1)},EventEmitter.prototype.on=EventEmitter.prototype.addListener,EventEmitter.prototype.prependListener=function prependListener(e,t){return _addListener(this,e,t,!0)},EventEmitter.prototype.once=function once(e,t){return checkListener(t),this.on(e,_onceWrap(this,e,t)),this},
EventEmitter.prototype.prependOnceListener=function prependOnceListener(e,t){return checkListener(t),this.prependListener(e,_onceWrap(this,e,t)),this},EventEmitter.prototype.removeListener=function removeListener(e,t){var n,i,a,s,c;if(checkListener(t),void 0===(i=this._events))return this;if(void 0===(n=i[e]))return this;if(n===t||n.listener===t)0==--this._eventsCount?this._events=Object.create(null):(delete i[e],i.removeListener&&this.emit("removeListener",e,n.listener||t));else if("function"!=typeof n){for(a=-1,s=n.length-1;s>=0;s--)if(n[s]===t||n[s].listener===t){c=n[s].listener,a=s;break}if(a<0)return this;0===a?n.shift():function spliceOne(e,t){for(;t+1<e.length;t++)e[t]=e[t+1];e.pop()}(n,a),1===n.length&&(i[e]=n[0]),void 0!==i.removeListener&&this.emit("removeListener",e,c||t)}return this},EventEmitter.prototype.off=EventEmitter.prototype.removeListener,EventEmitter.prototype.removeAllListeners=function removeAllListeners(e){var t,n,i;if(void 0===(n=this._events))return this
;if(void 0===n.removeListener)return 0===arguments.length?(this._events=Object.create(null),this._eventsCount=0):void 0!==n[e]&&(0==--this._eventsCount?this._events=Object.create(null):delete n[e]),this;if(0===arguments.length){var a,s=Object.keys(n);for(i=0;i<s.length;++i)"removeListener"!==(a=s[i])&&this.removeAllListeners(a);return this.removeAllListeners("removeListener"),this._events=Object.create(null),this._eventsCount=0,this}if("function"==typeof(t=n[e]))this.removeListener(e,t);else if(void 0!==t)for(i=t.length-1;i>=0;i--)this.removeListener(e,t[i]);return this},EventEmitter.prototype.listeners=function listeners(e){return _listeners(this,e,!0)},EventEmitter.prototype.rawListeners=function rawListeners(e){return _listeners(this,e,!1)},EventEmitter.listenerCount=function(e,t){return"function"==typeof e.listenerCount?e.listenerCount(t):listenerCount.call(e,t)},EventEmitter.prototype.listenerCount=listenerCount,EventEmitter.prototype.eventNames=function eventNames(){
return this._eventsCount>0?i(this._events):[]}},{}],163:[function(e,t,n){var i=Object.prototype.hasOwnProperty,a=Object.prototype.toString;t.exports=function forEach(e,t,n){if("[object Function]"!==a.call(t))throw new TypeError("iterator must be a function");var s=e.length;if(s===+s)for(var c=0;c<s;c++)t.call(n,e[c],c,e);else for(var l in e)i.call(e,l)&&t.call(n,e[l],l,e)}},{}],164:[function(e,t,n){"use strict";var i="Function.prototype.bind called on incompatible ",a=Array.prototype.slice,s=Object.prototype.toString,c="[object Function]";t.exports=function bind(e){var t=this;if("function"!=typeof t||s.call(t)!==c)throw new TypeError(i+t);for(var n,l=a.call(arguments,1),binder=function(){if(this instanceof n){var i=t.apply(this,l.concat(a.call(arguments)));return Object(i)===i?i:this}return t.apply(e,l.concat(a.call(arguments)))},u=Math.max(0,t.length-l.length),d=[],m=0;m<u;m++)d.push("$"+m)
;if(n=Function("binder","return function ("+d.join(",")+"){ return binder.apply(this,arguments); }")(binder),t.prototype){var p=function Empty(){};p.prototype=t.prototype,n.prototype=new p,p.prototype=null}return n}},{}],165:[function(e,t,n){"use strict";var i=e("./implementation");t.exports=Function.prototype.bind||i},{"./implementation":164}],166:[function(e,t,n){"use strict";var i,a=SyntaxError,s=Function,c=TypeError,getEvalledConstructor=function(e){try{return s('"use strict"; return ('+e+").constructor;")()}catch(e){}},l=Object.getOwnPropertyDescriptor;if(l)try{l({},"")}catch(e){l=null}var throwTypeError=function(){throw new c},u=l?function(){try{return throwTypeError}catch(e){try{return l(arguments,"callee").get}catch(e){return throwTypeError}}}():throwTypeError,d=e("has-symbols")(),m=Object.getPrototypeOf||function(e){return e.__proto__},p={},h="undefined"==typeof Uint8Array?i:m(Uint8Array),f={"%AggregateError%":"undefined"==typeof AggregateError?i:AggregateError,
"%Array%":Array,"%ArrayBuffer%":"undefined"==typeof ArrayBuffer?i:ArrayBuffer,"%ArrayIteratorPrototype%":d?m([][Symbol.iterator]()):i,"%AsyncFromSyncIteratorPrototype%":i,"%AsyncFunction%":p,"%AsyncGenerator%":p,"%AsyncGeneratorFunction%":p,"%AsyncIteratorPrototype%":p,"%Atomics%":"undefined"==typeof Atomics?i:Atomics,"%BigInt%":"undefined"==typeof BigInt?i:BigInt,"%Boolean%":Boolean,"%DataView%":"undefined"==typeof DataView?i:DataView,"%Date%":Date,"%decodeURI%":decodeURI,"%decodeURIComponent%":decodeURIComponent,"%encodeURI%":encodeURI,"%encodeURIComponent%":encodeURIComponent,"%Error%":Error,"%eval%":eval,"%EvalError%":EvalError,"%Float32Array%":"undefined"==typeof Float32Array?i:Float32Array,"%Float64Array%":"undefined"==typeof Float64Array?i:Float64Array,"%FinalizationRegistry%":"undefined"==typeof FinalizationRegistry?i:FinalizationRegistry,"%Function%":s,"%GeneratorFunction%":p,"%Int8Array%":"undefined"==typeof Int8Array?i:Int8Array,
"%Int16Array%":"undefined"==typeof Int16Array?i:Int16Array,"%Int32Array%":"undefined"==typeof Int32Array?i:Int32Array,"%isFinite%":isFinite,"%isNaN%":isNaN,"%IteratorPrototype%":d?m(m([][Symbol.iterator]())):i,"%JSON%":"object"==typeof JSON?JSON:i,"%Map%":"undefined"==typeof Map?i:Map,"%MapIteratorPrototype%":"undefined"!=typeof Map&&d?m((new Map)[Symbol.iterator]()):i,"%Math%":Math,"%Number%":Number,"%Object%":Object,"%parseFloat%":parseFloat,"%parseInt%":parseInt,"%Promise%":"undefined"==typeof Promise?i:Promise,"%Proxy%":"undefined"==typeof Proxy?i:Proxy,"%RangeError%":RangeError,"%ReferenceError%":ReferenceError,"%Reflect%":"undefined"==typeof Reflect?i:Reflect,"%RegExp%":RegExp,"%Set%":"undefined"==typeof Set?i:Set,"%SetIteratorPrototype%":"undefined"!=typeof Set&&d?m((new Set)[Symbol.iterator]()):i,"%SharedArrayBuffer%":"undefined"==typeof SharedArrayBuffer?i:SharedArrayBuffer,"%String%":String,"%StringIteratorPrototype%":d?m(""[Symbol.iterator]()):i,"%Symbol%":d?Symbol:i,
"%SyntaxError%":a,"%ThrowTypeError%":u,"%TypedArray%":h,"%TypeError%":c,"%Uint8Array%":"undefined"==typeof Uint8Array?i:Uint8Array,"%Uint8ClampedArray%":"undefined"==typeof Uint8ClampedArray?i:Uint8ClampedArray,"%Uint16Array%":"undefined"==typeof Uint16Array?i:Uint16Array,"%Uint32Array%":"undefined"==typeof Uint32Array?i:Uint32Array,"%URIError%":URIError,"%WeakMap%":"undefined"==typeof WeakMap?i:WeakMap,"%WeakRef%":"undefined"==typeof WeakRef?i:WeakRef,"%WeakSet%":"undefined"==typeof WeakSet?i:WeakSet},g=function doEval(e){var t;if("%AsyncFunction%"===e)t=getEvalledConstructor("async function () {}");else if("%GeneratorFunction%"===e)t=getEvalledConstructor("function* () {}");else if("%AsyncGeneratorFunction%"===e)t=getEvalledConstructor("async function* () {}");else if("%AsyncGenerator%"===e){var n=doEval("%AsyncGeneratorFunction%");n&&(t=n.prototype)}else if("%AsyncIteratorPrototype%"===e){var i=doEval("%AsyncGenerator%");i&&(t=m(i.prototype))}return f[e]=t,t},y={
"%ArrayBufferPrototype%":["ArrayBuffer","prototype"],"%ArrayPrototype%":["Array","prototype"],"%ArrayProto_entries%":["Array","prototype","entries"],"%ArrayProto_forEach%":["Array","prototype","forEach"],"%ArrayProto_keys%":["Array","prototype","keys"],"%ArrayProto_values%":["Array","prototype","values"],"%AsyncFunctionPrototype%":["AsyncFunction","prototype"],"%AsyncGenerator%":["AsyncGeneratorFunction","prototype"],"%AsyncGeneratorPrototype%":["AsyncGeneratorFunction","prototype","prototype"],"%BooleanPrototype%":["Boolean","prototype"],"%DataViewPrototype%":["DataView","prototype"],"%DatePrototype%":["Date","prototype"],"%ErrorPrototype%":["Error","prototype"],"%EvalErrorPrototype%":["EvalError","prototype"],"%Float32ArrayPrototype%":["Float32Array","prototype"],"%Float64ArrayPrototype%":["Float64Array","prototype"],"%FunctionPrototype%":["Function","prototype"],"%Generator%":["GeneratorFunction","prototype"],"%GeneratorPrototype%":["GeneratorFunction","prototype","prototype"],
"%Int8ArrayPrototype%":["Int8Array","prototype"],"%Int16ArrayPrototype%":["Int16Array","prototype"],"%Int32ArrayPrototype%":["Int32Array","prototype"],"%JSONParse%":["JSON","parse"],"%JSONStringify%":["JSON","stringify"],"%MapPrototype%":["Map","prototype"],"%NumberPrototype%":["Number","prototype"],"%ObjectPrototype%":["Object","prototype"],"%ObjProto_toString%":["Object","prototype","toString"],"%ObjProto_valueOf%":["Object","prototype","valueOf"],"%PromisePrototype%":["Promise","prototype"],"%PromiseProto_then%":["Promise","prototype","then"],"%Promise_all%":["Promise","all"],"%Promise_reject%":["Promise","reject"],"%Promise_resolve%":["Promise","resolve"],"%RangeErrorPrototype%":["RangeError","prototype"],"%ReferenceErrorPrototype%":["ReferenceError","prototype"],"%RegExpPrototype%":["RegExp","prototype"],"%SetPrototype%":["Set","prototype"],"%SharedArrayBufferPrototype%":["SharedArrayBuffer","prototype"],"%StringPrototype%":["String","prototype"],
"%SymbolPrototype%":["Symbol","prototype"],"%SyntaxErrorPrototype%":["SyntaxError","prototype"],"%TypedArrayPrototype%":["TypedArray","prototype"],"%TypeErrorPrototype%":["TypeError","prototype"],"%Uint8ArrayPrototype%":["Uint8Array","prototype"],"%Uint8ClampedArrayPrototype%":["Uint8ClampedArray","prototype"],"%Uint16ArrayPrototype%":["Uint16Array","prototype"],"%Uint32ArrayPrototype%":["Uint32Array","prototype"],"%URIErrorPrototype%":["URIError","prototype"],"%WeakMapPrototype%":["WeakMap","prototype"],"%WeakSetPrototype%":["WeakSet","prototype"]},b=e("function-bind"),v=e("has"),w=b.call(Function.call,Array.prototype.concat),S=b.call(Function.apply,Array.prototype.splice),T=b.call(Function.call,String.prototype.replace),E=b.call(Function.call,String.prototype.slice),_=/[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g,x=/\\(\\)?/g,A=function stringToPath(e){var t=E(e,0,1),n=E(e,-1)
;if("%"===t&&"%"!==n)throw new a("invalid intrinsic syntax, expected closing `%`");if("%"===n&&"%"!==t)throw new a("invalid intrinsic syntax, expected opening `%`");var i=[];return T(e,_,(function(e,t,n,a){i[i.length]=n?T(a,x,"$1"):t||e})),i},k=function getBaseIntrinsic(e,t){var n,i=e;if(v(y,i)&&(i="%"+(n=y[i])[0]+"%"),v(f,i)){var s=f[i];if(s===p&&(s=g(i)),void 0===s&&!t)throw new c("intrinsic "+e+" exists, but is not available. Please file an issue!");return{alias:n,name:i,value:s}}throw new a("intrinsic "+e+" does not exist!")};t.exports=function GetIntrinsic(e,t){if("string"!=typeof e||0===e.length)throw new c("intrinsic name must be a non-empty string");if(arguments.length>1&&"boolean"!=typeof t)throw new c('"allowMissing" argument must be a boolean');var n=A(e),i=n.length>0?n[0]:"",s=k("%"+i+"%",t),u=s.name,d=s.value,m=!1,p=s.alias;p&&(i=p[0],S(n,w([0,1],p)));for(var h=1,g=!0;h<n.length;h+=1){var y=n[h],b=E(y,0,1),T=E(y,-1)
;if(('"'===b||"'"===b||"`"===b||'"'===T||"'"===T||"`"===T)&&b!==T)throw new a("property names with quotes must have matching quotes");if("constructor"!==y&&g||(m=!0),v(f,u="%"+(i+="."+y)+"%"))d=f[u];else if(null!=d){if(!(y in d)){if(!t)throw new c("base intrinsic for "+e+" exists, but the property is not available.");return}if(l&&h+1>=n.length){var _=l(d,y);d=(g=!!_)&&"get"in _&&!("originalValue"in _.get)?_.get:d[y]}else g=v(d,y),d=d[y];g&&!m&&(f[u]=d)}}return d}},{"function-bind":165,has:169,"has-symbols":167}],167:[function(e,t,n){"use strict";var i="undefined"!=typeof Symbol&&Symbol,a=e("./shams");t.exports=function hasNativeSymbols(){return"function"==typeof i&&("function"==typeof Symbol&&("symbol"==typeof i("foo")&&("symbol"==typeof Symbol("bar")&&a())))}},{"./shams":168}],168:[function(e,t,n){"use strict";t.exports=function hasSymbols(){if("function"!=typeof Symbol||"function"!=typeof Object.getOwnPropertySymbols)return!1;if("symbol"==typeof Symbol.iterator)return!0
;var e={},t=Symbol("test"),n=Object(t);if("string"==typeof t)return!1;if("[object Symbol]"!==Object.prototype.toString.call(t))return!1;if("[object Symbol]"!==Object.prototype.toString.call(n))return!1;for(t in e[t]=42,e)return!1;if("function"==typeof Object.keys&&0!==Object.keys(e).length)return!1;if("function"==typeof Object.getOwnPropertyNames&&0!==Object.getOwnPropertyNames(e).length)return!1;var i=Object.getOwnPropertySymbols(e);if(1!==i.length||i[0]!==t)return!1;if(!Object.prototype.propertyIsEnumerable.call(e,t))return!1;if("function"==typeof Object.getOwnPropertyDescriptor){var a=Object.getOwnPropertyDescriptor(e,t);if(42!==a.value||!0!==a.enumerable)return!1}return!0}},{}],169:[function(e,t,n){"use strict";var i=e("function-bind");t.exports=i.call(Function.call,Object.prototype.hasOwnProperty)},{"function-bind":165}],170:[function(e,t,n){(function(n){(function(){var i=e("querystring"),a=e("./trim");function Link(e){if(!(this instanceof Link))return new Link(e);this.refs=[]}
Link.pattern=/(?:\<([^\>]+)\>)((\s*;\s*([a-z\*]+)=(("[^"]+")|('[^']+')|([^\,\;]+)))*)(\s*,\s*|$)/gi,Link.attrPattern=/([a-z\*]+)=(?:(?:"([^"]+)")|(?:'([^']+)')|([^\,\;]+))/gi,Link.isCompatibleEncoding=function(e){return/^utf-?8|ascii|utf-?16-?le|ucs-?2|base-?64|latin-?1$/i.test(e)},Link.formatExtendedAttribute=function(e,t){var a=(t.encoding||"utf-8").toUpperCase();return e+"="+a+"'"+(t.language||"en")+"'"+(n.isBuffer(t.value)&&Link.isCompatibleEncoding(a)?t.value.toString(a):n.isBuffer(t.value)?t.value.toString("hex").replace(/[0-9a-f]{2}/gi,"%$1"):i.escape(t.value))},Link.formatAttribute=function(e,t){return/\*$/.test(e)||"string"!=typeof t?Link.formatExtendedAttribute(e,t):(/[^a-z]/i.test(t)&&(t='"'+(t=i.escape(t).replace(/%20/g," ").replace(/%2C/g,",").replace(/%3B/g,";"))+'"'),e+"="+t)},Link.parseExtendedValue=function(e){var t=/([^']+)?(?:'([^']+)')?(.+)/.exec(e);return{language:t[2].toLowerCase(),encoding:Link.isCompatibleEncoding(t[1])?null:t[1].toLowerCase(),
value:Link.isCompatibleEncoding(t[1])?i.unescape(t[3]):t[3]}},Link.setAttr=function(e,t,n){return"rel"===t&&null!=e[t]||(Array.isArray(e[t])?e[t].push(n):null!=e[t]?e[t]=[e[t],n]:e[t]=n),e},Link.parseParams=function(e,t){var n={},i=/(.+)\?(.+)/gi.exec(t);if(!i)return e;i=i[2].split("&");for(var a=0;a<i.length;a++){var s=i[a].split("=");n[s[0]]=s[1]}return Link.setAttr(e,"params",n),e},Link.parseAttrs=function(e,t){var n=null,a="",s="",c="",l=/<(.*)>;\s*(.*)/gi.exec(t);for(l&&(c=l[2],e=Link.parseParams(e,l[1]));n=Link.attrPattern.exec(c);)a=n[1].toLowerCase(),s=n[4]||n[3]||n[2],/\*$/.test(a)?Link.setAttr(e,a,Link.parseExtendedValue(s)):/%/.test(s)?Link.setAttr(e,a,i.unescape(s)):Link.setAttr(e,a,s);return e},Link.parse=function(e){return(new Link).parse(e)},Link.prototype={constructor:Link,rel:function(e){for(var t=[],n=0;n<this.refs.length;n++)this.refs[n].rel===e&&t.push(this.refs[n]);return t},get:function(e,t){e=e.toLowerCase()
;for(var n=[],i=0;i<this.refs.length;i++)this.refs[i][e]===t&&n.push(this.refs[i]);return n},set:function(e){return this.refs.push(e),this},has:function(e,t){return null!=this.get(e,t)},parse:function(e){e=a(e).replace(/\r?\n[\x20\x09]+/g,"");for(var t=null;t=Link.pattern.exec(e);){var n=Link.parseAttrs({uri:t[1]},t[0]);this.refs.push(n)}return this},toString:function(){for(var e=[],t="",n=null,i=0;i<this.refs.length;i++)n=this.refs[i],t=Object.keys(this.refs[i]).reduce((function(e,t){return"uri"===t?e:e+"; "+Link.formatAttribute(t,n[t])}),"<"+n.uri+">"),e.push(t);return e.join(", ")}},t.exports=Link}).call(this)}).call(this,{isBuffer:e("../../is-buffer/index.js")})},{"../../is-buffer/index.js":182,"./trim":171,querystring:226}],171:[function(e,t,n){t.exports=function trim(e){return e.replace(/^[\s\uFEFF\xA0]+|[\s\uFEFF\xA0]+$/g,"")}},{}],172:[function(e,t,n){n.read=function(e,t,n,i,a){var s,c,l=8*a-i-1,u=(1<<l)-1,d=u>>1,m=-7,p=n?a-1:0,h=n?-1:1,f=e[t+p];for(p+=h,s=f&(1<<-m)-1,f>>=-m,
m+=l;m>0;s=256*s+e[t+p],p+=h,m-=8);for(c=s&(1<<-m)-1,s>>=-m,m+=i;m>0;c=256*c+e[t+p],p+=h,m-=8);if(0===s)s=1-d;else{if(s===u)return c?NaN:1/0*(f?-1:1);c+=Math.pow(2,i),s-=d}return(f?-1:1)*c*Math.pow(2,s-i)},n.write=function(e,t,n,i,a,s){var c,l,u,d=8*s-a-1,m=(1<<d)-1,p=m>>1,h=23===a?Math.pow(2,-24)-Math.pow(2,-77):0,f=i?0:s-1,g=i?1:-1,y=t<0||0===t&&1/t<0?1:0;for(t=Math.abs(t),isNaN(t)||t===1/0?(l=isNaN(t)?1:0,c=m):(c=Math.floor(Math.log(t)/Math.LN2),t*(u=Math.pow(2,-c))<1&&(c--,u*=2),(t+=c+p>=1?h/u:h*Math.pow(2,1-p))*u>=2&&(c++,u/=2),c+p>=m?(l=0,c=m):c+p>=1?(l=(t*u-1)*Math.pow(2,a),c+=p):(l=t*Math.pow(2,p-1)*Math.pow(2,a),c=0));a>=8;e[n+f]=255&l,f+=g,l/=256,a-=8);for(c=c<<a|l,d+=a;d>0;e[n+f]=255&c,f+=g,c/=256,d-=8);e[n+f-g]|=128*y}},{}],173:[function(e,t,n){var i;!function(e){"use strict";!function(e){e[e.Grey=1]="Grey",e[e.GreyAlpha=2]="GreyAlpha",e[e.RGB=3]="RGB",e[e.RGBAlpha=4]="RGBAlpha"}(e.Channels||(e.Channels={}));var t;e.Channels;e.compare=function compare(e,n,i,a,s,c,l){
if(void 0===i&&(i=8),void 0===a&&(a=.01),void 0===s&&(s=.03),void 0===c&&(c=!0),void 0===l&&(l=8),e.width!==n.width||e.height!==n.height)throw new Error("Images have different sizes!");var u=(1<<l)-1,d=Math.pow(a*u,2),m=Math.pow(s*u,2),p=0,h=0,f=0;return t._iterate(e,n,i,c,(function iteration(e,t,n,i){var a,s,c;a=s=c=0;for(var l=0;l<e.length;l++)s+=Math.pow(e[l]-n,2),c+=Math.pow(t[l]-i,2),a+=(e[l]-n)*(t[l]-i);var u=e.length-1;s/=u,c/=u;var g=(2*n*i+d)*(2*(a/=u)+m),y=(Math.pow(n,2)+Math.pow(i,2)+d)*(s+c+m);h+=g/y,f+=(2*a+m)/(s+c+m),p++})),{ssim:h/p,mcs:f/p}},function(e){function _lumaValuesForWindow(e,t,n,i,a,s){for(var c=e.data,l=new Float32Array(new ArrayBuffer(i*a*4)),u=0,d=n+a,m=n;m<d;m++){var p=m*e.width,h=(p+t)*e.channels,f=(p+t+i)*e.channels;switch(e.channels){case 1:for(;h<f;)l[u++]=c[h++];break;case 2:for(;h<f;)l[u++]=c[h++]*(c[h++]/255);break;case 3:if(s)for(;h<f;)l[u++]=.212655*c[h++]+.715158*c[h++]+.072187*c[h++];else for(;h<f;)l[u++]=c[h++]+c[h++]+c[h++];break;case 4:
if(s)for(;h<f;)l[u++]=(.212655*c[h++]+.715158*c[h++]+.072187*c[h++])*(c[h++]/255);else for(;h<f;)l[u++]=(c[h++]+c[h++]+c[h++])*(c[h++]/255)}}return l}function _averageLuma(e){for(var t=0,n=0;n<e.length;n++)t+=e[n];return t/e.length}e._iterate=function _iterate(e,t,n,i,a){for(var s=e.width,c=e.height,l=0;l<c;l+=n)for(var u=0;u<s;u+=n){var d=Math.min(n,s-u),m=Math.min(n,c-l),p=_lumaValuesForWindow(e,u,l,d,m,i),h=_lumaValuesForWindow(t,u,l,d,m,i);a(p,h,_averageLuma(p),_averageLuma(h))}}}(t||(t={}))}(i||(i={})),t.exports=i},{}],174:[function(e,t,n){"function"==typeof Object.create?t.exports=function inherits(e,t){t&&(e.super_=t,e.prototype=Object.create(t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}))}:t.exports=function inherits(e,t){if(t){e.super_=t;var TempCtor=function(){};TempCtor.prototype=t.prototype,e.prototype=new TempCtor,e.prototype.constructor=e}}},{}],175:[function(e,t,n){"use strict";var i=e("./lib/parser");t.exports=i,t.exports.default=i},{
"./lib/parser":176}],176:[function(e,t,n){"use strict";function peg$SyntaxError(e,t,n,i){this.message=e,this.expected=t,this.found=n,this.location=i,this.name="SyntaxError","function"==typeof Error.captureStackTrace&&Error.captureStackTrace(this,peg$SyntaxError)}!function peg$subclass(e,t){function ctor(){this.constructor=e}ctor.prototype=t.prototype,e.prototype=new ctor}(peg$SyntaxError,Error),peg$SyntaxError.buildMessage=function(e,t){var n={literal:function(e){return'"'+literalEscape(e.text)+'"'},class:function(e){var t,n="";for(t=0;t<e.parts.length;t++)n+=e.parts[t]instanceof Array?classEscape(e.parts[t][0])+"-"+classEscape(e.parts[t][1]):classEscape(e.parts[t]);return"["+(e.inverted?"^":"")+n+"]"},any:function(e){return"any character"},end:function(e){return"end of input"},other:function(e){return e.description}};function hex(e){return e.charCodeAt(0).toString(16).toUpperCase()}function literalEscape(e){
return e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,(function(e){return"\\x0"+hex(e)})).replace(/[\x10-\x1F\x7F-\x9F]/g,(function(e){return"\\x"+hex(e)}))}function classEscape(e){return e.replace(/\\/g,"\\\\").replace(/\]/g,"\\]").replace(/\^/g,"\\^").replace(/-/g,"\\-").replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,(function(e){return"\\x0"+hex(e)})).replace(/[\x10-\x1F\x7F-\x9F]/g,(function(e){return"\\x"+hex(e)}))}return"Expected "+function describeExpected(e){var t,i,a,s=new Array(e.length);for(t=0;t<e.length;t++)s[t]=(a=e[t],n[a.type](a));if(s.sort(),s.length>0){for(t=1,i=1;t<s.length;t++)s[t-1]!==s[t]&&(s[i]=s[t],i++);s.length=i}switch(s.length){case 1:return s[0];case 2:return s[0]+" or "+s[1];default:return s.slice(0,-1).join(", ")+", or "+s[s.length-1]}}(e)+" but "+function describeFound(e){
return e?'"'+literalEscape(e)+'"':"end of input"}(t)+" found."},t.exports={SyntaxError:peg$SyntaxError,parse:function peg$parse(e,t){t=void 0!==t?t:{};var n,i={},a={start:peg$parsestart},s=peg$parsestart,peg$c3=function(e){return e.join("")
},c=peg$literalExpectation("{",!1),l=",",u=peg$literalExpectation(",",!1),d=peg$literalExpectation("}",!1),m="number",p=peg$literalExpectation("number",!1),h="date",f=peg$literalExpectation("date",!1),g="time",y=peg$literalExpectation("time",!1),b="plural",v=peg$literalExpectation("plural",!1),w="selectordinal",S=peg$literalExpectation("selectordinal",!1),T="select",E=peg$literalExpectation("select",!1),_=peg$literalExpectation("=",!1),x="offset:",A=peg$literalExpectation("offset:",!1),k=peg$otherExpectation("whitespace"),R=/^[ \t\n\r]/,D=peg$classExpectation([" ","\t","\n","\r"],!1,!1),I=peg$otherExpectation("optionalWhitespace"),C=/^[0-9]/,j=peg$classExpectation([["0","9"]],!1,!1),N=/^[0-9a-f]/i,L=peg$classExpectation([["0","9"],["a","f"]],!1,!0),M=peg$literalExpectation("0",!1),P=/^[1-9]/,O=peg$classExpectation([["1","9"]],!1,!1),F="'",U=peg$literalExpectation("'",!1),B=/^[ \t\n\r,.+={}#]/,q=peg$classExpectation([" ","\t","\n","\r",",",".","+","=","{","}","#"],!1,!1),z={type:"any"
},V=/^[^{}\\\0-\x1F\x7F \t\n\r]/,W=peg$classExpectation(["{","}","\\",["\0",""],""," ","\t","\n","\r"],!0,!1),H=peg$literalExpectation("\\\\",!1),G=peg$literalExpectation("\\#",!1),$=peg$literalExpectation("\\{",!1),Y=peg$literalExpectation("\\}",!1),K=peg$literalExpectation("\\u",!1),J=0,Z=0,X=[{line:1,column:1}],Q=0,ee=[],te=0;if("startRule"in t){if(!(t.startRule in a))throw new Error("Can't start parsing from rule \""+t.startRule+'".');s=a[t.startRule]}function location(){return peg$computeLocation(Z,J)}function peg$literalExpectation(e,t){return{type:"literal",text:e,ignoreCase:t}}function peg$classExpectation(e,t,n){return{type:"class",parts:e,inverted:t,ignoreCase:n}}function peg$otherExpectation(e){return{type:"other",description:e}}function peg$computePosDetails(t){var n,i=X[t];if(i)return i;for(n=t-1;!X[n];)n--;for(i={line:(i=X[n]).line,column:i.column};n<t;)10===e.charCodeAt(n)?(i.line++,i.column=1):i.column++,n++;return X[t]=i,i}function peg$computeLocation(e,t){
var n=peg$computePosDetails(e),i=peg$computePosDetails(t);return{start:{offset:e,line:n.line,column:n.column},end:{offset:t,line:i.line,column:i.column}}}function peg$fail(e){J<Q||(J>Q&&(Q=J,ee=[]),ee.push(e))}function peg$buildStructuredError(e,t,n){return new peg$SyntaxError(peg$SyntaxError.buildMessage(e,t),e,t,n)}function peg$parsestart(){return peg$parsemessageFormatPattern()}function peg$parsemessageFormatPattern(){var e,t,n;for(e=J,t=[],n=peg$parsemessageFormatElement();n!==i;)t.push(n),n=peg$parsemessageFormatElement();return t!==i&&(Z=e,t={type:"messageFormatPattern",elements:t,location:location()}),e=t}function peg$parsemessageFormatElement(){var t;return(t=function peg$parsemessageTextElement(){var t,n;t=J,(n=function peg$parsemessageText(){var t,n,a,s,c,l;t=J,n=[],a=J,(s=peg$parse_())!==i&&(c=peg$parsechars())!==i&&(l=peg$parse_())!==i?a=s=[s,c,l]:(J=a,a=i);if(a!==i)for(;a!==i;)n.push(a),a=J,
(s=peg$parse_())!==i&&(c=peg$parsechars())!==i&&(l=peg$parse_())!==i?a=s=[s,c,l]:(J=a,a=i);else n=i;n!==i&&(Z=t,n=n.reduce((function(e,t){return e.concat(t)}),[]).join(""));(t=n)===i&&(t=J,t=(n=peg$parsews())!==i?e.substring(t,J):n);return t}())!==i&&(Z=t,n={type:"messageTextElement",value:n,location:location()});return t=n}())===i&&(t=function peg$parseargumentElement(){var t,n,a,s,_,x,A;t=J,123===e.charCodeAt(J)?(n="{",J++):(n=i,0===te&&peg$fail(c));n!==i&&peg$parse_()!==i&&(a=function peg$parseargument(){var e,t,n;if((e=peg$parsenumber())===i){for(e=J,t=[],n=peg$parsequoteEscapedChar();n!==i;)t.push(n),n=peg$parsequoteEscapedChar();t!==i&&(Z=e,t=peg$c3(t)),e=t}return e}())!==i&&peg$parse_()!==i?(s=J,44===e.charCodeAt(J)?(_=l,J++):(_=i,0===te&&peg$fail(u)),_!==i&&(x=peg$parse_())!==i&&(A=function peg$parseelementFormat(){var t;(t=function peg$parsesimpleFormat(){var t,n,a,s,c,d;t=J,e.substr(J,6)===m?(n=m,J+=6):(n=i,0===te&&peg$fail(p));n===i&&(e.substr(J,4)===h?(n=h,J+=4):(n=i,
0===te&&peg$fail(f)),n===i&&(e.substr(J,4)===g?(n=g,J+=4):(n=i,0===te&&peg$fail(y))));n!==i&&peg$parse_()!==i?(a=J,44===e.charCodeAt(J)?(s=l,J++):(s=i,0===te&&peg$fail(u)),s!==i&&(c=peg$parse_())!==i&&(d=peg$parsechars())!==i?a=s=[s,c,d]:(J=a,a=i),a===i&&(a=null),a!==i?(Z=t,t=n={type:n+"Format",style:(b=a)&&b[2],location:location()}):(J=t,t=i)):(J=t,t=i);var b;return t}())===i&&(t=function peg$parsepluralFormat(){var t,n,a,s;t=J,e.substr(J,6)===b?(n=b,J+=6):(n=i,0===te&&peg$fail(v));n!==i&&peg$parse_()!==i?(44===e.charCodeAt(J)?(a=l,J++):(a=i,0===te&&peg$fail(u)),a!==i&&peg$parse_()!==i&&(s=peg$parsepluralStyle())!==i?(Z=t,t=n={type:(c=s).type,ordinal:!1,offset:c.offset||0,options:c.options,location:location()}):(J=t,t=i)):(J=t,t=i);var c;return t}())===i&&(t=function peg$parseselectOrdinalFormat(){var t,n,a,s;t=J,e.substr(J,13)===w?(n=w,J+=13):(n=i,0===te&&peg$fail(S));n!==i&&peg$parse_()!==i?(44===e.charCodeAt(J)?(a=l,J++):(a=i,0===te&&peg$fail(u)),
a!==i&&peg$parse_()!==i&&(s=peg$parsepluralStyle())!==i?(Z=t,t=n={type:(c=s).type,ordinal:!0,offset:c.offset||0,options:c.options,location:location()}):(J=t,t=i)):(J=t,t=i);var c;return t}())===i&&(t=function peg$parseselectFormat(){var t,n,a,s,c;t=J,e.substr(J,6)===T?(n=T,J+=6):(n=i,0===te&&peg$fail(E));if(n!==i)if(peg$parse_()!==i)if(44===e.charCodeAt(J)?(a=l,J++):(a=i,0===te&&peg$fail(u)),a!==i)if(peg$parse_()!==i){if(s=[],(c=peg$parseoptionalFormatPattern())!==i)for(;c!==i;)s.push(c),c=peg$parseoptionalFormatPattern();else s=i;s!==i?(Z=t,t=n=function(e){return{type:"selectFormat",options:e,location:location()}}(s)):(J=t,t=i)}else J=t,t=i;else J=t,t=i;else J=t,t=i;else J=t,t=i;return t}());return t}())!==i?s=_=[_,x,A]:(J=s,s=i),s===i&&(s=null),s!==i&&(_=peg$parse_())!==i?(125===e.charCodeAt(J)?(x="}",J++):(x=i,0===te&&peg$fail(d)),x!==i?(Z=t,t=n={type:"argumentElement",id:a,format:(k=s)&&k[2],location:location()}):(J=t,t=i)):(J=t,t=i)):(J=t,t=i);var k;return t}()),t}
function peg$parseoptionalFormatPattern(){var t,n,a,s,l;return t=J,peg$parse_()!==i&&(n=function peg$parseselector(){var t,n,a,s;return t=J,n=J,61===e.charCodeAt(J)?(a="=",J++):(a=i,0===te&&peg$fail(_)),a!==i&&(s=peg$parsenumber())!==i?n=a=[a,s]:(J=n,n=i),(t=n!==i?e.substring(t,J):n)===i&&(t=peg$parsechars()),t}())!==i&&peg$parse_()!==i?(123===e.charCodeAt(J)?(a="{",J++):(a=i,0===te&&peg$fail(c)),a!==i&&(s=peg$parsemessageFormatPattern())!==i?(125===e.charCodeAt(J)?(l="}",J++):(l=i,0===te&&peg$fail(d)),l!==i?(Z=t,t={type:"optionalFormatPattern",selector:n,value:s,location:location()}):(J=t,t=i)):(J=t,t=i)):(J=t,t=i),t}function peg$parsepluralStyle(){var t,n,a,s;if(t=J,(n=function peg$parseoffset(){var t,n,a;return t=J,e.substr(J,7)===x?(n=x,J+=7):(n=i,0===te&&peg$fail(A)),n!==i&&peg$parse_()!==i&&(a=peg$parsenumber())!==i?(Z=t,t=n=a):(J=t,t=i),t}())===i&&(n=null),n!==i)if(peg$parse_()!==i){if(a=[],(s=peg$parseoptionalFormatPattern())!==i)for(;s!==i;)a.push(s),
s=peg$parseoptionalFormatPattern();else a=i;a!==i?(Z=t,t=n=function(e,t){return{type:"pluralFormat",offset:e,options:t,location:location()}}(n,a)):(J=t,t=i)}else J=t,t=i;else J=t,t=i;return t}function peg$parsews(){var t,n;if(te++,t=[],R.test(e.charAt(J))?(n=e.charAt(J),J++):(n=i,0===te&&peg$fail(D)),n!==i)for(;n!==i;)t.push(n),R.test(e.charAt(J))?(n=e.charAt(J),J++):(n=i,0===te&&peg$fail(D));else t=i;return te--,t===i&&(n=i,0===te&&peg$fail(k)),t}function peg$parse_(){var t,n,a;for(te++,t=J,n=[],a=peg$parsews();a!==i;)n.push(a),a=peg$parsews();return t=n!==i?e.substring(t,J):n,te--,t===i&&(n=i,0===te&&peg$fail(I)),t}function peg$parsedigit(){var t;return C.test(e.charAt(J))?(t=e.charAt(J),J++):(t=i,0===te&&peg$fail(j)),t}function peg$parsehexDigit(){var t;return N.test(e.charAt(J))?(t=e.charAt(J),J++):(t=i,0===te&&peg$fail(L)),t}function peg$parsenumber(){var t,n,a,s,c,l;if(t=J,48===e.charCodeAt(J)?(n="0",J++):(n=i,0===te&&peg$fail(M)),n===i){if(n=J,a=J,
P.test(e.charAt(J))?(s=e.charAt(J),J++):(s=i,0===te&&peg$fail(O)),s!==i){for(c=[],l=peg$parsedigit();l!==i;)c.push(l),l=peg$parsedigit();c!==i?a=s=[s,c]:(J=a,a=i)}else J=a,a=i;n=a!==i?e.substring(n,J):a}return n!==i&&(Z=t,n=parseInt(n,10)),t=n}function peg$parsequoteEscapedChar(){var t,n,a;return t=J,n=J,te++,39===e.charCodeAt(J)?(a=F,J++):(a=i,0===te&&peg$fail(U)),a===i&&(B.test(e.charAt(J))?(a=e.charAt(J),J++):(a=i,0===te&&peg$fail(q))),te--,a===i?n=void 0:(J=n,n=i),n!==i?(e.length>J?(a=e.charAt(J),J++):(a=i,0===te&&peg$fail(z)),a!==i?(Z=t,t=n=a):(J=t,t=i)):(J=t,t=i),t===i&&(t=J,39===e.charCodeAt(J)?(n=F,J++):(n=i,0===te&&peg$fail(U)),n!==i&&(a=function peg$parseescape(){var t;B.test(e.charAt(J))?(t=e.charAt(J),J++):(t=i,0===te&&peg$fail(q));t===i&&(t=peg$parseapostrophe());return t}())!==i?(Z=t,t=n=a):(J=t,t=i)),t}function peg$parseapostrophe(){var t;return 39===e.charCodeAt(J)?(t=F,J++):(t=i,0===te&&peg$fail(U)),t}function peg$parsechar(){var t,n,a,s,c,l,u,d,m;return t=J,
39===e.charCodeAt(J)?(n=F,J++):(n=i,0===te&&peg$fail(U)),n!==i&&(a=peg$parseapostrophe())!==i?(Z=t,t=n=a):(J=t,t=i),t===i&&(V.test(e.charAt(J))?(t=e.charAt(J),J++):(t=i,0===te&&peg$fail(W)),t===i&&(t=J,"\\\\"===e.substr(J,2)?(n="\\\\",J+=2):(n=i,0===te&&peg$fail(H)),n!==i&&(Z=t,n="\\"),(t=n)===i&&(t=J,"\\#"===e.substr(J,2)?(n="\\#",J+=2):(n=i,0===te&&peg$fail(G)),n!==i&&(Z=t,n="\\#"),(t=n)===i&&(t=J,"\\{"===e.substr(J,2)?(n="\\{",J+=2):(n=i,0===te&&peg$fail($)),n!==i&&(Z=t,n="{"),(t=n)===i&&(t=J,"\\}"===e.substr(J,2)?(n="\\}",J+=2):(n=i,0===te&&peg$fail(Y)),n!==i&&(Z=t,n="}"),(t=n)===i&&(t=J,"\\u"===e.substr(J,2)?(n="\\u",J+=2):(n=i,0===te&&peg$fail(K)),n!==i?(a=J,s=J,(c=peg$parsehexDigit())!==i&&(l=peg$parsehexDigit())!==i&&(u=peg$parsehexDigit())!==i&&(d=peg$parsehexDigit())!==i?s=c=[c,l,u,d]:(J=s,s=i),(a=s!==i?e.substring(a,J):s)!==i?(Z=t,m=a,t=n=String.fromCharCode(parseInt(m,16))):(J=t,t=i)):(J=t,t=i))))))),t}function peg$parsechars(){var e,t,n;if(e=J,t=[],
(n=peg$parsechar())!==i)for(;n!==i;)t.push(n),n=peg$parsechar();else t=i;return t!==i&&(Z=e,t=peg$c3(t)),e=t}if((n=s())!==i&&J===e.length)return n;throw n!==i&&J<e.length&&peg$fail({type:"end"}),peg$buildStructuredError(ee,Q<e.length?e.charAt(Q):null,Q<e.length?peg$computeLocation(Q,Q+1):peg$computeLocation(Q,Q))}}},{}],177:[function(e,t,n){"use strict";var i,a=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function __(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(__.prototype=t.prototype,new __)});Object.defineProperty(n,"__esModule",{value:!0});var s=function(){function Compiler(e,t,n){this.locales=[],this.formats={number:{},date:{},time:{}},this.pluralNumberFormat=null,this.currentPlural=null,this.pluralStack=[],this.locales=e,this.formats=t,this.formatters=n}
return Compiler.prototype.compile=function(e){return this.pluralStack=[],this.currentPlural=null,this.pluralNumberFormat=null,this.compileMessage(e)},Compiler.prototype.compileMessage=function(e){var t=this;if(!e||"messageFormatPattern"!==e.type)throw new Error('Message AST is not of type: "messageFormatPattern"');var n=e.elements,i=n.filter((function(e){return"messageTextElement"===e.type||"argumentElement"===e.type})).map((function(e){return"messageTextElement"===e.type?t.compileMessageText(e):t.compileArgument(e)}));if(i.length!==n.length)throw new Error("Message element does not have a valid type");return i},Compiler.prototype.compileMessageText=function(e){return this.currentPlural&&/(^|[^\\])#/g.test(e.value)?(this.pluralNumberFormat||(this.pluralNumberFormat=new Intl.NumberFormat(this.locales)),new d(this.currentPlural.id,this.currentPlural.format.offset,this.pluralNumberFormat,e.value)):e.value.replace(/\\#/g,"#")},Compiler.prototype.compileArgument=function(e){
var t=e.format,n=e.id,i=this.formatters;if(!t)return new l(n);var a=this.formats,s=this.locales;switch(t.type){case"numberFormat":return{id:n,format:i.getNumberFormat(s,a.number[t.style]).format};case"dateFormat":return{id:n,format:i.getDateTimeFormat(s,a.date[t.style]).format};case"timeFormat":return{id:n,format:i.getDateTimeFormat(s,a.time[t.style]).format};case"pluralFormat":return new u(n,t.offset,this.compileOptions(e),i.getPluralRules(s,{type:t.ordinal?"ordinal":"cardinal"}));case"selectFormat":return new m(n,this.compileOptions(e));default:throw new Error("Message element does not have a valid format type")}},Compiler.prototype.compileOptions=function(e){var t=this,n=e.format,i=n.options;this.pluralStack.push(this.currentPlural),this.currentPlural="pluralFormat"===n.type?e:null;var a=i.reduce((function(e,n){return e[n.selector]=t.compileMessage(n.value),e}),{});return this.currentPlural=this.pluralStack.pop(),a},Compiler}();n.default=s;var c=function c(e){this.id=e
},l=function(e){function StringFormat(){return null!==e&&e.apply(this,arguments)||this}return a(StringFormat,e),StringFormat.prototype.format=function(e){return e||"number"==typeof e?"string"==typeof e?e:String(e):""},StringFormat}(c),u=function(){function PluralFormat(e,t,n,i){this.id=e,this.offset=t,this.options=n,this.pluralRules=i}return PluralFormat.prototype.getOption=function(e){var t=this.options;return t["="+e]||t[this.pluralRules.select(e-this.offset)]||t.other},PluralFormat}(),d=function(e){function PluralOffsetString(t,n,i,a){var s=e.call(this,t)||this;return s.offset=n,s.numberFormat=i,s.string=a,s}return a(PluralOffsetString,e),PluralOffsetString.prototype.format=function(e){var t=this.numberFormat.format(e-this.offset);return this.string.replace(/(^|[^\\])#/g,"$1"+t).replace(/\\#/g,"#")},PluralOffsetString}(c);n.PluralOffsetString=d;var m=function(){function SelectFormat(e,t){this.id=e,this.options=t}return SelectFormat.prototype.getOption=function(e){var t=this.options
;return t[e]||t.other},SelectFormat}();n.SelectFormat=m,n.isSelectOrPluralFormat=function isSelectOrPluralFormat(e){return!!e.options}},{}],178:[function(e,t,n){"use strict";var i,a=this&&this.__extends||(i=function(e,t){return(i=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)},function(e,t){function __(){this.constructor=e}i(e,t),e.prototype=null===t?Object.create(t):(__.prototype=t.prototype,new __)}),s=this&&this.__assign||function(){return(s=Object.assign||function(e){for(var t,n=1,i=arguments.length;n<i;n++)for(var a in t=arguments[n])Object.prototype.hasOwnProperty.call(t,a)&&(e[a]=t[a]);return e}).apply(this,arguments)};Object.defineProperty(n,"__esModule",{value:!0});var c=e("./compiler");function resolveLocale(e){"string"==typeof e&&(e=[e]);try{return Intl.NumberFormat.supportedLocalesOf(e,{localeMatcher:"best fit"})[0]}catch(e){return u.defaultLocale}}
function formatPatterns(e,t){for(var n="",i=0,a=e;i<a.length;i++){var s=a[i];if("string"!=typeof s){var u=s.id;if(!t||!(u in t))throw new l("A value must be provided for: "+u,u);var d=t[u];c.isSelectOrPluralFormat(s)?n+=formatPatterns(s.getOption(d),t):n+=s.format(d)}else n+=s}return n}function mergeConfigs(e,t){return t?Object.keys(e).reduce((function(n,i){return n[i]=function mergeConfig(e,t){return t?s({},e||{},t||{},Object.keys(e).reduce((function(n,i){return n[i]=s({},e[i],t[i]||{}),n}),{})):e}(e[i],t[i]),n}),s({},e)):e}var l=function(e){function FormatError(t,n){var i=e.call(this,t)||this;return i.variableId=n,i}return a(FormatError,e),FormatError}(Error);function createDefaultFormatters(){return{getNumberFormat:function(){for(var e,t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];return new((e=Intl.NumberFormat).bind.apply(e,[void 0].concat(t)))},getDateTimeFormat:function(){for(var e,t=[],n=0;n<arguments.length;n++)t[n]=arguments[n]
;return new((e=Intl.DateTimeFormat).bind.apply(e,[void 0].concat(t)))},getPluralRules:function(){for(var e,t=[],n=0;n<arguments.length;n++)t[n]=arguments[n];return new((e=Intl.PluralRules).bind.apply(e,[void 0].concat(t)))}}}n.createDefaultFormatters=createDefaultFormatters;var u=function(){function IntlMessageFormat(e,t,n,i){var a=this;if(void 0===t&&(t=IntlMessageFormat.defaultLocale),this.format=function(e){try{return formatPatterns(a.pattern,e)}catch(e){throw e.variableId?new Error("The intl string context variable '"+e.variableId+"' was not provided to the string '"+a.message+"'"):e}},"string"==typeof e){if(!IntlMessageFormat.__parse)throw new TypeError("IntlMessageFormat.__parse must be set to process `message` of type `string`");this.ast=IntlMessageFormat.__parse(e)}else this.ast=e;if(this.message=e,!this.ast||"messageFormatPattern"!==this.ast.type)throw new TypeError("A message must be provided as a String or AST.");var s=mergeConfigs(IntlMessageFormat.formats,n)
;this.locale=resolveLocale(t||[]);var l=i&&i.formatters||createDefaultFormatters();this.pattern=new c.default(t,s,l).compile(this.ast)}return IntlMessageFormat.prototype.resolvedOptions=function(){return{locale:this.locale}},IntlMessageFormat.prototype.getAst=function(){return this.ast},IntlMessageFormat.defaultLocale="en",IntlMessageFormat.__parse=void 0,IntlMessageFormat.formats={number:{currency:{style:"currency"},percent:{style:"percent"}},date:{short:{month:"numeric",day:"numeric",year:"2-digit"},medium:{month:"short",day:"numeric",year:"numeric"},long:{month:"long",day:"numeric",year:"numeric"},full:{weekday:"long",month:"long",day:"numeric",year:"numeric"}},time:{short:{hour:"numeric",minute:"numeric"},medium:{hour:"numeric",minute:"numeric",second:"numeric"},long:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"},full:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"}}},IntlMessageFormat}();n.IntlMessageFormat=u,n.default=u},{
"./compiler":177}],179:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var i=e("intl-messageformat-parser"),a=e("./core");a.default.__parse=i.default.parse,function __export(e){for(var t in e)n.hasOwnProperty(t)||(n[t]=e[t])}(e("./core")),n.default=a.default},{"./core":178,"intl-messageformat-parser":175}],180:[function(e,t,n){"use strict";var i=e("./dist").default;(n=t.exports=i).default=n},{"./dist":179}],181:[function(e,t,n){"use strict";var i="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag,a=e("call-bind/callBound")("Object.prototype.toString"),s=function isArguments(e){return!(i&&e&&"object"==typeof e&&Symbol.toStringTag in e)&&"[object Arguments]"===a(e)},c=function isArguments(e){return!!s(e)||null!==e&&"object"==typeof e&&"number"==typeof e.length&&e.length>=0&&"[object Array]"!==a(e)&&"[object Function]"===a(e.callee)},l=function(){return s(arguments)}();s.isLegacyArguments=c,t.exports=l?s:c},{"call-bind/callBound":146}],
182:[function(e,t,n){function isBuffer(e){return!!e.constructor&&"function"==typeof e.constructor.isBuffer&&e.constructor.isBuffer(e)}
/*!
 * Determine if an object is a Buffer
 *
 * @author   Feross Aboukhadijeh <https://feross.org>
 * @license  MIT
 */
t.exports=function(e){return null!=e&&(isBuffer(e)||function isSlowBuffer(e){return"function"==typeof e.readFloatLE&&"function"==typeof e.slice&&isBuffer(e.slice(0,0))}(e)||!!e._isBuffer)}},{}],183:[function(e,t,n){"use strict";var i=Object.prototype.toString,a=Function.prototype.toString,s=/^\s*(?:function)?\*/,c="function"==typeof Symbol&&"symbol"==typeof Symbol.toStringTag,l=Object.getPrototypeOf,u=function(){if(!c)return!1;try{return Function("return function*() {}")()}catch(e){}}(),d=!(!l||!u)&&l(u);t.exports=function isGeneratorFunction(e){return"function"==typeof e&&(!!s.test(a.call(e))||(c?l&&l(e)===d:"[object GeneratorFunction]"===i.call(e)))}},{}],184:[function(e,t,n){(function(n){(function(){"use strict";var i=e("foreach"),a=e("available-typed-arrays"),s=e("call-bind/callBound"),c=s("Object.prototype.toString"),l=e("has-symbols")()&&"symbol"==typeof Symbol.toStringTag,u=a(),d=s("Array.prototype.indexOf",!0)||function indexOf(e,t){
for(var n=0;n<e.length;n+=1)if(e[n]===t)return n;return-1},m=s("String.prototype.slice"),p={},h=e("es-abstract/helpers/getOwnPropertyDescriptor"),f=Object.getPrototypeOf;l&&h&&f&&i(u,(function(e){var t=new n[e];if(!(Symbol.toStringTag in t))throw new EvalError("this engine has support for Symbol.toStringTag, but "+e+" does not have the property! Please report this.");var i=f(t),a=h(i,Symbol.toStringTag);if(!a){var s=f(i);a=h(s,Symbol.toStringTag)}p[e]=a.get}));t.exports=function isTypedArray(e){if(!e||"object"!=typeof e)return!1;if(!l){var t=m(c(e),8,-1);return d(u,t)>-1}return!!h&&function tryAllTypedArrays(e){var t=!1;return i(p,(function(n,i){if(!t)try{t=n.call(e)===i}catch(e){}})),t}(e)}}).call(this)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"available-typed-arrays":131,"call-bind/callBound":146,"es-abstract/helpers/getOwnPropertyDescriptor":161,foreach:163,"has-symbols":167}],185:[function(e,t,n){
var i=e("./lib/encoder"),a=e("./lib/decoder");t.exports={encode:i,decode:a}},{"./lib/decoder":186,"./lib/encoder":187}],186:[function(e,t,n){(function(e){(function(){var n=function jpegImage(){"use strict";var e=new Int32Array([0,1,8,16,9,2,3,10,17,24,32,25,18,11,4,5,12,19,26,33,40,48,41,34,27,20,13,6,7,14,21,28,35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63]),t=4017,n=799,i=3406,a=2276,s=1567,c=3784,l=5793,u=2896;function constructor(){}function buildHuffmanTable(e,t){for(var n,i,a=0,s=[],c=16;c>0&&!e[c-1];)c--;s.push({children:[],index:0});var l,u=s[0];for(n=0;n<c;n++){for(i=0;i<e[n];i++){for((u=s.pop()).children[u.index]=t[a];u.index>0;){if(0===s.length)throw new Error("Could not recreate Huffman Table");u=s.pop()}for(u.index++,s.push(u);s.length<=n;)s.push(l={children:[],index:0}),u.children[u.index]=l.children,u=l;a++}n+1<c&&(s.push(l={children:[],index:0}),u.children[u.index]=l.children,u=l)}return s[0].children}
function decodeScan(t,n,i,a,s,c,l,u,d,m){i.precision,i.samplesPerLine,i.scanLines;var p=i.mcusPerLine,h=i.progressive,f=(i.maxH,i.maxV,n),g=0,y=0;function readBit(){if(y>0)return y--,g>>y&1;if(255==(g=t[n++])){var e=t[n++];if(e)throw new Error("unexpected marker: "+(g<<8|e).toString(16))}return y=7,g>>>7}function decodeHuffman(e){for(var t,n=e;null!==(t=readBit());){if("number"==typeof(n=n[t]))return n;if("object"!=typeof n)throw new Error("invalid huffman sequence")}return null}function receive(e){for(var t=0;e>0;){var n=readBit();if(null===n)return;t=t<<1|n,e--}return t}function receiveAndExtend(e){var t=receive(e);return t>=1<<e-1?t:t+(-1<<e)+1}var b=0;var v,w=0;function decodeMcu(e,t,n,i,a){var s=n%p,c=(n/p|0)*e.v+i,l=s*e.h+a;void 0===e.blocks[c]&&m.tolerantDecoding||t(e,e.blocks[c][l])}function decodeBlock(e,t,n){var i=n/e.blocksPerLine|0,a=n%e.blocksPerLine;void 0===e.blocks[i]&&m.tolerantDecoding||t(e,e.blocks[i][a])}var S,T,E,_,x,A,k=a.length
;A=h?0===c?0===u?function decodeDCFirst(e,t){var n=decodeHuffman(e.huffmanTableDC),i=0===n?0:receiveAndExtend(n)<<d;t[0]=e.pred+=i}:function decodeDCSuccessive(e,t){t[0]|=readBit()<<d}:0===u?function decodeACFirst(t,n){if(b>0)b--;else for(var i=c,a=l;i<=a;){var s=decodeHuffman(t.huffmanTableAC),u=15&s,m=s>>4;if(0!==u)n[e[i+=m]]=receiveAndExtend(u)*(1<<d),i++;else{if(m<15){b=receive(m)+(1<<m)-1;break}i+=16}}}:function decodeACSuccessive(t,n){for(var i=c,a=l,s=0;i<=a;){var u=e[i],m=n[u]<0?-1:1;switch(w){case 0:var p=decodeHuffman(t.huffmanTableAC),h=15&p;if(s=p>>4,0===h)s<15?(b=receive(s)+(1<<s),w=4):(s=16,w=1);else{if(1!==h)throw new Error("invalid ACn encoding");v=receiveAndExtend(h),w=s?2:3}continue;case 1:case 2:n[u]?n[u]+=(readBit()<<d)*m:0==--s&&(w=2==w?3:0);break;case 3:n[u]?n[u]+=(readBit()<<d)*m:(n[u]=v<<d,w=0);break;case 4:n[u]&&(n[u]+=(readBit()<<d)*m)}i++}4===w&&0==--b&&(w=0)}:function decodeBaseline(t,n){var i=decodeHuffman(t.huffmanTableDC),a=0===i?0:receiveAndExtend(i)
;n[0]=t.pred+=a;for(var s=1;s<64;){var c=decodeHuffman(t.huffmanTableAC),l=15&c,u=c>>4;if(0!==l)n[e[s+=u]]=receiveAndExtend(l),s++;else{if(u<15)break;s+=16}}};var R,D,I,C,j=0;for(D=1==k?a[0].blocksPerLine*a[0].blocksPerColumn:p*i.mcusPerColumn,s||(s=D);j<D;){for(T=0;T<k;T++)a[T].pred=0;if(b=0,1==k)for(S=a[0],x=0;x<s;x++)decodeBlock(S,A,j),j++;else for(x=0;x<s;x++){for(T=0;T<k;T++)for(I=(S=a[T]).h,C=S.v,E=0;E<C;E++)for(_=0;_<I;_++)decodeMcu(S,A,j,E,_);if(++j===D)break}if(j===D)do{if(255===t[n]&&0!==t[n+1])break;n+=1}while(n<t.length-2);if(y=0,(R=t[n]<<8|t[n+1])<65280)throw new Error("marker was not found");if(!(R>=65488&&R<=65495))break;n+=2}return n-f}function buildComponentData(e,d){var m,p,h=[],f=d.blocksPerLine,g=d.blocksPerColumn,y=f<<3,b=new Int32Array(64),v=new Uint8Array(64);function quantizeAndInverse(e,m,p){var h,f,g,y,b,v,w,S,T,E,_=d.quantizationTable,x=p;for(E=0;E<64;E++)x[E]=e[E]*_[E];for(E=0;E<8;++E){var A=8*E
;0!=x[1+A]||0!=x[2+A]||0!=x[3+A]||0!=x[4+A]||0!=x[5+A]||0!=x[6+A]||0!=x[7+A]?(h=l*x[0+A]+128>>8,f=l*x[4+A]+128>>8,g=x[2+A],y=x[6+A],b=u*(x[1+A]-x[7+A])+128>>8,S=u*(x[1+A]+x[7+A])+128>>8,v=x[3+A]<<4,w=x[5+A]<<4,T=h-f+1>>1,h=h+f+1>>1,f=T,T=g*c+y*s+128>>8,g=g*s-y*c+128>>8,y=T,T=b-w+1>>1,b=b+w+1>>1,w=T,T=S+v+1>>1,v=S-v+1>>1,S=T,T=h-y+1>>1,h=h+y+1>>1,y=T,T=f-g+1>>1,f=f+g+1>>1,g=T,T=b*a+S*i+2048>>12,b=b*i-S*a+2048>>12,S=T,T=v*n+w*t+2048>>12,v=v*t-w*n+2048>>12,w=T,x[0+A]=h+S,x[7+A]=h-S,x[1+A]=f+w,x[6+A]=f-w,x[2+A]=g+v,x[5+A]=g-v,x[3+A]=y+b,x[4+A]=y-b):(T=l*x[0+A]+512>>10,x[0+A]=T,x[1+A]=T,x[2+A]=T,x[3+A]=T,x[4+A]=T,x[5+A]=T,x[6+A]=T,x[7+A]=T)}for(E=0;E<8;++E){var k=E;0!=x[8+k]||0!=x[16+k]||0!=x[24+k]||0!=x[32+k]||0!=x[40+k]||0!=x[48+k]||0!=x[56+k]?(h=l*x[0+k]+2048>>12,f=l*x[32+k]+2048>>12,g=x[16+k],y=x[48+k],b=u*(x[8+k]-x[56+k])+2048>>12,S=u*(x[8+k]+x[56+k])+2048>>12,v=x[24+k],w=x[40+k],T=h-f+1>>1,h=h+f+1>>1,f=T,T=g*c+y*s+2048>>12,g=g*s-y*c+2048>>12,y=T,T=b-w+1>>1,b=b+w+1>>1,w=T,T=S+v+1>>1,
v=S-v+1>>1,S=T,T=h-y+1>>1,h=h+y+1>>1,y=T,T=f-g+1>>1,f=f+g+1>>1,g=T,T=b*a+S*i+2048>>12,b=b*i-S*a+2048>>12,S=T,T=v*n+w*t+2048>>12,v=v*t-w*n+2048>>12,w=T,x[0+k]=h+S,x[56+k]=h-S,x[8+k]=f+w,x[48+k]=f-w,x[16+k]=g+v,x[40+k]=g-v,x[24+k]=y+b,x[32+k]=y-b):(T=l*p[E+0]+8192>>14,x[0+k]=T,x[8+k]=T,x[16+k]=T,x[24+k]=T,x[32+k]=T,x[40+k]=T,x[48+k]=T,x[56+k]=T)}for(E=0;E<64;++E){var R=128+(x[E]+8>>4);m[E]=R<0?0:R>255?255:R}}requestMemoryAllocation(y*g*8);for(var w=0;w<g;w++){var S=w<<3;for(m=0;m<8;m++)h.push(new Uint8Array(y));for(var T=0;T<f;T++){quantizeAndInverse(d.blocks[w][T],v,b);var E=0,_=T<<3;for(p=0;p<8;p++){var x=h[S+p];for(m=0;m<8;m++)x[_+m]=v[E++]}}}return h}function clampTo8bit(e){return e<0?0:e>255?255:e}constructor.prototype={load:function load(e){var t=new XMLHttpRequest;t.open("GET",e,!0),t.responseType="arraybuffer",t.onload=function(){var e=new Uint8Array(t.response||t.mozResponseArrayBuffer);this.parse(e),this.onload&&this.onload()}.bind(this),t.send(null)},parse:function parse(t){
var n=1e3*this.opts.maxResolutionInMP*1e3,i=0;t.length;function readUint16(){var e=t[i]<<8|t[i+1];return i+=2,e}function readDataBlock(){var e=readUint16(),n=t.subarray(i,i+e-2);return i+=n.length,n}function prepareComponents(e){var t,n,i=0,a=0;for(n in e.components)e.components.hasOwnProperty(n)&&(i<(t=e.components[n]).h&&(i=t.h),a<t.v&&(a=t.v));var s=Math.ceil(e.samplesPerLine/8/i),c=Math.ceil(e.scanLines/8/a);for(n in e.components)if(e.components.hasOwnProperty(n)){t=e.components[n];var l=Math.ceil(Math.ceil(e.samplesPerLine/8)*t.h/i),u=Math.ceil(Math.ceil(e.scanLines/8)*t.v/a),d=s*t.h,m=c*t.v,p=[];requestMemoryAllocation(256*(m*d));for(var h=0;h<m;h++){for(var f=[],g=0;g<d;g++)f.push(new Int32Array(64));p.push(f)}t.blocksPerLine=l,t.blocksPerColumn=u,t.blocks=p}e.maxH=i,e.maxV=a,e.mcusPerLine=s,e.mcusPerColumn=c}var a,s,c=null,l=null,u=[],d=[],m=[],p=[],h=readUint16();if(this.comments=[],65496!=h)throw new Error("SOI not found");for(h=readUint16();65497!=h;){switch(h){case 65280:
break;case 65504:case 65505:case 65506:case 65507:case 65508:case 65509:case 65510:case 65511:case 65512:case 65513:case 65514:case 65515:case 65516:case 65517:case 65518:case 65519:case 65534:var f=readDataBlock();if(65534===h){var g=String.fromCharCode.apply(null,f);this.comments.push(g)}65504===h&&74===f[0]&&70===f[1]&&73===f[2]&&70===f[3]&&0===f[4]&&(c={version:{major:f[5],minor:f[6]},densityUnits:f[7],xDensity:f[8]<<8|f[9],yDensity:f[10]<<8|f[11],thumbWidth:f[12],thumbHeight:f[13],thumbData:f.subarray(14,14+3*f[12]*f[13])}),65505===h&&69===f[0]&&120===f[1]&&105===f[2]&&102===f[3]&&0===f[4]&&(this.exifBuffer=f.subarray(5,f.length)),65518===h&&65===f[0]&&100===f[1]&&111===f[2]&&98===f[3]&&101===f[4]&&0===f[5]&&(l={version:f[6],flags0:f[7]<<8|f[8],flags1:f[9]<<8|f[10],transformCode:f[11]});break;case 65499:for(var y=readUint16()+i-2;i<y;){var b=t[i++];requestMemoryAllocation(256);var v=new Int32Array(64);if(b>>4==0)for(q=0;q<64;q++){v[e[q]]=t[i++]}else{
if(b>>4!=1)throw new Error("DQT: invalid table spec");for(q=0;q<64;q++){v[e[q]]=readUint16()}}u[15&b]=v}break;case 65472:case 65473:case 65474:readUint16(),(a={}).extended=65473===h,a.progressive=65474===h,a.precision=t[i++],a.scanLines=readUint16(),a.samplesPerLine=readUint16(),a.components={},a.componentsOrder=[];var w=a.scanLines*a.samplesPerLine;if(w>n){var S=Math.ceil((w-n)/1e6);throw new Error(`maxResolutionInMP limit exceeded by ${S}MP`)}var T,E=t[i++];for(U=0;U<E;U++){T=t[i];var _=t[i+1]>>4,x=15&t[i+1],A=t[i+2];a.componentsOrder.push(T),a.components[T]={h:_,v:x,quantizationIdx:A},i+=3}prepareComponents(a),d.push(a);break;case 65476:var k=readUint16();for(U=2;U<k;){var R=t[i++],D=new Uint8Array(16),I=0;for(q=0;q<16;q++,i++)I+=D[q]=t[i];requestMemoryAllocation(16+I);var C=new Uint8Array(I);for(q=0;q<I;q++,i++)C[q]=t[i];U+=17+I,(R>>4==0?p:m)[15&R]=buildHuffmanTable(D,C)}break;case 65501:readUint16(),s=readUint16();break;case 65498:readUint16();var j=t[i++],N=[];for(U=0;U<j;U++){
z=a.components[t[i++]];var L=t[i++];z.huffmanTableDC=p[L>>4],z.huffmanTableAC=m[15&L],N.push(z)}var M=t[i++],P=t[i++],O=t[i++],F=decodeScan(t,i,a,N,s,M,P,O>>4,15&O,this.opts);i+=F;break;case 65535:255!==t[i]&&i--;break;default:if(255==t[i-3]&&t[i-2]>=192&&t[i-2]<=254){i-=3;break}throw new Error("unknown JPEG marker "+h.toString(16))}h=readUint16()}if(1!=d.length)throw new Error("only single frame JPEGs supported");for(var U=0;U<d.length;U++){var B=d[U].components;for(var q in B)B[q].quantizationTable=u[B[q].quantizationIdx],delete B[q].quantizationIdx}this.width=a.samplesPerLine,this.height=a.scanLines,this.jfif=c,this.adobe=l,this.components=[];for(U=0;U<a.componentsOrder.length;U++){var z=a.components[a.componentsOrder[U]];this.components.push({lines:buildComponentData(0,z),scaleX:z.h/a.maxH,scaleY:z.v/a.maxV})}},getData:function getData(e,t){var n,i,a,s,c,l,u,d,m,p,h,f,g,y,b,v,w,S,T,E,_,x=this.width/e,A=this.height/t,k=0,R=e*t*this.components.length;requestMemoryAllocation(R)
;var D=new Uint8Array(R);switch(this.components.length){case 1:for(n=this.components[0],p=0;p<t;p++)for(c=n.lines[0|p*n.scaleY*A],m=0;m<e;m++)h=c[0|m*n.scaleX*x],D[k++]=h;break;case 2:for(n=this.components[0],i=this.components[1],p=0;p<t;p++)for(c=n.lines[0|p*n.scaleY*A],l=i.lines[0|p*i.scaleY*A],m=0;m<e;m++)h=c[0|m*n.scaleX*x],D[k++]=h,h=l[0|m*i.scaleX*x],D[k++]=h;break;case 3:for(_=!0,this.adobe&&this.adobe.transformCode?_=!0:void 0!==this.opts.colorTransform&&(_=!!this.opts.colorTransform),n=this.components[0],i=this.components[1],a=this.components[2],p=0;p<t;p++)for(c=n.lines[0|p*n.scaleY*A],l=i.lines[0|p*i.scaleY*A],u=a.lines[0|p*a.scaleY*A],m=0;m<e;m++)_?(h=c[0|m*n.scaleX*x],f=l[0|m*i.scaleX*x],S=clampTo8bit(h+1.402*((g=u[0|m*a.scaleX*x])-128)),T=clampTo8bit(h-.3441363*(f-128)-.71413636*(g-128)),E=clampTo8bit(h+1.772*(f-128))):(S=c[0|m*n.scaleX*x],T=l[0|m*i.scaleX*x],E=u[0|m*a.scaleX*x]),D[k++]=S,D[k++]=T,D[k++]=E;break;case 4:
if(!this.adobe)throw new Error("Unsupported color mode (4 components)");for(_=!1,this.adobe&&this.adobe.transformCode?_=!0:void 0!==this.opts.colorTransform&&(_=!!this.opts.colorTransform),n=this.components[0],i=this.components[1],a=this.components[2],s=this.components[3],p=0;p<t;p++)for(c=n.lines[0|p*n.scaleY*A],l=i.lines[0|p*i.scaleY*A],u=a.lines[0|p*a.scaleY*A],d=s.lines[0|p*s.scaleY*A],m=0;m<e;m++)_?(h=c[0|m*n.scaleX*x],f=l[0|m*i.scaleX*x],g=u[0|m*a.scaleX*x],y=d[0|m*s.scaleX*x],b=255-clampTo8bit(h+1.402*(g-128)),v=255-clampTo8bit(h-.3441363*(f-128)-.71413636*(g-128)),w=255-clampTo8bit(h+1.772*(f-128))):(b=c[0|m*n.scaleX*x],v=l[0|m*i.scaleX*x],w=u[0|m*a.scaleX*x],y=d[0|m*s.scaleX*x]),D[k++]=255-b,D[k++]=255-v,D[k++]=255-w,D[k++]=255-y;break;default:throw new Error("Unsupported color mode")}return D},copyToImageData:function copyToImageData(e,t){var n,i,a,s,c,l,u,d,m,p=e.width,h=e.height,f=e.data,g=this.getData(p,h),y=0,b=0;switch(this.components.length){case 1:
for(i=0;i<h;i++)for(n=0;n<p;n++)a=g[y++],f[b++]=a,f[b++]=a,f[b++]=a,t&&(f[b++]=255);break;case 3:for(i=0;i<h;i++)for(n=0;n<p;n++)u=g[y++],d=g[y++],m=g[y++],f[b++]=u,f[b++]=d,f[b++]=m,t&&(f[b++]=255);break;case 4:for(i=0;i<h;i++)for(n=0;n<p;n++)c=g[y++],l=g[y++],a=g[y++],u=255-clampTo8bit(c*(1-(s=g[y++])/255)+s),d=255-clampTo8bit(l*(1-s/255)+s),m=255-clampTo8bit(a*(1-s/255)+s),f[b++]=u,f[b++]=d,f[b++]=m,t&&(f[b++]=255);break;default:throw new Error("Unsupported color mode")}}};var d=0,m=0;function requestMemoryAllocation(e=0){var t=d+e;if(t>m){var n=Math.ceil((t-m)/1024/1024);throw new Error(`maxMemoryUsageInMB limit exceeded by at least ${n}MB`)}d=t}return constructor.resetMaxMemoryUsage=function(e){d=0,m=e},constructor.getBytesAllocated=function(){return d},constructor.requestMemoryAllocation=requestMemoryAllocation,constructor}();function decode(t,i={}){var a={...{colorTransform:void 0,useTArray:!1,formatAsRGBA:!0,tolerantDecoding:!0,maxResolutionInMP:100,maxMemoryUsageInMB:512},...i
},s=new Uint8Array(t),c=new n;c.opts=a,n.resetMaxMemoryUsage(1024*a.maxMemoryUsageInMB*1024),c.parse(s);var l=a.formatAsRGBA?4:3,u=c.width*c.height*l;try{n.requestMemoryAllocation(u);var d={width:c.width,height:c.height,exifBuffer:c.exifBuffer,data:a.useTArray?new Uint8Array(u):new e(u)};c.comments.length>0&&(d.comments=c.comments)}catch(e){throw e instanceof RangeError?new Error("Could not allocate enough memory for the image. Required: "+u):e}return c.copyToImageData(d,a.formatAsRGBA),d}void 0!==t?t.exports=decode:"undefined"!=typeof window&&(window["jpeg-js"]=window["jpeg-js"]||{},window["jpeg-js"].decode=decode)}).call(this)}).call(this,e("buffer").Buffer)},{buffer:145}],187:[function(e,t,n){(function(e){(function(){function JPEGEncoder(n){Math.round
;var i,a,s,c,l,u=Math.floor,d=new Array(64),m=new Array(64),p=new Array(64),h=new Array(64),f=new Array(65535),g=new Array(65535),y=new Array(64),b=new Array(64),v=[],w=0,S=7,T=new Array(64),E=new Array(64),_=new Array(64),x=new Array(256),A=new Array(2048),k=[0,1,5,6,14,15,27,28,2,4,7,13,16,26,29,42,3,8,12,17,25,30,41,43,9,11,18,24,31,40,44,53,10,19,23,32,39,45,52,54,20,22,33,38,46,51,55,60,21,34,37,47,50,56,59,61,35,36,48,49,57,58,62,63],R=[0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0],D=[0,1,2,3,4,5,6,7,8,9,10,11],I=[0,0,2,1,3,3,2,4,3,5,5,4,4,0,0,1,125],C=[1,2,3,0,4,17,5,18,33,49,65,6,19,81,97,7,34,113,20,50,129,145,161,8,35,66,177,193,21,82,209,240,36,51,98,114,130,9,10,22,23,24,25,26,37,38,39,40,41,42,52,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,225,226,227,228,229,230,231,232,233,234,241,242,243,244,245,246,247,248,249,250],j=[0,0,3,1,1,1,1,1,1,1,1,1,0,0,0,0,0],N=[0,1,2,3,4,5,6,7,8,9,10,11],L=[0,0,2,1,2,4,4,3,4,7,5,4,4,0,1,2,119],M=[0,1,2,3,17,4,5,33,49,6,18,65,81,7,97,113,19,34,50,129,8,20,66,145,161,177,193,9,35,51,82,240,21,98,114,209,10,22,36,52,225,37,241,23,24,25,26,38,39,40,41,42,53,54,55,56,57,58,67,68,69,70,71,72,73,74,83,84,85,86,87,88,89,90,99,100,101,102,103,104,105,106,115,116,117,118,119,120,121,122,130,131,132,133,134,135,136,137,138,146,147,148,149,150,151,152,153,154,162,163,164,165,166,167,168,169,170,178,179,180,181,182,183,184,185,186,194,195,196,197,198,199,200,201,202,210,211,212,213,214,215,216,217,218,226,227,228,229,230,231,232,233,234,242,243,244,245,246,247,248,249,250]
;function computeHuffmanTbl(e,t){for(var n=0,i=0,a=new Array,s=1;s<=16;s++){for(var c=1;c<=e[s];c++)a[t[i]]=[],a[t[i]][0]=n,a[t[i]][1]=s,i++,n++;n*=2}return a}function writeBits(e){for(var t=e[0],n=e[1]-1;n>=0;)t&1<<n&&(w|=1<<S),n--,--S<0&&(255==w?(writeByte(255),writeByte(0)):writeByte(w),S=7,w=0)}function writeByte(e){v.push(e)}function writeWord(e){writeByte(e>>8&255),writeByte(255&e)}function processDU(e,t,n,i,a){for(var s,c=a[0],l=a[240],u=function fDCTQuant(e,t){var n,i,a,s,c,l,u,d,m,p,h=0;for(m=0;m<8;++m){n=e[h],i=e[h+1],a=e[h+2],s=e[h+3],c=e[h+4],l=e[h+5],u=e[h+6];var f=n+(d=e[h+7]),g=n-d,b=i+u,v=i-u,w=a+l,S=a-l,T=s+c,E=s-c,_=f+T,x=f-T,A=b+w,k=b-w;e[h]=_+A,e[h+4]=_-A;var R=.707106781*(k+x);e[h+2]=x+R,e[h+6]=x-R;var D=.382683433*((_=E+S)-(k=v+g)),I=.5411961*_+D,C=1.306562965*k+D,j=.707106781*(A=S+v),N=g+j,L=g-j;e[h+5]=L+I,e[h+3]=L-I,e[h+1]=N+C,e[h+7]=N-C,h+=8}for(h=0,m=0;m<8;++m){n=e[h],i=e[h+8],a=e[h+16],s=e[h+24],c=e[h+32],l=e[h+40],u=e[h+48]
;var M=n+(d=e[h+56]),P=n-d,O=i+u,F=i-u,U=a+l,B=a-l,q=s+c,z=s-c,V=M+q,W=M-q,H=O+U,G=O-U;e[h]=V+H,e[h+32]=V-H;var $=.707106781*(G+W);e[h+16]=W+$,e[h+48]=W-$;var Y=.382683433*((V=z+B)-(G=F+P)),K=.5411961*V+Y,J=1.306562965*G+Y,Z=.707106781*(H=B+F),X=P+Z,Q=P-Z;e[h+40]=Q+K,e[h+24]=Q-K,e[h+8]=X+J,e[h+56]=X-J,h++}for(m=0;m<64;++m)p=e[m]*t[m],y[m]=p>0?p+.5|0:p-.5|0;return y}(e,t),d=0;d<64;++d)b[k[d]]=u[d];var m=b[0]-n;n=b[0],0==m?writeBits(i[0]):(writeBits(i[g[s=32767+m]]),writeBits(f[s]));for(var p=63;p>0&&0==b[p];p--);if(0==p)return writeBits(c),n;for(var h,v=1;v<=p;){for(var w=v;0==b[v]&&v<=p;++v);var S=v-w;if(S>=16){h=S>>4;for(var T=1;T<=h;++T)writeBits(l);S&=15}s=32767+b[v],writeBits(a[(S<<4)+g[s]]),writeBits(f[s]),v++}return 63!=p&&writeBits(c),n}function setQuality(e){if(e<=0&&(e=1),e>100&&(e=100),l!=e){(function initQuantTables(e){
for(var t=[16,11,10,16,24,40,51,61,12,12,14,19,26,58,60,55,14,13,16,24,40,57,69,56,14,17,22,29,51,87,80,62,18,22,37,56,68,109,103,77,24,35,55,64,81,104,113,92,49,64,78,87,103,121,120,101,72,92,95,98,112,100,103,99],n=0;n<64;n++){var i=u((t[n]*e+50)/100);i<1?i=1:i>255&&(i=255),d[k[n]]=i}for(var a=[17,18,24,47,99,99,99,99,18,21,26,66,99,99,99,99,24,26,56,99,99,99,99,99,47,66,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99,99],s=0;s<64;s++){var c=u((a[s]*e+50)/100);c<1?c=1:c>255&&(c=255),m[k[s]]=c}for(var l=[1,1.387039845,1.306562965,1.175875602,1,.785694958,.5411961,.275899379],f=0,g=0;g<8;g++)for(var y=0;y<8;y++)p[f]=1/(d[k[f]]*l[g]*l[y]*8),h[f]=1/(m[k[f]]*l[g]*l[y]*8),f++})(e<50?Math.floor(5e3/e):Math.floor(200-2*e)),l=e}}this.encode=function(n,l){(new Date).getTime();l&&setQuality(l),v=new Array,w=0,S=7,writeWord(65496),function writeAPP0(){writeWord(65504),writeWord(16),writeByte(74),writeByte(70),writeByte(73),
writeByte(70),writeByte(0),writeByte(1),writeByte(1),writeByte(0),writeWord(1),writeWord(1),writeByte(0),writeByte(0)}(),function writeAPP1(e){if(e){writeWord(65505),69===e[0]&&120===e[1]&&105===e[2]&&102===e[3]?writeWord(e.length+2):(writeWord(e.length+5+2),writeByte(69),writeByte(120),writeByte(105),writeByte(102),writeByte(0));for(var t=0;t<e.length;t++)writeByte(e[t])}}(n.exifBuffer),function writeDQT(){writeWord(65499),writeWord(132),writeByte(0);for(var e=0;e<64;e++)writeByte(d[e]);writeByte(1);for(var t=0;t<64;t++)writeByte(m[t])}(),function writeSOF0(e,t){writeWord(65472),writeWord(17),writeByte(8),writeWord(t),writeWord(e),writeByte(3),writeByte(1),writeByte(17),writeByte(0),writeByte(2),writeByte(17),writeByte(1),writeByte(3),writeByte(17),writeByte(1)}(n.width,n.height),function writeDHT(){writeWord(65476),writeWord(418),writeByte(0);for(var e=0;e<16;e++)writeByte(R[e+1]);for(var t=0;t<=11;t++)writeByte(D[t]);writeByte(16);for(var n=0;n<16;n++)writeByte(I[n+1])
;for(var i=0;i<=161;i++)writeByte(C[i]);writeByte(1);for(var a=0;a<16;a++)writeByte(j[a+1]);for(var s=0;s<=11;s++)writeByte(N[s]);writeByte(17);for(var c=0;c<16;c++)writeByte(L[c+1]);for(var l=0;l<=161;l++)writeByte(M[l])}(),function writeSOS(){writeWord(65498),writeWord(12),writeByte(3),writeByte(1),writeByte(0),writeByte(2),writeByte(17),writeByte(3),writeByte(17),writeByte(0),writeByte(63),writeByte(0)}();var u=0,f=0,g=0;w=0,S=7,this.encode.displayName="_encode_";for(var y,b,x,k,P,O,F,U,B,q=n.data,z=n.width,V=n.height,W=4*z,H=0;H<V;){for(y=0;y<W;){for(O=P=W*H+y,F=-1,U=0,B=0;B<64;B++)O=P+(U=B>>3)*W+(F=4*(7&B)),H+U>=V&&(O-=W*(H+1+U-V)),y+F>=W&&(O-=y+F-W+4),b=q[O++],x=q[O++],k=q[O++],T[B]=(A[b]+A[x+256>>0]+A[k+512>>0]>>16)-128,E[B]=(A[b+768>>0]+A[x+1024>>0]+A[k+1280>>0]>>16)-128,_[B]=(A[b+1280>>0]+A[x+1536>>0]+A[k+1792>>0]>>16)-128;u=processDU(T,p,u,i,s),f=processDU(E,h,f,a,c),g=processDU(_,h,g,a,c),y+=32}H+=8}if(S>=0){var G=[];G[1]=S+1,G[0]=(1<<S+1)-1,writeBits(G)}
return writeWord(65497),void 0===t?new Uint8Array(v):new e(v)},function init(){(new Date).getTime();n||(n=50),function initCharLookupTable(){for(var e=String.fromCharCode,t=0;t<256;t++)x[t]=e(t)}(),function initHuffmanTbl(){i=computeHuffmanTbl(R,D),a=computeHuffmanTbl(j,N),s=computeHuffmanTbl(I,C),c=computeHuffmanTbl(L,M)}(),function initCategoryNumber(){for(var e=1,t=2,n=1;n<=15;n++){for(var i=e;i<t;i++)g[32767+i]=n,f[32767+i]=[],f[32767+i][1]=n,f[32767+i][0]=i;for(var a=-(t-1);a<=-e;a++)g[32767+a]=n,f[32767+a]=[],f[32767+a][1]=n,f[32767+a][0]=t-1+a;e<<=1,t<<=1}}(),function initRGBYUVTable(){for(var e=0;e<256;e++)A[e]=19595*e,A[e+256>>0]=38470*e,A[e+512>>0]=7471*e+32768,A[e+768>>0]=-11059*e,A[e+1024>>0]=-21709*e,A[e+1280>>0]=32768*e+8421375,A[e+1536>>0]=-27439*e,A[e+1792>>0]=-5329*e}(),setQuality(n),(new Date).getTime()}()}function encode(e,t){return void 0===t&&(t=50),{data:new JPEGEncoder(t).encode(e,t),width:e.width,height:e.height}}
void 0!==t?t.exports=encode:"undefined"!=typeof window&&(window["jpeg-js"]=window["jpeg-js"]||{},window["jpeg-js"].encode=encode)}).call(this)}).call(this,e("buffer").Buffer)},{buffer:145}],188:[function(e,t,n){(function(n){(function(){"use strict";const i=e("debug"),a=e("marky"),s=e("events").EventEmitter,c="win32"===n.platform,l=n.browser,u={red:l?"crimson":1,yellow:l?"gold":3,cyan:l?"darkturquoise":6,green:l?"forestgreen":2,blue:l?"steelblue":4,magenta:l?"palevioletred":5};i.colors=[u.cyan,u.green,u.blue,u.magenta];const d={};let m;class Log{static _logToStdErr(e,t){Log.loggerfn(e)(...t)}static loggerfn(e){let t=d[e="LH:"+e];return t||(t=i(e),d[e]=t,e.endsWith("error")?t.color=u.red:e.endsWith("warn")&&(t.color=u.yellow)),t}static setLevel(e){switch(m=e,e){case"silent":i.enable("-LH:*");break;case"verbose":i.enable("LH:*");break;case"error":i.enable("-LH:*, LH:*:error");break;default:i.enable("LH:*, -LH:*:verbose")}}static formatProtocol(e,t,i){
const a=!n||n.browser?1/0:n.stdout.columns,s=t.method||"?????",c=a-s.length-e.length-25,l=t.params&&"IO.read"!==s?JSON.stringify(t.params).substr(0,c):"";Log._logToStdErr(`${e}:${i||""}`,[s,l])}static isVerbose(){return"verbose"===m}static time({msg:e,id:t,args:n=[]},i="log"){a.mark(t),Log[i]("status",e,...n)}static timeEnd({msg:e,id:t,args:n=[]},i="verbose"){Log[i]("statusEnd",e,...n),a.stop(t)}static log(e,...t){return Log.events.issueStatus(e,t),Log._logToStdErr(e,t)}static warn(e,...t){return Log.events.issueWarning(e,t),Log._logToStdErr(e+":warn",t)}static error(e,...t){return Log._logToStdErr(e+":error",t)}static verbose(e,...t){return Log.events.issueStatus(e,t),Log._logToStdErr(e+":verbose",t)}static greenify(e){return`${Log.green}${e}${Log.reset}`}static redify(e){return`${Log.red}${e}${Log.reset}`}static get green(){return"[32m"}static get red(){return"[31m"}static get yellow(){return"[33m"}static get purple(){return"[95m"}static get reset(){return"[0m"}
static get bold(){return"[1m"}static get dim(){return"[2m"}static get tick(){return c?"√":"✓"}static get cross(){return c?"×":"✘"}static get whiteSmallSquare(){return c?"·":"▫"}static get heavyHorizontal(){return c?"─":"━"}static get heavyVertical(){return c?"│ ":"┃ "}static get heavyUpAndRight(){return c?"└":"┗"}static get heavyVerticalAndRight(){return c?"├":"┣"}static get heavyDownAndHorizontal(){return c?"┬":"┳"}static get doubleLightHorizontal(){return"──"}}Log.events=new class Emitter extends s{issueStatus(e,t){"status"!==e&&"statusEnd"!==e||this.emit(e,[e,...t])}issueWarning(e,t){this.emit("warning",[e,...t])}},Log.takeTimeEntries=()=>{const e=a.getEntries();return a.clear(),e},Log.getTimeEntries=()=>a.getEntries(),t.exports=Log}).call(this)}).call(this,e("_process"))},{_process:223,debug:189,events:162,marky:219}],189:[function(e,t,n){(function(i){(function(){function load(){var e;try{e=n.storage.debug}catch(e){}return!e&&void 0!==i&&"env"in i&&(e=i.env.DEBUG),e}
(n=t.exports=e("./debug")).log=function log(){return"object"==typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)},n.formatArgs=function formatArgs(e){var t=this.useColors;if(e[0]=(t?"%c":"")+this.namespace+(t?" %c":" ")+e[0]+(t?"%c ":" ")+"+"+n.humanize(this.diff),!t)return;var i="color: "+this.color;e.splice(1,0,i,"color: inherit");var a=0,s=0;e[0].replace(/%[a-zA-Z%]/g,(function(e){"%%"!==e&&(a++,"%c"===e&&(s=a))})),e.splice(s,0,i)},n.save=function save(e){try{null==e?n.storage.removeItem("debug"):n.storage.debug=e}catch(e){}},n.load=load,n.useColors=function useColors(){if("undefined"!=typeof window&&window.process&&"renderer"===window.process.type)return!0
;return"undefined"!=typeof document&&document.documentElement&&document.documentElement.style&&document.documentElement.style.WebkitAppearance||"undefined"!=typeof window&&window.console&&(window.console.firebug||window.console.exception&&window.console.table)||"undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||"undefined"!=typeof navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/)},n.storage="undefined"!=typeof chrome&&void 0!==chrome.storage?chrome.storage.local:function localstorage(){try{return window.localStorage}catch(e){}}(),n.colors=["lightseagreen","forestgreen","goldenrod","dodgerblue","darkorchid","crimson"],n.formatters.j=function(e){try{return JSON.stringify(e)}catch(e){return"[UnexpectedJSONParseError]: "+e.message}},n.enable(load())}).call(this)}).call(this,e("_process"))},{"./debug":190,_process:223}],190:[function(e,t,n){var i
;function createDebug(e){function debug(){if(debug.enabled){var e=debug,t=+new Date,a=t-(i||t);e.diff=a,e.prev=i,e.curr=t,i=t;for(var s=new Array(arguments.length),c=0;c<s.length;c++)s[c]=arguments[c];s[0]=n.coerce(s[0]),"string"!=typeof s[0]&&s.unshift("%O");var l=0;s[0]=s[0].replace(/%([a-zA-Z%])/g,(function(t,i){if("%%"===t)return t;l++;var a=n.formatters[i];if("function"==typeof a){var c=s[l];t=a.call(e,c),s.splice(l,1),l--}return t})),n.formatArgs.call(e,s);var u=debug.log||n.log||console.log.bind(console);u.apply(e,s)}}return debug.namespace=e,debug.enabled=n.enabled(e),debug.useColors=n.useColors(),debug.color=function selectColor(e){var t,i=0;for(t in e)i=(i<<5)-i+e.charCodeAt(t),i|=0;return n.colors[Math.abs(i)%n.colors.length]}(e),"function"==typeof n.init&&n.init(debug),debug}(n=t.exports=createDebug.debug=createDebug.default=createDebug).coerce=function coerce(e){return e instanceof Error?e.stack||e.message:e},n.disable=function disable(){n.enable("")},
n.enable=function enable(e){n.save(e),n.names=[],n.skips=[];for(var t=("string"==typeof e?e:"").split(/[\s,]+/),i=t.length,a=0;a<i;a++)t[a]&&("-"===(e=t[a].replace(/\*/g,".*?"))[0]?n.skips.push(new RegExp("^"+e.substr(1)+"$")):n.names.push(new RegExp("^"+e+"$")))},n.enabled=function enabled(e){var t,i;for(t=0,i=n.skips.length;t<i;t++)if(n.skips[t].test(e))return!1;for(t=0,i=n.names.length;t<i;t++)if(n.names[t].test(e))return!0;return!1},n.humanize=e("ms"),n.names=[],n.skips=[],n.formatters={}},{ms:191}],191:[function(e,t,n){var i=1e3,a=60*i,s=60*a,c=24*s,l=365.25*c;function plural(e,t,n){if(!(e<t))return e<1.5*t?Math.floor(e/t)+" "+n:Math.ceil(e/t)+" "+n+"s"}t.exports=function(e,t){t=t||{};var n=typeof e;if("string"===n&&e.length>0)return function parse(e){if((e=String(e)).length>100)return;var t=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);if(!t)return;var n=parseFloat(t[1])
;switch((t[2]||"ms").toLowerCase()){case"years":case"year":case"yrs":case"yr":case"y":return n*l;case"days":case"day":case"d":return n*c;case"hours":case"hour":case"hrs":case"hr":case"h":return n*s;case"minutes":case"minute":case"mins":case"min":case"m":return n*a;case"seconds":case"second":case"secs":case"sec":case"s":return n*i;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return n;default:return}}(e);if("number"===n&&!1===isNaN(e))return t.long?function fmtLong(e){return plural(e,c,"day")||plural(e,s,"hour")||plural(e,a,"minute")||plural(e,i,"second")||e+" ms"}(e):function fmtShort(e){if(e>=c)return Math.round(e/c)+"d";if(e>=s)return Math.round(e/s)+"h";if(e>=a)return Math.round(e/a)+"m";if(e>=i)return Math.round(e/i)+"s";return e+"ms"}(e);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))}},{}],192:[function(e,t,n){
const i=e("lighthouse/lighthouse-core/lib/dependency-graph/base-node.js"),a=(e("lighthouse/lighthouse-core/lib/dependency-graph/cpu-node.js"),e("lighthouse/lighthouse-core/computed/metrics/lantern-metric")),{isBidRelatedRequest:s,isImpressionPing:c,isGoogleAds:l,isGptAdRequest:u,isGptTag:d,isGptImplTag:m,toURL:p}=(e("lighthouse/lighthouse-core/lib/dependency-graph/network-node.js"),e("../utils/resource-classification"));function getFrame(e){return e.args.frame||e.args.data&&e.args.data.frame||null}function isAdTask(e){return!!function getCpuNodeUrls(e){const t=new Set;for(const{args:n}of e.childEvents)n.data&&n.data.url&&t.add(n.data.url);return Array.from(t)}(e).find((e=>s(e)||l(p(e))))}function addEdge(e,t){e===t||e.endTime>t.startTime||e.addDependent(t)}function addEdges(e){const t=[],n=[];e.traverse((e=>{e.type===i.TYPES.NETWORK&&(d(e.record.url)&&"Script"===e.record.resourceType?n.push(e):u(e.record)&&t.push(e))})),e.traverse((e=>{if(e.type===i.TYPES.NETWORK){if(m(e.record.url)){
const t=e;for(const e of n)addEdge(e,t)}if(s(e.record)){const n=e;for(const e of t)addEdge(n,e)}if(c(e.record.url)){const n=e;for(const e of t){addEdge(e,n);for(const t of e.getDependents())addEdge(t,n)}}}}))}class AdLanternMetric extends a{static get COEFFICIENTS(){return{intercept:0,optimistic:1,pessimistic:0}}static getPessimisticGraph(e){const t=e.cloneWithRelationships((e=>!0));return addEdges(t),t}static getOptimisticGraph(e){const t=e.record.frameId,n=AdLanternMetric.getPessimisticGraph(e),a=n.cloneWithRelationships((e=>{if(e.type===i.TYPES.CPU)return function isLongTask(e){return e.event.dur>5e4}(e)||isAdTask(e)||!!getFrame(e.event)&&getFrame(e.event)!==t;if(e.hasRenderBlockingPriority())return!0;const n=e.record.url;return s(n)||l(p(n))}));return addEdges(n),a}static getEstimateFromSimulation(e,t){throw new Error("getEstimateFromSimulation not implemented by "+this.name)}static findTiming(e,t){let n={startTime:1/0,endTime:-1/0,duration:0}
;for(const[i,a]of e.entries())t(i,a)&&n.startTime>a.startTime&&(n=a);return n}static findNetworkTiming(e,t){return this.findTiming(e,(e=>e.type===i.TYPES.NETWORK&&t(e.record)))}}t.exports=AdLanternMetric},{"../utils/resource-classification":206,"lighthouse/lighthouse-core/computed/metrics/lantern-metric":27,"lighthouse/lighthouse-core/lib/dependency-graph/base-node.js":88,"lighthouse/lighthouse-core/lib/dependency-graph/cpu-node.js":89,"lighthouse/lighthouse-core/lib/dependency-graph/network-node.js":90}],193:[function(e,t,n){const i=e("./ad-lantern-metric"),a=e("lighthouse/lighthouse-core/computed/metrics/metric"),s=e("lighthouse/lighthouse-core/computed/computed-artifact"),{getPageStartTime:c,getImpressionStartTime:l}=e("../utils/network-timing"),{isImpressionPing:u}=e("../utils/resource-classification");class LanternAdRenderTime extends i{static getEstimateFromSimulation(e,t){const{nodeTimings:n}=e;return{timeInMs:i.findNetworkTiming(n,(e=>!!e.url&&u(new URL(e.url)))).startTime,
nodeTimings:n}}}LanternAdRenderTime=s(LanternAdRenderTime);class AdRenderTime extends a{static async computeSimulatedMetric(e,t){return LanternAdRenderTime.request(e,t)}static async computeObservedMetric(e,t){const{networkRecords:n}=e,i=c(n),a=1e3*(l(n)-i);return Promise.resolve({timing:a})}static async request(e,t){throw Error("Not implemented -- class not decorated")}}AdRenderTime=s(AdRenderTime),t.exports=AdRenderTime},{"../utils/network-timing":204,"../utils/resource-classification":206,"./ad-lantern-metric":192,"lighthouse/lighthouse-core/computed/computed-artifact":9,"lighthouse/lighthouse-core/computed/metrics/metric":33}],194:[function(e,t,n){const i=e("./ad-lantern-metric"),a=e("lighthouse/lighthouse-core/computed/metrics/metric"),s=e("lighthouse/lighthouse-core/computed/computed-artifact"),{getAdStartTime:c,getPageStartTime:l}=e("../utils/network-timing"),{isAdRequest:u}=e("../utils/resource-classification");class LanternAdRequestTime extends i{
static getEstimateFromSimulation(e,t){const{nodeTimings:n}=e;return{timeInMs:i.findNetworkTiming(n,u).startTime,nodeTimings:n}}}LanternAdRequestTime=s(LanternAdRequestTime);class AdRequestTime extends a{static async computeSimulatedMetric(e,t){return LanternAdRequestTime.request(e,t)}static async computeObservedMetric(e){const{networkRecords:t}=e,n=l(t),i=1e3*(c(t)-n);return Promise.resolve({timing:i})}static async request(e,t){throw Error("Not implemented -- class not decorated")}}AdRequestTime=s(AdRequestTime),t.exports=AdRequestTime},{"../utils/network-timing":204,"../utils/resource-classification":206,"./ad-lantern-metric":192,"lighthouse/lighthouse-core/computed/computed-artifact":9,"lighthouse/lighthouse-core/computed/metrics/metric":33}],195:[function(e,t,n){
const i=e("./ad-lantern-metric"),a=e("lighthouse/lighthouse-core/computed/metrics/metric"),s=e("lighthouse/lighthouse-core/computed/computed-artifact"),{getAdStartTime:c,getBidStartTime:l,getPageStartTime:u}=e("../utils/network-timing"),{isAdRequest:d,isBidRequest:m}=e("../utils/resource-classification");class LanternBidRequestTime extends i{static getEstimateFromSimulation(e,t){const{nodeTimings:n}=e,a=i.findNetworkTiming(n,m).startTime;return a>i.findNetworkTiming(n,d).startTime?{timeInMs:-1,nodeTimings:n}:{timeInMs:a,nodeTimings:n}}}LanternBidRequestTime=s(LanternBidRequestTime);class BidRequestTime extends a{static async computeSimulatedMetric(e,t){return LanternBidRequestTime.request(e,t)}static async computeObservedMetric(e){const{networkRecords:t}=e,n=u(t),i=l(t);if(c(t)<i)return{timing:-1};return{timing:1e3*(i-n)}}static async request(e,t){throw Error("Not implemented -- class not decorated")}}BidRequestTime=s(BidRequestTime),t.exports=BidRequestTime},{
"../utils/network-timing":204,"../utils/resource-classification":206,"./ad-lantern-metric":192,"lighthouse/lighthouse-core/computed/computed-artifact":9,"lighthouse/lighthouse-core/computed/metrics/metric":33}],196:[function(e,t,n){const i=e("../computed/ad-lantern-metric"),a=e("lighthouse/lighthouse-core/lib/dependency-graph/base-node.js"),s=e("lighthouse/lighthouse-core/computed/metrics/metric"),{getAttributableUrl:c}=(e("lighthouse/lighthouse-core/lib/dependency-graph/cpu-node.js"),e("../utils/tasks")),l=e("lighthouse/lighthouse-core/computed/load-simulator"),u=e("lighthouse/lighthouse-core/computed/main-thread-tasks"),d=e("lighthouse/lighthouse-core/computed/computed-artifact"),m=(e("lighthouse/lighthouse-core/lib/dependency-graph/network-node.js"),e("lighthouse/lighthouse-core/computed/network-records")),p=e("lighthouse/lighthouse-core/computed/page-dependency-graph");class LongTasks extends s{static async getSimulationGraph(e,t,n){const a=await p.request({trace:e,devtoolsLog:t
},n);return i.getOptimisticGraph(a)}static async computeSimulatedResult(e,t,n){const i=await this.getSimulationGraph(e,t,n),s=await l.request({devtoolsLog:t,settings:n.settings},n),{nodeTimings:c}=s.simulate(i,{}),u=[];for(const[e,t]of c.entries())e.type!==a.TYPES.CPU||t.duration<100||u.push({event:e.event,startTime:t.startTime,endTime:t.endTime,duration:t.duration,selfTime:t.duration,attributableURLs:Array.from(e.getEvaluateScriptURLs()),children:[],parent:e.parent,unbounded:e.unbounded,group:e.group});return u}static async computeObservedResult(e,t,n){const i=await u.request(e,n),a=await m.request(t,n),s=new Set(a.filter((e=>"Script"===e.resourceType)).map((e=>e.url)));return i.filter((e=>function isLong(e,t){if(e.duration<50)return!1;const n=c(e,t);if(!n)return!1;if(e.parent)return n!=c(e.parent,t);return!0}(e,s)))}static async compute_({trace:e,devtoolsLog:t},n){return"simulate"==n.settings.throttlingMethod?this.computeSimulatedResult(e,t,n):this.computeObservedResult(e,t,n)}
static async request(e,t){throw Error("Not implemented -- class not decorated")}}LongTasks=d(LongTasks),t.exports=LongTasks},{"../computed/ad-lantern-metric":192,"../utils/tasks":207,"lighthouse/lighthouse-core/computed/computed-artifact":9,"lighthouse/lighthouse-core/computed/load-simulator":13,"lighthouse/lighthouse-core/computed/main-thread-tasks":15,"lighthouse/lighthouse-core/computed/metrics/metric":33,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/computed/page-dependency-graph":41,"lighthouse/lighthouse-core/lib/dependency-graph/base-node.js":88,"lighthouse/lighthouse-core/lib/dependency-graph/cpu-node.js":89,"lighthouse/lighthouse-core/lib/dependency-graph/network-node.js":90}],197:[function(e,t,n){
const i=e("./ad-lantern-metric"),a=e("lighthouse/lighthouse-core/computed/metrics/metric"),s=e("lighthouse/lighthouse-core/computed/computed-artifact"),{getPageStartTime:c,getTagEndTime:l}=e("../utils/network-timing"),{isImplTag:u}=e("../utils/resource-classification"),{URL:d}=e("url");class LanternTagLoadTime extends i{static getEstimateFromSimulation(e,t){const{nodeTimings:n}=e;return{timeInMs:i.findNetworkTiming(n,(e=>!!e.url&&u(new d(e.url)))).endTime,nodeTimings:n}}}LanternTagLoadTime=s(LanternTagLoadTime);class TagLoadTime extends a{static async computeSimulatedMetric(e,t){return LanternTagLoadTime.request(e,t)}static async computeObservedMetric(e,t){const{networkRecords:n}=e,i=c(n),a=1e3*(l(n)-i);return Promise.resolve({timing:a})}static async request(e,t){throw Error("Not implemented -- class not decorated")}}TagLoadTime=s(TagLoadTime),t.exports=TagLoadTime},{"../utils/network-timing":204,"../utils/resource-classification":206,"./ad-lantern-metric":192,
"lighthouse/lighthouse-core/computed/computed-artifact":9,"lighthouse/lighthouse-core/computed/metrics/metric":33,url:"url"}],198:[function(e,t,n){(function(n){(function(){const i={GROUPS__METRICS:"Metrics",GROUPS__ADS_PERFORMANCE:"Ad Speed",GROUPS__ADS_BEST_PRACTICES:"Tag Best Practices",NOT_APPLICABLE__DEFAULT:"Audit not applicable",NOT_APPLICABLE__INVALID_TIMING:"Invalid timing task data",NOT_APPLICABLE__NO_AD_RELATED_REQ:"No ad-related requests",NOT_APPLICABLE__NO_AD_RENDERED:"No ads rendered",NOT_APPLICABLE__NO_ADS_VIEWPORT:"No ads in viewport",NOT_APPLICABLE__NO_ADS:"No ads requested",NOT_APPLICABLE__NO_BIDS:"No bids detected",NOT_APPLICABLE__NO_EVENT_MATCHING_REQ:"No event matches network records",NOT_APPLICABLE__NO_GPT:"GPT not requested",NOT_APPLICABLE__NO_RECORDS:"No successful network records",NOT_APPLICABLE__NO_VISIBLE_SLOTS:"No visible slots",NOT_APPLICABLE__NO_TAG:"No tag requested",NOT_APPLICABLE__NO_TAGS:"No tags requested",
NOT_APPLICABLE__NO_TASKS:"No tasks to compare",NOT_APPLICABLE__NO_VALID_AD_WIDTHS:"No requested ads contain ads of valid width",NOT_APPLICABLE__NO_LAYOUT_SHIFTS:"No layout shift events found",ERRORS__AREA_LARGER_THAN_VIEWPORT:"Calculated ad area is larger than viewport",ERRORS__VIEWPORT_AREA_ZERO:"Viewport area is zero",WARNINGS__NO_ADS:"No ads were requested when fetching this page.",WARNINGS__NO_AD_RENDERED:"No ads were rendered when rendering this page.",WARNINGS__NO_TAG:"The GPT tag was not requested."},a=e("lighthouse/lighthouse-core/lib/i18n/i18n").createMessageInstanceIdFn(n,i),notApplicableObj=e=>({notApplicable:!0,score:1,displayValue:a(e)}),s={Default:notApplicableObj(i.NOT_APPLICABLE__DEFAULT),InvalidTiming:notApplicableObj(i.NOT_APPLICABLE__INVALID_TIMING),NoAdRelatedReq:notApplicableObj(i.NOT_APPLICABLE__NO_AD_RELATED_REQ),NoAdRendered:notApplicableObj(i.NOT_APPLICABLE__NO_AD_RENDERED),NoAdsViewport:notApplicableObj(i.NOT_APPLICABLE__NO_ADS_VIEWPORT),
NoAds:notApplicableObj(i.NOT_APPLICABLE__NO_ADS),NoBids:notApplicableObj(i.NOT_APPLICABLE__NO_BIDS),NoEventMatchingReq:notApplicableObj(i.NOT_APPLICABLE__NO_EVENT_MATCHING_REQ),NoGpt:notApplicableObj(i.NOT_APPLICABLE__NO_GPT),NoLayoutShifts:notApplicableObj(i.NOT_APPLICABLE__NO_LAYOUT_SHIFTS),NoRecords:notApplicableObj(i.NOT_APPLICABLE__NO_RECORDS),NoVisibleSlots:notApplicableObj(i.NOT_APPLICABLE__NO_VISIBLE_SLOTS),NoTag:notApplicableObj(i.NOT_APPLICABLE__NO_TAG),NoTags:notApplicableObj(i.NOT_APPLICABLE__NO_TAGS),NoTasks:notApplicableObj(i.NOT_APPLICABLE__NO_TASKS),NoValidAdWidths:notApplicableObj(i.NOT_APPLICABLE__NO_VALID_AD_WIDTHS)},c={NoAds:a(i.WARNINGS__NO_ADS),NoAdRendered:a(i.WARNINGS__NO_AD_RENDERED),NoTag:a(i.WARNINGS__NO_TAG)},l={ViewportAreaZero:a(i.ERRORS__VIEWPORT_AREA_ZERO)},u={Metrics:a(i.GROUPS__METRICS),AdsPerformance:a(i.GROUPS__ADS_PERFORMANCE),AdsBestPractices:a(i.GROUPS__ADS_BEST_PRACTICES)};t.exports={auditNotApplicable:s,runWarning:c,auditError:l,group:u},
t.exports.UIStrings=i}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/messages/common-strings.js")},{"lighthouse/lighthouse-core/lib/i18n/i18n":98}],199:[function(e,t,n){t.exports={count:function count(e,t){let n=0;for(const i of e)t(i)&&n++;return n},bucket:function bucket(e,t){const n=new Map;for(const i of e){const e=t(i);if(null!=e){const t=n.get(e)||[];t.push(i),n.set(e,t)}}return n},flatten:function flatten(e){const t=[];for(const n of e)t.push(...n);return t}}},{}],200:[function(e,t,n){t.exports={assert:function assert(e){if(null==e)throw new Error("Expected not to be null");return e}}},{}],201:[function(e,t,n){t.exports=[{label:"Prebid JS",patterns:["^https?://([^.]*.)?prebid[.]org/.*","^https?://acdn[.]adnxs[.]com/prebid/.*"]},{label:"33Across",patterns:["^https?://ssc[.]33across.com/api/.*"]},{label:"AppNexus",patterns:["^https?://ib[.]adnxs[.]com/.*"]},{label:"Amazon Ads",patterns:["^https?://[a-z-_.]*[.]amazon-adsystem[.]com/.*bid.*"]},{
label:"AdTechus (AOL)",patterns:["^https?://([^.]*.)?adserver[.]adtechus[.]com/.*"]},{label:"Aardvark",patterns:["^https?://thor[.]rtk[.]io/.*"]},{label:"AdBlade",patterns:["^https?://rtb[.]adblade[.]com/prebidjs/bid.*"]},{label:"AdBund",patterns:["^https?://us-east-engine[.]adbund[.]xyz/prebid/ad/get.*","^https?://us-west-engine[.]adbund[.]xyz/prebid/ad/get.*"]},{label:"AdButler",patterns:["^https?://servedbyadbutler[.]com/adserve.*"]},{label:"Adequant",patterns:["^https?://rex[.]adequant[.]com/rex/c2s_prebid.*"]},{label:"AdForm",patterns:["^https?://adx[.]adform[.]net/adx.*"]},{label:"AdMedia",patterns:["^https?://b[.]admedia[.]com/banner/prebid/bidder.*"]},{label:"AdMixer",patterns:["^https?://inv-nets[.]admixer[.]net/prebid[.]aspx.*","^https?://inv-nets[.]admixer[.]net/videoprebid[.]aspx.*"]},{label:"AOL",
patterns:["^https?://adserver-us[.]adtech[.]advertising[.]com.*","^https?://adserver-eu[.]adtech[.]advertising[.]com.*","^https?://adserver-as[.]adtech[.]advertising[.]com.*","^https?://adserver[.]adtech[.]de/pubapi/.*"]},{label:"Beachfront",patterns:["^https?://reachms[.]bfmio[.]com/bid[.]json?exchange_id=.*"]},{label:"Bidfluence",patterns:["^https?://cdn[.]bidfluence[.]com/forge[.]js.*"]},{label:"Brightcom",patterns:["^https?://hb[.]iselephant[.]com/auc/ortb.*"]},{label:"C1x",patterns:["^https?://ht-integration[.]c1exchange[.]com:9000/ht.*"]},{label:"CentroBid",patterns:["^https?://t[.]brand-server[.]com/hb.*"]},{label:"Conversant",patterns:["^https?://media[.]msg[.]dotomi[.]com/s2s/.*"]},{label:"Criteo",patterns:["^https?://static[.]criteo[.]net/js/ld/publishertag[.]js.*","^https?://([^.]*.)?bidder[.]criteo[.]com/cdb.*","^https?://([^.]*.)?rtax[.]criteo[.]com/delivery/rta.*","^https?://([^.]*.)?rtax[.]eu[.]criteo[.]com/delivery/rta.*"]},{label:"Datablocks",
patterns:["^https?://[a-z0-9_.-]*[.]dblks[.]net/.*"]},{label:"Districtm",patterns:["^https?://prebid[.]districtm[.]ca/lib[.]js.*"]},{label:"E-Planning",patterns:["^https?://ads[.]us[.]e-planning[.]net.*"]},{label:"Essens",patterns:["^https?://bid[.]essrtb[.]com/bid/prebid_call.*"]},{label:"Facebook",patterns:["^https?://an[.]facebook[.]com/v2/placementbid[.]json.*"]},{label:"FeatureForward",patterns:["^https?://prmbdr[.]featureforward[.]com/newbidder/.*"]},{label:"Fidelity",patterns:["^https?://x[.]fidelity-media[.]com.*"]},{label:"GetIntent",patterns:["^https?://px[.]adhigh[.]net/rtb/direct_banner.*","^https?://px[.]adhigh[.]net/rtb/direct_vast.*"]},{label:"GumGum",patterns:["^https?://g2[.]gumgum[.]com/hbid/imp.*"]},{label:"Hiromedia",patterns:["^https?://hb-rtb[.]ktdpublishers[.]com/bid/get.*"]},{label:"Imonomy",patterns:["^https?://b[.]imonomy[.]com/openrtb/hb/.*"]},{label:"ImproveDigital",patterns:["^https?://ad[.]360yield[.]com/hb.*"]},{label:"IndexExchange",
patterns:["^https?://as(-sec)?[.]casalemedia[.]com/(cygnus|headertag).*","^https?://js(-sec)?[.]indexww[.]com/ht/.*"]},{label:"InnerActive",patterns:["^https?://ad-tag[.]inner-active[.]mobi/simpleM2M/requestJsonAd.*"]},{label:"Innity",patterns:["^https?://as[.]innity[.]com/synd/.*"]},{label:"JCM",patterns:["^https?://media[.]adfrontiers[.]com/pq.*"]},{label:"JustPremium",patterns:["^https?://pre[.]ads[.]justpremium[.]com/v/.*"]},{label:"Kargo",patterns:["^https?://krk[.]kargo[.]com/api/v1/bid.*"]},{label:"Komoona",patterns:["^https?://bidder[.]komoona[.]com/v1/GetSBids.*"]},{label:"KruxLink",patterns:["^https?://link[.]krxd[.]net/hb.*"]},{label:"Kumma",patterns:["^https?://cdn[.]kumma[.]com/pb_ortb[.]js.*"]},{label:"Mantis",patterns:["^https?://mantodea[.]mantisadnetwork[.]com/website/prebid.*"]},{label:"MarsMedia",patterns:["^https?://bid306[.]rtbsrv[.]com:9306/bidder.*"]},{label:"Media.net",patterns:["^https?://contextual[.]media[.]net/bidexchange.*"]},{label:"MemeGlobal",
patterns:["^https?://stinger[.]memeglobal[.]com/api/v1/services/prebid.*"]},{label:"MobFox",patterns:["^https?://my[.]mobfox[.]com/request[.]php.*"]},{label:"NanoInteractive",patterns:["^https?://tmp[.]audiencemanager[.]de/hb.*"]},{label:"OpenX",patterns:["^https?://([^.]*.)?d[.]openx[.]net/w/1[.]0/arj.*","^https?://([^.]*.)?servedbyopenx[.]com/.*"]},{label:"Piximedia",patterns:["^https?://static[.]adserver[.]pm/prebid.*"]},{label:"Platformio",patterns:["^https?://piohbdisp[.]hb[.]adx1[.]com.*"]},{label:"Pollux",patterns:["^https?://adn[.]plxnt[.]com/prebid.*"]},{label:"PubGears",patterns:["^https?://c[.]pubgears[.]com/tags.*"]},{label:"Pubmatic",patterns:["^https?://ads[.]pubmatic[.]com/AdServer/js/gshowad[.]js.*","^https?://([^.]*.)?gads.pubmatic[.]com/.*","^https?://hbopenbid.pubmatic[.]com/.*"]},{label:"Pulsepoint",patterns:["^https?://bid[.]contextweb[.]com/header/tag.*"]},{label:"Quantcast",patterns:["^https?://global[.]qc[.]rtb[.]quantserve[.]com:8080/qchb.*"]},{
label:"Rhythmone",patterns:["^https?://tag[.]1rx[.]io/rmp/.*"]},{label:"Roxot",patterns:["^https?://r[.]rxthdr[.]com.*"]},{label:"Rubicon",patterns:["^https?://([^.]*.)?(fastlane|optimized-by|anvil)[.]rubiconproject[.]com/a/api.*","^https?://fastlane-adv[.]rubiconproject[.]com/v1/auction/video.*"]},{label:"Sekindo",patterns:["^https?://hb[.]sekindo[.]com/live/liveView[.]php.*"]},{label:"ShareThrough",patterns:["^https?://btlr[.]sharethrough[.]com/header-bid/.*"]},{label:"Smart AdServer",patterns:["^https?://prg[.]smartadserver[.]com/prebid.*"]},{label:"Sonobi",patterns:["^https?://apex[.]go[.]sonobi[.]com/trinity[.]js.*"]},{label:"Sovrn",patterns:["^https?://ap[.]lijit[.]com/rtb/bid.*"]},{label:"SpringServe",patterns:["^https?://bidder[.]springserve[.]com/display/hbid.*"]},{label:"StickyAds",patterns:["^https?://cdn[.]stickyadstv[.]com/mustang/mustang[.]min[.]js.*","^https?://cdn[.]stickyadstv[.]com/prime-time/.*"]},{label:"TapSense3",
patterns:["^https?://ads04[.]tapsense[.]com/ads/headerad.*"]},{label:"ThoughtLeadr",patterns:["^https?://a[.]thoughtleadr[.]com/v4/.*"]},{label:"TremorBid",patterns:["^https?://([^.]*.)?ads[.]tremorhub[.]com/ad/tag.*"]},{label:"Trion",patterns:["^https?://in-appadvertising[.]com/api/bidRequest.*"]},{label:"TripleLift",patterns:["^https?://tlx[.]3lift[.]com/header/auction.*"]},{label:"TrustX",patterns:["^https?://sofia[.]trustx[.]org/hb.*"]},{label:"UCFunnel",patterns:["^https?://agent[.]aralego[.]com/header.*"]},{label:"Underdog Media",patterns:["^https?://udmserve[.]net/udm/img[.]fetch.*"]},{label:"UnRuly",patterns:["^https?://targeting[.]unrulymedia[.]com/prebid.*"]},{label:"VertaMedia",patterns:["^https?://rtb[.]vertamedia[.]com/hb/.*"]},{label:"Vertoz",patterns:["^https?://hb[.]vrtzads[.]com/vzhbidder/bid.*"]},{label:"WideOrbig",patterns:["^https?://([^.]*.)?atemda[.]com/JSAdservingMP[.]ashx.*"]},{label:"WideSpace",patterns:["^https?://engine[.]widespace[.]com/map/engine/hb/.*"]},{
label:"YieldBot",patterns:["^https?://cdn[.]yldbt[.]com/js/yieldbot[.]intent[.]js.*"]},{label:"YieldMo",patterns:["^https?://ads[.]yieldmo[.]com/exchange/prebid.*"]}]},{}],202:[function(e,t,n){function isBoxInViewport(e,t){const{innerWidth:n,innerHeight:i}=t,{left:a,top:s,right:c,bottom:l}=e;return a<c&&s<l&&a<n&&s<i&&0<c&&0<l}t.exports={boxViewableArea:function boxViewableArea(e,t){if(!isBoxInViewport(e,t))return 0;const{innerWidth:n,innerHeight:i}=t,{left:a,top:s,right:c,bottom:l}=e;return(Math.min(c,n)-Math.max(a,0))*(Math.min(l,i)-Math.max(s,0))},isBoxInViewport,overlaps:function overlaps(e,t){const n=!(e.right<t.left||t.right<e.left),i=!(e.bottom<t.top||t.bottom<e.top);return n&&i},toClientRect:function toClientRect([e,t,n,i]){return{left:e,top:t,width:n,height:i,right:e+n,bottom:t+i}}}},{}],203:[function(e,t,n){const i=e("lighthouse/lighthouse-core/lib/dependency-graph/base-node"),a=(e("lighthouse/lighthouse-core/lib/dependency-graph/cpu-node.js"),
e("lighthouse/lighthouse-core/lib/dependency-graph/network-node.js"),e("lighthouse/lighthouse-core/computed/network-records")),{assert:s}=e("./asserts"),{getNameOrTld:c,trimUrl:l}=e("../utils/resource-classification"),{getNetworkInitiators:u}=e("lighthouse/lighthouse-core/computed/page-dependency-graph"),{getTimingsByRecord:d}=e("../utils/network-timing"),{isAdRequest:m,isAdSense:p,isGpt:h,getHeaderBidder:f}=e("./resource-classification");function isXhrCritical(e,t,n){const i=t.xhrEdges.get(e.url);if(!i)return!1;for(const{url:e}of n)if(i.has(e))return!0;return!1}function addInitiatedRequests(e,t,n,i){const a=n.allRecords.filter((e=>null!=e.resourceType)).filter((e=>["Script","XHR"].includes(e.resourceType||"")&&e.endTime<t.startTime)).filter((t=>t.initiatorRequest==e||u(t).includes(e.url)));for(const e of a){"XHR"==e.resourceType&&isXhrCritical(e,n,i)&&linkGraph(n,e,i)}}function linkGraph(e,t,n=new Set){if(!t||n.has(t))return n;n.add(t);const i=new Set
;for(let a=t.initiator.stack;a;a=a.parent)for(const{url:s}of a.callFrames){if(i.has(s))continue;i.add(s);const c=e.requestsByUrl.get(s);if(c&&(linkGraph(e,c,n),"Script"==c.resourceType)){const i=a.callFrames[0].url,s=e.requestsByUrl.get(i);s&&addInitiatedRequests(s,t,e,n)}}return linkGraph(e,t.initiatorRequest||null,n),n}function buildNetworkSummary(e,t){const n=new Map;for(const t of e)n.set(t.url,t);const i=t.filter((e=>e.name.startsWith("XHR"))).filter((e=>!!(e.args.data||{}).url)),a=new Map;for(const e of i){const t=e.args.data||{},n=a.get(t.url)||new Set;for(const{url:e}of t.stackTrace||[])n.add(e);a.set(t.url,n)}return{requestsByUrl:n,xhrEdges:a,allRecords:e}}t.exports={getTransitiveClosure:function getTransitiveClosure(e,t){const n=new Set,a=function findTargetRequest(e,t){let n=null;return e.traverse((e=>{e.type!==i.TYPES.CPU&&t(e.record)&&(n&&n.startTime<e.startTime||(n=e))})),n}(e,t),c=[],l=[];if(null==a)return{requests:c,traceEvents:l};const u=[a];for(;u.length;){
const e=u.pop();e&&!n.has(e)&&(n.add(e),u.push(...e.getDependencies()))}const d=new Set;for(u.push(...e.getDependents());u.length;){const e=u.pop();if(e&&!d.has(e)){if(d.add(e),n.has(e))for(const e of u)n.add(e);u.push(...e.getDependents())}}for(const e of n)e.type===i.TYPES.NETWORK?e.endTime<s(a).startTime&&c.push(e.record):e.type===i.TYPES.CPU&&e.event.ts<1e6*s(a).startTime&&l.push(e.event,...e.childEvents);return{requests:c,traceEvents:l}},getCriticalGraph:function getCriticalGraph(e,t,n){const i=buildNetworkSummary(e,t),a=new Set;return linkGraph(i,n,a),a},computeAdRequestWaterfall:async function computeAdRequestWaterfall(e,t,n){const i=await a.request(t,n),u=i.find(m);if(null==u)return Promise.resolve([]);const g=new Set,y=s(u),b=i.filter((e=>h(e.url)||p(e.url))),v=i.filter((e=>!!f(e.url)&&e.endTime<=y.startTime)),w=buildNetworkSummary(i,e.traceEvents);for(const e of[y,...v,...b])linkGraph(w,e,g)
;const S=new Set(["Script","XHR","Fetch","EventStream","Document",void 0]),T=Array.from(g).filter((e=>e.endTime<y.startTime)).filter((e=>S.has(e.resourceType))).filter((e=>"text/css"!=e.mimeType)),E=await d(e,t,n),_=function computeSummaries(e){e.sort(((e,t)=>e.nameOrTld!=t.nameOrTld?e.nameOrTld<t.nameOrTld?-1:1:e.type!=t.type?e.type<t.type?-1:1:e.startTime!=t.startTime?e.startTime<t.startTime?-1:1:e.endTime-t.endTime));const t=[];for(let a=0;a<e.length;a++){const s=e[a];let c;for(;a<e.length&&(c=e[a+1],c&&(n=c,i=s,!(Math.max(n.startTime,i.startTime)>Math.min(n.endTime,i.endTime)||n.type&&i.type&&n.type!=i.type||"Script"==n.type||n.nameOrTld!=i.nameOrTld)));)s.endTime=Math.max(s.endTime,c.endTime),s.duration=s.endTime-s.startTime,a++;t.push(s)}var n,i;return t.sort(((e,t)=>e.startTime-t.startTime)),t}(T.map((e=>{const{startTime:t,endTime:n}=E.get(e)||e;return{startTime:t,endTime:n,duration:n-t,selfTime:0,url:l(e.url),nameOrTld:c(e.url),type:e.resourceType,record:e}})))
;return function computeSelfTimes(e){if(!e.length)return[];let t=s(e[0]);t.selfTime=t.duration;let n=t.startTime;for(const i of e){if(i.endTime<n||i==t)continue;const e=Math.max(n,i.startTime),a=Math.min(t.endTime,i.endTime);e<a&&(t.selfTime-=a-e),n=Math.max(n,a),i.endTime>t.endTime&&(i.selfTime=i.endTime-e,t=i)}}(_),_}}},{"../utils/network-timing":204,"../utils/resource-classification":206,"./asserts":200,"./resource-classification":206,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/computed/page-dependency-graph":41,"lighthouse/lighthouse-core/lib/dependency-graph/base-node":88,"lighthouse/lighthouse-core/lib/dependency-graph/cpu-node.js":89,"lighthouse/lighthouse-core/lib/dependency-graph/network-node.js":90}],204:[function(e,t,n){
const i=e("../computed/ad-lantern-metric"),a=e("lighthouse/lighthouse-core/computed/load-simulator"),s=e("lighthouse/lighthouse-core/computed/network-records"),c=e("lighthouse/lighthouse-core/computed/page-dependency-graph"),{isAdRequest:l,isBidRequest:u,isImplTag:d,isImpressionPing:m}=e("./resource-classification"),{URL:p}=e("url");function getPageStartTime(e,t=-1){const n=e.find((e=>200==e.statusCode));return n?n.startTime:t}async function getTimingsByRecord(e,t,n){const l=new Map,u=await s.request(t,n);if("simulate"==n.settings.throttlingMethod){const s=await c.request({trace:e,devtoolsLog:t},n),u=i.getOptimisticGraph(s),d=await a.request({devtoolsLog:t,settings:n.settings},n),{nodeTimings:m}=d.simulate(u,{});for(const[{record:e},t]of m.entries())e&&l.set(e,t)}else{const e=getPageStartTime(u);for(const t of u)l.set(t,{startTime:1e3*(t.startTime-e),endTime:1e3*(t.endTime-e),duration:1e3*(t.endTime-t.startTime)})}return l}function getScriptUrl(e){
if(e.args.data&&["EvaluateScript","FunctionCall"].includes(e.name))return e.args.data.url?e.args.data.url:e.args.data.stackTrace?e.args.data.stackTrace[0].url:void 0}t.exports={getTagEndTime:function getTagEndTime(e){const t=e.find((e=>d(new p(e.url))));return t?t.endTime:-1},getImpressionStartTime:function getImpressionStartTime(e){const t=e.find((e=>m(e.url)));return t?t.startTime:-1},getAdStartTime:function getAdStartTime(e){const t=e.find(l);return t?t.startTime:-1},getBidStartTime:function getBidStartTime(e){const t=e.find(u);return t?t.startTime:-1},getPageStartTime,getPageResponseTime:function getPageResponseTime(e,t=-1){const n=e.find((e=>200==e.statusCode));return n?n.responseReceivedTime:t},getScriptUrl,getTimingsByRecord,getScriptEvaluationTimes:async function getScriptEvaluationTimes(e,t,n){const i=1e3*getPageStartTime(await s.request(t,n)),a=new Map;for(const t of e.traceEvents){const e=getScriptUrl(t);if(!e)continue;const n=t.ts/1e3-i;(!a.has(e)||a.get(e)>n)&&a.set(e,n)}
if("simulate"!==n.settings.throttlingMethod)return a;const c=await getTimingsByRecord(e,t,n),l=new Map;for(const[e,t]of c.entries()){const s=a.get(e.url);if(!s)continue;if(l.has(e.url))continue;const c=1e3*e.startTime-i,u=t.endTime,d=n.settings.throttling.cpuSlowdownMultiplier*(s-c);l.set(e.url,u+d)}return l}}},{"../computed/ad-lantern-metric":192,"./resource-classification":206,"lighthouse/lighthouse-core/computed/load-simulator":13,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/computed/page-dependency-graph":41,url:"url"}],205:[function(e,t,n){const i=e("lighthouse/lighthouse-core/audits/byte-efficiency/uses-long-cache-ttl"),{parse:a}=e("@tusbar/cache-control");function getHeader(e,t){const n=t.toLowerCase();return(e.responseHeaders||[]).find((e=>e.name.toLowerCase()===n))}t.exports={isCacheable:function isCacheable(e){if(!i.isCacheableAsset(e))return!1;const t=getHeader(e,"cache-control");if(t){try{const e=a(t.value)
;if(e.noStore||e.noCache||0===e.maxAge)return!1}catch(e){}return!0}return!!getHeader(e,"expires")||!!getHeader(e,"last-modified")}}},{"@tusbar/cache-control":125,"lighthouse/lighthouse-core/audits/byte-efficiency/uses-long-cache-ttl":"../audits/byte-efficiency/uses-long-cache-ttl"}],206:[function(e,t,n){const i=e("./bidder-patterns"),a=e("lighthouse/lighthouse-core/lib/third-party-web"),{isCacheable:s}=e("../utils/network"),{URL:c}=e("url");function toURL(e){let t;try{t="string"==typeof e?new c(e):e}catch(e){t=new c("http://_")}return t}function isGoogleAds(e){return e=toURL(e),/(^|\.)(doubleclick.net|google(syndication|tagservices).com)$/.test(e.hostname)}function isAdSenseTag(e){const t="pagead2.googlesyndication.com"===(e=toURL(e)).host,n=["/pagead/js/adsbygoogle.js","/pagead/show_ads.js"].includes(e.pathname);return t&&n}function isAdSenseImplTag(e){const t="pagead2.googlesyndication.com"===(e=toURL(e)).host,n=/(^\/pagead\/js\/.*\/show_ads_impl.*?\.js)/.test(e.pathname);return t&&n
}function isAdSense(e){return isAdSenseTag(e=toURL(e))||isAdSenseImplTag(e)}function isAdSenseAdRequest(e){if(!e)return!1;const t=new c(e.url);return"/pagead/ads"===t.pathname&&"googleads.g.doubleclick.net"===t.host}function isAdSenseIframe(e){return/(^aswift_\d+)/.test(e.id)}function isGptTag(e){const{host:t,pathname:n}=toURL(e),i=["www.googletagservices.com","pagead2.googlesyndication.com","securepubads.g.doubleclick.net"].includes(t),a=["/tag/js/gpt.js","/tag/js/gpt_mobile.js"].includes(n);return i&&a}function isAMPTag(e){const{host:t,pathname:n}=toURL(e),i=["cdn.ampproject.org"].includes(t),a=["/v0/amp-ad-0.1.js"].includes(n);return i&&a}function isGptImplTag(e){return isGoogleAds(e)&&/(^\/gpt\/pubads_impl([a-z_]*)((?<!rendering)_)\d+\.js)/.test(toURL(e).pathname)}function isAMPImplTag(e){return/^\/[a-z_]*\/\d+\/v0\/amp-ad-network-doubleclick-impl-0.1.js/.test(toURL(e).pathname)}function isGpt(e){return isGptTag(e=toURL(e))||isGptImplTag(e)}function isGptAdRequest(e){if(!e)return!1
;return"/gampad/ads"===new c(e.url).pathname&&"XHR"===e.resourceType&&isGoogleAds(e.url)}function isAMPAdRequest(e){if(!e)return!1;const t=new c(e.url);return"/gampad/ads"===t.pathname&&"securepubads.g.doubleclick.net"===t.host&&"Fetch"===e.resourceType}function isGptIframe(e){return/(^google_ads_iframe_)/.test(e.id)}function getHeaderBidder(e){for(const t of i)for(const n of t.patterns)if(new RegExp(n).test(e))return t.label}function isBidRelatedRequest(e){return!!getHeaderBidder("string"==typeof e?e:e.url)}t.exports={isGoogleAds,isGptAdRequest,isImpressionPing:function isImpressionPing(e){const{host:t,pathname:n}=toURL(e);return["securepubads.g.doubleclick.net","googleads4.g.doubleclick.net"].includes(t)&&["/pcs/view","/pagead/adview"].includes(n)},isGpt,isAdSense,isAdSenseTag,isAdSenseImplTag,isAdSenseAdRequest,isAdSenseIframe,isGptTag,isGptImplTag,isGptIframe,isAdTag:function isAdTag(e){return isAdSenseTag(e)||isGptTag(e)||isAMPTag(e)},isAdScript:function isAdScript(e){
return isAdSense(e)||isGpt(e)||function isAMP(e){return isAMPTag(e)||isAMPImplTag(e)}(e)},isAdRequest:function isAdRequest(e){return isAdSenseAdRequest(e)||isGptAdRequest(e)||isAMPAdRequest(e)},isAdIframe:function isAdIframe(e){return isAdSenseIframe(e)||isGptIframe(e)},isImplTag:function isImplTag(e){return isAdSenseTag(e)||isGptImplTag(e)||isAMPImplTag(e)},containsAnySubstring:function containsAnySubstring(e,t){return t.some((t=>e.includes(t)))},hasImpressionPath:function hasImpressionPath(e){return"/pcs/view"===e.pathname||"/pagead/adview"===e.pathname},getHeaderBidder,isBidRelatedRequest,isBidRequest:function isBidRequest(e){return isBidRelatedRequest(e)&&function isPossibleBidRequest(e){return(null==e.resourceSize||e.resourceSize>0)&&"Image"!=e.resourceType&&!s(e)}(e)},isStaticRequest:function isStaticRequest(e){return["parser","preload","other"].includes(e.initiator.type)},toURL,trimUrl:function trimUrl(e){
const t=new c(e),n=t.pathname.length>60?t.pathname.substr(0,60)+"...":t.pathname;return t.origin+n},getNameOrTld:function getNameOrTld(e){const t=getHeaderBidder(e);if(t)return t;if(isGpt(e))return"GPT";if(isAdSense(e))return"AdSense";if(isAMPTag(e))return"AMP tag";const n=a.getEntity(e);if(n)return n.name;const{host:i}=new c(e),[s=""]=i.match(/([^.]*(\.[a-z]{2,3}){1,2})$/)||[];return s||i},isAMPTag,isAMPAdRequest}},{"../utils/network":205,"./bidder-patterns":201,"lighthouse/lighthouse-core/lib/third-party-web":116,url:"url"}],207:[function(e,t,n){t.exports={getAttributableUrl:function getAttributableUrl(e,t=new Set){const n=e.attributableURLs.find((e=>t.has(e))),i=e.attributableURLs[0],a=n||i;if(a)return a;let s=50,c="";for(const n of e.children){const e=getAttributableUrl(n,t);e&&n.duration>s&&(c=e,s=n.duration)}return c}}},{}],208:[function(e,t,n){
const i=[e("./packs/wordpress.js"),e("./packs/drupal.js"),e("./packs/react.js"),e("./packs/angular.js"),e("./packs/amp.js"),e("./packs/magento.js"),e("./packs/joomla.js"),e("./packs/octobercms.js")];t.exports=i},{"./packs/amp.js":209,"./packs/angular.js":210,"./packs/drupal.js":211,"./packs/joomla.js":212,"./packs/magento.js":213,"./packs/octobercms.js":214,"./packs/react.js":215,"./packs/wordpress.js":216}],209:[function(e,t,n){t.exports={id:"amp",title:"AMP",icon:'data:image/svg+xml,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 256 256"%3E%3Cpath d="M171.887 116.28l-53.696 89.36h-9.728l9.617-58.227-30.2.047a4.852 4.852 0 01-4.855-4.855c0-1.152 1.07-3.102 1.07-3.102l53.52-89.254 9.9.043-9.86 58.317 30.413-.043a4.852 4.852 0 014.855 4.855c0 1.088-.427 2.044-1.033 2.854l.004.004zM128 0C57.306 0 0 57.3 0 128s57.306 128 128 128 128-57.306 128-128S198.7 0 128 0z" fill="%230379c4" fill-rule="evenodd"/%3E%3C/svg%3E',UIStrings:{
"modern-image-formats":"Consider displaying all [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) components in WebP formats while specifying an appropriate fallback for other browsers. [Learn more](https://amp.dev/documentation/components/amp-img/#example:-specifying-a-fallback-image).","offscreen-images":"Ensure that you are using [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) for images to automatically lazy-load. [Learn more](https://amp.dev/documentation/guides-and-tutorials/develop/media_iframes_3p/?format=websites#images).","render-blocking-resources":"Use tools such as [AMP Optimizer](https://github.com/ampproject/amp-toolbox/tree/master/packages/optimizer) to [server-side render AMP layouts](https://amp.dev/documentation/guides-and-tutorials/optimize-and-measure/server-side-rendering/).",
"unminified-css":"Refer to the [AMP documentation](https://amp.dev/documentation/guides-and-tutorials/develop/style_and_layout/style_pages/) to ensure all styles are supported.","efficient-animated-content":"For animated content, use [`amp-anim`](https://amp.dev/documentation/components/amp-anim/) to minimize CPU usage when the content is offscreen.","uses-responsive-images":"The [`amp-img`](https://amp.dev/documentation/components/amp-img/?format=websites) component supports the [`srcset`](https://web.dev/use-srcset-to-automatically-choose-the-right-image/) attribute to specify which image assets to use based on the screen size. [Learn more](https://amp.dev/documentation/guides-and-tutorials/develop/style_and_layout/art_direction/)."}}},{}],210:[function(e,t,n){t.exports={id:"angular",title:"Angular",
icon:'data:image/svg+xml,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 250 250"%3E%3Cpath fill="%23dd0031" d="M125 30L31.9 63.2l14.2 123.1L125 230l78.9-43.7 14.2-123.1z"/%3E%3Cpath fill="%23c3002f" d="M125 30v22.2-.1V230l78.9-43.7 14.2-123.1L125 30z"/%3E%3Cpath d="M125 52.1L66.8 182.6h21.7l11.7-29.2h49.4l11.7 29.2H183L125 52.1zm17 83.3h-34l17-40.9 17 40.9z" fill="%23fff"/%3E%3C/svg%3E',UIStrings:{"total-byte-weight":"Apply [route-level code splitting](https://web.dev/route-level-code-splitting-in-angular/) to minimize the size of your JavaScript bundles. Also, consider precaching assets with the [Angular service worker](https://web.dev/precaching-with-the-angular-service-worker/).","unminified-warning":"If you are using Angular CLI, ensure that builds are generated in production mode. [Learn more](https://angular.io/guide/deployment#enable-runtime-production-mode).",
"unused-javascript":"If you are using Angular CLI, include source maps in your production build to inspect your bundles. [Learn more](https://angular.io/guide/deployment#inspect-the-bundles).","uses-responsive-images":"Consider using the `BreakpointObserver` utility in the Component Dev Kit (CDK) to manage image breakpoints. [Learn more](https://material.angular.io/cdk/layout/overview).","uses-rel-preload":"Preload routes ahead of time to speed up navigation. [Learn more](https://web.dev/route-preloading-in-angular/).","dom-size":"Consider virtual scrolling with the Component Dev Kit (CDK) if very large lists are being rendered. [Learn more](https://web.dev/virtualize-lists-with-angular-cdk/)."}}},{}],211:[function(e,t,n){t.exports={id:"drupal",title:"Drupal",
icon:'data:image/svg+xml,%3Csvg viewBox="0 0 681.167 778.583" xmlns="http://www.w3.org/2000/svg"%3E%3Cpath style="fill:%2300598E" d="M510.167 144.833c-39.75-24.75-77.25-34.5-114.75-59.25c-23.25-15.75-55.5-53.25-82.5-85.5c-5.25 51.75-21 72.75-39 87.75c-38.25 30-62.25 39-95.25 57c-27.75 14.25-178.5 104.25-178.5 297.75s162.75 336 343.5 336s337.5-131.25 337.5-330S534.167 159.833 510.167 144.833z" /%3E%3Cpath style="fill:%23FFF" d="M449.25 610.5c12 0 24.75 0.75 33.75 6.75s14.25 19.5 17.25 27s0 12-6 15c-5.25 3-6 1.5-11.25-8.25s-9.75-19.5-36-19.5s-34.5 9-47.25 19.5s-17.25 14.25-21.75 8.25s-3-12 5.25-19.5s21.75-19.5 34.5-24.75S437.25 610.5 449.25 610.5L449.25 610.5z" /%3E%3Cpath style="fill:%23FFF" d="M324.75 696c15 12 37.5 21.75 85.5 21.75S492 704.25 507 693c6.75-5.25 9.75-0.75 10.5 2.25s2.25 7.5-3 12.75c-3.75 3.75-38.25 27.75-78.75 31.5s-95.25 6-128.25-24c-5.25-5.25-3.75-12.75 0-15.75s6.75-5.25 11.25-5.25S322.5 694.5 324.75 696L324.75 696z" /%3E%3Cpath style="fill:%230073BA" d="M141 639c57-0.75 67.5-10.5 117.75-33c271.5-121.5 321.75-232.5 331.5-258s24-66.75 9-112.5c-2.896-8.832-5.006-15.924-6.53-21.63c-36.079-40.343-71.898-62.357-82.72-69.12c-39-24.75-77.25-34.5-114.75-59.25c-23.25-15-55.5-53.25-82.5-85.5c-5.25 51.75-20.25 73.5-39 87.75c-38.25 30-62.25 39-95.25 57C150.75 159.75 0 249 0 442.5c0 61.78 16.593 118.361 45.063 166.766L52.5 609C68.25 623.25 93 639.75 141 639z" /%3E%3Cpath style="fill:%23004975" d="M510 144.75c-39-24.75-77.25-34.5-114.75-59.25c-23.25-15-55.5-53.25-82.5-85.5c-5.25 51.75-20.25 73.5-39 87.75c-38.25 30-62.25 39-95.25 57C150.75 159.75 0 249 0 442.5c0 61.78 16.593 118.361 45.063 166.766C105.763 712.467 220.46 778.5 343.5 778.5c180.75 0 337.5-131.25 337.5-330c0-109.146-44.332-185.488-88.28-234.63C556.641 173.527 520.82 151.513 510 144.75z M601.164 232.547c49.242 61.564 74.211 134.221 74.211 215.953c0 47.428-9.033 92.23-26.849 133.165c-16.9 38.831-41.236 73.233-72.333 102.254c-61.47 57.364-144.107 88.956-232.693 88.956c-43.826 0-86.832-8.371-127.824-24.882c-40.263-16.217-76.547-39.438-107.843-69.02C41.923 616.678 5.625 532.696 5.625 442.5c0-80.336 26.076-151.72 77.503-212.167c39.289-46.18 81.655-71.774 98.047-80.634c7.958-4.341 15.423-8.172 22.643-11.877c22.63-11.615 44.005-22.586 73.404-45.645c15.677-11.914 32.377-30.785 39.489-78.702c24.774 29.466 53.522 62.579 75.49 76.752c19.5 12.87 39.501 21.888 58.844 30.61c18.298 8.25 37.219 16.781 55.942 28.663c0.031 0.021 0.702 0.438 0.702 0.438C562.421 184.11 591.581 220.566 601.164 232.547z" /%3E%3Cpath style="fill:%2393C5E4" d="M316.5 15c10.5 30.75 9 46.5 9 53.25S321.75 93 309.75 102c-5.25 3.75-6.75 6.75-6.75 7.5c0 3 6.75 5.25 6.75 12c0 8.25-3.75 24.75-43.5 64.5s-96.75 75-141 96.75S60 303 54 292.5s2.25-33.75 30-64.5s115.5-75 115.5-75L309 76.5l6-29.25" /%3E%3Cpath style="fill:%23FFF" d="M316.5 14.25c-6.75 49.5-21.75 64.5-42 80.25c-33.75 25.5-66.75 41.25-74.25 45c-19.5 9.75-90 48.75-126.75 105c-11.25 17.25 0 24 2.25 25.5s27.75 4.5 82.5-28.5S237 189 267.75 156.75c16.5-17.25 18.75-27 18.75-31.5c0-5.25-3.75-7.5-9.75-9c-3-0.75-3.75-2.25 0-4.5S296.25 102 300 99s21.75-15 22.5-34.5S321.75 31.5 316.5 14.25L316.5 14.25z" /%3E%3Cpath style="fill:%23FFF" d="M147.75 559.5c0.75-58.5 55.5-113.25 124.5-114c87.75-0.75 148.5 87 192.75 86.25c37.5-0.75 109.5-74.25 144.75-74.25c37.5 0 48 39 48 62.25s-7.5 65.25-25.5 91.5s-29.25 36-50.25 34.5c-27-2.25-81-86.25-115.5-87.75c-43.5-1.5-138 90.75-212.25 90.75c-45 0-58.5-6.75-73.5-16.5C158.25 616.5 147 592.5 147.75 559.5L147.75 559.5z" /%3E%3Cpath style="fill:none" d="M599.25 235.5c15 45.75 0.75 87-9 112.5s-60 136.5-331.5 258C208.5 628.5 198 638.25 141 639c-48 0.75-72.75-15.75-88.5-30l-7.437 0.266C105.763 712.467 220.46 778.5 343.5 778.5c180.75 0 337.5-131.25 337.5-330c0-109.146-44.332-185.488-88.28-234.63C594.244 219.576 596.354 226.668 599.25 235.5z" /%3E%3C/svg%3E',
UIStrings:{"unused-css-rules":"Consider removing unused CSS rules and only attach the needed Drupal libraries to the relevant page or component in a page. See the [Drupal documentation link](https://www.drupal.org/docs/8/creating-custom-modules/adding-stylesheets-css-and-javascript-js-to-a-drupal-8-module#library) for details. To identify attached libraries that are adding extraneous CSS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/module responsible from the URL of the stylesheet when CSS aggregation is disabled in your Drupal site. Look out for themes/modules that have many stylesheets in the list which have a lot of red in code coverage. A theme/module should only enqueue a stylesheet if it is actually used on the page.",
"unused-javascript":"Consider removing unused JavaScript assets and only attach the needed Drupal libraries to the relevant page or component in a page. See the [Drupal documentation link](https://www.drupal.org/docs/8/creating-custom-modules/adding-stylesheets-css-and-javascript-js-to-a-drupal-8-module#library) for details. To identify attached libraries that are adding extraneous JavaScript, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/module responsible from the URL of the script when JavaScript aggregation is disabled in your Drupal site. Look out for themes/modules that have many scripts in the list which have a lot of red in code coverage. A theme/module should only enqueue a script if it is actually used on the page.",
"modern-image-formats":"Consider installing and configuring [a module to leverage WebP image formats](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=webp&solrsort=iss_project_release_usage+desc&op=Search) in your site. Such modules automatically generate a WebP version of your uploaded images to optimize loading times.","offscreen-images":"Install [a Drupal module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A67&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=%22lazy+load%22&solrsort=iss_project_release_usage+desc&op=Search) that can lazy load images. Such modules provide the ability to defer any offscreen images to improve performance.",
"total-byte-weight":"Consider using [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) to reduce the size of images loaded on your page. If you are using Views to show multiple content items on a page, consider implementing pagination to limit the number of content items shown on a given page.","render-blocking-resources":"Consider using a module to inline critical CSS and JavaScript, or potentially load assets asynchronously via JavaScript such as the [Advanced CSS/JS Aggregation](https://www.drupal.org/project/advagg) module. Beware that optimizations provided by this module may break your site, so you will likely need to make code changes.",
"unminified-css":'Ensure you have enabled "Aggregate CSS files" in the "Administration » Configuration » Development" page. You can also configure more advanced aggregation options through [additional modules](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A123&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=css+aggregation&solrsort=iss_project_release_usage+desc&op=Search) to speed up your site by concatenating, minifying, and compressing your CSS styles.',
"unminified-javascript":'Ensure you have enabled "Aggregate JavaScript files" in the "Administration » Configuration » Development" page. You can also configure more advanced aggregation options through [additional modules](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A123&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=javascript+aggregation&solrsort=iss_project_release_usage+desc&op=Search) to speed up your site by concatenating, minifying, and compressing your JavaScript assets.',"efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.",
"uses-long-cache-ttl":'Set the "Browser and proxy cache maximum age" in the "Administration » Configuration » Development" page. Read about [Drupal cache and optimizing for performance](https://www.drupal.org/docs/7/managing-site-performance-and-scalability/caching-to-improve-performance/caching-overview#s-drupal-performance-resources).',"uses-optimized-images":"Consider using [a module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=im_vid_3%3A123&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=optimize+images&solrsort=iss_project_release_usage+desc&op=Search) that automatically optimizes and reduces the size of images uploaded through the site while retaining quality. Also, ensure you are using the native [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) provided from Drupal (available in Drupal 8 and above) for all images rendered on the site.",
"uses-responsive-images":"Ensure that you are using the native [Responsive Image Styles](https://www.drupal.org/docs/8/mobile-guide/responsive-images-in-drupal-8) provided from Drupal (available in Drupal 8 and above). Use the Responsive Image Styles when rendering image fields through view modes, views, or images uploaded through the WYSIWYG editor.","server-response-time":"Themes, modules, and server specifications all contribute to server response time. Consider finding a more optimized theme, carefully selecting an optimization module, and/or upgrading your server. Your hosting servers should make use of PHP opcode caching, memory-caching to reduce database query times such as Redis or Memcached, as well as optimized application logic to prepare pages faster.",
"uses-rel-preconnect":"Preconnect or dns-prefetch resource hints can be added by installing and configuring [a module](https://www.drupal.org/project/project_module?f%5B0%5D=&f%5B1%5D=&f%5B2%5D=&f%5B3%5D=&f%5B4%5D=sm_field_project_type%3Afull&f%5B5%5D=&f%5B6%5D=&text=dns-prefetch&solrsort=iss_project_release_usage+desc&op=Search) that provides facilities for user agent resource hints.","font-display":"Specify `@font-display` when defining custom fonts in your theme."}}},{}],212:[function(e,t,n){"use strict";t.exports={id:"joomla",title:"Joomla",
icon:"data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' preserveAspectRatio='xMidYMid' viewBox='0 0 256 258'%3E%3Cpath d='M255.7 35.6a33.7 33.7 0 00-67-4.8l-.4-.2c-27.6-12.4-50.8 9.6-50.8 9.6l-61.4 61.7 24.3 23.4 49.4-48.6c23-23 35.6-7.4 35.6-7.4 17.4 14.6.6 32 .6 32l24.9 24c20.3-22 21.5-41.1 15.3-56.3a33.7 33.7 0 0029.5-33.4' fill='%23F9AE41'/%3E%3Cpath d='M226.5 190.5l.2-.3c12.4-27.6-9.6-50.8-9.6-50.8L155.4 78l-23.3 24.3 48.5 49.4c23 23 7.5 35.6 7.5 35.6-14.7 17.4-32 .6-32 .6l-24 24.9c21.9 20.3 41 21.5 56.2 15.3a33.7 33.7 0 1038.2-37.6' fill='%23EE4035'/%3E%3Cpath d='M156 133l-49.5 48.6c-23 23-35.6 7.4-35.6 7.4-17.4-14.6-.6-32-.6-32l-24.9-24c-20.3 22-21.4 41.1-15.3 56.3a33.7 33.7 0 1037.6 38.2l.3.2c27.6 12.4 50.8-9.6 50.8-9.6l61.4-61.7-24.3-23.4' fill='%234F91CD'/%3E%3Cpath d='M75.7 106.6c-23-23-7.4-35.6-7.4-35.6 14.6-17.4 32-.6 32-.6l24-24.9c-22-20.3-41-21.5-56.3-15.3a33.7 33.7 0 10-38.2 37.6l-.2.3C17.2 95.7 39.2 119 39.2 119l61.7 61.4 23.4-24.3-48.6-49.4' fill='%237AC043'/%3E%3C/svg%3E",
UIStrings:{"unused-css-rules":"Consider reducing, or switching, the number of [Joomla extensions](https://extensions.joomla.org/) loading unused CSS in your page. To identify extensions that are adding extraneous CSS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the stylesheet. Look out for plugins that have many stylesheets in the list which have a lot of red in code coverage. A plugin should only enqueue a stylesheet if it is actually used on the page.","modern-image-formats":"Consider using a [plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=webp) or service that will automatically convert your uploaded images to the optimal formats.",
"offscreen-images":"Install a [lazy-load Joomla plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=lazy%20loading) that provides the ability to defer any offscreen images, or switch to a template that provides that functionality. Starting with Joomla 4.0, all new images will [automatically](https://github.com/joomla/joomla-cms/pull/30748) get the `loading` attribute from the core.","total-byte-weight":"Consider showing excerpts in your article categories (e.g. via the read more link), reducing the number of articles shown on a given page, breaking your long posts into multiple pages, or using a plugin to lazy-load comments.",
"render-blocking-resources":"There are a number of Joomla plugins that can help you [inline critical assets](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) or [defer less important resources](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance). Beware that optimizations provided by these plugins may break features of your templates or plugins, so you will need to test these thoroughly.","unminified-css":"A number of [Joomla extensions](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) can speed up your site by concatenating, minifying, and compressing your css styles. There are also templates that provide this functionality.","unminified-javascript":"A number of [Joomla extensions](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) can speed up your site by concatenating, minifying, and compressing your scripts. There are also templates that provide this functionality.",
"efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.","unused-javascript":"Consider reducing, or switching, the number of [Joomla extensions](https://extensions.joomla.org/) loading unused JavaScript in your page. To identify plugins that are adding extraneous JS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the extension responsible from the URL of the script. Look out for extensions that have many scripts in the list which have a lot of red in code coverage. An extension should only enqueue a script if it is actually used on the page.","uses-long-cache-ttl":"Read about [Browser Caching in Joomla](https://docs.joomla.org/Cache).",
"uses-optimized-images":"Consider using an [image optimization plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=performance) that compresses your images while retaining quality.","uses-text-compression":"You can enable text compression by enabling Gzip Page Compression in Joomla (System > Global configuration > Server).","uses-responsive-images":"Consider using a [responsive images plugin](https://extensions.joomla.org/instant-search/?jed_live%5Bquery%5D=responsive%20images) to use responsive images in your content.","server-response-time":"Templates, extensions, and server specifications all contribute to server response time. Consider finding a more optimized template, carefully selecting an optimization extension, and/or upgrading your server."}}},{}],213:[function(e,t,n){t.exports={id:"magento",title:"Magento",
icon:'data:image/svg+xml,%3Csvg xmlns="http://www.w3.org/2000/svg" fill="%23f26322" viewBox="0 0 1000 1000"%3E%3Cpath d="M916.9 267.4v465.3l-111.3 67.4V331.4l-1.5-.9-303.9-189-304.6 189.2-1.2.8V799L83.1 732.6V267.4l.7-.4L500.3 10l416 257 .6.4zM560.7 468.5v383.3L500.3 890l-61-38.2V306.7l-136 84.3v476.6l197 122.5 196.4-122.5V391l-136-84.3v161.8z"/%3E%3C/svg%3E',UIStrings:{"modern-image-formats":"Consider searching the [Magento Marketplace](https://marketplace.magento.com/catalogsearch/result/?q=webp) for a variety of third-party extensions to leverage newer image formats.","offscreen-images":"Consider modifying your product and catalog templates to make use of the web platform's [lazy loading](https://web.dev/native-lazy-loading) feature.","disable-bundling":"Disable Magento's built-in [JavaScript bundling and minification](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/themes/js-bundling.html), and consider using [baler](https://github.com/magento/baler/) instead.",
"unminified-css":'Enable the "Minify CSS Files" option in your store\'s Developer settings. [Learn more](https://devdocs.magento.com/guides/v2.3/performance-best-practices/configuration.html?itm_source=devdocs&itm_medium=search_page&itm_campaign=federated_search&itm_term=minify%20css%20files).',"unminified-javascript":"Use [Terser](https://www.npmjs.com/package/terser) to minify all JavaScript assets from static content deployment, and disable the built-in minification feature.","unused-javascript":"Disable Magento's built-in [JavaScript bundling](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/themes/js-bundling.html).","uses-optimized-images":"Consider searching the [Magento Marketplace](https://marketplace.magento.com/catalogsearch/result/?q=optimize%20image) for a variety of third party extensions to optimize images.","server-response-time":"Use Magento's [Varnish integration](https://devdocs.magento.com/guides/v2.3/config-guide/varnish/config-varnish.html).",
"uses-rel-preconnect":"Preconnect or dns-prefetch resource hints can be added by [modifying a themes's layout](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/layouts/xml-manage.html).","uses-rel-preload":"`<link rel=preload>` tags can be added by [modifying a themes's layout](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/layouts/xml-manage.html).","critical-request-chains":"If you are not bundling your JavaScript assets, consider using [baler](https://github.com/magento/baler).","font-display":"Specify `@font-display` when [defining custom fonts](https://devdocs.magento.com/guides/v2.3/frontend-dev-guide/css-topics/using-fonts.html)."}}},{}],214:[function(e,t,n){t.exports={id:"octobercms",title:"October CMS",
icon:'data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 310 310"><path fill="none" d="M-1-1h802v602H-1z"/><g><path fill="%23de6c26" d="M135 6.9c-14.2 4.4-34.9 21.8-49.9 42C55.8 88.5 39.6 135.8 41.4 177c.8 20.2 4.9 35.5 14.4 54.5 13.6 27.4 40.8 55.1 65.5 66.9 14.1 6.7 13.4 6.9 14.1-2.8.3-4.4 1-32.4 1.6-62.1 2.7-137.3 4.4-176 8.2-191.3.6-2.3 1.4-4.2 1.9-4.2 1.2 0 3.6 9.1 4.9 18.3.5 4.3 1 17.7 1 29.8 0 12 .3 21.9.7 21.9.3 0 5.7-5 11.9-11 6.9-6.8 12-11 13.3-11 1.8 0 1.9.3 1 2.7-1.2 3.1-7.9 13.2-19.1 28.5L153 128l.1 31.2c.1 17.2.4 37.4.8 44.9l.6 13.7 11-12.6c14-16 35.1-37.1 39.5-39.6l3.3-1.9-.6 3.2c-2 9.8-9.5 20.7-37.4 54.3L154 240.8v31.1c0 18.3.4 31.1.9 31.1 2.8 0 19.3-6.4 26.8-10.5 13.8-7.3 23.8-15 38.3-29.5 15.7-15.7 24.4-27.4 33.4-45.2 20.5-40 21-80.3 1.6-119-17.8-35.6-54.6-72.1-87.8-86.9-11.7-5.3-24.6-7.3-32.2-5z"/></g></svg>',UIStrings:{
"unused-css-rules":"Consider reviewing the [plugins](https://octobercms.com/plugins) loading unused CSS on the website. To identify plugins that add unnecessary CSS, run [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. Identify the theme/plugin responsible from the stylesheet URL. Look for plugins with many stylesheets with lots of red in code coverage. A plugin should only add a stylesheet if it is actually used on the web page.","modern-image-formats":"Consider using a [plugin](https://octobercms.com/plugins?search=image) or service that will automatically convert the uploaded images to the optimal formats. [WebP lossless images](https://developers.google.com/speed/webp) are 26% smaller in size compared to PNGs and 25-34% smaller than comparable JPEG images at the equivalent SSIM quality index. Another next-gen image format to consider is [AVIF](https://jakearchibald.com/2020/avif-has-landed/).",
"offscreen-images":"Consider installing an [image lazy loading plugin](https://octobercms.com/plugins?search=lazy) that provides the ability to defer any offscreen images, or switch to a theme that provides that functionality. Also consider using [the AMP plugin](https://octobercms.com/plugins?search=Accelerated+Mobile+Pages).","total-byte-weight":"Consider showing excerpts in the post lists (e.g. using a `show more` button), reducing the number of posts shown on a given web page, breaking long posts into multiple web pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are many plugins that help [inline critical assets](https://octobercms.com/plugins?search=css). These plugins may break other plugins, so you should test thoroughly.",
"unminified-css":"There are many [plugins](https://octobercms.com/plugins?search=css) that can speed up a website by concatenating, minifying and compressing the styles. Using a build process to do this minification up-front can speed up development.","unminified-javascript":"There are many [plugins](https://octobercms.com/plugins?search=javascript) that can speed up a website by concatenating, minifying and compressing the scripts. Using a build process to do this minification up-front can speed up development.","efficient-animated-content":"[Replace animated GIFs with video](https://web.dev/replace-gifs-with-videos/) for faster web page loads and consider using modern file formats such as [WebM](https://web.dev/replace-gifs-with-videos/#create-webm-videos) or [AV1](https://developers.google.com/web/updates/2018/09/chrome-70-media-updates#av1-decoder) to improve compression efficiency by greater than 30% over the current state-of-the-art video codec, VP9.",
"unused-javascript":"Consider reviewing the [plugins](https://octobercms.com/plugins?search=javascript) that load unused JavaScript in the web page. To identify plugins that add unnecessary JavaScript, run [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. Identify the theme/plugin responsible from the URL of the script. Look for plugins with many scripts with lots of red in code coverage. A plugin should only add a script if it is actually used on the web page.","uses-long-cache-ttl":"Read about [preventing unnecessary network requests with the HTTP Cache](https://web.dev/http-cache/#caching-checklist). There are many [plugins](https://octobercms.com/plugins?search=Caching) that can be used to speed up caching.","uses-optimized-images":"Consider using an [image optimization plugin](https://octobercms.com/plugins?search=image) to compresses images while retaining the quality.",
"uses-text-compression":"Enable text compression in the web server configuration.","uses-responsive-images":"Upload images directly in the media manager to ensure the required image sizes are available. Consider using the [resize filter](https://octobercms.com/docs/markup/filter-resize) or an [image resizing plugin](https://octobercms.com/plugins?search=image) to ensure the optimal image sizes are used.","server-response-time":"Themes, plugins and server specifications all contribute to the server response time. Consider finding a more optimized theme, carefully selecting an optimization plugin and/or upgrade the server. October CMS also allows developers to use [`Queues`](https://octobercms.com/docs/services/queues) to defer the processing of a time consuming task, such as sending an e-mail. This drastically speeds up web requests."}}},{}],215:[function(e,t,n){t.exports={id:"react",title:"React",
icon:'data:image/svg+xml,%3Csvg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 841.9 595.3"%3E %3Cg fill="%2361DAFB"%3E%3Cpath d="M666.3 296.5c0-32.5-40.7-63.3-103.1-82.4 14.4-63.6 8-114.2-20.2-130.4-6.5-3.8-14.1-5.6-22.4-5.6v22.3c4.6 0 8.3.9 11.4 2.6 13.6 7.8 19.5 37.5 14.9 75.7-1.1 9.4-2.9 19.3-5.1 29.4-19.6-4.8-41-8.5-63.5-10.9-13.5-18.5-27.5-35.3-41.6-50 32.6-30.3 63.2-46.9 84-46.9V78c-27.5 0-63.5 19.6-99.9 53.6-36.4-33.8-72.4-53.2-99.9-53.2v22.3c20.7 0 51.4 16.5 84 46.6-14 14.7-28 31.4-41.3 49.9-22.6 2.4-44 6.1-63.6 11-2.3-10-4-19.7-5.2-29-4.7-38.2 1.1-67.9 14.6-75.8 3-1.8 6.9-2.6 11.5-2.6V78.5c-8.4 0-16 1.8-22.6 5.6-28.1 16.2-34.4 66.7-19.9 130.1-62.2 19.2-102.7 49.9-102.7 82.3 0 32.5 40.7 63.3 103.1 82.4-14.4 63.6-8 114.2 20.2 130.4 6.5 3.8 14.1 5.6 22.5 5.6 27.5 0 63.5-19.6 99.9-53.6 36.4 33.8 72.4 53.2 99.9 53.2 8.4 0 16-1.8 22.6-5.6 28.1-16.2 34.4-66.7 19.9-130.1 62-19.1 102.5-49.9 102.5-82.3zm-130.2-66.7c-3.7 12.9-8.3 26.2-13.5 39.5-4.1-8-8.4-16-13.1-24-4.6-8-9.5-15.8-14.4-23.4 14.2 2.1 27.9 4.7 41 7.9zm-45.8 106.5c-7.8 13.5-15.8 26.3-24.1 38.2-14.9 1.3-30 2-45.2 2-15.1 0-30.2-.7-45-1.9-8.3-11.9-16.4-24.6-24.2-38-7.6-13.1-14.5-26.4-20.8-39.8 6.2-13.4 13.2-26.8 20.7-39.9 7.8-13.5 15.8-26.3 24.1-38.2 14.9-1.3 30-2 45.2-2 15.1 0 30.2.7 45 1.9 8.3 11.9 16.4 24.6 24.2 38 7.6 13.1 14.5 26.4 20.8 39.8-6.3 13.4-13.2 26.8-20.7 39.9zm32.3-13c5.4 13.4 10 26.8 13.8 39.8-13.1 3.2-26.9 5.9-41.2 8 4.9-7.7 9.8-15.6 14.4-23.7 4.6-8 8.9-16.1 13-24.1zM421.2 430c-9.3-9.6-18.6-20.3-27.8-32 9 .4 18.2.7 27.5.7 9.4 0 18.7-.2 27.8-.7-9 11.7-18.3 22.4-27.5 32zm-74.4-58.9c-14.2-2.1-27.9-4.7-41-7.9 3.7-12.9 8.3-26.2 13.5-39.5 4.1 8 8.4 16 13.1 24 4.7 8 9.5 15.8 14.4 23.4zM420.7 163c9.3 9.6 18.6 20.3 27.8 32-9-.4-18.2-.7-27.5-.7-9.4 0-18.7.2-27.8.7 9-11.7 18.3-22.4 27.5-32zm-74 58.9c-4.9 7.7-9.8 15.6-14.4 23.7-4.6 8-8.9 16-13 24-5.4-13.4-10-26.8-13.8-39.8 13.1-3.1 26.9-5.8 41.2-7.9zm-90.5 125.2c-35.4-15.1-58.3-34.9-58.3-50.6 0-15.7 22.9-35.6 58.3-50.6 8.6-3.7 18-7 27.7-10.1 5.7 19.6 13.2 40 22.5 60.9-9.2 20.8-16.6 41.1-22.2 60.6-9.9-3.1-19.3-6.5-28-10.2zM310 490c-13.6-7.8-19.5-37.5-14.9-75.7 1.1-9.4 2.9-19.3 5.1-29.4 19.6 4.8 41 8.5 63.5 10.9 13.5 18.5 27.5 35.3 41.6 50-32.6 30.3-63.2 46.9-84 46.9-4.5-.1-8.3-1-11.3-2.7zm237.2-76.2c4.7 38.2-1.1 67.9-14.6 75.8-3 1.8-6.9 2.6-11.5 2.6-20.7 0-51.4-16.5-84-46.6 14-14.7 28-31.4 41.3-49.9 22.6-2.4 44-6.1 63.6-11 2.3 10.1 4.1 19.8 5.2 29.1zm38.5-66.7c-8.6 3.7-18 7-27.7 10.1-5.7-19.6-13.2-40-22.5-60.9 9.2-20.8 16.6-41.1 22.2-60.6 9.9 3.1 19.3 6.5 28.1 10.2 35.4 15.1 58.3 34.9 58.3 50.6-.1 15.7-23 35.6-58.4 50.6zM320.8 78.4z"/%3E %3Ccircle cx="420.9" cy="296.5" r="45.7"/%3E %3Cpath d="M520.5 78.1z"/%3E%3C/g%3E%3C/svg%3E',
UIStrings:{"unminified-css":"If your build system minifies CSS files automatically, ensure that you are deploying the production build of your application. You can check this with the React Developer Tools extension. [Learn more](https://reactjs.org/docs/optimizing-performance.html#use-the-production-build).","unminified-javascript":"If your build system minifies JS files automatically, ensure that you are deploying the production build of your application. You can check this with the React Developer Tools extension. [Learn more](https://reactjs.org/docs/optimizing-performance.html#use-the-production-build).","unused-javascript":"If you are not server-side rendering, [split your JavaScript bundles](https://web.dev/code-splitting-suspense/) with `React.lazy()`. Otherwise, code-split using a third-party library such as [loadable-components](https://www.smooth-code.com/open-source/loadable-components/docs/getting-started/).",
"server-response-time":"If you are server-side rendering any React components, consider using `renderToNodeStream()` or `renderToStaticNodeStream()` to allow the client to receive and hydrate different parts of the markup instead of all at once. [Learn more](https://reactjs.org/docs/react-dom-server.html#rendertonodestream).",redirects:"If you are using React Router, minimize usage of the `<Redirect>` component for [route navigations](https://reacttraining.com/react-router/web/api/Redirect).","user-timings":"Use the React DevTools Profiler, which makes use of the Profiler API, to measure the rendering performance of your components. [Learn more.](https://reactjs.org/blog/2018/09/10/introducing-the-react-profiler.html)",
"dom-size":'Consider using a "windowing" library like `react-window` to minimize the number of DOM nodes created if you are rendering many repeated elements on the page. [Learn more](https://web.dev/virtualize-long-lists-react-window/). Also, minimize unnecessary re-renders using [`shouldComponentUpdate`](https://reactjs.org/docs/optimizing-performance.html#shouldcomponentupdate-in-action), [`PureComponent`](https://reactjs.org/docs/react-api.html#reactpurecomponent), or [`React.memo`](https://reactjs.org/docs/react-api.html#reactmemo) and [skip effects](https://reactjs.org/docs/hooks-effect.html#tip-optimizing-performance-by-skipping-effects) only until certain dependencies have changed if you are using the `Effect` hook to improve runtime performance.'}}},{}],216:[function(e,t,n){t.exports={id:"wordpress",title:"WordPress",
icon:'data:image/svg+xml,%3Csvg viewBox="0 0 122.5 122.5" xmlns="http://www.w3.org/2000/svg"%3E%3Cg fill="%232f3439"%3E%3Cpath d="M8.7 61.3c0 20.8 12.1 38.7 29.6 47.3l-25-68.7c-3 6.5-4.6 13.7-4.6 21.4zM96.7 58.6c0-6.5-2.3-11-4.3-14.5-2.7-4.3-5.2-8-5.2-12.3 0-4.8 3.7-9.3 8.9-9.3h.7a52.4 52.4 0 0 0-79.4 9.9h3.3c5.5 0 14-.6 14-.6 2.9-.2 3.2 4 .4 4.3 0 0-2.9.4-6 .5l19.1 57L59.7 59l-8.2-22.5c-2.8-.1-5.5-.5-5.5-.5-2.8-.1-2.5-4.5.3-4.3 0 0 8.7.7 13.9.7 5.5 0 14-.7 14-.7 2.8-.2 3.2 4 .3 4.3 0 0-2.8.4-6 .5l19 56.5 5.2-17.5c2.3-7.3 4-12.5 4-17z"/%3E%3Cpath d="M62.2 65.9l-15.8 45.8a52.6 52.6 0 0 0 32.3-.9l-.4-.7zM107.4 36a49.6 49.6 0 0 1-3.6 24.2l-16.1 46.5A52.5 52.5 0 0 0 107.4 36z"/%3E%3Cpath d="M61.3 0a61.3 61.3 0 1 0 .1 122.7A61.3 61.3 0 0 0 61.3 0zm0 119.7a58.5 58.5 0 1 1 .1-117 58.5 58.5 0 0 1-.1 117z"/%3E%3C/g%3E%3C/svg%3E',UIStrings:{
"unused-css-rules":"Consider reducing, or switching, the number of [WordPress plugins](https://wordpress.org/plugins/) loading unused CSS in your page. To identify plugins that are adding extraneous CSS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the stylesheet. Look out for plugins that have many stylesheets in the list which have a lot of red in code coverage. A plugin should only enqueue a stylesheet if it is actually used on the page.","modern-image-formats":"Consider using a [plugin](https://wordpress.org/plugins/search/convert+webp/) or service that will automatically convert your uploaded images to the optimal formats.",
"offscreen-images":"Install a [lazy-load WordPress plugin](https://wordpress.org/plugins/search/lazy+load/) that provides the ability to defer any offscreen images, or switch to a theme that provides that functionality. Also consider using [the AMP plugin](https://wordpress.org/plugins/amp/).","total-byte-weight":"Consider showing excerpts in your post lists (e.g. via the more tag), reducing the number of posts shown on a given page, breaking your long posts into multiple pages, or using a plugin to lazy-load comments.","render-blocking-resources":"There are a number of WordPress plugins that can help you [inline critical assets](https://wordpress.org/plugins/search/critical+css/) or [defer less important resources](https://wordpress.org/plugins/search/defer+css+javascript/). Beware that optimizations provided by these plugins may break features of your theme or plugins, so you will likely need to make code changes.",
"unminified-css":"A number of [WordPress plugins](https://wordpress.org/plugins/search/minify+css/) can speed up your site by concatenating, minifying, and compressing your styles. You may also want to use a build process to do this minification up-front if possible.","unminified-javascript":"A number of [WordPress plugins](https://wordpress.org/plugins/search/minify+javascript/) can speed up your site by concatenating, minifying, and compressing your scripts. You may also want to use a build process to do this minification up front if possible.","efficient-animated-content":"Consider uploading your GIF to a service which will make it available to embed as an HTML5 video.",
"unused-javascript":"Consider reducing, or switching, the number of [WordPress plugins](https://wordpress.org/plugins/) loading unused JavaScript in your page. To identify plugins that are adding extraneous JS, try running [code coverage](https://developers.google.com/web/updates/2017/04/devtools-release-notes#coverage) in Chrome DevTools. You can identify the theme/plugin responsible from the URL of the script. Look out for plugins that have many scripts in the list which have a lot of red in code coverage. A plugin should only enqueue a script if it is actually used on the page.","uses-long-cache-ttl":"Read about [Browser Caching in WordPress](https://wordpress.org/support/article/optimization/#browser-caching).","uses-optimized-images":"Consider using an [image optimization WordPress plugin](https://wordpress.org/plugins/search/optimize+images/) that compresses your images while retaining quality.",
"uses-text-compression":"You can enable text compression in your web server configuration.","uses-responsive-images":"Upload images directly through the [media library](https://wordpress.org/support/article/media-library-screen/) to ensure that the required image sizes are available, and then insert them from the media library or use the image widget to ensure the optimal image sizes are used (including those for the responsive breakpoints). Avoid using `Full Size` images unless the dimensions are adequate for their usage. [Learn More](https://wordpress.org/support/article/inserting-images-into-posts-and-pages/).","server-response-time":"Themes, plugins, and server specifications all contribute to server response time. Consider finding a more optimized theme, carefully selecting an optimization plugin, and/or upgrading your server."}}},{}],217:[function(e,t,n){(function(e){(function(){
var i="__lodash_hash_undefined__",a=9007199254740991,s="[object Arguments]",c="[object Array]",l="[object Boolean]",u="[object Date]",d="[object Error]",m="[object Function]",p="[object Map]",h="[object Number]",f="[object Object]",g="[object Promise]",y="[object RegExp]",b="[object Set]",v="[object String]",w="[object Symbol]",S="[object WeakMap]",T="[object ArrayBuffer]",E="[object DataView]",_=/^\[object .+?Constructor\]$/,x=/^(?:0|[1-9]\d*)$/,A={};A["[object Float32Array]"]=A["[object Float64Array]"]=A["[object Int8Array]"]=A["[object Int16Array]"]=A["[object Int32Array]"]=A["[object Uint8Array]"]=A["[object Uint8ClampedArray]"]=A["[object Uint16Array]"]=A["[object Uint32Array]"]=!0,A[s]=A[c]=A[T]=A[l]=A[E]=A[u]=A[d]=A[m]=A[p]=A[h]=A[f]=A[y]=A[b]=A[v]=A[S]=!1
;var k="object"==typeof e&&e&&e.Object===Object&&e,R="object"==typeof self&&self&&self.Object===Object&&self,D=k||R||Function("return this")(),I="object"==typeof n&&n&&!n.nodeType&&n,C=I&&"object"==typeof t&&t&&!t.nodeType&&t,j=C&&C.exports===I,N=j&&k.process,L=function(){try{return N&&N.binding&&N.binding("util")}catch(e){}}(),M=L&&L.isTypedArray;function arraySome(e,t){for(var n=-1,i=null==e?0:e.length;++n<i;)if(t(e[n],n,e))return!0;return!1}function mapToArray(e){var t=-1,n=Array(e.size);return e.forEach((function(e,i){n[++t]=[i,e]})),n}function setToArray(e){var t=-1,n=Array(e.size);return e.forEach((function(e){n[++t]=e})),n}
var P,O=Array.prototype,F=Function.prototype,U=Object.prototype,B=D["__core-js_shared__"],q=F.toString,z=U.hasOwnProperty,V=(P=/[^.]+$/.exec(B&&B.keys&&B.keys.IE_PROTO||""))?"Symbol(src)_1."+P:"",W=U.toString,H=RegExp("^"+q.call(z).replace(/[\\^$.*+?()[\]{}|]/g,"\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,"$1.*?")+"$"),G=j?D.Buffer:void 0,$=D.Symbol,Y=D.Uint8Array,K=U.propertyIsEnumerable,J=O.splice,Z=$?$.toStringTag:void 0,X=Object.getOwnPropertySymbols,Q=G?G.isBuffer:void 0,ee=function overArg(e,t){return function(n){return e(t(n))}}(Object.keys,Object),te=getNative(D,"DataView"),re=getNative(D,"Map"),ne=getNative(D,"Promise"),ie=getNative(D,"Set"),ae=getNative(D,"WeakMap"),se=getNative(Object,"create"),oe=toSource(te),ce=toSource(re),le=toSource(ne),ue=toSource(ie),de=toSource(ae),me=$?$.prototype:void 0,pe=me?me.valueOf:void 0;function Hash(e){var t=-1,n=null==e?0:e.length;for(this.clear();++t<n;){var i=e[t];this.set(i[0],i[1])}}function ListCache(e){
var t=-1,n=null==e?0:e.length;for(this.clear();++t<n;){var i=e[t];this.set(i[0],i[1])}}function MapCache(e){var t=-1,n=null==e?0:e.length;for(this.clear();++t<n;){var i=e[t];this.set(i[0],i[1])}}function SetCache(e){var t=-1,n=null==e?0:e.length;for(this.__data__=new MapCache;++t<n;)this.add(e[t])}function Stack(e){var t=this.__data__=new ListCache(e);this.size=t.size}function arrayLikeKeys(e,t){var n=ye(e),i=!n&&ge(e),a=!n&&!i&&be(e),s=!n&&!i&&!a&&ve(e),c=n||i||a||s,l=c?function baseTimes(e,t){for(var n=-1,i=Array(e);++n<e;)i[n]=t(n);return i}(e.length,String):[],u=l.length;for(var d in e)!t&&!z.call(e,d)||c&&("length"==d||a&&("offset"==d||"parent"==d)||s&&("buffer"==d||"byteLength"==d||"byteOffset"==d)||isIndex(d,u))||l.push(d);return l}function assocIndexOf(e,t){for(var n=e.length;n--;)if(eq(e[n][0],t))return n;return-1}function baseGetTag(e){return null==e?void 0===e?"[object Undefined]":"[object Null]":Z&&Z in Object(e)?function getRawTag(e){var t=z.call(e,Z),n=e[Z];try{
e[Z]=void 0;var i=!0}catch(e){}var a=W.call(e);i&&(t?e[Z]=n:delete e[Z]);return a}(e):function objectToString(e){return W.call(e)}(e)}function baseIsArguments(e){return isObjectLike(e)&&baseGetTag(e)==s}function baseIsEqual(e,t,n,i,a){return e===t||(null==e||null==t||!isObjectLike(e)&&!isObjectLike(t)?e!=e&&t!=t:function baseIsEqualDeep(e,t,n,i,a,m){var g=ye(e),S=ye(t),_=g?c:fe(e),x=S?c:fe(t),A=(_=_==s?f:_)==f,k=(x=x==s?f:x)==f,R=_==x;if(R&&be(e)){if(!be(t))return!1;g=!0,A=!1}if(R&&!A)return m||(m=new Stack),g||ve(e)?equalArrays(e,t,n,i,a,m):function equalByTag(e,t,n,i,a,s,c){switch(n){case E:if(e.byteLength!=t.byteLength||e.byteOffset!=t.byteOffset)return!1;e=e.buffer,t=t.buffer;case T:return!(e.byteLength!=t.byteLength||!s(new Y(e),new Y(t)));case l:case u:case h:return eq(+e,+t);case d:return e.name==t.name&&e.message==t.message;case y:case v:return e==t+"";case p:var m=mapToArray;case b:var f=1&i;if(m||(m=setToArray),e.size!=t.size&&!f)return!1;var g=c.get(e);if(g)return g==t;i|=2,
c.set(e,t);var S=equalArrays(m(e),m(t),i,a,s,c);return c.delete(e),S;case w:if(pe)return pe.call(e)==pe.call(t)}return!1}(e,t,_,n,i,a,m);if(!(1&n)){var D=A&&z.call(e,"__wrapped__"),I=k&&z.call(t,"__wrapped__");if(D||I){var C=D?e.value():e,j=I?t.value():t;return m||(m=new Stack),a(C,j,n,i,m)}}if(!R)return!1;return m||(m=new Stack),function equalObjects(e,t,n,i,a,s){var c=1&n,l=getAllKeys(e),u=l.length,d=getAllKeys(t).length;if(u!=d&&!c)return!1;var m=u;for(;m--;){var p=l[m];if(!(c?p in t:z.call(t,p)))return!1}var h=s.get(e);if(h&&s.get(t))return h==t;var f=!0;s.set(e,t),s.set(t,e);var g=c;for(;++m<u;){var y=e[p=l[m]],b=t[p];if(i)var v=c?i(b,y,p,t,e,s):i(y,b,p,e,t,s);if(!(void 0===v?y===b||a(y,b,n,i,s):v)){f=!1;break}g||(g="constructor"==p)}if(f&&!g){var w=e.constructor,S=t.constructor;w==S||!("constructor"in e)||!("constructor"in t)||"function"==typeof w&&w instanceof w&&"function"==typeof S&&S instanceof S||(f=!1)}return s.delete(e),s.delete(t),f}(e,t,n,i,a,m)}(e,t,n,i,baseIsEqual,a))}
function baseIsNative(e){return!(!isObject(e)||function isMasked(e){return!!V&&V in e}(e))&&(isFunction(e)?H:_).test(toSource(e))}function baseKeys(e){if(!function isPrototype(e){var t=e&&e.constructor,n="function"==typeof t&&t.prototype||U;return e===n}(e))return ee(e);var t=[];for(var n in Object(e))z.call(e,n)&&"constructor"!=n&&t.push(n);return t}function equalArrays(e,t,n,i,a,s){var c=1&n,l=e.length,u=t.length;if(l!=u&&!(c&&u>l))return!1;var d=s.get(e);if(d&&s.get(t))return d==t;var m=-1,p=!0,h=2&n?new SetCache:void 0;for(s.set(e,t),s.set(t,e);++m<l;){var f=e[m],g=t[m];if(i)var y=c?i(g,f,m,t,e,s):i(f,g,m,e,t,s);if(void 0!==y){if(y)continue;p=!1;break}if(h){if(!arraySome(t,(function(e,t){if(c=t,!h.has(c)&&(f===e||a(f,e,n,i,s)))return h.push(t);var c}))){p=!1;break}}else if(f!==g&&!a(f,g,n,i,s)){p=!1;break}}return s.delete(e),s.delete(t),p}function getAllKeys(e){return function baseGetAllKeys(e,t,n){var i=t(e);return ye(e)?i:function arrayPush(e,t){
for(var n=-1,i=t.length,a=e.length;++n<i;)e[a+n]=t[n];return e}(i,n(e))}(e,keys,he)}function getMapData(e,t){var n=e.__data__;return function isKeyable(e){var t=typeof e;return"string"==t||"number"==t||"symbol"==t||"boolean"==t?"__proto__"!==e:null===e}(t)?n["string"==typeof t?"string":"hash"]:n.map}function getNative(e,t){var n=function getValue(e,t){return null==e?void 0:e[t]}(e,t);return baseIsNative(n)?n:void 0}Hash.prototype.clear=function hashClear(){this.__data__=se?se(null):{},this.size=0},Hash.prototype.delete=function hashDelete(e){var t=this.has(e)&&delete this.__data__[e];return this.size-=t?1:0,t},Hash.prototype.get=function hashGet(e){var t=this.__data__;if(se){var n=t[e];return n===i?void 0:n}return z.call(t,e)?t[e]:void 0},Hash.prototype.has=function hashHas(e){var t=this.__data__;return se?void 0!==t[e]:z.call(t,e)},Hash.prototype.set=function hashSet(e,t){var n=this.__data__;return this.size+=this.has(e)?0:1,n[e]=se&&void 0===t?i:t,this},
ListCache.prototype.clear=function listCacheClear(){this.__data__=[],this.size=0},ListCache.prototype.delete=function listCacheDelete(e){var t=this.__data__,n=assocIndexOf(t,e);return!(n<0)&&(n==t.length-1?t.pop():J.call(t,n,1),--this.size,!0)},ListCache.prototype.get=function listCacheGet(e){var t=this.__data__,n=assocIndexOf(t,e);return n<0?void 0:t[n][1]},ListCache.prototype.has=function listCacheHas(e){return assocIndexOf(this.__data__,e)>-1},ListCache.prototype.set=function listCacheSet(e,t){var n=this.__data__,i=assocIndexOf(n,e);return i<0?(++this.size,n.push([e,t])):n[i][1]=t,this},MapCache.prototype.clear=function mapCacheClear(){this.size=0,this.__data__={hash:new Hash,map:new(re||ListCache),string:new Hash}},MapCache.prototype.delete=function mapCacheDelete(e){var t=getMapData(this,e).delete(e);return this.size-=t?1:0,t},MapCache.prototype.get=function mapCacheGet(e){return getMapData(this,e).get(e)},MapCache.prototype.has=function mapCacheHas(e){
return getMapData(this,e).has(e)},MapCache.prototype.set=function mapCacheSet(e,t){var n=getMapData(this,e),i=n.size;return n.set(e,t),this.size+=n.size==i?0:1,this},SetCache.prototype.add=SetCache.prototype.push=function setCacheAdd(e){return this.__data__.set(e,i),this},SetCache.prototype.has=function setCacheHas(e){return this.__data__.has(e)},Stack.prototype.clear=function stackClear(){this.__data__=new ListCache,this.size=0},Stack.prototype.delete=function stackDelete(e){var t=this.__data__,n=t.delete(e);return this.size=t.size,n},Stack.prototype.get=function stackGet(e){return this.__data__.get(e)},Stack.prototype.has=function stackHas(e){return this.__data__.has(e)},Stack.prototype.set=function stackSet(e,t){var n=this.__data__;if(n instanceof ListCache){var i=n.__data__;if(!re||i.length<199)return i.push([e,t]),this.size=++n.size,this;n=this.__data__=new MapCache(i)}return n.set(e,t),this.size=n.size,this};var he=X?function(e){return null==e?[]:(e=Object(e),
function arrayFilter(e,t){for(var n=-1,i=null==e?0:e.length,a=0,s=[];++n<i;){var c=e[n];t(c,n,e)&&(s[a++]=c)}return s}(X(e),(function(t){return K.call(e,t)})))}:function stubArray(){return[]},fe=baseGetTag;function isIndex(e,t){return!!(t=null==t?a:t)&&("number"==typeof e||x.test(e))&&e>-1&&e%1==0&&e<t}function toSource(e){if(null!=e){try{return q.call(e)}catch(e){}try{return e+""}catch(e){}}return""}function eq(e,t){return e===t||e!=e&&t!=t}(te&&fe(new te(new ArrayBuffer(1)))!=E||re&&fe(new re)!=p||ne&&fe(ne.resolve())!=g||ie&&fe(new ie)!=b||ae&&fe(new ae)!=S)&&(fe=function(e){var t=baseGetTag(e),n=t==f?e.constructor:void 0,i=n?toSource(n):"";if(i)switch(i){case oe:return E;case ce:return p;case le:return g;case ue:return b;case de:return S}return t});var ge=baseIsArguments(function(){return arguments}())?baseIsArguments:function(e){return isObjectLike(e)&&z.call(e,"callee")&&!K.call(e,"callee")},ye=Array.isArray;var be=Q||function stubFalse(){return!1};function isFunction(e){
if(!isObject(e))return!1;var t=baseGetTag(e);return t==m||"[object GeneratorFunction]"==t||"[object AsyncFunction]"==t||"[object Proxy]"==t}function isLength(e){return"number"==typeof e&&e>-1&&e%1==0&&e<=a}function isObject(e){var t=typeof e;return null!=e&&("object"==t||"function"==t)}function isObjectLike(e){return null!=e&&"object"==typeof e}var ve=M?function baseUnary(e){return function(t){return e(t)}}(M):function baseIsTypedArray(e){return isObjectLike(e)&&isLength(e.length)&&!!A[baseGetTag(e)]};function keys(e){return function isArrayLike(e){return null!=e&&isLength(e.length)&&!isFunction(e)}(e)?arrayLikeKeys(e):baseKeys(e)}t.exports=function isEqual(e,t){return baseIsEqual(e,t)}}).call(this)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],218:[function(e,t,n){t.exports=function lookupClosestLocale(e,t){if("string"==typeof e&&t[e])return e
;for(var n=[].concat(e||[]),i=0,a=n.length;i<a;++i)for(var s=n[i].split("-");s.length;){var c=s.join("-");if(t[c])return c;s.pop()}}},{}],219:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0});var i="undefined"!=typeof performance&&performance,a=i&&i.now?function(){return i.now()}:function(){return Date.now()};function throwIfEmpty(e){if(!e)throw new Error("name must be non-empty")}if(n.mark=void 0,n.stop=void 0,n.getEntries=void 0,n.clear=void 0,i&&i.mark&&i.getEntriesByName&&i.getEntriesByType&&i.clearMeasures)n.mark=function(e){throwIfEmpty(e),i.mark("start "+e)},n.stop=function(e){throwIfEmpty(e),i.mark("end "+e),i.measure(e,"start "+e,"end "+e);var t=i.getEntriesByName(e);return t[t.length-1]},n.getEntries=function(){return i.getEntriesByType("measure")},n.clear=function(){i.clearMarks(),i.clearMeasures()};else{var s={},c=[];n.mark=function(e){throwIfEmpty(e);var t=a();s["$"+e]=t},n.stop=function(e){throwIfEmpty(e);var t=a(),n=s["$"+e]
;if(!n)throw new Error("no known mark: "+e);var i={startTime:n,name:e,duration:t-n,entryType:"measure"};return function insertSorted(e,t){for(var n,i=0,a=e.length;i<a;)e[n=i+a>>>1].startTime<t.startTime?i=n+1:a=n;e.splice(i,0,t)}(c,i),i},n.getEntries=function(){return c},n.clear=function(){s={},c=[]}}},{}],220:[function(e,t,n){function min(e,t){return null===e?t:null===t?e:Math.min(e,t)}function max(e,t){return null===e?t:null===t?e:Math.max(e,t)}function translateLengthProperty(e,t,n){return"number"==typeof e?e>=0?clamp(e,1,1e4):void 0:"device-width"===e?100*t:"device-height"===e?100*n:1}function translateZoomProperty(e){return"number"==typeof e?e>=0?clamp(e,.1,10):void 0:"yes"===e?1:"device-width"===e||"device-height"===e?10:"no"===e||null===e?.1:void 0}function clamp(e,t,n){return max(min(e,n),t)}n.getRenderingDataFromViewport=function(e,t,n,i,a){var s=t/100,c=n/100,l=null,u=null,d=null,m=null,p=null,h=null,f=null,g=null,y=null,b=t,v=n,w="zoom"
;if(void 0!==e["maximum-scale"]&&(l=translateZoomProperty(e["maximum-scale"])),void 0!==e["minimum-scale"]&&(u=translateZoomProperty(e["minimum-scale"])),void 0!==e["initial-scale"]&&(d=translateZoomProperty(e["initial-scale"])),null!==u&&null===l&&(u=min(i,translateZoomProperty(e["minimum-scale"]))),void 0!==e.width&&(m="extend-to-zoom",h=translateLengthProperty(e.width,s,c)),void 0!==e.height&&(p="extend-to-zoom",f=translateLengthProperty(e.height,s,c)),void 0!==e["user-scalable"])if("number"==typeof(w=e["user-scalable"]))w=w>=1||w<=-1?"zoom":"fixed";else switch(w){case"yes":case"device-width":case"device-height":w="zoom";break;case"no":default:w="fixed"}null===d||void 0!==e.width&&void 0!==g||(void 0!==e.height?(m=null,h=null):(m="extend-to-zoom",h="extend-to-zoom")),null!==u&&null!==l&&(l=max(u,l)),null!==d&&(d=clamp(d,u,l));var S,T,E=null===d&&null===l?null:min(d,l);return null===E?("extend-to-zoom"===h&&(h=null),"extend-to-zoom"===f&&(f=null),"extend-to-zoom"===m&&(m=h),
"extend-to-zoom"===p&&(p=f)):(S=b/E,T=v/E,"extend-to-zoom"===h&&(h=S),"extend-to-zoom"===f&&(f=T),"extend-to-zoom"===m&&(m=max(S,h)),"extend-to-zoom"===p&&(p=max(T,f))),null===m&&null===h||(g=max(m,min(h,b))),null===p&&null===f||(y=max(p,min(f,v))),null===g&&(g=null===y?b:0!==v?Math.round(y*(b/v)):b),null===y&&(y=0!==b?Math.round(g*(v/b)):v),{zoom:d,width:g,height:y,userZoom:w}},n.parseMetaViewPortContent=function(e){for(var t={validProperties:{},unknownProperties:{},invalidValues:{}},n=1;n<=e.length;){for(;n<=e.length&&RegExp(" |\n|\t|\0d|,|;|=").test(e[n-1]);)n++;n<=e.length&&(n=parseProperty(t,e,n))}return t};var i=["width","height","initial-scale","minimum-scale","maximum-scale","user-scalable","shrink-to-fit","viewport-fit"];function parseProperty(e,t,n){for(var a=n;n<=t.length&&!RegExp(" |\n|\t|\0d|,|;|=").test(t[n-1]);)n++;if(n>t.length||RegExp(",|;").test(t[n-1]))return n;for(var s=t.slice(a-1,n-1);n<=t.length&&!RegExp(",|;|=").test(t[n-1]);)n++
;if(n>t.length||RegExp(",|;").test(t[n-1]))return n;for(;n<=t.length&&RegExp(" |\n|\t|\0d|=").test(t[n-1]);)n++;if(n>t.length||RegExp(",|;").test(t[n-1]))return n;for(a=n;n<=t.length&&!RegExp(" |\n|\t|\0d|,|;|=").test(t[n-1]);)n++;return function setProperty(e,t,n){if(i.indexOf(t)>=0){var a=parseFloat(n);if(!isNaN(a))return void(e.validProperties[t]=a);var s=n.toLowerCase();if("yes"===s||"no"===s||"device-width"===s||"device-height"===s||"viewport-fit"===t.toLowerCase()&&("auto"===s||"cover"===s))return void(e.validProperties[t]=s);e.validProperties[t]=null,e.invalidValues[t]=n}else e.unknownProperties[t]=n}(e,s,t.slice(a-1,n-1)),n}n.expectedValues={width:["device-width","device-height","a positive number"],height:["device-width","device-height","a positive number"],"initial-scale":["a positive number"],"minimum-scale":["a positive number"],"maximum-scale":["a positive number"],"user-scalable":["yes","no","0","1"],"shrink-to-fit":["yes","no"],"viewport-fit":["auto","cover"]}},{}],
221:[function(e,t,n){t.exports=function parseCacheControl(e){if("string"!=typeof e)return null;var t={},n=e.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g,(function(e,n,i,a){var s=i||a;return t[n]=!s||s.toLowerCase(),""}));if(t["max-age"])try{var i=parseInt(t["max-age"],10);if(isNaN(i))return null;t["max-age"]=i}catch(n){}return n?null:t}},{}],222:[function(e,t,n){(function(e){(function(){"use strict";function assertPath(e){if("string"!=typeof e)throw new TypeError("Path must be a string. Received "+JSON.stringify(e))}function normalizeStringPosix(e,t){for(var n,i="",a=0,s=-1,c=0,l=0;l<=e.length;++l){if(l<e.length)n=e.charCodeAt(l);else{if(47===n)break;n=47}if(47===n){if(s===l-1||1===c);else if(s!==l-1&&2===c){if(i.length<2||2!==a||46!==i.charCodeAt(i.length-1)||46!==i.charCodeAt(i.length-2))if(i.length>2){var u=i.lastIndexOf("/");if(u!==i.length-1){-1===u?(i="",
a=0):a=(i=i.slice(0,u)).length-1-i.lastIndexOf("/"),s=l,c=0;continue}}else if(2===i.length||1===i.length){i="",a=0,s=l,c=0;continue}t&&(i.length>0?i+="/..":i="..",a=2)}else i.length>0?i+="/"+e.slice(s+1,l):i=e.slice(s+1,l),a=l-s-1;s=l,c=0}else 46===n&&-1!==c?++c:c=-1}return i}var n={resolve:function resolve(){for(var t,n="",i=!1,a=arguments.length-1;a>=-1&&!i;a--){var s;a>=0?s=arguments[a]:(void 0===t&&(t=e.cwd()),s=t),assertPath(s),0!==s.length&&(n=s+"/"+n,i=47===s.charCodeAt(0))}return n=normalizeStringPosix(n,!i),i?n.length>0?"/"+n:"/":n.length>0?n:"."},normalize:function normalize(e){if(assertPath(e),0===e.length)return".";var t=47===e.charCodeAt(0),n=47===e.charCodeAt(e.length-1);return 0!==(e=normalizeStringPosix(e,!t)).length||t||(e="."),e.length>0&&n&&(e+="/"),t?"/"+e:e},isAbsolute:function isAbsolute(e){return assertPath(e),e.length>0&&47===e.charCodeAt(0)},join:function join(){if(0===arguments.length)return".";for(var e,t=0;t<arguments.length;++t){var i=arguments[t]
;assertPath(i),i.length>0&&(void 0===e?e=i:e+="/"+i)}return void 0===e?".":n.normalize(e)},relative:function relative(e,t){if(assertPath(e),assertPath(t),e===t)return"";if((e=n.resolve(e))===(t=n.resolve(t)))return"";for(var i=1;i<e.length&&47===e.charCodeAt(i);++i);for(var a=e.length,s=a-i,c=1;c<t.length&&47===t.charCodeAt(c);++c);for(var l=t.length-c,u=s<l?s:l,d=-1,m=0;m<=u;++m){if(m===u){if(l>u){if(47===t.charCodeAt(c+m))return t.slice(c+m+1);if(0===m)return t.slice(c+m)}else s>u&&(47===e.charCodeAt(i+m)?d=m:0===m&&(d=0));break}var p=e.charCodeAt(i+m);if(p!==t.charCodeAt(c+m))break;47===p&&(d=m)}var h="";for(m=i+d+1;m<=a;++m)m!==a&&47!==e.charCodeAt(m)||(0===h.length?h+="..":h+="/..");return h.length>0?h+t.slice(c+d):(c+=d,47===t.charCodeAt(c)&&++c,t.slice(c))},_makeLong:function _makeLong(e){return e},dirname:function dirname(e){if(assertPath(e),0===e.length)return".";for(var t=e.charCodeAt(0),n=47===t,i=-1,a=!0,s=e.length-1;s>=1;--s)if(47===(t=e.charCodeAt(s))){if(!a){i=s;break}
}else a=!1;return-1===i?n?"/":".":n&&1===i?"//":e.slice(0,i)},basename:function basename(e,t){if(void 0!==t&&"string"!=typeof t)throw new TypeError('"ext" argument must be a string');assertPath(e);var n,i=0,a=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t.length===e.length&&t===e)return"";var c=t.length-1,l=-1;for(n=e.length-1;n>=0;--n){var u=e.charCodeAt(n);if(47===u){if(!s){i=n+1;break}}else-1===l&&(s=!1,l=n+1),c>=0&&(u===t.charCodeAt(c)?-1==--c&&(a=n):(c=-1,a=l))}return i===a?a=l:-1===a&&(a=e.length),e.slice(i,a)}for(n=e.length-1;n>=0;--n)if(47===e.charCodeAt(n)){if(!s){i=n+1;break}}else-1===a&&(s=!1,a=n+1);return-1===a?"":e.slice(i,a)},extname:function extname(e){assertPath(e);for(var t=-1,n=0,i=-1,a=!0,s=0,c=e.length-1;c>=0;--c){var l=e.charCodeAt(c);if(47!==l)-1===i&&(a=!1,i=c+1),46===l?-1===t?t=c:1!==s&&(s=1):-1!==t&&(s=-1);else if(!a){n=c+1;break}}return-1===t||-1===i||0===s||1===s&&t===i-1&&t===n+1?"":e.slice(t,i)},format:function format(e){
if(null===e||"object"!=typeof e)throw new TypeError('The "pathObject" argument must be of type Object. Received type '+typeof e);return function _format(e,t){var n=t.dir||t.root,i=t.base||(t.name||"")+(t.ext||"");return n?n===t.root?n+i:n+e+i:i}("/",e)},parse:function parse(e){assertPath(e);var t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;var n,i=e.charCodeAt(0),a=47===i;a?(t.root="/",n=1):n=0;for(var s=-1,c=0,l=-1,u=!0,d=e.length-1,m=0;d>=n;--d)if(47!==(i=e.charCodeAt(d)))-1===l&&(u=!1,l=d+1),46===i?-1===s?s=d:1!==m&&(m=1):-1!==s&&(m=-1);else if(!u){c=d+1;break}return-1===s||-1===l||0===m||1===m&&s===l-1&&s===c+1?-1!==l&&(t.base=t.name=0===c&&a?e.slice(1,l):e.slice(c,l)):(0===c&&a?(t.name=e.slice(1,s),t.base=e.slice(1,l)):(t.name=e.slice(c,s),t.base=e.slice(c,l)),t.ext=e.slice(s,l)),c>0?t.dir=e.slice(0,c-1):a&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null};n.posix=n,t.exports=n}).call(this)}).call(this,e("_process"))},{_process:223}],
223:[function(e,t,n){var i,a,s=t.exports={};function defaultSetTimout(){throw new Error("setTimeout has not been defined")}function defaultClearTimeout(){throw new Error("clearTimeout has not been defined")}function runTimeout(e){if(i===setTimeout)return setTimeout(e,0);if((i===defaultSetTimout||!i)&&setTimeout)return i=setTimeout,setTimeout(e,0);try{return i(e,0)}catch(t){try{return i.call(null,e,0)}catch(t){return i.call(this,e,0)}}}!function(){try{i="function"==typeof setTimeout?setTimeout:defaultSetTimout}catch(e){i=defaultSetTimout}try{a="function"==typeof clearTimeout?clearTimeout:defaultClearTimeout}catch(e){a=defaultClearTimeout}}();var c,l=[],u=!1,d=-1;function cleanUpNextTick(){u&&c&&(u=!1,c.length?l=c.concat(l):d=-1,l.length&&drainQueue())}function drainQueue(){if(!u){var e=runTimeout(cleanUpNextTick);u=!0;for(var t=l.length;t;){for(c=l,l=[];++d<t;)c&&c[d].run();d=-1,t=l.length}c=null,u=!1,function runClearTimeout(e){if(a===clearTimeout)return clearTimeout(e)
;if((a===defaultClearTimeout||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(e);try{return a(e)}catch(t){try{return a.call(null,e)}catch(t){return a.call(this,e)}}}(e)}}function Item(e,t){this.fun=e,this.array=t}function noop(){}s.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];l.push(new Item(e,t)),1!==l.length||u||runTimeout(drainQueue)},Item.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=noop,s.addListener=noop,s.once=noop,s.off=noop,s.removeListener=noop,s.removeAllListeners=noop,s.emit=noop,s.prependListener=noop,s.prependOnceListener=noop,s.listeners=function(e){return[]},s.binding=function(e){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(e){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}},{}],224:[function(e,t,n){
"use strict";function hasOwnProperty(e,t){return Object.prototype.hasOwnProperty.call(e,t)}t.exports=function(e,t,n,a){t=t||"&",n=n||"=";var s={};if("string"!=typeof e||0===e.length)return s;var c=/\+/g;e=e.split(t);var l=1e3;a&&"number"==typeof a.maxKeys&&(l=a.maxKeys);var u=e.length;l>0&&u>l&&(u=l);for(var d=0;d<u;++d){var m,p,h,f,g=e[d].replace(c,"%20"),y=g.indexOf(n);y>=0?(m=g.substr(0,y),p=g.substr(y+1)):(m=g,p=""),h=decodeURIComponent(m),f=decodeURIComponent(p),hasOwnProperty(s,h)?i(s[h])?s[h].push(f):s[h]=[s[h],f]:s[h]=f}return s};var i=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)}},{}],225:[function(e,t,n){"use strict";var stringifyPrimitive=function(e){switch(typeof e){case"string":return e;case"boolean":return e?"true":"false";case"number":return isFinite(e)?e:"";default:return""}};t.exports=function(e,t,n,s){return t=t||"&",n=n||"=",null===e&&(e=void 0),"object"==typeof e?map(a(e),(function(a){
var s=encodeURIComponent(stringifyPrimitive(a))+n;return i(e[a])?map(e[a],(function(e){return s+encodeURIComponent(stringifyPrimitive(e))})).join(t):s+encodeURIComponent(stringifyPrimitive(e[a]))})).join(t):s?encodeURIComponent(stringifyPrimitive(s))+n+encodeURIComponent(stringifyPrimitive(e)):""};var i=Array.isArray||function(e){return"[object Array]"===Object.prototype.toString.call(e)};function map(e,t){if(e.map)return e.map(t);for(var n=[],i=0;i<e.length;i++)n.push(t(e[i],i));return n}var a=Object.keys||function(e){var t=[];for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.push(n);return t}},{}],226:[function(e,t,n){"use strict";n.decode=n.parse=e("./decode"),n.encode=n.stringify=e("./encode")},{"./decode":224,"./encode":225}],227:[function(e,t,n){var i=e("url").URL;function trimLine(e){return e?Array.isArray(e)?e.map(trimLine):String(e).trim():null}function removeComments(e){var t=e.indexOf("#");return t>-1?e.substr(0,t):e}function splitLine(e){
var t=String(e).indexOf(":");return!e||t<0?null:[e.slice(0,t),e.slice(t+1)]}function formatUserAgent(e){var t=e.toLowerCase(),n=t.indexOf("/");return n>-1&&(t=t.substr(0,n)),t.trim()}function urlEncodeToUpper(e){return e.replace(/%[0-9a-fA-F]{2}/g,(function(e){return e.toUpperCase()}))}function parsePattern(e){return(e=function normaliseEncoding(e){try{return urlEncodeToUpper(encodeURI(e).replace(/%25/g,"%"))}catch(t){return e}}(e)).indexOf("*")<0&&e.indexOf("$")<0?e:(e=e.replace(/[\-\[\]\/\{\}\(\)\+\?\.\\\^\$\|]/g,"\\$&").replace(/\*/g,"(?:.*)").replace(/\\\$$/,"$"),new RegExp(e))}function parseUrl(e){try{return new i(e)}catch(e){return null}}function Robots(e,t){this._url=parseUrl(e)||{},this._url.port=this._url.port||80,this._rules={},this._sitemaps=[],this._preferedHost=null,function parseRobots(e,t){for(var n=e.split(/\r\n|\r|\n/).map(removeComments).map(splitLine).map(trimLine),i=[],a=!0,s=0;s<n.length;s++){var c=n[s];if(c&&c[0]){switch(c[0].toLowerCase()){case"user-agent":
a&&(i.length=0),c[1]&&i.push(formatUserAgent(c[1]));break;case"disallow":t.addRule(i,c[1],!1,s+1);break;case"allow":t.addRule(i,c[1],!0,s+1);break;case"crawl-delay":t.setCrawlDelay(i,c[1]);break;case"sitemap":c[1]&&t.addSitemap(c[1]);break;case"host":c[1]&&t.setPreferredHost(c[1].toLowerCase())}a="user-agent"!==c[0].toLowerCase()}}}(t||"",this)}Robots.prototype.addRule=function(e,t,n,i){var a=this._rules;e.forEach((function(e){a[e]=a[e]||[],t&&a[e].push({pattern:parsePattern(t),allow:n,lineNumber:i})}))},Robots.prototype.setCrawlDelay=function(e,t){var n=this._rules,i=Number(t);e.forEach((function(e){n[e]=n[e]||[],isNaN(i)||(n[e].crawlDelay=i)}))},Robots.prototype.addSitemap=function(e){this._sitemaps.push(e)},Robots.prototype.setPreferredHost=function(e){this._preferedHost=e},Robots.prototype._getRule=function(e,t){var n=parseUrl(e)||{},i=formatUserAgent(t||"*");if(n.port=n.port||"80",n.protocol===this._url.protocol&&n.hostname===this._url.hostname&&n.port===this._url.port){
var a=this._rules[i]||this._rules["*"]||[];return function findRule(e,t){for(var n=null,i=0;i<t.length;i++){var a=t[i];if("string"==typeof a.pattern){if(0!==e.indexOf(a.pattern))continue;(!n||a.pattern.length>n.pattern.length)&&(n=a)}else if(a.pattern.test(e))return a}return n}(urlEncodeToUpper(n.pathname+n.search),a)}},Robots.prototype.isAllowed=function(e,t){var n=this._getRule(e,t);if(void 0!==n)return!n||n.allow},Robots.prototype.getMatchingLineNumber=function(e,t){var n=this._getRule(e,t);return n?n.lineNumber:-1},Robots.prototype.isDisallowed=function(e,t){return!this.isAllowed(e,t)},Robots.prototype.getCrawlDelay=function(e){var t=formatUserAgent(e||"*");return(this._rules[t]||this._rules["*"]||{}).crawlDelay},Robots.prototype.getPreferredHost=function(){return this._preferedHost},Robots.prototype.getSitemaps=function(){return this._sitemaps.slice(0)},t.exports=Robots},{url:"url"}],228:[function(e,t,n){var i=e("./Robots");t.exports=function(e,t){return new i(e,t)}},{
"./Robots":227}],229:[function(e,t,n){
/*! safe-buffer. MIT License. Feross Aboukhadijeh <https://feross.org/opensource> */
var i=e("buffer"),a=i.Buffer;function copyProps(e,t){for(var n in e)t[n]=e[n]}function SafeBuffer(e,t,n){return a(e,t,n)}a.from&&a.alloc&&a.allocUnsafe&&a.allocUnsafeSlow?t.exports=i:(copyProps(i,n),n.Buffer=SafeBuffer),SafeBuffer.prototype=Object.create(a.prototype),copyProps(a,SafeBuffer),SafeBuffer.from=function(e,t,n){if("number"==typeof e)throw new TypeError("Argument must not be a number");return a(e,t,n)},SafeBuffer.alloc=function(e,t,n){if("number"!=typeof e)throw new TypeError("Argument must be a number");var i=a(e);return void 0!==t?"string"==typeof n?i.fill(t,n):i.fill(t):i.fill(0),i},SafeBuffer.allocUnsafe=function(e){if("number"!=typeof e)throw new TypeError("Argument must be a number");return a(e)},SafeBuffer.allocUnsafeSlow=function(e){if("number"!=typeof e)throw new TypeError("Argument must be a number");return i.SlowBuffer(e)}},{buffer:145}],230:[function(e,t,n){(function(e){(function(){var i;n=t.exports=SemVer,
i="object"==typeof e&&e.env&&e.env.NODE_DEBUG&&/\bsemver\b/i.test(e.env.NODE_DEBUG)?function(){var e=Array.prototype.slice.call(arguments,0);e.unshift("SEMVER"),console.log.apply(console,e)}:function(){},n.SEMVER_SPEC_VERSION="2.0.0";var a=Number.MAX_SAFE_INTEGER||9007199254740991,s=n.re=[],c=n.src=[],l=0,u=l++;c[u]="0|[1-9]\\d*";var d=l++;c[d]="[0-9]+";var m=l++;c[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=l++;c[p]="("+c[u]+")\\.("+c[u]+")\\.("+c[u]+")";var h=l++;c[h]="("+c[d]+")\\.("+c[d]+")\\.("+c[d]+")";var f=l++;c[f]="(?:"+c[u]+"|"+c[m]+")";var g=l++;c[g]="(?:"+c[d]+"|"+c[m]+")";var y=l++;c[y]="(?:-("+c[f]+"(?:\\."+c[f]+")*))";var b=l++;c[b]="(?:-?("+c[g]+"(?:\\."+c[g]+")*))";var v=l++;c[v]="[0-9A-Za-z-]+";var w=l++;c[w]="(?:\\+("+c[v]+"(?:\\."+c[v]+")*))";var S=l++,T="v?"+c[p]+c[y]+"?"+c[w]+"?";c[S]="^"+T+"$";var E="[v=\\s]*"+c[h]+c[b]+"?"+c[w]+"?",_=l++;c[_]="^"+E+"$";var x=l++;c[x]="((?:<|>)?=?)";var A=l++;c[A]=c[d]+"|x|X|\\*";var k=l++;c[k]=c[u]+"|x|X|\\*";var R=l++
;c[R]="[v=\\s]*("+c[k]+")(?:\\.("+c[k]+")(?:\\.("+c[k]+")(?:"+c[y]+")?"+c[w]+"?)?)?";var D=l++;c[D]="[v=\\s]*("+c[A]+")(?:\\.("+c[A]+")(?:\\.("+c[A]+")(?:"+c[b]+")?"+c[w]+"?)?)?";var I=l++;c[I]="^"+c[x]+"\\s*"+c[R]+"$";var C=l++;c[C]="^"+c[x]+"\\s*"+c[D]+"$";var j=l++;c[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=l++;c[N]="(?:~>?)";var L=l++;c[L]="(\\s*)"+c[N]+"\\s+",s[L]=new RegExp(c[L],"g");var M=l++;c[M]="^"+c[N]+c[R]+"$";var P=l++;c[P]="^"+c[N]+c[D]+"$";var O=l++;c[O]="(?:\\^)";var F=l++;c[F]="(\\s*)"+c[O]+"\\s+",s[F]=new RegExp(c[F],"g");var U=l++;c[U]="^"+c[O]+c[R]+"$";var B=l++;c[B]="^"+c[O]+c[D]+"$";var q=l++;c[q]="^"+c[x]+"\\s*("+E+")$|^$";var z=l++;c[z]="^"+c[x]+"\\s*("+T+")$|^$";var V=l++;c[V]="(\\s*)"+c[x]+"\\s*("+E+"|"+c[R]+")",s[V]=new RegExp(c[V],"g");var W=l++;c[W]="^\\s*("+c[R]+")\\s+-\\s+("+c[R]+")\\s*$";var H=l++;c[H]="^\\s*("+c[D]+")\\s+-\\s+("+c[D]+")\\s*$";var G=l++;c[G]="(<|>)?=?\\s*\\*";for(var $=0;$<35;$++)i($,c[$]),
s[$]||(s[$]=new RegExp(c[$]));function parse(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof SemVer)return e;if("string"!=typeof e)return null;if(e.length>256)return null;if(!(t.loose?s[_]:s[S]).test(e))return null;try{return new SemVer(e,t)}catch(e){return null}}function SemVer(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof SemVer){if(e.loose===t.loose)return e;e=e.version}else if("string"!=typeof e)throw new TypeError("Invalid Version: "+e);if(e.length>256)throw new TypeError("version is longer than 256 characters");if(!(this instanceof SemVer))return new SemVer(e,t);i("SemVer",e,t),this.options=t,this.loose=!!t.loose;var n=e.trim().match(t.loose?s[_]:s[S]);if(!n)throw new TypeError("Invalid Version: "+e);if(this.raw=e,this.major=+n[1],this.minor=+n[2],this.patch=+n[3],this.major>a||this.major<0)throw new TypeError("Invalid major version");if(this.minor>a||this.minor<0)throw new TypeError("Invalid minor version")
;if(this.patch>a||this.patch<0)throw new TypeError("Invalid patch version");n[4]?this.prerelease=n[4].split(".").map((function(e){if(/^[0-9]+$/.test(e)){var t=+e;if(t>=0&&t<a)return t}return e})):this.prerelease=[],this.build=n[5]?n[5].split("."):[],this.format()}n.parse=parse,n.valid=function valid(e,t){var n=parse(e,t);return n?n.version:null},n.clean=function clean(e,t){var n=parse(e.trim().replace(/^[=v]+/,""),t);return n?n.version:null},n.SemVer=SemVer,SemVer.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},SemVer.prototype.toString=function(){return this.version},SemVer.prototype.compare=function(e){return i("SemVer.compare",this.version,this.options,e),e instanceof SemVer||(e=new SemVer(e,this.options)),this.compareMain(e)||this.comparePre(e)},SemVer.prototype.compareMain=function(e){return e instanceof SemVer||(e=new SemVer(e,this.options)),
compareIdentifiers(this.major,e.major)||compareIdentifiers(this.minor,e.minor)||compareIdentifiers(this.patch,e.patch)},SemVer.prototype.comparePre=function(e){if(e instanceof SemVer||(e=new SemVer(e,this.options)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;var t=0;do{var n=this.prerelease[t],a=e.prerelease[t];if(i("prerelease compare",t,n,a),void 0===n&&void 0===a)return 0;if(void 0===a)return 1;if(void 0===n)return-1;if(n!==a)return compareIdentifiers(n,a)}while(++t)},SemVer.prototype.inc=function(e,t){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t),this.inc("pre",t);break;case"prerelease":0===this.prerelease.length&&this.inc("patch",t),
this.inc("pre",t);break;case"major":0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":if(0===this.prerelease.length)this.prerelease=[0];else{for(var n=this.prerelease.length;--n>=0;)"number"==typeof this.prerelease[n]&&(this.prerelease[n]++,n=-2);-1===n&&this.prerelease.push(0)}t&&(this.prerelease[0]===t?isNaN(this.prerelease[1])&&(this.prerelease=[t,0]):this.prerelease=[t,0]);break;default:throw new Error("invalid increment argument: "+e)}return this.format(),this.raw=this.version,this},n.inc=function inc(e,t,n,i){"string"==typeof n&&(i=n,n=void 0);try{return new SemVer(e,n).inc(t,i).version}catch(e){return null}},n.diff=function diff(e,t){if(eq(e,t))return null;var n=parse(e),i=parse(t),a=""
;if(n.prerelease.length||i.prerelease.length){a="pre";var s="prerelease"}for(var c in n)if(("major"===c||"minor"===c||"patch"===c)&&n[c]!==i[c])return a+c;return s},n.compareIdentifiers=compareIdentifiers;var Y=/^[0-9]+$/;function compareIdentifiers(e,t){var n=Y.test(e),i=Y.test(t);return n&&i&&(e=+e,t=+t),e===t?0:n&&!i?-1:i&&!n?1:e<t?-1:1}function compare(e,t,n){return new SemVer(e,n).compare(new SemVer(t,n))}function gt(e,t,n){return compare(e,t,n)>0}function lt(e,t,n){return compare(e,t,n)<0}function eq(e,t,n){return 0===compare(e,t,n)}function neq(e,t,n){return 0!==compare(e,t,n)}function gte(e,t,n){return compare(e,t,n)>=0}function lte(e,t,n){return compare(e,t,n)<=0}function cmp(e,t,n,i){switch(t){case"===":return"object"==typeof e&&(e=e.version),"object"==typeof n&&(n=n.version),e===n;case"!==":return"object"==typeof e&&(e=e.version),"object"==typeof n&&(n=n.version),e!==n;case"":case"=":case"==":return eq(e,n,i);case"!=":return neq(e,n,i);case">":return gt(e,n,i);case">=":
return gte(e,n,i);case"<":return lt(e,n,i);case"<=":return lte(e,n,i);default:throw new TypeError("Invalid operator: "+t)}}function Comparator(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof Comparator){if(e.loose===!!t.loose)return e;e=e.value}if(!(this instanceof Comparator))return new Comparator(e,t);i("comparator",e,t),this.options=t,this.loose=!!t.loose,this.parse(e),this.semver===K?this.value="":this.value=this.operator+this.semver.version,i("comp",this)}n.rcompareIdentifiers=function rcompareIdentifiers(e,t){return compareIdentifiers(t,e)},n.major=function major(e,t){return new SemVer(e,t).major},n.minor=function minor(e,t){return new SemVer(e,t).minor},n.patch=function patch(e,t){return new SemVer(e,t).patch},n.compare=compare,n.compareLoose=function compareLoose(e,t){return compare(e,t,!0)},n.rcompare=function rcompare(e,t,n){return compare(t,e,n)},n.sort=function sort(e,t){return e.sort((function(e,i){return n.compare(e,i,t)}))},
n.rsort=function rsort(e,t){return e.sort((function(e,i){return n.rcompare(e,i,t)}))},n.gt=gt,n.lt=lt,n.eq=eq,n.neq=neq,n.gte=gte,n.lte=lte,n.cmp=cmp,n.Comparator=Comparator;var K={};function Range(e,t){if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),e instanceof Range)return e.loose===!!t.loose&&e.includePrerelease===!!t.includePrerelease?e:new Range(e.raw,t);if(e instanceof Comparator)return new Range(e.value,t);if(!(this instanceof Range))return new Range(e,t);if(this.options=t,this.loose=!!t.loose,this.includePrerelease=!!t.includePrerelease,this.raw=e,this.set=e.split(/\s*\|\|\s*/).map((function(e){return this.parseRange(e.trim())}),this).filter((function(e){return e.length})),!this.set.length)throw new TypeError("Invalid SemVer Range: "+e);this.format()}function isX(e){return!e||"x"===e.toLowerCase()||"*"===e}function hyphenReplace(e,t,n,i,a,s,c,l,u,d,m,p,h){
return((t=isX(n)?"":isX(i)?">="+n+".0.0":isX(a)?">="+n+"."+i+".0":">="+t)+" "+(l=isX(u)?"":isX(d)?"<"+(+u+1)+".0.0":isX(m)?"<"+u+"."+(+d+1)+".0":p?"<="+u+"."+d+"."+m+"-"+p:"<="+l)).trim()}function testSet(e,t,n){for(var a=0;a<e.length;a++)if(!e[a].test(t))return!1;if(t.prerelease.length&&!n.includePrerelease){for(a=0;a<e.length;a++)if(i(e[a].semver),e[a].semver!==K&&e[a].semver.prerelease.length>0){var s=e[a].semver;if(s.major===t.major&&s.minor===t.minor&&s.patch===t.patch)return!0}return!1}return!0}function satisfies(e,t,n){try{t=new Range(t,n)}catch(e){return!1}return t.test(e)}function outside(e,t,n,i){var a,s,c,l,u;switch(e=new SemVer(e,i),t=new Range(t,i),n){case">":a=gt,s=lte,c=lt,l=">",u=">=";break;case"<":a=lt,s=gte,c=gt,l="<",u="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(satisfies(e,t,i))return!1;for(var d=0;d<t.set.length;++d){var m=t.set[d],p=null,h=null;if(m.forEach((function(e){e.semver===K&&(e=new Comparator(">=0.0.0")),p=p||e,
h=h||e,a(e.semver,p.semver,i)?p=e:c(e.semver,h.semver,i)&&(h=e)})),p.operator===l||p.operator===u)return!1;if((!h.operator||h.operator===l)&&s(e,h.semver))return!1;if(h.operator===u&&c(e,h.semver))return!1}return!0}Comparator.prototype.parse=function(e){var t=this.options.loose?s[q]:s[z],n=e.match(t);if(!n)throw new TypeError("Invalid comparator: "+e);this.operator=n[1],"="===this.operator&&(this.operator=""),n[2]?this.semver=new SemVer(n[2],this.options.loose):this.semver=K},Comparator.prototype.toString=function(){return this.value},Comparator.prototype.test=function(e){return i("Comparator.test",e,this.options.loose),this.semver===K||("string"==typeof e&&(e=new SemVer(e,this.options)),cmp(e,this.operator,this.semver,this.options))},Comparator.prototype.intersects=function(e,t){if(!(e instanceof Comparator))throw new TypeError("a Comparator is required");var n;if(t&&"object"==typeof t||(t={loose:!!t,includePrerelease:!1}),""===this.operator)return n=new Range(e.value,t),
satisfies(this.value,n,t);if(""===e.operator)return n=new Range(this.value,t),satisfies(e.semver,n,t);var i=!(">="!==this.operator&&">"!==this.operator||">="!==e.operator&&">"!==e.operator),a=!("<="!==this.operator&&"<"!==this.operator||"<="!==e.operator&&"<"!==e.operator),s=this.semver.version===e.semver.version,c=!(">="!==this.operator&&"<="!==this.operator||">="!==e.operator&&"<="!==e.operator),l=cmp(this.semver,"<",e.semver,t)&&(">="===this.operator||">"===this.operator)&&("<="===e.operator||"<"===e.operator),u=cmp(this.semver,">",e.semver,t)&&("<="===this.operator||"<"===this.operator)&&(">="===e.operator||">"===e.operator);return i||a||s&&c||l||u},n.Range=Range,Range.prototype.format=function(){return this.range=this.set.map((function(e){return e.join(" ").trim()})).join("||").trim(),this.range},Range.prototype.toString=function(){return this.range},Range.prototype.parseRange=function(e){var t=this.options.loose;e=e.trim();var n=t?s[H]:s[W];e=e.replace(n,hyphenReplace),
i("hyphen replace",e),e=e.replace(s[V],"$1$2$3"),i("comparator trim",e,s[V]),e=(e=(e=e.replace(s[L],"$1~")).replace(s[F],"$1^")).split(/\s+/).join(" ");var a=t?s[q]:s[z],c=e.split(" ").map((function(e){return function parseComparator(e,t){return i("comp",e,t),e=function replaceCarets(e,t){return e.trim().split(/\s+/).map((function(e){return function replaceCaret(e,t){i("caret",e,t);var n=t.loose?s[B]:s[U];return e.replace(n,(function(t,n,a,s,c){var l;return i("caret",e,t,n,a,s,c),isX(n)?l="":isX(a)?l=">="+n+".0.0 <"+(+n+1)+".0.0":isX(s)?l="0"===n?">="+n+"."+a+".0 <"+n+"."+(+a+1)+".0":">="+n+"."+a+".0 <"+(+n+1)+".0.0":c?(i("replaceCaret pr",c),l="0"===n?"0"===a?">="+n+"."+a+"."+s+"-"+c+" <"+n+"."+a+"."+(+s+1):">="+n+"."+a+"."+s+"-"+c+" <"+n+"."+(+a+1)+".0":">="+n+"."+a+"."+s+"-"+c+" <"+(+n+1)+".0.0"):(i("no pr"),l="0"===n?"0"===a?">="+n+"."+a+"."+s+" <"+n+"."+a+"."+(+s+1):">="+n+"."+a+"."+s+" <"+n+"."+(+a+1)+".0":">="+n+"."+a+"."+s+" <"+(+n+1)+".0.0"),i("caret return",l),l}))}(e,t)
})).join(" ")}(e,t),i("caret",e),e=function replaceTildes(e,t){return e.trim().split(/\s+/).map((function(e){return function replaceTilde(e,t){var n=t.loose?s[P]:s[M];return e.replace(n,(function(t,n,a,s,c){var l;return i("tilde",e,t,n,a,s,c),isX(n)?l="":isX(a)?l=">="+n+".0.0 <"+(+n+1)+".0.0":isX(s)?l=">="+n+"."+a+".0 <"+n+"."+(+a+1)+".0":c?(i("replaceTilde pr",c),l=">="+n+"."+a+"."+s+"-"+c+" <"+n+"."+(+a+1)+".0"):l=">="+n+"."+a+"."+s+" <"+n+"."+(+a+1)+".0",i("tilde return",l),l}))}(e,t)})).join(" ")}(e,t),i("tildes",e),e=function replaceXRanges(e,t){return i("replaceXRanges",e,t),e.split(/\s+/).map((function(e){return function replaceXRange(e,t){e=e.trim();var n=t.loose?s[C]:s[I];return e.replace(n,(function(t,n,a,s,c,l){i("xRange",e,t,n,a,s,c,l);var u=isX(a),d=u||isX(s),m=d||isX(c);return"="===n&&m&&(n=""),u?t=">"===n||"<"===n?"<0.0.0":"*":n&&m?(d&&(s=0),c=0,">"===n?(n=">=",d?(a=+a+1,s=0,c=0):(s=+s+1,c=0)):"<="===n&&(n="<",d?a=+a+1:s=+s+1),
t=n+a+"."+s+"."+c):d?t=">="+a+".0.0 <"+(+a+1)+".0.0":m&&(t=">="+a+"."+s+".0 <"+a+"."+(+s+1)+".0"),i("xRange return",t),t}))}(e,t)})).join(" ")}(e,t),i("xrange",e),e=function replaceStars(e,t){return i("replaceStars",e,t),e.trim().replace(s[G],"")}(e,t),i("stars",e),e}(e,this.options)}),this).join(" ").split(/\s+/);return this.options.loose&&(c=c.filter((function(e){return!!e.match(a)}))),c=c.map((function(e){return new Comparator(e,this.options)}),this)},Range.prototype.intersects=function(e,t){if(!(e instanceof Range))throw new TypeError("a Range is required");return this.set.some((function(n){return n.every((function(n){return e.set.some((function(e){return e.every((function(e){return n.intersects(e,t)}))}))}))}))},n.toComparators=function toComparators(e,t){return new Range(e,t).set.map((function(e){return e.map((function(e){return e.value})).join(" ").trim().split(" ")}))},Range.prototype.test=function(e){if(!e)return!1;"string"==typeof e&&(e=new SemVer(e,this.options))
;for(var t=0;t<this.set.length;t++)if(testSet(this.set[t],e,this.options))return!0;return!1},n.satisfies=satisfies,n.maxSatisfying=function maxSatisfying(e,t,n){var i=null,a=null;try{var s=new Range(t,n)}catch(e){return null}return e.forEach((function(e){s.test(e)&&(i&&-1!==a.compare(e)||(a=new SemVer(i=e,n)))})),i},n.minSatisfying=function minSatisfying(e,t,n){var i=null,a=null;try{var s=new Range(t,n)}catch(e){return null}return e.forEach((function(e){s.test(e)&&(i&&1!==a.compare(e)||(a=new SemVer(i=e,n)))})),i},n.minVersion=function minVersion(e,t){e=new Range(e,t);var n=new SemVer("0.0.0");if(e.test(n))return n;if(n=new SemVer("0.0.0-0"),e.test(n))return n;n=null;for(var i=0;i<e.set.length;++i){e.set[i].forEach((function(e){var t=new SemVer(e.semver.version);switch(e.operator){case">":0===t.prerelease.length?t.patch++:t.prerelease.push(0),t.raw=t.format();case"":case">=":n&&!gt(n,t)||(n=t);break;case"<":case"<=":break;default:throw new Error("Unexpected operation: "+e.operator)}}))
}if(n&&e.test(n))return n;return null},n.validRange=function validRange(e,t){try{return new Range(e,t).range||"*"}catch(e){return null}},n.ltr=function ltr(e,t,n){return outside(e,t,"<",n)},n.gtr=function gtr(e,t,n){return outside(e,t,">",n)},n.outside=outside,n.prerelease=function prerelease(e,t){var n=parse(e,t);return n&&n.prerelease.length?n.prerelease:null},n.intersects=function intersects(e,t,n){return e=new Range(e,n),t=new Range(t,n),e.intersects(t)},n.coerce=function coerce(e){if(e instanceof SemVer)return e;if("string"!=typeof e)return null;var t=e.match(s[j]);if(null==t)return null;return parse(t[1]+"."+(t[2]||"0")+"."+(t[3]||"0"))}}).call(this)}).call(this,e("_process"))},{_process:223}],231:[function(e,t,n){(function(n){(function(){"use strict";const i=e("fs"),a=e("jpeg-js");function getPixel(e,t,n,i,a){return a[4*(e+t*i)+n]}function isWhitePixel(e,t,n){return getPixel(e,t,0,n.width,n.data)>=249&&getPixel(e,t,1,n.width,n.data)>=249&&getPixel(e,t,2,n.width,n.data)>=249}
function frame(e,t){let n=null,i=null,s=null,c=null,l=null,u=null;return{getHistogram:function(){if(n)return n;const e=this.getParsedImage();return n=function convertPixelsToHistogram(e){const createHistogramArray=function(){const e=[];for(let t=0;t<256;t++)e[t]=0;return e},t=e.width,n=e.height,i=[createHistogramArray(),createHistogramArray(),createHistogramArray()];for(let a=0;a<n;a++)for(let n=0;n<t;n++)if(!isWhitePixel(n,a,e))for(let s=0;s<i.length;s++){const c=getPixel(n,a,s,t,e.data);i[s][c]++}return i}(e),n},getTimeStamp:function(){return t},setProgress:function(e,t){i=e,s=Boolean(t)},setPerceptualProgress:function(e,t){c=e,l=Boolean(t)},getImage:function(){return e},getParsedImage:function(){return u||(u=a.decode(e)),u},getProgress:function(){return i},isProgressInterpolated:function(){return s},getPerceptualProgress:function(){return c},isPerceptualProgressInterpolated:function(){return l}}}t.exports={extractFramesFromTimeline:function extractFramesFromTimeline(e,t){let s
;t=t||{},e="string"==typeof e?i.readFileSync(e,"utf-8"):e;try{s="string"==typeof e?JSON.parse(e):e}catch(e){throw new Error("Speedline: Invalid JSON"+e.message)}let c=s.traceEvents||s,l=Number.MAX_VALUE,u=-Number.MAX_VALUE;c.forEach((e=>{0!==e.ts&&(l=Math.min(l,e.ts),u=Math.max(u,e.ts))})),l=(t.timeOrigin||l)/1e3,u/=1e3;let d=null;const m=c.filter((e=>e.cat.includes("disabled-by-default-devtools.screenshot")&&e.ts>=1e3*l));m.sort(((e,t)=>e.ts-t.ts));const p=m.map((function(e){const t=e.args&&e.args.snapshot,i=e.ts/1e3;if(t===d)return null;d=t;return frame(n.from(t,"base64"),i)})).filter(Boolean);if(0===p.length)return Promise.reject(new Error("No screenshots found in trace"));const h=frame(function synthesizeWhiteFrame(e){const t=a.decode(e[0].getImage()),i=t.width,s=t.height,c=n.alloc(i*s*4);let l=0;for(;l<c.length;)c[l++]=255,c[l++]=255,c[l++]=255,c[l++]=255;return a.encode({data:c,width:i,height:s}).data}(p),l);p.unshift(h);const f={startTs:l,endTs:u,frames:p}
;return Promise.resolve(f)},create:frame}}).call(this)}).call(this,e("buffer").Buffer)},{buffer:145,fs:144,"jpeg-js":185}],232:[function(e,t,n){"use strict";const i=e("./frame"),a=e("./speed-index");const s={All:"all",pSI:"perceptualSpeedIndex",SI:"speedIndex"};t.exports=function(e,t){const n=t&&t.include||s.All;if(!Object.keys(s).some((e=>s[e]===n)))throw new Error("Unrecognized include option: "+n);return i.extractFramesFromTimeline(e,t).then((function(e){const i=e.frames;return n!==s.All&&n!==s.SI||a.calculateVisualProgress(i,t),n!==s.All&&n!==s.pSI||a.calculatePerceptualProgress(i,t),function calculateValues(e,t){const n=a.calculateSpeedIndexes(e,t),i=Math.floor(t.endTs-t.startTs),s=Math.floor(n.firstPaintTs-t.startTs),c=Math.floor(n.visuallyCompleteTs-t.startTs);return{beginning:t.startTs,end:t.endTs,frames:e,first:s,complete:c,duration:i,speedIndex:n.speedIndex,perceptualSpeedIndex:n.perceptualSpeedIndex}}(i,e)}))}},{"./frame":231,"./speed-index":233}],233:[function(e,t,n){
"use strict";const i=e("image-ssim"),a=Math.log(4/6);function calculateFastModeAllowableChange(e){const t=e/1e3;return 6*Math.exp(a*t)-1}function calculateProgressBetweenFrames(e,t,n,i,a,s){if(!i)return void e.forEach((e=>s(e,a(e),!1)));const c=e[t],l=e[n],u=l.getTimeStamp()-c.getTimeStamp(),d=a(c),m=a(l);if(s(c,d,!1),s(l,m,!1),Math.abs(d-m)<calculateFastModeAllowableChange(u))for(let i=t+1;i<n;i++)s(e[i],d,!0);else if(n-t>1){const c=Math.floor((t+n)/2);calculateProgressBetweenFrames(e,t,c,i,a,s),calculateProgressBetweenFrames(e,c,n,i,a,s)}}function calculateFrameSimilarity(e,t){const n={channels:4},a=Object.assign(e.getParsedImage(),n),s=Object.assign(t.getParsedImage(),n);return i.compare(a,s).ssim}t.exports={calculateFastModeAllowableChange,calculateFrameSimilarity,calculateVisualProgress:function calculateVisualProgress(e,t){const n=e[0],i=e[e.length-1];return calculateProgressBetweenFrames(e,0,e.length-1,t&&t.fastMode,(function getProgress(e){
return"number"==typeof e.getProgress()?e.getProgress():function calculateFrameProgress(e,t,n){let i=0,a=0;const s=e.getHistogram(),c=t.getHistogram(),l=n.getHistogram();for(let e=0;e<3;e++)for(let t=0;t<256;t++){const n=s[e][t],u=c[e][t],d=l[e][t],m=Math.abs(n-u),p=Math.abs(d-u);a+=Math.min(m,p),i+=p}let u;return u=0===a&&0===i?100:Math.floor(a/i*100),u}(e,n,i)}),(function setProgress(e,t,n){return e.setProgress(t,n)})),e},calculatePerceptualProgress:function calculatePerceptualProgress(e,t){const n=e[0],i=e[e.length-1],a=calculateFrameSimilarity(n,i);return calculateProgressBetweenFrames(e,0,e.length-1,t&&t.fastMode,(function getProgress(e){if("number"==typeof e.getPerceptualProgress())return e.getPerceptualProgress();const t=calculateFrameSimilarity(e,i);return Math.max(100*(t-a)/(1-a),0)}),(function setProgress(e,t,n){return e.setPerceptualProgress(t,n)})),e},calculateSpeedIndexes:function calculateSpeedIndexes(e,t){
const n="number"==typeof e[0].getProgress(),i="number"==typeof e[0].getPerceptualProgress(),a=n?"getProgress":"getPerceptualProgress",s=t.startTs;let c,l;for(let t=0;t<e.length&&!l;t++)e[t][a]()>0&&(l=e[t].getTimeStamp());for(let t=0;t<e.length&&!c;t++)e[t][a]()>=100&&(c=e[t].getTimeStamp());let u=e[0].getTimeStamp(),d=e[0].getProgress(),m=e[0].getPerceptualProgress(),p=l-s,h=l-s;return e.forEach((function(e){if(e.getTimeStamp()>l){const t=e.getTimeStamp()-u;p+=t*(1-d),h+=t*(1-m)}u=e.getTimeStamp(),d=e.getProgress()/100,m=e.getPerceptualProgress()/100})),p=n?p:void 0,h=i?h:void 0,{firstPaintTs:l,visuallyCompleteTs:c,speedIndex:p,perceptualSpeedIndex:h}}}},{"image-ssim":173}],234:[function(e,t,n){t.exports=Stream;var i=e("events").EventEmitter;function Stream(){i.call(this)}e("inherits")(Stream,i),Stream.Readable=e("readable-stream/lib/_stream_readable.js"),Stream.Writable=e("readable-stream/lib/_stream_writable.js"),Stream.Duplex=e("readable-stream/lib/_stream_duplex.js"),
Stream.Transform=e("readable-stream/lib/_stream_transform.js"),Stream.PassThrough=e("readable-stream/lib/_stream_passthrough.js"),Stream.finished=e("readable-stream/lib/internal/streams/end-of-stream.js"),Stream.pipeline=e("readable-stream/lib/internal/streams/pipeline.js"),Stream.Stream=Stream,Stream.prototype.pipe=function(e,t){var n=this;function ondata(t){e.writable&&!1===e.write(t)&&n.pause&&n.pause()}function ondrain(){n.readable&&n.resume&&n.resume()}n.on("data",ondata),e.on("drain",ondrain),e._isStdio||t&&!1===t.end||(n.on("end",onend),n.on("close",onclose));var a=!1;function onend(){a||(a=!0,e.end())}function onclose(){a||(a=!0,"function"==typeof e.destroy&&e.destroy())}function onerror(e){if(cleanup(),0===i.listenerCount(this,"error"))throw e}function cleanup(){n.removeListener("data",ondata),e.removeListener("drain",ondrain),n.removeListener("end",onend),n.removeListener("close",onclose),n.removeListener("error",onerror),e.removeListener("error",onerror),
n.removeListener("end",cleanup),n.removeListener("close",cleanup),e.removeListener("close",cleanup)}return n.on("error",onerror),e.on("error",onerror),n.on("end",cleanup),n.on("close",cleanup),e.on("close",cleanup),e.emit("pipe",n),e}},{events:162,inherits:174,"readable-stream/lib/_stream_duplex.js":236,"readable-stream/lib/_stream_passthrough.js":237,"readable-stream/lib/_stream_readable.js":238,"readable-stream/lib/_stream_transform.js":239,"readable-stream/lib/_stream_writable.js":240,"readable-stream/lib/internal/streams/end-of-stream.js":244,"readable-stream/lib/internal/streams/pipeline.js":246}],235:[function(e,t,n){"use strict";var i={};function createErrorType(e,t,n){n||(n=Error);var a=function(e){function NodeError(n,i,a){return e.call(this,function getMessage(e,n,i){return"string"==typeof t?t:t(e,n,i)}(n,i,a))||this}return function _inheritsLoose(e,t){e.prototype=Object.create(t.prototype),e.prototype.constructor=e,e.__proto__=t}(NodeError,e),NodeError}(n)
;a.prototype.name=n.name,a.prototype.code=e,i[e]=a}function oneOf(e,t){if(Array.isArray(e)){var n=e.length;return e=e.map((function(e){return String(e)})),n>2?"one of ".concat(t," ").concat(e.slice(0,n-1).join(", "),", or ")+e[n-1]:2===n?"one of ".concat(t," ").concat(e[0]," or ").concat(e[1]):"of ".concat(t," ").concat(e[0])}return"of ".concat(t," ").concat(String(e))}createErrorType("ERR_INVALID_OPT_VALUE",(function(e,t){return'The value "'+t+'" is invalid for option "'+e+'"'}),TypeError),createErrorType("ERR_INVALID_ARG_TYPE",(function(e,t,n){var i,a;if("string"==typeof t&&function startsWith(e,t,n){return e.substr(!n||n<0?0:+n,t.length)===t}(t,"not ")?(i="must not be",t=t.replace(/^not /,"")):i="must be",function endsWith(e,t,n){return(void 0===n||n>e.length)&&(n=e.length),e.substring(n-t.length,n)===t}(e," argument"))a="The ".concat(e," ").concat(i," ").concat(oneOf(t,"type"));else{var s=function includes(e,t,n){return"number"!=typeof n&&(n=0),
!(n+t.length>e.length)&&-1!==e.indexOf(t,n)}(e,".")?"property":"argument";a='The "'.concat(e,'" ').concat(s," ").concat(i," ").concat(oneOf(t,"type"))}return a+=". Received type ".concat(typeof n)}),TypeError),createErrorType("ERR_STREAM_PUSH_AFTER_EOF","stream.push() after EOF"),createErrorType("ERR_METHOD_NOT_IMPLEMENTED",(function(e){return"The "+e+" method is not implemented"})),createErrorType("ERR_STREAM_PREMATURE_CLOSE","Premature close"),createErrorType("ERR_STREAM_DESTROYED",(function(e){return"Cannot call "+e+" after a stream was destroyed"})),createErrorType("ERR_MULTIPLE_CALLBACK","Callback called multiple times"),createErrorType("ERR_STREAM_CANNOT_PIPE","Cannot pipe, not readable"),createErrorType("ERR_STREAM_WRITE_AFTER_END","write after end"),createErrorType("ERR_STREAM_NULL_VALUES","May not write null values to stream",TypeError),createErrorType("ERR_UNKNOWN_ENCODING",(function(e){return"Unknown encoding: "+e}),TypeError),
createErrorType("ERR_STREAM_UNSHIFT_AFTER_END_EVENT","stream.unshift() after end event"),t.exports.codes=i},{}],236:[function(e,t,n){(function(n){(function(){"use strict";var i=Object.keys||function(e){var t=[];for(var n in e)t.push(n);return t};t.exports=Duplex;var a=e("./_stream_readable"),s=e("./_stream_writable");e("inherits")(Duplex,a);for(var c=i(s.prototype),l=0;l<c.length;l++){var u=c[l];Duplex.prototype[u]||(Duplex.prototype[u]=s.prototype[u])}function Duplex(e){if(!(this instanceof Duplex))return new Duplex(e);a.call(this,e),s.call(this,e),this.allowHalfOpen=!0,e&&(!1===e.readable&&(this.readable=!1),!1===e.writable&&(this.writable=!1),!1===e.allowHalfOpen&&(this.allowHalfOpen=!1,this.once("end",onend)))}function onend(){this._writableState.ended||n.nextTick(onEndNT,this)}function onEndNT(e){e.end()}Object.defineProperty(Duplex.prototype,"writableHighWaterMark",{enumerable:!1,get:function get(){return this._writableState.highWaterMark}}),
Object.defineProperty(Duplex.prototype,"writableBuffer",{enumerable:!1,get:function get(){return this._writableState&&this._writableState.getBuffer()}}),Object.defineProperty(Duplex.prototype,"writableLength",{enumerable:!1,get:function get(){return this._writableState.length}}),Object.defineProperty(Duplex.prototype,"destroyed",{enumerable:!1,get:function get(){return void 0!==this._readableState&&void 0!==this._writableState&&(this._readableState.destroyed&&this._writableState.destroyed)},set:function set(e){void 0!==this._readableState&&void 0!==this._writableState&&(this._readableState.destroyed=e,this._writableState.destroyed=e)}})}).call(this)}).call(this,e("_process"))},{"./_stream_readable":238,"./_stream_writable":240,_process:223,inherits:174}],237:[function(e,t,n){"use strict";t.exports=PassThrough;var i=e("./_stream_transform");function PassThrough(e){if(!(this instanceof PassThrough))return new PassThrough(e);i.call(this,e)}e("inherits")(PassThrough,i),
PassThrough.prototype._transform=function(e,t,n){n(null,e)}},{"./_stream_transform":239,inherits:174}],238:[function(e,t,n){(function(n,i){(function(){"use strict";var a;t.exports=Readable,Readable.ReadableState=ReadableState;e("events").EventEmitter;var s=function EElistenerCount(e,t){return e.listeners(t).length},c=e("./internal/streams/stream"),l=e("buffer").Buffer,u=i.Uint8Array||function(){};var d,m=e("util");d=m&&m.debuglog?m.debuglog("stream"):function debug(){};var p,h,f,g=e("./internal/streams/buffer_list"),y=e("./internal/streams/destroy"),b=e("./internal/streams/state").getHighWaterMark,v=e("../errors").codes,w=v.ERR_INVALID_ARG_TYPE,S=v.ERR_STREAM_PUSH_AFTER_EOF,T=v.ERR_METHOD_NOT_IMPLEMENTED,E=v.ERR_STREAM_UNSHIFT_AFTER_END_EVENT;e("inherits")(Readable,c);var _=y.errorOrDestroy,x=["error","close","destroy","pause","resume"];function ReadableState(t,n,i){a=a||e("./_stream_duplex"),t=t||{},"boolean"!=typeof i&&(i=n instanceof a),this.objectMode=!!t.objectMode,
i&&(this.objectMode=this.objectMode||!!t.readableObjectMode),this.highWaterMark=b(this,t,"readableHighWaterMark",i),this.buffer=new g,this.length=0,this.pipes=null,this.pipesCount=0,this.flowing=null,this.ended=!1,this.endEmitted=!1,this.reading=!1,this.sync=!0,this.needReadable=!1,this.emittedReadable=!1,this.readableListening=!1,this.resumeScheduled=!1,this.paused=!0,this.emitClose=!1!==t.emitClose,this.autoDestroy=!!t.autoDestroy,this.destroyed=!1,this.defaultEncoding=t.defaultEncoding||"utf8",this.awaitDrain=0,this.readingMore=!1,this.decoder=null,this.encoding=null,t.encoding&&(p||(p=e("string_decoder/").StringDecoder),this.decoder=new p(t.encoding),this.encoding=t.encoding)}function Readable(t){if(a=a||e("./_stream_duplex"),!(this instanceof Readable))return new Readable(t);var n=this instanceof a;this._readableState=new ReadableState(t,this,n),this.readable=!0,t&&("function"==typeof t.read&&(this._read=t.read),"function"==typeof t.destroy&&(this._destroy=t.destroy)),c.call(this)
}function readableAddChunk(e,t,n,i,a){d("readableAddChunk",t);var s,c=e._readableState;if(null===t)c.reading=!1,function onEofChunk(e,t){if(d("onEofChunk"),t.ended)return;if(t.decoder){var n=t.decoder.end();n&&n.length&&(t.buffer.push(n),t.length+=t.objectMode?1:n.length)}t.ended=!0,t.sync?emitReadable(e):(t.needReadable=!1,t.emittedReadable||(t.emittedReadable=!0,emitReadable_(e)))}(e,c);else if(a||(s=function chunkInvalid(e,t){var n;(function _isUint8Array(e){return l.isBuffer(e)||e instanceof u})(t)||"string"==typeof t||void 0===t||e.objectMode||(n=new w("chunk",["string","Buffer","Uint8Array"],t));return n}(c,t)),s)_(e,s);else if(c.objectMode||t&&t.length>0)if("string"==typeof t||c.objectMode||Object.getPrototypeOf(t)===l.prototype||(t=function _uint8ArrayToBuffer(e){return l.from(e)}(t)),i)c.endEmitted?_(e,new E):addChunk(e,c,t,!0);else if(c.ended)_(e,new S);else{if(c.destroyed)return!1;c.reading=!1,c.decoder&&!n?(t=c.decoder.write(t),
c.objectMode||0!==t.length?addChunk(e,c,t,!1):maybeReadMore(e,c)):addChunk(e,c,t,!1)}else i||(c.reading=!1,maybeReadMore(e,c));return!c.ended&&(c.length<c.highWaterMark||0===c.length)}function addChunk(e,t,n,i){t.flowing&&0===t.length&&!t.sync?(t.awaitDrain=0,e.emit("data",n)):(t.length+=t.objectMode?1:n.length,i?t.buffer.unshift(n):t.buffer.push(n),t.needReadable&&emitReadable(e)),maybeReadMore(e,t)}Object.defineProperty(Readable.prototype,"destroyed",{enumerable:!1,get:function get(){return void 0!==this._readableState&&this._readableState.destroyed},set:function set(e){this._readableState&&(this._readableState.destroyed=e)}}),Readable.prototype.destroy=y.destroy,Readable.prototype._undestroy=y.undestroy,Readable.prototype._destroy=function(e,t){t(e)},Readable.prototype.push=function(e,t){var n,i=this._readableState;return i.objectMode?n=!0:"string"==typeof e&&((t=t||i.defaultEncoding)!==i.encoding&&(e=l.from(e,t),t=""),n=!0),readableAddChunk(this,e,t,!1,n)},
Readable.prototype.unshift=function(e){return readableAddChunk(this,e,null,!0,!1)},Readable.prototype.isPaused=function(){return!1===this._readableState.flowing},Readable.prototype.setEncoding=function(t){p||(p=e("string_decoder/").StringDecoder);var n=new p(t);this._readableState.decoder=n,this._readableState.encoding=this._readableState.decoder.encoding;for(var i=this._readableState.buffer.head,a="";null!==i;)a+=n.write(i.data),i=i.next;return this._readableState.buffer.clear(),""!==a&&this._readableState.buffer.push(a),this._readableState.length=a.length,this};var A=1073741824;function howMuchToRead(e,t){return e<=0||0===t.length&&t.ended?0:t.objectMode?1:e!=e?t.flowing&&t.length?t.buffer.head.data.length:t.length:(e>t.highWaterMark&&(t.highWaterMark=function computeNewHighWaterMark(e){return e>=A?e=A:(e--,e|=e>>>1,e|=e>>>2,e|=e>>>4,e|=e>>>8,e|=e>>>16,e++),e}(e)),e<=t.length?e:t.ended?t.length:(t.needReadable=!0,0))}function emitReadable(e){var t=e._readableState
;d("emitReadable",t.needReadable,t.emittedReadable),t.needReadable=!1,t.emittedReadable||(d("emitReadable",t.flowing),t.emittedReadable=!0,n.nextTick(emitReadable_,e))}function emitReadable_(e){var t=e._readableState;d("emitReadable_",t.destroyed,t.length,t.ended),t.destroyed||!t.length&&!t.ended||(e.emit("readable"),t.emittedReadable=!1),t.needReadable=!t.flowing&&!t.ended&&t.length<=t.highWaterMark,flow(e)}function maybeReadMore(e,t){t.readingMore||(t.readingMore=!0,n.nextTick(maybeReadMore_,e,t))}function maybeReadMore_(e,t){for(;!t.reading&&!t.ended&&(t.length<t.highWaterMark||t.flowing&&0===t.length);){var n=t.length;if(d("maybeReadMore read 0"),e.read(0),n===t.length)break}t.readingMore=!1}function updateReadableListening(e){var t=e._readableState;t.readableListening=e.listenerCount("readable")>0,t.resumeScheduled&&!t.paused?t.flowing=!0:e.listenerCount("data")>0&&e.resume()}function nReadingNextTick(e){d("readable nexttick read 0"),e.read(0)}function resume_(e,t){
d("resume",t.reading),t.reading||e.read(0),t.resumeScheduled=!1,e.emit("resume"),flow(e),t.flowing&&!t.reading&&e.read(0)}function flow(e){var t=e._readableState;for(d("flow",t.flowing);t.flowing&&null!==e.read(););}function fromList(e,t){return 0===t.length?null:(t.objectMode?n=t.buffer.shift():!e||e>=t.length?(n=t.decoder?t.buffer.join(""):1===t.buffer.length?t.buffer.first():t.buffer.concat(t.length),t.buffer.clear()):n=t.buffer.consume(e,t.decoder),n);var n}function endReadable(e){var t=e._readableState;d("endReadable",t.endEmitted),t.endEmitted||(t.ended=!0,n.nextTick(endReadableNT,t,e))}function endReadableNT(e,t){if(d("endReadableNT",e.endEmitted,e.length),!e.endEmitted&&0===e.length&&(e.endEmitted=!0,t.readable=!1,t.emit("end"),e.autoDestroy)){var n=t._writableState;(!n||n.autoDestroy&&n.finished)&&t.destroy()}}function indexOf(e,t){for(var n=0,i=e.length;n<i;n++)if(e[n]===t)return n;return-1}Readable.prototype.read=function(e){d("read",e),e=parseInt(e,10)
;var t=this._readableState,n=e;if(0!==e&&(t.emittedReadable=!1),0===e&&t.needReadable&&((0!==t.highWaterMark?t.length>=t.highWaterMark:t.length>0)||t.ended))return d("read: emitReadable",t.length,t.ended),0===t.length&&t.ended?endReadable(this):emitReadable(this),null;if(0===(e=howMuchToRead(e,t))&&t.ended)return 0===t.length&&endReadable(this),null;var i,a=t.needReadable;return d("need readable",a),(0===t.length||t.length-e<t.highWaterMark)&&d("length less than watermark",a=!0),t.ended||t.reading?d("reading or ended",a=!1):a&&(d("do read"),t.reading=!0,t.sync=!0,0===t.length&&(t.needReadable=!0),this._read(t.highWaterMark),t.sync=!1,t.reading||(e=howMuchToRead(n,t))),null===(i=e>0?fromList(e,t):null)?(t.needReadable=t.length<=t.highWaterMark,e=0):(t.length-=e,t.awaitDrain=0),0===t.length&&(t.ended||(t.needReadable=!0),n!==e&&t.ended&&endReadable(this)),null!==i&&this.emit("data",i),i},Readable.prototype._read=function(e){_(this,new T("_read()"))},Readable.prototype.pipe=function(e,t){
var i=this,a=this._readableState;switch(a.pipesCount){case 0:a.pipes=e;break;case 1:a.pipes=[a.pipes,e];break;default:a.pipes.push(e)}a.pipesCount+=1,d("pipe count=%d opts=%j",a.pipesCount,t);var c=(!t||!1!==t.end)&&e!==n.stdout&&e!==n.stderr?onend:unpipe;function onunpipe(t,n){d("onunpipe"),t===i&&n&&!1===n.hasUnpiped&&(n.hasUnpiped=!0,function cleanup(){d("cleanup"),e.removeListener("close",onclose),e.removeListener("finish",onfinish),e.removeListener("drain",l),e.removeListener("error",onerror),e.removeListener("unpipe",onunpipe),i.removeListener("end",onend),i.removeListener("end",unpipe),i.removeListener("data",ondata),u=!0,!a.awaitDrain||e._writableState&&!e._writableState.needDrain||l()}())}function onend(){d("onend"),e.end()}a.endEmitted?n.nextTick(c):i.once("end",c),e.on("unpipe",onunpipe);var l=function pipeOnDrain(e){return function pipeOnDrainFunctionResult(){var t=e._readableState;d("pipeOnDrain",t.awaitDrain),t.awaitDrain&&t.awaitDrain--,
0===t.awaitDrain&&s(e,"data")&&(t.flowing=!0,flow(e))}}(i);e.on("drain",l);var u=!1;function ondata(t){d("ondata");var n=e.write(t);d("dest.write",n),!1===n&&((1===a.pipesCount&&a.pipes===e||a.pipesCount>1&&-1!==indexOf(a.pipes,e))&&!u&&(d("false write response, pause",a.awaitDrain),a.awaitDrain++),i.pause())}function onerror(t){d("onerror",t),unpipe(),e.removeListener("error",onerror),0===s(e,"error")&&_(e,t)}function onclose(){e.removeListener("finish",onfinish),unpipe()}function onfinish(){d("onfinish"),e.removeListener("close",onclose),unpipe()}function unpipe(){d("unpipe"),i.unpipe(e)}return i.on("data",ondata),function prependListener(e,t,n){if("function"==typeof e.prependListener)return e.prependListener(t,n);e._events&&e._events[t]?Array.isArray(e._events[t])?e._events[t].unshift(n):e._events[t]=[n,e._events[t]]:e.on(t,n)}(e,"error",onerror),e.once("close",onclose),e.once("finish",onfinish),e.emit("pipe",i),a.flowing||(d("pipe resume"),i.resume()),e},
Readable.prototype.unpipe=function(e){var t=this._readableState,n={hasUnpiped:!1};if(0===t.pipesCount)return this;if(1===t.pipesCount)return e&&e!==t.pipes||(e||(e=t.pipes),t.pipes=null,t.pipesCount=0,t.flowing=!1,e&&e.emit("unpipe",this,n)),this;if(!e){var i=t.pipes,a=t.pipesCount;t.pipes=null,t.pipesCount=0,t.flowing=!1;for(var s=0;s<a;s++)i[s].emit("unpipe",this,{hasUnpiped:!1});return this}var c=indexOf(t.pipes,e);return-1===c||(t.pipes.splice(c,1),t.pipesCount-=1,1===t.pipesCount&&(t.pipes=t.pipes[0]),e.emit("unpipe",this,n)),this},Readable.prototype.on=function(e,t){var i=c.prototype.on.call(this,e,t),a=this._readableState;return"data"===e?(a.readableListening=this.listenerCount("readable")>0,!1!==a.flowing&&this.resume()):"readable"===e&&(a.endEmitted||a.readableListening||(a.readableListening=a.needReadable=!0,a.flowing=!1,a.emittedReadable=!1,d("on readable",a.length,a.reading),a.length?emitReadable(this):a.reading||n.nextTick(nReadingNextTick,this))),i},
Readable.prototype.addListener=Readable.prototype.on,Readable.prototype.removeListener=function(e,t){var i=c.prototype.removeListener.call(this,e,t);return"readable"===e&&n.nextTick(updateReadableListening,this),i},Readable.prototype.removeAllListeners=function(e){var t=c.prototype.removeAllListeners.apply(this,arguments);return"readable"!==e&&void 0!==e||n.nextTick(updateReadableListening,this),t},Readable.prototype.resume=function(){var e=this._readableState;return e.flowing||(d("resume"),e.flowing=!e.readableListening,function resume(e,t){t.resumeScheduled||(t.resumeScheduled=!0,n.nextTick(resume_,e,t))}(this,e)),e.paused=!1,this},Readable.prototype.pause=function(){return d("call pause flowing=%j",this._readableState.flowing),!1!==this._readableState.flowing&&(d("pause"),this._readableState.flowing=!1,this.emit("pause")),this._readableState.paused=!0,this},Readable.prototype.wrap=function(e){var t=this,n=this._readableState,i=!1;for(var a in e.on("end",(function(){
if(d("wrapped end"),n.decoder&&!n.ended){var e=n.decoder.end();e&&e.length&&t.push(e)}t.push(null)})),e.on("data",(function(a){(d("wrapped data"),n.decoder&&(a=n.decoder.write(a)),n.objectMode&&null==a)||(n.objectMode||a&&a.length)&&(t.push(a)||(i=!0,e.pause()))})),e)void 0===this[a]&&"function"==typeof e[a]&&(this[a]=function methodWrap(t){return function methodWrapReturnFunction(){return e[t].apply(e,arguments)}}(a));for(var s=0;s<x.length;s++)e.on(x[s],this.emit.bind(this,x[s]));return this._read=function(t){d("wrapped _read",t),i&&(i=!1,e.resume())},this},"function"==typeof Symbol&&(Readable.prototype[Symbol.asyncIterator]=function(){return void 0===h&&(h=e("./internal/streams/async_iterator")),h(this)}),Object.defineProperty(Readable.prototype,"readableHighWaterMark",{enumerable:!1,get:function get(){return this._readableState.highWaterMark}}),Object.defineProperty(Readable.prototype,"readableBuffer",{enumerable:!1,get:function get(){
return this._readableState&&this._readableState.buffer}}),Object.defineProperty(Readable.prototype,"readableFlowing",{enumerable:!1,get:function get(){return this._readableState.flowing},set:function set(e){this._readableState&&(this._readableState.flowing=e)}}),Readable._fromList=fromList,Object.defineProperty(Readable.prototype,"readableLength",{enumerable:!1,get:function get(){return this._readableState.length}}),"function"==typeof Symbol&&(Readable.from=function(t,n){return void 0===f&&(f=e("./internal/streams/from")),f(Readable,t,n)})}).call(this)}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"../errors":235,"./_stream_duplex":236,"./internal/streams/async_iterator":241,"./internal/streams/buffer_list":242,"./internal/streams/destroy":243,"./internal/streams/from":245,"./internal/streams/state":247,"./internal/streams/stream":248,_process:223,buffer:145,events:162,inherits:174,
"string_decoder/":249,util:133}],239:[function(e,t,n){"use strict";t.exports=Transform;var i=e("../errors").codes,a=i.ERR_METHOD_NOT_IMPLEMENTED,s=i.ERR_MULTIPLE_CALLBACK,c=i.ERR_TRANSFORM_ALREADY_TRANSFORMING,l=i.ERR_TRANSFORM_WITH_LENGTH_0,u=e("./_stream_duplex");function afterTransform(e,t){var n=this._transformState;n.transforming=!1;var i=n.writecb;if(null===i)return this.emit("error",new s);n.writechunk=null,n.writecb=null,null!=t&&this.push(t),i(e);var a=this._readableState;a.reading=!1,(a.needReadable||a.length<a.highWaterMark)&&this._read(a.highWaterMark)}function Transform(e){if(!(this instanceof Transform))return new Transform(e);u.call(this,e),this._transformState={afterTransform:afterTransform.bind(this),needTransform:!1,transforming:!1,writecb:null,writechunk:null,writeencoding:null},this._readableState.needReadable=!0,this._readableState.sync=!1,e&&("function"==typeof e.transform&&(this._transform=e.transform),"function"==typeof e.flush&&(this._flush=e.flush)),
this.on("prefinish",prefinish)}function prefinish(){var e=this;"function"!=typeof this._flush||this._readableState.destroyed?done(this,null,null):this._flush((function(t,n){done(e,t,n)}))}function done(e,t,n){if(t)return e.emit("error",t);if(null!=n&&e.push(n),e._writableState.length)throw new l;if(e._transformState.transforming)throw new c;return e.push(null)}e("inherits")(Transform,u),Transform.prototype.push=function(e,t){return this._transformState.needTransform=!1,u.prototype.push.call(this,e,t)},Transform.prototype._transform=function(e,t,n){n(new a("_transform()"))},Transform.prototype._write=function(e,t,n){var i=this._transformState;if(i.writecb=n,i.writechunk=e,i.writeencoding=t,!i.transforming){var a=this._readableState;(i.needTransform||a.needReadable||a.length<a.highWaterMark)&&this._read(a.highWaterMark)}},Transform.prototype._read=function(e){var t=this._transformState;null===t.writechunk||t.transforming?t.needTransform=!0:(t.transforming=!0,
this._transform(t.writechunk,t.writeencoding,t.afterTransform))},Transform.prototype._destroy=function(e,t){u.prototype._destroy.call(this,e,(function(e){t(e)}))}},{"../errors":235,"./_stream_duplex":236,inherits:174}],240:[function(e,t,n){(function(n,i){(function(){"use strict";function CorkedRequest(e){var t=this;this.next=null,this.entry=null,this.finish=function(){!function onCorkedFinish(e,t,n){var i=e.entry;e.entry=null;for(;i;){var a=i.callback;t.pendingcb--,a(n),i=i.next}t.corkedRequestsFree.next=e}(t,e)}}var a;t.exports=Writable,Writable.WritableState=WritableState;var s={deprecate:e("util-deprecate")},c=e("./internal/streams/stream"),l=e("buffer").Buffer,u=i.Uint8Array||function(){}
;var d,m=e("./internal/streams/destroy"),p=e("./internal/streams/state").getHighWaterMark,h=e("../errors").codes,f=h.ERR_INVALID_ARG_TYPE,g=h.ERR_METHOD_NOT_IMPLEMENTED,y=h.ERR_MULTIPLE_CALLBACK,b=h.ERR_STREAM_CANNOT_PIPE,v=h.ERR_STREAM_DESTROYED,w=h.ERR_STREAM_NULL_VALUES,S=h.ERR_STREAM_WRITE_AFTER_END,T=h.ERR_UNKNOWN_ENCODING,E=m.errorOrDestroy;function nop(){}function WritableState(t,i,s){a=a||e("./_stream_duplex"),t=t||{},"boolean"!=typeof s&&(s=i instanceof a),this.objectMode=!!t.objectMode,s&&(this.objectMode=this.objectMode||!!t.writableObjectMode),this.highWaterMark=p(this,t,"writableHighWaterMark",s),this.finalCalled=!1,this.needDrain=!1,this.ending=!1,this.ended=!1,this.finished=!1,this.destroyed=!1;var c=!1===t.decodeStrings;this.decodeStrings=!c,this.defaultEncoding=t.defaultEncoding||"utf8",this.length=0,this.writing=!1,this.corked=0,this.sync=!0,this.bufferProcessing=!1,this.onwrite=function(e){!function onwrite(e,t){var i=e._writableState,a=i.sync,s=i.writecb
;if("function"!=typeof s)throw new y;if(function onwriteStateUpdate(e){e.writing=!1,e.writecb=null,e.length-=e.writelen,e.writelen=0}(i),t)!function onwriteError(e,t,i,a,s){--t.pendingcb,i?(n.nextTick(s,a),n.nextTick(finishMaybe,e,t),e._writableState.errorEmitted=!0,E(e,a)):(s(a),e._writableState.errorEmitted=!0,E(e,a),finishMaybe(e,t))}(e,i,a,t,s);else{var c=needFinish(i)||e.destroyed;c||i.corked||i.bufferProcessing||!i.bufferedRequest||clearBuffer(e,i),a?n.nextTick(afterWrite,e,i,c,s):afterWrite(e,i,c,s)}}(i,e)},this.writecb=null,this.writelen=0,this.bufferedRequest=null,this.lastBufferedRequest=null,this.pendingcb=0,this.prefinished=!1,this.errorEmitted=!1,this.emitClose=!1!==t.emitClose,this.autoDestroy=!!t.autoDestroy,this.bufferedRequestCount=0,this.corkedRequestsFree=new CorkedRequest(this)}function Writable(t){var n=this instanceof(a=a||e("./_stream_duplex"));if(!n&&!d.call(Writable,this))return new Writable(t);this._writableState=new WritableState(t,this,n),this.writable=!0,
t&&("function"==typeof t.write&&(this._write=t.write),"function"==typeof t.writev&&(this._writev=t.writev),"function"==typeof t.destroy&&(this._destroy=t.destroy),"function"==typeof t.final&&(this._final=t.final)),c.call(this)}function doWrite(e,t,n,i,a,s,c){t.writelen=i,t.writecb=c,t.writing=!0,t.sync=!0,t.destroyed?t.onwrite(new v("write")):n?e._writev(a,t.onwrite):e._write(a,s,t.onwrite),t.sync=!1}function afterWrite(e,t,n,i){n||function onwriteDrain(e,t){0===t.length&&t.needDrain&&(t.needDrain=!1,e.emit("drain"))}(e,t),t.pendingcb--,i(),finishMaybe(e,t)}function clearBuffer(e,t){t.bufferProcessing=!0;var n=t.bufferedRequest;if(e._writev&&n&&n.next){var i=t.bufferedRequestCount,a=new Array(i),s=t.corkedRequestsFree;s.entry=n;for(var c=0,l=!0;n;)a[c]=n,n.isBuf||(l=!1),n=n.next,c+=1;a.allBuffers=l,doWrite(e,t,!0,t.length,a,"",s.finish),t.pendingcb++,t.lastBufferedRequest=null,s.next?(t.corkedRequestsFree=s.next,s.next=null):t.corkedRequestsFree=new CorkedRequest(t),
t.bufferedRequestCount=0}else{for(;n;){var u=n.chunk,d=n.encoding,m=n.callback;if(doWrite(e,t,!1,t.objectMode?1:u.length,u,d,m),n=n.next,t.bufferedRequestCount--,t.writing)break}null===n&&(t.lastBufferedRequest=null)}t.bufferedRequest=n,t.bufferProcessing=!1}function needFinish(e){return e.ending&&0===e.length&&null===e.bufferedRequest&&!e.finished&&!e.writing}function callFinal(e,t){e._final((function(n){t.pendingcb--,n&&E(e,n),t.prefinished=!0,e.emit("prefinish"),finishMaybe(e,t)}))}function finishMaybe(e,t){var i=needFinish(t);if(i&&(function prefinish(e,t){t.prefinished||t.finalCalled||("function"!=typeof e._final||t.destroyed?(t.prefinished=!0,e.emit("prefinish")):(t.pendingcb++,t.finalCalled=!0,n.nextTick(callFinal,e,t)))}(e,t),0===t.pendingcb&&(t.finished=!0,e.emit("finish"),t.autoDestroy))){var a=e._readableState;(!a||a.autoDestroy&&a.endEmitted)&&e.destroy()}return i}e("inherits")(Writable,c),WritableState.prototype.getBuffer=function getBuffer(){
for(var e=this.bufferedRequest,t=[];e;)t.push(e),e=e.next;return t},function(){try{Object.defineProperty(WritableState.prototype,"buffer",{get:s.deprecate((function writableStateBufferGetter(){return this.getBuffer()}),"_writableState.buffer is deprecated. Use _writableState.getBuffer instead.","DEP0003")})}catch(e){}}(),"function"==typeof Symbol&&Symbol.hasInstance&&"function"==typeof Function.prototype[Symbol.hasInstance]?(d=Function.prototype[Symbol.hasInstance],Object.defineProperty(Writable,Symbol.hasInstance,{value:function value(e){return!!d.call(this,e)||this===Writable&&(e&&e._writableState instanceof WritableState)}})):d=function realHasInstance(e){return e instanceof this},Writable.prototype.pipe=function(){E(this,new b)},Writable.prototype.write=function(e,t,i){var a=this._writableState,s=!1,c=!a.objectMode&&function _isUint8Array(e){return l.isBuffer(e)||e instanceof u}(e);return c&&!l.isBuffer(e)&&(e=function _uint8ArrayToBuffer(e){return l.from(e)}(e)),
"function"==typeof t&&(i=t,t=null),c?t="buffer":t||(t=a.defaultEncoding),"function"!=typeof i&&(i=nop),a.ending?function writeAfterEnd(e,t){var i=new S;E(e,i),n.nextTick(t,i)}(this,i):(c||function validChunk(e,t,i,a){var s;return null===i?s=new w:"string"==typeof i||t.objectMode||(s=new f("chunk",["string","Buffer"],i)),!s||(E(e,s),n.nextTick(a,s),!1)}(this,a,e,i))&&(a.pendingcb++,s=function writeOrBuffer(e,t,n,i,a,s){if(!n){var c=function decodeChunk(e,t,n){e.objectMode||!1===e.decodeStrings||"string"!=typeof t||(t=l.from(t,n));return t}(t,i,a);i!==c&&(n=!0,a="buffer",i=c)}var u=t.objectMode?1:i.length;t.length+=u;var d=t.length<t.highWaterMark;d||(t.needDrain=!0);if(t.writing||t.corked){var m=t.lastBufferedRequest;t.lastBufferedRequest={chunk:i,encoding:a,isBuf:n,callback:s,next:null},m?m.next=t.lastBufferedRequest:t.bufferedRequest=t.lastBufferedRequest,t.bufferedRequestCount+=1}else doWrite(e,t,!1,u,i,a,s);return d}(this,a,c,e,t,i)),s},Writable.prototype.cork=function(){
this._writableState.corked++},Writable.prototype.uncork=function(){var e=this._writableState;e.corked&&(e.corked--,e.writing||e.corked||e.bufferProcessing||!e.bufferedRequest||clearBuffer(this,e))},Writable.prototype.setDefaultEncoding=function setDefaultEncoding(e){if("string"==typeof e&&(e=e.toLowerCase()),!(["hex","utf8","utf-8","ascii","binary","base64","ucs2","ucs-2","utf16le","utf-16le","raw"].indexOf((e+"").toLowerCase())>-1))throw new T(e);return this._writableState.defaultEncoding=e,this},Object.defineProperty(Writable.prototype,"writableBuffer",{enumerable:!1,get:function get(){return this._writableState&&this._writableState.getBuffer()}}),Object.defineProperty(Writable.prototype,"writableHighWaterMark",{enumerable:!1,get:function get(){return this._writableState.highWaterMark}}),Writable.prototype._write=function(e,t,n){n(new g("_write()"))},Writable.prototype._writev=null,Writable.prototype.end=function(e,t,i){var a=this._writableState;return"function"==typeof e?(i=e,
e=null,t=null):"function"==typeof t&&(i=t,t=null),null!=e&&this.write(e,t),a.corked&&(a.corked=1,this.uncork()),a.ending||function endWritable(e,t,i){t.ending=!0,finishMaybe(e,t),i&&(t.finished?n.nextTick(i):e.once("finish",i));t.ended=!0,e.writable=!1}(this,a,i),this},Object.defineProperty(Writable.prototype,"writableLength",{enumerable:!1,get:function get(){return this._writableState.length}}),Object.defineProperty(Writable.prototype,"destroyed",{enumerable:!1,get:function get(){return void 0!==this._writableState&&this._writableState.destroyed},set:function set(e){this._writableState&&(this._writableState.destroyed=e)}}),Writable.prototype.destroy=m.destroy,Writable.prototype._undestroy=m.undestroy,Writable.prototype._destroy=function(e,t){t(e)}}).call(this)}).call(this,e("_process"),"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"../errors":235,"./_stream_duplex":236,"./internal/streams/destroy":243,
"./internal/streams/state":247,"./internal/streams/stream":248,_process:223,buffer:145,inherits:174,"util-deprecate":254}],241:[function(e,t,n){(function(n){(function(){"use strict";var i;function _defineProperty(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}var a=e("./end-of-stream"),s=Symbol("lastResolve"),c=Symbol("lastReject"),l=Symbol("error"),u=Symbol("ended"),d=Symbol("lastPromise"),m=Symbol("handlePromise"),p=Symbol("stream");function createIterResult(e,t){return{value:e,done:t}}function readAndResolve(e){var t=e[s];if(null!==t){var n=e[p].read();null!==n&&(e[d]=null,e[s]=null,e[c]=null,t(createIterResult(n,!1)))}}function onReadable(e){n.nextTick(readAndResolve,e)}var h=Object.getPrototypeOf((function(){})),f=Object.setPrototypeOf((_defineProperty(i={get stream(){return this[p]},next:function next(){var e=this,t=this[l];if(null!==t)return Promise.reject(t)
;if(this[u])return Promise.resolve(createIterResult(void 0,!0));if(this[p].destroyed)return new Promise((function(t,i){n.nextTick((function(){e[l]?i(e[l]):t(createIterResult(void 0,!0))}))}));var i,a=this[d];if(a)i=new Promise(function wrapForNext(e,t){return function(n,i){e.then((function(){t[u]?n(createIterResult(void 0,!0)):t[m](n,i)}),i)}}(a,this));else{var s=this[p].read();if(null!==s)return Promise.resolve(createIterResult(s,!1));i=new Promise(this[m])}return this[d]=i,i}},Symbol.asyncIterator,(function(){return this})),_defineProperty(i,"return",(function _return(){var e=this;return new Promise((function(t,n){e[p].destroy(null,(function(e){e?n(e):t(createIterResult(void 0,!0))}))}))})),i),h);t.exports=function createReadableStreamAsyncIterator(e){var t,n=Object.create(f,(_defineProperty(t={},p,{value:e,writable:!0}),_defineProperty(t,s,{value:null,writable:!0}),_defineProperty(t,c,{value:null,writable:!0}),_defineProperty(t,l,{value:null,writable:!0}),_defineProperty(t,u,{
value:e._readableState.endEmitted,writable:!0}),_defineProperty(t,m,{value:function value(e,t){var i=n[p].read();i?(n[d]=null,n[s]=null,n[c]=null,e(createIterResult(i,!1))):(n[s]=e,n[c]=t)},writable:!0}),t));return n[d]=null,a(e,(function(e){if(e&&"ERR_STREAM_PREMATURE_CLOSE"!==e.code){var t=n[c];return null!==t&&(n[d]=null,n[s]=null,n[c]=null,t(e)),void(n[l]=e)}var i=n[s];null!==i&&(n[d]=null,n[s]=null,n[c]=null,i(createIterResult(void 0,!0))),n[u]=!0})),e.on("readable",onReadable.bind(null,n)),n}}).call(this)}).call(this,e("_process"))},{"./end-of-stream":244,_process:223}],242:[function(e,t,n){"use strict";function ownKeys(e,t){var n=Object.keys(e);if(Object.getOwnPropertySymbols){var i=Object.getOwnPropertySymbols(e);t&&(i=i.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),n.push.apply(n,i)}return n}function _defineProperty(e,t,n){return t in e?Object.defineProperty(e,t,{value:n,enumerable:!0,configurable:!0,writable:!0}):e[t]=n,e}
function _defineProperties(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}var i=e("buffer").Buffer,a=e("util").inspect,s=a&&a.custom||"inspect";t.exports=function(){function BufferList(){!function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,BufferList),this.head=null,this.tail=null,this.length=0}return function _createClass(e,t,n){return t&&_defineProperties(e.prototype,t),n&&_defineProperties(e,n),e}(BufferList,[{key:"push",value:function push(e){var t={data:e,next:null};this.length>0?this.tail.next=t:this.head=t,this.tail=t,++this.length}},{key:"unshift",value:function unshift(e){var t={data:e,next:this.head};0===this.length&&(this.tail=t),this.head=t,++this.length}},{key:"shift",value:function shift(){if(0!==this.length){var e=this.head.data;return 1===this.length?this.head=this.tail=null:this.head=this.head.next,
--this.length,e}}},{key:"clear",value:function clear(){this.head=this.tail=null,this.length=0}},{key:"join",value:function join(e){if(0===this.length)return"";for(var t=this.head,n=""+t.data;t=t.next;)n+=e+t.data;return n}},{key:"concat",value:function concat(e){if(0===this.length)return i.alloc(0);for(var t,n,a,s=i.allocUnsafe(e>>>0),c=this.head,l=0;c;)t=c.data,n=s,a=l,i.prototype.copy.call(t,n,a),l+=c.data.length,c=c.next;return s}},{key:"consume",value:function consume(e,t){var n;return e<this.head.data.length?(n=this.head.data.slice(0,e),this.head.data=this.head.data.slice(e)):n=e===this.head.data.length?this.shift():t?this._getString(e):this._getBuffer(e),n}},{key:"first",value:function first(){return this.head.data}},{key:"_getString",value:function _getString(e){var t=this.head,n=1,i=t.data;for(e-=i.length;t=t.next;){var a=t.data,s=e>a.length?a.length:e;if(s===a.length?i+=a:i+=a.slice(0,e),0===(e-=s)){s===a.length?(++n,
t.next?this.head=t.next:this.head=this.tail=null):(this.head=t,t.data=a.slice(s));break}++n}return this.length-=n,i}},{key:"_getBuffer",value:function _getBuffer(e){var t=i.allocUnsafe(e),n=this.head,a=1;for(n.data.copy(t),e-=n.data.length;n=n.next;){var s=n.data,c=e>s.length?s.length:e;if(s.copy(t,t.length-e,0,c),0===(e-=c)){c===s.length?(++a,n.next?this.head=n.next:this.head=this.tail=null):(this.head=n,n.data=s.slice(c));break}++a}return this.length-=a,t}},{key:s,value:function value(e,t){return a(this,function _objectSpread(e){for(var t=1;t<arguments.length;t++){var n=null!=arguments[t]?arguments[t]:{};t%2?ownKeys(Object(n),!0).forEach((function(t){_defineProperty(e,t,n[t])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(n)):ownKeys(Object(n)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(n,t))}))}return e}({},t,{depth:0,customInspect:!1}))}}]),BufferList}()},{buffer:145,util:133}],243:[function(e,t,n){
(function(e){(function(){"use strict";function emitErrorAndCloseNT(e,t){emitErrorNT(e,t),emitCloseNT(e)}function emitCloseNT(e){e._writableState&&!e._writableState.emitClose||e._readableState&&!e._readableState.emitClose||e.emit("close")}function emitErrorNT(e,t){e.emit("error",t)}t.exports={destroy:function destroy(t,n){var i=this,a=this._readableState&&this._readableState.destroyed,s=this._writableState&&this._writableState.destroyed;return a||s?(n?n(t):t&&(this._writableState?this._writableState.errorEmitted||(this._writableState.errorEmitted=!0,e.nextTick(emitErrorNT,this,t)):e.nextTick(emitErrorNT,this,t)),this):(this._readableState&&(this._readableState.destroyed=!0),this._writableState&&(this._writableState.destroyed=!0),this._destroy(t||null,(function(t){!n&&t?i._writableState?i._writableState.errorEmitted?e.nextTick(emitCloseNT,i):(i._writableState.errorEmitted=!0,e.nextTick(emitErrorAndCloseNT,i,t)):e.nextTick(emitErrorAndCloseNT,i,t):n?(e.nextTick(emitCloseNT,i),
n(t)):e.nextTick(emitCloseNT,i)})),this)},undestroy:function undestroy(){this._readableState&&(this._readableState.destroyed=!1,this._readableState.reading=!1,this._readableState.ended=!1,this._readableState.endEmitted=!1),this._writableState&&(this._writableState.destroyed=!1,this._writableState.ended=!1,this._writableState.ending=!1,this._writableState.finalCalled=!1,this._writableState.prefinished=!1,this._writableState.finished=!1,this._writableState.errorEmitted=!1)},errorOrDestroy:function errorOrDestroy(e,t){var n=e._readableState,i=e._writableState;n&&n.autoDestroy||i&&i.autoDestroy?e.destroy(t):e.emit("error",t)}}}).call(this)}).call(this,e("_process"))},{_process:223}],244:[function(e,t,n){"use strict";var i=e("../../../errors").codes.ERR_STREAM_PREMATURE_CLOSE;function noop(){}t.exports=function eos(e,t,n){if("function"==typeof t)return eos(e,null,t);t||(t={}),n=function once(e){var t=!1;return function(){if(!t){t=!0
;for(var n=arguments.length,i=new Array(n),a=0;a<n;a++)i[a]=arguments[a];e.apply(this,i)}}}(n||noop);var a=t.readable||!1!==t.readable&&e.readable,s=t.writable||!1!==t.writable&&e.writable,c=function onlegacyfinish(){e.writable||u()},l=e._writableState&&e._writableState.finished,u=function onfinish(){s=!1,l=!0,a||n.call(e)},d=e._readableState&&e._readableState.endEmitted,m=function onend(){a=!1,d=!0,s||n.call(e)},p=function onerror(t){n.call(e,t)},h=function onclose(){var t;return a&&!d?(e._readableState&&e._readableState.ended||(t=new i),n.call(e,t)):s&&!l?(e._writableState&&e._writableState.ended||(t=new i),n.call(e,t)):void 0},f=function onrequest(){e.req.on("finish",u)};return!function isRequest(e){return e.setHeader&&"function"==typeof e.abort}(e)?s&&!e._writableState&&(e.on("end",c),e.on("close",c)):(e.on("complete",u),e.on("abort",h),e.req?f():e.on("request",f)),e.on("end",m),e.on("finish",u),!1!==t.error&&e.on("error",p),e.on("close",h),function(){
e.removeListener("complete",u),e.removeListener("abort",h),e.removeListener("request",f),e.req&&e.req.removeListener("finish",u),e.removeListener("end",c),e.removeListener("close",c),e.removeListener("finish",u),e.removeListener("end",m),e.removeListener("error",p),e.removeListener("close",h)}}},{"../../../errors":235}],245:[function(e,t,n){t.exports=function(){throw new Error("Readable.from is not available in the browser")}},{}],246:[function(e,t,n){"use strict";var i;var a=e("../../../errors").codes,s=a.ERR_MISSING_ARGS,c=a.ERR_STREAM_DESTROYED;function noop(e){if(e)throw e}function destroyer(t,n,a,s){s=function once(e){var t=!1;return function(){t||(t=!0,e.apply(void 0,arguments))}}(s);var l=!1;t.on("close",(function(){l=!0})),void 0===i&&(i=e("./end-of-stream")),i(t,{readable:n,writable:a},(function(e){if(e)return s(e);l=!0,s()}));var u=!1;return function(e){if(!l&&!u)return u=!0,function isRequest(e){return e.setHeader&&"function"==typeof e.abort
}(t)?t.abort():"function"==typeof t.destroy?t.destroy():void s(e||new c("pipe"))}}function call(e){e()}function pipe(e,t){return e.pipe(t)}function popCallback(e){return e.length?"function"!=typeof e[e.length-1]?noop:e.pop():noop}t.exports=function pipeline(){for(var e=arguments.length,t=new Array(e),n=0;n<e;n++)t[n]=arguments[n];var i,a=popCallback(t);if(Array.isArray(t[0])&&(t=t[0]),t.length<2)throw new s("streams");var c=t.map((function(e,n){var s=n<t.length-1;return destroyer(e,s,n>0,(function(e){i||(i=e),e&&c.forEach(call),s||(c.forEach(call),a(i))}))}));return t.reduce(pipe)}},{"../../../errors":235,"./end-of-stream":244}],247:[function(e,t,n){"use strict";var i=e("../../../errors").codes.ERR_INVALID_OPT_VALUE;t.exports={getHighWaterMark:function getHighWaterMark(e,t,n,a){var s=function highWaterMarkFrom(e,t,n){return null!=e.highWaterMark?e.highWaterMark:t?e[n]:null}(t,a,n);if(null!=s){if(!isFinite(s)||Math.floor(s)!==s||s<0)throw new i(a?n:"highWaterMark",s)
;return Math.floor(s)}return e.objectMode?16:16384}}},{"../../../errors":235}],248:[function(e,t,n){t.exports=e("events").EventEmitter},{events:162}],249:[function(e,t,n){"use strict";var i=e("safe-buffer").Buffer,a=i.isEncoding||function(e){switch((e=""+e)&&e.toLowerCase()){case"hex":case"utf8":case"utf-8":case"ascii":case"binary":case"base64":case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":case"raw":return!0;default:return!1}};function StringDecoder(e){var t;switch(this.encoding=function normalizeEncoding(e){var t=function _normalizeEncoding(e){if(!e)return"utf8";for(var t;;)switch(e){case"utf8":case"utf-8":return"utf8";case"ucs2":case"ucs-2":case"utf16le":case"utf-16le":return"utf16le";case"latin1":case"binary":return"latin1";case"base64":case"ascii":case"hex":return e;default:if(t)return;e=(""+e).toLowerCase(),t=!0}}(e);if("string"!=typeof t&&(i.isEncoding===a||!a(e)))throw new Error("Unknown encoding: "+e);return t||e}(e),this.encoding){case"utf16le":this.text=utf16Text,
this.end=utf16End,t=4;break;case"utf8":this.fillLast=utf8FillLast,t=4;break;case"base64":this.text=base64Text,this.end=base64End,t=3;break;default:return this.write=simpleWrite,void(this.end=simpleEnd)}this.lastNeed=0,this.lastTotal=0,this.lastChar=i.allocUnsafe(t)}function utf8CheckByte(e){return e<=127?0:e>>5==6?2:e>>4==14?3:e>>3==30?4:e>>6==2?-1:-2}function utf8FillLast(e){var t=this.lastTotal-this.lastNeed,n=function utf8CheckExtraBytes(e,t,n){if(128!=(192&t[0]))return e.lastNeed=0,"�";if(e.lastNeed>1&&t.length>1){if(128!=(192&t[1]))return e.lastNeed=1,"�";if(e.lastNeed>2&&t.length>2&&128!=(192&t[2]))return e.lastNeed=2,"�"}}(this,e);return void 0!==n?n:this.lastNeed<=e.length?(e.copy(this.lastChar,t,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal)):(e.copy(this.lastChar,t,0,e.length),void(this.lastNeed-=e.length))}function utf16Text(e,t){if((e.length-t)%2==0){var n=e.toString("utf16le",t);if(n){var i=n.charCodeAt(n.length-1)
;if(i>=55296&&i<=56319)return this.lastNeed=2,this.lastTotal=4,this.lastChar[0]=e[e.length-2],this.lastChar[1]=e[e.length-1],n.slice(0,-1)}return n}return this.lastNeed=1,this.lastTotal=2,this.lastChar[0]=e[e.length-1],e.toString("utf16le",t,e.length-1)}function utf16End(e){var t=e&&e.length?this.write(e):"";if(this.lastNeed){var n=this.lastTotal-this.lastNeed;return t+this.lastChar.toString("utf16le",0,n)}return t}function base64Text(e,t){var n=(e.length-t)%3;return 0===n?e.toString("base64",t):(this.lastNeed=3-n,this.lastTotal=3,1===n?this.lastChar[0]=e[e.length-1]:(this.lastChar[0]=e[e.length-2],this.lastChar[1]=e[e.length-1]),e.toString("base64",t,e.length-n))}function base64End(e){var t=e&&e.length?this.write(e):"";return this.lastNeed?t+this.lastChar.toString("base64",0,3-this.lastNeed):t}function simpleWrite(e){return e.toString(this.encoding)}function simpleEnd(e){return e&&e.length?this.write(e):""}n.StringDecoder=StringDecoder,StringDecoder.prototype.write=function(e){
if(0===e.length)return"";var t,n;if(this.lastNeed){if(void 0===(t=this.fillLast(e)))return"";n=this.lastNeed,this.lastNeed=0}else n=0;return n<e.length?t?t+this.text(e,n):this.text(e,n):t||""},StringDecoder.prototype.end=function utf8End(e){var t=e&&e.length?this.write(e):"";return this.lastNeed?t+"�":t},StringDecoder.prototype.text=function utf8Text(e,t){var n=function utf8CheckIncomplete(e,t,n){var i=t.length-1;if(i<n)return 0;var a=utf8CheckByte(t[i]);if(a>=0)return a>0&&(e.lastNeed=a-1),a;if(--i<n||-2===a)return 0;if((a=utf8CheckByte(t[i]))>=0)return a>0&&(e.lastNeed=a-2),a;if(--i<n||-2===a)return 0;if((a=utf8CheckByte(t[i]))>=0)return a>0&&(2===a?a=0:e.lastNeed=a-3),a;return 0}(this,e,t);if(!this.lastNeed)return e.toString("utf8",t);this.lastTotal=n;var i=e.length-(n-this.lastNeed);return e.copy(this.lastChar,0,i),e.toString("utf8",t,i)},StringDecoder.prototype.fillLast=function(e){
if(this.lastNeed<=e.length)return e.copy(this.lastChar,this.lastTotal-this.lastNeed,0,this.lastNeed),this.lastChar.toString(this.encoding,0,this.lastTotal);e.copy(this.lastChar,this.lastTotal-this.lastNeed,0,e.length),this.lastNeed-=e.length}},{"safe-buffer":229}],250:[function(e,t,n){t.exports=[{name:"Facebook",homepage:"https://www.facebook.com",categories:["social"],domains:["*.facebook.com","*.atlassbx.com","*.fbsbx.com","fbcdn-photos-e-a.akamaihd.net","*.facebook.net","*.fbcdn.net"],products:[{name:"Facebook Messenger Customer Chat",urlPatterns:["REGEXP:connect\\.facebook\\.net\\/.*\\/sdk\\/xfbml\\.customerchat\\.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Google Analytics",company:"Google",homepage:"https://www.google.com/analytics/analytics/",categories:["analytics"],domains:["*.google-analytics.com","*.urchin.com","analytics.google.com"]},{name:"Google CDN",company:"Google",
homepage:"https://developers.google.com/speed/libraries/",categories:["cdn"],domains:["ajax.googleapis.com","commondatastorage.googleapis.com","www.gstatic.com"]},{name:"Google Tag Manager",company:"Google",homepage:"https://marketingplatform.google.com/about/tag-manager/",categories:["tag-manager"],domains:["*.googletagmanager.com"]},{name:"Google/Doubleclick Ads",company:"Google",homepage:"https://www.doubleclickbygoogle.com/",categories:["ad"],
domains:["adservice.google.com","adservice.google.com.au","adservice.google.com.sg","adservice.google.com.br","adservice.google.com.ua","adservice.google.co.uk","adservice.google.co.jp","adservice.google.co.in","adservice.google.co.kr","adservice.google.co.id","adservice.google.co.nz","adservice.google.ie","adservice.google.se","adservice.google.de","adservice.google.ca","adservice.google.be","adservice.google.es","adservice.google.ch","adservice.google.fr","adservice.google.nl","*.googleadservices.com","*.googlesyndication.com","*.googletagservices.com","*.2mdn.net","*.doubleclick.net"]},{name:"Other Google APIs/SDKs",company:"Google",homepage:"https://developers.google.com/apis-explorer/#p/",categories:["utility"],
domains:["accounts.google.com","apis.google.com","calendar.google.com","clients2.google.com","cse.google.com","news.google.com","pay.google.com","payments.google.com","play.google.com","smartlock.google.com","www.google.com","www.google.de","www.google.co.jp","www.google.com.au","www.google.co.uk","www.google.ie","www.google.com.sg","www.google.co.in","www.google.com.br","www.google.ca","www.google.co.kr","www.google.co.nz","www.google.co.id","www.google.fr","www.google.be","www.google.com.ua","www.google.nl","www.google.ru","www.google.se","imasdk.googleapis.com","storage.googleapis.com","translate.googleapis.com","lh3.googleusercontent.com","csi.gstatic.com"]},{name:"YouTube",homepage:"https://youtube.com",categories:["video"],domains:["*.youtube.com","*.ggpht.com","*.youtube-nocookie.com","*.ytimg.com"],products:[{name:"YouTube Embedded Player",urlPatterns:["youtube.com/embed/"],facades:[{name:"Lite YouTube",repo:"https://github.com/paulirish/lite-youtube-embed"}]}]},{
name:"Yandex Metrica",company:"Yandex",homepage:"https://metrica.yandex.com/about?",categories:["analytics"],domains:["mc.yandex.ru","d31j93rd8oukbv.cloudfront.net"]},{name:"Google Maps",company:"Google",homepage:"https://www.google.com/maps",categories:["utility"],domains:["maps.google.com","maps-api-ssl.google.com","maps.googleapis.com","mts.googleapis.com","maps.gstatic.com"]},{name:"Twitter",homepage:"https://twitter.com",categories:["social"],domains:["*.vine.co","*.twimg.com","*.twitpic.com","platform.twitter.com","syndication.twitter.com"]},{name:"Hotjar",homepage:"https://www.hotjar.com/",categories:["analytics"],domains:["*.hotjar.com","*.hotjar.io"]},{name:"jQuery CDN",homepage:"https://code.jquery.com/",categories:["cdn"],domains:["*.jquery.com"]},{name:"AddThis",homepage:"http://www.addthis.com/",categories:["social"],domains:["*.addthis.com","*.addthiscdn.com","*.addthisedge.com"]},{name:"Cloudflare CDN",homepage:"https://cdnjs.com/",categories:["cdn"],
domains:["amp.cloudflare.com","cdnjs.cloudflare.com"]},{name:"Shopify",homepage:"https://www.shopify.com/",categories:["hosting"],domains:["*.shopify.com","*.shopifyapps.com","*.shopifycdn.com","*.shopifysvc.com"]},{name:"JSDelivr CDN",homepage:"https://www.jsdelivr.com/",categories:["cdn"],domains:["*.jsdelivr.net"]},{name:"WordPress",company:"Automattic",homepage:"https://wp.com/",categories:["hosting"],domains:["*.wordpress.com","s0.wp.com","s2.wp.com","*.w.org","c0.wp.com","s1.wp.com","widgets.wp.com"]},{name:"AMP",homepage:"https://amp.dev/",categories:["content"],domains:["*.ampproject.org"]},{name:"ZenDesk",homepage:"https://zendesk.com/",categories:["customer-success"],domains:["*.zdassets.com","*.zendesk.com","*.zopim.com"]},{name:"Tawk.to",homepage:"https://www.tawk.to/",categories:["customer-success"],domains:["*.tawk.to"]},{name:"Criteo",homepage:"https://www.criteo.com/",categories:["ad"],domains:["*.criteo.com","*.emailretargeting.com","*.criteo.net"]},{name:"Wix",
homepage:"https://www.wix.com/",categories:["hosting"],domains:["*.parastorage.com","*.wix.com","*.wixstatic.com","*.wixapps.net"]},{name:"Cloudflare",homepage:"https://www.cloudflare.com/website-optimization/",categories:["utility"],domains:["ajax.cloudflare.com"]},{name:"Pubmatic",homepage:"https://pubmatic.com/",categories:["ad"],domains:["*.pubmatic.com"]},{name:"Adroll",homepage:"https://www.adroll.com/",categories:["ad"],domains:["*.adroll.com"]},{name:"FontAwesome CDN",homepage:"https://fontawesome.com/",categories:["cdn"],domains:["*.fontawesome.com"]},{name:"Jivochat",homepage:"https://www.jivochat.com/",categories:["customer-success"],domains:["*.jivosite.com"]},{name:"ShareThis",homepage:"https://www.sharethis.com/",categories:["social"],domains:["*.sharethis.com"]},{name:"Squarespace",homepage:"https://www.squarespace.com/",categories:["hosting"],domains:["*.squarespace.com"]},{name:"Rubicon Project",homepage:"https://rubiconproject.com/",categories:["ad"],
domains:["*.rubiconproject.com","*.chango.com","*.fimserve.com"]},{name:"Amazon Web Services",homepage:"https://aws.amazon.com/s3/",categories:["other"],domains:["*.amazon.com","*.amazonaws.com","*.amazonwebapps.com","*.amazonwebservices.com","*.elasticbeanstalk.com","*.images-amazon.com","*.amazon.co.uk"]},{name:"Hubspot",homepage:"https://hubspot.com/",categories:["marketing"],domains:["*.hs-scripts.com","*.hubspot.com","*.leadin.com","*.hs-analytics.net","*.hscollectedforms.net","*.hscta.net","*.hsforms.net","*.hsleadflows.net","*.hsstatic.net","*.hubspot.net"]},{name:"Adobe Tag Manager",company:"Adobe",homepage:"https://www.adobe.com/experience-platform/",categories:["tag-manager"],domains:["*.adobedtm.com","*.demdex.net","*.everesttech.net"]},{name:"Yandex APIs",company:"Yandex",homepage:"https://yandex.ru/",categories:["utility"],domains:["api-maps.yandex.ru","money.yandex.ru"]},{name:"Yandex Ads",company:"Yandex",homepage:"https://yandex.com/adv/",categories:["ad"],
domains:["an.yandex.ru"]},{name:"Amazon Ads",homepage:"https://ad.amazon.com/",categories:["ad"],domains:["*.amazon-adsystem.com"]},{name:"Taboola",homepage:"https://www.taboola.com/",categories:["ad"],domains:["*.taboola.com","*.taboolasyndication.com"]},{name:"AddToAny",homepage:"https://www.addtoany.com/",categories:["social"],domains:["*.addtoany.com"]},{name:"Yandex CDN",company:"Yandex",homepage:"https://yandex.ru/",categories:["cdn"],domains:["*.yandex.st","*.yastatic.net"]},{name:"Blogger",homepage:"http://www.blogger.com/",categories:["hosting"],domains:["*.blogblog.com","*.blogger.com","*.blogspot.com","images-blogger-opensocial.googleusercontent.com"]},{name:"Stripe",homepage:"https://stripe.com",categories:["utility"],domains:["*.stripe.com","*.stripecdn.com","*.stripe.network"]},{name:"Mailchimp",homepage:"https://mailchimp.com/",categories:["marketing"],domains:["*.chimpstatic.com","*.list-manage.com","*.mailchimp.com"]},{name:"Tynt",company:"33 Across",categories:["ad"],
domains:["*.tynt.com"]},{name:"Cookiebot",homepage:"https://www.cookiebot.com/",categories:["utility"],domains:["*.cookiebot.com"]},{name:"Optimizely",homepage:"https://www.optimizely.com/",categories:["analytics"],domains:["*.optimizely.com"]},{name:"LiveChat",homepage:"https://www.livechat.com/",categories:["customer-success"],domains:["*.livechatinc.com","*.livechat.com","*.livechat-static.com"]},{name:"WordAds",company:"Automattic",homepage:"https://wordads.co/",categories:["ad"],domains:["*.pubmine.com"]},{name:"Sumo",homepage:"https://sumo.com/",categories:["marketing"],domains:["*.sumo.com","*.sumome.com","sumo.b-cdn.net"]},{name:"Adobe TypeKit",company:"Adobe",homepage:"https://fonts.adobe.com/",categories:["cdn"],domains:["*.typekit.com","*.typekit.net"]},{name:"Kakao",categories:["social"],domains:["*.daum.net","*.daumcdn.net"]},{name:"Pinterest",homepage:"https://pinterest.com/",categories:["social"],domains:["*.pinimg.com","*.pinterest.com"]},{name:"POWr",
homepage:"https://www.powr.io",categories:["utility"],domains:["*.powr.io"]},{name:"Skimbit",categories:["ad"],domains:["*.redirectingat.com","*.skimresources.com","*.skimresources.net"]},{name:"Bing Ads",homepage:"https://bingads.microsoft.com",categories:["ad"],domains:["*.bing.com","*.microsoft.com","*.msn.com","*.s-msft.com","*.s-msn.com","*.msads.net","*.msecnd.net","*.windows.net"]},{name:"Intercom",homepage:"https://www.intercom.com",categories:["customer-success"],domains:["*.intercomcdn.com","*.intercom.io"],products:[{name:"Intercom Widget",urlPatterns:["widget.intercom.io","js.intercomcdn.com/shim.latest.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"PayPal",homepage:"https://paypal.com",categories:["utility"],domains:["*.paypal.com","*.paypalobjects.com"]},{name:"PIXNET",homepage:"https://www.pixnet.net/",categories:["social"],domains:["*.pixfs.net","*.pixnet.net"]},{name:"Trust Pilot",
categories:["analytics"],domains:["*.trustpilot.com"]},{name:"Klaviyo",categories:["ad"],domains:["*.klaviyo.com"]},{name:"Media.net",homepage:"https://www.media.net/",categories:["ad"],domains:["*.media.net","*.mnet-ad.net"]},{name:"Bridgewell DSP",homepage:"https://www.bridgewell.com/",categories:["ad"],domains:["*.scupio.com"]},{name:"LinkedIn",homepage:"https://www.linkedin.com/",categories:["social"],domains:["*.bizographics.com","platform.linkedin.com","*.slideshare.com","*.slidesharecdn.com"]},{name:"Yotpo",homepage:"https://www.yotpo.com/",categories:["marketing"],domains:["*.yotpo.com"]},{name:"Histats",homepage:"http://histats.com/",categories:["analytics"],domains:["*.histats.com"]},{name:"VK",homepage:"https://vk.com/",categories:["social"],domains:["*.vk.com"]},{name:"Snapchat",homepage:"https://www.snapchat.com",categories:["analytics"],domains:["*.snapchat.com","*.sc-static.net"]},{name:"Weebly",homepage:"https://www.weebly.com/",categories:["hosting"],
domains:["*.editmysite.com"]},{name:"Hatena Blog",homepage:"https://hatenablog.com/",categories:["hosting"],domains:["*.st-hatena.com","*.hatena.ne.jp"]},{name:"mPulse",homepage:"https://developer.akamai.com/akamai-mpulse",categories:["analytics"],domains:["*.akstat.io","*.go-mpulse.net","*.mpulse.net","*.mpstat.us"]},{name:"Bold Commerce",categories:["utility"],domains:["*.shappify-cdn.com","*.shappify.com","*.boldapps.net"]},{name:"Wistia",homepage:"https://wistia.com/",categories:["video"],domains:["*.wistia.com","embedwistia-a.akamaihd.net","*.wistia.net"]},{name:"New Relic",homepage:"https://newrelic.com/",categories:["utility"],domains:["*.newrelic.com","*.nr-data.net"]},{name:"Privy",categories:["ad"],domains:["*.privy.com","*.privymktg.com"]},{name:"iubenda",categories:["utility"],domains:["*.iubenda.com"]},{name:"DTSCOUT",categories:["ad"],domains:["*.dtscout.com"]},{name:"Smartsupp",company:"Smartsupp.com",homepage:"https://www.smartsupp.com",categories:["customer-success"],
domains:["*.smartsuppchat.com","*.smartsupp.com","smartsupp-widget-161959.c.cdn77.org","*.smartsuppcdn.com"]},{name:"Tidio Live Chat",company:"Tidio",homepage:"https://www.tidiochat.com/en/",categories:["customer-success"],domains:["*.tidiochat.com"]},{name:"Tealium",homepage:"https://tealium.com/",categories:["tag-manager"],domains:["*.aniview.com","*.delvenetworks.com","*.limelight.com","*.tiqcdn.com","*.llnwd.net","*.tealiumiq.com"]},{name:"Nielsen NetRatings SiteCensus",company:"The Nielsen Company",homepage:"http://www.nielsen-online.com/intlpage.html",categories:["analytics"],domains:["*.imrworldwide.com"]},{name:"Salesforce",homepage:"https://www.salesforce.com/products/marketing-cloud/",categories:["analytics"],domains:["*.krxd.net"]},{name:"Baidu Analytics",homepage:"https://tongji.baidu.com/web/welcome/login",categories:["analytics"],domains:["hm.baidu.com","hmcdn.baidu.com"]},{name:"Azure Web Services",company:"Microsoft",categories:["cdn"],
domains:["*.azurewebsites.net","*.azureedge.net","*.msedge.net"]},{name:"Vimeo",homepage:"http://vimeo.com/",categories:["video"],domains:["*.vimeo.com","*.vimeocdn.com"],products:[{name:"Vimeo Embedded Player",urlPatterns:["player.vimeo.com/video/"],facades:[{name:"Lite Vimeo",repo:"https://github.com/slightlyoff/lite-vimeo"},{name:"Lite Vimeo Embed",repo:"https://github.com/luwes/lite-vimeo-embed"}]}]},{name:"Bigcommerce",categories:["marketing"],domains:["*.bigcommerce.com"]},{name:"Permutive",categories:["ad"],domains:["*.permutive.com","d3alqb8vzo7fun.cloudfront.net"]},{name:"Segment",homepage:"https://segment.com/",categories:["analytics"],domains:["*.segment.com","*.segment.io"]},{name:"Instagram",homepage:"https://www.instagram.com",categories:["social"],domains:["*.cdninstagram.com","*.instagram.com"]},{name:"Sentry",homepage:"https://sentry.io/",categories:["utility"],domains:["*.getsentry.com","*.ravenjs.com","*.sentry-cdn.com"]},{name:"Bugsnag",categories:["utility"],
domains:["*.bugsnag.com","d2wy8f7a9ursnm.cloudfront.net"]},{name:"Dealer",homepage:"https://www.dealer.com/",categories:["hosting"],domains:["*.dealer.com"]},{name:"Judge.me",homepage:"https://judge.me/",categories:["marketing"],domains:["*.judge.me"]},{name:"MGID",homepage:"https://www.mgid.com/",categories:["ad"],domains:["*.mgid.com","*.dt07.net"]},{name:"Outbrain",homepage:"https://www.outbrain.com/",categories:["ad"],domains:["*.outbrain.com","*.outbrainimg.com","*.visualrevenue.com"]},{name:"Optanon",homepage:"https://www.cookielaw.org/",categories:["consent-provider"],domains:["*.onetrust.com","*.cookielaw.org"]},{name:"Intent Media",homepage:"https://intent.com/",categories:["ad"],domains:["*.intentmedia.net"]},{name:"Integral Ad Science",homepage:"https://integralads.com/uk/",categories:["ad"],domains:["*.adsafeprotected.com","*.iasds01.com"]},{name:"Tumblr",homepage:"https://tumblr.com/",categories:["social"],domains:["*.tumblr.com"]},{name:"Rambler",company:"Rambler & Co",
categories:["utility"],domains:["*.rambler.ru"]},{name:"FullStory",categories:["analytics"],domains:["*.fullstory.com"]},{name:"Lucky Orange",homepage:"https://www.luckyorange.com/",categories:["analytics"],domains:["*.luckyorange.com","d10lpsik1i8c69.cloudfront.net","*.luckyorange.net"]},{name:"Mixpanel",homepage:"https://mixpanel.com/",categories:["analytics"],domains:["*.mixpanel.com","*.mxpnl.com"]},{name:"OptinMonster",homepage:"https://optinmonster.com/",categories:["marketing"],domains:["*.opmnstr.com","*.optmnstr.com","*.optmstr.com"]},{name:"Tilda",homepage:"http://tilda.cc/",categories:["hosting"],domains:["*.tildacdn.com"]},{name:"Akamai",homepage:"https://www.akamai.com/",categories:["cdn"],domains:["23.62.3.183","*.akamaitechnologies.com","*.akamaitechnologies.fr","*.akamai.net","*.akamaiedge.net","*.akamaihd.net","*.akamaized.net","*.edgefcs.net","*.edgekey.net","edgesuite.net","*.srip.net"]},{name:"VigLink",categories:["ad"],domains:["*.viglink.com"]},{name:"CallRail",
categories:["analytics"],domains:["*.callrail.com"]},{name:"Scorecard Research",homepage:"https://www.scorecardresearch.com/",categories:["ad"],domains:["*.scorecardresearch.com"]},{name:"Olark",homepage:"https://www.olark.com/",categories:["customer-success"],domains:["*.olark.com"]},{name:"Moat",homepage:"https://moat.com/",categories:["ad"],domains:["*.moatads.com","*.moatpixel.com"]},{name:"Adform",categories:["ad"],domains:["*.adform.net","*.adformdsp.net"]},{name:"Fastly",categories:["utility"],domains:["*.fastly.net"]},{name:"GoDaddy",homepage:"https://www.godaddy.com/",categories:["utility"],domains:["*.godaddy.com","*.wsimg.com"]},{name:"Unpkg",homepage:"https://unpkg.com",categories:["cdn"],domains:["*.unpkg.com","*.npmcdn.com"]},{name:"Brightcove",homepage:"https://www.brightcove.com/en/",categories:["video"],domains:["*.brightcove.com","*.brightcove.net","*.zencdn.net"]},{name:"Drift",homepage:"https://www.drift.com/",categories:["marketing"],
domains:["*.drift.com","*.driftt.com"],products:[{name:"Drift Live Chat",urlPatterns:["REGEXP:js\\.driftt\\.com\\/include\\/.*\\/.*\\.js"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"RD Station",homepage:"https://www.rdstation.com/en/",categories:["marketing"],domains:["d335luupugsy2.cloudfront.net"]},{name:"Mediavine",homepage:"https://www.mediavine.com/",categories:["ad"],domains:["*.mediavine.com"]},{name:"Yahoo!",homepage:"https://www.yahoo.com/",categories:["ad"],domains:["*.bluelithium.com","*.hostingprod.com","*.lexity.com","*.yahoo.com","*.yahooapis.com","*.yimg.com","*.yimg.jp","*.zenfs.com","*.yahoo.net"]},{name:"Snowplow",homepage:"https://snowplowanalytics.com/",categories:["analytics"],domains:["d32hwlnfiv2gyn.cloudfront.net"]},{name:"Adloox",categories:["ad"],domains:["*.adlooxtracking.com"]},{name:"Amazon Pay",homepage:"https://pay.amazon.com",categories:["utility"],
domains:["payments.amazon.com","*.payments-amazon.com"]},{name:"Trusted Shops",categories:["utility"],domains:["*.trustedshops.com"]},{name:"Inspectlet",categories:["analytics"],domains:["*.inspectlet.com"]},{name:"Embedly",categories:["content"],domains:["*.embedly.com","*.embed.ly"]},{name:"Mapbox",categories:["utility"],domains:["*.mapbox.com"]},{name:"LINE Corporation",categories:["ad"],domains:["*.line-scdn.net","*.line.me"]},{name:"Parking Crew",homepage:"http://parkingcrew.net/",categories:["other"],domains:["d1lxhc4jvstzrp.cloudfront.net","*.parkingcrew.net"]},{name:"MailMunch",categories:["ad"],domains:["*.mailmunch.co"]},{name:"Crazy Egg",homepage:"https://www.crazyegg.com/",categories:["analytics"],domains:["*.cetrk.com","*.crazyegg.com","*.hellobar.com","dnn506yrbagrg.cloudfront.net"]},{name:"Index Exchange",company:"WPP",categories:["ad"],domains:["*.casalemedia.com","*.indexww.com"]},{name:"Microsoft Hosted Libs",company:"Microsoft",categories:["cdn"],
domains:["*.aspnetcdn.com"]},{name:"Treasure Data",categories:["analytics"],domains:["*.treasuredata.com"]},{name:"VWO",homepage:"https://vwo.com",categories:["analytics"],domains:["*.visualwebsiteoptimizer.com"]},{name:"sovrn",categories:["ad"],domains:["*.lijit.com"]},{name:"Pure Chat",categories:["customer-success"],domains:["*.purechat.com"]},{name:"Gemius",categories:["ad"],domains:["*.gemius.pl"]},{name:"Chartbeat",categories:["analytics"],domains:["*.chartbeat.com","*.chartbeat.net"]},{name:"SoundCloud",homepage:"https://www.soundcloud.com/",categories:["content"],domains:["*.sndcdn.com","*.soundcloud.com","*.stratus.sc"]},{name:"Cxense",categories:["ad"],domains:["*.cxense.com","*.cxpublic.com","*.emediate.dk","*.emediate.eu"]},{name:"Crisp",homepage:"https://crisp.chat/",categories:["customer-success"],domains:["*.crisp.chat"]},{name:"LivePerson",categories:["customer-success"],homepage:"https://www.liveperson.com/",
domains:["*.liveperson.com","*.look.io","*.liveperson.net","*.lpsnmedia.net"]},{name:"Searchanise",categories:["analytics"],domains:["*.searchanise.com"]},{name:"Monotype",categories:["cdn"],domains:["*.fonts.com","*.fonts.net"]},{name:"Beeketing",homepage:"https://beeketing.com/",categories:["marketing"],domains:["*.beeketing.com"]},{name:"FreakOut",categories:["ad"],domains:["*.fout.jp"]},{name:"Quantcast",homepage:"https://www.quantcast.com",categories:["analytics"],domains:["*.brtstats.com","*.quantcount.com","*.quantserve.com","*.semantictec.com","*.ntv.io"]},{name:"Ensighten",homepage:"https://www.ensighten.com/",categories:["tag-manager"],domains:["*.ensighten.com"]},{name:"WordPress Site Stats",company:"Automattic",homepage:"https://wp.com/",categories:["analytics"],domains:["pixel.wp.com","stats.wp.com"]},{name:"Infolinks",categories:["ad"],domains:["*.infolinks.com"]},{name:"LiveJournal",categories:["social"],domains:["*.livejournal.com","*.livejournal.net"]},{
name:"BrightTag / Signal",company:"Signal",homepage:"https://www.signal.co",categories:["tag-manager"],domains:["*.btstatic.com","*.thebrighttag.com"]},{name:"Unbounce",categories:["ad"],domains:["*.ubembed.com","*.unbounce.com","d2xxq4ijfwetlm.cloudfront.net","d9hhrg4mnvzow.cloudfront.net"]},{name:"Accessibe",homepage:"https://accessibe.com/",categories:["utility"],domains:["*.accessibe.com","*.acsbap.com"]},{name:"CreateJS CDN",homepage:"http://code.createjs.com/",categories:["cdn"],domains:["*.createjs.com"]},{name:"Teads",categories:["ad"],domains:["*.teads.tv"]},{name:"LongTail Ad Solutions",categories:["ad"],domains:["*.jwpcdn.com","*.jwplatform.com","*.jwplayer.com","*.jwpltx.com","*.jwpsrv.com","*.longtailvideo.com"]},{name:"CDK Dealer Management",company:"CDK Global",homepage:"https://www.cdkglobal.com/us",categories:["hosting"],domains:["*.assets-cdk.com"]},{name:"StatCounter",categories:["analytics"],domains:["*.statcounter.com"]},{name:"Parse.ly",categories:["analytics"],
domains:["*.parsely.com","d1z2jf7jlzjs58.cloudfront.net"]},{name:"ContactAtOnce",homepage:"https://www.contactatonce.com/",categories:["customer-success"],domains:["*.contactatonce.com"]},{name:"i-mobile",company:"i-mobile",categories:["ad"],domains:["*.i-mobile.co.jp"]},{name:"Spotify",homepage:"https://www.spotify.com/",categories:["content"],domains:["*.scdn.co","*.spotify.com"]},{name:"Adobe Business Catalyst",homepage:"https://www.businesscatalyst.com/",categories:["hosting"],domains:["*.businesscatalyst.com"]},{name:"Tray Commerce",homepage:"https://www.tray.com.br/",categories:["marketing"],domains:["*.tcdn.com.br"]},{name:"OpenX",homepage:"https://www.openx.com/",categories:["ad"],domains:["*.deliverimp.com","*.openxadexchange.com","*.servedbyopenx.com","*.jump-time.net","*.openx.net"]},{name:"AB Tasty",categories:["analytics"],domains:["*.abtasty.com","d1447tq2m68ekg.cloudfront.net"]},{name:"PushCrew",categories:["ad"],domains:["*.pushcrew.com"]},{name:"Popads",
homepage:"https://www.popads.net/",categories:["ad"],domains:["*.popads.net"]},{name:"GumGum",categories:["ad"],domains:["*.gumgum.com"]},{name:"PureCars",homepage:"https://www.purecars.com/",categories:["marketing"],domains:["*.purecars.com"]},{name:"Smart AdServer",categories:["ad"],domains:["*.01net.com","*.sascdn.com","*.sasqos.com","*.smartadserver.com"]},{name:"Salesforce Commerce Cloud",homepage:"https://www.salesforce.com/products/commerce-cloud/overview/",categories:["hosting"],domains:["*.cquotient.com","*.demandware.net","demandware.edgesuite.net"]},{name:"SnapWidget",categories:["content"],domains:["*.snapwidget.com"]},{name:"District M",categories:["ad"],domains:["*.districtm.io"]},{name:"Heap",categories:["analytics"],domains:["*.heapanalytics.com"]},{name:"Net Reviews",categories:["analytics"],domains:["*.avis-verifies.com"]},{name:"Marchex",categories:["analytics"],domains:["*.voicestar.com","*.marchex.io"]},{name:"Affirm",categories:["utility"],domains:["*.affirm.com"]
},{name:"Amplitude Mobile Analytics",company:"Amplitude",categories:["analytics"],domains:["*.amplitude.com","d24n15hnbwhuhn.cloudfront.net"]},{name:"MaxCDN Enterprise",company:"MaxCDN",categories:["utility"],domains:["*.netdna-cdn.com","*.netdna-ssl.com"]},{name:"TikTok",company:"ByteDance Ltd",homepage:"https://www.tiktok.com/en/",categories:["social"],domains:["*.tiktok.com","*.ipstatp.com"]},{name:"LightWidget",categories:["utility"],domains:["*.lightwidget.com"]},{name:"uLogin",categories:["other"],domains:["*.ulogin.ru"]},{name:"BlueKai",company:"Oracle",categories:["ad"],domains:["*.bkrtx.com","*.bluekai.com"]},{name:"Gigya",categories:["analytics"],domains:["*.gigya.com"]},{name:"Tencent",categories:["content"],domains:["*.qq.com","*.ywxi.net"]},{name:"Fraudlogix",categories:["utility"],domains:["*.yabidos.com"]},{name:"Research Online",company:"Skills Development Scotland",categories:["content"],domains:["*.researchonline.org.uk"]},{name:"Help Scout",
homepage:"https://www.helpscout.net/",categories:["customer-success"],domains:["djtflbt20bdde.cloudfront.net","*.helpscout.net"],products:[{name:"Help Scout Beacon",urlPatterns:["beacon-v2.helpscout.net"],facades:[{name:"React Live Chat Loader",repo:"https://github.com/calibreapp/react-live-chat-loader"}]}]},{name:"Secomapp",categories:["utility"],domains:["*.secomapp.com"]},{name:"fam",company:"Fing Co Ltd.",homepage:"http://admin.fam-ad.com/report/",categories:["ad"],domains:["*.fam-ad.com"]},{name:"SocialShopWave",categories:["social"],domains:["*.socialshopwave.com"]},{name:"TrafficStars",categories:["ad"],domains:["*.trafficstars.com","*.tsyndicate.com"]},{name:"Heroku",categories:["other"],domains:["*.herokuapp.com"]},{name:"iPerceptions",categories:["customer-success"],domains:["*.iperceptions.com"]},{name:"Nosto",categories:["analytics"],domains:["*.nosto.com"]},{name:"issuu",categories:["content"],domains:["*.issuu.com","*.isu.pub"]},{name:"Albacross",
homepage:"https://albacross.com/",categories:["marketing"],domains:["*.albacross.com"]},{name:"Ve",company:"Ve Interactive",categories:["marketing"],domains:["*.veinteractive.com"]},{name:"Bazaarvoice",categories:["analytics"],domains:["*.bazaarvoice.com","*.feedmagnet.com"]},{name:"Dailymotion",categories:["content"],domains:["*.dailymotion.com","*.dmxleo.com","*.dm.gg","*.pxlad.io","*.dmcdn.net","*.sublimevideo.net"]},{name:"GetSiteControl",company:"GetWebCraft",categories:["utility"],domains:["*.getsitecontrol.com"]},{name:"DoubleVerify",homepage:"https://www.doubleverify.com/",categories:["ad"],domains:["*.doubleverify.com","*.dvtps.com","*.iqfp1.com"]},{name:"Esri ArcGIS",company:"Esri",categories:["utility"],domains:["*.arcgis.com","*.arcgisonline.com"]},{name:"Signyfyd",categories:["utility"],domains:["*.signifyd.com"]},{name:"Feefo.com",company:"Feefo",categories:["analytics"],domains:["*.feefo.com"]},{name:"Booking.com",categories:["content"],domains:["*.bstatic.com"]},{
name:"Sharethrough",categories:["ad"],domains:["*.sharethrough.com"]},{name:"Seznam",categories:["utility"],domains:["*.imedia.cz"]},{name:"etracker",categories:["analytics"],domains:["*.etracker.com","*.etracker.de"]},{name:"Roxr Software",categories:["analytics"],domains:["*.getclicky.com"]},{name:"OptiMonk",categories:["ad"],domains:["*.optimonk.com"]},{name:"Perfect Market",categories:["ad"],domains:["*.perfectmarket.com"]},{name:"OpenTable",company:"Priceline Group",categories:["content"],domains:["*.opentable.com","*.opentable.co.uk","*.toptable.co.uk"]},{name:"Sortable",categories:["ad"],domains:["*.deployads.com"]},{name:"Swiftype",categories:["utility"],domains:["*.swiftype.com","*.swiftypecdn.com"]},{name:"Siteimprove",categories:["utility"],domains:["*.siteimprove.com","*.siteimproveanalytics.com"]},{name:"JuicyAds",categories:["ad"],domains:["*.juicyads.com"]},{name:"Accuweather",categories:["content"],domains:["*.accuweather.com"]},{name:"Sizmek",
homepage:"https://www.sizmek.com/",categories:["ad"],domains:["*.serving-sys.com","*.peer39.net"]},{name:"Key CDN",categories:["utility"],domains:["*.kxcdn.com"]},{name:"Bootstrap CDN",homepage:"https://www.bootstrapcdn.com/",categories:["cdn"],domains:["*.bootstrapcdn.com"]},{name:"Pardot",categories:["marketing"],domains:["*.pardot.com"]},{name:"Foursixty",categories:["customer-success"],domains:["*.foursixty.com"]},{name:"Ecwid",categories:["hosting"],domains:["*.ecwid.com","*.shopsettings.com","d3fi9i0jj23cau.cloudfront.net","d3j0zfs7paavns.cloudfront.net"]},{name:"BounceX",categories:["analytics"],homepage:"https://www.bouncex.com/",domains:["*.bounceexchange.com","*.bouncex.net"]},{name:"TrustArc",homepage:"https://www.trustarc.com/",categories:["utility"],domains:["*.trustarc.com"]},{name:"iZooto",homepage:"https://www.izooto.com",categories:["marketing"],domains:["*.izooto.com"]},{name:"ContentSquare",categories:["analytics"],
domains:["d1m6l9dfulcyw7.cloudfront.net","*.content-square.net","*.contentsquare.net"]},{name:"Marketo",homepage:"https://www.marketo.com",categories:["analytics"],domains:["*.marketo.com","*.mktoresp.com","*.marketo.net"]},{name:"LKQD",categories:["ad"],domains:["*.lkqd.net"]},{name:"Ezoic",categories:["analytics"],domains:["*.ezoic.net"]},{name:"Comm100",categories:["customer-success"],domains:["*.comm100.com"]},{name:"Refersion",categories:["ad"],domains:["*.refersion.com"]},{name:"Constant Contact",categories:["ad"],domains:["*.ctctcdn.com"]},{name:"UserReport",categories:["analytics"],domains:["*.userreport.com"]},{name:"Bizible",categories:["ad"],domains:["*.bizible.com","*.bizibly.com"]},{name:"LoyaltyLion",categories:["ad"],domains:["*.loyaltylion.com","*.loyaltylion.net","dg1f2pfrgjxdq.cloudfront.net"]},{name:"PageSense",homepage:"https://www.zoho.com/pagesense/",categories:["analytics"],domains:["*.pagesense.io"]},{name:"AppDynamics",homepage:"https://www.appdynamics.com/",
categories:["utility"],domains:["*.appdynamics.com","*.eum-appdynamics.com","d3tjaysgumg9lf.cloudfront.net"]},{name:"Disqus",homepage:"http://disqus.com/",categories:["social"],domains:["*.disqus.com","*.disquscdn.com"]},{name:"AppNexus",homepage:"https://www.appnexus.com/",categories:["ad"],domains:["*.adnxs.com","*.ctasnet.com","*.adrdgt.com"]},{name:"ResponsiveVoice",categories:["other"],domains:["*.responsivevoice.org"]},{name:"Adyoulike",categories:["ad"],domains:["*.adyoulike.com","*.omnitagjs.com","*.adyoulike.net"]},{name:"ExoClick",categories:["ad"],domains:["*.exoclick.com"]},{name:"RevJet",homepage:"https://www.revjet.com/",categories:["ad"],domains:["*.revjet.com"]},{name:"Rakuten Marketing",company:"Rakuten",categories:["ad"],domains:["*.rakuten-static.com","*.rmtag.com"]},{name:"Attentive",homepage:"https://attentivemobile.com/",categories:["ad"],domains:["*.attn.tv","*.attentivemobile.com"]},{name:"Unruly Media",categories:["ad"],domains:["*.unrulymedia.com"]},{
name:"33 Across",homepage:"https://33across.com/",categories:["ad"],domains:["*.33across.com"]},{name:"piano",categories:["ad"],domains:["*.npttech.com","*.tinypass.com"]},{name:"Smart Insight Tracking",company:"Emarsys",categories:["analytics"],domains:["*.scarabresearch.com"]},{name:"Geniee",categories:["ad"],domains:["*.href.asia","*.genieessp.jp","*.genieesspv.jp","*.gssprt.jp"]},{name:"Medium",categories:["content"],domains:["*.medium.com"]},{name:"Vidible",categories:["ad"],domains:["*.vidible.tv"]},{name:"Revolver Maps",categories:["analytics"],domains:["*.revolvermaps.com"]},{name:"SublimeSkinz",categories:["ad"],domains:["*.ayads.co"]},{name:"Kampyle",categories:["analytics"],domains:["*.kampyle.com"]},{name:"Nativo",categories:["ad"],domains:["*.postrelease.com"]},{name:"SnapEngage",categories:["customer-success"],domains:["*.snapengage.com"]},{name:"Sift Science",categories:["utility"],domains:["*.siftscience.com"]},{name:"Riskified",categories:["utility"],
domains:["*.riskified.com"]},{name:"Listrak",homepage:"https://www.listrak.com/",categories:["marketing"],domains:["*.listrak.com","*.listrakbi.com"]},{name:"GetResponse",categories:["ad"],domains:["*.getresponse.com"]},{name:"TagCommander",categories:["tag-manager"],domains:["*.commander1.com","*.tagcommander.com"]},{name:"Twitch",homepage:"https://twitch.tv/",categories:["video"],domains:["*.twitch.tv"]},{name:"Evidon",categories:["analytics"],domains:["*.evidon.com"]},{name:"Bronto Software",categories:["marketing"],domains:["*.bm23.com","*.bronto.com","*.brontops.com"]},{name:"Tribal Fusion",company:"Exponential Interactive",categories:["ad"],domains:["*.tribalfusion.com"]},{name:"PowerReviews",categories:["analytics"],domains:["*.powerreviews.com"]},{name:"Admixer for Publishers",company:"Admixer",categories:["ad"],domains:["*.admixer.net"]},{name:"Salesforce.com",categories:["ad"],domains:["*.force.com","*.salesforce.com"]},{name:"Covert Pics",categories:["content"],
domains:["*.covet.pics"]},{name:"Keen",company:"Keen",homepage:"https://keen.io/",categories:["analytics"],domains:["*.keen.io","d26b395fwzu5fz.cloudfront.net"]},{name:"Branch Metrics",categories:["ad"],domains:["*.branch.io","*.app.link"]},{name:"GitHub",categories:["utility"],domains:["*.github.com","*.githubusercontent.com","*.github.io","*.rawgit.com"]},{name:"Dynamic Yield",categories:["customer-success"],domains:["*.dynamicyield.com"]},{name:"ForeSee",company:"Answers",categories:["analytics"],domains:["*.4seeresults.com","*.answerscloud.com","*.foresee.com","*.foreseeresults.com"]},{name:"Clerk.io ApS",categories:["analytics"],domains:["*.clerk.io"]},{name:"iovation",categories:["utility"],domains:["*.iesnare.com"]},{name:"Convert Insights",categories:["analytics"],domains:["*.convertexperiments.com"]},{name:"STINGRAY",company:"FlexOne",categories:["ad"],domains:["*.impact-ad.jp"]},{name:"iAdvize SAS",categories:["customer-success"],domains:["*.iadvize.com"]},{name:"Digioh",
categories:["ad"],domains:["*.lightboxcdn.com"]},{name:"Polar",homepage:"https://polar.me/",categories:["ad"],domains:["*.polarmobile.ca","*.mediaeverywhere.com","*.mediavoice.com","*.plrsrvcs.com","*.polarcdn-engine.com","*.polarcdn-meraxes.com","*.polarcdn-pentos.com","*.polarcdn-static.com","*.polarcdn-terrax.com","*.polarcdn.com","*.polarmobile.com","*.poweredbypolar.com","*.mediaconductor.me","*.polaracademy.me"]},{name:"eBay",categories:["ad"],domains:["*.ebay.com","*.ebayimg.com","*.fetchback.com"]},{name:"Pendo",homepage:"https://www.pendo.io",categories:["analytics"],domains:["*.pendo.io"]},{name:"Clicktale",categories:["analytics"],domains:["*.cdngc.net","*.clicktale.net"]},{name:"Symantec",categories:["utility"],domains:["*.norton.com","*.symantec.com","*.symcb.com","*.symcd.com"]},{name:"Nend",categories:["ad"],domains:["*.nend.net"]},{name:"StickyADS.tv",categories:["ad"],domains:["*.stickyadstv.com"]},{name:"TrackJS",categories:["analytics"],
domains:["*.trackjs.com","d2zah9y47r7bi2.cloudfront.net"]},{name:"Usabilla",homepage:"https://usabilla.com",categories:["analytics"],domains:["*.usabilla.com","d6tizftlrpuof.cloudfront.net"]},{name:"Technorati",company:"Synacor",categories:["ad"],domains:["*.technoratimedia.com"]},{name:"SessionCam",company:"ServiceTick",categories:["analytics"],domains:["*.sessioncam.com","d2oh4tlt9mrke9.cloudfront.net"]},{name:"SpringServer",categories:["ad"],domains:["*.springserve.com"]},{name:"Hotmart",homepage:"https://www.hotmart.com/",categories:["content"],domains:["*.hotmart.com"]},{name:"WisePops",categories:["utility"],domains:["*.wisepops.com"]},{name:"IBM Digital Analytics",company:"IBM",categories:["analytics"],domains:["*.cmcore.com","coremetrics.com","data.coremetrics.com","data.de.coremetrics.com","libs.de.coremetrics.com","tmscdn.de.coremetrics.com","iocdn.coremetrics.com","libs.coremetrics.com","tmscdn.coremetrics.com","*.s81c.com","*.unica.com","*.coremetrics.eu"]},{name:"ZEDO",
categories:["ad"],domains:["*.zedo.com"]},{name:"AdMatic",categories:["ad"],domains:["*.admatic.com.tr"]},{name:"Wishpond Technologies",categories:["marketing"],domains:["*.wishpond.com","*.wishpond.net"]},{name:"Monetate",categories:["analytics"],domains:["*.monetate.net"]},{name:"AOL / Oath / Verizon Media",homepage:"https://www.oath.com/",categories:["ad"],domains:["*.advertising.com","*.aol.com","*.aolcdn.com","*.blogsmithmedia.com","*.oath.com","*.aol.net","*.tacoda.net","*.aol.co.uk"]},{name:"IPONWEB",categories:["ad"],domains:["*.company-target.com","*.liadm.com","*.iponweb.net","*.p161.net"]},{name:"Fort Awesome",categories:["cdn"],domains:["*.fortawesome.com"]},{name:"Affiliate Window",company:"Digital Window",categories:["ad"],domains:["*.dwin1.com"]},{name:"Forter",categories:["utility"],domains:["*.forter.com"]},{name:"WebsiteBuilder.com",homepage:"https://www.websitebuilder.com",categories:["hosting"],domains:["*.mywebsitebuilder.com"]},{name:"Reviews.co.uk",
categories:["analytics"],domains:["*.reviews.co.uk"]},{name:"Maxymiser",categories:["analytics"],domains:["*.maxymiser.net"]},{name:"Adocean",company:"Gemius",categories:["ad"],domains:["*.adocean.pl"]},{name:"Lytics",categories:["ad"],domains:["*.lytics.io"]},{name:"plista",categories:["ad"],domains:["*.plista.com"]},{name:"Bootstrap Chinese network",categories:["cdn"],domains:["*.bootcss.com"]},{name:"Snacktools",categories:["ad"],domains:["*.bannersnack.com"]},{name:"Skype",categories:["other"],domains:["*.skype.com"]},{name:"Okas Concepts",categories:["utility"],domains:["*.okasconcepts.com"]},{name:"Freshdesk",homepage:"https://freshdesk.com/",categories:["customer-success"],domains:["d36mpcpuzc4ztk.cloudfront.net"]},{name:"AIR.TV",categories:["ad"],domains:["*.air.tv"]},{name:"Rackspace",categories:["hosting"],domains:["*.rackcdn.com","*.rackspacecloud.com","*.raxcdn.com","*.websitetestlink.com"]},{name:"Shareaholic",homepage:"https://www.shareaholic.com/",categories:["social"],
domains:["*.shareaholic.com","dsms0mj1bbhn4.cloudfront.net"]},{name:"Meetrics",categories:["ad"],domains:["*.de.com","*.meetrics.net","*.mxcdn.net"]},{name:"LiveTex",categories:["customer-success"],domains:["*.livetex.ru"]},{name:"Media Management Technologies",categories:["ad"],domains:["*.speedshiftmedia.com"]},{name:"Opentag",company:"Qubit",categories:["tag-manager"],domains:["*.qutics.com","d3c3cq33003psk.cloudfront.net"]},{name:"Crowd Control",company:"Lotame",categories:["ad"],domains:["*.crwdcntrl.net"]},{name:"Wufoo",categories:["utility"],domains:["*.wufoo.com"]},{name:"Exponea",categories:["analytics"],domains:["*.exponea.com"]},{name:"Forensiq",categories:["utility"],domains:["*.fqtag.com"]},{name:"fluct",categories:["ad"],domains:["*.adingo.jp"]},{name:"Pagely",categories:["other"],domains:["*.optnmstr.com"]},{name:"ClickDesk",categories:["customer-success"],domains:["*.clickdesk.com","d1gwclp1pmzk26.cloudfront.net"]},{name:"Alexa",homepage:"https://www.alexa.com/",
categories:["analytics"],domains:["*.alexametrics.com","d31qbv1cthcecs.cloudfront.net"]},{name:"Radar",company:"Cedexis",homepage:"https://www.cedexis.com/radar/",categories:["analytics"],domains:["*.cedexis-test.com","*.cedexis.com","*.cmdolb.com","cedexis.leasewebcdn.com","*.cedexis-radar.net","*.cedexis.net","cedexis-test01.insnw.net","cedexisakamaitest.azureedge.net","cedexispub.cdnetworks.net","cs600.wac.alphacdn.net","cs600.wpc.edgecastdns.net","global2.cmdolb.com","img-cedexis.mncdn.com","a-cedexis.msedge.net","zn3vgszfh.fastestcdn.net"]},{name:"Talkable",categories:["ad"],domains:["*.talkable.com","d2jjzw81hqbuqv.cloudfront.net"]},{name:"WebEngage",categories:["customer-success"],domains:["*.webengage.co","*.webengage.com","d23nd6ymopvz52.cloudfront.net","d3701cc9l7v9a6.cloudfront.net"]},{name:"rewardStyle.com",categories:["ad"],domains:["*.rewardstyle.com"]},{name:"Revcontent",categories:["content"],domains:["*.revcontent.com"]},{name:"iBillboard",categories:["ad"],
domains:["*.ibillboard.com"]},{name:"Decibel Insight",categories:["analytics"],domains:["*.decibelinsight.net"]},{name:"Vidyard",homepage:"https://www.vidyard.com/",categories:["utility"],domains:["*.vidyard.com"]},{name:"Quantum Metric",homepage:"https://www.quantummetric.com/",categories:["analytics"],domains:["*.quantummetric.com"]},{name:"Civic",categories:["hosting"],domains:["*.civiccomputing.com"]},{name:"Highcharts",categories:["utility"],domains:["*.highcharts.com"]},{name:"Dynatrace",categories:["analytics"],domains:["*.ruxit.com","js-cdn.dynatrace.com"]},{name:"Auto Link Maker",company:"Apple",categories:["ad"],domains:["*.apple.com"]},{name:"Hubvisor",homepage:"https://www.hubvisor.io",categories:["ad"],domains:["*.hubvisor.io"]},{name:"Appier",categories:["ad"],domains:["*.appier.net"]},{name:"Yieldify",categories:["ad"],domains:["*.yieldify.com","*.yieldifylabs.com","d33wq5gej88ld6.cloudfront.net","dwmvwp56lzq5t.cloudfront.net"]},{name:"Sooqr Search",company:"Sooqr",
categories:["utility"],domains:["*.sooqr.com"]},{name:"Kaltura Video Platform",company:"Kaltura",categories:["content"],domains:["*.kaltura.com"]},{name:"BoldChat",company:"LogMeIn",categories:["customer-success"],domains:["*.boldchat.com"]},{name:"FirstImpression",categories:["ad"],domains:["*.firstimpression.io"]},{name:"Picreel",categories:["analytics"],domains:["*.pcrl.co","*.picreel.com"]},{name:"DigiTrust",homepage:"http://www.digitru.st/",categories:["analytics"],domains:["*.digitru.st"]},{name:"AdsWizz",categories:["ad"],domains:["*.adswizz.com"]},{name:"SaleCycle",categories:["ad"],domains:["*.salecycle.com","d16fk4ms6rqz1v.cloudfront.net","d22j4fzzszoii2.cloudfront.net","d30ke5tqu2tkyx.cloudfront.net","dn1i8v75r669j.cloudfront.net"]},{name:"Flowplayer",categories:["content"],domains:["*.flowplayer.org"]},{name:"LoopMe",categories:["ad"],domains:["*.loopme.biz","*.loopme.com","*.vntsm.com","*.loopme.me"]},{name:"Tail Target",company:"Tail",categories:["ad"],
domains:["*.tailtarget.com"]},{name:"AddShoppers",categories:["social"],domains:["*.addshoppers.com","d3rr3d0n31t48m.cloudfront.net","*.shop.pe"]},{name:"Browsealoud",homepage:"https://www.texthelp.com/en-gb/products/browsealoud/",categories:["other"],domains:["*.browsealoud.com","*.texthelp.com"]},{name:"LinkedIn Ads",categories:["ad"],domains:["*.licdn.com","ads.linkedin.com","www.linkedin.com"]},{name:"Audience 360",company:"Datapoint Media",categories:["ad"],domains:["*.dpmsrv.com"]},{name:"Tag Inspector",company:"InfoTrust",categories:["analytics"],domains:["d22xmn10vbouk4.cloudfront.net"]},{name:"MonetizeMore",categories:["ad"],domains:["*.m2.ai"]},{name:"Mather Economics",categories:["analytics"],domains:["*.matheranalytics.com"]},{name:"Fresh Relevance",categories:["analytics"],domains:["*.freshrelevance.com","*.cloudfront.ne","d1y9qtn9cuc3xw.cloudfront.net","d81mfvml8p5ml.cloudfront.net","dkpklk99llpj0.cloudfront.net"]},{name:"Supership",homepage:"https://supership.jp/",
categories:["ad"],domains:["*.socdm.com"]},{name:"Fastly Insights",homepage:"https://insights.fastlylabs.com",categories:["analytics"],domains:["*.fastly-insights.com"]},{name:"Keywee",categories:["ad"],domains:["*.keywee.co"]},{name:"LiveHelpNow",categories:["customer-success"],domains:["*.livehelpnow.net"]},{name:"AudienceSearch",company:"Intimate Merger",categories:["ad"],domains:["*.im-apps.net"]},{name:"Evergage",categories:["analytics"],domains:["*.evergage.com","*.evgnet.com"]},{name:"Wicked Reports",homepage:"https://www.wickedreports.com/",categories:["marketing"],domains:["*.wickedreports.com"]},{name:"ReadSpeaker",homepage:"https://www.readspeaker.com",categories:["other"],domains:["*.readspeaker.com"]},{name:"WebpageFX",categories:["ad"],domains:["*.leadmanagerfx.com"]},{name:"Adobe Scene7",company:"Adobe Systems",categories:["content"],domains:["wwwimages.adobe.com","*.scene7.com","*.everestads.net","*.everestjs.net"]},{name:"IBM Acoustic Campaign",company:"IBM",
categories:["analytics"],domains:["www.sc.pages01.net","www.sc.pages02.net","www.sc.pages03.net","www.sc.pages04.net","www.sc.pages05.net","www.sc.pages06.net","www.sc.pages07.net","www.sc.pages08.net","www.sc.pages09.net","www.sc.pagesA.net"]},{name:"The Trade Desk",homepage:"https://www.thetradedesk.com/",categories:["ad"],domains:["*.adsrvr.org","d1eoo1tco6rr5e.cloudfront.net"]},{name:"Google Plus",company:"Google",categories:["social"],domains:["plus.google.com"]},{name:"SearchSpring",categories:["utility"],domains:["*.searchspring.net"]},{name:"Curalate",categories:["marketing"],domains:["*.curalate.com","d116tqlcqfmz3v.cloudfront.net"]},{name:"Pixlee",categories:["social"],domains:["*.pixlee.com"]},{name:"Weborama",categories:["ad"],domains:["*.weborama.com","*.weborama.fr"]},{name:"Apester",categories:["analytics"],domains:["*.apester.com","*.qmerce.com"]},{name:"Sekindo",categories:["content"],domains:["*.sekindo.com"]},{name:"FoxyCart",categories:["utility"],
domains:["*.foxycart.com"]},{name:"MaxMind",categories:["utility"],domains:["*.maxmind.com"]},{name:"Braze",homepage:"https://www.braze.com",categories:["analytics"],domains:["*.appboycdn.com"]},{name:"smartclip",categories:["ad"],domains:["*.smartclip.net"]},{name:"Opta",company:"Perform Group",categories:["content"],domains:["*.opta.net"]},{name:"Interpublic Group",categories:["ad"],domains:["*.mbww.com"]},{name:"Between Digital",categories:["ad"],domains:["*.betweendigital.com"]},{name:"CyberSource (Visa)",categories:["utility"],domains:["*.authorize.net"]},{name:"JustPremium Ads",company:"JustPremium",categories:["ad"],domains:["*.justpremium.com"]},{name:"Concert",homepage:"https://concert.io/",categories:["ad"],domains:["*.concert.io"]},{name:"Vox Media",homepage:"https://www.voxmedia.com/",categories:["content"],domains:["*.vox-cdn.com","*.voxmedia.com"]},{name:"CPEx",categories:["content"],domains:["*.cpex.cz"]},{name:"TripAdvisor",categories:["content"],
domains:["*.jscache.com","*.tacdn.com","*.tamgrt.com","*.tripadvisor.com","*.viator.com","*.tripadvisor.co.uk"]},{name:"Ipify",homepage:"https://www.ipify.org",categories:["utility"],domains:["*.ipify.org"]},{name:"Click Guardian",homepage:"https://www.clickguardian.co.uk/",categories:["advertising"],domains:["*.clickguardian.app","*.clickguardian.co.uk"]},{name:"Autopilot",categories:["ad"],domains:["*.autopilothq.com"]},{name:"KISSmetrics",categories:["analytics"],domains:["*.kissmetrics.com","doug1izaerwt3.cloudfront.net","dsyszv14g9ymi.cloudfront.net"]},{name:"Yieldmo",categories:["ad"],domains:["*.yieldmo.com"]},{name:"Simplicity Marketing",categories:["ad"],domains:["*.flashtalking.com"]},{name:"mParticle",homepage:"https://www.mparticle.com/",categories:["utility"],domains:["*.mparticle.com"]},{name:"Global-e",categories:["hosting"],domains:["*.global-e.com"]},{name:"SurveyMonkey",categories:["analytics"],domains:["*.surveymonkey.com"]},{name:"Connatix",categories:["ad"],
domains:["*.connatix.com"]},{name:"Drip",company:"The Numa Group",categories:["ad"],domains:["*.getdrip.com"]},{name:"BannerFlow",company:"Nordic Factory Solutions",categories:["ad"],domains:["*.bannerflow.com"]},{name:"DemandBase",categories:["marketing"],domains:["*.demandbase.com"]},{name:"DMD Marketing",homepage:"https://www.dmdconnects.com/",categories:["ad"],domains:["*.medtargetsystem.com"]},{name:"Omniconvert",categories:["analytics"],domains:["*.omniconvert.com","d2tgfbvjf3q6hn.cloudfront.net","d3vbj265bmdenw.cloudfront.net"]},{name:"Yottaa",categories:["hosting"],domains:["*.yottaa.com","*.yottaa.net"]},{name:"Sirv",categories:["other"],domains:["*.sirv.com"]},{name:"TripleLift",categories:["ad"],domains:["*.3lift.com"]},{name:"Edge Web Fonts",company:"Adobe Systems",categories:["cdn"],domains:["*.edgefonts.net"]},{name:"Tradelab",categories:["ad"],domains:["*.tradelab.fr"]},{name:"DialogTech",categories:["ad"],domains:["*.dialogtech.com"]},{name:"Calendly",
categories:["other"],domains:["*.calendly.com"]},{name:"Media Math",homepage:"http://www.mediamath.com/",categories:["ad"],domains:["*.mathads.com","*.mathtag.com"]},{name:"Typepad",categories:["hosting"],domains:["*.typepad.com"]},{name:"Qualaroo",categories:["analytics"],domains:["*.qualaroo.com"]},{name:"Drawbridge",homepage:"https://www.drawbridge.com/",categories:["ad"],domains:["*.adsymptotic.com"]},{name:"Stamped.io",categories:["analytics"],domains:["*.stamped.io"]},{name:"Feedbackify",company:"InsideMetrics",categories:["analytics"],domains:["*.feedbackify.com"]},{name:"Auth0",homepage:"https://auth0.com/",categories:["utility"],domains:["*.auth0.com"]},{name:"Datawrapper",categories:["utility"],domains:["*.datawrapper.de","*.dwcdn.net"]},{name:"Reviews.io",categories:["analytics"],domains:["*.reviews.io"]},{name:"Adscale",categories:["ad"],domains:["*.adscale.de"]},{name:"SpotXchange",categories:["ad"],domains:["*.spotxcdn.com","*.spotxchange.com","*.spotx.tv"]},{
name:"Stackla PTY",categories:["social"],domains:["*.stackla.com"]},{name:"linkpulse",categories:["analytics"],domains:["*.lp4.io"]},{name:"Market GID",homepage:"https://www.marketgid.com/",categories:["ad"],domains:["*.marketgid.com"]},{name:"CleverTap",categories:["analytics"],domains:["d2r1yp2w7bby2u.cloudfront.net"]},{name:"Infinity Tracking",categories:["analytics"],domains:["*.infinity-tracking.net"]},{name:"Mouseflow",categories:["analytics"],domains:["*.mouseflow.com"]},{name:"Luigi’s Box",company:"Luigi’s Box",homepage:"https://www.luigisbox.com/",categories:["utility"],domains:["*.luigisbox.com"]},{name:"Shopgate",categories:["utility"],domains:["*.shopgate.com"]},{name:"Reklama",categories:["ad"],domains:["*.o2.pl","*.wp.pl"]},{name:"Survicate",categories:["analytics"],domains:["*.survicate.com"]},{name:"Ad6Media",categories:["ad"],domains:["*.ad6media.fr"]},{name:"GetIntent RTBSuite",company:"GetIntent",categories:["ad"],domains:["*.adhigh.net"]},{name:"Snack Media",
categories:["content"],domains:["*.snack-media.com"]},{name:"Cloudinary",categories:["content"],domains:["*.cloudinary.com"]},{name:"ThreatMetrix",categories:["utility"],domains:["*.online-metrix.net"]},{name:"Delta Projects AB",categories:["ad"],domains:["*.de17a.com"]},{name:"Adition",homepage:"https://www.adition.com",categories:["ad"],domains:["*.adition.com"]},{name:"Rocket Fuel",categories:["ad"],domains:["*.rfihub.com","*.ru4.com","*.rfihub.net","*.ad1x.com"]},{name:"Marketplace Web Service",company:"Amazon",categories:["other"],domains:["*.ssl-images-amazon.com"]},{name:"OneSignal",homepage:"https://onesignal.com/",categories:["utility"],domains:["*.onesignal.com"]},{name:"Customer.io",categories:["ad"],domains:["*.customer.io"]},{name:"Gleam",categories:["marketing"],domains:["*.gleam.io"]},{name:"Petametrics",categories:["analytics"],domains:["*.petametrics.com"]},{name:"ResponseTap",categories:["analytics"],domains:["*.adinsight.com","*.responsetap.com"]},{name:"TINT",
categories:["content"],domains:["*.71n7.com","d33w9bm0n1egwm.cloudfront.net","d36hc0p18k1aoc.cloudfront.net","d3l7tj34e9fc43.cloudfront.net"]},{name:"Zanox",categories:["ad"],domains:["*.zanox.com","*.zanox.ws"]},{name:"infogr.am",categories:["utility"],domains:["*.infogr.am","*.jifo.co"]},{name:"Playbuzz",categories:["hosting"],domains:["*.playbuzz.com"]},{name:"Klevu Search",company:"Klevu",categories:["utility"],domains:["*.klevu.com"]},{name:"Conversio",categories:["ad"],domains:["*.conversio.com"]},{name:"Sidecar",categories:["other"],domains:["*.getsidecar.com","d3v27wwd40f0xu.cloudfront.net"]},{name:"Sajari Pty",categories:["utility"],domains:["*.sajari.com"]},{name:"Profitshare",categories:["ad"],domains:["*.profitshare.ro"]},{name:"Qubit Deliver",company:"Qubit",categories:["analytics"],domains:["d1m54pdnjzjnhe.cloudfront.net","d22rutvoghj3db.cloudfront.net","dd6zx4ibq538k.cloudfront.net"]},{name:"Arbor",company:"LiveRamp",categories:["other"],domains:["*.pippio.com"]},{
name:"Best Of Media S.A.",categories:["content"],domains:["*.servebom.com"]},{name:"Impact Radius",categories:["ad"],domains:["*.impactradius-event.com","*.impactradius-go.com","*.7eer.net","d3cxv97fi8q177.cloudfront.net","*.evyy.net","*.ojrq.net"]},{name:"Matomo",company:"InnoCraft",homepage:"https://matomo.org/",categories:["analytics"],domains:["*.matomo.cloud"]},{name:"Flickr",categories:["content"],domains:["*.flickr.com","*.staticflickr.com"]},{name:"Fanplayr",categories:["analytics"],domains:["*.fanplayr.com","d38nbbai6u794i.cloudfront.net"]},{name:"Navegg",categories:["ad"],domains:["*.navdmp.com"]},{name:"Ambassador",categories:["ad"],domains:["*.getambassador.com"]},{name:"Intercept Interactive",categories:["ad"],domains:["*.undertone.com"]},{name:"Cookie-Script.com",categories:["utility"],domains:["*.cookie-script.com"]},{name:"GIPHY",categories:["content"],domains:["*.giphy.com"]},{name:"Kaizen Platform",categories:["analytics"],domains:["*.kaizenplatform.net"]},{
name:"Bluecore",categories:["analytics"],domains:["*.bluecore.com"]},{name:"Exponential Interactive",categories:["ad"],domains:["*.exponential.com"]},{name:"Hupso Website Analyzer",company:"Hupso",categories:["analytics"],domains:["*.hupso.com"]},{name:"Adkontekst",categories:["ad"],domains:["*.adkontekst.pl"]},{name:"Rakuten LinkShare",company:"Rakuten",categories:["ad"],domains:["*.linksynergy.com"]},{name:"WebSpectator",categories:["ad"],domains:["*.webspectator.com"]},{name:"The Hut Group",categories:["content"],domains:["*.thcdn.com"]},{name:"Underdog Media",categories:["ad"],domains:["*.underdog.media","*.udmserve.net"]},{name:"Steelhouse",categories:["ad"],domains:["*.steelhousemedia.com"]},{name:"Bolt",homepage:"https://www.bolt.com/",categories:["utility"],domains:["*.bolt.com"]},{name:"AdRiver",categories:["ad"],domains:["*.adriver.ru"]},{name:"Viacom",categories:["content"],domains:["*.mtvnservices.com"]},{name:"CleverDATA",categories:["ad"],domains:["*.1dmp.io"]},{
name:"WalkMe",categories:["customer-success"],domains:["*.walkme.com"]},{name:"Flockler",categories:["ad"],domains:["*.flockler.com"]},{name:"Hola Networks",categories:["other"],domains:["*.h-cdn.com"]},{name:"Acceptable Ads",homepage:"https://acceptableads.com/",categories:["ad"],domains:["*.aaxads.com","*.aaxdetect.com"]},{name:"Socialphotos",categories:["social"],domains:["*.slpht.com"]},{name:"epoq internet services",categories:["analytics"],domains:["*.epoq.de"]},{name:"Livefyre",categories:["content"],domains:["*.fyre.co","*.livefyre.com"]},{name:"Turn",categories:["ad"],domains:["*.turn.com"]},{name:"Kargo",categories:["marketing"],domains:["*.kargo.com"]},{name:"Adyen",categories:["utility"],domains:["*.adyen.com"]},{name:"Knight Lab",company:"Northwestern University",categories:["utility"],domains:["*.knightlab.com"]},{name:"Ziff Davis Tech",categories:["ad"],domains:["*.adziff.com","*.zdbb.net"]},{name:"Reevoo",categories:["analytics"],domains:["*.reevoo.com"]},{
name:"The ADEX",categories:["ad"],domains:["*.theadex.com"]},{name:"AWeber",categories:["ad"],domains:["*.aweber.com"]},{name:"Proper Media",categories:["content"],domains:["*.proper.io"]},{name:"Pusher",homepage:"https://pusher.com/",categories:["utility"],domains:["*.pusher.com","*.pusherapp.com"]},{name:"Ooyala",categories:["ad"],domains:["*.ooyala.com"]},{name:"Mopinion",categories:["analytics"],domains:["*.mopinion.com"]},{name:"Netlify",homepage:"https://www.netlify.com/",categories:["utility"],domains:["*.netlify.com","*.netlifyusercontent.com"]},{name:"Experian Cross-Channel Marketing Platform",company:"Experian",categories:["marketing"],domains:["*.eccmp.com","*.ccmp.eu"]},{name:"Postcode Anywhere (Holdings)",categories:["utility"],domains:["*.postcodeanywhere.co.uk"]},{name:"reEmbed",categories:["other"],domains:["*.reembed.com"]},{name:"Vibrant Media",categories:["ad"],domains:["*.intellitxt.com","*.picadmedia.com"]},{name:"GoSquared",homepage:"https://www.gosquared.com",
categories:["analytics"],domains:["*.gosquared.com","d1l6p2sc9645hc.cloudfront.net"]},{name:"Onet",categories:["ad"],domains:["*.onet.pl"]},{name:"SlimCut Media Outstream",company:"SlimCut Media",categories:["ad"],domains:["*.freeskreen.com"]},{name:"Sojern",categories:["marketing"],domains:["*.sojern.com"]},{name:"Tagboard",categories:["social"],domains:["*.tagboard.com"]},{name:"reddit",categories:["social"],domains:["*.reddit.com","*.redditstatic.com"]},{name:"bRealTime",categories:["ad"],domains:["*.brealtime.com"]},{name:"Woopra",categories:["analytics"],domains:["*.woopra.com"]},{name:"Cookie Reports",categories:["utility"],domains:["*.cookiereports.com"]},{name:"Usersnap",homepage:"https://usersnap.com",categories:["customer-success"],domains:["*.usersnap.com"]},{name:"NetAffiliation",company:"Kwanco",categories:["ad"],domains:["*.metaffiliation.com"]},{name:"Opinion Stage",categories:["analytics"],domains:["*.opinionstage.com"]},{name:"Kameleoon",categories:["analytics"],
domains:["*.kameleoon.com"]},{name:"Zmags",categories:["marketing"],domains:["*.zmags.com"]},{name:"Celtra",categories:["ad"],domains:["*.celtra.com"]},{name:"Elastic Ad",categories:["ad"],domains:["*.elasticad.net"]},{name:"FLXone",company:"Teradata",categories:["ad"],domains:["*.pangolin.blue","*.flx1.com","d2hlpp31teaww3.cloudfront.net","*.flxpxl.com"]},{name:"StreamRail",categories:["ad"],domains:["*.streamrail.com","*.streamrail.net"]},{name:"Effective Measure",categories:["ad"],domains:["*.effectivemeasure.net"]},{name:"Touch Commerce",categories:["customer-success"],domains:["*.inq.com","*.touchcommerce.com"]},{name:"Resonance Insights",categories:["analytics"],domains:["*.res-x.com"]},{name:"Advance Magazine Group",categories:["content"],domains:["*.condenastdigital.com","*.condenet.com","*.condenast.co.uk"]},{name:"PerimeterX Bot Defender",company:"PerimeterX",categories:["utility"],domains:["*.perimeterx.net","*.pxi.pub"]},{name:"Reflektion",categories:["analytics"],
domains:["*.reflektion.com","d26opx5dl8t69i.cloudfront.net"]},{name:"Clicktripz",categories:["content"],domains:["*.clicktripz.com"]},{name:"Barilliance",categories:["analytics"],domains:["*.barilliance.net","dn3y71tq7jf07.cloudfront.net"]},{name:"Qualtrics",categories:["analytics"],domains:["*.qualtrics.com"]},{name:"Sonobi",categories:["ad"],domains:["*.sonobi.com"]},{name:"Polldaddy",company:"Automattic",categories:["analytics"],domains:["polldaddy.com"]},{name:"Swoop",categories:["ad"],domains:["*.swoop.com"]},{name:"Mobify",categories:["utility"],domains:["*.mobify.com","*.mobify.net"]},{name:"Zarget",categories:["analytics"],domains:["*.zarget.com"]},{name:"TruConversion",categories:["analytics"],domains:["*.truconversion.com"]},{name:"Spot.IM",categories:["social"],domains:["*.spot.im","*.spotim.market"]},{name:"Bookatable",categories:["content"],domains:["*.bookatable.com","*.livebookings.com"]},{name:"Wow Analytics",categories:["analytics"],domains:["*.wowanalytics.co.uk"]},{
name:"Clickagy Audience Lab",company:"Clickagy",categories:["ad"],domains:["*.clickagy.com"]},{name:"Verizon Digital Media CDN",homepage:"https://www.verizondigitalmedia.com/",categories:["cdn"],domains:["*.edgecastcdn.net","*.edgecastdns.net"]},{name:"Moxie",homepage:"https://www.gomoxie.com/",categories:["utility"],domains:["*.gomoxie.solutions"]},{name:"OnScroll",categories:["ad"],domains:["*.onscroll.com"]},{name:"OwnerIQ",categories:["ad"],domains:["*.owneriq.net"]},{name:"Friendbuy",categories:["ad"],domains:["*.friendbuy.com","djnf6e5yyirys.cloudfront.net"]},{name:"Transifex",categories:["utility"],domains:["*.transifex.com"]},{name:"Twitter Online Conversion Tracking",company:"Twitter",categories:["ad"],domains:["*.ads-twitter.com","analytics.twitter.com"]},{name:"PebblePost",categories:["ad"],domains:["*.pbbl.co"]},{name:"Cachefly",categories:["utility"],domains:["*.cachefly.net"]},{name:"Storygize",categories:["ad"],domains:["*.storygize.net"]},{name:"Vergic AB",
categories:["customer-success"],domains:["*.psplugin.com"]},{name:"Republer",categories:["ad"],domains:["*.republer.com"]},{name:"Conversant Tag Manager",company:"Conversant",categories:["tag-manager"],domains:["*.mplxtms.com"]},{name:"Attribution",categories:["ad"],domains:["*.attributionapp.com"]},{name:"Netmining",company:"Ignition One",categories:["ad"],domains:["*.netmng.com"]},{name:"Betgenius",company:"Genius Sports",categories:["content"],domains:["*.connextra.com"]},{name:"Intent IQ",categories:["ad"],domains:["*.intentiq.com"]},{name:"Site24x7 Real User Monitoring",company:"Site24x7",categories:["analytics"],domains:["*.site24x7rum.com"]},{name:"Adobe Marketing Cloud",company:"Adobe Systems",categories:["ad"],domains:["*.adobetag.com"]},{name:"SkyScanner",categories:["content"],domains:["*.skyscanner.net"]},{name:"Madison Logic",categories:["marketing"],domains:["*.ml314.com"]},{name:"Foxentry",company:"AVANTRO",homepage:"https://foxentry.cz/",categories:["utility"],
domains:["*.foxentry.cz"]},{name:"MailPlus",categories:["ad"],domains:["*.mailplus.nl"]},{name:"Mux",categories:["analytics"],domains:["*.litix.io"]},{name:"News",categories:["social"],domains:["*.news.com.au","*.newsanalytics.com.au","*.newsapi.com.au","*.newscdn.com.au","*.newsdata.com.au","*.newsdiscover.com.au","*.news-static.com"]},{name:"AdTrue",company:"FPT AdTrue",categories:["ad"],domains:["*.adtrue.com"]},{name:"Optimove",company:"Mobius Solutions",categories:["analytics"],domains:["*.optimove.net"]},{name:"SecuredVisit",company:"4Cite Marketing",categories:["ad"],domains:["*.securedvisit.com"]},{name:"Investis",categories:["utility"],domains:["*.investis.com"]},{name:"Vivocha S.p.A",categories:["customer-success"],domains:["*.vivocha.com"]},{name:"AdSniper",categories:["ad"],domains:["*.adsniper.ru","*.sniperlog.ru"]},{name:"Hull.js",categories:["utility"],domains:["*.hull.io","*.hullapp.io"]},{name:"ShopRunner",categories:["content"],domains:["*.shoprunner.com","*.s-9.us"]
},{name:"InAuth",categories:["utility"],homepage:"https://www.inauth.com/",domains:["*.cdn-net.com"]},{name:"cloudIQ",categories:["analytics"],domains:["*.cloud-iq.com"]},{name:"BuySellAds",categories:["ad"],domains:["*.buysellads.com","*.buysellads.net"]},{name:"LiveRamp IdentityLink",homepage:"https://liveramp.com/discover-identitylink/",categories:["analytics"],domains:["*.circulate.com","*.rlcdn.com"]},{name:"Expedia",categories:["content"],domains:["*.travel-assets.com","*.trvl-media.com","*.trvl-px.com","*.uciservice.com"]},{name:"Aggregate Knowledge",company:"Neustar",categories:["ad"],domains:["*.agkn.com"]},{name:"DialogTech SourceTrak",company:"DialogTech",categories:["ad"],domains:["d31y97ze264gaa.cloudfront.net"]},{name:"Microad",categories:["ad"],domains:["*.microad.jp"]},{name:"Realytics",categories:["analytics"],domains:["dcniko1cv0rz.cloudfront.net","*.realytics.net"]},{name:"Holimetrix",homepage:"https://u360.d-bi.fr/",categories:["marketing"],domains:["*.d-bi.fr"]},{
name:"Kiosked",categories:["ad"],domains:["*.kiosked.com"]},{name:"Webkul",company:"Webkul Software",categories:["utility"],domains:["*.webkul.com"]},{name:"ReCollect",categories:["utility"],domains:["*.recollect.net"]},{name:"CNET Content Solutions",company:"CBS Interactive",categories:["content"],domains:["*.cnetcontent.com"]},{name:"Triblio",categories:["marketing"],domains:["*.tribl.io"]},{name:"Alchemy",company:"AndBeyond.Media",categories:["ad"],domains:["*.andbeyond.media"]},{name:"Vergic Engage Platform",company:"Vergic",categories:["customer-success"],domains:["*.vergic.com"]},{name:"Braintree Payments",company:"Paypal",categories:["utility"],domains:["*.braintreegateway.com"]},{name:"Reactful",categories:["analytics"],domains:["*.reactful.com"]},{name:"[24]7",categories:["customer-success"],domains:["*.247-inc.net","*.247inc.net","d1af033869koo7.cloudfront.net"]},{name:"PlayAd Media Group",categories:["ad"],domains:["*.youplay.se"]},{name:"Sailthru",categories:["analytics"],
domains:["*.sail-horizon.com","*.sail-personalize.com","*.sail-track.com"]},{name:"ShopStorm",categories:["utility"],domains:["*.shopstorm.com"]},{name:"Dataxu",categories:["marketing"],domains:["*.w55c.net"]},{name:"CANDDi",company:"Campaign and Digital Intelligence",categories:["ad"],domains:["*.canddi.com"]},{name:"Dynamic Converter",categories:["utility"],domains:["*.dynamicconverter.com"]},{name:"Meltwater Group",categories:["customer-success"],domains:["*.meltwaternews.com"]},{name:"Datacamp",categories:["utility"],domains:["*.cdn77.org"]},{name:"Janrain",categories:["analytics"],domains:["*.janrain.com","*.janrainbackplane.com","*.rpxnow.com","d3hmp0045zy3cs.cloudfront.net"]},{name:"Smartlook",company:"Smartsupp.com",homepage:"https://www.smartlook.com/",categories:["analytics"],domains:["*.smartlook.com"]},{name:"Iterate",homepage:"https://iteratehq.com/",categories:["analytics"],domains:["*.iteratehq.com"]},{name:"Perfect Audience",company:"Marin Software",categories:["ad"],
domains:["*.prfct.co","*.marinsm.com","*.perfectaudience.com"]},{name:"OneSoon",categories:["analytics"],domains:["*.adalyser.com"]},{name:"Fonecall",categories:["analytics"],domains:["*.web-call-analytics.com"]},{name:"Oracle Recommendations On Demand",company:"Oracle",categories:["analytics"],domains:["*.atgsvcs.com"]},{name:"Salesforce Live Agent",company:"Salesforce.com",categories:["customer-success"],domains:["*.salesforceliveagent.com"]},{name:"InSkin Media",categories:["ad"],domains:["*.inskinad.com","*.inskinmedia.com"]},{name:"ContextWeb",categories:["ad"],domains:["*.contextweb.com"]},{name:"Ekm Systems",categories:["analytics"],domains:["*.ekmsecure.com","*.ekmpinpoint.co.uk"]},{name:"VidPulse",categories:["analytics"],domains:["*.vidpulse.com"]},{name:"RichRelevance",categories:["analytics"],domains:["*.richrelevance.com"]},{name:"Byside",homepage:"http://www.byside.com",categories:["analytics"],domains:["*.byside.com"]},{name:"AnswerDash",categories:["customer-success"],
domains:["*.answerdash.com"]},{name:"Dash Hudson",company:"Dash Hudson",categories:["content"],domains:["*.dashhudson.com"]},{name:"Pingdom RUM",homepage:"https://www.pingdom.com/product/performance-monitoring/",categories:["analytics"],domains:["*.pingdom.net"]},{name:"Exactag",categories:["ad"],domains:["*.exactag.com"]},{name:"Sparkflow",company:"Intercept Interactive",categories:["ad"],domains:["*.sparkflow.net"]},{name:"MLveda",categories:["utility"],domains:["*.mlveda.com"]},{name:"Dropbox",categories:["utility"],domains:["*.dropboxusercontent.com"]},{name:"User Replay",categories:["analytics"],domains:["*.userreplay.net"]},{name:"TechTarget",categories:["content"],domains:["*.techtarget.com","*.ttgtmedia.com"]},{name:"LoginRadius",categories:["social"],domains:["*.loginradius.com"]},{name:"Gfycat",company:"Gycat",categories:["utility"],domains:["*.gfycat.com"]},{name:"PowerFront",categories:["hosting"],domains:["*.inside-graph.com"]},{name:"Raygun",categories:["utility"],
domains:["*.raygun.io"]},{name:"Prezi",categories:["utility"],domains:["*.prezi.com"]},{name:"Adthink",company:"Adthink Media",categories:["ad"],domains:["*.adxcore.com","*.dcoengine.com"]},{name:"JingDong",categories:["content"],domains:["*.3.com","*.jd.com"]},{name:"Cardosa Enterprises",categories:["analytics"],domains:["*.y-track.com"]},{name:"Remintrex",company:"SmartUp Venture",categories:["ad"],domains:["*.remintrex.com"]},{name:"Polyfill service",company:"Polyfill.io",categories:["other"],domains:["*.polyfill.io"]},{name:"Castle",homepage:"https://castle.io",categories:["utility"],domains:["*.castle.io","d2t77mnxyo7adj.cloudfront.net"]},{name:"TRUSTe",categories:["utility"],domains:["*.truste.com"]},{name:"AI Media Group",categories:["ad"],domains:["*.aimediagroup.com"]},{name:"Alliance for Audited Media",categories:["ad"],domains:["*.aamsitecertifier.com"]},{name:"Segmento",categories:["ad"],domains:["*.rutarget.ru"]},{name:"Vee24",categories:["customer-success"],
domains:["*.vee24.com"]},{name:"Performio",categories:["ad"],domains:["*.performax.cz"]},{name:"Beachfront Media",categories:["ad"],domains:["*.bfmio.com"]},{name:"Magnetic",categories:["ad"],domains:["*.domdex.com","d3ezl4ajpp2zy8.cloudfront.net"]},{name:"Web Dissector",company:"Beijing Gridsum Technologies",categories:["analytics"],domains:["*.gridsumdissector.com","*.webdissector.com"]},{name:"Chameleon",homepage:"https://www.trychameleon.com/",categories:["marketing"],domains:["*.trychameleon.com"]},{name:"UpSellit",categories:["analytics"],domains:["*.upsellit.com"]},{name:"UPS i-parcel",company:"UPS",categories:["other"],domains:["*.i-parcel.com"]},{name:"Filestack",categories:["content"],domains:["*.filepicker.io"]},{name:"MouseStats",categories:["analytics"],domains:["*.mousestats.com"]},{name:"Wigzo",homepage:"https://www.wigzo.com/",categories:["marketing"],domains:["*.wigzo.com","*.wigzopush.com"]},{name:"MathJax",categories:["utility"],domains:["*.mathjax.org"]},{
name:"OneTag",categories:["ad"],domains:["*.onetag-sys.com"]},{name:"StumbleUpon",categories:["content"],domains:["*.stumble-upon.com","*.stumbleupon.com"]},{name:"StackAdapt",categories:["ad"],domains:["*.stackadapt.com"]},{name:"TurnTo",homepage:"https://www.turntonetworks.com/",categories:["utility"],domains:["*.turnto.com"]},{name:"DemandJump",categories:["analytics"],domains:["*.demandjump.com"]},{name:"Xaxis",homepage:"https://www.xaxis.com/",categories:["ad"],domains:["*.247realmedia.com","*.mookie1.com","*.gmads.net"]},{name:"Council ad Network",categories:["ad"],domains:["*.counciladvertising.net"]},{name:"adKernel",categories:["ad"],domains:["*.adkernel.com"]},{name:"Trialfire",categories:["analytics"],domains:["*.trialfire.com"]},{name:"AdSupply",categories:["ad"],domains:["*.doublepimp.com"]},{name:"Moovweb",categories:["utility"],domains:["*.moovweb.net"]},{name:"Imgur",categories:["utility"],domains:["*.imgur.com"]},{name:"trueAnthem",categories:["social"],
domains:["*.tru.am"]},{name:"Google Fonts",company:"Google",homepage:"https://fonts.google.com/",categories:["cdn"],domains:["fonts.googleapis.com","fonts.gstatic.com"]},{name:"DistroScale",categories:["ad"],domains:["*.jsrdn.com"]},{name:"Extole",categories:["ad"],domains:["*.extole.com","*.extole.io"]},{name:"Adverline Board",company:"Adverline",categories:["ad"],domains:["*.adverline.com","*.adnext.fr"]},{name:"Datonics",categories:["ad"],domains:["*.pro-market.net"]},{name:"StackExchange",categories:["social"],domains:["*.sstatic.net"]},{name:"Gravatar",homepage:"http://en.gravatar.com/",categories:["social"],domains:["*.gravatar.com"]},{name:"Better Business Bureau",categories:["analytics"],domains:["*.bbb.org"]},{name:"content.ad",categories:["ad"],domains:["*.content.ad"]},{name:"Freespee",categories:["customer-success"],domains:["*.freespee.com"]},{name:"Ceros",categories:["other"],domains:["ceros.com","view.ceros.com"]},{name:"Adobe Test & Target",company:"Adobe Systems",
categories:["analytics"],domains:["*.omtrdc.net"]},{name:"SreamAMG",company:"StreamAMG",categories:["other"],domains:["*.streamamg.com"]},{name:"Browser-Update.org",categories:["other"],domains:["*.browser-update.org"]},{name:"Ruler Analytics",company:"Ruler",categories:["analytics"],domains:["*.nyltx.com","*.ruleranalytics.com"]},{name:"Multiview",categories:["content"],domains:["*.multiview.com","*.track-mv.com"]},{name:"Ada",homepage:"https://www.ada.support/",categories:["customer-success"],domains:["*.ada.support"]},{name:"Reach Group",categories:["ad"],domains:["*.redintelligence.net"]},{name:"Firebase",homepage:"https://developers.google.com/apis-explorer/#p/",categories:["utility"],domains:["firebasestorage.googleapis.com","firestore.googleapis.com"]},{name:"AddEvent",categories:["utility"],domains:["*.addevent.com"]},{name:"Fastest Forward",categories:["analytics"],domains:["*.gaug.es"]},{name:"Constructor.io",categories:["utility"],domains:["*.cnstrc.com"]},{name:"ARM",
categories:["analytics"],domains:["*.tag4arm.com"]},{name:"Hawk Search",categories:["utility"],domains:["*.hawksearch.com"]},{name:"BlueCava",categories:["ad"],domains:["*.bluecava.com"]},{name:"XiTi",company:"AT Internet",categories:["analytics"],domains:["*.xiti.com","*.aticdn.net"],homepage:"https://www.atinternet.com/en/"},{name:"Loop11",categories:["analytics"],domains:["*.loop11.com"]},{name:"AliveChat",company:"AYU Technology Solutions",categories:["customer-success"],domains:["*.websitealive.com","*.websitealive7.com"]},{name:"Retention Science",categories:["ad"],domains:["*.retentionscience.com","d1stxfv94hrhia.cloudfront.net"]},{name:"VoiceFive",categories:["analytics"],domains:["*.voicefive.com"]},{name:"YoYo",categories:["utility"],domains:["*.goadservices.com"]},{name:"Virtual Earth",company:"Microsoft",categories:["utility"],domains:["*.virtualearth.net"]},{name:"SPX",company:"Smaato",categories:["ad"],domains:["*.smaato.net"]},{name:"Klarna",categories:["utility"],
domains:["*.klarna.com"]},{name:"Flipboard",categories:["social"],domains:["*.flipboard.com"]},{name:"Glassdoor",categories:["content"],domains:["*.glassdoor.com"]},{name:"Webtrends",categories:["analytics"],domains:["*.webtrends.com","*.webtrendslive.com","d1q62gfb8siqnm.cloudfront.net"]},{name:"NaviStone",categories:["ad"],domains:["*.murdoog.com"]},{name:"Catchpoint",homepage:"https://www.catchpoint.com/",categories:["analytics"],domains:["*.3gl.net"]},{name:"JotForm",categories:["utility"],domains:["*.jotformpro.com"]},{name:"Userzoom",categories:["analytics"],domains:["*.userzoom.com"]},{name:"Now Interact",categories:["analytics"],domains:["*.nowinteract.com"]},{name:"RecoBell",categories:["analytics"],domains:["*.recobell.io"]},{name:"EmpathyBroker Site Search",company:"EmpathyBroker",categories:["utility"],domains:["*.empathybroker.com"]},{name:"Boomtrain",categories:["ad"],domains:["*.boomtrain.com","*.boomtrain.net"]},{name:"Roomkey",categories:["content"],
domains:["*.roomkey.com"]},{name:"Improve Digital",categories:["ad"],domains:["*.360yield.com"]},{name:"Webmarked",categories:["utility"],domains:["*.webmarked.net"]},{name:"Soundest",categories:["ad"],domains:["*.soundestlink.com","*.soundest.net"]},{name:"ESV Digital",categories:["analytics"],domains:["*.esearchvision.com"]},{name:"EmailCenter",categories:["ad"],domains:["*.emailcenteruk.com"]},{name:"Amplience",categories:["marketing"],domains:["*.10cms.com","*.amplience.com","*.bigcontent.io","*.adis.ws"]},{name:"The Publisher Desk",categories:["ad"],domains:["*.206ads.com","*.publisherdesk.com"]},{name:"HP Optimost",company:"Hewlett-Packard Development Company",categories:["marketing"],domains:["*.hp.com","d2uncb19xzxhzx.cloudfront.net"]},{name:"Azure Traffic Manager",company:"Microsoft",categories:["other"],domains:["*.gateway.net","*.trafficmanager.net"]},{name:"Peaks & Pies",categories:["analytics"],domains:["*.bunchbox.co"]},{name:"2AdPro Media Solutions",categories:["ad"],
domains:["*.2adpro.com"]},{name:"Mediahawk",categories:["analytics"],domains:["*.mediahawk.co.uk"]},{name:"Trust Guard",categories:["utility"],domains:["*.trust-guard.com"]},{name:"RightNow Service Cloud",company:"Oracle",categories:["customer-success"],domains:["*.rightnowtech.com","*.rnengage.com"]},{name:"Trustev",company:"TransUnion",categories:["utility"],domains:["*.trustev.com"]},{name:"Ometria",categories:["analytics"],domains:["*.ometria.com"]},{name:"Tapad",categories:["ad"],domains:["*.tapad.com"]},{name:"Quora Ads",homepage:"https://www.quora.com/business/",categories:["ad"],domains:["*.quora.com"]},{name:"RebelMouse",categories:["ad"],domains:["*.rebelmouse.com","*.rbl.ms"]},{name:"Cross Pixel Media",categories:["ad"],domains:["*.crsspxl.com"]},{name:"Elecard StreamEye",company:"Elecard",categories:["other"],domains:["*.streameye.net"]},{name:"Sub2 Technologies",categories:["analytics"],domains:["*.sub2tech.com"]},{name:"Pixalate",categories:["utility"],
domains:["*.adrta.com"]},{name:"Neodata",categories:["ad"],domains:["*.neodatagroup.com"]},{name:"HotelsCombined",categories:["content"],domains:["*.datahc.com"]},{name:"Infusionsoft",categories:["ad"],domains:["*.infusionsoft.com"]},{name:"Online republic",categories:["content"],domains:["*.imallcdn.net"]},{name:"MyRegistry",categories:["other"],domains:["*.myregistry.com"]},{name:"eGain",categories:["analytics"],domains:["*.analytics-egain.com","*.egain.com"]},{name:"Numberly",company:"1000mercis",categories:["ad"],domains:["*.mmtro.com","*.nzaza.com"]},{name:"Visual IQ",homepage:"https://www.visualiq.com",categories:["analytics"],domains:["*.myvisualiq.net"]},{name:"Click4Assistance",categories:["customer-success"],domains:["*.click4assistance.co.uk"]},{name:"Euroland",categories:["utility"],domains:["*.euroland.com"]},{name:"Sokrati",categories:["marketing"],domains:["*.sokrati.com"]},{name:"Acquisio",categories:["ad"],domains:["*.acq.io"]},{name:"Podsights",
homepage:"https://podsights.com/",categories:["marketing"],domains:["*.pdst.fm"]},{name:"AdvertServe",categories:["ad"],domains:["*.advertserve.com"]},{name:"eXTReMe digital",categories:["analytics"],domains:["*.extreme-dm.com"]},{name:"SAS Institute",categories:["ad"],domains:["*.aimatch.com","*.sas.com"]},{name:"Oracle",categories:["marketing"],domains:["*.custhelp.com","*.eloqua.com","*.en25.com","*.estara.com","*.instantservice.com"]},{name:"TrafficJunky",homepage:"https://www.trafficjunky.com/",categories:["ad"],domains:["*.contentabc.com","*.trafficjunky.net"]},{name:"Conversant",categories:["analytics"],domains:["*.dotomi.com","*.dtmpub.com","*.emjcd.com","mediaplex.com","*.tqlkg.com","*.fastclick.net"]},{name:"SiteScout",company:"Centro",categories:["ad"],domains:["*.pixel.ad","*.sitescout.com"]},{name:"Silverpop",company:"IBM",categories:["ad"],
domains:["*.mkt912.com","*.mkt922.com","*.mkt932.com","*.mkt941.com","*.mkt51.net","*.mkt61.net","*.pages01.net","*.pages02.net","*.pages03.net","*.pages04.net","*.pages05.net"]},{name:"eXelate",categories:["ad"],domains:["*.exelator.com"]},{name:"SmarterHQ",categories:["analytics"],domains:["*.smarterhq.io","d1n00d49gkbray.cloudfront.net","*.smarterremarketer.net"]},{name:"Divido",categories:["utility"],domains:["*.divido.com"]},{name:"BidTheatre",categories:["ad"],domains:["*.bidtheatre.com"]},{name:"Certona",categories:["analytics"],domains:["*.certona.net"]},{name:"Reflow",company:"Scenestealer",categories:["ad"],domains:["*.reflow.tv"]},{name:"Account Kit",categories:["other"],domains:["*.accountkit.com"]},{name:"Yummley",categories:["other"],domains:["*.yummly.com"]},{name:"ZergNet",categories:["content"],domains:["*.zergnet.com"]},{name:"LeasdBoxer",company:"LeadBoxer",categories:["ad"],domains:["*.leadboxer.com"]},{name:"SalesLoft",homepage:"https://salesloft.com/",
categories:["analytics","marketing"],domains:["*.salesloft.com"]},{name:"template-help.com",categories:["hosting"],domains:["*.template-help.com"]},{name:"Mention Me",categories:["ad"],domains:["*.mention-me.com"]},{name:"Borderfree",company:"pitney bowes",categories:["utility"],domains:["*.borderfree.com","*.fiftyone.com"]},{name:"360 picnic platform",company:"MediaV",categories:["ad"],domains:["*.mediav.com"]},{name:"Webtrekk",categories:["analytics"],domains:["*.wbtrk.net","*.webtrekk-asia.net","*.webtrekk.net","*.wt-eu02.net"]},{name:"Airship",categories:["marketing"],domains:["*.urbanairship.com","*.aswpsdkus.com"]},{name:"SpeedCurve LUX",company:"SpeedCurve",homepage:"https://speedcurve.com/features/lux/",categories:["analytics"],domains:["*.speedcurve.com"]},{name:"Adzerk",categories:["ad"],domains:["*.adzerk.net"]},{name:"AdCurve",categories:["ad"],domains:["*.shop2market.com"]},{name:"ToneMedia",categories:["ad"],domains:["*.clickfuse.com"]},{name:"F@N Communications",
homepage:"https://www.fancs.com/",categories:["ad"],domains:["*.ladsp.com"]},{name:"Sophus3",categories:["analytics"],domains:["*.s3ae.com","*.sophus3.com"]},{name:"Bidtellect",categories:["ad"],domains:["*.bttrack.com"]},{name:"Adtech (AOL)",categories:["ad"],domains:["*.adtechus.com"]},{name:"Admedo",categories:["ad"],domains:["*.a8723.com","*.adizio.com","*.admedo.com"]},{name:"Heatmap",categories:["analytics"],domains:["*.heatmap.it"]},{name:"Widespace",homepage:"https://www.widespace.com",categories:["ad"],domains:["*.widespace.com"]},{name:"Rollbar",categories:["utility"],domains:["*.rollbar.com","d37gvrvc0wt4s1.cloudfront.net"]},{name:"Adnium",categories:["ad"],domains:["*.adnium.com"]},{name:"Business Message",categories:["ad"],domains:["*.message-business.com"]},{name:"PrintFriendly",categories:["utility"],domains:["*.printfriendly.com"]},{name:"RTB House AdPilot",company:"RTB House",categories:["ad"],domains:["*.erne.co","*.creativecdn.com"]},{name:"my6sense",
categories:["ad"],domains:["*.mynativeplatform.com"]},{name:"Ambient",company:"Ericcson",categories:["other"],domains:["*.adnetwork.vn","*.ambientplatform.vn"]},{name:"Vertical Mass",categories:["ad"],domains:["*.vmweb.net"]},{name:"MyBuys",categories:["analytics"],domains:["*.mybuys.com"]},{name:"Recite Me",categories:["other"],domains:["*.reciteme.com"]},{name:"Admitad",categories:["ad"],domains:["*.lenmit.com"]},{name:"Infoline",categories:["analytics"],domains:["*.ioam.de"]},{name:"Adwise",categories:["ad"],domains:["*.adwise.bg"]},{name:"Tradedoubler",categories:["ad"],domains:["*.pvnsolutions.com","*.tradedoubler.com"]},{name:"Developer Media",categories:["ad"],domains:["*.developermedia.com"]},{name:"bd4travel",categories:["analytics"],domains:["*.bd4travel.com"]},{name:"Eyeota",categories:["ad"],domains:["*.eyeota.net"]},{name:"Fidelity Media",categories:["ad"],domains:["*.fidelity-media.com"]},{name:"Brandmetrics",homepage:"https://www.brandmetrics.com",
categories:["analytics"],domains:["*.brandmetrics.com"]},{name:"LockerDome",categories:["analytics"],domains:["*.lockerdome.com"]},{name:"C3 Metrics",categories:["analytics"],domains:["*.c3tag.com"]},{name:"WebInsight",company:"dotMailer",categories:["analytics"],domains:["*.trackedlink.net","*.trackedweb.net"]},{name:"Captify Media",categories:["ad"],domains:["*.cpx.to"]},{name:"Datalicious",categories:["tag-manager"],domains:["*.supert.ag","*.optimahub.com"]},{name:"Movable Ink",categories:["analytics"],domains:["*.micpn.com"]},{name:"Okta",categories:["analytics"],domains:["*.okta.com"]},{name:"AdSpeed",categories:["ad"],domains:["*.adspeed.net"]},{name:"Ahalogy",categories:["social"],domains:["*.ahalogy.com"]},{name:"Queue-it",categories:["other"],domains:["*.queue-it.net"]},{name:"EMX Digital",homepage:"https://emxdigital.com",categories:["ad"],domains:["*.emxdgt.com"]},{name:"Internet Brands",categories:["content"],domains:["*.ibpxl.com"]},{name:"HyperInzerce",
homepage:"https://hyperinzerce.cz",categories:["ad"],domains:["*.hyperinzerce.cz"]},{name:"Smarter Click",categories:["ad"],domains:["*.smct.co","*.smarterclick.co.uk"]},{name:"Accordant Media",categories:["ad"],domains:["*.a3cloud.net"]},{name:"Expedia USA",company:"Expedia",categories:["content"],domains:["*.expedia.com"]},{name:"ClickDimensions",categories:["ad"],domains:["*.clickdimensions.com"]},{name:"ipinfo.io",categories:["utility"],domains:["*.ipinfo.io"]},{name:"adnanny",categories:["ad"],domains:["*.adserver01.de"]},{name:"Force24",categories:["ad"],domains:["*.force24.co.uk"]},{name:"freewheel.tv",categories:["content"],domains:["*.fwmrm.net"]},{name:"Pulse Insights",categories:["analytics"],domains:["*.pulseinsights.com"]},{name:"Ido",categories:["customer-success"],domains:["*.idio.co"]},{name:"AirPR",categories:["analytics"],domains:["*.airpr.com"]},{name:"Loggly",homepage:"https://www.loggly.com/",categories:["analytics"],
domains:["*.loggly.com","d9jmv9u00p0mv.cloudfront.net"]},{name:"EQ works",categories:["ad"],domains:["*.eqads.com"]},{name:"Segmint",categories:["analytics"],domains:["*.segmint.net"]},{name:"Jivox",categories:["ad"],domains:["*.jivox.com"]},{name:"Yellow Robot",categories:["ad"],domains:["*.backinstock.org"]},{name:"Adtegrity",categories:["ad"],domains:["*.adtpix.com"]},{name:"Macropod BugHerd",company:"Macropod",categories:["utility"],domains:["*.bugherd.com"]},{name:"Simpli.fi",categories:["ad"],domains:["*.simpli.fi"]},{name:"Indeed",categories:["content"],domains:["*.indeed.com"]},{name:"SLI Systems",categories:["utility"],domains:["*.resultslist.com","*.resultspage.com","*.sli-spark.com"]},{name:"j2 Cloud Services",categories:["ad"],domains:["*.campaigner.com"]},{name:"Imagini Holdings",categories:["ad"],domains:["*.vdna-assets.com"]},{name:"Business Week",company:"Bloomberg",categories:["social"],domains:["*.bwbx.io"]},{name:"WizRocket Technologies",categories:["analytics"],
domains:["*.wzrkt.com"]},{name:"APSIS Profile Cloud",company:"APSIS",categories:["analytics"],domains:["*.innomdc.com"]},{name:"CogoCast",company:"Cogo Labs",categories:["ad"],domains:["*.cogocast.net"]},{name:"emetriq",homepage:"https://www.emetriq.com/",categories:["ad"],domains:["*.emetriq.de","*.xplosion.de"]},{name:"Crimtan",categories:["ad"],domains:["*.ctnsnet.com"]},{name:"Scroll",homepage:"https://scroll.com/",categories:["utility"],domains:["*.scroll.com"]},{name:"mbr targeting",categories:["ad"],domains:["*.m6r.eu"]},{name:"Thinglink",categories:["utility"],domains:["*.thinglink.com"]},{name:"Apptus eSales",company:"Apptus",categories:["analytics"],domains:["*.apptus.com"]},{name:"Kenshoo",categories:["marketing"],domains:["*.xg4ken.com"]},{name:"Adap.tv",categories:["ad"],domains:["*.adap.tv"]},{name:"ChannelAdvisor",categories:["ad"],domains:["*.channeladvisor.com","*.searchmarketing.com"]},{name:"Uniqodo",categories:["ad"],domains:["*.uniqodo.com"]},{name:"EpiServer",
homepage:"https://www.episerver.com",categories:["content"],domains:["*.episerver.net"]},{name:"Vero",company:"Semblance",categories:["ad"],domains:["*.getvero.com","d3qxef4rp70elm.cloudfront.net"]},{name:"Targito",company:"VIVmail.cz",homepage:"https://www.targito.com",categories:["marketing"],domains:["*.targito.com"]},{name:"Burst Media",categories:["ad"],domains:["*.burstnet.com","*.1rx.io"]},{name:"Yahoo! Ad Exchange",company:"Yahoo!",categories:["ad"],domains:["*.yieldmanager.com","*.browsiprod.com"]},{name:"Confirmit",categories:["analytics"],domains:["*.confirmit.com"]},{name:"QuinStreet",categories:["ad"],domains:["*.Quinstreet.com","*.b2btechleadform.com","*.qnsr.com","*.qsstats.com"]},{name:"Vizury",categories:["ad"],domains:["*.vizury.com"]},{name:"Fospha",categories:["analytics"],domains:["*.fospha.com"]},{name:"Vizzit",homepage:"http://www.vizzit.se",categories:["analytics"],domains:["*.vizzit.se"]},{name:"Wibbitz",categories:["other"],domains:["*.wibbitz.com"]},{
name:"rss2json",categories:["utility"],domains:["*.rss2json.com"]},{name:"BloomReach",categories:["ad"],domains:["*.brcdn.com","*.brsrvr.com","*.brsvr.com"]},{name:"PhotoBucket",categories:["content"],domains:["*.photobucket.com"]},{name:"Comodo",categories:["utility"],domains:["*.comodo.com","*.trust-provider.com","*.trustlogo.com","usertrust.com","*.comodo.net"]},{name:"Conversion Labs",categories:["ad"],domains:["*.net.pl"]},{name:"ObjectPlanet",categories:["analytics"],domains:["*.easypolls.net"]},{name:"Lifestreet Media",categories:["social"],domains:["*.lfstmedia.com"]},{name:"One by AOL",company:"AOL",categories:["ad"],domains:["*.adtechjp.com","*.adtech.de"]},{name:"Box",categories:["hosting"],domains:["*.box.com"]},{name:"Piwik",categories:["analytics"],domains:["*.drtvtracker.com","*.piwikpro.com","*.raac33.net"]},{name:"sage Pay",company:"Sage Pay Europe",categories:["utility"],domains:["*.sagepay.com"]},{name:"Effiliation sa",categories:["ad"],domains:["*.effiliation.com"]
},{name:"JustUno",categories:["ad"],domains:["*.justuno.com","d2j3qa5nc37287.cloudfront.net"]},{name:"StrÃ¶er Digital Media",categories:["ad"],domains:["*.stroeerdigitalmedia.de"]},{name:"audioBoom",categories:["social"],domains:["*.audioboom.com","*.audioboo.fm"]},{name:"NEORY Marketing Cloud",company:"NEORY",categories:["marketing"],domains:["*.ad-srv.net"]},{name:"Provide Support",categories:["customer-success"],domains:["*.providesupport.com"]},{name:"Adara Media",categories:["ad"],domains:["*.yieldoptimizer.com"]},{name:"AdultWebmasterEmpire.Com",categories:["ad"],domains:["*.awempire.com"]},{name:"Flipp",categories:["analytics"],domains:["*.wishabi.com","d2e0sxz09bo7k2.cloudfront.net","*.wishabi.net"]},{name:"Carbon Ads",homepage:"https://www.carbonads.net/",categories:["ad"],domains:["*.carbonads.net","*.carbonads.com"]},{name:"Playground",homepage:"https://playground.xyz",categories:["ad"],domains:["*.playground.xyz"]},{name:"Pepperjam",homepage:"https://www.pepperjam.com/",
categories:["marketing","analytics"],domains:["*.pepperjam.com","*.affiliatetechnology.com"]},{name:"Mynewsdesk",categories:["utility"],domains:["*.mynewsdesk.com"]},{name:"eKomi",categories:["analytics"],domains:["*.ekomi.com","*.ekomi.de"]},{name:"mainADV",categories:["ad"],domains:["*.httptrack.com","*.solocpm.com"]},{name:"Cludo",categories:["utility"],domains:["*.cludo.com"]},{name:"Digital Window",categories:["ad"],domains:["*.awin1.com","*.zenaps.com"]},{name:"SourceKnowledge",homepage:"http://www.sourceknowledge.com",categories:["ad"],domains:["*.provenpixel.com"]},{name:"Adblade",categories:["ad"],domains:["*.adblade.com"]},{name:"eDigital Research",categories:["customer-success"],domains:["*.edigitalresearch.com","*.edigitalsurvey.com","*.edrcdn.com","*.ecustomeropinions.com"]},{name:"Leaflet",categories:["utility"],domains:["*.leafletjs.com"]},{name:"Terminus",homepage:"https://terminus.com/",categories:["ad"],domains:["*.terminus.services"]},{name:"MyFonts",
categories:["cdn"],domains:["*.myfonts.net"]},{name:"Nanigans",categories:["ad"],domains:["*.nanigans.com"]},{name:"Digital Millennium Copyright Act Services",categories:["utility"],domains:["*.dmca.com"]},{name:"Statuspage",company:"Atlassian",homepage:"https://www.statuspage.io",categories:["utility"],domains:["*.statuspage.io"]},{name:"Intilery",categories:["customer-success"],domains:["*.intilery-analytics.com"]},{name:"dianomi",categories:["ad"],domains:["*.dianomi.com","*.dianomioffers.co.uk"]},{name:"TinyURL",categories:["utility"],domains:["*.tinyurl.com"]},{name:"Lead Forensics",categories:["ad"],
domains:["*.200summit.com","*.baw5tracker.com","*.business-path-55.com","*.bux1le001.com","*.central-core-7.com","*.direct-azr-78.com","*.explore-123.com","*.forensics1000.com","*.gldsta-02-or.com","*.green-bloc9.com","*.lansrv040.com","*.lead-123.com","*.leadforensics.com","*.mavic852.com","*.mon-com-net.com","*.peak-ip-54.com","*.snta0034.com","*.svr-prc-01.com","*.syntace-094.com","*.tghbn12.com","*.trail-web.com","*.web-01-gbl.com","*.web-cntr-07.com","*.trackdiscovery.net"]},{name:"IS Group",categories:["hosting"],domains:["*.creative-serving.com"]},{name:"AgilOne",categories:["marketing"],domains:["*.agilone.com"]},{name:"Qeryz",categories:["analytics"],domains:["*.qeryz.com"]},{name:"SFR",categories:["other"],domains:["*.sfr.fr"]},{name:"Emerse",homepage:"https://www.emerse.com/",categories:["ad"],domains:["*.emerse.com"]},{name:"AdRecover",categories:["ad"],domains:["*.adrecover.com"]},{name:"Sociomantic Labs",company:"DunnHumby",categories:["ad"],domains:["*.sociomantic.com"]
},{name:"Beeswax",categories:["ad"],domains:["*.bidr.io"]},{name:"Yieldlab",categories:["ad"],domains:["*.yieldlab.net"]},{name:"Geoplugin",categories:["utility"],domains:["*.geoplugin.com","*.geoplugin.net"]},{name:"eyeReturn Marketing",categories:["marketing"],domains:["*.eyereturn.com"]},{name:"Psyma",categories:["ad"],domains:["*.psyma.com"]},{name:"Infopark",categories:["hosting"],domains:["*.scrvt.com"]},{name:"Lengow",categories:["hosting"],domains:["*.lengow.com"]},{name:"Vextras",categories:["other"],domains:["*.vextras.com"]},{name:"Agility",categories:["hosting"],domains:["*.agilitycms.com"]},{name:"Bizrate",categories:["analytics"],domains:["*.bizrate.com"]},{name:"PERFORM",categories:["content"],domains:["*.performgroup.com"]},{name:"CoolaData",categories:["analytics"],domains:["*.cooladata.com"]},{name:"Consumable",homepage:"http://consumable.com/",categories:["ad"],domains:["*.serverbid.com"]},{name:"HitsLink",categories:["analytics"],domains:["*.hitslink.com"]},{
name:"VisualVisitor",categories:["ad"],domains:["*.id-visitors.com"]},{name:"GlobalSign",categories:["utility"],domains:["*.globalsign.com","*.globalsign.net"]},{name:"Adelphic",categories:["ad"],domains:["*.ipredictive.com"]},{name:"SecurityMetrics",categories:["utility"],domains:["*.securitymetrics.com"]},{name:"APSIS Forms",company:"APSIS",categories:["other"],domains:["*.apsisforms.com"]},{name:"Affiliatly",categories:["ad"],domains:["*.affiliatly.com"]},{name:"Blogg.se",categories:["hosting"],domains:["*.cdnme.se","*.publishme.se"]},{name:"Mark and Mini",categories:["ad"],domains:["*.markandmini.com"]},{name:"codigo",homepage:"http://www.codigo.se",categories:["analytics"],domains:["*.codigo.se"]},{name:"Sectigo",homepage:"https://sectigo.com/",categories:["utility"],domains:["*.sectigo.com"]},{name:"Google reCAPTCHA",company:"Google",categories:["utility"],domains:["*.recaptcha.net"]},{name:"Qode Interactive",categories:["hosting"],domains:["*.qodeinteractive.com"]},{
name:"comScore",categories:["analytics"],domains:["*.adxpose.com","*.comscore.com","*.sitestat.com","*.zqtk.net"]},{name:"Blindado",categories:["utility"],domains:["*.siteblindado.com"]},{name:"MotionPoint",categories:["other"],domains:["*.convertlanguage.com"]},{name:"Webcore",categories:["ad"],domains:["*.onefeed.co.uk"]},{name:"Spiceworks",homepage:"https://www.spiceworks.com",categories:["analytics"],domains:["*.spiceworks.com"]},{name:"Trinity Mirror",categories:["content"],domains:["*.mirror.co.uk"]},{name:"PollDaddy (Automattic)",categories:["ad"],domains:["static.polldaddy.com","*.poll.fm"]},{name:"ShopiMind",company:"ShopIMind",categories:["ad"],domains:["*.shopimind.com"]},{name:"Net Applications",categories:["analytics"],domains:["*.hitsprocessor.com"]},{name:"LiveInternet",categories:["analytics"],domains:["*.yadro.ru"]},{name:"Vindico",company:"Viant",categories:["ad"],domains:["*.vindicosuite.com"]},{name:"PriceRunner",categories:["content"],domains:["*.pricerunner.com"]
},{name:"dotMailer Surveys",company:"dotMailer",categories:["analytics"],domains:["*.dotmailer-surveys.com"]},{name:"OpinionBar",categories:["analytics"],domains:["*.opinionbar.com"]},{name:"A-FIS PTE",categories:["analytics"],domains:["*.websta.me"]},{name:"IcoMoon",categories:["cdn"],domains:["d19ayerf5ehaab.cloudfront.net","d1azc1qln24ryf.cloudfront.net"]},{name:"Improvely",categories:["analytics"],domains:["*.iljmp.com"]},{name:"eWAY",company:"Web Active Pty",categories:["utility"],domains:["*.eway.com.au"]},{name:"Adsty",categories:["ad"],domains:["*.adx1.com"]},{name:"MaxPoint Interactive",categories:["ad"],domains:["*.mxptint.net"]},{name:"Sweet Tooth",categories:["ad"],domains:["*.sweettooth.io"]},{name:"ADventori",categories:["ad"],domains:["*.adventori.com"]},{name:"Samba TV",company:"Samba",categories:["content"],domains:["*.samba.tv"]},{name:"Ghostery Enterprise",company:"Ghostery",categories:["marketing"],domains:["*.betrad.com"]},{name:"CJ Affiliate by Conversant",
company:"Conversant",categories:["ad"],domains:["*.ftjcfx.com"]},{name:"Varick Media Management",categories:["ad"],domains:["*.vmmpxl.com"]},{name:"Bidswitch",homepage:"https://www.bidswitch.com/",categories:["ad"],domains:["*.bidswitch.net"]},{name:"AdTheorent",categories:["ad"],domains:["*.adentifi.com"]}]},{}],251:[function(e,t,n){t.exports=e("./lib/subsets/httparchive-nostats.js")},{"./lib/subsets/httparchive-nostats.js":253}],252:[function(e,t,n){const i=/:\/\/(\S*?)(:\d+)?(\/|$)/,a=/([a-z0-9.-]+\.[a-z0-9]+|localhost)/i,s=/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/,c=/[^.]+\.([^.]+|(gov|com|co|ne)\.\w{2})$/i;function getDomainFromOriginOrURL(e){return"string"!=typeof e||e.length>1e4||e.startsWith("data:")?null:i.test(e)?e.match(i)[1]:a.test(e)?e.match(a)[0]:null}function getRootDomain(e){const t=getDomainFromOriginOrURL(e);if(!t)return null;if(s.test(t))return t;const n=t.match(c);return n&&n[0]||t}function sliceSubdomainFromDomain(e,t){
return e.length<=t.length?e:e.split(".").slice(1).join(".")}function getEntityInDataset(e,t,n,i){const a=getDomainFromOriginOrURL(i),s=getRootDomain(a);if(a&&s){if(e.has(a))return e.get(a);for(let e=a;e.length>s.length;e=sliceSubdomainFromDomain(e,s))if(t.has(e))return t.get(e);return n.has(s)?n.get(s):void 0}}function getProductInDataset(e,t,n,i){const a=getEntityInDataset(e,t,n,i),s=a&&a.products;if(s&&"string"==typeof i)for(const e of s)for(const t of e.urlPatterns){if(t instanceof RegExp&&t.test(i))return e;if("string"==typeof t&&i.includes(t))return e}}t.exports={createAPIFromDataset:function createAPIFromDataset(e){const t=function cloneEntities(e){return e.map((e=>{const t={company:e.name,...e},n=(e.products||[]).map((e=>({company:t.company,categories:t.categories,facades:[],...e,urlPatterns:(e.urlPatterns||[]).map((e=>e.startsWith("REGEXP:")?new RegExp(e.slice("REGEXP:".length)):e))})));return t.products=n,t}))}(e),n=new Map,i=new Map,a=new Map;for(const e of t){
e.totalExecutionTime=Number(e.totalExecutionTime)||0,e.totalOccurrences=Number(e.totalOccurrences)||0,e.averageExecutionTime=e.totalExecutionTime/e.totalOccurrences;for(const t of e.domains){if(n.has(t)){const i=n.get(t);throw new Error(`Duplicate domain ${t} (${e.name} and ${i.name})`)}n.set(t,e);const s=getRootDomain(t);if(t.startsWith("*.")){const n=t.slice(2);n===s?i.set(s,e):a.set(n,e)}}}for(const[e,t]of i.entries())t||i.delete(e);return{getEntity:getEntityInDataset.bind(null,n,a,i),getProduct:getProductInDataset.bind(null,n,a,i),getRootDomain,entities:t}}}},{}],253:[function(e,t,n){const{createAPIFromDataset:i}=e("../create-entity-finder-api.js"),a=e("../../dist/entities-httparchive-nostats.json");t.exports=i(a)},{"../../dist/entities-httparchive-nostats.json":250,"../create-entity-finder-api.js":252}],254:[function(e,t,n){(function(e){(function(){function config(t){try{if(!e.localStorage)return!1}catch(e){return!1}var n=e.localStorage[t]
;return null!=n&&"true"===String(n).toLowerCase()}t.exports=function deprecate(e,t){if(config("noDeprecation"))return e;var n=!1;return function deprecated(){if(!n){if(config("throwDeprecation"))throw new Error(t);config("traceDeprecation")?console.trace(t):console.warn(t),n=!0}return e.apply(this,arguments)}}}).call(this)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{}],255:[function(e,t,n){arguments[4][129][0].apply(n,arguments)},{dup:129}],256:[function(e,t,n){"use strict";var i=e("is-arguments"),a=e("is-generator-function"),s=e("which-typed-array"),c=e("is-typed-array");function uncurryThis(e){return e.call.bind(e)}var l="undefined"!=typeof BigInt,u="undefined"!=typeof Symbol,d=uncurryThis(Object.prototype.toString),m=uncurryThis(Number.prototype.valueOf),p=uncurryThis(String.prototype.valueOf),h=uncurryThis(Boolean.prototype.valueOf);if(l)var f=uncurryThis(BigInt.prototype.valueOf)
;if(u)var g=uncurryThis(Symbol.prototype.valueOf);function checkBoxedPrimitive(e,t){if("object"!=typeof e)return!1;try{return t(e),!0}catch(e){return!1}}function isMapToString(e){return"[object Map]"===d(e)}function isSetToString(e){return"[object Set]"===d(e)}function isWeakMapToString(e){return"[object WeakMap]"===d(e)}function isWeakSetToString(e){return"[object WeakSet]"===d(e)}function isArrayBufferToString(e){return"[object ArrayBuffer]"===d(e)}function isArrayBuffer(e){return"undefined"!=typeof ArrayBuffer&&(isArrayBufferToString.working?isArrayBufferToString(e):e instanceof ArrayBuffer)}function isDataViewToString(e){return"[object DataView]"===d(e)}function isDataView(e){return"undefined"!=typeof DataView&&(isDataViewToString.working?isDataViewToString(e):e instanceof DataView)}function isSharedArrayBufferToString(e){return"[object SharedArrayBuffer]"===d(e)}function isSharedArrayBuffer(e){
return"undefined"!=typeof SharedArrayBuffer&&(isSharedArrayBufferToString.working?isSharedArrayBufferToString(e):e instanceof SharedArrayBuffer)}function isNumberObject(e){return checkBoxedPrimitive(e,m)}function isStringObject(e){return checkBoxedPrimitive(e,p)}function isBooleanObject(e){return checkBoxedPrimitive(e,h)}function isBigIntObject(e){return l&&checkBoxedPrimitive(e,f)}function isSymbolObject(e){return u&&checkBoxedPrimitive(e,g)}n.isArgumentsObject=i,n.isGeneratorFunction=a,n.isTypedArray=c,n.isPromise=function isPromise(e){return"undefined"!=typeof Promise&&e instanceof Promise||null!==e&&"object"==typeof e&&"function"==typeof e.then&&"function"==typeof e.catch},n.isArrayBufferView=function isArrayBufferView(e){return"undefined"!=typeof ArrayBuffer&&ArrayBuffer.isView?ArrayBuffer.isView(e):c(e)||isDataView(e)},n.isUint8Array=function isUint8Array(e){return"Uint8Array"===s(e)},n.isUint8ClampedArray=function isUint8ClampedArray(e){return"Uint8ClampedArray"===s(e)},
n.isUint16Array=function isUint16Array(e){return"Uint16Array"===s(e)},n.isUint32Array=function isUint32Array(e){return"Uint32Array"===s(e)},n.isInt8Array=function isInt8Array(e){return"Int8Array"===s(e)},n.isInt16Array=function isInt16Array(e){return"Int16Array"===s(e)},n.isInt32Array=function isInt32Array(e){return"Int32Array"===s(e)},n.isFloat32Array=function isFloat32Array(e){return"Float32Array"===s(e)},n.isFloat64Array=function isFloat64Array(e){return"Float64Array"===s(e)},n.isBigInt64Array=function isBigInt64Array(e){return"BigInt64Array"===s(e)},n.isBigUint64Array=function isBigUint64Array(e){return"BigUint64Array"===s(e)},isMapToString.working="undefined"!=typeof Map&&isMapToString(new Map),n.isMap=function isMap(e){return"undefined"!=typeof Map&&(isMapToString.working?isMapToString(e):e instanceof Map)},isSetToString.working="undefined"!=typeof Set&&isSetToString(new Set),n.isSet=function isSet(e){
return"undefined"!=typeof Set&&(isSetToString.working?isSetToString(e):e instanceof Set)},isWeakMapToString.working="undefined"!=typeof WeakMap&&isWeakMapToString(new WeakMap),n.isWeakMap=function isWeakMap(e){return"undefined"!=typeof WeakMap&&(isWeakMapToString.working?isWeakMapToString(e):e instanceof WeakMap)},isWeakSetToString.working="undefined"!=typeof WeakSet&&isWeakSetToString(new WeakSet),n.isWeakSet=function isWeakSet(e){return isWeakSetToString(e)},isArrayBufferToString.working="undefined"!=typeof ArrayBuffer&&isArrayBufferToString(new ArrayBuffer),n.isArrayBuffer=isArrayBuffer,isDataViewToString.working="undefined"!=typeof ArrayBuffer&&"undefined"!=typeof DataView&&isDataViewToString(new DataView(new ArrayBuffer(1),0,1)),n.isDataView=isDataView,isSharedArrayBufferToString.working="undefined"!=typeof SharedArrayBuffer&&isSharedArrayBufferToString(new SharedArrayBuffer),n.isSharedArrayBuffer=isSharedArrayBuffer,n.isAsyncFunction=function isAsyncFunction(e){
return"[object AsyncFunction]"===d(e)},n.isMapIterator=function isMapIterator(e){return"[object Map Iterator]"===d(e)},n.isSetIterator=function isSetIterator(e){return"[object Set Iterator]"===d(e)},n.isGeneratorObject=function isGeneratorObject(e){return"[object Generator]"===d(e)},n.isWebAssemblyCompiledModule=function isWebAssemblyCompiledModule(e){return"[object WebAssembly.Module]"===d(e)},n.isNumberObject=isNumberObject,n.isStringObject=isStringObject,n.isBooleanObject=isBooleanObject,n.isBigIntObject=isBigIntObject,n.isSymbolObject=isSymbolObject,n.isBoxedPrimitive=function isBoxedPrimitive(e){return isNumberObject(e)||isStringObject(e)||isBooleanObject(e)||isBigIntObject(e)||isSymbolObject(e)},n.isAnyArrayBuffer=function isAnyArrayBuffer(e){return"undefined"!=typeof Uint8Array&&(isArrayBuffer(e)||isSharedArrayBuffer(e))},["isProxy","isExternal","isModuleNamespaceObject"].forEach((function(e){Object.defineProperty(n,e,{enumerable:!1,value:function(){
throw new Error(e+" is not supported in userland")}})}))},{"is-arguments":181,"is-generator-function":183,"is-typed-array":184,"which-typed-array":258}],257:[function(e,t,n){(function(t){(function(){var i=Object.getOwnPropertyDescriptors||function getOwnPropertyDescriptors(e){for(var t=Object.keys(e),n={},i=0;i<t.length;i++)n[t[i]]=Object.getOwnPropertyDescriptor(e,t[i]);return n},a=/%[sdj%]/g;n.format=function(e){if(!isString(e)){for(var t=[],n=0;n<arguments.length;n++)t.push(inspect(arguments[n]));return t.join(" ")}n=1;for(var i=arguments,s=i.length,c=String(e).replace(a,(function(e){if("%%"===e)return"%";if(n>=s)return e;switch(e){case"%s":return String(i[n++]);case"%d":return Number(i[n++]);case"%j":try{return JSON.stringify(i[n++])}catch(e){return"[Circular]"}default:return e}})),l=i[n];n<s;l=i[++n])isNull(l)||!isObject(l)?c+=" "+l:c+=" "+inspect(l);return c},n.deprecate=function(e,i){if(void 0!==t&&!0===t.noDeprecation)return e;if(void 0===t)return function(){
return n.deprecate(e,i).apply(this,arguments)};var a=!1;return function deprecated(){if(!a){if(t.throwDeprecation)throw new Error(i);t.traceDeprecation?console.trace(i):console.error(i),a=!0}return e.apply(this,arguments)}};var s={},c=/^$/;if(t.env.NODE_DEBUG){var l=t.env.NODE_DEBUG;l=l.replace(/[|\\{}()[\]^$+?.]/g,"\\$&").replace(/\*/g,".*").replace(/,/g,"$|^").toUpperCase(),c=new RegExp("^"+l+"$","i")}function inspect(e,t){var i={seen:[],stylize:stylizeNoColor};return arguments.length>=3&&(i.depth=arguments[2]),arguments.length>=4&&(i.colors=arguments[3]),isBoolean(t)?i.showHidden=t:t&&n._extend(i,t),isUndefined(i.showHidden)&&(i.showHidden=!1),isUndefined(i.depth)&&(i.depth=2),isUndefined(i.colors)&&(i.colors=!1),isUndefined(i.customInspect)&&(i.customInspect=!0),i.colors&&(i.stylize=stylizeWithColor),formatValue(i,e,i.depth)}function stylizeWithColor(e,t){var n=inspect.styles[t];return n?"["+inspect.colors[n][0]+"m"+e+"["+inspect.colors[n][1]+"m":e}function stylizeNoColor(e,t){
return e}function formatValue(e,t,i){if(e.customInspect&&t&&isFunction(t.inspect)&&t.inspect!==n.inspect&&(!t.constructor||t.constructor.prototype!==t)){var a=t.inspect(i,e);return isString(a)||(a=formatValue(e,a,i)),a}var s=function formatPrimitive(e,t){if(isUndefined(t))return e.stylize("undefined","undefined");if(isString(t)){var n="'"+JSON.stringify(t).replace(/^"|"$/g,"").replace(/'/g,"\\'").replace(/\\"/g,'"')+"'";return e.stylize(n,"string")}if(isNumber(t))return e.stylize(""+t,"number");if(isBoolean(t))return e.stylize(""+t,"boolean");if(isNull(t))return e.stylize("null","null")}(e,t);if(s)return s;var c=Object.keys(t),l=function arrayToHash(e){var t={};return e.forEach((function(e,n){t[e]=!0})),t}(c);if(e.showHidden&&(c=Object.getOwnPropertyNames(t)),isError(t)&&(c.indexOf("message")>=0||c.indexOf("description")>=0))return formatError(t);if(0===c.length){if(isFunction(t)){var u=t.name?": "+t.name:"";return e.stylize("[Function"+u+"]","special")}
if(isRegExp(t))return e.stylize(RegExp.prototype.toString.call(t),"regexp");if(isDate(t))return e.stylize(Date.prototype.toString.call(t),"date");if(isError(t))return formatError(t)}var d,m="",p=!1,h=["{","}"];(isArray(t)&&(p=!0,h=["[","]"]),isFunction(t))&&(m=" [Function"+(t.name?": "+t.name:"")+"]");return isRegExp(t)&&(m=" "+RegExp.prototype.toString.call(t)),isDate(t)&&(m=" "+Date.prototype.toUTCString.call(t)),isError(t)&&(m=" "+formatError(t)),0!==c.length||p&&0!=t.length?i<0?isRegExp(t)?e.stylize(RegExp.prototype.toString.call(t),"regexp"):e.stylize("[Object]","special"):(e.seen.push(t),d=p?function formatArray(e,t,n,i,a){for(var s=[],c=0,l=t.length;c<l;++c)hasOwnProperty(t,String(c))?s.push(formatProperty(e,t,n,i,String(c),!0)):s.push("");return a.forEach((function(a){a.match(/^\d+$/)||s.push(formatProperty(e,t,n,i,a,!0))})),s}(e,t,i,l,c):c.map((function(n){return formatProperty(e,t,i,l,n,p)})),e.seen.pop(),function reduceToSingleString(e,t,n){if(e.reduce((function(e,t){
return t.indexOf("\n")>=0&&0,e+t.replace(/\u001b\[\d\d?m/g,"").length+1}),0)>60)return n[0]+(""===t?"":t+"\n ")+" "+e.join(",\n  ")+" "+n[1];return n[0]+t+" "+e.join(", ")+" "+n[1]}(d,m,h)):h[0]+m+h[1]}function formatError(e){return"["+Error.prototype.toString.call(e)+"]"}function formatProperty(e,t,n,i,a,s){var c,l,u;if((u=Object.getOwnPropertyDescriptor(t,a)||{value:t[a]}).get?l=u.set?e.stylize("[Getter/Setter]","special"):e.stylize("[Getter]","special"):u.set&&(l=e.stylize("[Setter]","special")),hasOwnProperty(i,a)||(c="["+a+"]"),l||(e.seen.indexOf(u.value)<0?(l=isNull(n)?formatValue(e,u.value,null):formatValue(e,u.value,n-1)).indexOf("\n")>-1&&(l=s?l.split("\n").map((function(e){return"  "+e})).join("\n").substr(2):"\n"+l.split("\n").map((function(e){return"   "+e})).join("\n")):l=e.stylize("[Circular]","special")),isUndefined(c)){if(s&&a.match(/^\d+$/))return l;(c=JSON.stringify(""+a)).match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)?(c=c.substr(1,c.length-2),
c=e.stylize(c,"name")):(c=c.replace(/'/g,"\\'").replace(/\\"/g,'"').replace(/(^"|"$)/g,"'"),c=e.stylize(c,"string"))}return c+": "+l}function isArray(e){return Array.isArray(e)}function isBoolean(e){return"boolean"==typeof e}function isNull(e){return null===e}function isNumber(e){return"number"==typeof e}function isString(e){return"string"==typeof e}function isUndefined(e){return void 0===e}function isRegExp(e){return isObject(e)&&"[object RegExp]"===objectToString(e)}function isObject(e){return"object"==typeof e&&null!==e}function isDate(e){return isObject(e)&&"[object Date]"===objectToString(e)}function isError(e){return isObject(e)&&("[object Error]"===objectToString(e)||e instanceof Error)}function isFunction(e){return"function"==typeof e}function objectToString(e){return Object.prototype.toString.call(e)}function pad(e){return e<10?"0"+e.toString(10):e.toString(10)}n.debuglog=function(e){if(e=e.toUpperCase(),!s[e])if(c.test(e)){var i=t.pid;s[e]=function(){
var t=n.format.apply(n,arguments);console.error("%s %d: %s",e,i,t)}}else s[e]=function(){};return s[e]},n.inspect=inspect,inspect.colors={bold:[1,22],italic:[3,23],underline:[4,24],inverse:[7,27],white:[37,39],grey:[90,39],black:[30,39],blue:[34,39],cyan:[36,39],green:[32,39],magenta:[35,39],red:[31,39],yellow:[33,39]},inspect.styles={special:"cyan",number:"yellow",boolean:"yellow",undefined:"grey",null:"bold",string:"green",date:"magenta",regexp:"red"},n.types=e("./support/types"),n.isArray=isArray,n.isBoolean=isBoolean,n.isNull=isNull,n.isNullOrUndefined=function isNullOrUndefined(e){return null==e},n.isNumber=isNumber,n.isString=isString,n.isSymbol=function isSymbol(e){return"symbol"==typeof e},n.isUndefined=isUndefined,n.isRegExp=isRegExp,n.types.isRegExp=isRegExp,n.isObject=isObject,n.isDate=isDate,n.types.isDate=isDate,n.isError=isError,n.types.isNativeError=isError,n.isFunction=isFunction,n.isPrimitive=function isPrimitive(e){
return null===e||"boolean"==typeof e||"number"==typeof e||"string"==typeof e||"symbol"==typeof e||void 0===e},n.isBuffer=e("./support/isBuffer");var u=["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"];function timestamp(){var e=new Date,t=[pad(e.getHours()),pad(e.getMinutes()),pad(e.getSeconds())].join(":");return[e.getDate(),u[e.getMonth()],t].join(" ")}function hasOwnProperty(e,t){return Object.prototype.hasOwnProperty.call(e,t)}n.log=function(){console.log("%s - %s",timestamp(),n.format.apply(n,arguments))},n.inherits=e("inherits"),n._extend=function(e,t){if(!t||!isObject(t))return e;for(var n=Object.keys(t),i=n.length;i--;)e[n[i]]=t[n[i]];return e};var d="undefined"!=typeof Symbol?Symbol("util.promisify.custom"):void 0;function callbackifyOnRejected(e,t){if(!e){var n=new Error("Promise was rejected with a falsy value");n.reason=e,e=n}return t(e)}n.promisify=function promisify(e){
if("function"!=typeof e)throw new TypeError('The "original" argument must be of type Function');if(d&&e[d]){var t;if("function"!=typeof(t=e[d]))throw new TypeError('The "util.promisify.custom" argument must be of type Function');return Object.defineProperty(t,d,{value:t,enumerable:!1,writable:!1,configurable:!0}),t}function t(){for(var t,n,i=new Promise((function(e,i){t=e,n=i})),a=[],s=0;s<arguments.length;s++)a.push(arguments[s]);a.push((function(e,i){e?n(e):t(i)}));try{e.apply(this,a)}catch(e){n(e)}return i}return Object.setPrototypeOf(t,Object.getPrototypeOf(e)),d&&Object.defineProperty(t,d,{value:t,enumerable:!1,writable:!1,configurable:!0}),Object.defineProperties(t,i(e))},n.promisify.custom=d,n.callbackify=function callbackify(e){if("function"!=typeof e)throw new TypeError('The "original" argument must be of type Function');function callbackified(){for(var n=[],i=0;i<arguments.length;i++)n.push(arguments[i]);var a=n.pop()
;if("function"!=typeof a)throw new TypeError("The last argument must be of type Function");var s=this,cb=function(){return a.apply(s,arguments)};e.apply(this,n).then((function(e){t.nextTick(cb.bind(null,null,e))}),(function(e){t.nextTick(callbackifyOnRejected.bind(null,e,cb))}))}return Object.setPrototypeOf(callbackified,Object.getPrototypeOf(e)),Object.defineProperties(callbackified,i(e)),callbackified}}).call(this)}).call(this,e("_process"))},{"./support/isBuffer":255,"./support/types":256,_process:223,inherits:174}],258:[function(e,t,n){(function(n){(function(){"use strict";var i=e("foreach"),a=e("available-typed-arrays"),s=e("call-bind/callBound"),c=s("Object.prototype.toString"),l=e("has-symbols")()&&"symbol"==typeof Symbol.toStringTag,u=a(),d=s("String.prototype.slice"),m={},p=e("es-abstract/helpers/getOwnPropertyDescriptor"),h=Object.getPrototypeOf;l&&p&&h&&i(u,(function(e){if("function"==typeof n[e]){var t=new n[e]
;if(!(Symbol.toStringTag in t))throw new EvalError("this engine has support for Symbol.toStringTag, but "+e+" does not have the property! Please report this.");var i=h(t),a=p(i,Symbol.toStringTag);if(!a){var s=h(i);a=p(s,Symbol.toStringTag)}m[e]=a.get}}));var f=e("is-typed-array");t.exports=function whichTypedArray(e){return!!f(e)&&(l?function tryAllTypedArrays(e){var t=!1;return i(m,(function(n,i){if(!t)try{var a=n.call(e);a===i&&(t=a)}catch(e){}})),t}(e):d(c(e),8,-1))}}).call(this)}).call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"available-typed-arrays":131,"call-bind/callBound":146,"es-abstract/helpers/getOwnPropertyDescriptor":161,foreach:163,"has-symbols":167,"is-typed-array":184}],259:[function(e,t,n){t.exports={version:"8.5.0"}},{}],260:[function(e,t,n){"use strict";const i=e("./report-assets.js");class ReportGenerator{static replaceStrings(e,t){if(0===t.length)return e;const n=t[0],i=t.slice(1)
;return e.split(n.search).map((e=>ReportGenerator.replaceStrings(e,i))).join(n.replacement)}static sanitizeJson(e){return JSON.stringify(e).replace(/</g,"\\u003c").replace(/\u2028/g,"\\u2028").replace(/\u2029/g,"\\u2029")}static generateReportHtml(e){const t=ReportGenerator.sanitizeJson(e),n=i.REPORT_JAVASCRIPT.replace(/<\//g,"\\u003c/");return ReportGenerator.replaceStrings(i.REPORT_TEMPLATE,[{search:"%%LIGHTHOUSE_JSON%%",replacement:t},{search:"%%LIGHTHOUSE_JAVASCRIPT%%",replacement:n},{search:"/*%%LIGHTHOUSE_CSS%%*/",replacement:i.REPORT_CSS}])}static generateFlowReportHtml(e){const t=ReportGenerator.sanitizeJson(e);return ReportGenerator.replaceStrings(i.FLOW_REPORT_TEMPLATE,[{search:"%%LIGHTHOUSE_FLOW_JSON%%",replacement:t},{search:"%%LIGHTHOUSE_FLOW_JAVASCRIPT%%",replacement:i.FLOW_REPORT_JAVASCRIPT},{search:"/*%%LIGHTHOUSE_FLOW_CSS%%*/",replacement:i.FLOW_REPORT_CSS},{search:"/*%%LIGHTHOUSE_CSS%%*/",replacement:i.REPORT_CSS}])}static generateReportCSV(e){
const escape=e=>`"${e.replace(/"/g,'""')}"`,rowFormatter=e=>e.map((e=>e.toString())).map(escape),t=Object.keys(e.categories).map((t=>{const n=[],i=e.categories[t],a=null===i.score?-1:i.score;return n.push(rowFormatter([e.requestedUrl,e.finalUrl,i.title,t+"-score",`Overall ${i.title} Category Score`,"numeric",a])),n.concat(i.auditRefs.map((t=>{const n=e.audits[t.id],a=null===n.score?-1:n.score;return rowFormatter([e.requestedUrl,e.finalUrl,i.title,n.id,n.title,n.scoreDisplayMode,a])})))}));return[["requestedUrl","finalUrl","category","name","title","type","score"]].concat(...t).map((e=>e.join(","))).join("\r\n")}static generateReport(e,t){const n=Array.isArray(t);"string"==typeof t&&(t=[t]);const i=t.map((t=>{if("html"===t)return ReportGenerator.generateReportHtml(e);if("csv"===t)return ReportGenerator.generateReportCSV(e);if("json"===t)return JSON.stringify(e,null,2);throw new Error("Invalid output mode: "+t)}));return n?i:i[0]}}t.exports=ReportGenerator},{"./report-assets.js":144}],
261:[function(e,t,n){(function(e){(function(){"use strict";t.exports={LH_ROOT:e}}).call(this)}).call(this,"/")},{}],262:[function(e,t,n){t.exports={npm:{"@angular/core":[{id:"SNYK-JS-ANGULARCORE-1070902",severity:"low",semver:{vulnerable:["<11.0.5",">=11.1.0-next.0 <11.1.0-next.3"]}}],angular:[{id:"SNYK-JS-ANGULAR-572020",severity:"high",semver:{vulnerable:["<1.8.0"]}},{id:"SNYK-JS-ANGULAR-570058",severity:"medium",semver:{vulnerable:["<1.8.0"]}},{id:"SNYK-JS-ANGULAR-534884",severity:"high",semver:{vulnerable:[">=1.4.0-beta.6 <1.7.9"]}},{id:"SNYK-JS-ANGULAR-471885",severity:"medium",semver:{vulnerable:["<1.6.3"]}},{id:"SNYK-JS-ANGULAR-471882",severity:"medium",semver:{vulnerable:["<1.6.5"]}},{id:"SNYK-JS-ANGULAR-471879",severity:"medium",semver:{vulnerable:["<1.6.0-rc.0"]}},{id:"npm:angular:20180202",severity:"medium",semver:{vulnerable:["<1.6.9"]}},{id:"npm:angular:20171018",severity:"medium",semver:{vulnerable:["<1.6.7"]}},{id:"npm:angular:20160527",severity:"medium",semver:{
vulnerable:[">=1.0.0 <1.2.30"]}},{id:"npm:angular:20160122",severity:"medium",semver:{vulnerable:[">=1.3.0 <1.5.0-rc.2"]}},{id:"npm:angular:20140608",severity:"low",semver:{vulnerable:["<1.3.0"]}},{id:"npm:angular:20131113",severity:"high",semver:{vulnerable:["<1.2.2"]}},{id:"npm:angular:20140908",severity:"medium",semver:{vulnerable:["<1.3.0-rc.5"]}},{id:"npm:angular:20161101",severity:"medium",semver:{vulnerable:[">=1.5.0 <1.5.9"]}},{id:"npm:angular:20150909",severity:"high",semver:{vulnerable:["<1.5.0-beta.2"]}},{id:"npm:angular:20151205",severity:"medium",semver:{vulnerable:["<1.5.0-rc.0"]}},{id:"npm:angular:20151130",severity:"medium",semver:{vulnerable:["<1.4.10"]}},{id:"npm:angular:20130622",severity:"medium",semver:{vulnerable:[">=1.0.0 <1.2.0"]}},{id:"npm:angular:20150807-1",severity:"medium",semver:{vulnerable:[">=1.3.1 <1.5.0-beta.0"]}},{id:"npm:angular:20150807",severity:"high",semver:{vulnerable:[">=1.0.0 <1.5.0-beta.0"]}},{id:"npm:angular:20150315",severity:"medium",
semver:{vulnerable:["<1.6.1"]}},{id:"npm:angular:20150310",severity:"high",semver:{vulnerable:["<1.4.0-beta.6"]}},{id:"npm:angular:20141104",severity:"medium",semver:{vulnerable:["<1.3.2"]}},{id:"npm:angular:20130621",severity:"medium",semver:{vulnerable:["<1.2.0"]}},{id:"npm:angular:20140909",severity:"high",semver:{vulnerable:[">=1.2.19 <1.2.27"]}},{id:"npm:angular:20130625",severity:"high",semver:{vulnerable:["<1.1.5"]}}],backbone:[{id:"npm:backbone:20160523",severity:"medium",semver:{vulnerable:["<0.1.2"]}},{id:"npm:backbone:20110701",severity:"medium",semver:{vulnerable:["<0.5.0"]}}],bootstrap:[{id:"SNYK-JS-BOOTSTRAP-173700",severity:"medium",semver:{vulnerable:["<3.4.1",">=4.0.0 <4.3.1"]}},{id:"SNYK-JS-BOOTSTRAP-73560",severity:"medium",semver:{vulnerable:[">=4.0.0 <4.1.2"]}},{id:"SNYK-JS-BOOTSTRAP-72890",severity:"medium",semver:{vulnerable:["<3.4.0"]}},{id:"SNYK-JS-BOOTSTRAP-72889",severity:"medium",semver:{vulnerable:["<3.4.0"]}},{id:"npm:bootstrap:20180529",severity:"medium",
semver:{vulnerable:["<3.4.0",">=4.0.0 <4.1.2"]}},{id:"npm:bootstrap:20160627",severity:"medium",semver:{vulnerable:["<3.4.0",">=4.0.0-alpha <4.0.0-beta.2"]}},{id:"npm:bootstrap:20120510",severity:"medium",semver:{vulnerable:["<2.1.0"]}}],dojo:[{id:"SNYK-JS-DOJO-559224",severity:"medium",semver:{vulnerable:["<1.11.10",">=1.12.1 <1.12.8",">=1.13.0 <1.13.7",">=1.14.0 <1.14.6",">=1.15.0 <1.15.3",">=1.16.0 <1.16.2"]}},{id:"SNYK-JS-DOJO-174934",severity:"medium",semver:{vulnerable:[">=1.0.0 <1.0.3",">=1.1.0 <1.1.2",">=1.2.0 <1.2.4",">=1.3.0 <1.3.3",">=1.4.0 <1.4.2"]}},{id:"SNYK-JS-DOJO-174933",severity:"medium",semver:{vulnerable:["<1.2.0"]}},{id:"SNYK-JS-DOJO-72305",severity:"medium",semver:{vulnerable:[">=1.14.0-pre <1.14.0",">=1.13.0 <1.13.1",">=1.12.1 <1.12.4",">=1.11.0-rc1 <1.11.6","<1.10.10"]}},{id:"npm:dojo:20180818",severity:"medium",semver:{vulnerable:["<1.10.10",">=1.11.0 <1.11.6",">=1.12.0 <1.12.4",">=1.13.0 <1.13.1"]}},{id:"npm:dojo:20100614-6",severity:"medium",semver:{
vulnerable:["<1.4.2"]}},{id:"npm:dojo:20100614",severity:"medium",semver:{vulnerable:[">=0.4.0 <0.4.4",">=1.0.0 <1.0.3",">=1.1.0 <1.1.2",">=1.2.0 <1.2.4",">=1.3.0 <1.3.3",">=1.4.0 <1.4.2"]}}],"foundation-sites":[{id:"npm:foundation-sites:20170802",severity:"medium",semver:{vulnerable:["<6.0.0"]}},{id:"npm:foundation-sites:20150619",severity:"medium",semver:{vulnerable:["<5.5.3"]}},{id:"npm:foundation-sites:20120717",severity:"medium",semver:{vulnerable:[">=3.0.0 <3.0.6"]}}],"google-closure-library":[{id:"SNYK-JS-GOOGLECLOSURELIBRARY-561341",severity:"medium",semver:{vulnerable:["<20200315.0.0"]}},{id:"SNYK-JS-GOOGLECLOSURELIBRARY-174519",severity:"medium",semver:{vulnerable:[">=20190121.0.0 <20190301.0.0"]}}],gsap:[{id:"SNYK-JS-GSAP-1054614",severity:"high",semver:{vulnerable:["<3.6.0"]}}],handlebars:[{id:"SNYK-JS-HANDLEBARS-1279029",severity:"medium",semver:{vulnerable:["<4.7.7"]}},{id:"SNYK-JS-HANDLEBARS-1056767",severity:"medium",semver:{vulnerable:["<4.7.7"]}},{
id:"SNYK-JS-HANDLEBARS-567742",severity:"medium",semver:{vulnerable:["<4.6.0"]}},{id:"SNYK-JS-HANDLEBARS-534988",severity:"high",semver:{vulnerable:[">=4.0.0 <4.5.3","<3.0.8"]}},{id:"SNYK-JS-HANDLEBARS-534478",severity:"high",semver:{vulnerable:[">=4.0.0 <4.5.3","<3.0.8"]}},{id:"SNYK-JS-HANDLEBARS-480388",severity:"high",semver:{vulnerable:[">=4.0.0 <4.4.5"]}},{id:"SNYK-JS-HANDLEBARS-469063",severity:"high",semver:{vulnerable:[">=4.0.0 <4.3.0","<3.8.0"]}},{id:"SNYK-JS-HANDLEBARS-174183",severity:"high",semver:{vulnerable:[">=3.0.0 <3.0.7",">=4.1.0 <4.1.2",">=4.0.0 <4.0.14"]}},{id:"SNYK-JS-HANDLEBARS-173692",severity:"high",semver:{vulnerable:["<4.0.14",">=4.1.0 <4.1.2"]}},{id:"npm:handlebars:20151207",severity:"medium",semver:{vulnerable:["<4.0.0"]}},{id:"npm:handlebars:20110425",severity:"medium",semver:{vulnerable:["<=1.0.0-beta.3"]}}],highcharts:[{id:"SNYK-JS-HIGHCHARTS-1290057",severity:"medium",semver:{vulnerable:["<9.0.0"]}},{id:"SNYK-JS-HIGHCHARTS-1018906",severity:"medium",
semver:{vulnerable:["<9.0.0"]}},{id:"SNYK-JS-HIGHCHARTS-571995",severity:"high",semver:{vulnerable:["<7.2.2",">=8.0.0 <8.1.1"]}},{id:"npm:highcharts:20180225",severity:"high",semver:{vulnerable:["<6.1.0"]}}],jquery:[{id:"SNYK-JS-JQUERY-569619",severity:"medium",semver:{vulnerable:["<1.9.0"]}},{id:"SNYK-JS-JQUERY-567880",severity:"medium",semver:{vulnerable:[">=1.2.0 <3.5.0"]}},{id:"SNYK-JS-JQUERY-565129",severity:"medium",semver:{vulnerable:[">=1.5.1 <3.5.0"]}},{id:"SNYK-JS-JQUERY-174006",severity:"medium",semver:{vulnerable:["<3.4.0"]}},{id:"npm:jquery:20160529",severity:"low",semver:{vulnerable:[">=3.0.0-rc1 <3.0.0"]}},{id:"npm:jquery:20150627",severity:"medium",semver:{vulnerable:["<1.12.2",">=1.12.3 <2.2.2",">=2.2.3 <3.0.0"]}},{id:"npm:jquery:20140902",severity:"medium",semver:{vulnerable:[">=1.4.2 <1.6.2"]}},{id:"npm:jquery:20120206",severity:"medium",semver:{vulnerable:["<1.9.1"]}},{id:"npm:jquery:20110606",severity:"medium",semver:{vulnerable:["<1.6.3"]}}],"jquery-mobile":[{
id:"SNYK-JS-JQUERYMOBILE-174599",severity:"medium",semver:{vulnerable:["<=1.5.0-alpha.1"]}},{id:"npm:jquery-mobile:20120802",severity:"medium",semver:{vulnerable:["<1.2.0"]}}],"jquery-ui":[{id:"npm:jquery-ui:20121127",severity:"medium",semver:{vulnerable:["<1.10.0"]}},{id:"npm:jquery-ui:20100903",severity:"medium",semver:{vulnerable:["<1.10.0"]}},{id:"npm:jquery-ui:20160721",severity:"high",semver:{vulnerable:["<1.12.0"]}}],knockout:[{id:"npm:knockout:20180213",severity:"medium",semver:{vulnerable:["<3.5.0-beta"]}},{id:"npm:knockout:20130701",severity:"medium",semver:{vulnerable:[">=2.1.0-pre <3.0.0"]}}],lodash:[{id:"SNYK-JS-LODASH-1040724",severity:"high",semver:{vulnerable:["<4.17.21"]}},{id:"SNYK-JS-LODASH-1018905",severity:"medium",semver:{vulnerable:["<4.17.21"]}},{id:"SNYK-JS-LODASH-608086",severity:"high",semver:{vulnerable:["<4.17.17"]}},{id:"SNYK-JS-LODASH-590103",severity:"high",semver:{vulnerable:["<4.17.20"]}},{id:"SNYK-JS-LODASH-567746",severity:"medium",semver:{
vulnerable:["<4.17.16"]}},{id:"SNYK-JS-LODASH-450202",severity:"high",semver:{vulnerable:["<4.17.12"]}},{id:"SNYK-JS-LODASH-73639",severity:"medium",semver:{vulnerable:["<4.17.11"]}},{id:"SNYK-JS-LODASH-73638",severity:"high",semver:{vulnerable:["<4.17.11"]}},{id:"npm:lodash:20180130",severity:"medium",semver:{vulnerable:["<4.17.5"]}}],moment:[{id:"npm:moment:20170905",severity:"low",semver:{vulnerable:["<2.19.3"]}},{id:"npm:moment:20161019",severity:"medium",semver:{vulnerable:["<2.15.2"]}},{id:"npm:moment:20160126",severity:"medium",semver:{vulnerable:["<2.11.2"]}}],mustache:[{id:"npm:mustache:20151207",severity:"medium",semver:{vulnerable:["<2.2.1"]}},{id:"npm:mustache:20110814",severity:"medium",semver:{vulnerable:["< 0.3.1"]}}],next:[{id:"SNYK-JS-NEXT-1577139",severity:"medium",semver:{vulnerable:[">=10.0.0 <11.1.1"]}},{id:"SNYK-JS-NEXT-1540422",severity:"medium",semver:{vulnerable:["<11.1.0"]}},{id:"SNYK-JS-NEXT-1063481",severity:"medium",semver:{vulnerable:[">=9.5.0 <9.5.4"]}},{
id:"SNYK-JS-NEXT-571938",severity:"high",semver:{vulnerable:["<5.1.0"]}},{id:"SNYK-JS-NEXT-561584",severity:"medium",semver:{vulnerable:["<9.3.2"]}},{id:"SNYK-JS-NEXT-174590",severity:"high",semver:{vulnerable:["<2.4.1"]}},{id:"SNYK-JS-NEXT-72454",severity:"medium",semver:{vulnerable:[">=7.0.0 <7.0.2"]}},{id:"npm:next:20180124",severity:"high",semver:{vulnerable:["<4.2.3"]}},{id:"npm:next:20170607",severity:"medium",semver:{vulnerable:["<2.4.3"]}},{id:"npm:next:20170601",severity:"high",semver:{vulnerable:["<2.4.1",">=3.0.0-beta1 <3.0.0-beta7"]}}],react:[{id:"npm:react:20150318",severity:"high",semver:{vulnerable:[">=0.0.1 <0.14.0"]}},{id:"npm:react:20131217",severity:"medium",semver:{vulnerable:[">=0.5.0 <0.5.2",">=0.4.0 <0.4.2"]}}],riot:[{id:"npm:riot:20131114",severity:"medium",semver:{vulnerable:["<0.9.6"]}}],"socket.io":[{id:"SNYK-JS-SOCKETIO-1024859",severity:"medium",semver:{vulnerable:["<2.4.0"]}},{id:"npm:socket.io:20120417",severity:"medium",semver:{vulnerable:["<0.9.6"]}},{
id:"npm:socket.io:20120323",severity:"medium",semver:{vulnerable:["<0.9.7"]}}],three:[{id:"SNYK-JS-THREE-1064931",severity:"high",semver:{vulnerable:["<0.125.0"]}}],underscore:[{id:"SNYK-JS-UNDERSCORE-1080984",severity:"medium",semver:{vulnerable:[">=1.13.0-0 <1.13.0-2",">=1.3.2 <1.12.1"]}}],vue:[{id:"npm:vue:20170829",severity:"medium",semver:{vulnerable:["<2.4.3"]}},{id:"npm:vue:20170401",severity:"medium",semver:{vulnerable:["<2.3.0-beta.1"]}},{id:"npm:vue:20180802",severity:"medium",semver:{vulnerable:["<2.5.17"]}},{id:"npm:vue:20180222",severity:"low",semver:{vulnerable:["<2.5.14"]}}],yui:[{id:"npm:yui:20130604",severity:"medium",semver:{vulnerable:[">=3.0.0 <3.10.1","=3.10.2"]}},{id:"npm:yui:20130515",severity:"medium",semver:{vulnerable:["<3.10.0 >=3.0.0"]}},{id:"npm:yui:20121030",severity:"medium",semver:{vulnerable:["<3.0.0 >=2.4.0"]}},{id:"npm:yui:20120428",severity:"medium",semver:{vulnerable:["<3.5.1 >=3.5.0-PR1"]}},{id:"npm:yui:20101025",severity:"medium",semver:{
vulnerable:["<2.8.2 >=2.4.0"]}}]}}},{}],"lighthouse-plugin-publisher-ads/audits/ad-blocking-tasks":[function(e,t,n){(function(n){(function(){const i=e("../computed/ad-request-time"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),s=e("../computed/long-tasks"),{auditNotApplicable:c}=e("../messages/common-strings"),{Audit:l}=e("lighthouse"),{getAttributableUrl:u}=e("../utils/tasks"),{isAdScript:d}=e("../utils/resource-classification"),{URL:m}=e("url"),p={title:"No long tasks blocking ad-related network requests",failureTitle:"Avoid long tasks that block ad-related network requests",description:"Tasks blocking the main thread can delay ad requests and cause a poor user experience. Consider removing long blocking tasks or moving them off of the main thread. These tasks can be especially detrimental to performance on less powerful devices. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-blocking-tasks).",
failureDisplayValue:"{timeInMs, number, seconds} s blocked",columnScript:"Attributable URL",columnStartTime:"Start",columnDuration:"Duration"},h=a.createMessageInstanceIdFn(n,p),f=[{key:"script",itemType:"url",text:h(p.columnScript)},{key:"startTime",itemType:"ms",text:h(p.columnStartTime),granularity:1},{key:"duration",itemType:"ms",text:h(p.columnDuration),granularity:1}];class AdBlockingTasks extends l{static get meta(){return{id:"ad-blocking-tasks",title:h(p.title),failureTitle:h(p.failureTitle),description:h(p.description),requiredArtifacts:["traces","devtoolsLogs"]}}static async audit(e,t){const n="simulate"==t.settings.throttlingMethod?200:100,a={trace:e.traces[l.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[l.DEFAULT_PASS],settings:t.settings};let g=[];try{g=await s.request(a,t)}catch(e){return c.InvalidTiming}if(!g.length)return c.NoTasks;const{timing:y}=await i.request(a,t);if(!(y>0))return c.NoAdRelatedReq;const b=[];for(const e of g){if(e.startTime>y||e.duration<n)continue
;const t=u(e);if(t&&d(new m(t)))continue;const i=t&&new m(t),a=i&&i.origin+i.pathname||"Other";b.push({script:a,rawUrl:t,startTime:e.startTime,endTime:e.endTime,duration:e.duration,isTopLevel:!e.parent})}let v=Array.from(b);v.length>10&&(v=b.filter((e=>"Other"!==e.script&&e.isTopLevel)).sort(((e,t)=>t.duration-e.duration)).splice(0,10).sort(((e,t)=>e.startTime-t.startTime)));const w=v.reduce(((e,t)=>t.isTopLevel?e+t.duration:e),0),S=v.length>0;return{score:S?0:1,numericValue:w,numericUnit:"millisecond",displayValue:S?h(p.failureDisplayValue,{timeInMs:w}):"",details:AdBlockingTasks.makeTableDetails(f,v)}}}t.exports=AdBlockingTasks,t.exports.UIStrings=p}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/ad-blocking-tasks.js")},{"../computed/ad-request-time":194,"../computed/long-tasks":196,"../messages/common-strings":198,"../utils/resource-classification":206,"../utils/tasks":207,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98,url:"url"}],
"lighthouse-plugin-publisher-ads/audits/ad-render-blocking-resources":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),a=e("lighthouse/lighthouse-core/computed/network-records"),{auditNotApplicable:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),{getTimingsByRecord:l}=e("../utils/network-timing"),{isAdTag:u}=e("../utils/resource-classification"),{URL:d}=e("url"),m={title:"Minimal render-blocking resources found",failureTitle:"Avoid render-blocking resources",description:"Render-blocking resources slow down tag load times. Consider loading critical JS/CSS inline or loading scripts asynchronously or loading the tag earlier in the head. [Learn more](https://developers.google.com/web/tools/lighthouse/audits/blocking-resources).",failureDisplayValue:"Up to {timeInMs, number, seconds} s tag load time improvement",columnUrl:"Resource",columnStartTime:"Start",columnDuration:"Duration"},p=i.createMessageInstanceIdFn(n,m),h=[{key:"url",
itemType:"url",text:p(m.columnUrl)},{key:"startTime",itemType:"ms",text:p(m.columnStartTime),granularity:1},{key:"duration",itemType:"ms",text:p(m.columnDuration),granularity:1}];class AdRenderBlockingResources extends c{static get meta(){return{id:"ad-render-blocking-resources",title:p(m.title),failureTitle:p(m.failureTitle),scoreDisplayMode:"binary",description:p(m.description),requiredArtifacts:["LinkElements","ScriptElements","devtoolsLogs","traces"]}}static async audit(e,t){const n=e.devtoolsLogs[c.DEFAULT_PASS],i=e.traces[c.DEFAULT_PASS],f=await a.request(n,t),g=f.find((e=>u(new d(e.url))));if(!g)return s.NoTag;const y=await l(i,n,t),b=new Set;for(const t of e.LinkElements)t.href&&"stylesheet"==t.rel&&b.add(t.href);for(const t of e.ScriptElements)!t.src||t.defer||t.async||b.add(t.src);const v=f.filter((e=>e.endTime<g.startTime)).filter((e=>e!=g.initiatorRequest)).filter((e=>e.initiator.type="parser")).filter((e=>b.has(e.url))).map((e=>Object.assign({url:e.url},y.get(e))))
;v.sort(((e,t)=>e.endTime-t.endTime));const w=y.get(g)||{startTime:1/0},S=v.map((e=>e.startTime)),T=v.map((e=>e.endTime)),E=Math.min(...S),_=Math.min(Math.max(...T),w.startTime)-E;let x="";v.length>0&&_>0&&(x=p(m.failureDisplayValue,{timeInMs:_}));return{score:v.length>0&&_>100?0:1,numericValue:v.length,numericUnit:"unitless",displayValue:x,details:{opportunity:_,...AdRenderBlockingResources.makeTableDetails(h,v)}}}}t.exports=AdRenderBlockingResources,t.exports.UIStrings=m}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/ad-render-blocking-resources.js")},{"../messages/common-strings":198,"../utils/network-timing":204,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/lib/i18n/i18n":98,url:"url"}],"lighthouse-plugin-publisher-ads/audits/ad-request-critical-path":[function(e,t,n){(function(n){(function(){
const i=e("../computed/ad-request-time"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),{computeAdRequestWaterfall:l}=e("../utils/graph"),u={title:"Ad request waterfall",failureTitle:"Reduce critical path for ad loading",description:"Consider reducing the number of resources, loading multiple resources simultaneously, or loading resources earlier to improve ad speed. Requests that block ad loading can be found below. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-request-critical-path).",displayValue:"{serialResources, plural, =1 {1 serial resource} other {# serial resources}}",columnUrl:"Request",columnType:"Type",columnStartTime:"Start",columnEndTime:"End"},d=a.createMessageInstanceIdFn(n,u),m=[{key:"nameOrTld",itemType:"text",text:d(u.columnType)},{key:"url",itemType:"url",text:d(u.columnUrl)},{key:"startTime",itemType:"ms",text:d(u.columnStartTime),granularity:1},{
key:"endTime",itemType:"ms",text:d(u.columnEndTime),granularity:1}];class AdRequestCriticalPath extends c{static get meta(){return{id:"ad-request-critical-path",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),scoreDisplayMode:"informative",requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(e,t){const n=e.traces[c.DEFAULT_PASS],a=e.devtoolsLogs[c.DEFAULT_PASS],p={trace:n,devtoolsLog:a,settings:t.settings},h=await i.request(p,t),f=(await l(n,a,t)).filter((e=>e.startTime>0&&e.startTime<e.endTime&&e.endTime<h.timing));if(!f.length)return s.NoAds;const g=function computeDepth(e){let t=0,n=0;for(const{startTime:i,endTime:a}of e)i>t?(++n,t=a):t=Math.min(t,a);return n}(f),y=g>3;for(const e of f)delete e.record;const b=function computeIdleTimes(e){let t=1/0;const n=[];for(let i=0;i<e.length;){const{startTime:a,endTime:s}=e[i];for(a-t>150&&n.push(a-t),t=s;++i<e.length&&e[i].startTime<t;)t=Math.max(t,e[i].endTime)}return n
}(f),v=Math.max(...b),w=b.reduce(((e,t)=>e+t),0);return{numericValue:g,numericUnit:"unitless",score:y?0:1,displayValue:d(u.displayValue,{serialResources:g}),details:{size:f.length,depth:g,maxIdleTime:v,totalIdleTime:w,...AdRequestCriticalPath.makeTableDetails(m,f)}}}}t.exports=AdRequestCriticalPath,t.exports.UIStrings=u}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/ad-request-critical-path.js")},{"../computed/ad-request-time":194,"../messages/common-strings":198,"../utils/graph":203,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/ad-request-from-page-start":[function(e,t,n){(function(n){(function(){const i=e("../computed/ad-request-time"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:s,runWarning:c}=e("../messages/common-strings"),{Audit:l}=e("lighthouse"),u={title:"First ad request time",failureTitle:"Reduce time to send the first ad request",
description:"This metric measures the elapsed time from the start of page load until the first ad request is made. Delayed ad requests will decrease impressions and viewability, and have a negative impact on ad revenue. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-request-from-page-start).",displayValue:"{timeInMs, number, seconds} s"},d=a.createMessageInstanceIdFn(n,u);t.exports=class AdRequestFromPageStart extends l{static get meta(){return{id:"ad-request-from-page-start",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),scoreDisplayMode:l.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:6500,median:1e4},provided:{p10:1900,median:3500}}}static async audit(e,t){const n={trace:e.traces[l.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[l.DEFAULT_PASS],settings:t.settings
},a=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"],{timing:m}=await i.request(n,t);if(!(m>0)){const e=s.NoAds;return e.runWarnings=[c.NoAds],e}return{numericValue:m,numericUnit:"millisecond",score:l.computeLogNormalScore(a,m),displayValue:d(u.displayValue,{timeInMs:m})}}},t.exports.UIStrings=u}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/ad-request-from-page-start.js")},{"../computed/ad-request-time":194,"../messages/common-strings":198,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/ad-top-of-viewport":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:a}=e("../messages/common-strings"),{Audit:s}=e("lighthouse"),{isAdIframe:c}=e("../utils/resource-classification"),l={title:"No ad found at the very top of the viewport",failureTitle:"Move the top ad further down the page",
description:"Over 10% of ads are never viewed because users scroll past them before they become viewable. By moving ad slots away from the very top of the viewport, users are more likely to see ads before scrolling away. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ad-top-of-viewport).",failureDisplayValue:"A scroll of {valueInPx, number} px would hide half of your topmost ad",columnSlot:"Top Slot ID"},u=i.createMessageInstanceIdFn(n,l),d=[{key:"slot",itemType:"text",text:u(l.columnSlot)}];class AdTopOfViewport extends s{static get meta(){return{id:"ad-top-of-viewport",title:u(l.title),failureTitle:u(l.failureTitle),description:u(l.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(e){const t=e.ViewportDimensions,n=e.IFrameElements.filter(c).filter((e=>e.clientRect.width*e.clientRect.height>1&&!e.isPositionFixed)).map((e=>({midpoint:e.clientRect.top+e.clientRect.height/2,id:e.id})))
;if(!n.length)return a.NoVisibleSlots;const i=n.reduce(((e,t)=>e.midpoint<t.midpoint?e:t)),s=i.midpoint<t.innerHeight;if(!s)return a.NoAdsViewport;const m=s&&i.midpoint<100?0:1;return{score:m,numericValue:i.midpoint,numericUnit:"unitless",displayValue:m?"":u(l.failureDisplayValue,{valueInPx:i.midpoint}),details:AdTopOfViewport.makeTableDetails(d,m?[]:[{slot:i.id}])}}}t.exports=AdTopOfViewport,t.exports.UIStrings=l}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/ad-top-of-viewport.js")},{"../messages/common-strings":198,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/ads-in-viewport":[function(e,t,n){(function(n){(function(){const{auditNotApplicable:i}=e("../messages/common-strings"),{Audit:a}=e("lighthouse"),s=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{isBoxInViewport:c}=e("../utils/geometry"),{isGptIframe:l}=e("../utils/resource-classification"),u={
title:"Few or no ads loaded outside viewport",failureTitle:"Avoid loading ads until they are nearly on-screen",description:"Too many ads loaded outside the viewport lowers viewability rates and impacts user experience. Consider loading ads below the fold lazily as the user scrolls down. Consider using GPT's [Lazy Loading API](https://developers.google.com/doubleclick-gpt/reference#googletag.PubAdsService_enableLazyLoad). [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/ads-in-viewport).",failureDisplayValue:"{hiddenAds, plural, =1 {1 ad} other {# ads}} out of view",columnSlot:"Slots Outside Viewport"},d=s.createMessageInstanceIdFn(n,u),m=[{key:"slot",itemType:"text",text:d(u.columnSlot)}];class AdsInViewport extends a{static get meta(){return{id:"ads-in-viewport",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(e){
const t=e.ViewportDimensions,n=e.IFrameElements.filter((e=>l(e)&&e.clientRect.height*e.clientRect.width>1));if(!n.length)return i.NoVisibleSlots;const a=n.filter((e=>!c(e.clientRect,t))).map((e=>({slot:e.id}))).sort(((e,t)=>e.slot.localeCompare(t.slot)));return{numericValue:(n.length-a.length)/n.length,numericUnit:"unitless",score:a.length>3?0:1,displayValue:a.length?d(u.failureDisplayValue,{hiddenAds:a.length}):"",details:AdsInViewport.makeTableDetails(m,a)}}}t.exports=AdsInViewport,t.exports.UIStrings=u}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/ads-in-viewport.js")},{"../messages/common-strings":198,"../utils/geometry":202,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/async-ad-tags":[function(e,t,n){(function(n){(function(){
const i=e("../utils/array.js"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),s=e("lighthouse/lighthouse-core/computed/main-resource"),c=e("lighthouse/lighthouse-core/computed/network-records"),{auditNotApplicable:l}=e("../messages/common-strings"),{Audit:u}=e("lighthouse"),{isAdTag:d,isStaticRequest:m}=e("../utils/resource-classification"),{URL:p}=e("url"),h={title:"Ad tag is loaded asynchronously",failureTitle:"Load ad tag asynchronously",description:"Loading the ad tag synchronously blocks content rendering until the tag is fetched and loaded. Consider using the `async` attribute to load gpt.js and/or adsbygoogle.js asynchronously. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/async-ad-tags)."},f=a.createMessageInstanceIdFn(n,h);function isAsync(e){return"Low"==e.priority||m(e)}t.exports=class AsyncAdTags extends u{static get meta(){return{id:"async-ad-tags",title:f(h.title),failureTitle:f(h.failureTitle),description:f(h.description),
requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(e,t){const n=e.devtoolsLogs[u.DEFAULT_PASS],a=await c.request(n,t),m=await s.request({URL:e.URL,devtoolsLog:n},t),h=a.filter((e=>d(new p(e.url)))).filter((e=>e.frameId===m.frameId));if(!h.length)return l.NoTag;const f=i.count(h,isAsync)-h.length;return{score:Number(0===f),numericValue:f,numericUnit:"unitless"}}},t.exports.UIStrings=h}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/async-ad-tags.js")},{"../messages/common-strings":198,"../utils/array.js":199,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/main-resource":14,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/lib/i18n/i18n":98,url:"url"}],"lighthouse-plugin-publisher-ads/audits/bid-request-from-page-start":[function(e,t,n){(function(n){(function(){
const i=e("../computed/bid-request-time"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),l={title:"First bid request time",failureTitle:"Reduce time to send the first bid request",description:"This metric measures the elapsed time from the start of page load until the first bid request is made. Delayed bid requests will decrease impressions and viewability, and have a negative impact on ad revenue. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/bid-request-from-page-start).",displayValue:"{timeInMs, number, seconds} s"},u=a.createMessageInstanceIdFn(n,l);t.exports=class BidRequestFromPageStart extends c{static get meta(){return{id:"bid-request-from-page-start",title:u(l.title),failureTitle:u(l.failureTitle),description:u(l.description),scoreDisplayMode:c.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{
p10:4350,median:8e3},provided:{p10:1200,median:2e3}}}static async audit(e,t){const n={trace:e.traces[c.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[c.DEFAULT_PASS],settings:t.settings},a=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"],{timing:d}=await i.request(n,t);return d>0?{numericValue:d,numericUnit:"millisecond",score:c.computeLogNormalScore(a,d),displayValue:u(l.displayValue,{timeInMs:d})}:s.NoBids}},t.exports.UIStrings=l}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/bid-request-from-page-start.js")},{"../computed/bid-request-time":195,"../messages/common-strings":198,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/blocking-load-events":[function(e,t,n){(function(n){(function(){
const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),a=e("lighthouse/lighthouse-core/computed/network-records"),s=e("lighthouse/lighthouse-core/computed/trace-of-tab"),{auditNotApplicable:c}=e("../messages/common-strings"),{Audit:l}=e("lighthouse"),{computeAdRequestWaterfall:u}=e("../utils/graph"),{getTimingsByRecord:d}=e("../utils/network-timing"),m={title:"Ads not blocked by load events",failureTitle:"Avoid waiting on load events",description:"Waiting on load events increases ad latency. To speed up ads, eliminate the following load event handlers. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/blocking-load-events).",displayValue:"{timeInMs, number, seconds} s blocked",columnEvent:"Event Name",columnTime:"Event Time",columnScript:"Script",columnBlockedUrl:"Blocked URL",columnFunctionName:"Function"},p=i.createMessageInstanceIdFn(n,m),h=[{key:"eventName",itemType:"text",text:p(m.columnEvent)},{key:"time",itemType:"ms",text:p(m.columnTime),
granularity:1},{key:"url",itemType:"url",text:p(m.columnScript)},{key:"functionName",itemType:"text",text:p(m.columnFunctionName)}];function findOriginalCallFrame(e){const{record:t}=e;let n=t&&t.initiator&&t.initiator.stack;if(n){for(;n.parent;)n=n.parent;return n.callFrames[n.callFrames.length-1]}}function findTraceEventOfCallFrame(e,t){return t.find((t=>"FunctionCall"==t.name&&t.args.data&&t.args.data.functionName==e.functionName&&t.args.data.scriptId==e.scriptId&&t.args.data.url==e.url&&Math.abs(t.args.data.lineNumber==e.lineNumber)<2&&Math.abs(t.args.data.columnNumber==e.columnNumber)<2))}function findEventIntervals(e,t){let n={};const i=[];for(const a of t)a.name==e+"EventStart"?n={start:a.ts,end:1/0,eventName:e}:a.name==e+"EventEnd"&&(n.end=a.ts,i.push(n));return i}function quantifyBlockedTime(e,t,n){const i=t.find((t=>t.url==e.url)),a=t.find((t=>t.url==e.blockedUrl));if(!i||!a)return 0;const s=n.get(i),c=n.get(a);return s&&c?c.startTime-s.endTime:0}
class BlockingLoadEvents extends l{static get meta(){return{id:"blocking-load-events",title:p(m.title),failureTitle:p(m.failureTitle),description:p(m.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(e,t){const n=e.traces[l.DEFAULT_PASS],i=e.devtoolsLogs[l.DEFAULT_PASS],f=await a.request(i,t),{timings:g,processEvents:y}=await s.request(n,t),b=await d(n,i,t),v=(await u(n,i,t)).sort(((e,t)=>e.startTime-t.startTime));if(!v.length)return c.NoAdRelatedReq;const w=[...findEventIntervals("domContentLoaded",y),...findEventIntervals("load",y)],S=[],T=new Set;for(const e of v){const t=findOriginalCallFrame(e);if(!t)continue;const n=JSON.stringify(t);if(T.has(n))continue;T.add(n);const i=findTraceEventOfCallFrame(t,y);if(!i)continue;const a=w.find((e=>e.start<=i.ts&&i.ts<=e.end));if(a){const n=Object.assign({eventName:a.eventName,blockedUrl:e.url,time:g[a.eventName],blockedTime:1/0},t);n.blockedTime=quantifyBlockedTime(n,f,b),S.push(n)}}const E=S.length>0;let _=0
;return E&&(_=Math.min(...S.map((e=>e.blockedTime)))),{numericValue:S.length,numericUnit:"unitless",score:E?0:1,displayValue:E&&_?p(m.displayValue,{timeInMs:_}):"",details:BlockingLoadEvents.makeTableDetails(h,S)}}}t.exports=BlockingLoadEvents,t.exports.UIStrings=m}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/blocking-load-events.js")},{"../messages/common-strings":198,"../utils/graph":203,"../utils/network-timing":204,lighthouse:80,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/computed/trace-of-tab":47,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/bottleneck-requests":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:a}=e("../messages/common-strings"),{Audit:s}=e("lighthouse"),{computeAdRequestWaterfall:c}=e("../utils/graph"),{isAdScript:l,toURL:u}=e("../utils/resource-classification"),d={
title:"No bottleneck requests found",failureTitle:"Avoid bottleneck requests",description:"Speed up, load earlier, parallelize, or eliminate the following requests and their dependencies in order to speed up ad loading. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/bottleneck-requests).",displayValue:"{blockedTime, number, seconds} s spent blocked on requests",columnUrl:"Blocking Request",columnInitiatorUrl:"Initiator Request",columnStartTime:"Start",columnSelfTime:"Exclusive Time",columnDuration:"Total Time"},m=i.createMessageInstanceIdFn(n,d),p=[{key:"url",itemType:"url",text:m(d.columnUrl)},{key:"selfTime",itemType:"ms",text:m(d.columnSelfTime),granularity:1},{key:"duration",itemType:"ms",text:m(d.columnDuration),granularity:1}];class BottleneckRequests extends s{static get meta(){return{id:"bottleneck-requests",title:m(d.title),failureTitle:m(d.failureTitle),description:m(d.description),requiredArtifacts:["devtoolsLogs","traces"]}}
static async audit(e,t){const n=e.traces[s.DEFAULT_PASS],i=e.devtoolsLogs[s.DEFAULT_PASS],h=(await c(n,i,t)).filter((e=>e.startTime>0));if(!h.length)return a.NoAdRelatedReq;const cost=e=>3*e.selfTime+e.duration,f=h.filter((e=>!l(u(e.url))&&(e.selfTime>250||e.duration>1e3))).sort(((e,t)=>cost(t)-cost(e))).slice(0,5),g=f.reduce(((e,t)=>e+t.selfTime),0)/1e3,y=1e3*g>1e3;for(const e of f)delete e.record;return{numericValue:f.length,numericUnit:"unitless",score:y?0:1,displayValue:y?m(d.displayValue,{blockedTime:g}):"",details:BottleneckRequests.makeTableDetails(p,f)}}}t.exports=BottleneckRequests,t.exports.UIStrings=d}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/bottleneck-requests.js")},{"../messages/common-strings":198,"../utils/graph":203,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/cumulative-ad-shift":[function(e,t,n){(function(n){(function(){
const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:a}=e("../messages/common-strings"),{Audit:s}=e("lighthouse"),{getScriptUrl:c}=e("../utils/network-timing"),{isAdIframe:l,isImplTag:u}=e("../utils/resource-classification"),{overlaps:d,toClientRect:m}=e("../utils/geometry"),p={title:"Cumulative ad shift",failureTitle:"Reduce ad-related layout shift",description:"Measures layout shifts that were caused by ads or happened near ads. Reducing cumulative ad-related layout shift will improve user experience. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/cumulative-ad-shift)."},h=i.createMessageInstanceIdFn(n,p);t.exports=class CumulativeAdShift extends s{static get meta(){return{id:"cumulative-ad-shift",title:h(p.title),failureTitle:h(p.failureTitle),description:h(p.description),scoreDisplayMode:s.SCORING_MODES.NUMERIC,requiredArtifacts:["traces","IFrameElements"]}}static get defaultOptions(){return{p10:.05,median:.25}}
static isAdShift(e,t){if(!e.args||!e.args.data)return!1;for(const n of t)for(const t of e.args.data.impacted_nodes||[]){const e=t.old_rect||[],i=m(e),a=n.clientRect;if(d(i,a))return!0}return!1}static compute(e,t,n){let i=0,a=0,s=0,c=0,l=0,u=0;for(const d of e)d.args&&d.args.data&&d.args.data.is_main_frame&&(i+=d.args.data.score,a++,this.isAdShift(d,t)&&(s+=d.args.data.score,c++,d.ts<n&&(l+=d.args.data.score,u++)));return{cumulativeShift:i,numShifts:a,cumulativeAdShift:s,numAdShifts:c,cumulativePreImplTagAdShift:l,numPreImplTagAdShifts:u}}static async audit(e,t){const n=e.traces[s.DEFAULT_PASS],i=n.traceEvents.filter((e=>"LayoutShift"===e.name));if(!i.length)return a.NoLayoutShifts;const d=n.traceEvents.find((e=>u(c(e)||"")))||{ts:1/0},m=e.IFrameElements.filter(l);if(!m.length)return a.NoAdRendered;const p=this.compute(i,m,d.ts),h=p.cumulativeAdShift;return{numericValue:h,numericUnit:"unitless",score:s.computeLogNormalScore({p10:t.options.p10,median:t.options.median},h),
displayValue:h.toLocaleString(t.settings.locale),details:p}}},t.exports.UIStrings=p}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/cumulative-ad-shift.js")},{"../messages/common-strings":198,"../utils/geometry":202,"../utils/network-timing":204,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/deprecated-api-usage":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{Audit:a}=e("lighthouse"),{isGpt:s}=e("../utils/resource-classification"),c={title:"Deprecated GPT API Usage",failureTitle:"Avoid deprecated GPT APIs",description:"Deprecated GPT API methods should be avoided to ensure your page is tagged correctly. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/deprecated-gpt-api-usage).",displayValue:"{numErrors, plural, =1 {1 error} other {# errors}} found"
},l=i.createMessageInstanceIdFn(n,c);t.exports=class DeprecatedApiUsage extends a{static get meta(){return{id:"deprecated-gpt-api-usage",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),scoreDisplayMode:"informative",requiredArtifacts:["ConsoleMessages"]}}static audit(e){const t=e.ConsoleMessages.filter((e=>"warning"===e.level||"error"===e.level)).filter((e=>e.url&&s(e.url))).filter((e=>e.text.toLowerCase().includes("deprecated")||e.text.toLowerCase().includes("discouraged"))).map((e=>({source:e.source,description:e.text,url:e.url,timestamp:e.timestamp}))).sort(((e,t)=>(e.timestamp||0)-(t.timestamp||0))),n=[{key:"url",itemType:"url",text:l(i.UIStrings.columnURL)},{key:"description",itemType:"code",text:l(i.UIStrings.columnDescription)}],u=a.makeTableDetails(n,t),d=t.length;return{score:Number(0===d),details:u,displayValue:l(c.displayValue,{numErrors:d})}}},t.exports.UIStrings=c}).call(this)
}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/deprecated-api-usage.js")},{"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/duplicate-tags":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),a=e("lighthouse/lighthouse-core/computed/main-resource"),s=e("lighthouse/lighthouse-core/computed/network-records"),c=e("lighthouse/lighthouse-core/lib/network-request"),{auditNotApplicable:l}=e("../messages/common-strings"),{Audit:u}=e("lighthouse"),{containsAnySubstring:d}=e("../utils/resource-classification"),{URL:m}=e("url"),p={title:"No duplicate tags found",failureTitle:"Load tags only once",description:"Loading a tag more than once in the same page is redundant and adds overhead without benefit. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/duplicate-tags).",
failureDisplayValue:"{duplicateTags, plural, =1 {1 duplicate tag} other {# duplicate tags}}",columnScript:"Script",columnNumReqs:"Duplicate Requests",columnFrameId:"Frame ID"},h=i.createMessageInstanceIdFn(n,p),f=["googletagservices.com/tag/js/gpt.js","securepubads.g.doubleclick.net/tag/js/gpt.js","pagead2.googlesyndication.com/pagead/js/adsbygoogle.js","pagead2.googlesyndication.com/pagead/js/show_ads.js","cdn.ampproject.org/v0/amp-ad-0.1.js"],g=[{key:"script",itemType:"url",text:h(p.columnScript)},{key:"numReqs",itemType:"text",text:h(p.columnNumReqs)}];class DuplicateTags extends u{static get meta(){return{id:"duplicate-tags",title:h(p.title),failureTitle:h(p.failureTitle),description:h(p.description),requiredArtifacts:["devtoolsLogs","URL"]}}static async audit(e,t){const n=e.devtoolsLogs[u.DEFAULT_PASS],i=await s.request(n,t),y=await a.request({URL:e.URL,devtoolsLog:n},t),b=i.filter((e=>e.frameId===y.frameId)).filter((e=>d(e.url,f))).filter((e=>e.resourceType===c.TYPES.Script))
;if(!b.length)return l.NoTags;const v=new Map;for(const e of b){const t=new m(e.url).pathname,n=v.get(t)||0;v.set(t,n+1)}const w=[];for(const[e,t]of v)t>1&&w.push({script:e,numReqs:t});return{numericValue:w.length,numericUnit:"unitless",score:w.length?0:1,details:DuplicateTags.makeTableDetails(g,w),displayValue:w.length?h(p.failureDisplayValue,{duplicateTags:w.length}):""}}}t.exports=DuplicateTags,t.exports.UIStrings=p}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/duplicate-tags.js")},{"../messages/common-strings":198,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/main-resource":14,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/lib/i18n/i18n":98,"lighthouse/lighthouse-core/lib/network-request":109,url:"url"}],"lighthouse-plugin-publisher-ads/audits/first-ad-render":[function(e,t,n){(function(n){(function(){
const i=e("../computed/ad-render-time"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:s,runWarning:c}=e("../messages/common-strings"),{Audit:l}=e("lighthouse"),u={title:"Latency of first ad render",failureTitle:"Reduce time to render first ad",description:"This metric measures the time for the first ad iframe to render from page navigation. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/first-ad-render).",displayValue:"{timeInMs, number, seconds} s"},d=a.createMessageInstanceIdFn(n,u);t.exports=class FirstAdRender extends l{static get meta(){return{id:"first-ad-render",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),scoreDisplayMode:l.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:12900,median:22e3},provided:{p10:2750,median:3700}}}static async audit(e,t){const n=e.traces[l.DEFAULT_PASS],a={devtoolsLog:e.devtoolsLogs[l.DEFAULT_PASS],
trace:n,settings:t.settings},{timing:m}=await i.request(a,t);if(!(m>0)){const e=s.NoAdRendered;return e.runWarnings=[c.NoAdRendered],e}const p=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"];return{numericValue:m,numericUnit:"millisecond",score:l.computeLogNormalScore(p,m),displayValue:d(u.displayValue,{timeInMs:m})}}},t.exports.UIStrings=u}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/first-ad-render.js")},{"../computed/ad-render-time":193,"../messages/common-strings":198,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/full-width-slots":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),a=e("lighthouse/lighthouse-core/computed/network-records"),{auditNotApplicable:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),{isAdRequest:l}=e("../utils/resource-classification"),{URL:u}=e("url"),d={
title:"Ad slots effectively use horizontal space",failureTitle:"Increase the width of ad slots",description:"Ad slots that utilize most of the page width generally experience increased click-through rate over smaller ad sizes. We recommend leaving no more than 25% of the viewport width unutilized on mobile devices.",failureDisplayValue:"{percentUnused, number, percent} of viewport width is underutilized"},m=i.createMessageInstanceIdFn(n,d);t.exports=class FullWidthSlots extends c{static get meta(){return{id:"full-width-slots",title:m(d.title),failureTitle:m(d.failureTitle),description:m(d.description),requiredArtifacts:["ViewportDimensions","devtoolsLogs"]}}static async audit(e,t){const n=e.devtoolsLogs[c.DEFAULT_PASS],i=await a.request(n,t),p=e.ViewportDimensions.innerWidth,h=i.filter(l).map((e=>new u(e.url)));if(!h.length)return s.NoAds
;const f=h.map((e=>e.searchParams.get("prev_iu_szs")||e.searchParams.get("sz"))).join("|").split(/[|,]/).map((e=>parseInt(e.split("x")[0]))).filter((e=>e<=p&&e>1));if(!f.length)return s.NoValidAdWidths;const g=1-Math.max(...f)/p,y=g>.25?0:1;return{score:y,numericValue:g,numericUnit:"unitless",displayValue:y?"":m(d.failureDisplayValue,{percentUnused:g})}}},t.exports.UIStrings=d}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/full-width-slots.js")},{"../messages/common-strings":198,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/lib/i18n/i18n":98,url:"url"}],"lighthouse-plugin-publisher-ads/audits/gpt-bids-parallel":[function(e,t,n){
const i=e("lighthouse/lighthouse-core/computed/network-records"),{assert:a}=e("../utils/asserts"),{auditNotApplicable:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),{getCriticalGraph:l}=e("../utils/graph"),{getTimingsByRecord:u}=e("../utils/network-timing"),{isGptImplTag:d,isBidRequest:m,getHeaderBidder:p}=e("../utils/resource-classification"),h={title:"GPT and bids loaded in parallel",failureTitle:"Load GPT and bids in parallel",description:"To optimize ad loading, bid requests should not wait on GPT to load. This issue can often be fixed by making sure that bid requests do not wait on `googletag.pubadsReady` or `googletag.cmd.push`. [Learn More](https://developers.google.com/publisher-ads-audits/reference/audits/gpt-bids-parallel).",columnBidder:"Bidder",columnUrl:"URL",columnStartTime:"Start",columnDuration:"Duration"},f=[{key:"bidder",itemType:"text",text:h.columnBidder},{key:"url",itemType:"url",text:h.columnUrl},{key:"startTime",itemType:"ms",text:h.columnStartTime
},{key:"duration",itemType:"ms",text:h.columnDuration}];class GptBidsInParallel extends c{static get meta(){return{id:"gpt-bids-parallel",title:h.title,failureTitle:h.failureTitle,description:h.description,requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(e,t){const n=e.devtoolsLogs[c.DEFAULT_PASS],h=e.traces[c.DEFAULT_PASS],g=await i.request(n,t),y=g.find((e=>d(e.url)));if(!y)return s.NoGpt;const b=g.filter(m).filter((e=>e.frameId==y.frameId));if(!b.length)return s.NoBids;const v=await u(h,n,t),w=[],S=new Set;for(const e of b)if(l(g,h.traceEvents,e).has(y)){const{startTime:t,endTime:n}=v.get(e)||e,i=a(p(e.url));if(S.has(i))continue;S.add(i),w.push({bidder:i,url:e.url,startTime:t,duration:n-t})}const T=w.length>0;return{numericValue:w.length,numericUnit:"unitless",score:T?0:1,details:T?GptBidsInParallel.makeTableDetails(f,w):void 0}}}t.exports=GptBidsInParallel,t.exports.UIStrings=h},{"../messages/common-strings":198,"../utils/asserts":200,"../utils/graph":203,
"../utils/network-timing":204,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/network-records":40}],"lighthouse-plugin-publisher-ads/audits/gpt-errors-overall":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{Audit:a}=e("lighthouse"),{isGpt:s}=e("../utils/resource-classification"),c={title:"GPT Errors",failureTitle:"Fix GPT errors",description:"Fix GPT errors to ensure your page is tagged as intended. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/gpt-errors-overall).",displayValue:"{numErrors, plural, =1 {1 error} other {# errors}} found"},l=i.createMessageInstanceIdFn(n,c);t.exports=class GptErrorsOverall extends a{static get meta(){return{id:"gpt-errors-overall",title:l(c.title),failureTitle:l(c.failureTitle),description:l(c.description),scoreDisplayMode:"informative",requiredArtifacts:["ConsoleMessages"]}}static audit(e){
const t=e.ConsoleMessages.filter((e=>"error"===e.level||"warning"===e.level)).filter((e=>e.url&&s(e.url))).filter((e=>!e.text.toLowerCase().includes("deprecated")&&!e.text.toLowerCase().includes("discouraged"))).map((e=>({source:e.source,description:e.text,url:e.url,timestamp:e.timestamp}))).sort(((e,t)=>(e.timestamp||0)-(t.timestamp||0))),n=[{key:"url",itemType:"url",text:l(i.UIStrings.columnURL)},{key:"description",itemType:"code",text:l(i.UIStrings.columnDescription)}],u=a.makeTableDetails(n,t),d=t.length;return{score:Number(0===d),details:u,displayValue:l(c.displayValue,{numErrors:d})}}},t.exports.UIStrings=c}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/gpt-errors-overall.js")},{"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads/audits/loads-ad-tag-over-https":[function(e,t,n){(function(n){(function(){
const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),a=e("lighthouse/lighthouse-core/computed/network-records"),{auditNotApplicable:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),{isAdTag:l}=e("../utils/resource-classification"),{URL:u}=e("url"),d={title:"Ad tag is loaded over HTTPS",failureTitle:"Load ad tag over HTTPS",description:'For privacy and security, always load GPT/AdSense over HTTPS. Insecure pages should explicitly request the ad script securely. GPT Example: `<script async src="https://securepubads.g.doubleclick.net/tag/js/gpt.js">` AdSense Example: `<script async src="https://pagead2.googlesyndication.com/pagead/js/adsbygoogle.js">`. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/loads-ad-tag-over-https).'},m=i.createMessageInstanceIdFn(n,d);t.exports=class LoadsAdTagOverHttps extends c{static get meta(){return{id:"loads-ad-tag-over-https",title:m(d.title),failureTitle:m(d.failureTitle),description:m(d.description),
requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){const n=e.devtoolsLogs[c.DEFAULT_PASS],i=await a.request(n,t);if(!i.find((e=>200==e.statusCode)))return s.NoRecords;const d=i.filter((e=>l(new u(e.url)))),m=d.filter((e=>e.isSecure)),p={type:"debugdata",numAdTagHttpReqs:d.length-m.length,numAdTagHttpsReqs:m.length};if(!d.length){const e=s.NoTag;return e.details=p,e}return{numericValue:p.numAdTagHttpReqs,score:p.numAdTagHttpReqs?0:1,details:p}}},t.exports.UIStrings=d}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/loads-ad-tag-over-https.js")},{"../messages/common-strings":198,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/lib/i18n/i18n":98,url:"url"}],"lighthouse-plugin-publisher-ads/audits/loads-gpt-from-official-source":[function(e,t,n){(function(n){(function(){
const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),a=e("lighthouse/lighthouse-core/computed/network-records"),{auditNotApplicable:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),{isGptTag:l}=e("../utils/resource-classification"),{URL:u}=e("url"),d={title:"GPT tag is loaded from an official source",failureTitle:"Load GPT from an official source",description:"Load GPT from 'securepubads.g.doubleclick.net' for standard integrations or from 'pagead2.googlesyndication.com' for limited ads. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/loads-gpt-from-official-source)."},m=i.createMessageInstanceIdFn(n,d);t.exports=class LoadsGptFromOfficalSource extends c{static get meta(){return{id:"loads-gpt-from-official-source",title:m(d.title),failureTitle:m(d.failureTitle),description:m(d.description),requiredArtifacts:["devtoolsLogs"]}}static async audit(e,t){
const n=e.devtoolsLogs[c.DEFAULT_PASS],i=(await a.request(n,t)).map((e=>new u(e.url))).find(l);if(!i)return s.NoGpt;const d=["securepubads.g.doubleclick.net","pagead2.googlesyndication.com"].includes(i.host);return{score:Number(d),numericValue:Number(!d),numericUnit:"unitless"}}},t.exports.UIStrings=d}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/loads-gpt-from-official-source.js")},{"../messages/common-strings":198,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/lib/i18n/i18n":98,url:"url"}],"lighthouse-plugin-publisher-ads/audits/script-injected-tags":[function(e,t,n){(function(n){(function(){
const i=e("../utils/array.js"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),s=e("lighthouse/lighthouse-core/computed/page-dependency-graph"),{auditNotApplicable:c}=e("../messages/common-strings"),{Audit:l}=e("lighthouse"),{computeAdRequestWaterfall:u}=e("../utils/graph"),{getScriptEvaluationTimes:d}=e("../utils/network-timing"),m={title:"Ad scripts are loaded statically",failureTitle:"Load ad scripts statically",description:"Load the following scripts directly with `<script async src=...>` instead of injecting scripts with JavaScript. Doing so allows the browser to preload scripts sooner. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/script-injected-tags).",failureDisplayValue:"Load {tags, plural, =1 {1 script} other {# scripts}} statically",columnUrl:"Script",columnLoadTime:"Load Time"},p=a.createMessageInstanceIdFn(n,m),h=[{key:"url",itemType:"url",text:p(m.columnUrl)},{key:"loadTime",itemType:"ms",granularity:1,text:p(m.columnLoadTime)
}],f=[/amazon-adsystem\.com\/aax2\/apstag.js/,/js-sec\.indexww\.com\/ht\/p\/.*\.js/,/pubads\.g\.doubleclick\.net\/tag\/js\/gpt\.js/,/static\.criteo\.net\/js\/.*\/publishertag\.js/,/www\.googletagservices\.com\/tag\/js\/gpt\.js/,/pagead2\.googlesyndication\.com\/pagead\/js\/adsbygoogle\.js/,/cdn\.ampproject\.org\/v0\/amp-ad-\d+\.\d+\.js/];function initiatedByInlineScript(e){if("script"!==e.initiator.type)return!1;const t=s.getNetworkInitiators(e);return 1===t.length&&t[0]===e.documentURL}class StaticAdTags extends l{static get meta(){return{id:"script-injected-tags",title:p(m.title),failureTitle:p(m.failureTitle),description:p(m.description),requiredArtifacts:["devtoolsLogs","traces"]}}static async audit(e,t){const n=await async function findStaticallyLoadableTags(e,t){const n=e.devtoolsLogs[l.DEFAULT_PASS],i=e.traces[l.DEFAULT_PASS],a=[],s=await u(i,n,t);for(const{record:e}of s)e&&"Script"===e.resourceType&&(initiatedByInlineScript(e)||f.find((t=>e.url.match(t))))&&a.push(e);return a
}(e,t);if(!n.length)return c.NoTag;const a=new Set,s=[],g=e.devtoolsLogs[l.DEFAULT_PASS],y=e.traces[l.DEFAULT_PASS],b=await d(y,g,t);for(const e of n){if(a.has(e.url))continue;a.add(e.url);const t=n.filter((t=>t.url===e.url));if(0===i.count(t,(e=>"parser"===e.initiator.type&&!e.isLinkPreload))){const t=b.get(e.url)||0;if(t<400)continue;s.push({url:e.url,loadTime:t})}}s.sort(((e,t)=>e.loadTime-t.loadTime));const v=s.length>0;return{displayValue:v?p(m.failureDisplayValue,{tags:s.length}):"",score:Number(!v),numericValue:s.length,numericUnit:"unitless",details:StaticAdTags.makeTableDetails(h,s)}}}t.exports=StaticAdTags,t.exports.UIStrings=m}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/script-injected-tags.js")},{"../messages/common-strings":198,"../utils/array.js":199,"../utils/graph":203,"../utils/network-timing":204,lighthouse:80,"lighthouse/lighthouse-core/computed/page-dependency-graph":41,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],
"lighthouse-plugin-publisher-ads/audits/serial-header-bidding":[function(e,t,n){(function(n){(function(){const i=e("../computed/ad-request-time"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),s=e("lighthouse/lighthouse-core/computed/main-resource"),c=e("lighthouse/lighthouse-core/computed/network-records"),{auditNotApplicable:l}=e("../messages/common-strings"),{Audit:u}=e("lighthouse"),{bucket:d}=e("../utils/array"),{getTimingsByRecord:m}=e("../utils/network-timing"),{isCacheable:p}=e("../utils/network"),{isGoogleAds:h,getHeaderBidder:f}=e("../utils/resource-classification"),{URL:g}=e("url"),y={title:"Header bidding is parallelized",failureTitle:"Parallelize bid requests",description:"Send header bidding requests simultaneously, rather than serially, to retrieve bids more quickly. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/serial-header-bidding).",columnBidder:"Bidder",columnUrl:"URL",columnStartTime:"Start",columnDuration:"Duration"
},b=a.createMessageInstanceIdFn(n,y),v=[{key:"bidder",itemType:"text",text:b(y.columnBidder)},{key:"url",itemType:"url",text:b(y.columnUrl)},{key:"startTime",itemType:"ms",text:b(y.columnStartTime)},{key:"duration",itemType:"ms",text:b(y.columnDuration)}],w="ad",S="bid",T="unknown";function checkRecordType(e){return h(new g(e.url))?w:f(e.url)?S:T}function isPossibleBid(e){return(null==e.resourceSize||e.resourceSize>0)&&"Image"!=e.resourceType&&e.endTime-e.startTime>=.05&&!p(e)}function clearQueryString(e){const t=new g(e);return t.search="",t.toString()}class SerialHeaderBidding extends u{static get meta(){return{id:"serial-header-bidding",title:b(y.title),failureTitle:b(y.failureTitle),description:b(y.description),requiredArtifacts:["devtoolsLogs","traces","URL"]}}static async audit(e,t){const n=e.devtoolsLogs[u.DEFAULT_PASS],a=e.traces[u.DEFAULT_PASS],p=await c.request(n,t);if(!p.length)return l.NoRecords;const h=await s.request({URL:e.URL,devtoolsLog:n
},t),g=p.filter(isPossibleBid).filter((e=>e.frameId==h.frameId)),y=d(g,checkRecordType);if(!y.has(S))return l.NoBids;const b={trace:a,devtoolsLog:n,settings:t.settings},{timing:w}=await i.request(b,t),T=await m(a,n,t),E=function constructRecords(e,t,n){const i=[];for(const a of e){const e=n.get(a);e&&i.push(Object.assign({},e,{url:a.url,type:t}))}return i}(y.get(S)||[],S,T);let _,x=[];for(const e of E)w>0&&e.endTime>w||(e.bidder=f(e.url),e.url=clearQueryString(e.url),_&&e.startTime>=_.endTime&&(x.push(_),x.push(e)),(!_||e.endTime<_.endTime||e.startTime>=_.endTime)&&(_=e));x=Array.from(new Set(x));const A=x.length>1;return{numericValue:Number(A),numericUnit:"unitless",score:A?0:1,details:A?SerialHeaderBidding.makeTableDetails(v,x):void 0}}}t.exports=SerialHeaderBidding,t.exports.UIStrings=y}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/serial-header-bidding.js")},{"../computed/ad-request-time":194,"../messages/common-strings":198,"../utils/array":199,
"../utils/network":205,"../utils/network-timing":204,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/computed/main-resource":14,"lighthouse/lighthouse-core/computed/network-records":40,"lighthouse/lighthouse-core/lib/i18n/i18n":98,url:"url"}],"lighthouse-plugin-publisher-ads/audits/tag-load-time":[function(e,t,n){(function(n){(function(){const i=e("../computed/tag-load-time"),a=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:s,runWarning:c}=e("../messages/common-strings"),{Audit:l}=e("lighthouse"),u={title:"Tag load time",failureTitle:"Reduce tag load time",description:"This metric measures the time for the ad tag's implementation script (pubads_impl.js for GPT; adsbygoogle.js for AdSense) to load after the page loads. [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/tag-load-time).",displayValue:"{timeInMs, number, seconds} s"},d=a.createMessageInstanceIdFn(n,u);t.exports=class TagLoadTime extends l{
static get meta(){return{id:"tag-load-time",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),scoreDisplayMode:l.SCORING_MODES.NUMERIC,requiredArtifacts:["devtoolsLogs","traces"]}}static get defaultOptions(){return{simulate:{p10:4350,median:8e3},provided:{p10:1200,median:2e3}}}static async audit(e,t){const n={trace:e.traces[l.DEFAULT_PASS],devtoolsLog:e.devtoolsLogs[l.DEFAULT_PASS],settings:t.settings},a=t.options["provided"==t.settings.throttlingMethod?"provided":"simulate"],{timing:m}=await i.request(n,t);if(!(m>0)){const e=s.NoTag;return e.runWarnings=[c.NoTag],e}return{numericValue:m,numericUnit:"millisecond",score:l.computeLogNormalScore(a,m),displayValue:d(u.displayValue,{timeInMs:m})}}},t.exports.UIStrings=u}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/tag-load-time.js")},{"../computed/tag-load-time":197,"../messages/common-strings":198,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],
"lighthouse-plugin-publisher-ads/audits/viewport-ad-density":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{auditNotApplicable:a,auditError:s}=e("../messages/common-strings"),{Audit:c}=e("lighthouse"),{isAdIframe:l}=e("../utils/resource-classification"),u={title:"Ad density is within recommended range",failureTitle:"Reduce ad density",description:"Ad density, the ads-to-content ratio, can impact user experience and ultimately user retention. The Better Ads Standard [recommends having an ad density below 30%](https://www.betterads.org/mobile-ad-density-higher-than-30/). [Learn more](https://developers.google.com/publisher-ads-audits/reference/audits/viewport-ad-density).",displayValue:"{adDensity, number, percent} ad density"},d=i.createMessageInstanceIdFn(n,u);t.exports=class ViewportAdDensity extends c{static get meta(){return{id:"viewport-ad-density",title:d(u.title),failureTitle:d(u.failureTitle),description:d(u.description),
requiredArtifacts:["ViewportDimensions","IFrameElements"]}}static audit(e){const t=e.ViewportDimensions,n=e.IFrameElements.filter((e=>l(e)&&e.clientRect.width*e.clientRect.height>1));if(!n.length)return a.NoVisibleSlots;if(t.innerHeight<=0)throw new Error(s.ViewportAreaZero);const i=function computeAdLength(e,t){const n=new Set([...e.map((e=>e.clientRect.left)),...e.map((e=>e.clientRect.right))].map((e=>Math.min(Math.max(1,e),t.innerWidth-1))));e=e.sort(((e,t)=>e.clientRect.top!==t.clientRect.top?e.clientRect.top-t.clientRect.top:e.clientRect.bottom-t.clientRect.bottom));let i=0;for(const t of n){let n=0,a=0;for(const i of e){if(t<i.clientRect.left||t>i.clientRect.right)continue;if(i.isPositionFixed){n+=i.clientRect.height;continue}const e=i.clientRect.bottom-Math.max(a,i.clientRect.top);e>0&&(n+=e),a=Math.max(a,i.clientRect.bottom)}i=Math.max(i,n)}return i}(n,t),c=Math.max(...n.map((e=>e.clientRect.top+e.clientRect.height/2)))+t.innerHeight,m=Math.min(1,i/c);return{score:m>.3?0:1,
numericValue:m,numericUnit:"unitless",displayValue:d(u.displayValue,{adDensity:m})}}},t.exports.UIStrings=u}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/audits/viewport-ad-density.js")},{"../messages/common-strings":198,"../utils/resource-classification":206,lighthouse:80,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],"lighthouse-plugin-publisher-ads":[function(e,t,n){(function(n){(function(){const i=e("lighthouse/lighthouse-core/lib/i18n/i18n"),{group:a}=e("./messages/common-strings"),s="lighthouse-plugin-publisher-ads",c={categoryDescription:"A Lighthouse plugin to improve ad speed and overall quality that is targeted at sites using GPT or AdSense tag. [Learn more](https://developers.google.com/publisher-ads-audits/reference)"},l=i.createMessageInstanceIdFn(n,c);t.exports={audits:[{path:s+"/audits/ad-blocking-tasks"},{path:s+"/audits/ad-render-blocking-resources"},{path:s+"/audits/ad-request-critical-path"},{path:s+"/audits/bid-request-from-page-start"},{
path:s+"/audits/ad-request-from-page-start"},{path:s+"/audits/ad-top-of-viewport"},{path:s+"/audits/ads-in-viewport"},{path:s+"/audits/async-ad-tags"},{path:s+"/audits/blocking-load-events"},{path:s+"/audits/bottleneck-requests"},{path:s+"/audits/duplicate-tags"},{path:s+"/audits/first-ad-render"},{path:s+"/audits/full-width-slots"},{path:s+"/audits/gpt-bids-parallel"},{path:s+"/audits/loads-gpt-from-official-source"},{path:s+"/audits/loads-ad-tag-over-https"},{path:s+"/audits/script-injected-tags"},{path:s+"/audits/serial-header-bidding"},{path:s+"/audits/tag-load-time"},{path:s+"/audits/viewport-ad-density"},{path:s+"/audits/cumulative-ad-shift"},{path:s+"/audits/deprecated-api-usage"},{path:s+"/audits/gpt-errors-overall"}],groups:{metrics:{title:a.Metrics},"ads-performance":{title:a.AdsPerformance},"ads-best-practices":{title:a.AdsBestPractices}},category:{title:"Publisher Ads",description:l(c.categoryDescription),auditRefs:[{id:"tag-load-time",weight:5,group:"metrics"},{
id:"bid-request-from-page-start",weight:5,group:"metrics"},{id:"ad-request-from-page-start",weight:25,group:"metrics"},{id:"first-ad-render",weight:10,group:"metrics"},{id:"cumulative-ad-shift",weight:5,group:"metrics"},{id:"gpt-bids-parallel",weight:1,group:"ads-performance"},{id:"serial-header-bidding",weight:1,group:"ads-performance"},{id:"bottleneck-requests",weight:1,group:"ads-performance"},{id:"script-injected-tags",weight:1,group:"ads-performance"},{id:"blocking-load-events",weight:1,group:"ads-performance"},{id:"ad-render-blocking-resources",weight:1,group:"ads-performance"},{id:"ad-blocking-tasks",weight:1,group:"ads-performance"},{id:"ad-request-critical-path",weight:0,group:"ads-performance"},{id:"ads-in-viewport",weight:4,group:"ads-best-practices"},{id:"async-ad-tags",weight:2,group:"ads-best-practices"},{id:"loads-ad-tag-over-https",weight:1,group:"ads-best-practices"},{id:"loads-gpt-from-official-source",weight:4,group:"ads-best-practices"},{id:"viewport-ad-density",
weight:2,group:"ads-best-practices"},{id:"ad-top-of-viewport",weight:2,group:"ads-best-practices"},{id:"duplicate-tags",weight:1,group:"ads-best-practices"},{id:"deprecated-gpt-api-usage",weight:0,group:"ads-best-practices"},{id:"gpt-errors-overall",weight:0,group:"ads-best-practices"}]}},Object.defineProperty(t.exports,"UIStrings",{enumerable:!1,get:()=>c})}).call(this)}).call(this,"/node_modules/lighthouse-plugin-publisher-ads/plugin.js")},{"./messages/common-strings":198,"lighthouse/lighthouse-core/lib/i18n/i18n":98}],url:[function(e,t,n){"use strict";const i=e("../util-commonjs.js"),a=["https:","http:","chrome:","chrome-extension:"],s=["data","https","wss","blob","chrome","chrome-extension","about","filesystem"],c=["localhost","127.0.0.1"],l=["blob","data","intent","file","filesystem"];function rewriteChromeInternalUrl(e){return e&&e.startsWith("chrome://")?(e.endsWith("/")&&(e=e.replace(/\/$/,"")),e.replace(/^chrome:\/\/chrome\//,"chrome://")):e}class URLShim extends URL{
static isValid(e){try{return new URL(e),!0}catch(e){return!1}}static hostsMatch(e,t){try{return new URL(e).host===new URL(t).host}catch(e){return!1}}static originsMatch(e,t){try{return new URL(e).origin===new URL(t).origin}catch(e){return!1}}static getOrigin(e){try{const t=new URL(e);return t.host&&t.origin||null}catch(e){return null}}static rootDomainsMatch(e,t){let n,a;try{n=i.createOrReturnURL(e),a=i.createOrReturnURL(t)}catch(e){return!1}if(!n.hostname||!a.hostname)return!1;return i.getRootDomain(n)===i.getRootDomain(a)}static getURLDisplayName(e,t){return i.getURLDisplayName(new URL(e),t)}static elideDataURI(e){try{return"data:"===new URL(e).protocol?e.slice(0,100):e}catch(t){return e}}static equalWithExcludedFragments(e,t){[e,t]=[e,t].map(rewriteChromeInternalUrl);try{const n=new URL(e);n.hash="";const i=new URL(t);return i.hash="",n.href===i.href}catch(e){return!1}}static isProtocolAllowed(e){try{const t=new URL(e);return a.includes(t.protocol)}catch(e){return!1}}
static isLikeLocalhost(e){return c.includes(e)||e.endsWith(".localhost")}static isSecureScheme(e){return s.includes(e)}static isNonNetworkProtocol(e){const t=e.includes(":")?e.slice(0,e.indexOf(":")):e;return l.includes(t)}static guessMimeType(e){let t;try{t=new URL(e)}catch{return}if("data:"===t.protocol){const e=t.pathname.match(/image\/(png|jpeg|svg\+xml|webp|gif|avif)(?=;)/);if(!e)return;return e[0]}const n=t.pathname.toLowerCase().match(/\.(png|jpeg|jpg|svg|webp|gif|avif)$/);if(!n)return;const i=n[1];return"svg"===i?"image/svg+xml":"jpg"===i?"image/jpeg":"image/"+i}}URLShim.URL=URL,URLShim.INVALID_URL_DEBUG_STRING="Lighthouse was unable to determine the URL of some script executions. It's possible a Chrome extension or other eval'd code is the source.",t.exports=URLShim},{"../util-commonjs.js":124}]},{},[1]);